/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var a1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/nls!vs/base/common/platform","vs/base/common/platform","vs/nls","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker"],h1=function(t1){for(var e=[],d=0,t=t1.length;d<t;d++)e[d]=a1[t1[d]];return e};define(a1[6],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=d,e.$jb=t,e.$kb=k,e.$lb=m,e.$mb=r1,e.$nb=H,e.$ob=O,e.$qb=M,e.$rb=B,e.$sb=j,e.$tb=n1,e.$ub=l1;function d(P,z){const S=t(P,z);if(S!==-1)return P[S]}function t(P,z,S=P.length-1){for(let g=S;g>=0;g--){const b=P[g];if(z(b))return g}return-1}function k(P,z){const S=m(P,z);return S===-1?void 0:P[S]}function m(P,z,S=0,g=P.length){let b=S,R=g;for(;b<R;){const f=Math.floor((b+R)/2);z(P[f])?b=f+1:R=f}return b-1}function r1(P,z){const S=H(P,z);return S===P.length?void 0:P[S]}function H(P,z,S=0,g=P.length){let b=S,R=g;for(;b<R;){const f=Math.floor((b+R)/2);z(P[f])?R=f:b=f+1}return b}function O(P,z,S=0,g=P.length){const b=H(P,z,S,g);return b===P.length?-1:b}class U{static{this.assertInvariants=!1}constructor(z){this.e=z,this.c=0}findLastMonotonous(z){if(U.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!z(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=z}const S=m(this.e,z,this.c);return this.c=S+1,S===-1?void 0:this.e[S]}}e.$pb=U;function M(P,z){if(P.length===0)return;let S=P[0];for(let g=1;g<P.length;g++){const b=P[g];z(b,S)>0&&(S=b)}return S}function B(P,z){if(P.length===0)return;let S=P[0];for(let g=1;g<P.length;g++){const b=P[g];z(b,S)>=0&&(S=b)}return S}function j(P,z){return M(P,(S,g)=>-z(S,g))}function n1(P,z){if(P.length===0)return-1;let S=0;for(let g=1;g<P.length;g++){const b=P[g];z(b,P[S])>0&&(S=g)}return S}function l1(P,z){for(const S of P){const g=z(S);if(g!==void 0)return g}}}),define(a1[7],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var d;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(d||(e.CharCode=d={}))}),define(a1[8],h1([0,1]),function(t1,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=t,e.$L=k,e.$M=m,e.$N=r1;function t(O,U){const M=Object.create(null);for(const B of O){const j=U(B);let n1=M[j];n1||(n1=M[j]=[]),n1.push(B)}return M}function k(O,U){const M=[],B=[];for(const j of O)U.has(j)||M.push(j);for(const j of U)O.has(j)||B.push(j);return{removed:M,added:B}}function m(O,U){const M=[],B=[];for(const[j,n1]of O)U.has(j)||M.push(n1);for(const[j,n1]of U)O.has(j)||B.push(n1);return{removed:M,added:B}}function r1(O,U){const M=new Set;for(const B of U)O.has(B)&&M.add(B);return M}class H{static{d=Symbol.toStringTag}constructor(U,M){this.b=M,this.a=new Map,this[d]="SetWithKey";for(const B of U)this.add(B)}get size(){return this.a.size}add(U){const M=this.b(U);return this.a.set(M,U),this}delete(U){return this.a.delete(this.b(U))}has(U){return this.a.has(this.b(U))}*entries(){for(const U of this.a.values())yield[U,U]}keys(){return this.values()}*values(){for(const U of this.a.values())yield U}clear(){this.a.clear()}forEach(U,M){this.a.forEach(B=>U.call(M,B,B,this))}[Symbol.iterator](){return this.values()}}e.$O=H}),define(a1[2],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=k,e.$3=m,e.$4=r1,e.$5=H,e.$6=O,e.$7=M,e.$9=j,e.$0=n1,e.$$=l1,e.$ab=z;class d{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?R.isErrorNoTelemetry(s)?new R(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$Y=d,e.$Z=new d;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function k(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function m(n){M(n)||e.$Z.onUnexpectedError(n)}function r1(n){M(n)||e.$Z.onUnexpectedExternalError(n)}function H(n){if(n instanceof Error){const{name:s,message:o}=n,u=n.stacktrace||n.stack;return{$isError:!0,name:s,message:o,stack:u,noTelemetry:R.isErrorNoTelemetry(n)}}return n}function O(n){let s;return n.noTelemetry?s=new R:(s=new Error,s.name=n.name),s.message=n.message,s.stack=n.stack,s}const U="Canceled";function M(n){return n instanceof B?!0:n instanceof Error&&n.name===U&&n.message===U}class B extends Error{constructor(){super(U),this.name=this.message}}e.$8=B;function j(){const n=new Error(U);return n.name=n.message,n}function n1(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function l1(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class P extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=P;function z(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class S extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$bb=S;class g extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$cb=g;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=b;class R extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof R)return s;const o=new R;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$eb=R;class f extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$fb=f}),define(a1[9],h1([0,1,2,6]),function(t1,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=k,e.$wb=m,e.$xb=r1,e.$yb=H,e.$zb=O,e.$Ab=U,e.$Bb=M,e.$Cb=B,e.$Db=j,e.$Eb=n1,e.$Fb=l1,e.$Gb=P,e.$Hb=z,e.top=S,e.$Jb=g,e.$Kb=R,e.$Lb=f,e.$Mb=n,e.$Nb=s,e.$Ob=o,e.$Pb=u,e.$Qb=L,e.$Rb=T,e.$Sb=J,e.$Tb=g1,e.$Ub=_1,e.$Vb=K,e.$Wb=N,e.$Xb=a,e.$Yb=D,e.$Zb=G,e.$1b=v,e.$2b=E,e.$3b=F,e.$4b=Q,e.$5b=X,e.$6b=x,e.$7b=i1,e.$8b=Y,e.$9b=L1,e.$0b=R1,e.$ac=W1;function k(c,_=0){return c[c.length-(1+_)]}function m(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}function r1(c,_,l=($,w)=>$===w){if(c===_)return!0;if(!c||!_||c.length!==_.length)return!1;for(let $=0,w=c.length;$<w;$++)if(!l(c[$],_[$]))return!1;return!0}function H(c,_){const l=c.length-1;_<l&&(c[_]=c[l]),c.pop()}function O(c,_,l){return U(c.length,$=>l(c[$],_))}function U(c,_){let l=0,$=c-1;for(;l<=$;){const w=(l+$)/2|0,Z=_(w);if(Z<0)l=w+1;else if(Z>0)$=w-1;else return w}return-(l+1)}function M(c,_,l){if(c=c|0,c>=_.length)throw new TypeError("invalid index");const $=_[Math.floor(_.length*Math.random())],w=[],Z=[],c1=[];for(const E1 of _){const d1=l(E1,$);d1<0?w.push(E1):d1>0?Z.push(E1):c1.push(E1)}return c<w.length?M(c,w,l):c<w.length+c1.length?c1[0]:M(c-(w.length+c1.length),Z,l)}function B(c,_){const l=[];let $;for(const w of c.slice(0).sort(_))!$||_($[0],w)!==0?($=[w],l.push($)):$.push(w);return l}function*j(c,_){let l,$;for(const w of c)$!==void 0&&_($,w)?l.push(w):(l&&(yield l),l=[w]),$=w;l&&(yield l)}function n1(c,_){for(let l=0;l<=c.length;l++)_(l===0?void 0:c[l-1],l===c.length?void 0:c[l])}function l1(c,_){for(let l=0;l<c.length;l++)_(l===0?void 0:c[l-1],c[l],l+1===c.length?void 0:c[l+1])}function P(c,_,l){const $=[];function w(E1,d1,A1){if(d1===0&&A1.length===0)return;const y=$[$.length-1];y&&y.start+y.deleteCount===E1?(y.deleteCount+=d1,y.toInsert.push(...A1)):$.push({start:E1,deleteCount:d1,toInsert:A1})}let Z=0,c1=0;for(;;){if(Z===c.length){w(Z,0,_.slice(c1));break}if(c1===_.length){w(Z,c.length-Z,[]);break}const E1=c[Z],d1=_[c1],A1=l(E1,d1);A1===0?(Z+=1,c1+=1):A1<0?(w(Z,1,[]),Z+=1):A1>0&&(w(Z,0,[d1]),c1+=1)}return $}function z(c,_,l){const $=P(c,_,l),w=[],Z=[];for(const c1 of $)w.push(...c.slice(c1.start,c1.start+c1.deleteCount)),Z.push(...c1.toInsert);return{removed:w,added:Z}}function S(c,_,l){if(l===0)return[];const $=c.slice(0,l).sort(_);return b(c,_,$,l,c.length),$}function g(c,_,l,$,w){return l===0?Promise.resolve([]):new Promise((Z,c1)=>{(async()=>{const E1=c.length,d1=c.slice(0,l).sort(_);for(let A1=l,y=Math.min(l+$,E1);A1<E1;A1=y,y=Math.min(y+$,E1)){if(A1>l&&await new Promise(I=>setTimeout(I)),w&&w.isCancellationRequested)throw new d.$8;b(c,_,d1,A1,y)}return d1})().then(Z,c1)})}function b(c,_,l,$,w){for(const Z=l.length;$<w;$++){const c1=c[$];if(_(c1,l[Z-1])<0){l.pop();const E1=(0,t.$nb)(l,d1=>_(c1,d1)<0);l.splice(E1,0,c1)}}}function R(c){return c.filter(_=>!!_)}function f(c){let _=0;for(let l=0;l<c.length;l++)c[l]&&(c[_]=c[l],_+=1);c.length=_}function n(c,_,l){c.splice(l,0,c.splice(_,1)[0])}function s(c){return!Array.isArray(c)||c.length===0}function o(c){return Array.isArray(c)&&c.length>0}function u(c,_=l=>l){const l=new Set;return c.filter($=>{const w=_($);return l.has(w)?!1:(l.add(w),!0)})}function L(c){const _=new Set;return l=>{const $=c(l);return _.has($)?!1:(_.add($),!0)}}function T(c,_){return c.length>0?c[0]:_}function J(c,_){return c.length>0?c[c.length-1]:_}function g1(c,_,l=($,w)=>$===w){let $=0;for(let w=0,Z=Math.min(c.length,_.length);w<Z&&l(c[w],_[w]);w++)$++;return $}function _1(c,_){let l=typeof _=="number"?c:0;typeof _=="number"?l=c:(l=0,_=c);const $=[];if(l<=_)for(let w=l;w<_;w++)$.push(w);else for(let w=l;w>_;w--)$.push(w);return $}function K(c,_,l){return c.reduce(($,w)=>($[_(w)]=l?l(w):w,$),Object.create(null))}function N(c,_){return c.push(_),()=>a(c,_)}function a(c,_){const l=c.indexOf(_);if(l>-1)return c.splice(l,1),_}function D(c,_,l){const $=c.slice(0,_),w=c.slice(_);return $.concat(l,w)}function G(c,_){let l;if(typeof _=="number"){let $=_;l=()=>{const w=Math.sin($++)*179426549;return w-Math.floor(w)}}else l=Math.random;for(let $=c.length-1;$>0;$-=1){const w=Math.floor(l()*($+1)),Z=c[$];c[$]=c[w],c[w]=Z}}function v(c,_){const l=c.indexOf(_);l>-1&&(c.splice(l,1),c.unshift(_))}function E(c,_){const l=c.indexOf(_);l>-1&&(c.splice(l,1),c.push(_))}function F(c,_){for(const l of _)c.push(l)}function Q(c,_){return Array.isArray(c)?c.map(_):_(c)}function X(c){return Array.isArray(c)?c:[c]}function x(c){return c[Math.floor(Math.random()*c.length)]}function i1(c,_,l){const $=e1(c,_),w=c.length,Z=l.length;c.length=w+Z;for(let c1=w-1;c1>=$;c1--)c[c1+Z]=c[c1];for(let c1=0;c1<Z;c1++)c[c1+$]=l[c1]}function Y(c,_,l,$){const w=e1(c,_);let Z=c.splice(w,l);return Z===void 0&&(Z=[]),i1(c,w,$),Z}function e1(c,_){return _<0?Math.max(_+c.length,0):Math.min(_,c.length)}var f1;(function(c){function _(Z){return Z<0}c.isLessThan=_;function l(Z){return Z<=0}c.isLessThanOrEqual=l;function $(Z){return Z>0}c.isGreaterThan=$;function w(Z){return Z===0}c.isNeitherLessOrGreaterThan=w,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(f1||(e.CompareResult=f1={}));function L1(c,_){return(l,$)=>_(c(l),c($))}function R1(...c){return(_,l)=>{for(const $ of c){const w=$(_,l);if(!f1.isNeitherLessOrGreaterThan(w))return w}return f1.neitherLessOrGreaterThan}}const w1=(c,_)=>c-_;e.$$b=w1;const N1=(c,_)=>(0,e.$$b)(c?1:0,_?1:0);e.$_b=N1;function W1(c){return(_,l)=>-c(_,l)}class G1{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let l=this.c;for(;l<this.g.length&&_(this.g[l]);)l++;const $=l===this.c?null:this.g.slice(this.c,l);return this.c=l,$}takeFromEndWhile(_){let l=this.d;for(;l>=0&&_(this.g[l]);)l--;const $=l===this.d?null:this.g.slice(l+1,this.d+1);return this.d=l,$}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const l=this.g.slice(this.c,this.c+_);return this.c+=_,l}}e.$bc=G1;class v1{static{this.empty=new v1(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(l=>(_(l),!0))}toArray(){const _=[];return this.iterate(l=>(_.push(l),!0)),_}filter(_){return new v1(l=>this.iterate($=>_($)?l($):!0))}map(_){return new v1(l=>this.iterate($=>l(_($))))}some(_){let l=!1;return this.iterate($=>(l=_($),!l)),l}findFirst(_){let l;return this.iterate($=>_($)?(l=$,!1):!0),l}findLast(_){let l;return this.iterate($=>(_($)&&(l=$),!0)),l}findLastMaxBy(_){let l,$=!0;return this.iterate(w=>(($||f1.isGreaterThan(_(w,l)))&&($=!1,l=w),!0)),l}}e.$cc=v1;class y1{constructor(_){this.c=_}static createSortPermutation(_,l){const $=Array.from(_.keys()).sort((w,Z)=>l(_[w],_[Z]));return new y1($)}apply(_){return _.map((l,$)=>_[this.c[$]])}inverse(){const _=this.c.slice();for(let l=0;l<this.c.length;l++)_[this.c[l]]=l;return new y1(_)}}e.$dc=y1}),define(a1[3],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=d;function d(t,k){const m=this;let r1=!1,H;return function(){if(r1)return H;if(r1=!0,k)try{H=t.apply(m,arguments)}finally{k()}else H=t.apply(m,arguments);return H}}}),define(a1[10],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(t){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=k;const m=Object.freeze([]);function r1(){return m}t.empty=r1;function*H(s){yield s}t.single=H;function O(s){return k(s)?s:H(s)}t.wrap=O;function U(s){return s||m}t.from=U;function*M(s){for(let o=s.length-1;o>=0;o--)yield s[o]}t.reverse=M;function B(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=B;function j(s){return s[Symbol.iterator]().next().value}t.first=j;function n1(s,o){let u=0;for(const L of s)if(o(L,u++))return!0;return!1}t.some=n1;function l1(s,o){for(const u of s)if(o(u))return u}t.find=l1;function*P(s,o){for(const u of s)o(u)&&(yield u)}t.filter=P;function*z(s,o){let u=0;for(const L of s)yield o(L,u++)}t.map=z;function*S(s,o){let u=0;for(const L of s)yield*o(L,u++)}t.flatMap=S;function*g(...s){for(const o of s)yield*o}t.concat=g;function b(s,o,u){let L=u;for(const T of s)L=o(L,T);return L}t.reduce=b;function*R(s,o,u=s.length){for(o<0&&(o+=s.length),u<0?u+=s.length:u>s.length&&(u=s.length);o<u;o++)yield s[o]}t.slice=R;function f(s,o=Number.POSITIVE_INFINITY){const u=[];if(o===0)return[u,s];const L=s[Symbol.iterator]();for(let T=0;T<o;T++){const J=L.next();if(J.done)return[u,t.empty()];u.push(J.value)}return[u,{[Symbol.iterator](){return L}}]}t.consume=f;async function n(s){const o=[];for await(const u of s)o.push(u);return Promise.resolve(o)}t.asyncToArray=n})(d||(e.Iterable=d={}))}),define(a1[11],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class d{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=d}),define(a1[12],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class d{static{this.Undefined=new d(void 0)}constructor(m){this.element=m,this.next=d.Undefined,this.prev=d.Undefined}}class t{constructor(){this.a=d.Undefined,this.b=d.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===d.Undefined}clear(){let m=this.a;for(;m!==d.Undefined;){const r1=m.next;m.prev=d.Undefined,m.next=d.Undefined,m=r1}this.a=d.Undefined,this.b=d.Undefined,this.c=0}unshift(m){return this.d(m,!1)}push(m){return this.d(m,!0)}d(m,r1){const H=new d(m);if(this.a===d.Undefined)this.a=H,this.b=H;else if(r1){const U=this.b;this.b=H,H.prev=U,U.next=H}else{const U=this.a;this.a=H,H.next=U,U.prev=H}this.c+=1;let O=!1;return()=>{O||(O=!0,this.e(H))}}shift(){if(this.a!==d.Undefined){const m=this.a.element;return this.e(this.a),m}}pop(){if(this.b!==d.Undefined){const m=this.b.element;return this.e(this.b),m}}e(m){if(m.prev!==d.Undefined&&m.next!==d.Undefined){const r1=m.prev;r1.next=m.next,m.next.prev=r1}else m.prev===d.Undefined&&m.next===d.Undefined?(this.a=d.Undefined,this.b=d.Undefined):m.next===d.Undefined?(this.b=this.b.prev,this.b.next=d.Undefined):m.prev===d.Undefined&&(this.a=this.a.next,this.a.prev=d.Undefined);this.c-=1}*[Symbol.iterator](){let m=this.a;for(;m!==d.Undefined;)yield m.element,m=m.next}}e.$8c=t}),define(a1[13],h1([0,1]),function(t1,e){"use strict";var d,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=m,e.$Bc=r1,e.$Cc=H,e.$Lc=R;function m(f,n,s){let o=f.get(n);return o===void 0&&(o=s,f.set(n,o)),o}function r1(f){const n=[];return f.forEach((s,o)=>{n.push(`${o} => ${s}`)}),`Map(${f.size}) {${n.join(", ")}}`}function H(f){const n=[];return f.forEach(s=>{n.push(s)}),`Set(${f.size}) {${n.join(", ")}}`}class O{constructor(n,s){this.uri=n,this.value=s}}function U(f){return Array.isArray(f)}class M{static{this.c=n=>n.toString()}constructor(n,s){if(this[d]="ResourceMap",n instanceof M)this.d=new Map(n.d),this.e=s??M.c;else if(U(n)){this.d=new Map,this.e=s??M.c;for(const[o,u]of n)this.set(o,u)}else this.d=new Map,this.e=n??M.c}set(n,s){return this.d.set(this.e(n),new O(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[o,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(d=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=M;class B{constructor(n,s){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new M(n):(this.c=new M(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((o,u)=>n.call(s,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=B;var j;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(j||(e.Touch=j={}));class n1{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=j.None){const o=this.c.get(n);if(o)return s!==j.None&&this.m(o,s),o.value}set(n,s,o=j.None){let u=this.c.get(n);if(u)u.value=s,o!==j.None&&this.m(u,o);else{switch(u={key:n,value:s,next:void 0,previous:void 0},o){case j.None:this.k(u);break;case j.AsOld:this.j(u);break;case j.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const o=this.g;let u=this.d;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this.g;let o=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const L={value:o.key,done:!1};return o=o.next,L}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this.g;let o=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const L={value:o.value,done:!1};return o=o.next,L}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this.g;let o=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const L={value:[o.key,o.value],done:!1};return o=o.next,L}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,o=this.size;for(;s&&o>n;)this.c.delete(s.key),s=s.next,o--;this.d=s,this.f=o,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,o=this.size;for(;s&&o>n;)this.c.delete(s.key),s=s.previous,o--;this.e=s,this.f=o,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,o=n.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==j.AsOld&&s!==j.AsNew)){if(s===j.AsOld){if(n===this.d)return;const o=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(o.previous=u,u.next=o),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===j.AsNew){if(n===this.e)return;const o=n.next,u=n.previous;n===this.d?(o.previous=void 0,this.d=o):(o.previous=u,u.next=o),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,o)=>{n.push([o,s])}),n}fromJSON(n){this.clear();for(const[s,o]of n)this.set(s,o)}}e.$Fc=n1;class l1 extends n1{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=j.AsNew){return super.get(n,s)}peek(n){return super.get(n,j.None)}set(n,s){return super.set(n,s,j.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class P extends l1{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}e.$Gc=P;class z extends l1{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}e.$Hc=z;class S{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}e.$Ic=S;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,o]of n)this.set(s,o)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((o,u)=>{n.call(s,o,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=g;class b{constructor(){this.c=new Map}add(n,s){let o=this.c.get(n);o||(o=new Set,this.c.set(n,o)),o.add(s)}delete(n,s){const o=this.c.get(n);o&&(o.delete(s),o.size===0&&this.c.delete(n))}forEach(n,s){const o=this.c.get(n);o&&o.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}e.$Kc=b;function R(f,n){if(f===n)return!0;if(f.size!==n.size)return!1;for(const[s,o]of f)if(!n.has(s)||n.get(s)!==o)return!1;for(const[s]of n)if(!f.has(s))return!1;return!0}}),define(a1[4],h1([0,1,9,8,13,3,10]),function(t1,e,d,t,k,m,r1){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=M,e.$Oc=B,e.$Pc=j,e.$Qc=P,e.$Rc=z,e.$Sc=S,e.$Tc=g,e.$Uc=b,e.$Vc=R,e.$6c=_1;const H=!1;let O=null;class U{constructor(){this.b=new Map}static{this.a=0}c(a){let D=this.b.get(a);return D||(D={parent:null,source:null,isSingleton:!1,value:a,idx:U.a++},this.b.set(a,D)),D}trackDisposable(a){const D=this.c(a);D.source||(D.source=new Error().stack)}setParent(a,D){const G=this.c(a);G.parent=D}markAsDisposed(a){this.b.delete(a)}markAsSingleton(a){this.c(a).isSingleton=!0}f(a,D){const G=D.get(a);if(G)return G;const v=a.parent?this.f(this.c(a.parent),D):a;return D.set(a,v),v}getTrackedDisposables(){const a=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,a).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(a=10,D){let G;if(D)G=D;else{const X=new Map,x=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,X).isSingleton);if(x.length===0)return;const i1=new Set(x.map(Y=>Y.value));if(G=x.filter(Y=>!(Y.parent&&i1.has(Y.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function v(X){function x(Y,e1){for(;Y.length>0&&e1.some(f1=>typeof f1=="string"?f1===Y[0]:Y[0].match(f1));)Y.shift()}const i1=X.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return x(i1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),i1.reverse()}const E=new k.$Kc;for(const X of G){const x=v(X);for(let i1=0;i1<=x.length;i1++)E.add(x.slice(0,i1).join(`
`),X)}G.sort((0,d.$9b)(X=>X.idx,d.$$b));let F="",Q=0;for(const X of G.slice(0,a)){Q++;const x=v(X),i1=[];for(let Y=0;Y<x.length;Y++){let e1=x[Y];e1=`(shared with ${E.get(x.slice(0,Y+1).join(`
`)).size}/${G.length} leaks) at ${e1}`;const L1=E.get(x.slice(0,Y).join(`
`)),R1=(0,t.$K)([...L1].map(w1=>v(w1)[Y]),w1=>w1);delete R1[x[Y]];for(const[w1,N1]of Object.entries(R1))i1.unshift(`    - stacktraces of ${N1.length} other leaks continue with ${w1}`);i1.unshift(e1)}F+=`


==================== Leaking disposable ${Q}/${G.length}: ${X.value.constructor.name} ====================
${i1.join(`
`)}
============================================================

`}return G.length>a&&(F+=`


... and ${G.length-a} more leaking disposables

`),{leaks:G,details:F}}}e.$Mc=U;function M(N){O=N}if(H){const N="__is_disposable_tracked__";M(new class{trackDisposable(a){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[N]||console.log(D)},3e3)}setParent(a,D){if(a&&a!==n.None)try{a[N]=!0}catch{}}markAsDisposed(a){if(a&&a!==n.None)try{a[N]=!0}catch{}}markAsSingleton(a){}})}function B(N){return O?.trackDisposable(N),N}function j(N){O?.markAsDisposed(N)}function n1(N,a){O?.setParent(N,a)}function l1(N,a){if(O)for(const D of N)O.setParent(D,a)}function P(N){return O?.markAsSingleton(N),N}function z(N){return typeof N=="object"&&N!==null&&typeof N.dispose=="function"&&N.dispose.length===0}function S(N){if(r1.Iterable.is(N)){const a=[];for(const D of N)if(D)try{D.dispose()}catch(G){a.push(G)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(N)?[]:N}else if(N)return N.dispose(),N}function g(N){for(const a of N)z(a)&&a.dispose();return[]}function b(...N){const a=R(()=>S(N));return l1(N,a),a}function R(N){const a=B({dispose:(0,m.$gb)(()=>{j(a),N()})});return a}class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(j(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{S(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return n1(a,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(a),a.dispose()}}deleteAndLeak(a){a&&this.f.has(a)&&(this.f.delete(a),n1(a,null))}}e.$Wc=f;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,B(this),n1(this.q,this)}dispose(){j(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$Xc=n;class s{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&n1(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,j(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&n1(a,null),a}}e.$Yc=s;class o{constructor(a){this.a=new s,this.b=!1,this.a.value=a}get value(){return this.a.value}set value(a){this.b||a===this.a.value||(this.a.value=a)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=o;class u{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=u;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(a){let D=a;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,j(this))},this}}e.$2c=L;class T{constructor(){this.a=new Map}acquire(a,...D){let G=this.a.get(a);G||(G={counter:0,object:this.b(a,...D)},this.a.set(a,G));const{object:v}=G,E=(0,m.$gb)(()=>{--G.counter===0&&(this.c(a,G.object),this.a.delete(a))});return G.counter++,{object:v,dispose:E}}}e.$3c=T;class J{constructor(a){this.a=a}async acquire(a,...D){const G=this.a.acquire(a,...D);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(v){throw G.dispose(),v}}}e.$4c=J;class g1{constructor(a){this.object=a}dispose(){}}e.$5c=g1;function _1(N){const a=new f;try{N(a)}finally{a.dispose()}}class K{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){j(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{S(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get size(){return this.a.size}get(a){return this.a.get(a)}set(a,D,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(a)?.dispose(),this.a.set(a,D)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}deleteAndLeak(a){const D=this.a.get(a);return this.a.delete(a),D}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=K}),define(a1[14],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const d=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(m){return new t(m)}constructor(m){this.c=d&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define(a1[5],h1([0,1,2,3,4,12,14]),function(t1,e,d,t,k,m,r1){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=n1;const H=!1,O=!1,U=!1;var M;(function(v){v.None=()=>k.$Xc.None;function E(y){if(U){const{onDidAddListener:I}=y,q=P.create();let p=0;y.onDidAddListener=()=>{++p===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),I?.()}}}function F(y,I){return w1(y,()=>{},0,void 0,!0,void 0,I)}v.defer=F;function Q(y){return(I,q=null,p)=>{let V=!1,s1;return s1=y(o1=>{if(!V)return s1?s1.dispose():V=!0,I.call(q,o1)},null,p),V&&s1.dispose(),s1}}v.once=Q;function X(y,I,q){return L1((p,V=null,s1)=>y(o1=>p.call(V,I(o1)),null,s1),q)}v.map=X;function x(y,I,q){return L1((p,V=null,s1)=>y(o1=>{I(o1),p.call(V,o1)},null,s1),q)}v.forEach=x;function i1(y,I,q){return L1((p,V=null,s1)=>y(o1=>I(o1)&&p.call(V,o1),null,s1),q)}v.filter=i1;function Y(y){return y}v.signal=Y;function e1(...y){return(I,q=null,p)=>{const V=(0,k.$Uc)(...y.map(s1=>s1(o1=>I.call(q,o1))));return R1(V,p)}}v.any=e1;function f1(y,I,q,p){let V=q;return X(y,s1=>(V=I(V,s1),V),p)}v.reduce=f1;function L1(y,I){let q;const p={onWillAddFirstListener(){q=y(V.fire,V)},onDidRemoveLastListener(){q?.dispose()}};I||E(p);const V=new s(p);return I?.add(V),V.event}function R1(y,I){return I instanceof Array?I.push(y):I&&I.add(y),y}function w1(y,I,q=100,p=!1,V=!1,s1,o1){let b1,$1,F1,P1=0,C;const I1={leakWarningThreshold:s1,onWillAddFirstListener(){b1=y(H1=>{P1++,$1=I($1,H1),p&&!F1&&(p1.fire($1),$1=void 0),C=()=>{const K1=$1;$1=void 0,F1=void 0,(!p||P1>1)&&p1.fire(K1),P1=0},typeof q=="number"?(clearTimeout(F1),F1=setTimeout(C,q)):F1===void 0&&(F1=0,queueMicrotask(C))})},onWillRemoveListener(){V&&P1>0&&C?.()},onDidRemoveLastListener(){C=void 0,b1.dispose()}};o1||E(I1);const p1=new s(I1);return o1?.add(p1),p1.event}v.debounce=w1;function N1(y,I=0,q){return v.debounce(y,(p,V)=>p?(p.push(V),p):[V],I,void 0,!0,void 0,q)}v.accumulate=N1;function W1(y,I=(p,V)=>p===V,q){let p=!0,V;return i1(y,s1=>{const o1=p||!I(s1,V);return p=!1,V=s1,o1},q)}v.latch=W1;function G1(y,I,q){return[v.filter(y,I,q),v.filter(y,p=>!I(p),q)]}v.split=G1;function v1(y,I=!1,q=[],p){let V=q.slice(),s1=y($1=>{V?V.push($1):b1.fire($1)});p&&p.add(s1);const o1=()=>{V?.forEach($1=>b1.fire($1)),V=null},b1=new s({onWillAddFirstListener(){s1||(s1=y($1=>b1.fire($1)),p&&p.add(s1))},onDidAddFirstListener(){V&&(I?setTimeout(o1):o1())},onDidRemoveLastListener(){s1&&s1.dispose(),s1=null}});return p&&p.add(b1),b1.event}v.buffer=v1;function y1(y,I){return(p,V,s1)=>{const o1=I(new _);return y(function(b1){const $1=o1.evaluate(b1);$1!==c&&p.call(V,$1)},void 0,s1)}}v.chain=y1;const c=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(I){return this.f.push(I),this}forEach(I){return this.f.push(q=>(I(q),q)),this}filter(I){return this.f.push(q=>I(q)?q:c),this}reduce(I,q){let p=q;return this.f.push(V=>(p=I(p,V),p)),this}latch(I=(q,p)=>q===p){let q=!0,p;return this.f.push(V=>{const s1=q||!I(V,p);return q=!1,p=V,s1?V:c}),this}evaluate(I){for(const q of this.f)if(I=q(I),I===c)break;return I}}function l(y,I,q=p=>p){const p=(...b1)=>o1.fire(q(...b1)),V=()=>y.on(I,p),s1=()=>y.removeListener(I,p),o1=new s({onWillAddFirstListener:V,onDidRemoveLastListener:s1});return o1.event}v.fromNodeEventEmitter=l;function $(y,I,q=p=>p){const p=(...b1)=>o1.fire(q(...b1)),V=()=>y.addEventListener(I,p),s1=()=>y.removeEventListener(I,p),o1=new s({onWillAddFirstListener:V,onDidRemoveLastListener:s1});return o1.event}v.fromDOMEventEmitter=$;function w(y){return new Promise(I=>Q(y)(I))}v.toPromise=w;function Z(y){const I=new s;return y.then(q=>{I.fire(q)},()=>{I.fire(void 0)}).finally(()=>{I.dispose()}),I.event}v.fromPromise=Z;function c1(y,I,q){return I(q),y(p=>I(p))}v.runAndSubscribe=c1;class E1{constructor(I,q){this._observable=I,this.f=0,this.g=!1;const p={onWillAddFirstListener:()=>{I.addObserver(this)},onDidRemoveLastListener:()=>{I.removeObserver(this)}};q||E(p),this.emitter=new s(p),q&&q.add(this.emitter)}beginUpdate(I){this.f++}handlePossibleChange(I){}handleChange(I,q){this.g=!0}endUpdate(I){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function d1(y,I){return new E1(y,I).emitter.event}v.fromObservable=d1;function A1(y){return(I,q,p)=>{let V=0,s1=!1;const o1={beginUpdate(){V++},endUpdate(){V--,V===0&&(y.reportChanges(),s1&&(s1=!1,I.call(q)))},handlePossibleChange(){},handleChange(){s1=!0}};y.addObserver(o1),y.reportChanges();const b1={dispose(){y.removeObserver(o1)}};return p instanceof k.$Wc?p.add(b1):Array.isArray(p)&&p.push(b1),b1}}v.fromObservableLight=A1})(M||(e.Event=M={}));class B{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${B.f++}`,B.all.add(this)}start(E){this.g=new r1.$he,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$je=B;let j=-1;function n1(v){const E=j;return j=v,{dispose(){j=E}}}class l1{static{this.f=1}constructor(E,F,Q=(l1.f++).toString(16).padStart(3,"0")){this.j=E,this.threshold=F,this.name=Q,this.h=0}dispose(){this.g?.clear()}check(E,F){const Q=this.threshold;if(Q<=0||F<Q)return;this.g||(this.g=new Map);const X=this.g.get(E.value)||0;if(this.g.set(E.value,X+1),this.h-=1,this.h<=0){this.h=Q*.5;const[x,i1]=this.getMostFrequentStack(),Y=`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${i1}):`;console.warn(Y),console.warn(x);const e1=new z(Y,x);this.j(e1)}return()=>{const x=this.g.get(E.value)||0;this.g.set(E.value,x-1)}}getMostFrequentStack(){if(!this.g)return;let E,F=0;for(const[Q,X]of this.g)(!E||F<X)&&(E=[Q,X],F=X);return E}}class P{static create(){const E=new Error;return new P(E.stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class z extends Error{constructor(E,F){super(E),this.name="ListenerLeakError",this.stack=F}}e.$le=z;class S extends Error{constructor(E,F){super(E),this.name="ListenerRefusalError",this.stack=F}}e.$me=S;let g=0;class b{constructor(E){this.value=E,this.id=g++}}const R=2,f=(v,E)=>{if(v instanceof b)E(v);else for(let F=0;F<v.length;F++){const Q=v[F];Q&&E(Q)}};let n;if(H){const v=[];setInterval(()=>{v.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(v.join(`
`)),v.length=0)},3e3),n=new FinalizationRegistry(E=>{typeof E=="string"&&v.push(E)})}class s{constructor(E){this.z=0,this.f=E,this.g=j>0||this.f?.leakWarningThreshold?new l1(E?.onListenerError??d.$3,this.f?.leakWarningThreshold??j):void 0,this.j=this.f?._profName?new B(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(O){const E=this.u;queueMicrotask(()=>{f(E,F=>F.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,F,Q)=>{if(this.g&&this.z>this.g.threshold**2){const e1=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(e1);const f1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],L1=new S(`${e1}. HINT: Stack shows most frequent listener (${f1[1]}-times)`,f1[0]);return(this.f?.onListenerError||d.$3)(L1),k.$Xc.None}if(this.m)return k.$Xc.None;F&&(E=E.bind(F));const X=new b(E);let x,i1;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(X.stack=P.create(),x=this.g.check(X.stack,this.z+1)),O&&(X.stack=i1??P.create()),this.u?this.u instanceof b?(this.w??=new u,this.u=[this.u,X]):this.u.push(X):(this.f?.onWillAddFirstListener?.(this),this.u=X,this.f?.onDidAddFirstListener?.(this)),this.z++;const Y=(0,k.$Vc)(()=>{n?.unregister(Y),x?.(),this.A(X)});if(Q instanceof k.$Wc?Q.add(Y):Array.isArray(Q)&&Q.push(Y),n){const e1=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),f1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(e1);n.register(Y,f1?.[2]??e1,Y)}return Y},this.q}A(E){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const F=this.u,Q=F.indexOf(E);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,F[Q]=void 0;const X=this.w.current===this;if(this.z*R<=F.length){let x=0;for(let i1=0;i1<F.length;i1++)F[i1]?F[x++]=F[i1]:X&&(this.w.end--,x<this.w.i&&this.w.i--);F.length=x}}B(E,F){if(!E)return;const Q=this.f?.onListenerError||d.$3;if(!Q){E.value(F);return}try{E.value(F)}catch(X){Q(X)}}C(E){const F=E.current.u;for(;E.i<E.end;)this.B(F[E.i++],E.value);E.reset()}fire(E){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof b)this.B(this.u,E);else{const F=this.w;F.enqueue(this,E,this.u.length),this.C(F)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=s;const o=()=>new u;e.$oe=o;class u{constructor(){this.i=-1,this.end=0}enqueue(E,F,Q){this.i=0,this.end=Q,this.current=E,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends s{async fireAsync(E,F,Q){if(this.u)for(this.h||(this.h=new m.$8c),f(this.u,X=>this.h.push([X.value,E]));this.h.size>0&&!F.isCancellationRequested;){const[X,x]=this.h.shift(),i1=[],Y={...x,token:F,waitUntil:e1=>{if(Object.isFrozen(i1))throw new Error("waitUntil can NOT be called asynchronous");Q&&(e1=Q(e1,X)),i1.push(e1)}};try{X(Y)}catch(e1){(0,d.$3)(e1);continue}Object.freeze(i1),await Promise.allSettled(i1).then(e1=>{for(const f1 of e1)f1.status==="rejected"&&(0,d.$3)(f1.reason)})}}}e.$pe=L;class T extends s{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new m.$8c,this.t=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.t(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.z&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$qe=T;class J extends T{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$re=J;class g1 extends s{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$se=g1;class _1{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const F={event:E,listener:null};this.h.push(F),this.g&&this.m(F);const Q=()=>{this.g&&this.o(F);const X=this.h.indexOf(F);this.h.splice(X,1)};return(0,k.$Vc)((0,t.$gb)(Q))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(F=>this.f.fire(F))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$te=_1;class K{constructor(E,F,Q,X){this.f=new k.$Wc;const x=this.f.add(new _1),i1=this.f.add(new k.$7c);function Y(e1){i1.set(e1,x.add(X(e1)))}for(const e1 of E)Y(e1);this.f.add(F(e1=>{Y(e1)})),this.f.add(Q(e1=>{i1.deleteAndDispose(e1)})),this.event=x.event}dispose(){this.f.dispose()}}e.$ue=K;class N{constructor(){this.f=[]}wrapEvent(E,F,Q){return(X,x,i1)=>E(Y=>{const e1=this.f[this.f.length-1];if(!F){e1?e1.buffers.push(()=>X.call(x,Y)):X.call(x,Y);return}const f1=e1;if(!f1){X.call(x,F(Q,Y));return}f1.items??=[],f1.items.push(Y),f1.buffers.length===0&&e1.buffers.push(()=>{f1.reducedResult??=Q?f1.items.reduce(F,Q):f1.items.reduce(F),X.call(x,f1.reducedResult)})},void 0,i1)}bufferEvents(E){const F={buffers:new Array};this.f.push(F);const Q=E();return this.f.pop(),F.buffers.forEach(X=>X()),Q}}e.$ve=N;class a{constructor(){this.f=!1,this.g=M.None,this.h=k.$Xc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=a;class D{static const(E){return new G(E)}constructor(E){this.g=E,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(E){E!==this.g&&(this.g=E,this.f.fire(void 0))}}e.$xe=D;class G{constructor(E){this.value=E,this.onDidChange=M.None}}}),define(a1[15],h1([0,1,5]),function(t1,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=H;const t=Object.freeze(function(O,U){const M=setTimeout(O.bind(U),0);return{dispose(){clearTimeout(M)}}});var k;(function(O){function U(M){return M===O.None||M===O.Cancelled||M instanceof m?!0:!M||typeof M!="object"?!1:typeof M.isCancellationRequested=="boolean"&&typeof M.onCancellationRequested=="function"}O.isCancellationToken=U,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k||(e.CancellationToken=k={}));class m{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new d.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class r1{constructor(U){this.f=void 0,this.g=void 0,this.g=U&&U.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new m),this.f}cancel(){this.f?this.f instanceof m&&this.f.cancel():this.f=k.Cancelled}dispose(U=!1){U&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof m&&this.f.dispose():this.f=k.None}}e.$ye=r1;function H(O){const U=new r1;return O.add({dispose(){U.cancel()}}),U.token}}),define(a1[16],h1([0,1,15]),function(t1,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=k;class t{constructor(O){this.b=O,this.a=null}get(){if(this.a)return this.a;const O=new d.$ye,U=this.b(O.token);return this.a={promise:U,dispose:()=>{this.a=null,O.cancel(),O.dispose()}},this.a}}e.$$e=t;function k(H){return H}class m{constructor(O,U){this.a=void 0,this.b=void 0,typeof O=="function"?(this.c=O,this.d=k):(this.c=U,this.d=O.getCacheKey)}get(O){const U=this.d(O);return this.b!==U&&(this.b=U,this.a=this.c(O)),this.a}}e.$af=m;class r1{get cachedValues(){return this.a}constructor(O,U){this.a=new Map,this.b=new Map,typeof O=="function"?(this.c=O,this.d=k):(this.c=U,this.d=O.getCacheKey)}get(O){const U=this.d(O);if(this.b.has(U))return this.b.get(U);const M=this.c(O);return this.a.set(O,M),this.b.set(U,M),M}}e.$bf=r1}),define(a1[17],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=d,e.$hg=t,e.$ig=k,e.$jg=m,e.$kg=r1,e.$lg=H,e.$mg=O,e.$ng=U,e.$og=M,e.$pg=B,e.$qg=j,e.$rg=n1,e.$sg=l1,e.$tg=z,e.$ug=S,e.$vg=g,e.$wg=b,e.$xg=R;function d(f){return typeof f=="string"}function t(f){return Array.isArray(f)&&f.every(n=>d(n))}function k(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function m(f){const n=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof n}function r1(f){return typeof f=="number"&&!isNaN(f)}function H(f){return!!f&&typeof f[Symbol.iterator]=="function"}function O(f){return f===!0||f===!1}function U(f){return typeof f>"u"}function M(f){return!B(f)}function B(f){return U(f)||f===null}function j(f,n){if(!f)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function n1(f){if(B(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function l1(...f){const n=[];for(let s=0;s<f.length;s++){const o=f[s];if(B(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(o)}return n}const P=Object.prototype.hasOwnProperty;function z(f){if(!k(f))return!1;for(const n in f)if(P.call(f,n))return!1;return!0}function S(f){return typeof f=="function"}function g(...f){return f.length>0&&f.every(S)}function b(f,n){const s=Math.min(f.length,n.length);for(let o=0;o<s;o++)R(f[o],n[o])}function R(f,n){if(d(n)){if(typeof f!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(S(n)){try{if(f instanceof n)return}catch{}if(!B(f)&&f.constructor===n||n.length===1&&n.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(a1[18],h1([0,1,17]),function(t1,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=t,e.$fo=k,e.$go=r1,e.$ho=O,e.$io=U,e.$jo=M,e.$ko=B,e.$lo=j,e.$mo=n1,e.$no=l1,e.$oo=P,e.$po=z,e.$qo=S;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([R,f])=>{b[R]=f&&typeof f=="object"?t(f):f}),b}function k(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const R=b.shift();Object.freeze(R);for(const f in R)if(m.call(R,f)){const n=R[f];typeof n=="object"&&!Object.isFrozen(n)&&!(0,d.$jg)(n)&&b.push(n)}}return g}const m=Object.prototype.hasOwnProperty;function r1(g,b){return H(g,b,new Set)}function H(g,b,R){if((0,d.$pg)(g))return g;const f=b(g);if(typeof f<"u")return f;if(Array.isArray(g)){const n=[];for(const s of g)n.push(H(s,b,R));return n}if((0,d.$ig)(g)){if(R.has(g))throw new Error("Cannot clone recursive data-structure");R.add(g);const n={};for(const s in g)m.call(g,s)&&(n[s]=H(g[s],b,R));return R.delete(g),n}return g}function O(g,b,R=!0){return(0,d.$ig)(g)?((0,d.$ig)(b)&&Object.keys(b).forEach(f=>{f in g?R&&((0,d.$ig)(g[f])&&(0,d.$ig)(b[f])?O(g[f],b[f],R):g[f]=b[f]):g[f]=b[f]}),g):b}function U(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let R,f;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(R=0;R<g.length;R++)if(!U(g[R],b[R]))return!1}else{const n=[];for(f in g)n.push(f);n.sort();const s=[];for(f in b)s.push(f);if(s.sort(),!U(n,s))return!1;for(R=0;R<n.length;R++)if(!U(g[n[R]],b[n[R]]))return!1}return!0}function M(g){const b=new Set;return JSON.stringify(g,(R,f)=>{if((0,d.$ig)(f)||Array.isArray(f)){if(b.has(f))return"[Circular]";b.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function B(g,b){const R=Object.create(null);return!g||!b||Object.keys(b).forEach(n=>{const s=g[n],o=b[n];U(s,o)||(R[n]=o)}),R}function j(g,b){const R=b.toLowerCase(),f=Object.keys(g).find(n=>n.toLowerCase()===R);return f?g[f]:g[b]}function n1(g,b){const R=Object.create(null);for(const[f,n]of Object.entries(g))b(f,n)&&(R[f]=n);return R}function l1(g){let b=[];for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}function P(g){const b=[];for(const R of l1(g))typeof g[R]=="function"&&b.push(R);return b}function z(g,b){const R=n=>function(){const s=Array.prototype.slice.call(arguments,0);return b(n,s)},f={};for(const n of g)f[n]=R(n);return f}function S(g,b){const R={};for(const[f,n]of Object.entries(g))R[f]=b(n,f);return R}}),define(a1[19],h1([0,1]),function(t1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=k;var d;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d||(e.Constants=d={}));function t(m){return m<0?0:m>d.MAX_UINT_8?d.MAX_UINT_8:m|0}function k(m){return m<0?0:m>d.MAX_UINT_32?d.MAX_UINT_32:m|0}}),define(a1[20],h1([0,1,16,7,11,19]),function(t1,e,d,t,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=r1,e.$ff=O,e.$gf=M,e.$hf=B,e.$if=j,e.$jf=n1,e.$kf=l1,e.$lf=P,e.$mf=z,e.$nf=S,e.$of=g,e.$pf=b,e.$qf=R,e.$rf=f,e.$sf=n,e.$tf=s,e.$uf=o,e.$vf=u,e.$wf=L,e.$xf=T,e.$yf=J,e.$zf=g1,e.$Af=_1,e.$Bf=K,e.$Cf=N,e.$Df=a,e.$Ef=D,e.$Ff=G,e.$Gf=v,e.$Hf=E,e.$If=F,e.$Jf=Q,e.$Kf=X,e.$Lf=x,e.$Mf=i1,e.$Nf=Y,e.$Of=e1,e.$Rf=w1,e.$Sf=N1,e.$Tf=W1,e.$Uf=G1,e.$Vf=c,e.$Wf=l,e.$Yf=$,e.$Zf=w,e.$1f=Z,e.$2f=c1,e.$3f=d1,e.$4f=A1,e.$5f=I,e.$7f=q,e.$8f=p,e.$9f=V,e.$0f=s1,e.$$f=o1,e.$_f=b1,e.$ag=$1,e.$bg=F1,e.$cg=H1;function r1(i){return!i||typeof i!="string"?!0:i.trim().length===0}const H=/{(\d+)}/g;function O(i,...r){return r.length===0?i:i.replace(H,function(h,A){const W=parseInt(A,10);return isNaN(W)||W<0||W>=r.length?h:r[W]})}const U=/{([^}]+)}/g;function M(i,r){return Object.keys(r).length===0?i:i.replace(U,(h,A)=>r[A]??h)}function B(i){return i.replace(/[<>"'&]/g,r=>{switch(r){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return r})}function j(i){return i.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function n1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l1(i,r){let h=0,A=i.indexOf(r);for(;A!==-1;)h++,A=i.indexOf(r,A+r.length);return h}function P(i,r,h="\u2026"){return i.length<=r?i:`${i.substr(0,r)}${h}`}function z(i,r,h="\u2026"){if(i.length<=r)return i;const A=Math.ceil(r/2)-h.length/2,W=Math.floor(r/2)-h.length/2;return`${i.substr(0,A)}${h}${i.substr(i.length-W)}`}function S(i,r=" "){const h=g(i,r);return b(h,r)}function g(i,r){if(!i||!r)return i;const h=r.length;if(h===0||i.length===0)return i;let A=0;for(;i.indexOf(r,A)===A;)A=A+h;return i.substring(A)}function b(i,r){if(!i||!r)return i;const h=r.length,A=i.length;if(h===0||A===0)return i;let W=A,u1=-1;for(;u1=i.lastIndexOf(r,W-1),!(u1===-1||u1+h!==W);){if(u1===0)return"";W=u1}return i.substring(0,W)}function R(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(i){return i.replace(/\*/g,"")}function n(i,r,h={}){if(!i)throw new Error("Cannot create regex from empty string");r||(i=n1(i)),h.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let A="";return h.global&&(A+="g"),h.matchCase||(A+="i"),h.multiline&&(A+="m"),h.unicode&&(A+="u"),new RegExp(i,A)}function s(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function o(i){return i.split(/\r\n|\r|\n/)}function u(i){const r=[],h=i.split(/(\r\n|\r|\n)/);for(let A=0;A<Math.ceil(h.length/2);A++)r.push(h[2*A]+(h[2*A+1]??""));return r}function L(i){for(let r=0,h=i.length;r<h;r++){const A=i.charCodeAt(r);if(A!==t.CharCode.Space&&A!==t.CharCode.Tab)return r}return-1}function T(i,r=0,h=i.length){for(let A=r;A<h;A++){const W=i.charCodeAt(A);if(W!==t.CharCode.Space&&W!==t.CharCode.Tab)return i.substring(r,A)}return i.substring(r,h)}function J(i,r=i.length-1){for(let h=r;h>=0;h--){const A=i.charCodeAt(h);if(A!==t.CharCode.Space&&A!==t.CharCode.Tab)return h}return-1}function g1(i,r,h){const A=[];let W=0;for(const u1 of i.matchAll(r)){if(A.push(i.slice(W,u1.index)),u1.index===void 0)throw new Error("match.index should be defined");W=u1.index+u1[0].length,A.push(h(u1[0],...u1.slice(1),u1.index,i,u1.groups))}return A.push(i.slice(W)),Promise.all(A).then(u1=>u1.join(""))}function _1(i,r){return i<r?-1:i>r?1:0}function K(i,r,h=0,A=i.length,W=0,u1=r.length){for(;h<A&&W<u1;h++,W++){const O1=i.charCodeAt(h),D1=r.charCodeAt(W);if(O1<D1)return-1;if(O1>D1)return 1}const m1=A-h,M1=u1-W;return m1<M1?-1:m1>M1?1:0}function N(i,r){return a(i,r,0,i.length,0,r.length)}function a(i,r,h=0,A=i.length,W=0,u1=r.length){for(;h<A&&W<u1;h++,W++){let O1=i.charCodeAt(h),D1=r.charCodeAt(W);if(O1===D1)continue;if(O1>=128||D1>=128)return K(i.toLowerCase(),r.toLowerCase(),h,A,W,u1);G(O1)&&(O1-=32),G(D1)&&(D1-=32);const U1=O1-D1;if(U1!==0)return U1}const m1=A-h,M1=u1-W;return m1<M1?-1:m1>M1?1:0}function D(i){return i>=t.CharCode.Digit0&&i<=t.CharCode.Digit9}function G(i){return i>=t.CharCode.a&&i<=t.CharCode.z}function v(i){return i>=t.CharCode.A&&i<=t.CharCode.Z}function E(i,r){return i.length===r.length&&a(i,r)===0}function F(i,r){const h=r.length;return r.length>i.length?!1:a(i,r,0,h)===0}function Q(i,r){const h=Math.min(i.length,r.length);let A;for(A=0;A<h;A++)if(i.charCodeAt(A)!==r.charCodeAt(A))return A;return h}function X(i,r){const h=Math.min(i.length,r.length);let A;const W=i.length-1,u1=r.length-1;for(A=0;A<h;A++)if(i.charCodeAt(W-A)!==r.charCodeAt(u1-A))return A;return h}function x(i){return 55296<=i&&i<=56319}function i1(i){return 56320<=i&&i<=57343}function Y(i,r){return(i-55296<<10)+(r-56320)+65536}function e1(i,r,h){const A=i.charCodeAt(h);if(x(A)&&h+1<r){const W=i.charCodeAt(h+1);if(i1(W))return Y(A,W)}return A}function f1(i,r){const h=i.charCodeAt(r-1);if(i1(h)&&r>1){const A=i.charCodeAt(r-2);if(x(A))return Y(A,h)}return h}class L1{get offset(){return this.e}constructor(r,h=0){this.c=r,this.d=r.length,this.e=h}setOffset(r){this.e=r}prevCodePoint(){const r=f1(this.c,this.e);return this.e-=r>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}nextCodePoint(){const r=e1(this.c,this.d,this.e);return this.e+=r>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}eol(){return this.e>=this.d}}e.$Pf=L1;class R1{get offset(){return this.c.offset}constructor(r,h=0){this.c=new L1(r,h)}nextGraphemeLength(){const r=I1.getInstance(),h=this.c,A=h.offset;let W=r.getGraphemeBreakType(h.nextCodePoint());for(;!h.eol();){const u1=h.offset,m1=r.getGraphemeBreakType(h.nextCodePoint());if(P1(W,m1)){h.setOffset(u1);break}W=m1}return h.offset-A}prevGraphemeLength(){const r=I1.getInstance(),h=this.c,A=h.offset;let W=r.getGraphemeBreakType(h.prevCodePoint());for(;h.offset>0;){const u1=h.offset,m1=r.getGraphemeBreakType(h.prevCodePoint());if(P1(m1,W)){h.setOffset(u1);break}W=m1}return A-h.offset}eol(){return this.c.eol()}}e.$Qf=R1;function w1(i,r){return new R1(i,r).nextGraphemeLength()}function N1(i,r){return new R1(i,r).prevGraphemeLength()}function W1(i,r){r>0&&i1(i.charCodeAt(r))&&r--;const h=r+w1(i,r);return[h-N1(i,h),h]}function G1(i){const r=new R1(i);let h=0;for(;!r.eol();)h++,r.nextGraphemeLength();return h}let v1;function y1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function c(i){return v1||(v1=y1()),v1.test(i)}const _=/^[\t\n\r\x20-\x7E]*$/;function l(i){return _.test(i)}e.$Xf=/[\u2028\u2029]/;function $(i){return e.$Xf.test(i)}function w(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function Z(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function c1(i,r,h=""){const A=i.trimStart();if(A.length<r)return A;const W=/\b/g;let u1=0;for(;W.test(A)&&!(A.length-W.lastIndex<r);)u1=W.lastIndex,W.lastIndex+=1;return u1===0?A:h+A.substring(u1).trimStart()}const E1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*d1(i){let r=0;for(const h of i.matchAll(E1))r!==h.index&&(yield{isCode:!1,str:i.substring(r,h.index)}),yield{isCode:!0,str:h[0]},r=h.index+h[0].length;r!==i.length&&(yield{isCode:!1,str:i.substring(r)})}function A1(i){return i&&(i=i.replace(E1,"")),i}const y=/\\\[.*?\\\]/g;function I(i){return A1(i).replace(y,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function q(i){return!!(i&&i.length>0&&i.charCodeAt(0)===t.CharCode.UTF8_BOM)}function p(i){return q(i)?i.substr(1):i}function V(i,r){if(!i||!r||i.length<r.length)return!1;const h=r.length,A=i.toLowerCase();let W=0,u1=-1;for(;W<h;){const m1=A.indexOf(r[W],u1+1);if(m1<0)return!1;u1=m1,W++}return!0}function s1(i,r=!1){return i?(r&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function o1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function b1(i,r=1){if(r===0)return"";let h=-1;do h=i.indexOf(`
`,h+1),r--;while(r>0&&h>=0);return h===-1?i:(i[h-1]==="\r"&&h--,i.substr(0,h))}function $1(i){const r=t.CharCode.Z-t.CharCode.A+1;return i=i%(2*r),i<r?String.fromCharCode(t.CharCode.a+i):String.fromCharCode(t.CharCode.A+i-r)}function F1(i){return I1.getInstance().getGraphemeBreakType(i)}function P1(i,r){return i===C.Other?r!==C.Extend&&r!==C.SpacingMark:i===C.CR&&r===C.LF?!1:i===C.Control||i===C.CR||i===C.LF||r===C.Control||r===C.CR||r===C.LF?!0:!(i===C.L&&(r===C.L||r===C.V||r===C.LV||r===C.LVT)||(i===C.LV||i===C.V)&&(r===C.V||r===C.T)||(i===C.LVT||i===C.T)&&r===C.T||r===C.Extend||r===C.ZWJ||r===C.SpacingMark||i===C.Prepend||i===C.ZWJ&&r===C.Extended_Pictographic||i===C.Regional_Indicator&&r===C.Regional_Indicator)}var C;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(C||(e.GraphemeBreakType=C={}));class I1{static{this.c=null}static getInstance(){return I1.c||(I1.c=new I1),I1.c}constructor(){this.d=p1()}getGraphemeBreakType(r){if(r<32)return r===t.CharCode.LineFeed?C.LF:r===t.CharCode.CarriageReturn?C.CR:C.Control;if(r<127)return C.Other;const h=this.d,A=h.length/3;let W=1;for(;W<=A;)if(r<h[3*W])W=2*W;else if(r>h[3*W+1])W=2*W+1;else return h[3*W+2];return C.Other}}function p1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function H1(i,r){if(i===0)return 0;const h=K1(i,r);if(h!==void 0)return h;const A=new L1(r,i);return A.prevCodePoint(),A.offset}function K1(i,r){const h=new L1(r,i);let A=h.prevCodePoint();for(;J1(A)||A===q1.emojiVariantSelector||A===q1.enclosingKeyCap;){if(h.offset===0)return;A=h.prevCodePoint()}if(!Z(A))return;let W=h.offset;return W>0&&h.prevCodePoint()===q1.zwj&&(W=h.offset),W}function J1(i){return 127995<=i&&i<=127999}var q1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(q1||(q1={})),e.$dg="\xA0";class k1{static{this.c=new k.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new d.$af({getCacheKey:JSON.stringify},r=>{function h(U1){const S1=new Map;for(let T1=0;T1<U1.length;T1+=2)S1.set(U1[T1],U1[T1+1]);return S1}function A(U1,S1){const T1=new Map(U1);for(const[j1,z1]of S1)T1.set(j1,z1);return T1}function W(U1,S1){if(!U1)return S1;const T1=new Map;for(const[j1,z1]of U1)S1.has(j1)&&T1.set(j1,z1);return T1}const u1=this.c.value;let m1=r.filter(U1=>!U1.startsWith("_")&&U1 in u1);m1.length===0&&(m1=["_default"]);let M1;for(const U1 of m1){const S1=h(u1[U1]);M1=W(M1,S1)}const O1=h(u1._common),D1=A(O1,M1);return new k1(D1)})}static getInstance(r){return k1.d.get(Array.from(r))}static{this.e=new k.$X(()=>Object.keys(k1.c.value).filter(r=>!r.startsWith("_")))}static getLocales(){return k1.e.value}constructor(r){this.f=r}isAmbiguous(r){return this.f.has(r)}containsAmbiguousCharacter(r){for(let h=0;h<r.length;h++){const A=r.codePointAt(h);if(typeof A=="number"&&this.isAmbiguous(A))return!0}return!1}getPrimaryConfusable(r){return this.f.get(r)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=k1;class B1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(B1.c())),this.d}static isInvisibleCharacter(r){return B1.e().has(r)}static containsInvisibleCharacter(r){for(let h=0;h<r.length;h++){const A=r.codePointAt(h);if(typeof A=="number"&&B1.isInvisibleCharacter(A))return!0}return!1}static get codePoints(){return B1.e()}}e.$fg=B1}),define(a1[21],h1([23,24]),function(t1,e){return t1.create("vs/base/common/platform",e)});var X1=this&&this.__createBinding||(Object.create?function(t1,e,d,t){t===void 0&&(t=d);var k=Object.getOwnPropertyDescriptor(e,d);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[d]}}),Object.defineProperty(t1,t,k)}:function(t1,e,d,t){t===void 0&&(t=d),t1[t]=e[d]}),Y1=this&&this.__setModuleDefault||(Object.create?function(t1,e){Object.defineProperty(t1,"default",{enumerable:!0,value:e})}:function(t1,e){t1.default=e}),V1=this&&this.__importStar||function(t1){if(t1&&t1.__esModule)return t1;var e={};if(t1!=null)for(var d in t1)d!=="default"&&Object.prototype.hasOwnProperty.call(t1,d)&&X1(e,t1,d);return Y1(e,t1),e};define(a1[22],h1([0,1,21]),function(t1,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=g1,e.$J=_1,d=V1(d),e.$g="en";let t=!1,k=!1,m=!1,r1=!1,H=!1,O=!1,U=!1,M=!1,B=!1,j=!1,n1,l1=e.$g,P=e.$g,z,S;const g=globalThis;let b;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?b=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const R=typeof b?.versions?.electron=="string",f=R&&b?.type==="renderer";if(typeof b=="object"){t=b.platform==="win32",k=b.platform==="darwin",m=b.platform==="linux",r1=m&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,U=R,B=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n1=e.$g,l1=e.$g;const K=b.env.VSCODE_NLS_CONFIG;if(K)try{const N=JSON.parse(K),a=N.availableLanguages["*"];n1=N.locale,P=N.osLocale,l1=a||e.$g,z=N._translationsConfigFile}catch{}H=!0}else typeof navigator=="object"&&!f?(S=navigator.userAgent,t=S.indexOf("Windows")>=0,k=S.indexOf("Macintosh")>=0,M=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=S.indexOf("Linux")>=0,j=S?.indexOf("Mobi")>=0,O=!0,n1=d.getConfiguredDefaultLocale(d.localize(0,null))||e.$g,l1=n1,P=navigator.language):console.error("Unable to resolve platform.");var n;(function(K){K[K.Web=0]="Web",K[K.Mac=1]="Mac",K[K.Linux=2]="Linux",K[K.Windows=3]="Windows"})(n||(e.Platform=n={}));function s(K){switch(K){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let o=n.Web;k?o=n.Mac:t?o=n.Windows:m&&(o=n.Linux),e.$i=t,e.$j=k,e.$k=m,e.$l=r1,e.$m=H,e.$n=U,e.$o=O,e.$p=O&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=M,e.$s=j,e.$t=B,e.$u=o,e.$v=S,e.$w=l1;var u;(function(K){function N(){return e.$w}K.value=N;function a(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}K.isDefaultVariant=a;function D(){return e.$w==="en"}K.isDefault=D})(u||(e.Language=u={})),e.$x=n1,e.$y=P,e.$z=z,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const K=[];g.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let D=0,G=K.length;D<G;D++){const v=K[D];if(v.id===a.data.vscodeScheduleAsyncWork){K.splice(D,1),v.callback();return}}});let N=0;return a=>{const D=++N;K.push({id:D,callback:a}),g.postMessage({vscodeScheduleAsyncWork:D},"*")}}return K=>setTimeout(K)})();var L;(function(K){K[K.Windows=1]="Windows",K[K.Macintosh=2]="Macintosh",K[K.Linux=3]="Linux"})(L||(e.OperatingSystem=L={})),e.OS=k||M?L.Macintosh:t?L.Windows:L.Linux;let T=!0,J=!1;function g1(){if(!J){J=!0;const K=new Uint8Array(2);K[0]=1,K[1]=2,T=new Uint16Array(K.buffer)[0]===513}return T}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function _1(K){return parseFloat(K)>=20}}),define(a1[25],h1([0,1,2,5,4,18,22,20]),function(t1,e,d,t,k,m,r1,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SimpleWorkerServer=e.SimpleWorkerClient=void 0,e.logOnceWebWorkerWarning=M,e.create=s,H=V1(H);const O="$initialize";let U=!1;function M(o){r1.$o&&(U||(U=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var B;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})(B||(B={}));class j{constructor(u,L,T,J){this.vsWorker=u,this.req=L,this.method=T,this.args=J,this.type=B.Request}}class n1{constructor(u,L,T,J){this.vsWorker=u,this.seq=L,this.res=T,this.err=J,this.type=B.Reply}}class l1{constructor(u,L,T,J){this.vsWorker=u,this.req=L,this.eventName=T,this.arg=J,this.type=B.SubscribeEvent}}class P{constructor(u,L,T){this.vsWorker=u,this.req=L,this.event=T,this.type=B.Event}}class z{constructor(u,L){this.vsWorker=u,this.req=L,this.type=B.UnsubscribeEvent}}class S{constructor(u){this.a=-1,this.g=u,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(u){this.a=u}sendMessage(u,L){const T=String(++this.b);return new Promise((J,g1)=>{this.c[T]={resolve:J,reject:g1},this.o(new j(this.a,T,u,L))})}listen(u,L){let T=null;const J=new t.$ne({onWillAddFirstListener:()=>{T=String(++this.b),this.d.set(T,J),this.o(new l1(this.a,T,u,L))},onDidRemoveLastListener:()=>{this.d.delete(T),this.o(new z(this.a,T)),T=null}});return J.event}handleMessage(u){!u||!u.vsWorker||this.a!==-1&&u.vsWorker!==this.a||this.h(u)}h(u){switch(u.type){case B.Reply:return this.j(u);case B.Request:return this.k(u);case B.SubscribeEvent:return this.l(u);case B.Event:return this.m(u);case B.UnsubscribeEvent:return this.n(u)}}j(u){if(!this.c[u.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[u.seq];if(delete this.c[u.seq],u.err){let T=u.err;u.err.$isError&&(T=new Error,T.name=u.err.name,T.message=u.err.message,T.stack=u.err.stack),L.reject(T);return}L.resolve(u.res)}k(u){const L=u.req;this.g.handleMessage(u.method,u.args).then(J=>{this.o(new n1(this.a,L,J,void 0))},J=>{J.detail instanceof Error&&(J.detail=(0,d.$5)(J.detail)),this.o(new n1(this.a,L,void 0,(0,d.$5)(J)))})}l(u){const L=u.req,T=this.g.handleEvent(u.eventName,u.arg)(J=>{this.o(new P(this.a,L,J))});this.f.set(L,T)}m(u){if(!this.d.has(u.req)){console.warn("Got event for unknown req");return}this.d.get(u.req).fire(u.event)}n(u){if(!this.f.has(u.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(u.req).dispose(),this.f.delete(u.req)}o(u){const L=[];if(u.type===B.Request)for(let T=0;T<u.args.length;T++)u.args[T]instanceof ArrayBuffer&&L.push(u.args[T]);else u.type===B.Reply&&u.res instanceof ArrayBuffer&&L.push(u.res);this.g.sendMessage(u,L)}}class g extends k.$Xc{constructor(u,L,T){super();let J=null;this.a=this.B(u.create("vs/base/common/worker/simpleWorker",D=>{this.c.handleMessage(D)},D=>{J?.(D)})),this.c=new S({sendMessage:(D,G)=>{this.a.postMessage(D,G)},handleMessage:(D,G)=>{if(typeof T[D]!="function")return Promise.reject(new Error("Missing method "+D+" on main thread host."));try{return Promise.resolve(T[D].apply(T,G))}catch(v){return Promise.reject(v)}},handleEvent:(D,G)=>{if(R(D)){const v=T[D].call(T,G);if(typeof v!="function")throw new Error(`Missing dynamic event ${D} on main thread host.`);return v}if(b(D)){const v=T[D];if(typeof v!="function")throw new Error(`Missing event ${D} on main thread host.`);return v}throw new Error(`Malformed event name ${D}`)}}),this.c.setWorkerId(this.a.getId());let g1=null;const _1=globalThis.require;typeof _1<"u"&&typeof _1.getConfig=="function"?g1=_1.getConfig():typeof globalThis.requirejs<"u"&&(g1=globalThis.requirejs.s.contexts._.config);const K=(0,m.$oo)(T);this.b=this.c.sendMessage(O,[this.a.getId(),JSON.parse(JSON.stringify(g1)),L,K]);const N=(D,G)=>this.g(D,G),a=(D,G)=>this.c.listen(D,G);this.f=new Promise((D,G)=>{J=G,this.b.then(v=>{D(f(v,N,a))},v=>{G(v),this.h("Worker failed to load "+L,v)})})}getProxyObject(){return this.f}g(u,L){return new Promise((T,J)=>{this.b.then(()=>{this.c.sendMessage(u,L).then(T,J)},J)})}h(u,L){console.error(u),console.info(L)}}e.SimpleWorkerClient=g;function b(o){return o[0]==="o"&&o[1]==="n"&&H.$Gf(o.charCodeAt(2))}function R(o){return/^onDynamic/.test(o)&&H.$Gf(o.charCodeAt(9))}function f(o,u,L){const T=_1=>function(){const K=Array.prototype.slice.call(arguments,0);return u(_1,K)},J=_1=>function(K){return L(_1,K)},g1={};for(const _1 of o){if(R(_1)){g1[_1]=J(_1);continue}if(b(_1)){g1[_1]=L(_1,void 0);continue}g1[_1]=T(_1)}return g1}class n{constructor(u,L){this.a=L,this.b=null,this.c=new S({sendMessage:(T,J)=>{u(T,J)},handleMessage:(T,J)=>this.d(T,J),handleEvent:(T,J)=>this.f(T,J)})}onmessage(u){this.c.handleMessage(u)}d(u,L){if(u===O)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this.b[u].apply(this.b,L))}catch(T){return Promise.reject(T)}}f(u,L){if(!this.b)throw new Error("Missing requestHandler");if(R(u)){const T=this.b[u].call(this.b,L);if(typeof T!="function")throw new Error(`Missing dynamic event ${u} on request handler.`);return T}if(b(u)){const T=this.b[u];if(typeof T!="function")throw new Error(`Missing event ${u} on request handler.`);return T}throw new Error(`Malformed event name ${u}`)}g(u,L,T,J){this.c.setWorkerId(u);const K=f(J,(N,a)=>this.c.sendMessage(N,a),(N,a)=>this.c.listen(N,a));return this.a?(this.b=this.a(K),Promise.resolve((0,m.$oo)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((N,a)=>{(globalThis.require||t1)([T],G=>{if(this.b=G.create(K),!this.b){a(new Error("No RequestHandler!"));return}N((0,m.$oo)(this.b))},a)}))}}e.SimpleWorkerServer=n;function s(o){return new n(o,null)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/b36286db80c68b7fdc6bfee2f55e0208c8833dfc/core/vs/base/common/worker/simpleWorker.js.map
