/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/nls!vs/code/electron-main/main","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/objects","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/issue/electron-main/processMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ae=function(x){for(var e=[],n=0,o=x.length;n<o;n++)e[n]=oe[x[n]];return e};define(oe[138],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=n,e.$jb=o,e.$kb=k,e.$lb=D,e.$mb=O,e.$nb=I,e.$ob=v,e.$qb=f,e.$rb=d,e.$sb=g,e.$tb=w,e.$ub=h;function n(p,b){const $=o(p,b);if($!==-1)return p[$]}function o(p,b,$=p.length-1){for(let m=$;m>=0;m--){const E=p[m];if(b(E))return m}return-1}function k(p,b){const $=D(p,b);return $===-1?void 0:p[$]}function D(p,b,$=0,m=p.length){let E=$,P=m;for(;E<P;){const t=Math.floor((E+P)/2);b(p[t])?E=t+1:P=t}return E-1}function O(p,b){const $=I(p,b);return $===p.length?void 0:p[$]}function I(p,b,$=0,m=p.length){let E=$,P=m;for(;E<P;){const t=Math.floor((E+P)/2);b(p[t])?P=t:E=t+1}return E}function v(p,b,$=0,m=p.length){const E=I(p,b,$,m);return E===p.length?-1:E}class a{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(a.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!b(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const $=D(this.e,b,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$pb=a;function f(p,b){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const E=p[m];b(E,$)>0&&($=E)}return $}function d(p,b){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const E=p[m];b(E,$)>=0&&($=E)}return $}function g(p,b){return f(p,($,m)=>-b($,m))}function w(p,b){if(p.length===0)return-1;let $=0;for(let m=1;m<p.length;m++){const E=p[m];b(E,p[$])>0&&($=m)}return $}function h(p,b){for(const $ of p){const m=b($);if(m!==void 0)return m}}}),define(oe[39],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(o){o[o.Null=0]="Null",o[o.Backspace=8]="Backspace",o[o.Tab=9]="Tab",o[o.LineFeed=10]="LineFeed",o[o.CarriageReturn=13]="CarriageReturn",o[o.Space=32]="Space",o[o.ExclamationMark=33]="ExclamationMark",o[o.DoubleQuote=34]="DoubleQuote",o[o.Hash=35]="Hash",o[o.DollarSign=36]="DollarSign",o[o.PercentSign=37]="PercentSign",o[o.Ampersand=38]="Ampersand",o[o.SingleQuote=39]="SingleQuote",o[o.OpenParen=40]="OpenParen",o[o.CloseParen=41]="CloseParen",o[o.Asterisk=42]="Asterisk",o[o.Plus=43]="Plus",o[o.Comma=44]="Comma",o[o.Dash=45]="Dash",o[o.Period=46]="Period",o[o.Slash=47]="Slash",o[o.Digit0=48]="Digit0",o[o.Digit1=49]="Digit1",o[o.Digit2=50]="Digit2",o[o.Digit3=51]="Digit3",o[o.Digit4=52]="Digit4",o[o.Digit5=53]="Digit5",o[o.Digit6=54]="Digit6",o[o.Digit7=55]="Digit7",o[o.Digit8=56]="Digit8",o[o.Digit9=57]="Digit9",o[o.Colon=58]="Colon",o[o.Semicolon=59]="Semicolon",o[o.LessThan=60]="LessThan",o[o.Equals=61]="Equals",o[o.GreaterThan=62]="GreaterThan",o[o.QuestionMark=63]="QuestionMark",o[o.AtSign=64]="AtSign",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.OpenSquareBracket=91]="OpenSquareBracket",o[o.Backslash=92]="Backslash",o[o.CloseSquareBracket=93]="CloseSquareBracket",o[o.Caret=94]="Caret",o[o.Underline=95]="Underline",o[o.BackTick=96]="BackTick",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.OpenCurlyBrace=123]="OpenCurlyBrace",o[o.Pipe=124]="Pipe",o[o.CloseCurlyBrace=125]="CloseCurlyBrace",o[o.Tilde=126]="Tilde",o[o.NoBreakSpace=160]="NoBreakSpace",o[o.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",o[o.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",o[o.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",o[o.U_Combining_Tilde=771]="U_Combining_Tilde",o[o.U_Combining_Macron=772]="U_Combining_Macron",o[o.U_Combining_Overline=773]="U_Combining_Overline",o[o.U_Combining_Breve=774]="U_Combining_Breve",o[o.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",o[o.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",o[o.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",o[o.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",o[o.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",o[o.U_Combining_Caron=780]="U_Combining_Caron",o[o.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",o[o.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",o[o.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",o[o.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",o[o.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",o[o.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",o[o.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",o[o.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",o[o.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",o[o.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",o[o.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",o[o.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",o[o.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",o[o.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",o[o.U_Combining_Horn=795]="U_Combining_Horn",o[o.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",o[o.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",o[o.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",o[o.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",o[o.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",o[o.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",o[o.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",o[o.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",o[o.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",o[o.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",o[o.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",o[o.U_Combining_Cedilla=807]="U_Combining_Cedilla",o[o.U_Combining_Ogonek=808]="U_Combining_Ogonek",o[o.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",o[o.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",o[o.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",o[o.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",o[o.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",o[o.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",o[o.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",o[o.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",o[o.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",o[o.U_Combining_Low_Line=818]="U_Combining_Low_Line",o[o.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",o[o.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",o[o.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",o[o.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",o[o.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",o[o.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",o[o.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",o[o.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",o[o.U_Combining_Square_Below=827]="U_Combining_Square_Below",o[o.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",o[o.U_Combining_X_Above=829]="U_Combining_X_Above",o[o.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",o[o.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",o[o.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",o[o.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",o[o.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",o[o.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",o[o.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",o[o.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",o[o.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",o[o.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",o[o.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",o[o.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",o[o.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",o[o.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",o[o.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",o[o.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",o[o.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",o[o.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",o[o.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",o[o.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",o[o.U_Combining_Fermata=850]="U_Combining_Fermata",o[o.U_Combining_X_Below=851]="U_Combining_X_Below",o[o.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",o[o.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",o[o.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",o[o.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",o[o.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",o[o.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",o[o.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",o[o.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",o[o.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",o[o.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",o[o.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",o[o.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",o[o.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",o[o.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",o[o.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",o[o.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",o[o.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",o[o.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",o[o.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",o[o.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",o[o.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",o[o.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",o[o.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",o[o.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",o[o.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",o[o.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",o[o.LINE_SEPARATOR=8232]="LINE_SEPARATOR",o[o.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",o[o.NEXT_LINE=133]="NEXT_LINE",o[o.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",o[o.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",o[o.U_DIAERESIS=168]="U_DIAERESIS",o[o.U_MACRON=175]="U_MACRON",o[o.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",o[o.U_CEDILLA=184]="U_CEDILLA",o[o.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",o[o.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",o[o.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",o[o.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",o[o.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",o[o.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",o[o.U_BREVE=728]="U_BREVE",o[o.U_DOT_ABOVE=729]="U_DOT_ABOVE",o[o.U_RING_ABOVE=730]="U_RING_ABOVE",o[o.U_OGONEK=731]="U_OGONEK",o[o.U_SMALL_TILDE=732]="U_SMALL_TILDE",o[o.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",o[o.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",o[o.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",o[o.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",o[o.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",o[o.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",o[o.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",o[o.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",o[o.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",o[o.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",o[o.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",o[o.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",o[o.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",o[o.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",o[o.U_GREEK_TONOS=900]="U_GREEK_TONOS",o[o.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",o[o.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",o[o.U_GREEK_PSILI=8127]="U_GREEK_PSILI",o[o.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",o[o.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",o[o.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",o[o.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",o[o.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",o[o.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",o[o.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",o[o.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",o[o.U_GREEK_VARIA=8175]="U_GREEK_VARIA",o[o.U_GREEK_OXIA=8189]="U_GREEK_OXIA",o[o.U_GREEK_DASIA=8190]="U_GREEK_DASIA",o[o.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",o[o.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",o[o.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",o[o.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",o[o.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",o[o.U_OVERLINE=8254]="U_OVERLINE",o[o.UTF8_BOM=65279]="UTF8_BOM",o[o.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",o[o.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(oe[139],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=o,e.$L=k,e.$M=D,e.$N=O;function o(v,a){const f=Object.create(null);for(const d of v){const g=a(d);let w=f[g];w||(w=f[g]=[]),w.push(d)}return f}function k(v,a){const f=[],d=[];for(const g of v)a.has(g)||f.push(g);for(const g of a)v.has(g)||d.push(g);return{removed:f,added:d}}function D(v,a){const f=[],d=[];for(const[g,w]of v)a.has(g)||f.push(w);for(const[g,w]of a)v.has(g)||d.push(w);return{removed:f,added:d}}function O(v,a){const f=new Set;for(const d of a)v.has(d)&&f.add(d);return f}class I{static{n=Symbol.toStringTag}constructor(a,f){this.b=f,this.a=new Map,this[n]="SetWithKey";for(const d of a)this.add(d)}get size(){return this.a.size}add(a){const f=this.b(a);return this.a.set(f,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,f){this.a.forEach(d=>a.call(f,d,d,this))}[Symbol.iterator](){return this.values()}}e.$O=I}),define(oe[140],ae([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.$ju=e.$iu=void 0;function o(v,a){const f=Math.pow(10,a);return Math.round(v*f)/f}class k{constructor(a,f,d,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.r===f.r&&a.g===f.g&&a.b===f.b&&a.a===f.a}}e.$iu=k;class D{constructor(a,f,d,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,f),0),3),this.l=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.h===f.h&&a.s===f.s&&a.l===f.l&&a.a===f.a}static fromRGBA(a){const f=a.r/255,d=a.g/255,g=a.b/255,w=a.a,h=Math.max(f,d,g),p=Math.min(f,d,g);let b=0,$=0;const m=(p+h)/2,E=h-p;if(E>0){switch($=Math.min(m<=.5?E/(2*m):E/(2-2*m),1),h){case f:b=(d-g)/E+(d<g?6:0);break;case d:b=(g-f)/E+2;break;case g:b=(f-d)/E+4;break}b*=60,b=Math.round(b)}return new D(b,$,m,w)}static i(a,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?a+(f-a)*6*d:d<1/2?f:d<2/3?a+(f-a)*(2/3-d)*6:a}static toRGBA(a){const f=a.h/360,{s:d,l:g,a:w}=a;let h,p,b;if(d===0)h=p=b=g;else{const $=g<.5?g*(1+d):g+d-g*d,m=2*g-$;h=D.i(m,$,f+1/3),p=D.i(m,$,f),b=D.i(m,$,f-1/3)}return new k(Math.round(h*255),Math.round(p*255),Math.round(b*255),w)}}e.$ju=D;class O{constructor(a,f,d,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,f),0),3),this.v=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,f){return a.h===f.h&&a.s===f.s&&a.v===f.v&&a.a===f.a}static fromRGBA(a){const f=a.r/255,d=a.g/255,g=a.b/255,w=Math.max(f,d,g),h=Math.min(f,d,g),p=w-h,b=w===0?0:p/w;let $;return p===0?$=0:w===f?$=((d-g)/p%6+6)%6:w===d?$=(g-f)/p+2:$=(f-d)/p+4,new O(Math.round($*60),b,w,a.a)}static toRGBA(a){const{h:f,s:d,v:g,a:w}=a,h=g*d,p=h*(1-Math.abs(f/60%2-1)),b=g-h;let[$,m,E]=[0,0,0];return f<60?($=h,m=p):f<120?($=p,m=h):f<180?(m=h,E=p):f<240?(m=p,E=h):f<300?($=p,E=h):f<=360&&($=h,E=p),$=Math.round(($+b)*255),m=Math.round((m+b)*255),E=Math.round((E+b)*255),new k($,m,E,w)}}e.$ku=O;class I{static fromHex(a){return I.Format.CSS.parseHex(a)||I.red}static equals(a,f){return!a&&!f?!0:!a||!f?!1:a.equals(f)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof k)this.rgba=a;else if(a instanceof D)this.i=a,this.rgba=D.toRGBA(a);else if(a instanceof O)this.j=a,this.rgba=O.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&k.equals(this.rgba,a.rgba)&&D.equals(this.hsla,a.hsla)&&O.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=I.k(this.rgba.r),f=I.k(this.rgba.g),d=I.k(this.rgba.b),g=.2126*a+.7152*f+.0722*d;return o(g,4)}static k(a){const f=a/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f>d}isDarkerThan(a){const f=this.getRelativeLuminance(),d=a.getRelativeLuminance();return f<d}lighten(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:f,g:d,b:g,a:w}=this.rgba;return new I(new k(f,d,g,w*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const f=a.rgba,d=this.rgba.a,g=f.a,w=d+g*(1-d);if(w<1e-6)return I.transparent;const h=this.rgba.r*d/w+f.r*g*(1-d)/w,p=this.rgba.g*d/w+f.g*g*(1-d)/w,b=this.rgba.b*d/w+f.b*g*(1-d)/w;return new I(new k(h,p,b,w))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:f,g:d,b:g,a:w}=this.rgba;return new I(new k(a.rgba.r-w*(a.rgba.r-f),a.rgba.g-w*(a.rgba.g-d),a.rgba.b-w*(a.rgba.b-g),1))}flatten(...a){const f=a.reduceRight((d,g)=>I.o(g,d));return I.o(this,f)}static o(a,f){const d=1-a.rgba.a;return new I(new k(d*f.rgba.r+a.rgba.a*a.rgba.r,d*f.rgba.g+a.rgba.a*a.rgba.g,d*f.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(a,f,d){if(a.isLighterThan(f))return a;d=d||.5;const g=a.getRelativeLuminance(),w=f.getRelativeLuminance();return d=d*(w-g)/w,a.lighten(d)}static getDarkerColor(a,f,d){if(a.isDarkerThan(f))return a;d=d||.5;const g=a.getRelativeLuminance(),w=f.getRelativeLuminance();return d=d*(g-w)/g,a.darken(d)}static{this.white=new I(new k(255,255,255,1))}static{this.black=new I(new k(0,0,0,1))}static{this.red=new I(new k(255,0,0,1))}static{this.blue=new I(new k(0,0,255,1))}static{this.green=new I(new k(0,255,0,1))}static{this.cyan=new I(new k(0,255,255,1))}static{this.lightgrey=new I(new k(211,211,211,1))}static{this.transparent=new I(new k(0,0,0,0))}}e.$lu=I,function(v){let a;(function(f){let d;(function(g){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:v.Format.CSS.formatRGBA(i)}g.formatRGB=w;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}g.formatRGBA=h;function p(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(i)}g.formatHSL=p;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}g.formatHSLA=b;function $(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function m(i){return`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}`}g.formatHex=m;function E(i,c=!1){return c&&i.rgba.a===1?v.Format.CSS.formatHex(i):`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}${$(Math.round(i.rgba.a*255))}`}g.formatHexA=E;function P(i){return i.isOpaque()?v.Format.CSS.formatHex(i):v.Format.CSS.formatRGBA(i)}g.format=P;function t(i){const c=i.length;if(c===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(c===7){const s=16*r(i.charCodeAt(1))+r(i.charCodeAt(2)),l=16*r(i.charCodeAt(3))+r(i.charCodeAt(4)),u=16*r(i.charCodeAt(5))+r(i.charCodeAt(6));return new v(new k(s,l,u,1))}if(c===9){const s=16*r(i.charCodeAt(1))+r(i.charCodeAt(2)),l=16*r(i.charCodeAt(3))+r(i.charCodeAt(4)),u=16*r(i.charCodeAt(5))+r(i.charCodeAt(6)),S=16*r(i.charCodeAt(7))+r(i.charCodeAt(8));return new v(new k(s,l,u,S/255))}if(c===4){const s=r(i.charCodeAt(1)),l=r(i.charCodeAt(2)),u=r(i.charCodeAt(3));return new v(new k(16*s+s,16*l+l,16*u+u))}if(c===5){const s=r(i.charCodeAt(1)),l=r(i.charCodeAt(2)),u=r(i.charCodeAt(3)),S=r(i.charCodeAt(4));return new v(new k(16*s+s,16*l+l,16*u+u,(16*S+S)/255))}return null}g.parseHex=t;function r(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(a=v.Format||(v.Format={}))}(I||(e.$lu=I={}))}),define(oe[54],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=o,e.$_h=k,e.$ai=D;function n(O){return(I,v,a)=>{let f=null,d=null;if(typeof a.value=="function"?(f="value",d=a.value):typeof a.get=="function"&&(f="get",d=a.get),!d)throw new Error("not supported");a[f]=O(d,v)}}function o(O,I,v){let a=null,f=null;if(typeof v.value=="function"?(a="value",f=v.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(a="get",f=v.get),!f)throw new Error("not supported");const d=`$memoize$${I}`;v[a]=function(...g){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,g)}),this[d]}}function k(O,I,v){return n((a,f)=>{const d=`$debounce$${f}`,g=`$debounce$result$${f}`;return function(...w){this[g]||(this[g]=v?v():void 0),clearTimeout(this[d]),I&&(this[g]=I(this[g],...w),w=[this[g]]),this[d]=setTimeout(()=>{a.apply(this,w),this[g]=v?v():void 0},O)}})}function D(O,I,v){return n((a,f)=>{const d=`$throttle$timer$${f}`,g=`$throttle$result$${f}`,w=`$throttle$lastRun$${f}`,h=`$throttle$pending$${f}`;return function(...p){if(this[g]||(this[g]=v?v():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...p)),this[h])return;const b=this[w]+O;b<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=v?v():void 0):(this[h]=!0,this[d]=setTimeout(()=>{this[h]=!1,this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=v?v():void 0},b-Date.now()))}})}}),define(oe[16],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=o,e.$2=k,e.$3=D,e.$4=O,e.$5=I,e.$6=v,e.$7=f,e.$9=g,e.$0=w,e.$$=h,e.$ab=b;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?P.isErrorNoTelemetry(i)?new P(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=n,e.$Z=new n;function o(r){e.$Z.setUnexpectedErrorHandler(r)}function k(r){if(!r||typeof r!="object")return!1;const i=r;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function D(r){f(r)||e.$Z.onUnexpectedError(r)}function O(r){f(r)||e.$Z.onUnexpectedExternalError(r)}function I(r){if(r instanceof Error){const{name:i,message:c}=r,s=r.stacktrace||r.stack;return{$isError:!0,name:i,message:c,stack:s,noTelemetry:P.isErrorNoTelemetry(r)}}return r}function v(r){let i;return r.noTelemetry?i=new P:(i=new Error,i.name=r.name),i.message=r.message,i.stack=r.stack,i}const a="Canceled";function f(r){return r instanceof d?!0:r instanceof Error&&r.name===a&&r.message===a}class d extends Error{constructor(){super(a),this.name=this.message}}e.$8=d;function g(){const r=new Error(a);return r.name=r.message,r}function w(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function h(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=p;function b(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=$;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=m;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=E;class P extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof P)return i;const c=new P;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=P;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$fb=t}),define(oe[22],ae([0,1,16,138]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=k,e.$wb=D,e.$xb=O,e.$yb=I,e.$zb=v,e.$Ab=a,e.$Bb=f,e.$Cb=d,e.$Db=g,e.$Eb=w,e.$Fb=h,e.$Gb=p,e.$Hb=b,e.top=$,e.$Jb=m,e.$Kb=P,e.$Lb=t,e.$Mb=r,e.$Nb=i,e.$Ob=c,e.$Pb=s,e.$Qb=l,e.$Rb=u,e.$Sb=S,e.$Tb=y,e.$Ub=R,e.$Vb=L,e.$Wb=T,e.$Xb=A,e.$Yb=M,e.$Zb=U,e.$1b=C,e.$2b=z,e.$3b=re,e.$4b=Z,e.$5b=le,e.$6b=X,e.$7b=ee,e.$8b=q,e.$9b=G,e.$0b=ce,e.$ac=se;function k(W,H=0){return W[W.length-(1+H)]}function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function O(W,H,J=(Y,V)=>Y===V){if(W===H)return!0;if(!W||!H||W.length!==H.length)return!1;for(let Y=0,V=W.length;Y<V;Y++)if(!J(W[Y],H[Y]))return!1;return!0}function I(W,H){const J=W.length-1;H<J&&(W[H]=W[J]),W.pop()}function v(W,H,J){return a(W.length,Y=>J(W[Y],H))}function a(W,H){let J=0,Y=W-1;for(;J<=Y;){const V=(J+Y)/2|0,ie=H(V);if(ie<0)J=V+1;else if(ie>0)Y=V-1;else return V}return-(J+1)}function f(W,H,J){if(W=W|0,W>=H.length)throw new TypeError("invalid index");const Y=H[Math.floor(H.length*Math.random())],V=[],ie=[],de=[];for(const me of H){const we=J(me,Y);we<0?V.push(me):we>0?ie.push(me):de.push(me)}return W<V.length?f(W,V,J):W<V.length+de.length?de[0]:f(W-(V.length+de.length),ie,J)}function d(W,H){const J=[];let Y;for(const V of W.slice(0).sort(H))!Y||H(Y[0],V)!==0?(Y=[V],J.push(Y)):Y.push(V);return J}function*g(W,H){let J,Y;for(const V of W)Y!==void 0&&H(Y,V)?J.push(V):(J&&(yield J),J=[V]),Y=V;J&&(yield J)}function w(W,H){for(let J=0;J<=W.length;J++)H(J===0?void 0:W[J-1],J===W.length?void 0:W[J])}function h(W,H){for(let J=0;J<W.length;J++)H(J===0?void 0:W[J-1],W[J],J+1===W.length?void 0:W[J+1])}function p(W,H,J){const Y=[];function V(me,we,Oe){if(we===0&&Oe.length===0)return;const Se=Y[Y.length-1];Se&&Se.start+Se.deleteCount===me?(Se.deleteCount+=we,Se.toInsert.push(...Oe)):Y.push({start:me,deleteCount:we,toInsert:Oe})}let ie=0,de=0;for(;;){if(ie===W.length){V(ie,0,H.slice(de));break}if(de===H.length){V(ie,W.length-ie,[]);break}const me=W[ie],we=H[de],Oe=J(me,we);Oe===0?(ie+=1,de+=1):Oe<0?(V(ie,1,[]),ie+=1):Oe>0&&(V(ie,0,[we]),de+=1)}return Y}function b(W,H,J){const Y=p(W,H,J),V=[],ie=[];for(const de of Y)V.push(...W.slice(de.start,de.start+de.deleteCount)),ie.push(...de.toInsert);return{removed:V,added:ie}}function $(W,H,J){if(J===0)return[];const Y=W.slice(0,J).sort(H);return E(W,H,Y,J,W.length),Y}function m(W,H,J,Y,V){return J===0?Promise.resolve([]):new Promise((ie,de)=>{(async()=>{const me=W.length,we=W.slice(0,J).sort(H);for(let Oe=J,Se=Math.min(J+Y,me);Oe<me;Oe=Se,Se=Math.min(Se+Y,me)){if(Oe>J&&await new Promise(Pe=>setTimeout(Pe)),V&&V.isCancellationRequested)throw new n.$8;E(W,H,we,Oe,Se)}return we})().then(ie,de)})}function E(W,H,J,Y,V){for(const ie=J.length;Y<V;Y++){const de=W[Y];if(H(de,J[ie-1])<0){J.pop();const me=(0,o.$nb)(J,we=>H(de,we)<0);J.splice(me,0,de)}}}function P(W){return W.filter(H=>!!H)}function t(W){let H=0;for(let J=0;J<W.length;J++)W[J]&&(W[H]=W[J],H+=1);W.length=H}function r(W,H,J){W.splice(J,0,W.splice(H,1)[0])}function i(W){return!Array.isArray(W)||W.length===0}function c(W){return Array.isArray(W)&&W.length>0}function s(W,H=J=>J){const J=new Set;return W.filter(Y=>{const V=H(Y);return J.has(V)?!1:(J.add(V),!0)})}function l(W){const H=new Set;return J=>{const Y=W(J);return H.has(Y)?!1:(H.add(Y),!0)}}function u(W,H){return W.length>0?W[0]:H}function S(W,H){return W.length>0?W[W.length-1]:H}function y(W,H,J=(Y,V)=>Y===V){let Y=0;for(let V=0,ie=Math.min(W.length,H.length);V<ie&&J(W[V],H[V]);V++)Y++;return Y}function R(W,H){let J=typeof H=="number"?W:0;typeof H=="number"?J=W:(J=0,H=W);const Y=[];if(J<=H)for(let V=J;V<H;V++)Y.push(V);else for(let V=J;V>H;V--)Y.push(V);return Y}function L(W,H,J){return W.reduce((Y,V)=>(Y[H(V)]=J?J(V):V,Y),Object.create(null))}function T(W,H){return W.push(H),()=>A(W,H)}function A(W,H){const J=W.indexOf(H);if(J>-1)return W.splice(J,1),H}function M(W,H,J){const Y=W.slice(0,H),V=W.slice(H);return Y.concat(J,V)}function U(W,H){let J;if(typeof H=="number"){let Y=H;J=()=>{const V=Math.sin(Y++)*179426549;return V-Math.floor(V)}}else J=Math.random;for(let Y=W.length-1;Y>0;Y-=1){const V=Math.floor(J()*(Y+1)),ie=W[Y];W[Y]=W[V],W[V]=ie}}function C(W,H){const J=W.indexOf(H);J>-1&&(W.splice(J,1),W.unshift(H))}function z(W,H){const J=W.indexOf(H);J>-1&&(W.splice(J,1),W.push(H))}function re(W,H){for(const J of H)W.push(J)}function Z(W,H){return Array.isArray(W)?W.map(H):H(W)}function le(W){return Array.isArray(W)?W:[W]}function X(W){return W[Math.floor(Math.random()*W.length)]}function ee(W,H,J){const Y=j(W,H),V=W.length,ie=J.length;W.length=V+ie;for(let de=V-1;de>=Y;de--)W[de+ie]=W[de];for(let de=0;de<ie;de++)W[de+Y]=J[de]}function q(W,H,J,Y){const V=j(W,H);let ie=W.splice(V,J);return ie===void 0&&(ie=[]),ee(W,V,Y),ie}function j(W,H){return H<0?Math.max(H+W.length,0):Math.min(H,W.length)}var B;(function(W){function H(ie){return ie<0}W.isLessThan=H;function J(ie){return ie<=0}W.isLessThanOrEqual=J;function Y(ie){return ie>0}W.isGreaterThan=Y;function V(ie){return ie===0}W.isNeitherLessOrGreaterThan=V,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function G(W,H){return(J,Y)=>H(W(J),W(Y))}function ce(...W){return(H,J)=>{for(const Y of W){const V=Y(H,J);if(!B.isNeitherLessOrGreaterThan(V))return V}return B.neitherLessOrGreaterThan}}const K=(W,H)=>W-H;e.$$b=K;const he=(W,H)=>(0,e.$$b)(W?1:0,H?1:0);e.$_b=he;function se(W){return(H,J)=>-W(H,J)}class _{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let J=this.c;for(;J<this.g.length&&H(this.g[J]);)J++;const Y=J===this.c?null:this.g.slice(this.c,J);return this.c=J,Y}takeFromEndWhile(H){let J=this.d;for(;J>=0&&H(this.g[J]);)J--;const Y=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const J=this.g.slice(this.c,this.c+H);return this.c+=H,J}}e.$bc=_;class F{static{this.empty=new F(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(J=>(H(J),!0))}toArray(){const H=[];return this.iterate(J=>(H.push(J),!0)),H}filter(H){return new F(J=>this.iterate(Y=>H(Y)?J(Y):!0))}map(H){return new F(J=>this.iterate(Y=>J(H(Y))))}some(H){let J=!1;return this.iterate(Y=>(J=H(Y),!J)),J}findFirst(H){let J;return this.iterate(Y=>H(Y)?(J=Y,!1):!0),J}findLast(H){let J;return this.iterate(Y=>(H(Y)&&(J=Y),!0)),J}findLastMaxBy(H){let J,Y=!0;return this.iterate(V=>((Y||B.isGreaterThan(H(V,J)))&&(Y=!1,J=V),!0)),J}}e.$cc=F;class N{constructor(H){this.c=H}static createSortPermutation(H,J){const Y=Array.from(H.keys()).sort((V,ie)=>J(H[V],H[ie]));return new N(Y)}apply(H){return H.map((J,Y)=>H[this.c[Y]])}inverse(){const H=this.c.slice();for(let J=0;J<this.c.length;J++)H[this.c[J]]=J;return new N(H)}}e.$dc=N}),define(oe[141],ae([0,1,16]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=o,e.$hd=k,e.$id=D,e.$jd=O,e.$kd=I,e.$ld=v;function o(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function k(a,f="Unreachable"){throw new Error(f)}function D(a,f="unexpected state"){if(!a)throw new n.$fb(`Assertion Failed: ${f}`)}function O(a){a||(0,n.$3)(new n.$fb("Soft Assertion Failed"))}function I(a){if(!a()){debugger;a(),(0,n.$3)(new n.$fb("Assertion Failed"))}}function v(a,f){let d=0;for(;d<a.length-1;){const g=a[d],w=a[d+1];if(!f(g,w))return!1;d++}return!0}}),define(oe[90],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=n;function n(o,k){const D=this;let O=!1,I;return function(){if(O)return I;if(O=!0,k)try{I=o.apply(D,arguments)}finally{k()}else I=o.apply(D,arguments);return I}}}),define(oe[78],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(o){function k(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}o.is=k;const D=Object.freeze([]);function O(){return D}o.empty=O;function*I(i){yield i}o.single=I;function v(i){return k(i)?i:I(i)}o.wrap=v;function a(i){return i||D}o.from=a;function*f(i){for(let c=i.length-1;c>=0;c--)yield i[c]}o.reverse=f;function d(i){return!i||i[Symbol.iterator]().next().done===!0}o.isEmpty=d;function g(i){return i[Symbol.iterator]().next().value}o.first=g;function w(i,c){let s=0;for(const l of i)if(c(l,s++))return!0;return!1}o.some=w;function h(i,c){for(const s of i)if(c(s))return s}o.find=h;function*p(i,c){for(const s of i)c(s)&&(yield s)}o.filter=p;function*b(i,c){let s=0;for(const l of i)yield c(l,s++)}o.map=b;function*$(i,c){let s=0;for(const l of i)yield*c(l,s++)}o.flatMap=$;function*m(...i){for(const c of i)yield*c}o.concat=m;function E(i,c,s){let l=s;for(const u of i)l=c(l,u);return l}o.reduce=E;function*P(i,c,s=i.length){for(c<0&&(c+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);c<s;c++)yield i[c]}o.slice=P;function t(i,c=Number.POSITIVE_INFINITY){const s=[];if(c===0)return[s,i];const l=i[Symbol.iterator]();for(let u=0;u<c;u++){const S=l.next();if(S.done)return[s,o.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return l}}]}o.consume=t;async function r(i){const c=[];for await(const s of i)c.push(s);return Promise.resolve(c)}o.asyncToArray=r})(n||(e.Iterable=n={}))}),define(oe[43],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=O,e.$Xn=d,e.$Yn=g,e.$Zn=w,e.$1n=h,e.$2n=p,e.$3n=b,e.$4n=$,e.$5n=m,e.$6n=E,e.$7n=P;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var o;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(o||(e.SyntaxKind=o={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function O(t,r=!1){let i=0;const c=t.length;let s="",l=0,u=o.Unknown,S=n.None;function y(C){let z=0,re=0;for(;z<C;){const Z=t.charCodeAt(i);if(Z>=f._0&&Z<=f._9)re=re*16+Z-f._0;else if(Z>=f.A&&Z<=f.F)re=re*16+Z-f.A+10;else if(Z>=f.a&&Z<=f.f)re=re*16+Z-f.a+10;else break;i++,z++}return z<C&&(re=-1),re}function R(C){i=C,s="",l=0,u=o.Unknown,S=n.None}function L(){const C=i;if(t.charCodeAt(i)===f._0)i++;else for(i++;i<t.length&&a(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===f.dot)if(i++,i<t.length&&a(t.charCodeAt(i)))for(i++;i<t.length&&a(t.charCodeAt(i));)i++;else return S=n.UnexpectedEndOfNumber,t.substring(C,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===f.E||t.charCodeAt(i)===f.e))if(i++,(i<t.length&&t.charCodeAt(i)===f.plus||t.charCodeAt(i)===f.minus)&&i++,i<t.length&&a(t.charCodeAt(i))){for(i++;i<t.length&&a(t.charCodeAt(i));)i++;z=i}else S=n.UnexpectedEndOfNumber;return t.substring(C,z)}function T(){let C="",z=i;for(;;){if(i>=c){C+=t.substring(z,i),S=n.UnexpectedEndOfString;break}const re=t.charCodeAt(i);if(re===f.doubleQuote){C+=t.substring(z,i),i++;break}if(re===f.backslash){if(C+=t.substring(z,i),i++,i>=c){S=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case f.doubleQuote:C+='"';break;case f.backslash:C+="\\";break;case f.slash:C+="/";break;case f.b:C+="\b";break;case f.f:C+="\f";break;case f.n:C+=`
`;break;case f.r:C+="\r";break;case f.t:C+="	";break;case f.u:{const le=y(4);le>=0?C+=String.fromCharCode(le):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}z=i;continue}if(re>=0&&re<=31)if(v(re)){C+=t.substring(z,i),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;i++}return C}function A(){if(s="",S=n.None,l=i,i>=c)return l=c,u=o.EOF;let C=t.charCodeAt(i);if(I(C)){do i++,s+=String.fromCharCode(C),C=t.charCodeAt(i);while(I(C));return u=o.Trivia}if(v(C))return i++,s+=String.fromCharCode(C),C===f.carriageReturn&&t.charCodeAt(i)===f.lineFeed&&(i++,s+=`
`),u=o.LineBreakTrivia;switch(C){case f.openBrace:return i++,u=o.OpenBraceToken;case f.closeBrace:return i++,u=o.CloseBraceToken;case f.openBracket:return i++,u=o.OpenBracketToken;case f.closeBracket:return i++,u=o.CloseBracketToken;case f.colon:return i++,u=o.ColonToken;case f.comma:return i++,u=o.CommaToken;case f.doubleQuote:return i++,s=T(),u=o.StringLiteral;case f.slash:{const z=i-1;if(t.charCodeAt(i+1)===f.slash){for(i+=2;i<c&&!v(t.charCodeAt(i));)i++;return s=t.substring(z,i),u=o.LineCommentTrivia}if(t.charCodeAt(i+1)===f.asterisk){i+=2;const re=c-1;let Z=!1;for(;i<re;){if(t.charCodeAt(i)===f.asterisk&&t.charCodeAt(i+1)===f.slash){i+=2,Z=!0;break}i++}return Z||(i++,S=n.UnexpectedEndOfComment),s=t.substring(z,i),u=o.BlockCommentTrivia}return s+=String.fromCharCode(C),i++,u=o.Unknown}case f.minus:if(s+=String.fromCharCode(C),i++,i===c||!a(t.charCodeAt(i)))return u=o.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return s+=L(),u=o.NumericLiteral;default:for(;i<c&&M(C);)i++,C=t.charCodeAt(i);if(l!==i){switch(s=t.substring(l,i),s){case"true":return u=o.TrueKeyword;case"false":return u=o.FalseKeyword;case"null":return u=o.NullKeyword}return u=o.Unknown}return s+=String.fromCharCode(C),i++,u=o.Unknown}}function M(C){if(I(C)||v(C))return!1;switch(C){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function U(){let C;do C=A();while(C>=o.LineCommentTrivia&&C<=o.Trivia);return C}return{setPosition:R,getPosition:()=>i,scan:r?U:A,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>S}}function I(t){return t===f.space||t===f.tab||t===f.verticalTab||t===f.formFeed||t===f.nonBreakingSpace||t===f.ogham||t>=f.enQuad&&t<=f.zeroWidthSpace||t===f.narrowNoBreakSpace||t===f.mathematicalSpace||t===f.ideographicSpace||t===f.byteOrderMark}function v(t){return t===f.lineFeed||t===f.carriageReturn||t===f.lineSeparator||t===f.paragraphSeparator}function a(t){return t>=f._0&&t<=f._9}var f;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(f||(f={}));function d(t,r){const i=[],c=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function S(y,R,L,T){l.value=y,l.offset=R,l.length=L,l.type=T,l.colonOffset=void 0,s=l}try{E(t,{onObjectBegin:(y,R)=>{if(r<=y)throw c;s=void 0,u=r>y,i.push("")},onObjectProperty:(y,R,L)=>{if(r<R||(S(y,R,L,"property"),i[i.length-1]=y,r<=R+L))throw c},onObjectEnd:(y,R)=>{if(r<=y)throw c;s=void 0,i.pop()},onArrayBegin:(y,R)=>{if(r<=y)throw c;s=void 0,i.push(0)},onArrayEnd:(y,R)=>{if(r<=y)throw c;s=void 0,i.pop()},onLiteralValue:(y,R,L)=>{if(r<R||(S(y,R,L,P(y)),r<=R+L))throw c},onSeparator:(y,R,L)=>{if(r<=R)throw c;if(y===":"&&s&&s.type==="property")s.colonOffset=R,u=!1,s=void 0;else if(y===","){const T=i[i.length-1];typeof T=="number"?i[i.length-1]=T+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==c)throw y}return{path:i,previousNode:s,isAtPropertyKey:u,matches:y=>{let R=0;for(let L=0;R<y.length&&L<i.length;L++)if(y[R]===i[L]||y[R]==="*")R++;else if(y[R]!=="**")return!1;return R===y.length}}}function g(t,r=[],i=D.DEFAULT){let c=null,s=[];const l=[];function u(y){Array.isArray(s)?s.push(y):c!==null&&(s[c]=y)}return E(t,{onObjectBegin:()=>{const y={};u(y),l.push(s),s=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const y=[];u(y),l.push(s),s=y,c=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:u,onError:(y,R,L)=>{r.push({error:y,offset:R,length:L})}},i),s[0]}function w(t,r=[],i=D.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){c.type==="property"&&(c.length=y-c.offset,c=c.parent)}function l(y){return c.children.push(y),y}E(t,{onObjectBegin:y=>{c=l({type:"object",offset:y,length:-1,parent:c,children:[]})},onObjectProperty:(y,R,L)=>{c=l({type:"property",offset:R,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:y,offset:R,length:L,parent:c})},onObjectEnd:(y,R)=>{c.length=y+R-c.offset,c=c.parent,s(y+R)},onArrayBegin:(y,R)=>{c=l({type:"array",offset:y,length:-1,parent:c,children:[]})},onArrayEnd:(y,R)=>{c.length=y+R-c.offset,c=c.parent,s(y+R)},onLiteralValue:(y,R,L)=>{l({type:P(y),offset:R,length:L,parent:c,value:y}),s(R+L)},onSeparator:(y,R,L)=>{c.type==="property"&&(y===":"?c.colonOffset=R:y===","&&s(R))},onError:(y,R,L)=>{r.push({error:y,offset:R,length:L})}},i);const S=c.children[0];return S&&delete S.parent,S}function h(t,r){if(!t)return;let i=t;for(const c of r)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===c){i=l.children[1],s=!0;break}if(!s)return}else{const s=c;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const r=Object.create(null);for(const i of t.children){const c=i.children[1];c&&(r[i.children[0].value]=b(c))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}function m(t,r,i=!1){if($(t,r,i)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=r;s++){const l=m(c[s],r,i);if(l)return l}return t}}function E(t,r,i=D.DEFAULT){const c=O(t,!1);function s(G){return G?()=>G(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(G){return G?ce=>G(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),S=l(r.onObjectProperty),y=s(r.onObjectEnd),R=s(r.onArrayBegin),L=s(r.onArrayEnd),T=l(r.onLiteralValue),A=l(r.onSeparator),M=s(r.onComment),U=l(r.onError),C=i&&i.disallowComments,z=i&&i.allowTrailingComma;function re(){for(;;){const G=c.scan();switch(c.getTokenError()){case n.InvalidUnicode:Z(k.InvalidUnicode);break;case n.InvalidEscapeCharacter:Z(k.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:Z(k.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:C||Z(k.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:Z(k.UnexpectedEndOfString);break;case n.InvalidCharacter:Z(k.InvalidCharacter);break}switch(G){case o.LineCommentTrivia:case o.BlockCommentTrivia:C?Z(k.InvalidCommentToken):M();break;case o.Unknown:Z(k.InvalidSymbol);break;case o.Trivia:case o.LineBreakTrivia:break;default:return G}}}function Z(G,ce=[],K=[]){if(U(G),ce.length+K.length>0){let he=c.getToken();for(;he!==o.EOF;){if(ce.indexOf(he)!==-1){re();break}else if(K.indexOf(he)!==-1)break;he=re()}}}function le(G){const ce=c.getTokenValue();return G?T(ce):S(ce),re(),!0}function X(){switch(c.getToken()){case o.NumericLiteral:{let G=0;try{G=JSON.parse(c.getTokenValue()),typeof G!="number"&&(Z(k.InvalidNumberFormat),G=0)}catch{Z(k.InvalidNumberFormat)}T(G);break}case o.NullKeyword:T(null);break;case o.TrueKeyword:T(!0);break;case o.FalseKeyword:T(!1);break;default:return!1}return re(),!0}function ee(){return c.getToken()!==o.StringLiteral?(Z(k.PropertyNameExpected,[],[o.CloseBraceToken,o.CommaToken]),!1):(le(!1),c.getToken()===o.ColonToken?(A(":"),re(),B()||Z(k.ValueExpected,[],[o.CloseBraceToken,o.CommaToken])):Z(k.ColonExpected,[],[o.CloseBraceToken,o.CommaToken]),!0)}function q(){u(),re();let G=!1;for(;c.getToken()!==o.CloseBraceToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(G||Z(k.ValueExpected,[],[]),A(","),re(),c.getToken()===o.CloseBraceToken&&z)break}else G&&Z(k.CommaExpected,[],[]);ee()||Z(k.ValueExpected,[],[o.CloseBraceToken,o.CommaToken]),G=!0}return y(),c.getToken()!==o.CloseBraceToken?Z(k.CloseBraceExpected,[o.CloseBraceToken],[]):re(),!0}function j(){R(),re();let G=!1;for(;c.getToken()!==o.CloseBracketToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(G||Z(k.ValueExpected,[],[]),A(","),re(),c.getToken()===o.CloseBracketToken&&z)break}else G&&Z(k.CommaExpected,[],[]);B()||Z(k.ValueExpected,[],[o.CloseBracketToken,o.CommaToken]),G=!0}return L(),c.getToken()!==o.CloseBracketToken?Z(k.CloseBracketExpected,[o.CloseBracketToken],[]):re(),!0}function B(){switch(c.getToken()){case o.OpenBracketToken:return j();case o.OpenBraceToken:return q();case o.StringLiteral:return le(!0);default:return X()}}return re(),c.getToken()===o.EOF?i.allowEmptyContent?!0:(Z(k.ValueExpected,[],[]),!1):B()?(c.getToken()!==o.EOF&&Z(k.EndOfFileExpected,[],[]),!0):(Z(k.ValueExpected,[],[]),!1)}function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[142],ae([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=o,e.$9n=k,e.$0n=I,e.$$n=v;function o(a,f,d){let g,w,h,p,b;if(f){for(p=f.offset,b=p+f.length,h=p;h>0&&!v(a,h-1);)h--;let S=b;for(;S<a.length&&!v(a,S);)S++;w=a.substring(h,S),g=O(w,d)}else w=a,g=0,h=0,p=0,b=a.length;const $=I(d,a);let m=!1,E=0,P;d.insertSpaces?P=D(" ",d.tabSize||4):P="	";const t=(0,n.$Wn)(w,!1);let r=!1;function i(){return $+D(P,g+E)}function c(){let S=t.scan();for(m=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)m=m||S===n.SyntaxKind.LineBreakTrivia,S=t.scan();return r=S===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,S}const s=[];function l(S,y,R){!r&&y<b&&R>p&&a.substring(y,R)!==S&&s.push({offset:y,length:R-y,content:S})}let u=c();if(u!==n.SyntaxKind.EOF){const S=t.getTokenOffset()+h,y=D(P,g);l(y,h,S)}for(;u!==n.SyntaxKind.EOF;){let S=t.getTokenOffset()+t.getTokenLength()+h,y=c(),R="";for(;!m&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const T=t.getTokenOffset()+h;l(" ",S,T),S=t.getTokenOffset()+t.getTokenLength()+h,R=y===n.SyntaxKind.LineCommentTrivia?i():"",y=c()}if(y===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(E--,R=i());else if(y===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(E--,R=i());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:E++,R=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:R=i();break;case n.SyntaxKind.BlockCommentTrivia:m?R=i():R=" ";break;case n.SyntaxKind.ColonToken:R=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){R="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?R=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(r=!0);break;case n.SyntaxKind.Unknown:r=!0;break}m&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(R=i())}const L=t.getTokenOffset()+h;l(R,S,L),u=y}return s}function k(a,f){const d=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?d.replace(/\r\n|\r|\n/g,f.eol):d}function D(a,f){let d="";for(let g=0;g<f;g++)d+=a;return d}function O(a,f){let d=0,g=0;const w=f.tabSize||4;for(;d<a.length;){const h=a.charAt(d);if(h===" ")g++;else if(h==="	")g+=w;else break;d++}return Math.floor(g/w)}function I(a,f){for(let d=0;d<f.length;d++){const g=f.charAt(d);if(g==="\r")return d+1<f.length&&f.charAt(d+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return a&&a.eol||`
`}function v(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(oe[108],ae([0,1,43,142]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=k,e.$ao=D,e.$bo=O,e.$co=I,e.$do=v;function k(a,f,d){return D(a,f,void 0,d)}function D(a,f,d,g,w){const h=f.slice(),p=[],b=(0,n.$Zn)(a,p);let $,m;for(;h.length>0&&(m=h.pop(),$=(0,n.$1n)(b,h),$===void 0&&d!==void 0);)typeof m=="string"?d={[m]:d}:d=[d];if($)if($.type==="object"&&typeof m=="string"&&Array.isArray($.children)){const E=(0,n.$1n)($,[m]);if(E!==void 0)if(d===void 0){if(!E.parent)throw new Error("Malformed AST");const P=$.children.indexOf(E.parent);let t,r=E.parent.offset+E.parent.length;if(P>0){const i=$.children[P-1];t=i.offset+i.length}else t=$.offset+1,$.children.length>1&&(r=$.children[1].offset);return O(a,{offset:t,length:r-t,content:""},g)}else return O(a,{offset:E.offset,length:E.length,content:JSON.stringify(d)},g);else{if(d===void 0)return[];const P=`${JSON.stringify(m)}: ${JSON.stringify(d)}`,t=w?w($.children.map(i=>i.children[0].value)):$.children.length;let r;if(t>0){const i=$.children[t-1];r={offset:i.offset+i.length,length:0,content:","+P}}else $.children.length===0?r={offset:$.offset+1,length:0,content:P}:r={offset:$.offset+1,length:0,content:P+","};return O(a,r,g)}}else if($.type==="array"&&typeof m=="number"&&Array.isArray($.children))if(d!==void 0){const E=`${JSON.stringify(d)}`;let P;if($.children.length===0||m===0)P={offset:$.offset+1,length:0,content:$.children.length===0?E:E+","};else{const t=m===-1||m>$.children.length?$.children.length:m,r=$.children[t-1];P={offset:r.offset+r.length,length:0,content:","+E}}return O(a,P,g)}else{const E=m,P=$.children[E];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===E){const r=$.children[E-1],i=r.offset+r.length,c=$.offset+$.length;t={offset:i,length:c-2-i,content:""}}else t={offset:P.offset,length:$.children[E+1].offset-P.offset,content:""};return O(a,t,g)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${$.type}`);else return d===void 0?[]:O(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(d)},g)}function O(a,f,d){let g=I(a,f),w=f.offset,h=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;w>0&&!(0,o.$$n)(g,w-1);)w--;for(;h<g.length&&!(0,o.$$n)(g,h);)h++}const p=(0,o.$8n)(g,{offset:w,length:h-w},d);for(let $=p.length-1;$>=0;$--){const m=p[$];g=I(g,m),w=Math.min(w,m.offset),h=Math.max(h,m.offset+m.length),h+=m.content.length-m.length}const b=a.length-(g.length-h)-w;return[{offset:w,length:b,content:g.substring(w,h)}]}function I(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function v(a,f){const d=f.slice(0).sort((w,h)=>{const p=w.offset-h.offset;return p===0?w.length-h.length:p});let g=a.length;for(let w=d.length-1;w>=0;w--){const h=d[w];if(h.offset+h.length<=g)a=I(a,h);else throw new Error("Overlapping edit");g=h.offset}return a}}),function(){function x(e,n,o,k){const D=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function O(v){return v.replace(D,function(a,f,d,g,w,h){if(g)return"";if(w){const p=w.length;return w[p-1]===`
`?w[p-2]==="\r"?`\r
`:`
`:""}else return h?a.substring(1):a})}function I(v){const a=O(v);try{return JSON.parse(a)}catch{const d=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(d)}}return{stripComments:O,parse:I}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[66],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class n{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=n}),define(oe[109],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class o{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const O=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=O}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,O){const I=new n(D);if(this.a===n.Undefined)this.a=I,this.b=I;else if(O){const a=this.b;this.b=I,I.prev=a,a.next=I}else{const a=this.a;this.a=I,I.next=a,a.prev=I}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const O=D.prev;O.next=D.next,D.next.prev=O}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$8c=o}),define(oe[32],ae([0,1]),function(x,e){"use strict";var n,o,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=D,e.$Bc=O,e.$Cc=I,e.$Lc=P;function D(t,r,i){let c=t.get(r);return c===void 0&&(c=i,t.set(r,c)),c}function O(t){const r=[];return t.forEach((i,c)=>{r.push(`${c} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}function I(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}class v{constructor(r,i){this.uri=r,this.value=i}}function a(t){return Array.isArray(t)}class f{static{this.c=r=>r.toString()}constructor(r,i){if(this[n]="ResourceMap",r instanceof f)this.d=new Map(r.d),this.e=i??f.c;else if(a(r)){this.d=new Map,this.e=i??f.c;for(const[c,s]of r)this.set(c,s)}else this.d=new Map,this.e=r??f.c}set(r,i){return this.d.set(this.e(r),new v(r,i)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,i){typeof i<"u"&&(r=r.bind(i));for(const[c,s]of this.d)r(s.value,s.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Dc=f;class d{constructor(r,i){this[o]="ResourceSet",!r||typeof r=="function"?this.c=new f(r):(this.c=new f(i),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,i){this.c.forEach((c,s)=>r.call(i,s,s,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=d;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class w{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,i=g.None){const c=this.c.get(r);if(c)return i!==g.None&&this.m(c,i),c.value}set(r,i,c=g.None){let s=this.c.get(r);if(s)s.value=i,c!==g.None&&this.m(s,c);else{switch(s={key:r,value:i,next:void 0,previous:void 0},c){case g.None:this.k(s);break;case g.AsOld:this.j(s);break;case g.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(r,s),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this.c.get(r);if(i)return this.c.delete(r),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,i){const c=this.g;let s=this.d;for(;s;){if(i?r.bind(i)(s.value,s.key,this):r(s.value,s.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.key,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return s}values(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.value,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return s}entries(){const r=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:[c.key,c.value],done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return s}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.d,c=this.size;for(;i&&c>r;)this.c.delete(i.key),i=i.next,c--;this.d=i,this.f=c,i&&(i.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.e,c=this.size;for(;i&&c>r;)this.c.delete(i.key),i=i.previous,c--;this.e=i,this.f=c,i&&(i.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const i=r.next,c=r.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}r.next=void 0,r.previous=void 0,this.g++}m(r,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==g.AsOld&&i!==g.AsNew)){if(i===g.AsOld){if(r===this.d)return;const c=r.next,s=r.previous;r===this.e?(s.next=void 0,this.e=s):(c.previous=s,s.next=c),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(i===g.AsNew){if(r===this.e)return;const c=r.next,s=r.previous;r===this.d?(c.previous=void 0,this.d=c):(c.previous=s,s.next=c),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((i,c)=>{r.push([c,i])}),r}fromJSON(r){this.clear();for(const[i,c]of r)this.set(i,c)}}e.$Fc=w;class h extends w{constructor(r,i=1){super(),this.n=r,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,i=g.AsNew){return super.get(r,i)}peek(r){return super.get(r,g.None)}set(r,i){return super.set(r,i,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends h{constructor(r,i=1){super(r,i)}q(r){this.h(r)}set(r,i){return super.set(r,i),this.p(),this}}e.$Gc=p;class b extends h{constructor(r,i=1){super(r,i)}q(r){this.i(r)}set(r,i){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,i),this}}e.$Hc=b;class ${constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let i=this.c.get(r)||0;return i===0?!1:(i--,i===0?this.c.delete(r):this.c.set(r,i),!0)}has(r){return this.c.has(r)}}e.$Ic=$;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[i,c]of r)this.set(i,c)}clear(){this.c.clear(),this.d.clear()}set(r,i){this.c.set(r,i),this.d.set(i,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const i=this.c.get(r);return i===void 0?!1:(this.c.delete(r),this.d.delete(i),!0)}forEach(r,i){this.c.forEach((c,s)=>{r.call(i,c,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=m;class E{constructor(){this.c=new Map}add(r,i){let c=this.c.get(r);c||(c=new Set,this.c.set(r,c)),c.add(i)}delete(r,i){const c=this.c.get(r);c&&(c.delete(i),c.size===0&&this.c.delete(r))}forEach(r,i){const c=this.c.get(r);c&&c.forEach(i)}get(r){const i=this.c.get(r);return i||new Set}}e.$Kc=E;function P(t,r){if(t===r)return!0;if(t.size!==r.size)return!1;for(const[i,c]of t)if(!r.has(i)||r.get(i)!==c)return!1;for(const[i]of r)if(!t.has(i))return!1;return!0}}),define(oe[2],ae([0,1,22,139,32,90,78]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=f,e.$Oc=d,e.$Pc=g,e.$Qc=p,e.$Rc=b,e.$Sc=$,e.$Tc=m,e.$Uc=E,e.$Vc=P,e.$6c=R;const I=!1;let v=null;class a{constructor(){this.b=new Map}static{this.a=0}c(A){let M=this.b.get(A);return M||(M={parent:null,source:null,isSingleton:!1,value:A,idx:a.a++},this.b.set(A,M)),M}trackDisposable(A){const M=this.c(A);M.source||(M.source=new Error().stack)}setParent(A,M){const U=this.c(A);U.parent=M}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,M){const U=M.get(A);if(U)return U;const C=A.parent?this.f(this.c(A.parent),M):A;return M.set(A,C),C}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,A).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(A=10,M){let U;if(M)U=M;else{const le=new Map,X=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,le).isSingleton);if(X.length===0)return;const ee=new Set(X.map(q=>q.value));if(U=X.filter(q=>!(q.parent&&ee.has(q.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function C(le){function X(q,j){for(;q.length>0&&j.some(B=>typeof B=="string"?B===q[0]:q[0].match(B));)q.shift()}const ee=le.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return X(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const z=new k.$Kc;for(const le of U){const X=C(le);for(let ee=0;ee<=X.length;ee++)z.add(X.slice(0,ee).join(`
`),le)}U.sort((0,n.$9b)(le=>le.idx,n.$$b));let re="",Z=0;for(const le of U.slice(0,A)){Z++;const X=C(le),ee=[];for(let q=0;q<X.length;q++){let j=X[q];j=`(shared with ${z.get(X.slice(0,q+1).join(`
`)).size}/${U.length} leaks) at ${j}`;const G=z.get(X.slice(0,q).join(`
`)),ce=(0,o.$K)([...G].map(K=>C(K)[q]),K=>K);delete ce[X[q]];for(const[K,he]of Object.entries(ce))ee.unshift(`    - stacktraces of ${he.length} other leaks continue with ${K}`);ee.unshift(j)}re+=`


==================== Leaking disposable ${Z}/${U.length}: ${le.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return U.length>A&&(re+=`


... and ${U.length-A} more leaking disposables

`),{leaks:U,details:re}}}e.$Mc=a;function f(T){v=T}if(I){const T="__is_disposable_tracked__";f(new class{trackDisposable(A){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[T]||console.log(M)},3e3)}setParent(A,M){if(A&&A!==r.None)try{A[T]=!0}catch{}}markAsDisposed(A){if(A&&A!==r.None)try{A[T]=!0}catch{}}markAsSingleton(A){}})}function d(T){return v?.trackDisposable(T),T}function g(T){v?.markAsDisposed(T)}function w(T,A){v?.setParent(T,A)}function h(T,A){if(v)for(const M of T)v.setParent(M,A)}function p(T){return v?.markAsSingleton(T),T}function b(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function $(T){if(O.Iterable.is(T)){const A=[];for(const M of T)if(M)try{M.dispose()}catch(U){A.push(U)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function m(T){for(const A of T)b(A)&&A.dispose();return[]}function E(...T){const A=P(()=>$(T));return h(T,A),A}function P(T){const A=d({dispose:(0,D.$gb)(()=>{g(A),T()})});return A}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return w(A,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),w(A,null))}}e.$Wc=t;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,d(this),w(this.q,this)}dispose(){g(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Xc=r;class i{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&w(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&w(A,null),A}}e.$Yc=i;class c{constructor(A){this.a=new i,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=c;class s{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=s;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(A){let M=A;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.$2c=l;class u{constructor(){this.a=new Map}acquire(A,...M){let U=this.a.get(A);U||(U={counter:0,object:this.b(A,...M)},this.a.set(A,U));const{object:C}=U,z=(0,D.$gb)(()=>{--U.counter===0&&(this.c(A,U.object),this.a.delete(A))});return U.counter++,{object:C,dispose:z}}}e.$3c=u;class S{constructor(A){this.a=A}async acquire(A,...M){const U=this.a.acquire(A,...M);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(C){throw U.dispose(),C}}}e.$4c=S;class y{constructor(A){this.object=A}dispose(){}}e.$5c=y;function R(T){const A=new t;try{T(A)}finally{A.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,M,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(A)?.dispose(),this.a.set(A,M)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}deleteAndLeak(A){const M=this.a.get(A);return this.a.delete(A),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=L}),define(oe[91],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(o){o[o.Uri=1]="Uri",o[o.Regexp=2]="Regexp",o[o.ScmResource=3]="ScmResource",o[o.ScmResourceGroup=4]="ScmResourceGroup",o[o.ScmProvider=5]="ScmProvider",o[o.CommentController=6]="CommentController",o[o.CommentThread=7]="CommentThread",o[o.CommentThreadInstance=8]="CommentThreadInstance",o[o.CommentThreadReply=9]="CommentThreadReply",o[o.CommentNode=10]="CommentNode",o[o.CommentThreadNode=11]="CommentThreadNode",o[o.TimelineActionContext=12]="TimelineActionContext",o[o.NotebookCellActionContext=13]="NotebookCellActionContext",o[o.NotebookActionContext=14]="NotebookActionContext",o[o.TerminalContext=15]="TerminalContext",o[o.TestItemContext=16]="TestItemContext",o[o.Date=17]="Date",o[o.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(oe[79],ae([0,1,32]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=k,e.$om=O;const o=new n.$Gc(1e4);function k(a){return v(a,"NFC",o)}const D=new n.$Gc(1e4);function O(a){return v(a,"NFD",D)}const I=/[^\u0000-\u0080]/;function v(a,f,d){if(!a)return a;const g=d.get(a);if(g)return g;let w;return I.test(a)?w=a.normalize(f):w=a,d.set(a,w),w}e.$pm=function(){const a=/[\u0300-\u036f]/g;return function(f){return O(f).replace(a,"")}}()}),define(oe[143],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=n,e.rot=o,e.$Qm=I;function n(v,a,f){return Math.min(Math.max(v,a),f)}function o(v,a){return(a+v%a)%a}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=k;class D{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=D;class O{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=O;function I(v,a,f,d,g,w,h,p){const b=h-f,$=p-d,m=g-f,E=w-d,P=v-f,t=a-d,r=b*b+$*$,i=b*m+$*E,c=b*P+$*t,s=m*m+E*E,l=m*P+E*t,u=1/(r*s-i*i),S=(s*c-i*l)*u,y=(r*l-i*c)*u;return S>=0&&y>=0&&S+y<1}}),function(){function x(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function O(v){D.push(v,Date.now())}function I(){const v=[];for(let a=0;a<D.length;a+=2)v.push({name:D[a],startTime:D[a+1]});return v}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))D.push({name:O.name,startTime:Math.round(k+O.startTime)});return D}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var o;typeof global=="object"?o=global:typeof self=="object"?o=self:o={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(o)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(o):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),o.perf=n(o))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var o in n)(typeof exports=="object"?exports:x)[o]=n[o]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(o){if(e[o])return e[o].exports;var k=e[o]={i:o,l:!1,exports:{}};return x[o].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=x,n.c=e,n.d=function(o,k,D){n.o(o,k)||Object.defineProperty(o,k,{enumerable:!0,get:D})},n.r=function(o){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(o,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(o,"__esModule",{value:!0})},n.t=function(o,k){if(1&k&&(o=n(o)),8&k||4&k&&typeof o=="object"&&o&&o.__esModule)return o;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:o}),2&k&&typeof o!="string")for(var O in o)n.d(D,O,function(I){return o[I]}.bind(null,O));return D},n.n=function(o){var k=o&&o.__esModule?function(){return o.default}:function(){return o};return n.d(k,"a",k),k},n.o=function(o,k){return Object.prototype.hasOwnProperty.call(o,k)},n.p="",n(n.s=0)}([function(x,e,n){(function(o){var k;e=x.exports=he,k=typeof o=="object"&&o.env&&o.env.NODE_DEBUG&&/\bsemver\b/i.test(o.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],v=e.src=[],a=0,f=a++;v[f]="0|[1-9]\\d*";var d=a++;v[d]="[0-9]+";var g=a++;v[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;v[w]="("+v[f]+")\\.("+v[f]+")\\.("+v[f]+")";var h=a++;v[h]="("+v[d]+")\\.("+v[d]+")\\.("+v[d]+")";var p=a++;v[p]="(?:"+v[f]+"|"+v[g]+")";var b=a++;v[b]="(?:"+v[d]+"|"+v[g]+")";var $=a++;v[$]="(?:-("+v[p]+"(?:\\."+v[p]+")*))";var m=a++;v[m]="(?:-?("+v[b]+"(?:\\."+v[b]+")*))";var E=a++;v[E]="[0-9A-Za-z-]+";var P=a++;v[P]="(?:\\+("+v[E]+"(?:\\."+v[E]+")*))";var t=a++,r="v?"+v[w]+v[$]+"?"+v[P]+"?";v[t]="^"+r+"$";var i="[v=\\s]*"+v[h]+v[m]+"?"+v[P]+"?",c=a++;v[c]="^"+i+"$";var s=a++;v[s]="((?:<|>)?=?)";var l=a++;v[l]=v[d]+"|x|X|\\*";var u=a++;v[u]=v[f]+"|x|X|\\*";var S=a++;v[S]="[v=\\s]*("+v[u]+")(?:\\.("+v[u]+")(?:\\.("+v[u]+")(?:"+v[$]+")?"+v[P]+"?)?)?";var y=a++;v[y]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[m]+")?"+v[P]+"?)?)?";var R=a++;v[R]="^"+v[s]+"\\s*"+v[S]+"$";var L=a++;v[L]="^"+v[s]+"\\s*"+v[y]+"$";var T=a++;v[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=a++;v[A]="(?:~>?)";var M=a++;v[M]="(\\s*)"+v[A]+"\\s+",I[M]=new RegExp(v[M],"g");var U=a++;v[U]="^"+v[A]+v[S]+"$";var C=a++;v[C]="^"+v[A]+v[y]+"$";var z=a++;v[z]="(?:\\^)";var re=a++;v[re]="(\\s*)"+v[z]+"\\s+",I[re]=new RegExp(v[re],"g");var Z=a++;v[Z]="^"+v[z]+v[S]+"$";var le=a++;v[le]="^"+v[z]+v[y]+"$";var X=a++;v[X]="^"+v[s]+"\\s*("+i+")$|^$";var ee=a++;v[ee]="^"+v[s]+"\\s*("+r+")$|^$";var q=a++;v[q]="(\\s*)"+v[s]+"\\s*("+i+"|"+v[S]+")",I[q]=new RegExp(v[q],"g");var j=a++;v[j]="^\\s*("+v[S]+")\\s+-\\s+("+v[S]+")\\s*$";var B=a++;v[B]="^\\s*("+v[y]+")\\s+-\\s+("+v[y]+")\\s*$";var G=a++;v[G]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)k(ce,v[ce]),I[ce]||(I[ce]=new RegExp(v[ce]));function K(Q,ue){if(Q instanceof he)return Q;if(typeof Q!="string"||Q.length>D||!(ue?I[c]:I[t]).test(Q))return null;try{return new he(Q,ue)}catch{return null}}function he(Q,ue){if(Q instanceof he){if(Q.loose===ue)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(Q,ue);k("SemVer",Q,ue),this.loose=ue;var fe=Q.trim().match(ue?I[c]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Re=+be;if(Re>=0&&Re<O)return Re}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=K,e.valid=function(Q,ue){var fe=K(Q,ue);return fe?fe.version:null},e.clean=function(Q,ue){var fe=K(Q.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Q){return k("SemVer.compare",this.version,this.loose,Q),Q instanceof he||(Q=new he(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},he.prototype.compareMain=function(Q){return Q instanceof he||(Q=new he(Q,this.loose)),_(this.major,Q.major)||_(this.minor,Q.minor)||_(this.patch,Q.patch)},he.prototype.comparePre=function(Q){if(Q instanceof he||(Q=new he(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=Q.prerelease[ue];if(k("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return _(fe,be)}while(++ue)},he.prototype.inc=function(Q,ue){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(Q,fe).inc(ue,be).version}catch{return null}},e.diff=function(Q,ue){if(H(Q,ue))return null;var fe=K(Q),be=K(ue);if(fe.prerelease.length||be.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return Re},e.compareIdentifiers=_;var se=/^[0-9]+$/;function _(Q,ue){var fe=se.test(Q),be=se.test(ue);return fe&&be&&(Q=+Q,ue=+ue),fe&&!be?-1:be&&!fe?1:Q<ue?-1:Q>ue?1:0}function F(Q,ue,fe){return new he(Q,fe).compare(new he(ue,fe))}function N(Q,ue,fe){return F(Q,ue,fe)>0}function W(Q,ue,fe){return F(Q,ue,fe)<0}function H(Q,ue,fe){return F(Q,ue,fe)===0}function J(Q,ue,fe){return F(Q,ue,fe)!==0}function Y(Q,ue,fe){return F(Q,ue,fe)>=0}function V(Q,ue,fe){return F(Q,ue,fe)<=0}function ie(Q,ue,fe,be){var Re;switch(ue){case"===":typeof Q=="object"&&(Q=Q.version),typeof fe=="object"&&(fe=fe.version),Re=Q===fe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof fe=="object"&&(fe=fe.version),Re=Q!==fe;break;case"":case"=":case"==":Re=H(Q,fe,be);break;case"!=":Re=J(Q,fe,be);break;case">":Re=N(Q,fe,be);break;case">=":Re=Y(Q,fe,be);break;case"<":Re=W(Q,fe,be);break;case"<=":Re=V(Q,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Re}function de(Q,ue){if(Q instanceof de){if(Q.loose===ue)return Q;Q=Q.value}if(!(this instanceof de))return new de(Q,ue);k("comparator",Q,ue),this.loose=ue,this.parse(Q),this.semver===me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Q,ue){return _(ue,Q)},e.major=function(Q,ue){return new he(Q,ue).major},e.minor=function(Q,ue){return new he(Q,ue).minor},e.patch=function(Q,ue){return new he(Q,ue).patch},e.compare=F,e.compareLoose=function(Q,ue){return F(Q,ue,!0)},e.rcompare=function(Q,ue,fe){return F(ue,Q,fe)},e.sort=function(Q,ue){return Q.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(Q,ue){return Q.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=N,e.lt=W,e.eq=H,e.neq=J,e.gte=Y,e.lte=V,e.cmp=ie,e.Comparator=de;var me={};function we(Q,ue){if(Q instanceof we)return Q.loose===ue?Q:new we(Q.raw,ue);if(Q instanceof de)return new we(Q.value,ue);if(!(this instanceof we))return new we(Q,ue);if(this.loose=ue,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Oe(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Se(Q,ue,fe,be,Re,We,Fe,Te,Be,Ge,Qe,He,Xe){return((ue=Oe(fe)?"":Oe(be)?">="+fe+".0.0":Oe(Re)?">="+fe+"."+be+".0":">="+ue)+" "+(Te=Oe(Be)?"":Oe(Ge)?"<"+(+Be+1)+".0.0":Oe(Qe)?"<"+Be+"."+(+Ge+1)+".0":He?"<="+Be+"."+Ge+"."+Qe+"-"+He:"<="+Te)).trim()}function Pe(Q,ue){for(var fe=0;fe<Q.length;fe++)if(!Q[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<Q.length;fe++)if(k(Q[fe].semver),Q[fe].semver!==me&&Q[fe].semver.prerelease.length>0){var be=Q[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function Ie(Q,ue,fe){try{ue=new we(ue,fe)}catch{return!1}return ue.test(Q)}function $e(Q,ue,fe,be){var Re,We,Fe,Te,Be;switch(Q=new he(Q,be),ue=new we(ue,be),fe){case">":Re=N,We=V,Fe=W,Te=">",Be=">=";break;case"<":Re=W,We=Y,Fe=N,Te="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(Q,ue,be))return!1;for(var Ge=0;Ge<ue.set.length;++Ge){var Qe=ue.set[Ge],He=null,Xe=null;if(Qe.forEach(function(Ye){Ye.semver===me&&(Ye=new de(">=0.0.0")),He=He||Ye,Xe=Xe||Ye,Re(Ye.semver,He.semver,be)?He=Ye:Fe(Ye.semver,Xe.semver,be)&&(Xe=Ye)}),He.operator===Te||He.operator===Be||(!Xe.operator||Xe.operator===Te)&&We(Q,Xe.semver)||Xe.operator===Be&&Fe(Q,Xe.semver))return!1}return!0}de.prototype.parse=function(Q){var ue=this.loose?I[X]:I[ee],fe=Q.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+Q);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(Q){return k("Comparator.test",Q,this.loose),this.semver===me||(typeof Q=="string"&&(Q=new he(Q,this.loose)),ie(Q,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Q,ue){if(!(Q instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(Q.value,ue),Ie(this.value,fe,ue);if(Q.operator==="")return fe=new we(this.value,ue),Ie(Q.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),We=this.semver.version===Q.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Te=ie(this.semver,"<",Q.semver,ue)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Be=ie(this.semver,">",Q.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return be||Re||We&&Fe||Te||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Q){var ue=this.loose;Q=Q.trim(),k("range",Q,ue);var fe=ue?I[B]:I[j];Q=Q.replace(fe,Se),k("hyphen replace",Q),Q=Q.replace(I[q],"$1$2$3"),k("comparator trim",Q,I[q]),Q=(Q=(Q=Q.replace(I[M],"$1~")).replace(I[re],"$1^")).split(/\s+/).join(" ");var be=ue?I[X]:I[ee],Re=Q.split(" ").map(function(We){return function(Fe,Te){return k("comp",Fe),Fe=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(He,Xe){k("caret",He,Xe);var Ye=Xe?I[le]:I[Z];return He.replace(Ye,function(_e,Ne,te,ge,pe){var ye;return k("caret",He,_e,Ne,te,ge,pe),Oe(Ne)?ye="":Oe(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Oe(ge)?ye=Ne==="0"?">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+".0 <"+(+Ne+1)+".0.0":pe?(k("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+pe+" <"+(+Ne+1)+".0.0"):(k("no pr"),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+" <"+(+Ne+1)+".0.0"),k("caret return",ye),ye})}(Qe,Ge)}).join(" ")}(Fe,Te),k("caret",Fe),Fe=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(He,Xe){var Ye=Xe?I[C]:I[U];return He.replace(Ye,function(_e,Ne,te,ge,pe){var ye;return k("tilde",He,_e,Ne,te,ge,pe),Oe(Ne)?ye="":Oe(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Oe(ge)?ye=">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":pe?(k("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0"):ye=">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0",k("tilde return",ye),ye})}(Qe,Ge)}).join(" ")}(Fe,Te),k("tildes",Fe),Fe=function(Be,Ge){return k("replaceXRanges",Be,Ge),Be.split(/\s+/).map(function(Qe){return function(He,Xe){He=He.trim();var Ye=Xe?I[L]:I[R];return He.replace(Ye,function(_e,Ne,te,ge,pe,ye){k("xRange",He,_e,Ne,te,ge,pe,ye);var Me=Oe(te),Ue=Me||Oe(ge),Je=Ue||Oe(pe);return Ne==="="&&Je&&(Ne=""),Me?_e=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Je?(Ue&&(ge=0),Je&&(pe=0),Ne===">"?(Ne=">=",Ue?(te=+te+1,ge=0,pe=0):Je&&(ge=+ge+1,pe=0)):Ne==="<="&&(Ne="<",Ue?te=+te+1:ge=+ge+1),_e=Ne+te+"."+ge+"."+pe):Ue?_e=">="+te+".0.0 <"+(+te+1)+".0.0":Je&&(_e=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),k("xRange return",_e),_e})}(Qe,Ge)}).join(" ")}(Fe,Te),k("xrange",Fe),Fe=function(Be,Ge){return k("replaceStars",Be,Ge),Be.trim().replace(I[G],"")}(Fe,Te),k("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(We){return!!We.match(be)})),Re=Re.map(function(We){return new de(We,ue)})},we.prototype.intersects=function(Q,ue){if(!(Q instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return Q.set.some(function(Re){return Re.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(Q,ue){return new we(Q,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new he(Q,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],Q))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(Q,ue,fe){var be=null,Re=null;try{var We=new we(ue,fe)}catch{return null}return Q.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==-1||(Re=new he(be=Fe,fe)))}),be},e.minSatisfying=function(Q,ue,fe){var be=null,Re=null;try{var We=new we(ue,fe)}catch{return null}return Q.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==1||(Re=new he(be=Fe,fe)))}),be},e.validRange=function(Q,ue){try{return new we(Q,ue).range||"*"}catch{return null}},e.ltr=function(Q,ue,fe){return $e(Q,ue,"<",fe)},e.gtr=function(Q,ue,fe){return $e(Q,ue,">",fe)},e.outside=$e,e.prerelease=function(Q,ue){var fe=K(Q,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Q,ue,fe){return Q=new we(Q,fe),ue=new we(ue,fe),Q.intersects(ue)},e.coerce=function(Q){if(Q instanceof he)return Q;if(typeof Q!="string")return null;var ue=Q.match(I[T]);return ue==null?null:K((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,n(1))},function(x,e){var n,o,k=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(b){if(n===setTimeout)return setTimeout(b,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(b,0);try{return n(b,0)}catch{try{return n.call(null,b,0)}catch{return n.call(this,b,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{o=typeof clearTimeout=="function"?clearTimeout:O}catch{o=O}})();var v,a=[],f=!1,d=-1;function g(){f&&v&&(f=!1,v.length?a=v.concat(a):d=-1,a.length&&w())}function w(){if(!f){var b=I(g);f=!0;for(var $=a.length;$;){for(v=a,a=[];++d<$;)v&&v[d].run();d=-1,$=a.length}v=null,f=!1,function(m){if(o===clearTimeout)return clearTimeout(m);if((o===O||!o)&&clearTimeout)return o=clearTimeout,clearTimeout(m);try{o(m)}catch{try{return o.call(null,m)}catch{return o.call(this,m)}}}(b)}}function h(b,$){this.fun=b,this.array=$}function p(){}k.nextTick=function(b){var $=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)$[m-1]=arguments[m];a.push(new h(b,$)),a.length!==1||f||I(w)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=p,k.addListener=p,k.once=p,k.off=p,k.removeListener=p,k.removeAllListeners=p,k.emit=p,k.prependListener=p,k.prependOnceListener=p,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(oe[144],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class o{constructor(I,v,a){this.level=I,this.key=v,this.value=a,this.forward=[]}}const k=void 0;class D{constructor(I,v=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new o(this.c,k,k)}get size(){return this.f}clear(){this.e=new o(this.c,k,k),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,v){return D.h(this,I,v,this.comparator)&&(this.f+=1),this}delete(I){const v=D.k(this,I,this.comparator);return v&&(this.f-=1),v}forEach(I,v){let a=this.e.forward[0];for(;a;)I.call(v,a.value,a.key,this),a=a.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",v=this.e.forward[0];for(;v;)I+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return I}static g(I,v,a){let f=I.e;for(let d=I.d-1;d>=0;d--)for(;f.forward[d]&&a(f.forward[d].key,v)<0;)f=f.forward[d];if(f=f.forward[0],f&&a(f.key,v)===0)return f}static h(I,v,a,f){const d=[];let g=I.e;for(let w=I.d-1;w>=0;w--){for(;g.forward[w]&&f(g.forward[w].key,v)<0;)g=g.forward[w];d[w]=g}if(g=g.forward[0],g&&f(g.key,v)===0)return g.value=a,!1;{const w=D.j(I);if(w>I.d){for(let h=I.d;h<w;h++)d[h]=I.e;I.d=w}g=new o(w,v,a);for(let h=0;h<w;h++)g.forward[h]=d[h].forward[h],d[h].forward[h]=g;return!0}}static j(I,v=.5){let a=1;for(;Math.random()<v&&a<I.c;)a+=1;return a}static k(I,v,a){const f=[];let d=I.e;for(let g=I.d-1;g>=0;g--){for(;d.forward[g]&&a(d.forward[g].key,v)<0;)d=d.forward[g];f[g]=d}if(d=d.forward[0],!d||a(d.key,v)!==0)return!1;for(let g=0;g<I.d&&f[g].forward[g]===d;g++)f[g].forward[g]=d.forward[g];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.$Rs=D}),define(oe[67],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class o{static create(D){return new o(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=o}),define(oe[4],ae([0,1,16,90,2,109,67]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=w;const I=!1,v=!1,a=!1;var f;(function(C){C.None=()=>k.$Xc.None;function z(Se){if(a){const{onDidAddListener:Pe}=Se,Ie=p.create();let $e=0;Se.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),Pe?.()}}}function re(Se,Pe){return K(Se,()=>{},0,void 0,!0,void 0,Pe)}C.defer=re;function Z(Se){return(Pe,Ie=null,$e)=>{let Q=!1,ue;return ue=Se(fe=>{if(!Q)return ue?ue.dispose():Q=!0,Pe.call(Ie,fe)},null,$e),Q&&ue.dispose(),ue}}C.once=Z;function le(Se,Pe,Ie){return G(($e,Q=null,ue)=>Se(fe=>$e.call(Q,Pe(fe)),null,ue),Ie)}C.map=le;function X(Se,Pe,Ie){return G(($e,Q=null,ue)=>Se(fe=>{Pe(fe),$e.call(Q,fe)},null,ue),Ie)}C.forEach=X;function ee(Se,Pe,Ie){return G(($e,Q=null,ue)=>Se(fe=>Pe(fe)&&$e.call(Q,fe),null,ue),Ie)}C.filter=ee;function q(Se){return Se}C.signal=q;function j(...Se){return(Pe,Ie=null,$e)=>{const Q=(0,k.$Uc)(...Se.map(ue=>ue(fe=>Pe.call(Ie,fe))));return ce(Q,$e)}}C.any=j;function B(Se,Pe,Ie,$e){let Q=Ie;return le(Se,ue=>(Q=Pe(Q,ue),Q),$e)}C.reduce=B;function G(Se,Pe){let Ie;const $e={onWillAddFirstListener(){Ie=Se(Q.fire,Q)},onDidRemoveLastListener(){Ie?.dispose()}};Pe||z($e);const Q=new i($e);return Pe?.add(Q),Q.event}function ce(Se,Pe){return Pe instanceof Array?Pe.push(Se):Pe&&Pe.add(Se),Se}function K(Se,Pe,Ie=100,$e=!1,Q=!1,ue,fe){let be,Re,We,Fe=0,Te;const Be={leakWarningThreshold:ue,onWillAddFirstListener(){be=Se(Qe=>{Fe++,Re=Pe(Re,Qe),$e&&!We&&(Ge.fire(Re),Re=void 0),Te=()=>{const He=Re;Re=void 0,We=void 0,(!$e||Fe>1)&&Ge.fire(He),Fe=0},typeof Ie=="number"?(clearTimeout(We),We=setTimeout(Te,Ie)):We===void 0&&(We=0,queueMicrotask(Te))})},onWillRemoveListener(){Q&&Fe>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,be.dispose()}};fe||z(Be);const Ge=new i(Be);return fe?.add(Ge),Ge.event}C.debounce=K;function he(Se,Pe=0,Ie){return C.debounce(Se,($e,Q)=>$e?($e.push(Q),$e):[Q],Pe,void 0,!0,void 0,Ie)}C.accumulate=he;function se(Se,Pe=($e,Q)=>$e===Q,Ie){let $e=!0,Q;return ee(Se,ue=>{const fe=$e||!Pe(ue,Q);return $e=!1,Q=ue,fe},Ie)}C.latch=se;function _(Se,Pe,Ie){return[C.filter(Se,Pe,Ie),C.filter(Se,$e=>!Pe($e),Ie)]}C.split=_;function F(Se,Pe=!1,Ie=[],$e){let Q=Ie.slice(),ue=Se(Re=>{Q?Q.push(Re):be.fire(Re)});$e&&$e.add(ue);const fe=()=>{Q?.forEach(Re=>be.fire(Re)),Q=null},be=new i({onWillAddFirstListener(){ue||(ue=Se(Re=>be.fire(Re)),$e&&$e.add(ue))},onDidAddFirstListener(){Q&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}C.buffer=F;function N(Se,Pe){return($e,Q,ue)=>{const fe=Pe(new H);return Se(function(be){const Re=fe.evaluate(be);Re!==W&&$e.call(Q,Re)},void 0,ue)}}C.chain=N;const W=Symbol("HaltChainable");class H{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Ie=>(Pe(Ie),Ie)),this}filter(Pe){return this.f.push(Ie=>Pe(Ie)?Ie:W),this}reduce(Pe,Ie){let $e=Ie;return this.f.push(Q=>($e=Pe($e,Q),$e)),this}latch(Pe=(Ie,$e)=>Ie===$e){let Ie=!0,$e;return this.f.push(Q=>{const ue=Ie||!Pe(Q,$e);return Ie=!1,$e=Q,ue?Q:W}),this}evaluate(Pe){for(const Ie of this.f)if(Pe=Ie(Pe),Pe===W)break;return Pe}}function J(Se,Pe,Ie=$e=>$e){const $e=(...be)=>fe.fire(Ie(...be)),Q=()=>Se.on(Pe,$e),ue=()=>Se.removeListener(Pe,$e),fe=new i({onWillAddFirstListener:Q,onDidRemoveLastListener:ue});return fe.event}C.fromNodeEventEmitter=J;function Y(Se,Pe,Ie=$e=>$e){const $e=(...be)=>fe.fire(Ie(...be)),Q=()=>Se.addEventListener(Pe,$e),ue=()=>Se.removeEventListener(Pe,$e),fe=new i({onWillAddFirstListener:Q,onDidRemoveLastListener:ue});return fe.event}C.fromDOMEventEmitter=Y;function V(Se){return new Promise(Pe=>Z(Se)(Pe))}C.toPromise=V;function ie(Se){const Pe=new i;return Se.then(Ie=>{Pe.fire(Ie)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}C.fromPromise=ie;function de(Se,Pe,Ie){return Pe(Ie),Se($e=>Pe($e))}C.runAndSubscribe=de;class me{constructor(Pe,Ie){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Ie||z($e),this.emitter=new i($e),Ie&&Ie.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Ie){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(Se,Pe){return new me(Se,Pe).emitter.event}C.fromObservable=we;function Oe(Se){return(Pe,Ie,$e)=>{let Q=0,ue=!1;const fe={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(Se.reportChanges(),ue&&(ue=!1,Pe.call(Ie)))},handlePossibleChange(){},handleChange(){ue=!0}};Se.addObserver(fe),Se.reportChanges();const be={dispose(){Se.removeObserver(fe)}};return $e instanceof k.$Wc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Oe})(f||(e.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${d.f++}`,d.all.add(this)}start(z){this.g=new O.$he,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$je=d;let g=-1;function w(C){const z=g;return g=C,{dispose(){g=z}}}class h{static{this.f=1}constructor(z,re,Z=(h.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=re,this.name=Z,this.h=0}dispose(){this.g?.clear()}check(z,re){const Z=this.threshold;if(Z<=0||re<Z)return;this.g||(this.g=new Map);const le=this.g.get(z.value)||0;if(this.g.set(z.value,le+1),this.h-=1,this.h<=0){this.h=Z*.5;const[X,ee]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${ee}):`;console.warn(q),console.warn(X);const j=new b(q,X);this.j(j)}return()=>{const X=this.g.get(z.value)||0;this.g.set(z.value,X-1)}}getMostFrequentStack(){if(!this.g)return;let z,re=0;for(const[Z,le]of this.g)(!z||re<le)&&(z=[Z,le],re=le);return z}}class p{static create(){const z=new Error;return new p(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b extends Error{constructor(z,re){super(z),this.name="ListenerLeakError",this.stack=re}}e.$le=b;class $ extends Error{constructor(z,re){super(z),this.name="ListenerRefusalError",this.stack=re}}e.$me=$;let m=0;class E{constructor(z){this.value=z,this.id=m++}}const P=2,t=(C,z)=>{if(C instanceof E)z(C);else for(let re=0;re<C.length;re++){const Z=C[re];Z&&z(Z)}};let r;if(I){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),r=new FinalizationRegistry(z=>{typeof z=="string"&&C.push(z)})}class i{constructor(z){this.z=0,this.f=z,this.g=g>0||this.f?.leakWarningThreshold?new h(z?.onListenerError??n.$3,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(v){const z=this.u;queueMicrotask(()=>{t(z,re=>re.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,re,Z)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const B=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],G=new $(`${j}. HINT: Stack shows most frequent listener (${B[1]}-times)`,B[0]);return(this.f?.onListenerError||n.$3)(G),k.$Xc.None}if(this.m)return k.$Xc.None;re&&(z=z.bind(re));const le=new E(z);let X,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=p.create(),X=this.g.check(le.stack,this.z+1)),v&&(le.stack=ee??p.create()),this.u?this.u instanceof E?(this.w??=new s,this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const q=(0,k.$Vc)(()=>{r?.unregister(q),X?.(),this.A(le)});if(Z instanceof k.$Wc?Z.add(q):Array.isArray(Z)&&Z.push(q),r){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),B=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);r.register(q,B?.[2]??j,q)}return q},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const re=this.u,Z=re.indexOf(z);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,re[Z]=void 0;const le=this.w.current===this;if(this.z*P<=re.length){let X=0;for(let ee=0;ee<re.length;ee++)re[ee]?re[X++]=re[ee]:le&&(this.w.end--,X<this.w.i&&this.w.i--);re.length=X}}B(z,re){if(!z)return;const Z=this.f?.onListenerError||n.$3;if(!Z){z.value(re);return}try{z.value(re)}catch(le){Z(le)}}C(z){const re=z.current.u;for(;z.i<z.end;)this.B(re[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,z);else{const re=this.w;re.enqueue(this,z,this.u.length),this.C(re)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const c=()=>new s;e.$oe=c;class s{constructor(){this.i=-1,this.end=0}enqueue(z,re,Z){this.i=0,this.end=Z,this.current=z,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends i{async fireAsync(z,re,Z){if(this.u)for(this.h||(this.h=new D.$8c),t(this.u,le=>this.h.push([le.value,z]));this.h.size>0&&!re.isCancellationRequested;){const[le,X]=this.h.shift(),ee=[],q={...X,token:re,waitUntil:j=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Z&&(j=Z(j,le)),ee.push(j)}};try{le(q)}catch(j){(0,n.$3)(j);continue}Object.freeze(ee),await Promise.allSettled(ee).then(j=>{for(const B of j)B.status==="rejected"&&(0,n.$3)(B.reason)})}}}e.$pe=l;class u extends i{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new D.$8c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$qe=u;class S extends u{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$re=S;class y extends i{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(re=>super.fire(re)),this.h=[]}))}}e.$se=y;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const re={event:z,listener:null};this.h.push(re),this.g&&this.m(re);const Z=()=>{this.g&&this.o(re);const le=this.h.indexOf(re);this.h.splice(le,1)};return(0,k.$Vc)((0,o.$gb)(Z))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(re=>this.f.fire(re))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$te=R;class L{constructor(z,re,Z,le){this.f=new k.$Wc;const X=this.f.add(new R),ee=this.f.add(new k.$7c);function q(j){ee.set(j,X.add(le(j)))}for(const j of z)q(j);this.f.add(re(j=>{q(j)})),this.f.add(Z(j=>{ee.deleteAndDispose(j)})),this.event=X.event}dispose(){this.f.dispose()}}e.$ue=L;class T{constructor(){this.f=[]}wrapEvent(z,re,Z){return(le,X,ee)=>z(q=>{const j=this.f[this.f.length-1];if(!re){j?j.buffers.push(()=>le.call(X,q)):le.call(X,q);return}const B=j;if(!B){le.call(X,re(Z,q));return}B.items??=[],B.items.push(q),B.buffers.length===0&&j.buffers.push(()=>{B.reducedResult??=Z?B.items.reduce(re,Z):B.items.reduce(re),le.call(X,B.reducedResult)})},void 0,ee)}bufferEvents(z){const re={buffers:new Array};this.f.push(re);const Z=z();return this.f.pop(),re.buffers.forEach(le=>le()),Z}}e.$ve=T;class A{constructor(){this.f=!1,this.g=f.None,this.h=k.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=A;class M{static const(z){return new U(z)}constructor(z){this.g=z,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$xe=M;class U{constructor(z){this.value=z,this.onDidChange=f.None}}}),define(oe[23],ae([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=I;const o=Object.freeze(function(v,a){const f=setTimeout(v.bind(a),0);return{dispose(){clearTimeout(f)}}});var k;(function(v){function a(f){return f===v.None||f===v.Cancelled||f instanceof D?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}v.isCancellationToken=a,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})})(k||(e.CancellationToken=k={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?o:(this.b||(this.b=new n.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=k.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=k.None}}e.$ye=O;function I(v){const a=new O;return v.add({dispose(){a.cancel()}}),a.token}}),define(oe[145],ae([0,1,23]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=k;class o{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new n.$ye,a=this.b(v.token);return this.a={promise:a,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$$e=o;function k(I){return I}class D{constructor(v,a){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=k):(this.c=a,this.d=v.getCacheKey)}get(v){const a=this.d(v);return this.b!==a&&(this.b=a,this.a=this.c(v)),this.a}}e.$af=D;class O{get cachedValues(){return this.a}constructor(v,a){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=k):(this.c=a,this.d=v.getCacheKey)}get(v){const a=this.d(v);if(this.b.has(a))return this.b.get(a);const f=this.c(v);return this.a.set(v,f),this.b.set(a,f),f}}e.$bf=O}),define(oe[68],ae([0,1,16,2]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=k,e.$Be=D,e.$Ce=O,e.$De=I,e.$Ee=a,e.$Fe=f,e.$Ge=d,e.$He=g,e.$Ie=w,e.$Je=h,e.$Ke=p,e.$Le=b,e.$Me=$,e.$Ne=m,e.$Oe=E;function k(P){const t=P;return t?typeof t.read=="function":!1}function D(P){const t=P;return t?[t.on,t.pause,t.resume,t.destroy].every(r=>typeof r=="function"):!1}function O(P){const t=P;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(P,t){return new v(P,t)}class v{constructor(t,r){this.e=t,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(r=>r(t))}h(t){this.c.error.length===0?(0,n.$3)(t):this.c.error.slice(0).forEach(r=>r(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,r){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(t,r){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const c=i.indexOf(r);c>=0&&i.splice(c,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(P,t){const r=[];let i;for(;(i=P.read())!==null;)r.push(i);return t(r)}function f(P,t,r){const i=[];let c;for(;(c=P.read())!==null&&i.length<r;)i.push(c);return c===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const s=c;return c=void 0,s}return P.read()}}}function d(P,t){return new Promise((r,i)=>{const c=[];g(P,{onData:s=>{t&&c.push(s)},onError:s=>{t?i(s):r(void 0)},onEnd:()=>{r(t?t(c):void 0)}})})}function g(P,t,r){P.on("error",i=>{r?.isCancellationRequested||t.onError(i)}),P.on("end",()=>{r?.isCancellationRequested||t.onEnd()}),P.on("data",i=>{r?.isCancellationRequested||t.onData(i)})}function w(P,t){return new Promise((r,i)=>{const c=new o.$Wc,s=[],l=y=>{if(s.push(y),s.length>t)return c.dispose(),P.pause(),r({stream:P,buffer:s,ended:!1})},u=y=>(c.dispose(),i(y)),S=()=>(c.dispose(),r({stream:P,buffer:s,ended:!0}));c.add((0,o.$Vc)(()=>P.removeListener("error",u))),P.on("error",u),c.add((0,o.$Vc)(()=>P.removeListener("end",S))),P.on("end",S),c.add((0,o.$Vc)(()=>P.removeListener("data",l))),P.on("data",l)})}function h(P,t){const r=I(t);return r.end(P),r}function p(){const P=I(()=>{throw new Error("not supported")});return P.end(),P}function b(P){let t=!1;return{read:()=>t?null:(t=!0,P)}}function $(P,t,r){const i=I(r);return g(P,{onData:c=>i.write(t.data(c)),onError:c=>i.error(t.error?t.error(c):c),onEnd:()=>i.end()}),i}function m(P,t,r){let i=!1;return{read:()=>{const c=t.read();return i?c:(i=!0,c!==null?r([P,c]):P)}}}function E(P,t,r){let i=!1;const c=I(r);return g(t,{onData:s=>i?c.write(s):(i=!0,c.write(r([P,s]))),onError:s=>c.error(s),onEnd:()=>{i||(i=!0,c.write(P)),c.end()}}),c}});var Rt=this&&this.__createBinding||(Object.create?function(x,e,n,o){o===void 0&&(o=n);var k=Object.getOwnPropertyDescriptor(e,n);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,o,k)}:function(x,e,n,o){o===void 0&&(o=n),x[o]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),De=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&Rt(e,x,n);return At(e,x),e};define(oe[17],ae([0,1,66,68]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=a,e.$Re=f,e.$Se=d,e.$Te=g,e.$Ue=w,e.$Ve=h,e.$We=p,e.$Xe=b,e.$Ye=$,e.$Ze=m,e.$1e=E,e.$2e=P,e.$3e=t,e.$4e=r,e.$5e=i,e.$6e=c,e.$7e=s,e.$8e=l,e.$9e=u,e.$0e=R,o=De(o);const k=typeof Buffer<"u",D=new n.$X(()=>new Uint8Array(256));let O,I;class v{static alloc(T){return k?new v(Buffer.allocUnsafe(T)):new v(new Uint8Array(T))}static wrap(T){return k&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new v(T)}static fromString(T,A){return!(A?.dontUseNodeBuffer||!1)&&k?new v(Buffer.from(T)):(O||(O=new TextEncoder),new v(O.encode(T)))}static fromByteArray(T){const A=v.alloc(T.length);for(let M=0,U=T.length;M<U;M++)A.buffer[M]=T[M];return A}static concat(T,A){if(typeof A>"u"){A=0;for(let C=0,z=T.length;C<z;C++)A+=T[C].byteLength}const M=v.alloc(A);let U=0;for(let C=0,z=T.length;C<z;C++){const re=T[C];M.set(re,U),U+=re.byteLength}return M}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=v.alloc(this.byteLength);return T.set(this),T}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(T,A){return new v(this.buffer.subarray(T,A))}set(T,A){if(T instanceof v)this.buffer.set(T.buffer,A);else if(T instanceof Uint8Array)this.buffer.set(T,A);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),A);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return g(this.buffer,T)}writeUInt32BE(T,A){w(this.buffer,T,A)}readUInt32LE(T){return h(this.buffer,T)}writeUInt32LE(T,A){p(this.buffer,T,A)}readUInt8(T){return b(this.buffer,T)}writeUInt8(T,A){$(this.buffer,T,A)}indexOf(T,A=0){return a(this.buffer,T instanceof v?T.buffer:T,A)}}e.$Pe=v;function a(L,T,A=0){const M=T.byteLength,U=L.byteLength;if(M===0)return 0;if(M===1)return L.indexOf(T[0]);if(M>U-A)return-1;const C=D.value;C.fill(T.length);for(let le=0;le<T.length;le++)C[T[le]]=T.length-le-1;let z=A+T.length-1,re=z,Z=-1;for(;z<U;)if(L[z]===T[re]){if(re===0){Z=z;break}z--,re--}else z+=Math.max(T.length-re,C[L[z]]),re=T.length-1;return Z}function f(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0}function d(L,T,A){L[A+0]=T&255,T=T>>>8,L[A+1]=T&255}function g(L,T){return L[T]*2**24+L[T+1]*2**16+L[T+2]*2**8+L[T+3]}function w(L,T,A){L[A+3]=T,T=T>>>8,L[A+2]=T,T=T>>>8,L[A+1]=T,T=T>>>8,L[A]=T}function h(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0|L[T+2]<<16>>>0|L[T+3]<<24>>>0}function p(L,T,A){L[A+0]=T&255,T=T>>>8,L[A+1]=T&255,T=T>>>8,L[A+2]=T&255,T=T>>>8,L[A+3]=T&255}function b(L,T){return L[T]}function $(L,T,A){L[A]=T}function m(L){return o.$Ee(L,T=>v.concat(T))}function E(L){return o.$Le(L)}function P(L){return o.$Ge(L,T=>v.concat(T))}async function t(L){return L.ended?v.concat(L.buffer):v.concat([...L.buffer,await P(L.stream)])}function r(L){return o.$Je(L,T=>v.concat(T))}function i(L){return o.$Me(L,{data:T=>typeof T=="string"?v.fromString(T):v.wrap(T)},T=>v.concat(T))}function c(L){return o.$De(T=>v.concat(T),L)}function s(L,T){return o.$Ne(L,T,A=>v.concat(A))}function l(L,T){return o.$Oe(L,T,A=>v.concat(A))}function u(L){let T=0,A=0,M=0;const U=new Uint8Array(Math.floor(L.length/4*3)),C=re=>{switch(A){case 3:U[M++]=T|re,A=0;break;case 2:U[M++]=T|re>>>2,T=re<<6,A=3;break;case 1:U[M++]=T|re>>>4,T=re<<4,A=2;break;default:T=re<<2,A=1}};for(let re=0;re<L.length;re++){const Z=L.charCodeAt(re);if(Z>=65&&Z<=90)C(Z-65);else if(Z>=97&&Z<=122)C(Z-97+26);else if(Z>=48&&Z<=57)C(Z-48+52);else if(Z===43||Z===45)C(62);else if(Z===47||Z===95)C(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${L[re]}`)}}const z=M;for(;A>0;)C(0);return v.wrap(U).slice(0,z)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},T=!0,A=!1){const M=A?y:S;let U="";const C=L.byteLength%3;let z=0;for(;z<L.byteLength-C;z+=3){const re=L[z+0],Z=L[z+1],le=L[z+2];U+=M[re>>>2],U+=M[(re<<4|Z>>>4)&63],U+=M[(Z<<2|le>>>6)&63],U+=M[le&63]}if(C===1){const re=L[z+0];U+=M[re>>>2],U+=M[re<<4&63],T&&(U+="==")}else if(C===2){const re=L[z+0],Z=L[z+1];U+=M[re>>>2],U+=M[(re<<4|Z>>>4)&63],U+=M[Z<<2&63],T&&(U+="=")}return U}}),define(oe[146],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(oe[13],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=n,e.$hg=o,e.$ig=k,e.$jg=D,e.$kg=O,e.$lg=I,e.$mg=v,e.$ng=a,e.$og=f,e.$pg=d,e.$qg=g,e.$rg=w,e.$sg=h,e.$tg=b,e.$ug=$,e.$vg=m,e.$wg=E,e.$xg=P;function n(t){return typeof t=="string"}function o(t){return Array.isArray(t)&&t.every(r=>n(r))}function k(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const r=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof r}function O(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function v(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function f(t){return!d(t)}function d(t){return a(t)||t===null}function g(t,r){if(!t)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function w(t){if(d(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function h(...t){const r=[];for(let i=0;i<t.length;i++){const c=t[i];if(d(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(c)}return r}const p=Object.prototype.hasOwnProperty;function b(t){if(!k(t))return!1;for(const r in t)if(p.call(t,r))return!1;return!0}function $(t){return typeof t=="function"}function m(...t){return t.length>0&&t.every($)}function E(t,r){const i=Math.min(t.length,r.length);for(let c=0;c<i;c++)P(t[c],r[c])}function P(t,r){if(n(r)){if(typeof t!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if($(r)){try{if(t instanceof r)return}catch{}if(!d(t)&&t.constructor===r||r.length===1&&r.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[110],ae([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=k,e.$2j=D;const o=Object.create(null);function k(O,I){if((0,n.$gg)(I)){const v=o[I];if(v===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=v}return o[O]=I,{id:O}}function D(){return o}}),define(oe[147],ae([0,1,110]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,n.$1j)("add",6e4),plus:(0,n.$1j)("plus",6e4),gistNew:(0,n.$1j)("gist-new",6e4),repoCreate:(0,n.$1j)("repo-create",6e4),lightbulb:(0,n.$1j)("lightbulb",60001),lightBulb:(0,n.$1j)("light-bulb",60001),repo:(0,n.$1j)("repo",60002),repoDelete:(0,n.$1j)("repo-delete",60002),gistFork:(0,n.$1j)("gist-fork",60003),repoForked:(0,n.$1j)("repo-forked",60003),gitPullRequest:(0,n.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$1j)("record-keys",60005),keyboard:(0,n.$1j)("keyboard",60005),tag:(0,n.$1j)("tag",60006),gitPullRequestLabel:(0,n.$1j)("git-pull-request-label",60006),tagAdd:(0,n.$1j)("tag-add",60006),tagRemove:(0,n.$1j)("tag-remove",60006),person:(0,n.$1j)("person",60007),personFollow:(0,n.$1j)("person-follow",60007),personOutline:(0,n.$1j)("person-outline",60007),personFilled:(0,n.$1j)("person-filled",60007),gitBranch:(0,n.$1j)("git-branch",60008),gitBranchCreate:(0,n.$1j)("git-branch-create",60008),gitBranchDelete:(0,n.$1j)("git-branch-delete",60008),sourceControl:(0,n.$1j)("source-control",60008),mirror:(0,n.$1j)("mirror",60009),mirrorPublic:(0,n.$1j)("mirror-public",60009),star:(0,n.$1j)("star",60010),starAdd:(0,n.$1j)("star-add",60010),starDelete:(0,n.$1j)("star-delete",60010),starEmpty:(0,n.$1j)("star-empty",60010),comment:(0,n.$1j)("comment",60011),commentAdd:(0,n.$1j)("comment-add",60011),alert:(0,n.$1j)("alert",60012),warning:(0,n.$1j)("warning",60012),search:(0,n.$1j)("search",60013),searchSave:(0,n.$1j)("search-save",60013),logOut:(0,n.$1j)("log-out",60014),signOut:(0,n.$1j)("sign-out",60014),logIn:(0,n.$1j)("log-in",60015),signIn:(0,n.$1j)("sign-in",60015),eye:(0,n.$1j)("eye",60016),eyeUnwatch:(0,n.$1j)("eye-unwatch",60016),eyeWatch:(0,n.$1j)("eye-watch",60016),circleFilled:(0,n.$1j)("circle-filled",60017),primitiveDot:(0,n.$1j)("primitive-dot",60017),closeDirty:(0,n.$1j)("close-dirty",60017),debugBreakpoint:(0,n.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$1j)("primitive-square",60018),edit:(0,n.$1j)("edit",60019),pencil:(0,n.$1j)("pencil",60019),info:(0,n.$1j)("info",60020),issueOpened:(0,n.$1j)("issue-opened",60020),gistPrivate:(0,n.$1j)("gist-private",60021),gitForkPrivate:(0,n.$1j)("git-fork-private",60021),lock:(0,n.$1j)("lock",60021),mirrorPrivate:(0,n.$1j)("mirror-private",60021),close:(0,n.$1j)("close",60022),removeClose:(0,n.$1j)("remove-close",60022),x:(0,n.$1j)("x",60022),repoSync:(0,n.$1j)("repo-sync",60023),sync:(0,n.$1j)("sync",60023),clone:(0,n.$1j)("clone",60024),desktopDownload:(0,n.$1j)("desktop-download",60024),beaker:(0,n.$1j)("beaker",60025),microscope:(0,n.$1j)("microscope",60025),vm:(0,n.$1j)("vm",60026),deviceDesktop:(0,n.$1j)("device-desktop",60026),file:(0,n.$1j)("file",60027),fileText:(0,n.$1j)("file-text",60027),more:(0,n.$1j)("more",60028),ellipsis:(0,n.$1j)("ellipsis",60028),kebabHorizontal:(0,n.$1j)("kebab-horizontal",60028),mailReply:(0,n.$1j)("mail-reply",60029),reply:(0,n.$1j)("reply",60029),organization:(0,n.$1j)("organization",60030),organizationFilled:(0,n.$1j)("organization-filled",60030),organizationOutline:(0,n.$1j)("organization-outline",60030),newFile:(0,n.$1j)("new-file",60031),fileAdd:(0,n.$1j)("file-add",60031),newFolder:(0,n.$1j)("new-folder",60032),fileDirectoryCreate:(0,n.$1j)("file-directory-create",60032),trash:(0,n.$1j)("trash",60033),trashcan:(0,n.$1j)("trashcan",60033),history:(0,n.$1j)("history",60034),clock:(0,n.$1j)("clock",60034),folder:(0,n.$1j)("folder",60035),fileDirectory:(0,n.$1j)("file-directory",60035),symbolFolder:(0,n.$1j)("symbol-folder",60035),logoGithub:(0,n.$1j)("logo-github",60036),markGithub:(0,n.$1j)("mark-github",60036),github:(0,n.$1j)("github",60036),terminal:(0,n.$1j)("terminal",60037),console:(0,n.$1j)("console",60037),repl:(0,n.$1j)("repl",60037),zap:(0,n.$1j)("zap",60038),symbolEvent:(0,n.$1j)("symbol-event",60038),error:(0,n.$1j)("error",60039),stop:(0,n.$1j)("stop",60039),variable:(0,n.$1j)("variable",60040),symbolVariable:(0,n.$1j)("symbol-variable",60040),array:(0,n.$1j)("array",60042),symbolArray:(0,n.$1j)("symbol-array",60042),symbolModule:(0,n.$1j)("symbol-module",60043),symbolPackage:(0,n.$1j)("symbol-package",60043),symbolNamespace:(0,n.$1j)("symbol-namespace",60043),symbolObject:(0,n.$1j)("symbol-object",60043),symbolMethod:(0,n.$1j)("symbol-method",60044),symbolFunction:(0,n.$1j)("symbol-function",60044),symbolConstructor:(0,n.$1j)("symbol-constructor",60044),symbolBoolean:(0,n.$1j)("symbol-boolean",60047),symbolNull:(0,n.$1j)("symbol-null",60047),symbolNumeric:(0,n.$1j)("symbol-numeric",60048),symbolNumber:(0,n.$1j)("symbol-number",60048),symbolStructure:(0,n.$1j)("symbol-structure",60049),symbolStruct:(0,n.$1j)("symbol-struct",60049),symbolParameter:(0,n.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$1j)("symbol-type-parameter",60050),symbolKey:(0,n.$1j)("symbol-key",60051),symbolText:(0,n.$1j)("symbol-text",60051),symbolReference:(0,n.$1j)("symbol-reference",60052),goToFile:(0,n.$1j)("go-to-file",60052),symbolEnum:(0,n.$1j)("symbol-enum",60053),symbolValue:(0,n.$1j)("symbol-value",60053),symbolRuler:(0,n.$1j)("symbol-ruler",60054),symbolUnit:(0,n.$1j)("symbol-unit",60054),activateBreakpoints:(0,n.$1j)("activate-breakpoints",60055),archive:(0,n.$1j)("archive",60056),arrowBoth:(0,n.$1j)("arrow-both",60057),arrowDown:(0,n.$1j)("arrow-down",60058),arrowLeft:(0,n.$1j)("arrow-left",60059),arrowRight:(0,n.$1j)("arrow-right",60060),arrowSmallDown:(0,n.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$1j)("arrow-small-left",60062),arrowSmallRight:(0,n.$1j)("arrow-small-right",60063),arrowSmallUp:(0,n.$1j)("arrow-small-up",60064),arrowUp:(0,n.$1j)("arrow-up",60065),bell:(0,n.$1j)("bell",60066),bold:(0,n.$1j)("bold",60067),book:(0,n.$1j)("book",60068),bookmark:(0,n.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$1j)("briefcase",60076),broadcast:(0,n.$1j)("broadcast",60077),browser:(0,n.$1j)("browser",60078),bug:(0,n.$1j)("bug",60079),calendar:(0,n.$1j)("calendar",60080),caseSensitive:(0,n.$1j)("case-sensitive",60081),check:(0,n.$1j)("check",60082),checklist:(0,n.$1j)("checklist",60083),chevronDown:(0,n.$1j)("chevron-down",60084),chevronLeft:(0,n.$1j)("chevron-left",60085),chevronRight:(0,n.$1j)("chevron-right",60086),chevronUp:(0,n.$1j)("chevron-up",60087),chromeClose:(0,n.$1j)("chrome-close",60088),chromeMaximize:(0,n.$1j)("chrome-maximize",60089),chromeMinimize:(0,n.$1j)("chrome-minimize",60090),chromeRestore:(0,n.$1j)("chrome-restore",60091),circleOutline:(0,n.$1j)("circle-outline",60092),circle:(0,n.$1j)("circle",60092),debugBreakpointUnverified:(0,n.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$1j)("circle-slash",60093),circuitBoard:(0,n.$1j)("circuit-board",60094),clearAll:(0,n.$1j)("clear-all",60095),clippy:(0,n.$1j)("clippy",60096),closeAll:(0,n.$1j)("close-all",60097),cloudDownload:(0,n.$1j)("cloud-download",60098),cloudUpload:(0,n.$1j)("cloud-upload",60099),code:(0,n.$1j)("code",60100),collapseAll:(0,n.$1j)("collapse-all",60101),colorMode:(0,n.$1j)("color-mode",60102),commentDiscussion:(0,n.$1j)("comment-discussion",60103),creditCard:(0,n.$1j)("credit-card",60105),dash:(0,n.$1j)("dash",60108),dashboard:(0,n.$1j)("dashboard",60109),database:(0,n.$1j)("database",60110),debugContinue:(0,n.$1j)("debug-continue",60111),debugDisconnect:(0,n.$1j)("debug-disconnect",60112),debugPause:(0,n.$1j)("debug-pause",60113),debugRestart:(0,n.$1j)("debug-restart",60114),debugStart:(0,n.$1j)("debug-start",60115),debugStepInto:(0,n.$1j)("debug-step-into",60116),debugStepOut:(0,n.$1j)("debug-step-out",60117),debugStepOver:(0,n.$1j)("debug-step-over",60118),debugStop:(0,n.$1j)("debug-stop",60119),debug:(0,n.$1j)("debug",60120),deviceCameraVideo:(0,n.$1j)("device-camera-video",60121),deviceCamera:(0,n.$1j)("device-camera",60122),deviceMobile:(0,n.$1j)("device-mobile",60123),diffAdded:(0,n.$1j)("diff-added",60124),diffIgnored:(0,n.$1j)("diff-ignored",60125),diffModified:(0,n.$1j)("diff-modified",60126),diffRemoved:(0,n.$1j)("diff-removed",60127),diffRenamed:(0,n.$1j)("diff-renamed",60128),diff:(0,n.$1j)("diff",60129),diffSidebyside:(0,n.$1j)("diff-sidebyside",60129),discard:(0,n.$1j)("discard",60130),editorLayout:(0,n.$1j)("editor-layout",60131),emptyWindow:(0,n.$1j)("empty-window",60132),exclude:(0,n.$1j)("exclude",60133),extensions:(0,n.$1j)("extensions",60134),eyeClosed:(0,n.$1j)("eye-closed",60135),fileBinary:(0,n.$1j)("file-binary",60136),fileCode:(0,n.$1j)("file-code",60137),fileMedia:(0,n.$1j)("file-media",60138),filePdf:(0,n.$1j)("file-pdf",60139),fileSubmodule:(0,n.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$1j)("file-symlink-file",60142),fileZip:(0,n.$1j)("file-zip",60143),files:(0,n.$1j)("files",60144),filter:(0,n.$1j)("filter",60145),flame:(0,n.$1j)("flame",60146),foldDown:(0,n.$1j)("fold-down",60147),foldUp:(0,n.$1j)("fold-up",60148),fold:(0,n.$1j)("fold",60149),folderActive:(0,n.$1j)("folder-active",60150),folderOpened:(0,n.$1j)("folder-opened",60151),gear:(0,n.$1j)("gear",60152),gift:(0,n.$1j)("gift",60153),gistSecret:(0,n.$1j)("gist-secret",60154),gist:(0,n.$1j)("gist",60155),gitCommit:(0,n.$1j)("git-commit",60156),gitCompare:(0,n.$1j)("git-compare",60157),compareChanges:(0,n.$1j)("compare-changes",60157),gitMerge:(0,n.$1j)("git-merge",60158),githubAction:(0,n.$1j)("github-action",60159),githubAlt:(0,n.$1j)("github-alt",60160),globe:(0,n.$1j)("globe",60161),grabber:(0,n.$1j)("grabber",60162),graph:(0,n.$1j)("graph",60163),gripper:(0,n.$1j)("gripper",60164),heart:(0,n.$1j)("heart",60165),home:(0,n.$1j)("home",60166),horizontalRule:(0,n.$1j)("horizontal-rule",60167),hubot:(0,n.$1j)("hubot",60168),inbox:(0,n.$1j)("inbox",60169),issueReopened:(0,n.$1j)("issue-reopened",60171),issues:(0,n.$1j)("issues",60172),italic:(0,n.$1j)("italic",60173),jersey:(0,n.$1j)("jersey",60174),json:(0,n.$1j)("json",60175),kebabVertical:(0,n.$1j)("kebab-vertical",60176),key:(0,n.$1j)("key",60177),law:(0,n.$1j)("law",60178),lightbulbAutofix:(0,n.$1j)("lightbulb-autofix",60179),linkExternal:(0,n.$1j)("link-external",60180),link:(0,n.$1j)("link",60181),listOrdered:(0,n.$1j)("list-ordered",60182),listUnordered:(0,n.$1j)("list-unordered",60183),liveShare:(0,n.$1j)("live-share",60184),loading:(0,n.$1j)("loading",60185),location:(0,n.$1j)("location",60186),mailRead:(0,n.$1j)("mail-read",60187),mail:(0,n.$1j)("mail",60188),markdown:(0,n.$1j)("markdown",60189),megaphone:(0,n.$1j)("megaphone",60190),mention:(0,n.$1j)("mention",60191),milestone:(0,n.$1j)("milestone",60192),gitPullRequestMilestone:(0,n.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$1j)("mortar-board",60193),move:(0,n.$1j)("move",60194),multipleWindows:(0,n.$1j)("multiple-windows",60195),mute:(0,n.$1j)("mute",60196),noNewline:(0,n.$1j)("no-newline",60197),note:(0,n.$1j)("note",60198),octoface:(0,n.$1j)("octoface",60199),openPreview:(0,n.$1j)("open-preview",60200),package:(0,n.$1j)("package",60201),paintcan:(0,n.$1j)("paintcan",60202),pin:(0,n.$1j)("pin",60203),play:(0,n.$1j)("play",60204),run:(0,n.$1j)("run",60204),plug:(0,n.$1j)("plug",60205),preserveCase:(0,n.$1j)("preserve-case",60206),preview:(0,n.$1j)("preview",60207),project:(0,n.$1j)("project",60208),pulse:(0,n.$1j)("pulse",60209),question:(0,n.$1j)("question",60210),quote:(0,n.$1j)("quote",60211),radioTower:(0,n.$1j)("radio-tower",60212),reactions:(0,n.$1j)("reactions",60213),references:(0,n.$1j)("references",60214),refresh:(0,n.$1j)("refresh",60215),regex:(0,n.$1j)("regex",60216),remoteExplorer:(0,n.$1j)("remote-explorer",60217),remote:(0,n.$1j)("remote",60218),remove:(0,n.$1j)("remove",60219),replaceAll:(0,n.$1j)("replace-all",60220),replace:(0,n.$1j)("replace",60221),repoClone:(0,n.$1j)("repo-clone",60222),repoForcePush:(0,n.$1j)("repo-force-push",60223),repoPull:(0,n.$1j)("repo-pull",60224),repoPush:(0,n.$1j)("repo-push",60225),report:(0,n.$1j)("report",60226),requestChanges:(0,n.$1j)("request-changes",60227),rocket:(0,n.$1j)("rocket",60228),rootFolderOpened:(0,n.$1j)("root-folder-opened",60229),rootFolder:(0,n.$1j)("root-folder",60230),rss:(0,n.$1j)("rss",60231),ruby:(0,n.$1j)("ruby",60232),saveAll:(0,n.$1j)("save-all",60233),saveAs:(0,n.$1j)("save-as",60234),save:(0,n.$1j)("save",60235),screenFull:(0,n.$1j)("screen-full",60236),screenNormal:(0,n.$1j)("screen-normal",60237),searchStop:(0,n.$1j)("search-stop",60238),server:(0,n.$1j)("server",60240),settingsGear:(0,n.$1j)("settings-gear",60241),settings:(0,n.$1j)("settings",60242),shield:(0,n.$1j)("shield",60243),smiley:(0,n.$1j)("smiley",60244),sortPrecedence:(0,n.$1j)("sort-precedence",60245),splitHorizontal:(0,n.$1j)("split-horizontal",60246),splitVertical:(0,n.$1j)("split-vertical",60247),squirrel:(0,n.$1j)("squirrel",60248),starFull:(0,n.$1j)("star-full",60249),starHalf:(0,n.$1j)("star-half",60250),symbolClass:(0,n.$1j)("symbol-class",60251),symbolColor:(0,n.$1j)("symbol-color",60252),symbolConstant:(0,n.$1j)("symbol-constant",60253),symbolEnumMember:(0,n.$1j)("symbol-enum-member",60254),symbolField:(0,n.$1j)("symbol-field",60255),symbolFile:(0,n.$1j)("symbol-file",60256),symbolInterface:(0,n.$1j)("symbol-interface",60257),symbolKeyword:(0,n.$1j)("symbol-keyword",60258),symbolMisc:(0,n.$1j)("symbol-misc",60259),symbolOperator:(0,n.$1j)("symbol-operator",60260),symbolProperty:(0,n.$1j)("symbol-property",60261),wrench:(0,n.$1j)("wrench",60261),wrenchSubaction:(0,n.$1j)("wrench-subaction",60261),symbolSnippet:(0,n.$1j)("symbol-snippet",60262),tasklist:(0,n.$1j)("tasklist",60263),telescope:(0,n.$1j)("telescope",60264),textSize:(0,n.$1j)("text-size",60265),threeBars:(0,n.$1j)("three-bars",60266),thumbsdown:(0,n.$1j)("thumbsdown",60267),thumbsup:(0,n.$1j)("thumbsup",60268),tools:(0,n.$1j)("tools",60269),triangleDown:(0,n.$1j)("triangle-down",60270),triangleLeft:(0,n.$1j)("triangle-left",60271),triangleRight:(0,n.$1j)("triangle-right",60272),triangleUp:(0,n.$1j)("triangle-up",60273),twitter:(0,n.$1j)("twitter",60274),unfold:(0,n.$1j)("unfold",60275),unlock:(0,n.$1j)("unlock",60276),unmute:(0,n.$1j)("unmute",60277),unverified:(0,n.$1j)("unverified",60278),verified:(0,n.$1j)("verified",60279),versions:(0,n.$1j)("versions",60280),vmActive:(0,n.$1j)("vm-active",60281),vmOutline:(0,n.$1j)("vm-outline",60282),vmRunning:(0,n.$1j)("vm-running",60283),watch:(0,n.$1j)("watch",60284),whitespace:(0,n.$1j)("whitespace",60285),wholeWord:(0,n.$1j)("whole-word",60286),window:(0,n.$1j)("window",60287),wordWrap:(0,n.$1j)("word-wrap",60288),zoomIn:(0,n.$1j)("zoom-in",60289),zoomOut:(0,n.$1j)("zoom-out",60290),listFilter:(0,n.$1j)("list-filter",60291),listFlat:(0,n.$1j)("list-flat",60292),listSelection:(0,n.$1j)("list-selection",60293),selection:(0,n.$1j)("selection",60293),listTree:(0,n.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$1j)("circle-small-filled",60298),debugStackframeDot:(0,n.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$1j)("symbol-string",60301),debugReverseContinue:(0,n.$1j)("debug-reverse-continue",60302),debugStepBack:(0,n.$1j)("debug-step-back",60303),debugRestartFrame:(0,n.$1j)("debug-restart-frame",60304),debugAlt:(0,n.$1j)("debug-alt",60305),callIncoming:(0,n.$1j)("call-incoming",60306),callOutgoing:(0,n.$1j)("call-outgoing",60307),menu:(0,n.$1j)("menu",60308),expandAll:(0,n.$1j)("expand-all",60309),feedback:(0,n.$1j)("feedback",60310),gitPullRequestReviewer:(0,n.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$1j)("ungroup-by-ref-type",60312),account:(0,n.$1j)("account",60313),gitPullRequestAssignee:(0,n.$1j)("git-pull-request-assignee",60313),bellDot:(0,n.$1j)("bell-dot",60314),debugConsole:(0,n.$1j)("debug-console",60315),library:(0,n.$1j)("library",60316),output:(0,n.$1j)("output",60317),runAll:(0,n.$1j)("run-all",60318),syncIgnored:(0,n.$1j)("sync-ignored",60319),pinned:(0,n.$1j)("pinned",60320),githubInverted:(0,n.$1j)("github-inverted",60321),serverProcess:(0,n.$1j)("server-process",60322),serverEnvironment:(0,n.$1j)("server-environment",60323),pass:(0,n.$1j)("pass",60324),issueClosed:(0,n.$1j)("issue-closed",60324),stopCircle:(0,n.$1j)("stop-circle",60325),playCircle:(0,n.$1j)("play-circle",60326),record:(0,n.$1j)("record",60327),debugAltSmall:(0,n.$1j)("debug-alt-small",60328),vmConnect:(0,n.$1j)("vm-connect",60329),cloud:(0,n.$1j)("cloud",60330),merge:(0,n.$1j)("merge",60331),export:(0,n.$1j)("export",60332),graphLeft:(0,n.$1j)("graph-left",60333),magnet:(0,n.$1j)("magnet",60334),notebook:(0,n.$1j)("notebook",60335),redo:(0,n.$1j)("redo",60336),checkAll:(0,n.$1j)("check-all",60337),pinnedDirty:(0,n.$1j)("pinned-dirty",60338),passFilled:(0,n.$1j)("pass-filled",60339),circleLargeFilled:(0,n.$1j)("circle-large-filled",60340),circleLarge:(0,n.$1j)("circle-large",60341),circleLargeOutline:(0,n.$1j)("circle-large-outline",60341),combine:(0,n.$1j)("combine",60342),gather:(0,n.$1j)("gather",60342),table:(0,n.$1j)("table",60343),variableGroup:(0,n.$1j)("variable-group",60344),typeHierarchy:(0,n.$1j)("type-hierarchy",60345),typeHierarchySub:(0,n.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$1j)("git-pull-request-create",60348),runAbove:(0,n.$1j)("run-above",60349),runBelow:(0,n.$1j)("run-below",60350),notebookTemplate:(0,n.$1j)("notebook-template",60351),debugRerun:(0,n.$1j)("debug-rerun",60352),workspaceTrusted:(0,n.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$1j)("workspace-unknown",60355),terminalCmd:(0,n.$1j)("terminal-cmd",60356),terminalDebian:(0,n.$1j)("terminal-debian",60357),terminalLinux:(0,n.$1j)("terminal-linux",60358),terminalPowershell:(0,n.$1j)("terminal-powershell",60359),terminalTmux:(0,n.$1j)("terminal-tmux",60360),terminalUbuntu:(0,n.$1j)("terminal-ubuntu",60361),terminalBash:(0,n.$1j)("terminal-bash",60362),arrowSwap:(0,n.$1j)("arrow-swap",60363),copy:(0,n.$1j)("copy",60364),personAdd:(0,n.$1j)("person-add",60365),filterFilled:(0,n.$1j)("filter-filled",60366),wand:(0,n.$1j)("wand",60367),debugLineByLine:(0,n.$1j)("debug-line-by-line",60368),inspect:(0,n.$1j)("inspect",60369),layers:(0,n.$1j)("layers",60370),layersDot:(0,n.$1j)("layers-dot",60371),layersActive:(0,n.$1j)("layers-active",60372),compass:(0,n.$1j)("compass",60373),compassDot:(0,n.$1j)("compass-dot",60374),compassActive:(0,n.$1j)("compass-active",60375),azure:(0,n.$1j)("azure",60376),issueDraft:(0,n.$1j)("issue-draft",60377),gitPullRequestClosed:(0,n.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$1j)("git-pull-request-draft",60379),debugAll:(0,n.$1j)("debug-all",60380),debugCoverage:(0,n.$1j)("debug-coverage",60381),runErrors:(0,n.$1j)("run-errors",60382),folderLibrary:(0,n.$1j)("folder-library",60383),debugContinueSmall:(0,n.$1j)("debug-continue-small",60384),beakerStop:(0,n.$1j)("beaker-stop",60385),graphLine:(0,n.$1j)("graph-line",60386),graphScatter:(0,n.$1j)("graph-scatter",60387),pieChart:(0,n.$1j)("pie-chart",60388),bracket:(0,n.$1j)("bracket",60175),bracketDot:(0,n.$1j)("bracket-dot",60389),bracketError:(0,n.$1j)("bracket-error",60390),lockSmall:(0,n.$1j)("lock-small",60391),azureDevops:(0,n.$1j)("azure-devops",60392),verifiedFilled:(0,n.$1j)("verified-filled",60393),newline:(0,n.$1j)("newline",60394),layout:(0,n.$1j)("layout",60395),layoutActivitybarLeft:(0,n.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$1j)("layout-panel-right",60401),layoutPanel:(0,n.$1j)("layout-panel",60402),layoutSidebarLeft:(0,n.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$1j)("layout-statusbar",60405),layoutMenubar:(0,n.$1j)("layout-menubar",60406),layoutCentered:(0,n.$1j)("layout-centered",60407),target:(0,n.$1j)("target",60408),indent:(0,n.$1j)("indent",60409),recordSmall:(0,n.$1j)("record-small",60410),errorSmall:(0,n.$1j)("error-small",60411),terminalDecorationError:(0,n.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$1j)("layout-sidebar-left-off",60418),blank:(0,n.$1j)("blank",60419),heartFilled:(0,n.$1j)("heart-filled",60420),map:(0,n.$1j)("map",60421),mapHorizontal:(0,n.$1j)("map-horizontal",60421),foldHorizontal:(0,n.$1j)("fold-horizontal",60421),mapFilled:(0,n.$1j)("map-filled",60422),mapHorizontalFilled:(0,n.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$1j)("fold-horizontal-filled",60422),circleSmall:(0,n.$1j)("circle-small",60423),bellSlash:(0,n.$1j)("bell-slash",60424),bellSlashDot:(0,n.$1j)("bell-slash-dot",60425),commentUnresolved:(0,n.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$1j)("search-fuzzy",60429),commentDraft:(0,n.$1j)("comment-draft",60430),send:(0,n.$1j)("send",60431),sparkle:(0,n.$1j)("sparkle",60432),insert:(0,n.$1j)("insert",60433),mic:(0,n.$1j)("mic",60434),thumbsdownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$1j)("thumbsup-filled",60436),coffee:(0,n.$1j)("coffee",60437),snake:(0,n.$1j)("snake",60438),game:(0,n.$1j)("game",60439),vr:(0,n.$1j)("vr",60440),chip:(0,n.$1j)("chip",60441),piano:(0,n.$1j)("piano",60442),music:(0,n.$1j)("music",60443),micFilled:(0,n.$1j)("mic-filled",60444),repoFetch:(0,n.$1j)("repo-fetch",60445),copilot:(0,n.$1j)("copilot",60446),lightbulbSparkle:(0,n.$1j)("lightbulb-sparkle",60447),robot:(0,n.$1j)("robot",60448),sparkleFilled:(0,n.$1j)("sparkle-filled",60449),diffSingle:(0,n.$1j)("diff-single",60450),diffMultiple:(0,n.$1j)("diff-multiple",60451),surroundWith:(0,n.$1j)("surround-with",60452),share:(0,n.$1j)("share",60453),gitStash:(0,n.$1j)("git-stash",60454),gitStashApply:(0,n.$1j)("git-stash-apply",60455),gitStashPop:(0,n.$1j)("git-stash-pop",60456),vscode:(0,n.$1j)("vscode",60457),vscodeInsiders:(0,n.$1j)("vscode-insiders",60458),codeOss:(0,n.$1j)("code-oss",60459),runCoverage:(0,n.$1j)("run-coverage",60460),runAllCoverage:(0,n.$1j)("run-all-coverage",60461),coverage:(0,n.$1j)("coverage",60462),githubProject:(0,n.$1j)("github-project",60463),mapVertical:(0,n.$1j)("map-vertical",60464),foldVertical:(0,n.$1j)("fold-vertical",60464),mapVerticalFilled:(0,n.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$1j)("fold-vertical-filled",60465),goToSearch:(0,n.$1j)("go-to-search",60466),percentage:(0,n.$1j)("percentage",60467),sortPercentage:(0,n.$1j)("sort-percentage",60467),attach:(0,n.$1j)("attach",60468)}}),define(oe[80],ae([0,1,110,147]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=k;function k(){return Object.values(e.$6j)}e.$5j={dialogError:(0,n.$1j)("dialog-error","error"),dialogWarning:(0,n.$1j)("dialog-warning","warning"),dialogInfo:(0,n.$1j)("dialog-info","info"),dialogClose:(0,n.$1j)("dialog-close","close"),treeItemExpanded:(0,n.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$1j)("tree-filter-clear","close"),treeItemLoading:(0,n.$1j)("tree-item-loading","loading"),menuSelection:(0,n.$1j)("menu-selection","check"),menuSubmenu:(0,n.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$1j)("toolbar-more","more"),quickInputBack:(0,n.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$1j)("drop-down-button",60084),symbolCustomColor:(0,n.$1j)("symbol-customcolor",60252),exportIcon:(0,n.$1j)("export",60332),workspaceUnspecified:(0,n.$1j)("workspace-unspecified",60355),newLine:(0,n.$1j)("newline",60394),thumbsDownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$1j)("thumbsup-filled",60436),gitFetch:(0,n.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$1j)("debug-breakpoint-pending",60377)},e.$6j={...o.$3j,...e.$5j}}),define(oe[36],ae([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=o,e.$fo=k,e.$go=O,e.$ho=v,e.$io=a,e.$jo=f,e.$ko=d,e.$lo=g,e.$mo=w,e.$no=h,e.$oo=p,e.$po=b,e.$qo=$;function o(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const E=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([P,t])=>{E[P]=t&&typeof t=="object"?o(t):t}),E}function k(m){if(!m||typeof m!="object")return m;const E=[m];for(;E.length>0;){const P=E.shift();Object.freeze(P);for(const t in P)if(D.call(P,t)){const r=P[t];typeof r=="object"&&!Object.isFrozen(r)&&!(0,n.$jg)(r)&&E.push(r)}}return m}const D=Object.prototype.hasOwnProperty;function O(m,E){return I(m,E,new Set)}function I(m,E,P){if((0,n.$pg)(m))return m;const t=E(m);if(typeof t<"u")return t;if(Array.isArray(m)){const r=[];for(const i of m)r.push(I(i,E,P));return r}if((0,n.$ig)(m)){if(P.has(m))throw new Error("Cannot clone recursive data-structure");P.add(m);const r={};for(const i in m)D.call(m,i)&&(r[i]=I(m[i],E,P));return P.delete(m),r}return m}function v(m,E,P=!0){return(0,n.$ig)(m)?((0,n.$ig)(E)&&Object.keys(E).forEach(t=>{t in m?P&&((0,n.$ig)(m[t])&&(0,n.$ig)(E[t])?v(m[t],E[t],P):m[t]=E[t]):m[t]=E[t]}),m):E}function a(m,E){if(m===E)return!0;if(m==null||E===null||E===void 0||typeof m!=typeof E||typeof m!="object"||Array.isArray(m)!==Array.isArray(E))return!1;let P,t;if(Array.isArray(m)){if(m.length!==E.length)return!1;for(P=0;P<m.length;P++)if(!a(m[P],E[P]))return!1}else{const r=[];for(t in m)r.push(t);r.sort();const i=[];for(t in E)i.push(t);if(i.sort(),!a(r,i))return!1;for(P=0;P<r.length;P++)if(!a(m[r[P]],E[r[P]]))return!1}return!0}function f(m){const E=new Set;return JSON.stringify(m,(P,t)=>{if((0,n.$ig)(t)||Array.isArray(t)){if(E.has(t))return"[Circular]";E.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function d(m,E){const P=Object.create(null);return!m||!E||Object.keys(E).forEach(r=>{const i=m[r],c=E[r];a(i,c)||(P[r]=c)}),P}function g(m,E){const P=E.toLowerCase(),t=Object.keys(m).find(r=>r.toLowerCase()===P);return t?m[t]:m[E]}function w(m,E){const P=Object.create(null);for(const[t,r]of Object.entries(m))E(t,r)&&(P[t]=r);return P}function h(m){let E=[];for(;Object.prototype!==m;)E=E.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return E}function p(m){const E=[];for(const P of h(m))typeof m[P]=="function"&&E.push(P);return E}function b(m,E){const P=r=>function(){const i=Array.prototype.slice.call(arguments,0);return E(r,i)},t={};for(const r of m)t[r]=P(r);return t}function $(m,E){const P={};for(const[t,r]of Object.entries(m))P[t]=E(r,t);return P}}),define(oe[111],ae([0,1,80]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=k;var o;(function(O){function I(v){return v&&typeof v=="object"&&typeof v.id=="string"}O.isThemeColor=I})(o||(e.ThemeColor=o={}));function k(O){return{id:O}}var D;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function v(m){const E=I.exec(m.id);if(!E)return v(n.$6j.error);const[,P,t]=E,r=["codicon","codicon-"+P];return t&&r.push("codicon-modifier-"+t.substring(1)),r}O.asClassNameArray=v;function a(m){return v(m).join(" ")}O.asClassName=a;function f(m){return"."+v(m).join(".")}O.asCSSSelector=f;function d(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||o.isThemeColor(m.color))}O.isThemeIcon=d;const g=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function w(m){const E=g.exec(m);if(!E)return;const[,P]=E;return{id:P}}O.fromString=w;function h(m){return{id:m}}O.fromId=h;function p(m,E){let P=m.id;const t=P.lastIndexOf("~");return t!==-1&&(P=P.substring(0,t)),E&&(P=`${P}~${E}`),{id:P}}O.modify=p;function b(m){const E=m.id.lastIndexOf("~");if(E!==-1)return m.id.substring(E+1)}O.getModifier=b;function $(m,E){return m.id===E.id&&m.color?.id===E.color?.id}O.isEqual=$})(D||(e.ThemeIcon=D={}))}),define(oe[148],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=o,e.$df=k;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function o(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function k(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(oe[26],ae([0,1,145,39,66,148]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=O,e.$ff=v,e.$gf=f,e.$hf=d,e.$if=g,e.$jf=w,e.$kf=h,e.$lf=p,e.$mf=b,e.$nf=$,e.$of=m,e.$pf=E,e.$qf=P,e.$rf=t,e.$sf=r,e.$tf=i,e.$uf=c,e.$vf=s,e.$wf=l,e.$xf=u,e.$yf=S,e.$zf=y,e.$Af=R,e.$Bf=L,e.$Cf=T,e.$Df=A,e.$Ef=M,e.$Ff=U,e.$Gf=C,e.$Hf=z,e.$If=re,e.$Jf=Z,e.$Kf=le,e.$Lf=X,e.$Mf=ee,e.$Nf=q,e.$Of=j,e.$Rf=K,e.$Sf=he,e.$Tf=se,e.$Uf=_,e.$Vf=W,e.$Wf=J,e.$Yf=Y,e.$Zf=V,e.$1f=ie,e.$2f=de,e.$3f=we,e.$4f=Oe,e.$5f=Pe,e.$7f=Ie,e.$8f=$e,e.$9f=Q,e.$0f=ue,e.$$f=fe,e.$_f=be,e.$ag=Re,e.$bg=We,e.$cg=Qe;function O(te){return!te||typeof te!="string"?!0:te.trim().length===0}const I=/{(\d+)}/g;function v(te,...ge){return ge.length===0?te:te.replace(I,function(pe,ye){const Me=parseInt(ye,10);return isNaN(Me)||Me<0||Me>=ge.length?pe:ge[Me]})}const a=/{([^}]+)}/g;function f(te,ge){return Object.keys(ge).length===0?te:te.replace(a,(pe,ye)=>ge[ye]??pe)}function d(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(te,ge){let pe=0,ye=te.indexOf(ge);for(;ye!==-1;)pe++,ye=te.indexOf(ge,ye+ge.length);return pe}function p(te,ge,pe="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${pe}`}function b(te,ge,pe="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-pe.length/2,Me=Math.floor(ge/2)-pe.length/2;return`${te.substr(0,ye)}${pe}${te.substr(te.length-Me)}`}function $(te,ge=" "){const pe=m(te,ge);return E(pe,ge)}function m(te,ge){if(!te||!ge)return te;const pe=ge.length;if(pe===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+pe;return te.substring(ye)}function E(te,ge){if(!te||!ge)return te;const pe=ge.length,ye=te.length;if(pe===0||ye===0)return te;let Me=ye,Ue=-1;for(;Ue=te.lastIndexOf(ge,Me-1),!(Ue===-1||Ue+pe!==Me);){if(Ue===0)return"";Me=Ue}return te.substring(0,Me)}function P(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(te){return te.replace(/\*/g,"")}function r(te,ge,pe={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=w(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(te,ye)}function i(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function c(te){return te.split(/\r\n|\r|\n/)}function s(te){const ge=[],pe=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function l(te){for(let ge=0,pe=te.length;ge<pe;ge++){const ye=te.charCodeAt(ge);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ge}return-1}function u(te,ge=0,pe=te.length){for(let ye=ge;ye<pe;ye++){const Me=te.charCodeAt(ye);if(Me!==o.CharCode.Space&&Me!==o.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,pe)}function S(te,ge=te.length-1){for(let pe=ge;pe>=0;pe--){const ye=te.charCodeAt(pe);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return pe}return-1}function y(te,ge,pe){const ye=[];let Me=0;for(const Ue of te.matchAll(ge)){if(ye.push(te.slice(Me,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Me=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,te,Ue.groups))}return ye.push(te.slice(Me)),Promise.all(ye).then(Ue=>Ue.join(""))}function R(te,ge){return te<ge?-1:te>ge?1:0}function L(te,ge,pe=0,ye=te.length,Me=0,Ue=ge.length){for(;pe<ye&&Me<Ue;pe++,Me++){const at=te.charCodeAt(pe),rt=ge.charCodeAt(Me);if(at<rt)return-1;if(at>rt)return 1}const Je=ye-pe,lt=Ue-Me;return Je<lt?-1:Je>lt?1:0}function T(te,ge){return A(te,ge,0,te.length,0,ge.length)}function A(te,ge,pe=0,ye=te.length,Me=0,Ue=ge.length){for(;pe<ye&&Me<Ue;pe++,Me++){let at=te.charCodeAt(pe),rt=ge.charCodeAt(Me);if(at===rt)continue;if(at>=128||rt>=128)return L(te.toLowerCase(),ge.toLowerCase(),pe,ye,Me,Ue);U(at)&&(at-=32),U(rt)&&(rt-=32);const tt=at-rt;if(tt!==0)return tt}const Je=ye-pe,lt=Ue-Me;return Je<lt?-1:Je>lt?1:0}function M(te){return te>=o.CharCode.Digit0&&te<=o.CharCode.Digit9}function U(te){return te>=o.CharCode.a&&te<=o.CharCode.z}function C(te){return te>=o.CharCode.A&&te<=o.CharCode.Z}function z(te,ge){return te.length===ge.length&&A(te,ge)===0}function re(te,ge){const pe=ge.length;return ge.length>te.length?!1:A(te,ge,0,pe)===0}function Z(te,ge){const pe=Math.min(te.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function le(te,ge){const pe=Math.min(te.length,ge.length);let ye;const Me=te.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(te.charCodeAt(Me-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function X(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function q(te,ge){return(te-55296<<10)+(ge-56320)+65536}function j(te,ge,pe){const ye=te.charCodeAt(pe);if(X(ye)&&pe+1<ge){const Me=te.charCodeAt(pe+1);if(ee(Me))return q(ye,Me)}return ye}function B(te,ge){const pe=te.charCodeAt(ge-1);if(ee(pe)&&ge>1){const ye=te.charCodeAt(ge-2);if(X(ye))return q(ye,pe)}return pe}class G{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=B(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Pf=G;class ce{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new G(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,Je=ge.getGraphemeBreakType(pe.nextCodePoint());if(Fe(Me,Je)){pe.setOffset(Ue);break}Me=Je}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,Je=ge.getGraphemeBreakType(pe.prevCodePoint());if(Fe(Je,Me)){pe.setOffset(Ue);break}Me=Je}return ye-pe.offset}eol(){return this.c.eol()}}e.$Qf=ce;function K(te,ge){return new ce(te,ge).nextGraphemeLength()}function he(te,ge){return new ce(te,ge).prevGraphemeLength()}function se(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const pe=ge+K(te,ge);return[pe-he(te,pe),pe]}function _(te){const ge=new ce(te);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let F;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return F||(F=N()),F.test(te)}const H=/^[\t\n\r\x20-\x7E]*$/;function J(te){return H.test(te)}e.$Xf=/[\u2028\u2029]/;function Y(te){return e.$Xf.test(te)}function V(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function de(te,ge,pe=""){const ye=te.trimStart();if(ye.length<ge)return ye;const Me=/\b/g;let Ue=0;for(;Me.test(ye)&&!(ye.length-Me.lastIndex<ge);)Ue=Me.lastIndex,Me.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(te){let ge=0;for(const pe of te.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:te.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Oe(te){return te&&(te=te.replace(me,"")),te}const Se=/\\\[.*?\\\]/g;function Pe(te){return Oe(te).replace(Se,"")}e.$6f=String.fromCharCode(o.CharCode.UTF8_BOM);function Ie(te){return!!(te&&te.length>0&&te.charCodeAt(0)===o.CharCode.UTF8_BOM)}function $e(te){return Ie(te)?te.substr(1):te}function Q(te,ge){if(!te||!ge||te.length<ge.length)return!1;const pe=ge.length,ye=te.toLowerCase();let Me=0,Ue=-1;for(;Me<pe;){const Je=ye.indexOf(ge[Me],Ue+1);if(Je<0)return!1;Ue=Je,Me++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function be(te,ge=1){if(ge===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Re(te){const ge=o.CharCode.Z-o.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(o.CharCode.a+te):String.fromCharCode(o.CharCode.A+te-ge)}function We(te){return Be.getInstance().getGraphemeBreakType(te)}function Fe(te,ge){return te===Te.Other?ge!==Te.Extend&&ge!==Te.SpacingMark:te===Te.CR&&ge===Te.LF?!1:te===Te.Control||te===Te.CR||te===Te.LF||ge===Te.Control||ge===Te.CR||ge===Te.LF?!0:!(te===Te.L&&(ge===Te.L||ge===Te.V||ge===Te.LV||ge===Te.LVT)||(te===Te.LV||te===Te.V)&&(ge===Te.V||ge===Te.T)||(te===Te.LVT||te===Te.T)&&ge===Te.T||ge===Te.Extend||ge===Te.ZWJ||ge===Te.SpacingMark||te===Te.Prepend||te===Te.ZWJ&&ge===Te.Extended_Pictographic||te===Te.Regional_Indicator&&ge===Te.Regional_Indicator)}var Te;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===o.CharCode.LineFeed?Te.LF:ge===o.CharCode.CarriageReturn?Te.CR:Te.Control;if(ge<127)return Te.Other;const pe=this.d,ye=pe.length/3;let Me=1;for(;Me<=ye;)if(ge<pe[3*Me])Me=2*Me;else if(ge>pe[3*Me+1])Me=2*Me+1;else return pe[3*Me+2];return Te.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(te,ge){if(te===0)return 0;const pe=He(te,ge);if(pe!==void 0)return pe;const ye=new G(ge,te);return ye.prevCodePoint(),ye.offset}function He(te,ge){const pe=new G(ge,te);let ye=pe.prevCodePoint();for(;Xe(ye)||ye===Ye.emojiVariantSelector||ye===Ye.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ie(ye))return;let Me=pe.offset;return Me>0&&pe.prevCodePoint()===Ye.zwj&&(Me=pe.offset),Me}function Xe(te){return 127995<=te&&te<=127999}var Ye;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$dg="\xA0";class _e{static{this.c=new k.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$af({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let Je=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);Je.length===0&&(Je=["_default"]);let lt;for(const tt of Je){const ut=pe(Ue[tt]);lt=Me(lt,ut)}const at=pe(Ue._common),rt=ye(at,lt);return new _e(rt)})}static getInstance(ge){return _e.d.get(Array.from(ge))}static{this.e=new k.$X(()=>Object.keys(_e.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return _e.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=_e;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$fg=Ne}),define(oe[46],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=o,e.$vj=k,e.$wj=D,e.$xj=I,e.$zj=p,n=De(n);function o($){return k($,0)}function k($,m){switch(typeof $){case"object":return $===null?D(349,m):Array.isArray($)?v($,m):a($,m);case"string":return I($,m);case"boolean":return O($,m);case"number":return D($,m);case"undefined":return D(937,m);default:return D(617,m)}}function D($,m){return(m<<5)-m+$|0}function O($,m){return D($?433:863,m)}function I($,m){m=D(149417,m);for(let E=0,P=$.length;E<P;E++)m=D($.charCodeAt(E),m);return m}function v($,m){return m=D(104579,m),$.reduce((E,P)=>k(P,E),m)}function a($,m){return m=D(181387,m),Object.keys($).sort().reduce((E,P)=>(E=I(P,E),k($[P],E)),m)}class f{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=k(m,this.g),this.g}}e.$yj=f;var d;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function g($,m,E=32){const P=E-m,t=~((1<<P)-1);return($<<m|(t&$)>>>P)>>>0}function w($,m=0,E=$.byteLength,P=0){for(let t=0;t<E;t++)$[m+t]=P}function h($,m,E="0"){for(;$.length<m;)$=E+$;return $}function p($,m=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(E=>E.toString(16).padStart(2,"0")).join(""):h(($>>>0).toString(16),m/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const E=m.length;if(E===0)return;const P=this.p;let t=this.r,r=this.u,i,c;for(r!==0?(i=r,c=-1,r=0):(i=m.charCodeAt(0),c=0);;){let s=i;if(n.$Lf(i))if(c+1<E){const l=m.charCodeAt(c+1);n.$Mf(l)?(c++,s=n.$Nf(i,l)):s=d.UNICODE_REPLACEMENT}else{r=i;break}else n.$Mf(i)&&(s=d.UNICODE_REPLACEMENT);if(t=this.w(P,t,s),c++,c<E)i=m.charCodeAt(c);else break}this.r=t,this.u=r}w(m,E,P){return P<128?m[E++]=P:P<2048?(m[E++]=192|(P&1984)>>>6,m[E++]=128|(P&63)>>>0):P<65536?(m[E++]=224|(P&61440)>>>12,m[E++]=128|(P&4032)>>>6,m[E++]=128|(P&63)>>>0):(m[E++]=240|(P&1835008)>>>18,m[E++]=128|(P&258048)>>>12,m[E++]=128|(P&4032)>>>6,m[E++]=128|(P&63)>>>0),E>=d.BLOCK_SIZE&&(this.y(),E-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,m[0]=m[d.BLOCK_SIZE+0],m[1]=m[d.BLOCK_SIZE+1],m[2]=m[d.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=b.g,E=this.q;for(let S=0;S<64;S+=4)m.setUint32(S,E.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)m.setUint32(S,g(m.getUint32(S-12,!1)^m.getUint32(S-32,!1)^m.getUint32(S-56,!1)^m.getUint32(S-64,!1),1),!1);let P=this.h,t=this.l,r=this.m,i=this.n,c=this.o,s,l,u;for(let S=0;S<80;S++)S<20?(s=t&r|~t&i,l=1518500249):S<40?(s=t^r^i,l=1859775393):S<60?(s=t&r|t&i|r&i,l=2400959708):(s=t^r^i,l=3395469782),u=g(P,5)+s+c+l+m.getUint32(S*4,!1)&4294967295,c=i,i=r,r=g(t,30),t=P,P=u;this.h=this.h+P&4294967295,this.l=this.l+t&4294967295,this.m=this.m+r&4294967295,this.n=this.n+i&4294967295,this.o=this.o+c&4294967295}}e.$Aj=b}),define(oe[81],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=De(n);var o;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(o||(o={})),function(k){const D="error",O="warning",I="warn",v="info",a="ignore";function f(g){return g?n.$Hf(D,g)?k.Error:n.$Hf(O,g)||n.$Hf(I,g)?k.Warning:n.$Hf(v,g)?k.Info:k.Ignore:k.Ignore}k.fromValue=f;function d(g){switch(g){case k.Error:return D;case k.Warning:return O;case k.Info:return v;default:return a}}k.toString=d}(o||(o={})),e.default=o}),define(oe[61],ae([0,1,22,39,26]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class D{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const p=h.charCodeAt(0),b=this.b.charCodeAt(this.c);return p-b}value(){return this.b[this.c]}}e.$Ii=D;class O{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===o.CharCode.Period)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,k.$Bf)(h,this.b,0,h.length,this.c,this.d):(0,k.$Df)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=O;class I{constructor(h=!0,p=!0){this.f=h,this.g=p}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let p=h.length-1;p>=0;p--,this.c--){const b=this.b.charCodeAt(p);if(!(b===o.CharCode.Slash||this.f&&b===o.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===o.CharCode.Slash||this.f&&p===o.CharCode.Backslash)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,k.$Bf)(h,this.b,0,h.length,this.d,this.e):(0,k.$Df)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=I;var v;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(v||(v={}));class a{constructor(h,p){this.f=h,this.g=p,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(v.Path)),this.g(h)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===v.Scheme)return(0,k.$Cf)(h,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,k.$Cf)(h,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(h);if(this.d[this.e]===v.Query)return(0,k.$Af)(h,this.c.query);if(this.d[this.e]===v.Fragment)return(0,k.$Af)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Li=a;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(d||(d={}));class g{static forUris(h=()=>!1,p=()=>!1){return new g(new a(h,p))}static forPaths(h=!1){return new g(new I(void 0,!h))}static forStrings(){return new g(new D)}static forConfigKeys(){return new g(new O)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,p){if(p){const b=p.slice(0);(0,n.$Zb)(b);for(const $ of b)this.set($,h)}else{const b=h.slice(0);(0,n.$Zb)(b);for(const $ of b)this.set($[0],$[1])}}set(h,p){const b=this.b.reset(h);let $;this.c||(this.c=new f,this.c.segment=b.value());const m=[];for($=this.c;;){const P=b.cmp($.segment);if(P>0)$.left||($.left=new f,$.left.segment=b.value()),m.push([d.Left,$]),$=$.left;else if(P<0)$.right||($.right=new f,$.right.segment=b.value()),m.push([d.Right,$]),$=$.right;else if(b.hasNext())b.next(),$.mid||($.mid=new f,$.mid.segment=b.value()),m.push([d.Mid,$]),$=$.mid;else break}const E=$.value;$.value=p,$.key=h;for(let P=m.length-1;P>=0;P--){const t=m[P][1];t.updateHeight();const r=t.balanceFactor();if(r<-1||r>1){const i=m[P][0],c=m[P+1][0];if(i===d.Right&&c===d.Right)m[P][1]=t.rotateLeft();else if(i===d.Left&&c===d.Left)m[P][1]=t.rotateRight();else if(i===d.Right&&c===d.Left)t.right=m[P+1][1]=m[P+1][1].rotateRight(),m[P][1]=t.rotateLeft();else if(i===d.Left&&c===d.Right)t.left=m[P+1][1]=m[P+1][1].rotateLeft(),m[P][1]=t.rotateRight();else throw new Error;if(P>0)switch(m[P-1][0]){case d.Left:m[P-1][1].left=m[P][1];break;case d.Right:m[P-1][1].right=m[P][1];break;case d.Mid:m[P-1][1].mid=m[P][1];break}else this.c=m[0][1]}}return E}get(h){return this.d(h)?.value}d(h){const p=this.b.reset(h);let b=this.c;for(;b;){const $=p.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(h){const p=this.d(h);return!(p?.value===void 0&&p?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,p){const b=this.b.reset(h),$=[];let m=this.c;for(;m;){const E=b.cmp(m.segment);if(E>0)$.push([d.Left,m]),m=m.left;else if(E<0)$.push([d.Right,m]),m=m.right;else if(b.hasNext())b.next(),$.push([d.Mid,m]),m=m.mid;else break}if(m){if(p?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const E=this.f(m.right);if(E.key){const{key:P,value:t,segment:r}=E;this.e(E.key,!1),m.key=P,m.value=t,m.segment=r}}else{const E=m.left??m.right;if($.length>0){const[P,t]=$[$.length-1];switch(P){case d.Left:t.left=E;break;case d.Mid:t.mid=E;break;case d.Right:t.right=E;break}}else this.c=E}for(let E=$.length-1;E>=0;E--){const P=$[E][1];P.updateHeight();const t=P.balanceFactor();if(t>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),$[E][1]=P.rotateLeft()):t<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),$[E][1]=P.rotateRight()),E>0)switch($[E-1][0]){case d.Left:$[E-1][1].left=$[E][1];break;case d.Right:$[E-1][1].right=$[E][1];break;case d.Mid:$[E-1][1].mid=$[E][1];break}else this.c=$[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const p=this.b.reset(h);let b=this.c,$;for(;b;){const m=p.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(p.hasNext())p.next(),$=b.value||$,b=b.mid;else break}return b&&b.value||$}findSuperstr(h){return this.g(h,!1)}g(h,p){const b=this.b.reset(h);let $=this.c;for(;$;){const m=b.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(b.hasNext())b.next(),$=$.mid;else return $.mid?this.h($.mid):p?$.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[p,b]of this)h(b,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const p=[];return this.j(h,p),p[Symbol.iterator]()}j(h,p){h&&(h.left&&this.j(h.left,p),h.value&&p.push([h.key,h.value]),h.mid&&this.j(h.mid,p),h.right&&this.j(h.right,p))}_isBalanced(){const h=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:h(p.left)&&h(p.right)};return h(this.c)}}e.$Mi=g}),define(oe[33],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=o;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(k){return n.test(k)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let v=0;v<I.length;v++)I[v]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let v=0,a="";return a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a+="-",a+=O[D[v++]],a+=O[D[v++]],a+="-",a+=O[D[v++]],a+=O[D[v++]],a+="-",a+=O[D[v++]],a+=O[D[v++]],a+="-",a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a+=O[D[v++]],a}}()}),define(oe[149],ae([0,1,92,47,90]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yX=D,n=De(n),o=De(o);async function D(O,I){if(await new Promise((f,d)=>{const g=o.createReadStream(O),w=n.createHash("sha256");g.pipe(w);const h=(0,k.$gb)((p,b)=>{g.removeAllListeners(),w.removeAllListeners(),p?d(p):f(b)});g.once("error",h),g.once("end",h),w.once("error",h),w.once("data",p=>h(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(oe[150],ae([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=D;const o=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(O){const I=O.replace(/\-/g,":").toLowerCase();return!o.has(I)}function D(){const O=(0,n.networkInterfaces)();for(const I in O){const v=O[I];if(v){for(const{mac:a}of v)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[112],ae([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=o,e.$7g=D,n=De(n);function o(I,v,a,f=1){let d=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!d)return d=!0,g(0)},a);k(I,v,f,h=>{if(!d)return d=!0,clearTimeout(w),g(h)})})}function k(I,v,a,f){if(v===0)return f(0);const d=new n.Socket;d.once("connect",()=>(O(d),k(I+a,v-1,a,f))),d.once("data",()=>{}),d.once("error",g=>(O(d),g.code!=="ECONNREFUSED"?k(I+a,v-1,a,f):f(I))),d.connect(I,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,v,a,f="127.0.0.1"){let d=!1,g,w=1;const h=n.createServer({pauseOnConnect:!0});function p(b,$){d||(d=!0,h.removeAllListeners(),h.close(),g&&clearTimeout(g),$(b))}return new Promise(b=>{g=setTimeout(()=>{p(0,b)},a),h.on("listening",()=>{p(I,b)}),h.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<v?(I++,w++,h.listen(I,f)):p(0,b)}),h.on("close",()=>{p(0,b)}),h.listen(I,f)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(v){console.error(v)}}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(v){const a=new Set;if(Array.isArray(v))for(const f of v)typeof f=="string"&&a.add(f);return Array.from(a)}function o(){const v=e();return v?Array.from(v):[]}function k(v){if(process.platform!=="win32")return;const a=e();if(a)if(typeof v=="string")a.add(v.toLowerCase());else for(const f of n(v))k(f)}function D(v){if(typeof v!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let f;for(const d of a){if(v.indexOf(d)!==0)continue;const w=v.indexOf("\\",d.length);if(w===-1)continue;const h=v.substring(d.length,w);if(h){f=h;break}}return f}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:o,addUNCHostToAllowlist:k,getUNCHost:D,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[151],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EX=e.$DX=void 0,e.$DX="vscode:contextmenu",e.$EX="vscode:onCloseContextMenu"}),define(oe[152],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LX=void 0;class n{constructor(k,D){this.a=k,this.onMessage=D}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$LX=n}),define(oe[153],ae([11,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(oe[154],ae([0,1,153]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=a,e.$3m=f,e.$4m=d;const o=60,k=o*60,D=k*24,O=D*7,I=D*30,v=D*365;function a(g,w,h,p){typeof g!="number"&&(g=g.getTime());const b=Math.round((new Date().getTime()-g)/1e3);if(b<-30)return(0,n.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,n.localize)(1,null);let $;return b<o?($=b,w?$===1?h?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):h?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?h?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):h?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):b<k?($=Math.floor(b/o),w?$===1?h?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):h?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?h?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):h?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):b<D?($=Math.floor(b/k),w?$===1?h?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):h?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?h?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):h?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):b<O?($=Math.floor(b/D),w?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):b<I?($=Math.floor(b/O),w?$===1?h?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):h?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?h?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):h?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):b<v?($=Math.floor(b/I),w?$===1?h?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):h?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?h?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):h?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(b/v),w?$===1?h?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):h?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?h?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):h?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function f(g,w){const h=Math.abs(g/1e3);return h<1?w?(0,n.localize)(54,null,g):(0,n.localize)(55,null,g):h<o?w?(0,n.localize)(56,null,Math.round(g)/1e3):(0,n.localize)(57,null,Math.round(g)/1e3):h<k?w?(0,n.localize)(58,null,Math.round(g/(1e3*o))):(0,n.localize)(59,null,Math.round(g/(1e3*o))):h<D?w?(0,n.localize)(60,null,Math.round(g/(1e3*k))):(0,n.localize)(61,null,Math.round(g/(1e3*k))):(0,n.localize)(62,null,Math.round(g/(1e3*D)))}function d(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[155],ae([11,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(oe[55],ae([0,1,22,13,155]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=v,e.$sj=a,e.$tj=f,n=De(n),o=De(o),k=De(k);function D(d,g){return g&&(d.stack||d.stacktrace)?k.localize(0,null,I(d),O(d.stack)||O(d.stacktrace)):I(d)}function O(d){return Array.isArray(d)?d.join(`
`):d}function I(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?k.localize(1,null,d.message):d.message||k.localize(2,null)}function v(d=null,g=!1){if(!d)return k.localize(3,null);if(Array.isArray(d)){const w=n.$Kb(d),h=v(w[0],g);return w.length>1?k.localize(4,null,h,w.length):h}if(o.$gg(d))return d;if(d.detail){const w=d.detail;if(w.error)return D(w.error,g);if(w.exception)return D(w.exception,g)}return d.stack?D(d,g):d.message?d.message:k.localize(5,null)}function a(d){const g=d;return g instanceof Error&&Array.isArray(g.actions)}function f(d,g){let w;return typeof d=="string"?w=new Error(d):w=d,w.actions=g,w}}),define(oe[156],ae([11,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(oe[157],ae([0,1,156,43]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=k;function k(D){switch(D){case o.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case o.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case o.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case o.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case o.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case o.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case o.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case o.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case o.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(oe[158],ae([11,9]),function(x,e){return x.create("vs/base/common/platform",e)}),define(oe[3],ae([0,1,158]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=y,e.$J=R,n=De(n),e.$g="en";let o=!1,k=!1,D=!1,O=!1,I=!1,v=!1,a=!1,f=!1,d=!1,g=!1,w,h=e.$g,p=e.$g,b,$;const m=globalThis;let E;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?E=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const P=typeof E?.versions?.electron=="string",t=P&&E?.type==="renderer";if(typeof E=="object"){o=E.platform==="win32",k=E.platform==="darwin",D=E.platform==="linux",O=D&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,a=P,d=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,h=e.$g;const L=E.env.VSCODE_NLS_CONFIG;if(L)try{const T=JSON.parse(L),A=T.availableLanguages["*"];w=T.locale,p=T.osLocale,h=A||e.$g,b=T._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,o=$.indexOf("Windows")>=0,k=$.indexOf("Macintosh")>=0,f=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=$.indexOf("Linux")>=0,g=$?.indexOf("Mobi")>=0,v=!0,w=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,h=w,p=navigator.language):console.error("Unable to resolve platform.");var r;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(r||(e.Platform=r={}));function i(L){switch(L){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let c=r.Web;k?c=r.Mac:o?c=r.Windows:D&&(c=r.Linux),e.$i=o,e.$j=k,e.$k=D,e.$l=O,e.$m=I,e.$n=a,e.$o=v,e.$p=v&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=f,e.$s=g,e.$t=d,e.$u=c,e.$v=$,e.$w=h;var s;(function(L){function T(){return e.$w}L.value=T;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=A;function M(){return e.$w==="en"}L.isDefault=M})(s||(e.Language=s={})),e.$x=w,e.$y=p,e.$z=b,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const L=[];m.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let M=0,U=L.length;M<U;M++){const C=L[M];if(C.id===A.data.vscodeScheduleAsyncWork){L.splice(M,1),C.callback();return}}});let T=0;return A=>{const M=++T;L.push({id:M,callback:A}),m.postMessage({vscodeScheduleAsyncWork:M},"*")}}return L=>setTimeout(L)})();var l;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=k||f?l.Macintosh:o?l.Windows:l.Linux;let u=!0,S=!1;function y(){if(!S){S=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,u=new Uint16Array(L.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(L){return parseFloat(L)>=20}}),define(oe[37],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let o;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const D=k.process;o={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?o={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:o={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=o.cwd,e.env=o.env,e.$gc=o.platform,e.$hc=o.arch}),define(oe[10],ae([0,1,37]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,n=De(n);const o=65,k=97,D=90,O=122,I=46,v=47,a=92,f=58,d=63;class g extends Error{constructor(i,c,s){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const u=i.indexOf(".")!==-1?"property":"argument";let S=`The "${i}" ${u} ${l} of type ${c}`;S+=`. Received type ${typeof s}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function w(r,i){if(r===null||typeof r!="object")throw new g(i,"Object",r)}function h(r,i){if(typeof r!="string")throw new g(i,"string",r)}const p=n.$gc==="win32";function b(r){return r===v||r===a}function $(r){return r===v}function m(r){return r>=o&&r<=D||r>=k&&r<=O}function E(r,i,c,s){let l="",u=0,S=-1,y=0,R=0;for(let L=0;L<=r.length;++L){if(L<r.length)R=r.charCodeAt(L);else{if(s(R))break;R=v}if(s(R)){if(!(S===L-1||y===1))if(y===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const T=l.lastIndexOf(c);T===-1?(l="",u=0):(l=l.slice(0,T),u=l.length-1-l.lastIndexOf(c)),S=L,y=0;continue}else if(l.length!==0){l="",u=0,S=L,y=0;continue}}i&&(l+=l.length>0?`${c}..`:"..",u=2)}else l.length>0?l+=`${c}${r.slice(S+1,L)}`:l=r.slice(S+1,L),u=L-S-1;S=L,y=0}else R===I&&y!==-1?++y:y=-1}return l}function P(r,i){w(i,"pathObject");const c=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${s}`:`${c}${r}${s}`:s}e.$ic={resolve(...r){let i="",c="",s=!1;for(let l=r.length-1;l>=-1;l--){let u;if(l>=0){if(u=r[l],h(u,"path"),u.length===0)continue}else i.length===0?u=n.cwd():(u=n.env[`=${i}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===a)&&(u=`${i}\\`));const S=u.length;let y=0,R="",L=!1;const T=u.charCodeAt(0);if(S===1)b(T)&&(y=1,L=!0);else if(b(T))if(L=!0,b(u.charCodeAt(1))){let A=2,M=A;for(;A<S&&!b(u.charCodeAt(A));)A++;if(A<S&&A!==M){const U=u.slice(M,A);for(M=A;A<S&&b(u.charCodeAt(A));)A++;if(A<S&&A!==M){for(M=A;A<S&&!b(u.charCodeAt(A));)A++;(A===S||A!==M)&&(R=`\\\\${U}\\${u.slice(M,A)}`,y=A)}}}else y=1;else m(T)&&u.charCodeAt(1)===f&&(R=u.slice(0,2),y=2,S>2&&b(u.charCodeAt(2))&&(L=!0,y=3));if(R.length>0)if(i.length>0){if(R.toLowerCase()!==i.toLowerCase())continue}else i=R;if(s){if(i.length>0)break}else if(c=`${u.slice(y)}\\${c}`,s=L,L&&i.length>0)break}return c=E(c,!s,"\\",b),s?`${i}\\${c}`:`${i}${c}`||"."},normalize(r){h(r,"path");const i=r.length;if(i===0)return".";let c=0,s,l=!1;const u=r.charCodeAt(0);if(i===1)return $(u)?"\\":r;if(b(u))if(l=!0,b(r.charCodeAt(1))){let y=2,R=y;for(;y<i&&!b(r.charCodeAt(y));)y++;if(y<i&&y!==R){const L=r.slice(R,y);for(R=y;y<i&&b(r.charCodeAt(y));)y++;if(y<i&&y!==R){for(R=y;y<i&&!b(r.charCodeAt(y));)y++;if(y===i)return`\\\\${L}\\${r.slice(R)}\\`;y!==R&&(s=`\\\\${L}\\${r.slice(R,y)}`,c=y)}}}else c=1;else m(u)&&r.charCodeAt(1)===f&&(s=r.slice(0,2),c=2,i>2&&b(r.charCodeAt(2))&&(l=!0,c=3));let S=c<i?E(r.slice(c),!l,"\\",b):"";return S.length===0&&!l&&(S="."),S.length>0&&b(r.charCodeAt(i-1))&&(S+="\\"),s===void 0?l?`\\${S}`:S:l?`${s}\\${S}`:`${s}${S}`},isAbsolute(r){h(r,"path");const i=r.length;if(i===0)return!1;const c=r.charCodeAt(0);return b(c)||i>2&&m(c)&&r.charCodeAt(1)===f&&b(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,c;for(let u=0;u<r.length;++u){const S=r[u];h(S,"path"),S.length>0&&(i===void 0?i=c=S:i+=`\\${S}`)}if(i===void 0)return".";let s=!0,l=0;if(typeof c=="string"&&b(c.charCodeAt(0))){++l;const u=c.length;u>1&&b(c.charCodeAt(1))&&(++l,u>2&&(b(c.charCodeAt(2))?++l:s=!1))}if(s){for(;l<i.length&&b(i.charCodeAt(l));)l++;l>=2&&(i=`\\${i.slice(l)}`)}return e.$ic.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i)return"";const c=e.$ic.resolve(r),s=e.$ic.resolve(i);if(c===s||(r=c.toLowerCase(),i=s.toLowerCase(),r===i))return"";let l=0;for(;l<r.length&&r.charCodeAt(l)===a;)l++;let u=r.length;for(;u-1>l&&r.charCodeAt(u-1)===a;)u--;const S=u-l;let y=0;for(;y<i.length&&i.charCodeAt(y)===a;)y++;let R=i.length;for(;R-1>y&&i.charCodeAt(R-1)===a;)R--;const L=R-y,T=S<L?S:L;let A=-1,M=0;for(;M<T;M++){const C=r.charCodeAt(l+M);if(C!==i.charCodeAt(y+M))break;C===a&&(A=M)}if(M!==T){if(A===-1)return s}else{if(L>T){if(i.charCodeAt(y+M)===a)return s.slice(y+M+1);if(M===2)return s.slice(y+M)}S>T&&(r.charCodeAt(l+M)===a?A=M:M===2&&(A=3)),A===-1&&(A=0)}let U="";for(M=l+A+1;M<=u;++M)(M===u||r.charCodeAt(M)===a)&&(U+=U.length===0?"..":"\\..");return y+=A,U.length>0?`${U}${s.slice(y,R)}`:(s.charCodeAt(y)===a&&++y,s.slice(y,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const i=e.$ic.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===a){if(i.charCodeAt(1)===a){const c=i.charCodeAt(2);if(c!==d&&c!==I)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===f&&i.charCodeAt(2)===a)return`\\\\?\\${i}`;return r},dirname(r){h(r,"path");const i=r.length;if(i===0)return".";let c=-1,s=0;const l=r.charCodeAt(0);if(i===1)return b(l)?r:".";if(b(l)){if(c=s=1,b(r.charCodeAt(1))){let y=2,R=y;for(;y<i&&!b(r.charCodeAt(y));)y++;if(y<i&&y!==R){for(R=y;y<i&&b(r.charCodeAt(y));)y++;if(y<i&&y!==R){for(R=y;y<i&&!b(r.charCodeAt(y));)y++;if(y===i)return r;y!==R&&(c=s=y+1)}}}}else m(l)&&r.charCodeAt(1)===f&&(c=i>2&&b(r.charCodeAt(2))?3:2,s=c);let u=-1,S=!0;for(let y=i-1;y>=s;--y)if(b(r.charCodeAt(y))){if(!S){u=y;break}}else S=!1;if(u===-1){if(c===-1)return".";u=c}return r.slice(0,u)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let c=0,s=-1,l=!0,u;if(r.length>=2&&m(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(c=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,y=-1;for(u=r.length-1;u>=c;--u){const R=r.charCodeAt(u);if(b(R)){if(!l){c=u+1;break}}else y===-1&&(l=!1,y=u+1),S>=0&&(R===i.charCodeAt(S)?--S===-1&&(s=u):(S=-1,s=y))}return c===s?s=y:s===-1&&(s=r.length),r.slice(c,s)}for(u=r.length-1;u>=c;--u)if(b(r.charCodeAt(u))){if(!l){c=u+1;break}}else s===-1&&(l=!1,s=u+1);return s===-1?"":r.slice(c,s)},extname(r){h(r,"path");let i=0,c=-1,s=0,l=-1,u=!0,S=0;r.length>=2&&r.charCodeAt(1)===f&&m(r.charCodeAt(0))&&(i=s=2);for(let y=r.length-1;y>=i;--y){const R=r.charCodeAt(y);if(b(R)){if(!u){s=y+1;break}continue}l===-1&&(u=!1,l=y+1),R===I?c===-1?c=y:S!==1&&(S=1):c!==-1&&(S=-1)}return c===-1||l===-1||S===0||S===1&&c===l-1&&c===s+1?"":r.slice(c,l)},format:P.bind(null,"\\"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const c=r.length;let s=0,l=r.charCodeAt(0);if(c===1)return b(l)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(b(l)){if(s=1,b(r.charCodeAt(1))){let A=2,M=A;for(;A<c&&!b(r.charCodeAt(A));)A++;if(A<c&&A!==M){for(M=A;A<c&&b(r.charCodeAt(A));)A++;if(A<c&&A!==M){for(M=A;A<c&&!b(r.charCodeAt(A));)A++;A===c?s=A:A!==M&&(s=A+1)}}}}else if(m(l)&&r.charCodeAt(1)===f){if(c<=2)return i.root=i.dir=r,i;if(s=2,b(r.charCodeAt(2))){if(c===3)return i.root=i.dir=r,i;s=3}}s>0&&(i.root=r.slice(0,s));let u=-1,S=s,y=-1,R=!0,L=r.length-1,T=0;for(;L>=s;--L){if(l=r.charCodeAt(L),b(l)){if(!R){S=L+1;break}continue}y===-1&&(R=!1,y=L+1),l===I?u===-1?u=L:T!==1&&(T=1):u!==-1&&(T=-1)}return y!==-1&&(u===-1||T===0||T===1&&u===y-1&&u===S+1?i.base=i.name=r.slice(S,y):(i.name=r.slice(S,u),i.base=r.slice(S,y),i.ext=r.slice(u,y))),S>0&&S!==s?i.dir=r.slice(0,S-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(p){const r=/\\/g;return()=>{const i=n.cwd().replace(r,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.$jc={resolve(...r){let i="",c=!1;for(let s=r.length-1;s>=-1&&!c;s--){const l=s>=0?r[s]:t();h(l,"path"),l.length!==0&&(i=`${l}/${i}`,c=l.charCodeAt(0)===v)}return i=E(i,!c,"/",$),c?`/${i}`:i.length>0?i:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===v,c=r.charCodeAt(r.length-1)===v;return r=E(r,!i,"/",$),r.length===0?i?"/":c?"./":".":(c&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===v},join(...r){if(r.length===0)return".";let i;for(let c=0;c<r.length;++c){const s=r[c];h(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$jc.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i||(r=e.$jc.resolve(r),i=e.$jc.resolve(i),r===i))return"";const c=1,s=r.length,l=s-c,u=1,S=i.length-u,y=l<S?l:S;let R=-1,L=0;for(;L<y;L++){const A=r.charCodeAt(c+L);if(A!==i.charCodeAt(u+L))break;A===v&&(R=L)}if(L===y)if(S>y){if(i.charCodeAt(u+L)===v)return i.slice(u+L+1);if(L===0)return i.slice(u+L)}else l>y&&(r.charCodeAt(c+L)===v?R=L:L===0&&(R=0));let T="";for(L=c+R+1;L<=s;++L)(L===s||r.charCodeAt(L)===v)&&(T+=T.length===0?"..":"/..");return`${T}${i.slice(u+R)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===v;let c=-1,s=!0;for(let l=r.length-1;l>=1;--l)if(r.charCodeAt(l)===v){if(!s){c=l;break}}else s=!1;return c===-1?i?"/":".":i&&c===1?"//":r.slice(0,c)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let c=0,s=-1,l=!0,u;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let S=i.length-1,y=-1;for(u=r.length-1;u>=0;--u){const R=r.charCodeAt(u);if(R===v){if(!l){c=u+1;break}}else y===-1&&(l=!1,y=u+1),S>=0&&(R===i.charCodeAt(S)?--S===-1&&(s=u):(S=-1,s=y))}return c===s?s=y:s===-1&&(s=r.length),r.slice(c,s)}for(u=r.length-1;u>=0;--u)if(r.charCodeAt(u)===v){if(!l){c=u+1;break}}else s===-1&&(l=!1,s=u+1);return s===-1?"":r.slice(c,s)},extname(r){h(r,"path");let i=-1,c=0,s=-1,l=!0,u=0;for(let S=r.length-1;S>=0;--S){const y=r.charCodeAt(S);if(y===v){if(!l){c=S+1;break}continue}s===-1&&(l=!1,s=S+1),y===I?i===-1?i=S:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||s===-1||u===0||u===1&&i===s-1&&i===c+1?"":r.slice(i,s)},format:P.bind(null,"/"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const c=r.charCodeAt(0)===v;let s;c?(i.root="/",s=1):s=0;let l=-1,u=0,S=-1,y=!0,R=r.length-1,L=0;for(;R>=s;--R){const T=r.charCodeAt(R);if(T===v){if(!y){u=R+1;break}continue}S===-1&&(y=!1,S=R+1),T===I?l===-1?l=R:L!==1&&(L=1):l!==-1&&(L=-1)}if(S!==-1){const T=u===0&&c?1:u;l===-1||L===0||L===1&&l===S-1&&l===u+1?i.base=i.name=r.slice(T,S):(i.name=r.slice(T,l),i.base=r.slice(T,S),i.ext=r.slice(l,S))}return u>0?i.dir=r.slice(0,u-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=p?e.$ic.normalize:e.$jc.normalize,e.$lc=p?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=p?e.$ic.join:e.$jc.join,e.$nc=p?e.$ic.resolve:e.$jc.resolve,e.$oc=p?e.$ic.relative:e.$jc.relative,e.$pc=p?e.$ic.dirname:e.$jc.dirname,e.$qc=p?e.$ic.basename:e.$jc.basename,e.$rc=p?e.$ic.extname:e.$jc.extname,e.$sc=p?e.$ic.format:e.$jc.format,e.$tc=p?e.$ic.parse:e.$jc.parse,e.$uc=p?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=p?e.$ic.sep:e.$jc.sep,e.$wc=p?e.$ic.delimiter:e.$jc.delimiter}),define(oe[31],ae([0,1,39,10,3,26,13]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=I,e.$zg=v,e.$Ag=a,e.$Bg=f,e.$Cg=d,e.$Dg=p,e.$Eg=b,e.$Fg=$,e.$Gg=m,e.$Hg=E,e.$Ig=P,e.$Jg=t,e.$Kg=r,e.$Lg=i,e.$Mg=c,e.$Ng=s,e.$Og=S;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function v(y){return y.replace(/[\\/]/g,o.$jc.sep)}function a(y){return y.indexOf("/")===-1&&(y=v(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function f(y,R=o.$jc.sep){if(!y)return"";const L=y.length,T=y.charCodeAt(0);if(I(T)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let M=3;const U=M;for(;M<L&&!I(y.charCodeAt(M));M++);if(U!==M&&!I(y.charCodeAt(M+1))){for(M+=1;M<L;M++)if(I(y.charCodeAt(M)))return y.slice(0,M+1).replace(/[\\/]/g,R)}}return R}else if(m(T)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+R:y.slice(0,2);let A=y.indexOf("://");if(A!==-1){for(A+=3;A<L;A++)if(I(y.charCodeAt(A)))return y.slice(0,A+1)}return""}function d(y){if(!k.$i||!y||y.length<5)return!1;let R=y.charCodeAt(0);if(R!==n.CharCode.Backslash||(R=y.charCodeAt(1),R!==n.CharCode.Backslash))return!1;let L=2;const T=L;for(;L<y.length&&(R=y.charCodeAt(L),R!==n.CharCode.Backslash);L++);return!(T===L||(R=y.charCodeAt(L+1),isNaN(R)||R===n.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,w=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(y,R=k.$i){const L=R?g:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||R&&h.test(y)||y==="."||y===".."||R&&y[y.length-1]==="."||R&&y.length!==y.trim().length||y.length>255)}function b(y,R,L){const T=y===R;return!L||T?T:!y||!R?!1:(0,D.$Hf)(y,R)}function $(y,R,L,T=o.sep){if(y===R)return!0;if(!y||!R||R.length>y.length)return!1;if(L){if(!(0,D.$If)(y,R))return!1;if(R.length===y.length)return!0;let M=R.length;return R.charAt(R.length-1)===T&&M--,y.charAt(M)===T}return R.charAt(R.length-1)!==T&&(R+=T),y.indexOf(R)===0}function m(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function E(y,R){return k.$i&&y.endsWith(":")&&(y+=o.sep),(0,o.$lc)(y)||(y=(0,o.$mc)(R,y)),y=(0,o.$kc)(y),P(y)}function P(y){return k.$i?(y=(0,D.$pf)(y,o.sep),y.endsWith(":")&&(y+=o.sep)):(y=(0,D.$pf)(y,o.sep),y||(y=o.sep)),y}function t(y){const R=(0,o.$kc)(y);return k.$i?y.length>3?!1:r(R)&&(y.length===2||R.charCodeAt(2)===n.CharCode.Backslash):R===o.$jc.sep}function r(y,R=k.$i){return R?m(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,R=k.$i){return r(y,R)?y[0]:void 0}function c(y,R,L){return R.length>y.length?-1:y===R?0:(L&&(y=y.toLowerCase(),R=R.toLowerCase()),y.indexOf(R))}function s(y){const R=y.split(":");let L,T,A;for(const M of R){const U=Number(M);(0,O.$kg)(U)?T===void 0?T=U:A===void 0&&(A=U):L=L?[L,M].join(":"):M}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:T!==void 0?T:void 0,column:A!==void 0?A:T!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,R,L=8){let T="";for(let M=0;M<L;M++){let U;M===0&&k.$i&&!R&&(L===3||L===4)?U=u:U=l,T+=U.charAt(Math.floor(Math.random()*U.length))}let A;return R?A=`${R}-${T}`:A=T,y?(0,o.$mc)(y,A):A}}),define(oe[82],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=D,e.$mm=O;var o;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(o||(e.Source=o={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function D(I,...v){const a=v.reduce((g,w)=>(g[w]=!0,g),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(g=>!a[g]).forEach(g=>{for(let w=0;w<f.length;w++)if(g.search(f[w])!==-1){delete I[g];break}})}function O(I){I&&(delete I.DEBUG,n.$j&&delete I.DYLD_LIBRARY_PATH,n.$k&&delete I.LD_PRELOAD)}}),define(oe[7],ae([0,1,39,91,10,3]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=b,e.$zc=r,k=De(k);const O=/^\w[\w\d+.-]*$/,I=/^\//,v=/^\/\//;function a(u,S){if(!u.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!O.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!I.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(u,S){return!u&&!S?"file":u}function d(u,S){switch(u){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const g="",w="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(S){return S instanceof p?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,y,R,L,T,A=!1){typeof S=="object"?(this.scheme=S.scheme||g,this.authority=S.authority||g,this.path=S.path||g,this.query=S.query||g,this.fragment=S.fragment||g):(this.scheme=f(S,A),this.authority=y||g,this.path=d(this.scheme,R||g),this.query=L||g,this.fragment=T||g,a(this,A))}get fsPath(){return r(this,!1)}with(S){if(!S)return this;let{scheme:y,authority:R,path:L,query:T,fragment:A}=S;return y===void 0?y=this.scheme:y===null&&(y=g),R===void 0?R=this.authority:R===null&&(R=g),L===void 0?L=this.path:L===null&&(L=g),T===void 0?T=this.query:T===null&&(T=g),A===void 0?A=this.fragment:A===null&&(A=g),y===this.scheme&&R===this.authority&&L===this.path&&T===this.query&&A===this.fragment?this:new m(y,R,L,T,A)}static parse(S,y=!1){const R=h.exec(S);return R?new m(R[2]||g,l(R[4]||g),l(R[5]||g),l(R[7]||g),l(R[9]||g),y):new m(g,g,g,g,g)}static file(S){let y=g;if(D.$i&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const R=S.indexOf(w,2);R===-1?(y=S.substring(2),S=w):(y=S.substring(2,R),S=S.substring(R)||w)}return new m("file",y,S,g,g)}static from(S,y){return new m(S.scheme,S.authority,S.path,S.query,S.fragment,y)}static joinPath(S,...y){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$i&&S.scheme==="file"?R=p.file(k.$ic.join(r(S,!0),...y)).path:R=k.$jc.join(S.path,...y),S.with({path:R})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof p)return S;{const y=new m(S);return y._formatted=S.external??null,y._fsPath=S._sep===$?S.fsPath??null:null,y}}else return S}}e.URI=p;function b(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const $=D.$i?1:void 0;class m extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:o.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=$),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const E={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function P(u,S,y){let R,L=-1;for(let T=0;T<u.length;T++){const A=u.charCodeAt(T);if(A>=n.CharCode.a&&A<=n.CharCode.z||A>=n.CharCode.A&&A<=n.CharCode.Z||A>=n.CharCode.Digit0&&A<=n.CharCode.Digit9||A===n.CharCode.Dash||A===n.CharCode.Period||A===n.CharCode.Underline||A===n.CharCode.Tilde||S&&A===n.CharCode.Slash||y&&A===n.CharCode.OpenSquareBracket||y&&A===n.CharCode.CloseSquareBracket||y&&A===n.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(u.substring(L,T)),L=-1),R!==void 0&&(R+=u.charAt(T));else{R===void 0&&(R=u.substr(0,T));const M=E[A];M!==void 0?(L!==-1&&(R+=encodeURIComponent(u.substring(L,T)),L=-1),R+=M):L===-1&&(L=T)}}return L!==-1&&(R+=encodeURIComponent(u.substring(L))),R!==void 0?R:u}function t(u){let S;for(let y=0;y<u.length;y++){const R=u.charCodeAt(y);R===n.CharCode.Hash||R===n.CharCode.QuestionMark?(S===void 0&&(S=u.substr(0,y)),S+=E[R]):S!==void 0&&(S+=u[y])}return S!==void 0?S:u}function r(u,S){let y;return u.authority&&u.path.length>1&&u.scheme==="file"?y=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?S?y=u.path.substr(1):y=u.path[1].toLowerCase()+u.path.substr(2):y=u.path,D.$i&&(y=y.replace(/\//g,"\\")),y}function i(u,S){const y=S?t:P;let R="",{scheme:L,authority:T,path:A,query:M,fragment:U}=u;if(L&&(R+=L,R+=":"),(T||L==="file")&&(R+=w,R+=w),T){let C=T.indexOf("@");if(C!==-1){const z=T.substr(0,C);T=T.substr(C+1),C=z.lastIndexOf(":"),C===-1?R+=y(z,!1,!1):(R+=y(z.substr(0,C),!1,!1),R+=":",R+=y(z.substr(C+1),!1,!0)),R+="@"}T=T.toLowerCase(),C=T.lastIndexOf(":"),C===-1?R+=y(T,!1,!0):(R+=y(T.substr(0,C),!1,!0),R+=T.substr(C))}if(A){if(A.length>=3&&A.charCodeAt(0)===n.CharCode.Slash&&A.charCodeAt(2)===n.CharCode.Colon){const C=A.charCodeAt(1);C>=n.CharCode.A&&C<=n.CharCode.Z&&(A=`/${String.fromCharCode(C+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===n.CharCode.Colon){const C=A.charCodeAt(0);C>=n.CharCode.A&&C<=n.CharCode.Z&&(A=`${String.fromCharCode(C+32)}:${A.substr(2)}`)}R+=y(A,!0,!1)}return M&&(R+="?",R+=y(M,!1,!1)),U&&(R+="#",R+=S?U:P(U,!1,!1)),R}function c(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+c(u.substr(3)):u}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(u){return u.match(s)?u.replace(s,S=>c(S)):u}}),define(oe[159],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=o,e.$cr=k,e.$dr=D,e.log=I;function o(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function k(a){const f=[];let d;try{const g=JSON.parse(a.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),d=w.__$stack),f.push(...g)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:d}}function D(a){if(typeof a!="string")return D(k(a).stack);const f=a;if(f){const d=O(f),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(g&&g.length===4)return{uri:n.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function O(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function I(a,f){const{args:d,stack:g}=k(a),w=typeof d[0]=="string"&&d.length===1;let h=O(g);h&&(h=`(${h.trim()})`);let p=[];if(typeof d[0]=="string"?h&&w?p=[`%c[${f}] %c${d[0]} %c${h}`,v("blue"),v(""),v("grey")]:p=[`%c[${f}] %c${d[0]}`,v("blue"),v(""),...d.slice(1)]:p=[`%c[${f}]%`,v("blue"),...d],h&&!w&&p.push(h),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,p)}function v(a){return`color: ${a}`}}),define(oe[83],ae([0,1,17,7,91]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=D,e.$ci=O,e.$di=v;function D(a){return JSON.stringify(a,I)}function O(a){let f=JSON.parse(a);return f=v(f),f}function I(a,f){return f instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function v(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case k.MarshalledId.Uri:return o.URI.revive(a);case k.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case k.MarshalledId.Date:return new Date(a.source)}if(a instanceof n.$Pe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let d=0;d<a.length;++d)a[d]=v(a[d],f+1);else for(const d in a)Object.hasOwnProperty.call(a,d)&&(a[d]=v(a[d],f+1))}return a}}),define(oe[12],ae([0,1,16,3,26,7,10]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=v,e.$Qg=a,e.$Ug=d,n=De(n),o=De(o),O=De(O);var I;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(I||(e.Schemas=I={}));function v(h,p){return D.URI.isUri(h)?(0,k.$Hf)(h.scheme,p):(0,k.$If)(h,p+":")}function a(h,...p){return p.some(b=>v(h,b))}e.$Rg="vscode-tkn",e.$Sg="tkn";class f{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,b){this.f=d(p,b)}getServerRootPath(){return this.f}get g(){return O.$jc.join(this.f,I.vscodeRemoteResource)}set(p,b,$){this.a[p]=b,this.b[p]=$}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(t){return n.$3(t),p}const b=p.authority;let $=this.a[b];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const m=this.b[b],E=this.c[b];let P=`path=${encodeURIComponent(p.path)}`;return typeof E=="string"&&(P+=`&${e.$Sg}=${encodeURIComponent(E)}`),D.URI.from({scheme:o.$o?this.d:I.vscodeRemoteResource,authority:`${$}:${m}`,path:this.g,query:P})}}e.$Tg=new f;function d(h,p){return O.$jc.join(p??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class g{static{this.a=e.$Zg}asBrowserUri(p){const b=this.b(p,x);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Tg.rewrite(p):p.scheme===I.file&&(o.$m||o.$q===`${I.vscodeFileResource}://${g.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||g.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,x);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==g.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return D.URI.isUri(p)?p:D.URI.parse(b.toUrl(p))}}e.$1g=new g;var w;(function(h){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function $(E){let P;typeof E=="string"?P=new URL(E).searchParams:E instanceof URL?P=E.searchParams:D.URI.isUri(E)&&(P=new URL(E.toString(!0)).searchParams);const t=P?.get(b);if(t)return p.get(t)}h.getHeadersFromQuery=$;function m(E,P,t){if(!globalThis.crossOriginIsolated)return;const r=P&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(b,r):E[b]=r}h.addSearchParam=m})(w||(e.COI=w={}))}),define(oe[19],ae([0,1,39,31,12,10,3,26,7]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=a,e.$qh=d,e.$rh=w,o=De(o),D=De(D);function a(h){return(0,v.$zc)(h,!0)}class f{constructor(p){this.a=p}compare(p,b,$=!1){return p===b?0:(0,I.$Af)(this.getComparisonKey(p,$),this.getComparisonKey(b,$))}isEqual(p,b,$=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,$)===this.getComparisonKey(b,$)}getComparisonKey(p,b=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,b,$=!1){if(p.scheme===b.scheme){if(p.scheme===k.Schemas.file)return o.$Fg(a(p),a(b),this.a(p))&&p.query===b.query&&($||p.fragment===b.fragment);if((0,e.$mh)(p.authority,b.authority))return o.$Fg(p.path,b.path,this.a(p),"/")&&p.query===b.query&&($||p.fragment===b.fragment)}return!1}joinPath(p,...b){return v.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.$eh)(p)||p.authority}basename(p){return D.$jc.basename(p.path)}extname(p){return D.$jc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===k.Schemas.file?b=v.URI.file(D.$pc(a(p))).path:(b=D.$jc.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===k.Schemas.file?b=v.URI.file(D.$kc(a(p))).path:b=D.$jc.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.$mh)(p.authority,b.authority))return;if(p.scheme===k.Schemas.file){const E=D.$oc(a(p),a(b));return O.$i?o.$zg(E):E}let $=p.path||"/";const m=b.path||"/";if(this.a(p)){let E=0;for(const P=Math.min($.length,m.length);E<P&&!($.charCodeAt(E)!==m.charCodeAt(E)&&$.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);$=m.substr(0,E)+$.substr(E)}return D.$jc.relative($,m)}resolvePath(p,b){if(p.scheme===k.Schemas.file){const $=v.URI.file(D.$nc(a(p),b));return p.with({authority:$.authority,path:$.path})}return b=o.$Ag(b),p.with({path:D.$jc.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,I.$Hf)(p,b)}hasTrailingPathSeparator(p,b=D.sep){if(p.scheme===k.Schemas.file){const $=a(p);return $.length>o.$Bg($).length&&$[$.length-1]===b}else{const $=p.path;return $.length>1&&$.charCodeAt($.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=D.sep){return(0,e.$nh)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=D.sep){let $=!1;if(p.scheme===k.Schemas.file){const m=a(p);$=m!==void 0&&m.length===o.$Bg(m).length&&m[m.length-1]===b}else{b="/";const m=p.path;$=m.length===1&&m.charCodeAt(m.length-1)===n.CharCode.Slash}return!$&&!(0,e.$nh)(p,b)?p.with({path:p.path+"/"}):p}}e.$9g=f,e.$0g=new f(()=>!1),e.$$g=new f(h=>h.scheme===k.Schemas.file?!O.$k:!0),e.$_g=new f(h=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function d(h,p){const b=[];for(let $=0;$<h.length;$++){const m=p(h[$]);h.some((E,P)=>P===$?!1:(0,e.$bh)(m,p(E)))||b.push(h[$])}return b}var g;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function p(b){const $=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(P=>{const[t,r]=P.split(":");t&&r&&$.set(t,r)});const E=b.path.substring(0,b.path.indexOf(";"));return E&&$.set(h.META_DATA_MIME,E),$}h.parseMetaData=p})(g||(e.DataUri=g={}));function w(h,p,b){if(p){let $=h.path;return $&&$[0]!==D.$jc.sep&&($=D.$jc.sep+$),h.with({scheme:b,authority:p,path:$})}return h.with({scheme:b})}}),define(oe[8],ae([0,1,23,16,4,2,19,3,146,66]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=f,e.$th=d,e.$uh=g,e.$vh=w,e.$wh=h,e.$xh=p,e.$yh=b,e.$zh=$,e.$Hh=u,e.$Ih=S,e.$Jh=y,e.$Kh=R,e.$Lh=L,e.$1h=j,e.$9h=H;function f(Y){return!!Y&&typeof Y.then=="function"}function d(Y){const V=new n.$ye,ie=Y(V.token),de=new Promise((me,we)=>{const Oe=V.token.onCancellationRequested(()=>{Oe.dispose(),we(new o.$8)});Promise.resolve(ie).then(Se=>{Oe.dispose(),V.dispose(),me(Se)},Se=>{Oe.dispose(),V.dispose(),we(Se)})});return new class{cancel(){V.cancel(),V.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function g(Y,V,ie){return new Promise((de,me)=>{const we=V.onCancellationRequested(()=>{we.dispose(),de(ie)});Y.then(de,me).finally(()=>we.dispose())})}function w(Y,V){return new Promise((ie,de)=>{const me=V.onCancellationRequested(()=>{me.dispose(),de(new o.$8)});Y.then(ie,de).finally(()=>me.dispose())})}async function h(Y){let V=-1;const ie=Y.map((de,me)=>de.then(we=>(V=me,we)));try{return await Promise.race(ie)}finally{Y.forEach((de,me)=>{me!==V&&de.cancel()})}}function p(Y,V,ie){let de;const me=setTimeout(()=>{de?.(void 0),ie?.()},V);return Promise.race([Y.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function b(Y){return new Promise((V,ie)=>{const de=Y();f(de)?de.then(V,ie):V(de)})}function $(){let Y,V;return{promise:new Promise((de,me)=>{Y=de,V=me}),resolve:Y,reject:V}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const ie=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ie,ie).then(de)})}return new Promise((ie,de)=>{this.b.then(ie,de)})}return this.a=V(),new Promise((ie,de)=>{this.a.then(me=>{this.a=null,ie(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$Ah=m;class E{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$Bh=E;class P{constructor(){this.a=new Map}queue(V,ie){const me=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(V)===me&&this.a.delete(V)});return this.a.set(V,me),me}}e.$Ch=P;const t=(Y,V)=>{let ie=!0;const de=setTimeout(()=>{ie=!1,V()},Y);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(de),ie=!1}}},r=Y=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,Y())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class i{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,ie=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ie===v.$ie?r(de):t(ie,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new o.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class c{constructor(V){this.a=new i(V),this.b=new m}trigger(V,ie){return this.a.trigger(()=>this.b.queue(V),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=c;class s{constructor(){this.a=!1,this.b=new Promise((V,ie)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=s;class l extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Gh=l;function u(Y,V){return V?new Promise((ie,de)=>{const me=setTimeout(()=>{we.dispose(),ie()},Y),we=V.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new o.$8)})}):d(ie=>u(Y,ie))}function S(Y,V=0,ie){const de=setTimeout(()=>{Y(),ie&&me.dispose()},V),me=(0,D.$Vc)(()=>{clearTimeout(de),ie?.deleteAndLeak(me)});return ie?.add(me),me}function y(Y){const V=[];let ie=0;const de=Y.length;function me(){return ie<de?Y[ie++]():null}function we(Oe){Oe!=null&&V.push(Oe);const Se=me();return Se?Se.then(we):Promise.resolve(V)}return Promise.resolve(null).then(we)}function R(Y,V=de=>!!de,ie=null){let de=0;const me=Y.length,we=()=>{if(de>=me)return Promise.resolve(ie);const Oe=Y[de++];return Promise.resolve(Oe()).then(Pe=>V(Pe)?Promise.resolve(Pe):we())};return we()}function L(Y,V=de=>!!de,ie=null){if(Y.length===0)return Promise.resolve(ie);let de=Y.length;const me=()=>{de=-1;for(const we of Y)we.cancel?.()};return new Promise((we,Oe)=>{for(const Se of Y)Se.then(Pe=>{--de>=0&&V(Pe)?(me(),we(Pe)):de===0&&we(ie)}).catch(Pe=>{--de>=0&&(me(),Oe(Pe))})})}class T{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new k.$ne}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,de)=>{this.g.push({factory:V,c:ie,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const ie=V.factory();ie.then(V.c,V.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=T;class A extends T{constructor(){super(1)}}e.$Nh=A;class M{constructor(){this.a=new B,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$Oh=M;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new K;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,ie=O.$0g){const de=ie.getComparisonKey(V);return this.a.get(de)?.size??0}queueFor(V,ie,de=O.$0g){const me=de.getComparisonKey(V);let we=this.a.get(me);if(!we){we=new A;const Oe=this.f++,Se=k.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$7c),this.d.set(Oe,Se),this.a.set(me,we)}return we.queue(ie)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=U;class C{constructor(V,ie){this.b=!1,this.a=-1,typeof V=="function"&&typeof ie=="number"&&this.setIfNotSet(V,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,ie){if(this.b)throw new o.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},ie)}setIfNotSet(V,ie){if(this.b)throw new o.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},ie))}}e.$Qh=C;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,ie,de=globalThis){if(this.f)throw new o.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{V()},ie);this.d=(0,D.$Vc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=z;class re{constructor(V,ie){this.b=-1,this.a=V,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=re;class Z{constructor(V,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=V,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=Z;class le extends re{constructor(V,ie){super(V,ie),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$Uh=le;class X extends D.$Xc{constructor(V,ie){super(),this.g=V,this.h=ie,this.a=[],this.b=this.B(new D.$Yc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of V)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(Y,V)=>{(0,I.$B)(()=>{if(ie)return;const de=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Xh=(Y,V,ie)=>{const de=Y.requestIdleCallback(V,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,Y.cancelIdleCallback(de))}}},e.$Wh=Y=>(0,e.$Xh)(globalThis,Y)}();class ee{constructor(V,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Xh)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ee;class q extends ee{constructor(V){super(globalThis,V)}}e.$Zh=q;async function j(Y,V,ie){let de;for(let me=0;me<ie;me++)try{return await Y()}catch(we){de=we,await u(V)}throw de}class B{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,ie,de){return this.a={taskId:V,cancel:()=>de?.(),promise:ie},ie.then(()=>this.d(V),()=>this.d(V)),ie}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:ie,resolve:de,reject:me}=$();this.b={run:V,promise:ie,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=B;class G{constructor(V,ie=()=>Date.now()){this.d=V,this.f=ie,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$3h=G;var ce;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(ce||(ce={}));class K{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((V,ie)=>{this.a=V,this.b=ie})}complete(V){return new Promise(ie=>{this.a(V),this.d={outcome:ce.Resolved,value:V},ie()})}error(V){return new Promise(ie=>{this.b(V),this.d={outcome:ce.Rejected,value:V},ie()})}cancel(){return this.error(new o.$8)}}e.$4h=K;var he;(function(Y){async function V(de){let me;const we=await Promise.all(de.map(Oe=>Oe.then(Se=>Se,Se=>{me||(me=Se)})));if(typeof me<"u")throw me;return we}Y.settled=V;function ie(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Oe){we(Oe)}})}Y.withAsyncBody=ie})(he||(e.Promises=he={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new o.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=se;class _{constructor(V){this.b=V,this.a=new a.$X(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=_;var F;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(V){return new N(ie=>{ie.emitMany(V)})}static fromPromise(V){return new N(async ie=>{ie.emitMany(await V)})}static fromPromises(V){return new N(async ie=>{await Promise.all(V.map(async de=>ie.emitOne(await de)))})}static merge(V){return new N(async ie=>{await Promise.all(V.map(async de=>{for await(const me of de)ie.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(V,ie){this.a=F.Initial,this.b=[],this.d=null,this.f=ie,this.g=new k.$ne,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(V(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(V,ie){return new N(async de=>{for await(const me of V)de.emitOne(ie(me))})}map(V){return N.map(this,V)}static filter(V,ie){return new N(async de=>{for await(const me of V)ie(me)&&de.emitOne(me)})}filter(V){return N.filter(this,V)}static coalesce(V){return N.filter(V,ie=>!!ie)}coalesce(){return N.coalesce(this)}static async toPromise(V){const ie=[];for await(const de of V)ie.push(de);return ie}toPromise(){return N.toPromise(this)}h(V){this.a===F.Initial&&(this.b.push(V),this.g.fire())}j(V){this.a===F.Initial&&(this.b=this.b.concat(V),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(V){this.a===F.Initial&&(this.a=F.DoneError,this.d=V,this.g.fire())}}e.$7h=N;class W extends N{constructor(V,ie){super(ie),this.m=V}cancel(){this.m.cancel()}}e.$8h=W;function H(Y){const V=new n.$ye,ie=Y(V.token);return new W(V,async de=>{const me=V.token.onCancellationRequested(()=>{me.dispose(),V.dispose(),de.reject(new o.$8)});try{for await(const we of ie){if(V.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),V.dispose()}catch(we){me.dispose(),V.dispose(),de.reject(we)}})}class J{constructor(V){this.a=new K,this.b=new N(me=>{if(ie){me.reject(ie);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},V);let ie,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ie||(ie=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$0h=J}),define(oe[113],ae([0,1,22,8,39,31,32,10,3,26]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=f,e.$yk=p,e.$zk=M,e.$Ak=U,e.$Bk=C,e.$Ck=z,e.$Dk=re,e.$Ek=ee;function f(){return Object.create(null)}e.$wk="**",e.$xk="/";const d="[/\\\\]",g="[^/\\\\]",w=/\//g;function h(q,j){switch(q){case 0:return"";case 1:return`${g}*?`;default:return`(?:${d}|${g}+${d}${j?`|${d}${g}+`:""})*?`}}function p(q,j){if(!q)return[];const B=[];let G=!1,ce=!1,K="";for(const he of q){switch(he){case j:if(!G&&!ce){B.push(K),K="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}K+=he}return K&&B.push(K),B}function b(q){if(!q)return"";let j="";const B=p(q,e.$xk);if(B.every(G=>G===e.$wk))j=".*";else{let G=!1;B.forEach((ce,K)=>{if(ce===e.$wk){if(G)return;j+=h(2,K===B.length-1)}else{let he=!1,se="",_=!1,F="";for(const N of ce){if(N!=="}"&&he){se+=N;continue}if(_&&(N!=="]"||!F)){let W;N==="-"?W=N:(N==="^"||N==="!")&&!F?W="^":N===e.$xk?W="":W=(0,a.$jf)(N),F+=W;continue}switch(N){case"{":he=!0;continue;case"[":_=!0;continue;case"}":{const H=`(?:${p(se,",").map(J=>b(J)).join("|")})`;j+=H,he=!1,se="";break}case"]":{j+="["+F+"]",_=!1,F="";break}case"?":j+=g;continue;case"*":j+=h(1);continue;default:j+=(0,a.$jf)(N)}}K<B.length-1&&(B[K+1]!==e.$wk||K+2<B.length)&&(j+=d)}G=ce===e.$wk})}return j}const $=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Gc(1e4),c=function(){return!1},s=function(){return null};function l(q,j){if(!q)return s;let B;typeof q!="string"?B=q.pattern:B=q,B=B.trim();const G=`${B}_${!!j.trimForExclusions}`;let ce=i.get(G);if(ce)return u(ce,q);let K;return $.test(B)?ce=y(B.substr(4),B):(K=m.exec(S(B,j)))?ce=R(K[1],B):(j.trimForExclusions?P:E).test(B)?ce=L(B,j):(K=t.exec(S(B,j)))?ce=T(K[1].substr(1),B,!0):(K=r.exec(S(B,j)))?ce=T(K[1],B,!1):ce=A(B),i.set(G,ce),u(ce,q)}function u(q,j){if(typeof j=="string")return q;const B=function(G,ce){return(0,D.$Fg)(G,j.base,!v.$k)?q((0,a.$of)(G.substr(j.base.length),I.sep),ce):null};return B.allBasenames=q.allBasenames,B.allPaths=q.allPaths,B.basenames=q.basenames,B.patterns=q.patterns,B}function S(q,j){return j.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function y(q,j){return function(B,G){return typeof B=="string"&&B.endsWith(q)?j:null}}function R(q,j){const B=`/${q}`,G=`\\${q}`,ce=function(he,se){return typeof he!="string"?null:se?se===q?j:null:he===q||he.endsWith(B)||he.endsWith(G)?j:null},K=[q];return ce.basenames=K,ce.patterns=[j],ce.allBasenames=K,ce}function L(q,j){const B=X(q.slice(1,-1).split(",").map(se=>l(se,j)).filter(se=>se!==s),q),G=B.length;if(!G)return s;if(G===1)return B[0];const ce=function(se,_){for(let F=0,N=B.length;F<N;F++)if(B[F](se,_))return q;return null},K=B.find(se=>!!se.allBasenames);K&&(ce.allBasenames=K.allBasenames);const he=B.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function T(q,j,B){const G=I.sep===I.$jc.sep,ce=G?q:q.replace(w,I.sep),K=I.sep+ce,he=I.$jc.sep+q;let se;return B?se=function(_,F){return typeof _=="string"&&(_===ce||_.endsWith(K)||!G&&(_===q||_.endsWith(he)))?j:null}:se=function(_,F){return typeof _=="string"&&(_===ce||!G&&_===q)?j:null},se.allPaths=[(B?"*/":"./")+q],se}function A(q){try{const j=new RegExp(`^${b(q)}$`);return function(B){return j.lastIndex=0,typeof B=="string"&&j.test(B)?q:null}}catch{return s}}function M(q,j,B){return!q||typeof j!="string"?!1:U(q)(j,void 0,B)}function U(q,j={}){if(!q)return c;if(typeof q=="string"||C(q)){const B=l(q,j);if(B===s)return c;const G=function(ce,K){return!!B(ce,K)};return B.allBasenames&&(G.allBasenames=B.allBasenames),B.allPaths&&(G.allPaths=B.allPaths),G}return Z(q,j)}function C(q){const j=q;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function z(q){return q.allBasenames||[]}function re(q){return q.allPaths||[]}function Z(q,j){const B=X(Object.getOwnPropertyNames(q).map(se=>le(se,q[se],j)).filter(se=>se!==s)),G=B.length;if(!G)return s;if(!B.some(se=>!!se.requiresSiblings)){if(G===1)return B[0];const se=function(N,W){let H;for(let J=0,Y=B.length;J<Y;J++){const V=B[J](N,W);if(typeof V=="string")return V;(0,o.$sh)(V)&&(H||(H=[]),H.push(V))}return H?(async()=>{for(const J of H){const Y=await J;if(typeof Y=="string")return Y}return null})():null},_=B.find(N=>!!N.allBasenames);_&&(se.allBasenames=_.allBasenames);const F=B.reduce((N,W)=>W.allPaths?N.concat(W.allPaths):N,[]);return F.length&&(se.allPaths=F),se}const ce=function(se,_,F){let N,W;for(let H=0,J=B.length;H<J;H++){const Y=B[H];Y.requiresSiblings&&F&&(_||(_=(0,I.$qc)(se)),N||(N=_.substr(0,_.length-(0,I.$rc)(se).length)));const V=Y(se,_,N,F);if(typeof V=="string")return V;(0,o.$sh)(V)&&(W||(W=[]),W.push(V))}return W?(async()=>{for(const H of W){const J=await H;if(typeof J=="string")return J}return null})():null},K=B.find(se=>!!se.allBasenames);K&&(ce.allBasenames=K.allBasenames);const he=B.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function le(q,j,B){if(j===!1)return s;const G=l(q,B);if(G===s)return s;if(typeof j=="boolean")return G;if(j){const ce=j.when;if(typeof ce=="string"){const K=(he,se,_,F)=>{if(!F||!G(he,se))return null;const N=ce.replace("$(basename)",()=>_),W=F(N);return(0,o.$sh)(W)?W.then(H=>H?q:null):W?q:null};return K.requiresSiblings=!0,K}}return G}function X(q,j){const B=q.filter(se=>!!se.basenames);if(B.length<2)return q;const G=B.reduce((se,_)=>{const F=_.basenames;return F?se.concat(F):se},[]);let ce;if(j){ce=[];for(let se=0,_=G.length;se<_;se++)ce.push(j)}else ce=B.reduce((se,_)=>{const F=_.patterns;return F?se.concat(F):se},[]);const K=function(se,_){if(typeof se!="string")return null;if(!_){let N;for(N=se.length;N>0;N--){const W=se.charCodeAt(N-1);if(W===k.CharCode.Slash||W===k.CharCode.Backslash)break}_=se.substr(N)}const F=G.indexOf(_);return F!==-1?ce[F]:null};K.basenames=G,K.patterns=ce,K.allBasenames=G;const he=q.filter(se=>!se.basenames);return he.push(K),he}function ee(q,j){return(0,n.$xb)(q,j,(B,G)=>typeof B=="string"&&typeof G=="string"?B===G:typeof B!="string"&&typeof G!="string"?B.base===G.base&&B.pattern===G.pattern:!1)}}),define(oe[48],ae([0,1,22,31,10,3,19,26]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=v,e.$Xw=f,e.$Yw=g,e.$Zw=w,e.$1w=$,e.$2w=E,e.$3w=P,e.$4w=t,e.$5w=r,e.$6w=i;function v(s,l){const{os:u,tildify:S,relative:y}=l;if(y){const T=a(s,y,u);if(typeof T=="string")return T}let R=s.fsPath;if(u===D.OperatingSystem.Windows&&!D.$i?R=R.replace(/\//g,"\\"):u!==D.OperatingSystem.Windows&&D.$i&&(R=R.replace(/\\/g,"/")),u!==D.OperatingSystem.Windows&&S?.userHome){const T=S.userHome.fsPath;let A;s.scheme!==S.userHome.scheme&&s.path[0]===k.$jc.sep&&s.path[1]!==k.$jc.sep?A=S.userHome.with({path:s.path}).fsPath:A=R,R=g(A,T,u)}return(u===D.OperatingSystem.Windows?k.$ic:k.$jc).normalize(f(R,u===D.OperatingSystem.Windows))}function a(s,l,u){const S=u===D.OperatingSystem.Windows?k.$ic:k.$jc,y=u===D.OperatingSystem.Linux?O.$0g:O.$_g,R=l.getWorkspace(),L=(0,n.$Rb)(R.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===k.$jc.sep&&s.path[1]!==k.$jc.sep&&(s=L.uri.with({path:s.path}));const T=l.getWorkspaceFolder(s);if(!T)return;let A;if(y.isEqual(T.uri,s)?A="":A=y.relativePath(T.uri,s)??"",A&&(A=S.normalize(A)),R.folders.length>1&&!l.noPrefix){const M=T.name?T.name:y.basenameOrAuthority(T.uri);A=A?`${M} \u2022 ${A}`:M}return A}function f(s,l=D.$i){return(0,o.$Kg)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}let d=Object.create(null);function g(s,l,u=D.OS){if(u===D.OperatingSystem.Windows||!s||!l)return s;let S=d.original===l?d.normalized:void 0;S||(S=l,D.$i&&(S=(0,o.$zg)(S)),S=`${(0,I.$pf)(S,k.$jc.sep)}${k.$jc.sep}`,d={original:l,normalized:S});let y=s;return D.$i&&(y=(0,o.$zg)(y)),(u===D.OperatingSystem.Linux?y.startsWith(S):(0,I.$If)(y,S))?`~/${y.substr(S.length)}`:s}function w(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}const h="\u2026",p="\\\\",b="~";function $(s,l=k.sep){const u=new Array(s.length);let S=!1;for(let y=0;y<s.length;y++){const R=s[y];if(R===""){u[y]=`.${l}`;continue}if(!R){u[y]=R;continue}S=!0;let L="",T=R;T.indexOf(p)===0?(L=T.substr(0,T.indexOf(p)+p.length),T=T.substr(T.indexOf(p)+p.length)):T.indexOf(l)===0?(L=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length)):T.indexOf(b)===0&&(L=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const A=T.split(l);for(let M=1;S&&M<=A.length;M++)for(let U=A.length-M;S&&U>=0;U--){S=!1;let C=A.slice(U,U+M).join(l);for(let z=0;!S&&z<s.length;z++)if(z!==y&&s[z]&&s[z].indexOf(C)>-1){const re=U+M===A.length,Z=U>0&&s[z].indexOf(l)>-1?l+C:C,le=s[z].endsWith(Z);S=!re||le}if(!S){let z="";(A[0].endsWith(":")||L!=="")&&(U===1&&(U=0,M++,C=A[0]+l+C),U>0&&(z=A[0]+l),z=L+z),U>0&&(z=z+h+l),z=z+C,U+M<A.length&&(z=z+l+h),u[y]=z}}S&&(u[y]=R)}return u}var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function E(s,l=Object.create(null)){const u=[];let S=!1,y="";for(const R of s)if(R==="$"||S&&R==="{")y&&u.push({value:y,type:m.TEXT}),y="",S=!0;else if(R==="}"&&S){const L=l[y];if(typeof L=="string")L.length&&u.push({value:L,type:m.VARIABLE});else if(L){const T=u[u.length-1];(!T||T.type!==m.SEPARATOR)&&u.push({value:L.label,type:m.SEPARATOR})}y="",S=!1}else y+=R;return y&&!S&&u.push({value:y,type:m.TEXT}),u.filter((R,L)=>{if(R.type===m.SEPARATOR){const T=u[L-1],A=u[L+1];return[T,A].every(M=>M&&(M.type===m.VARIABLE||M.type===m.TEXT)&&M.value.length>0)}return!0}).map(R=>R.value).join("")}function P(s,l){return D.$j||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):s.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function t(s,l){return D.$j||l?s.replace(/\(&&\w\)|&&/g,""):D.$i?s.replace(/&&|&/g,u=>u==="&"?"&&":"&"):s.replace(/&&/g,"_")}function r(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const l=s.lastIndexOf(" [",s.length-2);if(l!==-1){const u=c(s.substring(0,l)),S=s.substring(l);return{name:u.name+S,parentPath:u.parentPath}}}return c(s)}function c(s){const l=s.indexOf("/")!==-1?k.$jc:k.$ic,u=l.basename(s),S=l.dirname(s);return u.length?{name:u,parentPath:S}:{name:S,parentPath:""}}}),define(oe[160],ae([0,1,17,91,7]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=v,e.$Pn=f,e.$Qn=d;function D(g){return g.toJSON()}class O{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:D(k.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:D(k.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:k.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Mn=O,e.$Nn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function I(g,w,h){if(!g||h>200)return null;if(typeof g=="object"){if(g instanceof k.URI)return w.transformOutgoing(g);for(const p in g)if(Object.hasOwnProperty.call(g,p)){const b=I(g[p],w,h+1);b!==null&&(g[p]=b)}}return null}function v(g,w){const h=I(g,w,0);return h===null?g:h}function a(g,w,h,p){if(!g||p>200)return null;if(typeof g=="object"){if(g.$mid===o.MarshalledId.Uri)return h?k.URI.revive(w.transformIncoming(g)):w.transformIncoming(g);if(g instanceof n.$Pe)return null;for(const b in g)if(Object.hasOwnProperty.call(g,b)){const $=a(g[b],w,h,p+1);$!==null&&(g[b]=$)}}return null}function f(g,w){const h=a(g,w,!1,0);return h===null?g:h}function d(g,w){const h=a(g,w,!0,0);return h===null?g:h}}),define(oe[94],ae([0,1,27,61,33,150,3]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=v,e.$Un=d,e.$Vn=g,k=De(k),e.$Sn=new class{c(w){return this.a||(this.a=o.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const p=(0,n.networkInterfaces)();for(const b in p){const $=p[b];if($)for(const{mac:m,internal:E}of $)E||(h+=1,this.c(m.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let I;async function v(w){return I||(I=(async()=>await a(w)||k.$3g())()),I}async function a(w){try{const h=await new Promise((b,$)=>{x(["crypto"],b,$)}).then(De),p=(0,D.$Rn)();return h.createHash("sha256").update(p,"utf8").digest("hex")}catch(h){w(h);return}}const f="Software\\Microsoft\\SQMClient";async function d(w){if(O.$i){const h=await new Promise((p,b)=>{x(["@vscode/windows-registry"],p,b)}).then(De);try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(p){return w(p),""}}return""}async function g(w){try{return await(await new Promise((b,$)=>{x(["@vscode/deviceid"],b,$)}).then(De)).getDeviceId()}catch(h){return w(h),""}}}),define(oe[21],ae([0,1,47,27,161,8,31,79,10,3,19,7]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=b,e.readdirSync=E,e.whenDeleted=r,e.configureFlushOnWrite=u,e.writeFileSync=y,n=De(n);var g;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function w(Z,le=g.UNLINK,X){if((0,O.$Jg)(Z))throw new Error("rimraf - will refuse to recursively delete root");return le===g.UNLINK?p(Z):h(Z,X)}async function h(Z,le=(0,O.$Og)((0,o.tmpdir)())){try{try{await n.promises.rename(Z,le)}catch(X){return X.code==="ENOENT"?void 0:p(Z)}p(le).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function p(Z){return n.promises.rm(Z,{recursive:!0,force:!0,maxRetries:3})}function b(Z){if((0,O.$Jg)(Z))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}async function $(Z,le){return P(await(le?m(Z):n.promises.readdir(Z)))}async function m(Z){try{return await n.promises.readdir(Z,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const le=[],X=await $(Z);for(const ee of X){let q=!1,j=!1,B=!1;try{const G=await e.Promises.lstat((0,v.$mc)(Z,ee));q=G.isFile(),j=G.isDirectory(),B=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}le.push({name:ee,isFile:()=>q,isDirectory:()=>j,isSymbolicLink:()=>B})}return le}function E(Z){return P(n.readdirSync(Z))}function P(Z){return Z.map(le=>typeof le=="string"?a.$j?(0,I.$nm)(le):le:(le.name=a.$j?(0,I.$nm)(le.name):le.name,le))}async function t(Z){const le=await $(Z),X=[];for(const ee of le)await i.existsDirectory((0,v.$mc)(Z,ee))&&X.push(ee);return X}function r(Z,le=1e3){return new Promise(X=>{let ee=!1;const q=setInterval(()=>{ee||(ee=!0,n.access(Z,j=>{ee=!1,j&&(clearInterval(q),X(void 0))}))},le)})}var i;(function(Z){async function le(q){let j;try{if(j=await e.Promises.lstat(q),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(a.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw G}throw B}}Z.stat=le;async function X(q){try{const{stat:j,symbolicLink:B}=await Z.stat(q);return j.isFile()&&B?.dangling!==!0}catch{}return!1}Z.existsFile=X;async function ee(q){try{const{stat:j,symbolicLink:B}=await Z.stat(q);return j.isDirectory()&&B?.dangling!==!0}catch{}return!1}Z.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const c=new D.$Ph;function s(Z,le,X){return c.queueFor(d.URI.file(Z),()=>{const ee=R(X);return new Promise((q,j)=>S(Z,le,ee,B=>B?j(B):q()))},f.$$g)}let l=!0;function u(Z){l=Z}function S(Z,le,X,ee){if(!l)return n.writeFile(Z,le,{mode:X.mode,flag:X.flag},ee);n.open(Z,X.flag,X.mode,(q,j)=>{if(q)return ee(q);n.writeFile(j,le,B=>{if(B)return n.close(j,()=>ee(B));n.fdatasync(j,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),u(!1)),n.close(j,ce=>ee(ce))))})})}function y(Z,le,X){const ee=R(X);if(!l)return n.writeFileSync(Z,le,{mode:ee.mode,flag:ee.flag});const q=n.openSync(Z,ee.flag,ee.mode);try{n.writeFileSync(q,le);try{n.fdatasyncSync(q)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),u(!1)}}finally{n.closeSync(q)}}function R(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function L(Z,le,X=6e4){if(Z!==le)try{a.$i&&typeof X=="number"?await T(Z,le,Date.now(),X):await n.promises.rename(Z,le)}catch(ee){if(Z.toLowerCase()!==le.toLowerCase()&&ee.code==="EXDEV"||Z.endsWith("."))await A(Z,le,{preserveSymlinks:!1}),await w(Z,g.MOVE);else throw ee}}async function T(Z,le,X,ee,q=0){try{return await n.promises.rename(Z,le)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-X>=ee)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${j}`),j;if(q===0){let B=!1;try{const{stat:G}=await i.stat(le);G.isFile()||(B=!0)}catch{}if(B)throw j}return await(0,D.$Hh)(Math.min(100,q*10)),T(Z,le,X,ee,q+1)}}async function A(Z,le,X){return U(Z,le,{root:{source:Z,target:le},options:X,handledSourcePaths:new Set})}const M=511;async function U(Z,le,X){if(X.handledSourcePaths.has(Z))return;X.handledSourcePaths.add(Z);const{stat:ee,symbolicLink:q}=await i.stat(Z);if(q){if(X.options.preserveSymlinks)try{return await re(Z,le,X)}catch{}if(q.dangling)return}return ee.isDirectory()?C(Z,le,ee.mode&M,X):z(Z,le,ee.mode&M)}async function C(Z,le,X,ee){await e.Promises.mkdir(le,{recursive:!0,mode:X});const q=await $(Z);for(const j of q)await U((0,v.$mc)(Z,j),(0,v.$mc)(le,j),ee)}async function z(Z,le,X){await e.Promises.copyFile(Z,le),await e.Promises.chmod(le,X)}async function re(Z,le,X){let ee=await e.Promises.readlink(Z);(0,O.$Fg)(ee,X.root.source,!a.$k)&&(ee=(0,v.$mc)(X.root.target,ee.substr(X.root.source.length+1))),await e.Promises.symlink(ee,le)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(Z,le,X,ee,q)=>new Promise((j,B)=>{n.read(Z,le,X,ee,q,(G,ce,K)=>G?B(G):j({bytesRead:ce,buffer:K}))})}get readFile(){return n.promises.readFile}get write(){return(Z,le,X,ee,q)=>new Promise((j,B)=>{n.write(Z,le,X,ee,q,(G,ce,K)=>G?B(G):j({bytesWritten:ce,buffer:K}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,k.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,k.promisify)(n.open)}get close(){return(0,k.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,k.promisify)(n.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return A}}}),define(oe[114],ae([0,1,47,10,3,26,21]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=I,e.$kr=v,e.$lr=a,e.$mr=f,n=De(n);function I(g){if(k.$k)return g;const w=(0,o.$pc)(g);if(g===w)return g;const h=((0,o.$qc)(g)||g).toLowerCase();try{const b=(0,O.readdirSync)(w).filter($=>$.toLowerCase()===h);if(b.length===1){const $=I(w);if($)return(0,o.$mc)($,b[0])}else if(b.length>1){const $=b.indexOf(h);if($>=0){const m=I(w);if(m)return(0,o.$mc)(m,b[$])}}}catch{}return null}async function v(g,w){if(k.$k)return g;const h=(0,o.$pc)(g);if(g===h)return g;const p=((0,o.$qc)(g)||g).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await O.Promises.readdir(h)).filter(m=>m.toLowerCase()===p);if($.length===1){const m=await v(h,w);if(m)return(0,o.$mc)(m,$[0])}else if($.length>1){const m=$.indexOf(p);if(m>=0){const E=await v(h,w);if(E)return(0,o.$mc)(E,$[m])}}}catch{}return null}async function a(g){try{return await O.Promises.realpath(g)}catch{const h=d(g);return await O.Promises.access(h,n.constants.R_OK),h}}function f(g){try{return n.realpathSync(g)}catch{const h=d(g);return n.accessSync(h,n.constants.R_OK),h}}function d(g){return(0,D.$pf)((0,o.$kc)(g),o.sep)}}),define(oe[115],ae([0,1,27,10,21]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=m,e.$xm=E,n=De(n),o=De(o),k=De(k);const D=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var v;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(v||(v={}));let a;switch(process.arch){case"ia32":a=v.x86;break;case"arm":case"arm64":a=v.ARM;break;default:a=v.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=v.x86:f=v.x64;class d{constructor(t,r,i){this.exePath=t,this.displayName=r,this.a=i}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:P=!1}={}){return P?a===v.x64?process.env["ProgramFiles(x86)"]||null:f===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:P=!1,findPreview:t=!1}={}){const r=g({useAlternateBitness:P});if(!r)return null;const i=o.$mc(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(i))return null;let c=-1,s=null;for(const S of await k.Promises.readdir(i)){let y=-1;if(t){const L=S.indexOf("-");if(L<0)continue;const T=S.substring(0,L);if(!D.test(T)||S.substring(L+1)!=="preview")continue;y=parseInt(T,10)}else{if(!D.test(S))continue;y=parseInt(S,10)}if(y<=c)continue;const R=o.$mc(i,S,"pwsh.exe");await k.SymlinkSupport.existsFile(R)&&(s=R,c=y)}if(!s)return null;const l=r.includes("x86")?" (x86)":"",u=t?" Preview":"";return new d(s,`PowerShell${u}${l}`,!0)}async function h({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const t=o.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:i}=P?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const c of await k.Promises.readdir(t))if(r.test(c)){const s=o.$mc(t,c,"pwsh.exe");return new d(s,i)}return null}function p(){const P=o.$mc(n.homedir(),".dotnet","tools","pwsh.exe");return new d(P,".NET Core PowerShell Global Tool")}function b(){const P=o.$mc(process.env.windir,a===v.x86&&f!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(P,"Windows PowerShell",!0)}async function*$(){let P=await w();P&&(yield P),P=await w({useAlternateBitness:!0}),P&&(yield P),P=await h(),P&&(yield P),P=p(),P&&(yield P),P=await w({findPreview:!0}),P&&(yield P),P=await h({findPreview:!0}),P&&(yield P),P=await w({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=b(),P&&(yield P)}async function*m(){for await(const P of $())await P.exists()&&(yield P)}async function E(){for await(const P of m())return P;return null}}),define(oe[95],ae([0,1,10,3,37,82,13,21]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=v,e.$zm=a,n=De(n),o=De(o),k=De(k),O=De(O),I=De(I),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function v(d=k.env){return d.comspec||"cmd.exe"}function a(d){let g=[],w=!1;const h=function(p){if(w){g.push(p);return}(!d.send(p,$=>{if($&&console.error($),w=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(E=>h(E))}})||o.$i)&&(w=!0)};return{send:h}}var f;(function(d){async function g(w,h,p){if(n.$lc(w))return w;if(h===void 0&&(h=k.cwd()),n.$pc(w)!=="."||(p===void 0&&O.$gg(k.env.PATH)&&(p=k.env.PATH.split(n.$wc)),p===void 0||p.length===0))return n.$mc(h,w);async function $(m){if(await I.Promises.exists(m)){let E;try{E=await I.Promises.stat(m)}catch(P){P.message.startsWith("EACCES")&&(E=await I.Promises.lstat(m))}return E?!E.isDirectory():!1}return!1}for(const m of p){let E;if(n.$lc(m)?E=n.$mc(m,w):E=n.$mc(h,m,w),await $(E))return E;let P=E+".com";if(await $(P)||(P=E+".exe",await $(P)))return P}return n.$mc(h,w)}d.findExecutable=g})(f||(e.win32=f={}))}),define(oe[116],ae([0,1,49,12]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=k;function k(O){return new Promise((I,v)=>{let a;const f=new Map;function d(w,h,p,b,$){const m=f.get(h);if(w===O||m){const E={name:g(p),cmd:p,pid:w,ppid:h,load:b,mem:$};f.set(w,E),w===O&&(a=E),m&&(m.children||(m.children=[]),m.children.push(E),m.children.length>1&&(m.children=m.children.sort((P,t)=>P.pid-t.pid)))}}function g(w){const h=/--utility-sub-type=network/i,p=/--crashes-directory/i,b=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(p.exec(w))return"electron-crash-reporter";if(b.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let E=m.exec(w);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?h.exec(w)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const P=/[a-zA-Z-]+\.js/g;let t="";do E=P.exec(w),E&&(t+=E+" ");while(E);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,p)=>{x(["@vscode/windows-process-tree"],h,p)}).then(De).then(h=>{h.getProcessList(O,p=>{if(!p){v(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(p,b=>{const $=new Map;b.forEach(m=>{const E=w(m.commandLine||"");$.set(m.pid,{name:g(E),cmd:E,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),a=$.get(O),a?($.forEach(m=>{const E=$.get(m.ppid);E&&(E.children||(E.children=[]),E.children.push(m))}),$.forEach(m=>{m.children&&(m.children=m.children.sort((E,P)=>E.pid-P.pid))}),I(a)):v(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let w=function(){let h=[a];const p=[];for(;h.length;){const $=h.shift();$&&(p.push($.pid),$.children&&(h=h.concat($.children)))}let b=JSON.stringify(o.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+p.join(" "),(0,n.exec)(b,{},($,m,E)=>{if($||E)v($||new Error(E.toString()));else{const P=m.toString().split(`
`);for(let t=0;t<p.length;t++){const r=f.get(p[t]);r.load=parseFloat(P[t])}if(!a){v(new Error(`Root process ${O} not found`));return}I(a)}})};(0,n.exec)("which ps",{},(h,p,b)=>{if(h||b)if(process.platform!=="linux")v(h||new Error(b.toString()));else{const $=JSON.stringify(o.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(m,E,P)=>{m||P?v(m||new Error(P.toString())):(D(E,d),w())})}else{const $=p.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,P,t)=>{E||t&&!t.includes("screen size is bogus")?v(E||new Error(t.toString())):(D(P,d),process.platform==="linux"?w():a?I(a):v(new Error(`Root process ${O} not found`)))})}})}})}function D(O,I){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=O.toString().split(`
`);for(const f of a){const d=v.exec(f.trim());d&&d.length===6&&I(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(oe[117],ae([0,1,27,3,115,95]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=O,o=De(o),D=De(D);async function O(d,g){return d===o.OperatingSystem.Windows?o.$i?f():D.$ym(g):v(d,g)}let I=null;function v(d,g){if(o.$k&&d===o.OperatingSystem.Macintosh||o.$j&&d===o.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(o.$i)w="/bin/bash";else{if(w=g.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let a=null;async function f(){return a||(a=(await(0,k.$xm)()).exePath),a}});var ke=this&&this.__decorate||function(x,e,n,o){var k=arguments.length,D=k<3?e:o===null?o=Object.getOwnPropertyDescriptor(e,n):o,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,n,o);else for(var I=x.length-1;I>=0;I--)(O=x[I])&&(D=(k<3?O(D):k>3?O(e,n,D):O(e,n))||D);return k>3&&D&&Object.defineProperty(e,n,D),D};define(oe[44],ae([0,1,22,8,17,23,54,16,4,2,83,26,13]),function(x,e,n,o,k,D,O,I,v,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=u,e.$hi=S,e.$mi=M,e.$ni=U,d=De(d);var w;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(w||(w={}));function h(q){switch(q){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function b(q){switch(q){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var $;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})($||($={}));function m(q){let j=0;for(let B=0;;B+=7){const G=q.read(1);if(j|=(G.buffer[0]&127)<<B,!(G.buffer[0]&128))return j}}const E=c(0);function P(q,j){if(j===0){q.write(E);return}let B=0;for(let ce=j;ce!==0;ce=ce>>>7)B++;const G=k.$Pe.alloc(B);for(let ce=0;j!==0;ce++)G.buffer[ce]=j&127,j=j>>>7,j>0&&(G.buffer[ce]|=128);q.write(G)}class t{constructor(j){this.b=j,this.a=0}read(j){const B=this.b.slice(this.a,this.a+j);return this.a+=B.byteLength,B}}e.$ei=t;class r{constructor(){this.a=[]}get buffer(){return k.$Pe.concat(this.a)}write(j){this.a.push(j)}}e.$fi=r;var i;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(i||(i={}));function c(q){const j=k.$Pe.alloc(1);return j.writeUInt8(q,0),j}const s={Undefined:c(i.Undefined),String:c(i.String),Buffer:c(i.Buffer),VSBuffer:c(i.VSBuffer),Array:c(i.Array),Object:c(i.Object),Uint:c(i.Int)},l=typeof Buffer<"u";function u(q,j){if(typeof j>"u")q.write(s.Undefined);else if(typeof j=="string"){const B=k.$Pe.fromString(j);q.write(s.String),P(q,B.byteLength),q.write(B)}else if(l&&Buffer.isBuffer(j)){const B=k.$Pe.wrap(j);q.write(s.Buffer),P(q,B.byteLength),q.write(B)}else if(j instanceof k.$Pe)q.write(s.VSBuffer),P(q,j.byteLength),q.write(j);else if(Array.isArray(j)){q.write(s.Array),P(q,j.length);for(const B of j)u(q,B)}else if(typeof j=="number"&&(j|0)===j)q.write(s.Uint),P(q,j);else{const B=k.$Pe.fromString(JSON.stringify(j));q.write(s.Object),P(q,B.byteLength),q.write(B)}}function S(q){switch(q.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return q.read(m(q)).toString();case i.Buffer:return q.read(m(q)).buffer;case i.VSBuffer:return q.read(m(q));case i.Array:{const B=m(q),G=[];for(let ce=0;ce<B;ce++)G.push(S(q));return G}case i.Object:return JSON.parse(q.read(m(q)).toString());case i.Int:return m(q)}}class y{constructor(j,B,G=null,ce=1e3){this.h=j,this.j=B,this.k=G,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:p.Initialize})}registerChannel(j,B){this.b.set(j,B),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case p.Initialize:{const B=this.o([j.type]);this.k?.logOutgoing(B,0,R.OtherSide,b(j.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const B=this.o([j.type,j.id],j.data);this.k?.logOutgoing(B,j.id,R.OtherSide,b(j.type),j.data);return}}}o(j,B=void 0){const G=new r;return u(G,j),u(G,B),this.p(G.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const B=new t(j),G=S(B),ce=S(B),K=G[0];switch(K){case w.Promise:return this.k?.logIncoming(j.byteLength,G[1],R.OtherSide,`${h(K)}: ${G[2]}.${G[3]}`,ce),this.s({type:K,id:G[1],channelName:G[2],name:G[3],arg:ce});case w.EventListen:return this.k?.logIncoming(j.byteLength,G[1],R.OtherSide,`${h(K)}: ${G[2]}.${G[3]}`,ce),this.t({type:K,id:G[1],channelName:G[2],name:G[3],arg:ce});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,G[1],R.OtherSide,`${h(K)}`),this.u({type:K,id:G[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,G[1],R.OtherSide,`${h(K)}`),this.u({type:K,id:G[1]})}}s(j){const B=this.b.get(j.channelName);if(!B){this.v(j);return}const G=new D.$ye;let ce;try{ce=B.call(this.j,j.name,j.arg,G.token)}catch(se){ce=Promise.reject(se)}const K=j.id;ce.then(se=>{this.m({id:K,data:se,type:p.PromiseSuccess})},se=>{se instanceof Error?this.m({id:K,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:p.PromiseError}):this.m({id:K,data:se,type:p.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,a.$Vc)(()=>G.cancel());this.d.set(j.id,he)}t(j){const B=this.b.get(j.channelName);if(!B){this.v(j);return}const G=j.id,K=B.listen(this.j,j.name,j.arg)(he=>this.m({id:G,data:he,type:p.EventFire}));this.d.set(j.id,K)}u(j){const B=this.d.get(j.id);B&&(B.dispose(),this.d.delete(j.id))}v(j){let B=this.g.get(j.channelName);B||(B=[],this.g.set(j.channelName,B));const G=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:p.PromiseError})},this.l);B.push({request:j,timeoutTimer:G})}w(j){const B=this.g.get(j);if(B){for(const G of B)switch(clearTimeout(G.timeoutTimer),G.request.type){case w.Promise:this.s(G.request);break;case w.EventListen:this.t(G.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Sc)(this.d.values()),this.d.clear()}}e.$ii=y;var R;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(j,B=null){this.l=j,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=B}getChannel(j){const B=this;return{call(G,ce,K){return B.a?Promise.reject(new I.$8):B.m(j,G,ce,K)},listen(G,ce){return B.a?v.Event.None:B.o(j,G,ce)}}}m(j,B,G,ce=D.CancellationToken.None){const K=this.g++,he=w.Promise,se={id:K,type:he,channelName:j,name:B,arg:G};if(ce.isCancellationRequested)return Promise.reject(new I.$8);let _;return new Promise((N,W)=>{if(ce.isCancellationRequested)return W(new I.$8);const H=()=>{const ie=de=>{switch(de.type){case p.PromiseSuccess:this.f.delete(K),N(de.data);break;case p.PromiseError:{this.f.delete(K);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case p.PromiseErrorObj:this.f.delete(K),W(de.data);break}};this.f.set(K,ie),this.p(se)};let J=null;this.b===$.Idle?H():(J=(0,o.$th)(ie=>this.u()),J.then(()=>{J=null,H()}));const Y=()=>{J?(J.cancel(),J=null):this.p({id:K,type:w.PromiseCancel}),W(new I.$8)},V=ce.onCancellationRequested(Y);_=(0,a.$Uc)((0,a.$Vc)(Y),V),this.d.add(_)}).finally(()=>{_.dispose(),this.d.delete(_)})}o(j,B,G){const ce=this.g++,K=w.EventListen,he={id:ce,type:K,channelName:j,name:B,arg:G};let se=null;const _=new v.$ne({onWillAddFirstListener:()=>{se=(0,o.$th)(N=>this.u()),se.then(()=>{se=null,this.d.add(_),this.p(he)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.d.delete(_),this.p({id:ce,type:w.EventDispose}))}}),F=N=>_.fire(N.data);return this.f.set(ce,F),_.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const B=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(B,j.id,R.LocalSide,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const B=this.q([j.type,j.id]);this.j?.logOutgoing(B,j.id,R.LocalSide,h(j.type));return}}}q(j,B=void 0){const G=new r;return u(G,j),u(G,B),this.r(G.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const B=new t(j),G=S(B),ce=S(B),K=G[0];switch(K){case p.Initialize:return this.j?.logIncoming(j.byteLength,0,R.LocalSide,b(K)),this.t({type:G[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,G[1],R.LocalSide,b(K),ce),this.t({type:G[0],id:G[1],data:ce})}}t(j){if(j.type===p.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Sc)(this.d.values()),this.d.clear()}}e.$ji=L,ke([O.$$h],L.prototype,"onDidInitializePromise",null);class T{get connections(){const j=[];return this.f.forEach(B=>j.push(B)),j}constructor(j,B,G){this.a=new Map,this.f=new Set,this.g=new v.$ne,this.onDidAddConnection=this.g.event,this.h=new v.$ne,this.onDidRemoveConnection=this.h.event,this.j=new a.$Wc,this.j.add(j(({protocol:ce,onDidClientDisconnect:K})=>{const he=v.Event.once(ce.onMessage);this.j.add(he(se=>{const _=new t(se),F=S(_),N=new y(ce,F,B,G),W=new L(ce,B);this.a.forEach((J,Y)=>N.registerChannel(Y,J));const H={channelServer:N,channelClient:W,ctx:F};this.f.add(H),this.g.fire(H),this.j.add(K(()=>{N.dispose(),W.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(j,B){const G=this;return{call(ce,K,he){let se;if((0,g.$ug)(B)){const F=(0,n.$6b)(G.connections.filter(B));se=F?Promise.resolve(F):v.Event.toPromise(v.Event.filter(G.onDidAddConnection,B))}else se=B.routeCall(G,ce,K);const _=se.then(F=>F.channelClient.getChannel(j));return M(_).call(ce,K,he)},listen(ce,K){if((0,g.$ug)(B))return G.k(j,B,ce,K);const he=B.routeEvent(G,ce,K).then(se=>se.channelClient.getChannel(j));return M(he).listen(ce,K)}}}k(j,B,G,ce){const K=this;let he;const se=new v.$ne({onWillAddFirstListener:()=>{he=new a.$Wc;const _=new v.$te,F=new Map,N=H=>{const Y=H.channelClient.getChannel(j).listen(G,ce),V=_.add(Y);F.set(H,V)},W=H=>{const J=F.get(H);J&&(J.dispose(),F.delete(H))};K.connections.filter(B).forEach(N),v.Event.filter(K.onDidAddConnection,B)(N,void 0,he),K.onDidRemoveConnection(W,void 0,he),_.event(se.fire,se,he),he.add(_)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return se.event}registerChannel(j,B){this.a.set(j,B);for(const G of this.f)G.channelServer.registerChannel(j,B)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=T;class A{constructor(j,B,G=null){const ce=new r;u(ce,B),j.send(ce.buffer),this.a=new L(j,G),this.d=new y(j,B,G)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,B){this.d.registerChannel(j,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=A;function M(q){return{call(j,B,G){return q.then(ce=>ce.call(j,B,G))},listen(j,B){const G=new v.$we;return q.then(ce=>G.input=ce.listen(j,B)),G.event}}}function U(q){let j=!1;return{call(B,G,ce){return j?q.call(B,G,ce):(0,o.$Hh)(0).then(()=>j=!0).then(()=>q.call(B,G,ce))},listen(B,G){if(j)return q.listen(B,G);const ce=new v.$we;return(0,o.$Hh)(0).then(()=>j=!0).then(()=>ce.input=q.listen(B,G)),ce.event}}}class C{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const B of j.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await v.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$oi=C;var z;(function(q){function j(K,he,se){const _=K,F=se&&se.disableMarshalling,N=new Map;for(const W in _)G(W)&&N.set(W,v.Event.buffer(_[W],!0,void 0,he));return new class{listen(W,H,J){const Y=N.get(H);if(Y)return Y;const V=_[H];if(typeof V=="function"){if(ce(H))return V.call(_,J);if(G(H))return N.set(H,v.Event.buffer(_[H],!0,void 0,he)),N.get(H)}throw new I.$eb(`Event not found: ${H}`)}call(W,H,J){const Y=_[H];if(typeof Y=="function"){if(!F&&Array.isArray(J))for(let ie=0;ie<J.length;ie++)J[ie]=(0,f.$di)(J[ie]);let V=Y.apply(_,J);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new I.$eb(`Method not found: ${H}`)}}}q.fromService=j;function B(K,he){const se=he&&he.disableMarshalling;return new Proxy({},{get(_,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):ce(F)?function(N){return K.listen(F,N)}:G(F)?K.listen(F):async function(...N){let W;he&&!(0,g.$pg)(he.context)?W=[he.context,...N]:W=N;const H=await K.call(F,W);return se?H:(0,f.$di)(H)};throw new I.$eb(`Property not found: ${String(F)}`)}})}q.toService=B;function G(K){return K[0]==="o"&&K[1]==="n"&&d.$Gf(K.charCodeAt(2))}function ce(K){return/^onDynamic/.test(K)&&d.$Gf(K.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const j=q.toString();if(j!=="[object Object]")return j}return q}function le(q){return Array.isArray(q)?q.map(Z):Z(q)}function X(q,j,B,G,ce,K,he){he=le(he);const se=re[ce],_=se[G%se.length];let F=[`%c[${q}]%c[${String(j).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(K)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class ee{constructor(j,B){this.d=j,this.f=B,this.a=0,this.b=0}logOutgoing(j,B,G,ce,K){this.b+=j,X(this.d,this.b,j,B,G,ce,K)}logIncoming(j,B,G,ce,K){this.a+=j,X(this.f,this.a,j,B,G,ce,K)}}e.$pi=ee}),define(oe[162],ae([0,1,17,4,44]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=e.$IX=void 0;class D{constructor(v){this.a=v,this.onMessage=o.Event.fromDOMEventEmitter(this.a,"message",a=>a.data?n.$Pe.wrap(a.data):n.$Pe.alloc(0)),v.start()}send(v){this.a.postMessage(v.buffer)}disconnect(){this.a.close()}}e.$IX=D;class O extends k.$li{constructor(v,a){const f=new D(v);super(f,a),this.b=f}dispose(){this.b.disconnect(),super.dispose()}}e.$JX=O}),define(oe[118],ae([0,1,17,4,2,44]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const l=new WeakMap;let u=0;function S(R,L){if(!l.has(R)){const T=String(++u);l.set(R,T)}return l.get(R)}function y(R,L,T,A){if(!s.enableDiagnostics)return;const M=S(R,L);if(A instanceof n.$Pe||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const U=n.$Pe.alloc(A.byteLength);U.set(A),s.records.push({timestamp:Date.now(),id:M,label:L,type:T,buff:U})}else s.records.push({timestamp:Date.now(),id:M,label:L,type:T,data:A})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let a=null;function f(){return a||(a=n.$Pe.alloc(0)),a}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,u){if(l===0)return f();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const L=this.a[0];return u&&(this.a.shift(),this.b-=l),L}if(this.a[0].byteLength>l){const L=this.a[0].slice(0,l);return u&&(this.a[0]=this.a[0].slice(l),this.b-=l),L}const S=n.$Pe.alloc(l);let y=0,R=0;for(;l>0;){const L=this.a[R];if(L.byteLength>l){const T=L.slice(0,l);S.set(T,y),y+=l,u&&(this.a[R]=L.slice(l),this.b-=l),l-=l}else S.set(L,y),y+=L.byteLength,u?(this.a.shift(),this.b-=L.byteLength):R++,l-=L.byteLength}return S}}e.$qi=d;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function w(s){switch(s){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class p{constructor(l,u,S,y){this.type=l,this.id=u,this.ack=S,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.$Xc{constructor(l){super(),this.f=this.B(new o.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:h.HeaderLength,messageType:g.None,id:0,ack:0},this.a=l,this.b=!1,this.c=new d,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,y=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=h.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,u),this.f.fire(new p(S,y,R,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Pe.alloc(h.HeaderLength);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:w(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,l.data),this.j(u,l.data)}g(l,u){const S=this.f===0;return this.d.push(l,u),this.f+=l.byteLength+u.byteLength,S}h(){const l=n.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,u){this.g(l,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:l.byteLength}),this.c.write(l)}}class m extends k.$Xc{constructor(l){super(),this.f=new o.$ne,this.onMessage=this.f.event,this.g=new o.$ne,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new $(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(u=>{u.type===g.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new p(g.Regular,0,0,l))}}e.$ri=m;class E extends D.$li{static fromSocket(l,u){return new E(new m(l),u)}get onDidDispose(){return this.b.onDidDispose}constructor(l,u,S=null){super(l,u,S),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$si=E;class P{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$ti=P;class t{constructor(l){this.data=l,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let l=0,u=this.a;for(;u;)u=u.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let u=0,S=this.a;for(;S;)l[u++]=S.data,S=S.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const u=new t(l);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const l=Date.now();for(let u=0;u<i.a;u++)this.c[u]=l-1e3*u;setInterval(()=>{for(let u=i.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),u=(1+i.a)*1e3;let S=0;for(let y=0;y<i.a;y++)l-this.c[y]<=u&&S++;return 1-S/i.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new P,this.onControlMessage=this.u.event,this.v=new P,this.onMessage=this.v.event,this.w=new P,this.onDidDispose=this.w.event,this.x=new P,this.onSocketClose=this.x.event,this.y=new P,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??i.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new k.$Wc,this.o=l.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},h.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new p(g.Disconnect,0,0,f());this.p.write(l),this.p.flush()}sendPause(){const l=new p(g.Pause,0,0,f());this.p.write(l)}sendResume(){const l=new p(g.Resume,0,0,f());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,u){this.a=!0,this.r.dispose(),this.r=new k.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new p(g.Ack,0,this.h,f());this.p.write(l);const u=this.b.toArray();for(let S=0,y=u.length;S<y;S++)this.p.write(u[S]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const u=this.b.peek();if(u&&u.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case g.None:break;case g.Regular:{if(l.id>this.g)if(l.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new p(g.ReplayRequest,0,0,f())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case g.Control:{this.u.fire(l.data);break}case g.Ack:break;case g.Disconnect:{this.w.fire();break}case g.ReplayRequest:{const u=this.b.toArray();for(let S=0,y=u.length;S<y;S++)this.p.write(u[S]);this.B();break}case g.Pause:{this.p.pause();break}case g.Resume:{this.p.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const u=++this.c;this.h=this.g;const S=new p(g.Regular,u,this.h,l);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(l){const u=new p(g.Control,0,0,l);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=h.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},h.AcknowledgeTime-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),u=Date.now()-l.writtenTime,S=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(u>=h.TimeoutTime&&S>=h.TimeoutTime&&y>=h.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:S});return}const R=Math.max(h.TimeoutTime-u,h.TimeoutTime-S,h.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new p(g.Ack,0,this.h,f());this.p.write(l)}D(){this.h=this.g;const l=new p(g.KeepAlive,0,this.h,f());this.p.write(l)}}e.$ui=c}),define(oe[35],ae([0,1,14,16,12]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=void 0;class D{constructor(){this.a=new WeakMap}on(I,v){const a=(f,...d)=>{this.b(I,f)&&v(f,...d)};return this.a.set(v,a),n.ipcMain.on(I,a),this}once(I,v){return n.ipcMain.once(I,(a,...f)=>{this.b(I,a)&&v(a,...f)}),this}handle(I,v){return n.ipcMain.handle(I,(a,...f)=>this.b(I,a)?v(a,...f):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.ipcMain.removeHandler(I),this}removeListener(I,v){const a=this.a.get(v);return a&&(n.ipcMain.removeListener(I,a),this.a.delete(v)),this}b(I,v){if(!I||!I.startsWith("vscode:"))return(0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const a=v.senderFrame,f=a.url;if(!f||f==="about:blank")return!0;let d="unknown";try{d=new URL(f).host}catch{return(0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${f}'.`),!1}return d!==k.$Zg?((0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${d}'.`),!1):a.parent!==null?((0,o.$3)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${d}' is not a main frame.`),!1):!0}}e.$FX=new D}),define(oe[163],ae([0,1,14,35,151]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GX=D;function D(){o.$FX.on(k.$DX,(I,v,a,f,d)=>{const g=O(I,f,a);g.popup({x:d?d.x:void 0,y:d?d.y:void 0,positioningItem:d?d.positioningItem:void 0,callback:()=>{g&&I.sender.send(k.$EX,v)}})})}function O(I,v,a){const f=new n.Menu;return a.forEach(d=>{let g;d.type==="separator"?g=new n.MenuItem({type:d.type}):Array.isArray(d.submenu)?g=new n.MenuItem({submenu:O(I,v,d.submenu),label:d.label}):g=new n.MenuItem({label:d.label,type:d.type,accelerator:d.accelerator,checked:d.checked,enabled:d.enabled,visible:d.visible,click:(w,h,p)=>I.sender.send(v,d.id,p)}),f.append(g)}),f}}),define(oe[164],ae([0,1,35,17,4,2,44,152]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=void 0;function v(f,d){const g=k.Event.fromNodeEventEmitter(n.$FX,d,(h,p)=>({event:h,message:p})),w=k.Event.filter(g,({event:h})=>h.sender.id===f);return k.Event.map(w,({message:h})=>h&&o.$Pe.wrap(h))}class a extends O.$ki{static{this.b=new Map}static d(){const d=k.Event.fromNodeEventEmitter(n.$FX,"vscode:hello",({sender:g})=>g);return k.Event.map(d,g=>{const w=g.id;a.b.get(w)?.dispose();const p=new k.$ne;a.b.set(w,(0,D.$Vc)(()=>p.fire()));const b=v(w,"vscode:message"),$=k.Event.any(k.Event.signal(v(w,"vscode:disconnect")),p.event);return{protocol:new I.$LX(g,b),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$MX=a}),define(oe[119],ae([0,1,35,4,33,162]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=void 0,e.$OX=I;class O extends D.$JX{constructor(a,f){super({addEventListener:(d,g)=>a.addListener(d,g),removeEventListener:(d,g)=>a.removeListener(d,g),postMessage:d=>a.postMessage(d),start:()=>a.start(),close:()=>a.close()},f)}}e.$NX=O;async function I(v){if(v.isDestroyed()||v.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,k.$3g)();v.webContents.send("vscode:createMessageChannel",a);const f=o.Event.fromNodeEventEmitter(n.$FX,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:d}=await o.Event.toPromise(o.Event.once(o.Event.filter(f,g=>g.nonce===a)));return d}}),define(oe[165],ae([0,1,49,8,17,23,159,16,4,2,36,95,82,44]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,I=De(I);class h extends w.$ii{constructor($){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",m=>k.$Pe.wrap(Buffer.from(m,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$fr=h;class p{constructor($,m){this.i=$,this.j=m,this.c=new Set,this.g=new Map,this.h=new v.$ne,this.onDidProcessExit=this.h.event;const E=m&&m.timeout?m.timeout:6e4;this.b=new o.$Dh(E),this.d=null,this.f=null}getChannel($){const m=this;return{call(E,P,t){return m.k($,E,P,t)},listen(E,P){return m.l($,E,P)}}}k($,m,E,P=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(I.$9());this.b.cancel();const t=this.n($),r=(0,o.$th)(s=>t.call(m,E,s)),i=P.onCancellationRequested(()=>r.cancel()),c=(0,a.$Vc)(()=>r.cancel());return this.c.add(c),r.finally(()=>{i.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l($,m,E){if(!this.b)return v.Event.None;this.b.cancel();let P;const t=new v.$ne({onWillAddFirstListener:()=>{P=this.n($).listen(m,E)(t.fire,t),this.c.add(P)},onDidRemoveLastListener:()=>{this.c.delete(P),P.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,f.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,g.$mm)(m.env),this.d=(0,n.fork)(this.i,$,m);const E=new v.$ne,t=v.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,O.$br)(u)){(0,O.log)(u,`IPC Library: ${this.j.serverName}`);return}E.fire(k.$Pe.wrap(Buffer.from(u,"base64")))}),r=this.j.useQueue?(0,d.$zm)(this.d):this.d,i=u=>this.d&&this.d.connected&&r.send(u.buffer.toString("base64")),c=E.event,s={send:i,onMessage:c};this.f=new w.$ji(s);const l=()=>this.o();process.once("exit",l),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,S)=>{process.removeListener("exit",l),t.dispose(),this.c.forEach(y=>(0,a.$Sc)(y)),this.c.clear(),u!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:S})})}return this.f}n($){let m=this.g.get($);return m||(m=this.m.getChannel($),this.g.set($,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=p}),define(oe[120],ae([0,1,8,4,2,83,13]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=v;var I;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function v(g){const w=g;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends k.$Xc{static{this.a=100}constructor(w,h=Object.create(null)){super(),this.r=w,this.s=h,this.b=this.B(new o.$qe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new n.$Eh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((h,p)=>this.w(p,h)),w.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(w,h){if(this.c===a.Closed)return;let p=!1;(0,O.$pg)(h)?p=this.f.delete(w):this.f.get(w)!==h&&(this.f.set(w,h),p=!0),p&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,h){const p=this.f.get(w);return(0,O.$pg)(p)?h:p}getBoolean(w,h){const p=this.get(w);return(0,O.$pg)(p)?h:p==="true"}getNumber(w,h){const p=this.get(w);return(0,O.$pg)(p)?h:parseInt(p,10)}getObject(w,h){const p=this.get(w);return(0,O.$pg)(p)?h:(0,D.$ci)(p)}async set(w,h,p=!1){if(this.c===a.Closed)return;if((0,O.$pg)(h))return this.delete(w,p);const b=(0,O.$ig)(h)||Array.isArray(h)?(0,D.$bi)(h):String(h);if(this.f.get(w)!==b)return this.f.set(w,b),this.j.set(w,b),this.h.delete(w),this.b.fire({key:w,external:p}),this.D()}async delete(w,h=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:h}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$cq=f;class d{constructor(){this.onDidChangeItemsExternal=o.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((h,p)=>this.a.set(p,h)),w.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$dq=d}),define(oe[166],ae([0,1,8,4,32,10,21]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$X=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return o.Event.None}static{this.a=2e3}static{this.b=256}constructor(f,d=Object.create(null)){this.g=f,this.h=d,this.c=(0,D.$qc)(this.g),this.d=new v(this.h.logging),this.f=this.n(this.g)}async getItems(){const f=await this.f,d=new Map;return(await this.s(f,"SELECT * FROM ItemTable")).forEach(w=>d.set(w.key,w.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(f){const d=await this.f;return this.j(d,f)}j(f,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,k.$Bc)(d.insert):"0"}), delete(${d.delete?(0,k.$Cc)(d.delete):"0"})`),this.t(f,()=>{const g=d.insert,w=d.delete;if(g&&g.size>0){const h=[];h.push([]);let p=0;g.forEach((b,$)=>{let m=h[p];m.length>I.b&&(p++,m=[],h.push(m)),m.push($,b)}),h.forEach(b=>{this.u(f,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let m=0;return g.forEach((E,P)=>{$.push(P),m+=E.length}),`Keys: ${$.join(", ")} Length: ${m}`})})}if(w&&w.size){const h=[];h.push([]);let p=0;w.forEach(b=>{let $=h[p];$.length>I.b&&(p++,$=[],h.push($)),$.push(b)}),h.forEach(b=>{this.u(f,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return w.forEach(m=>{$.push(m)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const f=await this.f;return this.q(f,"VACUUM")}async close(f){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,f)}k(f,d){return new Promise((g,w)=>{f.db.close(h=>(h&&this.o(f,`[storage ${this.c}] close(): ${h}`),this.g===I.IN_MEMORY_PATH?g():!f.isErroneous&&!f.isInMemory?this.l().then(g,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),g())):typeof d=="function"?O.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const b=()=>this.k(p,void 0);return this.j(p,{insert:d()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(g,w):w(h||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const f=this.m(this.g);return O.Promises.copy(this.g,f,{preserveSymlinks:!1})}m(f){return`${f}.backup`}async checkIntegrity(f){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${f})`);const d=await this.f,g=await this.r(d,f?"PRAGMA integrity_check":"PRAGMA quick_check"),w=f?g.integrity_check:g.quick_check;return d.isErroneous?`${w} (last error: ${d.lastError})`:d.isInMemory?`${w} (in-memory!)`:w}async n(f,d=!0){this.d.trace(`[storage ${this.c}] open(${f}, retryOnBusy: ${d})`);try{return await this.p(f)}catch(g){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&d)return await(0,n.$Hh)(I.a),this.n(f,!1);try{await O.Promises.unlink(f);try{await O.Promises.rename(this.m(f),f,!1)}catch{}return await this.p(f)}catch(w){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${w}`),this.p(I.IN_MEMORY_PATH)}}}o(f,d){f.isErroneous=!0,f.lastError=d,this.d.error(d)}p(f){return new Promise((d,g)=>{new Promise((w,h)=>{x(["@vscode/sqlite3"],w,h)}).then(De).then(w=>{const h={db:new(this.d.isTracing?w.verbose().Database:w.Database)(f,p=>p?h.db&&p.code!=="SQLITE_CANTOPEN"?h.db.close(()=>g(p)):g(p):this.q(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(h),b=>h.db.close(()=>g(b)))),isInMemory:f===I.IN_MEMORY_PATH};h.db.on("error",p=>this.o(h,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&h.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},g)})}q(f,d){return new Promise((g,w)=>{f.db.exec(d,h=>h?(this.o(f,`[storage ${this.c}] exec(): ${h}`),w(h)):g())})}r(f,d){return new Promise((g,w)=>{f.db.get(d,(h,p)=>h?(this.o(f,`[storage ${this.c}] get(): ${h}`),w(h)):g(p))})}s(f,d){return new Promise((g,w)=>{f.db.all(d,(h,p)=>h?(this.o(f,`[storage ${this.c}] all(): ${h}`),w(h)):g(p))})}t(f,d){return new Promise((g,w)=>{f.db.serialize(()=>{f.db.run("BEGIN TRANSACTION"),d(),f.db.run("END TRANSACTION",h=>h?(this.o(f,`[storage ${this.c}] transaction(): ${h}`),w(h)):g())})})}u(f,d,g,w){const h=f.db.prepare(d),p=b=>{this.o(f,`[storage ${this.c}] prepare(): ${b} (${d}). Details: ${w()}`)};h.on("error",p),g(h),h.finalize(b=>{b&&p(b),h.removeListener("error",p)})}}e.$$X=I;class v{static{this.a="VSCODE_TRACE_STORAGE"}constructor(f){f&&typeof f.logTrace=="function"&&process.env[v.a]&&(this.b=f.logTrace),f&&typeof f.logError=="function"&&(this.c=f.logError)}get isTracing(){return!!this.b}trace(f){this.b?.(f)}error(f){this.c?.(f)}}}),define(oe[167],ae([11,9]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(oe[168],ae([11,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[169],ae([11,9]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[170],ae([11,9]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(oe[171],ae([11,9]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[172],ae([11,9]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[173],ae([11,9]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(oe[174],ae([11,9]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(oe[175],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[176],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[177],ae([11,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[178],ae([11,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[179],ae([11,9]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[180],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(oe[181],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(oe[182],ae([11,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(oe[183],ae([11,9]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[184],ae([11,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[185],ae([11,9]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[186],ae([11,9]),function(x,e){return x.create("vs/platform/issue/electron-main/processMainService",e)}),define(oe[187],ae([11,9]),function(x,e){return x.create("vs/platform/log/common/log",e)}),define(oe[188],ae([11,9]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[189],ae([11,9]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[190],ae([11,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(oe[191],ae([11,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(oe[192],ae([11,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[193],ae([11,9]),function(x,e){return x.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[194],ae([11,9]),function(x,e){return x.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[195],ae([11,9]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[196],ae([11,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[197],ae([11,9]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[198],ae([11,9]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[199],ae([11,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(oe[200],ae([11,9]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[201],ae([11,9]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[202],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whb=n,e.$Xhb=o;function n(k){return k&&k.hasOwnProperty("folderUri")}function o(k){return k&&k.hasOwnProperty("workspace")}}),define(oe[203],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=o,e.$Sec=k,e.$Tec=D;function o(O){return typeof O?.backupFolder=="string"}function k(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(v=>({workspace:{id:v.id,configPath:n.URI.parse(v.configURIPath)},remoteAuthority:v.remoteAuthority})))}catch{}return I}function D(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(v=>({folderUri:n.URI.parse(v.folderUri),remoteAuthority:v.remoteAuthority})))}catch{}return I}}),define(oe[204],ae([0,1,39,16,170]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var D;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(D||(e.TokenType=D={}));function O(...f){switch(f.length){case 1:return(0,k.localize)(0,null,f[0]);case 2:return(0,k.localize)(1,null,f[0],f[1]);case 3:return(0,k.localize)(2,null,f[0],f[1],f[2]);default:return}}const I=(0,k.localize)(3,null),v=(0,k.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return d.isTripleEq?"===":"==";case D.NotEq:return d.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return d.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return d.lexeme;case D.QuotedStr:return d.lexeme;case D.Error:return d.lexeme;case D.EOF:return"EOF";default:throw(0,o.$$)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:g})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:g})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(O("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(O("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(O("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const g=this.d,w=this.c.substring(this.d,this.e),h={type:D.Error,offset:this.d,lexeme:w};this.g.push({offset:g,lexeme:w,additionalInfo:d}),this.f.push(h)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const g=this.c.substring(this.d,this.e),w=a.b.get(g);w?this.k(w):this.f.push({type:D.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,g=!1,w=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(v);return}const p=this.c.charCodeAt(d);if(g)g=!1;else if(p===n.CharCode.Slash&&!w){d++;break}else p===n.CharCode.OpenSquareBracket?w=!0:p===n.CharCode.Backslash?g=!0:p===n.CharCode.CloseSquareBracket&&(w=!1);d++}for(;d<this.c.length&&a.a.has(this.c.charCodeAt(d));)d++;this.e=d;const h=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=a}),define(oe[205],ae([0,1,4,2]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;class k{constructor(){this.a=new n.$ne,this.b=new n.$ne,this.c=new n.$ne,this.d=new n.$ne}static{this.ChannelName="extensionhostdebugservice"}call(I,v,a){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(I,v,a){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Xo=k;class D extends o.$Xc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,v,a){this.b.call("attach",[I,v,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,v){this.b.call("terminate",[I,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,v){return this.b.call("openExtensionDevelopmentHostWindow",[I,v])}}e.$Yo=D}),define(oe[206],ae([0,1,154,54,12,10,37,19,7]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=f,e.$8m=d,e.$5m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,D.$pc)(k.$1g.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,D.$mc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,I.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$mc)(this.userDataPath,"logs",w)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$hh)(v.URI.file((0,D.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=O.env.VSCODE_PORTABLE;return w?v.URI.file((0,D.$mc)(w,"argv.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,D.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.$nc)(w):(0,D.$kc)((0,D.$mc)(k.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?v.URI.file((0,D.$nc)(w)):v.URI.file((0,D.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.$nc)(w);const h=O.env.VSCODE_EXTENSIONS;if(h)return h;const p=O.env.VSCODE_PORTABLE;return p?(0,D.$mc)(p,"extensions"):(0,I.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(h=>/^[^:/?#]+?:\/\//.test(h)?v.URI.parse(h):v.URI.file((0,D.$kc)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?v.URI.parse(w):v.URI.file((0,D.$kc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$5m.test(w))}get extensionLogLevel(){const w=[];for(const h of this.args.log||[]){const p=e.$5m.exec(h);p&&p[1]&&p[2]&&w.push([p[1],p[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$hh)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=O.env.VSCODE_PORTABLE;return w?v.URI.file((0,D.$mc)(w,"policy.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,h,p){this.a=w,this.b=h,this.c=p,this.editSessionId=this.args.editSessionId}}e.$6m=a,ke([o.$$h],a.prototype,"appRoot",null),ke([o.$$h],a.prototype,"userHome",null),ke([o.$$h],a.prototype,"userDataPath",null),ke([o.$$h],a.prototype,"appSettingsHome",null),ke([o.$$h],a.prototype,"tmpDir",null),ke([o.$$h],a.prototype,"cacheHome",null),ke([o.$$h],a.prototype,"stateResource",null),ke([o.$$h],a.prototype,"userRoamingDataHome",null),ke([o.$$h],a.prototype,"userDataSyncHome",null),ke([o.$$h],a.prototype,"sync",null),ke([o.$$h],a.prototype,"machineSettingsResource",null),ke([o.$$h],a.prototype,"workspaceStorageHome",null),ke([o.$$h],a.prototype,"localHistoryHome",null),ke([o.$$h],a.prototype,"keyboardLayoutResource",null),ke([o.$$h],a.prototype,"argvResource",null),ke([o.$$h],a.prototype,"isExtensionDevelopment",null),ke([o.$$h],a.prototype,"untitledWorkspacesHome",null),ke([o.$$h],a.prototype,"builtinExtensionsPath",null),ke([o.$$h],a.prototype,"extensionsPath",null),ke([o.$$h],a.prototype,"extensionDevelopmentLocationURI",null),ke([o.$$h],a.prototype,"extensionDevelopmentKind",null),ke([o.$$h],a.prototype,"extensionTestsLocationURI",null),ke([o.$$h],a.prototype,"debugExtensionHost",null),ke([o.$$h],a.prototype,"logLevel",null),ke([o.$$h],a.prototype,"extensionLogLevel",null),ke([o.$$h],a.prototype,"serviceMachineIdResource",null),ke([o.$$h],a.prototype,"disableTelemetry",null),ke([o.$$h],a.prototype,"disableWorkspaceTrust",null),ke([o.$$h],a.prototype,"useInMemorySecretStorage",null),ke([o.$$h],a.prototype,"policyFile",null);function f(g,w){return d(g["inspect-extensions"],g["inspect-brk-extensions"],5870,w,g.debugId,g.extensionEnvironment)}function d(g,w,h,p,b,$){const E=Number(w||g)||(p?null:h),P=E?!!w:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:E,break:P,debugId:b,env:t}}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[121],ae([0,1,319,3,173]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=I,e.$Em=a,e.$Fm=w,e.$Gm=h,n=et(n);const D={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,b,$=O){const m=p.find(u=>u.length>0&&u[0]!=="-"),E={},P=["_"],t=[],r={};let i;for(const u in b){const S=b[u];S.type==="subcommand"?u===m&&(i=S):(S.alias&&(E[u]=S.alias),S.type==="string"||S.type==="string[]"?(P.push(u),S.deprecates&&P.push(...S.deprecates)):S.type==="boolean"&&(t.push(u),S.deprecates&&t.push(...S.deprecates)),S.global&&(r[u]=S))}if(i&&m){const u=r;for(const L in i.options)u[L]=i.options[L];const S=p.filter(L=>L!==m),y=$.getSubcommandReporter?$.getSubcommandReporter(m):void 0,R=I(S,u,y);return{[m]:R,_:[]}}const c=(0,n.default)(p,{string:P,boolean:t,alias:E}),s={},l=c;s._=c._.map(u=>String(u)).filter(u=>u.length>0),delete l._;for(const u in b){const S=b[u];if(S.type==="subcommand")continue;S.alias&&delete l[S.alias];let y=l[u];if(S.deprecates)for(const R of S.deprecates)l.hasOwnProperty(R)&&(y||(y=l[R],y&&$.onDeprecatedOption(R,S.deprecationMessage||(0,k.localize)(39,null,u))),delete l[R]);if(typeof y<"u"){if(S.type==="string[]"){if(Array.isArray(y)||(y=[y]),!S.allowEmptyValue){const R=y.filter(L=>L.length>0);R.length!==y.length&&($.onEmptyValue(u),y=R.length>0?R:void 0)}}else S.type==="string"&&(Array.isArray(y)?(y=y.pop(),$.onMultipleValues(u,y)):!y&&!S.allowEmptyValue&&($.onEmptyValue(u),y=void 0));s[u]=y,S.deprecationMessage&&$.onDeprecatedOption(u,S.deprecationMessage)}delete l[u]}for(const u in l)$.onUnknownOption(u);return s}function v(p,b){let $="";return b.args&&(Array.isArray(b.args)?$=` <${b.args.join("> <")}>`:$=` <${b.args}>`),b.alias?`-${b.alias} --${p}${$}`:`--${p}${$}`}function a(p,b){const $=[];for(const m in p){const E=p[m],P=v(m,E);$.push([P,E.description])}return f($,b)}function f(p,b){const m=p.reduce((t,r)=>Math.max(t,r[0].length),12)+2+1;if(b-m<25)return p.reduce((t,r)=>t.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const E=b-m-1,P=[];for(const t of p){const r=t[0],i=g(t[1],E),c=d(m-r.length-2);P.push("  "+r+c+i[0]);for(let s=1;s<i.length;s++)P.push(d(m)+i[s])}return P}function d(p){return" ".repeat(p)}function g(p,b){const $=[];for(;p.length;){const m=p.length<b?p.length:p.lastIndexOf(" ",b),E=p.slice(0,m).trim();p=p.slice(m),$.push(E)}return $}function w(p,b,$,m,E){const P=process.stdout.isTTY&&process.stdout.columns||80,t=E?.noInputFiles!==!0?`[${(0,k.localize)(40,null)}...]`:"",r=[`${p} ${$}`];r.push(""),r.push(`${(0,k.localize)(41,null)}: ${b} [${(0,k.localize)(42,null)}]${t}`),r.push(""),E?.noPipe!==!0&&(o.$i?r.push((0,k.localize)(43,null,b)):r.push((0,k.localize)(44,null,b)),r.push(""));const i={},c=[];for(const s in m){const l=m[s];if(l.type==="subcommand")l.description&&c.push({command:s,description:l.description});else if(l.description&&l.cat){let u=i[l.cat];u||(i[l.cat]=u={}),u[s]=l}}for(const s in i){const l=s,u=i[l];u&&(r.push(D[l]),r.push(...a(u,P)),r.push(""))}return c.length&&(r.push((0,k.localize)(45,null)),r.push(...f(c.map(s=>[s.command,s.description]),P)),r.push("")),r.join(`
`)}function h(p,b){return`${p||(0,k.localize)(46,null)}
${b||(0,k.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[69],ae([0,1,320,174,121]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=I,e.$Im=v,e.$Jm=a,e.$Km=f,n=et(n);function D(d,g){const w=(E,P)=>{console.warn((0,o.localize)(0,null,E,P))},h=E=>{console.warn((0,o.localize)(1,null,E))},p=(E,P)=>{console.warn((0,o.localize)(2,null,E,P))},b=E=>({onUnknownOption:P=>{k.$Bm.includes(E)||console.warn((0,o.localize)(3,null,P,E))},onMultipleValues:w,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:k.$Bm.includes(E)?b:void 0}),$={onUnknownOption:E=>{console.warn((0,o.localize)(4,null,E))},onMultipleValues:w,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:b},m=(0,k.$Dm)(d,k.$Cm,g?$:void 0);return m.goto&&m._.forEach(E=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(E),(0,o.localize)(5,null))),m}function O(d){const g=d.findIndex(w=>!/^-/.test(w));if(g>-1)return[...d.slice(0,g),...d.slice(g+1)]}function I(d){let[,...g]=d;process.env.VSCODE_DEV&&(g=O(g)||[]);const w=!f(process.env);return D(g,w)}function v(d){let[,,...g]=d;return process.env.VSCODE_DEV&&(g=O(g)||[]),D(g,!0)}function a(d,...g){const w=d.indexOf("--");return w===-1?d.push(...g):d.splice(w,0,...g),d}function f(d){return d.VSCODE_CLI==="1"}}),function(){"use strict";function x(e,n,o){function k(O,I){const v=D(O,I),a=[v];return e.isAbsolute(v)||a.unshift(o),e.resolve(...a)}function D(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const f=O["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(d,"AppData","Roaming")}break;case"darwin":a=e.join(n.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:k}}if(typeof define=="function")define(oe[207],ae([122,27,37]),function(e,n,o){return x(e,n,o.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[96],ae([0,1,27,206,207]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=O,e.$$m=I;class D extends o.$6m{constructor(a,f){super(a,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,f.nameShort)},f)}}e.$9m=D;function O(v,a){return(0,o.$8m)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,a,v.extensionEnvironment)}function I(v,a){return(0,o.$8m)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,a,v.extensionEnvironment)}}),define(oe[208],ae([0,1,47,27,31]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=D;function D(O){const I=(0,k.$Og)((0,o.tmpdir)());try{return(0,n.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(v){O&&console.error(`Failed to create marker file for --wait: ${v}`);return}}}),define(oe[209],ae([0,1,13,176]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=k;function k(O,I,v,a){try{D(O,I,v,a)}catch(f){O.error(f?.message??f)}return I}function D(O,I,v,a){const f=(d,g,w)=>{const h=d[g];if((0,n.$gg)(h)){const p=h,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const $=p.substr(1,b-2);let m=v[$];m===void 0&&a&&(m=a[$]);const E=typeof m=="string"?m:m?.message,P=a?.[$],t=typeof P=="string"?P:P?.message;if(!E){t||O.warn(`[${I.name}]: ${(0,o.localize)(0,null,$)}`);return}if(w&&(g==="title"||g==="category")&&t&&t!==E){const r={value:E,original:t};d[g]=r}else d[g]=E}}else if((0,n.$ig)(h))for(const p in h)h.hasOwnProperty(p)&&(p==="commands"?f(h,p,!0):f(h,p,w));else if(Array.isArray(h))for(let p=0;p<h.length;p++)f(h,p,w)};for(const d in I)I.hasOwnProperty(d)&&f(I,d)}}),define(oe[210],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(oe[84],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(k,D=[],O=!1){this.ctor=k,this.staticArguments=D,this.supportsDelayedInstantiation=O}}e.$Di=n}),define(oe[211],ae([0,1,84]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=D,e.$Qs=O;const o=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function D(I,v,a){v instanceof n.$Di||(v=new n.$Di(v,[],!!a)),o.push([I,v])}function O(){return o}}),define(oe[212],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class n{constructor(D,O){this.key=D,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$sr=n;class o{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const O of this.a.values())O.outgoing.size===0&&D.push(O);return D}insertEdge(D,O){const I=this.lookupOrInsertNode(D),v=this.lookupOrInsertNode(O);I.outgoing.set(v.key,v),v.incoming.set(I.key,I)}removeNode(D){const O=this.b(D);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(D){const O=this.b(D);let I=this.a.get(O);return I||(I=new n(O,D),this.a.set(O,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[O,I]of this.a)D.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,O]of this.a){const I=new Set([D]),v=this.c(O,I);if(v)return v}}c(D,O){for(const[I,v]of D.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const a=this.c(v,O);if(a)return a;O.delete(I)}}}e.$tr=o}),define(oe[6],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=k,e.$Hi=D;var n;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(v){return v[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(n||(e._util=n={})),e.$Fi=k("instantiationService");function o(O,I,v){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:O,index:v}):(I[n.DI_DEPENDENCIES]=[{id:O,index:v}],I[n.DI_TARGET]=I)}function k(O){if(n.serviceIds.has(O))return n.serviceIds.get(O);const I=function(v,a,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");o(I,v,f)};return I.toString=()=>O,n.serviceIds.set(O,I),I}function D(O){return O}}),define(oe[85],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0,e.$Lfc=(0,n.$Gi)("auxiliaryWindowsMainService")}),define(oe[70],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0,e.$Uec=(0,n.$Gi)("backupMainService")}),define(oe[18],ae([0,1,13,7,6]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=D,e.$cj=O,e.$dj=v,e.$ej=a,e.$fj=f,e.$gj=d,e.$hj=g,e.$ij=h,e.$jj=p,e.$kj=b,n=De(n),e.$aj=(0,k.$Gi)("configurationService");function D($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof o.URI)}function O($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof o.URI)}var I;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function v($){switch($){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function f($,m){const E=Object.create(null);for(const P in $)d(E,P,$[P],m);return E}function d($,m,E,P){const t=m.split("."),r=t.pop();let i=$;for(let c=0;c<t.length;c++){const s=t[c];let l=i[s];switch(typeof l){case"undefined":l=i[s]=Object.create(null);break;case"object":if(l===null){P(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is null`);return}break;default:P(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[r]=E}catch{P(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}else P(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}function g($,m){const E=m.split(".");w($,E)}function w($,m){const E=m.shift();if(m.length===0){delete $[E];return}if(Object.keys($).indexOf(E)!==-1){const P=$[E];typeof P=="object"&&!Array.isArray(P)&&(w(P,m),Object.keys(P).length===0&&delete $[E])}}function h($,m,E){function P(i,c){let s=i;for(const l of c){if(typeof s!="object"||s===null)return;s=s[l]}return s}const t=m.split("."),r=P($,t);return typeof r>"u"?E:r}function p($,m,E){Object.keys(m).forEach(P=>{P!=="__proto__"&&(P in $?n.$ig($[P])&&n.$ig(m[P])?p($[P],m[P],E):E&&($[P]=m[P]):$[P]=m[P])})}function b($){return $.replace(/[\[\]]/g,"")}}),define(oe[123],ae([0,1,39,3,26,204,6,169,16]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=f,e.$Fj=c,e.$Gj=s,e.$Zj=K;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",o.$j),a.set("isLinux",o.$k),a.set("isWindows",o.$i),a.set("isWeb",o.$o),a.set("isMacNative",o.$j&&!o.$o),a.set("isEdge",o.$H),a.set("isFirefox",o.$F),a.set("isChrome",o.$E),a.set("isSafari",o.$G);function f(_,F){if(a.get(_)!==void 0)throw(0,v.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,F)}const d=Object.prototype.hasOwnProperty;var g;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const w={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),p=(0,I.localize)(1,null),b=(0,I.localize)(2,null),$=(0,I.localize)(3,null),m=(0,I.localize)(4,null),E=(0,I.localize)(5,null),P=(0,I.localize)(6,null),t=(0,I.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=w){this.k=F,this.d=new D.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const W=this.D(),H=W.type===D.TokenType.Str?E:void 0;throw this.h.push({message:m,offset:W.offset,lexeme:D.$Bj.getLexeme(W),additionalInfo:H}),r.c}return N}catch(N){if(N!==r.c)throw N;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(D.TokenType.Or);){const N=this.o();F.push(N)}return F.length===1?F[0]:i.or(...F)}o(){const F=[this.s()];for(;this.y(D.TokenType.And);){const N=this.s();F.push(N)}return F.length===1?F[0]:i.and(...F)}s(){if(this.y(D.TokenType.Neg)){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),u.INSTANCE;case D.TokenType.False:return this.z(),S.INSTANCE;case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N?.negate()}case D.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),i.true();case D.TokenType.False:return this.z(),i.false();case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N}case D.TokenType.Str:{const N=F.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==D.TokenType.RegexStr)throw this.B("REGEX",H);const J=H.lexeme,Y=J.lastIndexOf("/"),V=Y===J.length-1?void 0:this.w(J.substring(Y+1));let ie;try{ie=new RegExp(J.substring(1,Y),V)}catch{throw this.B("REGEX",H)}return le.create(N,ie)}switch(H.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const J=[H.lexeme];this.z();let Y=this.D(),V=0;for(let Oe=0;Oe<H.lexeme.length;Oe++)H.lexeme.charCodeAt(Oe)===n.CharCode.OpenParen?V++:H.lexeme.charCodeAt(Oe)===n.CharCode.CloseParen&&V--;for(;!this.E()&&Y.type!==D.TokenType.And&&Y.type!==D.TokenType.Or;){switch(Y.type){case D.TokenType.LParen:V++;break;case D.TokenType.RParen:V--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Oe=0;Oe<Y.lexeme.length;Oe++)Y.lexeme.charCodeAt(Oe)===n.CharCode.OpenParen?V++:H.lexeme.charCodeAt(Oe)===n.CharCode.CloseParen&&V--}if(V<0)break;J.push(D.$Bj.getLexeme(Y)),this.z(),Y=this.D()}const ie=J.join(""),de=ie.lastIndexOf("/"),me=de===ie.length-1?void 0:this.w(ie.substring(de+1));let we;try{we=new RegExp(ie.substring(1,de),me)}catch{throw this.B("REGEX",H)}return i.regex(N,we)}case D.TokenType.QuotedStr:{const J=H.lexeme;this.z();let Y=null;if(!(0,k.$ef)(J)){const V=J.indexOf("/"),ie=J.lastIndexOf("/");if(V!==ie&&V>=0){const de=J.slice(V+1,ie),me=J[ie+1]==="i"?"i":"";try{Y=new RegExp(de,me)}catch{throw this.B("REGEX",H)}}}if(Y===null)throw this.B("REGEX",H);return le.create(N,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,b);const H=this.u();return i.notIn(N,H)}switch(this.D().type){case D.TokenType.Eq:{this.z();const H=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.equals(N,H);switch(H){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,H)}}case D.TokenType.NotEq:{this.z();const H=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.notEquals(N,H);switch(H){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,H)}}case D.TokenType.Lt:return this.z(),re.create(N,this.u());case D.TokenType.LtEq:return this.z(),Z.create(N,this.u());case D.TokenType.Gt:return this.z(),C.create(N,this.u());case D.TokenType.GtEq:return this.z(),z.create(N,this.u());case D.TokenType.In:return this.z(),i.in(N,this.u());default:return i.has(N)}}case D.TokenType.EOF:throw this.h.push({message:P,offset:F.offset,lexeme:"",additionalInfo:t}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),F.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,N){if(this.C(F))return this.z();throw this.B(N,this.D())}B(F,N,W){const H=(0,I.localize)(8,null,F,D.$Bj.getLexeme(N)),J=N.offset,Y=D.$Bj.getLexeme(N);return this.h.push({message:H,offset:J,lexeme:Y,additionalInfo:W}),r.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Dj=r;class i{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(F){return y.create(F)}static equals(F,N){return R.create(F,N)}static notEquals(F,N){return A.create(F,N)}static regex(F,N){return le.create(F,N)}static in(F,N){return L.create(F,N)}static notIn(F,N){return T.create(F,N)}static not(F){return M.create(F)}static and(...F){return q.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,N){return C.create(F,N)}static greaterEquals(F,N){return z.create(F,N)}static smaller(F,N){return re.create(F,N)}static smallerEquals(F,N){return Z.create(F,N)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Ej=i;function c(_){const F=new r({regexParsingWithErrorRecovery:!1});return _.map(N=>(F.parse(N),F.lexingErrors.length>0?F.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,I.localize)(9,null,W.additionalInfo):(0,I.localize)(10,null),offset:W.offset,length:W.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(_,F){const N=_?_.substituteConstants():void 0,W=F?F.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}function l(_,F){return _.cmp(F)}class u{static{this.INSTANCE=new u}constructor(){this.type=g.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}e.$Hj=u;class S{static{this.INSTANCE=new S}constructor(){this.type=g.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return u.INSTANCE}}e.$Ij=S;class y{static create(F,N=null){const W=a.get(F);return typeof W=="boolean"?W?S.INSTANCE:u.INSTANCE:new y(F,N)}constructor(F,N){this.key=F,this.c=N,this.type=g.Defined}cmp(F){return F.type!==this.type?this.type-F.type:G(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=a.get(this.key);return typeof F=="boolean"?F?S.INSTANCE:u.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Jj=y;class R{static create(F,N,W=null){if(typeof N=="boolean")return N?y.create(F,W):M.create(F,W);const H=a.get(F);return typeof H=="boolean"?N===(H?"true":"false")?S.INSTANCE:u.INSTANCE:new R(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Equals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?S.INSTANCE:u.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Kj=R;class L{static create(F,N){return new L(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.f),W=F.getValue(this.d);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?d.call(N,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Lj=L;class T{static create(F,N){return new T(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.NotIn,this.c=L.create(F,N)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=T;class A{static create(F,N,W=null){if(typeof N=="boolean")return N?M.create(F,W):y.create(F,W);const H=a.get(F);return typeof H=="boolean"?N===(H?"true":"false")?u.INSTANCE:S.INSTANCE:new A(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?u.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Nj=A;class M{static create(F,N=null){const W=a.get(F);return typeof W=="boolean"?W?u.INSTANCE:S.INSTANCE:new M(F,N)}constructor(F,N){this.c=F,this.d=N,this.type=g.Not}cmp(F){return F.type!==this.type?this.type-F.type:G(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=a.get(this.c);return typeof F=="boolean"?F?u.INSTANCE:S.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Oj=M;function U(_,F){if(typeof _=="string"){const N=parseFloat(_);isNaN(N)||(_=N)}return typeof _=="string"||typeof _=="number"?F(_):u.INSTANCE}class C{static create(F,N,W=null){return U(N,H=>new C(F,H,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Greater}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Pj=C;class z{static create(F,N,W=null){return U(N,H=>new z(F,H,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Qj=z;class re{static create(F,N,W=null){return U(N,H=>new re(F,H,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Rj=re;class Z{static create(F,N,W=null){return U(N,H=>new Z(F,H,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Sj=Z;class le{static create(F,N){return new le(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return N<W?-1:N>W?1:0}equals(F){if(F.type===this.type){const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return this.d===F.d&&N===W}return!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Tj=le;class X{static create(F){return new X(F)}constructor(F){this.c=F,this.type=g.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new X(this.c.map(F))}negate(){return this.c}}e.$Uj=X;function ee(_){let F=null;for(let N=0,W=_.length;N<W;N++){const H=_[N].substituteConstants();if(_[N]!==H&&F===null){F=[];for(let J=0;J<N;J++)F[J]=_[J]}F!==null&&(F[N]=H)}return F===null?_:F}class q{static create(F,N,W){return q.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const H=l(this.expr[N],F.expr[N]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:q.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(F))return!1;return!0}static d(F,N,W){const H=[];let J=!1;for(const Y of F)if(Y){if(Y.type===g.True){J=!0;continue}if(Y.type===g.False)return u.INSTANCE;if(Y.type===g.And){H.push(...Y.expr);continue}H.push(Y)}if(H.length===0&&J)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(l);for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];for(;H.length>1;){const Y=H[H.length-1];if(Y.type!==g.Or)break;H.pop();const V=H.pop(),ie=H.length===0,de=j.create(Y.expr.map(me=>q.create([me,V],null,W)),null,ie);de&&(H.push(de),H.sort(l))}if(H.length===1)return H[0];if(W){for(let Y=0;Y<H.length;Y++)for(let V=Y+1;V<H.length;V++)if(H[Y].negate().equals(H[V]))return u.INSTANCE;if(H.length===1)return H[0]}return new q(H,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new q(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Vj=q;class j{static create(F,N,W){return j.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const H=l(this.expr[N],F.expr[N]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(F))return!0;return!1}static d(F,N,W){let H=[],J=!1;if(F){for(let Y=0,V=F.length;Y<V;Y++){const ie=F[Y];if(ie){if(ie.type===g.False){J=!0;continue}if(ie.type===g.True)return S.INSTANCE;if(ie.type===g.Or){H=H.concat(ie.expr);continue}H.push(ie)}}if(H.length===0&&J)return u.INSTANCE;H.sort(l)}if(H.length!==0){if(H.length===1)return H[0];for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];if(W){for(let Y=0;Y<H.length;Y++)for(let V=Y+1;V<H.length;V++)if(H[Y].negate().equals(H[V]))return S.INSTANCE;if(H.length===1)return H[0]}return new j(H,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new j(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());for(;F.length>1;){const N=F.shift(),W=F.shift(),H=[];for(const J of se(N))for(const Y of se(W))H.push(q.create([J,Y],null,!1));F.unshift(j.create(H,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Wj=j;class B extends y{static{this.d=[]}static all(){return B.d.values()}constructor(F,N,W){super(F,null),this.f=N,typeof W=="object"?B.d.push({...W,key:F}):W!==!0&&B.d.push({key:F,description:W,type:N!=null?typeof N:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return R.create(this.key,F)}notEqualsTo(F){return A.create(this.key,F)}}e.$Xj=B,e.$Yj=(0,O.$Gi)("contextKeyService");function G(_,F){return _<F?-1:_>F?1:0}function ce(_,F,N,W){return _<N?-1:_>N?1:F<W?-1:F>W?1:0}function K(_,F){if(_.type===g.False||F.type===g.True)return!0;if(_.type===g.Or)return F.type===g.Or?he(_.expr,F.expr):!1;if(F.type===g.Or){for(const N of F.expr)if(K(_,N))return!0;return!1}if(_.type===g.And){if(F.type===g.And)return he(F.expr,_.expr);for(const N of _.expr)if(K(N,F))return!0;return!1}return _.equals(F)}function he(_,F){let N=0,W=0;for(;N<_.length&&W<F.length;){const H=_[N].cmp(F[W]);if(H<0)return!1;H===0&&N++,W++}return N===_.length}function se(_){return _.type===g.Or?_.expr:[_]}}),define(oe[97],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=o,e.ID="diagnosticsService",e.$Tm=(0,n.$Gi)(e.ID);function o(D){return!!D.hostName&&!!D.errorMessage}class k{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Vm=k});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[124],ae([0,1,19,81,171,6,48,3,36]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$9w=e.$8w=e.$7w=void 0,e.$0w=w,e.$$w=h,o=et(o),e.$7w=(0,D.$Gi)("dialogService");var a;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(a||(a={}));class f{a(b){return this.d(b,a.Confirmation)}b(b){return this.d(b,a.Prompt)}c(b){return this.d(b,a.Input)}d(b,$){const m=[];switch($){case a.Confirmation:{const E=b;E.primaryButton?m.push(E.primaryButton):m.push((0,k.localize)(0,null)),E.cancelButton?m.push(E.cancelButton):m.push((0,k.localize)(1,null));break}case a.Prompt:{const E=b;Array.isArray(E.buttons)&&E.buttons.length>0&&m.push(...E.buttons.map(P=>P.label)),E.cancelButton&&(E.cancelButton===!0?m.push((0,k.localize)(2,null)):typeof E.cancelButton=="string"?m.push(E.cancelButton):E.cancelButton.label?m.push(E.cancelButton.label):m.push((0,k.localize)(3,null))),m.length===0&&m.push((0,k.localize)(4,null));break}case a.Input:{const E=b;E.primaryButton?m.push(E.primaryButton):m.push((0,k.localize)(5,null)),E.cancelButton?m.push(E.cancelButton):m.push((0,k.localize)(6,null));break}}return m}e(b){if(typeof b=="string")return b;if(typeof b=="number")return b===o.default.Info?"info":b===o.default.Error?"error":b===o.default.Warning?"warning":"none"}f(b,$,m){const E=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&E.push(b.cancelButton);let P=E[$]?.run({checkboxChecked:m});return P instanceof Promise||(P=Promise.resolve(P)),{result:P,checkboxChecked:m}}}e.$8w=f,e.$9w=(0,D.$Gi)("fileDialogService");var d;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const g=10;function w(p){const b=[];return b.push(...p.slice(0,g).map($=>typeof $=="string"?$:(0,n.$eh)($))),p.length>g&&(p.length-g===1?b.push((0,k.localize)(7,null)):b.push((0,k.localize)(8,null,p.length-g))),b.push(""),b.join(`
`)}function h(p,b){const $=(0,v.$eo)(p);let m=($.buttons??[]).map(r=>(0,O.$4w)(r)),E=(p.buttons||[]).map((r,i)=>i),P=0,t=$.cancelId??m.length-1;if(m.length>1){const r=typeof t=="number"?m[t]:void 0;if(I.$k||I.$j){if(typeof r=="string"&&m.length>1&&t!==1){m.splice(t,1),m.splice(1,0,r);const i=E[t];E.splice(t,1),E.splice(1,0,i),t=1}I.$k&&m.length>1&&(m=m.reverse(),E=E.reverse(),P=m.length-1,typeof r=="string"&&(t=P-1))}else if(I.$i&&typeof r=="string"&&m.length>1&&t!==m.length-1){m.splice(t,1),m.push(r);const i=E[t];E.splice(t,1),E.push(i),t=m.length-1}}return $.buttons=m,$.defaultId=P,$.cancelId=t,$.noLink=!0,$.title=$.title||b.nameLong,{options:$,buttonIndeces:E}}}),define(oe[98],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$oY=e.$nY=void 0,e.$pY=D,e.$qY=O,e.$nY=(0,n.$Gi)("encryptionService"),e.$oY=(0,n.$Gi)("encryptionMainService");var o;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(o||(e.PasswordStoreCLIOption=o={}));var k;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function D(I){return I===k.kwallet||I===k.kwallet5||I===k.kwallet6}function O(I){return I===k.gnomeAny||I===k.gnomeLibsecret||I===k.gnomeKeyring}}),define(oe[38],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,n.$Gi)("environmentService"),e.$Oi=(0,n.$Hi)(e.$Ni)}),define(oe[213],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=e.$Afc=void 0,e.$Afc=(0,n.$Gi)("extensionHostStarter"),e.$Bfc="extensionHostStarter"}),define(oe[214],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=void 0,e.$Q9b=(0,n.$Gi)("externalTerminal"),e.$R9b="Terminal.app"}),define(oe[215],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0,e.$Dfc=(0,n.$Gi)("externalTerminal")}),define(oe[216],ae([0,1,49,54,12,10,3,82,21,95,179,214]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=e.$Efc=void 0,n=De(n),D=De(D),O=De(O),v=De(v),a=De(a),f=De(f);const g=f.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends w{static{this.b="cmd.exe"}openTerminal(t,r){return this.spawnTerminal(n,t,a.$ym(),r)}spawnTerminal(t,r,i,c){const s=r.windowsExec||h.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const l=D.$qc(s,".exe").toLowerCase();if(l==="cmder")return t.spawn(s,c?[c]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return s.indexOf(" ")>=0&&u.push('""'),u.push(s),l==="wt"&&u.push("-d ."),new Promise((S,y)=>{const R=$(process),L=t.spawn(i,u,{cwd:c,env:R,detached:!0});L.on("error",y),L.on("exit",()=>S())})}async runInTerminal(t,r,i,c,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows(),u=await h.f();return new Promise((S,y)=>{const R=`"${r} - ${g}"`,L=`"${i.join('" "')}" & pause`,T=Object.assign({},$(process),c);Object.keys(T).filter(z=>T[z]===null).forEach(z=>delete T[z]);const A={cwd:r,env:T,windowsVerbatimArguments:!0};let M,U;D.$qc(l,".exe")==="wt"?(M=l,U=["-d",".",h.b,"/c",L]):u?(M=u,U=["-d",".",l,"/c",L]):(M=h.b,U=["/c","start",R,"/wait",l,"/c",`"${L}"`]),n.spawn(M,U,A).on("error",z=>{y(m(z))}),S(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return h.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await v.Promises.exists(t)?t:void 0}catch{return}}}e.$Efc=h,ke([o.$$h],h,"f",null);class p extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,r){return this.spawnTerminal(n,t,r)}runInTerminal(t,r,i,c,s){const l=s.osxExec||d.$R9b;return new Promise((u,S)=>{if(l===d.$R9b||l==="iTerm.app"){const y=l===d.$R9b?"TerminalHelper":"iTermHelper",L=[k.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||g,"-w",r];for(const M of i)L.push("-a"),L.push(M);if(c){const M=Object.assign({},$(process),c);for(const U in M){const C=M[U];C===null?(L.push("-u"),L.push(U)):(L.push("-e"),L.push(`${U}=${C}`))}}let T="";const A=n.spawn(p.b,L);A.on("error",M=>{S(m(M))}),A.stderr.on("data",M=>{T+=M.toString()}),A.on("exit",M=>{if(M===0)u(void 0);else if(T){const U=T.split(`
`,1);S(new Error(U[0]))}else S(new Error(f.localize(1,null,y,M)))})}else S(new Error(f.localize(2,null,l)))})}spawnTerminal(t,r,i){const c=r.osxExec||d.$R9b;return new Promise((s,l)=>{const u=["-a",c];i&&u.push(i);const S=$(process),y=t.spawn("/usr/bin/open",u,{cwd:i,env:S});y.on("error",l),y.on("exit",()=>s())})}}e.$Ffc=p;class b extends w{static{this.b=f.localize(3,null)}openTerminal(t,r){return this.spawnTerminal(n,t,r)}runInTerminal(t,r,i,c,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((u,S)=>{const y=[];l.then(R=>{R.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${E(i)}; echo; read -p "${b.b}" -n1;`;y.push(`''${L}''`);const T=Object.assign({},$(process),c);Object.keys(T).filter(C=>T[C]===null).forEach(C=>delete T[C]);const A={cwd:r,env:T};let M="";const U=n.spawn(R,y,A);U.on("error",C=>{S(m(C))}),U.stderr.on("data",C=>{M+=C.toString()}),U.on("exit",C=>{if(C===0)u(void 0);else if(M){const z=M.split(`
`,1);S(new Error(z[0]))}else S(new Error(f.localize(4,null,R,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!O.$k)b.d=Promise.resolve("xterm");else{const t=await v.Promises.exists("/etc/debian_version");b.d=new Promise(r=>{t?r("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?r("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?r("konsole"):process.env.COLORTERM?r(process.env.COLORTERM):process.env.TERM?r(process.env.TERM):r("xterm")})}return b.d}spawnTerminal(t,r,i){const c=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{c.then(u=>{const S=$(process),y=t.spawn(u,[],{cwd:i,env:S});y.on("error",l),y.on("exit",()=>s())})})}}e.$Gfc=b;function $(P){const t={...P.env};return(0,I.$lm)(t),t}function m(P){return"errno"in P&&P.errno==="ENOENT"&&"path"in P&&typeof P.path=="string"?new Error(f.localize(5,null,P.path)):P}function E(P){let t="";for(const r of P)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(oe[15],ae([0,1,61,10,26,13,7,181,6,3,12,66]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=g,e.$cl=b,e.$dl=m,e.$el=E,e.$fl=P,e.$gl=t,e.$hl=r,e.$il=i,e.$jl=c,e.$kl=s,e.$ll=l,e.$nl=y,e.$ol=R,e.$pl=L,e.$ql=T,e.$rl=A,e.$ul=re,e.$Gl=j,e.$Hl=B,e.$Jl=ce,e.$al=(0,v.$Gi)("fileService");function g(K){return K.create===!0}var w;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var h;(function(K){K[K.Readonly=1]="Readonly",K[K.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var p;(function(K){K[K.UPDATED=2]="UPDATED",K[K.ADDED=4]="ADDED",K[K.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function b(K){const he=K;return!!he&&typeof he.onDidChange=="function"}var $;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileAtomicWrite=32768]="FileAtomicWrite",K[K.FileAtomicDelete=65536]="FileAtomicDelete",K[K.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function m(K){return!!(K.capabilities&$.FileReadWrite)}function E(K){return!!(K.capabilities&$.FileFolderCopy)}function P(K){return!!(K.capabilities&$.FileClone)}function t(K){return!!(K.capabilities&$.FileOpenReadWriteClose)}function r(K){return!!(K.capabilities&$.FileReadStream)}function i(K){return m(K)?!!(K.capabilities&$.FileAtomicRead):!1}function c(K){return m(K)?!!(K.capabilities&$.FileAtomicWrite):!1}function s(K){return!!(K.capabilities&$.FileAtomicDelete)}function l(K){return!!(K.capabilities&$.Readonly)}var u;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsStorageQuota="EntryExceedsStorageQuota",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class S extends Error{static create(he,se){const _=new S(he.toString(),se);return L(_,se),_}constructor(he,se){super(he),this.code=se}}e.$ml=S;function y(K,he){return S.create(K,he)}function R(K){return K||y((0,I.localize)(0,null),u.Unknown)}function L(K,he){return K.name=he?`${he} (FileSystemError)`:"FileSystemError",K}function T(K){if(!K)return u.Unknown;if(K instanceof S)return K.code;const he=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!he)return u.Unknown;switch(he[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function A(K){if(K instanceof Z)return K.fileOperationResult;switch(T(K)){case u.FileNotFound:return ee.FILE_NOT_FOUND;case u.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case u.NoPermissions:return ee.FILE_PERMISSION_DENIED;case u.FileExists:return ee.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var M;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class U{constructor(he,se,_){this.resource=he,this.operation=se,this.target=_}isOperation(he){return this.operation===he}}e.$sl=U;var C;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class z{static{this.a=null}constructor(he,se){this.c=se,this.b=void 0,this.d=new d.$X(()=>{const _=n.$Mi.forUris(()=>this.c);return _.fill(this.rawAdded.map(F=>[F,!0])),_}),this.f=new d.$X(()=>{const _=n.$Mi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(F=>[F,!0])),_}),this.g=new d.$X(()=>{const _=n.$Mi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(F=>[F,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of he){switch(_.type){case C.ADDED:this.rawAdded.push(_.resource);break;case C.UPDATED:this.rawUpdated.push(_.resource);break;case C.DELETED:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(he,...se){return this.h(he,{includeChildren:!1},...se)}affects(he,...se){return this.h(he,{includeChildren:!0},...se)}h(he,se,..._){if(!he)return!1;const F=_.length>0;return!!((!F||_.includes(C.ADDED))&&(this.d.value.get(he)||se.includeChildren&&this.d.value.findSuperstr(he))||(!F||_.includes(C.UPDATED))&&(this.f.value.get(he)||se.includeChildren&&this.f.value.findSuperstr(he))||(!F||_.includes(C.DELETED))&&(this.g.value.findSubstr(he)||se.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$tl=z;function re(K,he,se){return!K||!he||K===he||he.length>K.length?!1:(he.charAt(he.length-1)!==o.sep&&(he+=o.sep),se?(0,k.$If)(K,he):K.indexOf(he)===0)}class Z extends Error{constructor(he,se,_){super(he),this.fileOperationResult=se,this.options=_}}e.$vl=Z;class le extends Z{constructor(he,se,_,F){super(he,se,F),this.fileOperationResult=se,this.size=_}}e.$wl=le;class X extends Z{constructor(he,se,_){super(he,ee.FILE_NOT_MODIFIED_SINCE,_),this.stat=se}}e.$xl=X;var ee;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var q;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$Fl="";function j(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}async function B(K,he){if(!he.hasProvider(O.URI.from({scheme:K.scheme})))return new Promise(se=>{const _=he.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===K.scheme&&F.added&&(_.dispose(),se())})})}class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(he){return(0,D.$kg)(he)||(he=0),he<G.KB?(0,I.localize)(1,null,he.toFixed(0)):he<G.MB?(0,I.localize)(2,null,(he/G.KB).toFixed(2)):he<G.GB?(0,I.localize)(3,null,(he/G.MB).toFixed(2)):he<G.TB?(0,I.localize)(4,null,(he/G.GB).toFixed(2)):(0,I.localize)(5,null,(he/G.TB).toFixed(2))}}e.$Il=G;function ce(K){const he=typeof K=="string"||K?.scheme===f.Schemas.vscodeRemote;return typeof K!="string"&&K?.scheme===f.Schemas.file?1024*G.MB:he?10*G.MB:a.$o?50*G.MB:1024*G.MB}}),define(oe[125],ae([0,1,17,16,182,15]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=O;async function O(f,d,g,w,h,p){let b;try{await I(f,d,g,w,h,p)}catch($){b=$}finally{b&&h.errorTransformer&&(b=h.errorTransformer(b)),typeof b<"u"&&g.error(b),g.end()}}async function I(f,d,g,w,h,p){v(p);const b=await f.open(d,{create:!1});try{v(p);let $=0,m=0,E=h&&typeof h.length=="number"?h.length:void 0,P=n.$Pe.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),t=h&&typeof h.position=="number"?h.position:0,r=0;do m=await f.read(b,t,P.buffer,r,P.byteLength-r),t+=m,r+=m,$+=m,typeof E=="number"&&(E-=m),r===P.byteLength&&(await g.write(w(P)),P=n.$Pe.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),r=0);while(m>0&&(typeof E!="number"||E>0)&&v(p)&&a($,h));if(r>0){let i=r;typeof E=="number"&&(i=Math.min(r,E)),g.write(w(P.slice(0,i)))}}catch($){throw(0,D.$ol)($)}finally{await f.close(b)}}function v(f){if(f.isCancellationRequested)throw(0,o.$9)();return!0}function a(f,d){if(typeof d?.limits?.size=="number"&&f>d.limits.size)throw(0,D.$nl)((0,k.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[62],ae([0,1,113,2,10,3,7,15]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=v,e.$3q=a,e.$7q=w,e.$8q=h,e.$9q=p,e.$0q=b,e.$$q=m,e.$_q=E;function v(P){return typeof P.correlationId=="number"}function a(P){return P.recursive===!0}class f extends o.$Xc{static{this.a=5}constructor(t,r,i,c){super(),this.h=t,this.j=r,this.m=i,this.n=c,this.c=this.B(new o.$Yc),this.f=void 0,this.g=0}s(){const t=new o.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(r=>this.h(r))),t.add(this.b.onDidLogMessage(r=>this.j(r))),t.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(t,r){this.u(t,r)?this.g<f.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,r){return!(!this.n.restartOnError||r||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=f;class d extends f{constructor(t,r,i){super(t,r,i,{type:"node.js",restartOnError:!1})}}e.$5q=d;class g extends f{constructor(t,r,i){super(t,r,i,{type:"universal",restartOnError:!0})}}e.$6q=g;function w(P){return P.map(t=>({type:t.type,resource:O.URI.revive(t.resource),cId:t.cId}))}function h(P){const t=new $;for(const r of P)t.processEvent(r);return t.coalesce()}function p(P,t){return typeof t=="string"&&!t.startsWith(n.$wk)&&!(0,k.$lc)(t)?{base:P,pattern:t}:t}function b(P,t){const r=[];for(const i of t)r.push((0,n.$Ak)(p(P,i)));return r}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return D.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const r=this.b.get(this.c(t));let i=!1;if(r){const c=r.type,s=t.type;r.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:c===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(r)):c===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?r.type=I.FileChangeType.UPDATED:c===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(r.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],r=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,c)=>i.resource.fsPath.length-c.resource.fsPath.length).filter(i=>r.some(c=>(0,I.$ul)(i.resource.fsPath,c,!D.$k))?!1:(r.push(i.resource.fsPath),!0)).concat(t)}}function m(P,t){if(typeof t=="number")switch(P.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function E(P){if(typeof P=="number"){const t=[];return P&I.FileChangeFilter.ADDED&&t.push("Added"),P&I.FileChangeFilter.DELETED&&t.push("Deleted"),P&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(oe[217],ae([0,1,17,55,16,4,2,68,33,15,62]),function(x,e,n,o,k,D,O,I,v,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class d extends O.$Xc{constructor(w,h){super(),this.a=w,this.b=h,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$ne),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$ne),this.onDidWatchError=this.g.event,this.h=(0,v.$3g)(),this.j()}get capabilities(){return this.c||(this.c=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=a.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,h){const{buffer:p}=await this.a.call("readFile",[w,h]);return p}readFileStream(w,h,p){const b=(0,I.$De)(m=>n.$Pe.concat(m.map(E=>n.$Pe.wrap(E))).buffer),$=new O.$Wc;return $.add(this.a.listen("readFileStream",[w,h])(m=>{if(m instanceof n.$Pe)b.write(m.buffer);else{if(m==="end")b.end();else{let E;if(m instanceof Error)E=m;else{const P=m;E=(0,a.$nl)(P.message??(0,o.$rj)(P),P.code??a.FileSystemProviderErrorCode.Unknown)}b.error(E),b.end()}$.dispose()}})),$.add(p.onCancellationRequested(()=>{b.error((0,k.$9)()),b.end(),$.dispose()})),b}writeFile(w,h,p){return this.a.call("writeFile",[w,n.$Pe.wrap(h),p])}open(w,h){return this.a.call("open",[w,h])}close(w){return this.a.call("close",[w])}async read(w,h,p,b,$){const[m,E]=await this.a.call("read",[w,h,$]);return p.set(m.buffer.slice(0,E),b),E}write(w,h,p,b,$){return this.a.call("write",[w,h,n.$Pe.wrap(p),b,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,h){return this.a.call("delete",[w,h])}rename(w,h,p){return this.a.call("rename",[w,h,p])}copy(w,h,p){return this.a.call("copy",[w,h,p])}cloneFile(w,h){return this.a.call("cloneFile",[w,h])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const h=w;this.f.fire((0,f.$7q)(h))}else{const h=w;this.g.fire(h)}}))}watch(w,h){const p=(0,v.$3g)();return this.a.call("watch",[this.h,p,w,h]),(0,O.$Vc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$0Q=d}),define(oe[218],ae([0,1,47,2,62,4,15,7,8]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class a extends o.$Xc{constructor(){super(),this.a=this.B(new D.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new o.$7c),this.m=new Set,this.n=this.B(new v.$Eh(this.y())),this.r=5007,this.s=new v.$4h,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,k.$2q)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new v.$4h;try{this.h.clear(),this.g.clear();for(const g of d)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const g=new o.$Wc;this.j.set(d.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(d,g),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,g){this.F(d,g)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,g),this.m.add(d.correlationId))}F(d,g){const w=this.O?.subscribe(d.path,(h,p)=>{g.isDisposed||(h?this.D(d,g):p?.type===O.FileChangeType.ADDED&&this.H(d))});return w?(g.add(w),!0):!1}G(d,g){let w=!1;const h=(p,b)=>{if(g.isDisposed)return;const $=this.I(p),m=this.I(b),E=w;w=$,!$&&(m||E)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.r},h)}catch(p){this.Q(`fs.watchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}g.add((0,o.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,h)}catch(p){this.Q(`fs.unwatchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const g={resource:I.URI.file(d.path),type:O.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([g]),this.J(g,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,g){if(this.R){const w=` >> normalized ${d.type===O.FileChangeType.ADDED?"[ADDED]":d.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L(w,g)}}L(d,g){this.R&&this.P(`${d}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,k.$_q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$ir=a}),define(oe[219],ae([0,1,47,8,23,31,2,79,10,3,19,7,114,21,15,62]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=$;class b extends O.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(E,P,t,r,i,c){super(),this.s=E,this.t=P,this.u=t,this.w=r,this.y=i,this.z=c,this.c=this.B(new o.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new o.$Uh(s=>this.M(s),b.b)),this.g=(0,p.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,p.$2q)(this.s)?this.s.filter:void 0,this.m=new k.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const E=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const P=await w.Promises.stat(E);if(this.m.token.isCancellationRequested)return;this.B(await this.G(E,P.isDirectory()))}catch(E){E.code!=="ENOENT"?this.O(E):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${E})`),this.D()}}D(){this.r=!0,this.w?.()}async F(E){let P=E.path;try{P=await w.Promises.realpath(E.path),E.path===P&&(P=await(0,g.$kr)(E.path,this.m.token)??E.path),E.path!==P&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${P})`)}catch{}return P}async G(E,P){const t=new O.$Wc;return this.H(E,P,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(E,P,t)),t}H(E,P,t){if(P)return!1;const r=d.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(c,s)=>{if(!t.isDisposed)if(c){const l=await this.G(E,P);t.isDisposed?l.dispose():t.add(l)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(E,P,t){if(a.$j&&(0,D.$Fg)(E,"/Volumes/",!0)){this.O(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new k.$ye(this.m.token);t.add((0,O.$Vc)(()=>r.dispose(!0)));const i=new O.$Wc;t.add(i);try{const c=d.URI.file(this.s.path),s=(0,v.$qc)(E),l=(0,n.watch)(E);i.add((0,O.$Vc)(()=>{l.removeAllListeners(),l.close()})),this.Q(`Started watching: '${E}'`);const u=new Set;if(P)try{for(const y of await w.Promises.readdir(E))u.add(y)}catch(y){this.O(y)}if(r.token.isCancellationRequested)return;const S=new Map;i.add((0,O.$Vc)(()=>{for(const[,y]of S)y.dispose();S.clear()})),l.on("error",(y,R)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${E} for changes using fs.watch() (${y}, ${R})`),this.D())}),l.on("change",(y,R)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${R}`);let L="";if(R&&(L=R.toString(),a.$j&&(L=(0,I.$nm)(L))),!(!L||y!=="change"&&y!=="rename"))if(P)if(y==="rename"){S.get(L)?.dispose();const T=setTimeout(async()=>{if(S.delete(L),L===s&&!await w.Promises.exists(E)){this.J(c);return}if(r.token.isCancellationRequested)return;const A=await this.N((0,v.$mc)(E,L));if(r.token.isCancellationRequested)return;let M;A?u.has(L)?M=h.FileChangeType.UPDATED:(M=h.FileChangeType.ADDED,u.add(L)):(u.delete(L),M=h.FileChangeType.DELETED),this.L({resource:(0,f.$hh)(c,L),type:M,cId:this.s.correlationId})},b.a);S.set(L,(0,O.$Vc)(()=>clearTimeout(T)))}else{let T;u.has(L)?T=h.FileChangeType.UPDATED:(T=h.FileChangeType.ADDED,u.add(L)),this.L({resource:(0,f.$hh)(c,L),type:T,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const T=setTimeout(async()=>{const A=await w.Promises.exists(E);r.token.isCancellationRequested||(A?(this.L({resource:c,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(E,!1))):this.J(c))},b.a);i.clear(),i.add((0,O.$Vc)(()=>clearTimeout(T)))}else this.L({resource:c,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(c){r.token.isCancellationRequested||this.O(`Failed to watch ${E} for changes using fs.watch() (${c.toString()})`),this.D()}}J(E){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:E,type:h.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(E,P=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${E.type===h.FileChangeType.ADDED?"[ADDED]":E.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`),!P&&this.g.some(t=>t(E.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${E.resource.fsPath}`):!P&&this.h&&this.h.length>0&&!this.h.some(t=>t(E.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${E.resource.fsPath}`):this.f.work(E))}M(E){const P=(0,p.$8q)(E),t=[];for(const i of P){if((0,p.$$q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===h.FileChangeType.ADDED?"[ADDED]":i.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(E){if(a.$k)return w.Promises.exists(E);try{const P=(0,v.$qc)(E);return(await w.Promises.readdir((0,v.$pc)(E))).some(r=>r===P)}catch(P){return this.Q(P),!1}}setVerboseLogging(E){this.z=E}O(E){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}P(E){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}Q(E){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}R(E){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${E}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=b;async function $(m,E,P,t,r=512){const i=await w.Promises.open(m,"r"),c=Buffer.allocUnsafe(r),s=new k.$ye(t);let l,u=!1;const S={path:m,excludes:[],recursive:!1},y=new b(S,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===h.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:T}=await w.Promises.read(i,c,0,r,null);if(!T||s.token.isCancellationRequested)break;E(c.slice(0,T))}}catch(T){l=new Error(T),s.dispose(!0)}finally{u=!1}}})()});return await y.ready,P(),new Promise((R,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(i)}catch(T){l=new Error(T)}l?L(l):R()})})}}),define(oe[220],ae([0,1,4,113,218,3,219,31]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class v extends k.$ir{constructor(f){super(),this.O=f,this.onDidError=n.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const d=[],g=new Set(Array.from(this.watchers));for(const w of f){const h=this.W(w);h&&(0,o.$Ek)(h.request.excludes,w.excludes)&&(0,o.$Ek)(h.request.includes,w.includes)?g.delete(h):d.push(w)}d.length&&this.P(`Request to start watching: ${d.map(w=>this.M(w)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(w=>this.M(w.request)).join(",")}`);for(const w of g)this.Y(w);for(const w of d)this.X(w)}W(f){for(const d of this.watchers)if(typeof f.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===f.correlationId)return d}else if((0,I.$Eg)(d.request.path,f.path,!D.$k))return d}X(f){const d=new O.$nr(f,this.O,w=>this.a.fire(w),()=>this.c.fire(f),w=>this.b.fire(w),this.R),g={request:f,instance:d};this.watchers.add(g)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const d=new Map;for(const g of f){const w=D.$k?g.path:g.path.toLowerCase();let h=d.get(g.correlationId);h||(h=new Map,d.set(g.correlationId,h)),h.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),h.set(w,g)}return Array.from(d.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const d of this.watchers)d.instance.setVerboseLogging(f)}P(f,d){this.R&&this.b.fire({type:"trace",message:this.bb(f,d)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,d){return d?`[File Watcher (node.js)] ${f} (${this.M(d.request)})`:`[File Watcher (node.js)] ${f}`}}e.$pr=v}),define(oe[221],ae([0,1,62,220]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class k extends n.$5q{constructor(O,I,v){super(O,I,v),this.s()}r(O){return O.add(new o.$pr(void 0))}}e.$qr=k}),define(oe[222],ae([0,1,12,44,165,62]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class O extends D.$6q{constructor(v,a,f){super(v,a,f),this.s()}r(v){const a=v.add(new k.$gr(n.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(a.onDidProcessExit(({code:f,signal:d})=>this.t(`terminated by itself with code ${f}, signal: ${d} (ETERM)`))),o.ProxyChannel.toService((0,o.$ni)(a.getChannel("watcher")))}}e.$hr=O}),define(oe[99],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class n{constructor(...k){this.a=new Map;for(const[D,O]of k)this.set(D,O)}set(k,D){const O=this.a.get(k);return this.a.set(k,D),O}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Ei=n}),define(oe[223],ae([0,1,8,16,2,84,212,6,99,109]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const f=!1;class d extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class g{constructor(b=new v.$Ei,$=!1,m,E=f){this.i=b,this.j=$,this.k=m,this.l=E,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Fi,this),this._globalGraph=E?m?._globalGraph??new O.$tr(P=>P):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Sc)(this.h),this.h.clear();for(const b of this.g)(0,k.$Rc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,$){this.m();const m=this,E=new class extends g{dispose(){m.h.delete(E),super.dispose()}}(b,this.j,this,this.l);return this.h.add(E),$?.add(E),E}invokeFunction(b,...$){this.m();const m=h.traceInvocation(this.l,b);let E=!1;try{return b({get:t=>{if(E)throw(0,o.$$)("service accessor is only valid during the invocation of its target method");const r=this.s(t,m);if(!r)throw new Error(`[invokeFunction] unknown service '${t}'`);return r}},...$)}finally{E=!0,m.stop()}}createInstance(b,...$){this.m();let m,E;return b instanceof D.$Di?(m=h.traceCreation(this.l,b.ctor),E=this.o(b.ctor,b.staticArguments.concat($),m)):(m=h.traceCreation(this.l,b),E=this.o(b,$,m)),m.stop(),E}o(b,$=[],m){const E=I._util.getServiceDependencies(b).sort((r,i)=>r.index-i.index),P=[];for(const r of E){const i=this.s(r.id,m);i||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${r.id}.`,!1),P.push(i)}const t=E.length>0?E[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${b.name} at position ${t+1} conflicts with ${$.length} static arguments`);const r=t-$.length;r>0?$=$.concat(new Array(r)):$=$.slice(0,t)}return Reflect.construct(b,$.concat(P))}q(b,$){if(this.i.get(b)instanceof D.$Di)this.i.set(b,$);else if(this.k)this.k.q(b,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const $=this.i.get(b);return!$&&this.k?this.k.r(b):$}s(b,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const m=this.r(b);return m instanceof D.$Di?this.u(b,m,$.branch(b,!0)):($.branch(b,!1),m)}u(b,$,m){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,$,m)}finally{this.t.delete(b)}}v(b,$,m){const E=new O.$tr(r=>r.id.toString());let P=0;const t=[{id:b,desc:$,_trace:m}];for(;t.length;){const r=t.pop();if(E.lookupOrInsertNode(r),P++>1e3)throw new d(E);for(const i of I._util.getServiceDependencies(r.desc.ctor)){const c=this.r(i.id);if(c||this.y(`[createInstance] ${b} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(i.id)),c instanceof D.$Di){const s={id:i.id,desc:c,_trace:r._trace.branch(i.id,!0)};E.insertEdge(r,s),t.push(s)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new d(E);break}for(const{data:i}of r){if(this.r(i.id)instanceof D.$Di){const s=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,s)}E.removeNode(i)}}return this.r(b)}w(b,$,m=[],E,P){if(this.i.get(b)instanceof D.$Di)return this.x(b,$,m,E,P,this.g);if(this.k)return this.k.w(b,$,m,E,P);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(b,$,m=[],E,P,t){if(E){const r=new g(void 0,this.j,this,this.l);r.c=String(b);const i=new Map,c=new n.$Zh(()=>{const s=r.o($,m,P);for(const[l,u]of i){const S=s[l];if(typeof S=="function")for(const y of u)y.disposable=S.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,l){if(!c.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let y=i.get(l);return y||(y=new a.$8c,i.set(l,y)),(L,T,A)=>{if(c.isInitialized)return c.value[l](L,T,A);{const M={listener:[L,T,A],disposable:void 0},U=y.push(M);return(0,k.$Vc)(()=>{U(),M.disposable?.dispose()})}}}if(l in s)return s[l];const u=c.value;let S=u[l];return typeof S!="function"||(S=S.bind(u),s[l]=S),S},set(s,l,u){return c.value[l]=u,!0},getPrototypeOf(s){return $.prototype}})}else{const r=this.o($,m,P);return t.add(r),r}}y(b,$){if($&&console.warn(b),this.j)throw new Error(b)}}e.$ur=g;var w;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(w||(w={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,$){return b?new h(w.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(b,$){return b?new h(w.Creation,$.name):h.c}static{this.f=0}constructor(b,$){this.type=b,this.name=$,this.g=Date.now(),this.h=[]}branch(b,$){const m=new h(w.Branch,b.toString());return this.h.push([b,$,m]),m}stop(){const b=Date.now()-this.g;h.f+=b;let $=!1;function m(P,t){const r=[],i=new Array(P+1).join("	");for(const[c,s,l]of t.h)if(s&&l){$=!0,r.push(`${i}CREATES -> ${c}`);const u=m(P+1,l);u&&r.push(u)}else r.push(`${i}uses -> ${c}`);return r.join(`
`)}const E=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(b>2||$)&&h.all.add(E.join(`
`))}}e.$vr=h}),define(oe[224],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=e.IssueSource=e.IssueType=void 0;var o;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(o||(e.IssueType=o={}));var k;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$k_b=(0,n.$Gi)("issueService"),e.$l_b=(0,n.$Gi)("processService")}),define(oe[5],ae([0,1,187,55,4,46,2,32,3,19,13,7,123,6]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=p,e.log=$,e.$ok=S,e.$pk=y,e.$qk=R,e.$rk=L,n=De(n),e.$ak=(0,w.$Gi)("logService"),e.$bk=(0,w.$Gi)("loggerService");function h(){return new Date().toISOString()}function p(T){return(0,f.$kg)(T)}var b;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$dk=b.Info;function $(T,A,M){switch(A){case b.Trace:T.trace(M);break;case b.Debug:T.debug(M);break;case b.Info:T.info(M);break;case b.Warning:T.warn(M);break;case b.Error:T.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function m(T,A=!1){let M="";for(let U=0;U<T.length;U++){let C=T[U];if(C instanceof Error&&(C=(0,o.$rj)(C,A)),typeof C=="object")try{C=JSON.stringify(C)}catch{}M+=(U>0?" ":"")+C}return M}class E extends O.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new k.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==b.Off&&this.b<=A}}e.$fk=E;class P extends E{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...M){this.f(b.Trace)&&this.g(b.Trace,m([A,...M],!0))}debug(A,...M){this.f(b.Debug)&&this.g(b.Debug,m([A,...M]))}info(A,...M){this.f(b.Info)&&this.g(b.Info,m([A,...M]))}warn(A,...M){this.f(b.Warning)&&this.g(b.Warning,m([A,...M]))}error(A,...M){if(this.f(b.Error))if(A instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=A.stack,this.g(b.Error,m(U))}else this.g(b.Error,m([A,...M]))}flush(){}}e.$gk=P;class t extends E{constructor(A=e.$dk){super(),this.setLevel(A),this.g=!v.$i}trace(A,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,A,...M):console.log(`[main ${h()}]`,A,...M))}debug(A,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,A,...M):console.log(`[main ${h()}]`,A,...M))}info(A,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,A,...M):console.log(`[main ${h()}]`,A,...M))}warn(A,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,A,...M):console.warn(`[main ${h()}]`,A,...M))}error(A,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,A,...M):console.error(`[main ${h()}]`,A,...M))}flush(){}}e.$hk=t;class r extends E{constructor(A=e.$dk,M=!0){super(),this.g=M,this.setLevel(A)}trace(A,...M){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...M):console.log(A,...M))}debug(A,...M){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...M):console.log(A,...M))}info(A,...M){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...M):console.log(A,...M))}warn(A,...M){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...M):console.log(A,...M))}error(A,...M){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...M):console.error(A,...M))}flush(){}}e.$ik=r;class i extends E{constructor(A,M=e.$dk){super(),this.g=A,this.setLevel(M)}trace(A,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(A),...M])}debug(A,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(A),...M])}info(A,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(A),...M])}warn(A,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(A),...M])}error(A,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(A),...M])}h(A){return typeof A=="string"?A:(0,o.$rj)(A,this.f(b.Trace))}flush(){}}e.$jk=i;class c extends E{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const M of this.g)M.setLevel(A);super.setLevel(A)}trace(A,...M){for(const U of this.g)U.trace(A,...M)}debug(A,...M){for(const U of this.g)U.debug(A,...M)}info(A,...M){for(const U of this.g)U.info(A,...M)}warn(A,...M){for(const U of this.g)U.warn(A,...M)}error(A,...M){for(const U of this.g)U.error(A,...M)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}e.$kk=c;class s extends O.$Xc{constructor(A,M,U){if(super(),this.h=A,this.j=M,this.b=new I.$Dc,this.c=this.B(new k.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$ne),this.onDidChangeVisibility=this.g.event,U)for(const C of U)this.b.set(C.resource,{logger:void 0,info:C})}m(A){return(0,f.$gg)(A)?[...this.b.values()].find(M=>M.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,M){const U=this.n(A),C=(0,f.$gg)(A)?A:M?.id??(0,D.$uj)(U.toString()).toString(16);let z=this.b.get(U)?.logger;const re=M?.logLevel==="always"?b.Trace:M?.logLevel;z||(z=this.s(U,re??this.getLogLevel(U)??this.h,{...M,id:C}));const Z={logger:z,info:{resource:U,id:C,logLevel:re,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Z.info),this.b.set(U,Z),z}n(A){return(0,f.$gg)(A)?(0,a.$hh)(this.j,`${A}.log`):A}setLogLevel(A,M){if(d.URI.isUri(A)){const U=A,C=M,z=this.b.get(U);z&&C!==z.info.logLevel&&(z.info.logLevel=C===this.h?void 0:C,z.logger?.setLevel(C),this.b.set(z.info.resource,z),this.f.fire([U,C]))}else{this.h=A;for(const[U,C]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,M){const U=this.m(A);U&&M!==!U.info.hidden&&(U.info.hidden=!M,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,M]))}getLogLevel(A){let M;return A&&(M=this.b.get(A)?.info.logLevel),M??this.h}registerLogger(A){const M=this.b.get(A.resource);M?M.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const M=this.b.get(A);M&&(M.logger&&M.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=s;class l{constructor(){this.onDidChangeLogLevel=new k.$ne().event}setLevel(A){}getLevel(){return b.Info}trace(A,...M){}debug(A,...M){}info(A,...M){}warn(A,...M){}error(A,...M){}critical(A,...M){}dispose(){}flush(){}}e.$mk=l;class u extends l{}e.$nk=u;function S(T){if(T.verbose)return b.Trace;if(typeof T.logLevel=="string"){const A=L(T.logLevel.toLowerCase());if(A!==void 0)return A}return e.$dk}function y(T){switch(T){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function R(T){switch(T){case b.Trace:return{original:"Trace",value:n.localize(0,null)};case b.Debug:return{original:"Debug",value:n.localize(1,null)};case b.Info:return{original:"Info",value:n.localize(2,null)};case b.Warning:return{original:"Warning",value:n.localize(3,null)};case b.Error:return{original:"Error",value:n.localize(4,null)};case b.Off:return{original:"Off",value:n.localize(5,null)}}}function L(T){switch(T){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$sk=new g.$Xj("logLevel",y(b.Info))});var ne=this&&this.__param||function(x,e){return function(n,o){e(n,o,x)}};define(oe[225],ae([0,1,14,3,98,5]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;const O=n.safeStorage;let I=class{constructor(a){this.a=a,n.app.commandLine.getSwitchValue("password-store")===k.PasswordStoreCLIOption.basic&&O.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.a.trace("[EncryptionMainService] Encrypting value.");try{const f=JSON.stringify(O.encryptString(a));return this.a.trace("[EncryptionMainService] Encrypted value."),f}catch(f){throw this.a.error(f),f}}async decrypt(a){let f;try{if(f=JSON.parse(a),!f.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const d=Buffer.from(f.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=O.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(o.$i)return Promise.resolve(k.KnownStorageProvider.dplib);if(o.$j)return Promise.resolve(k.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{const a=O.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.a.error(a)}return Promise.resolve(k.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(o.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(o.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$zfc=I,e.$zfc=I=ke([ne(0,D.$ak)],I)}),define(oe[226],ae([0,1,22,8,16,4,31,2,10,62,5]),function(x,e,n,o,k,D,O,I,v,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class d extends I.$Xc{constructor(w,h){super(),this.a=w,this.b=h,this.c=this.B(new D.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new o.$Eh(0)),this.w=[],this.y=this.B(new o.$Eh(0))}watch(w,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(w,h):this.z(w,h)}n(w,h){const p={path:this.J(w),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},b=(0,n.$Wb)(this.j,p);return this.r(),(0,I.$Vc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,k.$3)(w))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,a.$7q)(h)),h=>this.G(h),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const h of this.j)(0,a.$3q)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const h of this.j)(0,a.$3q)(h)&&w.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,h){const p={path:this.J(w),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},b=(0,n.$Wb)(this.w,p);return this.C(),(0,I.$Vc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,k.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$7q)(w)),w=>this.G(w),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,v.$kc)(w.fsPath)}J(w){const h=this.I(w);return(0,O.$Ig)(h)}}e.$ar=d}),define(oe[227],ae([0,1,22,8,17,23,4,46,78,2,61,12,71,19,68,180,15,125,5,16]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let t=class extends a.$Xc{static{P=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new O.$ne),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$ne),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$ne),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$ne),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$ne),this.Y=this.B(new O.$ne),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$ne),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new o.$Ph)}registerProvider(i,c){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const s=new a.$Wc;return this.h.set(i,c),this.c.fire({added:!0,scheme:i,provider:c}),s.add(c.onDidChangeFile(l=>{const u=new b.$tl(l,!this.S(c));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(l=>this.Z.fire(new Error(l)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:i}))),(0,a.$Vc)(()=>{this.c.fire({added:!1,scheme:i,provider:c}),this.h.delete(i),(0,a.$Sc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const c=[];this.f.fire({scheme:i,join(s){c.push(s)}}),!this.h.has(i)&&await o.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,c){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return v.Iterable.map(this.h,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async j(i){if(!(0,w.$lh)(i))throw new b.$vl((0,p.localize)(0,null,this.sb(i)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const c=this.h.get(i.scheme);if(!c){const s=new E.$eb;throw s.message=(0,p.localize)(1,null,i.toString()),s}return c}async m(i){const c=await this.j(i);if((0,b.$gl)(c)||(0,b.$dl)(c)||(0,b.$hl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const c=await this.j(i);if((0,b.$gl)(c)||(0,b.$dl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.s(i,c)}catch(s){throw(0,b.$ql)(s)===b.FileSystemProviderErrorCode.FileNotFound?new b.$vl((0,p.localize)(2,null,this.sb(i)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$ol)(s)}}async s(i,c){const s=await this.j(i),l=this.S(s),u=c?.resolveTo,S=c?.resolveSingleChildDescendants,y=c?.resolveMetadata,R=await s.stat(i);let L;return this.t(s,i,R,void 0,!!y,(T,A)=>(L||(L=f.$Mi.forUris(()=>!l),L.set(i,!0),u&&L.fill(!0,u)),L.get(T.resource)||L.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&S?A===1:!1))}async t(i,c,s,l,u,S){const{providerExtUri:y}=this.R(i),R={resource:c,name:y.basename(c),isFile:(s.type&b.FileType.File)!==0,isDirectory:(s.type&b.FileType.Directory)!==0,isSymbolicLink:(s.type&b.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&b.FilePermission.Readonly)||!!(i.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Gl)({mtime:s.mtime,size:s.size}),children:void 0};if(R.isDirectory&&S(R,l)){try{const L=await i.readdir(c),T=await o.Promises.settled(L.map(async([A,M])=>{try{const U=y.joinPath(c,A),C=u?await i.stat(U):{type:M};return await this.t(i,U,C,L.length,u,S)}catch(U){return this.b.trace(U),null}}));R.children=(0,n.$Kb)(T)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(i){return o.Promises.settled(i.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.j(i),s=await c.stat(i);return this.t(c,i,s,void 0,!0,()=>!1)}async exists(i){const c=await this.j(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.u(i,c)}catch(s){return s}return!0}async u(i,c){if(!c?.overwrite&&await this.exists(i))throw new b.$vl((0,p.localize)(3,null,this.sb(i)),b.FileOperationResult.FILE_MODIFIED_SINCE,c)}async createFile(i,c=k.$Pe.fromString(""),s){await this.u(i,s);const l=await this.writeFile(i,c);return this.r.fire(new b.$sl(i,b.FileOperation.CREATE,l)),l}async writeFile(i,c,s){const l=this.qb(await this.n(i),i),{providerExtUri:u}=this.R(l);let S=s;if((0,b.$jl)(l)&&!S?.atomic){const y=l.enforceAtomicWriteFile?.(i);y&&(S={...s,atomic:y})}try{await this.w(l,i,S)||await this.U(l,u.dirname(i));let R;if((0,b.$dl)(l)&&!(c instanceof k.$Pe))if((0,h.$Be)(c)){const L=await(0,h.$Ie)(c,3);L.ended?R=k.$Pe.concat(L.buffer):R=L}else R=(0,h.$Fe)(c,L=>k.$Pe.concat(L),3);else R=c;!(0,b.$gl)(l)||(0,b.$dl)(l)&&R instanceof k.$Pe||(0,b.$dl)(l)&&(0,b.$jl)(l)&&S?.atomic?await this.hb(l,i,S,R):await this.db(l,i,S,R instanceof k.$Pe?(0,k.$1e)(R):R),this.r.fire(new b.$sl(i,b.FileOperation.WRITE))}catch(y){throw new b.$vl((0,p.localize)(4,null,this.sb(i),(0,b.$ol)(y).toString()),(0,b.$rl)(y),S)}return this.resolve(i,{resolveMetadata:!0})}async w(i,c,s){const l=!!s?.unlock;if(l&&!(i.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(5,null,this.sb(c)));if(!!s?.atomic){if(!(i.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(6,null,this.sb(c)));if(!(i.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(7,null,this.sb(c)));if(l)throw new Error((0,p.localize)(8,null,this.sb(c)))}let S;try{S=await i.stat(c)}catch{return}if(S.type&b.FileType.Directory)throw new b.$vl((0,p.localize)(9,null,this.sb(c)),b.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(c,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==b.$Fl&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,b.$Gl)({mtime:s.mtime,size:S.size}))throw new b.$vl((0,p.localize)(10,null),b.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(i,c,s){const l=await this.m(i);return c?.atomic?this.z(l,i,c,s):this.C(l,i,c,s)}async z(i,c,s,l){return new Promise((u,S)=>{this.cb.queueFor(c,async()=>{try{const y=await this.C(i,c,s,l);u(y)}catch(y){S(y)}},this.R(i).providerExtUri)})}async C(i,c,s,l){const u=await this.D(i,c,{...s,preferUnbuffered:!0},l);return{...u,value:await(0,k.$2e)(u.value)}}async readFileStream(i,c,s){const l=await this.m(i);return this.D(l,i,c,s)}async D(i,c,s,l){const u=new D.$ye(l);let S=s;(0,b.$il)(i)&&i.enforceAtomicReadFile?.(c)&&(S={...s,atomic:!0});const y=this.J(c,S).then(L=>L,L=>{throw u.dispose(!0),L});let R;try{return typeof S?.etag=="string"&&S.etag!==b.$Fl&&await y,S?.atomic&&(0,b.$il)(i)||!((0,b.$gl)(i)||(0,b.$hl)(i))||(0,b.$dl)(i)&&S?.preferUnbuffered?R=this.I(i,c,S):(0,b.$hl)(i)?R=this.G(i,c,u.token,S):R=this.H(i,c,u.token,S),R.on("end",()=>u.dispose()),R.on("error",()=>u.dispose()),{...await y,value:R}}catch(L){throw R&&await(0,h.$Ge)(R),this.F(L,c,S)}}F(i,c,s){const l=(0,p.localize)(11,null,this.sb(c),(0,b.$ol)(i).toString());return i instanceof b.$xl?new b.$xl(l,i.stat,s):i instanceof b.$wl?new b.$wl(l,i.fileOperationResult,i.size,i.options):new b.$vl(l,(0,b.$rl)(i),s)}G(i,c,s,l=Object.create(null)){const u=i.readFileStream(c,l,s);return(0,h.$Me)(u,{data:S=>S instanceof k.$Pe?S:k.$Pe.wrap(S),error:S=>this.F(S,c,l)},S=>k.$Pe.concat(S))}H(i,c,s,l=Object.create(null)){const u=(0,k.$6e)();return(0,$.$Zq)(i,c,u,S=>S,{...l,bufferSize:this.a,errorTransformer:S=>this.F(S,c,l)},s),u}I(i,c,s){const l=(0,h.$De)(u=>k.$Pe.concat(u));return(async()=>{try{let u;s?.atomic&&(0,b.$il)(i)?u=await i.readFile(c,{atomic:!0}):u=await i.readFile(c),typeof s?.position=="number"&&(u=u.slice(s.position)),typeof s?.length=="number"&&(u=u.slice(0,s.length)),this.L(c,u.byteLength,s),l.end(k.$Pe.wrap(u))}catch(u){l.error(u),l.end()}})(),l}async J(i,c){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new b.$vl((0,p.localize)(12,null,this.sb(i)),b.FileOperationResult.FILE_IS_DIRECTORY,c);if(typeof c?.etag=="string"&&c.etag!==b.$Fl&&c.etag===s.etag)throw new b.$xl((0,p.localize)(13,null),s,c);return this.L(i,s.size,c),s}L(i,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new b.$wl((0,p.localize)(14,null,this.sb(i)),b.FileOperationResult.FILE_TOO_LARGE,c,s)}async canMove(i,c,s){return this.M(i,c,"move",s)}async canCopy(i,c,s){return this.M(i,c,"copy",s)}async M(i,c,s,l){if(i.toString()!==c.toString())try{const u=s==="move"?this.qb(await this.n(i),i):await this.m(i),S=this.qb(await this.n(c),c);await this.Q(u,i,S,c,s,l)}catch(u){return u}return!0}async move(i,c,s){const l=this.qb(await this.n(i),i),u=this.qb(await this.n(c),c),S=await this.N(l,i,u,c,"move",!!s),y=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new b.$sl(i,S==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,y)),y}async copy(i,c,s){const l=await this.m(i),u=this.qb(await this.n(c),c),S=await this.N(l,i,u,c,"copy",!!s),y=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new b.$sl(i,S==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,y)),y}async N(i,c,s,l,u,S){if(c.toString()===l.toString())return u;const{exists:y,isSameResourceWithDifferentPathCase:R}=await this.Q(i,c,s,l,u,S);if(y&&!R&&S&&await this.del(l,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(l)),u==="copy"){if(i===s&&(0,b.$el)(i))await i.copy(c,l,{overwrite:S});else{const L=await this.resolve(c);L.isDirectory?await this.P(i,L,s,l):await this.O(i,c,s,l)}return u}else return i===s?(await i.rename(c,l,{overwrite:S}),u):(await this.N(i,c,s,l,"copy",S),await this.del(c,{recursive:!0}),"copy")}async O(i,c,s,l){if((0,b.$gl)(i)&&(0,b.$gl)(s))return this.jb(i,c,s,l);if((0,b.$gl)(i)&&(0,b.$dl)(s))return this.pb(i,c,s,l);if((0,b.$dl)(i)&&(0,b.$gl)(s))return this.nb(i,c,s,l);if((0,b.$dl)(i)&&(0,b.$dl)(s))return this.lb(i,c,s,l)}async P(i,c,s,l){await s.mkdir(l),Array.isArray(c.children)&&await o.Promises.settled(c.children.map(async u=>{const S=this.R(s).providerExtUri.joinPath(l,u.name);return u.isDirectory?this.P(i,await this.resolve(u.resource),s,S):this.O(i,u.resource,s,S)}))}async Q(i,c,s,l,u,S){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:T}=this.R(i);if(T||(y=L.isEqual(c,l)),y&&u==="copy")throw new Error((0,p.localize)(15,null,this.sb(c),this.sb(l)));if(!y&&L.isEqualOrParent(l,c))throw new Error((0,p.localize)(16,null,this.sb(c),this.sb(l)))}const R=await this.exists(l);if(R&&!y){if(!S)throw new b.$vl((0,p.localize)(17,null,this.sb(c),this.sb(l)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(c,l))throw new Error((0,p.localize)(18,null,this.sb(c),this.sb(l)))}}return{exists:R,isSameResourceWithDifferentPathCase:y}}R(i){const c=this.S(i);return{providerExtUri:c?w.$0g:w.$_g,isPathCaseSensitive:c}}S(i){return!!(i.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const c=this.qb(await this.j(i),i);await this.U(c,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new b.$sl(i,b.FileOperation.CREATE,s)),s}async U(i,c){const s=[],{providerExtUri:l}=this.R(i);for(;!l.isEqual(c,l.dirname(c));)try{if(!((await i.stat(c)).type&b.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(c)));break}catch(u){if((0,b.$ql)(u)!==b.FileSystemProviderErrorCode.FileNotFound)throw u;s.push(l.basename(c)),c=l.dirname(c)}for(let u=s.length-1;u>=0;u--){c=l.joinPath(c,s[u]);try{await i.mkdir(c)}catch(S){if((0,b.$ql)(S)!==b.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(i,c){try{await this.W(i,c)}catch(s){return s}return!0}async W(i,c){const s=this.qb(await this.j(i),i),l=!!c?.useTrash;if(l&&!(s.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(20,null,this.sb(i)));const u=c?.atomic;if(u&&!(s.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(21,null,this.sb(i)));if(l&&u)throw new Error((0,p.localize)(22,null,this.sb(i)));let S;try{S=await s.stat(i)}catch{}if(S)this.rb(i,S);else throw new b.$vl((0,p.localize)(23,null,this.sb(i)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!c?.recursive){const R=await this.resolve(i);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(i)))}return s}async del(i,c){const s=await this.W(i,c);let l=c;if((0,b.$kl)(s)&&!l?.atomic){const R=s.enforceAtomicDelete?.(i);R&&(l={...c,atomic:R})}const u=!!l?.useTrash,S=!!l?.recursive,y=l?.atomic??!1;await s.delete(i,{recursive:S,useTrash:u,atomic:y}),this.r.fire(new b.$sl(i,b.FileOperation.DELETE))}async cloneFile(i,c){const s=await this.j(i),l=this.qb(await this.n(c),c);if(!(s===l&&this.R(s).providerExtUri.isEqual(i,c)))return s===l&&(0,b.$fl)(s)?s.cloneFile(i,c):(await this.U(l,this.R(l).providerExtUri.dirname(c)),s===l&&(0,b.$el)(s)?this.cb.queueFor(i,()=>s.copy(i,c,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,l,c),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,c){return this.watch(i,{...c,correlationId:P.ab++})}watch(i,c={recursive:!1,excludes:[]}){const s=new a.$Wc;let l=!1,u=()=>{l=!0};s.add((0,a.$Vc)(()=>u())),(async()=>{try{const y=await this.bb(i,c);l?(0,a.$Sc)(y):u=()=>(0,a.$Sc)(y)}catch(y){this.b.error(y)}})();const S=c.correlationId;if(typeof S=="number"){const y=s.add(new O.$ne);return s.add(this.X.event(L=>{L.correlates(S)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,c){const s=await this.j(i),l=(0,I.$uj)([this.R(s).providerExtUri.getComparisonKey(i),c]);let u=this.$.get(l);return u||(u={count:0,disposable:s.watch(i,c)},this.$.set(l,u)),u.count+=1,(0,a.$Vc)(()=>{u&&(u.count--,u.count===0&&((0,a.$Sc)(u.disposable),this.$.delete(l)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,a.$Sc)(i.disposable);this.$.clear()}async db(i,c,s,l){return this.cb.queueFor(c,async()=>{const u=await i.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,h.$Be)(l)||(0,h.$Ce)(l)?await this.eb(i,u,l):await this.fb(i,u,l)}catch(S){throw(0,b.$ol)(S)}finally{await i.close(u)}},this.R(i).providerExtUri)}async eb(i,c,s){let l=0,u;if((0,h.$Ce)(s)){if(s.buffer.length>0){const S=k.$Pe.concat(s.buffer);await this.gb(i,c,S,S.byteLength,l,0),l+=S.byteLength}if(s.ended)return;u=s.stream}else u=s;return new Promise((S,y)=>{(0,h.$He)(u,{onData:async R=>{u.pause();try{await this.gb(i,c,R,R.byteLength,l,0)}catch(L){return y(L)}l+=R.byteLength,setTimeout(()=>u.resume())},onError:R=>y(R),onEnd:()=>S()})})}async fb(i,c,s){let l=0,u;for(;(u=s.read())!==null;)await this.gb(i,c,u,u.byteLength,l,0),l+=u.byteLength}async gb(i,c,s,l,u,S){let y=0;for(;y<l;){const R=await i.write(c,u+y,s.buffer,S+y,l-y);y+=R}}async hb(i,c,s,l){return this.cb.queueFor(c,()=>this.ib(i,c,s,l),this.R(i).providerExtUri)}async ib(i,c,s,l){let u;l instanceof k.$Pe?u=l:(0,h.$Be)(l)?u=await(0,k.$2e)(l):(0,h.$Ce)(l)?u=await(0,k.$3e)(l):u=(0,k.$Ze)(l),await i.writeFile(c,u.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,c,s,l){return this.cb.queueFor(l,()=>this.kb(i,c,s,l),this.R(s).providerExtUri)}async kb(i,c,s,l){let u,S;try{u=await i.open(c,{create:!1}),S=await s.open(l,{create:!0,unlock:!1});const y=k.$Pe.alloc(this.a);let R=0,L=0,T=0;do T=await i.read(u,R,y.buffer,L,y.byteLength-L),await this.gb(s,S,y,T,R,L),R+=T,L+=T,L===y.byteLength&&(L=0);while(T>0)}catch(y){throw(0,b.$ol)(y)}finally{await o.Promises.settled([typeof u=="number"?i.close(u):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(i,c,s,l){return this.cb.queueFor(l,()=>this.mb(i,c,s,l),this.R(s).providerExtUri)}async mb(i,c,s,l){return s.writeFile(l,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,c,s,l){return this.cb.queueFor(l,()=>this.ob(i,c,s,l),this.R(s).providerExtUri)}async ob(i,c,s,l){const u=await s.open(l,{create:!0,unlock:!1});try{const S=await i.readFile(c);await this.gb(s,u,k.$Pe.wrap(S),S.byteLength,0,0)}catch(S){throw(0,b.$ol)(S)}finally{await s.close(u)}}async pb(i,c,s,l){const u=await(0,k.$2e)(this.H(i,c,D.CancellationToken.None));await this.hb(s,l,void 0,u)}qb(i,c){if(i.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$vl((0,p.localize)(25,null,this.sb(c)),b.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,c){if((c.permissions??0)&b.FilePermission.Readonly)throw new b.$vl((0,p.localize)(26,null,this.sb(i)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}};e.$1q=t,e.$1q=t=P=ke([ne(0,m.$ak)],t)}),define(oe[100],ae([0,1,8,32,17,4,31,2,10,3,19,68,21,184,15,125,226,222,221]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class E extends b.$ar{static{this.L=!1}constructor(t,r){super(t,r),this.onDidChangeCapabilities=D.Event.None,this.P=new o.$Dc(i=>f.$$g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=h.FileSystemProviderCapabilities.FileReadWrite|h.FileSystemProviderCapabilities.FileOpenReadWriteClose|h.FileSystemProviderCapabilities.FileReadStream|h.FileSystemProviderCapabilities.FileFolderCopy|h.FileSystemProviderCapabilities.FileWriteUnlock|h.FileSystemProviderCapabilities.FileAtomicRead|h.FileSystemProviderCapabilities.FileAtomicWrite|h.FileSystemProviderCapabilities.FileAtomicDelete|h.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=h.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:r,symbolicLink:i}=await g.SymlinkSupport.stat(this.I(t));return{type:this.O(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:h.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const r=await g.Promises.readdir(this.I(t),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,f.$hh)(t,c.name))).type:s=this.O(c),i.push([c.name,s])}catch(s){this.a.trace(s)}})),i}catch(r){throw this.hb(r)}}O(t,r){let i;return r?.dangling?i=h.FileType.Unknown:t.isFile()?i=h.FileType.File:t.isDirectory()?i=h.FileType.Directory:i=h.FileType.Unknown,r&&(i|=h.FileType.SymbolicLink),i}async Q(t){const r=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let i;for(;i=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await i.wait();const c=new n.$Fh;return this.P.set(t,c),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,I.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(t)===c&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let i;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),i=await this.Q(t));const c=this.I(t);return await g.Promises.readFile(c)}catch(c){throw this.hb(c)}finally{i?.dispose()}}R(t){E.L&&this.a.trace(t)}readFileStream(t,r,i){const c=(0,d.$De)(s=>k.$Pe.concat(s.map(l=>k.$Pe.wrap(l))).buffer);return(0,p.$Zq)(this,t,c,s=>s.buffer,{...r,bufferSize:256*1024},i),c}async writeFile(t,r,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(t)?this.U(t,(0,f.$hh)((0,f.$gh)(t),`${(0,f.$eh)(t)}${i.atomic.postfix}`),r,i):this.W(t,r,i)}async S(t){try{const r=this.I(t),{symbolicLink:i}=await g.SymlinkSupport.stat(r);if(i)return!1}catch{}return!0}async U(t,r,i,c){const s=new I.$Wc;try{s.add(await this.Q(t)),s.add(await this.Q(r)),await this.W(r,i,c,!0);try{await this.rename(r,t,{overwrite:!0})}catch(l){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{s.dispose()}}async W(t,r,i,c){let s;try{const l=this.I(t);if(!i.create||!i.overwrite){if(await g.Promises.exists(l)){if(!i.overwrite)throw(0,h.$nl)((0,w.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,h.$nl)((0,w.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:i.unlock},c),await this.write(s,0,r,0,r.byteLength)}catch(l){throw await this.ib(t,l)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(t){E.$=t}async open(t,r,i){const c=this.I(t);let s;(0,h.$bl)(r)&&!i&&(s=await this.Q(t));let l;try{if((0,h.$bl)(r)&&r.unlock)try{const{stat:S}=await g.SymlinkSupport.stat(c);S.mode&128||await g.Promises.chmod(c,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let u;if((0,h.$bl)(r)){if(a.$i)try{await g.Promises.truncate(c,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}u||(u="w")}else u="r";l=await g.Promises.open(c,u)}catch(u){throw s?.dispose(),(0,h.$bl)(r)?await this.ib(t,u):this.hb(u)}if(this.X.set(l,0),(0,h.$bl)(r)&&this.Z.set(l,t),s){const u=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${c})`),this.Y.set(l,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${c})`),u.dispose())}return l}async close(t){const r=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&E.$)try{await g.Promises.fdatasync(t)}catch(i){E.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(t)}catch(i){throw this.hb(i)}finally{r&&(this.Y.get(t)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,i,c,s){const l=this.ab(t,r);let u=null;try{u=(await g.Promises.read(t,i,c,s,l)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(t,l,u)}return u}ab(t,r){return r===this.X.get(t)?null:r}bb(t,r,i){const c=this.X.get(t);typeof c=="number"&&(typeof r=="number"||(typeof i=="number"?this.X.set(t,c+i):this.X.delete(t)))}async write(t,r,i,c,s){return(0,n.$1h)(()=>this.cb(t,r,i,c,s),100,3)}async cb(t,r,i,c,s){const l=this.ab(t,r);let u=null;try{u=(await g.Promises.write(t,i,c,s,l)).bytesWritten}catch(S){throw await this.ib(this.Z.get(t),S)}finally{this.bb(t,l,u)}return u}async mkdir(t){try{await g.Promises.mkdir(this.I(t))}catch(r){throw this.hb(r)}}async delete(t,r){try{const i=this.I(t);if(r.recursive){let c;r?.atomic!==!1&&r.atomic.postfix&&(c=(0,v.$mc)((0,v.$pc)(i),`${(0,v.$qc)(i)}${r.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(i)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let s=!1;try{const{stat:l,symbolicLink:u}=await g.SymlinkSupport.stat(i);s=l.isDirectory()&&!u}catch{}if(s)await g.Promises.rmdir(i);else throw c}else throw c}}catch(i){throw this.hb(i)}}async rename(t,r,i){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"move",i.overwrite),await g.Promises.rename(c,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(2,null,(0,v.$qc)(c),(0,v.$qc)((0,v.$pc)(s)),l.toString()))),this.hb(l)}}async copy(t,r,i){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"copy",i.overwrite),await g.Promises.copy(c,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(3,null,(0,v.$qc)(c),(0,v.$qc)((0,v.$pc)(s)),l.toString()))),this.hb(l)}}async db(t,r,i,c){const s=this.I(t),l=this.I(r);let u=!1;if(!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,O.$Eg)(s,l,!0)),u){if(i==="copy")throw(0,h.$nl)((0,w.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const y=await this.N(t);if(!y)throw(0,h.$nl)((0,w.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(r);if(R){if(!c)throw(0,h.$nl)((0,w.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);y.type&h.FileType.File&&R.type&h.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,r){return this.eb(t,r,!1)}async eb(t,r,i){const c=this.I(t),s=this.I(r),l=!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Eg)(c,s,!l))return;const u=new I.$Wc;try{u.add(await this.Q(t)),u.add(await this.Q(r)),i&&await g.Promises.mkdir((0,v.$pc)(s),{recursive:!0}),await g.Promises.copyFile(c,s)}catch(S){if(S.code==="ENOENT"&&!i)return this.eb(t,r,!0);throw this.hb(S)}finally{u.dispose()}}t(t,r,i){return new $.$hr(c=>t(c),c=>r(c),i)}F(t,r,i){return new m.$qr(c=>t(c),c=>r(c),i)}hb(t){if(t instanceof h.$ml)return t;let r=t,i;switch(t.code){case"ENOENT":i=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=h.FileSystemProviderErrorCode.Unknown;break;default:i=h.FileSystemProviderErrorCode.Unknown}return(0,h.$nl)(r,i)}async ib(t,r){let i=this.hb(r);if(t&&i.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.I(t));c.mode&128||(i=(0,h.$nl)(r,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return i}}e.$rr=E}),define(oe[228],ae([0,1,4,100,2,17,68,23]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;class v extends k.$Xc{constructor(d,g){super(),this.a=d,this.b=g,this.F=new Map,this.G=new Map}call(d,g,w){const h=this.c(d);switch(g){case"stat":return this.g(h,w[0]);case"readdir":return this.h(h,w[0]);case"open":return this.r(h,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(h,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(h,w[0],w[1],w[2]);case"rename":return this.z(h,w[0],w[1],w[2]);case"copy":return this.C(h,w[0],w[1],w[2]);case"cloneFile":return this.D(h,w[0],w[1]);case"mkdir":return this.w(h,w[0]);case"delete":return this.y(h,w[0],w[1]);case"watch":return this.I(h,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${g} not found`)}listen(d,g,w){const h=this.c(d);switch(g){case"fileChange":return this.H(h,w[0]);case"readFileStream":return this.m(h,w[0],w[1])}throw new Error(`Unknown event ${g}`)}g(d,g){const w=this.f(d,g,!0);return this.a.stat(w)}h(d,g){const w=this.f(d,g);return this.a.readdir(w)}async j(d,g,w){const h=this.f(d,g,!0),p=await this.a.readFile(h,w);return D.$Pe.wrap(p)}m(d,g,w){const h=this.f(d,g,!0),p=new I.$ye,b=new n.$ne({onDidRemoveLastListener:()=>{p.cancel()}}),$=this.a.readFileStream(h,w,p.token);return(0,O.$He)($,{onData:m=>b.fire(D.$Pe.wrap(m)),onError:m=>b.fire(m),onEnd:()=>{b.fire("end"),b.dispose(),p.dispose()}}),b.event}n(d,g,w,h){const p=this.f(d,g);return this.a.writeFile(p,w.buffer,h)}r(d,g,w){const h=this.f(d,g,!0);return this.a.open(h,w)}s(d){return this.a.close(d)}async t(d,g,w){const h=D.$Pe.alloc(w),b=await this.a.read(d,g,h.buffer,0,w);return[h,b]}u(d,g,w,h,p){return this.a.write(d,g,w.buffer,h,p)}w(d,g){const w=this.f(d,g);return this.a.mkdir(w)}y(d,g,w){const h=this.f(d,g);return this.a.delete(h,w)}z(d,g,w,h){const p=this.f(d,g),b=this.f(d,w);return this.a.rename(p,b,h)}C(d,g,w,h){const p=this.f(d,g),b=this.f(d,w);return this.a.copy(p,b,h)}D(d,g,w){const h=this.f(d,g),p=this.f(d,w);return this.a.cloneFile(h,p)}H(d,g){const w=new n.$ne({onWillAddFirstListener:()=>{this.F.set(g,this.L(d,w))},onDidRemoveLastListener:()=>{(0,k.$Sc)(this.F.get(g)),this.F.delete(g)}});return w.event}async I(d,g,w,h,p){const b=this.F.get(g);if(b){const $=this.f(d,h),m=b.watch(w,$,p);this.G.set(g+w,m)}}async J(d,g){const w=d+g,h=this.G.get(w);h&&((0,k.$Sc)(h),this.G.delete(w))}dispose(){super.dispose();for(const[,d]of this.G)d.dispose();this.G.clear();for(const[,d]of this.F)d.dispose();this.F.clear()}}e.$2s=v;class a extends k.$Xc{constructor(d,g,w,h){super(),this.c=d,this.f=w,this.g=h,this.a=new Map,this.b=this.B(new o.$rr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(g)}h(d){const g=this.B(new n.$ne);this.B(g.event(w=>{d.fire(w.map(h=>({resource:this.c.transformOutgoingURI(h.resource),type:h.type,cId:h.cId})))})),this.B(this.b.onDidChangeFile(w=>g.fire(w))),this.B(this.b.onDidWatchError(w=>d.fire(w)))}j(d){}m(d){}watch(d,g,w){const h=this.m(this.g);return Array.isArray(h)&&(w.excludes=[...w.excludes,...h]),this.a.set(d,this.b.watch(g,w)),(0,k.$Vc)(()=>{(0,k.$Sc)(this.a.get(d)),this.a.delete(d)})}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),super.dispose()}}e.$3s=a}),define(oe[229],ae([0,1,14,183,3,7,15,10,228,160,55]),function(x,e,n,o,k,D,O,I,v,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class d extends v.$2s{constructor(h,p,b){super(h,p),this.M=b}c(h){return a.$Nn}f(h,p){return D.URI.revive(p)}async y(h,p,b){if(!b.useTrash)return super.y(h,p,b);const $=this.f(h,p),m=(0,I.$kc)($.fsPath);try{await n.shell.trashItem(m)}catch(E){throw(0,O.$nl)(k.$i?(0,o.localize)(0,null,(0,I.$qc)(m),(0,f.$rj)(E)):(0,o.localize)(1,null,(0,I.$qc)(m),(0,f.$rj)(E)),O.FileSystemProviderErrorCode.Unknown)}}L(h,p){return new g(h,p,this.b,this.M)}}e.$Hfc=d;class g extends v.$3s{watch(h,p,b){if(b.recursive)throw(0,O.$nl)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(h,p,b)}}}),define(oe[230],ae([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class o extends n.$gk{constructor(D=n.$dk){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(D){this.n=D;for(const{level:O,message:I}of this.m)(0,n.log)(D,O,I);this.m=[]}g(D,O){this.n?(0,n.log)(this.n,D,O):this.getLevel()<=D&&this.m.push({level:D,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$occ=o}),define(oe[231],ae([0,1,7,4,5,2]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=void 0;class O extends k.$lk{constructor(d,g,w,h,p){super(g,w,h),this.r=d,this.t=p,this.B(p.listen("onDidChangeLogLevel",d)(b=>{(0,k.$ck)(b)?super.setLogLevel(b):super.setLogLevel(n.URI.revive(b[0]),b[1])})),this.B(p.listen("onDidChangeVisibility",d)(([b,$])=>super.setVisibility(n.URI.revive(b),$))),this.B(p.listen("onDidChangeLoggers",d)(({added:b,removed:$})=>{for(const m of b)super.registerLogger({...m,resource:n.URI.revive(m.resource)});for(const m of $)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new k.$jk({log:(d,g)=>{this.t.call("consoleLog",[d,g])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,g){super.setLogLevel(d,g),this.t.call("setLogLevel",[d,g])}setVisibility(d,g){super.setVisibility(d,g),this.t.call("setVisibility",[this.n(d),g])}s(d,g,w){return new I(this.t,d,g,w,this.r)}static setLogLevel(d,g,w){return d.call("setLogLevel",[g,w])}}e.$rs=O;class I extends k.$gk{constructor(d,g,w,h,p){super(h?.logLevel==="always"),this.r=d,this.s=g,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[g,h,p]).then(()=>{this.u(this.n),this.m=!0})}g(d,g){const w=[[d,g]];this.m?this.u(w):this.n.push(...w)}u(d){this.r.call("log",[this.s,d])}}class v{constructor(d,g){this.a=d,this.b=g}listen(d,g){const w=this.b(d);switch(g){case"onDidChangeLoggers":return o.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(p=>this.c(p,w)),removed:[...h.removed].map(p=>this.c(p,w))}));case"onDidChangeVisibility":return o.Event.map(this.a.onDidChangeVisibility,h=>[w.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return o.Event.map(this.a.onDidChangeLogLevel,h=>(0,k.$ck)(h)?h:[w.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${g}`)}async call(d,g,w){const h=this.b(d);switch(g){case"setLogLevel":return(0,k.$ck)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(h.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,h)))}throw new Error(`Call not found: ${g}`)}c(d,g){return{...d,resource:g.transformOutgoingURI(d.resource)}}}e.$ss=v;class a extends D.$Xc{constructor(d,g){super(),g.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(w=>g.call("setLogLevel",[w]))),g.call("getRegisteredLoggers").then(w=>{for(const h of w)d.registerLogger({...h,resource:n.URI.revive(h.resource)})}),this.B(g.listen("onDidChangeVisibility")(([w,h])=>d.setVisibility(n.URI.revive(w),h))),this.B(g.listen("onDidChangeLoggers")(({added:w,removed:h})=>{for(const p of w)d.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of h)d.deregisterLogger(p.resource)}))}}e.$ts=a}),define(oe[232],ae([0,1,2,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class k extends n.$Xc{constructor(O,I=[]){super(),this.a=new o.$kk([O,...I]),this.B(O.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$oR=k}),define(oe[233],ae([0,1,32,7,5]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class D{constructor(I){this.b=I,this.a=new n.$Dc}listen(I,v,a){switch(v){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${v}`)}async call(I,v,a){switch(v){case"createLogger":this.c(o.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(o.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,k.$ck)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(o.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(o.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:o.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(o.URI.revive(a[0]))}throw new Error(`Call not found: ${v}`)}c(I,v,a){this.a.set(I,this.b.createLogger(I,v,a))}d(I,v){let a=console.log;switch(I){case k.LogLevel.Error:a=console.error;break;case k.LogLevel.Warning:a=console.warn;break;case k.LogLevel.Info:a=console.info;break}a.call(console,...v)}e(I,v){const a=this.a.get(I);if(!a)throw new Error("Create the logger before logging");for(const[f,d]of v)(0,k.log)(a,f,d)}}e.$Fgc=D}),define(oe[234],ae([0,1,15,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function D(a,f,d,g,w){try{const h=await new Promise((b,$)=>{x(["@vscode/spdlog"],b,$)}).then(De);h.setFlushOn(k.Trace);const p=await h.createAsyncRotatingLogger(a,f,d,g);return w?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(h){console.error(h)}return null}function O(a,f,d){switch(f){case o.LogLevel.Trace:a.trace(d);break;case o.LogLevel.Debug:a.debug(d);break;case o.LogLevel.Info:a.info(d);break;case o.LogLevel.Warning:a.warn(d);break;case o.LogLevel.Error:a.error(d);break;case o.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function I(a,f){switch(f){case o.LogLevel.Trace:a.setLevel(k.Trace);break;case o.LogLevel.Debug:a.setLevel(k.Debug);break;case o.LogLevel.Info:a.setLevel(k.Info);break;case o.LogLevel.Warning:a.setLevel(k.Warning);break;case o.LogLevel.Error:a.setLevel(k.Error);break;case o.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class v extends o.$gk{constructor(f,d,g,w,h){super(),this.m=[],this.setLevel(h),this.n=this.s(f,d,g,w),this.B(this.onDidChangeLogLevel(p=>{this.r&&I(this.r,p)}))}async s(f,d,g,w){const h=g?6:1,p=30/h*n.$Il.MB,b=await D(f,d,p,h,w);if(b){this.r=b,I(this.r,this.getLevel());for(const{level:$,message:m}of this.m)O(this.r,$,m);this.m=[]}}g(f,d){this.r?O(this.r,f,d):this.getLevel()<=f&&this.m.push({level:f,message:d})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=v}),define(oe[235],ae([0,1,33,5,234]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class D extends o.$lk{s(I,v,a){return new k.$dR((0,n.$3g)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,v)}}e.$eR=D}),define(oe[72],ae([0,1,32,4,6,5,235]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0,e.$cfc=(0,k.$Hi)(D.$bk);class I extends O.$eR{constructor(){super(...arguments),this.u=new n.$Dc}createLogger(a,f,d){d!==void 0&&this.u.set(this.n(a),d);try{return super.createLogger(a,f)}catch(g){throw this.u.delete(this.n(a)),g}}registerLogger(a,f){f!==void 0&&this.u.set(a.resource,f),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const f=[];for(const d of super.getRegisteredLoggers())a===this.u.get(d.resource)&&f.push(d);return f}getOnDidChangeLogLevelEvent(a){return o.Event.filter(this.onDidChangeLogLevel,f=>(0,D.$ck)(f)||this.w(f[0],a))}getOnDidChangeVisibilityEvent(a){return o.Event.filter(this.onDidChangeVisibility,([f])=>this.w(f,a))}getOnDidChangeLoggersEvent(a){return o.Event.filter(o.Event.map(this.onDidChangeLoggers,f=>({added:[...f.added].filter(g=>this.w(g.resource,a)),removed:[...f.removed].filter(g=>this.w(g.resource,a))})),f=>f.added.length>0||f.removed.length>0)}deregisterLoggers(a){for(const[f,d]of this.u)d===a&&this.deregisterLogger(f)}w(a,f){const d=this.u.get(a);return d===void 0||d===f}dispose(){super.dispose(),this.u.clear()}}e.$dfc=I}),define(oe[236],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=n,e.$Wfc=o,e.$Xfc=k,e.$Yfc=D;function n(O){return O.submenu!==void 0}function o(O){return O.id==="vscode.menubar.separator"}function k(O){return O.uri!==void 0}function D(O){return!n(O)&&!o(O)&&!k(O)}}),define(oe[40],ae([0,1,4,78,2,6]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,D.$Gi)("policy");class O extends k.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ne),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),o.Iterable.reduce(this.g.entries(),(d,[g,w])=>({...d,[g]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return o.Iterable.reduce(Object.entries(this.f),(a,[f,d])=>({...a,[f]:{definition:d,value:this.g.get(f)}}),{})}}e.$uo=O;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=I}),define(oe[237],ae([0,1,8,4,78,13,15,5,40]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;function a(d,g){const w=[];for(const h of new Set(k.Iterable.concat(d.keys(),g.keys())))d.get(h)!==g.get(h)&&w.push(h);return w}let f=class extends v.$uo{constructor(g,w,h){super(),this.m=g,this.n=w,this.s=h,this.c=this.B(new n.$Eh(500));const p=o.Event.filter(w.onDidFilesChange,b=>b.affects(g));this.B(w.watch(g)),this.B(p(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const w=await this.n.readFile(this.m),h=JSON.parse(w.value.toString());if(!(0,D.$ig)(h))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(h))this.f[p]&&g.set(p,h[p])}catch(w){w.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return g}async w(){const g=await this.u(),w=a(this.g,g);this.g=g,w.length>0&&this.h.fire(w)}};e.$Ygc=f,e.$Ygc=f=ke([ne(1,O.$al),ne(2,I.$ak)],f)}),define(oe[238],ae([0,1,4,2,40]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;class D{constructor(v){this.b=v,this.a=new o.$Wc}listen(v,a){switch(a){case"onDidChange":return n.Event.map(this.b.onDidChange,f=>f.reduce((d,g)=>({...d,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(v,a,f){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(f)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$ugc=D;class O extends k.$uo{constructor(v,a){super(),this.a=a;for(const f in v){const{definition:d,value:g}=v[f];this.f[f]=d,g!==void 0&&this.g.set(f,g)}this.a.listen("onDidChange")(f=>{for(const d in f){const g=f[d];g===null?this.g.delete(d):this.g.set(d,g)}this.h.fire(Object.keys(f))})}async j(v){const a=await this.a.call("updatePolicyDefinitions",v);for(const f in a)this.g.set(f,a[f])}}e.$vgc=O}),define(oe[239],ae([0,1,40,8,2,5]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;let O=class extends n.$uo{constructor(v,a){super(),this.m=v,this.n=a,this.a=new o.$Ah,this.b=this.B(new k.$Yc)}async j(v){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(v).length} policy definitions`);const{createWatcher:a}=await new Promise((f,d)=>{x(["@vscode/policy-watcher"],f,d)}).then(De);await this.a.queue(()=>new Promise((f,d)=>{try{this.b.value=a(this.n,v,g=>{this.t(g),f()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),d(g)}}))}t(v){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(v)}`);for(const a in v){const f=v[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(v))}};e.$Xgc=O,e.$Xgc=O=ke([ne(0,D.$ak)],O)}),define(oe[73],ae([0,1,37]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const D=k.context.configuration();if(D)o=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:D.version})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(oe[28],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,n.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(oe[240],ae([0,1,8,5]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let k=class{constructor(O,I,v){this.a=O,this.b=I,this.c=v}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Hh)(O);const v=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),v.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$Kfc=k,e.$Kfc=k=ke([ne(2,o.$ak)],k)}),define(oe[74],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0,e.$Xec=(0,n.$Gi)("protocolMainService")}),define(oe[45],ae([0,1,141,13]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,n=De(n),o=De(o);class k{constructor(){this.a=new Map}add(O,I){n.ok(o.$gg(O)),n.ok(o.$ig(I)),n.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$ro=new k}),define(oe[241],ae([0,1,4,45]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,o=De(o),e.$so={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this.b=new n.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,a){this.a[k(v)]=a,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const O=new D;o.$ro.add(e.$so.JSONContribution,O)}),define(oe[56],ae([0,1,22,4,13,168,18,241,45]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=p,e.$Io=b,e.$Jo=$,e.$Ko=E,e.$Lo=P,k=De(k),D=De(D);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$wo={Configuration:"base.contributions.configuration"};var f;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const d=v.$ro.as(I.$so.JSONContribution);class g{constructor(){this.h=new Set,this.i=new o.$ne,this.onDidSchemaChange=this.i.event,this.j=new o.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$Do,this.g),this.v()}registerConfiguration(r,i=!0){this.registerConfigurations([r],i)}registerConfigurations(r,i=!0){const c=new Set;this.n(r,i,c),d.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const i=new Set;this.o(r,i),d.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:r,remove:i}){const c=new Set;this.o(i,c),this.n(r,!1,c),d.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const i=new Set;this.k(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(r,i){const c=[];for(const{overrides:s,source:l}of r)for(const u in s)if(i.add(u),e.$Go.test(u)){const S=this.a.get(u),y=S?.valuesSources??new Map,R=S?.value||{};for(const A of Object.keys(s[u])){const M=s[u][A];if(k.$ig(M)&&(k.$ng(R[A])||k.$ig(R[A]))){if(R[A]={...R[A]??{},...M},l){let C=y.get(A);if(C||(C=new Map,y.set(A,C)),!(C instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const z in M)C.set(z,l)}}else R[A]=M,l&&y.set(A,l)}this.a.set(u,{source:l,value:R,valuesSources:y});const L=(0,O.$kj)(u),T={type:"object",default:R,description:D.localize(1,null,L),$ref:e.$Do,defaultDefaultValue:R,source:k.$gg(l)?void 0:l,defaultValueSource:l};c.push(...p(u)),this.d[u]=T,this.b.properties[u]=T}else{const S=this.d[u],y=this.a.get(u);let R=y?.value??S?.defaultDefaultValue,L=s[u],T=l;if(k.$ig(L)&&(S!==void 0&&S.type==="object"||S===void 0&&(k.$ng(R)||k.$ig(R)))){if(k.$ig(R)||(R={}),L={...R,...L},T=y?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const M in s[u])l?T.set(M,l):T.delete(M)}this.a.set(u,{value:L,source:T}),S&&(this.w(u,S),this.r(u,S))}this.m(c)}deregisterDefaultConfigurations(r){const i=new Set;this.l(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(r,i){for(const{overrides:c,source:s}of r)for(const l in c){const u=k.$gg(s)?s:s?.id,S=this.a.get(l);if(S){if(e.$Go.test(l)){for(const R of Object.keys(c[l])){const L=c[l][R];if(k.$ig(L)){const T=S.valuesSources?.get(R);for(const A of Object.keys(L)){const M=T?.get(A);(k.$gg(M)?M:M?.id)===u&&(T?.delete(A),delete S.value[R][A])}Object.keys(S.value[R]).length===0&&(delete S.value[R],S.valuesSources?.delete(R))}else{const T=S.valuesSources?.get(R);(k.$gg(T)?T:T?.id)===u&&(S.valuesSources?.delete(R),delete S.value[R])}}const y=this.a.get(l);y&&Object.keys(y.value).length===0&&(this.a.delete(l),delete this.d[l],delete this.b.properties[l])}else{if(S.source instanceof Map){const R=S.source;for(const L in c[l]){const T=R.get(L);(k.$gg(T)?T:T?.id)===u&&(R.delete(L),delete S.value[L])}R.size===0&&this.a.delete(l)}else{const R=k.$gg(S.source)?S.source:S.source?.id;if(u!==R)continue;this.a.delete(l)}const y=this.d[l];y&&(this.w(l,y),this.r(l,y))}i.add(l)}}this.u()}deltaConfiguration(r){let i=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),i=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),i=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const i of r)this.h.add(i);this.u()}n(r,i,c){r.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,c),this.c.push(s),this.q(s)})}o(r,i){const c=s=>{if(s.properties)for(const l in s.properties){i.add(l);const u=this.d[l];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[l],this.s(l,s.properties[l])}s.allOf?.forEach(l=>c(l))};for(const s of r){c(s);const l=this.c.indexOf(s);l!==-1&&this.c.splice(l,1)}}p(r,i=!0,c,s,l=f.WINDOW,u){l=k.$pg(r.scope)?l:r.scope;const S=r.properties;if(S)for(const R in S){const L=S[R];if(i&&E(R,L)){delete S[R];continue}if(L.source=c,L.defaultDefaultValue=S[R].default,this.w(R,L),e.$Go.test(R)?L.scope=void 0:(L.scope=k.$pg(L.scope)?l:L.scope,L.restricted=k.$pg(L.restricted)?!!s?.includes(R):L.restricted),S[R].hasOwnProperty("included")&&!S[R].included){this.f[R]=S[R],delete S[R];continue}else this.d[R]=S[R],S[R].policy?.name&&this.e.set(S[R].policy.name,R);!S[R].deprecationMessage&&S[R].markdownDeprecationMessage&&(S[R].deprecationMessage=S[R].markdownDeprecationMessage),u.add(R)}const y=r.allOf;if(y)for(const R of y)this.p(R,i,c,s,l,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const i=c=>{const s=c.properties;if(s)for(const u in s)this.r(u,s[u]);c.allOf?.forEach(i)};i(r)}r(r,i){switch(e.$xo.properties[r]=i,i.scope){case f.APPLICATION:e.$yo.properties[r]=i;break;case f.MACHINE:e.$zo.properties[r]=i;break;case f.MACHINE_OVERRIDABLE:e.$Ao.properties[r]=i;break;case f.WINDOW:e.$Bo.properties[r]=i;break;case f.RESOURCE:e.$Co.properties[r]=i;break;case f.LANGUAGE_OVERRIDABLE:e.$Co.properties[r]=i,this.g.properties[r]=i;break}}s(r,i){switch(delete e.$xo.properties[r],i.scope){case f.APPLICATION:delete e.$yo.properties[r];break;case f.MACHINE:delete e.$zo.properties[r];break;case f.MACHINE_OVERRIDABLE:delete e.$Ao.properties[r];break;case f.WINDOW:delete e.$Bo.properties[r];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const i=`[${r}]`,c={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$Do};this.w(i,c),e.$xo.properties[i]=c,e.$yo.properties[i]=c,e.$zo.properties[i]=c,e.$Ao.properties[i]=c,e.$Bo.properties[i]=c,e.$Co.properties[i]=c}}v(){const r={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=r,e.$yo.patternProperties[e.$Fo]=r,e.$zo.patternProperties[e.$Fo]=r,e.$Ao.patternProperties[e.$Fo]=r,e.$Bo.patternProperties[e.$Fo]=r,e.$Co.patternProperties[e.$Fo]=r,this.i.fire()}w(r,i){const c=this.a.get(r);let s=c?.value,l=c?.source;k.$ng(s)&&(s=i.defaultDefaultValue,l=void 0),k.$ng(s)&&(s=$(i.type)),i.default=s,i.defaultValueSource=l}}const w="\\[([^\\]]+)\\]",h=new RegExp(w,"g");e.$Fo=`^(${w})+$`,e.$Go=new RegExp(e.$Fo);function p(t){const r=[];if(e.$Go.test(t)){let i=h.exec(t);for(;i?.length;){const c=i[1].trim();c&&r.push(c),i=h.exec(t)}}return(0,n.$Pb)(r)}function b(t){return t.reduce((r,i)=>`${r}[${i}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new g;v.$ro.add(e.$wo.Configuration,m);function E(t,r){return t.trim()?e.$Go.test(t)?D.localize(7,null,t):m.getConfigurationProperties()[t]!==void 0?D.localize(8,null,t):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?D.localize(9,null,t,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:D.localize(6,null)}function P(){const t=[],r=m.getConfigurationProperties();for(const i of Object.keys(r))t.push([i,r[i].scope]);return t.push(["launch",f.RESOURCE]),t.push(["task",f.RESOURCE]),t}}),define(oe[126],ae([0,1,22,4,43,2,32,36,13,7,18,56,15,45]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=P,n=De(n),k=De(k),I=De(I),v=De(v);function h(c){return Object.isFrozen(c)?c:I.$fo(c)}class p{static createEmptyModel(s){return new p({},[],[],void 0,s)}constructor(s,l,u,S,y){this.b=s,this.c=l,this.d=u,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof p)return l;const u=new b("",this.f);return u.parseRaw(l),u.configurationModel});this.g=s.reduce((l,u)=>u===l?u:l.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,f.$ij)(this.contents,s):this.contents}inspect(s,l){const u=this;return{get value(){return h(u.rawConfiguration.getValue(s))},get override(){return l?h(u.rawConfiguration.getOverrideValue(s,l)):void 0},get merged(){return h(l?u.rawConfiguration.override(l).getValue(s):u.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:y,identifiers:R,keys:L}of u.rawConfiguration.overrides){const T=new p(y,L,[],void 0,u.f).getValue(s);T!==void 0&&S.push({identifiers:R,value:T})}return S.length?h(S):void 0}}}getOverrideValue(s,l){const u=this.j(l);return u?s?(0,f.$ij)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const u of this.overrides)u.identifiers.includes(s)&&l.push(...u.keys);return n.$Pb(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return n.$Pb(s)}override(s){let l=this.a.get(s);return l||(l=this.h(s),this.a.set(s,l)),l}merge(...s){const l=I.$eo(this.contents),u=I.$eo(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const R of s)if(y.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(l,R.contents);for(const L of R.overrides){const[T]=u.filter(A=>n.$xb(A.identifiers,L.identifiers));T?(this.i(T.contents,L.contents),T.keys.push(...L.keys),T.keys=n.$Pb(T.keys)):u.push(I.$eo(L))}for(const L of R.keys)S.indexOf(L)===-1&&S.push(L)}return new p(l,S,u,y.every(R=>R instanceof p)?void 0:y,this.f)}h(s){const l=this.j(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const S of n.$Pb([...Object.keys(this.contents),...Object.keys(l)])){let y=this.contents[S];const R=l[S];R&&(typeof y=="object"&&typeof R=="object"?(y=I.$eo(y),this.i(y,R)):y=R),u[S]=y}return new p(u,this.keys,this.overrides,void 0,this.f)}i(s,l){for(const u of Object.keys(l)){if(u in s&&v.$ig(s[u])&&v.$ig(l[u])){this.i(s[u],l[u]);continue}s[u]=I.$eo(l[u])}}j(s){let l=null,u=null;const S=y=>{y&&(u?this.i(u,y):u=I.$eo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?l=y.contents:y.identifiers.includes(s)&&S(y.contents);return S(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.k(s,l,!0)}setValue(s,l){this.k(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,f.$hj)(this.contents,s),d.$Go.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>n.$xb(u.identifiers,(0,d.$Ho)(s))),1))}k(s,l,u){(0,f.$gj)(this.contents,s,l,S=>this.f.error(S)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),d.$Go.test(s)&&this.overrides.push({identifiers:(0,d.$Ho)(s),keys:Object.keys(this.contents[s]),contents:(0,f.$fj)(this.contents[s],S=>this.f.error(S))})}}e.$Mo=p;class b{constructor(s,l){this.f=s,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!v.$pg(s)){const u=this.h(s);this.parseRaw(u,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:u,keys:S,overrides:y,restricted:R,hasExcludedProperties:L}=this.i(s,l);this.b=new p(u,S,y,L?[s]:void 0,this.g),this.c=R||[]}h(s){let l={},u=null,S=[];const y=[],R=[];function L(A){Array.isArray(S)?S.push(A):u!==null&&(S[u]=A)}const T={onObjectBegin:()=>{const A={};L(A),y.push(S),S=A,u=null},onObjectProperty:A=>{u=A},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const A=[];L(A),y.push(S),S=A,u=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:L,onError:(A,M,U)=>{R.push({error:A,offset:M,length:U})}};if(s)try{k.$6n(s,T),l=S[0]||{}}catch(A){this.g.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return l}i(s,l){const u=w.$ro.as(d.$wo.Configuration).getConfigurationProperties(),S=this.j(s,u,!0,l);s=S.raw;const y=(0,f.$fj)(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`)),R=Object.keys(s),L=this.l(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:y,keys:R,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,l,u,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const R={},L=[];for(const T in s)if(d.$Go.test(T)&&u){const A=this.j(s[T],l,!1,S);R[T]=A.raw,y=y||A.hasExcludedProperties,L.push(...A.restricted)}else{const A=l[T],M=A?typeof A.scope<"u"?A.scope:d.ConfigurationScope.WINDOW:void 0;A?.restricted&&L.push(T),!S.exclude?.includes(T)&&(S.include?.includes(T)||(M===void 0||S.scopes===void 0||S.scopes.includes(M))&&!(S.skipRestricted&&A?.restricted))?R[T]=s[T]:y=!0}return{raw:R,restricted:L,hasExcludedProperties:y}}l(s,l){const u=[];for(const S of Object.keys(s))if(d.$Go.test(S)){const y={};for(const R in s[S])y[R]=s[S][R];u.push({identifiers:(0,d.$Ho)(S),keys:Object.keys(y),contents:(0,f.$fj)(y,l)})}return u}}e.$No=b;class $ extends D.$Xc{constructor(s,l,u,S,y){super(),this.c=s,this.f=l,this.g=S,this.h=y,this.b=this.B(new o.$ne),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),y),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(o.Event.any(o.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),o.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(g.FileOperation.CREATE)||R.isOperation(g.FileOperation.COPY)||R.isOperation(g.FileOperation.DELETE)||R.isOperation(g.FileOperation.WRITE))&&u.isEqual(R.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=$;class m{constructor(s,l,u,S,y,R,L,T,A,M,U,C,z){this.a=s,this.b=l,this.c=u,this.overrideIdentifiers=S,this.d=y,this.f=R,this.g=L,this.h=T,this.i=A,this.j=M,this.k=U,this.l=C,this.m=z}get value(){return h(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class E{constructor(s,l,u,S,y,R,L,T,A,M){this.j=s,this.l=l,this.m=u,this.n=S,this.p=y,this.q=R,this.r=L,this.s=T,this.t=A,this.u=M,this.h=null,this.i=new O.$Dc,this.v=null}getValue(s,l,u){return this.w(s,l,u).getValue(s)}updateValue(s,l,u={}){let S;u.resource?(S=this.t.get(u.resource),S||(S=p.createEmptyModel(this.u),this.t.set(u.resource,S))):S=this.s,l===void 0?S.removeValue(s):S.setValue(s,l),u.resource||(this.h=null)}inspect(s,l,u){const S=this.w(s,l,u),y=this.A(l.resource,u),R=l.resource?this.t.get(l.resource)||this.s:this.s,L=new Set;for(const T of S.overrides)for(const A of T.identifiers)S.getOverrideValue(s,A)!==void 0&&L.add(A);return new m(s,l,S.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,y||void 0,R)}keys(s){const l=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,l){this.r.set(s,l),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const u=[];if(!l){const{added:S,updated:y,removed:R}=r(this.j,s);l=[...S,...y,...R]}for(const S of l)for(const y of(0,d.$Ho)(S)){const R=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),T=[...L.filter(A=>R.indexOf(A)===-1),...R.filter(A=>L.indexOf(A)===-1),...R.filter(A=>!I.$io(this.j.override(y).getValue(A),s.override(y).getValue(A)))];u.push([y,T])}return this.updateDefaultConfiguration(s),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:u,removed:S}=r(this.l,s),y=[...l,...u,...S];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:u,removed:S,overrides:y}=r(this.applicationConfiguration,s),R=[...l,...u,...S];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:u,removed:S,overrides:y}=r(this.localUserConfiguration,s),R=[...l,...u,...S];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:u,removed:S,overrides:y}=r(this.remoteUserConfiguration,s),R=[...l,...u,...S];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:u,removed:S,overrides:y}=r(this.workspaceConfiguration,s),R=[...l,...u,...S];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:y}}compareAndUpdateFolderConfiguration(s,l){const u=this.folderConfigurations.get(s),{added:S,updated:y,removed:R,overrides:L}=r(u,l),T=[...S,...y,...R];return(T.length||!u)&&this.updateFolderConfiguration(s,l),{keys:T,overrides:L}}compareAndDeleteFolderConfiguration(s){const l=this.folderConfigurations.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:S,removed:y,overrides:R}=r(l,void 0);return{keys:[...u,...S,...y],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,l,u){let S=this.x(l,u);return l.overrideIdentifier&&(S=S.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},l){let u=this.y();if(l&&s){const S=l.getFolder(s);S&&(u=this.z(S.uri)||u);const y=this.t.get(s);y&&(u=u.merge(y))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let l=this.i.get(s);if(!l){const u=this.y(),S=this.r.get(s);S?(l=u.merge(S),this.i.set(s,l)):l=u}return l}A(s,l){if(l&&s){const u=l.getFolder(s);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,l)=>{const{contents:u,overrides:S,keys:y}=this.r.get(l);return s.push([l,{contents:u,overrides:S,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.q.keys.forEach(l=>s.add(l)),this.r.forEach(l=>l.keys.forEach(u=>s.add(u))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}D(s){const l=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>l.add(u)),this.q.getKeysForOverrideIdentifier(s).forEach(u=>l.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(S=>l.add(S))),[...l.values()]}static parse(s,l){const u=this.E(s.defaults,l),S=this.E(s.policy,l),y=this.E(s.application,l),R=this.E(s.user,l),L=this.E(s.workspace,l),T=s.folders.reduce((A,M)=>(A.set(a.URI.revive(M[0]),this.E(M[1],l)),A),new O.$Dc);return new E(u,S,y,R,p.createEmptyModel(l),L,T,p.createEmptyModel(l),new O.$Dc,l)}static E(s,l){return new p(s.contents,s.keys,s.overrides,void 0,l)}}e.$Po=E;function P(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,l=new Map;for(const S of c)S.keys.forEach(y=>s.add(y)),S.overrides.forEach(([y,R])=>{const L=(0,O.$Ac)(l,y,new Set);R.forEach(T=>L.add(T))});const u=[];return l.forEach((S,y)=>u.push([y,[...S.values()]])),{keys:[...s.values()],overrides:u}}class t{constructor(s,l,u,S,y){this.change=s,this.f=l,this.g=u,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of s.keys)this.affectedKeys.add(R);for(const[,R]of s.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=E.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,l){const u=this.a+s,S=this.d.indexOf(u);if(S<0)return!1;const y=S+u.length;if(y>=this.d.length)return!1;const R=this.d.charCodeAt(y);if(R!==this.b&&R!==this.c)return!1;if(l){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,T=this.g.getValue(s,l,this.h);return!I.$io(L,T)}return!0}}e.$Ro=t;function r(c,s){const{added:l,removed:u,updated:S}=i(s?.rawConfiguration,c?.rawConfiguration),y=[],R=c?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const T=L.filter(A=>!R.includes(A));for(const A of T)y.push([A,s.getKeysForOverrideIdentifier(A)])}if(c){const T=R.filter(A=>!L.includes(A));for(const A of T)y.push([A,c.getKeysForOverrideIdentifier(A)])}if(s&&c){for(const T of R)if(L.includes(T)){const A=i({contents:c.getOverrideValue(void 0,T)||{},keys:c.getKeysForOverrideIdentifier(T)},{contents:s.getOverrideValue(void 0,T)||{},keys:s.getKeysForOverrideIdentifier(T)});y.push([T,[...A.added,...A.removed,...A.updated]])}}return{added:l,removed:u,updated:S,overrides:y}}function i(c,s){const l=c?s?c.keys.filter(y=>s.keys.indexOf(y)===-1):[...c.keys]:[],u=s?c?s.keys.filter(y=>c.keys.indexOf(y)===-1):[...s.keys]:[],S=[];if(c&&s){for(const y of s.keys)if(c.keys.indexOf(y)!==-1){const R=(0,f.$ij)(s.contents,y),L=(0,f.$ij)(c.contents,y);I.$io(R,L)||S.push(y)}}return{added:l,removed:u,updated:S}}}),define(oe[242],ae([0,1,22,4,2,36,13,126,56,5,40,45]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class g extends k.$Xc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new o.$ne),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$ro.as(v.$wo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:$})=>this.f(Array.from(b),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,$){this.j(b,d.$ro.as(v.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=I.$Mo.createEmptyModel(this.c);const b=d.$ro.as(v.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,$){const m=this.g();for(const E of b){const P=m[E],t=$[E];P!==void 0?this.b.addValue(E,P):t?this.b.addValue(E,t.default):this.b.removeValue(E)}}}e.$So=g;class w{constructor(){this.onDidChangeConfiguration=o.Event.None,this.configurationModel=I.$Mo.createEmptyModel(new a.$nk)}async initialize(){return this.configurationModel}}e.$To=w;let h=class extends k.$Xc{get configurationModel(){return this.b}constructor(b,$,m){super(),this.c=b,this.f=$,this.g=m,this.a=this.B(new o.$ne),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const $={},m=[],E=d.$ro.as(v.$wo.Configuration).getConfigurationProperties();for(const P of b){const t=E[P];if(!t){m.push(P);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}m.push(P),$[t.policy.name]={type:t.type}}}return(0,O.$tg)($)||await this.f.updatePolicyDefinitions($),m}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const $=d.$ro.as(v.$wo.Configuration).getPolicyConfigurations(),m=(0,n.$Kb)(b.map(E=>$.get(E)));this.m(m,!0)}m(b,$){this.g.trace("PolicyConfiguration#update",b);const m=d.$ro.as(v.$wo.Configuration).getConfigurationProperties(),E=[],P=this.b.isEmpty();for(const t of b){const r=m[t]?.policy?.name;if(r){const i=this.f.getPolicyValue(r);(P?i!==void 0:!(0,D.$io)(this.b.getValue(t),i))&&E.push([t,i])}else this.b.getValue(t)!==void 0&&E.push([t,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const t=this.b;this.b=I.$Mo.createEmptyModel(this.g);for(const r of t.keys)this.b.setValue(r,t.getValue(r));for(const[r,i]of E)i===void 0?this.b.removeValue(r):this.b.setValue(r,i);$&&this.a.fire(this.b)}}};e.$Uo=h,e.$Uo=h=ke([ne(1,f.$to),ne(2,a.$ak)],h)}),define(oe[243],ae([0,1,22,8,17,4,43,108,2,32,36,3,19,18,126,56,242,15,40]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class E extends v.$Xc{constructor(r,i,c,s){super(),this.m=r,this.n=s,this.h=this.B(new D.$ne),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$So(s)),this.c=c instanceof m.$vo?new b.$To:this.B(new b.$Uo(this.b,c,s)),this.f=this.B(new h.$Oo(this.m,{},g.$$g,i,s)),this.a=new h.$Po(this.b.configurationModel,this.c.configurationModel,h.$Mo.createEmptyModel(s),h.$Mo.createEmptyModel(s),h.$Mo.createEmptyModel(s),h.$Mo.createEmptyModel(s),new a.$Dc,h.$Mo.createEmptyModel(s),new a.$Dc,s),this.j=new P(r,i,this),this.g=this.B(new o.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:u})=>this.s(l,u))),this.B(this.c.onDidChangeConfiguration(l=>this.t(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,i,c]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$Po(r,i,h.$Mo.createEmptyModel(this.n),c,h.$Mo.createEmptyModel(this.n),h.$Mo.createEmptyModel(this.n),new a.$Dc,h.$Mo.createEmptyModel(this.n),new a.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,i){const c=typeof r=="string"?r:void 0,s=(0,w.$bj)(r)?r:(0,w.$bj)(i)?i:{};return this.a.getValue(c,s,void 0)}async updateValue(r,i,c,s,l){const u=(0,w.$cj)(c)?c:(0,w.$bj)(c)?{resource:c.resource,overrideIdentifiers:c.overrideIdentifier?[c.overrideIdentifier]:void 0}:void 0,S=u?s:c;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${S}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.$Pb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const y=this.inspect(r,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,f.$io)(i,y.defaultValue)&&(i=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const L=u.overrideIdentifiers.sort(),T=this.a.localUserConfiguration.overrides.find(A=>(0,n.$xb)([...A.identifiers].sort(),L));T&&(u.overrideIdentifiers=T.identifiers)}const R=u?.overrideIdentifiers?.length?[(0,p.$Io)(u.overrideIdentifiers),r]:[r];await this.j.write(R,i),await this.reloadConfiguration()}inspect(r,i={}){return this.a.inspect(r,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const i=this.a.toData(),c=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(c,i,w.ConfigurationTarget.USER)}s(r,i){const c=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(r,i);this.u(s,c,w.ConfigurationTarget.DEFAULT)}t(r){const i=this.a.toData(),c=this.a.compareAndUpdatePolicyConfiguration(r);this.u(c,i,w.ConfigurationTarget.DEFAULT)}u(r,i,c){const s=new h.$Ro(r,{data:i},this.a,void 0,this.n);s.source=c,this.h.fire(s)}}e.$Vo=E;class P{constructor(r,i,c){this.b=r,this.c=i,this.d=c,this.a=new o.$Nh}write(r,i){return this.a.queue(()=>this.e(r,i))}async e(r,i){let c;try{c=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)c="{}";else throw u}const s=[];if((0,O.$Yn)(c,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const l=this.f(c,r,i);c=(0,I.$do)(c,l),await this.c.writeFile(this.b,k.$Pe.fromString(c))}f(r,i,c){const{tabSize:s,insertSpaces:l,eol:u}=this.h;if(!i.length){const S=JSON.stringify(c,null,l?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,I.$ao)(r,i,c,{tabSize:s,insertSpaces:l,eol:u})}get h(){if(!this.g){let r=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(r=i),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[244],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=void 0,e.$Kgc="request",e.$Lgc="remoteResourceHandler";class n{async routeCall(k,D,O){if(D!==e.$Kgc)throw new Error(`Call not found: ${D}`);const I=O[0];if(I?.authority){const v=k.connections.find(a=>a.ctx===I.authority);if(v)return v}throw new Error("Caller not found")}routeEvent(k,D){throw new Error(`Event not found: ${D}`)}}e.$Mgc=n}),define(oe[245],ae([0,1,16,6]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=a,e.$Rl=(0,o.$Gi)("remoteAuthorityResolverService");var k;(function(f){f[f.WebSocket=0]="WebSocket",f[f.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class D{constructor(d){this.id=d,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=D;class O{constructor(d,g){this.host=d,this.port=g,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=O;var I;(function(f){f.Unknown="Unknown",f.NotAvailable="NotAvailable",f.TemporarilyNotAvailable="TemporarilyNotAvailable",f.NoResolverFound="NoResolverFound",f.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class v extends n.$eb{static isNotAvailable(d){return d instanceof v&&d._code===I.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof v&&d._code===I.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof v&&d._code===I.NoResolverFound}static isInvalidAuthority(d){return d instanceof v&&d._code===I.InvalidAuthority}static isHandled(d){return d instanceof v&&d.isHandled}constructor(d,g=I.Unknown,w){super(d),this._message=d,this._code=g,this._detail=w,this.isHandled=g===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Ul=v;function a(f){const d=f.indexOf("+");return d===-1?f:f.substring(0,d)}}),define(oe[246],ae([0,1,8,17,23,16,4,2,12,71,67,33,118,245]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=y,e.$2l=R,e.$3l=T,a=De(a);const h=30*1e3;var p;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function b(se){switch(se){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function $(se){const _=new k.$ye;return setTimeout(()=>_.cancel(),se),_.token}function m(se,_){if(se.isCancellationRequested||_.isCancellationRequested)return k.CancellationToken.Cancelled;const F=new k.$ye;return se.onCancellationRequested(()=>F.cancel()),_.onCancellationRequested(()=>F.cancel()),F.token}class E{get didTimeout(){return this.c==="timedout"}constructor(_){this.c="pending",this.d=new I.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$zh)(),_.isCancellationRequested?this.h():this.d.add(_.onCancellationRequested(()=>this.h()))}registerDisposable(_){this.c==="pending"?this.d.add(_):_.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(_))}reject(_){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(_))}}function P(se,_){const F=new E(_);return F.registerDisposable(se.onControlMessage(N=>{const W=JSON.parse(N.toString()),H=j(W);H?F.reject(H):F.resolve(W)})),F.promise}function t(se,_,F,N,W,H,J,Y){const V=new E(Y),ie=f.$he.create(!1);return se.info(`Creating a socket (${J})...`),a.mark(`code/willCreateSocket/${H}`),_.connect(F,N,W,J).then(de=>{V.didTimeout?(a.mark(`code/didCreateSocketError/${H}`),se.info(`Creating a socket (${J}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(a.mark(`code/didCreateSocketOK/${H}`),se.info(`Creating a socket (${J}) was successful after ${ie.elapsed()} ms.`),V.resolve(de))},de=>{a.mark(`code/didCreateSocketError/${H}`),se.info(`Creating a socket (${J}) returned an error after ${ie.elapsed()} ms.`),se.error(de),V.reject(de)}),V.promise}function r(se,_){const F=new E(_);return se.then(N=>{F.didTimeout||F.resolve(N)},N=>{F.didTimeout||F.reject(N)}),F.promise}async function i(se,_,F,N){const W=K(se,_);se.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let H;try{H=await t(se.logService,se.remoteSocketFactoryService,se.connectTo,v.$Tg.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,b(_),`renderer-${b(_)}-${se.reconnectionToken}`,N)}catch(de){throw se.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let J,Y;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(H,null),J=se.reconnectionProtocol,Y=!1):(J=new g.$ui({socket:H}),Y=!0),se.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const V=await r(se.signService.createNewMessage((0,d.$3g)()),N),ie={type:"auth",auth:se.connectionToken||"00000000000000000000",data:V.data};J.sendControl(o.$Pe.fromString(JSON.stringify(ie)));try{const de=await P(J,m(N,$(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(se.logService.trace(`${W} 4/6. received SignRequest control message.`),!await r(se.signService.validate(V,de.signedData),N)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const we=await r(se.signService.sign(de.data),N),Oe={type:"connectionType",commit:se.commit,signedData:we,desiredConnectionType:_};return F&&(Oe.args=F),se.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(o.$Pe.fromString(JSON.stringify(Oe))),{protocol:J,ownsProtocol:Y}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${W} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${W} received error control message when negotiating connection. Error:`),se.logService.error(de)),Y&&q(J),de}}async function c(se,_,F,N){const W=Date.now(),H=K(se,_),{protocol:J,ownsProtocol:Y}=await i(se,_,F,N),V=new E(N);return V.registerDisposable(J.onControlMessage(ie=>{const de=JSON.parse(ie.toString()),me=j(de);me?(se.logService.error(`${H} received error control message when negotiating connection. Error:`),se.logService.error(me),Y&&q(J),V.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(W)}!`),V.resolve({protocol:J,firstMessage:de}))})),V.promise}async function s(se,_){const{protocol:F}=await c(se,p.Management,void 0,_);return{protocol:F}}async function l(se,_,F){const{protocol:N,firstMessage:W}=await c(se,p.ExtensionHost,_,F),H=W&&W.debugPort;return{protocol:N,debugPort:H}}async function u(se,_,F){const N=Date.now(),W=K(se,p.Tunnel),{protocol:H}=await i(se,p.Tunnel,_,F);return se.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${he(N)}!`),H}async function S(se,_,F){const{connectTo:N,connectionToken:W}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:N,connectionToken:W,reconnectionToken:_,reconnectionProtocol:F,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function y(se,_,F){return L(se,async N=>{const{protocol:W}=await s(N,k.CancellationToken.None);return new X(se,_,F,N.reconnectionToken,W)})}async function R(se,_){return L(se,async F=>{const{protocol:N,debugPort:W}=await l(F,_,k.CancellationToken.None);return new ee(se,_,F.reconnectionToken,N,W)})}async function L(se,_){for(let N=1;;N++)try{const W=(0,d.$3g)(),H=await S(se,W,null);return await _(H)}catch(W){if(N<5)se.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(W);else throw se.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(W),le.triggerPermanentFailure(0,0,w.$Ul.isHandled(W)),W}}async function T(se,_,F){const N=await S(se,(0,d.$3g)(),null);return await u(N,{host:_,port:F},k.CancellationToken.None)}function A(se){return(0,n.$th)(_=>new Promise((F,N)=>{const W=setTimeout(F,se*1e3);_.onCancellationRequested(()=>{clearTimeout(W),F()})}))}var M;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class U{constructor(_,F){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$4l=U;class C{constructor(_,F,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.durationSeconds=N,this.c=W,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=C;class z{constructor(_,F,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ReconnectionRunning}}e.$6l=z;class re{constructor(_,F,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ConnectionGain}}e.$7l=re;class Z{constructor(_,F,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.handled=W,this.type=M.ReconnectionPermanentFailure}}e.$8l=Z;class le extends I.$Xc{static triggerPermanentFailure(_,F,N){this._permanentFailure=!0,this.f=_,this.g=F,this.h=N,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(_=>_.y())}static debugPauseSocketWriting(){this.j.forEach(_=>_.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(_,F,N,W,H){super(),this.t=_,this.u=F,this.reconnectionToken=N,this.protocol=W,this.w=H,this.m=this.B(new O.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new re(this.reconnectionToken,0,0)),this.B(W.onSocketClose(J=>{const Y=ce(this.t,this.reconnectionToken,!0);J?J.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Y} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${Y} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${Y} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(J=>{const Y=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,I.$Vc)(()=>{const J=le.j.indexOf(this);J>=0&&le.j.splice(J,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<F.length?F[N]:F[F.length-1];try{if(W>0){const J=A(W);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,J)),this.u.logService.info(`${_} waiting for ${W} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${_} resolving connection...`);const H=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${_} connecting to ${H.connectTo}...`),await this.G(H,$(h)),this.u.logService.info(`${_} reconnected!`),this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(w.$Ul.isTemporarilyNotAvailable(H)){this.u.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,D.$7)(H)){this.u.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof w.$Ul){this.u.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,w.$Ul.isHandled(H));break}this.u.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(_,F,N){this.w?le.triggerPermanentFailure(_,F,N):this.D(_,F,N)}D(_,F,N){this.m.fire(new Z(this.reconnectionToken,_,F,N)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=le;class X extends le{constructor(_,F,N,W,H){super(p.Management,_,W,H,!0),this.client=this.B(new g.$si(H,{remoteAuthority:F,clientId:N},_.ipcLogger))}async G(_,F){await s(_,F)}}e.$0l=X;class ee extends le{constructor(_,F,N,W,H){super(p.ExtensionHost,_,N,W,!1),this.H=F,this.debugPort=H}async G(_,F){await l(_,this.H,F)}}e.$$l=ee;function q(se){try{se.acceptDisconnect();const _=se.getSocket();se.dispose(),_.dispose()}catch(_){(0,D.$3)(_)}}function j(se){if(se&&se.type==="error"){const _=new Error(`Connection error: ${se.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function B(se,_){for(;se.length<_;)se+=" ";return se}function G(se,_){return`[remote-connection][${B(b(se),13)}][${_.substr(0,5)}\u2026]`}function ce(se,_,F){return`${G(se,_)}[${F?"reconnect":"initial"}]`}function K(se,_){return`${ce(_,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function he(se){return`${Date.now()-se} ms`}}),define(oe[75],ae([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=o,e.$in=k,e.$jn=D,e.$kn=O;function o(v){return v.scheme===n.Schemas.vscodeRemote?v.authority:void 0}function k(v){if(!v)return;const a=v.indexOf("+");return a<0?v:v.substr(0,a)}function D(v){const{host:a,port:f}=I(v);if(typeof f>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function O(v,a){let{host:f,port:d}=I(v);return typeof d>"u"&&(d=a),{host:f,port:d}}function I(v){const a=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=v.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const d=v.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:v,port:void 0}}}),define(oe[86],ae([0,1,26,6,75]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=D,e.$un=d,e.$vn=g,e.$wn=w,e.$xn=h,e.$yn=p,e.$zn=b,n=De(n),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function D($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function($){$[$.System=0]="System",$[$.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class v{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,E){if(typeof m>"u"||m===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof m=="string"||typeof E=="string"){const P=typeof m=="string"?m:m.value,t=typeof E=="string"?E:E.value;return n.$Hf(P,t)}return m._lower===E._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$rn=v;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const E of m)this.add(E)}add(m){this.c.add(v.toKey(m))}delete(m){return this.c.delete(v.toKey(m))}has(m){return this.c.has(v.toKey(m))}}e.$sn=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(v.toKey(m))}get(m){return this.c.get(v.toKey(m))}has(m){return this.c.has(v.toKey(m))}set(m,E){this.c.set(v.toKey(m),E)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=f;function d($){return g($)}function g($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function w($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function h($,m){if(m){const E=`onResolveRemoteAuthority:${(0,k.$in)(m)}`;return!!$.activationEvents?.includes(E)}return!1}function p($){return $.map(m=>{const[E,P]=m.split("@");return{proposalName:E,version:P?parseInt(P):void 0}})}function b($){return $.map(m=>m.split("@")[0])}e.$An=(0,o.$Gi)("IBuiltinExtensionsScannerService")}),define(oe[127],ae([0,1,3,175,86,6]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=I,e.$ep=v,e.$fp=a,e.$gp=f,e.$hp=d,e.$ip=g,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var O;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function v(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function a(t,r){switch(t){case n.Platform.Windows:return r==="x64"?k.TargetPlatform.WIN32_X64:r==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Linux:return r==="x64"?k.TargetPlatform.LINUX_X64:r==="arm64"?k.TargetPlatform.LINUX_ARM64:r==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?k.TargetPlatform.ALPINE_X64:r==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Mac:return r==="x64"?k.TargetPlatform.DARWIN_X64:r==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Web:return k.TargetPlatform.WEB}}function f(t,r){return r===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function d(t,r,i){return f(r,i)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===i}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var h;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var p;(function(t){t.Install="install",t.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var b;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$jp=(0,D.$Gi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class m extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$kp=m;var E;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class P extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$lp=P,e.$mp=(0,D.$Gi)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,D.$Gi)("IGlobalExtensionEnablementService"),e.$qp=(0,D.$Gi)("IExtensionTipsService"),e.$rp=(0,o.localize2)(0,"Extensions"),e.$sp=(0,o.localize2)(1,"Preferences")});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[247],ae([0,1,19,81,178,248,86,210]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=f,e.$Yp=d,e.$Zp=g,e.$1p=w,e.$2p=h,e.$3p=p,e.$4p=b,e.$5p=$,o=et(o),k=De(k),D=De(D);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(P){return P=P.trim(),P==="*"||v.test(P)}function d(P){if(!f(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=P.match(v);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function g(P){if(!P)return null;const t=P.majorBase,r=P.majorMustEqual,i=P.minorBase;let c=P.minorMustEqual;const s=P.patchBase;let l=P.patchMustEqual;P.hasCaret&&(t===0||(c=!1),l=!1);let u=0;if(P.preRelease){const S=a.exec(P.preRelease);if(S){const[,y,R,L]=S;u=Date.UTC(Number(y),Number(R)-1,Number(L))}}return{majorBase:t,majorMustEqual:r,minorBase:i,minorMustEqual:c,patchBase:s,patchMustEqual:l,isMinimum:P.hasGreaterEquals,notBefore:u}}function w(P,t,r){let i;typeof P=="string"?i=g(d(P)):i=P;let c;t instanceof Date?c=t.getTime():typeof t=="string"&&(c=new Date(t).getTime());let s;if(typeof r=="string"?s=g(d(r)):s=r,!i||!s)return!1;const l=i.majorBase,u=i.minorBase,S=i.patchBase;let y=s.majorBase,R=s.minorBase,L=s.patchBase;const T=s.notBefore;let A=s.majorMustEqual,M=s.minorMustEqual,U=s.patchMustEqual;return s.isMinimum?l>y?!0:l<y?!1:u>R?!0:u<R||c&&c<T?!1:S>=L:(l===1&&y===0&&(!A||!M||!U)&&(y=1,R=0,L=0,A=!0,M=!1,U=!1),l<y?!1:l>y?!A:u<R?!1:u>R?!M:S<L?!1:S>L?!U:!(c&&c<T))}function h(P,t,r,i,c){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([o.default.Error,k.localize(0,null)]),s;if(typeof i.name!="string")return s.push([o.default.Error,k.localize(1,null,"name")]),s;if(typeof i.version!="string")return s.push([o.default.Error,k.localize(2,null,"version")]),s;if(!i.engines)return s.push([o.default.Error,k.localize(3,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([o.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!E(i.extensionDependencies))return s.push([o.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!E(i.activationEvents))return s.push([o.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([o.default.Error,k.localize(7,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([o.default.Warning,k.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([o.default.Error,k.localize(9,null,"main")]),s;{const S=(0,n.$hh)(r,i.main);(0,n.$bh)(S,r)||s.push([o.default.Warning,k.localize(10,null,S.path,r.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([o.default.Error,k.localize(11,null,"browser")]),s;{const S=(0,n.$hh)(r,i.browser);(0,n.$bh)(S,r)||s.push([o.default.Warning,k.localize(12,null,S.path,r.path)])}}if(!D.valid(i.version))return s.push([o.default.Error,k.localize(13,null)]),s;const l=[];if(!p(P,t,i,c,l))for(const S of l)s.push([o.default.Error,S]);if(i.enabledApiProposals?.length){const S=[];if(!$([...i.enabledApiProposals],S))for(const y of S)s.push([o.default.Error,y])}return s}function p(P,t,r,i,c){return i||typeof r.main>"u"&&typeof r.browser>"u"?!0:m(P,t,r.engines.vscode,c)}function b(P,t,r){return P==="*"||m(t,r,P)}function $(P,t){if(P.length===0)return!0;const r=Array.isArray(t)?t:void 0,i=(r?void 0:t)??I.allApiProposals,c=[],s=(0,O.$yn)(P);for(const{proposalName:l,version:u}of s){const S=i[l];S&&u&&S.version!==u&&c.push(k.localize(14,null,l))}return r?.push(...c),c.length===0}function m(P,t,r,i=[]){const c=g(d(r));if(!c)return i.push(k.localize(15,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return i.push(k.localize(16,null,r)),!1}else if(!c.majorMustEqual)return i.push(k.localize(17,null,r)),!1;return w(P,t,c)?!0:(i.push(k.localize(18,null,P,r)),!1)}function E(P){if(!Array.isArray(P))return!1;for(let t=0,r=P.length;t<r;t++)if(typeof P[t]!="string")return!1;return!0}}),define(oe[249],ae([0,1,2,6]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,o.$Gi)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,n.$Vc)(()=>{const v=this.a[O]?.indexOf(I);typeof v=="number"&&v>=0&&this.a[O]?.splice(v,1)})}b(O){return(this.a[O.type]||[]).find(v=>v.supports(O))}connect(O,I,v,a){const f=this.b(O);if(!f)throw new Error(`No socket factory found for ${O}`);return f.connect(O,I,v,a)}}e.$Xl=k}),define(oe[250],ae([0,1,27,49,21,122]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=I,n=De(n),o=De(o),D=De(D);let O;async function I(w=!1){return(O===void 0||w)&&(O=v()),O}async function v(){const w=a();if(w===void 0)return!1;if(w>=22e3){const h=d();if(h)return new Promise(p=>{o.execFile(h,["--status"],b=>p(!b))})}else{const h=g();if(h)try{if((await k.Promises.stat(h)).isFile())return!0}catch{}}return!1}function a(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(w)return parseInt(w[3])}function f(w){const h=process.env.SystemRoot;if(h){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(h,p?"Sysnative":"System32",w)}}function d(){return f("wsl.exe")}function g(){return f("lxss\\LxssManager.dll")}}),define(oe[57],ae([0,1,17,16,2,190,56,6,5,45]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=g,e.$9p=w,e.$0p=h,e.$$p=p,e.$_p=b,e.$aq=$,e.$6p=(0,I.$Gi)("requestService");class f{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?t[r]="*****":t[r]=this.b[r];this.a=t}return this.a}}class d extends k.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(0,null),when:v.$sk.isEqualTo((0,v.$pk)(v.LogLevel.Trace)).serialize()})}async c(t,r,i){const c=`${t} #${++this.b}: ${r.url}`;this.a.trace(`${c} - begin`,r.type,new f(r.headers??{}));try{const s=await i();return this.a.trace(`${c} - end`,r.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${c} - error`,r.type,(0,o.$ab)(s)),s}}}e.$7p=d;function g(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}function w(P){return P.res.statusCode===204}async function h(P){return w(P)?null:(await(0,n.$2e)(P.stream)).toString()}async function p(P){if(!g(P))throw new Error("Server returned "+P.res.statusCode);return h(P)}async function b(P){if(!g(P))throw new Error("Server returned "+P.res.statusCode);if(w(P))return null;const r=(await(0,n.$2e)(P.stream)).toString();try{return JSON.parse(r)}catch(i){throw i.message+=`:
`+r,i}}function $(P){E(P)}let m;function E(P){const t=a.$ro.as(O.$wo.Configuration),r=m;m={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null),(0,D.localize)(10,null)],default:"override",description:(0,D.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[m],remove:r?[r]:[]})}E(O.ConfigurationScope.APPLICATION)}),define(oe[251],ae([0,1,17,23]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class k{constructor(I){this.a=I}listen(I,v){throw new Error("Invalid listen")}call(I,v,a,f=o.CancellationToken.None){switch(v){case"request":return this.a.request(a[0],f).then(async({res:d,stream:g})=>{const w=await(0,n.$2e)(g);return[{statusCode:d.statusCode,headers:d.headers},w]});case"resolveProxy":return this.a.resolveProxy(a[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$as=k;class D{constructor(I){this.a=I}async request(I,v){const[a,f]=await this.a.call("request",[I],v);return{res:a,stream:(0,n.$4e)(f)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$bs=D}),define(oe[252],ae([0,1,253,13]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=D;function k(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(O,I,v={}){const a=(0,n.parse)(O),f=v.proxyUrl||k(a,I);if(!f)return null;const d=(0,n.parse)(f);if(!/^https?:$/.test(d.protocol||""))return null;const g={host:d.hostname||"",port:(d.port?+d.port:0)||(d.protocol==="https"?443:80),auth:d.auth,rejectUnauthorized:(0,o.$mg)(v.strictSSL)?v.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,h)=>{x(["http-proxy-agent"],w,h)}).then(De)).HttpProxyAgent(f,g):new(await new Promise((w,h)=>{x(["https-proxy-agent"],w,h)}).then(De)).HttpsProxyAgent(f,g)}}),define(oe[254],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=void 0,e.$5fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$6fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$7fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[101],ae([0,1,49,10,191,23,55,16,3,33,117,69,8,143]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=p;let h;async function p($,m,E,P){return E["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$Km)(P)&&!E["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$Km)(P)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=g.Promises.withAsyncBody(async(t,r)=>{const i=new D.$ye;let c=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(c=(0,w.$Lm)(s,1,120)*1e3);const l=setTimeout(()=>{i.dispose(!0),r(new Error((0,k.localize)(0,null)))},c);try{t(await b(m,i.token))}catch(u){!(0,I.$7)(u)&&!i.token.isCancellationRequested?r(new Error((0,k.localize)(1,null,(0,O.$rj)(u)))):t({})}finally{clearTimeout(l),i.dispose()}})),h)}async function b($,m){const E=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",E);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",P);const t=(0,a.$3g)().replace(/-/g,"").substr(0,12),r=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",i);const c=await(0,f.$Am)(v.OS,i);return $.trace("getUnixShellEnvironment#shell",c),new Promise((s,l)=>{if(m.isCancellationRequested)return l(new I.$8);const u=(0,o.$qc)(c);let S,y;const R="";/^pwsh(-preview)?$/.test(u)?(S=`& '${process.execPath}' ${R} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):u==="nu"?(S=`^'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):u==="xonsh"?(S=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(S=`'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u==="tcsh"||u==="csh"?y=["-ic"]:y=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),S);const L=(0,n.spawn)(c,[...y,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});m.onCancellationRequested(()=>(L.kill(),l(new I.$8))),L.on("error",M=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,O.$rj)(M)),l(M)});const T=[];L.stdout.on("data",M=>T.push(M));const A=[];L.stderr.on("data",M=>A.push(M)),L.on("close",(M,U)=>{const C=Buffer.concat(T).toString("utf8");$.trace("getUnixShellEnvironment#raw",C);const z=Buffer.concat(A).toString("utf8");if(z.trim()&&$.trace("getUnixShellEnvironment#stderr",z),M||U)return l(new Error((0,k.localize)(2,null,M,U)));const re=r.exec(C),Z=re?re[1]:"{}";try{const le=JSON.parse(Z);E?le.ELECTRON_RUN_AS_NODE=E:delete le.ELECTRON_RUN_AS_NODE,P?le.ELECTRON_NO_ATTACH_CONSOLE=P:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",le),s(le)}catch(le){$.error("getUnixShellEnvironment#errorCaught",(0,O.$rj)(le)),l(le)}})})}}),define(oe[255],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const D=await this.c();if(D){const O=String(n.a++);return this.b.set(O,D),{id:O,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,D){if(!k.id)return!0;const O=this.b.get(k.id);if(!O)return!1;this.b.delete(k.id);try{return O.validate(D)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$Qbc=n}),define(oe[102],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,n.$Gi)(e.$Yl)}),define(oe[256],ae([0,1,255]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class o extends n.$Qbc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(O=>new O.signer().sign(D))}h(){return new Promise((D,O)=>x(["vsda"],D,O))}}e.$Wgc=o}),define(oe[34],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,n.$Gi)("stateReadService"),e.$gR=(0,n.$Gi)("stateService")}),define(oe[128],ae([0,1,8,17,2,13,38,15,5]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends k.$Xc{constructor(h,p,b,$){super(),this.h=h,this.j=p,this.m=b,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Eh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(h)}}getItem(h,p){const b=this.a[h];return(0,D.$pg)(b)?p:b}setItem(h,p){this.setItems([{key:h,data:p}])}setItems(h){let p=!1;for(const{key:b,data:$}of h)this.a[b]!==$&&((0,D.$pg)($)?(0,D.$ng)(this.a[b])||(this.a[b]=void 0,p=!0):(this.a[b]=$,p=!0));p&&this.s()}removeItem(h){(0,D.$ng)(this.a[h])||(this.a[h]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.n.writeFile(this.h,o.$Pe.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(p){this.m.error(p)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=f;let d=class extends k.$Xc{constructor(h,p,b,$){super(),this.a=this.B(new f(p.stateResource,h,b,$))}async init(){await this.a.init()}getItem(h,p){return this.a.getItem(h,p)}};e.$iR=d,e.$iR=d=ke([ne(1,O.$Ni),ne(2,v.$ak),ne(3,I.$al)],d);class g extends d{setItem(h,p){this.a.setItem(h,p)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$jR=g}),define(oe[129],ae([0,1,3,37,33]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=O,e.$up=I;function D(v){if(n.$u===n.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function O(v,a,f,d,g,w,h,p,b,$){const m=Object.create(null);m["common.machineId"]=w,m["common.sqmId"]=h,m["common.devDeviceId"]=p,m.sessionID=(0,k.$3g)()+Date.now(),m.commitHash=d,m.version=g,m["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,n.$h)(n.$u),m["common.nodePlatform"]=o.$gc,m["common.nodeArch"]=f,m["common.product"]=$||"desktop",b&&(m["common.msftInternal"]=b);let E=0;const P=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-P,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),n.$l&&(m["common.snap"]="true");const t=D(a);return t&&(m["common.platformDetail"]=t),m}function I(v){const a=o.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return v.some(d=>f===d)}}),define(oe[25],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,n.$Gi)("telemetryService"),e.$am=(0,n.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var o;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(o||(e.TelemetryLevel=o={}));var k;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(oe[257],ae([0,1,27,8,43,12,10,3,67,7,94,21,116,97,15,28,25]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Ws=m,e.$Xs=P,e.$Ys=t,n=De(n);const $=new Map;async function m(i,c){const s=`${i}::${c.join(":")}`,l=$.get(s);if(l)return l;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],S=new Map,y=new Map,R=2e4;function L(A,M,U,C){const z=M.substring(A.length+1);return o.Promises.withAsyncBody(async re=>{let Z;C.readdirCount++;try{Z=await d.Promises.readdir(M,{withFileTypes:!0})}catch{re();return}if(C.count>=R){C.count+=Z.length,C.maxReached=!0,re();return}let le=Z.length;if(le===0){re();return}let X=Z;C.count+Z.length>R&&(C.maxReached=!0,le=R-C.count,X=Z.slice(0,le)),C.count+=Z.length;for(const ee of X)if(ee.isDirectory()){if(U.includes(ee.name)||await L(A,(0,O.$mc)(M,ee.name),U,C),--le===0){re();return}}else{const q=ee.name.lastIndexOf(".");if(q>=0){const j=ee.name.substring(q+1);j&&S.set(j,(S.get(j)??0)+1)}for(const j of u)j.relativePathPattern?.test(z)!==!1&&j.filePattern.test(ee.name)&&y.set(j.tag,(y.get(j.tag)??0)+1);if(--le===0){re();return}}})}const T=o.Promises.withAsyncBody(async A=>{const M={count:0,maxReached:!1,readdirCount:0},U=new v.$he(!0);await L(i,i,c,M);const C=await t(i);A({configFiles:E(y),fileTypes:E(S),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:C,totalScanTime:U.elapsed(),totalReaddirCount:M.readdirCount})});return $.set(s,T),T}function E(i){return Array.from(i.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function P(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/h.$Il.GB).toFixed(2)}GB (${(n.freemem()/h.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$Sn.value()*100)}%`},c=n.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}async function t(i){try{const c=new Map,s=(0,O.$mc)(i,".vscode","launch.json"),l=await d.Promises.readFile(s),u=[],S=(0,k.$Yn)(l.toString(),u);if(u.length)return console.log(`Unable to parse ${s}`),[];if((0,k.$7n)(S)==="object"&&S.configurations)for(const y of S.configurations){const R=y.type;R&&(c.has(R)?c.set(R,c.get(R)+1):c.set(R,1))}return E(c)}catch{return[]}}let r=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const l=n.cpus();return l&&l.length>0&&s.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/h.$Il.GB).toFixed(2)}GB (${(n.freemem()/h.$Il.GB).toFixed(2)}GB free)`),I.$i||s.push(`Load (avg):       ${n.loadavg().map(u=>Math.round(u)).join(", ")}`),s.push(`VM:               ${Math.round(f.$Sn.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,g.$Vs)(c.mainPID),this.k(c)]).then(async l=>{let[u,S]=l,y=this.m(c,u);return s.forEach(R=>{if((0,w.$Um)(R))y+=`
${R.errorMessage}`,S+=`
${R.errorMessage}`;else if(y+=`

Remote: ${R.hostName}`,R.processes&&(y+=`
${this.m(c,R.processes)}`),R.workspaceMetadata){S+=`
|  Remote: ${R.hostName}`;for(const L of Object.keys(R.workspaceMetadata)){const T=R.workspaceMetadata[L];let A=`${T.fileCount} files`;T.maxFilesReached&&(A=`more than ${A}`),S+=`|    Folder (${L}): ${A}`,S+=this.h(T)}}}),{processInfo:y,workspaceInfo:S}})}async getSystemInfo(c,s){const{memory:l,vmHint:u,os:S,cpus:y}=P(),R={os:S,memory:l,cpus:y,vmHint:u,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return I.$i||(R.load=`${n.loadavg().map(L=>Math.round(L)).join(", ")}`),I.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(c,s){const l=[];return(0,g.$Vs)(c.mainPID).then(async u=>(l.push(""),l.push(this.g(c)),l.push(""),l.push(this.m(c,u)),c.windows.some(S=>S.folderURIs&&S.folderURIs.length>0&&!S.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(c))),s.forEach(S=>{if((0,w.$Um)(S))l.push(`
${S.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${S.hostName}`),l.push(this.f(S.machineInfo)),S.processes&&l.push(this.m(c,S.processes)),S.workspaceMetadata)for(const y of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[y];let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),l.push(`Folder (${y}): ${L}`),l.push(this.h(R))}}),l.push(""),l.push(""),l.join(`
`)))}h(c){const s=[];let u=0;const S=(T,A)=>{const M=` ${T}(${A})`;u+M.length>60?(s.push(y),y="|                 ",u=y.length):u+=M.length,y+=M};let y="|      File types:";const R=10,L=c.fileTypes.length>R?R:c.fileTypes.length;for(let T=0;T<L;T++){const A=c.fileTypes[T];S(A.name,A.count)}if(s.push(y),c.configFiles.length>=0&&(y="|      Conf files:",u=0,c.configFiles.forEach(T=>{S(T.name,T.count)}),s.push(y)),c.launchConfigFiles.length>0){let T="|      Launch Configs:";c.launchConfigFiles.forEach(A=>{const M=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;T+=M}),s.push(T)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(l=>l.length));return Object.keys(c).map(l=>`${l}:  ${" ".repeat(s-l.length)}  ${c[l]}`).join(`
                  `)}k(c){const s=[],l=[];return c.windows.forEach(u=>{u.folderURIs.length===0||u.remoteAuthority||(s.push(`|  Window (${u.title})`),u.folderURIs.forEach(S=>{const y=a.URI.revive(S);if(y.scheme===D.Schemas.file){const R=y.fsPath;l.push(m(R,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,O.$qc)(R)}): ${T}`),s.push(this.h(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${L.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(u=>s.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}m(c,s){const l=new Map;c.windows.forEach(S=>l.set(S.pid,`window [${S.id}] (${S.title})`)),c.pidToNames.forEach(({pid:S,name:y})=>l.set(S,y));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,l,u,s,0),u.join(`
`)}n(c,s,l,u,S){const y=S===0;let R;y?R=u.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(u.pid)?R=s.get(u.pid):R=`${"  ".repeat(S)} ${u.name}`;const L=process.platform==="win32"?u.mem:n.totalmem()*(u.mem/100);l.push(`${u.load.toFixed(0).padStart(5," ")}	${(L/h.$Il.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(u.children)&&u.children.forEach(T=>this.n(c,s,l,T,S+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:l}of c.folders){const u=a.URI.revive(l);if(u.scheme!==D.Schemas.file)continue;const S=u.fsPath;try{(await m(S,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const l=a.URI.revive(s);if(l.scheme!==D.Schemas.file)continue;const u=l.fsPath;try{const S=await m(u,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),S.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:y.name,count:y.count})}),S.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:y.name,count:y.count})}),S.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:S.totalScanTime,reachedLimit:S.maxFilesReached,fileCount:S.fileCount,readdirCount:S.totalReaddirCount})}catch{}}}};e.$Zs=r,e.$Zs=r=ke([ne(0,b.$_l),ne(1,p.$tk)],r)}),define(oe[258],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;class n{constructor(D){this.b=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,{eventName:I,data:v}){return this.b.forEach(a=>a.log(I,v)),Promise.resolve(null)}}e.$0fc=n;class o{constructor(D){this.b=D}log(D,O){return this.b.call("log",{eventName:D,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$$fc=o}),define(oe[58],ae([0,1,36,13,75,129,25]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=f,e.$Dp=d,e.$Ep=g,e.$Fp=w,e.$Gp=p,e.$Hp=$,e.$Ip=m,e.$Jp=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$vp=I;class v{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=v,e.$xp=new v;class a{async publicLog(i,c,s){}async publicLogError(i,c,s){}}e.$yp=a,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function f(r,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!r.enableTelemetry)}function d(r,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function g(r){const i=r.getValue(O.$im),c=r.getValue(O.$jm);if(r.getValue(O.$km)===!1||c===!1)return O.TelemetryLevel.NONE;switch(i??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function w(r){const i={},c={},s={};b(r,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const u=s[l];typeof u=="number"?c[l]=u:typeof u=="boolean"?c[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),i[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(i[l]=u)}return{properties:i,measurements:c}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(r){if(!r)return"none";const i=(0,k.$in)(r);return h.has(i)?i:"other"}function b(r,i,c=0,s){if(r)for(const l of Object.getOwnPropertyNames(r)){const u=r[l],S=s?s+l:l;Array.isArray(u)?i[S]=(0,n.$jo)(u):u instanceof Date?i[S]=u.toISOString():(0,o.$ig)(u)?c<2?b(u,i,c+1,S+"."):i[S]=(0,n.$jo)(u):i[S]=u}}function $(r,i){const c=r.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,D.$up)(c)||s}function m(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function E(r,i){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let c=r;const s=[];for(const y of i)for(;;){const R=y.exec(r);if(!R)break;s.push([R.index,y.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(c="";;){const y=u.exec(r);if(!y)break;const R=s.some(([L,T])=>y.index<T&&L<u.lastIndex);!l.test(y[0])&&!R&&(c+=r.substring(S,y.index)+"<REDACTED: user-file-path>",S=u.lastIndex)}return S<r.length&&(c+=r.substr(S)),c}function P(r){if(!r)return r;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of i)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return r}function t(r,i){return(0,n.$go)(r,c=>{if(c instanceof I||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=E(s,i);for(const l of i)s=s.replace(l,"");return s=P(s),s}})}}),define(oe[130],ae([0,1,26,127,86,3,7,16,37,58]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=f,e.$Mp=h,e.$Np=p,e.$Op=b,e.$Pp=$,e.$Qp=m,e.$Rp=E,e.$Sp=P,e.$Up=t,e.$Vp=i;function f(c,s){return c.uuid&&s.uuid?c.uuid===s.uuid:c.id===s.id?!0:(0,n.$Cf)(c.id,s.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const l=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,l,u)}static parse(s){const l=d.exec(s);return l&&l[1]&&l[2]?new g({id:l[1]},l[2],l[4]||void 0):null}constructor(s,l,u=k.TargetPlatform.UNDEFINED){this.identifier=s,this.version=l,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?f(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Lp=g;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(c){const s=w.exec(c);return s&&s[1]?[b(s[1]),s[2]]:[b(c),void 0]}function p(c,s){return`${c}.${s}`}function b(c){return c.toLowerCase()}function $(c,s){return b(p(c??k.$nn,s))}function m(c,s){const l=[],u=S=>{for(const y of l)if(y.some(R=>f(s(R),s(S))))return y;return null};for(const S of c){const y=u(S);y?y.push(S):l.push([S])}return l}function E(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function P(c){return{id:new a.$vp(c.identifier.id),name:new a.$vp(c.name),version:c.version,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Tp=new k.$rn("pprice.better-merge");function t(c,s){const l=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const S=u.shift();if(S&&l.every(y=>!f(y.identifier,{id:S}))){const y=c.filter(R=>f(R.identifier,{id:S}));y.length===1&&(l.push(y[0]),u.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function r(c,s){if(!D.$k)return!1;let l;try{l=(await c.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await c.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,I.$ab)(S))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(c,s){const l=await r(c,s),u=(0,o.$fp)(l?"alpine":D.$u,v.$hc);return s.debug("ComputeTargetPlatform:",u),u}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[259],ae([0,1,2,36,3,26,192,18,56,73,28,45,25,58]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,a=et(a);let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,m,E){this.k=m,this.l=E,this.d={},this.i=new n.$Wc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=g.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this.f)this.j.push(new RegExp((0,D.$jf)(P),"gi")),P.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$jf)(P.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(P=>{(P.affectsConfiguration(g.$im)||P.affectsConfiguration(g.$km)||P.affectsConfiguration(g.$jm))&&this.m()}))}setExperimentProperty($,m){this.d[$]=m}m(){let $=(0,w.$Ep)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const E=m.usage?g.TelemetryLevel.USAGE:m.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;$=Math.min($,E)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,m,E){this.g<m||(E=(0,o.$ho)(E,this.d),E=(0,w.$Jp)(E,this.j),E=(0,o.$ho)(E,this.c),this.b.forEach(P=>P.log($,E)))}publicLog($,m){this.n($,g.TelemetryLevel.USAGE,m)}publicLog2($,m){this.publicLog($,m)}publicLogError($,m){this.h&&this.n($,g.TelemetryLevel.ERROR,m)}publicLogError2($,m){this.publicLogError($,m)}};e.$fs=h,e.$fs=h=ke([ne(1,I.$aj),ne(2,f.$tk)],h);function p(){const b=(0,O.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=k.$o?"":(0,O.localize)(3,null),E=(0,O.localize)(4,null),P=(0,O.localize)(5,null),t=(0,O.localize)(6,null),r=(0,O.localize)(7,null),i=`
|       | ${E} | ${P} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,O.localize)(8,null);return`
${b} ${$} ${m}

&nbsp;

${r}
${i}

&nbsp;

${c}
`}d.$ro.as(v.$wo.Configuration).registerConfiguration({id:g.$hm,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[g.$im]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:g.TelemetryConfiguration.ON,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$ro.as(v.$wo.Configuration).registerConfiguration({id:g.$hm,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[g.$km]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,O.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,O.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${g.$im}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[260],ae([0,1,3,94,25]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=D,e.$Agc=O,e.$Bgc=I;async function D(v,a){let f=v.getItem(k.$em);return(typeof f!="string"||n.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,o.$Tn)(a.error.bind(a))),f}async function O(v,a){let f=v.getItem(k.$fm);return typeof f!="string"&&(f=await(0,o.$Un)(a.error.bind(a))),f}async function I(v,a){let f=v.getItem(k.$gm);return typeof f!="string"&&(f=await(0,o.$Vn)(a.error.bind(a))),f}}),define(oe[261],ae([0,1,25,260]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=k,e.$Dgc=D,e.$Egc=O;async function k(I,v){const a=await(0,o.$zgc)(I,v);return I.setItem(n.$em,a),a}async function D(I,v){const a=await(0,o.$Agc)(I,v);return I.setItem(n.$fm,a),a}async function O(I,v){const a=await(0,o.$Bgc)(I,v);return I.setItem(n.$gm,a),a}}),define(oe[131],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(o){o[o.Replace=1]="Replace",o[o.Append=2]="Append",o[o.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[262],ae([0,1,3,131]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;const k=new Map([[o.EnvironmentVariableMutatorType.Append,"APPEND"],[o.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[o.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(f){this.collections=f,this.a=new Map,this.b=new Map,f.forEach((d,g)=>{this.d(d,g);const w=d.map.entries();let h=w.next();for(;!h.done;){const p=h.value[1],b=h.value[0];let $=this.a.get(b);if($||($=[],this.a.set(b,$)),$.length>0&&$[0].type===o.EnvironmentVariableMutatorType.Replace){h=w.next();continue}const m={extensionIdentifier:g,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};m.scope||delete m.scope,$.unshift(m),h=w.next()}})}async applyToProcessEnvironment(f,d,g){let w;n.$i&&(w={},Object.keys(f).forEach(h=>w[h.toLowerCase()]=h));for(const[h,p]of this.getVariableMap(d)){const b=n.$i&&w[h.toLowerCase()]||h;for(const $ of p){const m=g?await g($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case o.EnvironmentVariableMutatorType.Append:f[b]=(f[b]||"")+m;break;case o.EnvironmentVariableMutatorType.Prepend:f[b]=m+(f[b]||"");break;case o.EnvironmentVariableMutatorType.Replace:f[b]=m;break}if($.options?.applyAtShellIntegration??!1){const E=`VSCODE_ENV_${k.get($.type)}`;f[E]=(f[E]?f[E]+":":"")+h+"="+this.c(m)}}}}c(f){return f.replaceAll(":","\\x3a")}diff(f,d){const g=new Map,w=new Map,h=new Map;if(f.getVariableMap(d).forEach((p,b)=>{const $=this.getVariableMap(d).get(b),m=I(p,$);m&&g.set(b,m)}),this.getVariableMap(d).forEach((p,b)=>{const $=f.getVariableMap(d).get(b),m=I(p,$);m&&h.set(b,m)}),this.getVariableMap(d).forEach((p,b)=>{const $=f.getVariableMap(d).get(b),m=v(p,$);m&&w.set(b,m)}),!(g.size===0&&w.size===0&&h.size===0))return{added:g,changed:w,removed:h}}getVariableMap(f){const d=new Map;for(const g of this.a.values()){const w=g.filter(h=>O(h,f));w.length>0&&d.set(w[0].variable,w)}return d}getDescriptionMap(f){const d=new Map;for(const g of this.b.values()){const w=g.filter(h=>O(h,f,!0));for(const h of w)d.set(h.extensionIdentifier,h.description)}return d}d(f,d){if(!f.descriptionMap)return;const g=f.descriptionMap.entries();let w=g.next();for(;!w.done;){const h=w.value[1],p=w.value[0];let b=this.b.get(p);b||(b=[],this.b.set(p,b));const $={extensionIdentifier:d,scope:h.scope,description:h.description};$.scope||delete $.scope,b.push($),w=g.next()}}}e.$Js=D;function O(a,f,d=!1){return a.scope?!!(a.scope.workspaceFolder&&f?.workspaceFolder&&a.scope.workspaceFolder.index===f.workspaceFolder.index):d?f===a.scope:!0}function I(a,f){if(!f)return a;const d=new Set;f.forEach(w=>d.add(w.extensionIdentifier));const g=[];return a.forEach(w=>{d.has(w.extensionIdentifier)||g.push(w)}),g.length===0?void 0:g}function v(a,f){if(!f)return;const d=new Map;f.forEach(w=>d.set(w.extensionIdentifier,w));const g=[];return a.forEach(w=>{const h=d.get(w.extensionIdentifier);h&&(w.type!==h.type||w.value!==h.value||w.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index)&&g.push(h)}),g.length===0?void 0:g}}),define(oe[263],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=n,e.$Es=o,e.$Fs=k,e.$Gs=D,e.$Hs=O,e.$Is=I;function n(v){return[...v.entries()]}function o(v){return v?[...v.entries()]:[]}function k(v){return new Map(v)}function D(v){return new Map(v??[])}function O(v){return Array.from(v.entries()).map(a=>[a[0],n(a[1].map),o(a[1].descriptionMap)])}function I(v){return new Map(v.map(a=>[a[0],{map:k(a[1]),descriptionMap:D(a[2])}]))}}),define(oe[264],ae([0,1,8,23,4,2,5]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;let I=class extends D.$Xc{constructor(a,f){super(),this.h=f,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$ne),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,D.$Vc)(()=>{for(const d of this.f.values())(0,D.$Sc)(d)}))}createRequest(a){return new Promise((f,d)=>{const g=++this.a;this.c.set(g,f),this.g.fire({requestId:g,...a});const w=new o.$ye;(0,n.$Hh)(this.b,w.token).then(()=>d(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.$Vc)(()=>w.cancel())])})}acceptReply(a,f){const d=this.c.get(a);d?(this.c.delete(a),(0,D.$Sc)(this.f.get(a)||[]),this.f.delete(a),d(f)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$us=I,e.$us=I=ke([ne(1,O.$ak)],I)}),define(oe[76],ae([0,1,6,123,45]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new o.$Xj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var O;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var v;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(v||(e.WindowsShellType=v={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var f;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(f||(e.TerminalIpcChannels=f={}));var d;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$ns=(0,n.$Gi)("ptyService");var g;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var h;(function(t){t.TerminalView="view",t.Editor="editor"})(h||(e.TerminalLocationString=h={}));var p;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var b;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var m;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(E||(e.TerminalExitReason=E={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(r){const i=this.b(r.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,r)}getTerminalBackend(r){return this.a.get(this.b(r))}b(r){return r?.toLowerCase()??""}}k.$ro.add(e.$os.Backend,new P),e.$ps=(0,n.$Gi)("localPtyService"),e.$qs=(0,n.$Gi)("terminalLogService")}),define(oe[265],ae([0,1,80,7,194,111]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=O,e.$ws=a,e.$xs=f,e.$ys=d;function O(g,w){const h=[{name:null,description:(0,k.localize)(0,null)}];return h.push(...g.map(p=>({name:p.profileName,description:I(p)}))),w&&h.push(...w.map(p=>({name:p.title,description:v(p)}))),{values:h.map(p=>p.name),markdownDescriptions:h.map(p=>p.description)}}function I(g){let w=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$6j.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?w+=`
- args: "${g.args}"`:w+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(w+=`
- overrideName: ${g.overrideName}`),g.color&&(w+=`
- color: ${g.color}`),g.env&&(w+=`
- env: ${JSON.stringify(g.env)}`),w}function v(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$6j.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function a(g,w){if(!g&&!w)return!0;if(typeof g=="string"&&typeof w=="string")return g===w;if(Array.isArray(g)&&Array.isArray(w)){if(g.length!==w.length)return!1;for(let h=0;h<g.length;h++)if(g[h]!==w[h])return!1;return!0}return!1}function f(g,w){if(!g&&!w)return!0;if(!g||!w)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(w))return g.id===w.id&&g.color===w.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof w=="object"&&"light"in w&&"dark"in w){const h=g,p=w;if((o.URI.isUri(h.light)||d(h.light))&&(o.URI.isUri(h.dark)||d(h.dark))&&(o.URI.isUri(p.light)||d(p.light))&&(o.URI.isUri(p.dark)||d(p.dark)))return h.light.path===p.light.path&&h.dark.path===p.dark.path}if(o.URI.isUri(g)&&o.URI.isUri(w)||d(g)||d(w)){const h=g,p=w;return h.path===p.path&&h.scheme===p.scheme}return!1}function d(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(oe[266],ae([0,1,80,3,193,56,45,76,265]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=void 0,e.$Bs=h,e.$Cs=b,e.$zs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$As={type:"string",enum:Array.from((0,n.$4j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,n.$4j)(),$=>`$(${$.id})`)};const a={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),...e.$As},color:{description:(0,k.localize)(3,null),...e.$zs},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},f={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...a}},d={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(6,null),type:["string"],items:{type:"string"}},...a}};function g($){const m=$===o.Platform.Linux?"linux":$===o.Platform.Mac?"osx":"windows";return(0,k.localize)(7,null,(0,o.$h)($),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,k.localize)(8,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(o.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(12,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(13,null),type:"string"},id:{description:(0,k.localize)(14,null),type:"string"},title:{description:(0,k.localize)(15,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(o.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(16,null),type:"string"},id:{description:(0,k.localize)(17,null),type:"string"},title:{description:(0,k.localize)(18,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(o.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(19,null),type:"string"},id:{description:(0,k.localize)(20,null),type:"string"},title:{description:(0,k.localize)(21,null),type:"string"},...a}},{type:"null"},f]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,k.localize)(22,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,k.localize)(23,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,k.localize)(24,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,k.localize)(25,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,k.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){O.$ro.as(D.$wo.Configuration).registerConfiguration(w),b()}let p;function b($,m){const E=O.$ro.as(D.$wo.Configuration);let P;$&&(P=(0,v.$vs)($?.profiles,m));const t=p;p={id:"terminal",order:100,title:(0,k.localize)(27,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(28,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Linux?P?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Linux?P?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(29,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Macintosh?P?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Macintosh?P?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(30,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Windows?P?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Windows?P?.markdownDescriptions:void 0}}},E.updateConfigurations({add:[p],remove:t?[t]:[]})}}),define(oe[267],ae([0,1,27,12,36,10,3,37,26,13,21,131,263,262]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=h,e.$Ls=p,e.$Ms=b,n=De(n),D=De(D),I=De(I),f=De(f);function h(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return u&&u.length===4&&(S=parseInt(u[3])),S}async function p(u,S,y,R=I.env,L=f.Promises.exists){if(D.$lc(u))return await L(u)?u:void 0;if(S===void 0&&(S=I.cwd()),D.$pc(u)!=="."){const U=D.$mc(S,u);return await L(U)?U:void 0}const A=(0,k.$lo)(R,"PATH");if(y===void 0&&(0,a.$gg)(A)&&(y=A.split(D.$wc)),y===void 0||y.length===0){const U=D.$mc(S,u);return await L(U)?U:void 0}for(const U of y){let C;if(D.$lc(U)?C=D.$mc(U,u):C=D.$mc(S,U,u),await L(C))return C;if(O.$i){let z=C+".com";if(await L(z)||(z=C+".exe",await L(z)))return z}}const M=D.$mc(S,u);return await L(M)?M:void 0}function b(u,S,y,R,L){const T=O.$i&&(!S.windowsEnableConpty||h()<18309);if(!S.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||T)return;const A=u.args,M=I.$gc==="win32"?D.$qc(u.executable).toLowerCase():D.$qc(u.executable),U=D.$pc(o.$1g.asFileUri("").fsPath);let C;const z={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(z.VSCODE_NONCE=S.shellIntegration.nonce),O.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!A||s(A)?C=E.get(m.WindowsPwsh):c(A)&&(C=E.get(m.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,v.$ff)(C[C.length-1],U,""),z.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:z}):void 0;if(M==="bash.exe")return!A||A.length===0?C=E.get(m.Bash):l(A)&&(z.VSCODE_SHELL_LOGIN="1",$(S,z),C=E.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,v.$ff)(C[C.length-1],U),z.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;R.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(M){case"bash":return!A||A.length===0?C=E.get(m.Bash):l(A)&&(z.VSCODE_SHELL_LOGIN="1",$(S,z),C=E.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,v.$ff)(C[C.length-1],U),z.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"fish":{const re=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Z=D.$mc(U,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${re}:${Z}`,$(S,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!A||s(A)?C=E.get(m.Pwsh):c(A)&&(C=E.get(m.PwshLogin)),C?(S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,v.$ff)(C[C.length-1],U,""),z.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"zsh":{if(!A||A.length===0?C=E.get(m.Zsh):l(A)?(C=E.get(m.ZshLogin),$(S,z)):(A===E.get(m.Zsh)||A===E.get(m.ZshLogin))&&(C=A),!C)return;C=[...C],C[C.length-1]=(0,v.$ff)(C[C.length-1],U);let re;try{re=n.userInfo().username}catch{re="unknown"}const Z=D.$mc(n.tmpdir(),`${re}-${L.applicationName}-zsh`);z.ZDOTDIR=Z;const le=y?.ZDOTDIR??n.homedir()??"~";z.USER_ZDOTDIR=le;const X=[];return X.push({source:D.$mc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$mc(Z,".zshrc")}),X.push({source:D.$mc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$mc(Z,".zprofile")}),X.push({source:D.$mc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$mc(Z,".zshenv")}),X.push({source:D.$mc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$mc(Z,".zlogin")}),{newArgs:C,envMixin:z,filesToCopy:X}}}R.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function $(u,S){if(O.$j&&u.environmentVariableCollections){const y=(0,g.$Is)(u.environmentVariableCollections),L=new w.$Js(y).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),T=[];if(L)for(const A of L)A.type===d.EnvironmentVariableMutatorType.Prepend&&T.push(A.value);T.length>0&&(S.VSCODE_PATH_PREFIX=T.join(""))}}var m;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(m||(m={}));const E=new Map;E.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),E.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),E.set(m.Zsh,["-i"]),E.set(m.ZshLogin,["-il"]),E.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],t=["--login","-l"],r=["-i","--interactive"],i=["-nol","-nologo"];function c(u){return typeof u=="string"?P.includes(u.toLowerCase()):u.length===1&&P.includes(u[0].toLowerCase())||u.length===2&&(P.includes(u[0].toLowerCase())||P.includes(u[1].toLowerCase()))&&(i.includes(u[0].toLowerCase())||i.includes(u[1].toLowerCase()))}function s(u){return typeof u=="string"?i.includes(u.toLowerCase()):u.length===0||u?.length===1&&i.includes(u[0].toLowerCase())}function l(u){return typeof u!="string"&&(u=u.filter(S=>!r.includes(S.toLowerCase()))),u==="string"&&t.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&t.includes(u[0].toLowerCase())}}),define(oe[268],ae([0,1,49,80,10,3,13,21,115,76,267,122]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=p,n=De(n),I=De(I);var g;(function(S){S.UnixShellsPath="/etc/shells"})(g||(g={}));let w,h=!0;function p(S,y,R,L,T=process.env,A,M,U,C){return A=A||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},D.$i?b(R,A,T,M,L.getValue(a.TerminalSettingId.UseWslProfiles)!==!1,S&&typeof S=="object"?{...S}:L.getValue(a.TerminalSettingId.ProfilesWindows),typeof y=="string"?y:L.getValue(a.TerminalSettingId.DefaultProfileWindows),C,U):s(A,M,R,S&&typeof S=="object"?{...S}:L.getValue(D.$k?a.TerminalSettingId.ProfilesLinux:a.TerminalSettingId.ProfilesMacOs),typeof y=="string"?y:L.getValue(D.$k?a.TerminalSettingId.DefaultProfileLinux:a.TerminalSettingId.DefaultProfileMacOs),C,U,T)}async function b(S,y,R,L,T,A,M,U,C){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Z=!1;(0,f.$Ks)()>=16299&&(Z=!0),await P(U);const le=new Map;if(S){le.set("PowerShell",{source:a.ProfileSource.Pwsh,icon:o.$6j.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:o.$6j.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:a.ProfileSource.GitBash,isAutoDetected:!0}),le.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:o.$6j.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:o.$6j.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}l(A,le);const X=await $(le.entries(),M,y,R,L,C);if(S&&T)try{const ee=await i(`${re}\\${Z?"wsl":"bash"}.exe`,M);for(const q of ee)(!A||!(q.profileName in A))&&X.push(q)}catch{h&&(L?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return X}async function $(S,y,R,L=process.env,T,A){const M=[];for(const[U,C]of S)M.push(m(U,C,y,R,L,T,A));return(await Promise.all(M)).filter(U=>!!U)}async function m(S,y,R,L,T=process.env,A,M){if(y===null)return;let U,C,z;if("source"in y&&!("path"in y)){const X=w?.get(y.source);if(!X)return;U=X.paths,C=y.args||X.args,y.icon?z=E(y.icon):X.icon&&(z=X.icon)}else U=Array.isArray(y.path)?y.path:[y.path],C=D.$i||Array.isArray(y.args)?y.args:void 0,z=E(y.icon);let re;if(M){const X=U.map(q=>typeof q=="string"?q:q.path),ee=await M(X);re=new Array(U.length);for(let q=0;q<U.length;q++)typeof U[q]=="string"?re[q]=ee[q]:re[q]={path:ee[q],isUnsafe:!0}}else re=U.slice();let Z;if(y.requiresPath){let X;if((0,O.$gg)(y.requiresPath)?X=y.requiresPath:(X=y.requiresPath.path,y.requiresPath.isUnsafe&&(Z=X)),!await L.existsFile(X))return}const le=await u(S,R,re,L,T,C,y.env,y.overrideName,y.isAutoDetected,Z);if(!le){A?.debug("Terminal profile not validated",S,U);return}return le.isAutoDetected=y.isAutoDetected,le.icon=z,le.color=y.color,le}function E(S){return typeof S=="string"?{id:S}:S}async function P(S){if(w&&!S)return;const[y,R]=await Promise.all([t(),S||r()]);w=new Map,w.set(a.ProfileSource.GitBash,{profileName:"Git Bash",paths:y,args:["--login","-i"]}),w.set(a.ProfileSource.Pwsh,{profileName:"PowerShell",paths:R,icon:o.$6j.terminalPowershell})}async function t(){const S=new Set,y=await(0,f.$Ls)("git.exe");if(y){const T=(0,d.dirname)(y);S.add((0,d.resolve)(T,"../.."))}function R(T,A){A&&T.add(A)}R(S,process.env.ProgramW6432),R(S,process.env.ProgramFiles),R(S,process.env["ProgramFiles(X86)"]),R(S,`${process.env.LocalAppData}\\Program`);const L=[];for(const T of S)L.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function r(){const S=[];for await(const y of(0,v.$wm)())S.push(y.exePath);return S}async function i(S,y){const R=[],L=await new Promise((M,U)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,z)=>{if(C)return U("Problem occurred when getting wsl distros");M(z)})});if(!L)return[];const T=new RegExp(/[\r?\n]/),A=L.split(T).filter(M=>M.trim().length>0&&M!=="");for(const M of A){if(M===""||M.startsWith("docker-desktop"))continue;const U=`${M} (WSL)`,C={profileName:U,path:S,args:["-d",`${M}`],isDefault:U===y,icon:c(M),isAutoDetected:!1};R.push(C)}return R}function c(S){return S.includes("Ubuntu")?o.$6j.terminalUbuntu:S.includes("Debian")?o.$6j.terminalDebian:o.$6j.terminalLinux}async function s(S,y,R,L,T,A,M,U){const C=new Map;if(R&&await S.existsFile(g.UnixShellsPath)){const z=(await S.readFile(g.UnixShellsPath)).toString(),re=(A||z.split(`
`)).map(le=>{const X=le.indexOf("#");return X===-1?le:le.substring(0,X)}).filter(le=>le.trim().length>0),Z=new Map;for(const le of re){let X=(0,k.$qc)(le),ee=Z.get(X)||0;ee++,ee>1&&(X=`${X} (${ee})`),Z.set(X,ee),C.set(X,{path:le,isAutoDetected:!0})}}return l(L,C),await $(C.entries(),T,S,U,y,M)}function l(S,y){if(S)for(const[R,L]of Object.entries(S))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?y.delete(R):(L.icon=L.icon||y.get(R)?.icon,y.set(R,L))}async function u(S,y,R,L,T,A,M,U,C,z){if(R.length===0)return Promise.resolve(void 0);const re=R.shift();if(re==="")return u(S,y,R,L,T,A,M,U,C);const Z=typeof re!="string"&&re.isUnsafe,le=typeof re=="string"?re:re.path,X={profileName:S,path:le,args:A,env:M,overrideName:U,isAutoDetected:C,isDefault:S===y,isUnsafePath:Z,requiresUnsafePath:z};if((0,k.$qc)(le)===le){const q=T.PATH?T.PATH.split(k.$wc):void 0,j=await(0,f.$Ls)(le,void 0,q,void 0,L.existsFile);return j?(X.path=j,X.isFromPath=!0,X):u(S,y,R,L,T,A)}return await L.existsFile((0,k.$kc)(le))?X:u(S,y,R,L,T,A,M,U,C)}}),define(oe[269],ae([0,1,4,2,3,44,18,5,231,101,264,76,266,268,117,67]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;var b;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let $=class extends o.$Xc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(E,P,t,r){super(),this.M=E,this.N=P,this.O=t,this.P=r,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ne),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ne),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ne),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ne),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ne),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ne),this.onProcessData=this.D.event,this.F=this.B(new n.$ne),this.onProcessReady=this.F.event,this.G=this.B(new n.$ne),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ne),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ne),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ne),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ne),this.onProcessExit=this.L.event,(0,g.$Bs)(),this.B(this.M),this.B((0,o.$Vc)(()=>this.W())),this.j=this.B(new f.$us(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(d.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$i)return process.env;try{return await(0,a.$Rm)(this.N,this.O,{_:[]},process.env)}catch(E){return this.O.error("ptyHost was unable to resolve shell environment",E),{}}}U(){const E=this.M.start(),P=E.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(P.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(E.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=b.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const r=D.ProxyChannel.toService(P.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(i=>this.D.fire(i))),this.B(r.onProcessReady(i=>this.F.fire(i))),this.B(r.onProcessExit(i=>this.L.fire(i))),this.B(r.onDidChangeProperty(i=>this.J.fire(i))),this.B(r.onProcessReplay(i=>this.G.fire(i))),this.B(r.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(r.onDidRequestDetach(i=>this.I.fire(i))),this.B(new v.$ts(this.P,P.getChannel(d.TerminalIpcChannels.Logger))),this.a=E,this.b=r,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(d.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[E,r]}async createProcess(E,P,t,r,i,c,s,l,u,S,y){const R=setTimeout(()=>this.$(),d.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(E,P,t,r,i,c,s,l,u,S,y);return clearTimeout(R),L}updateTitle(E,P,t){return this.f.updateTitle(E,P,t)}updateIcon(E,P,t,r){return this.f.updateIcon(E,P,t,r)}attachToProcess(E){return this.f.attachToProcess(E)}detachFromProcess(E,P){return this.f.detachFromProcess(E,P)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(E){return this.f.start(E)}shutdown(E,P){return this.f.shutdown(E,P)}input(E,P){return this.f.input(E,P)}processBinary(E,P){return this.f.processBinary(E,P)}resize(E,P,t){return this.f.resize(E,P,t)}clearBuffer(E){return this.f.clearBuffer(E)}acknowledgeDataEvent(E,P){return this.f.acknowledgeDataEvent(E,P)}setUnicodeVersion(E,P){return this.f.setUnicodeVersion(E,P)}getInitialCwd(E){return this.f.getInitialCwd(E)}getCwd(E){return this.f.getCwd(E)}async getLatency(){const E=new p.$he,P=await this.f.getLatency();return E.stop(),[{label:"ptyhostservice<->ptyhost",latency:E.elapsed()},...P]}orphanQuestionReply(E){return this.f.orphanQuestionReply(E)}installAutoReply(E,P){return this.f.installAutoReply(E,P)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(E){return this.f.uninstallAutoReply(E)}getDefaultSystemShell(E){return this.g?.getDefaultSystemShell(E)??(0,h.$Am)(E??k.OS,process.env)}async getProfiles(E,P,t,r=!1){const i=await this.S();return(0,w.$Ns)(P,t,r,this.N,i,void 0,this.O,this.bb.bind(this,E))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(E,P){return this.f.getWslPath(E,P)}getRevivedPtyNewId(E,P){return this.f.getRevivedPtyNewId(E,P)}setTerminalLayoutInfo(E){return this.f.setTerminalLayoutInfo(E)}async getTerminalLayoutInfo(E){return this.g?.getTerminalLayoutInfo(E)}async requestDetachInstance(E,P){return this.f.requestDetachInstance(E,P)}async acceptDetachInstanceReply(E,P){return this.f.acceptDetachInstanceReply(E,P)}async freePortKillProcess(E){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(E)}async serializeTerminalState(E){return this.f.serializeTerminalState(E)}async reviveTerminalProcesses(E,P,t){return this.f.reviveTerminalProcesses(E,P,t)}async refreshProperty(E,P){return this.f.refreshProperty(E,P)}async updateProperty(E,P,t){return this.f.updateProperty(E,P,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(E){this.ab(),this.s=setTimeout(()=>this.Y(),E?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(E,P){return this.j.createRequest({workspaceId:E,originalText:P})}async acceptPtyHostResolvedVariables(E,P){this.j.acceptReply(E,P)}};e.$Os=$,e.$Os=$=ke([ne(1,O.$aj),ne(2,I.$ak),ne(3,I.$bk)],$)}),define(oe[77],ae([0,1,14,4,2,3,18,6,34]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;const a="#FFFFFF",f="#1E1E1E",d="#000000",g="#FFFFFF",w="theme",h="themeBackground",p="windowSplash";var b;(function(m){m.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",m.SYSTEM_COLOR_THEME="window.systemColorTheme"})(b||(b={})),e.$Yec=(0,I.$Gi)("themeMainService");let $=class extends k.$Xc{constructor(E,P){super(),this.b=E,this.c=P,this.a=this.B(new o.$ne),this.onDidChangeColorScheme=this.a.event,D.$k||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(b.SYSTEM_COLOR_THEME)||t.affectsConfiguration(b.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(o.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$k||this.c.getValue(b.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(b.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const E=this.getColorScheme();if(E.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return E.dark?d:g;let P=this.b.getItem(h,null);if(!P)switch(this.g()){case"vs":P=a;break;case"hc-black":P=d;break;case"hc-light":P=g;break;default:P=f}return D.$j&&P.toUpperCase()===f&&(P="#171717"),P}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(E,P){this.b.setItems([{key:w,data:P.baseTheme},{key:h,data:P.colorInfo.background},{key:p,data:P}]),typeof E=="number"&&this.h(E,P),this.f()}h(E,P){for(const t of n.BrowserWindow.getAllWindows())if(t.id===E){t.setBackgroundColor(P.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.$Zec=$,e.$Zec=$=ke([ne(0,v.$gR),ne(1,O.$aj)],$)}),define(oe[132],ae([0,1,4,2,3,7,18,6,5]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=d,e.$Ew=w,e.$Fw=h,e.$Hw=p,e.$Jw=b,e.$Kw=$,e.$Bw=(0,I.$Gi)("tunnelService"),e.$Cw=(0,I.$Gi)("sharedTunnelsService");var a;(function(P){P.Http="http",P.Https="https"})(a||(e.TunnelProtocol=a={}));var f;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(f||(e.TunnelPrivacyId=f={}));function d(P){return!!P.forwardPort}var g;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function w(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(t)return{address:t[1],port:+t[2]}}function h(P){if(P.scheme!=="http"&&P.scheme!=="https"||!P.query)return;const t=P.query.split("&");for(const r of t){const i=r.split("=")[1];if(/^https?:/.exec(i)){const c=w(D.URI.parse(i));if(c)return c}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(P){return e.$Gw.indexOf(P)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(P){return e.$Iw.indexOf(P)>=0}function $(P,t,r,i){if(r===k.OperatingSystem.Windows)return!1;if(r===k.OperatingSystem.Macintosh&&b(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(c?.length===4&&parseInt(c[1])>=18)return!1}return P<1024}class m{constructor(t,r,i){this.remoteAddress=t,this.localAddress=r,this.b=i,this.a=new n.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=m;let E=class extends o.$Xc{constructor(t,r){super(),this.r=t,this.s=r,this.a=new n.$ne,this.onTunnelOpened=this.a.event,this.b=new n.$ne,this.onTunnelClosed=this.b.event,this.c=new n.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],r=Array.from(this.f.values());for(const i of r){const c=Array.from(i.values());for(const s of c){const l=await s.value;l&&typeof l!="string"&&t.push(l)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:r}of t.values())await r.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,r,i,c,s){this.z(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:i,privacy:c,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(b(t)||p(t))&&(t=e.$Gw[0]);const i=this.D(t,r);if(i)return++i.refcount,i.value}openTunnel(t,r,i,c,s,l=!1,u,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(r||(r="localhost"),c||(c=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(y,r,i,c,s,l,u,S);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const T=this.w(L);return(L.tunnelRemoteHost!==r||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&L.privacy!==u&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(T),T}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.f.get(t.tunnelRemoteHost);if(r){const i=r.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,r,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(r),c}}async closeTunnel(t,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const i=this.f.get(t);if(i&&i.has(r)){const c=i.get(r);c.refcount=0,await this.y(t,r,c)}}z(t,r,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(r,{refcount:1,value:i})}async C(t,r){const i=this.f.get(t);if(i){const c=i.get(r),s=c?await c.value:void 0;(!s||typeof s=="string")&&i.delete(r),i.size===0&&this.f.delete(t)}}D(t,r){const i=[t];p(t)?(i.push(...e.$Gw),i.push(...e.$Iw)):b(t)&&i.push(...e.$Iw);const c=i.map(s=>this.f.get(s));for(const s of c){const l=s?.get(r);if(l)return l}}canTunnel(t){return!!w(t)}G(t,r,i,c,s,l,u){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${i} on local port ${c}.`);const S=i;this.n.add(S);const y=c===void 0?i:c,R={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:r,port:i},localAddressPort:c,privacy:l,public:l?l!==f.Private:void 0,protocol:u},T=t.forwardPort(L,R);return T?(this.z(r,i,T),T.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),T}};e.$Mw=E,e.$Mw=E=ke([ne(0,v.$ak),ne(1,O.$aj)],E)}),define(oe[50],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EY=e.$DY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var o;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(o||(e.StateType=o={}));var k;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var D;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$DY={Uninitialized:{type:o.Uninitialized},Disabled:O=>({type:o.Disabled,reason:O}),Idle:(O,I)=>({type:o.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:o.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:o.AvailableForDownload,update:O}),Downloading:{type:o.Downloading},Downloaded:O=>({type:o.Downloaded,update:O}),Updating:O=>({type:o.Updating,update:O}),Ready:O=>({type:o.Ready,update:O})},e.$EY=(0,n.$Gi)("updateService")}),define(oe[270],ae([0,1,3,195,56,45]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$ro.as(k.$wo.Configuration).registerConfiguration({id:"update",order:15,title:(0,o.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,o.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,o.localize)(2,null),(0,o.localize)(3,null),(0,o.localize)(4,null),(0,o.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,o.localize)(6,null),deprecationMessage:(0,o.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,title:(0,o.localize)(8,null),description:(0,o.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,description:(0,o.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[271],ae([0,1,4,50]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=void 0;class k{constructor(I){this.a=I}listen(I,v){switch(v){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${v}`)}call(I,v,a){switch(v){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${v}`)}}e.$_fc=k;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$ne,this.onStateChange=this.a.event,this.b=o.$DY.Uninitialized,this.c.listen("onStateChange")(v=>this.state=v),this.c.call("_getInitialState").then(v=>this.state=v)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$agc=D}),define(oe[41],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,n.$Gi)("IUriIdentityService")}),define(oe[272],ae([0,1,41,211,15,19,144,4,2]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class a{static{this._clock=0}constructor(g){this.uri=g,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(g){this.g=g,this.c=new v.$Wc,this.f=2**16;const w=new Map,h=p=>{let b=w.get(p.scheme);return b===void 0&&(b=g.hasProvider(p)&&!this.g.hasCapability(p,k.FileSystemProviderCapabilities.PathCaseSensitive),w.set(p.scheme,b)),b};this.c.add(I.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(p=>{w.delete(p.scheme)})),this.extUri=new D.$9g(h),this.d=new O.$Rs((p,b)=>this.extUri.compare(p,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.$ih)(g));const w=this.d.get(g);return w?w.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new a(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((h,p)=>h[1].time<p[1].time?1:h[1].time>p[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let h=0;h<w;h++)this.d.set(g[h][0],g[h][1].touch())}};e.$Ss=f,e.$Ss=f=ke([ne(0,k.$al)],f),(0,o.$Ps)(n.$Kl,f,o.InstantiationType.Delayed)}),define(oe[133],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uY=void 0,e.$uY=(0,n.$Gi)("urlService")}),define(oe[273],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0;class o{constructor(I){this.a=I}listen(I,v){throw new Error(`Event not found: ${v}`)}call(I,v,a){switch(v){case"handleURL":return this.a.handleURL(n.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${v}`)}}e.$hgc=o;class k{constructor(I){this.a=I}handleURL(I,v){return this.a.call("handleURL",[I.toJSON(),v])}}e.$igc=k;class D{constructor(I,v){this.a=I,this.b=v}async routeCall(I,v,a,f){if(v!=="handleURL")throw new Error(`Call not found: ${v}`);if(Array.isArray(a)&&a.length>0){const d=n.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const g=/\bwindowId=(\d+)/.exec(d.query);if(g){const w=g[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,d.toString(!0));const h=new RegExp(`window:${w}`),p=I.connections.find(b=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",b.ctx),h.test(b.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,v,a,f)}routeEvent(I,v){throw new Error(`Event not found: ${v}`)}}e.$jgc=D}),define(oe[274],ae([0,1,8,2,7,28]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wY=e.$vY=void 0;class O extends o.$Xc{constructor(){super(...arguments),this.a=new Set}open(a,f){const d=[...this.a.values()];return(0,n.$Kh)(d.map(g=>()=>g.handleURL(a,f)),void 0,!1).then(g=>g||!1)}registerHandler(a){return this.a.add(a),(0,o.$Vc)(()=>this.a.delete(a))}}e.$vY=O;let I=class extends O{constructor(a){super(),this.b=a}create(a){let{authority:f,path:d,query:g,fragment:w}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return f&&d&&d.indexOf("/")!==0&&(d=`/${d}`),k.URI.from({scheme:this.b.urlProtocol,authority:f,path:d,query:g,fragment:w})}};e.$wY=I,e.$wY=I=ke([ne(0,D.$tk)],I)}),define(oe[275],ae([0,1,14,8,4,2,3,7]),function(x,e,n,o,k,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class v extends D.$Xc{constructor(f,d,g,w,h,p){if(super(),this.c=d,this.f=p,this.a=[],this.b=0,f&&(p.trace("ElectronURLListener initialUrisToHandle:",f.map(m=>m.originalUrl)),this.a=f),O.$i){const m=w.isBuilt?[]:[`"${w.appRoot}"`];m.push("--open-url","--"),n.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,m)}const b=k.Event.map(k.Event.fromNodeEventEmitter(n.app,"open-url",(m,E)=>({event:m,url:E})),({event:m,url:E})=>(m.preventDefault(),E));this.B(b(m=>{const E=this.g(m);E&&this.c.open(E,{originalUrl:m})})),g.getWindows().filter(m=>m.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once(g.onDidSignalReadyWindow)(()=>this.h())))}g(f){try{return I.URI.parse(f)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const f=[];for(const d of this.a)await this.c.open(d.uri,{originalUrl:d.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),f.push(d));f.length!==0&&(this.a=f,(0,o.$Ih)(()=>this.h(),500,this.q))}}e.$kgc=v}),define(oe[276],ae([0,1,4,2,15,61,32]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class I extends o.$Xc{constructor(a,f,d,g,w,h){super(),this.f=a,this.g=f,this.h=d,this.j=g,this.m=w,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$ne),this.onDidChangeFile=this.a.event,this.b=D.$Mi.forUris(()=>!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Ec(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,d,g,w){return this.g.read(a,f,d,g,w)}write(a,f,d,g,w){return this.g.write(a,f,d,g,w)}watch(a,f){this.b.set(a,a);const d=this.g.watch(this.t(a),f);return(0,o.$Vc)(()=>{this.b.delete(a),d.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,d){return this.g.rename(this.t(a),this.t(f),d)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,d){return this.g.readFileStream(this.t(a),f,d)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,d){return this.g.writeFile(this.t(a),f,d)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,d){if((0,k.$el)(this.g))return this.g.copy(this.t(a),this.t(f),d);throw new Error("copy not supported")}cloneFile(a,f){if((0,k.$fl)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const d of a){if(d.resource.scheme!==this.f)continue;const g=this.u(d.resource);this.b.findSubstr(g)&&f.push({resource:g,type:d.type,cId:d.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Zgc=I}),define(oe[277],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0,e.$Ggc="utilityProcessWorker"}),define(oe[278],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0,e.$lgc=(0,n.$Gi)("webviewManagerService")}),define(oe[279],ae([0,1,14,2,12,7]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class O extends o.$Xc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const v=this.b.bind(this);n.protocol.registerFileProtocol(k.Schemas.vscodeWebview,v)}b(v,a){try{const f=D.URI.parse(v.url),d=O.a.get(f.path);if(typeof d=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${d}`,w=k.$1g.asFileUri(g);return a({path:w.fsPath,headers:{...k.COI.getHeadersFromQuery(v.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$mgc=O}),define(oe[51],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$XD=void 0,e.$YD=o,e.$ZD=k,e.$1D=D,e.$2D=O,e.$3D=I,e.$4D=d,e.$5D=g,e.$6D=w,e.$8D=h,e.$9D=p,e.$0D=b,e.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function o($){return typeof $.parentId=="number"}function k($){return!!$.workspaceUri}function D($){return!!$.folderUri}function O($){return!!$.fileUri}function I($){const m=g($),E=$.getValue("window.menuBarVisibility");return E==="default"||m&&E==="compact"||n.$j&&n.$m?"classic":E}var v;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(v||(e.TitleBarSetting=v={}));var a;(function($){$.NATIVE="native",$.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var f;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(f||(e.CustomTitleBarVisibility=f={}));function d($,m){return!0}function g($,m){return m||(m=w($)),m===a.NATIVE}function w($){if(n.$o)return a.CUSTOM;const m=$.getValue("window");if(m){if(n.$j&&m.nativeTabs===!0||n.$j&&m.nativeFullScreen===!1)return a.NATIVE;const t=m.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return n.$k?a.NATIVE:a.CUSTOM}e.$7D=35;function h($){return!(!n.$i||n.$o||g($))}function p($){const m=$.getValue("window");return!m||typeof m.nativeFullScreen!="boolean"||m.nativeTabs?!0:m.nativeFullScreen!==!1}function b($=0){return Math.pow(1.2,$)}}),define(oe[52],ae([0,1,14]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Oec=e.$Nec=e.UnloadReason=e.LoadReason=void 0;var o;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(o||(e.LoadReason=o={}));var k;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const D=function(a=I.Normal){return{width:1024,height:768,mode:a}};e.$Nec=D;const O=function(){const d=n.screen.getPrimaryDisplay().workArea,g=Math.max(d.x+d.width/2-800/2,0),w=Math.max(d.y+d.height/2-600/2,0);return{x:g,y:w,width:800,height:600,mode:I.Normal}};e.$Oec=O;var I;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var v;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(v||(e.WindowError=v={}))}),define(oe[280],ae([0,1,8,4,2]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class D extends k.$Xc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:v,getActiveWindowId:a}){super(),this.a=this.B(new k.$Wc),o.Event.latch(o.Event.any(I,v))(this.f,this,this.a),this.b=(0,n.$th)(()=>a()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$sgc=D}),define(oe[30],ae([0,1,199,10,61,19,7,6,12]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=a,e.$Ri=f,e.$Ui=d,e.$Vi=g,e.$Wi=w,e.$Xi=p,e.$Yi=b,e.$2i=E,e.$7i=P,e.$8i=t,e.$0i=r,e.$$i=i,e.$_i=c,e.$Pi=(0,I.$Gi)("contextService");function a(s){const l=s;return typeof l?.id=="string"&&O.URI.isUri(l.uri)}function f(s){return typeof s?.id=="string"&&!a(s)&&!g(s)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function d(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,o.$qc)(s)}:l?e.$Si:e.$Ti;const u=s;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function g(s){const l=s;return typeof l?.id=="string"&&O.URI.isUri(l.configPath)}function w(s){const l=s;if(l?.uri)return{id:l.id,uri:O.URI.revive(l.uri)};const u=s;if(u?.configPath)return{id:u.id,configPath:O.URI.revive(u.configPath)};if(s?.id)return{id:s.id}}var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function p(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function b(s){const l=s;return!!(l&&typeof l=="object"&&O.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class ${constructor(l,u,S,y,R){this.h=l,this.j=S,this.k=y,this.l=R,this.c=k.$Mi.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=k.$Mi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=$;class m{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,D.$hh)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=m;function E(s){return new m({uri:s,index:0,name:(0,D.$dh)(s)},{uri:s.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,n.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function P(s,l){return D.$$g.isEqualOrParent(s,l.untitledWorkspacesHome)}function t(s){let l;return O.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===v.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.$9i}function i(s,l){return!P(s,l)&&!t(s)}function c(s){return(typeof s=="string"?(0,o.$rc)(s):(0,D.$fh)(s))===e.$4i}}),define(oe[53],ae([0,1,14,8,46,48,2,79,3,21,172,124,6,5,28,30]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=void 0,e.$Vec=(0,g.$Gi)("dialogMainService");let b=class{constructor(m,E){this.d=m,this.e=E,this.a=new Map,this.b=new Map,this.c=new o.$Nh}pickFileFolder(m,E){return this.f({...m,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},E)}pickFolder(m,E){return this.f({...m,pickFolders:!0,title:(0,f.localize)(1,null)},E)}pickFile(m,E){return this.f({...m,pickFiles:!0,title:(0,f.localize)(2,null)},E)}pickWorkspace(m,E){const P=(0,f.localize)(3,null),t=(0,D.$4w)((0,f.localize)(4,null)),r=p.$5i;return this.f({...m,pickFiles:!0,title:P,filters:r,buttonLabel:t},E)}async f(m,E){const P={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(P.properties=void 0,m.pickFiles&&m.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),v.$j&&P.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(P,(E||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(m){if(m){let E=this.b.get(m.id);return E||(E=new o.$Nh,this.b.set(m.id,E)),E}else return this.c}showMessageBox(m,E){return this.g(E).queue(async()=>{const{options:P,buttonIndeces:t}=(0,d.$$w)(m,this.e);let r;return E?r=await n.dialog.showMessageBox(E,P):r=await n.dialog.showMessageBox(P),{response:t[r.response],checkboxChecked:r.checkboxChecked}})}async showSaveDialog(m,E){const P=this.j(m,E);if(!P)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(E).queue(async()=>{let t;return E?t=await n.dialog.showSaveDialog(E,m):t=await n.dialog.showSaveDialog(m),t.filePath=this.h(t.filePath),t})}finally{(0,O.$Sc)(P)}}h(m){return m&&v.$j&&(m=(0,I.$nm)(m)),m}i(m){return m.map(E=>this.h(E))}async showOpenDialog(m,E){m.defaultPath&&(await a.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const P=this.j(m,E);if(!P)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(E).queue(async()=>{let t;return E?t=await n.dialog.showOpenDialog(E,m):t=await n.dialog.showOpenDialog(m),t.filePaths=this.i(t.filePaths),t})}finally{(0,O.$Sc)(P)}}j(m,E){if(!E)return O.$Xc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",m);let P=this.a.get(E.id);P||(P=new Set,this.a.set(E.id,P));const t=(0,k.$uj)(m);if(!P.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",m),P.add(t),(0,O.$Vc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",m),P?.delete(t),P?.size===0&&this.a.delete(E.id)})}};e.$Wec=b,e.$Wec=b=ke([ne(0,w.$ak),ne(1,h.$tk)],b)}),define(oe[281],ae([0,1,4,2,83,30]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class O extends o.$Xc{static{this.a=100}constructor(v,a){super(),this.f=v,this.g=a,this.b=this.B(new n.$ne),this.c=new Map,this.h(a.applicationStorage,this.b)}h(v,a){this.B(n.Event.debounce(v.onDidChangeStorage,(f,d)=>(f?f.push(d):f=[d],f),O.a)(f=>{f.length&&a.fire(this.j(f,v))}))}j(v,a){const f=new Map,d=new Set;return v.forEach(g=>{const w=a.get(g.key);typeof w=="string"?f.set(g.key,w):d.add(g.key)}),{changed:Array.from(f.entries()),deleted:Array.from(d.values())}}listen(v,a,f){switch(a){case"onDidChangeStorage":{const d=f.profile?(0,k.$di)(f.profile):void 0;if(!d)return this.b.event;let g=this.c.get(d.id);return g||(g=this.B(new n.$ne),this.h(this.g.profileStorage(d),g),this.c.set(d.id,g)),g.event}}throw new Error(`Event not found: ${a}`)}async call(v,a,f){const d=f.profile?(0,k.$di)(f.profile):void 0,g=(0,D.$Wi)(f.workspace),w=await this.m(d,g);switch(a){case"getItems":return Array.from(w.items.entries());case"updateItems":{const h=f;if(h.insert)for(const[p,b]of h.insert)w.set(p,b);h.delete?.forEach(p=>w.delete(p));break}case"optimize":return w.optimize();case"isUsed":{const h=f.payload;if(typeof h=="string")return this.g.isUsed(h)}default:throw new Error(`Call not found: ${a}`)}}async m(v,a){let f;a?f=this.g.workspaceStorage(a):v?f=this.g.profileStorage(v):f=this.g.applicationStorage;try{await f.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":v?"profile":"application"} storage due to ${d}`)}return f}}e.$9fc=O}),define(oe[42],ae([0,1,46,4,2,19,7,196,38,15,6,5,30,32,41,8,33,26,13]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=P,e.$Nl=t,e.$Ol=r;var E;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(E||(e.ProfileResourceType=E={}));function P(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&O.URI.isUri(l.location)&&O.URI.isUri(l.globalStorageHome)&&O.URI.isUri(l.settingsResource)&&O.URI.isUri(l.keybindingsResource)&&O.URI.isUri(l.tasksResource)&&O.URI.isUri(l.snippetsHome)&&O.URI.isUri(l.extensionsResource))}e.$Ml=(0,f.$Gi)("IUserDataProfilesService");function t(s,l){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:l}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:l}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:l}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:l}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:l}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:l}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:l}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:l}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function r(s,l,u,S,y,R){return{id:s,name:l,location:u,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:R&&y?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$hh)(u,"globalStorage"),settingsResource:R&&y?.useDefaultFlags?.settings?R.settingsResource:(0,D.$hh)(u,"settings.json"),keybindingsResource:R&&y?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$hh)(u,"keybindings.json"),tasksResource:R&&y?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$hh)(u,"tasks.json"),snippetsHome:R&&y?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$hh)(u,"snippets"),extensionsResource:R&&y?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$hh)(u,"extensions.json"),cacheHome:(0,D.$hh)(S,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends k.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,u,S,y){super(),this.t=l,this.u=u,this.w=S,this.y=y,this.f=!0,this.h=this.B(new o.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new o.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new o.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new o.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Dc,workspaces:new w.$Dc,emptyWindows:new Map},this.profilesHome=(0,D.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),u=[l];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,m.$gg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}u.push(r((0,D.$eh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},l))}}catch(R){this.y.error(R)}const S=new w.$Dc,y=new Map;if(u.length)try{const R=this.Q();if(R.workspaces)for(const[L,T]of Object.entries(R.workspaces)){const A=O.URI.parse(L),M=u.find(U=>U.id===T);M&&S.set(A,M)}if(R.emptyWindows)for(const[L,T]of Object.entries(R.emptyWindows)){const A=u.find(M=>M.id===T);A&&y.set(L,A)}}catch(R){this.y.error(R)}this.z={profiles:u,workspaces:S,emptyWindows:y}}return this.z}D(){const l=r("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",S=new RegExp(`${(0,$.$jf)(u)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const T=S.exec(L.name),A=T?parseInt(T[1]):0;y=A>y?A:y}const R=`${u} ${y+1}`;return this.createProfile((0,n.$uj)((0,b.$3g)()).toString(16),R,{transient:!0},l)}async createNamedProfile(l,u,S){return this.createProfile((0,n.$uj)((0,b.$3g)()).toString(16),l,u,S)}async createProfile(l,u,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(l,u,S);return y&&await this.setProfileForWorkspace(y,R),R}async F(l,u,S){if(!(0,m.$gg)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(u);return y||(y=(async()=>{try{if(this.profiles.find(A=>A.name===u||A.id===l))throw new Error(`Profile with ${u} name already exists`);const L=r(l,u,(0,D.$hh)(this.profilesHome,l),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const T=[];return this.j.fire({profile:L,join(A){T.push(A)}}),await p.Promises.settled(T),this.I([L],[],[]),L}finally{this.r.delete(u)}})(),this.r.set(u,y)),y}async updateProfile(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);return S=r(S.id,u.name??S.name,S.location,this.g,{shortName:u.shortName??S.shortName,icon:u.icon===null?void 0:u.icon??S.icon,transient:u.transient??S.isTransient,useDefaultFlags:u.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(y=>y.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const S=[];this.m.fire({profile:u,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(y){(0,a.$rl)(y)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);this.L(l,S)}unsetWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,u)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.G(l),S=O.URI.isUri(u)?this.C.workspaces.get(u):this.C.emptyWindows.get(u);return S||((0,g.$Qi)(l)?this.s.folders.get(l.uri):(0,g.$Vi)(l)?this.s.workspaces.get(l.configPath):this.s.emptyWindows.get(l.id))}G(l){return(0,g.$Qi)(l)?l.uri:(0,g.$Vi)(l)?l.configPath:l.id}H(l){return!!([...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.folders.values()].some(u=>this.w.extUri.isEqual(u.location,l.location)))}I(l,u,S){const y=[...this.profiles,...l],R=[],L=this.s.profiles;this.s.profiles=[];for(let T of y){if(T.isDefault||u.some(M=>T.id===M.id))continue;T=S.find(M=>T.id===M.id)??T;const A=L.find(M=>T.id===M.id);if(T.isTransient)this.s.profiles.push(T);else{if(A){for(const[M,U]of this.s.emptyWindows.entries())if(T.id===U.id){this.L({id:M},T);break}for(const[M,U]of this.s.workspaces.entries())if(T.id===U.id){this.L({id:"",configPath:M},T);break}for(const[M,U]of this.s.folders.entries())if(T.id===U.id){this.L({id:"",uri:M},T);break}}R.push({location:T.location,name:T.name,shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(l,u,S)}J(l,u,S){this.h.fire({added:l,removed:u,updated:S,all:this.profiles})}L(l,u,S){if(S=u?.isTransient?!0:S,S)(0,g.$Qi)(l)?(this.s.folders.delete(l.uri),u&&this.s.folders.set(l.uri,u)):(0,g.$Vi)(l)?(this.s.workspaces.delete(l.configPath),u&&this.s.workspaces.set(l.configPath,u)):(this.s.emptyWindows.delete(l.id),u&&this.s.emptyWindows.set(l.id,u));else{this.L(l,void 0,!0);const y=this.G(l);O.URI.isUri(y)?(this.C.workspaces.delete(y),u&&this.C.workspaces.set(y,u)):(this.C.emptyWindows.delete(y),u&&this.C.emptyWindows.set(y,u)),this.M()}}M(){const l={};for(const[S,y]of this.C.workspaces.entries())l[S.toString()]=y.id;const u={};for(const[S,y]of this.C.emptyWindows.entries())u[S.toString()]=y.id;this.R({workspaces:l,emptyWindows:u}),this.z=void 0}N(l){const u={},S=this.D();if(l.workspaces)for(const[R,L]of Object.entries(l.workspaces)){const T=O.URI.parse(L);u[R]=this.w.extUri.isEqual(T,S.location)?S.id:this.w.extUri.basename(T)}const y={};if(l.emptyWindows)for(const[R,L]of Object.entries(l.emptyWindows)){const T=O.URI.parse(L);y[R]=this.w.extUri.isEqual(T,S.location)?S.id:this.w.extUri.basename(T)}return{workspaces:u,emptyWindows:y}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Pl=i,e.$Pl=i=ke([ne(0,v.$Ni),ne(1,a.$al),ne(2,h.$Kl),ne(3,d.$ak)],i);class c extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Ql=c}),define(oe[87],ae([0,1,8,17,2,4,32,7,127,130,15,6,5,42,41,13,16,25]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class E extends Error{constructor(c,s){super(c),this.code=s}}e.$Gq=E,e.$Hq=(0,d.$Gi)("IExtensionsProfileScannerService");let P=class extends k.$Xc{constructor(c,s,l,u,S,y){super(),this.j=c,this.m=s,this.n=l,this.r=u,this.s=S,this.t=y,this.b=this.B(new D.$ne),this.onAddExtensions=this.b.event,this.c=this.B(new D.$ne),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$ne),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$ne),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Dc}scanProfileExtensions(c,s){return this.u(c,void 0,s)}async addExtensionsToProfile(c,s,l){const u=[],S=[];try{return await this.u(s,y=>{const R=[];if(l)R.push(...y);else for(const L of y)c.some(([T])=>(0,a.$Kp)(T.identifier,L.identifier)&&T.manifest.version!==L.version)?u.push(L):R.push(L);for(const[L,T]of c){const A=R.findIndex(U=>(0,a.$Kp)(U.identifier,L.identifier)&&U.version===L.manifest.version),M={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:T};A===-1?(S.push(M),R.push(M)):R.splice(A,1,M)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),u.length&&this.f.fire({extensions:u,profileLocation:s}),R}),S.length&&this.c.fire({extensions:S,profileLocation:s}),u.length&&this.g.fire({extensions:u,profileLocation:s}),S}catch(y){throw S.length&&this.c.fire({extensions:S,error:y,profileLocation:s}),u.length&&this.g.fire({extensions:u,error:y,profileLocation:s}),y}}async updateMetadata(c,s){const l=[];return await this.u(s,u=>{const S=[];for(const y of u){const R=c.find(([L])=>(0,a.$Kp)(L.identifier,y.identifier)&&L.manifest.version===y.version);R&&(y.metadata={...y.metadata,...R[1]},l.push(y)),S.push(y)}return S}),l}async removeExtensionFromProfile(c,s){const l=[];try{await this.u(s,u=>{const S=[];for(const y of u)(0,a.$Kp)(y.identifier,c.identifier)?l.push(y):S.push(y);return l.length&&this.f.fire({extensions:l,profileLocation:s}),S}),l.length&&this.g.fire({extensions:l,profileLocation:s})}catch(u){throw l.length&&this.g.fire({extensions:l,error:u,profileLocation:s}),u}}async u(c,s,l){return this.F(c).queue(async()=>{let u=[],S;try{const y=await this.m.readFile(c);S=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,f.$rl)(y)!==f.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(c,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&l?.bailOutWhenFileNotFound)throw new E((0,b.$ab)(y),m.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(c);let y=!1;for(const R of S){t(R)||this.w(c);let L;if((0,p.$gg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,p.$gg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=I.URI.revive(R.location);const T=this.y(L);T&&(y=!0,R.relativeLocation=T)}(0,p.$ng)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(y=!0,R.metadata.hasPreReleaseVersion=!0),u.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}y&&await this.m.writeFile(c,o.$Pe.fromString(JSON.stringify(S)))}if(s){u=s(u);const y=u.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(c,o.$Pe.fromString(JSON.stringify(y)))}return u})}w(c){const s=new E(`Invalid extensions content in ${c.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(c){return this.r.extUri.isEqual(this.r.extUri.dirname(c),this.j)?this.r.extUri.basename(c):void 0}z(c){return this.r.extUri.joinPath(this.j,c)}async D(){return this.C||(this.C=(async()=>{const c=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let l;try{l=(await this.m.readFile(c)).value.toString()}catch(S){if((0,f.$rl)(S)===f.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",c.toString());let u;try{const S=JSON.parse(l);Array.isArray(S)&&S.every(y=>t(y))?u=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,o.$Pe.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",c.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,f.$rl)(S)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",c.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(c)}catch(S){(0,f.$rl)(S)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,f.$rl)(S)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return u})()),this.C}F(c){let s=this.h.get(c);return s||(s=new n.$Nh,this.h.set(c,s)),s}};e.$Iq=P,e.$Iq=P=ke([ne(1,f.$al),ne(2,w.$Ml),ne(3,h.$Kl),ne(4,$.$_l),ne(5,g.$ak)],P);function t(i){return(0,p.$ig)(i)&&(0,v.$ip)(i.identifier)&&(r(i.location)||(0,p.$gg)(i.location)&&i.location)&&((0,p.$ng)(i.relativeLocation)||(0,p.$gg)(i.relativeLocation))&&i.version&&(0,p.$gg)(i.version)}function r(i){return i?(0,p.$gg)(i.path)&&(0,p.$gg)(i.scheme):!1}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[134],ae([0,1,22,8,36,17,16,43,157,2,12,10,3,19,248,81,13,7,177,38,130,86,247,15,6,5,28,4,83,87,42,41,209]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=re,k=De(k),d=De(d),g=De(g),h=De(h),p=et(p);var A;(function(le){function X(ee,q){if(ee===q)return!0;const j=Object.keys(ee),B=new Set;for(const G of Object.keys(q))B.add(G);if(j.length!==B.size)return!1;for(const G of j){if(ee[G]!==q[G])return!1;B.delete(G)}return B.size===0}le.equals=X})(A||(e.Translations=A={})),e.$Lq=(0,c.$Gi)("IExtensionsScannerService");let M=class extends a.$Xc{constructor(X,ee,q,j,B,G,ce,K,he,se,_,F){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=ee,this.r=q,this.s=j,this.t=B,this.u=G,this.w=ce,this.y=K,this.z=he,this.C=se,this.D=_,this.F=F,this.g=this.B(new u.$ne),this.onDidChangeCache=this.g.event,this.h=(0,w.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,P.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(X,ee,q){const[j,B]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(ee)]),G=q?await this.scanExtensionsUnderDevelopment(X,[...j,...B]):[];return this.L(j,B,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const ee=[];ee.push(this.M(!!X.useCache,X.language)),ee.push(this.N(X.language,!!X.checkControlFile));const[q,j]=await Promise.all(ee);return this.J([...q,...j],t.ExtensionType.System,X,!1)}async scanUserExtensions(X){const ee=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ee);const q=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(ee,!!X.profileLocation,t.ExtensionType.User,!X.includeUninstalled,X.language,!0,q,X.productVersion??this.R()),B=X.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let G;try{G=await B.scanExtensions(j)}catch(ce){if(ce instanceof y.$Gq&&ce.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),G=await B.scanExtensions(j);else throw ce}return G=await this.J(G,t.ExtensionType.User,X,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(X,ee){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===f.Schemas.file).map(async j=>{const B=await this.P(j,!1,t.ExtensionType.User,!0,X.language,!1,void 0,X.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(B)).map(ce=>(ce.type=ee.find(K=>(0,P.$Kp)(K.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,B)))}))).flat();return this.J(q,"development",X,!0)}return[]}async scanExistingExtension(X,ee,q){const j=await this.P(X,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanExtension(j);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(X,ee,q){const j=await this.P(X,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanOneOrMultipleExtensions(j);return this.J(B,ee,q,!0)}async scanMultipleExtensions(X,ee,q){const j=[];return await Promise.all(X.map(async B=>{const G=await this.scanOneOrMultipleExtensions(B,ee,q);j.push(...G)})),this.J(j,ee,q,!0)}async scanMetadata(X){const ee=(0,w.$hh)(X,"package.json"),q=(await this.w.readFile(ee)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(X,ee){const q=(0,w.$hh)(X,"package.json"),j=(await this.w.readFile(q)).value.toString(),B=JSON.parse(j);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,B.__metadata={...B.__metadata,...ee},await this.w.writeFile((0,w.$hh)(X,"package.json"),D.$Pe.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof y.$Gq&&X.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(ee=>[ee,ee.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Pe.fromString(JSON.stringify([])))}catch(ee){(0,i.$rl)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$ab)(ee))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,ee,q,j){return q.includeAllVersions||(X=this.L(ee===t.ExtensionType.System?X:void 0,ee===t.ExtensionType.User?X:void 0,ee==="development"?X:void 0,await this.getTargetPlatform(),j)),q.includeInvalid||(X=X.filter(B=>B.isValid)),X.sort((B,G)=>{const ce=d.$qc(B.location.fsPath),K=d.$qc(G.location.fsPath);return ce<K?-1:ce>K?1:0})}L(X,ee,q,j,B){const G=(K,he,se)=>{if(K.isValid&&!he.isValid)return!1;if(K.isValid===he.isValid){if(B&&h.gt(K.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(h.eq(K.manifest.version,he.manifest.version)){if(K.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return se?this.y.warn(`Overwriting user extension ${K.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${he.location.path}.`),!0},ce=new t.$tn;return X?.forEach(K=>{const he=ce.get(K.identifier.id);(!he||G(he,K,!1))&&ce.set(K.identifier.id,K)}),ee?.forEach(K=>{const he=ce.get(K.identifier.id);if(!he&&X&&K.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!he||G(he,K,!1))&&ce.set(K.identifier.id,K)}),q?.forEach(K=>{const he=ce.get(K.identifier.id);(!he||G(he,K,!0))&&ce.set(K.identifier.id,K),ce.set(K.identifier.id,K)}),[...ce.values()]}async M(X,ee){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ee,!0,void 0,this.R()),B=await(X&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",B.length),B}async N(X,ee){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const j=ee?await this.O():{},B=[],G=$.URI.file(d.$kc(d.$mc(f.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of q){const he=j[K.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":B.push((0,w.$hh)(G,K.name));break;default:B.push($.URI.file(he));break}}const ce=await Promise.all(B.map(async K=>this.n.scanExtension(await this.P(K,!1,t.ExtensionType.System,!0,X,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,n.$Kb)(ce)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,ee,q,j,B,G,ce,K){const he=await this.f(B??g.$w),se=await this.Q(X),_=ee&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=_?await this.Q(_):void 0;return new U(X,se,_,F,ee,ce,q,j,G,K.version,K.date,this.C.commit,!this.z.isBuilt,B,he)}async Q(X){try{const ee=await this.w.stat(X);if(typeof ee.mtime=="number")return ee.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=M,e.$Mq=M=ke([ne(4,R.$Ml),ne(5,y.$Hq),ne(6,i.$al),ne(7,s.$ak),ne(8,E.$Ni),ne(9,l.$tk),ne(10,L.$Kl),ne(11,c.$Fi)],M);class U{constructor(X,ee,q,j,B,G,ce,K,he,se,_,F,N,W,H){this.location=X,this.mtime=ee,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=j,this.profile=B,this.profileScanOptions=G,this.type=ce,this.excludeObsolete=K,this.validate=he,this.productVersion=se,this.productDate=_,this.productCommit=F,this.devMode=N,this.language=W,this.translations=H}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,ee){return(0,w.$ah)(X.location,ee.location)&&X.mtime===ee.mtime&&(0,w.$ah)(X.applicationExtensionslocation,ee.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&X.profile===ee.profile&&k.$io(X.profileScanOptions,ee.profileScanOptions)&&X.type===ee.type&&X.excludeObsolete===ee.excludeObsolete&&X.validate===ee.validate&&X.productVersion===ee.productVersion&&X.productDate===ee.productDate&&X.productCommit===ee.productCommit&&X.devMode===ee.devMode&&X.language===ee.language&&A.equals(X.translations,ee.translations)}}e.$Nq=U;let C=class extends a.$Xc{constructor(X,ee,q,j,B,G){super(),this.g=X,this.h=ee,this.j=q,this.m=j,this.n=G,this.f=B.extensionsEnabledWithApiProposalVersion?.map(ce=>ce.toLowerCase())??[]}async scanExtensions(X){const ee=X.profile?await this.s(X):await this.r(X);let q={};if(X.excludeObsolete&&X.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();q=JSON.parse(j)}catch{}return(0,b.$tg)(q)?ee:ee.filter(j=>!q[P.$Lp.create(j).toString()])}async r(X){const ee=await this.m.resolve(X.location);if(!ee.children?.length)return[];const q=await Promise.all(ee.children.map(async j=>{if(!j.isDirectory||X.type===t.ExtensionType.User&&(0,w.$eh)(j.resource).indexOf(".")===0)return null;const B=new U(j.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(B)}));return(0,n.$Kb)(q).sort((j,B)=>j.location.path<B.location.path?-1:1)}async s(X){let ee=await this.t(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.j.extUri.isEqual(X.location,X.applicationExtensionslocation)){ee=ee.filter(j=>!j.metadata?.isApplicationScoped);const q=await this.t(X.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,X);ee.push(...q)}return ee}async t(X,ee,q){const j=await this.h.scanProfileExtensions(X,q.profileScanOptions);if(!j.length)return[];const B=await Promise.all(j.map(async G=>{if(ee(G)){const ce=new U(G.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ce,G.metadata)}return null}));return(0,n.$Kb)(B)}async scanOneOrMultipleExtensions(X){try{if(await this.m.exists((0,w.$hh)(X.location,"package.json"))){const ee=await this.scanExtension(X);return ee?[ee]:[]}else return await this.scanExtensions(X)}catch(ee){return this.n.error(`Error scanning extensions at ${X.location.path}:`,(0,O.$ab)(ee)),[]}}async scanExtension(X,ee){try{let q=await this.u(X.location);if(q){q.publisher||(q.publisher=t.$nn),ee=ee??q.__metadata,delete q.__metadata;const j=(0,P.$Pp)(q.publisher,q.name),B=ee?.id?{id:j,uuid:ee.id}:{id:j},G=ee?.isSystem?t.ExtensionType.System:X.type,ce=G===t.ExtensionType.System||!!ee?.isBuiltin;q=await this.w(X.location,q,U.createNlsConfiguration(X)),q.enabledApiProposals&&!this.f?.includes(j.toLowerCase())&&(q.enabledApiProposals=(0,t.$zn)([...q.enabledApiProposals]));const K={type:G,identifier:B,manifest:q,location:X.location,isBuiltin:ce,targetPlatform:ee?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return X.validate?this.validate(K,X):K}}catch(q){X.type!==t.ExtensionType.System&&this.n.error(q)}return null}validate(X,ee){let q=!0;const j=(0,r.$2p)(ee.productVersion,ee.productDate,ee.location,X.manifest,X.isBuiltin);for(const[B,G]of j)B===p.default.Error&&(q=!1,this.n.error(this.D(ee.location,G)));return X.isValid=q,X.validations=j,X}async u(X){const ee=(0,w.$hh)(X,"package.json");let q;try{q=(await this.m.readFile(ee)).value.toString()}catch(B){return(0,i.$rl)(B)!==i.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(X,(0,m.localize)(0,null,ee.path,B.message))),null}let j;try{j=JSON.parse(q)}catch{const G=[];(0,I.$Yn)(q,G);for(const ce of G)this.n.error(this.D(X,(0,m.localize)(1,null,ee.path,ce.offset,ce.length,(0,v.$Jq)(ce.error))));return null}return(0,I.$7n)(j)!=="object"?(this.n.error(this.D(X,(0,m.localize)(2,null,ee.path))),null):j}async w(X,ee,q){const j=await this.y(X,ee,q);if(j)try{const B=[],G=await this.z(j.default,B);if(B.length>0)return B.forEach(K=>{this.n.error(this.D(X,(0,m.localize)(3,null,j.default?.path,(0,v.$Jq)(K.error))))}),ee;if((0,I.$7n)(j)!=="object")return this.n.error(this.D(X,(0,m.localize)(4,null,j.default?.path))),ee;const ce=j.values||Object.create(null);return(0,T.$Kq)(this.n,ee,ce,G)}catch{}return ee}async y(X,ee,q){const j=(0,w.$hh)(X,"package.nls.json"),B=(he,se)=>{se.forEach(_=>{this.n.error(this.D(X,(0,m.localize)(5,null,he?.path,(0,v.$Jq)(_.error))))})},G=he=>{this.n.error(this.D(X,(0,m.localize)(6,null,he?.path)))},ce=`${ee.publisher}.${ee.name}`,K=q.translations[ce];if(K)try{const he=$.URI.file(K),se=(await this.m.readFile(he)).value.toString(),_=[],F=(0,I.$Yn)(se,_);return _.length>0?(B(he,_),{values:void 0,default:j}):(0,I.$7n)(F)!=="object"?(G(he),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let se;try{se=await this.C(X,q)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const _=(await this.m.readFile(se.localized)).value.toString(),F=[],N=(0,I.$Yn)(_,F);return F.length>0?(B(se.localized,F),{values:void 0,default:se.original}):(0,I.$7n)(N)!=="object"?(G(se.localized),{values:void 0,default:se.original}):{values:N,default:se.original}}catch{return{values:void 0,default:se.original}}}}async z(X,ee){if(X)try{const q=(await this.m.readFile(X)).value.toString();return(0,I.$Yn)(q,ee)}catch{}}C(X,ee){return new Promise((q,j)=>{const B=G=>{const ce=(0,w.$hh)(X,`package.nls.${G}.json`);this.m.exists(ce).then(K=>{K&&q({localized:ce,original:(0,w.$hh)(X,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?q({localized:(0,w.$hh)(X,"package.nls.json"),original:null}):(G=G.substring(0,he),B(G))})};if(ee.devMode||ee.pseudo||!ee.language)return q({localized:(0,w.$hh)(X,"package.nls.json"),original:null});B(ee.language)})}D(X,ee){return`[${X.path}]: ${ee}`}};C=ke([ne(1,y.$Hq),ne(2,L.$Kl),ne(3,i.$al),ne(4,l.$tk),ne(5,s.$ak)],C);let z=class extends C{constructor(X,ee,q,j,B,G,ce,K){super(ee,j,B,G,ce,K),this.I=X,this.J=q,this.G=this.B(new o.$Eh(3e3)),this.H=this.B(new u.$ne),this.onDidChangeCache=this.H.event}async scanExtensions(X){const ee=this.O(X),q=await this.L(ee);if(this.F=X,q&&q.input&&U.equals(q.input,this.F))return this.n.debug("Using cached extensions scan result",X.type===t.ExtensionType.System?"system":"user",X.location.toString()),this.G.trigger(()=>this.N()),q.result.map(B=>(B.location=$.URI.revive(B.location),B));const j=await super.scanExtensions(X);return await this.M(ee,{input:X,result:j}),j}async L(X){try{const ee=await this.m.readFile(X),q=JSON.parse(ee.value.toString());return{result:q.result,input:(0,S.$di)(q.input)}}catch(ee){this.n.debug("Error while reading the extension cache file:",X.path,(0,O.$ab)(ee))}return null}async M(X,ee){try{await this.m.writeFile(X,D.$Pe.fromString(JSON.stringify(ee)))}catch(q){this.n.debug("Error while writing the extension cache file:",X.path,(0,O.$ab)(q))}}async N(){if(!this.F)return;const X=this.O(this.F),ee=await this.L(X);if(!ee)return;const q=ee.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!k.$io(j,q))try{this.n.info("Invalidating Cache",q,j),await this.m.del(X),this.H.fire()}catch(B){this.n.error(B)}}O(X){const ee=this.P(X);return this.j.extUri.joinPath(ee.cacheHome,X.type===t.ExtensionType.System?t.$mn:t.$ln)}P(X){return X.type===t.ExtensionType.System?this.J.defaultProfile:X.profile?this.j.extUri.isEqual(X.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ee=>this.j.extUri.isEqual(X.location,ee.extensionsResource))??this.I:this.J.defaultProfile}};z=ke([ne(2,R.$Ml),ne(3,y.$Hq),ne(4,L.$Kl),ne(5,i.$al),ne(6,l.$tk),ne(7,s.$ak)],z);function re(le,X){const ee=(0,P.$Np)(le.manifest.publisher,le.manifest.name);return{id:ee,identifier:new t.$rn(ee),isBuiltin:le.type===t.ExtensionType.System,isUserBuiltin:le.type===t.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:X,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class Z extends M{constructor(X,ee,q,j,B,G,ce,K,he,se,_,F){super(X,ee,(0,w.$hh)(q,".vscode-oss-dev","extensions","control.json"),j,B,G,ce,K,he,se,_,F),this.S=(async()=>{if(g.$z)try{const N=await this.w.readFile($.URI.file(g.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(X){return this.S}}e.$Pq=Z}),define(oe[282],ae([0,1,5,42,41,25,87,15,38,7]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let f=class extends O.$Iq{constructor(g,w,h,p,b,$){super(a.URI.file(g.extensionsPath),w,h,p,b,$)}};e.$nR=f,e.$nR=f=ke([ne(0,v.$Oi),ne(1,I.$al),ne(2,o.$Ml),ne(3,k.$Kl),ne(4,D.$_l),ne(5,n.$ak)],f)}),define(oe[283],ae([0,1,7,38,87,134,15,6,5,28,41,42]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;let g=class extends D.$Pq{constructor(h,p,b,$,m,E,P,t){super(n.URI.file(m.builtinExtensionsPath),n.URI.file(m.extensionsPath),m.userHome,h.defaultProfile,h,p,b,$,m,E,P,t)}};e.$wgc=g,e.$wgc=g=ke([ne(0,d.$Ml),ne(1,k.$Hq),ne(2,O.$al),ne(3,v.$ak),ne(4,o.$Oi),ne(5,a.$tk),ne(6,f.$Kl),ne(7,I.$Fi)],g)}),define(oe[284],ae([0,1,14,2,12,10,3,61,7,33,35,38,5,42]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;let h=class extends o.$Xc{constructor(b,$,m){super(),this.c=b,this.f=m,this.a=I.$Mi.forPaths(!O.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(b.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:b}=n.session;b.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,($,m)=>this.j($,m)),b.protocol.interceptFileProtocol(k.Schemas.file,($,m)=>this.h($,m)),this.B((0,o.$Vc)(()=>{b.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(b){const $=(0,D.$kc)(b);return this.a.get($)?o.$Xc.None:(this.a.set($,!0),(0,o.$Vc)(()=>this.a.delete($)))}h(b,$){const m=v.URI.parse(b.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${k.Schemas.file}: protocol (original URL: ${b.url})`),$({error:-3})}j(b,$){const m=this.m(b);let E;return this.c.crossOriginIsolated&&((0,D.$qc)(m)==="workbench.html"||(0,D.$qc)(m)==="workbench-dev.html"?E=k.COI.CoopAndCoep:E=k.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(m)?$({path:m,headers:E}):this.b.has((0,D.$rc)(m).toLowerCase())?$({path:m}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),$({error:-3}))}m(b){const $=v.URI.parse(b.url),m=k.$1g.uriToFileUri($);return(0,D.$kc)(m.fsPath)}createIPCObjectUrl(){let b;const $=v.URI.from({scheme:"vscode",path:(0,a.$3g)()}),m=$.toString(),E=async()=>b;return f.$FX.handle(m,E),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:$,update:P=>b=P,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),f.$FX.removeHandler(m)}}}};e.$Qgc=h,e.$Qgc=h=ke([ne(0,d.$Oi),ne(1,w.$Ml),ne(2,g.$ak)],h)}),define(oe[63],ae([0,1,8,4,2,71,13,120,6,42]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=w,e.$jq=p,e.$lq=$,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,v.$Gi)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var d;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function w(m){const E=m.get(e.$fq);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}class h extends k.$Xc{static{this.a=60*1e3}constructor(E={flushInterval:h.a}){super(),this.m=E,this.b=this.B(new o.$qe),this.c=this.B(new o.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new o.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(E,P,t){return o.Event.filter(this.b.event,r=>r.scope===E&&(P===void 0||r.key===P),t)}n(){this.j.value=(0,n.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(E,P){const{key:t,external:r}=P;if(t===e.$fq){switch(E){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:t,target:this.J(E)[t],external:r})}w(E){this.f.fire({reason:E})}get(E,P,t){return this.P(P)?.get(E,t)}getBoolean(E,P,t){return this.P(P)?.getBoolean(E,t)}getNumber(E,P,t){return this.P(P)?.getNumber(E,t)}getObject(E,P,t){return this.P(P)?.getObject(E,t)}storeAll(E,P){this.y(()=>{for(const t of E)this.store(t.key,t.value,t.scope,t.target,P)})}store(E,P,t,r,i=!1){if((0,O.$pg)(P)){this.remove(E,t,i);return}this.y(()=>{this.z(E,t,r),this.P(t)?.set(E,P,i)})}remove(E,P,t=!1){this.y(()=>{this.z(E,P,void 0),this.P(P)?.delete(E,t)})}y(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,P){const t=[],r=this.J(E);for(const i of Object.keys(r))r[i]===P&&t.push(i);return t}z(E,P,t,r=!1){const i=this.J(P);typeof t=="number"?i[E]!==t&&(i[E]=t,this.P(P)?.set(e.$fq,JSON.stringify(i),r)):typeof i[E]=="number"&&(delete i[E],this.P(P)?.set(e.$fq,JSON.stringify(i),r))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(E){switch(E){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(E){const P=this.P(E);return P?w(P):Object.create(null)}isNew(E){return this.getBoolean(e.$eq,E)===!0}async flush(E=f.NONE){this.f.fire({reason:E});const P=this.P(d.APPLICATION),t=this.P(d.PROFILE),r=this.P(d.WORKSPACE);switch(E){case f.NONE:await n.Promises.settled([P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await n.Promises.settled([P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.P(d.APPLICATION)?.items??new Map,P=this.P(d.PROFILE)?.items??new Map,t=this.P(d.WORKSPACE)?.items??new Map;return $(E,P,t,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(E){return await this.flush(),this.P(E)?.optimize()}async switch(E,P){return this.w(f.NONE),(0,a.$Ll)(E)?this.R(E,P):this.S(E,P)}M(E,P){return!(E.id===P.id||p(P)&&p(E))}N(E,P,t){this.y(()=>{const r=new Set;for(const[i,c]of E)r.add(i),P.get(i)!==c&&this.u(t,{key:i,external:!0});for(const[i]of P.items)r.has(i)||this.u(t,{key:i,external:!0})})}}e.$iq=h;function p(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class b extends h{constructor(){super(),this.U=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(E=>this.u(d.WORKSPACE,E))),this.B(this.W.onDidChangeStorage(E=>this.u(d.PROFILE,E))),this.B(this.U.onDidChangeStorage(E=>this.u(d.APPLICATION,E)))}P(E){switch(E){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(E){switch(E){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(E){return!1}}e.$kq=b;async function $(m,E,P,t,r,i){const c=A=>{try{return JSON.parse(A)}catch{return A}},s=new Map,l=new Map;m.forEach((A,M)=>{s.set(M,A),l.set(M,c(A))});const u=new Map,S=new Map;E.forEach((A,M)=>{u.set(M,A),S.set(M,c(A))});const y=new Map,R=new Map;P.forEach((A,M)=>{y.set(M,A),R.set(M,c(A))}),console.group(t!==r?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((A,M)=>{L.push({key:M,value:A})}),console.table(L),console.groupEnd(),console.log(l),t!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const A=[];u.forEach((M,U)=>{A.push({key:U,value:M})}),console.table(A),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${i})`);const T=[];y.forEach((A,M)=>{T.push({key:M,value:A})}),console.table(T),console.groupEnd(),console.log(R)}}),define(oe[285],ae([0,1,17,33,63]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=D;async function D(O,I,v){let a=v&&v.get("storage.serviceMachineId",k.StorageScope.APPLICATION)||null;if(a)return a;try{const d=(await I.readFile(O.serviceMachineIdResource)).value.toString();a=(0,o.$2g)(d)?d:null}catch{a=null}if(!a){a=(0,o.$3g)();try{await I.writeFile(O.serviceMachineIdResource,n.$Pe.fromString(a))}catch{}}return v?.store("storage.serviceMachineId",a,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE),a}}),define(oe[286],ae([0,1,285,25,58]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=D;async function D(O,I,v,a,f,d,g){const w={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,k.$Cp)(I,v)&&(0,k.$Ep)(a)===o.TelemetryLevel.USAGE){const h=await(0,n.$mq)(v,f,d);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=g.machineId||h}return w}}),define(oe[287],ae([0,1,22,8,4,2,10,67,7,21,120,166,5,63,25,30,12]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=void 0;class $ extends D.$Xc{static{this.a=2e3}get storage(){return this.f}constructor(c,s){super(),this.m=c,this.n=s,this.b=this.B(new k.$ne),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.$ne),this.onDidCloseStorage=this.c.event,this.f=this.B(new f.$cq(new f.$dq,{hint:f.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new o.$4h,this.whenInit=this.h.p,this.j=f.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===f.StorageState.None)try{const c=this.B(await this.t());this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(l=>this.b.fire(l))),await this.s(c);const s=c.getBoolean(w.$eq);s===void 0?c.set(w.$eq,!0):s&&c.set(w.$eq,!1)}catch(c){this.m.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.j=f.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===g.LogLevel.Trace?c=>this.m.trace(c):void 0,logError:c=>this.m.error(c)}}s(c){return c.init()}get items(){return this.f.items}get(c,s){return this.f.get(c,s)}set(c,s){return this.f.set(c,s)}delete(c){return this.f.delete(c)}optimize(){return this.f.optimize()}async close(){const c=new I.$he(!1);await this.w(),c.stop(),c.elapsed()>$.a&&await this.u(c),this.c.fire()}async u(c){if(this.path)try{const s=(0,n.top)(Array.from(this.f.items.entries()).map(([u,S])=>({key:u,length:S.length})),(u,S)=>S.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),l=(await this.n.stat(v.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${l}b, Large Keys: ${s}`)}catch(s){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async w(){this.g&&await this.g,this.j=f.StorageState.Closed,await this.f.close()}}class m extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,O.$mc)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,m.y)}constructor(c,s,l,u){super(l,u),this.z=c,this.C=s}async t(){return new f.$cq(new d.$$X(this.path??d.$$X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:f.StorageHint.STORAGE_IN_MEMORY})}}class E extends m{constructor(c,s,l,u){super(c,s,l,u)}}e.$jfc=E;class P extends m{constructor(c,s,l,u){super(s.defaultProfile,c,l,u)}async s(c){await super.s(c),this.G(c)}G(c){c.get(h.$cm,void 0)===void 0&&c.set(h.$cm,new Date().toUTCString());const l=c.get(h.$bm,void 0),u=new Date().toUTCString();c.set(h.$dm,typeof l>"u"?null:l),c.set(h.$bm,u)}}e.$kfc=P;class t extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,O.$mc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,t.y)}constructor(c,s,l,u,S){super(l,S),this.C=c,this.D=s,this.F=u}async t(){const{storageFilePath:c,wasCreated:s}=await this.H();return new f.$cq(new d.$$X(c,{logging:this.r()}),{hint:this.D.useInMemoryStorage?f.StorageHint.STORAGE_IN_MEMORY:s?f.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$$X.IN_MEMORY_PATH,wasCreated:!0};const c=(0,O.$mc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),s=(0,O.$mc)(c,t.y);return await a.Promises.exists(c)?{storageFilePath:s,wasCreated:!1}:(await a.Promises.mkdir(c,{recursive:!0}),this.I(c),{storageFilePath:s,wasCreated:!0})}async I(c){let s;if((0,p.$Qi)(this.C)?s={folder:this.C.uri.toString()}:(0,p.$Vi)(this.C)&&(s={workspace:this.C.configPath.toString()}),s)try{const l=(0,O.$mc)(c,t.z);await a.Promises.exists(l)||await a.Promises.writeFile(l,JSON.stringify(s,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$lfc=t;class r extends ${get path(){}async t(){return new f.$cq(new f.$dq,{hint:f.StorageHint.STORAGE_IN_MEMORY})}}e.$mfc=r}),define(oe[288],ae([0,1,4,2,63]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class D extends o.$Xc{constructor(I,v,a){super(),this.b=I,this.c=v,this.f=a;const f=this.B(new o.$Yc);this.a=this.B(new n.$ne({onWillAddFirstListener:()=>f.value=this.g(),onDidRemoveLastListener:()=>f.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new o.$Wc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(v,a)=>(v?v.push(a.key):v=[a.key],v),100)(v=>this.h(v))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(v,a)=>{v||(v=new Map);let f=v.get(a.profile.id);return f||v.set(a.profile.id,f={profile:a.profile,keys:[],storage:a.storage}),f.keys.push(a.key),v},100)(v=>this.j(v))),I}h(I){const v=I.includes(k.$fq)?[this.c.defaultProfile]:[],a=[];if(I=I.filter(f=>f!==k.$fq),I.length){const f=(0,k.$hq)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:I.map(d=>({key:d,scope:k.StorageScope.PROFILE,target:f[d]}))})}this.m(v,a)}j(I){const v=[],a=new Map;for(const[f,d]of I.entries()){d.keys.includes(k.$fq)&&v.push(d.profile);const g=d.keys.filter(w=>w!==k.$fq);if(g.length){const w=(0,k.$hq)(d.storage.storage);a.set(f,{profile:d.profile,changes:g.map(h=>({key:h,scope:k.StorageScope.PROFILE,target:w[h]}))})}}this.m(v,[...a.values()])}m(I,v){(I.length||v.length)&&this.a.fire({valueChanges:v,targetChanges:I})}listen(I,v,a){switch(v){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${v}`)}async call(I,v){throw new Error(`Call not found: ${v}`)}}e.$ygc=D}),define(oe[289],ae([0,1,7,38,15,5,34,41,42,13,128]),function(x,e,n,o,k,D,O,I,v,a,f){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let w=class extends v.$Pl{static{d=this}static{this.a="profileAssociationsMigration"}constructor($,m,E,P,t){super(E,P,m,t),this.U=$,this.W=E}O(){return this.U.getItem(d.b,[]).map(m=>({...m,location:(0,a.$gg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):n.URI.revive(m.location)}))}Q(){const $=this.U.getItem(d.c,{});return this.U.getItem(d.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=w,e.$kR=w=d=ke([ne(0,O.$fR),ne(1,I.$Kl),ne(2,o.$Oi),ne(3,k.$al),ne(4,D.$ak)],w);let h=g=class extends w{constructor($,m,E,P,t){super($,m,E,P,t),this.$=$}P($){$.length?this.$.setItem(g.b,$.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(g.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(g.c,$):this.$.removeItem(g.c)}Q(){const $="workspaceAndProfileInfo",m=this.$.getItem($,void 0);if(m){this.$.removeItem($);const P=m.reduce((t,{workspace:r,profile:i})=>(t[n.URI.revive(r).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(g.c,{workspaces:P})}const E=super.Q();return this.$.getItem(g.a,!1)||(this.R(E),this.$.setItem(g.a,!0)),E}};e.$lR=h,e.$lR=h=g=ke([ne(0,O.$gR),ne(1,I.$Kl),ne(2,o.$Oi),ne(3,k.$al),ne(4,D.$ak)],h);let p=class extends h{constructor($,m,E,P){super(new f.$jR(f.SaveStrategy.IMMEDIATE,m,P,E),$,m,E,P)}async init(){return await this.$.init(),super.init()}};e.$mR=p,e.$mR=p=ke([ne(0,I.$Kl),ne(1,o.$Oi),ne(2,k.$al),ne(3,D.$ak)],p)}),define(oe[59],ae([0,1,38,15,6,5,41,42,289,34]),function(x,e,n,o,k,D,O,I,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=void 0,e.$4ec=(0,k.$Hi)(I.$Ml);let f=class extends v.$lR{constructor(g,w,h,p,b){super(g,w,h,p,b)}getAssociatedEmptyWindows(){const g=[];for(const w of this.C.emptyWindows.keys())g.push({id:w});return g}};e.$5ec=f,e.$5ec=f=ke([ne(0,a.$gR),ne(1,O.$Kl),ne(2,n.$Oi),ne(3,o.$al),ne(4,D.$ak)],f)}),define(oe[135],ae([0,1,19,7,30]),function(x,e,n,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=D,e.$7ec=O,e.$8ec=I;async function D(v,a,f){for(const g of v){const w=g.openedWorkspace;if((0,k.$Vi)(w)){const h=await f(w);if(h){if(h.folders.some(p=>n.$$g.isEqualOrParent(a,p.uri)))return g}else if(n.$$g.isEqualOrParent(a,w.configPath))return g}}const d=v.filter(g=>(0,k.$Qi)(g.openedWorkspace)&&n.$$g.isEqualOrParent(a,g.openedWorkspace.uri));if(d.length)return d.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function O(v,a){for(const f of v)if((0,k.$Vi)(f.openedWorkspace)&&n.$$g.isEqual(f.openedWorkspace.configPath,a)||(0,k.$Qi)(f.openedWorkspace)&&n.$$g.isEqual(f.openedWorkspace.uri,a))return f}function I(v,a){const f=d=>a.some(g=>n.$$g.isEqual(o.URI.file(g),o.URI.file(d)));for(const d of v)if(d.config?.extensionDevelopmentPath?.some(g=>f(g)))return d}}),define(oe[103],ae([0,1,31,43,108,48,12,10,3,19,7,6,75,30]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhb=void 0,e.$Zhb=h,e.$1hb=p,e.$2hb=b,e.$3hb=$,e.$4hb=P,e.$5hb=r,e.$6hb=i,e.$7hb=S,e.$8hb=y,o=De(o),k=De(k),e.$Yhb=(0,d.$Gi)("workspacesService");function h(R){return R.hasOwnProperty("workspace")}function p(R){return R.hasOwnProperty("folderUri")}function b(R){return R.hasOwnProperty("fileUri")}function $(R){return m(R)||E(R)}function m(R){const L=R;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function E(R){const L=R;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function P(R,L,T,A,M){if(R.scheme!==A.scheme)return{name:T,uri:R.toString(!0)};let U=L?void 0:M.relativePath(A,R);if(U!==void 0)U.length===0?U=".":v.$i&&(U=t(U));else if(R.scheme===O.Schemas.file)U=R.fsPath,v.$i&&(U=t(U));else if(M.isEqualAuthority(R.authority,A.authority))U=R.path;else return{name:T,uri:R.toString(!0)};return{name:T,path:U}}function t(R){return R=(0,D.$Xw)(R),(0,n.$Cg)(R)||(R=(0,n.$zg)(R)),R}function r(R,L,T){const A=[],M=new Set,U=T.dirname(L);for(const C of R){let z;if(m(C))C.path&&(z=T.resolvePath(U,C.path));else if(E(C))try{z=f.URI.parse(C.uri),z.path[0]!==I.$jc.sep&&(z=z.with({path:I.$jc.sep+z.path}))}catch(re){console.warn(re)}if(z){const re=T.getComparisonKey(z);if(!M.has(re)){M.add(re);const Z=C.name||T.basenameOrAuthority(z);A.push(new w.$1i({uri:z,name:Z,index:A.length},C))}}}return A}function i(R,L,T,A,M){const U=c(L,R),C=M.dirname(L),z=M.dirname(A),re=[];for(const ee of U.folders){const q=m(ee)?M.resolvePath(C,ee.path):f.URI.parse(ee.uri);let j;T?j=!1:j=!m(ee)||(0,I.$lc)(ee.path),re.push(P(q,j,ee.name,z,M))}const Z={insertSpaces:!1,tabSize:4,eol:v.$k||v.$j?`
`:`\r
`},le=k.$ao(R,["folders"],re,Z);let X=k.$do(R,le);return(0,a.$mh)(U.remoteAuthority,(0,g.$hn)(A))&&(X=k.$do(X,k.$_n(X,["remoteAuthority"],Z))),X}function c(R,L){const T=o.$Yn(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(A=>$(A));else throw new Error(`${R} looks like an invalid workspace file.`);return T}function s(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function l(R){return typeof R.folderUri=="string"}function u(R){return typeof R.fileUri=="string"}function S(R,L){const T={workspaces:[],files:[]};if(R){const A=function(U,C){for(let z=0;z<U.length;z++)try{C(U[z],z)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(U[z])}: ${re.toString()}. Skip entry.`)}},M=R;Array.isArray(M.entries)&&A(M.entries,U=>{const C=U.label,z=U.remoteAuthority;s(U)?T.workspaces.push({label:C,remoteAuthority:z,workspace:{id:U.workspace.id,configPath:f.URI.parse(U.workspace.configPath)}}):l(U)?T.workspaces.push({label:C,remoteAuthority:z,folderUri:f.URI.parse(U.folderUri)}):u(U)&&T.files.push({label:C,remoteAuthority:z,fileUri:f.URI.parse(U.fileUri)})})}return T}function y(R){const L={entries:[]};for(const T of R.workspaces)p(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of R.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}}),define(oe[104],ae([0,1,92,12,3,19]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0,e.$0ec=O,e.$$ec=I,e.$_ec=v,e.$9ec=128/4;function O(a){function f(){let d=a.scheme===o.Schemas.file?(0,D.$8g)(a):a.toString();return k.$k||(d=d.toLowerCase()),(0,n.createHash)("md5").update(d).digest("hex")}return{id:f(),configPath:a}}function I(a,f){function d(){if(a.scheme!==o.Schemas.file)return(0,n.createHash)("md5").update(a.toString()).digest("hex");if(!f)return;let w;return k.$k?w=f.ino:k.$j?w=f.birthtime.getTime():k.$i&&(typeof f.birthtimeMs=="number"?w=Math.floor(f.birthtimeMs):w=f.birthtime.getTime()),(0,n.createHash)("md5").update(a.fsPath).update(w?String(w):"").digest("hex")}const g=d();if(typeof g=="string")return{id:g,uri:a}}function v(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[105],ae([0,1,92,93,27,290,17,16,4,2,10,3,33,44,118]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=s,e.$zi=l,e.$Bi=y,e.$Ci=R;const p=3e4;class b{traceSocketEvent(T,A){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,T,A)}constructor(T,A=""){this.f=!0,this.debugLabel=A,this.socket=T,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,I.$3)(U)}},this.socket.on("error",this.a);let M;this.b=U=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>T.destroy(),p)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(T){const A=M=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,M),T(O.$Pe.wrap(M))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(T){const A=M=>{T({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(T){const A=()=>{T()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(T){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,T),this.socket.write(T.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,I.$3)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,I.$3)(A)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((T,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),T();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),T()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$vi=b;var $;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var m;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(m||(m={}));class E extends a.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(T,A){this.socket.traceSocketEvent(T,A)}constructor(T,A,M,U){super(),this.f=this.B(new v.$ne),this.g=this.B(new v.$ne),this.h=!1,this.j={state:m.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=T,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:M?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new P(this,A,M,U,this.f,(C,z)=>this.m(C,z))),this.B(this.a.onError(C=>{console.error(C),(0,I.$3)(C),this.g.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:C})})),this.b=new h.$qi,this.B(this.socket.onData(C=>this.n(C))),this.B(this.socket.onClose(async C=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(C)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(T){return this.f.event(T)}onClose(T){return this.g.event(T)}onEnd(T){return this.socket.onEnd(T)}write(T){let A=0;for(;A<T.byteLength;)this.a.writeMessage(T.slice(A,Math.min(A+$.MaxWebSocketMessageLength,T.byteLength)),{compressed:!0,opcode:2}),A+=$.MaxWebSocketMessageLength}m(T,{compressed:A,opcode:M}){if(this.h)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,T);let U=$.MinHeaderByteSize;T.byteLength<126?U+=0:T.byteLength<2**16?U+=2:U+=8;const C=O.$Pe.alloc(U),z=A?64:0,re=M&15;if(C.writeUInt8(128|z|re,0),T.byteLength<126)C.writeUInt8(T.byteLength,1);else if(T.byteLength<2**16){C.writeUInt8(126,1);let Z=1;C.writeUInt8(T.byteLength>>>8&255,++Z),C.writeUInt8(T.byteLength>>>0&255,++Z)}else{C.writeUInt8(127,1);let Z=1;C.writeUInt8(0,++Z),C.writeUInt8(0,++Z),C.writeUInt8(0,++Z),C.writeUInt8(0,++Z),C.writeUInt8(T.byteLength>>>24&255,++Z),C.writeUInt8(T.byteLength>>>16&255,++Z),C.writeUInt8(T.byteLength>>>8&255,++Z),C.writeUInt8(T.byteLength>>>0&255,++Z)}this.socket.write(O.$Pe.concat([C,T]))}end(){this.h=!0,this.socket.end()}n(T){if(T.byteLength!==0){for(this.b.acceptChunk(T);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const A=this.b.peek(this.j.readLen),M=A.readUInt8(0),U=(M&128)>>>7,C=(M&64)>>>6,z=M&15,re=A.readUInt8(1),Z=(re&128)>>>7,le=re&127;this.j.state=m.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(Z?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!C),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const A=this.b.read(this.j.readLen),M=A.readUInt8(1),U=(M&128)>>>7;let C=M&127,z=1;C===126?C=A.readUInt8(++z)*2**8+A.readUInt8(++z):C===127&&(C=A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*2**24+A.readUInt8(++z)*2**16+A.readUInt8(++z)*2**8+A.readUInt8(++z));let re=0;U&&(re=A.readUInt8(++z)*2**24+A.readUInt8(++z)*2**16+A.readUInt8(++z)*2**8+A.readUInt8(++z)),this.j.state=m.ReadBody,this.j.readLen=C,this.j.mask=re,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const A=this.b.read(this.j.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,A),i(A,this.j.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,A),this.j.state=m.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=E;class P extends a.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Pe.alloc(0)}constructor(T,A,M,U,C,z){super(),this.n=T,this.r=C,this.s=z,this.a=this.B(new v.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new t(this.n,U,M,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(re=>this.a.fire(re))),this.B(this.f.onError(re=>this.a.fire(re)))):(this.b=null,this.f=null)}writeMessage(T,A){this.g.push({data:T,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:T,options:A}=this.g.shift();if(this.f&&A.compressed){const M=await this.w(this.f,T);this.s(M,A)}else this.s(T,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(T,A){return new Promise((M,U)=>{T.write(A),T.flush(C=>M(C))})}acceptFrame(T,A,M){this.h.push({data:T,isCompressed:A,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const T=this.h.shift();if(this.b&&T.isCompressed){const A=await this.C(this.b,T.data,T.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(T.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(T,A,M){return new Promise((U,C)=>{T.write(A),M&&T.write(O.$Pe.fromByteArray([0,0,255,255])),T.flush(z=>U(z))})}}class t extends a.$Xc{get recordedInflateBytes(){return this.j?O.$Pe.concat(this.f):O.$Pe.alloc(0)}constructor(T,A,M,U){super(),this.h=T,this.j=A,this.a=this.B(new v.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(U),this.b.on("error",C=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,C),this.g.push(O.$Pe.wrap(C))}),M&&(this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(T){this.j&&this.f.push(T.clone()),this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,T),this.b.write(T.buffer)}flush(T){this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const A=O.$Pe.concat(this.g);this.g.length=0,T(A)})}}class r extends a.$Xc{constructor(T,A){super(),this.g=T,this.a=this.B(new v.$ne),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(O.$Pe.wrap(M))})}write(T){this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,T.buffer),this.b.write(T.buffer)}flush(T){this.b.flush(2,()=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let A=O.$Pe.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),T(A)})}}function i(L,T){if(T===0)return;const A=L.byteLength>>>2;for(let Z=0;Z<A;Z++){const le=L.readUInt32BE(Z*4);L.writeUInt32BE(le^T,Z*4)}const M=A*4,U=L.byteLength-M,C=T>>>24&255,z=T>>>16&255,re=T>>>8&255;U>=1&&L.writeUInt8(L.readUInt8(M)^C,M),U>=2&&L.writeUInt8(L.readUInt8(M+1)^z,M+1),U>=3&&L.writeUInt8(L.readUInt8(M+2)^re,M+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const c={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function s(){const L=(0,g.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const T=process.platform!=="darwin"&&e.$xi?e.$xi:(0,k.tmpdir)(),A=(0,f.$mc)(T,`vscode-ipc-${L}.sock`);return u(A),A}function l(L,T,A){const U=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${A}-${T}-sock`;const C=A.substr(0,4),z=T.substr(0,6);let re;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?re=(0,f.$mc)(e.$xi,`vscode-${U}-${C}-${z}.sock`):re=(0,f.$mc)(L,`${C}-${z}.sock`),u(re),re}function u(L){const T=c[d.$u];typeof T=="number"&&L.length>=T&&console.warn(`WARNING: IPC handle "${L}" is longer than ${T} chars, try a shorter --user-data-dir`)}class S extends w.$ki{static b(T){const A=v.Event.fromNodeEventEmitter(T,"connection");return v.Event.map(A,M=>({protocol:new h.$ri(new b(M,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(M,"close"))}))}constructor(T){super(S.b(T)),this.d=T}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=S;function y(L){return new Promise((T,A)=>{const M=(0,o.createServer)();M.on("error",A),M.listen(L,()=>{M.removeListener("error",A),T(new S(M))})})}function R(L,T){return new Promise((A,M)=>{const U=(0,o.createConnection)(L,()=>{U.removeListener("error",M),A(h.$si.fromSocket(new b(U,`ipc-client${T}`),T))});U.once("error",M)})}}),define(oe[24],ae([0,1,54,10,3,105,38,96,6]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0,e.$Pec=(0,v.$Hi)(O.$Ni);class a extends I.$9m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,o.$mc)(this.userDataPath,"clp")}get backupHome(){return(0,o.$mc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$zi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,o.$mc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const g=d.slice(0,-17);if(this.d[g])continue;process.env[g]&&(this.d[g]=process.env[g]),process.env[d]?process.env[g]=process.env[d]:delete process.env[g]}}}restoreSnapExportedVariables(){if(k.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$Qec=a,ke([n.$$h],a.prototype,"cachedLanguagesPath",null),ke([n.$$h],a.prototype,"backupHome",null),ke([n.$$h],a.prototype,"mainIPCHandle",null),ke([n.$$h],a.prototype,"mainLockfile",null),ke([n.$$h],a.prototype,"disableUpdates",null),ke([n.$$h],a.prototype,"crossOriginIsolated",null),ke([n.$$h],a.prototype,"codeCachePath",null),ke([n.$$h],a.prototype,"useCodeCache",null)}),define(oe[291],ae([0,1,92,31,12,10,3,19,21,203,18,24,34,15,5,202,30,104]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;let E=class{static{m=this}static{this.a="backupWorkspaces"}constructor(t,r,i,c){this.j=t,this.k=r,this.l=i,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$$g,this.i={isEqual:(s,l)=>(0,o.$Eg)(s,l,!O.$k)}}async initialize(){const t=this.m.getItem(m.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,a.$Sec)(t)),this.e=await this.v((0,a.$Tec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$zl.OFF}q(){return this.s()===w.$zl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$zl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,r){this.d.some(c=>t.workspace.id===c.workspace.id)||(this.d.push(t),this.C());const i=(0,D.$mc)(this.c,t.workspace.id);return r?this.t(i,r).then(()=>i):i}async t(t,r){if(await v.Promises.exists(t)&&await this.z(t),await v.Promises.exists(r))try{await v.Promises.rename(r,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(r=>this.h.isEqual(t.folderUri,r.folderUri))||(this.e.push(t),this.C()),(0,D.$mc)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$mc)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const r=new Set,i=[];for(const c of t){const s=c.workspace;if(!(0,b.$Vi)(s))return[];if(!r.has(s.id)){r.add(s.id);const l=(0,D.$mc)(this.c,s.id);await this.B(l)?s.configPath.scheme!==k.Schemas.file||await v.Promises.exists(s.configPath.fsPath)?i.push(c):await this.z(l):await this.x(l)}}return i}async v(t){if(!Array.isArray(t))return[];const r=[],i=new Set;for(const c of t){const s=c.folderUri,l=this.h.getComparisonKey(s);if(!i.has(l)){i.add(l);const u=(0,D.$mc)(this.c,this.D(c));await this.B(u)?s.scheme!==k.Schemas.file||await v.Promises.exists(s.fsPath)?r.push(c):await this.z(u):await this.x(u)}}return r}async w(t){if(!Array.isArray(t))return[];const r=[],i=new Set;for(const c of t){const s=c.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const l=(0,D.$mc)(this.c,s);await this.B(l)?r.push(c):await this.x(l)}}return r}async x(t){try{await v.Promises.rm(t,v.RimRafMode.MOVE)}catch(r){this.l.error(`Backup: Could not delete stale backup: ${r.toString()}`)}}y(){let t=(0,$.$_ec)();for(;this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.id));)t=(0,$.$_ec)();return{backupFolder:t.id}}async z(t){const r=this.y(),i=(0,D.$mc)(this.c,r.backupFolder);try{await v.Promises.rename(t,i,!1)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(r),!0}async getDirtyWorkspaces(){const t=[];for(const r of this.d)await this.A(r)&&t.push(r);for(const r of this.e)await this.A(r)&&t.push(r);return t}A(t){let r;return(0,a.$Rec)(t)?r=(0,D.$mc)(this.c,t.backupFolder):(0,p.$Whb)(t)?r=(0,D.$mc)(this.c,this.D(t)):r=(0,D.$mc)(this.c,t.workspace.id),this.B(r)}async B(t){try{const r=await v.Promises.readdir(t);for(const i of r)try{if((await v.Promises.readdir((0,D.$mc)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:r,remoteAuthority:i})=>{const c={id:r.id,configURIPath:r.configPath.toString()};return i&&(c.remoteAuthority=i),c}),folders:this.e.map(({folderUri:r,remoteAuthority:i})=>{const c={folderUri:r.toString()};return i&&(c.remoteAuthority=i),c}),emptyWindows:this.g.map(({backupFolder:r,remoteAuthority:i})=>{const c={backupFolder:r};return i&&(c.remoteAuthority=i),c})};this.m.setItem(m.a,t)}D(t){const r=t.folderUri;let i;return r.scheme===k.Schemas.file?i=O.$k?r.fsPath:r.fsPath.toLowerCase():i=r.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$sfc=E,e.$sfc=E=m=ke([ne(0,d.$Pec),ne(1,f.$aj),ne(2,h.$ak),ne(3,g.$gR)],E)}),define(oe[20],ae([0,1,14,35,8,4,2,3,37,13,6,5,34,52,24]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.LifecycleMainPhase=e.ShutdownReason=e.$hfc=void 0,e.$hfc=(0,f.$Gi)("lifecycleMainService");var b;(function(E){E[E.QUIT=1]="QUIT",E[E.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var $;(function(E){E[E.Starting=1]="Starting",E[E.Ready=2]="Ready",E[E.AfterWindowOpen=3]="AfterWindowOpen",E[E.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let m=class extends O.$Xc{static{p=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(P,t,r){super(),this.F=P,this.G=t,this.H=r,this.c=this.B(new D.$ne),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$ne),this.onWillShutdown=this.f.event,this.g=this.B(new D.$ne),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$ne),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=$.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when($.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(p.b),this.m&&this.G.removeItem(p.b)}J(){const P=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$j&&this.t===0&&this.L(b.QUIT))};n.app.addListener("before-quit",P);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$j)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",r=>{this.S("Lifecycle#app.on(will-quit) - begin"),r.preventDefault(),this.L(b.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",P),n.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(P){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const r=[];return this.f.fire({reason:P,join(i,c){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),r.push(c.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(r)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===P)return;this.S(`lifecycle (main): phase changed (value: ${P})`),this.n=P;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(P){if(P<=this.n)return;let t=this.C.get(P);t||(t=new k.$Fh,this.C.set(P,t)),await t.wait()}registerWindow(P){const t=new O.$Wc;this.t++,t.add(P.onWillLoad(i=>this.g.fire({window:P,workspace:i.workspace,reason:i.reason})));const r=(0,a.$rg)(P.win);t.add(D.Event.fromNodeEventEmitter(r,"close")(i=>{const c=P.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${P.id}`),i.preventDefault(),this.unload(P,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(P),P.close()})})),t.add(D.Event.fromNodeEventEmitter(r,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.t--,t.dispose(),this.t===0&&(!I.$j||this.j)&&this.L(b.QUIT)}))}registerAuxWindow(P){const t=(0,a.$rg)(P.win),r=new O.$Wc;r.add(D.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${P.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),r.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${P.id}`),r.dispose()}))}async reload(P,t){await this.unload(P,w.UnloadReason.RELOAD)||P.reload(t)}unload(P,t){const r=this.z.get(P.id);if(r)return r;const i=this.M(P,t).finally(()=>{this.z.delete(P.id)});return this.z.set(P.id,i),i}async M(P,t){if(!P.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${P.id}`);const r=this.j?w.UnloadReason.QUIT:t,i=await this.P(P,r);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.N(i)):(await this.Q(P,r),!1)}N(P){return P?(this.O(!0),this.j=!1,!0):!1}O(P){this.w&&(this.w(P),this.w=void 0,this.u=void 0)}P(P,t){return new Promise(r=>{const i=this.s++,c=`vscode:ok${i}`,s=`vscode:cancel${i}`;o.$FX.once(c,()=>{r(!1)}),o.$FX.once(s,()=>{r(!0)}),P.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:t})})}Q(P,t){return new Promise(r=>{const c=`vscode:reply${this.s++}`;o.$FX.once(c,()=>r()),P.send("vscode:onWillUnload",{replyChannel:c,reason:t})})}quit(P){return this.R(P).then(t=>{if(!t&&P)try{if(I.$i){const r=(0,v.cwd)();r!==process.cwd()&&process.chdir(r)}}catch(r){this.F.error(r)}return t})}R(P){return this.S(`Lifecycle#quit() - begin (willRestart: ${P})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(P&&this.G.setItem(p.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(P){this.H.args["enable-smoke-test-driver"]?this.F.info(P):this.F.trace(P)}setRelaunchHandler(P){this.D=P}async relaunch(P){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(P?.addArgs&&t.push(...P.addArgs),P?.removeArgs)for(const c of P.removeArgs){const s=t.indexOf(c);s>=0&&t.splice(s,1)}const r=()=>{this.D?.handleRelaunch(P)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",r),await this.quit(!0)&&n.app.removeListener("quit",r)}async kill(P){this.S("Lifecycle#kill()"),await this.L(b.KILL),await Promise.race([(0,k.$Hh)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let r;t.webContents&&!t.webContents.isDestroyed()?r=new Promise(i=>t.once("closed",i)):r=Promise.resolve(),t.destroy(),await r}})()]),n.app.exit(P)}};e.$ifc=m,e.$ifc=m=p=ke([ne(0,d.$ak),ne(1,g.$gR),ne(2,h.$Pec)],m)}),define(oe[292],ae([0,1,3,4,2,6,20]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=void 0,n=De(n),e.$Qfc=(0,D.$Gi)("keyboardLayoutMainService");let I=class extends k.$Xc{constructor(f){super(),this.a=this.B(new o.$ne),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,f.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const f=await new Promise((d,g)=>{x(["native-keymap"],d,g)}).then(De);this.c=v(f),n.$t||f.onDidChangeKeyboardLayout(()=>{this.c=v(f),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Rfc=I,e.$Rfc=I=ke([ne(0,O.$hfc)],I);function v(a){const f=a.getKeyMap(),d=a.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:d}}}),define(oe[293],ae([0,1,253,8,17,16,13,18,38,101,5,57,252,290]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$es=b;let h=class extends d.$7p{constructor(m,E,P,t){super(t),this.m=m,this.n=E,this.r=P,this.s(),this.B(m.onDidChangeConfiguration(r=>{r.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,E){const{f:P,g:t}=this;let r;try{r=await(0,a.$Rm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$ab)(s)))}const i={...process.env,...r},c=m.agent?m.agent:await(0,g.$cs)(m.url||"",i,{proxyUrl:P,strictSSL:t});return m.agent=c,m.strictSSL=t,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>b(m,E))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((E,P)=>{x(["@vscode/proxy-agent"],E,P)}).then(De)).loadSystemCertificates({log:this.r})}};e.$ds=h,e.$ds=h=ke([ne(0,I.$aj),ne(1,v.$Oi),ne(2,f.$ak),ne(3,f.$bk)],h);async function p($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((P,t)=>{x(["https"],P,t)}).then(De):await new Promise((P,t)=>{x(["http"],P,t)}).then(De)).request}async function b($,m){return o.Promises.withAsyncBody(async(E,P)=>{const t=(0,n.parse)($.url),r=$.getRawRequest?$.getRawRequest($):await p($),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,O.$mg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(i.auth=$.user+":"+$.password);const c=r(i,s=>{const l=(0,O.$kg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&l>0&&s.headers.location)b({...$,url:s.headers.location,followRedirects:l-1},m).then(E,P);else{let u=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(u=s.pipe((0,w.createGunzip)())),E({res:s,stream:(0,k.$5e)(u)})}});c.on("error",P),$.timeout&&c.setTimeout($.timeout),$.isChromiumNetwork&&c.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&c.write($.data),c.end(),m.onCancellationRequested(()=>{c.abort(),P(new D.$8)})})}}),define(oe[294],ae([0,1,14,293]),function(x,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;function k(O){return n.net.request}class D extends o.$ds{request(I,v){return super.request({...I||{},getRawRequest:k,isChromiumNetwork:!0},v)}}e.$Vgc=D}),define(oe[88],ae([0,1,7,4,2,38,15,6,20,5,63,287,42,59,41,12]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=e.$ofc=e.$nfc=void 0,e.$nfc=(0,I.$Gi)("storageMainService");let b=class extends k.$Xc{constructor(E,P,t,r,i,c){super(),this.c=E,this.f=P,this.g=t,this.h=r,this.j=i,this.m=c,this.a=void 0,this.b=this.B(new o.$ne),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(v.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.t)E.join("profileStorage",P.close());for(const[,P]of this.w)E.join("workspaceStorage",P.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const P=this.t.get(E.profile.id);P&&E.join(P.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new d.$kfc(this.n(),this.g,this.c,this.j);return this.B(o.Event.once(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,f.$jq)(E))return this.applicationStorage;let P=this.t.get(E.id);if(!P){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),P=this.B(this.u(E)),this.t.set(E.id,P);const t=this.B(P.onDidChangeStorage(r=>this.b.fire({...r,storage:P,profile:E})));this.B(o.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return P}u(E){return this.a===v.ShutdownReason.KILL?new d.$mfc(this.c,this.j):new d.$jfc(E,this.n(),this.c,this.j)}workspaceStorage(E){let P=this.w.get(E.id);return P||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),P=this.B(this.y(E)),this.w.set(E.id,P),this.B(o.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),P}y(E){return this.a===v.ShutdownReason.KILL?new d.$mfc(this.c,this.j):new d.$lfc(E,this.n(),this.c,this.f,this.j)}isUsed(E){const P=n.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),P))return!0;return!1}};e.$ofc=b,e.$ofc=b=ke([ne(0,a.$ak),ne(1,D.$Ni),ne(2,w.$4ec),ne(3,v.$hfc),ne(4,O.$al),ne(5,h.$Kl)],b),e.$pfc=(0,I.$Gi)("applicationStorageMainService");let $=class extends f.$iq{constructor(E,P){super(),this.s=E,this.U=P,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===f.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(E){if(E===f.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$qfc=$,e.$qfc=$=ke([ne(0,g.$Ml),ne(1,e.$nfc)],$)}),define(oe[295],ae([0,1,93,27,112,105,8,2,3,18,5,28,246,249,102,132,17]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,n=De(n),o=De(o);async function $(r,i,c,s,l){let u;for(let S=3;S&&(u?.dispose(),u=await new m(r,i,c,s,l).waitForReady(),!(l&&k.$6g[l]||!k.$6g[u.tunnelLocalPort]));S--);return u}class m extends I.$Xc{constructor(i,c,s,l,u){super(),this.m=c,this.n=u,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new O.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,c=(0,p.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,k.$7g)(i,2,1e3,c),l=null;return this.b.listen(s,this.m),await this.c.wait(),l=this.b.address(),l||(s=0,this.b.listen(s,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(i){i.pause();const c=(0,p.$Hw)(this.tunnelRemoteHost)||(0,p.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$3l)(this.a,c,this.tunnelRemotePort),l=s.getSocket(),u=s.readEntireBuffer();s.dispose(),u.byteLength>0&&i.write(u.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),l.end()}),i.on("close",()=>l.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),l instanceof D.$vi?l.socket.destroy():l.end()}),l instanceof D.$vi?this.t(i,l):this.s(i,l),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),l.end()})}s(i,c){c.onClose(()=>i.destroy()),c.onEnd(()=>i.end()),c.onData(s=>i.write(s.buffer)),i.on("data",s=>c.write(b.$Pe.wrap(s))),i.resume()}t(i,c){const s=c.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$Rgc=m;let E=class extends p.$Mw{constructor(i,c,s,l,u){super(c,u),this.H=i,this.I=s,this.J=l}isPortPrivileged(i){return(0,p.$Kw)(i,this.t,v.OS,o.release())}F(i,c,s,l,u,S,y,R){const L=this.D(c,s);if(L)return++L.refcount,L.value;if((0,p.$Dw)(i))return this.G(i,c,s,u,S,y,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${s} on local port ${u}.`);const T={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},A=$(T,l,c,s,u);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(c,s,A),A}}};e.$Sgc=E,e.$Sgc=E=ke([ne(0,w.$Wl),ne(1,f.$ak),ne(2,h.$Zl),ne(3,d.$tk),ne(4,a.$aj)],E);let P=class extends E{constructor(i,c,s,l,u){super(i,c,s,l,u)}};e.$Tgc=P,e.$Tgc=P=ke([ne(0,w.$Wl),ne(1,f.$ak),ne(2,h.$Zl),ne(3,d.$tk),ne(4,a.$aj)],P);let t=class extends I.$Xc{constructor(i,c,s,l,u){super(),this.b=i,this.c=c,this.f=s,this.g=l,this.h=u,this.a=new Map}async openTunnel(i,c,s,l,u,S,y,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${l} on local port ${S}.`),!this.a.has(i)){const T=new P(this.b,this.c,this.g,this.f,this.h);this.B(T),this.a.set(i,T),T.onTunnelClosed(async()=>{(await T.tunnels).length===0&&(T.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(c,s,l,u,S,y,R,L)}};e.$Ugc=t,e.$Ugc=t=ke([ne(0,w.$Wl),ne(1,f.$ak),ne(2,d.$tk),ne(3,h.$Zl),ne(4,a.$aj)],t)}),define(oe[106],ae([0,1,8,23,4,18,24,20,5,28,57,50]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0,e.$bgc=g;function g(h,p,b){return`${b.updateUrl}/api/update/${h}/${p}/${b.commit}`}let w=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,b,$,m,E,P){this.f=p,this.g=b,this.h=$,this.i=m,this.j=E,this.k=P,this.b=d.$DY.Uninitialized,this.c=new k.$ne,this.onStateChange=this.c.event,p.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$DY.Disabled(d.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(d.$DY.Disabled(d.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$DY.Disabled(d.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),b=this.m(p);if(!b){this.d(d.$DY.Disabled(d.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.d(d.$DY.Disabled(d.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(d.$DY.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,n.$Hh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},o.CancellationToken.None)).res.statusCode===204}catch(b){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(b);return}}async _applySpecificUpdate(p){}q(){return d.UpdateType.Archive}r(){}};e.$cgc=w,e.$cgc=w=ke([ne(0,I.$hfc),ne(1,D.$aj),ne(2,O.$Pec),ne(3,f.$6p),ne(4,v.$ak),ne(5,a.$tk)],w)}),define(oe[296],ae([0,1,14,54,4,46,2,18,24,20,5,28,57,25,50,106]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0,n=De(n);let b=class extends p.$cgc{get v(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"error",(m,E)=>E)}get w(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(m,E,P,t)=>({version:P,productVersion:P,timestamp:t}))}constructor(m,E,P,t,r,i,c){super(m,E,t,r,i,c),this.z=P,this.u=new O.$Wc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!==h.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.z.publicLog2("update:error",{messageHash:String((0,D.$uj)(String(m)))}),this.j.error("UpdateService error:",m);const E=this.state.type===h.StateType.CheckingForUpdates&&this.state.explicit?m:void 0;this.d(h.$DY.Idle(h.UpdateType.Archive,E))}s(m){let E;this.k.darwinUniversalAssetId?E=this.k.darwinUniversalAssetId:E=process.arch==="x64"?"darwin":"darwin-arm64";const P=(0,p.$bgc)(E,m,this.k);try{n.autoUpdater.setFeedURL({url:P})}catch(t){this.j.error("Failed to set update feed URL",t);return}return P}t(m){this.d(h.$DY.CheckingForUpdates(m)),n.autoUpdater.checkForUpdates()}E(){this.state.type===h.StateType.CheckingForUpdates&&this.d(h.$DY.Downloading)}F(m){this.state.type===h.StateType.Downloading&&(this.d(h.$DY.Downloaded(m)),this.z.publicLog2("update:downloaded",{version:m.version}),this.d(h.$DY.Ready(m)))}G(){this.state.type===h.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$DY.Idle(h.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$dgc=b,ke([o.$$h],b.prototype,"v",null),ke([o.$$h],b.prototype,"w",null),ke([o.$$h],b.prototype,"x",null),ke([o.$$h],b.prototype,"y",null),e.$dgc=b=ke([ne(0,a.$hfc),ne(1,I.$aj),ne(2,w.$_l),ne(3,v.$Pec),ne(4,g.$6p),ne(5,f.$ak),ne(6,d.$tk)],b)}),define(oe[297],ae([0,1,49,47,8,4,10,24,20,5,25,50]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0,O=De(O);let g=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,b,$){if(this.f=p,this.g=$,this.a=d.$DY.Uninitialized,this.b=new D.$ne,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$DY.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(p=60*60*1e3){return(0,k.$Hh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return d.UpdateType.Snap}l(){}async _applySpecificUpdate(p){}};g=ke([ne(0,v.$hfc),ne(1,I.$Pec),ne(2,a.$ak)],g);let w=class extends g{constructor(p,b,$,m,E,P){super($,m,E),this.o=p,this.p=b,this.q=P;const t=(0,o.watch)(O.$pc(this.o)),r=D.Event.fromNodeEventEmitter(t,"change",(l,u)=>u),i=D.Event.filter(r,l=>l==="current"),s=D.Event.debounce(i,(l,u)=>u,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(d.$DY.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(d.$DY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$DY.Idle(d.UpdateType.Snap)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$DY.Idle(d.UpdateType.Snap,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+O.$qc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise(($,m)=>(0,o.realpath)(`${O.$pc(this.o)}/current`,(E,P)=>E?m(E):$(P))),b=O.$qc(p);return this.p!==b}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$fgc=w,e.$fgc=w=ke([ne(2,v.$hfc),ne(3,I.$Pec),ne(4,a.$ak),ne(5,f.$_l)],w)}),define(oe[29],ae([0,1,14,3,6,52,51,77,28,18,24,10,140]),function(x,e,n,o,k,D,O,I,v,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$1ec=void 0,e.$2ec=h,e.$3ec=p,e.$1ec=(0,k.$Gi)("windowsMainService");var w;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(w||(e.OpenContext=w={}));function h($,m,E){const P=$.get(I.$Yec),t=$.get(v.$tk),r=$.get(a.$aj),i=$.get(f.$Pec),c=r.getValue("window"),s={backgroundColor:P.getBackgroundColor(),minWidth:O.$XD.WIDTH,minHeight:O.$XD.HEIGHT,title:t.nameLong,show:m.mode!==D.WindowMode.Maximized&&m.mode!==D.WindowMode.Fullscreen,x:m.x,y:m.y,width:m.width,height:m.height,webPreferences:{...E,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,O.$0D)(m.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(o.$k?s.icon=(0,d.$mc)(i.appRoot,"resources/linux/code.png"):o.$i&&!i.isBuilt&&(s.icon=(0,d.$mc)(i.appRoot,"resources/win32/code_150x150.png")),o.$j&&(s.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),o.$j&&!(0,O.$9D)(r)&&(s.fullscreenable=!1),o.$j&&c?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,O.$5D)(r)&&(s.titleBarStyle="hidden",o.$j||(s.frame=!1),(0,O.$8D)(r))){const S=P.getWindowSplash()?.colorInfo.titleBarBackground??P.getBackgroundColor(),y=g.$lu.fromHex(S).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:S,symbolColor:y}}return s}function p($){let m,E=Number.MIN_VALUE;for(const P of $)P.lastFocusTime>E&&(E=P.lastFocusTime,m=P);return m}var b;(function($){function m(P,t,r=n.screen.getAllDisplays()){if(P.trace(`window#validateWindowState: validating window state on ${r.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){P.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){P.trace("window#validateWindowState: unexpected negative values");return}if(r.length===1){const s=E(r[0]);if(P.trace("window#validateWindowState: single monitor working area",s),s){let l=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};l(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),l()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=r.find(l=>l.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){P.trace("window#validateWindowState: restoring fullscreen to previous display");const l=(0,D.$Nec)(D.WindowMode.Fullscreen);return l.x=s.bounds.x,l.y=s.bounds.y,l}}let i,c;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),c=E(i),P.trace("window#validateWindowState: multi-monitor working area",c)}catch(s){P.error("window#validateWindowState: error finding display for window state",s)}if(i&&c&&t.x+t.width>c.x&&t.y+t.height>c.y&&t.x<c.x+c.width&&t.y<c.y+c.height)return t;P.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=m;function E(P){if(P.workArea.width>0&&P.workArea.height>0)return P.workArea;if(P.bounds.width>0&&P.bounds.height>0)return P.bounds}})(b||(e.WindowStateValidator=b={}))}),define(oe[298],ae([0,1,14,23,4,46,2,33,98,5,63,88,29]),function(x,e,n,o,k,D,O,I,v,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;var w;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let h=class extends O.$Xc{constructor(b,$,m,E){super(),this.g=b,this.h=$,this.j=m,this.m=E,this.a="proxy-credentials://",this.b=void 0,this.c=w.Initial,this.f=void 0,this.n()}n(){const b=k.Event.fromNodeEventEmitter(n.app,"login",($,m,E,P,t)=>({event:$,webContents:m,req:E,authInfo:P,callback:t}));this.B(b(this.r,this))}async r({event:b,authInfo:$,req:m,callback:E}){if(!$.isProxy)return;if(!this.b&&this.c===w.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let P;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),P=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{P=await this.b}finally{this.b=void 0}}E(P?.username,P?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(b);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const $=String((0,D.$uj)({scheme:b.scheme,host:b.host,port:b.port}));let m,E;try{const i=this.m.get(this.a+$,f.StorageScope.APPLICATION);if(i){const c=JSON.parse(await this.j.decrypt(i));m=c.username,E=c.password}}catch(i){this.g.error(i)}if(this.c!==w.StoredCredentialsUsed&&typeof m=="string"&&typeof E=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=w.StoredCredentialsUsed,{username:m,password:E};const P=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!P){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${P.id} to handle proxy login`);const t={authInfo:b,username:this.f?.username??m,password:this.f?.password??E,replyChannel:`vscode:proxyAuthResponse:${(0,I.$3g)()}`};P.sendWhenReady("vscode:openProxyAuthenticationDialog",o.CancellationToken.None,t),this.c=w.LoginDialogShown;const r=await new Promise(i=>{const c=async(s,l,u)=>{if(l===t.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${P.id}`),P.win?.webContents.off("ipc-message",c),u){const S={username:u.username,password:u.password};try{if(u.remember){const y=await this.j.encrypt(JSON.stringify(S));this.m.store(this.a+$,y,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.m.remove(this.a+$,f.StorageScope.APPLICATION)}catch(y){this.g.error(y)}i({username:S.username,password:S.password})}else i(void 0)};P.win?.webContents.on("ipc-message",c)});return this.f=r,r}};e.$rfc=h,e.$rfc=h=ke([ne(0,a.$ak),ne(1,g.$1ec),ne(2,v.$oY),ne(3,d.$pfc)],h)}),define(oe[299],ae([0,1,93,205,121,29]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class O extends o.$Xo{constructor(v){super(),this.f=v}call(v,a,f){return a==="openExtensionDevelopmentHostWindow"?this.g(f[0],f[1]):super.call(v,a,f)}async g(v,a){const f=(0,k.$Dm)(v,k.$Cm);f.debugRenderer=a;const d=f.extensionDevelopmentPath;if(!d)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow(d,{context:D.OpenContext.API,cli:f,forceProfile:f.profile,forceTempProfile:f["profile-temp"]});if(!a)return{success:!0};const w=g.win;if(!w)return{success:!0};const h=w.webContents.debugger;let p=h.isAttached()?1/0:0;const b=(0,n.createServer)($=>{p++===0&&h.attach();let m=!1;const E=r=>{m||$.write(JSON.stringify(r)+"\0")},P=(r,i,c,s)=>E({method:i,params:c,sessionId:s});w.on("close",()=>{h.removeListener("message",P),$.end(),m=!0}),h.addListener("message",P);let t=Buffer.alloc(0);$.on("data",r=>{t=Buffer.concat([t,r]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let c;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),c=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(c.method,c.params,c.sessionId).then(s=>E({id:c.id,sessionId:c.sessionId,result:s})).catch(s=>E({id:c.id,sessionId:c.sessionId,error:{code:0,message:s.message}}))}}),$.on("error",r=>{console.error("error on cdp pipe:",r)}),$.on("close",()=>{m=!0,--p===0&&h.detach()})});return await new Promise($=>b.listen(0,$)),w.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$tfc=O}),define(oe[300],ae([0,1,14,22,3,7,21,18,69,6,5,133,29]),function(x,e,n,o,k,D,O,I,v,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=e.ID=void 0,e.ID="launchMainService",e.$Tfc=(0,a.$Gi)(e.ID);let w=class{constructor(p,b,$,m){this.a=p,this.b=b,this.c=$,this.d=m}async start(p,b){this.a.trace("Received data from other instance: ",p,b),k.$j&&n.app.focus({steal:!0});const $=this.e(p);if($.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const E=(0,o.$Rb)(await this.b.openEmptyWindow({context:g.OpenContext.DESKTOP}));E&&(m=E.ready())}m.then(()=>{for(const{uri:E,originalUrl:P}of $)this.c.open(E,{originalUrl:P})})}else return this.f(p,b)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,o.$Kb)(p._urls.map(b=>{try{return{uri:D.URI.parse(b),originalUrl:b}}catch{return null}})):[]}async f(p,b){const $=(0,v.$Km)(b)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let m=[];const E=p.wait&&p.waitMarkerFilePath?D.URI.file(p.waitMarkerFilePath):void 0,P=p.remote||void 0,t={context:$,cli:p,userEnv:p["preserve-env"]||$===g.OpenContext.CLI?b:void 0,waitMarkerFileURI:E,remoteAuthority:P,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,t);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let r=!1;if(p["new-window"]||t.forceProfile||t.forceTempProfile)r=!0;else if(p["reuse-window"])r=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!k.$j}if(r)m=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),m=[i]):m=await this.b.open({...t,forceEmpty:!0})}}else m=await this.b.open({...t,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(E&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,O.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Ufc=w,e.$Ufc=w=ke([ne(0,f.$ak),ne(1,g.$1ec),ne(2,d.$uY),ne(3,I.$aj)],w)}),define(oe[301],ae([0,1,2,20,52,59,30,8,29]),function(x,e,n,o,k,D,O,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let a=class extends n.$Xc{constructor(d,g,w){super(),this.a=g,this.b=w,this.B(d.onWillLoadWindow(h=>{h.reason===k.LoadReason.LOAD&&this.c(h.window)})),this.B(d.onBeforeCloseWindow(h=>this.c(h))),this.B(new I.$Sh(()=>this.g(),30*1e3)).schedule()}async c(d){const g=this.f(d),w=this.a.getProfileForWorkspace(g);w?.isTransient&&(this.a.unsetWorkspace(g,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,O.$Ui)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const g=this.b.getWindows().map(w=>this.f(w));for(const w of d)g.some(h=>h.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$xgc=a,e.$xgc=a=ke([ne(0,o.$hfc),ne(1,D.$4ec),ne(2,v.$1ec)],a)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[64],ae([0,1,14,2,4,5,321,8,12,29,81,25,20,82,36,3,107]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0,f=et(f);function m(t){return typeof t.responseWindowId=="number"}let E=class extends o.$Xc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(r,i,c){super(),this.w=r,this.y=i,this.z=c,this.c=String(++$.a),this.f=this.B(new k.$ne),this.onStdout=this.f.event,this.g=this.B(new k.$ne),this.onStderr=this.g.event,this.h=this.B(new k.$ne),this.onMessage=this.h.event,this.j=this.B(new k.$ne),this.onSpawn=this.j.event,this.m=this.B(new k.$ne),this.onExit=this.m.event,this.n=this.B(new k.$ne),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(r,i){let c;switch(this.t?.correlationId?c=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`:c=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`,i){case f.default.Error:this.w.error(c);break;case f.default.Warning:this.w.warn(c);break;case f.default.Info:this.w.trace(c);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",f.default.Error),!1):!0}start(r){const i=this.F(r);return i&&r.payload&&this.postMessage(r.payload)&&this.C("payload sent via postMessage()",f.default.Info),i}F(r){if(!this.D())return!1;this.t=r;const i=`${this.t.type}-${this.c}`,c=v.$1g.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],l=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,S=this.t.forceAllocationsToV8Sandbox,y="pipe",R=this.G(r);return this.C("creating new...",f.default.Info),this.r=n.utilityProcess.fork(c,s,{serviceName:i,env:R,execArgv:l,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:S,stdio:y}),this.H(this.r,this.t,i),!0}G(r){const i=r.env?{...r.env}:{...(0,h.$eo)(process.env)};i.VSCODE_AMD_ENTRYPOINT=r.entryPoint,typeof r.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(r.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=r.type,p.$i&&((0,b.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,b.getUNCHostAllowlist)().join("\\")),(0,w.$mm)(i);for(const c of Object.keys(i))i[c]=String(i[c]);return i}H(r,i,c){if(r.stdout){const s=new O.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(r.stdout,"data")(l=>this.f.fire(typeof l=="string"?l:s.write(l))))}if(r.stderr){const s=new O.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(r.stderr,"data")(l=>this.g.fire(typeof l=="string"?l:s.write(l))))}this.B(k.Event.fromNodeEventEmitter(r,"message")(s=>this.h.fire(s))),this.B(k.Event.fromNodeEventEmitter(r,"spawn")(()=>{this.s=r.pid,typeof r.pid=="number"&&$.b.set(r.pid,{pid:r.pid,name:m(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",f.default.Info),this.j.fire(r.pid)})),this.B(k.Event.fromNodeEventEmitter(r,"exit")(s=>{const l=this.I(s)?0:s;this.C(`received exit event with code ${l}`,f.default.Info),this.m.fire({pid:this.s,code:l,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,l)=>({event:s,details:l}))(({details:s})=>{s.type==="Utility"&&s.name===c&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,f.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(r,i){const c=this.B(this.h.event(s=>{s===r&&(c.dispose(),i())}))}postMessage(r,i){return this.r?(this.r.postMessage(r,i),!0):!1}connect(r){const{port1:i,port2:c}=new n.MessageChannelMain;return this.postMessage(r,[c]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",f.default.Info);const r=process;return typeof r._debugProcess=="function"?(r._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",f.default.Info),this.r.kill()?(this.C("successfully killed the process",f.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",f.default.Warning)}I(r){return r===0?!0:this.u&&r===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(r){this.r&&(this.C("waiting to exit...",f.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,I.$Hh)(r)]),this.r&&(this.C(`did not exit within ${r}ms, will kill it now...`,f.default.Info),this.kill()))}};e.$ufc=E,e.$ufc=E=$=ke([ne(0,D.$ak),ne(1,d.$_l),ne(2,g.$hfc)],E);let P=class extends E{constructor(r,i,c,s){super(r,c,s),this.L=i}start(r){const i=this.L.getWindowById(r.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",f.default.Error),!0;if(!super.F(r))return!1;this.M(i.win,r);const s=this.connect(r.payload);return i.win.webContents.postMessage(r.responseChannel,r.responseNonce,[s]),!0}M(r,i){i.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,c=>c.window.win===r)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(r,"closed")(()=>this.kill())))}};e.$vfc=P,e.$vfc=P=ke([ne(0,D.$ak),ne(1,a.$1ec),ne(2,d.$_l),ne(3,g.$hfc)],P)}),define(oe[302],ae([0,1,8,16,4,2,20,5,25,64,29]),function(x,e,n,o,k,D,O,I,v,a,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;let g=class extends D.$Xc{static{d=this}static{this.a=0}constructor(h,p,b,$){super(),this.f=h,this.g=p,this.h=b,this.j=$,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(h){const p=this.b.get(h);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(h){return this.m(h).onStdout}onDynamicStderr(h){return this.m(h).onStderr}onDynamicMessage(h){return this.m(h).onMessage}onDynamicExit(h){return this.m(h).onExit}async createExtensionHost(){if(this.c)throw(0,o.$9)();const h=String(++d.a),p=new a.$vfc(this.f,this.h,this.j,this.g);this.b.set(h,p);const b=p.onExit(({pid:$,code:m,signal:E})=>{b.dispose(),this.f.info(`Extension host with pid ${$} exited with code: ${m}, signal: ${E}.`),setTimeout(()=>{p.dispose(),this.b.delete(h)}),setTimeout(()=>{try{process.kill($,0),this.f.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)});return{id:h}}async start(h,p){if(this.c)throw(0,o.$9)();const b=this.m(h);return b.start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:h}),{pid:await k.Event.toPromise(b.onSpawn)}}async enableInspectPort(h){if(this.c)throw(0,o.$9)();const p=this.b.get(h);return p?p.enableInspectPort():!1}async kill(h){if(this.c)throw(0,o.$9)();const p=this.b.get(h);p&&p.kill()}async _killAllNow(){for(const[,h]of this.b)h.kill()}async _waitForAllExit(h){const p=[];for(const[,b]of this.b)p.push(b.waitForExit(h));return n.Promises.settled(p).then(()=>{})}};e.$Cfc=g,e.$Cfc=g=d=ke([ne(0,I.$ak),ne(1,O.$hfc),ne(2,f.$1ec),ne(3,v.$_l)],g)}),define(oe[303],ae([0,1,35,8,2,24,20,5,42,40,72,64,58,96,13,254,4]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;let $=class extends k.$Xc{constructor(E,P,t,r,i,c,s,l,u){super(),this.g=E,this.h=P,this.j=t,this.m=r,this.n=i,this.r=c,this.s=s,this.t=l,this.u=u,this.a=new o.$Fh,this.b=void 0,this.c=void 0,this.f=this.B(new b.$ne),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$FX.on(p.$6fc.request,(E,P)=>this.y(E,P,p.$6fc.response)),n.$FX.on(p.$7fc.request,(E,P)=>this.y(E,P,p.$7fc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(E,P,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect(t);if(E.sender.isDestroyed())return r.close();E.sender.postMessage(t,P,[r])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(p.$5fc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const E=new o.$4h;this.b?.once(p.$5fc.initDone,()=>E.complete()),await E.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const E=new o.$4h;this.b?.once(p.$5fc.ipcReady,()=>E.complete()),await E.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new d.$ufc(this.s,g.$xp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const E=(0,w.$$m)(this.m.args,this.m.isBuilt);let P;E.port&&(P=["--nolazy"],E.break?P.push(`--inspect-brk=${E.port}`):P.push(`--inspect=${E.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:P}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(E){return await this.F,(0,h.$rg)(this.b).connect(E)}};e.$8fc=$,e.$8fc=$=ke([ne(3,D.$Pec),ne(4,v.$Ml),ne(5,O.$hfc),ne(6,I.$ak),ne(7,f.$cfc),ne(8,a.$to)],$)}),define(oe[304],ae([0,1,24,96,20,5,58,76,64,119,35,2,4,36,18,12]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;let b=class extends d.$Xc{constructor(m,E,P,t,r){super(),this.f=m,this.g=E,this.h=P,this.j=t,this.m=r,this.a=void 0,this.b=new g.$ne,this.onRequestConnection=this.b.event,this.c=new g.$ne,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),f.$FX.on("vscode:createPtyHostMessageChannel",(i,c)=>this.r(i,c)),this.B((0,d.$Vc)(()=>{f.$FX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new v.$ufc(this.m,O.$xp,this.j);const m=(0,o.$0m)(this.h.args,this.h.isBuilt),E=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:E,args:["--logsPath",this.h.logsHome.with({scheme:p.Schemas.file}).fsPath],env:this.n()});const P=this.a.connect(),t=new a.$NX(P,"ptyHost"),r=new d.$Wc;return r.add(t),r.add((0,d.$Vc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:r,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,w.$eo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);E&&typeof E=="number"&&(m.VSCODE_LATENCY=String(E));const P=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return P&&typeof P=="number"&&(m.VSCODE_STARTUP_DELAY=String(P)),this.h.restoreSnapExportedVariables(),m}r(m,E){this.b.fire();const P=this.a.connect();if(m.sender.isDestroyed()){P.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",E,[P])}};e.$Jgc=b,e.$Jgc=b=ke([ne(1,h.$aj),ne(2,n.$Pec),ne(3,k.$hfc),ne(4,D.$ak)],b)}),define(oe[305],ae([0,1,2,6,5,29,64,25,46,4,8,20]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0,e.$Hgc=(0,o.$Gi)("utilityProcessWorker");let g=class extends n.$Xc{constructor(p,b,$,m){super(),this.b=p,this.c=b,this.f=$,this.g=m,this.a=new Map}async createWorker(p){const b=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${b})`);const $=this.h(p);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${b})`),this.disposeWorker(p));const m=new w(this.b,this.c,this.f,this.g,p);if(!m.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,m);const E=new f.$4h;return a.Event.once(m.onDidTerminate)(P=>{P.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.a.delete($),E.complete({reason:P})}),E.p}h(p){return(0,v.$uj)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const b=this.h(p),$=this.a.get(b);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),$.kill(),$.dispose(),this.a.delete(b))}};e.$Igc=g,e.$Igc=g=ke([ne(0,k.$ak),ne(1,D.$1ec),ne(2,I.$_l),ne(3,d.$hfc)],g);let w=class extends n.$Xc{constructor(p,b,$,m,E){super(),this.c=p,this.f=b,this.g=$,this.h=m,this.j=E,this.a=this.B(new a.$ne),this.onDidTerminate=this.a.event,this.b=this.B(new O.$vfc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const b=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:b,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=ke([ne(0,k.$ak),ne(1,D.$1ec),ne(2,I.$_l),ne(3,d.$hfc)],w)}),define(oe[306],ae([0,1,14,4,2,279,29]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let I=class extends k.$Xc{constructor(a){super(),this.b=a,this.a=this.B(new o.$ne),this.onFoundInFrame=this.a.event,this.B(new D.$mgc)}async setIgnoreMenuShortcuts(a,f){let d;if(typeof a.windowId=="number"){const{windowId:g}=a,w=this.b.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);d=w.win.webContents}else{const{webContentsId:g}=a;if(d=n.webContents.fromId(g),!d)throw new Error(`Invalid webContentsId: ${g}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts(f)}async findInFrame(a,f,d,g){const h=this.c(a,f);if(typeof h.findInFrame=="function"){h.findInFrame(d,{findNext:g.findNext,forward:g.forward});const p=(b,$)=>{$.finalUpdate&&(this.a.fire($),h.removeListener("found-in-frame",p))};h.on("found-in-frame",p)}}async stopFindInFrame(a,f,d){const w=this.c(a,f);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(a,f){const d=this.b.getWindowById(a.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${a}`);const g=d.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===f);if(!g)throw new Error(`Unknown frame: ${f}`);return g}};e.$ngc=I,e.$ngc=I=ke([ne(0,O.$1ec)],I)}),define(oe[307],ae([0,1,14,2,3,19,7,18,20,5,34,29,52,30]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0,e.$pgc=b,e.$qgc=m;let p=class extends o.$Xc{static{h=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,r,i,c,s){super(),this.g=t,this.h=r,this.j=i,this.m=c,this.n=s,this.b=b(this.h.getItem(h.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,r={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!r.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(l=>!l.isExtensionDevelopmentHost)),s&&(r.lastActiveWindow=this.w(s),r.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&t.add(r.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(r.lastPluginDevelopmentHostWindow=this.w(i),r.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(t.has(r.lastPluginDevelopmentHostWindow.uiState.display)?k.$j&&!i.win?.isSimpleFullScreen()&&(r.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):t.add(r.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(r.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const l=this.w(s);return l.uiState.mode===g.WindowMode.Fullscreen&&(t.has(l.uiState.display)?k.$j&&l.windowId!==r.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(l.uiState.mode=g.WindowMode.Normal):t.add(l.uiState.display)),l}));const c=m(r);this.h.setItem(h.a,c),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",c)}u(t){if(this.j.quitRequested)return;const r=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=r:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const c=(0,w.$Vi)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Qi)(t.openedWorkspace)&&i.folderUri&&D.$$g.isEqual(i.folderUri,t.openedWorkspace.uri);(c||s)&&(i.uiState=r.uiState)}),this.g.getWindowCount()===1&&(this.c=r)}w(t){return{windowId:t.id,workspace:(0,w.$Vi)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Qi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const r=this.z(t),i=this.n.getValue("window");if(r.mode===g.WindowMode.Fullscreen){let c;r.hasDefaultState?c=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):c=!!(this.j.wasRestarted||i?.restoreFullscreen),c||(r.mode=g.WindowMode.Normal)}return r}z(t){const r=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=t.workspace;if((0,w.$Vi)(S)){const R=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===S.id).map(L=>L.uiState);if(R.length)return R[0]}if((0,w.$Qi)(S)){const R=this.state.openedWindows.filter(L=>L.folderUri&&D.$$g.isEqual(L.folderUri,S.uri)).map(L=>L.uiState);if(R.length)return R[0]}else if(t.backupPath){const R=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(R.length)return R[0]}const y=this.c||this.state.lastActiveWindow;if(!r&&y)return y.uiState}let i;const c=n.screen.getAllDisplays();if(c.length===1)i=c[0];else{if(k.$j){const S=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(S)}!i&&r&&(i=n.screen.getDisplayMatching(r.getBounds())),i||(i=n.screen.getPrimaryDisplay()||c[0])}let s=(0,g.$Nec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const l=this.n.getValue("window");let u=!0;if(l?.newWindowDimensions){if(l.newWindowDimensions==="maximized")s.mode=g.WindowMode.Maximized,u=!1;else if(l.newWindowDimensions==="fullscreen")s.mode=g.WindowMode.Fullscreen,u=!1;else if((l.newWindowDimensions==="inherit"||l.newWindowDimensions==="offset")&&r){const S=r.serializeWindowState();S.mode===g.WindowMode.Fullscreen?s.mode=g.WindowMode.Fullscreen:s={...S,zoomLevel:void 0},u=s.mode!==g.WindowMode.Fullscreen&&l.newWindowDimensions==="offset"}}return u&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const r=this.g.getWindows().map(i=>i.getBounds());for(;r.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$ogc=p,e.$ogc=p=h=ke([ne(0,d.$1ec),ne(1,f.$gR),ne(2,v.$hfc),ne(3,a.$ak),ne(4,I.$aj)],p);function b(P){const t={openedWindows:[]},r=P||{openedWindows:[]};return r.lastActiveWindow&&(t.lastActiveWindow=$(r.lastActiveWindow)),r.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=$(r.lastPluginDevelopmentHostWindow)),Array.isArray(r.openedWindows)&&(t.openedWindows=r.openedWindows.map(i=>$(i))),t}function $(P){const t={uiState:P.uiState};return P.backupPath&&(t.backupPath=P.backupPath),P.remoteAuthority&&(t.remoteAuthority=P.remoteAuthority),P.folder&&(t.folderUri=O.URI.parse(P.folder)),P.workspaceIdentifier&&(t.workspace={id:P.workspaceIdentifier.id,configPath:O.URI.parse(P.workspaceIdentifier.configURIPath)}),t}function m(P){return{lastActiveWindow:P.lastActiveWindow&&E(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&E(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(t=>E(t))}}function E(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(oe[60],ae([0,1,14,4,43,2,12,10,19,21,201,70,53,24,6,5,59,135,30,103,104]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0,e.$afc=(0,h.$Gi)("workspacesManagementMainService");let t=class extends D.$Xc{constructor(i,c,s,l,u){super(),this.g=i,this.h=c,this.j=s,this.m=l,this.n=u,this.a=this.B(new o.$ne),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new o.$ne),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await a.Promises.readdir(this.c.with({scheme:O.Schemas.file}).fsPath)).map(c=>(0,v.$hh)(this.c,c,m.$6i));for(const c of i){const s=(0,P.$0ec)(c),l=await this.resolveLocalWorkspace(c);l?this.f.push({workspace:s,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.r(i,c=>a.Promises.readFile(c,"utf8"))}r(i,c){if(this.s(i)&&i.scheme===O.Schemas.file)try{const s=c(i.fsPath);return s instanceof Promise?s.then(l=>this.t(i,l),l=>{}):this.t(i,s)}catch{return}}s(i){return(0,m.$7i)(i,this.g)||(0,m.$_i)(i)}t(i,c){try{const s=this.u(i,c),l=(0,P.$0ec)(i);return{id:l.id,configPath:l.configPath,folders:(0,E.$5hb)(s.folders,l.configPath,v.$$g),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}u(i,c){const s=(0,k.$Yn)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(l=>(0,E.$3hb)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(i,c){const{workspace:s,storedWorkspace:l}=this.w(i,c),u=s.configPath.fsPath;return await a.Promises.mkdir((0,I.$pc)(u),{recursive:!0}),await a.Promises.writeFile(u,JSON.stringify(l,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}w(i=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,v.$hh)(this.c,s),u=(0,v.$hh)(l,m.$6i),S=[];for(const y of i)S.push((0,E.$4hb)(y.uri,!0,y.name,l,v.$$g));return{workspace:(0,P.$0ec)(u),storedWorkspace:{folders:S,remoteAuthority:c}}}async getWorkspaceIdentifier(i){return(0,P.$0ec)(i)}isUntitledWorkspace(i){return(0,m.$7i)(i.configPath,this.g)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.y(i),this.j.isEnabled()&&this.j.unsetWorkspace(i),this.a.fire(i))}async y(i){const c=(0,v.$8g)(i.configPath);try{await a.Promises.rm((0,I.$pc)(c));const s=(0,I.$mc)(this.g.workspaceStorageHome.with({scheme:O.Schemas.file}).fsPath,i.id);await a.Promises.exists(s)&&await a.Promises.writeFile((0,I.$mc)(s,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==i.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,c,s){if(!i||!i.win||!i.isReady||!await this.z(i,c,s))return;const u=await this.C(i,(0,P.$0ec)(s));if(u)return this.b.fire({window:i,workspace:u.workspace}),u}async z(i,c,s){return s?(0,m.$Vi)(i.openedWorkspace)&&v.$$g.isEqual(i.openedWorkspace.configPath,s)?!1:(0,$.$7ec)(c,s)?(await this.n.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,v.$eh)(s)),detail:(0,f.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(i,c){if(!i.config)return;i.focus();let s;return i.config.extensionDevelopmentPath||(i.config.backupPath?s=await this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority},i.config.backupPath):s=this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority})),(0,m.$Vi)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=c,i.config.backupPath=s,{workspace:c,backupPath:s}}};e.$bfc=t,e.$bfc=t=ke([ne(0,w.$Pec),ne(1,p.$ak),ne(2,b.$4ec),ne(3,d.$Uec),ne(4,g.$Vec)],t)}),define(oe[136],ae([0,1,14,35,23,6,29,30,60,13,5,64]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=e.ID=void 0,e.ID="diagnosticsMainService",e.$xfc=(0,D.$Gi)(e.ID);let g=class{constructor(h,p,b){this.a=h,this.b=p,this.c=b}async getRemoteDiagnostics(h){const p=this.a.getWindows();return(await Promise.all(p.map(async $=>{const m=$.remoteAuthority;if(!m)return;const E=`vscode:getDiagnosticInfoResponse${$.id}`,P={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(t=>{$.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:E,args:P}),o.$FX.once(E,(r,i)=>{i||t({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),t(i)}),setTimeout(()=>{t({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const b of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(b.id);$?h.push(await this.d($)):h.push(this.e(b))}const p=[];for(const{pid:b,name:$}of d.$ufc.getAll())p.push({pid:b,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,pidToNames:p,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(h){const p=await this.f(h),b=(0,a.$rg)(h.win);return this.e(b,p,h.remoteAuthority)}e(h,p=[],b){return{id:h.id,pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:p,remoteAuthority:b}}async f(h){const p=[],b=h.openedWorkspace;if((0,I.$Qi)(b))p.push(b.uri);else if((0,I.$Vi)(b)){const $=await this.b.resolveLocalWorkspace(b.configPath);$&&$.folders.forEach(E=>{p.push(E.uri)})}return p}};e.$yfc=g,e.$yfc=g=ke([ne(0,O.$1ec),ne(1,v.$afc),ne(2,f.$ak)],g)}),define(oe[65],ae([0,1,49,14,27,161,54,4,2,12,10,3,7,114,94,21,112,189,53,24,6,20,5,28,77,29,30,60,17,250,240,85,16]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0,e.$Mfc=(0,P.$Gi)("nativeHostMainService");let A=class extends v.$Xc{constructor(U,C,z,re,Z,le,X,ee,q){super(),this.a=U,this.b=C,this.c=z,this.f=re,this.g=Z,this.h=le,this.j=X,this.m=ee,this.n=q,this.onDidOpenMainWindow=I.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:B,y:G})=>({windowId:j.id,x:B,y:G})),I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:B,y:G})=>({windowId:j.id,x:B,y:G}))),this.onDidMaximizeWindow=I.Event.any(I.Event.map(this.a.onDidMaximizeWindow,j=>j.id),I.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=I.Event.any(I.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),I.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=I.Event.any(I.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),I.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,B)=>B.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,B)=>B.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,B)=>this.b.getWindowByWebContents(B.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,B)=>this.b.getWindowByWebContents(B.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(o.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new I.$ne),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(o.screen,"display-metrics-changed",(j,B,G)=>G),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),I.Event.fromNodeEventEmitter(o.screen,"display-added"),I.Event.fromNodeEventEmitter(o.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(U,C){const z=this.a.getWindows().map(Z=>({id:Z.id,workspace:Z.openedWorkspace??(0,l.$Ui)(Z.backupPath,Z.isExtensionDevelopmentHost),title:Z.win?.getTitle()??"",filename:Z.getRepresentedFilename(),dirty:Z.isDocumentEdited()})),re=[];return C.includeAuxiliaryWindows&&re.push(...this.b.getWindows().map(Z=>({id:Z.id,parentId:Z.parentId,title:Z.win?.getTitle()??"",filename:Z.getRepresentedFilename()}))),[...z,...re]}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const C=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(C)return C.id}openWindow(U,C,z){return Array.isArray(C)?this.s(U,C,z):this.t(U,C)}async s(U,C,z=Object.create(null)){C.length>0&&await this.a.open({context:s.OpenContext.API,contextWindowId:U,urisToOpen:C,cli:this.g.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async t(U,C){await this.a.openEmptyWindow({context:s.OpenContext.API,contextWindowId:U},C)}async isFullScreen(U,C){return this.C(C?.targetWindowId,U)?.isFullScreen??!1}async toggleFullScreen(U,C){this.C(C?.targetWindowId,U)?.toggleFullScreen()}async handleTitleDoubleClick(U,C){this.C(C?.targetWindowId,U)?.handleTitleDoubleClick()}async getCursorScreenPoint(U){const C=o.screen.getCursorScreenPoint(),z=o.screen.getDisplayNearestPoint(C);return{point:C,display:z.bounds}}async isMaximized(U,C){return this.C(C?.targetWindowId,U)?.win?.isMaximized()??!1}async maximizeWindow(U,C){this.C(C?.targetWindowId,U)?.win?.maximize()}async unmaximizeWindow(U,C){this.C(C?.targetWindowId,U)?.win?.unmaximize()}async minimizeWindow(U,C){this.C(C?.targetWindowId,U)?.win?.minimize()}async moveWindowTop(U,C){this.C(C?.targetWindowId,U)?.win?.moveTop()}async positionWindow(U,C,z){const re=this.C(z?.targetWindowId,U);if(re?.win){if(re.win.isFullScreen()){const Z=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(re.win,"leave-full-screen")));re.win.setFullScreen(!1),await Z}re.win.setBounds(C)}}async updateWindowControls(U,C){this.C(C?.targetWindowId,U)?.updateWindowControls(C)}async focusWindow(U,C){this.C(C?.targetWindowId,U)?.focus({force:C?.force??!1})}async setMinimumSize(U,C,z){const re=this.D(U);if(re?.win){const[Z,le]=re.win.getSize(),[X,ee]=re.win.getMinimumSize(),[q,j]=[C??X,z??ee],[B,G]=[Math.max(Z,q),Math.max(le,j)];(X!==q||ee!==j)&&re.win.setMinimumSize(q,j),(Z!==B||le!==G)&&re.win.setSize(B,G)}}async saveWindowSplash(U,C){this.m.saveWindowSplash(U,C)}async installShellCommand(U){const{source:C,target:z}=await this.u();try{const{symbolicLink:re}=await p.SymlinkSupport.stat(C);if(re&&!re.dangling){const Z=await(0,w.$lr)(C);if(z===Z)return}await p.Promises.unlink(C)}catch(re){if(re.code!=="ENOENT")throw re}try{await p.Promises.symlink(z,C)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:Z}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(Z===1)throw new T.$8;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(le)}catch{throw new Error((0,$.localize)(3,null,C))}}}async uninstallShellCommand(U){const{source:C}=await this.u();try{await p.Promises.unlink(C)}catch(z){switch(z.code){case"EACCES":{const{response:re}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(re===1)throw new T.$8;try{const Z=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(Z)}catch{throw new Error((0,$.localize)(7,null,C))}break}case"ENOENT":break;default:throw z}}}async u(){const U=(0,f.$nc)(this.g.appRoot,"bin","code"),C=`/usr/local/bin/${this.j.applicationName}`;if(!await p.Promises.exists(U))throw new Error((0,$.localize)(8,null,U));return{source:C,target:U}}async showMessageBox(U,C){const z=this.C(C?.targetWindowId,U);return this.c.showMessageBox(C,z?.win??void 0)}async showSaveDialog(U,C){const z=this.C(C?.targetWindowId,U);return this.c.showSaveDialog(C,z?.win??void 0)}async showOpenDialog(U,C){const z=this.C(C?.targetWindowId,U);return this.c.showOpenDialog(C,z?.win??void 0)}async pickFileFolderAndOpen(U,C){const z=await this.c.pickFileFolder(C);z&&await this.w(await Promise.all(z.map(async re=>await p.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),C,U)}async pickFolderAndOpen(U,C){const z=await this.c.pickFolder(C);z&&await this.w(z.map(re=>({folderUri:g.URI.file(re)})),C,U)}async pickFileAndOpen(U,C){const z=await this.c.pickFile(C);z&&await this.w(z.map(re=>({fileUri:g.URI.file(re)})),C,U)}async pickWorkspaceAndOpen(U,C){const z=await this.c.pickWorkspace(C);z&&await this.w(z.map(re=>({workspaceUri:g.URI.file(re)})),C,U)}async w(U,C,z){await this.a.open({context:s.OpenContext.DIALOG,contextWindowId:z,cli:this.g.args,urisToOpen:U,forceNewWindow:C.forceNewWindow})}async showItemInFolder(U,C){o.shell.showItemInFolder(C)}async setRepresentedFilename(U,C,z){this.C(z?.targetWindowId,U)?.setRepresentedFilename(C)}async setDocumentEdited(U,C,z){this.C(z?.targetWindowId,U)?.setDocumentEdited(C)}async openExternal(U,C){return this.g.unsetSnapExportedVariables(),o.shell.openExternal(C),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,C){return o.shell.trashItem(C)}async isAdmin(){let U;return d.$i?U=(await new Promise((C,z)=>{x(["native-is-elevated"],C,z)}).then(De)).default():U=process.getuid?.()===0,U}async writeElevated(U,C,z,re){const Z=await new Promise((le,X)=>{x(["@vscode/sudo-prompt"],le,X)}).then(De);return new Promise((le,X)=>{const ee=[`"${this.z}"`];re?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${C.fsPath}"`,`"${z.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:d.$j&&this.g.isBuilt?(0,f.$mc)((0,f.$pc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};Z.exec(ee.join(" "),q,(j,B,G)=>{B&&this.h.trace(`[sudo-prompt] received stdout: ${B}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),j?X(j):le(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:o.app.runningUnderARM64Translation}get z(){return d.$i?this.g.isBuilt?(0,f.$mc)((0,f.$pc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,f.$mc)(this.g.appRoot,"scripts","code-cli.bat"):d.$k?this.g.isBuilt?(0,f.$mc)((0,f.$pc)(process.execPath),"bin",`${this.j.applicationName}`):(0,f.$mc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,f.$mc)(this.g.appRoot,"bin","code"):(0,f.$mc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return h.$Sn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,y.$Jfc)()}async getProcessId(U){return this.C(void 0,U)?.win?.webContents.getOSProcessId()}async killProcess(U,C,z){process.kill(C,z)}async readClipboardText(U,C){return o.clipboard.readText(C)}async writeClipboardText(U,C,z){return o.clipboard.writeText(C,z)}async readClipboardFindText(U){return o.clipboard.readFindText()}async writeClipboardFindText(U,C){return o.clipboard.writeFindText(C)}async writeClipboardBuffer(U,C,z,re){return o.clipboard.writeBuffer(C,Buffer.from(z.buffer),re)}async readClipboardBuffer(U,C){return S.$Pe.wrap(o.clipboard.readBuffer(C))}async hasClipboard(U,C,z){return o.clipboard.has(C,z)}async newWindowTab(){await this.a.open({context:s.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){o.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){o.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){o.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){o.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){o.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,C){this.D(U)?.updateTouchBar(C)}async notifyReady(U){this.D(U)?.setReady()}async relaunch(U,C){return this.f.relaunch(C)}async reload(U,C){const z=this.D(U);if(z){if((0,l.$Vi)(z.openedWorkspace)){const re=z.openedWorkspace.configPath;if(re.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(re))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.f.reload(z,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(U,C){return this.C(C?.targetWindowId,U)?.win?.close()}async quit(U){const C=this.a.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&C.win?C.win.close():this.f.quit()}async exit(U,C){await this.f.kill(C)}async resolveProxy(U,C){return this.D(U)?.win?.webContents?.session?.resolveProxy(C)}async loadCertificates(U){return(await new Promise((z,re)=>{x(["@vscode/proxy-agent"],z,re)}).then(De)).loadSystemCertificates({log:this.h})}findFreePort(U,C,z,re,Z=1){return(0,b.$5g)(C,z,re,Z)}async openDevTools(U,C){this.C(C?.targetWindowId,U)?.win?.webContents.openDevTools(C?.mode?{mode:C.mode,activate:C.activate}:void 0)}async toggleDevTools(U,C){this.C(C?.targetWindowId,U)?.win?.webContents.toggleDevTools()}async profileRenderer(U,C,z){const re=this.D(U);if(!re||!re.win)throw new Error;return await new R.$Kfc(re.win,C,this.h).inspect(z)}async windowsGetStringRegKey(U,C,z,re){if(!d.$i)return;const Z=await new Promise((le,X)=>{x(["@vscode/windows-registry"],le,X)}).then(De);try{return Z.GetStringRegKey(C,z,re)}catch{return}}C(U,C){return this.D(U)??this.F(U)??this.D(C)}D(U){if(typeof U=="number")return this.a.getWindowById(U)}F(U){if(typeof U!="number")return;const C=o.webContents.fromId(U);if(C)return this.b.getWindowByWebContents(C)}};e.$Nfc=A,ke([O.$$h],A.prototype,"z",null),e.$Nfc=A=ke([ne(0,s.$1ec),ne(1,L.$Lfc),ne(2,m.$Vec),ne(3,t.$hfc),ne(4,E.$Pec),ne(5,r.$ak),ne(6,i.$tk),ne(7,c.$Yec),ne(8,u.$afc)],A)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[308],ae([0,1,14,27,8,23,2,12,3,35,185,53,24,5,65,73,74,51,29]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0,p=et(p);let P=class{static{E=this}static{this.a="#1E1E1E"}constructor(r,i,c,s,l,u,S){this.d=r,this.e=i,this.f=c,this.g=s,this.h=l,this.i=u,this.j=S,this.b=null,this.c=null}async openReporter(r){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new O.$Wc,c=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,c,{backgroundColor:r.styles.backgroundColor,title:(0,f.localize)(0,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:r,disableExtensions:!!this.e.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:p.default}),this.b.loadURL(I.$1g.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(r){this.f.error(r)}}async $showConfirmCloseDialog(){if(this.b){const{response:r}=await this.g.showMessageBox({type:"warning",message:(0,f.localize)(1,null),buttons:[(0,f.localize)(2,null),(0,f.localize)(3,null)]},this.b);r===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:r}=await this.g.showMessageBox({type:"warning",message:(0,f.localize)(4,null),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]},this.b);return r===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const r=this.j.getWindowById(this.c.id);if(!r)throw new Error("Window not found");return r}async $sendReporterMenu(r,i){const c=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",l=new D.$ye;return c.sendWhenReady(s,l.token,{replyChannel:s,extensionId:r,extensionName:i}),await(0,k.$xh)(new Promise(S=>a.$FX.once(`vscode:triggerReporterMenuResponse:${r}`,(y,R)=>S(R))),5e3,()=>{this.f.error(`Error: Extension ${r} timed out waiting for menu response`),l.cancel()})}async $closeReporter(){this.b?.close()}k(r){r.isMinimized()&&r.restore(),r.focus()}l(r,i,c,s){const l=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:c.title,backgroundColor:c.backgroundColor||E.a,webPreferences:{preload:I.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,$.$0D)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return l.setMenuBarVisibility(!1),l}m(r,i,c){let s;const l=n.screen.getAllDisplays();if(l.length===1)s=l[0];else{if(v.$j){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&r&&(s=n.screen.getDisplayMatching(r.getBounds())),s||(s=n.screen.getPrimaryDisplay()||l[0])}const u=s.bounds,S={width:i,height:c,x:u.x+u.width/2-i/2,y:u.y+u.height/2-c/2};return u.width>0&&u.height>0&&(S.x<u.x&&(S.x=u.x),S.y<u.y&&(S.y=u.y),S.x>u.x+u.width&&(S.x=u.x),S.y>u.y+u.height&&(S.y=u.y),S.width>u.width&&(S.width=u.width),S.height>u.height&&(S.height=u.height)),S}};e.$Ofc=P,e.$Ofc=P=E=ke([ne(1,g.$Pec),ne(2,w.$ak),ne(3,d.$Vec),ne(4,h.$Mfc),ne(5,b.$Xec),ne(6,m.$1ec)],P)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[309],ae([0,1,14,31,2,12,3,116,35,186,97,136,53,24,5,65,73,28,74,34,64,51]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0,b=et(b);const i="issue.processExplorerWindowState";let c=class{static{r=this}static{this.a="#1E1E1E"}constructor(u,S,y,R,L,T,A,M,U,C){this.d=u,this.f=S,this.g=y,this.h=R,this.i=L,this.j=T,this.k=A,this.l=M,this.m=U,this.n=C,this.b=null,this.c=null,this.o()}o(){v.$FX.on("vscode:listProcesses",async u=>{const S=[];try{S.push({name:(0,a.localize)(0,null),rootProcess:await(0,I.$Vs)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(R=>{(0,f.$Um)(R)?S.push({name:R.hostName,rootProcess:R}):R.processes&&S.push({name:R.hostName,rootProcess:R.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(u,"vscode:listProcessesResponse",S)}),v.$FX.on("vscode:workbenchCommand",(u,S)=>{const{id:y,from:R,args:L}=S;let T;switch(R){case"processExplorer":T=this.c;break;default:throw new Error(`Unexpected command source: ${R}`)}T?.webContents.send("vscode:runAction",{id:y,from:R,args:L})}),v.$FX.on("vscode:closeProcessExplorer",u=>{this.b?.close()}),v.$FX.on("vscode:pidToNameRequest",async u=>{const S=await this.i.getMainDiagnostics(),y=[];for(const R of S.windows)y.push([R.pid,`window [${R.id}] (${R.title})`]);for(const{pid:R,name:L}of P.$ufc.getAll())y.push([R,L]);this.s(u,"vscode:pidToNameResponse",y)})}async openProcessExplorer(u){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const S=new k.$Wc,y=S.add(this.l.createIPCObjectUrl()),R=this.n.getItem(i,void 0),L=s(R)?R:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:u.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:u,product:b.default}),this.b.loadURL(D.$1g.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())});const T=()=>{if(!this.b)return;const A=this.b.getSize(),M=this.b.getPosition();if(!A||!M)return;const U={width:A[0],height:A[1],x:M[0],y:M[1]};this.n.setItem(i,U)};this.b.on("moved",T),this.b.on("resized",T)}this.b&&this.p(this.b)}p(u){u.isMinimized()&&u.restore(),u.focus()}q(u,S,y){let R;const L=n.screen.getAllDisplays();if(L.length===1)R=L[0];else{if(O.$j){const M=n.screen.getCursorScreenPoint();R=n.screen.getDisplayNearestPoint(M)}!R&&u&&(R=n.screen.getDisplayMatching(u.getBounds())),R||(R=n.screen.getPrimaryDisplay()||L[0])}const T=R.bounds,A={width:S,height:y,x:T.x+T.width/2-S/2,y:T.y+T.height/2-y/2};return T.width>0&&T.height>0&&(A.x<T.x&&(A.x=T.x),A.y<T.y&&(A.y=T.y),A.x>T.x+T.width&&(A.x=T.x),A.y>T.y+T.height&&(A.y=T.y),A.width>T.width&&(A.width=T.width),A.height>T.height&&(A.height=T.height)),A}async stopTracing(){if(!this.f.args.trace)return;const u=await n.contentTracing.stopRecording(`${(0,o.$Og)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,a.localize)(2,null),detail:(0,a.localize)(3,null,u),buttons:[(0,a.localize)(4,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,u)}async getSystemStatus(){const[u,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(u,S)}async $getSystemInfo(){const[u,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(u,S)}async $getPerformanceInfo(){try{const[u,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(u,S)}catch(u){throw this.g.warn("issueService#getPerformanceInfo ",u.message),u}}r(u,S,y,R){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:y.title,backgroundColor:y.backgroundColor||r.a,webPreferences:{preload:D.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$0D)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(u,S,...y){u.sender.isDestroyed()||u.sender.send(S,...y)}async closeProcessExplorer(){this.b?.close()}};e.$Pfc=c,e.$Pfc=c=r=ke([ne(1,w.$Pec),ne(2,h.$ak),ne(3,f.$Tm),ne(4,d.$xfc),ne(5,g.$Vec),ne(6,p.$Mfc),ne(7,m.$Xec),ne(8,$.$tk),ne(9,E.$gR)],c);function s(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(oe[310],ae([0,1,23,18,24,20,5,65,28,57,25,50,106]),function(x,e,n,o,k,D,O,I,v,a,f,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;let w=class extends g.$cgc{constructor(p,b,$,m,E,P,t,r){super(p,b,m,E,P,r),this.e=$,this.u=t}s(p){return(0,g.$bgc)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(d.$DY.CheckingForUpdates(p)),this.i.request({url:this.a},n.CancellationToken.None).then(a.$_p).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(d.$DY.Idle(d.UpdateType.Archive))):this.d(d.$DY.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b);const $=p?b.message||b:void 0;this.d(d.$DY.Idle(d.UpdateType.Archive,$))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(d.$DY.Idle(d.UpdateType.Archive))}};e.$egc=w,e.$egc=w=ke([ne(0,D.$hfc),ne(1,o.$aj),ne(2,f.$_l),ne(3,k.$Pec),ne(4,a.$6p),ne(5,O.$ak),ne(6,I.$Mfc),ne(7,v.$tk)],w)}),define(oe[311],ae([0,1,49,47,27,8,23,54,46,10,7,149,21,18,24,15,20,5,65,28,57,25,50,106]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0,o=De(o),a=De(a),g=De(g);async function c(S,y=1e3){for(;!S();)await(0,D.$Hh)(y)}let s;function l(){return typeof s>"u"&&(s=o.existsSync(a.$mc(a.$pc(process.execPath),"unins000.exe"))?r.UpdateType.Setup:r.UpdateType.Archive),s}let u=class extends i.$cgc{get cachePath(){const y=a.$mc((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,R,L,T,A,M,U,C,z){super(y,R,T,A,M,z),this.u=L,this.v=U,this.w=C,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==r.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(r.$DY.Disabled(r.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let R=`win32-${process.arch}`;return l()===r.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,i.$bgc)(R,y,this.k)}t(y){this.a&&(this.d(r.$DY.CheckingForUpdates(y)),this.i.request({url:this.a},O.CancellationToken.None).then(P.$_p).then(R=>{const L=l();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(r.$DY.Idle(L)),Promise.resolve(null)):L===r.UpdateType.Archive?(this.d(r.$DY.AvailableForDownload(R)),Promise.resolve(null)):(this.d(r.$DY.Downloading),this.C(R.version).then(()=>this.B(R.version).then(T=>g.Promises.exists(T).then(A=>{if(A)return Promise.resolve(T);const M=`${T}.tmp`;return this.i.request({url:R.url},O.CancellationToken.None).then(U=>this.v.writeFile(f.URI.file(M),U.stream)).then(R.sha256hash?()=>(0,d.$yX)(M,R.sha256hash):()=>{}).then(()=>g.Promises.rename(M,T,!1)).then(()=>T)})).then(T=>{this.e={packagePath:T},this.d(r.$DY.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(r.$DY.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,v.$uj)(String(R)))}),this.j.error(R);const L=y?R.message||R:void 0;this.d(r.$DY.Idle(l(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(r.$DY.Idle(l()))}async B(y){const R=await this.cachePath;return a.$mc(R,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const R=y?M=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(M):()=>!0,L=await this.cachePath,A=(await g.Promises.readdir(L)).filter(R).map(async M=>{try{await g.Promises.unlink(a.$mc(L,M))}catch{}});await Promise.all(A)}async p(){if(this.state.type!==r.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(r.$DY.Updating(y));const R=await this.cachePath;this.e.updateFilePath=a.$mc(R,`CodeSetup-${this.k.quality}-${y.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(r.$DY.Idle(l()))});const T=`${this.k.win32MutexName}-ready`,A=await new Promise((M,U)=>{x(["@vscode/windows-mutex"],M,U)}).then(De);c(()=>A.isActive(T)).then(()=>this.d(r.$DY.Ready(y)))}r(){this.state.type!==r.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?o.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return l()}async _applySpecificUpdate(y){if(this.state.type!==r.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(r.$DY.Downloading),this.e={packagePath:y},this.d(r.$DY.Downloaded(L)),R?this.k.target==="user"&&this.p():this.d(r.$DY.Ready(L))}};e.$ggc=u,ke([I.$$h],u.prototype,"cachePath",null),e.$ggc=u=ke([ne(0,b.$hfc),ne(1,w.$aj),ne(2,t.$_l),ne(3,h.$Pec),ne(4,P.$6p),ne(5,$.$ak),ne(6,p.$al),ne(7,m.$Mfc),ne(8,E.$tk)],u)}),define(oe[137],ae([0,1,14,8,23,55,4,2,12,71,3,7,197,27,70,18,53,24,69,15,20,5,28,74,286,88,25,111,77,51,29,30,60,52,40,34,59,72,22,6]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T,A,M,U,C,z,re,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;var le;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(le||(le={}));class X extends I.$Xc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(O.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const B=!(0,y.$5D)(this.r);if(f.$j&&B&&j.setSheetOffset((0,f.$J)((0,w.release)())?28:22),B&&(f.$i&&(0,y.$8D)(this.r)||f.$j)){const G=this.s.getItem(X.D);G?this.updateWindowControls({height:G}):this.updateWindowControls({height:y.$7D})}f.$i&&B&&j.hookWindowMessage(278,()=>{const[ce,K]=j.getPosition(),he=n.screen.getCursorScreenPoint(),se=he.x-ce,_=he.y-K;return!(se>30&&_>=0&&_<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:se,y:_})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),f.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,B,G,ce){super(),this.r=j,this.s=B,this.t=G,this.u=ce,this.a=this.B(new O.$ne),this.onDidClose=this.a.event,this.b=this.B(new O.$ne),this.onDidMaximize=this.b.event,this.c=this.B(new O.$ne),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$ne),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$ne),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$ne),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$8D)(this.r),this.G=void 0,this.H=void 0}w(j,B=n.screen.getAllDisplays().length>0){const G=this.r.getValue("window"),ce=f.$j&&G?.nativeTabs===!0;(f.$j||f.$i)&&B&&(!ce||n.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(K=>typeof K=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===A.WindowMode.Maximized||j.mode===A.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===A.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){f.$j?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return f.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){f.$j&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return f.$j?!!this.win?.isDocumentEdited():!!this.C}focus(j){f.$j&&j?.force&&n.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(f.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const B=this.win;if(B){if(j.height&&this.s.setItem(ee.D,j.height),f.$i&&this.F)B.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(f.$j&&j.height!==void 0){const G=(j.height-15)/2;G?B.setWindowButtonPosition({x:G,y:G}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,B){(0,y.$9D)(this.r)?this.J(j,B):this.M(j)}get isFullScreen(){if(f.$j&&typeof this.G=="boolean")return this.G;const j=this.win,B=j?.isFullScreen(),G=j?.isSimpleFullScreen();return!!(B||G)}J(j,B){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.L(j,B)}L(j,B){if(f.$j){this.G=j;const ce=this.H=new o.$4h;(async()=>{const K=await Promise.race([ce.p,(0,o.$Hh)(1e4).then(()=>!1)]);this.H===ce&&(this.G=void 0,this.H=void 0,!K&&j&&B&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const B=this.win;B?.isFullScreen()&&this.L(!1,!1),B?.setSimpleFullScreen(j),B?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$efc=X;let ee=class extends X{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Ui)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,B,G,ce,K,he,se,_,F,N,W,H,J,Y,V,ie,de,me,we,Oe,Se){super(N,Oe,ce,B),this.fb=G,this.gb=K,this.hb=he,this.ib=se,this.jb=_,this.kb=F,this.lb=W,this.mb=H,this.nb=J,this.ob=Y,this.pb=V,this.qb=ie,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new O.$ne),this.onWillLoad=this.N.event,this.O=this.B(new O.$ne),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$ne),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=le.NONE;{const[Pe,Ie]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=Se.invokeFunction(R.$2ec,this.U,{preload:v.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow($e),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Ie),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=le.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===le.READY}get whenClosedOrLoaded(){return new Promise(j=>{function B(){G.dispose(),ce.dispose(),j()}const G=this.onDidClose(()=>B()),ce=this.onWillLoad(()=>B())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(A.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(B,G)=>G)(B=>this.yb(A.WindowError.PROCESS_GONE,{...B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(B,G,ce)=>({exitCode:G,reason:ce}))(({exitCode:B,reason:G})=>this.yb(A.WindowError.LOAD,{reason:G,exitCode:B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(B=>B.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(B=>this.Bb(B))),this.B(this.mb.onDidDeleteUntitledWorkspace(B=>this.Ab(B)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(B,G)=>{const ce=await this.xb();G({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,ce)})})}xb(){return this.wb||(this.wb=(0,c.$nq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,B){switch(j){case A.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case A.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case A.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:B?.reason,code:B?.exitCode}),j){case A.WindowError.UNRESPONSIVE:case A.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===A.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.S?.workspace?(0,g.localize)(5,null):void 0},this.m);if(G!==2){const K=G===0;await this.zb(K,ce)}}else if(j===A.WindowError.PROCESS_GONE){let G;B?G=(0,g.localize)(7,null,B.reason,B.exitCode??"<unknown>"):G=(0,g.localize)(6,null);const{response:ce,checkboxChecked:K}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:G,detail:this.S?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.S?.workspace?(0,g.localize)(13,null):void 0},this.m),he=ce===0;await this.zb(he,K)}break}}async zb(j,B){const G=this.S?.workspace;if(B&&G)try{const ce=this.kb.workspaceStorage(G);await ce.init(),ce.delete("memento/workbench.parts.editor"),await ce.close()}catch(ce){this.u.error(ce)}this.P.fire();try{if(j&&this.S){let ce,K;(0,L.$Qi)(G)?ce={folderUri:G.uri}:(0,L.$Vi)(G)?ce={workspaceUri:G.configPath}:K=!0,(0,re.$Rb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ce?[ce]:void 0,forceEmpty:K,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const B=this.Gb();B!==this.W&&(this.W=B,this.Hb(B))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let B=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const G=(this.r.getValue("http.noProxy")||[]).map(ce=>ce.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.Z||G!==this.$)){this.Z=B,this.$=G;const ce=B||"",K=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${ce}', bypassing '${K}'`),this.m.webContents.session.setProxy({proxyRules:ce,proxyBypassRules:K,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ce,proxyBypassRules:K,pacScript:""})}}}addTabbedWindow(j){f.$j&&j.win&&this.m.addTabbedWindow(j.win)}load(j,B=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!B.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,B),this.ub===le.NONE?this.S=j:this.db=j,this.ub=le.NAVIGATING,this.m.loadURL(v.$1g.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new o.$Sh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:B.isReload?A.LoadReason.RELOAD:G?A.LoadReason.LOAD:A.LoadReason.INITIAL})}Cb(j,B){const G=(this.S??this.db)?.userEnv;if(G){const ce=(0,m.$Km)(G)&&!(0,m.$Km)(j.userEnv),K=this.isExtensionDevelopmentHost;(ce||K)&&(j.userEnv={...G,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(j["disable-extensions"]=B.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),j.perfMarks=(0,a.getMarks)(),this.bb.update(j)}async reload(j){const B=Object.assign({},this.S);B.workspace=await this.Db(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&j&&(B.verbose=j.verbose,B.debugId=j.debugId,B.extensionEnvironment=j.extensionEnvironment,B["inspect-extensions"]=j["inspect-extensions"],B["inspect-brk-extensions"]=j["inspect-brk-extensions"],B["extensions-dir"]=j["extensions-dir"]),B.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.gb.serialize(),B.continueOn=this.t.continueOn,B.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},B.logLevel=this.fb.getLogLevel(),B.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Vi)(j.workspace)){const B=j.workspace.configPath;if(B.scheme===v.Schemas.file&&!await this.ib.exists(B))return}else if((0,L.$Qi)(j.workspace)){const B=j.workspace.uri;if(B.scheme===v.Schemas.file&&!await this.ib.exists(B))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,A.$Nec)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const ce=(0,A.$Nec)();return{mode:A.WindowMode.Fullscreen,display:G?G.id:void 0,width:this.U.width||ce.width,height:this.U.height||ce.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let B;if(!f.$j&&this.m.isMaximized()?B=A.WindowMode.Maximized:B=A.WindowMode.Normal,B===A.WindowMode.Maximized?j.mode=A.WindowMode.Maximized:j.mode=A.WindowMode.Normal,B===A.WindowMode.Normal||B===A.WindowMode.Maximized){let G;B===A.WindowMode.Normal?G=this.getBounds():G=this.m.getNormalBounds(),j.x=G.x,j.y=G.y,j.width=G.width,j.height=G.height}return j.zoomLevel=this.ab,j}Eb(j){(0,a.mark)("code/willRestoreCodeWindowState");let B=!1;if(j){this.ab=j.zoomLevel;try{const G=n.screen.getAllDisplays();B=G.length>1,j=R.WindowStateValidator.validateWindowState(this.u,j,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[j||(0,A.$Nec)(),B]}getBounds(){const[j,B]=this.m.getPosition(),[G,ce]=this.m.getSize();return{x:j,y:B,width:G,height:ce}}I(j,B){super.I(j,B),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$3D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,B=!0){f.$j||(j==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const B=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!B),this.m.autoHideMenuBar=B;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,B,...G){this.isReady?this.send(j,...G):this.ready().then(()=>{B.isCancellationRequested||this.send(j,...G)})}send(j,...B){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...B)}catch(G){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$rj)(G)}`)}}}updateTouchBar(j){f.$j&&this.Y.forEach((B,G)=>{const ce=j[G];B.segments=this.Mb(ce)})}Kb(){if(f.$j){for(let j=0;j<10;j++){const B=this.Lb();this.Y.push(B)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(j=[]){const B=this.Mb(j),G=new n.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:ce=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:G.segments[ce].id,from:"touchbar"})}});return G}Mb(j=[]){return j.map(G=>{let ce;G.icon&&!u.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===v.Schemas.file&&(ce=n.nativeImage.createFromPath(d.URI.revive(G.icon.dark).fsPath),ce.isEmpty()&&(ce=void 0));let K;return typeof G.title=="string"?K=G.title:K=G.title.value,{id:G.id,label:ce?void 0:K,icon:ce}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$ffc=ee,e.$ffc=ee=ke([ne(1,t.$ak),ne(2,z.$cfc),ne(3,$.$Pec),ne(4,M.$to),ne(5,C.$4ec),ne(6,E.$al),ne(7,s.$pfc),ne(8,s.$nfc),ne(9,p.$aj),ne(10,S.$Yec),ne(11,T.$afc),ne(12,h.$Uec),ne(13,l.$_l),ne(14,b.$Vec),ne(15,P.$hfc),ne(16,r.$tk),ne(17,i.$Xec),ne(18,R.$1ec),ne(19,U.$gR),ne(20,Z.$Fi)],ee)}),define(oe[312],ae([0,1,14,3,18,24,20,5,34,51,52,137]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let g=class extends d.$efc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,p,b,$,m,E){super($,m,p,b),this.O=h,this.P=E,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(h){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),h&&!this.N&&(this.N=!0,this.w({x:h.x,y:h.y,width:h.width,height:h.height,mode:h.show===!1?f.WindowMode.Maximized:f.WindowMode.Normal})))}Q(){if(this.m)return;const h=n.BrowserWindow.fromWebContents(this.O);h&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(h),h.setMenu(null),(o.$i||o.$k)&&(0,a.$5D)(this.r)&&h.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(h){return this.O.id===h.id}};e.$gfc=g,e.$gfc=g=ke([ne(1,D.$Pec),ne(2,I.$ak),ne(3,k.$aj),ne(4,v.$gR),ne(5,O.$hfc)],g)}),define(oe[313],ae([0,1,14,4,2,12,35,312,6,5,52,29]),function(x,e,n,o,k,D,O,I,v,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;let g=class extends k.$Xc{constructor(h,p){super(),this.h=h,this.j=p,this.a=this.B(new o.$ne),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new o.$ne),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new o.$ne),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new o.$ne),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(h,p)=>{const b=this.getWindowByWebContents(p.webContents);if(b)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),b.tryClaimWindow();else{const $=new k.$Wc;$.add(o.Event.fromNodeEventEmitter(p.webContents,"did-create-window",(m,E)=>({browserWindow:m,details:E}))(({browserWindow:m,details:E})=>{const P=this.getWindowByWebContents(m.webContents);P&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),P.tryClaimWindow(E.options))})),$.add(o.Event.fromNodeEventEmitter(p,"closed")(()=>$.dispose()))}}),O.$FX.handle("vscode:registerAuxiliaryWindow",async(h,p)=>{const b=this.getWindowByWebContents(h.sender);return b&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),b.parentId=p),h.sender.id})}createWindow(h){return this.h.invokeFunction(d.$2ec,this.n(h),{preload:D.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(h){const p={},b=h.features.split(",");for(const m of b){const[E,P]=m.split("=");switch(E){case"width":p.width=parseInt(P,10);break;case"height":p.height=parseInt(P,10);break;case"left":p.x=parseInt(P,10);break;case"top":p.y=parseInt(P,10);break;case"window-maximized":p.mode=f.WindowMode.Maximized;break;case"window-fullscreen":p.mode=f.WindowMode.Fullscreen;break}}const $=d.WindowStateValidator.validateWindowState(this.j,p)??(0,f.$Oec)();return this.j.trace("[aux window] using window state",$),$}registerWindow(h){const p=new k.$Wc,b=this.h.createInstance(I.$gfc,h);this.g.set(b.id,b),p.add((0,k.$Vc)(()=>this.g.delete(b.id))),p.add(b.onDidMaximize(()=>this.a.fire(b))),p.add(b.onDidUnmaximize(()=>this.b.fire(b))),p.add(b.onDidEnterFullScreen(()=>this.c.fire({window:b,fullscreen:!0}))),p.add(b.onDidLeaveFullScreen(()=>this.c.fire({window:b,fullscreen:!1}))),p.add(b.onDidTriggerSystemContextMenu(({x:$,y:m})=>this.f.fire({window:b,x:$,y:m}))),o.Event.once(b.onDidClose)(()=>p.dispose())}getWindowByWebContents(h){const p=this.g.get(h.id);return p?.matches(h)?p:void 0}getFocusedWindow(){const h=n.BrowserWindow.getFocusedWindow();if(h)return this.getWindowByWebContents(h.webContents)}getLastActiveWindow(){return(0,d.$3ec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Ngc=g,e.$Ngc=g=ke([ne(0,v.$Fi),ne(1,a.$ak)],g)}),define(oe[89],ae([0,1,14,22,8,4,48,2,12,3,19,7,21,200,6,20,5,63,88,103,30,60,32,53]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0,e.$Zfc=(0,h.$Gi)("workspacesHistoryMainService");let s=class extends I.$Xc{static{c=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(u,S,y,R,L){super(),this.f=u,this.g=S,this.h=y,this.j=R,this.m=L,this.c=this.B(new D.$ne),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$Eh(800)),this.n()}n(){this.h.when(p.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){let S=[],y=[];for(const L of u)if((0,E.$Zhb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(S,L.workspace)&&S.push(L);else if((0,E.$1hb)(L))this.y(S,L.folderUri)||S.push(L);else{const T=this.z(y,L.fileUri),A=L.fileUri.scheme===v.Schemas.file&&c.G.indexOf((0,f.$eh)(L.fileUri))>=0;!T&&!A&&(y.push(L),a.$i&&L.fileUri.scheme===v.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const R=await this.r({workspaces:S,files:y});S=R.workspaces,y=R.files,S.length>c.a&&(S.length=c.a),y.length>c.a&&(y.length=c.a),await this.t({workspaces:S,files:y}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(u){const S=T=>{const A=this.u(T);for(const M of u)if(f.$$g.isEqual(M,A))return!1;return!0},y=await this.getRecentlyOpened(),R=y.workspaces.filter(S),L=y.files.filter(S);(R.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:R}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(u){if(u?.confirm){const{response:S}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null)],message:(0,w.localize)(2,null),detail:(0,w.localize)(3,null),cancelId:1});if(S!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(u){const S=new r.$Dc(L=>f.$$g.getComparisonKey(L));if(u?.workspaces)for(const L of u.workspaces)S.set(this.u(L),L);const y=new r.$Dc(L=>f.$$g.getComparisonKey(L));if(u?.files)for(const L of u.files)y.set(this.u(L),L);const R=await this.s();for(const L of R.workspaces){const T=S.get(this.u(L));T?T.label=T.label??L.label:S.set(this.u(L),L)}for(const L of R.files){const T=y.get(this.u(L));T?T.label=T.label??L.label:y.set(this.u(L),L)}return{workspaces:[...S.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let u;const S=this.j.get(c.b,$.StorageScope.APPLICATION);if(typeof S=="string")try{u=JSON.parse(S)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,E.$7hb)(u,this.f)}async t(u){await this.j.whenReady,this.j.store(c.b,JSON.stringify((0,E.$8hb)(u)),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}u(u){return(0,E.$1hb)(u)?u.folderUri:(0,E.$2hb)(u)?u.fileUri:u.workspace.configPath}w(u,S){return!!u.find(y=>(0,E.$Zhb)(y)&&y.workspace.id===S.id)}y(u,S){return!!u.find(y=>(0,E.$1hb)(y)&&f.$$g.isEqual(y.folderUri,S))}z(u,S){return!!u.find(y=>f.$$g.isEqual(y.fileUri,S))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){a.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$i)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(4,null),description:(0,w.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const L of n.app.getJumpListSettings().removedItems){const T=L.args;if(T){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(T);A&&S.push(d.URI.parse(A[2]))}}await this.removeRecentlyOpened(S);let y=!1;const R=(0,o.$Kb)((await this.getRecentlyOpened()).workspaces.slice(0,c.F).map(L=>{const T=(0,E.$Zhb)(L)?L.workspace:L.folderUri,{title:A,description:M}=this.L(T,L.label);let U;return d.URI.isUri(T)?U=`--folder-uri "${T.toString()}"`:(y=!0,U=`--file-uri "${T.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:M.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&u.push({type:"custom",name:y?(0,w.localize)(6,null):(0,w.localize)(7,null),items:R})}u.push({type:"recent"});try{const S=n.app.setJumpList(u);S&&S!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.f.warn("updateWindowsJumpList#setJumpList",S)}}L(u,S){if(S)return{title:(0,O.$6w)(S).name,description:S};if(d.URI.isUri(u))return{title:(0,f.$eh)(u),description:this.M(u)};if(this.g.isUntitledWorkspace(u))return{title:(0,w.localize)(8,null),description:""};let y=(0,f.$eh)(u.configPath);return y.endsWith(P.$3i)&&(y=y.substr(0,y.length-P.$3i.length-1)),{title:(0,w.localize)(9,null,y),description:this.M(u.configPath)}}M(u){return u.scheme==="file"?(0,O.$Xw)(u.fsPath):u.toString()}async N(){if(!a.$j)return;n.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),S=[];let y=0;for(let L=0;L<u.workspaces.length&&y<c.C;L++){const T=this.u(u.workspaces[L]);if(T.scheme===v.Schemas.file){const A=(0,f.$8g)(T);await g.Promises.exists(A)&&(S.push(A),y++)}}const R=[];for(let L=0;L<u.files.length&&y<c.D;L++){const T=this.u(u.files[L]);if(T.scheme===v.Schemas.file){const A=(0,f.$8g)(T);if(c.G.includes((0,f.$eh)(T))||S.includes(A))continue;await g.Promises.exists(A)&&(R.push(A),y++)}}R.reverse().forEach(L=>n.app.addRecentDocument(L)),S.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$1fc=s,e.$1fc=s=c=ke([ne(0,b.$ak),ne(1,t.$afc),ne(2,p.$hfc),ne(3,m.$pfc),ne(4,i.$Vec)],s)}),define(oe[314],ae([0,1,14,8,23,48,3,7,188,85,18,24,20,5,236,65,28,34,25,50,51,29,89,2]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0,v=De(v);const s="menu";let l=class extends i.$Xc{static{c=this}static{this.a="lastKnownMenubarData"}constructor(y,R,L,T,A,M,U,C,z,re,Z,le){super(),this.t=y,this.u=R,this.w=L,this.y=T,this.z=A,this.C=M,this.D=U,this.F=C,this.G=z,this.H=re,this.I=Z,this.J=le,this.s=Object.create(null),this.h=new o.$Sh(()=>this.R(),0),this.j=new o.$Sh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$j||(0,P.$5D)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(c.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,U,C)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:U?.id})},this.s["workbench.action.newWindow"]=(M,U,C)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:U?.id}),this.s["workbench.action.files.openFileFolder"]=(M,U,C)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,U,C)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,U,C)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const T=this.I.licenseUrl;T&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$w){const M=T.indexOf("?")>0?"&":"?";this.ob(`${T}${M}lang=${O.$w}`,"openLicenseUrl")}else this.ob(T,"openLicenseUrl")});const A=this.I.privacyStatementUrl;A&&T&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(A,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!O.$j)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,R){this.n=y.menus,this.r=y.keybindings,this.D.setItem(c.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){O.$j&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!O.$j)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(O.$j?new n.Menu:null);return}const R=new n.Menu;let L;if(O.$j){const A=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:A}),this.Y(A),R.append(L)}if(O.$j&&!this.c){this.c=!0;const A=new n.Menu;A.append(new n.MenuItem({label:this.qb(v.localize(0,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(A)}if(this.$("File")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(1,null)),submenu:A});this.bb(A,"File"),R.append(M)}if(this.$("Edit")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(2,null)),submenu:A});this.bb(A,"Edit"),R.append(M)}if(this.$("Selection")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(3,null)),submenu:A});this.bb(A,"Selection"),R.append(M)}if(this.$("View")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(4,null)),submenu:A});this.bb(A,"View"),R.append(M)}if(this.$("Go")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(5,null)),submenu:A});this.bb(A,"Go"),R.append(M)}if(this.$("Run")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(6,null)),submenu:A});this.bb(A,"Run"),R.append(M)}if(this.$("Terminal")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(7,null)),submenu:A});this.bb(A,"Terminal"),R.append(M)}let T;if(this.$("Window")){const A=new n.Menu;T=new n.MenuItem({label:this.qb(v.localize(8,null)),submenu:A,role:"window"}),this.hb(A)}if(T&&R.append(T),this.$("Help")){const A=new n.Menu,M=new n.MenuItem({label:this.qb(v.localize(9,null)),submenu:A,role:"help"});this.bb(A,"Help"),R.append(M)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(y){const R=this.jb(v.localize(10,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let T;if(this.$("Preferences")){const le=new n.Menu;this.bb(le,"Preferences"),T=new n.MenuItem({label:this.qb(v.localize(11,null)),submenu:le})}const A=new n.Menu,M=new n.MenuItem({label:v.localize(12,null),role:"services",submenu:A}),U=new n.MenuItem({label:v.localize(13,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),C=new n.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new n.MenuItem({label:v.localize(15,null),role:"unhide"}),re=new n.MenuItem(this.nb("workbench.action.quit",{label:v.localize(16,null,this.I.nameLong),click:async(le,X,ee)=>{const q=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||q?.win?.isMinimized())&&await this.Z(ee)&&this.H.quit(void 0)}})),Z=[R];Z.push(...L),T&&Z.push(u(),T),Z.push(u(),M,u(),U,C,z,u(),re),Z.forEach(le=>y.append(le))}async Z(y){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[v.localize(17,null),v.localize(18,null)],message:v.localize(19,null)});return L===0}return!0}$(y){if(!O.$j&&!(0,P.$5D)(this.u))return!1;switch(y){case"File":case"Help":if(O.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(O.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,R){R.forEach(L=>{if((0,h.$Wfc)(L))y.append(u());else if((0,h.$Vfc)(L)){const T=new n.Menu,A=new n.MenuItem({label:this.qb(L.label),submenu:T});this.ab(T,L.submenu.items),y.append(A)}else(0,h.$Xfc)(L)?y.append(this.db(L)):(0,h.$Yfc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),O.$j?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,R){this.n&&this.n[R]&&this.ab(y,this.n[R].items)}cb(y){const R=this.ib();R.length&&(R.forEach(L=>y.append(L)),y.append(u()))}db(y){const R=I.URI.revive(y.uri),L=y.id,T=L==="openRecentFile"?{fileUri:R}:L==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new n.MenuItem(this.nb(L,{label:y.label,click:async(A,M,U)=>{const C=this.eb(U);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[T],forceNewWindow:C,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(y){return!!(y&&(!O.$j&&(y.ctrlKey||y.shiftKey)||O.$j&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,R,L){const T={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(R,T))}hb(y){const R=new n.MenuItem({label:v.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:v.localize(21,null),role:"zoom",enabled:this.w.getWindowCount()>0}),T=new n.MenuItem({label:v.localize(22,null),role:"front",enabled:this.w.getWindowCount()>0}),A=this.jb(v.localize(23,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(u()),M.push(this.jb(v.localize(24,null),"workbench.action.newWindowTab")),M.push(this.gb(v.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(v.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(v.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(v.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,L,u(),A,...M,u(),T].forEach(U=>y.append(U))}ib(){switch(this.t.state.type){case E.StateType.Idle:return[new n.MenuItem({label:this.qb(v.localize(29,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case E.StateType.CheckingForUpdates:return[new n.MenuItem({label:v.localize(30,null),enabled:!1})];case E.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(v.localize(31,null)),click:()=>{this.t.downloadUpdate()}})];case E.StateType.Downloading:return[new n.MenuItem({label:v.localize(32,null),enabled:!1})];case E.StateType.Downloaded:return O.$j?[]:[new n.MenuItem({label:this.qb(v.localize(33,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case E.StateType.Updating:return[new n.MenuItem({label:v.localize(34,null),enabled:!1})];case E.StateType.Ready:return[new n.MenuItem({label:this.qb(v.localize(35,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,R,L,T){const A=this.qb(y),M=typeof R=="function"?R:(Z,le,X)=>{const ee=Z?Z.userSettingsLabel:null;let q=R;Array.isArray(R)&&(q=this.eb(X)?R[1]:R[0]),ee&&X.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:ee}):this.lb({type:"commandId",commandId:q})},U=typeof L=="boolean"?L:this.w.getWindowCount()>0,C=typeof T=="boolean"?T:!1,z={label:A,click:M,enabled:U};C&&(z.type="checkbox",z.checked=C);let re;return typeof R=="string"?re=R:Array.isArray(R)&&(re=R[0]),O.$j&&(re==="editor.action.clipboardCutAction"?z.role="cut":re==="editor.action.clipboardCopyAction"?z.role="copy":re==="editor.action.clipboardPasteAction"&&(z.role="paste"),re==="undo"?z.click=this.kb(M,{inDevTools:Z=>Z.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?z.click=this.kb(M,{inDevTools:Z=>Z.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(z.click=this.kb(M,{inDevTools:Z=>Z.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(re,z))}kb(y,R){return(L,T,A)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return R.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return R.inDevTools(M.webContents.devToolsWebContents);y(L,T||M,A)}}lb(y){let R=n.BrowserWindow.getFocusedWindow();if(R){const T=this.J.getWindowByWebContents(R.webContents);T&&(R=this.w.getWindowById(T.parentId)?.win??null)}if(!R){const T=this.w.getLastActiveWindow();T?.win?.isMinimized()&&(R=T.win)}const L=R?this.w.getWindowById(R.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),O.$j&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const T={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",k.CancellationToken.None,T)}else{const T={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,T)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,R){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)R.accelerator=L.label,R.userSettingsLabel=L.userSettingsLabel;else if(typeof R.label=="string"){const T=R.label.indexOf("[");T>=0?R.label=`${R.label.substr(0,T)} [${L.label}]`:R.label=`${R.label} [${L.label}]`}}else R.accelerator=void 0;return R}nb(y,R,L=!R.accelerator){L&&(R=this.mb(y,R));const T=R.click;return R.click=(A,M,U)=>{this.pb(y),T?.(A,M,U)},R}ob(y,R){this.H.openExternal(void 0,y),this.pb(R)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,D.$3w)(y,!this.O)}};e.$2fc=l,e.$2fc=l=c=ke([ne(0,E.$EY),ne(1,f.$aj),ne(2,t.$1ec),ne(3,d.$Pec),ne(4,m.$_l),ne(5,r.$Zfc),ne(6,$.$gR),ne(7,g.$hfc),ne(8,w.$ak),ne(9,p.$Mfc),ne(10,b.$tk),ne(11,a.$Lfc)],l);function u(){return new n.MenuItem({type:"separator"})}}),define(oe[315],ae([0,1,6,20,5,314,2]),function(x,e,n,o,k,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0,e.$3fc=(0,n.$Gi)("menubarMainService");let I=class extends O.$Xc{constructor(a,f,d){super(),this.b=a,this.c=f,this.f=d,this.a=this.g()}async g(){return await this.c.when(o.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$2fc))}async updateMenubar(a,f){this.f.trace("menubarService#updateMenubar",a),(await this.a).updateMenu(f,a)}};e.$4fc=I,e.$4fc=I=ke([ne(0,n.$Fi),ne(1,o.$hfc),ne(2,k.$ak)],I)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[316],ae([0,1,14,21,107,27,22,23,39,4,31,48,2,12,10,71,3,37,19,13,7,198,70,18,53,24,15,6,20,5,73,74,75,34,51,137,29,135,307,30,104,89,60,52,77,40,59,72,85]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T,A,M,U,C,z,re,Z,le,X,ee,q,j,B,G,ce,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0,R=et(R);function he(F){return(0,Z.$Vi)(F?.workspace)}function se(F){return(0,Z.$Qi)(F?.workspace)}let _=class extends g.$Xc{constructor(N,W,H,J,Y,V,ie,de,me,we,Oe,Se,Pe,Ie,$e,Q,ue,fe,be,Re,We){super(),this.s=N,this.t=W,this.u=H,this.w=J,this.z=Y,this.C=V,this.D=ie,this.F=de,this.G=me,this.H=we,this.I=Oe,this.J=Se,this.L=Pe,this.M=Ie,this.N=$e,this.O=Q,this.P=ue,this.Q=fe,this.R=be,this.S=Re,this.U=We,this.a=this.B(new a.$ne),this.onDidOpenWindow=this.a.event,this.b=this.B(new a.$ne),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new a.$ne),this.onDidDestroyWindow=this.c.event,this.f=this.B(new a.$ne),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new a.$ne),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new a.$ne),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new a.$ne),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new a.$ne),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new re.$ogc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const W=new g.$Wc;if(W.add(a.Event.any(N.onDidClose,N.onDidDestroy)(()=>W.dispose())),N.config.extensionDevelopmentPath)for(const H of N.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(H));N.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,W){const H=this.G.args,J=W?.remoteAuthority||void 0,Y=!0,V=W?.forceReuseWindow,ie=!V;return this.open({...N,cli:H,forceEmpty:Y,forceNewWindow:ie,forceReuseWindow:V,remoteAuthority:J,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(N,W){N.focus(),this.X(W,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const W=[],H=[],J=[],Y=[],V=[];let ie,de=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const Ie of me)se(Ie)?N.addMode?W.push(Ie):H.push(Ie):he(Ie)?J.push(Ie):Ie.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),ie.filesToOpenOrCreate.push(Ie)):Ie.backupPath?V.push({backupFolder:(0,h.$qc)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):de++;N.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),N.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&N.waitMarkerFileURI&&(ie.filesToWait={paths:(0,O.$Kb)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(Y.push(...this.N.getUntitledWorkspaces()),J.push(...Y),V.push(...this.J.getEmptyWindowBackups())):V.length=0;const{windows:we,filesOpenedInWindow:Oe}=await this.Y(N,J,H,V,de,ie,W);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${J.length}, foldersToOpen: ${H.length}, emptyToRestore: ${V.length}, emptyToOpen: ${de})`),we.length>1)if(Oe)Oe.focus();else{const Ie=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,Q=!0;if(Ie){const ue=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,Q=!1)}if($e)for(let ue=we.length-1;ue>=0;ue--){const fe=we[ue];if(!(fe.openedWorkspace&&Y.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&V.some(be=>fe.backupPath&&be.backupFolder===(0,h.$qc)(fe.backupPath)))){fe.focus(),Q=!1;break}}Q&&we[we.length-1].focus()}const Se=ie&&ie.filesToDiff.length>0,Pe=ie&&ie.filesToMerge.length>0;if(!we.some(Ie=>Ie.isExtensionDevelopmentHost)&&!Se&&!Pe&&!N.noRecentEntry){const Ie=[];for(const $e of me)he($e)&&!$e.transient?Ie.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):se($e)?Ie.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Ie.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Ie)}return this.X(N,we),we}X(N,W){const H=N.waitMarkerFileURI;N.context===C.OpenContext.CLI&&H&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(H)}catch{}})()}async Y(N,W,H,J,Y,V,ie){const de=[];let me;function we(ue,fe){de.push(ue),fe&&(me=ue,V=void 0)}let{openFolderInNewWindow:Oe,openFilesInNewWindow:Se}=this.pb(N);if(!N.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,fe=this.vb(ue);fe&&we(this.ab(fe,ie.map(be=>be.workspace.uri)))}const Pe=H.length+W.length+J.length;if(V&&Pe===0){const ue=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],fe=this.getWindows().filter(Re=>V&&(0,m.$mh)(Re.remoteAuthority,V.remoteAuthority));let be;ue?.fileUri&&!Se&&((N.context===C.OpenContext.DESKTOP||N.context===C.OpenContext.CLI||N.context===C.OpenContext.DOCK)&&(be=await(0,z.$6ec)(fe,ue.fileUri,async Re=>Re.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Re.configPath):void 0)),be||(be=this.wb(fe))),be?(0,Z.$Vi)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,Z.$Qi)(be.openedWorkspace)?H.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(N,be,V),!0):we(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const Ie=(0,O.$Pb)(W,ue=>ue.workspace.id);if(Ie.length>0){const ue=(0,O.$Kb)(Ie.map(fe=>(0,z.$7ec)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,m.$mh)(V?.remoteAuthority,fe.remoteAuthority)?V:void 0;we(this.Z(N,fe,be),!!be),Oe=!0}for(const fe of Ie){if(ue.some(We=>We.openedWorkspace&&We.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Re=(0,m.$mh)(V?.remoteAuthority,be)?V:void 0;we(await this.cb(N,fe,Oe,Re),!!Re),Oe=!0}}const $e=(0,O.$Pb)(H,ue=>m.$$g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,O.$Kb)($e.map(fe=>(0,z.$7ec)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,m.$mh)(V?.remoteAuthority,fe.remoteAuthority)?V:void 0;we(this.Z(N,fe,be),!!be),Oe=!0}for(const fe of $e){if(ue.some(We=>(0,Z.$Qi)(We.openedWorkspace)&&m.$$g.isEqual(We.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Re=(0,m.$mh)(V?.remoteAuthority,be)?V:void 0;we(await this.cb(N,fe,Oe,Re),!!Re),Oe=!0}}const Q=(0,O.$Pb)(J,ue=>ue.backupFolder);if(Q.length>0)for(const ue of Q){const fe=ue.remoteAuthority,be=(0,m.$mh)(V?.remoteAuthority,fe)?V:void 0;we(await this.bb(N,!0,fe,be,ue),!!be),Oe=!0}if(de.length===0||V){V&&!Y&&Y++;const ue=V?V.remoteAuthority:N.remoteAuthority;for(let fe=0;fe<Y;fe++)we(await this.bb(N,Oe,ue,V),!!V),Oe=!0}return{windows:(0,O.$Pb)(de),filesOpenedInWindow:me}}Z(N,W,H){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:H}),this.$(W);const J={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToMerge:H?.filesToMerge,filesToWait:H?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",I.CancellationToken.None,J),W}$(N){let W=N;const H=n.BrowserWindow.getFocusedWindow();if(H&&H.id!==N.id){const J=this.U.getWindowByWebContents(H.webContents);J&&J.parentId===N.id&&(W=J)}W.focus()}ab(N,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),N.focus();const H={foldersToAdd:W};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,H),N}bb(N,W,H,J,Y){this.z.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:H,filesToOpen:J,forceNewWindow:W});let V;return!W&&typeof N.contextWindowId=="number"&&(V=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:H,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:J,windowToUse:V,emptyWindowBackupInfo:Y,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,W,H,J,Y){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:J}),!H&&!Y&&typeof N.contextWindowId=="number"&&(Y=this.getWindowById(N.contextWindowId)),this.qb({workspace:W.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:J,windowToUse:Y,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let W,H=!1,J=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(W=await this.eb(N),H=!0):N.forceEmpty?W=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(W=await this.fb(N.cli),W.length===0&&W.push(Object.create(null)),H=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),J=!0),!N.addMode&&H){const Y=W.filter(V=>se(V));if(Y.length>1){const V=Y[0].remoteAuthority;if(Y.every(ie=>(0,m.$mh)(ie.remoteAuthority,V))){const ie=await this.N.createUntitledWorkspace(Y.map(de=>({uri:de.workspace.uri})));W.push({workspace:ie,remoteAuthority:V}),W=W.filter(de=>!se(de))}}}if(N.initialStartup&&!J&&this.L.getValue("window")?.restoreWindows==="preserve"){const Y=await this.hb();W.unshift(...Y.filter(V=>he(V)||se(V)||V.backupPath))}return W}async eb(N){const W={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},H=await Promise.all((0,O.$Kb)(N.urisToOpen||[]).map(async J=>{const Y=await this.jb(J,W);if(Y)return Y.label=J.label,Y;const V=this.lb(J);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(0,null)],message:V.scheme===w.Schemas.file?(0,t.localize)(1,null):(0,t.localize)(2,null),detail:V.scheme===w.Schemas.file?(0,t.localize)(3,null,(0,d.$Ww)(V,{os:b.OS,tildify:this.G})):(0,t.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Kb)(H)}async fb(N){const W=[],H={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},J=N["folder-uri"];if(J){const ie=await Promise.all(J.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},H)}));W.push(...(0,O.$Kb)(ie))}const Y=N["file-uri"];if(Y){const ie=await Promise.all(Y.map(de=>{const me=this.gb(de);if(me)return this.jb((0,Z.$_i)(de)?{workspaceUri:me}:{fileUri:me},H)}));W.push(...(0,O.$Kb)(ie))}const V=await Promise.all(N._.map(ie=>H.remoteAuthority?this.ob(ie,H):this.mb(ie,H)));return W.push(...(0,O.$Kb)(V)),W}gb(N){try{const W=P.URI.parse(N);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${N}, ${W.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];N!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const H=await Promise.all(W.map(async J=>{if(J.workspace){const Y=await this.jb({workspaceUri:J.workspace.configPath},{remoteAuthority:J.remoteAuthority,rejectTransientWorkspaces:!0});if(he(Y))return Y}else if(J.folderUri){const Y=await this.jb({folderUri:J.folderUri},{remoteAuthority:J.remoteAuthority});if(se(Y))return Y}else if(N!=="folders"&&J.backupPath)return{backupPath:J.backupPath,remoteAuthority:J.remoteAuthority}}));return(0,O.$Kb)(H)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,W=Object.create(null)){const H=this.lb(N);return H.scheme===w.Schemas.file?((0,M.$2D)(N)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(H.fsPath,W)):this.kb(N,W)}kb(N,W){let H=this.lb(N);const J=(0,T.$hn)(H)||W.remoteAuthority;if(H=(0,m.$oh)((0,m.$ih)(H)),(0,M.$2D)(N)){if(W.gotoLineMode){const{path:Y,line:V,column:ie}=(0,f.$Ng)(H.path);return{fileUri:H.with({path:Y}),options:{selection:V?{startLineNumber:V,startColumn:ie||1}:void 0},remoteAuthority:J}}return{fileUri:H,remoteAuthority:J}}else if((0,M.$ZD)(N))return{workspace:(0,le.$0ec)(H),remoteAuthority:J};return{workspace:(0,le.$$ec)(H),remoteAuthority:J}}lb(N){return(0,M.$ZD)(N)?N.workspaceUri:(0,M.$1D)(N)?N.folderUri:N.fileUri}async mb(N,W,H){let J,Y;W.gotoLineMode&&({path:N,line:J,column:Y}=(0,f.$Ng)(N)),N=(0,f.$Hg)((0,h.$kc)(N),(0,$.cwd)());try{const V=await o.Promises.stat(N);if(V.isFile()){if(!W.forceOpenWorkspaceAsFile){const ie=await this.N.resolveLocalWorkspace(P.URI.file(N));if(ie)return ie.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:l.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:P.URI.file(N),type:l.FileType.File,exists:!0,options:{selection:J?{startLineNumber:J,startColumn:Y||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,le.$$ec)(P.URI.file(N),V),type:l.FileType.Directory,exists:!0};if(!b.$i&&N==="/dev/null")return{fileUri:P.URI.file(N),type:l.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!H)return this.nb(N,W);const ie=P.URI.file(N);if(this.M.removeRecentlyOpened([ie]),W.ignoreFileNotFound)return{fileUri:ie,type:l.FileType.File,exists:!1}}}async nb(N,W){const H=P.URI.file(N),{response:J,checkboxChecked:Y}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],message:(0,t.localize)(8,null,H.authority),detail:(0,t.localize)(9,null,(0,d.$Ww)(H,{os:b.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10,null,H.authority),cancelId:1});if(J===0){if((0,k.addUNCHostToAllowlist)(H.authority),Y){const V={channel:"vscode:configureAllowedUNCHost",args:H.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.mb(N,W,!0)}if(J===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,W)}ob(N,W){const H=N.charCodeAt(0),J=W.remoteAuthority;let Y,V;W.gotoLineMode&&({path:N,line:Y,column:V}=(0,f.$Ng)(N)),H!==v.CharCode.Slash&&((0,f.$Gg)(H)&&N.charCodeAt(N.charCodeAt(1))===v.CharCode.Colon&&(N=(0,f.$zg)(N)),N=`/${N}`);const ie=P.URI.from({scheme:w.Schemas.vscodeRemote,authority:J,path:N});if(N.charCodeAt(N.length-1)!==v.CharCode.Slash){if((0,Z.$_i)(N))return W.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:Y?{startLineNumber:Y,startColumn:V||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,le.$0ec)(ie),remoteAuthority:J};if(W.gotoLineMode||h.$jc.basename(N).indexOf(".")!==-1)return{fileUri:ie,options:{selection:Y?{startLineNumber:Y,startColumn:V||1}:void 0},remoteAuthority:J}}return{workspace:(0,le.$$ec)(ie),remoteAuthority:J}}pb(N){const W=this.L.getValue("window"),H=W?.openFoldersInNewWindow||"default",J=W?.openFilesInNewWindow||"off";let Y=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(H==="on"||H==="off")&&(Y=H==="on");let V=!1;return N.forceNewWindow||N.forceReuseWindow?V=!!N.forceNewWindow&&!N.forceReuseWindow:(b.$j?N.context===C.OpenContext.DOCK&&(V=!0):N.context!==C.OpenContext.DIALOG&&N.context!==C.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!N.cli.extensionDevelopmentPath&&(J==="on"||J==="off")&&(V=J==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(N,W){const H=(0,z.$8ec)(this.getWindows(),N);if(H)return this.I.reload(H,W.cli),H.focus(),[H];let J=W.cli["folder-uri"]||[],Y=W.cli["file-uri"]||[],V=W.cli._;if(!V.length&&!J.length&&!Y.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(P.URI.isUri(we)?we.scheme===w.Schemas.file?V=[we.fsPath]:J=[we.toString()]:we.configPath.scheme===w.Schemas.file?V=[(0,m.$8g)(we.configPath)]:Y=[we.configPath.toString()])}let ie=W.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=P.URI.parse(me),Oe=(0,T.$hn)(we);Oe&&(ie?(0,m.$mh)(Oe,ie)||this.z.error("more than one extension development path authority"):ie=Oe)}V=V.filter(me=>{const we=P.URI.file(me);return(0,z.$7ec)(this.getWindows(),we)?!1:(0,m.$mh)((0,T.$hn)(we),ie)}),J=J.filter(me=>{const we=this.gb(me);return we&&(0,z.$7ec)(this.getWindows(),we)?!1:we?(0,m.$mh)((0,T.$hn)(we),ie):!1}),Y=Y.filter(me=>{const we=this.gb(me);return we&&(0,z.$7ec)(this.getWindows(),we)?!1:we?(0,m.$mh)((0,T.$hn)(we),ie):!1}),W.cli._=V,W.cli["folder-uri"]=J,W.cli["file-uri"]=Y;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!V.length&&!J.length&&!Y.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ie,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(N){const W=this.L.getValue("window"),H=this.getLastActiveWindow(),Y=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??H?.profile??this.H.defaultProfile;let V;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(V=N.windowToUse||H,V&&V.focus());const ie={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,h.$mc)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:Y},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:N.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(V){const de=V.config;!ie.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=de.extensionDevelopmentPath,ie.extensionDevelopmentKind=de.extensionDevelopmentKind,ie["enable-proposed-api"]=de["enable-proposed-api"],ie.verbose=de.verbose,ie["inspect-extensions"]=de["inspect-extensions"],ie["inspect-brk-extensions"]=de["inspect-brk-extensions"],ie.debugId=de.debugId,ie.extensionEnvironment=de.extensionEnvironment,ie["extensions-dir"]=de["extensions-dir"],ie["disable-extensions"]=de["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:de?.loggers.window??ie.loggers.window}}else{const de=this.r.getNewWindowState(ie);(0,p.mark)("code/willCreateCodeWindow");const me=V=this.O.createInstance(U.$ffc,{state:de,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new g.$Wc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(a.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(a.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Se,y:Pe})=>this.m.fire({window:me,x:Se,y:Pe})));const Oe=(0,E.$rg)(me.win?.webContents);Oe.removeAllListeners("devtools-reload-page"),we.add(a.Event.fromNodeEventEmitter(Oe,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ie.windowId=V.id,V.isReady?this.I.unload(V,q.UnloadReason.LOAD).then(async de=>{de||await this.rb(V,ie,N,Y)}):await this.rb(V,ie,N,Y),V}async rb(N,W,H,J){if(W.extensionDevelopmentPath||((0,Z.$Vi)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,Z.$Qi)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:H.emptyWindowBackupInfo?.backupFolder??(0,le.$_ec)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const Y=W.workspace??(0,Z.$Ui)(W.backupPath,!1),V=this.sb(H,Y,J),ie=V instanceof Promise?await V:V;W.profiles.profile=ie,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(Y,ie)}N.load(W)}sb(N,W,H){return N.forceProfile?this.H.profiles.find(J=>J.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??H}tb(N,W){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=n.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(W=>(0,m.$mh)(W.remoteAuthority,N)))}wb(N){return(0,C.$3ec)(N)}sendToFocused(N,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,...W)}sendToOpeningWindow(N,...W){this.B(a.Event.once(this.onDidSignalReadyWindow)(H=>{H.sendWhenReady(N,I.CancellationToken.None,...W)}))}sendToAll(N,W,H){for(const J of this.getWindows())H&&H.indexOf(J.id)>=0||J.sendWhenReady(N,I.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const W=n.BrowserWindow.fromWebContents(N);if(!W)return;const H=this.getWindowById(W.id);return H?.matches(N)?H:void 0}};e.$rgc=_,e.$rgc=_=ke([ne(4,y.$ak),ne(5,ce.$cfc),ne(6,A.$gR),ne(7,B.$to),ne(8,s.$Pec),ne(9,G.$4ec),ne(10,S.$hfc),ne(11,r.$Uec),ne(12,i.$aj),ne(13,X.$Zfc),ne(14,ee.$afc),ne(15,u.$Fi),ne(16,c.$Vec),ne(17,l.$al),ne(18,L.$Xec),ne(19,j.$Yec),ne(20,K.$Lfc)],_)}),define(oe[317],ae([0,1,70,29,89,60]),function(x,e,n,o,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let O=class{constructor(v,a,f,d){this.a=v,this.b=a,this.c=f,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(v,a){const f=this.b.getWindowById(v);if(f)return this.a.enterWorkspace(f,this.b.getWindows(),a)}createUntitledWorkspace(v,a,f){return this.a.createUntitledWorkspace(a,f)}deleteUntitledWorkspace(v,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(v,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(v){return this.c.getRecentlyOpened()}addRecentlyOpened(v,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(v,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(v){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$tgc=O,e.$tgc=O=ke([ne(0,D.$afc),ne(1,o.$1ec),ne(2,k.$Zfc),ne(3,n.$Uec)],O)}),define(oe[318],ae([0,1,14,107,35,27,17,55,16,31,4,322,48,2,12,10,3,13,7,33,163,44,164,119,298,167,70,291,18,299,97,136,53,98,225,24,69,101,213,302,215,216,217,15,229,100,84,6,99,224,308,309,292,300,20,5,315,65,28,75,303,102,34,281,88,129,25,258,259,58,50,271,296,310,297,311,133,273,274,275,278,306,51,29,316,280,30,103,89,317,60,40,238,59,251,57,87,134,283,301,288,8,261,282,233,72,305,277,22,76,304,269,244,66,85,313,79]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T,A,M,U,C,z,re,Z,le,X,ee,q,j,B,G,ce,K,he,se,_,F,N,W,H,J,Y,V,ie,de,me,we,Oe,Se,Pe,Ie,$e,Q,ue,fe,be,Re,We,Fe,Te,Be,Ge,Qe,He,Xe,Ye,_e,Ne,te,ge,pe,ye,Me,Ue,Je,lt,at,rt,tt,ut,ct,ft,gt,Ot,Tt,mt,$t,Lt,jt,Mt,pt,Ft,Et,dt,Nt,Ct,wt,Wt,St,Bt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;let yt=class extends w.$Xc{static{bt=this}static{this.a={[h.Schemas.file]:"security.promptForLocalFileProtocolHandling",[h.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,Le,je,ve,Ee,qe,xe,Ke,Ce,Ve,ze,Ze){super(),this.g=Ae,this.h=Le,this.j=je,this.m=ve,this.n=Ee,this.s=qe,this.t=xe,this.u=Ke,this.w=Ce,this.y=Ve,this.z=ze,this.C=Ze,this.D(),this.F()}D(){const Ae=Ce=>Ce?.startsWith(`${h.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ce,Ve,ze,Ze)=>Ae(Ze.requestingUrl)?ze(Le.has(Ve)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ce,Ve,ze,Ze)=>Ae(Ze.requestingUrl)?Le.has(Ve):!1);const je=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,h.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ce=>{for(let Ve=Ce;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Ce=>Ce.resourceType==="xhr"||ve(Ce.frame),qe=Ce=>{const Ve=Ce.frame;if(!Ve||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const Ze of ze)if(Ve.processId===Ze.webContents.mainFrame.processId)return!0;return!1},xe=(Ce,Ve)=>{if(Ce.path!=="/index.html")return!0;const ze=Ve.frame;if(!ze||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&ze.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ce,Ve)=>{const ze=m.URI.parse(Ce.url);return ze.scheme===h.Schemas.vscodeWebview&&!xe(ze,Ce)?(this.m.error("Blocked vscode-webview request",Ce.url),Ve({cancel:!0})):ze.scheme===h.Schemas.vscodeFileResource&&!qe(Ce)?(this.m.error("Blocked vscode-file request",Ce.url),Ve({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?Ve({cancel:!Ee(Ce)}):Ve({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ve)=>{const ze=Ce.responseHeaders,Ze=ze["content-type"]||ze["Content-Type"];if(Ze&&Array.isArray(Ze)){const it=m.URI.parse(Ce.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ze.some(ot=>ot.toLowerCase().includes("image/svg")))return Ve({cancel:!Ee(Ce)})}return Ve({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ve)=>{if(Ce.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ce.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ve({cancel:!1,responseHeaders:ze})}return Ve({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,p.$mc)(this.s.codeCachePath,"chrome")),b.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,o.disableUNCAccessRestrictions)():(0,o.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,v.setUnexpectedErrorHandler)(je=>this.H(je)),process.on("uncaughtException",je=>{(0,v.$2)(je)||(0,v.$3)(je)}),process.on("unhandledRejection",je=>(0,v.$3)(je)),f.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,P.$GX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ne.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${h.Schemas.vscodeFileResource}://${h.$Zg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Ae=[],Le;n.app.on("open-file",(je,ve)=>{ve=(0,kt.$nm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Ae.push((0,pe.$_i)(ve)?{workspaceUri:m.URI.file(ve)}:{fileUri:m.URI.file(ve)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Ne.OpenContext.DOCK,cli:this.s.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Le=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ne.OpenContext.DESKTOP})}),k.$FX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Ee,qe;return ve?.config?(Ee=ve.config,qe={...process.env,...ve.config.userEnv}):(Ee=this.s.args,qe=process.env),this.X(Ee,qe,!1)}),k.$FX.handle("vscode:writeNlsFile",(je,ve,Ee)=>{const qe=this.G([ve]);if(!qe||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,O.$Pe.fromString(Ee))}),k.$FX.handle("vscode:readNlsFile",async(je,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),k.$FX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),k.$FX.on("vscode:openDevTools",je=>je.sender.openDevTools()),k.$FX.on("vscode:reloadWindow",je=>je.sender.reload()),k.$FX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Ee=this.b?.getWindowByWebContents(je.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Ae){let Le;for(const je of Ae)typeof je=="string"&&(typeof Le!="string"?Le=je:Le=(0,p.$mc)(Le,je));if(!(typeof Le!="string"||!(0,p.$lc)(Le)||!(0,a.$Fg)(Le,this.s.cachedLanguagesPath,!b.$k)))return m.URI.file(Le)}H(Ae){if(Ae){const Le={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.m.error(Ae.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ae=this.z.win32AppUserModelId;b.$i&&Ae&&n.app.setAppUserModelId(Ae);try{b.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Le=new r.$MX;f.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===W.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Ee]=await Promise.all([(0,$t.$Cgc)(this.w,this.m),(0,$t.$Dgc)(this.w,this.m),(0,$t.$Egc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:qe,sharedProcessClient:xe}=this.P(je,ve,Ee),Ke=await this.Q(je,ve,Ee,qe);this.B(Ke.createInstance(c.$rfc)),this.B(Ke.createInstance(Ot.$xgc)),Ke.invokeFunction(ze=>this.R(ze,Le,xe));const Ce=await Ke.invokeFunction(ze=>this.I(ze,Le));this.J(Le),this.t.phase=W.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.S(ze,Ce)),this.t.phase=W.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new mt.$Sh(()=>{this.B((0,mt.$Wh)(()=>this.t.phase=W.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Ae,Le){const je=this.b=Ae.get(Ne.$1ec),ve=Ae.get(Be.$uY),Ee=this.f=Ae.get(Y.$Mfc),qe=Ae.get(T.$Vec),xe=this;ve.registerHandler({async handleURL(it,ot){return xe.O(je,qe,ve,it,ot)}});const Ke=this.B(new ge.$sgc({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ce=new t.$oi(it=>Ke.getActiveClientId().then(ot=>it===ot)),Ve=new Ge.$jgc(Ce,this.m),ze=Le.getChannel("urlHandler",Ve);ve.registerHandler(new Ge.$igc(ze));const Ze=await this.L(je,qe);return this.B(new He.$kgc(Ze?.urls,ve,je,this.s,this.z,this.m)),Ze}J(Ae){const Le=()=>({statusCode:404,data:"Not found"}),je=new Wt.$X(()=>Ae.getChannel(wt.$Lgc,new wt.$Mgc));n.protocol.registerBufferProtocol(h.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const qe=m.URI.parse(ve.url);if(!qe.authority.startsWith("window:"))return Ee(Le());je.value.call(wt.$Kgc,[qe]).then(xe=>Ee({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),Ee({statusCode:500,data:String(xe)})})})}async L(Ae,Le){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Ee=[...je,...ve].map(Ke=>{try{return{uri:m.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),qe=[],xe=[];for(const Ke of Ee){if(!Ke)continue;const Ce=this.N(Ke.uri);if(Ce)if(await this.M(Ce,Ae,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ce),qe.push(Ce);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),xe.push(Ke)}return{urls:xe,openables:qe}}async M(Ae,Le,je){let ve,Ee;if((0,_e.$ZD)(Ae)?(ve=Ae.workspaceUri,Ee=(0,s.localize)(0,null,ve.scheme===h.Schemas.file?(0,g.$Ww)(ve,{os:b.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,_e.$1D)(Ae)?(ve=Ae.folderUri,Ee=(0,s.localize)(1,null,ve.scheme===h.Schemas.file?(0,g.$Ww)(ve,{os:b.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Ae.fileUri,Ee=(0,s.localize)(2,null,ve.scheme===h.Schemas.file?(0,g.$Ww)(ve,{os:b.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==h.Schemas.file&&ve.scheme!==h.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ke}=await je.showMessageBox({type:"warning",buttons:[(0,s.localize)(3,null),(0,s.localize)(4,null)],message:Ee,detail:(0,s.localize)(5,null),checkboxLabel:ve.scheme===h.Schemas.file?(0,s.localize)(6,null):(0,s.localize)(7,null),cancelId:1});if(xe!==0)return!0;if(Ke){const Ce={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===h.Schemas.file?"local":"remote"};Le.sendToFocused(Ce.channel,Ce.args),Le.sendToOpeningWindow(Ce.channel,Ce.args)}return!1}N(Ae){if(Ae.path){if(Ae.authority===h.Schemas.file){const Le=m.URI.file(Ae.fsPath);return(0,pe.$_i)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Ae.authority===h.Schemas.vscodeRemote){const Le=Ae.path.indexOf(p.$jc.sep,1);if(Le!==-1){const je=Ae.path.substring(1,Le),ve=Ae.path.substring(Le);let Ee=Ae.query;const qe=new URLSearchParams(Ae.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Ee=qe.toString());const xe=m.URI.from({scheme:h.Schemas.vscodeRemote,authority:je,path:ve,query:Ee,fragment:Ae.fragment});return(0,pe.$_i)(ve)?{workspaceUri:xe}:/:[\d]+$/.test(ve)?{fileUri:xe}:{folderUri:xe}}}}}async O(Ae,Le,je,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:m.URI.parse(ve.query).path,query:""}));let qe=!1;const xe=new URLSearchParams(ve.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),xe.delete("windowId"),ve=ve.with({query:xe.toString()}),qe=!0):b.$j&&Ae.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),qe=!0);const Ke=xe.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),xe.delete("continueOn"),ve=ve.with({query:xe.toString()}),this.s.continueOn=Ke??void 0);const Ce=this.N(ve);return Ce?await this.M(Ce,Ae,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ce,ve.toString(!0)),(0,Et.$Rb)(await Ae.open({context:Ne.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ce],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Rb)(await Ae.open({context:Ne.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ie.$hn)(ve)}))?.ready(),je.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Ae,Le,je){const ve=this.B(this.j.createInstance(de.$8fc,Ae,Le,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new i.$NX(xe,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Ae,Le,je,ve){const Ee=new K.$Ei;switch(process.platform){case"win32":Ee.set(fe.$EY,new G.$Di(Te.$ggc));break;case"linux":b.$l?Ee.set(fe.$EY,new G.$Di(Fe.$fgc,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(fe.$EY,new G.$Di(We.$egc));break;case"darwin":Ee.set(fe.$EY,new G.$Di(Re.$dgc));break}Ee.set(Ne.$1ec,new G.$Di(te.$rgc,[Ae,Le,je,this.h],!1)),Ee.set(St.$Lfc,new G.$Di(Bt.$Ngc,void 0,!1));const qe=new T.$Wec(this.m,this.z);Ee.set(T.$Vec,qe),Ee.set(N.$Tfc,new G.$Di(N.$Ufc,void 0,!1)),Ee.set(L.$xfc,new G.$Di(L.$yfc,void 0,!1)),Ee.set(R.$Tm,t.ProxyChannel.toService((0,t.$mi)(ve.then(ze=>ze.getChannel("diagnostics"))))),Ee.set(he.$k_b,new G.$Di(se.$Ofc,[this.h])),Ee.set(he.$l_b,new G.$Di(_.$Pfc,[this.h])),Ee.set(A.$oY,new G.$Di(M.$zfc)),Ee.set(F.$Qfc,new G.$Di(F.$Rfc)),Ee.set(Y.$Mfc,new G.$Di(Y.$Nfc,void 0,!1)),Ee.set(Xe.$lgc,new G.$Di(Ye.$ngc)),Ee.set(J.$3fc,new G.$Di(J.$4fc)),Ee.set(re.$Afc,new G.$Di(Z.$Cfc)),Ee.set(Se.$nfc,new G.$Di(Se.$ofc)),Ee.set(Se.$pfc,new G.$Di(Se.$qfc));const xe=new Nt.$Jgc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Ct.$Os(xe,this.u,this.m,this.n);Ee.set(dt.$ps,Ke),b.$i?Ee.set(le.$Dfc,new G.$Di(X.$Efc)):b.$j?Ee.set(le.$Dfc,new G.$Di(X.$Ffc)):b.$k&&Ee.set(le.$Dfc,new G.$Di(X.$Gfc));const Ce=new u.$sfc(this.s,this.u,this.m,this.w);Ee.set(l.$Uec,Ce);const Ve=new Je.$bfc(this.s,this.m,this.C,Ce,qe);if(Ee.set(Je.$afc,Ve),Ee.set(ye.$Yhb,new G.$Di(Ue.$tgc,void 0,!1)),Ee.set(Me.$Zfc,new G.$Di(Me.$1fc,void 0,!1)),Ee.set(Be.$uY,new G.$Di(Qe.$wY,void 0,!1)),(0,ue.$Cp)(this.z,this.s)){const ze=(0,ue.$Hp)(this.z,this.u),Ze=(0,t.$mi)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new $e.$$fc(Ze),ot=(0,Pe.$tp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Ae,Le,je,ze),nt=(0,ue.$Ip)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Ee.set(Ie.$_l,new G.$Di(Q.$fs,[ht],!1))}else Ee.set(Ie.$_l,ue.$xp);return Ee.set(ct.$Hq,new G.$Di(Lt.$nR,void 0,!0)),Ee.set(ft.$Lq,new G.$Di(gt.$wgc,void 0,!0)),Ee.set(pt.$Hgc,new G.$Di(pt.$Igc,void 0,!0)),await mt.Promises.settled([Ce.initialize(),Ve.initialize()]),this.j.createChild(Ee)}R(Ae,Le,je){const ve=this.B(new w.$Wc),Ee=t.ProxyChannel.fromService(Ae.get(N.$Tfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const qe=t.ProxyChannel.fromService(Ae.get(L.$xfc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const xe=ve.add(new at.$ugc(Ae.get(lt.$to)));Le.registerChannel("policy",xe),je.then(st=>st.registerChannel("policy",xe));const Ke=this.y.getProvider(h.Schemas.file);(0,$.$qg)(Ke instanceof B.$rr);const Ce=ve.add(new j.$Hfc(Ke,this.m,this.s));Le.registerChannel(ee.$9Q,Ce),je.then(st=>st.registerChannel(ee.$9Q,Ce));const Ve=t.ProxyChannel.fromService(Ae.get(rt.$4ec),ve);Le.registerChannel("userDataProfiles",Ve),je.then(st=>st.registerChannel("userDataProfiles",Ve));const ze=new tt.$as(Ae.get(ut.$6p));je.then(st=>st.registerChannel("request",ze));const Ze=new be.$_fc(Ae.get(fe.$EY));Le.registerChannel("update",Ze);const it=t.ProxyChannel.fromService(Ae.get(he.$k_b),ve);Le.registerChannel("issue",it);const ot=t.ProxyChannel.fromService(Ae.get(he.$l_b),ve);Le.registerChannel("process",ot);const nt=t.ProxyChannel.fromService(Ae.get(A.$oY),ve);Le.registerChannel("encryption",nt);const ht=t.ProxyChannel.fromService(Ae.get(me.$Zl),ve);Le.registerChannel("sign",ht);const vt=t.ProxyChannel.fromService(Ae.get(F.$Qfc),ve);Le.registerChannel("keyboardLayout",vt),this.f=Ae.get(Y.$Mfc);const Pt=t.ProxyChannel.fromService(this.f,ve);Le.registerChannel("nativeHost",Pt),je.then(st=>st.registerChannel("nativeHost",Pt));const Ut=t.ProxyChannel.fromService(Ae.get(ye.$Yhb),ve);Le.registerChannel("workspaces",Ut);const zt=t.ProxyChannel.fromService(Ae.get(J.$3fc),ve);Le.registerChannel("menubar",zt);const qt=t.ProxyChannel.fromService(Ae.get(Be.$uY),ve);Le.registerChannel("url",qt);const Ht=t.ProxyChannel.fromService(Ae.get(Xe.$lgc),ve);Le.registerChannel("webview",Ht);const It=ve.add(new Oe.$9fc(this.m,Ae.get(Se.$nfc)));Le.registerChannel("storage",It),je.then(st=>st.registerChannel("storage",It));const Vt=ve.add(new Tt.$ygc(Ae.get(Se.$nfc),Ae.get(rt.$4ec),this.m));je.then(st=>st.registerChannel("profileStorageListener",Vt));const xt=t.ProxyChannel.fromService(Ae.get(dt.$ps),ve);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Gt=t.ProxyChannel.fromService(Ae.get(le.$Dfc),ve);Le.registerChannel("externalTerminal",Gt);const Dt=new jt.$Fgc(Ae.get(Mt.$cfc));Le.registerChannel("logger",Dt),je.then(st=>st.registerChannel("logger",Dt));const Kt=new y.$tfc(Ae.get(Ne.$1ec));Le.registerChannel("extensionhostdebugservice",Kt);const Xt=t.ProxyChannel.fromService(Ae.get(re.$Afc),ve);Le.registerChannel(re.$Bfc,Xt);const Yt=t.ProxyChannel.fromService(Ae.get(pt.$Hgc),ve);Le.registerChannel(Ft.$Ggc,Yt)}async S(Ae,Le){const je=this.b=Ae.get(Ne.$1ec);this.c=Ae.get(St.$Lfc);const ve=(0,C.$Km)(process.env)?Ne.OpenContext.CLI:Ne.OpenContext.DESKTOP,Ee=this.s.args;if(Le){if(Le.openables.length>0)return je.open({context:ve,cli:Ee,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,xe=Ee._.length,Ke=!!Ee["folder-uri"],Ce=!!Ee["file-uri"],Ve=Ee["skip-add-to-recently-opened"]===!0,ze=Ee.wait&&Ee.waitMarkerFilePath?m.URI.file(Ee.waitMarkerFilePath):void 0,Ze=Ee.remote||void 0,it=Ee.profile,ot=Ee["profile-temp"];if(!xe&&!Ke&&!Ce){if(Ee["new-window"]||it||ot)return je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:Ze,forceProfile:it,forceTempProfile:ot});if(qe.length)return je.open({context:Ne.OpenContext.DOCK,cli:Ee,urisToOpen:qe.map(nt=>(nt=(0,kt.$nm)(nt),(0,pe.$_i)(nt)?{workspaceUri:m.URI.file(nt)}:{fileUri:m.URI.file(nt)})),noRecentEntry:Ve,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:Ve,waitMarkerFileURI:ze,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:it,forceTempProfile:ot})}U(){this.W(),n.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Ae,Le)=>{Le({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.X(this.s.args,process.env,!0),this.Y(),b.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ae=this.z.win32MutexName;if(b.$i&&Ae)try{const Le=await new Promise((ve,Ee)=>{x(["@vscode/windows-mutex"],ve,Ee)}).then(De),je=new Le.Mutex(Ae);f.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Le){this.m.error(Le)}}async X(Ae,Le,je){try{return await(0,z.$Rm)(this.u,this.m,Ae,Le)}catch(ve){const Ee=(0,I.$rj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,d.parse)(Le),Ee=(0,ue.$Ep)(this.u)>=Ie.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,E.$3g)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Pe.fromString(xe))}else{const qe=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);qe!==Le&&await this.y.writeFile(this.s.argvResource,O.$Pe.fromString(qe))}}catch(Ae){this.m.error(Ae),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Ogc=yt,e.$Ogc=yt=bt=ke([ne(2,ce.$Fi),ne(3,H.$ak),ne(4,H.$bk),ne(5,U.$Pec),ne(6,W.$hfc),ne(7,S.$aj),ne(8,we.$gR),ne(9,q.$al),ne(10,V.$tk),ne(11,rt.$4ec)],yt)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[323],ae([0,1,14,47,7,22,8,55,16,31,4,48,12,10,71,3,37,26,21,44,105,318,9,18,243,257,24,69,208,15,227,100,84,223,99,20,230,5,73,28,74,284,132,295,57,294,102,256,34,58,77,59,40,239,237,2,41,272,72,232,124,128,276,107,270]),function(x,e,n,o,k,D,O,I,v,a,f,d,g,w,h,p,b,$,m,E,P,t,r,i,c,s,l,u,S,y,R,L,T,A,M,U,C,z,re,Z,le,X,ee,q,j,B,G,ce,K,he,se,_,F,N,W,H,J,Y,V,ie,de,me,we,Oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),re=et(re);class Se{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,v.setUnexpectedErrorHandler)(Te=>console.error(Te));const[$e,Q,ue,fe,be,Re,We,Fe]=this.b();try{try{await this.d(ue,Fe,fe,be,We)}catch(Te){throw this.g(ue,We,Te),Te}await $e.invokeFunction(async Te=>{const Be=Te.get(z.$ak),Ge=Te.get(U.$hfc),Qe=Te.get(y.$al),He=Te.get(z.$bk),Xe=await this.f(Be,ue,Ge,$e,We,!0);return m.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Ye=>{Be.warn(`app#startup(): Error writing main lockfile: ${Ye.stack}`)}),Re.logger=He.createLogger("main",{name:(0,r.localize)(0,null)}),f.Event.once(Ge.onWillShutdown)(Ye=>{Qe.dispose(),fe.dispose(),Ye.join("instanceLockfile",m.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$Ogc,Xe,Q).startup()})}catch(Te){$e.invokeFunction(this.j,Te)}}b(){const $e=new M.$Ei,Q=new H.$Wc;process.once("exit",()=>Q.dispose());const ue={_serviceBrand:void 0,...re.default};$e.set(Z.$tk,ue);const fe=new l.$Qec(this.k(),ue),be=this.c(fe);$e.set(l.$Pec,fe);const Re=new V.$dfc((0,z.$ok)(fe),fe.logsHome);$e.set(V.$cfc,Re);const We=new C.$occ(Re.getLogLevel()),Fe=Q.add(new ie.$oR(We,[new z.$hk(Re.getLogLevel())]));$e.set(z.$ak,Fe);const Te=new R.$1q(Fe);$e.set(y.$al,Te);const Be=new L.$rr(Fe);Te.registerProvider(g.Schemas.file,Be);const Ge=new Y.$Ss(Te);$e.set(J.$Kl,Ge);const Qe=new me.$jR(me.SaveStrategy.DELAYED,fe,Fe,Te);$e.set(K.$fR,Qe),$e.set(K.$gR,Qe);const He=new _.$5ec(Qe,Ge,fe,Te,Fe);$e.set(_.$4ec,He),Te.registerProvider(g.Schemas.vscodeUserData,new we.$Zgc(g.Schemas.file,Be,g.Schemas.vscodeUserData,He,Ge,Fe));const Xe=p.$i&&ue.win32RegValueName?Q.add(new N.$Xgc(Fe,ue.win32RegValueName)):fe.policyFile?Q.add(new W.$Ygc(fe.policyFile,Te,Fe)):new F.$vo;$e.set(F.$to,Xe);const Ye=new c.$Vo(He.defaultProfile.settingsResource,Te,Xe,Fe);return $e.set(i.$aj,Ye),$e.set(U.$hfc,new T.$Di(U.$ifc,void 0,!1)),$e.set(j.$6p,new T.$Di(B.$Vgc,void 0,!0)),$e.set(se.$Yec,new T.$Di(se.$Zec)),$e.set(G.$Zl,new T.$Di(ce.$Wgc,void 0,!1)),$e.set(ee.$Bw,new T.$Di(q.$Tgc)),$e.set(le.$Xec,new X.$Qgc(fe,He,Fe)),[new A.$ur($e,!0),be,fe,Ye,Qe,We,ue,He]}c($e){const Q={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(Q[ue]=fe)}),Object.assign(process.env,Q),Q}async d($e,Q,ue,fe,be){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:g.Schemas.file}).fsPath,Q.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,$e.backupHome].map(Re=>Re?m.Promises.mkdir(Re,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),Q.init()}e($e){if(p.$i){const Q=(0,Oe.getUNCHost)($e);Q&&(0,Oe.addUNCHostToAllowlist)(Q)}return $e}async f($e,Q,ue,fe,be,Re){let We;try{(0,h.mark)("code/willStartMainServer"),We=await(0,P.$Bi)(Q.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),f.Event.once(ue.onWillShutdown)(()=>We.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.g(Q,be,Fe),Fe;let Te;try{Te=await(0,P.$Ci)(Q.mainIPCHandle,"main")}catch(He){if(!Re||p.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.h((0,r.localize)(1,null,be.nameShort),(0,r.localize)(2,null),be),He;try{(0,o.unlinkSync)(Q.mainIPCHandle)}catch(Xe){throw $e.warn("Could not delete obsolete instance handle",Xe),Xe}return this.f($e,Q,ue,fe,be,!1)}if(Q.extensionTestsLocationURI&&!Q.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(He),Te.dispose(),new Error(He)}let Be;!Q.args.wait&&!Q.args.status&&(Be=setTimeout(()=>{this.h((0,r.localize)(3,null,be.nameShort),(0,r.localize)(4,null),be)},1e4));const Ge=E.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Qe=E.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(Q.args.status)return fe.invokeFunction(async()=>{const He=new s.$Zs(he.$xp,be),Xe=await Qe.getMainDiagnostics(),Ye=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),_e=await He.getDiagnostics(Xe,Ye);throw console.log(_e),new v.$db});throw p.$i&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(Q.args,process.env),Te.dispose(),Be&&clearTimeout(Be),new v.$db("Sent env to running instance. Terminating...")}if(Q.args.status)throw console.log((0,r.localize)(5,null,be.nameShort)),new v.$db("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}g($e,Q,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,D.$Kb)([$e.userDataPath,$e.extensionsPath,P.$xi]).map(be=>(0,d.$Ww)(k.URI.file(be),{os:p.OS,tildify:$e}));this.h((0,r.localize)(6,null),(0,r.localize)(7,null,(0,I.$rj)(ue),fe.join(`
`)),Q)}}h($e,Q,ue){n.dialog.showMessageBoxSync((0,de.$$w)({type:"warning",buttons:[(0,r.localize)(8,null)],message:$e,detail:Q},ue).options)}async i($e,Q){if(p.$i){const ue=await $e.getMainProcessId();Q.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(De)).allowSetForegroundWindow(ue)}catch(fe){Q.error(fe)}}}j($e,Q){const ue=$e.get(z.$ak),fe=$e.get(U.$hfc);let be=0;Q&&(Q.isExpected?Q.message&&ue.trace(Q.message):(be=1,Q.stack?ue.error(Q.stack):ue.error(`Startup error: ${Q.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,u.$Hm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const Q=(0,S.$Pgc)($e.verbose);Q&&((0,u.$Jm)(process.argv,"--waitMarkerFilePath",Q),$e.waitMarkerFilePath=Q)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const Q=this.m($e._,$e.goto);$e._=Q}return $e}m($e,Q){const ue=(0,b.cwd)(),fe=$e.map(We=>{let Fe=String(We),Te;Q&&(Te=(0,a.$Ng)(Fe),Fe=Te.path),Fe&&(Fe=this.n(ue,Fe));const Be=(0,a.$Hg)(Fe,ue),Ge=(0,w.$qc)(Be);return Ge&&!(0,a.$Dg)(Ge)?null:Q&&Te?(Te.path=Be,this.o(Te)):Be}),be=p.$i||p.$j,Re=(0,D.$Pb)(fe,We=>We&&be?We.toLowerCase():We||"");return(0,D.$Kb)(Re)}n($e,Q){return p.$i&&(Q=(0,$.$pf)(Q,'"')),Q=(0,$.$nf)((0,$.$nf)(Q," "),"	"),p.$i&&(Q=(0,w.$nc)($e,Q),Q=(0,$.$pf)(Q,".")),Q}o($e){const Q=[$e.path];return typeof $e.line=="number"&&Q.push(String($e.line)),typeof $e.column=="number"&&Q.push(String($e.column)),Q.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/b36286db80c68b7fdc6bfee2f55e0208c8833dfc/core/vs/code/electron-main/main.js.map
