/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/platform/extensions/common/extensions","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ne){for(var e=[],R=0,c=ne.length;R<c;R++)e[R]=ce[ne[R]];return e};define(ce[129],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var R;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class c{static get(){const k=new Map,T=new Map,O=new Map,A=new Map;function w(h,b){h.has(b.detail)||h.set(b.detail,-b.timestamp)}function S(h,b){const v=h.get(b.detail);v&&(v>=0||h.set(b.detail,v+b.timestamp))}let m=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(m=ne.getStats().slice(0).sort((h,b)=>h.timestamp-b.timestamp));for(const h of m)switch(h.type){case R.BeginLoadingScript:w(k,h);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:S(k,h);break;case R.BeginInvokeFactory:w(T,h);break;case R.EndInvokeFactory:S(T,h);break;case R.NodeBeginNativeRequire:w(O,h);break;case R.NodeEndNativeRequire:S(O,h);break;case R.NodeBeginEvaluatingScript:w(A,h);break;case R.NodeEndEvaluatingScript:S(A,h);break}let u=0;O.forEach(h=>u+=h);function $(h){const b=[];return h.forEach((v,d)=>b.push([d,v])),b}return{amdLoad:$(k),amdInvoke:$(T),nodeRequire:$(O),nodeEval:$(A),nodeRequireTotal:u}}static toMarkdownTable(k,T){let O="";const A=[];return k.forEach((w,S)=>{A[S]=w.length}),T.forEach(w=>{w.forEach((S,m)=>{typeof S>"u"&&(S=w[m]="-");const u=S.toString().length;A[m]=Math.max(u,A[m])})}),k.forEach((w,S)=>{O+=`| ${w+" ".repeat(A[S]-w.toString().length)} `}),O+=`|
`,k.forEach((w,S)=>{O+=`| ${"-".repeat(A[S])} `}),O+=`|
`,T.forEach(w=>{w.forEach((S,m)=>{typeof S<"u"&&(O+=`| ${S+" ".repeat(A[m]-S.toString().length)} `)}),O+=`|
`}),O}}e.$W=c}),define(ce[130],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=R,e.$jb=c,e.$kb=N,e.$lb=k,e.$mb=T,e.$nb=O,e.$ob=A,e.$qb=S,e.$rb=m,e.$sb=u,e.$tb=$,e.$ub=h;function R(b,v){const d=c(b,v);if(d!==-1)return b[d]}function c(b,v,d=b.length-1){for(let p=d;p>=0;p--){const P=b[p];if(v(P))return p}return-1}function N(b,v){const d=k(b,v);return d===-1?void 0:b[d]}function k(b,v,d=0,p=b.length){let P=d,g=p;for(;P<g;){const s=Math.floor((P+g)/2);v(b[s])?P=s+1:g=s}return P-1}function T(b,v){const d=O(b,v);return d===b.length?void 0:b[d]}function O(b,v,d=0,p=b.length){let P=d,g=p;for(;P<g;){const s=Math.floor((P+g)/2);v(b[s])?g=s:P=s+1}return P}function A(b,v,d=0,p=b.length){const P=O(b,v,d,p);return P===b.length?-1:P}class w{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(w.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!v(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const d=k(this.e,v,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$pb=w;function S(b,v){if(b.length===0)return;let d=b[0];for(let p=1;p<b.length;p++){const P=b[p];v(P,d)>0&&(d=P)}return d}function m(b,v){if(b.length===0)return;let d=b[0];for(let p=1;p<b.length;p++){const P=b[p];v(P,d)>=0&&(d=P)}return d}function u(b,v){return S(b,(d,p)=>-v(d,p))}function $(b,v){if(b.length===0)return-1;let d=0;for(let p=1;p<b.length;p++){const P=b[p];v(P,b[d])>0&&(d=p)}return d}function h(b,v){for(const d of b){const p=v(d);if(p!==void 0)return p}}}),define(ce[39],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(ce[131],le([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=c,e.$L=N,e.$M=k,e.$N=T;function c(A,w){const S=Object.create(null);for(const m of A){const u=w(m);let $=S[u];$||($=S[u]=[]),$.push(m)}return S}function N(A,w){const S=[],m=[];for(const u of A)w.has(u)||S.push(u);for(const u of w)A.has(u)||m.push(u);return{removed:S,added:m}}function k(A,w){const S=[],m=[];for(const[u,$]of A)w.has(u)||S.push($);for(const[u,$]of w)A.has(u)||m.push($);return{removed:S,added:m}}function T(A,w){const S=new Set;for(const m of w)A.has(m)&&S.add(m);return S}class O{static{R=Symbol.toStringTag}constructor(w,S){this.b=S,this.a=new Map,this[R]="SetWithKey";for(const m of w)this.add(m)}get size(){return this.a.size}add(w){const S=this.b(w);return this.a.set(S,w),this}delete(w){return this.a.delete(this.b(w))}has(w){return this.a.has(this.b(w))}*entries(){for(const w of this.a.values())yield[w,w]}keys(){return this.values()}*values(){for(const w of this.a.values())yield w}clear(){this.a.clear()}forEach(w,S){this.a.forEach(m=>w.call(S,m,m,this))}[Symbol.iterator](){return this.values()}}e.$O=O}),define(ce[88],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=c,e.$_h=N,e.$ai=k;function R(T){return(O,A,w)=>{let S=null,m=null;if(typeof w.value=="function"?(S="value",m=w.value):typeof w.get=="function"&&(S="get",m=w.get),!m)throw new Error("not supported");w[S]=T(m,A)}}function c(T,O,A){let w=null,S=null;if(typeof A.value=="function"?(w="value",S=A.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(w="get",S=A.get),!S)throw new Error("not supported");const m=`$memoize$${O}`;A[w]=function(...u){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,u)}),this[m]}}function N(T,O,A){return R((w,S)=>{const m=`$debounce$${S}`,u=`$debounce$result$${S}`;return function(...$){this[u]||(this[u]=A?A():void 0),clearTimeout(this[m]),O&&(this[u]=O(this[u],...$),$=[this[u]]),this[m]=setTimeout(()=>{w.apply(this,$),this[u]=A?A():void 0},T)}})}function k(T,O,A){return R((w,S)=>{const m=`$throttle$timer$${S}`,u=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,h=`$throttle$pending$${S}`;return function(...b){if(this[u]||(this[u]=A?A():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...b)),this[h])return;const v=this[$]+T;v<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0):(this[h]=!0,this[m]=setTimeout(()=>{this[h]=!1,this[$]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0},v-Date.now()))}})}}),define(ce[8],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=c,e.$2=N,e.$3=k,e.$4=T,e.$5=O,e.$6=A,e.$7=S,e.$9=u,e.$0=$,e.$$=h,e.$ab=v;class R{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?g.isErrorNoTelemetry(t)?new g(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$Y=R,e.$Z=new R;function c(r){e.$Z.setUnexpectedErrorHandler(r)}function N(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function k(r){S(r)||e.$Z.onUnexpectedError(r)}function T(r){S(r)||e.$Z.onUnexpectedExternalError(r)}function O(r){if(r instanceof Error){const{name:t,message:a}=r,i=r.stacktrace||r.stack;return{$isError:!0,name:t,message:a,stack:i,noTelemetry:g.isErrorNoTelemetry(r)}}return r}function A(r){let t;return r.noTelemetry?t=new g:(t=new Error,t.name=r.name),t.message=r.message,t.stack=r.stack,t}const w="Canceled";function S(r){return r instanceof m?!0:r instanceof Error&&r.name===w&&r.message===w}class m extends Error{constructor(){super(w),this.name=this.message}}e.$8=m;function u(){const r=new Error(w);return r.name=r.message,r}function $(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function h(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class b extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=b;function v(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$bb=d;class p extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$cb=p;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=P;class g extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof g)return t;const a=new g;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$eb=g;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$fb=s}),define(ce[19],le([0,1,8,130]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=N,e.$wb=k,e.$xb=T,e.$yb=O,e.$zb=A,e.$Ab=w,e.$Bb=S,e.$Cb=m,e.$Db=u,e.$Eb=$,e.$Fb=h,e.$Gb=b,e.$Hb=v,e.top=d,e.$Jb=p,e.$Kb=g,e.$Lb=s,e.$Mb=r,e.$Nb=t,e.$Ob=a,e.$Pb=i,e.$Qb=n,e.$Rb=o,e.$Sb=l,e.$Tb=f,e.$Ub=I,e.$Vb=L,e.$Wb=E,e.$Xb=y,e.$Yb=C,e.$Zb=F,e.$1b=D,e.$2b=M,e.$3b=K,e.$4b=W,e.$5b=_,e.$6b=H,e.$7b=ie,e.$8b=V,e.$9b=se,e.$0b=he,e.$ac=X;function N(B,j=0){return B[B.length-(1+j)]}function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function T(B,j,x=(ee,J)=>ee===J){if(B===j)return!0;if(!B||!j||B.length!==j.length)return!1;for(let ee=0,J=B.length;ee<J;ee++)if(!x(B[ee],j[ee]))return!1;return!0}function O(B,j){const x=B.length-1;j<x&&(B[j]=B[x]),B.pop()}function A(B,j,x){return w(B.length,ee=>x(B[ee],j))}function w(B,j){let x=0,ee=B-1;for(;x<=ee;){const J=(x+ee)/2|0,oe=j(J);if(oe<0)x=J+1;else if(oe>0)ee=J-1;else return J}return-(x+1)}function S(B,j,x){if(B=B|0,B>=j.length)throw new TypeError("invalid index");const ee=j[Math.floor(j.length*Math.random())],J=[],oe=[],ue=[];for(const ge of j){const pe=x(ge,ee);pe<0?J.push(ge):pe>0?oe.push(ge):ue.push(ge)}return B<J.length?S(B,J,x):B<J.length+ue.length?ue[0]:S(B-(J.length+ue.length),oe,x)}function m(B,j){const x=[];let ee;for(const J of B.slice(0).sort(j))!ee||j(ee[0],J)!==0?(ee=[J],x.push(ee)):ee.push(J);return x}function*u(B,j){let x,ee;for(const J of B)ee!==void 0&&j(ee,J)?x.push(J):(x&&(yield x),x=[J]),ee=J;x&&(yield x)}function $(B,j){for(let x=0;x<=B.length;x++)j(x===0?void 0:B[x-1],x===B.length?void 0:B[x])}function h(B,j){for(let x=0;x<B.length;x++)j(x===0?void 0:B[x-1],B[x],x+1===B.length?void 0:B[x+1])}function b(B,j,x){const ee=[];function J(ge,pe,Ie){if(pe===0&&Ie.length===0)return;const we=ee[ee.length-1];we&&we.start+we.deleteCount===ge?(we.deleteCount+=pe,we.toInsert.push(...Ie)):ee.push({start:ge,deleteCount:pe,toInsert:Ie})}let oe=0,ue=0;for(;;){if(oe===B.length){J(oe,0,j.slice(ue));break}if(ue===j.length){J(oe,B.length-oe,[]);break}const ge=B[oe],pe=j[ue],Ie=x(ge,pe);Ie===0?(oe+=1,ue+=1):Ie<0?(J(oe,1,[]),oe+=1):Ie>0&&(J(oe,0,[pe]),ue+=1)}return ee}function v(B,j,x){const ee=b(B,j,x),J=[],oe=[];for(const ue of ee)J.push(...B.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:J,added:oe}}function d(B,j,x){if(x===0)return[];const ee=B.slice(0,x).sort(j);return P(B,j,ee,x,B.length),ee}function p(B,j,x,ee,J){return x===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const ge=B.length,pe=B.slice(0,x).sort(j);for(let Ie=x,we=Math.min(x+ee,ge);Ie<ge;Ie=we,we=Math.min(we+ee,ge)){if(Ie>x&&await new Promise(be=>setTimeout(be)),J&&J.isCancellationRequested)throw new R.$8;P(B,j,pe,Ie,we)}return pe})().then(oe,ue)})}function P(B,j,x,ee,J){for(const oe=x.length;ee<J;ee++){const ue=B[ee];if(j(ue,x[oe-1])<0){x.pop();const ge=(0,c.$nb)(x,pe=>j(ue,pe)<0);x.splice(ge,0,ue)}}}function g(B){return B.filter(j=>!!j)}function s(B){let j=0;for(let x=0;x<B.length;x++)B[x]&&(B[j]=B[x],j+=1);B.length=j}function r(B,j,x){B.splice(x,0,B.splice(j,1)[0])}function t(B){return!Array.isArray(B)||B.length===0}function a(B){return Array.isArray(B)&&B.length>0}function i(B,j=x=>x){const x=new Set;return B.filter(ee=>{const J=j(ee);return x.has(J)?!1:(x.add(J),!0)})}function n(B){const j=new Set;return x=>{const ee=B(x);return j.has(ee)?!1:(j.add(ee),!0)}}function o(B,j){return B.length>0?B[0]:j}function l(B,j){return B.length>0?B[B.length-1]:j}function f(B,j,x=(ee,J)=>ee===J){let ee=0;for(let J=0,oe=Math.min(B.length,j.length);J<oe&&x(B[J],j[J]);J++)ee++;return ee}function I(B,j){let x=typeof j=="number"?B:0;typeof j=="number"?x=B:(x=0,j=B);const ee=[];if(x<=j)for(let J=x;J<j;J++)ee.push(J);else for(let J=x;J>j;J--)ee.push(J);return ee}function L(B,j,x){return B.reduce((ee,J)=>(ee[j(J)]=x?x(J):J,ee),Object.create(null))}function E(B,j){return B.push(j),()=>y(B,j)}function y(B,j){const x=B.indexOf(j);if(x>-1)return B.splice(x,1),j}function C(B,j,x){const ee=B.slice(0,j),J=B.slice(j);return ee.concat(x,J)}function F(B,j){let x;if(typeof j=="number"){let ee=j;x=()=>{const J=Math.sin(ee++)*179426549;return J-Math.floor(J)}}else x=Math.random;for(let ee=B.length-1;ee>0;ee-=1){const J=Math.floor(x()*(ee+1)),oe=B[ee];B[ee]=B[J],B[J]=oe}}function D(B,j){const x=B.indexOf(j);x>-1&&(B.splice(x,1),B.unshift(j))}function M(B,j){const x=B.indexOf(j);x>-1&&(B.splice(x,1),B.push(j))}function K(B,j){for(const x of j)B.push(x)}function W(B,j){return Array.isArray(B)?B.map(j):j(B)}function _(B){return Array.isArray(B)?B:[B]}function H(B){return B[Math.floor(Math.random()*B.length)]}function ie(B,j,x){const ee=z(B,j),J=B.length,oe=x.length;B.length=J+oe;for(let ue=J-1;ue>=ee;ue--)B[ue+oe]=B[ue];for(let ue=0;ue<oe;ue++)B[ue+ee]=x[ue]}function V(B,j,x,ee){const J=z(B,j);let oe=B.splice(J,x);return oe===void 0&&(oe=[]),ie(B,J,ee),oe}function z(B,j){return j<0?Math.max(j+B.length,0):Math.min(j,B.length)}var te;(function(B){function j(oe){return oe<0}B.isLessThan=j;function x(oe){return oe<=0}B.isLessThanOrEqual=x;function ee(oe){return oe>0}B.isGreaterThan=ee;function J(oe){return oe===0}B.isNeitherLessOrGreaterThan=J,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function se(B,j){return(x,ee)=>j(B(x),B(ee))}function he(...B){return(j,x)=>{for(const ee of B){const J=ee(j,x);if(!te.isNeitherLessOrGreaterThan(J))return J}return te.neitherLessOrGreaterThan}}const q=(B,j)=>B-j;e.$$b=q;const Z=(B,j)=>(0,e.$$b)(B?1:0,j?1:0);e.$_b=Z;function X(B){return(j,x)=>-B(j,x)}class G{constructor(j){this.g=j,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(j){let x=this.c;for(;x<this.g.length&&j(this.g[x]);)x++;const ee=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ee}takeFromEndWhile(j){let x=this.d;for(;x>=0&&j(this.g[x]);)x--;const ee=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const j=this.g[this.c];return this.c++,j}removeLast(){const j=this.g[this.d];return this.d--,j}takeCount(j){const x=this.g.slice(this.c,this.c+j);return this.c+=j,x}}e.$bc=G;class U{static{this.empty=new U(j=>{})}constructor(j){this.iterate=j}forEach(j){this.iterate(x=>(j(x),!0))}toArray(){const j=[];return this.iterate(x=>(j.push(x),!0)),j}filter(j){return new U(x=>this.iterate(ee=>j(ee)?x(ee):!0))}map(j){return new U(x=>this.iterate(ee=>x(j(ee))))}some(j){let x=!1;return this.iterate(ee=>(x=j(ee),!x)),x}findFirst(j){let x;return this.iterate(ee=>j(ee)?(x=ee,!1):!0),x}findLast(j){let x;return this.iterate(ee=>(j(ee)&&(x=ee),!0)),x}findLastMaxBy(j){let x,ee=!0;return this.iterate(J=>((ee||te.isGreaterThan(j(J,x)))&&(ee=!1,x=J),!0)),x}}e.$cc=U;class Q{constructor(j){this.c=j}static createSortPermutation(j,x){const ee=Array.from(j.keys()).sort((J,oe)=>x(j[J],j[oe]));return new Q(ee)}apply(j){return j.map((x,ee)=>j[this.c[ee]])}inverse(){const j=this.c.slice();for(let x=0;x<this.c.length;x++)j[this.c[x]]=x;return new Q(j)}}e.$dc=Q}),define(ce[132],le([0,1,8]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$hd=N,e.$id=k,e.$jd=T,e.$kd=O,e.$ld=A;function c(w,S){if(!w)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function N(w,S="Unreachable"){throw new Error(S)}function k(w,S="unexpected state"){if(!w)throw new R.$fb(`Assertion Failed: ${S}`)}function T(w){w||(0,R.$3)(new R.$fb("Soft Assertion Failed"))}function O(w){if(!w()){debugger;w(),(0,R.$3)(new R.$fb("Assertion Failed"))}}function A(w,S){let m=0;for(;m<w.length-1;){const u=w[m],$=w[m+1];if(!S(u,$))return!1;m++}return!0}}),define(ce[89],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=R;function R(c,N){const k=this;let T=!1,O;return function(){if(T)return O;if(T=!0,N)try{O=c.apply(k,arguments)}finally{N()}else O=c.apply(k,arguments);return O}}}),define(ce[64],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(c){function N(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}c.is=N;const k=Object.freeze([]);function T(){return k}c.empty=T;function*O(t){yield t}c.single=O;function A(t){return N(t)?t:O(t)}c.wrap=A;function w(t){return t||k}c.from=w;function*S(t){for(let a=t.length-1;a>=0;a--)yield t[a]}c.reverse=S;function m(t){return!t||t[Symbol.iterator]().next().done===!0}c.isEmpty=m;function u(t){return t[Symbol.iterator]().next().value}c.first=u;function $(t,a){let i=0;for(const n of t)if(a(n,i++))return!0;return!1}c.some=$;function h(t,a){for(const i of t)if(a(i))return i}c.find=h;function*b(t,a){for(const i of t)a(i)&&(yield i)}c.filter=b;function*v(t,a){let i=0;for(const n of t)yield a(n,i++)}c.map=v;function*d(t,a){let i=0;for(const n of t)yield*a(n,i++)}c.flatMap=d;function*p(...t){for(const a of t)yield*a}c.concat=p;function P(t,a,i){let n=i;for(const o of t)n=a(n,o);return n}c.reduce=P;function*g(t,a,i=t.length){for(a<0&&(a+=t.length),i<0?i+=t.length:i>t.length&&(i=t.length);a<i;a++)yield t[a]}c.slice=g;function s(t,a=Number.POSITIVE_INFINITY){const i=[];if(a===0)return[i,t];const n=t[Symbol.iterator]();for(let o=0;o<a;o++){const l=n.next();if(l.done)return[i,c.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return n}}]}c.consume=s;async function r(t){const a=[];for await(const i of t)a.push(i);return Promise.resolve(a)}c.asyncToArray=r})(R||(e.Iterable=R={}))}),define(ce[34],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=T,e.$Xn=m,e.$Yn=u,e.$Zn=$,e.$1n=h,e.$2n=b,e.$3n=v,e.$4n=d,e.$5n=p,e.$6n=P,e.$7n=g;var R;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var c;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var N;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var k;(function(s){s.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function T(s,r=!1){let t=0;const a=s.length;let i="",n=0,o=c.Unknown,l=R.None;function f(D){let M=0,K=0;for(;M<D;){const W=s.charCodeAt(t);if(W>=S._0&&W<=S._9)K=K*16+W-S._0;else if(W>=S.A&&W<=S.F)K=K*16+W-S.A+10;else if(W>=S.a&&W<=S.f)K=K*16+W-S.a+10;else break;t++,M++}return M<D&&(K=-1),K}function I(D){t=D,i="",n=0,o=c.Unknown,l=R.None}function L(){const D=t;if(s.charCodeAt(t)===S._0)t++;else for(t++;t<s.length&&w(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===S.dot)if(t++,t<s.length&&w(s.charCodeAt(t)))for(t++;t<s.length&&w(s.charCodeAt(t));)t++;else return l=R.UnexpectedEndOfNumber,s.substring(D,t);let M=t;if(t<s.length&&(s.charCodeAt(t)===S.E||s.charCodeAt(t)===S.e))if(t++,(t<s.length&&s.charCodeAt(t)===S.plus||s.charCodeAt(t)===S.minus)&&t++,t<s.length&&w(s.charCodeAt(t))){for(t++;t<s.length&&w(s.charCodeAt(t));)t++;M=t}else l=R.UnexpectedEndOfNumber;return s.substring(D,M)}function E(){let D="",M=t;for(;;){if(t>=a){D+=s.substring(M,t),l=R.UnexpectedEndOfString;break}const K=s.charCodeAt(t);if(K===S.doubleQuote){D+=s.substring(M,t),t++;break}if(K===S.backslash){if(D+=s.substring(M,t),t++,t>=a){l=R.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case S.doubleQuote:D+='"';break;case S.backslash:D+="\\";break;case S.slash:D+="/";break;case S.b:D+="\b";break;case S.f:D+="\f";break;case S.n:D+=`
`;break;case S.r:D+="\r";break;case S.t:D+="	";break;case S.u:{const _=f(4);_>=0?D+=String.fromCharCode(_):l=R.InvalidUnicode;break}default:l=R.InvalidEscapeCharacter}M=t;continue}if(K>=0&&K<=31)if(A(K)){D+=s.substring(M,t),l=R.UnexpectedEndOfString;break}else l=R.InvalidCharacter;t++}return D}function y(){if(i="",l=R.None,n=t,t>=a)return n=a,o=c.EOF;let D=s.charCodeAt(t);if(O(D)){do t++,i+=String.fromCharCode(D),D=s.charCodeAt(t);while(O(D));return o=c.Trivia}if(A(D))return t++,i+=String.fromCharCode(D),D===S.carriageReturn&&s.charCodeAt(t)===S.lineFeed&&(t++,i+=`
`),o=c.LineBreakTrivia;switch(D){case S.openBrace:return t++,o=c.OpenBraceToken;case S.closeBrace:return t++,o=c.CloseBraceToken;case S.openBracket:return t++,o=c.OpenBracketToken;case S.closeBracket:return t++,o=c.CloseBracketToken;case S.colon:return t++,o=c.ColonToken;case S.comma:return t++,o=c.CommaToken;case S.doubleQuote:return t++,i=E(),o=c.StringLiteral;case S.slash:{const M=t-1;if(s.charCodeAt(t+1)===S.slash){for(t+=2;t<a&&!A(s.charCodeAt(t));)t++;return i=s.substring(M,t),o=c.LineCommentTrivia}if(s.charCodeAt(t+1)===S.asterisk){t+=2;const K=a-1;let W=!1;for(;t<K;){if(s.charCodeAt(t)===S.asterisk&&s.charCodeAt(t+1)===S.slash){t+=2,W=!0;break}t++}return W||(t++,l=R.UnexpectedEndOfComment),i=s.substring(M,t),o=c.BlockCommentTrivia}return i+=String.fromCharCode(D),t++,o=c.Unknown}case S.minus:if(i+=String.fromCharCode(D),t++,t===a||!w(s.charCodeAt(t)))return o=c.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return i+=L(),o=c.NumericLiteral;default:for(;t<a&&C(D);)t++,D=s.charCodeAt(t);if(n!==t){switch(i=s.substring(n,t),i){case"true":return o=c.TrueKeyword;case"false":return o=c.FalseKeyword;case"null":return o=c.NullKeyword}return o=c.Unknown}return i+=String.fromCharCode(D),t++,o=c.Unknown}}function C(D){if(O(D)||A(D))return!1;switch(D){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function F(){let D;do D=y();while(D>=c.LineCommentTrivia&&D<=c.Trivia);return D}return{setPosition:I,getPosition:()=>t,scan:r?F:y,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>n,getTokenLength:()=>t-n,getTokenError:()=>l}}function O(s){return s===S.space||s===S.tab||s===S.verticalTab||s===S.formFeed||s===S.nonBreakingSpace||s===S.ogham||s>=S.enQuad&&s<=S.zeroWidthSpace||s===S.narrowNoBreakSpace||s===S.mathematicalSpace||s===S.ideographicSpace||s===S.byteOrderMark}function A(s){return s===S.lineFeed||s===S.carriageReturn||s===S.lineSeparator||s===S.paragraphSeparator}function w(s){return s>=S._0&&s<=S._9}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function m(s,r){const t=[],a=new Object;let i;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(f,I,L,E){n.value=f,n.offset=I,n.length=L,n.type=E,n.colonOffset=void 0,i=n}try{P(s,{onObjectBegin:(f,I)=>{if(r<=f)throw a;i=void 0,o=r>f,t.push("")},onObjectProperty:(f,I,L)=>{if(r<I||(l(f,I,L,"property"),t[t.length-1]=f,r<=I+L))throw a},onObjectEnd:(f,I)=>{if(r<=f)throw a;i=void 0,t.pop()},onArrayBegin:(f,I)=>{if(r<=f)throw a;i=void 0,t.push(0)},onArrayEnd:(f,I)=>{if(r<=f)throw a;i=void 0,t.pop()},onLiteralValue:(f,I,L)=>{if(r<I||(l(f,I,L,g(f)),r<=I+L))throw a},onSeparator:(f,I,L)=>{if(r<=I)throw a;if(f===":"&&i&&i.type==="property")i.colonOffset=I,o=!1,i=void 0;else if(f===","){const E=t[t.length-1];typeof E=="number"?t[t.length-1]=E+1:(o=!0,t[t.length-1]=""),i=void 0}}})}catch(f){if(f!==a)throw f}return{path:t,previousNode:i,isAtPropertyKey:o,matches:f=>{let I=0;for(let L=0;I<f.length&&L<t.length;L++)if(f[I]===t[L]||f[I]==="*")I++;else if(f[I]!=="**")return!1;return I===f.length}}}function u(s,r=[],t=k.DEFAULT){let a=null,i=[];const n=[];function o(f){Array.isArray(i)?i.push(f):a!==null&&(i[a]=f)}return P(s,{onObjectBegin:()=>{const f={};o(f),n.push(i),i=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{i=n.pop()},onArrayBegin:()=>{const f=[];o(f),n.push(i),i=f,a=null},onArrayEnd:()=>{i=n.pop()},onLiteralValue:o,onError:(f,I,L)=>{r.push({error:f,offset:I,length:L})}},t),i[0]}function $(s,r=[],t=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(f){a.type==="property"&&(a.length=f-a.offset,a=a.parent)}function n(f){return a.children.push(f),f}P(s,{onObjectBegin:f=>{a=n({type:"object",offset:f,length:-1,parent:a,children:[]})},onObjectProperty:(f,I,L)=>{a=n({type:"property",offset:I,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:f,offset:I,length:L,parent:a})},onObjectEnd:(f,I)=>{a.length=f+I-a.offset,a=a.parent,i(f+I)},onArrayBegin:(f,I)=>{a=n({type:"array",offset:f,length:-1,parent:a,children:[]})},onArrayEnd:(f,I)=>{a.length=f+I-a.offset,a=a.parent,i(f+I)},onLiteralValue:(f,I,L)=>{n({type:g(f),offset:I,length:L,parent:a,value:f}),i(I+L)},onSeparator:(f,I,L)=>{a.type==="property"&&(f===":"?a.colonOffset=I:f===","&&i(I))},onError:(f,I,L)=>{r.push({error:f,offset:I,length:L})}},t);const l=a.children[0];return l&&delete l.parent,l}function h(s,r){if(!s)return;let t=s;for(const a of r)if(typeof a=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let i=!1;for(const n of t.children)if(Array.isArray(n.children)&&n.children[0].value===a){t=n.children[1],i=!0;break}if(!i)return}else{const i=a;if(t.type!=="array"||i<0||!Array.isArray(t.children)||i>=t.children.length)return;t=t.children[i]}return t}function b(s){if(!s.parent||!s.parent.children)return[];const r=b(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const r=Object.create(null);for(const t of s.children){const a=t.children[1];a&&(r[t.children[0].value]=v(a))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function d(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}function p(s,r,t=!1){if(d(s,r,t)){const a=s.children;if(Array.isArray(a))for(let i=0;i<a.length&&a[i].offset<=r;i++){const n=p(a[i],r,t);if(n)return n}return s}}function P(s,r,t=k.DEFAULT){const a=T(s,!1);function i(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function n(se){return se?he=>se(he,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=i(r.onObjectBegin),l=n(r.onObjectProperty),f=i(r.onObjectEnd),I=i(r.onArrayBegin),L=i(r.onArrayEnd),E=n(r.onLiteralValue),y=n(r.onSeparator),C=i(r.onComment),F=n(r.onError),D=t&&t.disallowComments,M=t&&t.allowTrailingComma;function K(){for(;;){const se=a.scan();switch(a.getTokenError()){case R.InvalidUnicode:W(N.InvalidUnicode);break;case R.InvalidEscapeCharacter:W(N.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:W(N.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:D||W(N.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:W(N.UnexpectedEndOfString);break;case R.InvalidCharacter:W(N.InvalidCharacter);break}switch(se){case c.LineCommentTrivia:case c.BlockCommentTrivia:D?W(N.InvalidCommentToken):C();break;case c.Unknown:W(N.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return se}}}function W(se,he=[],q=[]){if(F(se),he.length+q.length>0){let Z=a.getToken();for(;Z!==c.EOF;){if(he.indexOf(Z)!==-1){K();break}else if(q.indexOf(Z)!==-1)break;Z=K()}}}function _(se){const he=a.getTokenValue();return se?E(he):l(he),K(),!0}function H(){switch(a.getToken()){case c.NumericLiteral:{let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&(W(N.InvalidNumberFormat),se=0)}catch{W(N.InvalidNumberFormat)}E(se);break}case c.NullKeyword:E(null);break;case c.TrueKeyword:E(!0);break;case c.FalseKeyword:E(!1);break;default:return!1}return K(),!0}function ie(){return a.getToken()!==c.StringLiteral?(W(N.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(_(!1),a.getToken()===c.ColonToken?(y(":"),K(),te()||W(N.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):W(N.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function V(){o(),K();let se=!1;for(;a.getToken()!==c.CloseBraceToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||W(N.ValueExpected,[],[]),y(","),K(),a.getToken()===c.CloseBraceToken&&M)break}else se&&W(N.CommaExpected,[],[]);ie()||W(N.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),se=!0}return f(),a.getToken()!==c.CloseBraceToken?W(N.CloseBraceExpected,[c.CloseBraceToken],[]):K(),!0}function z(){I(),K();let se=!1;for(;a.getToken()!==c.CloseBracketToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||W(N.ValueExpected,[],[]),y(","),K(),a.getToken()===c.CloseBracketToken&&M)break}else se&&W(N.CommaExpected,[],[]);te()||W(N.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),se=!0}return L(),a.getToken()!==c.CloseBracketToken?W(N.CloseBracketExpected,[c.CloseBracketToken],[]):K(),!0}function te(){switch(a.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return V();case c.StringLiteral:return _(!0);default:return H()}}return K(),a.getToken()===c.EOF?t.allowEmptyContent?!0:(W(N.ValueExpected,[],[]),!1):te()?(a.getToken()!==c.EOF&&W(N.EndOfFileExpected,[],[]),!0):(W(N.ValueExpected,[],[]),!1)}function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[45],le([0,1,34]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=c,e.$9n=N,e.$0n=O,e.$$n=A;function c(w,S,m){let u,$,h,b,v;if(S){for(b=S.offset,v=b+S.length,h=b;h>0&&!A(w,h-1);)h--;let l=v;for(;l<w.length&&!A(w,l);)l++;$=w.substring(h,l),u=T($,m)}else $=w,u=0,h=0,b=0,v=w.length;const d=O(m,w);let p=!1,P=0,g;m.insertSpaces?g=k(" ",m.tabSize||4):g="	";const s=(0,R.$Wn)($,!1);let r=!1;function t(){return d+k(g,u+P)}function a(){let l=s.scan();for(p=!1;l===R.SyntaxKind.Trivia||l===R.SyntaxKind.LineBreakTrivia;)p=p||l===R.SyntaxKind.LineBreakTrivia,l=s.scan();return r=l===R.SyntaxKind.Unknown||s.getTokenError()!==R.ScanError.None,l}const i=[];function n(l,f,I){!r&&f<v&&I>b&&w.substring(f,I)!==l&&i.push({offset:f,length:I-f,content:l})}let o=a();if(o!==R.SyntaxKind.EOF){const l=s.getTokenOffset()+h,f=k(g,u);n(f,h,l)}for(;o!==R.SyntaxKind.EOF;){let l=s.getTokenOffset()+s.getTokenLength()+h,f=a(),I="";for(;!p&&(f===R.SyntaxKind.LineCommentTrivia||f===R.SyntaxKind.BlockCommentTrivia);){const E=s.getTokenOffset()+h;n(" ",l,E),l=s.getTokenOffset()+s.getTokenLength()+h,I=f===R.SyntaxKind.LineCommentTrivia?t():"",f=a()}if(f===R.SyntaxKind.CloseBraceToken)o!==R.SyntaxKind.OpenBraceToken&&(P--,I=t());else if(f===R.SyntaxKind.CloseBracketToken)o!==R.SyntaxKind.OpenBracketToken&&(P--,I=t());else{switch(o){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:P++,I=t();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:I=t();break;case R.SyntaxKind.BlockCommentTrivia:p?I=t():I=" ";break;case R.SyntaxKind.ColonToken:I=" ";break;case R.SyntaxKind.StringLiteral:if(f===R.SyntaxKind.ColonToken){I="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:f===R.SyntaxKind.LineCommentTrivia||f===R.SyntaxKind.BlockCommentTrivia?I=" ":f!==R.SyntaxKind.CommaToken&&f!==R.SyntaxKind.EOF&&(r=!0);break;case R.SyntaxKind.Unknown:r=!0;break}p&&(f===R.SyntaxKind.LineCommentTrivia||f===R.SyntaxKind.BlockCommentTrivia)&&(I=t())}const L=s.getTokenOffset()+h;n(I,l,L),o=f}return i}function N(w,S){const m=JSON.stringify(w,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?m.replace(/\r\n|\r|\n/g,S.eol):m}function k(w,S){let m="";for(let u=0;u<S;u++)m+=w;return m}function T(w,S){let m=0,u=0;const $=S.tabSize||4;for(;m<w.length;){const h=w.charAt(m);if(h===" ")u++;else if(h==="	")u+=$;else break;m++}return Math.floor(u/$)}function O(w,S){for(let m=0;m<S.length;m++){const u=S.charAt(m);if(u==="\r")return m+1<S.length&&S.charAt(m+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return w&&w.eol||`
`}function A(w,S){return`\r
`.indexOf(w.charAt(S))!==-1}}),define(ce[65],le([0,1,34,45]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=N,e.$ao=k,e.$bo=T,e.$co=O,e.$do=A;function N(w,S,m){return k(w,S,void 0,m)}function k(w,S,m,u,$){const h=S.slice(),b=[],v=(0,R.$Zn)(w,b);let d,p;for(;h.length>0&&(p=h.pop(),d=(0,R.$1n)(v,h),d===void 0&&m!==void 0);)typeof p=="string"?m={[p]:m}:m=[m];if(d)if(d.type==="object"&&typeof p=="string"&&Array.isArray(d.children)){const P=(0,R.$1n)(d,[p]);if(P!==void 0)if(m===void 0){if(!P.parent)throw new Error("Malformed AST");const g=d.children.indexOf(P.parent);let s,r=P.parent.offset+P.parent.length;if(g>0){const t=d.children[g-1];s=t.offset+t.length}else s=d.offset+1,d.children.length>1&&(r=d.children[1].offset);return T(w,{offset:s,length:r-s,content:""},u)}else return T(w,{offset:P.offset,length:P.length,content:JSON.stringify(m)},u);else{if(m===void 0)return[];const g=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,s=$?$(d.children.map(t=>t.children[0].value)):d.children.length;let r;if(s>0){const t=d.children[s-1];r={offset:t.offset+t.length,length:0,content:","+g}}else d.children.length===0?r={offset:d.offset+1,length:0,content:g}:r={offset:d.offset+1,length:0,content:g+","};return T(w,r,u)}}else if(d.type==="array"&&typeof p=="number"&&Array.isArray(d.children))if(m!==void 0){const P=`${JSON.stringify(m)}`;let g;if(d.children.length===0||p===0)g={offset:d.offset+1,length:0,content:d.children.length===0?P:P+","};else{const s=p===-1||p>d.children.length?d.children.length:p,r=d.children[s-1];g={offset:r.offset+r.length,length:0,content:","+P}}return T(w,g,u)}else{const P=p,g=d.children[P];let s;if(d.children.length===1)s={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===P){const r=d.children[P-1],t=r.offset+r.length,a=d.offset+d.length;s={offset:t,length:a-2-t,content:""}}else s={offset:g.offset,length:d.children[P+1].offset-g.offset,content:""};return T(w,s,u)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${d.type}`);else return m===void 0?[]:T(w,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(m)},u)}function T(w,S,m){let u=O(w,S),$=S.offset,h=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,c.$$n)(u,$-1);)$--;for(;h<u.length&&!(0,c.$$n)(u,h);)h++}const b=(0,c.$8n)(u,{offset:$,length:h-$},m);for(let d=b.length-1;d>=0;d--){const p=b[d];u=O(u,p),$=Math.min($,p.offset),h=Math.max(h,p.offset+p.length),h+=p.content.length-p.length}const v=w.length-(u.length-h)-$;return[{offset:$,length:v,content:u.substring($,h)}]}function O(w,S){return w.substring(0,S.offset)+S.content+w.substring(S.offset+S.length)}function A(w,S){const m=S.slice(0).sort(($,h)=>{const b=$.offset-h.offset;return b===0?$.length-h.length:b});let u=w.length;for(let $=m.length-1;$>=0;$--){const h=m[$];if(h.offset+h.length<=u)w=O(w,h);else throw new Error("Overlapping edit");u=h.offset}return w}}),define(ce[54],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class R{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=R}),define(ce[90],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}class c{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let k=this.a;for(;k!==R.Undefined;){const T=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=T}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,T){const O=new R(k);if(this.a===R.Undefined)this.a=O,this.b=O;else if(T){const w=this.b;this.b=O,O.prev=w,w.next=O}else{const w=this.a;this.a=O,O.next=w,w.prev=O}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(O))}}shift(){if(this.a!==R.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==R.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===R.Undefined&&k.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):k.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):k.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.$8c=c}),define(ce[35],le([0,1]),function(ne,e){"use strict";var R,c,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=k,e.$Bc=T,e.$Cc=O,e.$Lc=g;function k(s,r,t){let a=s.get(r);return a===void 0&&(a=t,s.set(r,a)),a}function T(s){const r=[];return s.forEach((t,a)=>{r.push(`${a} => ${t}`)}),`Map(${s.size}) {${r.join(", ")}}`}function O(s){const r=[];return s.forEach(t=>{r.push(t)}),`Set(${s.size}) {${r.join(", ")}}`}class A{constructor(r,t){this.uri=r,this.value=t}}function w(s){return Array.isArray(s)}class S{static{this.c=r=>r.toString()}constructor(r,t){if(this[R]="ResourceMap",r instanceof S)this.d=new Map(r.d),this.e=t??S.c;else if(w(r)){this.d=new Map,this.e=t??S.c;for(const[a,i]of r)this.set(a,i)}else this.d=new Map,this.e=r??S.c}set(r,t){return this.d.set(this.e(r),new A(r,t)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,t){typeof t<"u"&&(r=r.bind(t));for(const[a,i]of this.d)r(i.value,i.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Dc=S;class m{constructor(r,t){this[c]="ResourceSet",!r||typeof r=="function"?this.c=new S(r):(this.c=new S(t),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,t){this.c.forEach((a,i)=>r.call(t,i,i,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=m;var u;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class ${constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,t=u.None){const a=this.c.get(r);if(a)return t!==u.None&&this.m(a,t),a.value}set(r,t,a=u.None){let i=this.c.get(r);if(i)i.value=t,a!==u.None&&this.m(i,a);else{switch(i={key:r,value:t,next:void 0,previous:void 0},a){case u.None:this.k(i);break;case u.AsOld:this.j(i);break;case u.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(r,i),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const t=this.c.get(r);if(t)return this.c.delete(r),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,t){const a=this.g;let i=this.d;for(;i;){if(t?r.bind(t)(i.value,i.key,this):r(i.value,i.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.key,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}values(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.value,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}entries(){const r=this,t=this.g;let a=this.d;const i={[Symbol.iterator](){return i},next(){if(r.g!==t)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:[a.key,a.value],done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return i}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this.d,a=this.size;for(;t&&a>r;)this.c.delete(t.key),t=t.next,a--;this.d=t,this.f=a,t&&(t.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this.e,a=this.size;for(;t&&a>r;)this.c.delete(t.key),t=t.previous,a--;this.e=t,this.f=a,t&&(t.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const t=r.next,a=r.previous;if(!t||!a)throw new Error("Invalid list");t.previous=a,a.next=t}r.next=void 0,r.previous=void 0,this.g++}m(r,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==u.AsOld&&t!==u.AsNew)){if(t===u.AsOld){if(r===this.d)return;const a=r.next,i=r.previous;r===this.e?(i.next=void 0,this.e=i):(a.previous=i,i.next=a),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(t===u.AsNew){if(r===this.e)return;const a=r.next,i=r.previous;r===this.d?(a.previous=void 0,this.d=a):(a.previous=i,i.next=a),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((t,a)=>{r.push([a,t])}),r}fromJSON(r){this.clear();for(const[t,a]of r)this.set(t,a)}}e.$Fc=$;class h extends ${constructor(r,t=1){super(),this.n=r,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,t=u.AsNew){return super.get(r,t)}peek(r){return super.get(r,u.None)}set(r,t){return super.set(r,t,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends h{constructor(r,t=1){super(r,t)}q(r){this.h(r)}set(r,t){return super.set(r,t),this.p(),this}}e.$Gc=b;class v extends h{constructor(r,t=1){super(r,t)}q(r){this.i(r)}set(r,t){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,t),this}}e.$Hc=v;class d{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let t=this.c.get(r)||0;return t===0?!1:(t--,t===0?this.c.delete(r):this.c.set(r,t),!0)}has(r){return this.c.has(r)}}e.$Ic=d;class p{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[t,a]of r)this.set(t,a)}clear(){this.c.clear(),this.d.clear()}set(r,t){this.c.set(r,t),this.d.set(t,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const t=this.c.get(r);return t===void 0?!1:(this.c.delete(r),this.d.delete(t),!0)}forEach(r,t){this.c.forEach((a,i)=>{r.call(t,a,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=p;class P{constructor(){this.c=new Map}add(r,t){let a=this.c.get(r);a||(a=new Set,this.c.set(r,a)),a.add(t)}delete(r,t){const a=this.c.get(r);a&&(a.delete(t),a.size===0&&this.c.delete(r))}forEach(r,t){const a=this.c.get(r);a&&a.forEach(t)}get(r){const t=this.c.get(r);return t||new Set}}e.$Kc=P;function g(s,r){if(s===r)return!0;if(s.size!==r.size)return!1;for(const[t,a]of s)if(!r.has(t)||r.get(t)!==a)return!1;for(const[t]of r)if(!s.has(t))return!1;return!0}}),define(ce[2],le([0,1,19,131,35,89,64]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=S,e.$Oc=m,e.$Pc=u,e.$Qc=b,e.$Rc=v,e.$Sc=d,e.$Tc=p,e.$Uc=P,e.$Vc=g,e.$6c=I;const O=!1;let A=null;class w{constructor(){this.b=new Map}static{this.a=0}c(y){let C=this.b.get(y);return C||(C={parent:null,source:null,isSingleton:!1,value:y,idx:w.a++},this.b.set(y,C)),C}trackDisposable(y){const C=this.c(y);C.source||(C.source=new Error().stack)}setParent(y,C){const F=this.c(y);F.parent=C}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,C){const F=C.get(y);if(F)return F;const D=y.parent?this.f(this.c(y.parent),C):y;return C.set(y,D),D}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,y).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(y=10,C){let F;if(C)F=C;else{const _=new Map,H=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,_).isSingleton);if(H.length===0)return;const ie=new Set(H.map(V=>V.value));if(F=H.filter(V=>!(V.parent&&ie.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function D(_){function H(V,z){for(;V.length>0&&z.some(te=>typeof te=="string"?te===V[0]:V[0].match(te));)V.shift()}const ie=_.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return H(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new N.$Kc;for(const _ of F){const H=D(_);for(let ie=0;ie<=H.length;ie++)M.add(H.slice(0,ie).join(`
`),_)}F.sort((0,R.$9b)(_=>_.idx,R.$$b));let K="",W=0;for(const _ of F.slice(0,y)){W++;const H=D(_),ie=[];for(let V=0;V<H.length;V++){let z=H[V];z=`(shared with ${M.get(H.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${z}`;const se=M.get(H.slice(0,V).join(`
`)),he=(0,c.$K)([...se].map(q=>D(q)[V]),q=>q);delete he[H[V]];for(const[q,Z]of Object.entries(he))ie.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${q}`);ie.unshift(z)}K+=`


==================== Leaking disposable ${W}/${F.length}: ${_.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>y&&(K+=`


... and ${F.length-y} more leaking disposables

`),{leaks:F,details:K}}}e.$Mc=w;function S(E){A=E}if(O){const E="__is_disposable_tracked__";S(new class{trackDisposable(y){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[E]||console.log(C)},3e3)}setParent(y,C){if(y&&y!==r.None)try{y[E]=!0}catch{}}markAsDisposed(y){if(y&&y!==r.None)try{y[E]=!0}catch{}}markAsSingleton(y){}})}function m(E){return A?.trackDisposable(E),E}function u(E){A?.markAsDisposed(E)}function $(E,y){A?.setParent(E,y)}function h(E,y){if(A)for(const C of E)A.setParent(C,y)}function b(E){return A?.markAsSingleton(E),E}function v(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function d(E){if(T.Iterable.is(E)){const y=[];for(const C of E)if(C)try{C.dispose()}catch(F){y.push(F)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function p(E){for(const y of E)v(y)&&y.dispose();return[]}function P(...E){const y=g(()=>d(E));return h(E,y),y}function g(E){const y=m({dispose:(0,k.$gb)(()=>{u(y),E()})});return y}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return $(y,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),$(y,null))}}e.$Wc=s;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,m(this),$(this.q,this)}dispose(){u(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Xc=r;class t{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&$(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&$(y,null),y}}e.$Yc=t;class a{constructor(y){this.a=new t,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=a;class i{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(y){let C=y;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,u(this))},this}}e.$2c=n;class o{constructor(){this.a=new Map}acquire(y,...C){let F=this.a.get(y);F||(F={counter:0,object:this.b(y,...C)},this.a.set(y,F));const{object:D}=F,M=(0,k.$gb)(()=>{--F.counter===0&&(this.c(y,F.object),this.a.delete(y))});return F.counter++,{object:D,dispose:M}}}e.$3c=o;class l{constructor(y){this.a=y}async acquire(y,...C){const F=this.a.acquire(y,...C);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(D){throw F.dispose(),D}}}e.$4c=l;class f{constructor(y){this.object=y}dispose(){}}e.$5c=f;function I(E){const y=new s;try{E(y)}finally{y.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,C,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(y)?.dispose(),this.a.set(y,C)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const C=this.a.get(y);return this.a.delete(y),C}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=L}),define(ce[66],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(ce[91],le([0,1,35]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=N,e.$om=T;const c=new R.$Gc(1e4);function N(w){return A(w,"NFC",c)}const k=new R.$Gc(1e4);function T(w){return A(w,"NFD",k)}const O=/[^\u0000-\u0080]/;function A(w,S,m){if(!w)return w;const u=m.get(w);if(u)return u;let $;return O.test(w)?$=w.normalize(S):$=w,m.set(w,$),$}e.$pm=function(){const w=/[\u0300-\u036f]/g;return function(S){return T(S).replace(w,"")}}()}),function(){function ne(N){const k=[];typeof N=="number"&&k.push("code/timeOrigin",N);function T(A){k.push(A,Date.now())}function O(){const A=[];for(let w=0;w<k.length;w+=2)A.push({name:k[w],startTime:k[w+1]});return A}return{mark:T,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(N+T.startTime)});return k}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function R(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=R(c))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var c in R)(typeof exports=="object"?exports:ne)[c]=R[c]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function R(c){if(e[c])return e[c].exports;var N=e[c]={i:c,l:!1,exports:{}};return ne[c].call(N.exports,N,N.exports,R),N.l=!0,N.exports}return R.m=ne,R.c=e,R.d=function(c,N,k){R.o(c,N)||Object.defineProperty(c,N,{enumerable:!0,get:k})},R.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},R.t=function(c,N){if(1&N&&(c=R(c)),8&N||4&N&&typeof c=="object"&&c&&c.__esModule)return c;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:c}),2&N&&typeof c!="string")for(var T in c)R.d(k,T,function(O){return c[O]}.bind(null,T));return k},R.n=function(c){var N=c&&c.__esModule?function(){return c.default}:function(){return c};return R.d(N,"a",N),N},R.o=function(c,N){return Object.prototype.hasOwnProperty.call(c,N)},R.p="",R(R.s=0)}([function(ne,e,R){(function(c){var N;e=ne.exports=Z,N=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],A=e.src=[],w=0,S=w++;A[S]="0|[1-9]\\d*";var m=w++;A[m]="[0-9]+";var u=w++;A[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;A[$]="("+A[S]+")\\.("+A[S]+")\\.("+A[S]+")";var h=w++;A[h]="("+A[m]+")\\.("+A[m]+")\\.("+A[m]+")";var b=w++;A[b]="(?:"+A[S]+"|"+A[u]+")";var v=w++;A[v]="(?:"+A[m]+"|"+A[u]+")";var d=w++;A[d]="(?:-("+A[b]+"(?:\\."+A[b]+")*))";var p=w++;A[p]="(?:-?("+A[v]+"(?:\\."+A[v]+")*))";var P=w++;A[P]="[0-9A-Za-z-]+";var g=w++;A[g]="(?:\\+("+A[P]+"(?:\\."+A[P]+")*))";var s=w++,r="v?"+A[$]+A[d]+"?"+A[g]+"?";A[s]="^"+r+"$";var t="[v=\\s]*"+A[h]+A[p]+"?"+A[g]+"?",a=w++;A[a]="^"+t+"$";var i=w++;A[i]="((?:<|>)?=?)";var n=w++;A[n]=A[m]+"|x|X|\\*";var o=w++;A[o]=A[S]+"|x|X|\\*";var l=w++;A[l]="[v=\\s]*("+A[o]+")(?:\\.("+A[o]+")(?:\\.("+A[o]+")(?:"+A[d]+")?"+A[g]+"?)?)?";var f=w++;A[f]="[v=\\s]*("+A[n]+")(?:\\.("+A[n]+")(?:\\.("+A[n]+")(?:"+A[p]+")?"+A[g]+"?)?)?";var I=w++;A[I]="^"+A[i]+"\\s*"+A[l]+"$";var L=w++;A[L]="^"+A[i]+"\\s*"+A[f]+"$";var E=w++;A[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var y=w++;A[y]="(?:~>?)";var C=w++;A[C]="(\\s*)"+A[y]+"\\s+",O[C]=new RegExp(A[C],"g");var F=w++;A[F]="^"+A[y]+A[l]+"$";var D=w++;A[D]="^"+A[y]+A[f]+"$";var M=w++;A[M]="(?:\\^)";var K=w++;A[K]="(\\s*)"+A[M]+"\\s+",O[K]=new RegExp(A[K],"g");var W=w++;A[W]="^"+A[M]+A[l]+"$";var _=w++;A[_]="^"+A[M]+A[f]+"$";var H=w++;A[H]="^"+A[i]+"\\s*("+t+")$|^$";var ie=w++;A[ie]="^"+A[i]+"\\s*("+r+")$|^$";var V=w++;A[V]="(\\s*)"+A[i]+"\\s*("+t+"|"+A[l]+")",O[V]=new RegExp(A[V],"g");var z=w++;A[z]="^\\s*("+A[l]+")\\s+-\\s+("+A[l]+")\\s*$";var te=w++;A[te]="^\\s*("+A[f]+")\\s+-\\s+("+A[f]+")\\s*$";var se=w++;A[se]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)N(he,A[he]),O[he]||(O[he]=new RegExp(A[he]));function q(ae,de){if(ae instanceof Z)return ae;if(typeof ae!="string"||ae.length>k||!(de?O[a]:O[s]).test(ae))return null;try{return new Z(ae,de)}catch{return null}}function Z(ae,de){if(ae instanceof Z){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ae,de);N("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?O[a]:O[s]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Oe=+Re;if(Oe>=0&&Oe<T)return Oe}return Re}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(ae,de){var me=q(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=q(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ae){return N("SemVer.compare",this.version,this.loose,ae),ae instanceof Z||(ae=new Z(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Z.prototype.compareMain=function(ae){return ae instanceof Z||(ae=new Z(ae,this.loose)),G(this.major,ae.major)||G(this.minor,ae.minor)||G(this.patch,ae.patch)},Z.prototype.comparePre=function(ae){if(ae instanceof Z||(ae=new Z(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Re=ae.prerelease[de];if(N("prerelease compare",de,me,Re),me===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(me===void 0)return-1;if(me!==Re)return G(me,Re)}while(++de)},Z.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Re){typeof me=="string"&&(Re=me,me=void 0);try{return new Z(ae,me).inc(de,Re).version}catch{return null}},e.diff=function(ae,de){if(j(ae,de))return null;var me=q(ae),Re=q(de);if(me.prerelease.length||Re.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Re[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Re[Oe])return Oe},e.compareIdentifiers=G;var X=/^[0-9]+$/;function G(ae,de){var me=X.test(ae),Re=X.test(de);return me&&Re&&(ae=+ae,de=+de),me&&!Re?-1:Re&&!me?1:ae<de?-1:ae>de?1:0}function U(ae,de,me){return new Z(ae,me).compare(new Z(de,me))}function Q(ae,de,me){return U(ae,de,me)>0}function B(ae,de,me){return U(ae,de,me)<0}function j(ae,de,me){return U(ae,de,me)===0}function x(ae,de,me){return U(ae,de,me)!==0}function ee(ae,de,me){return U(ae,de,me)>=0}function J(ae,de,me){return U(ae,de,me)<=0}function oe(ae,de,me,Re){var Oe;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae!==me;break;case"":case"=":case"==":Oe=j(ae,me,Re);break;case"!=":Oe=x(ae,me,Re);break;case">":Oe=Q(ae,me,Re);break;case">=":Oe=ee(ae,me,Re);break;case"<":Oe=B(ae,me,Re);break;case"<=":Oe=J(ae,me,Re);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function ue(ae,de){if(ae instanceof ue){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ue))return new ue(ae,de);N("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(ae,de){return G(de,ae)},e.major=function(ae,de){return new Z(ae,de).major},e.minor=function(ae,de){return new Z(ae,de).minor},e.patch=function(ae,de){return new Z(ae,de).patch},e.compare=U,e.compareLoose=function(ae,de){return U(ae,de,!0)},e.rcompare=function(ae,de,me){return U(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Re){return e.compare(me,Re,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Re){return e.rcompare(me,Re,de)})},e.gt=Q,e.lt=B,e.eq=j,e.neq=x,e.gte=ee,e.lte=J,e.cmp=oe,e.Comparator=ue;var ge={};function pe(ae,de){if(ae instanceof pe)return ae.loose===de?ae:new pe(ae.raw,de);if(ae instanceof ue)return new pe(ae.value,de);if(!(this instanceof pe))return new pe(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ie(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function we(ae,de,me,Re,Oe,Fe,Te,Ne,Ue,qe,Ge,Me,Be){return((de=Ie(me)?"":Ie(Re)?">="+me+".0.0":Ie(Oe)?">="+me+"."+Re+".0":">="+de)+" "+(Ne=Ie(Ue)?"":Ie(qe)?"<"+(+Ue+1)+".0.0":Ie(Ge)?"<"+Ue+"."+(+qe+1)+".0":Me?"<="+Ue+"."+qe+"."+Ge+"-"+Me:"<="+Ne)).trim()}function be(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(N(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Re=ae[me].semver;if(Re.major===de.major&&Re.minor===de.minor&&Re.patch===de.patch)return!0}return!1}return!0}function Ee(ae,de,me){try{de=new pe(de,me)}catch{return!1}return de.test(ae)}function Se(ae,de,me,Re){var Oe,Fe,Te,Ne,Ue;switch(ae=new Z(ae,Re),de=new pe(de,Re),me){case">":Oe=Q,Fe=J,Te=B,Ne=">",Ue=">=";break;case"<":Oe=B,Fe=ee,Te=Q,Ne="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(ae,de,Re))return!1;for(var qe=0;qe<de.set.length;++qe){var Ge=de.set[qe],Me=null,Be=null;if(Ge.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),Me=Me||ze,Be=Be||ze,Oe(ze.semver,Me.semver,Re)?Me=ze:Te(ze.semver,Be.semver,Re)&&(Be=ze)}),Me.operator===Ne||Me.operator===Ue||(!Be.operator||Be.operator===Ne)&&Fe(ae,Be.semver)||Be.operator===Ue&&Te(ae,Be.semver))return!1}return!0}ue.prototype.parse=function(ae){var de=this.loose?O[H]:O[ie],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Z(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(ae){return N("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new Z(ae,this.loose)),oe(ae,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(ae,de){if(!(ae instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(ae.value,de),Ee(this.value,me,de);if(ae.operator==="")return me=new pe(this.value,de),Ee(ae.semver,me,de);var Re=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=oe(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ue=oe(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Re||Oe||Fe&&Te||Ne||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),N("range",ae,de);var me=de?O[te]:O[z];ae=ae.replace(me,we),N("hyphen replace",ae),ae=ae.replace(O[V],"$1$2$3"),N("comparator trim",ae,O[V]),ae=(ae=(ae=ae.replace(O[C],"$1~")).replace(O[K],"$1^")).split(/\s+/).join(" ");var Re=de?O[H]:O[ie],Oe=ae.split(" ").map(function(Fe){return function(Te,Ne){return N("comp",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ge){return function(Me,Be){N("caret",Me,Be);var ze=Be?O[_]:O[W];return Me.replace(ze,function(We,Le,re,fe,$e){var ye;return N("caret",Me,We,Le,re,fe,$e),Ie(Le)?ye="":Ie(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ie(fe)?ye=Le==="0"?">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+".0 <"+(+Le+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+re+"."+(+fe+1):">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+fe+$e+" <"+(+Le+1)+".0.0"):(N("no pr"),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+fe+" <"+Le+"."+re+"."+(+fe+1):">="+Le+"."+re+"."+fe+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+fe+" <"+(+Le+1)+".0.0"),N("caret return",ye),ye})}(Ge,qe)}).join(" ")}(Te,Ne),N("caret",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ge){return function(Me,Be){var ze=Be?O[D]:O[F];return Me.replace(ze,function(We,Le,re,fe,$e){var ye;return N("tilde",Me,We,Le,re,fe,$e),Ie(Le)?ye="":Ie(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ie(fe)?ye=">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Le+"."+re+"."+fe+$e+" <"+Le+"."+(+re+1)+".0"):ye=">="+Le+"."+re+"."+fe+" <"+Le+"."+(+re+1)+".0",N("tilde return",ye),ye})}(Ge,qe)}).join(" ")}(Te,Ne),N("tildes",Te),Te=function(Ue,qe){return N("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(Ge){return function(Me,Be){Me=Me.trim();var ze=Be?O[L]:O[I];return Me.replace(ze,function(We,Le,re,fe,$e,ye){N("xRange",Me,We,Le,re,fe,$e,ye);var Ae=Ie(re),Ce=Ae||Ie(fe),je=Ce||Ie($e);return Le==="="&&je&&(Le=""),Ae?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&je?(Ce&&(fe=0),je&&($e=0),Le===">"?(Le=">=",Ce?(re=+re+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Le==="<="&&(Le="<",Ce?re=+re+1:fe=+fe+1),We=Le+re+"."+fe+"."+$e):Ce?We=">="+re+".0.0 <"+(+re+1)+".0.0":je&&(We=">="+re+"."+fe+".0 <"+re+"."+(+fe+1)+".0"),N("xRange return",We),We})}(Ge,qe)}).join(" ")}(Te,Ne),N("xrange",Te),Te=function(Ue,qe){return N("replaceStars",Ue,qe),Ue.trim().replace(O[se],"")}(Te,Ne),N("stars",Te),Te}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Re)})),Oe=Oe.map(function(Fe){return new ue(Fe,de)})},pe.prototype.intersects=function(ae,de){if(!(ae instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Re){return ae.set.some(function(Oe){return Oe.every(function(Fe){return Re.intersects(Fe,de)})})})})},e.toComparators=function(ae,de){return new pe(ae,de).set.map(function(me){return me.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Z(ae,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],ae))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(ae,de,me){var Re=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Te){Fe.test(Te)&&(Re&&Oe.compare(Te)!==-1||(Oe=new Z(Re=Te,me)))}),Re},e.minSatisfying=function(ae,de,me){var Re=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Te){Fe.test(Te)&&(Re&&Oe.compare(Te)!==1||(Oe=new Z(Re=Te,me)))}),Re},e.validRange=function(ae,de){try{return new pe(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Se(ae,de,"<",me)},e.gtr=function(ae,de,me){return Se(ae,de,">",me)},e.outside=Se,e.prerelease=function(ae,de){var me=q(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new pe(ae,me),de=new pe(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof Z)return ae;if(typeof ae!="string")return null;var de=ae.match(O[E]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(ne,e){var R,c,N=ne.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function O(v){if(R===setTimeout)return setTimeout(v,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(v,0);try{return R(v,0)}catch{try{return R.call(null,v,0)}catch{return R.call(this,v,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch{R=k}try{c=typeof clearTimeout=="function"?clearTimeout:T}catch{c=T}})();var A,w=[],S=!1,m=-1;function u(){S&&A&&(S=!1,A.length?w=A.concat(w):m=-1,w.length&&$())}function $(){if(!S){var v=O(u);S=!0;for(var d=w.length;d;){for(A=w,w=[];++m<d;)A&&A[m].run();m=-1,d=w.length}A=null,S=!1,function(p){if(c===clearTimeout)return clearTimeout(p);if((c===T||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(p);try{c(p)}catch{try{return c.call(null,p)}catch{return c.call(this,p)}}}(v)}}function h(v,d){this.fun=v,this.array=d}function b(){}N.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)d[p-1]=arguments[p];w.push(new h(v,d)),w.length!==1||S||O($)},h.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=b,N.addListener=b,N.once=b,N.off=b,N.removeListener=b,N.removeAllListeners=b,N.emit=b,N.prependListener=b,N.prependOnceListener=b,N.listeners=function(v){return[]},N.binding=function(v){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(v){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(ce[133],le([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class c{constructor(O,A,w){this.level=O,this.key=A,this.value=w,this.forward=[]}}const N=void 0;class k{constructor(O,A=2**16){this.comparator=O,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new c(this.c,N,N)}get size(){return this.f}clear(){this.e=new c(this.c,N,N),this.f=0}has(O){return!!k.g(this,O,this.comparator)}get(O){return k.g(this,O,this.comparator)?.value}set(O,A){return k.h(this,O,A,this.comparator)&&(this.f+=1),this}delete(O){const A=k.k(this,O,this.comparator);return A&&(this.f-=1),A}forEach(O,A){let w=this.e.forward[0];for(;w;)O.call(A,w.value,w.key,this),w=w.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",A=this.e.forward[0];for(;A;)O+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return O}static g(O,A,w){let S=O.e;for(let m=O.d-1;m>=0;m--)for(;S.forward[m]&&w(S.forward[m].key,A)<0;)S=S.forward[m];if(S=S.forward[0],S&&w(S.key,A)===0)return S}static h(O,A,w,S){const m=[];let u=O.e;for(let $=O.d-1;$>=0;$--){for(;u.forward[$]&&S(u.forward[$].key,A)<0;)u=u.forward[$];m[$]=u}if(u=u.forward[0],u&&S(u.key,A)===0)return u.value=w,!1;{const $=k.j(O);if($>O.d){for(let h=O.d;h<$;h++)m[h]=O.e;O.d=$}u=new c($,A,w);for(let h=0;h<$;h++)u.forward[h]=m[h].forward[h],m[h].forward[h]=u;return!0}}static j(O,A=.5){let w=1;for(;Math.random()<A&&w<O.c;)w+=1;return w}static k(O,A,w){const S=[];let m=O.e;for(let u=O.d-1;u>=0;u--){for(;m.forward[u]&&w(m.forward[u].key,A)<0;)m=m.forward[u];S[u]=m}if(m=m.forward[0],!m||w(m.key,A)!==0)return!1;for(let u=0;u<O.d&&S[u].forward[u]===m;u++)S[u].forward[u]=m.forward[u];for(;O.d>0&&O.e.forward[O.d-1]===N;)O.d-=1;return!0}}e.$Rs=k}),define(ce[55],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(k){return new c(k)}constructor(k){this.c=R&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=c}),define(ce[3],le([0,1,8,89,2,90,55]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=$;const O=!1,A=!1,w=!1;var S;(function(D){D.None=()=>N.$Xc.None;function M(we){if(w){const{onDidAddListener:be}=we,Ee=b.create();let Se=0;we.onDidAddListener=()=>{++Se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),be?.()}}}function K(we,be){return q(we,()=>{},0,void 0,!0,void 0,be)}D.defer=K;function W(we){return(be,Ee=null,Se)=>{let ae=!1,de;return de=we(me=>{if(!ae)return de?de.dispose():ae=!0,be.call(Ee,me)},null,Se),ae&&de.dispose(),de}}D.once=W;function _(we,be,Ee){return se((Se,ae=null,de)=>we(me=>Se.call(ae,be(me)),null,de),Ee)}D.map=_;function H(we,be,Ee){return se((Se,ae=null,de)=>we(me=>{be(me),Se.call(ae,me)},null,de),Ee)}D.forEach=H;function ie(we,be,Ee){return se((Se,ae=null,de)=>we(me=>be(me)&&Se.call(ae,me),null,de),Ee)}D.filter=ie;function V(we){return we}D.signal=V;function z(...we){return(be,Ee=null,Se)=>{const ae=(0,N.$Uc)(...we.map(de=>de(me=>be.call(Ee,me))));return he(ae,Se)}}D.any=z;function te(we,be,Ee,Se){let ae=Ee;return _(we,de=>(ae=be(ae,de),ae),Se)}D.reduce=te;function se(we,be){let Ee;const Se={onWillAddFirstListener(){Ee=we(ae.fire,ae)},onDidRemoveLastListener(){Ee?.dispose()}};be||M(Se);const ae=new t(Se);return be?.add(ae),ae.event}function he(we,be){return be instanceof Array?be.push(we):be&&be.add(we),we}function q(we,be,Ee=100,Se=!1,ae=!1,de,me){let Re,Oe,Fe,Te=0,Ne;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Re=we(Ge=>{Te++,Oe=be(Oe,Ge),Se&&!Fe&&(qe.fire(Oe),Oe=void 0),Ne=()=>{const Me=Oe;Oe=void 0,Fe=void 0,(!Se||Te>1)&&qe.fire(Me),Te=0},typeof Ee=="number"?(clearTimeout(Fe),Fe=setTimeout(Ne,Ee)):Fe===void 0&&(Fe=0,queueMicrotask(Ne))})},onWillRemoveListener(){ae&&Te>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Re.dispose()}};me||M(Ue);const qe=new t(Ue);return me?.add(qe),qe.event}D.debounce=q;function Z(we,be=0,Ee){return D.debounce(we,(Se,ae)=>Se?(Se.push(ae),Se):[ae],be,void 0,!0,void 0,Ee)}D.accumulate=Z;function X(we,be=(Se,ae)=>Se===ae,Ee){let Se=!0,ae;return ie(we,de=>{const me=Se||!be(de,ae);return Se=!1,ae=de,me},Ee)}D.latch=X;function G(we,be,Ee){return[D.filter(we,be,Ee),D.filter(we,Se=>!be(Se),Ee)]}D.split=G;function U(we,be=!1,Ee=[],Se){let ae=Ee.slice(),de=we(Oe=>{ae?ae.push(Oe):Re.fire(Oe)});Se&&Se.add(de);const me=()=>{ae?.forEach(Oe=>Re.fire(Oe)),ae=null},Re=new t({onWillAddFirstListener(){de||(de=we(Oe=>Re.fire(Oe)),Se&&Se.add(de))},onDidAddFirstListener(){ae&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Se&&Se.add(Re),Re.event}D.buffer=U;function Q(we,be){return(Se,ae,de)=>{const me=be(new j);return we(function(Re){const Oe=me.evaluate(Re);Oe!==B&&Se.call(ae,Oe)},void 0,de)}}D.chain=Q;const B=Symbol("HaltChainable");class j{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Ee=>(be(Ee),Ee)),this}filter(be){return this.f.push(Ee=>be(Ee)?Ee:B),this}reduce(be,Ee){let Se=Ee;return this.f.push(ae=>(Se=be(Se,ae),Se)),this}latch(be=(Ee,Se)=>Ee===Se){let Ee=!0,Se;return this.f.push(ae=>{const de=Ee||!be(ae,Se);return Ee=!1,Se=ae,de?ae:B}),this}evaluate(be){for(const Ee of this.f)if(be=Ee(be),be===B)break;return be}}function x(we,be,Ee=Se=>Se){const Se=(...Re)=>me.fire(Ee(...Re)),ae=()=>we.on(be,Se),de=()=>we.removeListener(be,Se),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}D.fromNodeEventEmitter=x;function ee(we,be,Ee=Se=>Se){const Se=(...Re)=>me.fire(Ee(...Re)),ae=()=>we.addEventListener(be,Se),de=()=>we.removeEventListener(be,Se),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}D.fromDOMEventEmitter=ee;function J(we){return new Promise(be=>W(we)(be))}D.toPromise=J;function oe(we){const be=new t;return we.then(Ee=>{be.fire(Ee)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}D.fromPromise=oe;function ue(we,be,Ee){return be(Ee),we(Se=>be(Se))}D.runAndSubscribe=ue;class ge{constructor(be,Ee){this._observable=be,this.f=0,this.g=!1;const Se={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Ee||M(Se),this.emitter=new t(Se),Ee&&Ee.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Ee){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(we,be){return new ge(we,be).emitter.event}D.fromObservable=pe;function Ie(we){return(be,Ee,Se)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(we.reportChanges(),de&&(de=!1,be.call(Ee)))},handlePossibleChange(){},handleChange(){de=!0}};we.addObserver(me),we.reportChanges();const Re={dispose(){we.removeObserver(me)}};return Se instanceof N.$Wc?Se.add(Re):Array.isArray(Se)&&Se.push(Re),Re}}D.fromObservableLight=Ie})(S||(e.Event=S={}));class m{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${m.f++}`,m.all.add(this)}start(M){this.g=new T.$he,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$je=m;let u=-1;function $(D){const M=u;return u=D,{dispose(){u=M}}}class h{static{this.f=1}constructor(M,K,W=(h.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=K,this.name=W,this.h=0}dispose(){this.g?.clear()}check(M,K){const W=this.threshold;if(W<=0||K<W)return;this.g||(this.g=new Map);const _=this.g.get(M.value)||0;if(this.g.set(M.value,_+1),this.h-=1,this.h<=0){this.h=W*.5;const[H,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(H);const z=new v(V,H);this.j(z)}return()=>{const H=this.g.get(M.value)||0;this.g.set(M.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let M,K=0;for(const[W,_]of this.g)(!M||K<_)&&(M=[W,_],K=_);return M}}class b{static create(){const M=new Error;return new b(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(M,K){super(M),this.name="ListenerLeakError",this.stack=K}}e.$le=v;class d extends Error{constructor(M,K){super(M),this.name="ListenerRefusalError",this.stack=K}}e.$me=d;let p=0;class P{constructor(M){this.value=M,this.id=p++}}const g=2,s=(D,M)=>{if(D instanceof P)M(D);else for(let K=0;K<D.length;K++){const W=D[K];W&&M(W)}};let r;if(O){const D=[];setInterval(()=>{D.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(D.join(`
`)),D.length=0)},3e3),r=new FinalizationRegistry(M=>{typeof M=="string"&&D.push(M)})}class t{constructor(M){this.z=0,this.f=M,this.g=u>0||this.f?.leakWarningThreshold?new h(M?.onListenerError??R.$3,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const M=this.u;queueMicrotask(()=>{s(M,K=>K.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,K,W)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const te=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],se=new d(`${z}. HINT: Stack shows most frequent listener (${te[1]}-times)`,te[0]);return(this.f?.onListenerError||R.$3)(se),N.$Xc.None}if(this.m)return N.$Xc.None;K&&(M=M.bind(K));const _=new P(M);let H,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(_.stack=b.create(),H=this.g.check(_.stack,this.z+1)),A&&(_.stack=ie??b.create()),this.u?this.u instanceof P?(this.w??=new i,this.u=[this.u,_]):this.u.push(_):(this.f?.onWillAddFirstListener?.(this),this.u=_,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,N.$Vc)(()=>{r?.unregister(V),H?.(),this.A(_)});if(W instanceof N.$Wc?W.add(V):Array.isArray(W)&&W.push(V),r){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),te=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);r.register(V,te?.[2]??z,V)}return V},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const K=this.u,W=K.indexOf(M);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,K[W]=void 0;const _=this.w.current===this;if(this.z*g<=K.length){let H=0;for(let ie=0;ie<K.length;ie++)K[ie]?K[H++]=K[ie]:_&&(this.w.end--,H<this.w.i&&this.w.i--);K.length=H}}B(M,K){if(!M)return;const W=this.f?.onListenerError||R.$3;if(!W){M.value(K);return}try{M.value(K)}catch(_){W(_)}}C(M){const K=M.current.u;for(;M.i<M.end;)this.B(K[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,M);else{const K=this.w;K.enqueue(this,M,this.u.length),this.C(K)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=t;const a=()=>new i;e.$oe=a;class i{constructor(){this.i=-1,this.end=0}enqueue(M,K,W){this.i=0,this.end=W,this.current=M,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends t{async fireAsync(M,K,W){if(this.u)for(this.h||(this.h=new k.$8c),s(this.u,_=>this.h.push([_.value,M]));this.h.size>0&&!K.isCancellationRequested;){const[_,H]=this.h.shift(),ie=[],V={...H,token:K,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");W&&(z=W(z,_)),ie.push(z)}};try{_(V)}catch(z){(0,R.$3)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const te of z)te.status==="rejected"&&(0,R.$3)(te.reason)})}}}e.$pe=n;class o extends t{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new k.$8c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$qe=o;class l extends o{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$re=l;class f extends t{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}e.$se=f;class I{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const K={event:M,listener:null};this.h.push(K),this.g&&this.m(K);const W=()=>{this.g&&this.o(K);const _=this.h.indexOf(K);this.h.splice(_,1)};return(0,N.$Vc)((0,c.$gb)(W))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(K=>this.f.fire(K))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$te=I;class L{constructor(M,K,W,_){this.f=new N.$Wc;const H=this.f.add(new I),ie=this.f.add(new N.$7c);function V(z){ie.set(z,H.add(_(z)))}for(const z of M)V(z);this.f.add(K(z=>{V(z)})),this.f.add(W(z=>{ie.deleteAndDispose(z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ue=L;class E{constructor(){this.f=[]}wrapEvent(M,K,W){return(_,H,ie)=>M(V=>{const z=this.f[this.f.length-1];if(!K){z?z.buffers.push(()=>_.call(H,V)):_.call(H,V);return}const te=z;if(!te){_.call(H,K(W,V));return}te.items??=[],te.items.push(V),te.buffers.length===0&&z.buffers.push(()=>{te.reducedResult??=W?te.items.reduce(K,W):te.items.reduce(K),_.call(H,te.reducedResult)})},void 0,ie)}bufferEvents(M){const K={buffers:new Array};this.f.push(K);const W=M();return this.f.pop(),K.buffers.forEach(_=>_()),W}}e.$ve=E;class y{constructor(){this.f=!1,this.g=S.None,this.h=N.$Xc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=y;class C{static const(M){return new F(M)}constructor(M){this.g=M,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$xe=C;class F{constructor(M){this.value=M,this.onDidChange=S.None}}}),define(ce[26],le([0,1,3]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=O;const c=Object.freeze(function(A,w){const S=setTimeout(A.bind(w),0);return{dispose(){clearTimeout(S)}}});var N;(function(A){function w(S){return S===A.None||S===A.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}A.isCancellationToken=w,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(N||(e.CancellationToken=N={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new R.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=N.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=N.None}}e.$ye=T;function O(A){const w=new T;return A.add({dispose(){w.cancel()}}),w.token}}),define(ce[134],le([0,1,26]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=N;class c{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new R.$ye,w=this.b(A.token);return this.a={promise:w,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$$e=c;function N(O){return O}class k{constructor(A,w){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);return this.b!==w&&(this.b=w,this.a=this.c(A)),this.a}}e.$af=k;class T{get cachedValues(){return this.a}constructor(A,w){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);if(this.b.has(w))return this.b.get(w);const S=this.c(A);return this.a.set(A,S),this.b.set(w,S),S}}e.$bf=T}),define(ce[51],le([0,1,8,2]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=N,e.$Be=k,e.$Ce=T,e.$De=O,e.$Ee=w,e.$Fe=S,e.$Ge=m,e.$He=u,e.$Ie=$,e.$Je=h,e.$Ke=b,e.$Le=v,e.$Me=d,e.$Ne=p,e.$Oe=P;function N(g){const s=g;return s?typeof s.read=="function":!1}function k(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}function T(g){const s=g;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function O(g,s){return new A(g,s)}class A{constructor(s,r){this.e=s,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(r=>r(s))}h(s){this.c.error.length===0?(0,R.$3)(s):this.c.error.slice(0).forEach(r=>r(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,r){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(s,r){if(this.a.destroyed)return;let t;switch(s){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const a=t.indexOf(r);a>=0&&t.splice(a,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(g,s){const r=[];let t;for(;(t=g.read())!==null;)r.push(t);return s(r)}function S(g,s,r){const t=[];let a;for(;(a=g.read())!==null&&t.length<r;)t.push(a);return a===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return g.read()}}}function m(g,s){return new Promise((r,t)=>{const a=[];u(g,{onData:i=>{s&&a.push(i)},onError:i=>{s?t(i):r(void 0)},onEnd:()=>{r(s?s(a):void 0)}})})}function u(g,s,r){g.on("error",t=>{r?.isCancellationRequested||s.onError(t)}),g.on("end",()=>{r?.isCancellationRequested||s.onEnd()}),g.on("data",t=>{r?.isCancellationRequested||s.onData(t)})}function $(g,s){return new Promise((r,t)=>{const a=new c.$Wc,i=[],n=f=>{if(i.push(f),i.length>s)return a.dispose(),g.pause(),r({stream:g,buffer:i,ended:!1})},o=f=>(a.dispose(),t(f)),l=()=>(a.dispose(),r({stream:g,buffer:i,ended:!0}));a.add((0,c.$Vc)(()=>g.removeListener("error",o))),g.on("error",o),a.add((0,c.$Vc)(()=>g.removeListener("end",l))),g.on("end",l),a.add((0,c.$Vc)(()=>g.removeListener("data",n))),g.on("data",n)})}function h(g,s){const r=O(s);return r.end(g),r}function b(){const g=O(()=>{throw new Error("not supported")});return g.end(),g}function v(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}function d(g,s,r){const t=O(r);return u(g,{onData:a=>t.write(s.data(a)),onError:a=>t.error(s.error?s.error(a):a),onEnd:()=>t.end()}),t}function p(g,s,r){let t=!1;return{read:()=>{const a=s.read();return t?a:(t=!0,a!==null?r([g,a]):g)}}}function P(g,s,r){let t=!1;const a=O(r);return u(s,{onData:i=>t?a.write(i):(t=!0,a.write(r([g,i]))),onError:i=>a.error(i),onEnd:()=>{t||(t=!0,a.write(g)),a.end()}}),a}});var Ot=this&&this.__createBinding||(Object.create?function(ne,e,R,c){c===void 0&&(c=R);var N=Object.getOwnPropertyDescriptor(e,R);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(ne,c,N)}:function(ne,e,R,c){c===void 0&&(c=R),ne[c]=e[R]}),At=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),ke=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var R in ne)R!=="default"&&Object.prototype.hasOwnProperty.call(ne,R)&&Ot(e,ne,R);return At(e,ne),e};define(ce[15],le([0,1,54,51]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=w,e.$Re=S,e.$Se=m,e.$Te=u,e.$Ue=$,e.$Ve=h,e.$We=b,e.$Xe=v,e.$Ye=d,e.$Ze=p,e.$1e=P,e.$2e=g,e.$3e=s,e.$4e=r,e.$5e=t,e.$6e=a,e.$7e=i,e.$8e=n,e.$9e=o,e.$0e=I,c=ke(c);const N=typeof Buffer<"u",k=new R.$X(()=>new Uint8Array(256));let T,O;class A{static alloc(E){return N?new A(Buffer.allocUnsafe(E)):new A(new Uint8Array(E))}static wrap(E){return N&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new A(E)}static fromString(E,y){return!(y?.dontUseNodeBuffer||!1)&&N?new A(Buffer.from(E)):(T||(T=new TextEncoder),new A(T.encode(E)))}static fromByteArray(E){const y=A.alloc(E.length);for(let C=0,F=E.length;C<F;C++)y.buffer[C]=E[C];return y}static concat(E,y){if(typeof y>"u"){y=0;for(let D=0,M=E.length;D<M;D++)y+=E[D].byteLength}const C=A.alloc(y);let F=0;for(let D=0,M=E.length;D<M;D++){const K=E[D];C.set(K,F),F+=K.byteLength}return C}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=A.alloc(this.byteLength);return E.set(this),E}toString(){return N?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(E,y){return new A(this.buffer.subarray(E,y))}set(E,y){if(E instanceof A)this.buffer.set(E.buffer,y);else if(E instanceof Uint8Array)this.buffer.set(E,y);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),y);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return u(this.buffer,E)}writeUInt32BE(E,y){$(this.buffer,E,y)}readUInt32LE(E){return h(this.buffer,E)}writeUInt32LE(E,y){b(this.buffer,E,y)}readUInt8(E){return v(this.buffer,E)}writeUInt8(E,y){d(this.buffer,E,y)}indexOf(E,y=0){return w(this.buffer,E instanceof A?E.buffer:E,y)}}e.$Pe=A;function w(L,E,y=0){const C=E.byteLength,F=L.byteLength;if(C===0)return 0;if(C===1)return L.indexOf(E[0]);if(C>F-y)return-1;const D=k.value;D.fill(E.length);for(let _=0;_<E.length;_++)D[E[_]]=E.length-_-1;let M=y+E.length-1,K=M,W=-1;for(;M<F;)if(L[M]===E[K]){if(K===0){W=M;break}M--,K--}else M+=Math.max(E.length-K,D[L[M]]),K=E.length-1;return W}function S(L,E){return L[E+0]<<0>>>0|L[E+1]<<8>>>0}function m(L,E,y){L[y+0]=E&255,E=E>>>8,L[y+1]=E&255}function u(L,E){return L[E]*2**24+L[E+1]*2**16+L[E+2]*2**8+L[E+3]}function $(L,E,y){L[y+3]=E,E=E>>>8,L[y+2]=E,E=E>>>8,L[y+1]=E,E=E>>>8,L[y]=E}function h(L,E){return L[E+0]<<0>>>0|L[E+1]<<8>>>0|L[E+2]<<16>>>0|L[E+3]<<24>>>0}function b(L,E,y){L[y+0]=E&255,E=E>>>8,L[y+1]=E&255,E=E>>>8,L[y+2]=E&255,E=E>>>8,L[y+3]=E&255}function v(L,E){return L[E]}function d(L,E,y){L[y]=E}function p(L){return c.$Ee(L,E=>A.concat(E))}function P(L){return c.$Le(L)}function g(L){return c.$Ge(L,E=>A.concat(E))}async function s(L){return L.ended?A.concat(L.buffer):A.concat([...L.buffer,await g(L.stream)])}function r(L){return c.$Je(L,E=>A.concat(E))}function t(L){return c.$Me(L,{data:E=>typeof E=="string"?A.fromString(E):A.wrap(E)},E=>A.concat(E))}function a(L){return c.$De(E=>A.concat(E),L)}function i(L,E){return c.$Ne(L,E,y=>A.concat(y))}function n(L,E){return c.$Oe(L,E,y=>A.concat(y))}function o(L){let E=0,y=0,C=0;const F=new Uint8Array(Math.floor(L.length/4*3)),D=K=>{switch(y){case 3:F[C++]=E|K,y=0;break;case 2:F[C++]=E|K>>>2,E=K<<6,y=3;break;case 1:F[C++]=E|K>>>4,E=K<<4,y=2;break;default:E=K<<2,y=1}};for(let K=0;K<L.length;K++){const W=L.charCodeAt(K);if(W>=65&&W<=90)D(W-65);else if(W>=97&&W<=122)D(W-97+26);else if(W>=48&&W<=57)D(W-48+52);else if(W===43||W===45)D(62);else if(W===47||W===95)D(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${L[K]}`)}}const M=C;for(;y>0;)D(0);return A.wrap(F).slice(0,M)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:L},E=!0,y=!1){const C=y?f:l;let F="";const D=L.byteLength%3;let M=0;for(;M<L.byteLength-D;M+=3){const K=L[M+0],W=L[M+1],_=L[M+2];F+=C[K>>>2],F+=C[(K<<4|W>>>4)&63],F+=C[(W<<2|_>>>6)&63],F+=C[_&63]}if(D===1){const K=L[M+0];F+=C[K>>>2],F+=C[K<<4&63],E&&(F+="==")}else if(D===2){const K=L[M+0],W=L[M+1];F+=C[K>>>2],F+=C[(K<<4|W>>>4)&63],F+=C[W<<2&63],E&&(F+="=")}return F}}),define(ce[135],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(ce[13],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=R,e.$hg=c,e.$ig=N,e.$jg=k,e.$kg=T,e.$lg=O,e.$mg=A,e.$ng=w,e.$og=S,e.$pg=m,e.$qg=u,e.$rg=$,e.$sg=h,e.$tg=v,e.$ug=d,e.$vg=p,e.$wg=P,e.$xg=g;function R(s){return typeof s=="string"}function c(s){return Array.isArray(s)&&s.every(r=>R(r))}function N(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function k(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}function T(s){return typeof s=="number"&&!isNaN(s)}function O(s){return!!s&&typeof s[Symbol.iterator]=="function"}function A(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function S(s){return!m(s)}function m(s){return w(s)||s===null}function u(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function $(s){if(m(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function h(...s){const r=[];for(let t=0;t<s.length;t++){const a=s[t];if(m(a))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);r.push(a)}return r}const b=Object.prototype.hasOwnProperty;function v(s){if(!N(s))return!1;for(const r in s)if(b.call(s,r))return!1;return!0}function d(s){return typeof s=="function"}function p(...s){return s.length>0&&s.every(d)}function P(s,r){const t=Math.min(s.length,r.length);for(let a=0;a<t;a++)g(s[a],r[a])}function g(s,r){if(R(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(s instanceof r)return}catch{}if(!m(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[30],le([0,1,13]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=c,e.$fo=N,e.$go=T,e.$ho=A,e.$io=w,e.$jo=S,e.$ko=m,e.$lo=u,e.$mo=$,e.$no=h,e.$oo=b,e.$po=v,e.$qo=d;function c(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const P=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([g,s])=>{P[g]=s&&typeof s=="object"?c(s):s}),P}function N(p){if(!p||typeof p!="object")return p;const P=[p];for(;P.length>0;){const g=P.shift();Object.freeze(g);for(const s in g)if(k.call(g,s)){const r=g[s];typeof r=="object"&&!Object.isFrozen(r)&&!(0,R.$jg)(r)&&P.push(r)}}return p}const k=Object.prototype.hasOwnProperty;function T(p,P){return O(p,P,new Set)}function O(p,P,g){if((0,R.$pg)(p))return p;const s=P(p);if(typeof s<"u")return s;if(Array.isArray(p)){const r=[];for(const t of p)r.push(O(t,P,g));return r}if((0,R.$ig)(p)){if(g.has(p))throw new Error("Cannot clone recursive data-structure");g.add(p);const r={};for(const t in p)k.call(p,t)&&(r[t]=O(p[t],P,g));return g.delete(p),r}return p}function A(p,P,g=!0){return(0,R.$ig)(p)?((0,R.$ig)(P)&&Object.keys(P).forEach(s=>{s in p?g&&((0,R.$ig)(p[s])&&(0,R.$ig)(P[s])?A(p[s],P[s],g):p[s]=P[s]):p[s]=P[s]}),p):P}function w(p,P){if(p===P)return!0;if(p==null||P===null||P===void 0||typeof p!=typeof P||typeof p!="object"||Array.isArray(p)!==Array.isArray(P))return!1;let g,s;if(Array.isArray(p)){if(p.length!==P.length)return!1;for(g=0;g<p.length;g++)if(!w(p[g],P[g]))return!1}else{const r=[];for(s in p)r.push(s);r.sort();const t=[];for(s in P)t.push(s);if(t.sort(),!w(r,t))return!1;for(g=0;g<r.length;g++)if(!w(p[r[g]],P[r[g]]))return!1}return!0}function S(p){const P=new Set;return JSON.stringify(p,(g,s)=>{if((0,R.$ig)(s)||Array.isArray(s)){if(P.has(s))return"[Circular]";P.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function m(p,P){const g=Object.create(null);return!p||!P||Object.keys(P).forEach(r=>{const t=p[r],a=P[r];w(t,a)||(g[r]=a)}),g}function u(p,P){const g=P.toLowerCase(),s=Object.keys(p).find(r=>r.toLowerCase()===g);return s?p[s]:p[P]}function $(p,P){const g=Object.create(null);for(const[s,r]of Object.entries(p))P(s,r)&&(g[s]=r);return g}function h(p){let P=[];for(;Object.prototype!==p;)P=P.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return P}function b(p){const P=[];for(const g of h(p))typeof p[g]=="function"&&P.push(g);return P}function v(p,P){const g=r=>function(){const t=Array.prototype.slice.call(arguments,0);return P(r,t)},s={};for(const r of p)s[r]=g(r);return s}function d(p,P){const g={};for(const[s,r]of Object.entries(p))g[s]=P(r,s);return g}}),define(ce[136],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=c,e.$df=N;var R;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function c(k){return k<0?0:k>R.MAX_UINT_8?R.MAX_UINT_8:k|0}function N(k){return k<0?0:k>R.MAX_UINT_32?R.MAX_UINT_32:k|0}}),define(ce[27],le([0,1,134,39,54,136]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=T,e.$ff=A,e.$gf=S,e.$hf=m,e.$if=u,e.$jf=$,e.$kf=h,e.$lf=b,e.$mf=v,e.$nf=d,e.$of=p,e.$pf=P,e.$qf=g,e.$rf=s,e.$sf=r,e.$tf=t,e.$uf=a,e.$vf=i,e.$wf=n,e.$xf=o,e.$yf=l,e.$zf=f,e.$Af=I,e.$Bf=L,e.$Cf=E,e.$Df=y,e.$Ef=C,e.$Ff=F,e.$Gf=D,e.$Hf=M,e.$If=K,e.$Jf=W,e.$Kf=_,e.$Lf=H,e.$Mf=ie,e.$Nf=V,e.$Of=z,e.$Rf=q,e.$Sf=Z,e.$Tf=X,e.$Uf=G,e.$Vf=B,e.$Wf=x,e.$Yf=ee,e.$Zf=J,e.$1f=oe,e.$2f=ue,e.$3f=pe,e.$4f=Ie,e.$5f=be,e.$7f=Ee,e.$8f=Se,e.$9f=ae,e.$0f=de,e.$$f=me,e.$_f=Re,e.$ag=Oe,e.$bg=Fe,e.$cg=Ge;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}const O=/{(\d+)}/g;function A(re,...fe){return fe.length===0?re:re.replace(O,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const w=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(w,($e,ye)=>fe[ye]??$e)}function m(re){return re.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function u(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(re,fe){let $e=0,ye=re.indexOf(fe);for(;ye!==-1;)$e++,ye=re.indexOf(fe,ye+fe.length);return $e}function b(re,fe,$e="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${$e}`}function v(re,fe,$e="\u2026"){if(re.length<=fe)return re;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${re.substr(0,ye)}${$e}${re.substr(re.length-Ae)}`}function d(re,fe=" "){const $e=p(re,fe);return P($e,fe)}function p(re,fe){if(!re||!fe)return re;const $e=fe.length;if($e===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+$e;return re.substring(ye)}function P(re,fe){if(!re||!fe)return re;const $e=fe.length,ye=re.length;if($e===0||ye===0)return re;let Ae=ye,Ce=-1;for(;Ce=re.lastIndexOf(fe,Ae-1),!(Ce===-1||Ce+$e!==Ae);){if(Ce===0)return"";Ae=Ce}return re.substring(0,Ae)}function g(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(re){return re.replace(/\*/g,"")}function r(re,fe,$e={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=$(re)),$e.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(re,ye)}function t(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function a(re){return re.split(/\r\n|\r|\n/)}function i(re){const fe=[],$e=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(re){for(let fe=0,$e=re.length;fe<$e;fe++){const ye=re.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function o(re,fe=0,$e=re.length){for(let ye=fe;ye<$e;ye++){const Ae=re.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return re.substring(fe,ye)}return re.substring(fe,$e)}function l(re,fe=re.length-1){for(let $e=fe;$e>=0;$e--){const ye=re.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function f(re,fe,$e){const ye=[];let Ae=0;for(const Ce of re.matchAll(fe)){if(ye.push(re.slice(Ae,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ae=Ce.index+Ce[0].length,ye.push($e(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return ye.push(re.slice(Ae)),Promise.all(ye).then(Ce=>Ce.join(""))}function I(re,fe){return re<fe?-1:re>fe?1:0}function L(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){const Xe=re.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Xe<Qe)return-1;if(Xe>Qe)return 1}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function E(re,fe){return y(re,fe,0,re.length,0,fe.length)}function y(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){let Xe=re.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Xe===Qe)continue;if(Xe>=128||Qe>=128)return L(re.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Ce);F(Xe)&&(Xe-=32),F(Qe)&&(Qe-=32);const Ve=Xe-Qe;if(Ve!==0)return Ve}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function C(re){return re>=c.CharCode.Digit0&&re<=c.CharCode.Digit9}function F(re){return re>=c.CharCode.a&&re<=c.CharCode.z}function D(re){return re>=c.CharCode.A&&re<=c.CharCode.Z}function M(re,fe){return re.length===fe.length&&y(re,fe)===0}function K(re,fe){const $e=fe.length;return fe.length>re.length?!1:y(re,fe,0,$e)===0}function W(re,fe){const $e=Math.min(re.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function _(re,fe){const $e=Math.min(re.length,fe.length);let ye;const Ae=re.length-1,Ce=fe.length-1;for(ye=0;ye<$e;ye++)if(re.charCodeAt(Ae-ye)!==fe.charCodeAt(Ce-ye))return ye;return $e}function H(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function V(re,fe){return(re-55296<<10)+(fe-56320)+65536}function z(re,fe,$e){const ye=re.charCodeAt($e);if(H(ye)&&$e+1<fe){const Ae=re.charCodeAt($e+1);if(ie(Ae))return V(ye,Ae)}return ye}function te(re,fe){const $e=re.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=re.charCodeAt(fe-2);if(H(ye))return V(ye,$e)}return $e}class se{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=te(this.c,this.e);return this.e-=fe>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Pf=se;class he{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new se(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,je)){$e.setOffset(Ce);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(je,Ae)){$e.setOffset(Ce);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Qf=he;function q(re,fe){return new he(re,fe).nextGraphemeLength()}function Z(re,fe){return new he(re,fe).prevGraphemeLength()}function X(re,fe){fe>0&&ie(re.charCodeAt(fe))&&fe--;const $e=fe+q(re,fe);return[$e-Z(re,$e),$e]}function G(re){const fe=new he(re);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let U;function Q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(re){return U||(U=Q()),U.test(re)}const j=/^[\t\n\r\x20-\x7E]*$/;function x(re){return j.test(re)}e.$Xf=/[\u2028\u2029]/;function ee(re){return e.$Xf.test(re)}function J(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function oe(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function ue(re,fe,$e=""){const ye=re.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Ce=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Ce=Ae.lastIndex,Ae.lastIndex+=1;return Ce===0?ye:$e+ye.substring(Ce).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(re){let fe=0;for(const $e of re.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:re.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==re.length&&(yield{isCode:!1,str:re.substring(fe)})}function Ie(re){return re&&(re=re.replace(ge,"")),re}const we=/\\\[.*?\\\]/g;function be(re){return Ie(re).replace(we,"")}e.$6f=String.fromCharCode(c.CharCode.UTF8_BOM);function Ee(re){return!!(re&&re.length>0&&re.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Se(re){return Ee(re)?re.substr(1):re}function ae(re,fe){if(!re||!fe||re.length<fe.length)return!1;const $e=fe.length,ye=re.toLowerCase();let Ae=0,Ce=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Ce+1);if(je<0)return!1;Ce=je,Ae++}return!0}function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Re(re,fe=1){if(fe===0)return"";let $e=-1;do $e=re.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?re:(re[$e-1]==="\r"&&$e--,re.substr(0,$e))}function Oe(re){const fe=c.CharCode.Z-c.CharCode.A+1;return re=re%(2*fe),re<fe?String.fromCharCode(c.CharCode.a+re):String.fromCharCode(c.CharCode.A+re-fe)}function Fe(re){return Ue.getInstance().getGraphemeBreakType(re)}function Te(re,fe){return re===Ne.Other?fe!==Ne.Extend&&fe!==Ne.SpacingMark:re===Ne.CR&&fe===Ne.LF?!1:re===Ne.Control||re===Ne.CR||re===Ne.LF||fe===Ne.Control||fe===Ne.CR||fe===Ne.LF?!0:!(re===Ne.L&&(fe===Ne.L||fe===Ne.V||fe===Ne.LV||fe===Ne.LVT)||(re===Ne.LV||re===Ne.V)&&(fe===Ne.V||fe===Ne.T)||(re===Ne.LVT||re===Ne.T)&&fe===Ne.T||fe===Ne.Extend||fe===Ne.ZWJ||fe===Ne.SpacingMark||re===Ne.Prepend||re===Ne.ZWJ&&fe===Ne.Extended_Pictographic||re===Ne.Regional_Indicator&&fe===Ne.Regional_Indicator)}var Ne;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Ne.LF:fe===c.CharCode.CarriageReturn?Ne.CR:Ne.Control;if(fe<127)return Ne.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Ne.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(re,fe){if(re===0)return 0;const $e=Me(re,fe);if($e!==void 0)return $e;const ye=new se(fe,re);return ye.prevCodePoint(),ye.offset}function Me(re,fe){const $e=new se(fe,re);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!oe(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(re){return 127995<=re&&re<=127999}var ze;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$dg="\xA0";class We{static{this.c=new N.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$af({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)_e.set(Ve[Ye],Ve[Ye+1]);return _e}function ye(Ve,_e){const Ye=new Map(Ve);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Ae(Ve,_e){if(!Ve)return _e;const Ye=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ye.set(nt,at);return Ye}const Ce=this.c.value;let je=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Ce);je.length===0&&(je=["_default"]);let xe;for(const Ve of je){const _e=$e(Ce[Ve]);xe=Ae(xe,_e)}const Xe=$e(Ce._common),Qe=ye(Xe,xe);return new We(Qe)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new N.$X(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=We;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(fe){return Le.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Le.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Le.e()}}e.$fg=Le}),define(ce[56],le([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=c,e.$vj=N,e.$wj=k,e.$xj=O,e.$zj=b,R=ke(R);function c(d){return N(d,0)}function N(d,p){switch(typeof d){case"object":return d===null?k(349,p):Array.isArray(d)?A(d,p):w(d,p);case"string":return O(d,p);case"boolean":return T(d,p);case"number":return k(d,p);case"undefined":return k(937,p);default:return k(617,p)}}function k(d,p){return(p<<5)-p+d|0}function T(d,p){return k(d?433:863,p)}function O(d,p){p=k(149417,p);for(let P=0,g=d.length;P<g;P++)p=k(d.charCodeAt(P),p);return p}function A(d,p){return p=k(104579,p),d.reduce((P,g)=>N(g,P),p)}function w(d,p){return p=k(181387,p),Object.keys(d).sort().reduce((P,g)=>(P=O(g,P),N(d[g],P)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=N(p,this.g),this.g}}e.$yj=S;var m;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function u(d,p,P=32){const g=P-p,s=~((1<<g)-1);return(d<<p|(s&d)>>>g)>>>0}function $(d,p=0,P=d.byteLength,g=0){for(let s=0;s<P;s++)d[p+s]=g}function h(d,p,P="0"){for(;d.length<p;)d=P+d;return d}function b(d,p=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(P=>P.toString(16).padStart(2,"0")).join(""):h((d>>>0).toString(16),p/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(m.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const P=p.length;if(P===0)return;const g=this.p;let s=this.r,r=this.u,t,a;for(r!==0?(t=r,a=-1,r=0):(t=p.charCodeAt(0),a=0);;){let i=t;if(R.$Lf(t))if(a+1<P){const n=p.charCodeAt(a+1);R.$Mf(n)?(a++,i=R.$Nf(t,n)):i=m.UNICODE_REPLACEMENT}else{r=t;break}else R.$Mf(t)&&(i=m.UNICODE_REPLACEMENT);if(s=this.w(g,s,i),a++,a<P)t=p.charCodeAt(a);else break}this.r=s,this.u=r}w(p,P,g){return g<128?p[P++]=g:g<2048?(p[P++]=192|(g&1984)>>>6,p[P++]=128|(g&63)>>>0):g<65536?(p[P++]=224|(g&61440)>>>12,p[P++]=128|(g&4032)>>>6,p[P++]=128|(g&63)>>>0):(p[P++]=240|(g&1835008)>>>18,p[P++]=128|(g&258048)>>>12,p[P++]=128|(g&4032)>>>6,p[P++]=128|(g&63)>>>0),P>=m.BLOCK_SIZE&&(this.y(),P-=m.BLOCK_SIZE,this.t+=m.BLOCK_SIZE,p[0]=p[m.BLOCK_SIZE+0],p[1]=p[m.BLOCK_SIZE+1],p[2]=p[m.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,m.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=v.g,P=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,P.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,u(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let g=this.h,s=this.l,r=this.m,t=this.n,a=this.o,i,n,o;for(let l=0;l<80;l++)l<20?(i=s&r|~s&t,n=1518500249):l<40?(i=s^r^t,n=1859775393):l<60?(i=s&r|s&t|r&t,n=2400959708):(i=s^r^t,n=3395469782),o=u(g,5)+i+a+n+p.getUint32(l*4,!1)&4294967295,a=t,t=r,r=u(s,30),s=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+s&4294967295,this.m=this.m+r&4294967295,this.n=this.n+t&4294967295,this.o=this.o+a&4294967295}}e.$Aj=v}),define(ce[92],le([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=ke(R);var c;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(c||(c={})),function(N){const k="error",T="warning",O="warn",A="info",w="ignore";function S(u){return u?R.$Hf(k,u)?N.Error:R.$Hf(T,u)||R.$Hf(O,u)?N.Warning:R.$Hf(A,u)?N.Info:N.Ignore:N.Ignore}N.fromValue=S;function m(u){switch(u){case N.Error:return k;case N.Warning:return T;case N.Info:return A;default:return w}}N.toString=m}(c||(c={})),e.default=c}),define(ce[52],le([0,1,19,39,27]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class k{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const b=h.charCodeAt(0),v=this.b.charCodeAt(this.c);return b-v}value(){return this.b[this.c]}}e.$Ii=k;class T{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$Bf)(h,this.b,0,h.length,this.c,this.d):(0,N.$Df)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=T;class O{constructor(h=!0,b=!0){this.f=h,this.g=b}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let b=h.length-1;b>=0;b--,this.c--){const v=this.b.charCodeAt(b);if(!(v===c.CharCode.Slash||this.f&&v===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===c.CharCode.Slash||this.f&&b===c.CharCode.Backslash)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$Bf)(h,this.b,0,h.length,this.d,this.e):(0,N.$Df)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=O;var A;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(h,b){this.f=h,this.g=b,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(A.Path)),this.g(h)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===A.Scheme)return(0,N.$Cf)(h,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,N.$Cf)(h,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(h);if(this.d[this.e]===A.Query)return(0,N.$Af)(h,this.c.query);if(this.d[this.e]===A.Fragment)return(0,N.$Af)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Li=w;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(m||(m={}));class u{static forUris(h=()=>!1,b=()=>!1){return new u(new w(h,b))}static forPaths(h=!1){return new u(new O(void 0,!h))}static forStrings(){return new u(new k)}static forConfigKeys(){return new u(new T)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,b){if(b){const v=b.slice(0);(0,R.$Zb)(v);for(const d of v)this.set(d,h)}else{const v=h.slice(0);(0,R.$Zb)(v);for(const d of v)this.set(d[0],d[1])}}set(h,b){const v=this.b.reset(h);let d;this.c||(this.c=new S,this.c.segment=v.value());const p=[];for(d=this.c;;){const g=v.cmp(d.segment);if(g>0)d.left||(d.left=new S,d.left.segment=v.value()),p.push([m.Left,d]),d=d.left;else if(g<0)d.right||(d.right=new S,d.right.segment=v.value()),p.push([m.Right,d]),d=d.right;else if(v.hasNext())v.next(),d.mid||(d.mid=new S,d.mid.segment=v.value()),p.push([m.Mid,d]),d=d.mid;else break}const P=d.value;d.value=b,d.key=h;for(let g=p.length-1;g>=0;g--){const s=p[g][1];s.updateHeight();const r=s.balanceFactor();if(r<-1||r>1){const t=p[g][0],a=p[g+1][0];if(t===m.Right&&a===m.Right)p[g][1]=s.rotateLeft();else if(t===m.Left&&a===m.Left)p[g][1]=s.rotateRight();else if(t===m.Right&&a===m.Left)s.right=p[g+1][1]=p[g+1][1].rotateRight(),p[g][1]=s.rotateLeft();else if(t===m.Left&&a===m.Right)s.left=p[g+1][1]=p[g+1][1].rotateLeft(),p[g][1]=s.rotateRight();else throw new Error;if(g>0)switch(p[g-1][0]){case m.Left:p[g-1][1].left=p[g][1];break;case m.Right:p[g-1][1].right=p[g][1];break;case m.Mid:p[g-1][1].mid=p[g][1];break}else this.c=p[0][1]}}return P}get(h){return this.d(h)?.value}d(h){const b=this.b.reset(h);let v=this.c;for(;v;){const d=b.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(b.hasNext())b.next(),v=v.mid;else break}return v}has(h){const b=this.d(h);return!(b?.value===void 0&&b?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,b){const v=this.b.reset(h),d=[];let p=this.c;for(;p;){const P=v.cmp(p.segment);if(P>0)d.push([m.Left,p]),p=p.left;else if(P<0)d.push([m.Right,p]),p=p.right;else if(v.hasNext())v.next(),d.push([m.Mid,p]),p=p.mid;else break}if(p){if(b?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const P=this.f(p.right);if(P.key){const{key:g,value:s,segment:r}=P;this.e(P.key,!1),p.key=g,p.value=s,p.segment=r}}else{const P=p.left??p.right;if(d.length>0){const[g,s]=d[d.length-1];switch(g){case m.Left:s.left=P;break;case m.Mid:s.mid=P;break;case m.Right:s.right=P;break}}else this.c=P}for(let P=d.length-1;P>=0;P--){const g=d[P][1];g.updateHeight();const s=g.balanceFactor();if(s>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),d[P][1]=g.rotateLeft()):s<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),d[P][1]=g.rotateRight()),P>0)switch(d[P-1][0]){case m.Left:d[P-1][1].left=d[P][1];break;case m.Right:d[P-1][1].right=d[P][1];break;case m.Mid:d[P-1][1].mid=d[P][1];break}else this.c=d[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const b=this.b.reset(h);let v=this.c,d;for(;v;){const p=b.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(b.hasNext())b.next(),d=v.value||d,v=v.mid;else break}return v&&v.value||d}findSuperstr(h){return this.g(h,!1)}g(h,b){const v=this.b.reset(h);let d=this.c;for(;d;){const p=v.cmp(d.segment);if(p>0)d=d.left;else if(p<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.h(d.mid):b?d.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[b,v]of this)h(v,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const b=[];return this.j(h,b),b[Symbol.iterator]()}j(h,b){h&&(h.left&&this.j(h.left,b),h.value&&b.push([h.key,h.value]),h.mid&&this.j(h.mid,b),h.right&&this.j(h.right,b))}_isBalanced(){const h=b=>{if(!b)return!0;const v=b.balanceFactor();return v<-1||v>1?!1:h(b.left)&&h(b.right)};return h(this.c)}}e.$Mi=u}),define(ce[32],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=c;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(N){return R.test(N)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(O){for(let A=0;A<O.length;A++)O[A]=Math.floor(Math.random()*256);return O};const k=new Uint8Array(16),T=[];for(let O=0;O<256;O++)T.push(O.toString(16).padStart(2,"0"));return function(){N(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let A=0,w="";return w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w+="-",w+=T[k[A++]],w+=T[k[A++]],w+="-",w+=T[k[A++]],w+=T[k[A++]],w+="-",w+=T[k[A++]],w+=T[k[A++]],w+="-",w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w+=T[k[A++]],w}}()}),define(ce[137],le([0,1,38]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=k;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const O=T.replace(/\-/g,":").toLowerCase();return!c.has(O)}function k(){const T=(0,R.networkInterfaces)();for(const O in T){const A=T[O];if(A){for(const{mac:w}of A)if(N(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[138],le([0,1,277,15]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zX=void 0;class N extends R.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const O=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(T,O,A){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let w=0;for(;w<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,w):(0,c.$Qe)(this.a,this.b,w);if(S===-1)break;this.push(this.a.slice(w,S+this.c)),w=S+this.c}this.a=w===this.a.length?void 0:this.a.slice(w),A()}_flush(T){this.a&&this.push(this.a),T()}}e.$zX=N}),define(ce[139],le([0,1,67]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=c,e.$7g=k,R=ke(R);function c(O,A,w,S=1){let m=!1;return new Promise(u=>{const $=setTimeout(()=>{if(!m)return m=!0,u(0)},w);N(O,A,S,h=>{if(!m)return m=!0,clearTimeout($),u(h)})})}function N(O,A,w,S){if(A===0)return S(0);const m=new R.Socket;m.once("connect",()=>(T(m),N(O+w,A-1,w,S))),m.once("data",()=>{}),m.once("error",u=>(T(m),u.code!=="ECONNREFUSED"?N(O+w,A-1,w,S):S(O))),m.connect(O,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(O,A,w,S="127.0.0.1"){let m=!1,u,$=1;const h=R.createServer({pauseOnConnect:!0});function b(v,d){m||(m=!0,h.removeAllListeners(),h.close(),u&&clearTimeout(u),d(v))}return new Promise(v=>{u=setTimeout(()=>{b(0,v)},w),h.on("listening",()=>{b(O,v)}),h.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&$<A?(O++,$++,h.listen(O,S)):b(0,v)}),h.on("close",()=>{b(0,v)}),h.listen(O,S)})}function T(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(A){console.error(A)}}}),define(ce[140],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RX=R;function R(c){return!!c.parentPort}}),define(ce[141],le([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ce[68],le([0,1,141]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=w,e.$3m=S,e.$4m=m;const c=60,N=c*60,k=N*24,T=k*7,O=k*30,A=k*365;function w(u,$,h,b){typeof u!="number"&&(u=u.getTime());const v=Math.round((new Date().getTime()-u)/1e3);if(v<-30)return(0,R.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(!b&&v<30)return(0,R.localize)(1,null);let d;return v<c?(d=v,$?d===1?h?(0,R.localize)(2,null,d):(0,R.localize)(3,null,d):h?(0,R.localize)(4,null,d):(0,R.localize)(5,null,d):d===1?h?(0,R.localize)(6,null,d):(0,R.localize)(7,null,d):h?(0,R.localize)(8,null,d):(0,R.localize)(9,null,d)):v<N?(d=Math.floor(v/c),$?d===1?h?(0,R.localize)(10,null,d):(0,R.localize)(11,null,d):h?(0,R.localize)(12,null,d):(0,R.localize)(13,null,d):d===1?h?(0,R.localize)(14,null,d):(0,R.localize)(15,null,d):h?(0,R.localize)(16,null,d):(0,R.localize)(17,null,d)):v<k?(d=Math.floor(v/N),$?d===1?h?(0,R.localize)(18,null,d):(0,R.localize)(19,null,d):h?(0,R.localize)(20,null,d):(0,R.localize)(21,null,d):d===1?h?(0,R.localize)(22,null,d):(0,R.localize)(23,null,d):h?(0,R.localize)(24,null,d):(0,R.localize)(25,null,d)):v<T?(d=Math.floor(v/k),$?d===1?(0,R.localize)(26,null,d):(0,R.localize)(27,null,d):d===1?(0,R.localize)(28,null,d):(0,R.localize)(29,null,d)):v<O?(d=Math.floor(v/T),$?d===1?h?(0,R.localize)(30,null,d):(0,R.localize)(31,null,d):h?(0,R.localize)(32,null,d):(0,R.localize)(33,null,d):d===1?h?(0,R.localize)(34,null,d):(0,R.localize)(35,null,d):h?(0,R.localize)(36,null,d):(0,R.localize)(37,null,d)):v<A?(d=Math.floor(v/O),$?d===1?h?(0,R.localize)(38,null,d):(0,R.localize)(39,null,d):h?(0,R.localize)(40,null,d):(0,R.localize)(41,null,d):d===1?h?(0,R.localize)(42,null,d):(0,R.localize)(43,null,d):h?(0,R.localize)(44,null,d):(0,R.localize)(45,null,d)):(d=Math.floor(v/A),$?d===1?h?(0,R.localize)(46,null,d):(0,R.localize)(47,null,d):h?(0,R.localize)(48,null,d):(0,R.localize)(49,null,d):d===1?h?(0,R.localize)(50,null,d):(0,R.localize)(51,null,d):h?(0,R.localize)(52,null,d):(0,R.localize)(53,null,d))}function S(u,$){const h=Math.abs(u/1e3);return h<1?$?(0,R.localize)(54,null,u):(0,R.localize)(55,null,u):h<c?$?(0,R.localize)(56,null,Math.round(u)/1e3):(0,R.localize)(57,null,Math.round(u)/1e3):h<N?$?(0,R.localize)(58,null,Math.round(u/(1e3*c))):(0,R.localize)(59,null,Math.round(u/(1e3*c))):h<k?$?(0,R.localize)(60,null,Math.round(u/(1e3*N))):(0,R.localize)(61,null,Math.round(u/(1e3*N))):(0,R.localize)(62,null,Math.round(u/(1e3*k)))}function m(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[142],le([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ce[41],le([0,1,19,13,142]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=A,e.$sj=w,e.$tj=S,R=ke(R),c=ke(c),N=ke(N);function k(m,u){return u&&(m.stack||m.stacktrace)?N.localize(0,null,O(m),T(m.stack)||T(m.stacktrace)):O(m)}function T(m){return Array.isArray(m)?m.join(`
`):m}function O(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?N.localize(1,null,m.message):m.message||N.localize(2,null)}function A(m=null,u=!1){if(!m)return N.localize(3,null);if(Array.isArray(m)){const $=R.$Kb(m),h=A($[0],u);return $.length>1?N.localize(4,null,h,$.length):h}if(c.$gg(m))return m;if(m.detail){const $=m.detail;if($.error)return k($.error,u);if($.exception)return k($.exception,u)}return m.stack?k(m,u):m.message?m.message:N.localize(5,null)}function w(m){const u=m;return u instanceof Error&&Array.isArray(u.actions)}function S(m,u){let $;return typeof m=="string"?$=new Error(m):$=m,$.actions=u,$}}),define(ce[143],le([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ce[144],le([0,1,143,34]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=N;function N(k){switch(k){case c.ParseErrorCode.InvalidSymbol:return(0,R.localize)(0,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(1,null);case c.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(2,null);case c.ParseErrorCode.ValueExpected:return(0,R.localize)(3,null);case c.ParseErrorCode.ColonExpected:return(0,R.localize)(4,null);case c.ParseErrorCode.CommaExpected:return(0,R.localize)(5,null);case c.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(6,null);case c.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(7,null);case c.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(8,null);default:return""}}}),define(ce[145],le([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ce[5],le([0,1,145]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=t,e.$D=f,e.$J=I,R=ke(R),e.$g="en";let c=!1,N=!1,k=!1,T=!1,O=!1,A=!1,w=!1,S=!1,m=!1,u=!1,$,h=e.$g,b=e.$g,v,d;const p=globalThis;let P;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?P=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(P=process);const g=typeof P?.versions?.electron=="string",s=g&&P?.type==="renderer";if(typeof P=="object"){c=P.platform==="win32",N=P.platform==="darwin",k=P.platform==="linux",T=k&&!!P.env.SNAP&&!!P.env.SNAP_REVISION,w=g,m=!!P.env.CI||!!P.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,h=e.$g;const L=P.env.VSCODE_NLS_CONFIG;if(L)try{const E=JSON.parse(L),y=E.availableLanguages["*"];$=E.locale,b=E.osLocale,h=y||e.$g,v=E._translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!s?(d=navigator.userAgent,c=d.indexOf("Windows")>=0,N=d.indexOf("Macintosh")>=0,S=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,u=d?.indexOf("Mobi")>=0,A=!0,$=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$g,h=$,b=navigator.language):console.error("Unable to resolve platform.");var r;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(r||(e.Platform=r={}));function t(L){switch(L){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let a=r.Web;N?a=r.Mac:c?a=r.Windows:k&&(a=r.Linux),e.$i=c,e.$j=N,e.$k=k,e.$l=T,e.$m=O,e.$n=w,e.$o=A,e.$p=A&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=S,e.$s=u,e.$t=m,e.$u=a,e.$v=d,e.$w=h;var i;(function(L){function E(){return e.$w}L.value=E;function y(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=y;function C(){return e.$w==="en"}L.isDefault=C})(i||(e.Language=i={})),e.$x=$,e.$y=b,e.$z=v,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const L=[];p.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let C=0,F=L.length;C<F;C++){const D=L[C];if(D.id===y.data.vscodeScheduleAsyncWork){L.splice(C,1),D.callback();return}}});let E=0;return y=>{const C=++E;L.push({id:C,callback:y}),p.postMessage({vscodeScheduleAsyncWork:C},"*")}}return L=>setTimeout(L)})();var n;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=N||S?n.Macintosh:c?n.Windows:n.Linux;let o=!0,l=!1;function f(){if(!l){l=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,o=new Uint16Array(L.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(L){return parseFloat(L)>=20}}),define(ce[37],le([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let c;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const k=N.process;c={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$gc=c.platform,e.$hc=c.arch}),define(ce[146],le([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=T;var c;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(c||(c={}));const N="XDG_CURRENT_DESKTOP",k="KDE_SESSION_VERSION";function T(){const O=R.env[N];if(O){const w=O.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of w)switch(S){case"Unity":{const m=R.env.DESKTOP_SESSION;return m&&m.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const m=R.env[k];return m==="5"?c.KDE5:m==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const A=R.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return k in R.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?c.GNOME:"KDE_FULL_SESSION"in R.env?k in R.env?c.KDE4:c.KDE3:c.UNKNOWN}}),define(ce[14],le([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,R=ke(R);const c=65,N=97,k=90,T=122,O=46,A=47,w=92,S=58,m=63;class u extends Error{constructor(t,a,i){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=t.indexOf(".")!==-1?"property":"argument";let l=`The "${t}" ${o} ${n} of type ${a}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function $(r,t){if(r===null||typeof r!="object")throw new u(t,"Object",r)}function h(r,t){if(typeof r!="string")throw new u(t,"string",r)}const b=R.$gc==="win32";function v(r){return r===A||r===w}function d(r){return r===A}function p(r){return r>=c&&r<=k||r>=N&&r<=T}function P(r,t,a,i){let n="",o=0,l=-1,f=0,I=0;for(let L=0;L<=r.length;++L){if(L<r.length)I=r.charCodeAt(L);else{if(i(I))break;I=A}if(i(I)){if(!(l===L-1||f===1))if(f===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==O||n.charCodeAt(n.length-2)!==O){if(n.length>2){const E=n.lastIndexOf(a);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(a)),l=L,f=0;continue}else if(n.length!==0){n="",o=0,l=L,f=0;continue}}t&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${r.slice(l+1,L)}`:n=r.slice(l+1,L),o=L-l-1;l=L,f=0}else I===O&&f!==-1?++f:f=-1}return n}function g(r,t){$(t,"pathObject");const a=t.dir||t.root,i=t.base||`${t.name||""}${t.ext||""}`;return a?a===t.root?`${a}${i}`:`${a}${r}${i}`:i}e.$ic={resolve(...r){let t="",a="",i=!1;for(let n=r.length-1;n>=-1;n--){let o;if(n>=0){if(o=r[n],h(o,"path"),o.length===0)continue}else t.length===0?o=R.cwd():(o=R.env[`=${t}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${t}\\`));const l=o.length;let f=0,I="",L=!1;const E=o.charCodeAt(0);if(l===1)v(E)&&(f=1,L=!0);else if(v(E))if(L=!0,v(o.charCodeAt(1))){let y=2,C=y;for(;y<l&&!v(o.charCodeAt(y));)y++;if(y<l&&y!==C){const F=o.slice(C,y);for(C=y;y<l&&v(o.charCodeAt(y));)y++;if(y<l&&y!==C){for(C=y;y<l&&!v(o.charCodeAt(y));)y++;(y===l||y!==C)&&(I=`\\\\${F}\\${o.slice(C,y)}`,f=y)}}}else f=1;else p(E)&&o.charCodeAt(1)===S&&(I=o.slice(0,2),f=2,l>2&&v(o.charCodeAt(2))&&(L=!0,f=3));if(I.length>0)if(t.length>0){if(I.toLowerCase()!==t.toLowerCase())continue}else t=I;if(i){if(t.length>0)break}else if(a=`${o.slice(f)}\\${a}`,i=L,L&&t.length>0)break}return a=P(a,!i,"\\",v),i?`${t}\\${a}`:`${t}${a}`||"."},normalize(r){h(r,"path");const t=r.length;if(t===0)return".";let a=0,i,n=!1;const o=r.charCodeAt(0);if(t===1)return d(o)?"\\":r;if(v(o))if(n=!0,v(r.charCodeAt(1))){let f=2,I=f;for(;f<t&&!v(r.charCodeAt(f));)f++;if(f<t&&f!==I){const L=r.slice(I,f);for(I=f;f<t&&v(r.charCodeAt(f));)f++;if(f<t&&f!==I){for(I=f;f<t&&!v(r.charCodeAt(f));)f++;if(f===t)return`\\\\${L}\\${r.slice(I)}\\`;f!==I&&(i=`\\\\${L}\\${r.slice(I,f)}`,a=f)}}}else a=1;else p(o)&&r.charCodeAt(1)===S&&(i=r.slice(0,2),a=2,t>2&&v(r.charCodeAt(2))&&(n=!0,a=3));let l=a<t?P(r.slice(a),!n,"\\",v):"";return l.length===0&&!n&&(l="."),l.length>0&&v(r.charCodeAt(t-1))&&(l+="\\"),i===void 0?n?`\\${l}`:l:n?`${i}\\${l}`:`${i}${l}`},isAbsolute(r){h(r,"path");const t=r.length;if(t===0)return!1;const a=r.charCodeAt(0);return v(a)||t>2&&p(a)&&r.charCodeAt(1)===S&&v(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let t,a;for(let o=0;o<r.length;++o){const l=r[o];h(l,"path"),l.length>0&&(t===void 0?t=a=l:t+=`\\${l}`)}if(t===void 0)return".";let i=!0,n=0;if(typeof a=="string"&&v(a.charCodeAt(0))){++n;const o=a.length;o>1&&v(a.charCodeAt(1))&&(++n,o>2&&(v(a.charCodeAt(2))?++n:i=!1))}if(i){for(;n<t.length&&v(t.charCodeAt(n));)n++;n>=2&&(t=`\\${t.slice(n)}`)}return e.$ic.normalize(t)},relative(r,t){if(h(r,"from"),h(t,"to"),r===t)return"";const a=e.$ic.resolve(r),i=e.$ic.resolve(t);if(a===i||(r=a.toLowerCase(),t=i.toLowerCase(),r===t))return"";let n=0;for(;n<r.length&&r.charCodeAt(n)===w;)n++;let o=r.length;for(;o-1>n&&r.charCodeAt(o-1)===w;)o--;const l=o-n;let f=0;for(;f<t.length&&t.charCodeAt(f)===w;)f++;let I=t.length;for(;I-1>f&&t.charCodeAt(I-1)===w;)I--;const L=I-f,E=l<L?l:L;let y=-1,C=0;for(;C<E;C++){const D=r.charCodeAt(n+C);if(D!==t.charCodeAt(f+C))break;D===w&&(y=C)}if(C!==E){if(y===-1)return i}else{if(L>E){if(t.charCodeAt(f+C)===w)return i.slice(f+C+1);if(C===2)return i.slice(f+C)}l>E&&(r.charCodeAt(n+C)===w?y=C:C===2&&(y=3)),y===-1&&(y=0)}let F="";for(C=n+y+1;C<=o;++C)(C===o||r.charCodeAt(C)===w)&&(F+=F.length===0?"..":"\\..");return f+=y,F.length>0?`${F}${i.slice(f,I)}`:(i.charCodeAt(f)===w&&++f,i.slice(f,I))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const t=e.$ic.resolve(r);if(t.length<=2)return r;if(t.charCodeAt(0)===w){if(t.charCodeAt(1)===w){const a=t.charCodeAt(2);if(a!==m&&a!==O)return`\\\\?\\UNC\\${t.slice(2)}`}}else if(p(t.charCodeAt(0))&&t.charCodeAt(1)===S&&t.charCodeAt(2)===w)return`\\\\?\\${t}`;return r},dirname(r){h(r,"path");const t=r.length;if(t===0)return".";let a=-1,i=0;const n=r.charCodeAt(0);if(t===1)return v(n)?r:".";if(v(n)){if(a=i=1,v(r.charCodeAt(1))){let f=2,I=f;for(;f<t&&!v(r.charCodeAt(f));)f++;if(f<t&&f!==I){for(I=f;f<t&&v(r.charCodeAt(f));)f++;if(f<t&&f!==I){for(I=f;f<t&&!v(r.charCodeAt(f));)f++;if(f===t)return r;f!==I&&(a=i=f+1)}}}}else p(n)&&r.charCodeAt(1)===S&&(a=t>2&&v(r.charCodeAt(2))?3:2,i=a);let o=-1,l=!0;for(let f=t-1;f>=i;--f)if(v(r.charCodeAt(f))){if(!l){o=f;break}}else l=!1;if(o===-1){if(a===-1)return".";o=a}return r.slice(0,o)},basename(r,t){t!==void 0&&h(t,"ext"),h(r,"path");let a=0,i=-1,n=!0,o;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===S&&(a=2),t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let l=t.length-1,f=-1;for(o=r.length-1;o>=a;--o){const I=r.charCodeAt(o);if(v(I)){if(!n){a=o+1;break}}else f===-1&&(n=!1,f=o+1),l>=0&&(I===t.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=f))}return a===i?i=f:i===-1&&(i=r.length),r.slice(a,i)}for(o=r.length-1;o>=a;--o)if(v(r.charCodeAt(o))){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":r.slice(a,i)},extname(r){h(r,"path");let t=0,a=-1,i=0,n=-1,o=!0,l=0;r.length>=2&&r.charCodeAt(1)===S&&p(r.charCodeAt(0))&&(t=i=2);for(let f=r.length-1;f>=t;--f){const I=r.charCodeAt(f);if(v(I)){if(!o){i=f+1;break}continue}n===-1&&(o=!1,n=f+1),I===O?a===-1?a=f:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||n===-1||l===0||l===1&&a===n-1&&a===i+1?"":r.slice(a,n)},format:g.bind(null,"\\"),parse(r){h(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const a=r.length;let i=0,n=r.charCodeAt(0);if(a===1)return v(n)?(t.root=t.dir=r,t):(t.base=t.name=r,t);if(v(n)){if(i=1,v(r.charCodeAt(1))){let y=2,C=y;for(;y<a&&!v(r.charCodeAt(y));)y++;if(y<a&&y!==C){for(C=y;y<a&&v(r.charCodeAt(y));)y++;if(y<a&&y!==C){for(C=y;y<a&&!v(r.charCodeAt(y));)y++;y===a?i=y:y!==C&&(i=y+1)}}}}else if(p(n)&&r.charCodeAt(1)===S){if(a<=2)return t.root=t.dir=r,t;if(i=2,v(r.charCodeAt(2))){if(a===3)return t.root=t.dir=r,t;i=3}}i>0&&(t.root=r.slice(0,i));let o=-1,l=i,f=-1,I=!0,L=r.length-1,E=0;for(;L>=i;--L){if(n=r.charCodeAt(L),v(n)){if(!I){l=L+1;break}continue}f===-1&&(I=!1,f=L+1),n===O?o===-1?o=L:E!==1&&(E=1):o!==-1&&(E=-1)}return f!==-1&&(o===-1||E===0||E===1&&o===f-1&&o===l+1?t.base=t.name=r.slice(l,f):(t.name=r.slice(l,o),t.base=r.slice(l,f),t.ext=r.slice(o,f))),l>0&&l!==i?t.dir=r.slice(0,l-1):t.dir=t.root,t},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(b){const r=/\\/g;return()=>{const t=R.cwd().replace(r,"/");return t.slice(t.indexOf("/"))}}return()=>R.cwd()})();e.$jc={resolve(...r){let t="",a=!1;for(let i=r.length-1;i>=-1&&!a;i--){const n=i>=0?r[i]:s();h(n,"path"),n.length!==0&&(t=`${n}/${t}`,a=n.charCodeAt(0)===A)}return t=P(t,!a,"/",d),a?`/${t}`:t.length>0?t:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===A,a=r.charCodeAt(r.length-1)===A;return r=P(r,!t,"/",d),r.length===0?t?"/":a?"./":".":(a&&(r+="/"),t?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===A},join(...r){if(r.length===0)return".";let t;for(let a=0;a<r.length;++a){const i=r[a];h(i,"path"),i.length>0&&(t===void 0?t=i:t+=`/${i}`)}return t===void 0?".":e.$jc.normalize(t)},relative(r,t){if(h(r,"from"),h(t,"to"),r===t||(r=e.$jc.resolve(r),t=e.$jc.resolve(t),r===t))return"";const a=1,i=r.length,n=i-a,o=1,l=t.length-o,f=n<l?n:l;let I=-1,L=0;for(;L<f;L++){const y=r.charCodeAt(a+L);if(y!==t.charCodeAt(o+L))break;y===A&&(I=L)}if(L===f)if(l>f){if(t.charCodeAt(o+L)===A)return t.slice(o+L+1);if(L===0)return t.slice(o+L)}else n>f&&(r.charCodeAt(a+L)===A?I=L:L===0&&(I=0));let E="";for(L=a+I+1;L<=i;++L)(L===i||r.charCodeAt(L)===A)&&(E+=E.length===0?"..":"/..");return`${E}${t.slice(o+I)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===A;let a=-1,i=!0;for(let n=r.length-1;n>=1;--n)if(r.charCodeAt(n)===A){if(!i){a=n;break}}else i=!1;return a===-1?t?"/":".":t&&a===1?"//":r.slice(0,a)},basename(r,t){t!==void 0&&h(t,"ext"),h(r,"path");let a=0,i=-1,n=!0,o;if(t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let l=t.length-1,f=-1;for(o=r.length-1;o>=0;--o){const I=r.charCodeAt(o);if(I===A){if(!n){a=o+1;break}}else f===-1&&(n=!1,f=o+1),l>=0&&(I===t.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=f))}return a===i?i=f:i===-1&&(i=r.length),r.slice(a,i)}for(o=r.length-1;o>=0;--o)if(r.charCodeAt(o)===A){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":r.slice(a,i)},extname(r){h(r,"path");let t=-1,a=0,i=-1,n=!0,o=0;for(let l=r.length-1;l>=0;--l){const f=r.charCodeAt(l);if(f===A){if(!n){a=l+1;break}continue}i===-1&&(n=!1,i=l+1),f===O?t===-1?t=l:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||i===-1||o===0||o===1&&t===i-1&&t===a+1?"":r.slice(t,i)},format:g.bind(null,"/"),parse(r){h(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const a=r.charCodeAt(0)===A;let i;a?(t.root="/",i=1):i=0;let n=-1,o=0,l=-1,f=!0,I=r.length-1,L=0;for(;I>=i;--I){const E=r.charCodeAt(I);if(E===A){if(!f){o=I+1;break}continue}l===-1&&(f=!1,l=I+1),E===O?n===-1?n=I:L!==1&&(L=1):n!==-1&&(L=-1)}if(l!==-1){const E=o===0&&a?1:o;n===-1||L===0||L===1&&n===l-1&&n===o+1?t.base=t.name=r.slice(E,l):(t.name=r.slice(E,n),t.base=r.slice(E,l),t.ext=r.slice(n,l))}return o>0?t.dir=r.slice(0,o-1):a&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=b?e.$ic.normalize:e.$jc.normalize,e.$lc=b?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=b?e.$ic.join:e.$jc.join,e.$nc=b?e.$ic.resolve:e.$jc.resolve,e.$oc=b?e.$ic.relative:e.$jc.relative,e.$pc=b?e.$ic.dirname:e.$jc.dirname,e.$qc=b?e.$ic.basename:e.$jc.basename,e.$rc=b?e.$ic.extname:e.$jc.extname,e.$sc=b?e.$ic.format:e.$jc.format,e.$tc=b?e.$ic.parse:e.$jc.parse,e.$uc=b?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=b?e.$ic.sep:e.$jc.sep,e.$wc=b?e.$ic.delimiter:e.$jc.delimiter}),define(ce[42],le([0,1,39,14,5,27,13]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=O,e.$zg=A,e.$Ag=w,e.$Bg=S,e.$Cg=m,e.$Dg=b,e.$Eg=v,e.$Fg=d,e.$Gg=p,e.$Hg=P,e.$Ig=g,e.$Jg=s,e.$Kg=r,e.$Lg=t,e.$Mg=a,e.$Ng=i,e.$Og=l;function O(f){return f===R.CharCode.Slash||f===R.CharCode.Backslash}function A(f){return f.replace(/[\\/]/g,c.$jc.sep)}function w(f){return f.indexOf("/")===-1&&(f=A(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function S(f,I=c.$jc.sep){if(!f)return"";const L=f.length,E=f.charCodeAt(0);if(O(E)){if(O(f.charCodeAt(1))&&!O(f.charCodeAt(2))){let C=3;const F=C;for(;C<L&&!O(f.charCodeAt(C));C++);if(F!==C&&!O(f.charCodeAt(C+1))){for(C+=1;C<L;C++)if(O(f.charCodeAt(C)))return f.slice(0,C+1).replace(/[\\/]/g,I)}}return I}else if(p(E)&&f.charCodeAt(1)===R.CharCode.Colon)return O(f.charCodeAt(2))?f.slice(0,2)+I:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(O(f.charCodeAt(y)))return f.slice(0,y+1)}return""}function m(f){if(!N.$i||!f||f.length<5)return!1;let I=f.charCodeAt(0);if(I!==R.CharCode.Backslash||(I=f.charCodeAt(1),I!==R.CharCode.Backslash))return!1;let L=2;const E=L;for(;L<f.length&&(I=f.charCodeAt(L),I!==R.CharCode.Backslash);L++);return!(E===L||(I=f.charCodeAt(L+1),isNaN(I)||I===R.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,$=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,I=N.$i){const L=I?u:$;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||I&&h.test(f)||f==="."||f===".."||I&&f[f.length-1]==="."||I&&f.length!==f.trim().length||f.length>255)}function v(f,I,L){const E=f===I;return!L||E?E:!f||!I?!1:(0,k.$Hf)(f,I)}function d(f,I,L,E=c.sep){if(f===I)return!0;if(!f||!I||I.length>f.length)return!1;if(L){if(!(0,k.$If)(f,I))return!1;if(I.length===f.length)return!0;let C=I.length;return I.charAt(I.length-1)===E&&C--,f.charAt(C)===E}return I.charAt(I.length-1)!==E&&(I+=E),f.indexOf(I)===0}function p(f){return f>=R.CharCode.A&&f<=R.CharCode.Z||f>=R.CharCode.a&&f<=R.CharCode.z}function P(f,I){return N.$i&&f.endsWith(":")&&(f+=c.sep),(0,c.$lc)(f)||(f=(0,c.$mc)(I,f)),f=(0,c.$kc)(f),g(f)}function g(f){return N.$i?(f=(0,k.$pf)(f,c.sep),f.endsWith(":")&&(f+=c.sep)):(f=(0,k.$pf)(f,c.sep),f||(f=c.sep)),f}function s(f){const I=(0,c.$kc)(f);return N.$i?f.length>3?!1:r(I)&&(f.length===2||I.charCodeAt(2)===R.CharCode.Backslash):I===c.$jc.sep}function r(f,I=N.$i){return I?p(f.charCodeAt(0))&&f.charCodeAt(1)===R.CharCode.Colon:!1}function t(f,I=N.$i){return r(f,I)?f[0]:void 0}function a(f,I,L){return I.length>f.length?-1:f===I?0:(L&&(f=f.toLowerCase(),I=I.toLowerCase()),f.indexOf(I))}function i(f){const I=f.split(":");let L,E,y;for(const C of I){const F=Number(C);(0,T.$kg)(F)?E===void 0?E=F:y===void 0&&(y=F):L=L?[L,C].join(":"):C}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:E!==void 0?E:void 0,column:y!==void 0?y:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(f,I,L=8){let E="";for(let C=0;C<L;C++){let F;C===0&&N.$i&&!I&&(L===3||L===4)?F=o:F=n,E+=F.charAt(Math.floor(Math.random()*F.length))}let y;return I?y=`${I}-${E}`:y=E,f?(0,c.$mc)(f,y):y}}),define(ce[147],le([0,1,14]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=k,e.$$s=T,e.$_s=O,e.$at=w,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(S){const m=(0,R.$rc)(S),u=c[m.toLowerCase()];return u!==void 0?u:T(S)}function T(S){const m=(0,R.$rc)(S);return N[m.toLowerCase()]}function O(S){for(const m in N)if(N[m]===S)return m}const A=/^(.+)\/(.+?)(;.+)?$/;function w(S,m){const u=A.exec(S);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:m?void 0:S}}),define(ce[93],le([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=k,e.$mm=T;var c;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(c||(e.Source=c={}));var N;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function k(O,...A){const w=A.reduce((u,$)=>(u[$]=!0,u),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(u=>!w[u]).forEach(u=>{for(let $=0;$<S.length;$++)if(u.search(S[$])!==-1){delete O[u];break}})}function T(O){O&&(delete O.DEBUG,R.$j&&delete O.DYLD_LIBRARY_PATH,R.$k&&delete O.LD_PRELOAD)}}),define(ce[9],le([0,1,39,66,14,5]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=v,e.$zc=r,N=ke(N);const T=/^\w[\w\d+.-]*$/,O=/^\//,A=/^\/\//;function w(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!O.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function m(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==$&&(l=$+l):l=$;break}return l}const u="",$="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(l){return l instanceof b?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,f,I,L,E,y=!1){typeof l=="object"?(this.scheme=l.scheme||u,this.authority=l.authority||u,this.path=l.path||u,this.query=l.query||u,this.fragment=l.fragment||u):(this.scheme=S(l,y),this.authority=f||u,this.path=m(this.scheme,I||u),this.query=L||u,this.fragment=E||u,w(this,y))}get fsPath(){return r(this,!1)}with(l){if(!l)return this;let{scheme:f,authority:I,path:L,query:E,fragment:y}=l;return f===void 0?f=this.scheme:f===null&&(f=u),I===void 0?I=this.authority:I===null&&(I=u),L===void 0?L=this.path:L===null&&(L=u),E===void 0?E=this.query:E===null&&(E=u),y===void 0?y=this.fragment:y===null&&(y=u),f===this.scheme&&I===this.authority&&L===this.path&&E===this.query&&y===this.fragment?this:new p(f,I,L,E,y)}static parse(l,f=!1){const I=h.exec(l);return I?new p(I[2]||u,n(I[4]||u),n(I[5]||u),n(I[7]||u),n(I[9]||u),f):new p(u,u,u,u,u)}static file(l){let f=u;if(k.$i&&(l=l.replace(/\\/g,$)),l[0]===$&&l[1]===$){const I=l.indexOf($,2);I===-1?(f=l.substring(2),l=$):(f=l.substring(2,I),l=l.substring(I)||$)}return new p("file",f,l,u,u)}static from(l,f){return new p(l.scheme,l.authority,l.path,l.query,l.fragment,f)}static joinPath(l,...f){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return k.$i&&l.scheme==="file"?I=b.file(N.$ic.join(r(l,!0),...f)).path:I=N.$jc.join(l.path,...f),l.with({path:I})}toString(l=!1){return t(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof b)return l;{const f=new p(l);return f._formatted=l.external??null,f._fsPath=l._sep===d?l.fsPath??null:null,f}}else return l}}e.URI=b;function v(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const d=k.$i?1:void 0;class p extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(l=!1){return l?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const l={$mid:c.MarshalledId.Uri};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=d),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const P={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function g(o,l,f){let I,L=-1;for(let E=0;E<o.length;E++){const y=o.charCodeAt(E);if(y>=R.CharCode.a&&y<=R.CharCode.z||y>=R.CharCode.A&&y<=R.CharCode.Z||y>=R.CharCode.Digit0&&y<=R.CharCode.Digit9||y===R.CharCode.Dash||y===R.CharCode.Period||y===R.CharCode.Underline||y===R.CharCode.Tilde||l&&y===R.CharCode.Slash||f&&y===R.CharCode.OpenSquareBracket||f&&y===R.CharCode.CloseSquareBracket||f&&y===R.CharCode.Colon)L!==-1&&(I+=encodeURIComponent(o.substring(L,E)),L=-1),I!==void 0&&(I+=o.charAt(E));else{I===void 0&&(I=o.substr(0,E));const C=P[y];C!==void 0?(L!==-1&&(I+=encodeURIComponent(o.substring(L,E)),L=-1),I+=C):L===-1&&(L=E)}}return L!==-1&&(I+=encodeURIComponent(o.substring(L))),I!==void 0?I:o}function s(o){let l;for(let f=0;f<o.length;f++){const I=o.charCodeAt(f);I===R.CharCode.Hash||I===R.CharCode.QuestionMark?(l===void 0&&(l=o.substr(0,f)),l+=P[I]):l!==void 0&&(l+=o[f])}return l!==void 0?l:o}function r(o,l){let f;return o.authority&&o.path.length>1&&o.scheme==="file"?f=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===R.CharCode.Slash&&(o.path.charCodeAt(1)>=R.CharCode.A&&o.path.charCodeAt(1)<=R.CharCode.Z||o.path.charCodeAt(1)>=R.CharCode.a&&o.path.charCodeAt(1)<=R.CharCode.z)&&o.path.charCodeAt(2)===R.CharCode.Colon?l?f=o.path.substr(1):f=o.path[1].toLowerCase()+o.path.substr(2):f=o.path,k.$i&&(f=f.replace(/\//g,"\\")),f}function t(o,l){const f=l?s:g;let I="",{scheme:L,authority:E,path:y,query:C,fragment:F}=o;if(L&&(I+=L,I+=":"),(E||L==="file")&&(I+=$,I+=$),E){let D=E.indexOf("@");if(D!==-1){const M=E.substr(0,D);E=E.substr(D+1),D=M.lastIndexOf(":"),D===-1?I+=f(M,!1,!1):(I+=f(M.substr(0,D),!1,!1),I+=":",I+=f(M.substr(D+1),!1,!0)),I+="@"}E=E.toLowerCase(),D=E.lastIndexOf(":"),D===-1?I+=f(E,!1,!0):(I+=f(E.substr(0,D),!1,!0),I+=E.substr(D))}if(y){if(y.length>=3&&y.charCodeAt(0)===R.CharCode.Slash&&y.charCodeAt(2)===R.CharCode.Colon){const D=y.charCodeAt(1);D>=R.CharCode.A&&D<=R.CharCode.Z&&(y=`/${String.fromCharCode(D+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===R.CharCode.Colon){const D=y.charCodeAt(0);D>=R.CharCode.A&&D<=R.CharCode.Z&&(y=`${String.fromCharCode(D+32)}:${y.substr(2)}`)}I+=f(y,!0,!1)}return C&&(I+="?",I+=f(C,!1,!1)),F&&(I+="#",I+=l?F:g(F,!1,!1)),I}function a(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,l=>a(l)):o}}),define(ce[148],le([0,1,9]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=c,e.$cr=N,e.$dr=k,e.log=O;function c(w){const S=w;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function N(w){const S=[];let m;try{const u=JSON.parse(w.arguments),$=u[u.length-1];$&&$.__$stack&&(u.pop(),m=$.__$stack),S.push(...u)}catch{S.push("Unable to log remote console arguments",w.arguments)}return{args:S,stack:m}}function k(w){if(typeof w!="string")return k(N(w).stack);const S=w;if(S){const m=T(S),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(u&&u.length===4)return{uri:R.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(w){if(!w)return w;const S=w.indexOf(`
`);return S===-1?w:w.substring(0,S)}function O(w,S){const{args:m,stack:u}=N(w),$=typeof m[0]=="string"&&m.length===1;let h=T(u);h&&(h=`(${h.trim()})`);let b=[];if(typeof m[0]=="string"?h&&$?b=[`%c[${S}] %c${m[0]} %c${h}`,A("blue"),A(""),A("grey")]:b=[`%c[${S}] %c${m[0]}`,A("blue"),A(""),...m.slice(1)]:b=[`%c[${S}]%`,A("blue"),...m],h&&!$&&b.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,b)}function A(w){return`color: ${w}`}}),define(ce[69],le([0,1,15,9,66]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=k,e.$ci=T,e.$di=A;function k(w){return JSON.stringify(w,O)}function T(w){let S=JSON.parse(w);return S=A(S),S}function O(w,S){return S instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function A(w,S=0){if(!w||S>200)return w;if(typeof w=="object"){switch(w.$mid){case N.MarshalledId.Uri:return c.URI.revive(w);case N.MarshalledId.Regexp:return new RegExp(w.source,w.flags);case N.MarshalledId.Date:return new Date(w.source)}if(w instanceof R.$Pe||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let m=0;m<w.length;++m)w[m]=A(w[m],S+1);else for(const m in w)Object.hasOwnProperty.call(w,m)&&(w[m]=A(w[m],S+1))}return w}}),define(ce[23],le([0,1,8,5,27,9,14]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=A,e.$Qg=w,e.$Ug=m,R=ke(R),c=ke(c),T=ke(T);var O;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(O||(e.Schemas=O={}));function A(h,b){return k.URI.isUri(h)?(0,N.$Hf)(h.scheme,b):(0,N.$If)(h,b+":")}function w(h,...b){return b.some(v=>A(h,v))}e.$Rg="vscode-tkn",e.$Sg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,v){this.f=m(b,v)}getServerRootPath(){return this.f}get g(){return T.$jc.join(this.f,O.vscodeRemoteResource)}set(b,v,d){this.a[b]=v,this.b[b]=d}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(s){return R.$3(s),b}const v=b.authority;let d=this.a[v];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const p=this.b[v],P=this.c[v];let g=`path=${encodeURIComponent(b.path)}`;return typeof P=="string"&&(g+=`&${e.$Sg}=${encodeURIComponent(P)}`),k.URI.from({scheme:c.$o?this.d:O.vscodeRemoteResource,authority:`${d}:${p}`,path:this.g,query:g})}}e.$Tg=new S;function m(h,b){return T.$jc.join(b??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class u{static{this.a=e.$Zg}asBrowserUri(b){const v=this.b(b,ne);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===O.vscodeRemote?e.$Tg.rewrite(b):b.scheme===O.file&&(c.$m||c.$q===`${O.vscodeFileResource}://${u.a}`)?b.with({scheme:O.vscodeFileResource,authority:b.authority||u.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,ne);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===O.vscodeFileResource?b.with({scheme:O.file,authority:b.authority!==u.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return k.URI.isUri(b)?b:k.URI.parse(v.toUrl(b))}}e.$1g=new u;var $;(function(h){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function d(P){let g;typeof P=="string"?g=new URL(P).searchParams:P instanceof URL?g=P.searchParams:k.URI.isUri(P)&&(g=new URL(P.toString(!0)).searchParams);const s=g?.get(v);if(s)return b.get(s)}h.getHeadersFromQuery=d;function p(P,g,s){if(!globalThis.crossOriginIsolated)return;const r=g&&s?"3":s?"2":"1";P instanceof URLSearchParams?P.set(v,r):P[v]=r}h.addSearchParam=p})($||(e.COI=$={}))}),define(ce[149],le([0,1,129,23,5,9]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=S,N=ke(N);class T{constructor(u,$,h){this.id=u,this.dependencies=$,this.callback=h}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,$,h)=>{typeof u!="string"&&(h=$,$=u,u=null),(typeof $!="object"||!Array.isArray($))&&(h=$,$=null),this.c.push(new T(u,$,h))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const $=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!$)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(u){return new Promise(($,h)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const v=()=>{b.removeEventListener("load",d),b.removeEventListener("error",p)},d=P=>{v(),$(this.c.pop())},p=P=>{v(),h(P)};b.addEventListener("load",d),b.addEventListener("error",p),this.f&&(u=this.f.createScriptURL(u)),b.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(u){return new Promise(($,h)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),$(this.c.pop())}catch(b){h(b)}})}async j(u){try{const $=globalThis._VSCODE_NODE_MODULES.fs,h=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,v=k.URI.parse(u).fsPath,d=$.readFileSync(v).toString(),p=b.wrap(d.replace(/^#!.*/,""));return new h.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const A=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function S(m,u,$){if(R.$V){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[m]&&(m=w[m]);const h=`${m}/${u}`;if(A.has(h))return A.get(h);let b;if(/^\w[\w\d+.-]*:\/\//.test(h))b=h;else{const P=`${$&&!N.$o?c.$Xg:c.$Wg}/${h}`;b=c.$1g.asBrowserUri(P).toString(!0)}const v=O.INSTANCE.load(b);return A.set(h,v),v}else return await new Promise((h,b)=>{ne([m],h,b)}).then(ke)}}),define(ce[21],le([0,1,39,42,23,14,5,27,9]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=w,e.$qh=m,e.$rh=$,c=ke(c),k=ke(k);function w(h){return(0,A.$zc)(h,!0)}class S{constructor(b){this.a=b}compare(b,v,d=!1){return b===v?0:(0,O.$Af)(this.getComparisonKey(b,d),this.getComparisonKey(v,d))}isEqual(b,v,d=!1){return b===v?!0:!b||!v?!1:this.getComparisonKey(b,d)===this.getComparisonKey(v,d)}getComparisonKey(b,v=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,v,d=!1){if(b.scheme===v.scheme){if(b.scheme===N.Schemas.file)return c.$Fg(w(b),w(v),this.a(b))&&b.query===v.query&&(d||b.fragment===v.fragment);if((0,e.$mh)(b.authority,v.authority))return c.$Fg(b.path,v.path,this.a(b),"/")&&b.query===v.query&&(d||b.fragment===v.fragment)}return!1}joinPath(b,...v){return A.URI.joinPath(b,...v)}basenameOrAuthority(b){return(0,e.$eh)(b)||b.authority}basename(b){return k.$jc.basename(b.path)}extname(b){return k.$jc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let v;return b.scheme===N.Schemas.file?v=A.URI.file(k.$pc(w(b))).path:(v=k.$jc.dirname(b.path),b.authority&&v.length&&v.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${b.toString})) resulted in a relative path`),v="/")),b.with({path:v})}normalizePath(b){if(!b.path.length)return b;let v;return b.scheme===N.Schemas.file?v=A.URI.file(k.$kc(w(b))).path:v=k.$jc.normalize(b.path),b.with({path:v})}relativePath(b,v){if(b.scheme!==v.scheme||!(0,e.$mh)(b.authority,v.authority))return;if(b.scheme===N.Schemas.file){const P=k.$oc(w(b),w(v));return T.$i?c.$zg(P):P}let d=b.path||"/";const p=v.path||"/";if(this.a(b)){let P=0;for(const g=Math.min(d.length,p.length);P<g&&!(d.charCodeAt(P)!==p.charCodeAt(P)&&d.charAt(P).toLowerCase()!==p.charAt(P).toLowerCase());P++);d=p.substr(0,P)+d.substr(P)}return k.$jc.relative(d,p)}resolvePath(b,v){if(b.scheme===N.Schemas.file){const d=A.URI.file(k.$nc(w(b),v));return b.with({authority:d.authority,path:d.path})}return v=c.$Ag(v),b.with({path:k.$jc.resolve(b.path,v)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,v){return b===v||b!==void 0&&v!==void 0&&(0,O.$Hf)(b,v)}hasTrailingPathSeparator(b,v=k.sep){if(b.scheme===N.Schemas.file){const d=w(b);return d.length>c.$Bg(d).length&&d[d.length-1]===v}else{const d=b.path;return d.length>1&&d.charCodeAt(d.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,v=k.sep){return(0,e.$nh)(b,v)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,v=k.sep){let d=!1;if(b.scheme===N.Schemas.file){const p=w(b);d=p!==void 0&&p.length===c.$Bg(p).length&&p[p.length-1]===v}else{v="/";const p=b.path;d=p.length===1&&p.charCodeAt(p.length-1)===R.CharCode.Slash}return!d&&!(0,e.$nh)(b,v)?b.with({path:b.path+"/"}):b}}e.$9g=S,e.$0g=new S(()=>!1),e.$$g=new S(h=>h.scheme===N.Schemas.file?!T.$k:!0),e.$_g=new S(h=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function m(h,b){const v=[];for(let d=0;d<h.length;d++){const p=b(h[d]);h.some((P,g)=>g===d?!1:(0,e.$bh)(p,b(P)))||v.push(h[d])}return v}var u;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function b(v){const d=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,r]=g.split(":");s&&r&&d.set(s,r)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&d.set(h.META_DATA_MIME,P),d}h.parseMetaData=b})(u||(e.DataUri=u={}));function $(h,b,v){if(b){let d=h.path;return d&&d[0]!==k.$jc.sep&&(d=k.$jc.sep+d),h.with({scheme:v,authority:b,path:d})}return h.with({scheme:v})}}),define(ce[6],le([0,1,26,8,3,2,21,5,135,54]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=S,e.$th=m,e.$uh=u,e.$vh=$,e.$wh=h,e.$xh=b,e.$yh=v,e.$zh=d,e.$Hh=o,e.$Ih=l,e.$Jh=f,e.$Kh=I,e.$Lh=L,e.$1h=z,e.$9h=j;function S(ee){return!!ee&&typeof ee.then=="function"}function m(ee){const J=new R.$ye,oe=ee(J.token),ue=new Promise((ge,pe)=>{const Ie=J.token.onCancellationRequested(()=>{Ie.dispose(),pe(new c.$8)});Promise.resolve(oe).then(we=>{Ie.dispose(),J.dispose(),ge(we)},we=>{Ie.dispose(),J.dispose(),pe(we)})});return new class{cancel(){J.cancel(),J.dispose()}then(ge,pe){return ue.then(ge,pe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function u(ee,J,oe){return new Promise((ue,ge)=>{const pe=J.onCancellationRequested(()=>{pe.dispose(),ue(oe)});ee.then(ue,ge).finally(()=>pe.dispose())})}function $(ee,J){return new Promise((oe,ue)=>{const ge=J.onCancellationRequested(()=>{ge.dispose(),ue(new c.$8)});ee.then(oe,ue).finally(()=>ge.dispose())})}async function h(ee){let J=-1;const oe=ee.map((ue,ge)=>ue.then(pe=>(J=ge,pe)));try{return await Promise.race(oe)}finally{ee.forEach((ue,ge)=>{ge!==J&&ue.cancel()})}}function b(ee,J,oe){let ue;const ge=setTimeout(()=>{ue?.(void 0),oe?.()},J);return Promise.race([ee.finally(()=>clearTimeout(ge)),new Promise(pe=>ue=pe)])}function v(ee){return new Promise((J,oe)=>{const ue=ee();S(ue)?ue.then(J,oe):J(ue)})}function d(){let ee,J;return{promise:new Promise((ue,ge)=>{ee=ue,J=ge}),resolve:ee,reject:J}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const oe=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(oe,oe).then(ue)})}return new Promise((oe,ue)=>{this.b.then(oe,ue)})}return this.a=J(),new Promise((oe,ue)=>{this.a.then(ge=>{this.a=null,oe(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$Ah=p;class P{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Bh=P;class g{constructor(){this.a=new Map}queue(J,oe){const ge=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(J)===ge&&this.a.delete(J)});return this.a.set(J,ge),ge}}e.$Ch=g;const s=(ee,J)=>{let oe=!0;const ue=setTimeout(()=>{oe=!1,J()},ee);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ue),oe=!1}}},r=ee=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ee())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class t{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,oe=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ge,pe)=>{this.d=ge,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=oe===A.$ie?r(ue):s(oe,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=t;class a{constructor(J){this.a=new t(J),this.b=new p}trigger(J,oe){return this.a.trigger(()=>this.b.queue(J),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=a;class i{constructor(){this.a=!1,this.b=new Promise((J,oe)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=i;class n extends i{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Gh=n;function o(ee,J){return J?new Promise((oe,ue)=>{const ge=setTimeout(()=>{pe.dispose(),oe()},ee),pe=J.onCancellationRequested(()=>{clearTimeout(ge),pe.dispose(),ue(new c.$8)})}):m(oe=>o(ee,oe))}function l(ee,J=0,oe){const ue=setTimeout(()=>{ee(),oe&&ge.dispose()},J),ge=(0,k.$Vc)(()=>{clearTimeout(ue),oe?.deleteAndLeak(ge)});return oe?.add(ge),ge}function f(ee){const J=[];let oe=0;const ue=ee.length;function ge(){return oe<ue?ee[oe++]():null}function pe(Ie){Ie!=null&&J.push(Ie);const we=ge();return we?we.then(pe):Promise.resolve(J)}return Promise.resolve(null).then(pe)}function I(ee,J=ue=>!!ue,oe=null){let ue=0;const ge=ee.length,pe=()=>{if(ue>=ge)return Promise.resolve(oe);const Ie=ee[ue++];return Promise.resolve(Ie()).then(be=>J(be)?Promise.resolve(be):pe())};return pe()}function L(ee,J=ue=>!!ue,oe=null){if(ee.length===0)return Promise.resolve(oe);let ue=ee.length;const ge=()=>{ue=-1;for(const pe of ee)pe.cancel?.()};return new Promise((pe,Ie)=>{for(const we of ee)we.then(be=>{--ue>=0&&J(be)?(ge(),pe(be)):ue===0&&pe(oe)}).catch(be=>{--ue>=0&&(ge(),Ie(be))})})}class E{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new N.$ne}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,ue)=>{this.g.push({factory:J,c:oe,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const oe=J.factory();oe.then(J.c,J.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=E;class y extends E{constructor(){super(1)}}e.$Nh=y;class C{constructor(){this.a=new te,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Oh=C;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new q;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,oe=T.$0g){const ue=oe.getComparisonKey(J);return this.a.get(ue)?.size??0}queueFor(J,oe,ue=T.$0g){const ge=ue.getComparisonKey(J);let pe=this.a.get(ge);if(!pe){pe=new y;const Ie=this.f++,we=N.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$7c),this.d.set(Ie,we),this.a.set(ge,pe)}return pe.queue(oe)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=F;class D{constructor(J,oe){this.b=!1,this.a=-1,typeof J=="function"&&typeof oe=="number"&&this.setIfNotSet(J,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,oe){if(this.b)throw new c.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},oe)}setIfNotSet(J,oe){if(this.b)throw new c.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},oe))}}e.$Qh=D;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,oe,ue=globalThis){if(this.f)throw new c.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{J()},oe);this.d=(0,k.$Vc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=M;class K{constructor(J,oe){this.b=-1,this.a=J,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=K;class W{constructor(J,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=J,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=W;class _ extends K{constructor(J,oe){super(J,oe),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Uh=_;class H extends k.$Xc{constructor(J,oe){super(),this.g=J,this.h=oe,this.a=[],this.b=this.B(new k.$Yc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of J)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(ee,J)=>{(0,O.$B)(()=>{if(oe)return;const ue=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Xh=(ee,J,oe)=>{const ue=ee.requestIdleCallback(J,typeof oe=="number"?{timeout:oe}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ee.cancelIdleCallback(ue))}}},e.$Wh=ee=>(0,e.$Xh)(globalThis,ee)}();class ie{constructor(J,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Xh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ie;class V extends ie{constructor(J){super(globalThis,J)}}e.$Zh=V;async function z(ee,J,oe){let ue;for(let ge=0;ge<oe;ge++)try{return await ee()}catch(pe){ue=pe,await o(J)}throw ue}class te{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,oe,ue){return this.a={taskId:J,cancel:()=>ue?.(),promise:oe},oe.then(()=>this.d(J),()=>this.d(J)),oe}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:oe,resolve:ue,reject:ge}=d();this.b={run:J,promise:oe,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=te;class se{constructor(J,oe=()=>Date.now()){this.d=J,this.f=oe,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$3h=se;var he;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(he||(he={}));class q{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,oe)=>{this.a=J,this.b=oe})}complete(J){return new Promise(oe=>{this.a(J),this.d={outcome:he.Resolved,value:J},oe()})}error(J){return new Promise(oe=>{this.b(J),this.d={outcome:he.Rejected,value:J},oe()})}cancel(){return this.error(new c.$8)}}e.$4h=q;var Z;(function(ee){async function J(ue){let ge;const pe=await Promise.all(ue.map(Ie=>Ie.then(we=>we,we=>{ge||(ge=we)})));if(typeof ge<"u")throw ge;return pe}ee.settled=J;function oe(ue){return new Promise(async(ge,pe)=>{try{await ue(ge,pe)}catch(Ie){pe(Ie)}})}ee.withAsyncBody=oe})(Z||(e.Promises=Z={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new c.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=X;class G{constructor(J){this.b=J,this.a=new w.$X(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=G;var U;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(U||(U={}));class Q{static fromArray(J){return new Q(oe=>{oe.emitMany(J)})}static fromPromise(J){return new Q(async oe=>{oe.emitMany(await J)})}static fromPromises(J){return new Q(async oe=>{await Promise.all(J.map(async ue=>oe.emitOne(await ue)))})}static merge(J){return new Q(async oe=>{await Promise.all(J.map(async ue=>{for await(const ge of ue)oe.emitOne(ge)}))})}static{this.EMPTY=Q.fromArray([])}constructor(J,oe){this.a=U.Initial,this.b=[],this.d=null,this.f=oe,this.g=new N.$ne,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(J(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,oe){return new Q(async ue=>{for await(const ge of J)ue.emitOne(oe(ge))})}map(J){return Q.map(this,J)}static filter(J,oe){return new Q(async ue=>{for await(const ge of J)oe(ge)&&ue.emitOne(ge)})}filter(J){return Q.filter(this,J)}static coalesce(J){return Q.filter(J,oe=>!!oe)}coalesce(){return Q.coalesce(this)}static async toPromise(J){const oe=[];for await(const ue of J)oe.push(ue);return oe}toPromise(){return Q.toPromise(this)}h(J){this.a===U.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===U.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(J){this.a===U.Initial&&(this.a=U.DoneError,this.d=J,this.g.fire())}}e.$7h=Q;class B extends Q{constructor(J,oe){super(oe),this.m=J}cancel(){this.m.cancel()}}e.$8h=B;function j(ee){const J=new R.$ye,oe=ee(J.token);return new B(J,async ue=>{const ge=J.token.onCancellationRequested(()=>{ge.dispose(),J.dispose(),ue.reject(new c.$8)});try{for await(const pe of oe){if(J.token.isCancellationRequested)return;ue.emitOne(pe)}ge.dispose(),J.dispose()}catch(pe){ge.dispose(),J.dispose(),ue.reject(pe)}})}class x{constructor(J){this.a=new q,this.b=new Q(ge=>{if(oe){ge.reject(oe);return}return ue&&ge.emitMany(ue),this.d=pe=>ge.reject(pe),this.f=pe=>ge.emitOne(pe),this.a.p},J);let oe,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{oe||(oe=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$0h=x}),define(ce[94],le([0,1,19,6,39,42,35,14,5,27]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=S,e.$yk=b,e.$zk=C,e.$Ak=F,e.$Bk=D,e.$Ck=M,e.$Dk=K,e.$Ek=ie;function S(){return Object.create(null)}e.$wk="**",e.$xk="/";const m="[/\\\\]",u="[^/\\\\]",$=/\//g;function h(V,z){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${m}|${u}+${m}${z?`|${m}${u}+`:""})*?`}}function b(V,z){if(!V)return[];const te=[];let se=!1,he=!1,q="";for(const Z of V){switch(Z){case z:if(!se&&!he){te.push(q),q="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":he=!0;break;case"]":he=!1;break}q+=Z}return q&&te.push(q),te}function v(V){if(!V)return"";let z="";const te=b(V,e.$xk);if(te.every(se=>se===e.$wk))z=".*";else{let se=!1;te.forEach((he,q)=>{if(he===e.$wk){if(se)return;z+=h(2,q===te.length-1)}else{let Z=!1,X="",G=!1,U="";for(const Q of he){if(Q!=="}"&&Z){X+=Q;continue}if(G&&(Q!=="]"||!U)){let B;Q==="-"?B=Q:(Q==="^"||Q==="!")&&!U?B="^":Q===e.$xk?B="":B=(0,w.$jf)(Q),U+=B;continue}switch(Q){case"{":Z=!0;continue;case"[":G=!0;continue;case"}":{const j=`(?:${b(X,",").map(x=>v(x)).join("|")})`;z+=j,Z=!1,X="";break}case"]":{z+="["+U+"]",G=!1,U="";break}case"?":z+=u;continue;case"*":z+=h(1);continue;default:z+=(0,w.$jf)(Q)}}q<te.length-1&&(te[q+1]!==e.$wk||q+2<te.length)&&(z+=m)}se=he===e.$wk})}return z}const d=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.$Gc(1e4),a=function(){return!1},i=function(){return null};function n(V,z){if(!V)return i;let te;typeof V!="string"?te=V.pattern:te=V,te=te.trim();const se=`${te}_${!!z.trimForExclusions}`;let he=t.get(se);if(he)return o(he,V);let q;return d.test(te)?he=f(te.substr(4),te):(q=p.exec(l(te,z)))?he=I(q[1],te):(z.trimForExclusions?g:P).test(te)?he=L(te,z):(q=s.exec(l(te,z)))?he=E(q[1].substr(1),te,!0):(q=r.exec(l(te,z)))?he=E(q[1],te,!1):he=y(te),t.set(se,he),o(he,V)}function o(V,z){if(typeof z=="string")return V;const te=function(se,he){return(0,k.$Fg)(se,z.base,!A.$k)?V((0,w.$of)(se.substr(z.base.length),O.sep),he):null};return te.allBasenames=V.allBasenames,te.allPaths=V.allPaths,te.basenames=V.basenames,te.patterns=V.patterns,te}function l(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function f(V,z){return function(te,se){return typeof te=="string"&&te.endsWith(V)?z:null}}function I(V,z){const te=`/${V}`,se=`\\${V}`,he=function(Z,X){return typeof Z!="string"?null:X?X===V?z:null:Z===V||Z.endsWith(te)||Z.endsWith(se)?z:null},q=[V];return he.basenames=q,he.patterns=[z],he.allBasenames=q,he}function L(V,z){const te=H(V.slice(1,-1).split(",").map(X=>n(X,z)).filter(X=>X!==i),V),se=te.length;if(!se)return i;if(se===1)return te[0];const he=function(X,G){for(let U=0,Q=te.length;U<Q;U++)if(te[U](X,G))return V;return null},q=te.find(X=>!!X.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=te.reduce((X,G)=>G.allPaths?X.concat(G.allPaths):X,[]);return Z.length&&(he.allPaths=Z),he}function E(V,z,te){const se=O.sep===O.$jc.sep,he=se?V:V.replace($,O.sep),q=O.sep+he,Z=O.$jc.sep+V;let X;return te?X=function(G,U){return typeof G=="string"&&(G===he||G.endsWith(q)||!se&&(G===V||G.endsWith(Z)))?z:null}:X=function(G,U){return typeof G=="string"&&(G===he||!se&&G===V)?z:null},X.allPaths=[(te?"*/":"./")+V],X}function y(V){try{const z=new RegExp(`^${v(V)}$`);return function(te){return z.lastIndex=0,typeof te=="string"&&z.test(te)?V:null}}catch{return i}}function C(V,z,te){return!V||typeof z!="string"?!1:F(V)(z,void 0,te)}function F(V,z={}){if(!V)return a;if(typeof V=="string"||D(V)){const te=n(V,z);if(te===i)return a;const se=function(he,q){return!!te(he,q)};return te.allBasenames&&(se.allBasenames=te.allBasenames),te.allPaths&&(se.allPaths=te.allPaths),se}return W(V,z)}function D(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(V){return V.allBasenames||[]}function K(V){return V.allPaths||[]}function W(V,z){const te=H(Object.getOwnPropertyNames(V).map(X=>_(X,V[X],z)).filter(X=>X!==i)),se=te.length;if(!se)return i;if(!te.some(X=>!!X.requiresSiblings)){if(se===1)return te[0];const X=function(Q,B){let j;for(let x=0,ee=te.length;x<ee;x++){const J=te[x](Q,B);if(typeof J=="string")return J;(0,c.$sh)(J)&&(j||(j=[]),j.push(J))}return j?(async()=>{for(const x of j){const ee=await x;if(typeof ee=="string")return ee}return null})():null},G=te.find(Q=>!!Q.allBasenames);G&&(X.allBasenames=G.allBasenames);const U=te.reduce((Q,B)=>B.allPaths?Q.concat(B.allPaths):Q,[]);return U.length&&(X.allPaths=U),X}const he=function(X,G,U){let Q,B;for(let j=0,x=te.length;j<x;j++){const ee=te[j];ee.requiresSiblings&&U&&(G||(G=(0,O.$qc)(X)),Q||(Q=G.substr(0,G.length-(0,O.$rc)(X).length)));const J=ee(X,G,Q,U);if(typeof J=="string")return J;(0,c.$sh)(J)&&(B||(B=[]),B.push(J))}return B?(async()=>{for(const j of B){const x=await j;if(typeof x=="string")return x}return null})():null},q=te.find(X=>!!X.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=te.reduce((X,G)=>G.allPaths?X.concat(G.allPaths):X,[]);return Z.length&&(he.allPaths=Z),he}function _(V,z,te){if(z===!1)return i;const se=n(V,te);if(se===i)return i;if(typeof z=="boolean")return se;if(z){const he=z.when;if(typeof he=="string"){const q=(Z,X,G,U)=>{if(!U||!se(Z,X))return null;const Q=he.replace("$(basename)",()=>G),B=U(Q);return(0,c.$sh)(B)?B.then(j=>j?V:null):B?V:null};return q.requiresSiblings=!0,q}}return se}function H(V,z){const te=V.filter(X=>!!X.basenames);if(te.length<2)return V;const se=te.reduce((X,G)=>{const U=G.basenames;return U?X.concat(U):X},[]);let he;if(z){he=[];for(let X=0,G=se.length;X<G;X++)he.push(z)}else he=te.reduce((X,G)=>{const U=G.patterns;return U?X.concat(U):X},[]);const q=function(X,G){if(typeof X!="string")return null;if(!G){let Q;for(Q=X.length;Q>0;Q--){const B=X.charCodeAt(Q-1);if(B===N.CharCode.Slash||B===N.CharCode.Backslash)break}G=X.substr(Q)}const U=se.indexOf(G);return U!==-1?he[U]:null};q.basenames=se,q.patterns=he,q.allBasenames=se;const Z=V.filter(X=>!X.basenames);return Z.push(q),Z}function ie(V,z){return(0,R.$xb)(V,z,(te,se)=>typeof te=="string"&&typeof se=="string"?te===se:typeof te!="string"&&typeof se!="string"?te.base===se.base&&te.pattern===se.pattern:!1)}}),define(ce[95],le([0,1,15,66,9]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=A,e.$Pn=S,e.$Qn=m;function k(u){return u.toJSON()}class T{constructor($){this.a=$}transformIncoming($){const h=this.a.transformIncoming($);return h===$?$:k(N.URI.from(h))}transformOutgoing($){const h=this.a.transformOutgoing($);return h===$?$:k(N.URI.from(h))}transformOutgoingURI($){const h=this.a.transformOutgoing($);return h===$?$:N.URI.from(h)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Mn=T,e.$Nn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,$,h){if(!u||h>200)return null;if(typeof u=="object"){if(u instanceof N.URI)return $.transformOutgoing(u);for(const b in u)if(Object.hasOwnProperty.call(u,b)){const v=O(u[b],$,h+1);v!==null&&(u[b]=v)}}return null}function A(u,$){const h=O(u,$,0);return h===null?u:h}function w(u,$,h,b){if(!u||b>200)return null;if(typeof u=="object"){if(u.$mid===c.MarshalledId.Uri)return h?N.URI.revive($.transformIncoming(u)):$.transformIncoming(u);if(u instanceof R.$Pe)return null;for(const v in u)if(Object.hasOwnProperty.call(u,v)){const d=w(u[v],$,h,b+1);d!==null&&(u[v]=d)}}return null}function S(u,$){const h=w(u,$,!1,0);return h===null?u:h}function m(u,$){const h=w(u,$,!0,0);return h===null?u:h}}),define(ce[150],le([0,1,38,52,32,137,5]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=A,e.$Un=m,e.$Vn=u,N=ke(N),e.$Sn=new class{c($){return this.a||(this.a=c.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,h=0;const b=(0,R.networkInterfaces)();for(const v in b){const d=b[v];if(d)for(const{mac:p,internal:P}of d)P||(h+=1,this.c(p.toUpperCase())&&($+=1))}this.b=h>0?$/h:0}return this.b}};let O;async function A($){return O||(O=(async()=>await w($)||N.$3g())()),O}async function w($){try{const h=await new Promise((v,d)=>{ne(["crypto"],v,d)}).then(ke),b=(0,k.$Rn)();return h.createHash("sha256").update(b,"utf8").digest("hex")}catch(h){$(h);return}}const S="Software\\Microsoft\\SQMClient";async function m($){if(T.$i){const h=await new Promise((b,v)=>{ne(["@vscode/windows-registry"],b,v)}).then(ke);try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(b){return $(b),""}}return""}async function u($){try{return await(await new Promise((v,d)=>{ne(["@vscode/deviceid"],v,d)}).then(ke)).getDeviceId()}catch(h){return $(h),""}}}),define(ce[151],le([0,1,46,152,14,37]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AX=S,e.$BX=m;const T="XDG_SESSION_TYPE",O="WAYLAND_DISPLAY",A="XDG_RUNTIME_DIR";var w;(function(u){u.Wayland="wayland",u.XWayland="xwayland",u.X11="x11",u.Unknown="unknown"})(w||(w={}));async function S(u){const $=k.env[T];if($)return $===w.Wayland||$===w.X11?$:w.Unknown;if(k.env[O]){const b=k.env[A];if(b){const v=(0,N.$mc)(b,"wayland-0");try{return await(0,c.access)(v,R.constants.R_OK),w.Wayland}catch(d){return u(d),w.Unknown}}else return w.Unknown}else return w.X11}function m(u,$){if($)switch($){case"auto":return u;case"x11":return u===w.Wayland?w.XWayland:w.X11;case"wayland":return w.Wayland;default:return w.Unknown}else return u===w.Wayland?w.XWayland:w.X11}}),define(ce[153],le([0,1,46,152,278,5]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=T,k=ke(k);async function T(O){if(k.$j||k.$i)return;let A;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await(0,c.open)(w,R.constants.R_OK);break}catch{}if(!A){O("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const m of(0,N.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!m.includes("="))continue;const u=m.split("=")[0].toUpperCase().trim();if(w.has(u)){const $=m.split("=")[1].replace(/"/g,"").toLowerCase().trim();u==="ID"||u==="DISTRIB_ID"?S.id=$:u==="ID_LIKE"?S.id_like=$:(u==="VERSION_ID"||u==="DISTRIB_RELEASE")&&(S.version_id=$)}}return S}catch(w){O(w)}}}),define(ce[31],le([0,1,46,38,279,6,42,91,14,5,21,9]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=P,e.whenDeleted=r,e.configureFlushOnWrite=o,e.writeFileSync=f,R=ke(R);var u;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function $(W,_=u.UNLINK,H){if((0,T.$Jg)(W))throw new Error("rimraf - will refuse to recursively delete root");return _===u.UNLINK?b(W):h(W,H)}async function h(W,_=(0,T.$Og)((0,c.tmpdir)())){try{try{await R.promises.rename(W,_)}catch(H){return H.code==="ENOENT"?void 0:b(W)}b(_).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function b(W){return R.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function v(W){if((0,T.$Jg)(W))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function d(W,_){return g(await(_?p(W):R.promises.readdir(W)))}async function p(W){try{return await R.promises.readdir(W,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const _=[],H=await d(W);for(const ie of H){let V=!1,z=!1,te=!1;try{const se=await e.Promises.lstat((0,A.$mc)(W,ie));V=se.isFile(),z=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}_.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>te})}return _}function P(W){return g(R.readdirSync(W))}function g(W){return W.map(_=>typeof _=="string"?w.$j?(0,O.$nm)(_):_:(_.name=w.$j?(0,O.$nm)(_.name):_.name,_))}async function s(W){const _=await d(W),H=[];for(const ie of _)await t.existsDirectory((0,A.$mc)(W,ie))&&H.push(ie);return H}function r(W,_=1e3){return new Promise(H=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,R.access(W,z=>{ie=!1,z&&(clearInterval(V),H(void 0))}))},_)})}var t;(function(W){async function _(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(w.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw se}throw te}}W.stat=_;async function H(V){try{const{stat:z,symbolicLink:te}=await W.stat(V);return z.isFile()&&te?.dangling!==!0}catch{}return!1}W.existsFile=H;async function ie(V){try{const{stat:z,symbolicLink:te}=await W.stat(V);return z.isDirectory()&&te?.dangling!==!0}catch{}return!1}W.existsDirectory=ie})(t||(e.SymlinkSupport=t={}));const a=new k.$Ph;function i(W,_,H){return a.queueFor(m.URI.file(W),()=>{const ie=I(H);return new Promise((V,z)=>l(W,_,ie,te=>te?z(te):V()))},S.$$g)}let n=!0;function o(W){n=W}function l(W,_,H,ie){if(!n)return R.writeFile(W,_,{mode:H.mode,flag:H.flag},ie);R.open(W,H.flag,H.mode,(V,z)=>{if(V)return ie(V);R.writeFile(z,_,te=>{if(te)return R.close(z,()=>ie(te));R.fdatasync(z,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),R.close(z,he=>ie(he))))})})}function f(W,_,H){const ie=I(H);if(!n)return R.writeFileSync(W,_,{mode:ie.mode,flag:ie.flag});const V=R.openSync(W,ie.flag,ie.mode);try{R.writeFileSync(V,_);try{R.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{R.closeSync(V)}}function I(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function L(W,_,H=6e4){if(W!==_)try{w.$i&&typeof H=="number"?await E(W,_,Date.now(),H):await R.promises.rename(W,_)}catch(ie){if(W.toLowerCase()!==_.toLowerCase()&&ie.code==="EXDEV"||W.endsWith("."))await y(W,_,{preserveSymlinks:!1}),await $(W,u.MOVE);else throw ie}}async function E(W,_,H,ie,V=0){try{return await R.promises.rename(W,_)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-H>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let te=!1;try{const{stat:se}=await t.stat(_);se.isFile()||(te=!0)}catch{}if(te)throw z}return await(0,k.$Hh)(Math.min(100,V*10)),E(W,_,H,ie,V+1)}}async function y(W,_,H){return F(W,_,{root:{source:W,target:_},options:H,handledSourcePaths:new Set})}const C=511;async function F(W,_,H){if(H.handledSourcePaths.has(W))return;H.handledSourcePaths.add(W);const{stat:ie,symbolicLink:V}=await t.stat(W);if(V){if(H.options.preserveSymlinks)try{return await K(W,_,H)}catch{}if(V.dangling)return}return ie.isDirectory()?D(W,_,ie.mode&C,H):M(W,_,ie.mode&C)}async function D(W,_,H,ie){await e.Promises.mkdir(_,{recursive:!0,mode:H});const V=await d(W);for(const z of V)await F((0,A.$mc)(W,z),(0,A.$mc)(_,z),ie)}async function M(W,_,H){await e.Promises.copyFile(W,_),await e.Promises.chmod(_,H)}async function K(W,_,H){let ie=await e.Promises.readlink(W);(0,T.$Fg)(ie,H.root.source,!w.$k)&&(ie=(0,A.$mc)(H.root.target,ie.substr(H.root.source.length+1))),await e.Promises.symlink(ie,_)}e.Promises=new class{get access(){return R.promises.access}get stat(){return R.promises.stat}get lstat(){return R.promises.lstat}get utimes(){return R.promises.utimes}get read(){return(W,_,H,ie,V)=>new Promise((z,te)=>{R.read(W,_,H,ie,V,(se,he,q)=>se?te(se):z({bytesRead:he,buffer:q}))})}get readFile(){return R.promises.readFile}get write(){return(W,_,H,ie,V)=>new Promise((z,te)=>{R.write(W,_,H,ie,V,(se,he,q)=>se?te(se):z({bytesWritten:he,buffer:q}))})}get appendFile(){return R.promises.appendFile}get fdatasync(){return(0,N.promisify)(R.fdatasync)}get truncate(){return R.promises.truncate}get copyFile(){return R.promises.copyFile}get open(){return(0,N.promisify)(R.open)}get close(){return(0,N.promisify)(R.close)}get symlink(){return R.promises.symlink}get readlink(){return R.promises.readlink}get chmod(){return R.promises.chmod}get mkdir(){return R.promises.mkdir}get unlink(){return R.promises.unlink}get rmdir(){return R.promises.rmdir}get realpath(){return(0,N.promisify)(R.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return s}get writeFile(){return i}get rm(){return $}get rename(){return L}get copy(){return y}}}),define(ce[154],le([0,1,46,14,5,27,31]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=O,e.$kr=A,e.$lr=w,e.$mr=S,R=ke(R);function O(u){if(N.$k)return u;const $=(0,c.$pc)(u);if(u===$)return u;const h=((0,c.$qc)(u)||u).toLowerCase();try{const v=(0,T.readdirSync)($).filter(d=>d.toLowerCase()===h);if(v.length===1){const d=O($);if(d)return(0,c.$mc)(d,v[0])}else if(v.length>1){const d=v.indexOf(h);if(d>=0){const p=O($);if(p)return(0,c.$mc)(p,v[d])}}}catch{}return null}async function A(u,$){if(N.$k)return u;const h=(0,c.$pc)(u);if(u===h)return u;const b=((0,c.$qc)(u)||u).toLowerCase();try{if($?.isCancellationRequested)return null;const d=(await T.Promises.readdir(h)).filter(p=>p.toLowerCase()===b);if(d.length===1){const p=await A(h,$);if(p)return(0,c.$mc)(p,d[0])}else if(d.length>1){const p=d.indexOf(b);if(p>=0){const P=await A(h,$);if(P)return(0,c.$mc)(P,d[p])}}}catch{}return null}async function w(u){try{return await T.Promises.realpath(u)}catch{const h=m(u);return await T.Promises.access(h,R.constants.R_OK),h}}function S(u){try{return R.realpathSync(u)}catch{const h=m(u);return R.accessSync(h,R.constants.R_OK),h}}function m(u){return(0,k.$pf)((0,c.$kc)(u),c.sep)}}),define(ce[155],le([0,1,14,5,37,93,13,31]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=A,e.$zm=w,R=ke(R),c=ke(c),N=ke(N),T=ke(T),O=ke(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function A(m=N.env){return m.comspec||"cmd.exe"}function w(m){let u=[],$=!1;const h=function(b){if($){u.push(b);return}(!m.send(b,d=>{if(d&&console.error(d),$=!1,u.length>0){const p=u.slice(0);u=[],p.forEach(P=>h(P))}})||c.$i)&&($=!0)};return{send:h}}var S;(function(m){async function u($,h,b){if(R.$lc($))return $;if(h===void 0&&(h=N.cwd()),R.$pc($)!=="."||(b===void 0&&T.$gg(N.env.PATH)&&(b=N.env.PATH.split(R.$wc)),b===void 0||b.length===0))return R.$mc(h,$);async function d(p){if(await O.Promises.exists(p)){let P;try{P=await O.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(P=await O.Promises.lstat(p))}return P?!P.isDirectory():!1}return!1}for(const p of b){let P;if(R.$lc(p)?P=R.$mc(p,$):P=R.$mc(h,p,$),await d(P))return P;let g=P+".com";if(await d(g)||(g=P+".exe",await d(g)))return g}return R.$mc(h,$)}m.findExecutable=u})(S||(e.win32=S={}))}),define(ce[156],le([0,1,70,23]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=N;function N(T){return new Promise((O,A)=>{let w;const S=new Map;function m($,h,b,v,d){const p=S.get(h);if($===T||p){const P={name:u(b),cmd:b,pid:$,ppid:h,load:v,mem:d};S.set($,P),$===T&&(w=P),p&&(p.children||(p.children=[]),p.children.push(P),p.children.length>1&&(p.children=p.children.sort((g,s)=>g.pid-s.pid)))}}function u($){const h=/--utility-sub-type=network/i,b=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(b.exec($))return"electron-crash-reporter";if(v.exec($))return"winpty-agent";if(d.exec($))return"conpty-agent";let P=p.exec($);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?h.exec($)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const g=/[a-zA-Z-]+\.js/g;let s="";do P=g.exec($),P&&(s+=P+" ");while(P);return s&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${s})`:$}if(process.platform==="win32"){const $=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,b)=>{ne(["@vscode/windows-process-tree"],h,b)}).then(ke).then(h=>{h.getProcessList(T,b=>{if(!b){A(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(b,v=>{const d=new Map;v.forEach(p=>{const P=$(p.commandLine||"");d.set(p.pid,{name:u(P),cmd:P,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=d.get(T),w?(d.forEach(p=>{const P=d.get(p.ppid);P&&(P.children||(P.children=[]),P.children.push(p))}),d.forEach(p=>{p.children&&(p.children=p.children.sort((P,g)=>P.pid-g.pid))}),O(w)):A(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let $=function(){let h=[w];const b=[];for(;h.length;){const d=h.shift();d&&(b.push(d.pid),d.children&&(h=h.concat(d.children)))}let v=JSON.stringify(c.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+b.join(" "),(0,R.exec)(v,{},(d,p,P)=>{if(d||P)A(d||new Error(P.toString()));else{const g=p.toString().split(`
`);for(let s=0;s<b.length;s++){const r=S.get(b[s]);r.load=parseFloat(g[s])}if(!w){A(new Error(`Root process ${T} not found`));return}O(w)}})};(0,R.exec)("which ps",{},(h,b,v)=>{if(h||v)if(process.platform!=="linux")A(h||new Error(v.toString()));else{const d=JSON.stringify(c.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(d,{},(p,P,g)=>{p||g?A(p||new Error(g.toString())):(k(P,m),$())})}else{const d=b.toString().trim();(0,R.exec)(`${d} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,g,s)=>{P||s&&!s.includes("screen size is bogus")?A(P||new Error(s.toString())):(k(g,m),process.platform==="linux"?$():w?O(w):A(new Error(`Root process ${T} not found`)))})}})}})}function k(T,O){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const S of w){const m=A.exec(S.trim());m&&m.length===6&&O(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}});var ve=this&&this.__decorate||function(ne,e,R,c){var N=arguments.length,k=N<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,R):c,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ne,e,R,c);else for(var O=ne.length-1;O>=0;O--)(T=ne[O])&&(k=(N<3?T(k):N>3?T(e,R,k):T(e,R))||k);return N>3&&k&&Object.defineProperty(e,R,k),k};define(ce[43],le([0,1,19,6,15,26,88,8,3,2,69,27,13]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=o,e.$hi=l,e.$mi=C,e.$ni=F,m=ke(m);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function h(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b||(b={}));function v(V){switch(V){case b.Initialize:return"init";case b.PromiseSuccess:return"reply:";case b.PromiseError:case b.PromiseErrorObj:return"replyErr:";case b.EventFire:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function p(V){let z=0;for(let te=0;;te+=7){const se=V.read(1);if(z|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return z}}const P=a(0);function g(V,z){if(z===0){V.write(P);return}let te=0;for(let he=z;he!==0;he=he>>>7)te++;const se=N.$Pe.alloc(te);for(let he=0;z!==0;he++)se.buffer[he]=z&127,z=z>>>7,z>0&&(se.buffer[he]|=128);V.write(se)}class s{constructor(z){this.b=z,this.a=0}read(z){const te=this.b.slice(this.a,this.a+z);return this.a+=te.byteLength,te}}e.$ei=s;class r{constructor(){this.a=[]}get buffer(){return N.$Pe.concat(this.a)}write(z){this.a.push(z)}}e.$fi=r;var t;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(t||(t={}));function a(V){const z=N.$Pe.alloc(1);return z.writeUInt8(V,0),z}const i={Undefined:a(t.Undefined),String:a(t.String),Buffer:a(t.Buffer),VSBuffer:a(t.VSBuffer),Array:a(t.Array),Object:a(t.Object),Uint:a(t.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(i.Undefined);else if(typeof z=="string"){const te=N.$Pe.fromString(z);V.write(i.String),g(V,te.byteLength),V.write(te)}else if(n&&Buffer.isBuffer(z)){const te=N.$Pe.wrap(z);V.write(i.Buffer),g(V,te.byteLength),V.write(te)}else if(z instanceof N.$Pe)V.write(i.VSBuffer),g(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(i.Array),g(V,z.length);for(const te of z)o(V,te)}else if(typeof z=="number"&&(z|0)===z)V.write(i.Uint),g(V,z);else{const te=N.$Pe.fromString(JSON.stringify(z));V.write(i.Object),g(V,te.byteLength),V.write(te)}}function l(V){switch(V.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return V.read(p(V)).toString();case t.Buffer:return V.read(p(V)).buffer;case t.VSBuffer:return V.read(p(V));case t.Array:{const te=p(V),se=[];for(let he=0;he<te;he++)se.push(l(V));return se}case t.Object:return JSON.parse(V.read(p(V)).toString());case t.Int:return p(V)}}class f{constructor(z,te,se=null,he=1e3){this.h=z,this.j=te,this.k=se,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:b.Initialize})}registerChannel(z,te){this.b.set(z,te),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case b.Initialize:{const te=this.o([z.type]);this.k?.logOutgoing(te,0,I.OtherSide,v(z.type));return}case b.PromiseSuccess:case b.PromiseError:case b.EventFire:case b.PromiseErrorObj:{const te=this.o([z.type,z.id],z.data);this.k?.logOutgoing(te,z.id,I.OtherSide,v(z.type),z.data);return}}}o(z,te=void 0){const se=new r;return o(se,z),o(se,te),this.p(se.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const te=new s(z),se=l(te),he=l(te),q=se[0];switch(q){case $.Promise:return this.k?.logIncoming(z.byteLength,se[1],I.OtherSide,`${h(q)}: ${se[2]}.${se[3]}`,he),this.s({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case $.EventListen:return this.k?.logIncoming(z.byteLength,se[1],I.OtherSide,`${h(q)}: ${se[2]}.${se[3]}`,he),this.t({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,se[1],I.OtherSide,`${h(q)}`),this.u({type:q,id:se[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,se[1],I.OtherSide,`${h(q)}`),this.u({type:q,id:se[1]})}}s(z){const te=this.b.get(z.channelName);if(!te){this.v(z);return}const se=new k.$ye;let he;try{he=te.call(this.j,z.name,z.arg,se.token)}catch(X){he=Promise.reject(X)}const q=z.id;he.then(X=>{this.m({id:q,data:X,type:b.PromiseSuccess})},X=>{X instanceof Error?this.m({id:q,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split(`
`):void 0},type:b.PromiseError}):this.m({id:q,data:X,type:b.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(z.id)});const Z=(0,w.$Vc)(()=>se.cancel());this.d.set(z.id,Z)}t(z){const te=this.b.get(z.channelName);if(!te){this.v(z);return}const se=z.id,q=te.listen(this.j,z.name,z.arg)(Z=>this.m({id:se,data:Z,type:b.EventFire}));this.d.set(z.id,q)}u(z){const te=this.d.get(z.id);te&&(te.dispose(),this.d.delete(z.id))}v(z){let te=this.g.get(z.channelName);te||(te=[],this.g.set(z.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:b.PromiseError})},this.l);te.push({request:z,timeoutTimer:se})}w(z){const te=this.g.get(z);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case $.Promise:this.s(se.request);break;case $.EventListen:this.t(se.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Sc)(this.d.values()),this.d.clear()}}e.$ii=f;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class L{constructor(z,te=null){this.l=z,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=te}getChannel(z){const te=this;return{call(se,he,q){return te.a?Promise.reject(new O.$8):te.m(z,se,he,q)},listen(se,he){return te.a?A.Event.None:te.o(z,se,he)}}}m(z,te,se,he=k.CancellationToken.None){const q=this.g++,Z=$.Promise,X={id:q,type:Z,channelName:z,name:te,arg:se};if(he.isCancellationRequested)return Promise.reject(new O.$8);let G;return new Promise((Q,B)=>{if(he.isCancellationRequested)return B(new O.$8);const j=()=>{const oe=ue=>{switch(ue.type){case b.PromiseSuccess:this.f.delete(q),Q(ue.data);break;case b.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,B(ge);break}case b.PromiseErrorObj:this.f.delete(q),B(ue.data);break}};this.f.set(q,oe),this.p(X)};let x=null;this.b===d.Idle?j():(x=(0,c.$th)(oe=>this.u()),x.then(()=>{x=null,j()}));const ee=()=>{x?(x.cancel(),x=null):this.p({id:q,type:$.PromiseCancel}),B(new O.$8)},J=he.onCancellationRequested(ee);G=(0,w.$Uc)((0,w.$Vc)(ee),J),this.d.add(G)}).finally(()=>{G.dispose(),this.d.delete(G)})}o(z,te,se){const he=this.g++,q=$.EventListen,Z={id:he,type:q,channelName:z,name:te,arg:se};let X=null;const G=new A.$ne({onWillAddFirstListener:()=>{X=(0,c.$th)(Q=>this.u()),X.then(()=>{X=null,this.d.add(G),this.p(Z)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(G),this.p({id:he,type:$.EventDispose}))}}),U=Q=>G.fire(Q.data);return this.f.set(he,U),G.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const te=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(te,z.id,I.LocalSide,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const te=this.q([z.type,z.id]);this.j?.logOutgoing(te,z.id,I.LocalSide,h(z.type));return}}}q(z,te=void 0){const se=new r;return o(se,z),o(se,te),this.r(se.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const te=new s(z),se=l(te),he=l(te),q=se[0];switch(q){case b.Initialize:return this.j?.logIncoming(z.byteLength,0,I.LocalSide,v(q)),this.t({type:se[0]});case b.PromiseSuccess:case b.PromiseError:case b.EventFire:case b.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,se[1],I.LocalSide,v(q),he),this.t({type:se[0],id:se[1],data:he})}}t(z){if(z.type===b.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Sc)(this.d.values()),this.d.clear()}}e.$ji=L,ve([T.$$h],L.prototype,"onDidInitializePromise",null);class E{get connections(){const z=[];return this.f.forEach(te=>z.push(te)),z}constructor(z,te,se){this.a=new Map,this.f=new Set,this.g=new A.$ne,this.onDidAddConnection=this.g.event,this.h=new A.$ne,this.onDidRemoveConnection=this.h.event,this.j=new w.$Wc,this.j.add(z(({protocol:he,onDidClientDisconnect:q})=>{const Z=A.Event.once(he.onMessage);this.j.add(Z(X=>{const G=new s(X),U=l(G),Q=new f(he,U,te,se),B=new L(he,te);this.a.forEach((x,ee)=>Q.registerChannel(ee,x));const j={channelServer:Q,channelClient:B,ctx:U};this.f.add(j),this.g.fire(j),this.j.add(q(()=>{Q.dispose(),B.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(z,te){const se=this;return{call(he,q,Z){let X;if((0,u.$ug)(te)){const U=(0,R.$6b)(se.connections.filter(te));X=U?Promise.resolve(U):A.Event.toPromise(A.Event.filter(se.onDidAddConnection,te))}else X=te.routeCall(se,he,q);const G=X.then(U=>U.channelClient.getChannel(z));return C(G).call(he,q,Z)},listen(he,q){if((0,u.$ug)(te))return se.k(z,te,he,q);const Z=te.routeEvent(se,he,q).then(X=>X.channelClient.getChannel(z));return C(Z).listen(he,q)}}}k(z,te,se,he){const q=this;let Z;const X=new A.$ne({onWillAddFirstListener:()=>{Z=new w.$Wc;const G=new A.$te,U=new Map,Q=j=>{const ee=j.channelClient.getChannel(z).listen(se,he),J=G.add(ee);U.set(j,J)},B=j=>{const x=U.get(j);x&&(x.dispose(),U.delete(j))};q.connections.filter(te).forEach(Q),A.Event.filter(q.onDidAddConnection,te)(Q,void 0,Z),q.onDidRemoveConnection(B,void 0,Z),G.event(X.fire,X,Z),Z.add(G)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return X.event}registerChannel(z,te){this.a.set(z,te);for(const se of this.f)se.channelServer.registerChannel(z,te)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=E;class y{constructor(z,te,se=null){const he=new r;o(he,te),z.send(he.buffer),this.a=new L(z,se),this.d=new f(z,te,se)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,te){this.d.registerChannel(z,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=y;function C(V){return{call(z,te,se){return V.then(he=>he.call(z,te,se))},listen(z,te){const se=new A.$we;return V.then(he=>se.input=he.listen(z,te)),se.event}}}function F(V){let z=!1;return{call(te,se,he){return z?V.call(te,se,he):(0,c.$Hh)(0).then(()=>z=!0).then(()=>V.call(te,se,he))},listen(te,se){if(z)return V.listen(te,se);const he=new A.$we;return(0,c.$Hh)(0).then(()=>z=!0).then(()=>he.input=V.listen(te,se)),he.event}}}class D{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const te of z.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await A.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$oi=D;var M;(function(V){function z(q,Z,X){const G=q,U=X&&X.disableMarshalling,Q=new Map;for(const B in G)se(B)&&Q.set(B,A.Event.buffer(G[B],!0,void 0,Z));return new class{listen(B,j,x){const ee=Q.get(j);if(ee)return ee;const J=G[j];if(typeof J=="function"){if(he(j))return J.call(G,x);if(se(j))return Q.set(j,A.Event.buffer(G[j],!0,void 0,Z)),Q.get(j)}throw new O.$eb(`Event not found: ${j}`)}call(B,j,x){const ee=G[j];if(typeof ee=="function"){if(!U&&Array.isArray(x))for(let oe=0;oe<x.length;oe++)x[oe]=(0,S.$di)(x[oe]);let J=ee.apply(G,x);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new O.$eb(`Method not found: ${j}`)}}}V.fromService=z;function te(q,Z){const X=Z&&Z.disableMarshalling;return new Proxy({},{get(G,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):he(U)?function(Q){return q.listen(U,Q)}:se(U)?q.listen(U):async function(...Q){let B;Z&&!(0,u.$pg)(Z.context)?B=[Z.context,...Q]:B=Q;const j=await q.call(U,B);return X?j:(0,S.$di)(j)};throw new O.$eb(`Property not found: ${String(U)}`)}})}V.toService=te;function se(q){return q[0]==="o"&&q[1]==="n"&&m.$Gf(q.charCodeAt(2))}function he(q){return/^onDynamic/.test(q)&&m.$Gf(q.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function _(V){return Array.isArray(V)?V.map(W):W(V)}function H(V,z,te,se,he,q,Z){Z=_(Z);const X=K[he],G=X[se%X.length];let U=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(q)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}class ie{constructor(z,te){this.d=z,this.f=te,this.a=0,this.b=0}logOutgoing(z,te,se,he,q){this.b+=z,H(this.d,this.b,z,te,se,he,q)}logIncoming(z,te,se,he,q){this.a+=z,H(this.f,this.a,z,te,se,he,q)}}e.$pi=ie}),define(ce[71],le([0,1,15,3,2,43]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var O;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(I,L){if(!n.has(I)){const E=String(++o);n.set(I,E)}return n.get(I)}function f(I,L,E,y){if(!i.enableDiagnostics)return;const C=l(I,L);if(y instanceof R.$Pe||y instanceof Uint8Array||y instanceof ArrayBuffer||ArrayBuffer.isView(y)){const F=R.$Pe.alloc(y.byteLength);F.set(y),i.records.push({timestamp:Date.now(),id:C,label:L,type:E,buff:F})}else i.records.push({timestamp:Date.now(),id:C,label:L,type:E,data:y})}i.traceSocketEvent=f})(O||(e.SocketDiagnostics=O={}));var A;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let w=null;function S(){return w||(w=R.$Pe.alloc(0)),w}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const L=this.a[0];return o&&(this.a.shift(),this.b-=n),L}if(this.a[0].byteLength>n){const L=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),L}const l=R.$Pe.alloc(n);let f=0,I=0;for(;n>0;){const L=this.a[I];if(L.byteLength>n){const E=L.slice(0,n);l.set(E,f),f+=n,o&&(this.a[I]=L.slice(n),this.b-=n),n-=n}else l.set(L,f),f+=L.byteLength,o?(this.a.shift(),this.b-=L.byteLength):I++,n-=L.byteLength}return l}}e.$qi=m;var u;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(u||(u={}));function $(i){switch(i){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class b{constructor(n,o,l,f){this.type=n,this.id=o,this.ack=l,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends N.$Xc{constructor(n){super(),this.f=this.B(new c.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:h.HeaderLength,messageType:u.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new m,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,f=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=h.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,o),this.f.fire(new b(l,f,I,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.$Pe.alloc(h.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const l=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,l}h(){const n=R.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class p extends N.$Xc{constructor(n){super(),this.f=new c.$ne,this.onMessage=this.f.event,this.g=new c.$ne,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(o=>{o.type===u.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(u.Regular,0,0,n))}}e.$ri=p;class P extends k.$li{static fromSocket(n,o){return new P(new p(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,l=null){super(n,o,l),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$si=P;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ti=g;class s{constructor(n){this.data=n,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,l=this.a;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new s(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<t.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=t.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+t.a)*1e3;let l=0;for(let f=0;f<t.a;f++)n-this.c[f]<=o&&l++;return 1-l/t.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??t.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Wc,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new v(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},h.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(u.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new b(u.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new b(u.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new N.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new v(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(u.Ack,0,this.h,S());this.p.write(n);const o=this.b.toArray();for(let l=0,f=o.length;l<f;l++)this.p.write(o[l]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case u.None:break;case u.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new b(u.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case u.Control:{this.u.fire(n.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const o=this.b.toArray();for(let l=0,f=o.length;l<f;l++)this.p.write(o[l]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const l=new b(u.Regular,o,this.h,n);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(n){const o=new b(u.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=h.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},h.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this.q.lastReadTime,f=Date.now()-this.n;if(o>=h.TimeoutTime&&l>=h.TimeoutTime&&f>=h.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:l});return}const I=Math.max(h.TimeoutTime-o,h.TimeoutTime-l,h.TimeoutTime-f,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(u.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new b(u.KeepAlive,0,this.h,S());this.p.write(n)}}e.$ui=a}),define(ce[96],le([0,1,70,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,O=ke(O);class h extends $.$ii{constructor(d){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",p=>N.$Pe.wrap(Buffer.from(p,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$fr=h;class b{constructor(d,p){this.i=d,this.j=p,this.c=new Set,this.g=new Map,this.h=new A.$ne,this.onDidProcessExit=this.h.event;const P=p&&p.timeout?p.timeout:6e4;this.b=new c.$Dh(P),this.d=null,this.f=null}getChannel(d){const p=this;return{call(P,g,s){return p.k(d,P,g,s)},listen(P,g){return p.l(d,P,g)}}}k(d,p,P,g=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(O.$9());this.b.cancel();const s=this.n(d),r=(0,c.$th)(i=>s.call(p,P,i)),t=g.onCancellationRequested(()=>r.cancel()),a=(0,w.$Vc)(()=>r.cancel());return this.c.add(a),r.finally(()=>{t.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l(d,p,P){if(!this.b)return A.Event.None;this.b.cancel();let g;const s=new A.$ne({onWillAddFirstListener:()=>{g=this.n(d).listen(p,P)(s.fire,s),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.$mm)(p.env),this.d=(0,R.fork)(this.i,d,p);const P=new A.$ne,s=A.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.$br)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}P.fire(N.$Pe.wrap(Buffer.from(o,"base64")))}),r=this.j.useQueue?(0,m.$zm)(this.d):this.d,t=o=>this.d&&this.d.connected&&r.send(o.buffer.toString("base64")),a=P.event,i={send:t,onMessage:a};this.f=new $.$ji(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",n),s.dispose(),this.c.forEach(f=>(0,w.$Sc)(f)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(d){let p=this.g.get(d);return p||(p=this.m.getChannel(d),this.g.set(d,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=b}),define(ce[157],le([0,1,140,15,43,3,13,19]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SX=void 0,e.$TX=S;class A{constructor(u){this.a=u,this.onMessage=k.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?c.$Pe.wrap($.data):c.$Pe.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}class w extends N.$ki{static b(u){(0,T.$qg)((0,R.$RX)(process),"Electron Utility Process");const $=new k.$ne;return process.parentPort.on("message",h=>{if(u?.handledClientConnection(h))return;const b=(0,O.$Rb)(h.ports);b&&$.fire(b)}),k.Event.map($.event,h=>({protocol:new A(h),onDidClientDisconnect:k.Event.fromNodeEventEmitter(h,"close")}))}constructor(u){super(w.b(u))}}e.$SX=w;function S(m,u,$){const h=b=>{b.data===u&&(m.removeListener("message",h),$())};m.on("message",h)}}),define(ce[72],le([0,1,6,3,2,69,13]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=A;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function A(u){const $=u;return $?.changed instanceof Map||$?.deleted instanceof Set}var w;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(w||(e.StorageState=w={}));class S extends N.$Xc{static{this.a=100}constructor($,h=Object.create(null)){super(),this.r=$,this.s=h,this.b=this.B(new c.$qe),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new R.$Eh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((h,b)=>this.w(b,h)),$.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w($,h){if(this.c===w.Closed)return;let b=!1;(0,T.$pg)(h)?b=this.f.delete($):this.f.get($)!==h&&(this.f.set($,h),b=!0),b&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,h){const b=this.f.get($);return(0,T.$pg)(b)?h:b}getBoolean($,h){const b=this.get($);return(0,T.$pg)(b)?h:b==="true"}getNumber($,h){const b=this.get($);return(0,T.$pg)(b)?h:parseInt(b,10)}getObject($,h){const b=this.get($);return(0,T.$pg)(b)?h:(0,k.$ci)(b)}async set($,h,b=!1){if(this.c===w.Closed)return;if((0,T.$pg)(h))return this.delete($,b);const v=(0,T.$ig)(h)||Array.isArray(h)?(0,k.$bi)(h):String(h);if(this.f.get($)!==v)return this.f.set($,v),this.j.set($,v),this.h.delete($),this.b.fire({key:$,external:b}),this.D()}async delete($,h=!1){if(!(this.c===w.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:h}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===w.Closed||this.m))return this.D($)}async D($){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$cq=S;class m{constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((h,b)=>this.a.set(b,h)),$.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$dq=m}),define(ce[158],le([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ce[73],le([0,1,46,6,14,13,31,158]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0,e.zip=v,e.$Bq=d,e.$Cq=P,N=ke(N),O=ke(O),e.$yq="end of central directory record signature not found";const A=new RegExp(e.$yq);class w extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=s,this.cause=r}}e.$zq=w;function S(g){const s=g.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function m(g){if(g instanceof w)return g;let s;return A.test(g.message)&&(s="CorruptZip"),new w(s,g)}function u(g,s,r,t,a,i){const n=N.$pc(s),o=N.$mc(t,n);if(!o.startsWith(t))return Promise.reject(new Error(O.localize(0,null,s)));const l=N.$mc(t,s);let f;return i.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,L)=>{if(!i.isCancellationRequested)try{f=(0,R.createWriteStream)(l,{mode:r}),f.once("close",()=>I()),f.once("error",L),g.once("error",L),g.pipe(f)}catch(E){L(E)}}))}function $(g,s,r,t){let a=(0,c.$th)(()=>Promise.resolve()),i=0;const n=t.onCancellationRequested(()=>{a.cancel(),g.close()});return new Promise((o,l)=>{const f=new c.$Bh,I=L=>{L.isCancellationRequested||(i++,g.readEntry())};g.once("error",l),g.once("close",()=>a.then(()=>{t.isCancellationRequested||g.entryCount===i?o():l(new w("Incomplete",new Error(O.localize(1,null,i,g.entryCount))))},l)),g.readEntry(),g.on("entry",L=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(L.fileName)){I(t);return}const E=L.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(E)){const F=N.$mc(s,E);a=(0,c.$th)(D=>T.Promises.mkdir(F,{recursive:!0}).then(()=>I(D)).then(void 0,l));return}const y=b(g,L),C=S(L);a=(0,c.$th)(F=>f.queue(()=>y.then(D=>u(D,E,C,s,r,F).then(()=>I(F)))).then(null,l))})}).finally(()=>n.dispose())}async function h(g,s=!1){const{open:r}=await new Promise((t,a)=>{ne(["yauzl"],t,a)}).then(ke);return new Promise((t,a)=>{r(g,s?{lazyEntries:!0}:void 0,(i,n)=>{i?a(m(i)):t((0,k.$rg)(n))})})}function b(g,s){return new Promise((r,t)=>{g.openReadStream(s,(a,i)=>{a?t(m(a)):r((0,k.$rg)(i))})})}async function v(g,s){const{ZipFile:r}=await new Promise((t,a)=>{ne(["yazl"],t,a)}).then(ke);return new Promise((t,a)=>{const i=new r;s.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,R.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",a),n.once("error",a),n.once("finish",()=>t(g))})}function d(g,s,r={},t){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let i=h(g,!0);return r.overwrite&&(i=i.then(n=>T.Promises.rm(s).then(()=>n))),i.then(n=>$(n,s,{sourcePathRegex:a},t))}function p(g,s){return h(g).then(r=>new Promise((t,a)=>{r.on("entry",i=>{i.fileName===s&&b(r,i).then(n=>t(n),n=>a(n))}),r.once("close",()=>a(new Error(O.localize(2,null,s))))}))}function P(g,s){return p(g,s).then(r=>new Promise((t,a)=>{const i=[];r.once("error",a),r.on("data",n=>i.push(n)),r.on("end",()=>t(Buffer.concat(i)))}))}}),define(ce[159],le([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[160],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[161],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ce[162],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[163],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[164],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[165],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[166],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[167],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[168],le([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[169],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ce[170],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ce[171],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ce[172],le([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[173],le([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[174],le([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ce[175],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[176],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[177],le([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ce[178],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[179],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[180],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[181],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[182],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[183],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[184],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[185],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[186],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[187],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[188],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[189],le([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ce[190],le([0,1,39,8,161]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var k;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(k||(e.TokenType=k={}));function T(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const O=(0,N.localize)(3,null),A=(0,N.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return m.isTripleEq?"===":"==";case k.NotEq:return m.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return m.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return m.lexeme;case k.QuotedStr:return m.lexeme;case k.Error:return m.lexeme;case k.EOF:return"EOF";default:throw(0,c.$$)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case R.CharCode.OpenParen:this.k(k.LParen);break;case R.CharCode.CloseParen:this.k(k.RParen);break;case R.CharCode.ExclamationMark:if(this.h(R.CharCode.Equals)){const u=this.h(R.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:u})}else this.k(k.Neg);break;case R.CharCode.SingleQuote:this.o();break;case R.CharCode.Slash:this.q();break;case R.CharCode.Equals:if(this.h(R.CharCode.Equals)){const u=this.h(R.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:u})}else this.h(R.CharCode.Tilde)?this.k(k.RegexOp):this.l(T("==","=~"));break;case R.CharCode.LessThan:this.k(this.h(R.CharCode.Equals)?k.LtEq:k.Lt);break;case R.CharCode.GreaterThan:this.k(this.h(R.CharCode.Equals)?k.GtEq:k.Gt);break;case R.CharCode.Ampersand:this.h(R.CharCode.Ampersand)?this.k(k.And):this.l(T("&&"));break;case R.CharCode.Pipe:this.h(R.CharCode.Pipe)?this.k(k.Or):this.l(T("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?R.CharCode.Null:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const u=this.d,$=this.c.substring(this.d,this.e),h={type:k.Error,offset:this.d,lexeme:$};this.g.push({offset:u,lexeme:$,additionalInfo:m}),this.f.push(h)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const u=this.c.substring(this.d,this.e),$=w.b.get(u);$?this.k($):this.f.push({type:k.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==R.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,u=!1,$=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(A);return}const b=this.c.charCodeAt(m);if(u)u=!1;else if(b===R.CharCode.Slash&&!$){m++;break}else b===R.CharCode.OpenSquareBracket?$=!0:b===R.CharCode.Backslash?u=!0:b===R.CharCode.CloseSquareBracket&&($=!1);m++}for(;m<this.c.length&&w.a.has(this.c.charCodeAt(m));)m++;this.e=m;const h=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=w}),define(ce[191],le([0,1,68,88,23,14,37,21,9]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=S,e.$8m=m,e.$5m=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,k.$pc)(N.$1g.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,k.$mc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,O.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,R.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$mc)(this.userDataPath,"logs",$)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$hh)(A.URI.file((0,k.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=T.env.VSCODE_PORTABLE;return $?A.URI.file((0,k.$mc)($,"argv.json")):(0,O.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,k.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,k.$nc)($):(0,k.$kc)((0,k.$mc)(N.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?A.URI.file((0,k.$nc)($)):A.URI.file((0,k.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,k.$nc)($);const h=T.env.VSCODE_EXTENSIONS;if(h)return h;const b=T.env.VSCODE_PORTABLE;return b?(0,k.$mc)(b,"extensions"):(0,O.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(h=>/^[^:/?#]+?:\/\//.test(h)?A.URI.parse(h):A.URI.file((0,k.$kc)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?A.URI.parse($):A.URI.file((0,k.$kc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$5m.test($))}get extensionLogLevel(){const $=[];for(const h of this.args.log||[]){const b=e.$5m.exec(h);b&&b[1]&&b[2]&&$.push([b[1],b[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,O.$hh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=T.env.VSCODE_PORTABLE;return $?A.URI.file((0,k.$mc)($,"policy.json")):(0,O.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,h,b){this.a=$,this.b=h,this.c=b,this.editSessionId=this.args.editSessionId}}e.$6m=w,ve([c.$$h],w.prototype,"appRoot",null),ve([c.$$h],w.prototype,"userHome",null),ve([c.$$h],w.prototype,"userDataPath",null),ve([c.$$h],w.prototype,"appSettingsHome",null),ve([c.$$h],w.prototype,"tmpDir",null),ve([c.$$h],w.prototype,"cacheHome",null),ve([c.$$h],w.prototype,"stateResource",null),ve([c.$$h],w.prototype,"userRoamingDataHome",null),ve([c.$$h],w.prototype,"userDataSyncHome",null),ve([c.$$h],w.prototype,"sync",null),ve([c.$$h],w.prototype,"machineSettingsResource",null),ve([c.$$h],w.prototype,"workspaceStorageHome",null),ve([c.$$h],w.prototype,"localHistoryHome",null),ve([c.$$h],w.prototype,"keyboardLayoutResource",null),ve([c.$$h],w.prototype,"argvResource",null),ve([c.$$h],w.prototype,"isExtensionDevelopment",null),ve([c.$$h],w.prototype,"untitledWorkspacesHome",null),ve([c.$$h],w.prototype,"builtinExtensionsPath",null),ve([c.$$h],w.prototype,"extensionsPath",null),ve([c.$$h],w.prototype,"extensionDevelopmentLocationURI",null),ve([c.$$h],w.prototype,"extensionDevelopmentKind",null),ve([c.$$h],w.prototype,"extensionTestsLocationURI",null),ve([c.$$h],w.prototype,"debugExtensionHost",null),ve([c.$$h],w.prototype,"logLevel",null),ve([c.$$h],w.prototype,"extensionLogLevel",null),ve([c.$$h],w.prototype,"serviceMachineIdResource",null),ve([c.$$h],w.prototype,"disableTelemetry",null),ve([c.$$h],w.prototype,"disableWorkspaceTrust",null),ve([c.$$h],w.prototype,"useInMemorySecretStorage",null),ve([c.$$h],w.prototype,"policyFile",null);function S(u,$){return m(u["inspect-extensions"],u["inspect-brk-extensions"],5870,$,u.debugId,u.extensionEnvironment)}function m(u,$,h,b,v,d){const P=Number($||u)||(b?null:h),g=P?!!$:!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:P,break:g,debugId:v,env:s}}}),function(){"use strict";function ne(e,R,c){function N(T,O){const A=k(T,O),w=[A];return e.isAbsolute(A)||w.unshift(c),e.resolve(...w)}function k(T,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,O);const S=T["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(m,"AppData","Roaming")}break;case"darwin":w=e.join(R.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,O)}return{getUserDataPath:N}}if(typeof define=="function")define(ce[192],le([280,38,37]),function(e,R,c){return ne(e,R,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ne(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[193],le([0,1,38,191,192]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=T,e.$$m=O;class k extends c.$6m{constructor(w,S){super(w,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,N.getUserDataPath)(w,S.nameShort)},S)}}e.$9m=k;function T(A,w){return(0,c.$8m)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,w,A.extensionEnvironment)}function O(A,w){return(0,c.$8m)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,w,A.extensionEnvironment)}}),define(ce[194],le([0,1,13,164]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=N;function N(T,O,A,w){try{k(T,O,A,w)}catch(S){T.error(S?.message??S)}return O}function k(T,O,A,w){const S=(m,u,$)=>{const h=m[u];if((0,R.$gg)(h)){const b=h,v=b.length;if(v>1&&b[0]==="%"&&b[v-1]==="%"){const d=b.substr(1,v-2);let p=A[d];p===void 0&&w&&(p=w[d]);const P=typeof p=="string"?p:p?.message,g=w?.[d],s=typeof g=="string"?g:g?.message;if(!P){s||T.warn(`[${O.name}]: ${(0,c.localize)(0,null,d)}`);return}if($&&(u==="title"||u==="category")&&s&&s!==P){const r={value:P,original:s};m[u]=r}else m[u]=P}}else if((0,R.$ig)(h))for(const b in h)h.hasOwnProperty(b)&&(b==="commands"?S(h,b,!0):S(h,b,$));else if(Array.isArray(h))for(let b=0;b<h.length;b++)S(h,b,$)};for(const m in O)O.hasOwnProperty(m)&&S(O,m)}}),define(ce[195],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=void 0;class R{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k){return this.a.call("promptImportantExtensionsInstallNotification",[k])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Khc=R;class c{constructor(k){this.a=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,O){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${T}`)}}e.$Lhc=c}),define(ce[196],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(ce[74],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class R{constructor(N,k=[],T=!1){this.ctor=N,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.$Di=R}),define(ce[197],le([0,1,74]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=k,e.$Qs=T;const c=[];var N;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function k(O,A,w){A instanceof R.$Di||(A=new R.$Di(A,[],!!w)),c.push([O,A])}function T(){return c}}),define(ce[198],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class R{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$sr=R;class c{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const T of this.a.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const O=this.lookupOrInsertNode(k),A=this.lookupOrInsertNode(T);O.outgoing.set(A.key,A),A.incoming.set(O.key,O)}removeNode(k){const T=this.b(k);this.a.delete(T);for(const O of this.a.values())O.outgoing.delete(T),O.incoming.delete(T)}lookupOrInsertNode(k){const T=this.b(k);let O=this.a.get(T);return O||(O=new R(T,k),this.a.set(T,O)),O}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[T,O]of this.a)k.push(`${T}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this.a){const O=new Set([k]),A=this.c(T,O);if(A)return A}}c(k,T){for(const[O,A]of k.outgoing){if(T.has(O))return[...T,O].join(" -> ");T.add(O);const w=this.c(A,T);if(w)return w;T.delete(O)}}}e.$tr=c}),define(ce[4],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=N,e.$Hi=k;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function O(A){return A[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=O})(R||(e._util=R={})),e.$Fi=N("instantiationService");function c(T,O,A){O[R.DI_TARGET]===O?O[R.DI_DEPENDENCIES].push({id:T,index:A}):(O[R.DI_DEPENDENCIES]=[{id:T,index:A}],O[R.DI_TARGET]=O)}function N(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const O=function(A,w,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(O,A,S)};return O.toString=()=>T,R.serviceIds.set(T,O),O}function k(T){return T}}),define(ce[199],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0,e.$khc=(0,R.$Gi)("checksumService")}),define(ce[22],le([0,1,13,9,4]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=k,e.$cj=T,e.$dj=A,e.$ej=w,e.$fj=S,e.$gj=m,e.$hj=u,e.$ij=h,e.$jj=b,e.$kj=v,R=ke(R),e.$aj=(0,N.$Gi)("configurationService");function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof c.URI)}function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof c.URI)}var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function A(d){switch(d){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function w(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function S(d,p){const P=Object.create(null);for(const g in d)m(P,g,d[g],p);return P}function m(d,p,P,g){const s=p.split("."),r=s.pop();let t=d;for(let a=0;a<s.length;a++){const i=s[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":if(n===null){g(`Ignoring ${p} as ${s.slice(0,a+1).join(".")} is null`);return}break;default:g(`Ignoring ${p} as ${s.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[r]=P}catch{g(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(t)}`)}else g(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(t)}`)}function u(d,p){const P=p.split(".");$(d,P)}function $(d,p){const P=p.shift();if(p.length===0){delete d[P];return}if(Object.keys(d).indexOf(P)!==-1){const g=d[P];typeof g=="object"&&!Array.isArray(g)&&($(g,p),Object.keys(g).length===0&&delete d[P])}}function h(d,p,P){function g(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const s=p.split("."),r=g(d,s);return typeof r>"u"?P:r}function b(d,p,P){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in d?R.$ig(d[g])&&R.$ig(p[g])?b(d[g],p[g],P):P&&(d[g]=p[g]):d[g]=p[g])})}function v(d){return d.replace(/[\[\]]/g,"")}}),define(ce[97],le([0,1,39,5,27,190,4,160,8]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=S,e.$Fj=a,e.$Gj=i,e.$Zj=q;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",c.$j),w.set("isLinux",c.$k),w.set("isWindows",c.$i),w.set("isWeb",c.$o),w.set("isMacNative",c.$j&&!c.$o),w.set("isEdge",c.$H),w.set("isFirefox",c.$F),w.set("isChrome",c.$E),w.set("isSafari",c.$G);function S(G,U){if(w.get(G)!==void 0)throw(0,A.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(G,U)}const m=Object.prototype.hasOwnProperty;var u;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const $={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),b=(0,O.localize)(1,null),v=(0,O.localize)(2,null),d=(0,O.localize)(3,null),p=(0,O.localize)(4,null),P=(0,O.localize)(5,null),g=(0,O.localize)(6,null),s=(0,O.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new k.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const B=this.D(),j=B.type===k.TokenType.Str?P:void 0;throw this.h.push({message:p,offset:B.offset,lexeme:k.$Bj.getLexeme(B),additionalInfo:j}),r.c}return Q}catch(Q){if(Q!==r.c)throw Q;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(k.TokenType.Or);){const Q=this.o();U.push(Q)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(k.TokenType.And);){const Q=this.s();U.push(Q)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(k.TokenType.Neg)){const U=this.D();switch(U.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),l.INSTANCE;case k.TokenType.LParen:{this.z();const Q=this.l();return this.A(k.TokenType.RParen,d),Q?.negate()}case k.TokenType.Str:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case k.TokenType.True:return this.z(),t.true();case k.TokenType.False:return this.z(),t.false();case k.TokenType.LParen:{this.z();const Q=this.l();return this.A(k.TokenType.RParen,d),Q}case k.TokenType.Str:{const Q=U.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==k.TokenType.RegexStr)throw this.B("REGEX",j);const x=j.lexeme,ee=x.lastIndexOf("/"),J=ee===x.length-1?void 0:this.w(x.substring(ee+1));let oe;try{oe=new RegExp(x.substring(1,ee),J)}catch{throw this.B("REGEX",j)}return _.create(Q,oe)}switch(j.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const x=[j.lexeme];this.z();let ee=this.D(),J=0;for(let Ie=0;Ie<j.lexeme.length;Ie++)j.lexeme.charCodeAt(Ie)===R.CharCode.OpenParen?J++:j.lexeme.charCodeAt(Ie)===R.CharCode.CloseParen&&J--;for(;!this.E()&&ee.type!==k.TokenType.And&&ee.type!==k.TokenType.Or;){switch(ee.type){case k.TokenType.LParen:J++;break;case k.TokenType.RParen:J--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Ie=0;Ie<ee.lexeme.length;Ie++)ee.lexeme.charCodeAt(Ie)===R.CharCode.OpenParen?J++:j.lexeme.charCodeAt(Ie)===R.CharCode.CloseParen&&J--}if(J<0)break;x.push(k.$Bj.getLexeme(ee)),this.z(),ee=this.D()}const oe=x.join(""),ue=oe.lastIndexOf("/"),ge=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let pe;try{pe=new RegExp(oe.substring(1,ue),ge)}catch{throw this.B("REGEX",j)}return t.regex(Q,pe)}case k.TokenType.QuotedStr:{const x=j.lexeme;this.z();let ee=null;if(!(0,N.$ef)(x)){const J=x.indexOf("/"),oe=x.lastIndexOf("/");if(J!==oe&&J>=0){const ue=x.slice(J+1,oe),ge=x[oe+1]==="i"?"i":"";try{ee=new RegExp(ue,ge)}catch{throw this.B("REGEX",j)}}}if(ee===null)throw this.B("REGEX",j);return _.create(Q,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,v);const j=this.u();return t.notIn(Q,j)}switch(this.D().type){case k.TokenType.Eq:{this.z();const j=this.u();if(this.x().type===k.TokenType.QuotedStr)return t.equals(Q,j);switch(j){case"true":return t.has(Q);case"false":return t.not(Q);default:return t.equals(Q,j)}}case k.TokenType.NotEq:{this.z();const j=this.u();if(this.x().type===k.TokenType.QuotedStr)return t.notEquals(Q,j);switch(j){case"true":return t.not(Q);case"false":return t.has(Q);default:return t.notEquals(Q,j)}}case k.TokenType.Lt:return this.z(),K.create(Q,this.u());case k.TokenType.LtEq:return this.z(),W.create(Q,this.u());case k.TokenType.Gt:return this.z(),D.create(Q,this.u());case k.TokenType.GtEq:return this.z(),M.create(Q,this.u());case k.TokenType.In:return this.z(),t.in(Q,this.u());default:return t.has(Q)}}case k.TokenType.EOF:throw this.h.push({message:g,offset:U.offset,lexeme:"",additionalInfo:s}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),U.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,Q){if(this.C(U))return this.z();throw this.B(Q,this.D())}B(U,Q,B){const j=(0,O.localize)(8,null,U,k.$Bj.getLexeme(Q)),x=Q.offset,ee=k.$Bj.getLexeme(Q);return this.h.push({message:j,offset:x,lexeme:ee,additionalInfo:B}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Dj=r;class t{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(U){return f.create(U)}static equals(U,Q){return I.create(U,Q)}static notEquals(U,Q){return y.create(U,Q)}static regex(U,Q){return _.create(U,Q)}static in(U,Q){return L.create(U,Q)}static notIn(U,Q){return E.create(U,Q)}static not(U){return C.create(U)}static and(...U){return V.create(U,null,!0)}static or(...U){return z.create(U,null,!0)}static greater(U,Q){return D.create(U,Q)}static greaterEquals(U,Q){return M.create(U,Q)}static smaller(U,Q){return K.create(U,Q)}static smallerEquals(U,Q){return W.create(U,Q)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ej=t;function a(G){const U=new r({regexParsingWithErrorRecovery:!1});return G.map(Q=>(U.parse(Q),U.lexingErrors.length>0?U.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function i(G,U){const Q=G?G.substituteConstants():void 0,B=U?U.substituteConstants():void 0;return!Q&&!B?!0:!Q||!B?!1:Q.equals(B)}function n(G,U){return G.cmp(U)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Hj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.$Ij=l;class f{static create(U,Q=null){const B=w.get(U);return typeof B=="boolean"?B?l.INSTANCE:o.INSTANCE:new f(U,Q)}constructor(U,Q){this.key=U,this.c=Q,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:se(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=w.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:o.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Jj=f;class I{static create(U,Q,B=null){if(typeof Q=="boolean")return Q?f.create(U,B):C.create(U,B);const j=w.get(U);return typeof j=="boolean"?Q===(j?"true":"false")?l.INSTANCE:o.INSTANCE:new I(U,Q,B)}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const Q=U?"true":"false";return this.d===Q?l.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Kj=I;class L{static create(U,Q){return new L(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:he(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const Q=U.getValue(this.f),B=U.getValue(this.d);return Array.isArray(Q)?Q.includes(B):typeof B=="string"&&typeof Q=="object"&&Q!==null?m.call(Q,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Lj=L;class E{static create(U,Q){return new E(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=u.NotIn,this.c=L.create(U,Q)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=E;class y{static create(U,Q,B=null){if(typeof Q=="boolean")return Q?C.create(U,B):f.create(U,B);const j=w.get(U);return typeof j=="boolean"?Q===(j?"true":"false")?o.INSTANCE:l.INSTANCE:new y(U,Q,B)}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const Q=U?"true":"false";return this.d===Q?o.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Nj=y;class C{static create(U,Q=null){const B=w.get(U);return typeof B=="boolean"?B?o.INSTANCE:l.INSTANCE:new C(U,Q)}constructor(U,Q){this.c=U,this.d=Q,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=w.get(this.c);return typeof U=="boolean"?U?o.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Oj=C;function F(G,U){if(typeof G=="string"){const Q=parseFloat(G);isNaN(Q)||(G=Q)}return typeof G=="string"||typeof G=="number"?U(G):o.INSTANCE}class D{static create(U,Q,B=null){return F(Q,j=>new D(U,j,B))}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=D;class M{static create(U,Q,B=null){return F(Q,j=>new M(U,j,B))}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Qj=M;class K{static create(U,Q,B=null){return F(Q,j=>new K(U,j,B))}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Rj=K;class W{static create(U,Q,B=null){return F(Q,j=>new W(U,j,B))}constructor(U,Q,B){this.c=U,this.d=Q,this.f=B,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Sj=W;class _{static create(U,Q){return new _(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const Q=this.f?this.f.source:"",B=U.f?U.f.source:"";return Q<B?-1:Q>B?1:0}equals(U){if(U.type===this.type){const Q=this.f?this.f.source:"",B=U.f?U.f.source:"";return this.d===U.d&&Q===B}return!1}substituteConstants(){return this}evaluate(U){const Q=U.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Tj=_;class H{static create(U){return new H(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new H(this.c.map(U))}negate(){return this.c}}e.$Uj=H;function ie(G){let U=null;for(let Q=0,B=G.length;Q<B;Q++){const j=G[Q].substituteConstants();if(G[Q]!==j&&U===null){U=[];for(let x=0;x<Q;x++)U[x]=G[x]}U!==null&&(U[Q]=j)}return U===null?G:U}class V{static create(U,Q,B){return V.d(U,Q,B)}constructor(U,Q){this.expr=U,this.c=Q,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Q=0,B=this.expr.length;Q<B;Q++){const j=n(this.expr[Q],U.expr[Q]);if(j!==0)return j}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Q=0,B=this.expr.length;Q<B;Q++)if(!this.expr[Q].equals(U.expr[Q]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:V.create(U,this.c,!1)}evaluate(U){for(let Q=0,B=this.expr.length;Q<B;Q++)if(!this.expr[Q].evaluate(U))return!1;return!0}static d(U,Q,B){const j=[];let x=!1;for(const ee of U)if(ee){if(ee.type===u.True){x=!0;continue}if(ee.type===u.False)return o.INSTANCE;if(ee.type===u.And){j.push(...ee.expr);continue}j.push(ee)}if(j.length===0&&x)return l.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(n);for(let ee=1;ee<j.length;ee++)j[ee-1].equals(j[ee])&&(j.splice(ee,1),ee--);if(j.length===1)return j[0];for(;j.length>1;){const ee=j[j.length-1];if(ee.type!==u.Or)break;j.pop();const J=j.pop(),oe=j.length===0,ue=z.create(ee.expr.map(ge=>V.create([ge,J],null,B)),null,oe);ue&&(j.push(ue),j.sort(n))}if(j.length===1)return j[0];if(B){for(let ee=0;ee<j.length;ee++)for(let J=ee+1;J<j.length;J++)if(j[ee].negate().equals(j[J]))return o.INSTANCE;if(j.length===1)return j[0]}return new V(j,Q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const Q of this.expr)U.push(...Q.keys());return U}map(U){return new V(this.expr.map(Q=>Q.map(U)),null)}negate(){if(!this.c){const U=[];for(const Q of this.expr)U.push(Q.negate());this.c=z.create(U,this,!0)}return this.c}}e.$Vj=V;class z{static create(U,Q,B){return z.d(U,Q,B)}constructor(U,Q){this.expr=U,this.c=Q,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Q=0,B=this.expr.length;Q<B;Q++){const j=n(this.expr[Q],U.expr[Q]);if(j!==0)return j}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Q=0,B=this.expr.length;Q<B;Q++)if(!this.expr[Q].equals(U.expr[Q]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:z.create(U,this.c,!1)}evaluate(U){for(let Q=0,B=this.expr.length;Q<B;Q++)if(this.expr[Q].evaluate(U))return!0;return!1}static d(U,Q,B){let j=[],x=!1;if(U){for(let ee=0,J=U.length;ee<J;ee++){const oe=U[ee];if(oe){if(oe.type===u.False){x=!0;continue}if(oe.type===u.True)return l.INSTANCE;if(oe.type===u.Or){j=j.concat(oe.expr);continue}j.push(oe)}}if(j.length===0&&x)return o.INSTANCE;j.sort(n)}if(j.length!==0){if(j.length===1)return j[0];for(let ee=1;ee<j.length;ee++)j[ee-1].equals(j[ee])&&(j.splice(ee,1),ee--);if(j.length===1)return j[0];if(B){for(let ee=0;ee<j.length;ee++)for(let J=ee+1;J<j.length;J++)if(j[ee].negate().equals(j[J]))return l.INSTANCE;if(j.length===1)return j[0]}return new z(j,Q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const Q of this.expr)U.push(...Q.keys());return U}map(U){return new z(this.expr.map(Q=>Q.map(U)),null)}negate(){if(!this.c){const U=[];for(const Q of this.expr)U.push(Q.negate());for(;U.length>1;){const Q=U.shift(),B=U.shift(),j=[];for(const x of X(Q))for(const ee of X(B))j.push(V.create([x,ee],null,!1));U.unshift(z.create(j,null,!1))}this.c=z.create(U,this,!0)}return this.c}}e.$Wj=z;class te extends f{static{this.d=[]}static all(){return te.d.values()}constructor(U,Q,B){super(U,null),this.f=Q,typeof B=="object"?te.d.push({...B,key:U}):B!==!0&&te.d.push({key:U,description:B,type:Q!=null?typeof Q:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return I.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Xj=te,e.$Yj=(0,T.$Gi)("contextKeyService");function se(G,U){return G<U?-1:G>U?1:0}function he(G,U,Q,B){return G<Q?-1:G>Q?1:U<B?-1:U>B?1:0}function q(G,U){if(G.type===u.False||U.type===u.True)return!0;if(G.type===u.Or)return U.type===u.Or?Z(G.expr,U.expr):!1;if(U.type===u.Or){for(const Q of U.expr)if(q(G,Q))return!0;return!1}if(G.type===u.And){if(U.type===u.And)return Z(U.expr,G.expr);for(const Q of G.expr)if(q(Q,U))return!0;return!1}return G.equals(U)}function Z(G,U){let Q=0,B=0;for(;Q<G.length&&B<U.length;){const j=G[Q].cmp(U[B]);if(j<0)return!1;j===0&&Q++,B++}return Q===G.length}function X(G){return G.type===u.Or?G.expr:[G]}}),define(ce[98],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=c,e.ID="diagnosticsService",e.$Tm=(0,R.$Gi)(e.ID);function c(k){return!!k.hostName&&!!k.errorMessage}class N{async getPerformanceInfo(T,O){return{}}async getSystemInfo(T,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,O){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Vm=N}),define(ce[99],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0,e.$Zo=(0,R.$Gi)("downloadService")}),define(ce[16],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,R.$Gi)("environmentService"),e.$Oi=(0,R.$Hi)(e.$Ni)}),define(ce[75],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$I6b=N;var c;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function N(T){switch(T){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k||(e.RecommendationsNotificationResult=k={})),e.$J6b=(0,R.$Gi)("IExtensionRecommendationNotificationService")}),define(ce[7],le([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=u,e.$cl=v,e.$dl=p,e.$el=P,e.$fl=g,e.$gl=s,e.$hl=r,e.$il=t,e.$jl=a,e.$kl=i,e.$ll=n,e.$nl=f,e.$ol=I,e.$pl=L,e.$ql=E,e.$rl=y,e.$ul=K,e.$Gl=z,e.$Hl=te,e.$Jl=he,e.$al=(0,A.$Gi)("fileService");function u(q){return q.create===!0}var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var h;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var b;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(b||(e.FileChangeFilter=b={}));function v(q){const Z=q;return!!Z&&typeof Z.onDidChange=="function"}var d;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function p(q){return!!(q.capabilities&d.FileReadWrite)}function P(q){return!!(q.capabilities&d.FileFolderCopy)}function g(q){return!!(q.capabilities&d.FileClone)}function s(q){return!!(q.capabilities&d.FileOpenReadWriteClose)}function r(q){return!!(q.capabilities&d.FileReadStream)}function t(q){return p(q)?!!(q.capabilities&d.FileAtomicRead):!1}function a(q){return p(q)?!!(q.capabilities&d.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&d.FileAtomicDelete)}function n(q){return!!(q.capabilities&d.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class l extends Error{static create(Z,X){const G=new l(Z.toString(),X);return L(G,X),G}constructor(Z,X){super(Z),this.code=X}}e.$ml=l;function f(q,Z){return l.create(q,Z)}function I(q){return q||f((0,O.localize)(0,null),o.Unknown)}function L(q,Z){return q.name=Z?`${Z} (FileSystemError)`:"FileSystemError",q}function E(q){if(!q)return o.Unknown;if(q instanceof l)return q.code;const Z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Z)return o.Unknown;switch(Z[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function y(q){if(q instanceof W)return q.fileOperationResult;switch(E(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var C;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class F{constructor(Z,X,G){this.resource=Z,this.operation=X,this.target=G}isOperation(Z){return this.operation===Z}}e.$sl=F;var D;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class M{static{this.a=null}constructor(Z,X){this.c=X,this.b=void 0,this.d=new m.$X(()=>{const G=R.$Mi.forUris(()=>this.c);return G.fill(this.rawAdded.map(U=>[U,!0])),G}),this.f=new m.$X(()=>{const G=R.$Mi.forUris(()=>this.c);return G.fill(this.rawUpdated.map(U=>[U,!0])),G}),this.g=new m.$X(()=>{const G=R.$Mi.forUris(()=>this.c);return G.fill(this.rawDeleted.map(U=>[U,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of Z){switch(G.type){case D.ADDED:this.rawAdded.push(G.resource);break;case D.UPDATED:this.rawUpdated.push(G.resource);break;case D.DELETED:this.rawDeleted.push(G.resource);break}this.b!==M.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Z,...X){return this.h(Z,{includeChildren:!1},...X)}affects(Z,...X){return this.h(Z,{includeChildren:!0},...X)}h(Z,X,...G){if(!Z)return!1;const U=G.length>0;return!!((!U||G.includes(D.ADDED))&&(this.d.value.get(Z)||X.includeChildren&&this.d.value.findSuperstr(Z))||(!U||G.includes(D.UPDATED))&&(this.f.value.get(Z)||X.includeChildren&&this.f.value.findSuperstr(Z))||(!U||G.includes(D.DELETED))&&(this.g.value.findSubstr(Z)||X.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$tl=M;function K(q,Z,X){return!q||!Z||q===Z||Z.length>q.length?!1:(Z.charAt(Z.length-1)!==c.sep&&(Z+=c.sep),X?(0,N.$If)(q,Z):q.indexOf(Z)===0)}class W extends Error{constructor(Z,X,G){super(Z),this.fileOperationResult=X,this.options=G}}e.$vl=W;class _ extends W{constructor(Z,X,G,U){super(Z,X,U),this.fileOperationResult=X,this.size=G}}e.$wl=_;class H extends W{constructor(Z,X,G){super(Z,ie.FILE_NOT_MODIFIED_SINCE,G),this.stat=X}}e.$xl=H;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Fl="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function te(q,Z){if(!Z.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(X=>{const G=Z.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===q.scheme&&U.added&&(G.dispose(),X())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(Z){return(0,k.$kg)(Z)||(Z=0),Z<se.KB?(0,O.localize)(1,null,Z.toFixed(0)):Z<se.MB?(0,O.localize)(2,null,(Z/se.KB).toFixed(2)):Z<se.GB?(0,O.localize)(3,null,(Z/se.MB).toFixed(2)):Z<se.TB?(0,O.localize)(4,null,(Z/se.GB).toFixed(2)):(0,O.localize)(5,null,(Z/se.TB).toFixed(2))}}e.$Il=se;function he(q){const Z=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*se.MB:Z?10*se.MB:w.$o?50*se.MB:1024*se.MB}});var Y=this&&this.__param||function(ne,e){return function(R,c){e(R,c,ne)}};define(ce[200],le([0,1,76,51,7]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let k=class{constructor(O){this.a=O}async checksum(O){const A=(await this.a.readFileStream(O)).value;return new Promise((w,S)=>{const m=(0,R.createHash)("sha256");(0,c.$He)(A,{onData:u=>m.update(u.buffer),onError:u=>S(u),onEnd:()=>w(m.digest("base64").replace(/=+$/,""))})})}};e.$lhc=k,e.$lhc=k=ve([Y(0,N.$al)],k)}),define(ce[100],le([0,1,15,8,171,7]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=T;async function T(S,m,u,$,h,b){let v;try{await O(S,m,u,$,h,b)}catch(d){v=d}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v<"u"&&u.error(v),u.end()}}async function O(S,m,u,$,h,b){A(b);const v=await S.open(m,{create:!1});try{A(b);let d=0,p=0,P=h&&typeof h.length=="number"?h.length:void 0,g=R.$Pe.alloc(Math.min(h.bufferSize,typeof P=="number"?P:h.bufferSize)),s=h&&typeof h.position=="number"?h.position:0,r=0;do p=await S.read(v,s,g.buffer,r,g.byteLength-r),s+=p,r+=p,d+=p,typeof P=="number"&&(P-=p),r===g.byteLength&&(await u.write($(g)),g=R.$Pe.alloc(Math.min(h.bufferSize,typeof P=="number"?P:h.bufferSize)),r=0);while(p>0&&(typeof P!="number"||P>0)&&A(b)&&w(d,h));if(r>0){let t=r;typeof P=="number"&&(t=Math.min(r,P)),u.write($(g.slice(0,t)))}}catch(d){throw(0,k.$ol)(d)}finally{await S.close(v)}}function A(S){if(S.isCancellationRequested)throw(0,c.$9)();return!0}function w(S,m){if(typeof m?.limits?.size=="number"&&S>m.limits.size)throw(0,k.$nl)((0,N.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[47],le([0,1,94,2,14,5,9,7]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=A,e.$3q=w,e.$7q=$,e.$8q=h,e.$9q=b,e.$0q=v,e.$$q=p,e.$_q=P;function A(g){return typeof g.correlationId=="number"}function w(g){return g.recursive===!0}class S extends c.$Xc{static{this.a=5}constructor(s,r,t,a){super(),this.h=s,this.j=r,this.m=t,this.n=a,this.c=this.B(new c.$Yc),this.f=void 0,this.g=0}s(){const s=new c.$Wc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(r=>this.h(r))),s.add(this.b.onDidLogMessage(r=>this.j(r))),s.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(s,r){this.u(s,r)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,r){return!(!this.n.restartOnError||r||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=S;class m extends S{constructor(s,r,t){super(s,r,t,{type:"node.js",restartOnError:!1})}}e.$5q=m;class u extends S{constructor(s,r,t){super(s,r,t,{type:"universal",restartOnError:!0})}}e.$6q=u;function $(g){return g.map(s=>({type:s.type,resource:T.URI.revive(s.resource),cId:s.cId}))}function h(g){const s=new d;for(const r of g)s.processEvent(r);return s.coalesce()}function b(g,s){return typeof s=="string"&&!s.startsWith(R.$wk)&&!(0,N.$lc)(s)?{base:g,pattern:s}:s}function v(g,s){const r=[];for(const t of s)r.push((0,R.$Ak)(b(g,t)));return r}class d{constructor(){this.a=new Set,this.b=new Map}c(s){return k.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const r=this.b.get(this.c(s));let t=!1;if(r){const a=r.type,i=s.type;r.resource.fsPath!==s.resource.fsPath&&(s.type===O.FileChangeType.DELETED||s.type===O.FileChangeType.ADDED)?t=!0:a===O.FileChangeType.ADDED&&i===O.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(r)):a===O.FileChangeType.DELETED&&i===O.FileChangeType.ADDED?r.type=O.FileChangeType.UPDATED:a===O.FileChangeType.ADDED&&i===O.FileChangeType.UPDATED||(r.type=i)}else t=!0;t&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],r=[];return Array.from(this.a).filter(t=>t.type!==O.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,a)=>t.resource.fsPath.length-a.resource.fsPath.length).filter(t=>r.some(a=>(0,O.$ul)(t.resource.fsPath,a,!k.$k))?!1:(r.push(t.resource.fsPath),!0)).concat(s)}}function p(g,s){if(typeof s=="number")switch(g.type){case O.FileChangeType.ADDED:return(s&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(s&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(s&O.FileChangeFilter.UPDATED)===0}return!1}function P(g){if(typeof g=="number"){const s=[];return g&O.FileChangeFilter.ADDED&&s.push("Added"),g&O.FileChangeFilter.DELETED&&s.push("Deleted"),g&O.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(ce[201],le([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class m extends T.$Xc{constructor($,h){super(),this.a=$,this.b=h,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$ne),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$ne),this.onDidWatchError=this.g.event,this.h=(0,A.$3g)(),this.j()}get capabilities(){return this.c||(this.c=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=w.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=w.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,h){const{buffer:b}=await this.a.call("readFile",[$,h]);return b}readFileStream($,h,b){const v=(0,O.$De)(p=>R.$Pe.concat(p.map(P=>R.$Pe.wrap(P))).buffer),d=new T.$Wc;return d.add(this.a.listen("readFileStream",[$,h])(p=>{if(p instanceof R.$Pe)v.write(p.buffer);else{if(p==="end")v.end();else{let P;if(p instanceof Error)P=p;else{const g=p;P=(0,w.$nl)(g.message??(0,c.$rj)(g),g.code??w.FileSystemProviderErrorCode.Unknown)}v.error(P),v.end()}d.dispose()}})),d.add(b.onCancellationRequested(()=>{v.error((0,N.$9)()),v.end(),d.dispose()})),v}writeFile($,h,b){return this.a.call("writeFile",[$,R.$Pe.wrap(h),b])}open($,h){return this.a.call("open",[$,h])}close($){return this.a.call("close",[$])}async read($,h,b,v,d){const[p,P]=await this.a.call("read",[$,h,d]);return b.set(p.buffer.slice(0,P),v),P}write($,h,b,v,d){return this.a.call("write",[$,h,R.$Pe.wrap(b),v,d])}mkdir($){return this.a.call("mkdir",[$])}delete($,h){return this.a.call("delete",[$,h])}rename($,h,b){return this.a.call("rename",[$,h,b])}copy($,h,b){return this.a.call("copy",[$,h,b])}cloneFile($,h){return this.a.call("cloneFile",[$,h])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const h=$;this.f.fire((0,S.$7q)(h))}else{const h=$;this.g.fire(h)}}))}watch($,h){const b=(0,A.$3g)();return this.a.call("watch",[this.h,b,$,h]),(0,T.$Vc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$0Q=m}),define(ce[202],le([0,1,46,2,47,3,7,9,6]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class w extends c.$Xc{constructor(){super(),this.a=this.B(new k.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$7c),this.m=new Set,this.n=this.B(new A.$Eh(this.y())),this.r=5007,this.s=new A.$4h,this.R=!1,this.B(this.f(m=>this.t(m)))}t(m){this.u(m)&&this.z(m)}u(m){return(0,N.$2q)(m)}async watch(m){this.s.isSettled||this.s.complete(),this.s=new A.$4h;try{this.h.clear(),this.g.clear();for(const u of m)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(m){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),m?this.y():0)}y(){return 800}isSuspended(m){return typeof m.correlationId!="number"?!1:this.m.has(m.correlationId)?"polling":this.j.has(m.correlationId)}async z(m){if(this.j.has(m.correlationId))return;const u=new c.$Wc;this.j.set(m.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(m,u),this.w(!0))}C(m){this.j.deleteAndDispose(m.correlationId),this.m.delete(m.correlationId),this.w(!1)}D(m,u){this.F(m,u)?(this.P(`reusing an existing recursive watcher to monitor ${m.path}`),this.m.delete(m.correlationId)):(this.G(m,u),this.m.add(m.correlationId))}F(m,u){const $=this.O?.subscribe(m.path,(h,b)=>{u.isDisposed||(h?this.D(m,u):b?.type===T.FileChangeType.ADDED&&this.H(m))});return $?(u.add($),!0):!1}G(m,u){let $=!1;const h=(b,v)=>{if(u.isDisposed)return;const d=this.I(b),p=this.I(v),P=$;$=d,!d&&(p||P)&&this.H(m)};this.P(`starting fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,R.watchFile)(m.path,{persistent:!1,interval:this.r},h)}catch(b){this.Q(`fs.watchFile() failed with error ${b} on path ${m.path} (correlationId: ${m.correlationId})`)}u.add((0,c.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,R.unwatchFile)(m.path,h)}catch(b){this.Q(`fs.unwatchFile() failed with error ${b} on path ${m.path} (correlationId: ${m.correlationId})`)}}))}H(m){this.P(`detected ${m.path} exists again, resuming watcher (correlationId: ${m.correlationId})`);const u={resource:O.URI.file(m.path),type:T.FileChangeType.ADDED,cId:m.correlationId};this.a.fire([u]),this.J(u,m),this.C(m)}I(m){return m.ctimeMs===0&&m.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(m,u){if(this.R){const $=` >> normalized ${m.type===T.FileChangeType.ADDED?"[ADDED]":m.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`;this.L($,u)}}L(m,u){this.R&&this.P(`${m}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(m){return`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, filter: ${(0,N.$_q)(m.filter)}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`}async setVerboseLogging(m){this.R=m}}e.$ir=w}),define(ce[203],le([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=d;class v extends T.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,g,s,r,t,a){super(),this.s=P,this.t=g,this.u=s,this.w=r,this.y=t,this.z=a,this.c=this.B(new c.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new c.$Uh(i=>this.M(i),v.b)),this.g=(0,b.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,b.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,b.$2q)(this.s)?this.s.filter:void 0,this.m=new N.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const g=await $.Promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,g.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let g=P.path;try{g=await $.Promises.realpath(P.path),P.path===g&&(g=await(0,u.$kr)(P.path,this.m.token)??P.path),P.path!==g&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${g})`)}catch{}return g}async G(P,g){const s=new T.$Wc;return this.H(P,g,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,g,s)),s}H(P,g,s){if(g)return!1;const r=m.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(a,i)=>{if(!s.isDisposed)if(a){const n=await this.G(P,g);s.isDisposed?n.dispose():s.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:i.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(P,g,s){if(w.$j&&(0,k.$Fg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new N.$ye(this.m.token);s.add((0,T.$Vc)(()=>r.dispose(!0)));const t=new T.$Wc;s.add(t);try{const a=m.URI.file(this.s.path),i=(0,A.$qc)(P),n=(0,R.watch)(P);t.add((0,T.$Vc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${P}'`);const o=new Set;if(g)try{for(const f of await $.Promises.readdir(P))o.add(f)}catch(f){this.O(f)}if(r.token.isCancellationRequested)return;const l=new Map;t.add((0,T.$Vc)(()=>{for(const[,f]of l)f.dispose();l.clear()})),n.on("error",(f,I)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${f}, ${I})`),this.D())}),n.on("change",(f,I)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${I}`);let L="";if(I&&(L=I.toString(),w.$j&&(L=(0,O.$nm)(L))),!(!L||f!=="change"&&f!=="rename"))if(g)if(f==="rename"){l.get(L)?.dispose();const E=setTimeout(async()=>{if(l.delete(L),L===i&&!await $.Promises.exists(P)){this.J(a);return}if(r.token.isCancellationRequested)return;const y=await this.N((0,A.$mc)(P,L));if(r.token.isCancellationRequested)return;let C;y?o.has(L)?C=h.FileChangeType.UPDATED:(C=h.FileChangeType.ADDED,o.add(L)):(o.delete(L),C=h.FileChangeType.DELETED),this.L({resource:(0,S.$hh)(a,L),type:C,cId:this.s.correlationId})},v.a);l.set(L,(0,T.$Vc)(()=>clearTimeout(E)))}else{let E;o.has(L)?E=h.FileChangeType.UPDATED:(E=h.FileChangeType.ADDED,o.add(L)),this.L({resource:(0,S.$hh)(a,L),type:E,cId:this.s.correlationId})}else if(f==="rename"||L!==i){const E=setTimeout(async()=>{const y=await $.Promises.exists(P);r.token.isCancellationRequested||(y?(this.L({resource:a,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(P,!1))):this.J(a))},v.a);t.clear(),t.add((0,T.$Vc)(()=>clearTimeout(E)))}else this.L({resource:a,type:h.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(a){r.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${a.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:h.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,g=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===h.FileChangeType.ADDED?"[ADDED]":P.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!g&&this.g.some(s=>s(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(s=>s(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const g=(0,b.$8q)(P),s=[];for(const t of g){if((0,b.$$q)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.R(` >> normalized ${t.type===h.FileChangeType.ADDED?"[ADDED]":t.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(w.$k)return $.Promises.exists(P);try{const g=(0,A.$qc)(P);return(await $.Promises.readdir((0,A.$pc)(P))).some(r=>r===g)}catch(g){return this.Q(g),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=v;async function d(p,P,g,s,r=512){const t=await $.Promises.open(p,"r"),a=Buffer.allocUnsafe(r),i=new N.$ye(s);let n,o=!1;const l={path:p,excludes:[],recursive:!1},f=new v(l,void 0,I=>{(async()=>{for(const{type:L}of I)if(L===h.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(t,a,0,r,null);if(!E||i.token.isCancellationRequested)break;P(a.slice(0,E))}}catch(E){n=new Error(E),i.dispose(!0)}finally{o=!1}}})()});return await f.ready,g(),new Promise((I,L)=>{i.token.onCancellationRequested(async()=>{f.dispose();try{await $.Promises.close(t)}catch(E){n=new Error(E)}n?L(n):I()})})}}),define(ce[204],le([0,1,3,94,202,5,203,42]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class A extends N.$ir{constructor(S){super(),this.O=S,this.onDidError=R.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const m=[],u=new Set(Array.from(this.watchers));for(const $ of S){const h=this.W($);h&&(0,c.$Ek)(h.request.excludes,$.excludes)&&(0,c.$Ek)(h.request.includes,$.includes)?u.delete(h):m.push($)}m.length&&this.P(`Request to start watching: ${m.map($=>this.M($)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map($=>this.M($.request)).join(",")}`);for(const $ of u)this.Y($);for(const $ of m)this.X($)}W(S){for(const m of this.watchers)if(typeof S.correlationId=="number"||typeof m.request.correlationId=="number"){if(m.request.correlationId===S.correlationId)return m}else if((0,O.$Eg)(m.request.path,S.path,!k.$k))return m}X(S){const m=new T.$nr(S,this.O,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.R),u={request:S,instance:m};this.watchers.add(u)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const m=new Map;for(const u of S){const $=k.$k?u.path:u.path.toLowerCase();let h=m.get(u.correlationId);h||(h=new Map,m.set(u.correlationId,h)),h.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),h.set($,u)}return Array.from(m.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const m of this.watchers)m.instance.setVerboseLogging(S)}P(S,m){this.R&&this.b.fire({type:"trace",message:this.bb(S,m)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,m){return m?`[File Watcher (node.js)] ${S} (${this.M(m.request)})`:`[File Watcher (node.js)] ${S}`}}e.$pr=A}),define(ce[205],le([0,1,47,204]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class N extends R.$5q{constructor(T,O,A){super(T,O,A),this.s()}r(T){return T.add(new c.$pr(void 0))}}e.$qr=N}),define(ce[206],le([0,1,23,43,96,47]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class T extends k.$6q{constructor(A,w,S){super(A,w,S),this.s()}r(A){const w=A.add(new N.$gr(R.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(w.onDidProcessExit(({code:S,signal:m})=>this.t(`terminated by itself with code ${S}, signal: ${m} (ETERM)`))),c.ProxyChannel.toService((0,c.$ni)(w.getChannel("watcher")))}}e.$hr=T}),define(ce[77],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class R{constructor(...N){this.a=new Map;for(const[k,T]of N)this.set(k,T)}set(N,k){const T=this.a.get(N);return this.a.set(N,k),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Ei=R}),define(ce[207],le([0,1,6,8,2,74,198,4,77,90]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const S=!1;class m extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class u{constructor(v=new A.$Ei,d=!1,p,P=S){this.i=v,this.j=d,this.k=p,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Fi,this),this._globalGraph=P?p?._globalGraph??new T.$tr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Sc)(this.h),this.h.clear();for(const v of this.g)(0,N.$Rc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,d){this.m();const p=this,P=new class extends u{dispose(){p.h.delete(P),super.dispose()}}(v,this.j,this,this.l);return this.h.add(P),d?.add(P),P}invokeFunction(v,...d){this.m();const p=h.traceInvocation(this.l,v);let P=!1;try{return v({get:s=>{if(P)throw(0,c.$$)("service accessor is only valid during the invocation of its target method");const r=this.s(s,p);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...d)}finally{P=!0,p.stop()}}createInstance(v,...d){this.m();let p,P;return v instanceof k.$Di?(p=h.traceCreation(this.l,v.ctor),P=this.o(v.ctor,v.staticArguments.concat(d),p)):(p=h.traceCreation(this.l,v),P=this.o(v,d,p)),p.stop(),P}o(v,d=[],p){const P=O._util.getServiceDependencies(v).sort((r,t)=>r.index-t.index),g=[];for(const r of P){const t=this.s(r.id,p);t||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${r.id}.`,!1),g.push(t)}const s=P.length>0?P[0].index:d.length;if(d.length!==s){console.trace(`[createInstance] First service dependency of ${v.name} at position ${s+1} conflicts with ${d.length} static arguments`);const r=s-d.length;r>0?d=d.concat(new Array(r)):d=d.slice(0,s)}return Reflect.construct(v,d.concat(g))}q(v,d){if(this.i.get(v)instanceof k.$Di)this.i.set(v,d);else if(this.k)this.k.q(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const d=this.i.get(v);return!d&&this.k?this.k.r(v):d}s(v,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const p=this.r(v);return p instanceof k.$Di?this.u(v,p,d.branch(v,!0)):(d.branch(v,!1),p)}u(v,d,p){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,d,p)}finally{this.t.delete(v)}}v(v,d,p){const P=new T.$tr(r=>r.id.toString());let g=0;const s=[{id:v,desc:d,_trace:p}];for(;s.length;){const r=s.pop();if(P.lookupOrInsertNode(r),g++>1e3)throw new m(P);for(const t of O._util.getServiceDependencies(r.desc.ctor)){const a=this.r(t.id);if(a||this.y(`[createInstance] ${v} depends on ${t.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(t.id)),a instanceof k.$Di){const i={id:t.id,desc:a,_trace:r._trace.branch(t.id,!0)};P.insertEdge(r,i),s.push(i)}}}for(;;){const r=P.roots();if(r.length===0){if(!P.isEmpty())throw new m(P);break}for(const{data:t}of r){if(this.r(t.id)instanceof k.$Di){const i=this.w(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this.q(t.id,i)}P.removeNode(t)}}return this.r(v)}w(v,d,p=[],P,g){if(this.i.get(v)instanceof k.$Di)return this.x(v,d,p,P,g,this.g);if(this.k)return this.k.w(v,d,p,P,g);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(v,d,p=[],P,g,s){if(P){const r=new u(void 0,this.j,this,this.l);r.c=String(v);const t=new Map,a=new R.$Zh(()=>{const i=r.o(d,p,g);for(const[n,o]of t){const l=i[n];if(typeof l=="function")for(const f of o)f.disposable=l.apply(i,f.listener)}return t.clear(),s.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let f=t.get(n);return f||(f=new w.$8c,t.set(n,f)),(L,E,y)=>{if(a.isInitialized)return a.value[n](L,E,y);{const C={listener:[L,E,y],disposable:void 0},F=f.push(C);return(0,N.$Vc)(()=>{F(),C.disposable?.dispose()})}}}if(n in i)return i[n];const o=a.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return a.value[n]=o,!0},getPrototypeOf(i){return d.prototype}})}else{const r=this.o(d,p,g);return s.add(r),r}}y(v,d){if(d&&console.warn(v),this.j)throw new Error(v)}}e.$ur=u;var $;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})($||($={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,d){return v?new h($.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(v,d){return v?new h($.Creation,d.name):h.c}static{this.f=0}constructor(v,d){this.type=v,this.name=d,this.g=Date.now(),this.h=[]}branch(v,d){const p=new h($.Branch,v.toString());return this.h.push([v,d,p]),p}stop(){const v=Date.now()-this.g;h.f+=v;let d=!1;function p(g,s){const r=[],t=new Array(g+1).join("	");for(const[a,i,n]of s.h)if(i&&n){d=!0,r.push(`${t}CREATES -> ${a}`);const o=p(g+1,n);o&&r.push(o)}else r.push(`${t}uses -> ${a}`);return r.join(`
`)}const P=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(v>2||d)&&h.all.add(P.join(`
`))}}e.$vr=h}),define(ce[57],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,R.$Gi)("mainProcessService");class c{constructor(k,T){this.a=k,this.b=T}getChannel(k){return this.a.getChannel(k,this.b)}registerChannel(k,T){this.a.registerChannel(k,T)}}e.$2gc=c}),define(ce[10],le([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=b,e.log=d,e.$ok=l,e.$pk=f,e.$qk=I,e.$rk=L,R=ke(R),e.$ak=(0,$.$Gi)("logService"),e.$bk=(0,$.$Gi)("loggerService");function h(){return new Date().toISOString()}function b(E){return(0,S.$kg)(E)}var v;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$dk=v.Info;function d(E,y,C){switch(y){case v.Trace:E.trace(C);break;case v.Debug:E.debug(C);break;case v.Info:E.info(C);break;case v.Warning:E.warn(C);break;case v.Error:E.error(C);break;case v.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function p(E,y=!1){let C="";for(let F=0;F<E.length;F++){let D=E[F];if(D instanceof Error&&(D=(0,c.$rj)(D,y)),typeof D=="object")try{D=JSON.stringify(D)}catch{}C+=(F>0?" ":"")+D}return C}class P extends T.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new N.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==v.Off&&this.b<=y}}e.$fk=P;class g extends P{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...C){this.f(v.Trace)&&this.g(v.Trace,p([y,...C],!0))}debug(y,...C){this.f(v.Debug)&&this.g(v.Debug,p([y,...C]))}info(y,...C){this.f(v.Info)&&this.g(v.Info,p([y,...C]))}warn(y,...C){this.f(v.Warning)&&this.g(v.Warning,p([y,...C]))}error(y,...C){if(this.f(v.Error))if(y instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=y.stack,this.g(v.Error,p(F))}else this.g(v.Error,p([y,...C]))}flush(){}}e.$gk=g;class s extends P{constructor(y=e.$dk){super(),this.setLevel(y),this.g=!A.$i}trace(y,...C){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...C):console.log(`[main ${h()}]`,y,...C))}debug(y,...C){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...C):console.log(`[main ${h()}]`,y,...C))}info(y,...C){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...C):console.log(`[main ${h()}]`,y,...C))}warn(y,...C){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,y,...C):console.warn(`[main ${h()}]`,y,...C))}error(y,...C){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,y,...C):console.error(`[main ${h()}]`,y,...C))}flush(){}}e.$hk=s;class r extends P{constructor(y=e.$dk,C=!0){super(),this.g=C,this.setLevel(y)}trace(y,...C){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...C):console.log(y,...C))}debug(y,...C){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...C):console.log(y,...C))}info(y,...C){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...C):console.log(y,...C))}warn(y,...C){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...C):console.log(y,...C))}error(y,...C){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...C):console.error(y,...C))}flush(){}}e.$ik=r;class t extends P{constructor(y,C=e.$dk){super(),this.g=y,this.setLevel(C)}trace(y,...C){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(y),...C])}debug(y,...C){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(y),...C])}info(y,...C){this.f(v.Info)&&this.g.log(v.Info,[this.h(y),...C])}warn(y,...C){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(y),...C])}error(y,...C){this.f(v.Error)&&this.g.log(v.Error,[this.h(y),...C])}h(y){return typeof y=="string"?y:(0,c.$rj)(y,this.f(v.Trace))}flush(){}}e.$jk=t;class a extends P{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const C of this.g)C.setLevel(y);super.setLevel(y)}trace(y,...C){for(const F of this.g)F.trace(y,...C)}debug(y,...C){for(const F of this.g)F.debug(y,...C)}info(y,...C){for(const F of this.g)F.info(y,...C)}warn(y,...C){for(const F of this.g)F.warn(y,...C)}error(y,...C){for(const F of this.g)F.error(y,...C)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$kk=a;class i extends T.$Xc{constructor(y,C,F){if(super(),this.h=y,this.j=C,this.b=new O.$Dc,this.c=this.B(new N.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$ne),this.onDidChangeVisibility=this.g.event,F)for(const D of F)this.b.set(D.resource,{logger:void 0,info:D})}m(y){return(0,S.$gg)(y)?[...this.b.values()].find(C=>C.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,C){const F=this.n(y),D=(0,S.$gg)(y)?y:C?.id??(0,k.$uj)(F.toString()).toString(16);let M=this.b.get(F)?.logger;const K=C?.logLevel==="always"?v.Trace:C?.logLevel;M||(M=this.s(F,K??this.getLogLevel(F)??this.h,{...C,id:D}));const W={logger:M,info:{resource:F,id:D,logLevel:K,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(W.info),this.b.set(F,W),M}n(y){return(0,S.$gg)(y)?(0,w.$hh)(this.j,`${y}.log`):y}setLogLevel(y,C){if(m.URI.isUri(y)){const F=y,D=C,M=this.b.get(F);M&&D!==M.info.logLevel&&(M.info.logLevel=D===this.h?void 0:D,M.logger?.setLevel(D),this.b.set(M.info.resource,M),this.f.fire([F,D]))}else{this.h=y;for(const[F,D]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&D.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,C){const F=this.m(y);F&&C!==!F.info.hidden&&(F.info.hidden=!C,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,C]))}getLogLevel(y){let C;return y&&(C=this.b.get(y)?.info.logLevel),C??this.h}registerLogger(y){const C=this.b.get(y.resource);C?C.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const C=this.b.get(y);C&&(C.logger&&C.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=i;class n{constructor(){this.onDidChangeLogLevel=new N.$ne().event}setLevel(y){}getLevel(){return v.Info}trace(y,...C){}debug(y,...C){}info(y,...C){}warn(y,...C){}error(y,...C){}critical(y,...C){}dispose(){}flush(){}}e.$mk=n;class o extends n{}e.$nk=o;function l(E){if(E.verbose)return v.Trace;if(typeof E.logLevel=="string"){const y=L(E.logLevel.toLowerCase());if(y!==void 0)return y}return e.$dk}function f(E){switch(E){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function I(E){switch(E){case v.Trace:return{original:"Trace",value:R.localize(0,null)};case v.Debug:return{original:"Debug",value:R.localize(1,null)};case v.Info:return{original:"Info",value:R.localize(2,null)};case v.Warning:return{original:"Warning",value:R.localize(3,null)};case v.Error:return{original:"Error",value:R.localize(4,null)};case v.Off:return{original:"Off",value:R.localize(5,null)}}}function L(E){switch(E){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$sk=new u.$Xj("logLevel",f(v.Info))}),define(ce[208],le([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let m=class extends N.$Xc{constructor($,h){super(),this.a=$,this.b=h,this.B(new R.$Sh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,O.$eh)(this.a.logsHome),h=(0,O.$gh)(this.a.logsHome.with({scheme:k.Schemas.file})).fsPath,d=(await A.Promises.readdir(h)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==$),p=d.slice(0,Math.max(0,d.length-9));p.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(P=>A.Promises.rm((0,T.$mc)(h,P)))))}catch($){(0,c.$3)($)}}};e.$ihc=m,e.$ihc=m=ve([Y(0,w.$Ni),Y(1,S.$ak)],m)}),define(ce[209],le([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class m extends O.$Xc{constructor($,h){super(),this.a=$,this.b=h,this.c=this.B(new k.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Eh(0)),this.w=[],this.y=this.B(new c.$Eh(0))}watch($,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n($,h):this.z($,h)}n($,h){const b={path:this.J($),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},v=(0,R.$Wb)(this.j,b);return this.r(),(0,O.$Vc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,N.$3)($))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,w.$7q)(h)),h=>this.G(h),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const h of this.j)(0,w.$3q)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const h of this.j)(0,w.$3q)(h)&&$.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,h){const b={path:this.J($),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},v=(0,R.$Wb)(this.w,b);return this.C(),(0,O.$Vc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,N.$3)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,w.$7q)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,A.$kc)($.fsPath)}J($){const h=this.I($);return(0,T.$Ig)(h)}}e.$ar=m}),define(ce[210],le([0,1,19,6,15,26,3,56,64,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let s=class extends w.$Xc{static{g=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new T.$ne),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$ne),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$ne),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$ne),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$ne),this.Y=this.B(new T.$ne),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$ne),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Ph)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${t}`);const i=new w.$Wc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>{const o=new v.$tl(n,!this.S(a));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,w.$Vc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,w.$Sc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await c.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return A.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,$.$lh)(t))throw new v.$vl((0,b.localize)(0,null,this.sb(t)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new P.$eb;throw i.message=(0,b.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,v.$gl)(a)||(0,v.$dl)(a)||(0,v.$hl)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,v.$gl)(a)||(0,v.$dl)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,v.$ql)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.$vl((0,b.localize)(2,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ol)(i)}}async s(t,a){const i=await this.j(t),n=this.S(i),o=a?.resolveTo,l=a?.resolveSingleChildDescendants,f=a?.resolveMetadata,I=await i.stat(t);let L;return this.t(i,t,I,void 0,!!f,(E,y)=>(L||(L=S.$Mi.forUris(()=>!n),L.set(t,!0),o&&L.fill(!0,o)),L.get(E.resource)||L.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&l?y===1:!1))}async t(t,a,i,n,o,l){const{providerExtUri:f}=this.R(t),I={resource:a,name:f.basename(a),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(t.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Gl)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&l(I,n)){try{const L=await t.readdir(a),E=await c.Promises.settled(L.map(async([y,C])=>{try{const F=f.joinPath(a,y),D=o?await t.stat(F):{type:C};return await this.t(t,F,D,L.length,o,l)}catch(F){return this.b.trace(F),null}}));I.children=(0,R.$Kb)(E)}catch(L){this.b.trace(L),I.children=[]}return I}return I}async resolveAll(t){return c.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new v.$vl((0,b.localize)(3,null,this.sb(t)),v.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(t,a=N.$Pe.fromString(""),i){await this.u(t,i);const n=await this.writeFile(t,a);return this.r.fire(new v.$sl(t,v.FileOperation.CREATE,n)),n}async writeFile(t,a,i){const n=this.qb(await this.n(t),t),{providerExtUri:o}=this.R(n);let l=i;if((0,v.$jl)(n)&&!l?.atomic){const f=n.enforceAtomicWriteFile?.(t);f&&(l={...i,atomic:f})}try{await this.w(n,t,l)||await this.U(n,o.dirname(t));let I;if((0,v.$dl)(n)&&!(a instanceof N.$Pe))if((0,h.$Be)(a)){const L=await(0,h.$Ie)(a,3);L.ended?I=N.$Pe.concat(L.buffer):I=L}else I=(0,h.$Fe)(a,L=>N.$Pe.concat(L),3);else I=a;!(0,v.$gl)(n)||(0,v.$dl)(n)&&I instanceof N.$Pe||(0,v.$dl)(n)&&(0,v.$jl)(n)&&l?.atomic?await this.hb(n,t,l,I):await this.db(n,t,l,I instanceof N.$Pe?(0,N.$1e)(I):I),this.r.fire(new v.$sl(t,v.FileOperation.WRITE))}catch(f){throw new v.$vl((0,b.localize)(4,null,this.sb(t),(0,v.$ol)(f).toString()),(0,v.$rl)(f),l)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,b.localize)(5,null,this.sb(a)));if(!!i?.atomic){if(!(t.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,b.localize)(6,null,this.sb(a)));if(!(t.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,b.localize)(7,null,this.sb(a)));if(n)throw new Error((0,b.localize)(8,null,this.sb(a)))}let l;try{l=await t.stat(a)}catch{return}if(l.type&v.FileType.Directory)throw new v.$vl((0,b.localize)(9,null,this.sb(a)),v.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(a,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.$Fl&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,v.$Gl)({mtime:i.mtime,size:l.size}))throw new v.$vl((0,b.localize)(10,null),v.FileOperationResult.FILE_MODIFIED_SINCE,i);return l}async readFile(t,a,i){const n=await this.m(t);return a?.atomic?this.z(n,t,a,i):this.C(n,t,a,i)}async z(t,a,i,n){return new Promise((o,l)=>{this.cb.queueFor(a,async()=>{try{const f=await this.C(t,a,i,n);o(f)}catch(f){l(f)}},this.R(t).providerExtUri)})}async C(t,a,i,n){const o=await this.D(t,a,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,N.$2e)(o.value)}}async readFileStream(t,a,i){const n=await this.m(t);return this.D(n,t,a,i)}async D(t,a,i,n){const o=new k.$ye(n);let l=i;(0,v.$il)(t)&&t.enforceAtomicReadFile?.(a)&&(l={...i,atomic:!0});const f=this.J(a,l).then(L=>L,L=>{throw o.dispose(!0),L});let I;try{return typeof l?.etag=="string"&&l.etag!==v.$Fl&&await f,l?.atomic&&(0,v.$il)(t)||!((0,v.$gl)(t)||(0,v.$hl)(t))||(0,v.$dl)(t)&&l?.preferUnbuffered?I=this.I(t,a,l):(0,v.$hl)(t)?I=this.G(t,a,o.token,l):I=this.H(t,a,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await f,value:I}}catch(L){throw I&&await(0,h.$Ge)(I),this.F(L,a,l)}}F(t,a,i){const n=(0,b.localize)(11,null,this.sb(a),(0,v.$ol)(t).toString());return t instanceof v.$xl?new v.$xl(n,t.stat,i):t instanceof v.$wl?new v.$wl(n,t.fileOperationResult,t.size,t.options):new v.$vl(n,(0,v.$rl)(t),i)}G(t,a,i,n=Object.create(null)){const o=t.readFileStream(a,n,i);return(0,h.$Me)(o,{data:l=>l instanceof N.$Pe?l:N.$Pe.wrap(l),error:l=>this.F(l,a,n)},l=>N.$Pe.concat(l))}H(t,a,i,n=Object.create(null)){const o=(0,N.$6e)();return(0,d.$Zq)(t,a,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,a,n)},i),o}I(t,a,i){const n=(0,h.$De)(o=>N.$Pe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,v.$il)(t)?o=await t.readFile(a,{atomic:!0}):o=await t.readFile(a),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(a,o.byteLength,i),n.end(N.$Pe.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new v.$vl((0,b.localize)(12,null,this.sb(t)),v.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==v.$Fl&&a.etag===i.etag)throw new v.$xl((0,b.localize)(13,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new v.$wl((0,b.localize)(14,null,this.sb(t)),v.FileOperationResult.FILE_TOO_LARGE,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,n){if(t.toString()!==a.toString())try{const o=i==="move"?this.qb(await this.n(t),t):await this.m(t),l=this.qb(await this.n(a),a);await this.Q(o,t,l,a,i,n)}catch(o){return o}return!0}async move(t,a,i){const n=this.qb(await this.n(t),t),o=this.qb(await this.n(a),a),l=await this.N(n,t,o,a,"move",!!i),f=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,l==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,f)),f}async copy(t,a,i){const n=await this.m(t),o=this.qb(await this.n(a),a),l=await this.N(n,t,o,a,"copy",!!i),f=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,l==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,f)),f}async N(t,a,i,n,o,l){if(a.toString()===n.toString())return o;const{exists:f,isSameResourceWithDifferentPathCase:I}=await this.Q(t,a,i,n,o,l);if(f&&!I&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,v.$el)(t))await t.copy(a,n,{overwrite:l});else{const L=await this.resolve(a);L.isDirectory?await this.P(t,L,i,n):await this.O(t,a,i,n)}return o}else return t===i?(await t.rename(a,n,{overwrite:l}),o):(await this.N(t,a,i,n,"copy",l),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,n){if((0,v.$gl)(t)&&(0,v.$gl)(i))return this.jb(t,a,i,n);if((0,v.$gl)(t)&&(0,v.$dl)(i))return this.pb(t,a,i,n);if((0,v.$dl)(t)&&(0,v.$gl)(i))return this.nb(t,a,i,n);if((0,v.$dl)(t)&&(0,v.$dl)(i))return this.lb(t,a,i,n)}async P(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await c.Promises.settled(a.children.map(async o=>{const l=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(t,await this.resolve(o.resource),i,l):this.O(t,o.resource,i,l)}))}async Q(t,a,i,n,o,l){let f=!1;if(t===i){const{providerExtUri:L,isPathCaseSensitive:E}=this.R(t);if(E||(f=L.isEqual(a,n)),f&&o==="copy")throw new Error((0,b.localize)(15,null,this.sb(a),this.sb(n)));if(!f&&L.isEqualOrParent(n,a))throw new Error((0,b.localize)(16,null,this.sb(a),this.sb(n)))}const I=await this.exists(n);if(I&&!f){if(!l)throw new v.$vl((0,b.localize)(17,null,this.sb(a),this.sb(n)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(t===i){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(a,n))throw new Error((0,b.localize)(18,null,this.sb(a),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:f}}R(t){const a=this.S(t);return{providerExtUri:a?$.$0g:$.$_g,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const a=this.qb(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,v.FileOperation.CREATE,i)),i}async U(t,a){const i=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&v.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(a)));break}catch(o){if((0,v.$ql)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(a)),a=n.dirname(a)}for(let o=i.length-1;o>=0;o--){a=n.joinPath(a,i[o]);try{await t.mkdir(a)}catch(l){if((0,v.$ql)(l)!==v.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.qb(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,b.localize)(20,null,this.sb(t)));const o=a?.atomic;if(o&&!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,b.localize)(21,null,this.sb(t)));if(n&&o)throw new Error((0,b.localize)(22,null,this.sb(t)));let l;try{l=await i.stat(t)}catch{}if(l)this.rb(t,l);else throw new v.$vl((0,b.localize)(23,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(t)))}return i}async del(t,a){const i=await this.W(t,a);let n=a;if((0,v.$kl)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(t);I&&(n={...a,atomic:I})}const o=!!n?.useTrash,l=!!n?.recursive,f=n?.atomic??!1;await i.delete(t,{recursive:l,useTrash:o,atomic:f}),this.r.fire(new v.$sl(t,v.FileOperation.DELETE))}async cloneFile(t,a){const i=await this.j(t),n=this.qb(await this.n(a),a);if(!(i===n&&this.R(i).providerExtUri.isEqual(t,a)))return i===n&&(0,v.$fl)(i)?i.cloneFile(t,a):(await this.U(n,this.R(n).providerExtUri.dirname(a)),i===n&&(0,v.$el)(i)?this.cb.queueFor(t,()=>i.copy(t,a,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(t,()=>this.O(i,t,n,a),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(t,a){return this.watch(t,{...a,correlationId:g.ab++})}watch(t,a={recursive:!1,excludes:[]}){const i=new w.$Wc;let n=!1,o=()=>{n=!0};i.add((0,w.$Vc)(()=>o())),(async()=>{try{const f=await this.bb(t,a);n?(0,w.$Sc)(f):o=()=>(0,w.$Sc)(f)}catch(f){this.b.error(f)}})();const l=a.correlationId;if(typeof l=="number"){const f=i.add(new T.$ne);return i.add(this.X.event(L=>{L.correlates(l)&&f.fire(L)})),{onDidChange:f.event,dispose:()=>i.dispose()}}return i}async bb(t,a){const i=await this.j(t),n=(0,O.$uj)([this.R(i).providerExtUri.getComparisonKey(t),a]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(t,a)},this.$.set(n,o)),o.count+=1,(0,w.$Vc)(()=>{o&&(o.count--,o.count===0&&((0,w.$Sc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,w.$Sc)(t.disposable);this.$.clear()}async db(t,a,i,n){return this.cb.queueFor(a,async()=>{const o=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,h.$Be)(n)||(0,h.$Ce)(n)?await this.eb(t,o,n):await this.fb(t,o,n)}catch(l){throw(0,v.$ol)(l)}finally{await t.close(o)}},this.R(t).providerExtUri)}async eb(t,a,i){let n=0,o;if((0,h.$Ce)(i)){if(i.buffer.length>0){const l=N.$Pe.concat(i.buffer);await this.gb(t,a,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,f)=>{(0,h.$He)(o,{onData:async I=>{o.pause();try{await this.gb(t,a,I,I.byteLength,n,0)}catch(L){return f(L)}n+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>f(I),onEnd:()=>l()})})}async fb(t,a,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(t,a,o,o.byteLength,n,0),n+=o.byteLength}async gb(t,a,i,n,o,l){let f=0;for(;f<n;){const I=await t.write(a,o+f,i.buffer,l+f,n-f);f+=I}}async hb(t,a,i,n){return this.cb.queueFor(a,()=>this.ib(t,a,i,n),this.R(t).providerExtUri)}async ib(t,a,i,n){let o;n instanceof N.$Pe?o=n:(0,h.$Be)(n)?o=await(0,N.$2e)(n):(0,h.$Ce)(n)?o=await(0,N.$3e)(n):o=(0,N.$Ze)(n),await t.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(t,a,i,n){return this.cb.queueFor(n,()=>this.kb(t,a,i,n),this.R(i).providerExtUri)}async kb(t,a,i,n){let o,l;try{o=await t.open(a,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const f=N.$Pe.alloc(this.a);let I=0,L=0,E=0;do E=await t.read(o,I,f.buffer,L,f.byteLength-L),await this.gb(i,l,f,E,I,L),I+=E,L+=E,L===f.byteLength&&(L=0);while(E>0)}catch(f){throw(0,v.$ol)(f)}finally{await c.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(t,a,i,n){return this.cb.queueFor(n,()=>this.mb(t,a,i,n),this.R(i).providerExtUri)}async mb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,a,i,n){return this.cb.queueFor(n,()=>this.ob(t,a,i,n),this.R(i).providerExtUri)}async ob(t,a,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await t.readFile(a);await this.gb(i,o,N.$Pe.wrap(l),l.byteLength,0,0)}catch(l){throw(0,v.$ol)(l)}finally{await i.close(o)}}async pb(t,a,i,n){const o=await(0,N.$2e)(this.H(t,a,k.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(t,a){if(t.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$vl((0,b.localize)(25,null,this.sb(a)),v.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,a){if((a.permissions??0)&v.FilePermission.Readonly)throw new v.$vl((0,b.localize)(26,null,this.sb(t)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.$1q=s,e.$1q=s=g=ve([Y(0,p.$ak)],s)}),define(ce[211],le([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,209,206,205]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class P extends v.$ar{static{this.L=!1}constructor(s,r){super(s,r),this.onDidChangeCapabilities=k.Event.None,this.P=new c.$Dc(t=>S.$$g.getComparisonKey(t)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=h.FileSystemProviderCapabilities.FileReadWrite|h.FileSystemProviderCapabilities.FileOpenReadWriteClose|h.FileSystemProviderCapabilities.FileReadStream|h.FileSystemProviderCapabilities.FileFolderCopy|h.FileSystemProviderCapabilities.FileWriteUnlock|h.FileSystemProviderCapabilities.FileAtomicRead|h.FileSystemProviderCapabilities.FileAtomicWrite|h.FileSystemProviderCapabilities.FileAtomicDelete|h.FileSystemProviderCapabilities.FileClone,w.$k&&(this.M|=h.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:r,symbolicLink:t}=await u.SymlinkSupport.stat(this.I(s));return{type:this.O(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:h.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const r=await u.Promises.readdir(this.I(s),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async a=>{try{let i;a.isSymbolicLink()?i=(await this.stat((0,S.$hh)(s,a.name))).type:i=this.O(a),t.push([a.name,i])}catch(i){this.a.trace(i)}})),t}catch(r){throw this.hb(r)}}O(s,r){let t;return r?.dangling?t=h.FileType.Unknown:s.isFile()?t=h.FileType.File:s.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,r&&(t|=h.FileType.SymbolicLink),t}async Q(s){const r=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let t;for(;t=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await t.wait();const a=new R.$Fh;return this.P.set(s,a),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,O.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(s)===a&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(s,r){let t;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),t=await this.Q(s));const a=this.I(s);return await u.Promises.readFile(a)}catch(a){throw this.hb(a)}finally{t?.dispose()}}R(s){P.L&&this.a.trace(s)}readFileStream(s,r,t){const a=(0,m.$De)(i=>N.$Pe.concat(i.map(n=>N.$Pe.wrap(n))).buffer);return(0,b.$Zq)(this,s,a,i=>i.buffer,{...r,bufferSize:256*1024},t),a}async writeFile(s,r,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.S(s)?this.U(s,(0,S.$hh)((0,S.$gh)(s),`${(0,S.$eh)(s)}${t.atomic.postfix}`),r,t):this.W(s,r,t)}async S(s){try{const r=this.I(s),{symbolicLink:t}=await u.SymlinkSupport.stat(r);if(t)return!1}catch{}return!0}async U(s,r,t,a){const i=new O.$Wc;try{i.add(await this.Q(s)),i.add(await this.Q(r)),await this.W(r,t,a,!0);try{await this.rename(r,s,{overwrite:!0})}catch(n){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async W(s,r,t,a){let i;try{const n=this.I(s);if(!t.create||!t.overwrite){if(await u.Promises.exists(n)){if(!t.overwrite)throw(0,h.$nl)((0,$.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.$nl)((0,$.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:t.unlock},a),await this.write(i,0,r,0,r.byteLength)}catch(n){throw await this.ib(s,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(s){P.$=s}async open(s,r,t){const a=this.I(s);let i;(0,h.$bl)(r)&&!t&&(i=await this.Q(s));let n;try{if((0,h.$bl)(r)&&r.unlock)try{const{stat:l}=await u.SymlinkSupport.stat(a);l.mode&128||await u.Promises.chmod(a,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let o;if((0,h.$bl)(r)){if(w.$i)try{await u.Promises.truncate(a,0),o="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}o||(o="w")}else o="r";n=await u.Promises.open(a,o)}catch(o){throw i?.dispose(),(0,h.$bl)(r)?await this.ib(s,o):this.hb(o)}if(this.X.set(n,0),(0,h.$bl)(r)&&this.Z.set(n,s),i){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${a})`),this.Y.set(n,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${a})`),o.dispose())}return n}async close(s){const r=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&P.$)try{await u.Promises.fdatasync(s)}catch(t){P.configureFlushOnWrite(!1),this.a.error(t)}return await u.Promises.close(s)}catch(t){throw this.hb(t)}finally{r&&(this.Y.get(s)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),r.dispose())}}async read(s,r,t,a,i){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.read(s,t,a,i,n)).bytesRead}catch(l){throw this.hb(l)}finally{this.bb(s,n,o)}return o}ab(s,r){return r===this.X.get(s)?null:r}bb(s,r,t){const a=this.X.get(s);typeof a=="number"&&(typeof r=="number"||(typeof t=="number"?this.X.set(s,a+t):this.X.delete(s)))}async write(s,r,t,a,i){return(0,R.$1h)(()=>this.cb(s,r,t,a,i),100,3)}async cb(s,r,t,a,i){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.write(s,t,a,i,n)).bytesWritten}catch(l){throw await this.ib(this.Z.get(s),l)}finally{this.bb(s,n,o)}return o}async mkdir(s){try{await u.Promises.mkdir(this.I(s))}catch(r){throw this.hb(r)}}async delete(s,r){try{const t=this.I(s);if(r.recursive){let a;r?.atomic!==!1&&r.atomic.postfix&&(a=(0,A.$mc)((0,A.$pc)(t),`${(0,A.$qc)(t)}${r.atomic.postfix}`)),await u.Promises.rm(t,u.RimRafMode.MOVE,a)}else try{await u.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:o}=await u.SymlinkSupport.stat(t);i=n.isDirectory()&&!o}catch{}if(i)await u.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.hb(t)}}async rename(s,r,t){const a=this.I(s),i=this.I(r);if(a!==i)try{await this.db(s,r,"move",t.overwrite),await u.Promises.rename(a,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(2,null,(0,A.$qc)(a),(0,A.$qc)((0,A.$pc)(i)),n.toString()))),this.hb(n)}}async copy(s,r,t){const a=this.I(s),i=this.I(r);if(a!==i)try{await this.db(s,r,"copy",t.overwrite),await u.Promises.copy(a,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(3,null,(0,A.$qc)(a),(0,A.$qc)((0,A.$pc)(i)),n.toString()))),this.hb(n)}}async db(s,r,t,a){const i=this.I(s),n=this.I(r);let o=!1;if(!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,T.$Eg)(i,n,!0)),o){if(t==="copy")throw(0,h.$nl)((0,$.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const f=await this.N(s);if(!f)throw(0,h.$nl)((0,$.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const I=await this.N(r);if(I){if(!a)throw(0,h.$nl)((0,$.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);f.type&h.FileType.File&&I.type&h.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,r){return this.eb(s,r,!1)}async eb(s,r,t){const a=this.I(s),i=this.I(r),n=!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Eg)(a,i,!n))return;const o=new O.$Wc;try{o.add(await this.Q(s)),o.add(await this.Q(r)),t&&await u.Promises.mkdir((0,A.$pc)(i),{recursive:!0}),await u.Promises.copyFile(a,i)}catch(l){if(l.code==="ENOENT"&&!t)return this.eb(s,r,!0);throw this.hb(l)}finally{o.dispose()}}t(s,r,t){return new d.$hr(a=>s(a),a=>r(a),t)}F(s,r,t){return new p.$qr(a=>s(a),a=>r(a),t)}hb(s){if(s instanceof h.$ml)return s;let r=s,t;switch(s.code){case"ENOENT":t=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=h.FileSystemProviderErrorCode.Unknown;break;default:t=h.FileSystemProviderErrorCode.Unknown}return(0,h.$nl)(r,t)}async ib(s,r){let t=this.hb(r);if(s&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.I(s));a.mode&128||(t=(0,h.$nl)(r,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$rr=P}),define(ce[102],le([0,1,3,2,4,10]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0,e.$Hhc=(0,N.$Gi)("sharedProcessLifecycleService");let T=class extends c.$Xc{constructor(A){super(),this.b=A,this.a=this.B(new R.$ne),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Ihc=T,e.$Ihc=T=ve([Y(0,k.$ak)],T)}),define(ce[212],le([0,1,9,3,10,2]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=void 0;class T extends N.$lk{constructor(m,u,$,h,b){super(u,$,h),this.r=m,this.t=b,this.B(b.listen("onDidChangeLogLevel",m)(v=>{(0,N.$ck)(v)?super.setLogLevel(v):super.setLogLevel(R.URI.revive(v[0]),v[1])})),this.B(b.listen("onDidChangeVisibility",m)(([v,d])=>super.setVisibility(R.URI.revive(v),d))),this.B(b.listen("onDidChangeLoggers",m)(({added:v,removed:d})=>{for(const p of v)super.registerLogger({...p,resource:R.URI.revive(p.resource)});for(const p of d)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new N.$jk({log:(m,u)=>{this.t.call("consoleLog",[m,u])}})}registerLogger(m){super.registerLogger(m),this.t.call("registerLogger",[m,this.r])}deregisterLogger(m){super.deregisterLogger(m),this.t.call("deregisterLogger",[m,this.r])}setLogLevel(m,u){super.setLogLevel(m,u),this.t.call("setLogLevel",[m,u])}setVisibility(m,u){super.setVisibility(m,u),this.t.call("setVisibility",[this.n(m),u])}s(m,u,$){return new O(this.t,m,u,$,this.r)}static setLogLevel(m,u,$){return m.call("setLogLevel",[u,$])}}e.$rs=T;class O extends N.$gk{constructor(m,u,$,h,b){super(h?.logLevel==="always"),this.r=m,this.s=u,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[u,h,b]).then(()=>{this.u(this.n),this.m=!0})}g(m,u){const $=[[m,u]];this.m?this.u($):this.n.push(...$)}u(m){this.r.call("log",[this.s,m])}}class A{constructor(m,u){this.a=m,this.b=u}listen(m,u){const $=this.b(m);switch(u){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(b=>this.c(b,$)),removed:[...h.removed].map(b=>this.c(b,$))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,h=>[$.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,h=>(0,N.$ck)(h)?h:[$.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${u}`)}async call(m,u,$){const h=this.b(m);switch(u){case"setLogLevel":return(0,N.$ck)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(R.URI.revive(h.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,h)))}throw new Error(`Call not found: ${u}`)}c(m,u){return{...m,resource:u.transformOutgoingURI(m.resource)}}}e.$ss=A;class w extends k.$Xc{constructor(m,u){super(),u.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel($=>u.call("setLogLevel",[$]))),u.call("getRegisteredLoggers").then($=>{for(const h of $)m.registerLogger({...h,resource:R.URI.revive(h.resource)})}),this.B(u.listen("onDidChangeVisibility")(([$,h])=>m.setVisibility(R.URI.revive($),h))),this.B(u.listen("onDidChangeLoggers")(({added:$,removed:h})=>{for(const b of $)m.registerLogger({...b,resource:R.URI.revive(b.resource)});for(const b of h)m.deregisterLogger(b.resource)}))}}e.$ts=w}),define(ce[213],le([0,1,2,10]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class N extends R.$Xc{constructor(T,O=[]){super(),this.a=new c.$kk([T,...O]),this.B(T.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...O){this.a.trace(T,...O)}debug(T,...O){this.a.debug(T,...O)}info(T,...O){this.a.info(T,...O)}warn(T,...O){this.a.warn(T,...O)}error(T,...O){this.a.error(T,...O)}flush(){this.a.flush()}}e.$oR=N}),define(ce[58],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0,e.$Ifc=(0,R.$Gi)("nativeHostService")}),define(ce[214],le([0,1,43,57]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;let N=class{constructor(T,O){return this.windowId=T,R.ProxyChannel.toService(O.getChannel("nativeHost"),{context:T,properties:(()=>{const A=new Map;return A.set("windowId",T),A})()})}};e.$4gc=N,e.$4gc=N=ve([Y(1,c.$1gc)],N)}),define(ce[59],le([0,1,3,64,2,4]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,k.$Gi)("policy");class T extends N.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$ne),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const S=Object.keys(this.f).length;return this.f={...w,...this.f},S!==Object.keys(this.f).length&&await this.j(w),c.Iterable.reduce(this.g.entries(),(m,[u,$])=>({...m,[u]:$}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(w,[S,m])=>({...w,[S]:{definition:m,value:this.g.get(S)}}),{})}}e.$uo=T;class O{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=O}),define(ce[215],le([0,1,3,2,59]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;class k{constructor(A){this.b=A,this.a=new c.$Wc}listen(A,w){switch(w){case"onDidChange":return R.Event.map(this.b.onDidChange,S=>S.reduce((m,u)=>({...m,[u]:this.b.getPolicyValue(u)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(A,w,S){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.$ugc=k;class T extends N.$uo{constructor(A,w){super(),this.a=w;for(const S in A){const{definition:m,value:u}=A[S];this.f[S]=m,u!==void 0&&this.g.set(S,u)}this.a.listen("onDidChange")(S=>{for(const m in S){const u=S[m];u===null?this.g.delete(m):this.g.set(m,u)}this.h.fire(Object.keys(S))})}async j(A){const w=await this.a.call("updatePolicyDefinitions",A);for(const S in w)this.g.set(S,w[S])}}e.$vgc=T}),define(ce[103],le([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const k=N.context.configuration();if(k)c=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:k.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(ce[24],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,R.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(ce[216],le([0,1,6,8,2,14,31,10,24]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let w=class extends N.$Xc{constructor(m,u,$){super(),this.b=u,this.c=$,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new R.$Sh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const u=Date.now(),$=(0,k.$pc)(m),h=(0,k.$qc)(m),b=await T.Promises.readdir($);await Promise.all(b.map(async v=>{if(v===h)return;const d=(0,k.$mc)($,v),p=await T.Promises.stat(d);if(p.isDirectory()&&u-p.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),T.Promises.rm(d)}))}catch(u){(0,c.$3)(u)}}};e.$fhc=w,e.$fhc=w=ve([Y(1,A.$tk),Y(2,O.$ak)],w)}),define(ce[217],le([0,1,6,8,2,14,31,16,10,24]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let S=class extends N.$Xc{constructor(u,$,h){super(),this.b=u,this.c=$,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$Sh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const u=Object.create(null),$=JSON.parse(await T.Promises.readFile((0,k.$mc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys($)){const P=$[p];u[`${P.hash}.${p}`]=!0}const h=(0,k.$mc)(this.b.userDataPath,"clp");if(!await T.Promises.exists(h))return;const v=await T.Promises.readdir(h);for(const p of v){if(u[p]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await T.Promises.rm((0,k.$mc)(h,p))}const d=Date.now();for(const p of Object.keys(u)){const P=(0,k.$mc)(h,p),g=await T.Promises.readdir(P);for(const s of g){if(s==="tcf.json")continue;const r=(0,k.$mc)(P,s),t=await T.Promises.stat(r);t.isDirectory()&&d-t.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.$mc)(p,s)}`),await T.Promises.rm(r))}}}catch(u){(0,c.$3)(u)}}};e.$ghc=S,e.$ghc=S=ve([Y(0,O.$Oi),Y(1,A.$ak),Y(2,w.$tk)],S)}),define(ce[218],le([0,1,14,4]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$NG=void 0,e.$NG=(0,c.$Gi)("IV8InspectProfilingService");var N;(function(k){function T(A){return!!(A.samples&&A.timeDeltas)}k.isValidProfile=T;function O(A,w="noAbsolutePaths"){for(const S of A.nodes)S.callFrame&&S.callFrame.url&&((0,R.$lc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,R.$mc)(w,(0,R.$qc)(S.callFrame.url)));return A}k.rewriteAbsolutePaths=O})(N||(e.Utils=N={}))}),define(ce[219],le([0,1,32]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class c{constructor(){this.a=new Map}async startProfiling(k){const O=await(await new Promise((w,S)=>{ne(["v8-inspect-profiler"],w,S)}).then(ke)).startProfiling({host:k.host,port:k.port,checkForPaused:!0}),A=(0,R.$3g)();return this.a.set(A,O),A}async stopProfiling(k){const T=this.a.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const O=await T.stop();return this.a.delete(k),O.profile}}e.$xhc=c}),define(ce[44],le([0,1,132,13]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,R=ke(R),c=ke(c);class N{constructor(){this.a=new Map}add(T,O){R.ok(c.$gg(T)),R.ok(c.$ig(O)),R.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,O)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$ro=new N}),define(ce[104],le([0,1,3,44]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,c=ke(c),e.$so={JSONContribution:"base.contributions.json"};function N(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class k{constructor(){this.b=new R.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(A,w){this.a[N(A)]=w,this.b.fire(A)}notifySchemaChanged(A){this.b.fire(A)}getSchemaContributions(){return{schemas:this.a}}}const T=new k;c.$ro.add(e.$so.JSONContribution,T)}),define(ce[48],le([0,1,19,3,13,159,22,104,44]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=b,e.$Io=v,e.$Jo=d,e.$Ko=P,e.$Lo=g,N=ke(N),k=ke(k);var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$wo={Configuration:"base.contributions.configuration"};var S;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const m=A.$ro.as(O.$so.JSONContribution);class u{constructor(){this.h=new Set,this.i=new c.$ne,this.onDidSchemaChange=this.i.event,this.j=new c.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.$Do,this.g),this.v()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const a=new Set;this.n(r,t,a),m.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(r){const t=new Set;this.o(r,t),m.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:t})}updateConfigurations({add:r,remove:t}){const a=new Set;this.o(t,a),this.n(r,!1,a),m.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(r){const t=new Set;this.k(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}k(r,t){const a=[];for(const{overrides:i,source:n}of r)for(const o in i)if(t.add(o),e.$Go.test(o)){const l=this.a.get(o),f=l?.valuesSources??new Map,I=l?.value||{};for(const y of Object.keys(i[o])){const C=i[o][y];if(N.$ig(C)&&(N.$ng(I[y])||N.$ig(I[y]))){if(I[y]={...I[y]??{},...C},n){let D=f.get(y);if(D||(D=new Map,f.set(y,D)),!(D instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const M in C)D.set(M,n)}}else I[y]=C,n&&f.set(y,n)}this.a.set(o,{source:n,value:I,valuesSources:f});const L=(0,T.$kj)(o),E={type:"object",default:I,description:k.localize(1,null,L),$ref:e.$Do,defaultDefaultValue:I,source:N.$gg(n)?void 0:n,defaultValueSource:n};a.push(...b(o)),this.d[o]=E,this.b.properties[o]=E}else{const l=this.d[o],f=this.a.get(o);let I=f?.value??l?.defaultDefaultValue,L=i[o],E=n;if(N.$ig(L)&&(l!==void 0&&l.type==="object"||l===void 0&&(N.$ng(I)||N.$ig(I)))){if(N.$ig(I)||(I={}),L={...I,...L},E=f?.source??new Map,!(E instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const C in i[o])n?E.set(C,n):E.delete(C)}this.a.set(o,{value:L,source:E}),l&&(this.w(o,l),this.r(o,l))}this.m(a)}deregisterDefaultConfigurations(r){const t=new Set;this.l(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}l(r,t){for(const{overrides:a,source:i}of r)for(const n in a){const o=N.$gg(i)?i:i?.id,l=this.a.get(n);if(l){if(e.$Go.test(n)){for(const I of Object.keys(a[n])){const L=a[n][I];if(N.$ig(L)){const E=l.valuesSources?.get(I);for(const y of Object.keys(L)){const C=E?.get(y);(N.$gg(C)?C:C?.id)===o&&(E?.delete(y),delete l.value[I][y])}Object.keys(l.value[I]).length===0&&(delete l.value[I],l.valuesSources?.delete(I))}else{const E=l.valuesSources?.get(I);(N.$gg(E)?E:E?.id)===o&&(l.valuesSources?.delete(I),delete l.value[I])}}const f=this.a.get(n);f&&Object.keys(f.value).length===0&&(this.a.delete(n),delete this.d[n],delete this.b.properties[n])}else{if(l.source instanceof Map){const I=l.source;for(const L in a[n]){const E=I.get(L);(N.$gg(E)?E:E?.id)===o&&(I.delete(L),delete l.value[L])}I.size===0&&this.a.delete(n)}else{const I=N.$gg(l.source)?l.source:l.source?.id;if(o!==I)continue;this.a.delete(n)}const f=this.d[n];f&&(this.w(n,f),this.r(n,f))}t.add(n)}}this.u()}deltaConfiguration(r){let t=!1;const a=new Set;r.removedDefaults&&(this.l(r.removedDefaults,a),t=!0),r.addedDefaults&&(this.k(r.addedDefaults,a),t=!0),r.removedConfigurations&&this.o(r.removedConfigurations,a),r.addedConfigurations&&this.n(r.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const t of r)this.h.add(t);this.u()}n(r,t,a){r.forEach(i=>{this.p(i,t,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(r,t){const a=i=>{if(i.properties)for(const n in i.properties){t.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>a(n))};for(const i of r){a(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(r,t=!0,a,i,n=S.WINDOW,o){n=N.$pg(r.scope)?n:r.scope;const l=r.properties;if(l)for(const I in l){const L=l[I];if(t&&P(I,L)){delete l[I];continue}if(L.source=a,L.defaultDefaultValue=l[I].default,this.w(I,L),e.$Go.test(I)?L.scope=void 0:(L.scope=N.$pg(L.scope)?n:L.scope,L.restricted=N.$pg(L.restricted)?!!i?.includes(I):L.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const f=r.allOf;if(f)for(const I of f)this.p(I,t,a,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const t=a=>{const i=a.properties;if(i)for(const o in i)this.r(o,i[o]);a.allOf?.forEach(t)};t(r)}r(r,t){switch(e.$xo.properties[r]=t,t.scope){case S.APPLICATION:e.$yo.properties[r]=t;break;case S.MACHINE:e.$zo.properties[r]=t;break;case S.MACHINE_OVERRIDABLE:e.$Ao.properties[r]=t;break;case S.WINDOW:e.$Bo.properties[r]=t;break;case S.RESOURCE:e.$Co.properties[r]=t;break;case S.LANGUAGE_OVERRIDABLE:e.$Co.properties[r]=t,this.g.properties[r]=t;break}}s(r,t){switch(delete e.$xo.properties[r],t.scope){case S.APPLICATION:delete e.$yo.properties[r];break;case S.MACHINE:delete e.$zo.properties[r];break;case S.MACHINE_OVERRIDABLE:delete e.$Ao.properties[r];break;case S.WINDOW:delete e.$Bo.properties[r];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const t=`[${r}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$Do};this.w(t,a),e.$xo.properties[t]=a,e.$yo.properties[t]=a,e.$zo.properties[t]=a,e.$Ao.properties[t]=a,e.$Bo.properties[t]=a,e.$Co.properties[t]=a}}v(){const r={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=r,e.$yo.patternProperties[e.$Fo]=r,e.$zo.patternProperties[e.$Fo]=r,e.$Ao.patternProperties[e.$Fo]=r,e.$Bo.patternProperties[e.$Fo]=r,e.$Co.patternProperties[e.$Fo]=r,this.i.fire()}w(r,t){const a=this.a.get(r);let i=a?.value,n=a?.source;N.$ng(i)&&(i=t.defaultDefaultValue,n=void 0),N.$ng(i)&&(i=d(t.type)),t.default=i,t.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",h=new RegExp($,"g");e.$Fo=`^(${$})+$`,e.$Go=new RegExp(e.$Fo);function b(s){const r=[];if(e.$Go.test(s)){let t=h.exec(s);for(;t?.length;){const a=t[1].trim();a&&r.push(a),t=h.exec(s)}}return(0,R.$Pb)(r)}function v(s){return s.reduce((r,t)=>`${r}[${t}]`,"")}function d(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new u;A.$ro.add(e.$wo.Configuration,p);function P(s,r){return s.trim()?e.$Go.test(s)?k.localize(7,null,s):p.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?k.localize(9,null,s,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:k.localize(6,null)}function g(){const s=[],r=p.getConfigurationProperties();for(const t of Object.keys(r))s.push([t,r[t].scope]);return s.push(["launch",S.RESOURCE]),s.push(["task",S.RESOURCE]),s}}),define(ce[78],le([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=g,R=ke(R),N=ke(N),O=ke(O),A=ke(A);function h(a){return Object.isFrozen(a)?a:O.$fo(a)}class b{static createEmptyModel(i){return new b({},[],[],void 0,i)}constructor(i,n,o,l,f){this.b=i,this.c=n,this.d=o,this.raw=l,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof b)return n;const o=new v("",this.f);return o.parseRaw(n),o.configurationModel});this.g=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$ij)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return h(o.rawConfiguration.getValue(i))},get override(){return n?h(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return h(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const l=[];for(const{contents:f,identifiers:I,keys:L}of o.rawConfiguration.overrides){const E=new b(f,L,[],void 0,o.f).getValue(i);E!==void 0&&l.push({identifiers:I,value:E})}return l.length?h(l):void 0}}}getOverrideValue(i,n){const o=this.j(n);return o?i?(0,S.$ij)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return R.$Pb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return R.$Pb(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=O.$eo(this.contents),o=O.$eo(this.overrides),l=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const I of i)if(f.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.i(n,I.contents);for(const L of I.overrides){const[E]=o.filter(y=>R.$xb(y.identifiers,L.identifiers));E?(this.i(E.contents,L.contents),E.keys.push(...L.keys),E.keys=R.$Pb(E.keys)):o.push(O.$eo(L))}for(const L of I.keys)l.indexOf(L)===-1&&l.push(L)}return new b(n,l,o,f.every(I=>I instanceof b)?void 0:f,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of R.$Pb([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[l];const I=n[l];I&&(typeof f=="object"&&typeof I=="object"?(f=O.$eo(f),this.i(f,I)):f=I),o[l]=f}return new b(o,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const o of Object.keys(n)){if(o in i&&A.$ig(i[o])&&A.$ig(n[o])){this.i(i[o],n[o]);continue}i[o]=O.$eo(n[o])}}j(i){let n=null,o=null;const l=f=>{f&&(o?this.i(o,f):o=O.$eo(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===i?n=f.contents:f.identifiers.includes(i)&&l(f.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$hj)(this.contents,i),m.$Go.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>R.$xb(o.identifiers,(0,m.$Ho)(i))),1))}k(i,n,o){(0,S.$gj)(this.contents,i,n,l=>this.f.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.$Go.test(i)&&this.overrides.push({identifiers:(0,m.$Ho)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$fj)(this.contents[i],l=>this.f.error(l))})}}e.$Mo=b;class v{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||b.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!A.$pg(i)){const o=this.h(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:l,overrides:f,restricted:I,hasExcludedProperties:L}=this.i(i,n);this.b=new b(o,l,f,L?[i]:void 0,this.g),this.c=I||[]}h(i){let n={},o=null,l=[];const f=[],I=[];function L(y){Array.isArray(l)?l.push(y):o!==null&&(l[o]=y)}const E={onObjectBegin:()=>{const y={};L(y),f.push(l),l=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const y=[];L(y),f.push(l),l=y,o=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:L,onError:(y,C,F)=>{I.push({error:y,offset:C,length:F})}};if(i)try{N.$6n(i,E),n=l[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return n}i(i,n){const o=$.$ro.as(m.$wo.Configuration).getConfigurationProperties(),l=this.j(i,o,!0,n);i=l.raw;const f=(0,S.$fj)(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),I=Object.keys(i),L=this.l(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:f,keys:I,overrides:L,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(i,n,o,l){let f=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:f};const I={},L=[];for(const E in i)if(m.$Go.test(E)&&o){const y=this.j(i[E],n,!1,l);I[E]=y.raw,f=f||y.hasExcludedProperties,L.push(...y.restricted)}else{const y=n[E],C=y?typeof y.scope<"u"?y.scope:m.ConfigurationScope.WINDOW:void 0;y?.restricted&&L.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(C===void 0||l.scopes===void 0||l.scopes.includes(C))&&!(l.skipRestricted&&y?.restricted))?I[E]=i[E]:f=!0}return{raw:I,restricted:L,hasExcludedProperties:f}}l(i,n){const o=[];for(const l of Object.keys(i))if(m.$Go.test(l)){const f={};for(const I in i[l])f[I]=i[l][I];o.push({identifiers:(0,m.$Ho)(l),keys:Object.keys(f),contents:(0,S.$fj)(f,n)})}return o}}e.$No=v;class d extends k.$Xc{constructor(i,n,o,l,f){super(),this.c=i,this.f=n,this.g=l,this.h=f,this.b=this.B(new c.$ne),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),f),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(u.FileOperation.CREATE)||I.isOperation(u.FileOperation.COPY)||I.isOperation(u.FileOperation.DELETE)||I.isOperation(u.FileOperation.WRITE))&&o.isEqual(I.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return b.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=d;class p{constructor(i,n,o,l,f,I,L,E,y,C,F,D,M){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=l,this.d=f,this.f=I,this.g=L,this.h=E,this.i=y,this.j=C,this.k=F,this.l=D,this.m=M}get value(){return h(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(i,n,o,l,f,I,L,E,y,C){this.j=i,this.l=n,this.m=o,this.n=l,this.p=f,this.q=I,this.r=L,this.s=E,this.t=y,this.u=C,this.h=null,this.i=new T.$Dc,this.v=null}getValue(i,n,o){return this.w(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=b.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this.h=null)}inspect(i,n,o){const l=this.w(i,n,o),f=this.A(n.resource,o),I=n.resource?this.t.get(n.resource)||this.s:this.s,L=new Set;for(const E of l.overrides)for(const y of E.identifiers)l.getOverrideValue(i,y)!==void 0&&L.add(y);return new p(i,n,l.getValue(i),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,f||void 0,I)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:f,removed:I}=r(this.j,i);n=[...l,...f,...I]}for(const l of n)for(const f of(0,m.$Ho)(l)){const I=this.j.getKeysForOverrideIdentifier(f),L=i.getKeysForOverrideIdentifier(f),E=[...L.filter(y=>I.indexOf(y)===-1),...I.filter(y=>L.indexOf(y)===-1),...I.filter(y=>!O.$io(this.j.override(f).getValue(y),i.override(f).getValue(y)))];o.push([f,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=r(this.l,i),f=[...n,...o,...l];return f.length&&this.updatePolicyConfiguration(i),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:f}=r(this.applicationConfiguration,i),I=[...n,...o,...l];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:f}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:f}=r(this.localUserConfiguration,i),I=[...n,...o,...l];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:f}=r(this.remoteUserConfiguration,i),I=[...n,...o,...l];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:f}=r(this.workspaceConfiguration,i),I=[...n,...o,...l];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:f}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:l,updated:f,removed:I,overrides:L}=r(o,n),E=[...l,...f,...I];return(E.length||!o)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:L}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:f,overrides:I}=r(n,void 0);return{keys:[...o,...l,...f],overrides:I}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,o){let l=this.x(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(l=l.merge(this.l)),l}x({resource:i},n){let o=this.y();if(n&&i){const l=n.getFolder(i);l&&(o=this.z(l.uri)||o);const f=this.t.get(i);f&&(o=o.merge(f))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const o=this.y(),l=this.r.get(i);l?(n=o.merge(l),this.i.set(i,n)):n=o}return n}A(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:f}=this.r.get(n);return i.push([n,{contents:o,overrides:l,keys:f}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i,n){const o=this.E(i.defaults,n),l=this.E(i.policy,n),f=this.E(i.application,n),I=this.E(i.user,n),L=this.E(i.workspace,n),E=i.folders.reduce((y,C)=>(y.set(w.URI.revive(C[0]),this.E(C[1],n)),y),new T.$Dc);return new P(o,l,f,I,b.createEmptyModel(n),L,E,b.createEmptyModel(n),new T.$Dc,n)}static E(i,n){return new b(i.contents,i.keys,i.overrides,void 0,n)}}e.$Po=P;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const l of a)l.keys.forEach(f=>i.add(f)),l.overrides.forEach(([f,I])=>{const L=(0,T.$Ac)(n,f,new Set);I.forEach(E=>L.add(E))});const o=[];return n.forEach((l,f)=>o.push([f,[...l.values()]])),{keys:[...i.values()],overrides:o}}class s{constructor(i,n,o,l,f){this.change=i,this.f=n,this.g=o,this.h=l,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const I of i.keys)this.affectedKeys.add(I);for(const[,I]of i.overrides)for(const L of I)this.affectedKeys.add(L);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const f=l+o.length;if(f>=this.d.length)return!1;const I=this.d.charCodeAt(f);if(I!==this.b&&I!==this.c)return!1;if(n){const L=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!O.$io(L,E)}return!0}}e.$Ro=s;function r(a,i){const{added:n,removed:o,updated:l}=t(i?.rawConfiguration,a?.rawConfiguration),f=[],I=a?.getAllOverrideIdentifiers()||[],L=i?.getAllOverrideIdentifiers()||[];if(i){const E=L.filter(y=>!I.includes(y));for(const y of E)f.push([y,i.getKeysForOverrideIdentifier(y)])}if(a){const E=I.filter(y=>!L.includes(y));for(const y of E)f.push([y,a.getKeysForOverrideIdentifier(y)])}if(i&&a){for(const E of I)if(L.includes(E)){const y=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});f.push([E,[...y.added,...y.removed,...y.updated]])}}return{added:n,removed:o,updated:l,overrides:f}}function t(a,i){const n=a?i?a.keys.filter(f=>i.keys.indexOf(f)===-1):[...a.keys]:[],o=i?a?i.keys.filter(f=>a.keys.indexOf(f)===-1):[...i.keys]:[],l=[];if(a&&i){for(const f of i.keys)if(a.keys.indexOf(f)!==-1){const I=(0,S.$ij)(i.contents,f),L=(0,S.$ij)(a.contents,f);O.$io(I,L)||l.push(f)}}return{added:n,removed:o,updated:l}}}),define(ce[220],le([0,1,19,3,2,30,13,78,48,10,59,44]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class u extends N.$Xc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new c.$ne),this.onDidChangeConfiguration=this.a.event,this.b=O.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(m.$ro.as(A.$wo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.f(Array.from(v),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,d){this.j(v,m.$ro.as(A.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=O.$Mo.createEmptyModel(this.c);const v=m.$ro.as(A.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,d){const p=this.g();for(const P of v){const g=p[P],s=d[P];g!==void 0?this.b.addValue(P,g):s?this.b.addValue(P,s.default):this.b.removeValue(P)}}}e.$So=u;class ${constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=O.$Mo.createEmptyModel(new w.$nk)}async initialize(){return this.configurationModel}}e.$To=$;let h=class extends N.$Xc{get configurationModel(){return this.b}constructor(v,d,p){super(),this.c=v,this.f=d,this.g=p,this.a=this.B(new c.$ne),this.onDidChangeConfiguration=this.a.event,this.b=O.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const d={},p=[],P=m.$ro.as(A.$wo.Configuration).getConfigurationProperties();for(const g of v){const s=P[g];if(!s){p.push(g);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}p.push(g),d[s.policy.name]={type:s.type}}}return(0,T.$tg)(d)||await this.f.updatePolicyDefinitions(d),p}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const d=m.$ro.as(A.$wo.Configuration).getPolicyConfigurations(),p=(0,R.$Kb)(v.map(P=>d.get(P)));this.m(p,!0)}m(v,d){this.g.trace("PolicyConfiguration#update",v);const p=m.$ro.as(A.$wo.Configuration).getConfigurationProperties(),P=[],g=this.b.isEmpty();for(const s of v){const r=p[s]?.policy?.name;if(r){const t=this.f.getPolicyValue(r);(g?t!==void 0:!(0,k.$io)(this.b.getValue(s),t))&&P.push([s,t])}else this.b.getValue(s)!==void 0&&P.push([s,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const s=this.b;this.b=O.$Mo.createEmptyModel(this.g);for(const r of s.keys)this.b.setValue(r,s.getValue(r));for(const[r,t]of P)t===void 0?this.b.removeValue(r):this.b.setValue(r,t);d&&this.a.fire(this.b)}}};e.$Uo=h,e.$Uo=h=ve([Y(1,S.$to),Y(2,w.$ak)],h)}),define(ce[221],le([0,1,19,6,15,3,34,65,2,35,30,5,21,22,78,48,220,7,59]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class P extends A.$Xc{constructor(r,t,a,i){super(),this.m=r,this.n=i,this.h=this.B(new k.$ne),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$So(i)),this.c=a instanceof p.$vo?new v.$To:this.B(new v.$Uo(this.b,a,i)),this.f=this.B(new h.$Oo(this.m,{},u.$$g,t,i)),this.a=new h.$Po(this.b.configurationModel,this.c.configurationModel,h.$Mo.createEmptyModel(i),h.$Mo.createEmptyModel(i),h.$Mo.createEmptyModel(i),h.$Mo.createEmptyModel(i),new w.$Dc,h.$Mo.createEmptyModel(i),new w.$Dc,i),this.j=new g(r,t,this),this.g=this.B(new c.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,t,a]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$Po(r,t,h.$Mo.createEmptyModel(this.n),a,h.$Mo.createEmptyModel(this.n),h.$Mo.createEmptyModel(this.n),new w.$Dc,h.$Mo.createEmptyModel(this.n),new w.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,t){const a=typeof r=="string"?r:void 0,i=(0,$.$bj)(r)?r:(0,$.$bj)(t)?t:{};return this.a.getValue(a,i,void 0)}async updateValue(r,t,a,i,n){const o=(0,$.$cj)(a)?a:(0,$.$bj)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,l=o?i:a;if(l!==void 0&&l!==$.ConfigurationTarget.USER_LOCAL&&l!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,R.$Pb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const f=this.inspect(r,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(f.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,S.$io)(t,f.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const L=o.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(y=>(0,R.$xb)([...y.identifiers].sort(),L));E&&(o.overrideIdentifiers=E.identifiers)}const I=o?.overrideIdentifiers?.length?[(0,b.$Io)(o.overrideIdentifiers),r]:[r];await this.j.write(I,t),await this.reloadConfiguration()}inspect(r,t={}){return this.a.inspect(r,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const t=this.a.toData(),a=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(a,t,$.ConfigurationTarget.USER)}s(r,t){const a=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(r,t);this.u(i,a,$.ConfigurationTarget.DEFAULT)}t(r){const t=this.a.toData(),a=this.a.compareAndUpdatePolicyConfiguration(r);this.u(a,t,$.ConfigurationTarget.DEFAULT)}u(r,t,a){const i=new h.$Ro(r,{data:t},this.a,void 0,this.n);i.source=a,this.h.fire(i)}}e.$Vo=P;class g{constructor(r,t,a){this.b=r,this.c=t,this.d=a,this.a=new c.$Nh}write(r,t){return this.a.queue(()=>this.e(r,t))}async e(r,t){let a;try{a=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw o}const i=[];if((0,T.$Yn)(a,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(a,r,t);a=(0,O.$do)(a,n),await this.c.writeFile(this.b,N.$Pe.fromString(a))}f(r,t,a){const{tabSize:i,insertSpaces:n,eol:o}=this.h;if(!t.length){const l=JSON.stringify(a,null,n?" ".repeat(i):"	");return[{content:l,length:l.length,offset:0}]}return(0,O.$ao)(r,t,a,{tabSize:i,insertSpaces:n,eol:o})}get h(){if(!this.g){let r=m.OS===m.OperatingSystem.Linux||m.OS===m.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(r=t),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[222],le([0,1,15,3,2,71]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ixb=e.$gxb=e.$fxb=void 0,e.$hxb=O;const T=(w,S,m)=>{const u=new Uint8Array(16);for(let b=0;b<16;b++)u[b]=Math.round(Math.random()*256);const $=(0,R.$0e)(R.$Pe.wrap(u));return[`GET ws://localhost${w}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$fxb=T,e.$gxb=R.$Pe.fromString(`\r
\r
`);async function O(w,S,m,u,$){w.write(R.$Pe.fromString((0,e.$fxb)(S,m,u)));const h=new N.$Wc;try{return await new Promise((b,v)=>{let d;h.add(w.onData(p=>{d?d=R.$Pe.concat([d,p],d.byteLength+p.byteLength):d=p;const P=d.indexOf(e.$gxb);if(P===-1)return;b(w),w.pauseData();const g=d.slice(P+e.$gxb.byteLength);g.byteLength&&$.onData.fire(g)})),h.add(w.onClose(p=>v(p??new Error("socket closed")))),h.add(w.onEnd(()=>v(new Error("socket ended"))))})}catch(b){throw w.dispose(),b}finally{h.dispose()}}class A extends N.$Xc{constructor(S,m){super(),this.g=S,this.a=this.B(new c.$qe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new c.$ne),this.onDidDispose=this.b.event,this.f=!1,this.B(m.onData),this.B(m.onData.event(u=>this.a.fire(u))),this.onClose=this.B(m.onClose).event,this.onEnd=this.B(m.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,m){k.SocketDiagnostics.traceSocketEvent(this,this.g,S,m)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ixb=A}),define(ce[105],le([0,1,8,4]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=w,e.$Rl=(0,c.$Gi)("remoteAuthorityResolverService");var N;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class k{constructor(m){this.id=m,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=k;class T{constructor(m,u){this.host=m,this.port=u,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=T;var O;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class A extends R.$eb{static isNotAvailable(m){return m instanceof A&&m._code===O.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof A&&m._code===O.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof A&&m._code===O.NoResolverFound}static isInvalidAuthority(m){return m instanceof A&&m._code===O.InvalidAuthority}static isHandled(m){return m instanceof A&&m.isHandled}constructor(m,u=O.Unknown,$){super(m),this._message=m,this._code=u,this._detail=$,this.isHandled=u===O.NotAvailable&&$===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Ul=A;function w(S){const m=S.indexOf("+");return m===-1?S:S.substring(0,m)}}),define(ce[223],le([0,1,6,15,26,8,3,2,23,101,55,32,71,105]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=f,e.$2l=I,e.$3l=E,w=ke(w);const h=30*1e3;var b;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function v(X){switch(X){case b.Management:return"Management";case b.ExtensionHost:return"ExtensionHost";case b.Tunnel:return"Tunnel"}}function d(X){const G=new N.$ye;return setTimeout(()=>G.cancel(),X),G.token}function p(X,G){if(X.isCancellationRequested||G.isCancellationRequested)return N.CancellationToken.Cancelled;const U=new N.$ye;return X.onCancellationRequested(()=>U.cancel()),G.onCancellationRequested(()=>U.cancel()),U.token}class P{get didTimeout(){return this.c==="timedout"}constructor(G){this.c="pending",this.d=new O.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$zh)(),G.isCancellationRequested?this.h():this.d.add(G.onCancellationRequested(()=>this.h()))}registerDisposable(G){this.c==="pending"?this.d.add(G):G.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(G))}reject(G){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(G))}}function g(X,G){const U=new P(G);return U.registerDisposable(X.onControlMessage(Q=>{const B=JSON.parse(Q.toString()),j=z(B);j?U.reject(j):U.resolve(B)})),U.promise}function s(X,G,U,Q,B,j,x,ee){const J=new P(ee),oe=S.$he.create(!1);return X.info(`Creating a socket (${x})...`),w.mark(`code/willCreateSocket/${j}`),G.connect(U,Q,B,x).then(ue=>{J.didTimeout?(w.mark(`code/didCreateSocketError/${j}`),X.info(`Creating a socket (${x}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${j}`),X.info(`Creating a socket (${x}) was successful after ${oe.elapsed()} ms.`),J.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${j}`),X.info(`Creating a socket (${x}) returned an error after ${oe.elapsed()} ms.`),X.error(ue),J.reject(ue)}),J.promise}function r(X,G){const U=new P(G);return X.then(Q=>{U.didTimeout||U.resolve(Q)},Q=>{U.didTimeout||U.reject(Q)}),U.promise}async function t(X,G,U,Q){const B=q(X,G);X.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let j;try{j=await s(X.logService,X.remoteSocketFactoryService,X.connectTo,A.$Tg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,v(G),`renderer-${v(G)}-${X.reconnectionToken}`,Q)}catch(ue){throw X.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ue),ue}X.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let x,ee;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(j,null),x=X.reconnectionProtocol,ee=!1):(x=new u.$ui({socket:j}),ee=!0),X.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const J=await r(X.signService.createNewMessage((0,m.$3g)()),Q),oe={type:"auth",auth:X.connectionToken||"00000000000000000000",data:J.data};x.sendControl(c.$Pe.fromString(JSON.stringify(oe)));try{const ue=await g(x,p(Q,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(X.logService.trace(`${B} 4/6. received SignRequest control message.`),!await r(X.signService.validate(J,ue.signedData),Q)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const pe=await r(X.signService.sign(ue.data),Q),Ie={type:"connectionType",commit:X.commit,signedData:pe,desiredConnectionType:G};return U&&(Ie.args=U),X.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(c.$Pe.fromString(JSON.stringify(Ie))),{protocol:x,ownsProtocol:ee}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(X.logService.error(`${B} the handshake timed out. Error:`),X.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${B} received error control message when negotiating connection. Error:`),X.logService.error(ue)),ee&&V(x),ue}}async function a(X,G,U,Q){const B=Date.now(),j=q(X,G),{protocol:x,ownsProtocol:ee}=await t(X,G,U,Q),J=new P(Q);return J.registerDisposable(x.onControlMessage(oe=>{const ue=JSON.parse(oe.toString()),ge=z(ue);ge?(X.logService.error(`${j} received error control message when negotiating connection. Error:`),X.logService.error(ge),ee&&V(x),J.reject(ge)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Z(B)}!`),J.resolve({protocol:x,firstMessage:ue}))})),J.promise}async function i(X,G){const{protocol:U}=await a(X,b.Management,void 0,G);return{protocol:U}}async function n(X,G,U){const{protocol:Q,firstMessage:B}=await a(X,b.ExtensionHost,G,U),j=B&&B.debugPort;return{protocol:Q,debugPort:j}}async function o(X,G,U){const Q=Date.now(),B=q(X,b.Tunnel),{protocol:j}=await t(X,b.Tunnel,G,U);return X.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Z(Q)}!`),j}async function l(X,G,U){const{connectTo:Q,connectionToken:B}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:Q,connectionToken:B,reconnectionToken:G,reconnectionProtocol:U,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function f(X,G,U){return L(X,async Q=>{const{protocol:B}=await i(Q,N.CancellationToken.None);return new H(X,G,U,Q.reconnectionToken,B)})}async function I(X,G){return L(X,async U=>{const{protocol:Q,debugPort:B}=await n(U,G,N.CancellationToken.None);return new ie(X,G,U.reconnectionToken,Q,B)})}async function L(X,G){for(let Q=1;;Q++)try{const B=(0,m.$3g)(),j=await l(X,B,null);return await G(j)}catch(B){if(Q<5)X.logService.error(`[remote-connection][attempt ${Q}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(B);else throw X.logService.error(`[remote-connection][attempt ${Q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(B),_.triggerPermanentFailure(0,0,$.$Ul.isHandled(B)),B}}async function E(X,G,U){const Q=await l(X,(0,m.$3g)(),null);return await o(Q,{host:G,port:U},N.CancellationToken.None)}function y(X){return(0,R.$th)(G=>new Promise((U,Q)=>{const B=setTimeout(U,X*1e3);G.onCancellationRequested(()=>{clearTimeout(B),U()})}))}var C;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class F{constructor(G,U){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.type=C.ConnectionLost}}e.$4l=F;class D{constructor(G,U,Q,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.durationSeconds=Q,this.c=B,this.type=C.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=D;class M{constructor(G,U,Q){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=Q,this.type=C.ReconnectionRunning}}e.$6l=M;class K{constructor(G,U,Q){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=Q,this.type=C.ConnectionGain}}e.$7l=K;class W{constructor(G,U,Q,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=Q,this.handled=B,this.type=C.ReconnectionPermanentFailure}}e.$8l=W;class _ extends O.$Xc{static triggerPermanentFailure(G,U,Q){this._permanentFailure=!0,this.f=G,this.g=U,this.h=Q,this.j.forEach(B=>B.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(G=>G.y())}static debugPauseSocketWriting(){this.j.forEach(G=>G.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||_._permanentFailure}constructor(G,U,Q,B,j){super(),this.t=G,this.u=U,this.reconnectionToken=Q,this.protocol=B,this.w=j,this.m=this.B(new T.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new K(this.reconnectionToken,0,0)),this.B(B.onSocketClose(x=>{const ee=he(this.t,this.reconnectionToken,!0);x?x.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ee} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(B.onSocketTimeout(x=>{const ee=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),_.j.push(this),this.B((0,O.$Vc)(()=>{const x=_.j.indexOf(this);x>=0&&_.j.splice(x,1)})),this.n&&this.D(_.f,_.g,_.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const G=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const B=Q<U.length?U[Q]:U[U.length-1];try{if(B>0){const x=y(B);this.m.fire(new D(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,x)),this.u.logService.info(`${G} waiting for ${B} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this.u.logService.info(`${G} resolving connection...`);const j=await l(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${G} connecting to ${j.connectTo}...`),await this.G(j,d(h)),this.u.logService.info(`${G} reconnected!`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this.u.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if($.$Ul.isTemporarilyNotAvailable(j)){this.u.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this.u.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((0,k.$7)(j)){this.u.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if(j instanceof $.$Ul){this.u.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,$.$Ul.isHandled(j));break}this.u.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this.n&&!this.s)}C(G,U,Q){this.w?_.triggerPermanentFailure(G,U,Q):this.D(G,U,Q)}D(G,U,Q){this.m.fire(new W(this.reconnectionToken,G,U,Q)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=_;class H extends _{constructor(G,U,Q,B,j){super(b.Management,G,B,j,!0),this.client=this.B(new u.$si(j,{remoteAuthority:U,clientId:Q},G.ipcLogger))}async G(G,U){await i(G,U)}}e.$0l=H;class ie extends _{constructor(G,U,Q,B,j){super(b.ExtensionHost,G,Q,B,!1),this.H=U,this.debugPort=j}async G(G,U){await n(G,this.H,U)}}e.$$l=ie;function V(X){try{X.acceptDisconnect();const G=X.getSocket();X.dispose(),G.dispose()}catch(G){(0,k.$3)(G)}}function z(X){if(X&&X.type==="error"){const G=new Error(`Connection error: ${X.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function te(X,G){for(;X.length<G;)X+=" ";return X}function se(X,G){return`[remote-connection][${te(v(X),13)}][${G.substr(0,5)}\u2026]`}function he(X,G,U){return`${se(X,G)}[${U?"reconnect":"initial"}]`}function q(X,G){return`${he(G,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function Z(X){return`${Date.now()-X} ms`}}),define(ce[106],le([0,1,23]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=c,e.$in=N,e.$jn=k,e.$kn=T;function c(A){return A.scheme===R.Schemas.vscodeRemote?A.authority:void 0}function N(A){if(!A)return;const w=A.indexOf("+");return w<0?A:A.substr(0,w)}function k(A){const{host:w,port:S}=O(A);if(typeof S>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:S}}function T(A,w){let{host:S,port:m}=O(A);return typeof m>"u"&&(m=w),{host:S,port:m}}function O(A){const w=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const S=A.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=A.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:A,port:void 0}}}),define(ce[36],le([0,1,27,4,106]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=k,e.$un=m,e.$vn=u,e.$wn=$,e.$xn=h,e.$yn=b,e.$zn=v,R=ke(R),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function k(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(T||(e.ExtensionType=T={}));var O;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class A{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,P){if(typeof p>"u"||p===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof p=="string"||typeof P=="string"){const g=typeof p=="string"?p:p.value,s=typeof P=="string"?P:P.value;return R.$Hf(g,s)}return p._lower===P._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$rn=A;class w{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const P of p)this.add(P)}add(p){this.c.add(A.toKey(p))}delete(p){return this.c.delete(A.toKey(p))}has(p){return this.c.has(A.toKey(p))}}e.$sn=w;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(A.toKey(p))}get(p){return this.c.get(A.toKey(p))}has(p){return this.c.has(A.toKey(p))}set(p,P){this.c.set(A.toKey(p),P)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=S;function m(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function $(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function h(d,p){if(p){const P=`onResolveRemoteAuthority:${(0,N.$in)(p)}`;return!!d.activationEvents?.includes(P)}return!1}function b(d){return d.map(p=>{const[P,g]=p.split("@");return{proposalName:P,version:g?parseInt(g):void 0}})}function v(d){return d.map(p=>p.split("@")[0])}e.$An=(0,c.$Gi)("IBuiltinExtensionsScannerService")}),define(ce[28],le([0,1,5,163,36,4]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=O,e.$ep=A,e.$fp=w,e.$gp=S,e.$hp=m,e.$ip=u,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var T;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function O(s){switch(s){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function A(s){switch(s){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function w(s,r){switch(s){case R.Platform.Windows:return r==="x64"?N.TargetPlatform.WIN32_X64:r==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Linux:return r==="x64"?N.TargetPlatform.LINUX_X64:r==="arm64"?N.TargetPlatform.LINUX_ARM64:r==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?N.TargetPlatform.ALPINE_X64:r==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Mac:return r==="x64"?N.TargetPlatform.DARWIN_X64:r==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Web:return N.TargetPlatform.WEB}}function S(s,r){return r===N.TargetPlatform.WEB&&!s.includes(N.TargetPlatform.WEB)}function m(s,r,t){return S(r,t)?!1:s===N.TargetPlatform.UNDEFINED||s===N.TargetPlatform.UNIVERSAL?!0:s===N.TargetPlatform.UNKNOWN?!1:s===t}function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var $;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var b;(function(s){s.Install="install",s.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$jp=(0,k.$Gi)("extensionGalleryService");var d;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class p extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.$kp=p;var P;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateExistingMetadata="UpdateExistingMetadata",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class g extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.$lp=g,e.$mp=(0,k.$Gi)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,k.$Gi)("IGlobalExtensionEnablementService"),e.$qp=(0,k.$Gi)("IExtensionTipsService"),e.$rp=(0,c.localize2)(0,"Extensions"),e.$sp=(0,c.localize2)(1,"Preferences")}),define(ce[224],le([0,1,3,2,30,9,95,28]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0;function A(v,d){return v?k.URI.revive(d?d.transformIncoming(v):v):void 0}function w(v,d){return d?d.transformOutgoingURI(v):v}function S(v,d){d=d||T.$Nn;const p=v.manifest;return{...(0,T.$Qn)({...v,manifest:void 0},d),manifest:p}}function m(v,d){return v?.profileLocation?(0,T.$Qn)(v,d??T.$Nn):v}function u(v,d){return d?(0,N.$go)(v,p=>p instanceof k.URI?d.transformOutgoingURI(p):void 0):v}class ${constructor(d,p){this.a=d,this.b=p,this.onInstallExtension=R.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,p){const P=this.b(d);switch(p){case"onInstallExtension":return R.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,P):g.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,g=>g.map(s=>({...s,local:s.local?u(s.local,P):s.local,profileLocation:s.profileLocation?w(s.profileLocation,P):s.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,P):g.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,P):g.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,g=>({local:u(g.local,P),profileLocation:w(g.profileLocation,P)}))}throw new Error("Invalid listen")}async call(d,p,P){const g=this.b(d);switch(p){case"zip":{const s=S(P[0],g),r=await this.a.zip(s);return w(r,g)}case"unzip":return this.a.unzip(A(P[0],g));case"install":return this.a.install(A(P[0],g),m(P[1],g));case"installFromLocation":return this.a.installFromLocation(A(P[0],g),A(P[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],A(P[1],g),A(P[2],g));case"getManifest":return this.a.getManifest(A(P[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],m(P[1],g));case"installGalleryExtensions":{const s=P[0];return this.a.installGalleryExtensions(s.map(({extension:r,options:t})=>({extension:r,options:m(t,g)??{}})))}case"uninstall":return this.a.uninstall(S(P[0],g),m(P[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(P[0],g));case"getInstalled":return(await this.a.getInstalled(P[0],A(P[1],g),P[2])).map(r=>u(r,g));case"toggleAppliationScope":{const s=await this.a.toggleAppliationScope(S(P[0],g),A(P[1],g));return u(s,g)}case"copyExtensions":return this.a.copyExtensions(A(P[0],g),A(P[1],g));case"updateMetadata":{const s=await this.a.updateMetadata(S(P[0],g),P[1],A(P[2],g));return u(s,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$vq=$;class h extends c.$Xc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(d){super(),this.m=d,this.c=this.B(new R.$ne),this.f=this.B(new R.$ne),this.g=this.B(new R.$ne),this.h=this.B(new R.$ne),this.j=this.B(new R.$ne),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?k.URI.revive(p.source):p.source,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(P=>({...P,local:P.local?S(P.local,null):P.local,source:this.r(P.source)?k.URI.revive(P.source):P.source,profileLocation:k.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:k.URI.revive(p.profileLocation),local:S(p.local,null)})))}n(d,p){d.fire(p)}r(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(d){const p=await this.getTargetPlatform();return d.allTargetPlatforms.some(P=>(0,O.$hp)(P,d.allTargetPlatforms,p))}zip(d){return Promise.resolve(this.m.call("zip",[d]).then(p=>k.URI.revive(p)))}unzip(d){return Promise.resolve(this.m.call("unzip",[d]))}install(d,p){return Promise.resolve(this.m.call("install",[d,p])).then(P=>S(P,null))}installFromLocation(d,p){return Promise.resolve(this.m.call("installFromLocation",[d,p])).then(P=>S(P,null))}async installExtensionsFromProfile(d,p,P){return(await this.m.call("installExtensionsFromProfile",[d,p,P])).map(s=>S(s,null))}getManifest(d){return Promise.resolve(this.m.call("getManifest",[d]))}installFromGallery(d,p){return Promise.resolve(this.m.call("installFromGallery",[d,p])).then(P=>S(P,null))}async installGalleryExtensions(d){return(await this.m.call("installGalleryExtensions",[d])).map(P=>({...P,local:P.local?S(P.local,null):P.local,source:this.r(P.source)?k.URI.revive(P.source):P.source,profileLocation:k.URI.revive(P.profileLocation)}))}uninstall(d,p){if(d.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[d,p]))}reinstallFromGallery(d){return Promise.resolve(this.m.call("reinstallFromGallery",[d])).then(p=>S(p,null))}getInstalled(d=null,p,P){return Promise.resolve(this.m.call("getInstalled",[d,p,P])).then(g=>g.map(s=>S(s,null)))}updateMetadata(d,p,P){return Promise.resolve(this.m.call("updateMetadata",[d,p,P])).then(g=>S(g,null))}toggleAppliationScope(d,p){return this.m.call("toggleAppliationScope",[d,p]).then(P=>S(P,null))}copyExtensions(d,p){return this.m.call("copyExtensions",[d,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(d,p,P){const g=await this.m.call("download",[d,p,P]);return k.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$wq=h;class b{constructor(d){this.a=d}listen(d,p){throw new Error("Invalid listen")}call(d,p,P){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$xq=b}),define(ce[225],le([0,1,2,36,7]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class k extends R.$Xc{constructor(O,A,w,S,m){super(),this.a=O,this.b=A,this.c=w,this.f=m,this.B(S.onDidInstallExtensions(u=>this.g(u))),this.B(S.onDidUninstallExtension(u=>this.h(u)))}g(O){for(const A of O)A.local&&this.invalidate(A.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,O)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,c.$ln))}catch(A){(0,N.$rl)(A)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$Uq=k});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[60],le([0,1,21,92,168,61,36,196]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=S,e.$Yp=m,e.$Zp=u,e.$1p=$,e.$2p=h,e.$3p=b,e.$4p=v,e.$5p=d,c=it(c),N=ke(N),k=ke(k);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function S(g){return g=g.trim(),g==="*"||A.test(g)}function m(g){if(!S(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=g.match(A);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function u(g){if(!g)return null;const s=g.majorBase,r=g.majorMustEqual,t=g.minorBase;let a=g.minorMustEqual;const i=g.patchBase;let n=g.patchMustEqual;g.hasCaret&&(s===0||(a=!1),n=!1);let o=0;if(g.preRelease){const l=w.exec(g.preRelease);if(l){const[,f,I,L]=l;o=Date.UTC(Number(f),Number(I)-1,Number(L))}}return{majorBase:s,majorMustEqual:r,minorBase:t,minorMustEqual:a,patchBase:i,patchMustEqual:n,isMinimum:g.hasGreaterEquals,notBefore:o}}function $(g,s,r){let t;typeof g=="string"?t=u(m(g)):t=g;let a;s instanceof Date?a=s.getTime():typeof s=="string"&&(a=new Date(s).getTime());let i;if(typeof r=="string"?i=u(m(r)):i=r,!t||!i)return!1;const n=t.majorBase,o=t.minorBase,l=t.patchBase;let f=i.majorBase,I=i.minorBase,L=i.patchBase;const E=i.notBefore;let y=i.majorMustEqual,C=i.minorMustEqual,F=i.patchMustEqual;return i.isMinimum?n>f?!0:n<f?!1:o>I?!0:o<I||a&&a<E?!1:l>=L:(n===1&&f===0&&(!y||!C||!F)&&(f=1,I=0,L=0,y=!0,C=!1,F=!1),n<f?!1:n>f?!y:o<I?!1:o>I?!C:l<L?!1:l>L?!F:!(a&&a<E))}function h(g,s,r,t,a){const i=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return i.push([c.default.Error,N.localize(0,null)]),i;if(typeof t.name!="string")return i.push([c.default.Error,N.localize(1,null,"name")]),i;if(typeof t.version!="string")return i.push([c.default.Error,N.localize(2,null,"version")]),i;if(!t.engines)return i.push([c.default.Error,N.localize(3,null,"engines")]),i;if(typeof t.engines.vscode!="string")return i.push([c.default.Error,N.localize(4,null,"engines.vscode")]),i;if(typeof t.extensionDependencies<"u"&&!P(t.extensionDependencies))return i.push([c.default.Error,N.localize(5,null,"extensionDependencies")]),i;if(typeof t.activationEvents<"u"){if(!P(t.activationEvents))return i.push([c.default.Error,N.localize(6,null,"activationEvents")]),i;if(typeof t.main>"u"&&typeof t.browser>"u")return i.push([c.default.Error,N.localize(7,null,"activationEvents","main","browser")]),i}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&i.push([c.default.Warning,N.localize(8,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return i.push([c.default.Error,N.localize(9,null,"main")]),i;{const l=(0,R.$hh)(r,t.main);(0,R.$bh)(l,r)||i.push([c.default.Warning,N.localize(10,null,l.path,r.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return i.push([c.default.Error,N.localize(11,null,"browser")]),i;{const l=(0,R.$hh)(r,t.browser);(0,R.$bh)(l,r)||i.push([c.default.Warning,N.localize(12,null,l.path,r.path)])}}if(!k.valid(t.version))return i.push([c.default.Error,N.localize(13,null)]),i;const n=[];if(!b(g,s,t,a,n))for(const l of n)i.push([c.default.Error,l]);if(t.enabledApiProposals?.length){const l=[];if(!d([...t.enabledApiProposals],l))for(const f of l)i.push([c.default.Error,f])}return i}function b(g,s,r,t,a){return t||typeof r.main>"u"&&typeof r.browser>"u"?!0:p(g,s,r.engines.vscode,a)}function v(g,s,r){return g==="*"||p(s,r,g)}function d(g,s){if(g.length===0)return!0;const r=Array.isArray(s)?s:void 0,t=(r?void 0:s)??O.allApiProposals,a=[],i=(0,T.$yn)(g);for(const{proposalName:n,version:o}of i){const l=t[n];l&&o&&l.version!==o&&a.push(N.localize(14,null,n))}return r?.push(...a),a.length===0}function p(g,s,r,t=[]){const a=u(m(r));if(!a)return t.push(N.localize(15,null,r)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return t.push(N.localize(16,null,r)),!1}else if(!a.majorMustEqual)return t.push(N.localize(17,null,r)),!1;return $(g,s,a)?!0:(t.push(N.localize(18,null,g,r)),!1)}function P(g){if(!Array.isArray(g))return!1;for(let s=0,r=g.length;s<r;s++)if(typeof g[s]!="string")return!1;return!0}}),define(ce[79],le([0,1,26,2,5,173,28,4]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0,e.$9r=A;function A(S){return S.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.$0r=(0,O.$Gi)("languagePackService");let w=class extends c.$Xc{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new R.$ye;setTimeout(()=>m.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const h=u.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(v=>v.startsWith("lp-"))).map(b=>{const v=b.properties.localizedLanguages?.[0],d=A(b);return{...this.f(d,v,b),extensionId:b.identifier.id,galleryExtension:b}});return h.push(this.f("en","English")),h}f(m,u,$){const h=u??m;let b;if(h!==m&&(b=`(${m})`),m.toLowerCase()===N.$w.toLowerCase()&&(b??="",b+=(0,k.localize)(0,null)),$?.installCount){b??="";const v=$.installCount;let d;v>1e6?d=`${Math.floor(v/1e5)/10}M`:v>1e3?d=`${Math.floor(v/1e3)}K`:d=String(v),b+=` $(cloud-download) ${d}`}return{id:m,label:h,description:b}}};e.$$r=w,e.$$r=w=ve([Y(0,T.$jp)],w)}),define(ce[226],le([0,1,2,79]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let N=class extends R.$Xc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$hhc=N,e.$hhc=N=ve([Y(0,c.$0r)],N)}),define(ce[107],le([0,1,2,4]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,c.$Gi)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,O){return this.a[T]??=[],this.a[T].push(O),(0,R.$Vc)(()=>{const A=this.a[T]?.indexOf(O);typeof A=="number"&&A>=0&&this.a[T]?.splice(A,1)})}b(T){return(this.a[T.type]||[]).find(A=>A.supports(T))}connect(T,O,A,w){const S=this.b(T);if(!S)throw new Error(`No socket factory found for ${T}`);return S.connect(T,O,A,w)}}e.$Xl=N}),define(ce[227],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0,e.$uhc=(0,R.$Gi)("sharedProcessTunnelService"),e.$vhc="sharedProcessTunnel"}),define(ce[108],le([0,1,4,175]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=e.$Dhc=e.$Chc=e.$Bhc=e.TunnelStates=e.$Ahc=e.$zhc=void 0,e.$zhc=(0,R.$Gi)("IRemoteTunnelService"),e.$Ahc={active:!1};var N;(function(k){k.disconnected=T=>({type:"disconnected",onTokenFailed:T}),k.connected=(T,O)=>({type:"connected",info:T,serviceInstallFailed:O}),k.connecting=T=>({type:"connecting",progress:T}),k.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$Bhc="remote.tunnels.access",e.$Chc=e.$Bhc+".hostNameOverride",e.$Dhc=e.$Bhc+".preventSleep",e.$Ehc="remoteTunnelService",e.$Fhc=(0,c.localize)(0,null)}),define(ce[62],le([0,1,15,8,2,177,48,4,10,44]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=u,e.$9p=$,e.$0p=h,e.$$p=b,e.$_p=v,e.$aq=d,e.$6p=(0,O.$Gi)("requestService");class S{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?s[r]="*****":s[r]=this.b[r];this.a=s}return this.a}}class m extends N.$Xc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,k.localize)(0,null),when:A.$sk.isEqualTo((0,A.$pk)(A.LogLevel.Trace)).serialize()})}async c(s,r,t){const a=`${s} #${++this.b}: ${r.url}`;this.a.trace(`${a} - begin`,r.type,new S(r.headers??{}));try{const i=await t();return this.a.trace(`${a} - end`,r.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${a} - error`,r.type,(0,c.$ab)(i)),i}}}e.$7p=m;function u(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function $(g){return g.res.statusCode===204}async function h(g){return $(g)?null:(await(0,R.$2e)(g.stream)).toString()}async function b(g){if(!u(g))throw new Error("Server returned "+g.res.statusCode);return h(g)}async function v(g){if(!u(g))throw new Error("Server returned "+g.res.statusCode);if($(g))return null;const r=(await(0,R.$2e)(g.stream)).toString();try{return JSON.parse(r)}catch(t){throw t.message+=`:
`+r,t}}function d(g){P(g)}let p;function P(g){const s=w.$ro.as(T.$wo.Configuration),r=p;p={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null),(0,k.localize)(10,null)],default:"override",description:(0,k.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(13,null),restricted:!0}}},s.updateConfigurations({add:[p],remove:r?[r]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(ce[228],le([0,1,26,23,7,62]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let T=class{constructor(A,w){this.a=A,this.b=w}async download(A,w,S=R.CancellationToken.None){if(A.scheme===c.Schemas.file||A.scheme===c.Schemas.vscodeRemote){await this.b.copy(A,w);return}const m={type:"GET",url:A.toString(!0)},u=await this.a.request(m,S);if(u.res.statusCode===200)await this.b.writeFile(w,u.stream);else{const $=await(0,k.$$p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${$}`)}}};e.$DR=T,e.$DR=T=ve([Y(0,k.$6p),Y(1,N.$al)],T)}),define(ce[229],le([0,1,15,26]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class N{constructor(O){this.a=O}listen(O,A){throw new Error("Invalid listen")}call(O,A,w,S=c.CancellationToken.None){switch(A){case"request":return this.a.request(w[0],S).then(async({res:m,stream:u})=>{const $=await(0,R.$2e)(u);return[{statusCode:m.statusCode,headers:m.headers},$]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$as=N;class k{constructor(O){this.a=O}async request(O,A){const[w,S]=await this.a.call("request",[O],A);return{res:w,stream:(0,R.$4e)(S)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$bs=k}),define(ce[230],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=void 0,e.$5fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$6fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$7fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[231],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const k=await this.c();if(k){const T=String(R.a++);return this.b.set(T,k),{id:T,data:k.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,k){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(k)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$Qbc=R}),define(ce[109],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,R.$Gi)(e.$Yl)}),define(ce[232],le([0,1,231]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class c extends R.$Qbc{c(){return this.h().then(k=>new k.validator)}d(k){return this.h().then(T=>new T.signer().sign(k))}h(){return new Promise((k,T)=>ne(["vsda"],k,T))}}e.$Wgc=c}),define(ce[80],le([0,1,3,2]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TMb=e.$SMb=e.$RMb=e.$QMb=void 0;class N extends c.$Xc{constructor(m,u,$){super(),this.a=m,this.b=u,this.c=$}async getItems(){const m={profile:this.b,workspace:this.c},u=await this.a.call("getItems",m);return new Map(u)}updateItems(m){const u={profile:this.b,workspace:this.c};return m.insert&&(u.insert=Array.from(m.insert.entries())),m.delete&&(u.delete=Array.from(m.delete.values())),this.a.call("updateItems",u)}optimize(){const m={profile:this.b,workspace:this.c};return this.a.call("optimize",m)}}class k extends N{constructor(m,u){super(m,u,void 0),this.f=this.B(new R.$ne),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(m=>this.h(m)))}h(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this.f.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}}class T extends k{constructor(m){super(m,void 0)}async close(){this.dispose()}}e.$QMb=T;class O extends k{constructor(m,u){super(m,u)}async close(){this.dispose()}}e.$RMb=O;class A extends N{constructor(m,u){super(m,void 0,u),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$SMb=A;class w{constructor(m){this.a=m}isUsed(m){const u={payload:m,profile:void 0,workspace:void 0};return this.a.call("isUsed",u)}}e.$TMb=w}),define(ce[110],le([0,1,5,37,32]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=T,e.$up=O;function k(A){if(R.$u===R.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function T(A,w,S,m,u,$,h,b,v,d){const p=Object.create(null);p["common.machineId"]=$,p["common.sqmId"]=h,p["common.devDeviceId"]=b,p.sessionID=(0,N.$3g)()+Date.now(),p.commitHash=m,p.version=u,p["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,R.$h)(R.$u),p["common.nodePlatform"]=c.$gc,p["common.nodeArch"]=S,p["common.product"]=d||"desktop",v&&(p["common.msftInternal"]=v);let P=0;const g=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),R.$l&&(p["common.snap"]="true");const s=k(w);return s&&(p["common.platformDetail"]=s),p}function O(A){const w=c.env.USERDNSDOMAIN;if(!w)return!1;const S=w.toLowerCase();return A.some(m=>S===m)}}),define(ce[18],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,R.$Gi)("telemetryService"),e.$am=(0,R.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var c;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var N;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(ce[233],le([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Ws=p,e.$Xs=g,e.$Ys=s,R=ke(R);const d=new Map;async function p(t,a){const i=`${t}::${a.join(":")}`,n=d.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,f=new Map,I=2e4;function L(y,C,F,D){const M=C.substring(y.length+1);return c.Promises.withAsyncBody(async K=>{let W;D.readdirCount++;try{W=await m.Promises.readdir(C,{withFileTypes:!0})}catch{K();return}if(D.count>=I){D.count+=W.length,D.maxReached=!0,K();return}let _=W.length;if(_===0){K();return}let H=W;D.count+W.length>I&&(D.maxReached=!0,_=I-D.count,H=W.slice(0,_)),D.count+=W.length;for(const ie of H)if(ie.isDirectory()){if(F.includes(ie.name)||await L(y,(0,T.$mc)(C,ie.name),F,D),--_===0){K();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&l.set(z,(l.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(ie.name)&&f.set(z.tag,(f.get(z.tag)??0)+1);if(--_===0){K();return}}})}const E=c.Promises.withAsyncBody(async y=>{const C={count:0,maxReached:!1,readdirCount:0},F=new A.$he(!0);await L(t,t,a,C);const D=await s(t);y({configFiles:P(f),fileTypes:P(l),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:D,totalScanTime:F.elapsed(),totalReaddirCount:C.readdirCount})});return d.set(i,E),E}function P(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function g(){const t={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.$Il.GB).toFixed(2)}GB (${(R.freemem()/h.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$Sn.value()*100)}%`},a=R.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}async function s(t){try{const a=new Map,i=(0,T.$mc)(t,".vscode","launch.json"),n=await m.Promises.readFile(i),o=[],l=(0,N.$Yn)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,N.$7n)(l)==="object"&&l.configurations)for(const f of l.configurations){const I=f.type;I&&(a.has(I)?a.set(I,a.get(I)+1):a.set(I,1))}return P(a)}catch{return[]}}let r=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const n=R.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(R.totalmem()/h.$Il.GB).toFixed(2)}GB (${(R.freemem()/h.$Il.GB).toFixed(2)}GB free)`),O.$i||i.push(`Load (avg):       ${R.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(S.$Sn.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,u.$Vs)(a.mainPID),this.k(a)]).then(async n=>{let[o,l]=n,f=this.m(a,o);return i.forEach(I=>{if((0,$.$Um)(I))f+=`
${I.errorMessage}`,l+=`
${I.errorMessage}`;else if(f+=`

Remote: ${I.hostName}`,I.processes&&(f+=`
${this.m(a,I.processes)}`),I.workspaceMetadata){l+=`
|  Remote: ${I.hostName}`;for(const L of Object.keys(I.workspaceMetadata)){const E=I.workspaceMetadata[L];let y=`${E.fileCount} files`;E.maxFilesReached&&(y=`more than ${y}`),l+=`|    Folder (${L}): ${y}`,l+=this.h(E)}}}),{processInfo:f,workspaceInfo:l}})}async getSystemInfo(a,i){const{memory:n,vmHint:o,os:l,cpus:f}=g(),I={os:l,memory:n,cpus:f,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return O.$i||(I.load=`${R.loadavg().map(L=>Math.round(L)).join(", ")}`),O.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(a,i){const n=[];return(0,u.$Vs)(a.mainPID).then(async o=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,o)),a.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(l=>{if((0,$.$Um)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(a,l.processes)),l.workspaceMetadata)for(const f of Object.keys(l.workspaceMetadata)){const I=l.workspaceMetadata[f];let L=`${I.fileCount} files`;I.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${f}): ${L}`),n.push(this.h(I))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let o=0;const l=(E,y)=>{const C=` ${E}(${y})`;o+C.length>60?(i.push(f),f="|                 ",o=f.length):o+=C.length,f+=C};let f="|      File types:";const I=10,L=a.fileTypes.length>I?I:a.fileTypes.length;for(let E=0;E<L;E++){const y=a.fileTypes[E];l(y.name,y.count)}if(i.push(f),a.configFiles.length>=0&&(f="|      Conf files:",o=0,a.configFiles.forEach(E=>{l(E.name,E.count)}),i.push(f)),a.launchConfigFiles.length>0){let E="|      Launch Configs:";a.launchConfigFiles.forEach(y=>{const C=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;E+=C}),i.push(E)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const f=w.URI.revive(l);if(f.scheme===k.Schemas.file){const I=f.fsPath;n.push(p(I,["node_modules",".git"]).then(L=>{let E=`${L.fileCount} files`;L.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,T.$qc)(I)}): ${E}`),i.push(this.h(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${I} (${L.toString()})`)}))}else i.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(a,i){const n=new Map;a.windows.forEach(l=>n.set(l.pid,`window [${l.id}] (${l.title})`)),a.pidToNames.forEach(({pid:l,name:f})=>n.set(l,f));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,o,i,0),o.join(`
`)}n(a,i,n,o,l){const f=l===0;let I;f?I=o.pid===a?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?I=i.get(o.pid):I=`${"  ".repeat(l)} ${o.name}`;const L=process.platform==="win32"?o.mem:R.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/h.$Il.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(a,i,n,E,l+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const o=w.URI.revive(n);if(o.scheme!==k.Schemas.file)continue;const l=o.fsPath;try{(await p(l,["node_modules",".git"])).fileTypes.forEach(I=>i.add(I.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=w.URI.revive(i);if(n.scheme!==k.Schemas.file)continue;const o=n.fsPath;try{const l=await p(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),l.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),l.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),l.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:f.name,count:f.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:l.totalScanTime,reachedLimit:l.maxFilesReached,fileCount:l.fileCount,readdirCount:l.totalReaddirCount})}catch{}}}};e.$Zs=r,e.$Zs=r=ve([Y(0,v.$_l),Y(1,b.$tk)],r)}),define(ce[111],le([0,1,8,4,10,18]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.ExtensionSignatureVerificationCode=e.$rq=void 0,e.$rq=(0,c.$Gi)("IExtensionSignatureVerificationService");var T;(function(w){w.Success="Success",w.RequiredArgumentMissing="RequiredArgumentMissing",w.InvalidArgument="InvalidArgument",w.PackageIsUnreadable="PackageIsUnreadable",w.UnhandledException="UnhandledException",w.SignatureManifestIsMissing="SignatureManifestIsMissing",w.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",w.SignatureIsMissing="SignatureIsMissing",w.SignatureIsUnreadable="SignatureIsUnreadable",w.CertificateIsUnreadable="CertificateIsUnreadable",w.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",w.FileAlreadyExists="FileAlreadyExists",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",w.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",w.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",w.SignatureIsInvalid="SignatureIsInvalid",w.SignatureManifestIsInvalid="SignatureManifestIsInvalid",w.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",w.EntryIsMissing="EntryIsMissing",w.EntryIsTampered="EntryIsTampered",w.Untrusted="Untrusted",w.CertificateRevoked="CertificateRevoked",w.SignatureIsNotValid="SignatureIsNotValid",w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class O extends Error{constructor(S){super(S),this.code=S}}e.$sq=O;let A=class{constructor(S,m){this.b=S,this.c=m}d(){return this.a||(this.a=new Promise((S,m)=>ne(["@vscode/vsce-sign"],async u=>S(u),m))),this.a}async verify(S,m,u,$){let h;const b=S.identifier.id;try{h=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,R.$ab)(P)),this.b.info(`Extension signature verification is not done: ${b}`),!1}const v=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${b}...`),d=await h.verify(m,u,this.b.getLevel()===N.LogLevel.Trace)}catch(P){d={code:T.UnknownError,didExecute:!1,output:(0,R.$ab)(P)}}const p=new Date().getTime()-v;if(this.b.info(`Extension signature verification result for ${b}: ${d.code}. Executed: ${d.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${b}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:b,extensionVersion:S.version,code:d.code,internalCode:d.internalCode,duration:p,didExecute:d.didExecute,clientTargetPlatform:$}),d.code===T.Success)return!0;throw new O(d.code)}};e.$tq=A,e.$tq=A=ve([Y(0,N.$ak),Y(1,k.$_l)],A)}),define(ce[112],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;class R{constructor(k){this.b=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:O,data:A}){return this.b.forEach(w=>w.log(O,A)),Promise.resolve(null)}}e.$0fc=R;class c{constructor(k){this.b=k}log(k,T){return this.b.call("log",{eventName:k,data:T}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$$fc=c}),define(ce[49],le([0,1,30,13,106,110,18]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=S,e.$Dp=m,e.$Ep=u,e.$Fp=$,e.$Gp=b,e.$Hp=d,e.$Ip=p,e.$Jp=s;class O{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$vp=O;class A{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=A,e.$xp=new A;class w{async publicLog(t,a,i){}async publicLogError(t,a,i){}}e.$yp=w,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function S(r,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!r.enableTelemetry)}function m(r,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function u(r){const t=r.getValue(T.$im),a=r.getValue(T.$jm);if(r.getValue(T.$km)===!1||a===!1)return T.TelemetryLevel.NONE;switch(t??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function $(r){const t={},a={},i={};v(r,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?a[n]=o:typeof o=="boolean"?a[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),t[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(t[n]=o)}return{properties:t,measurements:a}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(r){if(!r)return"none";const t=(0,N.$in)(r);return h.has(t)?t:"other"}function v(r,t,a=0,i){if(r)for(const n of Object.getOwnPropertyNames(r)){const o=r[n],l=i?i+n:n;Array.isArray(o)?t[l]=(0,R.$jo)(o):o instanceof Date?t[l]=o.toISOString():(0,c.$ig)(o)?a<2?v(o,t,a+1,l+"."):t[l]=(0,R.$jo)(o):t[l]=o}}function d(r,t){const a=r.msftInternalDomains||[],i=t.getValue("telemetry.internalTesting");return(0,k.$up)(a)||i}function p(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function P(r,t){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let a=r;const i=[];for(const f of t)for(;;){const I=f.exec(r);if(!I)break;i.push([I.index,f.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(a="";;){const f=o.exec(r);if(!f)break;const I=i.some(([L,E])=>f.index<E&&L<o.lastIndex);!n.test(f[0])&&!I&&(a+=r.substring(l,f.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<r.length&&(a+=r.substr(l)),a}function g(r){if(!r)return r;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(r))return`<REDACTED: ${a.label}>`;return r}function s(r,t){return(0,R.$go)(r,a=>{if(a instanceof O||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let i=a.replaceAll("%20"," ");i=P(i,t);for(const n of t)i=i.replace(n,"");return i=g(i),i}})}}),define(ce[33],le([0,1,27,28,36,5,9,8,37,49]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=S,e.$Mp=h,e.$Np=b,e.$Op=v,e.$Pp=d,e.$Qp=p,e.$Rp=P,e.$Sp=g,e.$Up=s,e.$Vp=t;function S(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,R.$Cf)(a.id,i.id)===0}const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new u(i.identifier,n,o)}static parse(i){const n=m.exec(i);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=N.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof u?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Lp=u;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(a){const i=$.exec(a);return i&&i[1]?[v(i[1]),i[2]]:[v(a),void 0]}function b(a,i){return`${a}.${i}`}function v(a){return a.toLowerCase()}function d(a,i){return v(b(a??N.$nn,i))}function p(a,i){const n=[],o=l=>{for(const f of n)if(f.some(I=>S(i(I),i(l))))return f;return null};for(const l of a){const f=o(l);f?f.push(l):n.push([l])}return n}function P(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function g(a){return{id:new w.$vp(a.identifier.id),name:new w.$vp(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Tp=new N.$rn("pprice.better-merge");function s(a,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(f=>!S(f.identifier,{id:l}))){const f=a.filter(I=>S(I.identifier,{id:l}));f.length===1&&(n.push(f[0]),o.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function r(a,i){if(!k.$k)return!1;let n;try{n=(await a.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,O.$ab)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(a,i){const n=await r(a,i),o=(0,c.$fp)(n?"alpine":k.$u,A.$hc);return i.debug("ComputeTargetPlatform:",o),o}}),define(ce[234],le([0,1,26,28,33,36]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=T;async function T(O,A,w,S,m){try{const u=await O.getExtensionsControlManifest();if(!u.deprecated)return;const $=await O.getInstalled(k.ExtensionType.User);for(const[h,b]of Object.entries(u.deprecated)){if(!b?.extension)continue;const{id:v,autoMigrate:d,preRelease:p}=b.extension;if(!d)continue;const P=$.find(s=>(0,N.$Kp)(s.identifier,{id:h}));if(!P)continue;const g=(await A.getExtensions([{id:v,preRelease:p}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){m.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${v}' extension is not found`);continue}try{m.info(`Migrating '${P.identifier.id}' extension to '${v}' extension...`);const s=!S.getDisabledExtensions().some(t=>(0,N.$Kp)(t,P.identifier));await O.uninstall(P),m.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let r=$.find(t=>(0,N.$Kp)(t.identifier,{id:v}));(!r||!r.isPreReleaseVersion&&s)&&(r=await O.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:c.InstallOperation.Migrate}),m.info(`Installed the pre-release extension '${r.identifier.id}'`),s||(await S.disableExtension(r.identifier),m.info(`Disabled the pre-release extension '${r.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),d.storage&&(w.addToMigrationList((0,N.$Np)(P.manifest.publisher,P.manifest.name),(0,N.$Np)(r.manifest.publisher,r.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${P.identifier.id}' extension to '${v}' extension.`)}catch(s){m.error(s)}}}catch(u){m.error(u)}}}),define(ce[235],le([0,1,3,2,35,33,36,7]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class A extends c.$Xc{constructor(S,m,u,$,h,b,v){super(),this.f=S,this.g=m,this.h=u,this.j=$,this.m=h,this.n=b,this.r=v,this.a=this.B(new R.$ne),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new c.$7c),this.s().then(null,d=>v.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(m=>(this.c.set(m.id,(0,c.$Uc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(S){for(const m of S.extensions)this.I(this.L(m.identifier,m.version),S.profileLocation)}async y(S){for(const m of S.extensions){const u=this.L(m.identifier,m.version);S.error?this.J(u,S.profileLocation):this.I(u,S.profileLocation)}}async z(S){for(const m of S.extensions)this.J(this.L(m.identifier,m.version),S.profileLocation)}async C(S){const m=[],u=[];for(const $ of S.extensions){const h=this.L($.identifier,$.version);S.error?this.I(h,S.profileLocation):(this.J(h,S.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),u.push(this.f.scanInstalledExtensionAtLocation($.location).then(b=>{b?m.push(b):this.r.info("Extension not found at the location",$.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(u),m.length&&await this.H(m)}catch($){this.r.error($)}}D(S){for(const m of this.h.profiles)S.contains(m.extensionsResource,O.FileChangeType.UPDATED,O.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(S){const m=[],u=[],$=await this.j.scanProfileExtensions(S),h=new Set,b=new Set;for(const[v,d]of this.b)d.has(S)&&b.add(v);for(const v of $){const d=this.L(v.identifier,v.version);h.add(d),b.has(d)||(m.push(v.identifier),this.I(d,S))}for(const v of b)if(!h.has(v)){const d=this.M(v);d&&(u.push(d.identifier),this.J(v,S))}(m.length||u.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:S}:void 0,removed:u.length?{extensions:u,profileLocation:S}:void 0})}async G(S){const m=await this.j.scanProfileExtensions(S);for(const u of m)this.I(this.L(u.identifier,u.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(u=>!this.b.has(this.L(u.identifier,u.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,m){let u=this.b.get(S);u||this.b.set(S,u=new N.$Ec($=>this.m.extUri.getComparisonKey($))),u.add(m)}J(S,m){const u=this.b.get(S);u&&u.delete(m),u?.size||this.b.delete(S)}L(S,m){return`${T.$rn.toKey(S.id)}@${m}`}M(S){const[m,u]=(0,k.$Mp)(S);return u?{identifier:{id:m},version:u}:void 0}}e.$Vq=A}),define(ce[236],le([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;let b=class extends $.$$r{constructor(P,g,s,r){super(s),this.h=P,this.j=r,this.g=this.B(new v(g,r)),this.h.registerParticipant({postInstall:async t=>this.m(t),postUninstall:async t=>this.n(t)})}async getBuiltInExtensionTranslationsUri(P,g){const r=(await this.g.getLanguagePacks())[g];if(!r){this.j.warn(`No language pack found for ${g}`);return}const t=r.translations[P];return t?h.URI.file(t):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),g=Object.keys(P).map(s=>{const r=P[s];return{...this.f(s,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((s,r)=>s.label.localeCompare(r.label)),g}async m(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",P.identifier.id),await this.update())}async n(P){const g=await this.g.getLanguagePacks();Object.keys(g).some(s=>g[s]&&g[s].extensions.some(r=>(0,m.$Kp)(r.extensionIdentifier,P.identifier)))&&(this.j.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),s=await this.g.update(g);return!(0,c.$xb)(Object.keys(P),Object.keys(s))}};e.$_r=b,e.$_r=b=ve([Y(0,S.$mp),Y(1,w.$Oi),Y(2,S.$jp),Y(3,u.$ak)],b);let v=class extends k.$Xc{constructor(P,g){super(),this.j=g,this.c={},this.f=(0,O.$mc)(P.userDataPath,"languagepacks.json"),this.g=new N.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.s(g=>{Object.keys(g).forEach(s=>delete g[s]),this.m(g,...P)}).then(()=>this.c)}m(P,...g){for(const s of g)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.n(P,s);Object.keys(P).forEach(s=>this.r(P[s]))}n(P,g){const s=g.identifier,r=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of r)if(g.location.scheme===T.Schemas.file&&d(t)){let a=P[t.languageId];a||(a={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},P[t.languageId]=a);const i=a.extensions.filter(n=>(0,m.$Kp)(n.extensionIdentifier,s))[0];i?i.version=g.manifest.version:a.extensions.push({extensionIdentifier:s,version:g.manifest.version});for(const n of t.translations)a.translations[n.id]=(0,O.$mc)(g.location.fsPath,n.path)}}r(P){if(P){const g=(0,R.createHash)("md5");for(const s of P.extensions)g.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);P.hash=g.digest("hex")}}s(P=()=>null){return this.g.queue(()=>{let g=null;return A.Promises.readFile(this.f,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch{return{}}}).then(s=>(g=P(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.c=s,this.h=!0;const r=JSON.stringify(this.c);return this.j.debug("Writing language packs",r),A.Promises.writeFile(this.f,r)}).then(()=>g,s=>this.j.error(s))})}};v=ve([Y(0,w.$Oi),Y(1,u.$ak)],v);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const P of p.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ce[237],le([0,1,149,8,30,49]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function A(S,m,u){const $=await(0,R.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),h=await(0,R.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new $.AppInsightsCore,v=new h.PostChannel,d={instrumentationKey:S,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(u){d.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};d.extensionConfig[v.identifier]=p}return b.initialize(d,[]),b.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),b}class w{constructor(m,u,$,h,b){this.e=m,this.f=u,this.g=$,this.h=b,this.c=T,this.d=O,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(u=>{m(u)},u=>{(0,c.$3)(u),console.error(u)})}}log(m,u){if(!this.a)return;u=(0,N.$ho)(u,this.g),u=(0,k.$Fp)(u);const $=this.f+"/"+m;try{this.i(h=>{h.pluginVersionString=u?.properties.version??"Unknown",h.track({name:$,baseData:{name:$,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$bR=w}),define(ce[113],le([0,1,2,178,16,10,24,49]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;let A=class extends R.$Xc{constructor(S,m,u,$,h=""){super(),this.b=h;const b=m.getLogger(O.$zp);if(b)this.a=this.B(b);else{const d=(0,O.$Dp)($,u)?" (Not Sent)":"",p=()=>(0,O.$Cp)($,u)&&S.getLevel()===k.LogLevel.Trace;this.a=this.B(m.createLogger(O.$zp,{name:(0,c.localize)(0,null,d),hidden:!p()})),this.B(S.onDidChangeLogLevel(()=>m.setVisibility(O.$zp,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,m){this.a.trace(`${this.b}telemetry/${S}`,(0,O.$Fp)(m))}};e.$ndc=A,e.$ndc=A=ve([Y(0,k.$ak),Y(1,k.$bk),Y(2,N.$Ni),Y(3,T.$tk)],A)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[114],le([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,w=it(w);let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,p,P){this.k=p,this.l=P,this.d={},this.i=new R.$Wc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,k.$jf)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$jf)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(u.$im)||g.affectsConfiguration(u.$km)||g.affectsConfiguration(u.$jm))&&this.m()}))}setExperimentProperty(d,p){this.d[d]=p}m(){let d=(0,$.$Ep)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const P=p.usage?u.TelemetryLevel.USAGE:p.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;d=Math.min(d,P)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,p,P){this.g<p||(P=(0,c.$ho)(P,this.d),P=(0,$.$Jp)(P,this.j),P=(0,c.$ho)(P,this.c),this.b.forEach(g=>g.log(d,P)))}publicLog(d,p){this.n(d,u.TelemetryLevel.USAGE,p)}publicLog2(d,p){this.publicLog(d,p)}publicLogError(d,p){this.h&&this.n(d,u.TelemetryLevel.ERROR,p)}publicLogError2(d,p){this.publicLogError(d,p)}};e.$fs=h,e.$fs=h=ve([Y(1,O.$aj),Y(2,S.$tk)],h);function b(){const v=(0,T.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=N.$o?"":(0,T.localize)(3,null),P=(0,T.localize)(4,null),g=(0,T.localize)(5,null),s=(0,T.localize)(6,null),r=(0,T.localize)(7,null),t=`
|       | ${P} | ${g} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${v} ${d} ${p}

&nbsp;

${r}
${t}

&nbsp;

${a}
`}m.$ro.as(A.$wo.Configuration).registerConfiguration({id:u.$hm,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[u.$im]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:b(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),m.$ro.as(A.$wo.Configuration).registerConfiguration({id:u.$hm,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[u.$km]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,T.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,T.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${u.$im}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[238],le([0,1,15,26,281,237]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,N=ke(N);async function T(S,m){const u=await m.request(S,c.CancellationToken.None),$=(await(0,R.$2e)(u.stream)).toString(),h=u.res.statusCode??200;return{headers:u.res.headers,statusCode:h,responseData:$}}async function O(S){const m={method:S.type,headers:S.headers};return new Promise(($,h)=>{const b=N.request(S.url??"",m,v=>{v.on("data",function(d){$({headers:v.headers,statusCode:v.statusCode??200,responseData:d.toString()})}),v.on("error",function(d){h(d)})});b.write(S.data,v=>{v&&h(v)}),b.end()})}async function A(S,m,u){const $=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),h={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:$};try{const b=S?await T(h,S):await O(h);u(b.statusCode,b.headers,b.responseData)}catch{u(0,{})}}class w extends k.$bR{constructor(m,u,$,h,b){const v={sendPOST:(d,p)=>{A(m,d,p)}};super(u,$,h,b,v)}}e.$cR=w}),define(ce[239],le([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;let u=class{constructor(h,b,v,d,p,P){this.b=h,this.c=b,this.d=v,this.e=d,this.f=p,this.g=P,this.a=new Map}h(h){if(!this.a.has(h.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const v=[h.id,JSON.stringify(b),h.aiKey],p=new c.$gr(R.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new w.$$fc(p),new S.$ndc(this.d,this.e,this.f,this.g,`[${h.id}] `)];this.a.set(h.id,new m.$fs({appenders:P,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.g))}return this.a.get(h.id)}publicLog(h,b,v){this.h(h).publicLog(b,v)}publicLogError(h,b,v){this.h(h).publicLogError(b,v)}};e.$mhc=u,e.$mhc=u=ve([Y(0,N.$aj),Y(1,A.$_l),Y(2,T.$ak),Y(3,T.$bk),Y(4,k.$Ni),Y(5,O.$tk)],u)}),define(ce[81],le([0,1,3,2,5,9,22,4,10]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=m,e.$Ew=$,e.$Fw=h,e.$Hw=b,e.$Jw=v,e.$Kw=d,e.$Bw=(0,O.$Gi)("tunnelService"),e.$Cw=(0,O.$Gi)("sharedTunnelsService");var w;(function(g){g.Http="http",g.Https="https"})(w||(e.TunnelProtocol=w={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function m(g){return!!g.forwardPort}var u;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function $(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(s)return{address:s[1],port:+s[2]}}function h(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const s=g.query.split("&");for(const r of s){const t=r.split("=")[1];if(/^https?:/.exec(t)){const a=$(k.URI.parse(t));if(a)return a}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(g){return e.$Gw.indexOf(g)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(g){return e.$Iw.indexOf(g)>=0}function d(g,s,r,t){if(r===N.OperatingSystem.Windows)return!1;if(r===N.OperatingSystem.Macintosh&&v(s)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(a?.length===4&&parseInt(a[1])>=18)return!1}return g<1024}class p{constructor(s,r,t){this.remoteAddress=s,this.localAddress=r,this.b=t,this.a=new R.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=p;let P=class extends c.$Xc{constructor(s,r){super(),this.r=s,this.s=r,this.a=new R.$ne,this.onTunnelOpened=this.a.event,this.b=new R.$ne,this.onTunnelClosed=this.b.event,this.c=new R.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],r=Array.from(this.f.values());for(const t of r){const a=Array.from(t.values());for(const i of a){const n=await i.value;n&&typeof n!="string"&&s.push(n)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:r}of s.values())await r.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,r,t,a,i){this.z(s,r,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:r,localAddress:t,privacy:a,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,r){(v(s)||b(s))&&(s=e.$Gw[0]);const t=this.D(s,r);if(t)return++t.refcount,t.value}openTunnel(s,r,t,a,i,n=!1,o,l){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${t} on local port ${i}.`);const f=this.g??s;if(!f)return;if(r||(r="localhost"),a||(a=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const I=this.F(f,r,t,a,i,n,o,l);return I?I.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.w(L);return(L.tunnelRemoteHost!==r||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&L.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),I)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const r=this.f.get(s.tunnelRemoteHost);if(r){const t=r.get(s.tunnelRemotePort);t&&(t.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async y(s,r,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${r}.`);const a=t.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(r),a}}async closeTunnel(s,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${r} `);const t=this.f.get(s);if(t&&t.has(r)){const a=t.get(r);a.refcount=0,await this.y(s,r,a)}}z(s,r,t){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(r,{refcount:1,value:t})}async C(s,r){const t=this.f.get(s);if(t){const a=t.get(r),i=a?await a.value:void 0;(!i||typeof i=="string")&&t.delete(r),t.size===0&&this.f.delete(s)}}D(s,r){const t=[s];b(s)?(t.push(...e.$Gw),t.push(...e.$Iw)):v(s)&&t.push(...e.$Iw);const a=t.map(i=>this.f.get(i));for(const i of a){const n=i?.get(r);if(n)return n}}canTunnel(s){return!!$(s)}G(s,r,t,a,i,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${t} on local port ${a}.`);const l=t;this.n.add(l);const f=a===void 0?t:a,I={elevationRequired:i?this.isPortPrivileged(f):!1},L={remoteAddress:{host:r,port:t},localAddressPort:a,privacy:n,public:n?n!==S.Private:void 0,protocol:o},E=s.forwardPort(L,I);return E?(this.z(r,t,E),E.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(l)})):this.n.delete(l),E}};e.$Mw=P,e.$Mw=P=ve([Y(0,A.$ak),Y(1,T.$aj)],P)}),define(ce[240],le([0,1,10,81,2,8,6]),function(ne,e,R,c,N,k,T){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class A extends N.$Xc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$4h),this.b.p)}setAddress(m){this.a=m,this.b&&(this.b.complete(m),this.b=null)}setTunnel(m){this.B(m)}}let w=class extends N.$Xc{static{O=this}static{this.a=0}constructor(m,u){super(),this.f=m,this.g=u,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(m=>m.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel(m,u,$,h,b,v,d){const p=new A,P=await Promise.resolve(this.f.openTunnel(m,p,$,h,b,v,d));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${h} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this.c.has(u))throw this.c.delete(u),p.dispose(),await P.dispose(),(0,k.$9)();return p.setTunnel(P),this.b.set(u,p),this.g.info(`[SharedProcessTunnelService] Created tunnel ${u}: ${P.localAddress} (local) to ${$}:${h} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(m,u){const $=this.b.get(m);$&&$.setAddress(u)}async destroyTunnel(m){const u=this.b.get(m);if(u){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${m}.`),this.b.delete(m),await u.dispose();return}this.c.add(m)}};e.$whc=w,e.$whc=w=O=ve([Y(0,c.$Cw),Y(1,R.$ak)],w)}),define(ce[29],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,R.$Gi)("IUriIdentityService")}),define(ce[241],le([0,1,29,197,7,21,133,3,2]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class w{static{this._clock=0}constructor(u){this.uri=u,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let S=class{constructor(u){this.g=u,this.c=new A.$Wc,this.f=2**16;const $=new Map,h=b=>{let v=$.get(b.scheme);return v===void 0&&(v=u.hasProvider(b)&&!this.g.hasCapability(b,N.FileSystemProviderCapabilities.PathCaseSensitive),$.set(b.scheme,v)),v};this.c.add(O.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(b=>{$.delete(b.scheme)})),this.extUri=new k.$9g(h),this.d=new T.$Rs((b,v)=>this.extUri.compare(b,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,k.$ih)(u));const $=this.d.get(u);return $?$.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new w(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((h,b)=>h[1].time<b[1].time?1:h[1].time>b[1].time?-1:0);w._clock=0,this.d.clear();const $=this.f*.5;for(let h=0;h<$;h++)this.d.set(u[h][0],u[h][1].touch())}};e.$Ss=S,e.$Ss=S=ve([Y(0,N.$al)],S),(0,c.$Ps)(R.$Kl,S,c.InstantiationType.Delayed)}),define(ce[242],le([0,1,3,2,7,52,35]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class O extends c.$Xc{constructor(w,S,m,u,$,h){super(),this.f=w,this.g=S,this.h=m,this.j=u,this.m=$,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$ne),this.onDidChangeFile=this.a.event,this.b=k.$Mi.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ec(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const w of this.j.profiles)this.c.add(w.settingsResource),this.c.add(w.keybindingsResource),this.c.add(w.tasksResource),this.c.add(w.extensionsResource)}open(w,S){return this.g.open(this.t(w),S)}close(w){return this.g.close(w)}read(w,S,m,u,$){return this.g.read(w,S,m,u,$)}write(w,S,m,u,$){return this.g.write(w,S,m,u,$)}watch(w,S){this.b.set(w,w);const m=this.g.watch(this.t(w),S);return(0,c.$Vc)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.g.stat(this.t(w))}mkdir(w){return this.g.mkdir(this.t(w))}rename(w,S,m){return this.g.rename(this.t(w),this.t(S),m)}readFile(w,S){return this.g.readFile(this.t(w),S)}readFileStream(w,S,m){return this.g.readFileStream(this.t(w),S,m)}readdir(w){return this.g.readdir(this.t(w))}enforceAtomicReadFile(w){return this.c.has(w)}writeFile(w,S,m){return this.g.writeFile(this.t(w),S,m)}enforceAtomicWriteFile(w){return this.c.has(w)?{postfix:".vsctmp"}:!1}delete(w,S){return this.g.delete(this.t(w),S)}copy(w,S,m){if((0,N.$el)(this.g))return this.g.copy(this.t(w),this.t(S),m);throw new Error("copy not supported")}cloneFile(w,S){if((0,N.$fl)(this.g))return this.g.cloneFile(this.t(w),this.t(S));throw new Error("clone not supported")}s(w){const S=[];for(const m of w){if(m.resource.scheme!==this.f)continue;const u=this.u(m.resource);this.b.findSubstr(u)&&S.push({resource:u,type:m.type,cId:m.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(w){return w.with({scheme:this.f})}u(w){return w.with({scheme:this.h})}}e.$Zgc=O}),define(ce[82],le([0,1,65]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$wMb=N,e.$xMb=k;function c(T,O,A,w){const S=(0,R.$ao)(T,O,A,w)[0];return S&&(T=T.substring(0,S.offset)+S.content+T.substring(S.offset+S.length)),T}function N(T,O,A){let w=A;for(;w>=0;){if(T.charAt(w)===O.charAt(O.length-1)&&O.length===1)return w+1;if(w--,O.length===2&&w>=0&&T.charAt(w)===O.charAt(0))return w+2}return 0}function k(T,O,A){let w=A;for(;w>=0;)if(T.charAt(w)===O.charAt(O.length-1)&&O.length===1||(w++,O.length===2&&w>=0&&T.charAt(w)===O.charAt(1)))return w;return T.length-1}}),define(ce[243],le([0,1,30,61,13]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=k,c=ke(c);function k($,h,b,v,d,p){const P=[],g=[],s=[];if(!h){const M=$.filter(({identifier:K})=>d.every(W=>W.toLowerCase()!==K.id.toLowerCase()));return{local:{added:P,removed:g,updated:s},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}$=$.map(m),h=h.map(m),b=b?b.map(m):null;const r=new Map,t=M=>{M.uuid&&r.set(M.id.toLowerCase(),M.uuid)};$.forEach(({identifier:M})=>t(M)),h.forEach(({identifier:M})=>t(M)),b?.forEach(({identifier:M})=>t(M)),v?.forEach(({identifier:M})=>t(M)),p?.forEach(M=>t(M));const a=M=>{const K=M.identifier.uuid||r.get(M.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${M.identifier.id.toLowerCase()}`},i=(M,K)=>(M.set(a(K),K),M),n=$.reduce(i,new Map),o=h.reduce(i,new Map),l=h.reduce((M,K)=>i(M,(0,R.$eo)(K)),new Map),f=b?b.reduce(i,new Map):null,I=v.reduce(i,new Map),L=d.reduce((M,K)=>{const W=r.get(K.toLowerCase());return M.add(W?`uuid:${W}`:`id:${K.toLowerCase()}`)},new Set),E=p?p.reduce((M,{id:K,uuid:W})=>(W=W??r.get(K.toLowerCase()),M.add(W?`uuid:${W}`:`id:${K.toLowerCase()}`)),new Set):null,y=T(n,o,L,!1);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const M=T(f,n,L,!1),K=T(f,o,L,!0),W=(_,H,ie,V)=>{let z,te,se;return H.installed?(z=V.pinned,se=V.preRelease,z&&(te=V.version)):(z=ie.pinned,se=ie.preRelease,z&&(te=ie.version)),z===void 0&&(z=H.pinned,z&&(te=H.version)),se===void 0&&(se=H.preRelease),{...V,installed:H.installed||ie.installed,pinned:z,preRelease:se,version:te??(ie.version&&(!H.installed||c.gt(ie.version,H.version))?ie.version:H.version),state:A(H,ie,f?.get(_))}};for(const _ of K.removed.values()){const H=n.get(_);if(!H)continue;const ie=(0,N.$rg)(f?.get(_)),V=E&&!E.has(_)&&ie.installed;H.installed&&V?g.push(H.identifier):l.set(_,H)}for(const _ of K.added.values()){const H=(0,N.$rg)(o.get(_)),ie=n.get(_);if(ie){if(y.updated.has(_)){const V=W(_,ie,H,H);O(ie,H,!1,!1)||s.push(u(V,_)),l.set(_,V)}}else H.installed&&P.push(u(H,_))}for(const _ of K.updated.values()){const H=(0,N.$rg)(o.get(_)),ie=(0,N.$rg)(f?.get(_)),V=n.get(_);if(V)if(E&&!E.has(_)&&ie.installed&&V.installed&&!H.installed)g.push(V.identifier);else{const te=W(_,V,H,H);s.push(u(te,_)),l.set(_,te)}else H.installed&&P.push(u(H,_))}for(const _ of M.added.values())K.added.has(_)||l.set(_,(0,N.$rg)(n.get(_)));for(const _ of M.updated.values()){if(K.removed.has(_)||K.updated.has(_))continue;const H=(0,N.$rg)(n.get(_)),ie=(0,N.$rg)(o.get(_));l.set(_,W(_,H,ie,H))}for(const _ of M.removed.values())K.updated.has(_)||K.removed.has(_)||I.has(_)||(0,N.$rg)(o.get(_)).installed&&E&&(E.has(_)||!(0,N.$rg)(f?.get(_)).installed||l.delete(_))}const C=[],F=T(o,l,new Set,!0),D=F.added.size>0||F.updated.size>0||F.removed.size>0;return D&&l.forEach((M,K)=>C.push(u(M,K))),{local:{added:P,removed:g,updated:s},remote:D?{added:[...F.added].map(M=>l.get(M)),updated:[...F.updated].map(M=>l.get(M)),removed:[...F.removed].map(M=>o.get(M)),all:C}:null}}function T($,h,b,v){const d=$?[...$.keys()].filter(r=>!b.has(r)):[],p=[...h.keys()].filter(r=>!b.has(r)),P=p.filter(r=>!d.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),g=d.filter(r=>!p.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of d){if(g.has(r))continue;const t=$.get(r),a=h.get(r);(!a||!O(t,a,v,!0))&&s.add(r)}return{added:P,removed:g,updated:s}}function O($,h,b,v){return!($.disabled!==h.disabled||!!$.isApplicationScoped!=!!h.isApplicationScoped||v&&$.installed!==h.installed||$.installed&&h.installed&&($.preRelease!==h.preRelease||$.pinned!==h.pinned||h.pinned&&$.version!==h.version)||!S($.state,h.state)||b&&$.version!==h.version)}function A($,h,b){const v=$.state,d=h.state,p=b?.state;if(!h.version||v&&c.gt($.version,h.version))return v;if(d&&c.gt(h.version,$.version)||!v)return d;if(!d)return v;const P=(0,R.$eo)(v),g=p?w(p,d):{added:Object.keys(d).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set},s=p?w(p,v):{added:Object.keys(v).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set};for(const r of[...g.added.values(),...g.updated.values()])P[r]=d[r];for(const r of g.removed.values())s.updated.has(r)||delete P[r];return P}function w($,h){const b=Object.keys($),v=Object.keys(h),d=v.filter(g=>!b.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),p=b.filter(g=>!v.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),P=new Set;for(const g of b){if(p.has(g))continue;const s=$[g],r=h[g];(0,R.$io)(s,r)||P.add(g)}return{added:d,removed:p,updated:P}}function S($={},h={}){const{added:b,removed:v,updated:d}=w($,h);return b.size===0&&v.size===0&&d.size===0}function m($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function u($,h){const b={...$,identifier:{id:$.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete b.disabled,$.installed||delete b.installed,$.state||delete b.state,$.isApplicationScoped||delete b.isApplicationScoped,b}}),define(ce[115],le([0,1,19,22,4]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NOb=e.$MOb=void 0,e.$MOb=(0,N.$Gi)("IIgnoredExtensionsManagementService");let k=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==O&&S!==`-${O}`),A&&w.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==O&&S!==`-${O}`),A&&w.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(O){const A=O.filter(u=>u.isMachineScoped).map(u=>u.identifier.id.toLowerCase()),w=this.b().map(u=>u.toLowerCase()),S=[],m=[];if(Array.isArray(w))for(const u of w)u.startsWith("-")?m.push(u.substring(1)):S.push(u);return(0,R.$Pb)([...A,...S].filter(u=>!m.includes(u)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$NOb=k,e.$NOb=k=ve([Y(0,c.$aj)],k)}),define(ce[244],le([0,1,19,34,30,97,82]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=A,N=ke(N),T=ke(T);function O(g){return(0,c.$Yn)(g)||[]}async function A(g,s,r,t,a){const i=O(g),n=O(s),o=r?O(r):null,l=[...i,...n,...o||[]].map(W=>W.key),f=await a.resolveUserBindings(l),I=S(i,n,o,f);if(!I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!I.hasLocalForwarded&&I.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const L=u(i),E=u(n),y=o?u(o):null,C=h(L,E,f),F=y?h(y,L,f):{added:[...L.keys()].reduce((W,_)=>(W.add(_),W),new Set),removed:new Set,updated:new Set},D=y?h(y,E,f):{added:[...E.keys()].reduce((W,_)=>(W.add(_),W),new Set),removed:new Set,updated:new Set},M=w(C,F,D);let K=g;for(const W of M.removed.values())M.conflicts.has(W)||(K=p(K,W,t));for(const W of M.added.values()){if(M.conflicts.has(W))continue;const _=E.get(W);if(_.some(H=>H.command!==`-${W}`&&I.conflicts.has(f[H.key]))){M.conflicts.add(W);continue}K=d(K,_,t)}for(const W of M.updated.values()){if(M.conflicts.has(W))continue;const _=E.get(W);if(_.some(H=>H.command!==`-${W}`&&I.conflicts.has(f[H.key]))){M.conflicts.add(W);continue}K=P(K,W,_,t)}return{mergeContent:K,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function w(g,s,r){const t=new Set,a=new Set,i=new Set,n=new Set;for(const o of s.removed.values())r.updated.has(o)&&n.add(o);for(const o of r.removed.values())n.has(o)||(s.updated.has(o)?n.add(o):a.add(o));for(const o of s.added.values())n.has(o)||r.added.has(o)&&g.updated.has(o)&&n.add(o);for(const o of r.added.values())n.has(o)||(s.added.has(o)?g.updated.has(o)&&n.add(o):t.add(o));for(const o of s.updated.values())n.has(o)||r.updated.has(o)&&g.updated.has(o)&&n.add(o);for(const o of r.updated.values())n.has(o)||(s.updated.has(o)?g.updated.has(o)&&n.add(o):i.add(o));return{added:t,removed:a,updated:i,conflicts:n}}function S(g,s,r,t){const a=new Set,i=m(g,t),n=m(s,t),o=r?m(r,t):null,l=$(i,n);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const f=o?$(o,i):{added:[...i.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:a,removed:a,updated:a,conflicts:a};const I=o?$(o,n):{added:[...n.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const{added:L,removed:E,updated:y,conflicts:C}=w(l,f,I);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:E,updated:y,conflicts:C}}function m(g,s){const r=new Map;for(const t of g){const a=s[t.key];let i=r.get(a);i||(i=[],r.set(a,i)),i.push(t)}return r}function u(g){const s=new Map;for(const r of g){const t=r.command[0]==="-"?r.command.substring(1):r.command;let a=s.get(t);a||(a=[],s.set(t,a)),a.push(r)}return s}function $(g,s){const r=[...g.keys()],t=[...s.keys()],a=t.filter(o=>!r.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=r.filter(o=>!t.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),n=new Set;for(const o of r){if(i.has(o))continue;const l=g.get(o).map(I=>({...I,key:o})),f=s.get(o).map(I=>({...I,key:o}));(0,R.$xb)(l,f,(I,L)=>v(I,L))||n.add(o)}return{added:a,removed:i,updated:n}}function h(g,s,r){const t=[...g.keys()],a=[...s.keys()],i=a.filter(l=>!t.includes(l)).reduce((l,f)=>(l.add(f),l),new Set),n=t.filter(l=>!a.includes(l)).reduce((l,f)=>(l.add(f),l),new Set),o=new Set;for(const l of t){if(n.has(l))continue;const f=g.get(l).map(L=>({...L,key:r[L.key]})),I=s.get(l).map(L=>({...L,key:r[L.key]}));b(f,I)||o.add(l)}return{added:i,removed:n,updated:o}}function b(g,s){return!(!(0,R.$xb)(g.filter(({command:r})=>r[0]!=="-"),s.filter(({command:r})=>r[0]!=="-"),(r,t)=>v(r,t))||!(0,R.$xb)(g.filter(({command:r})=>r[0]==="-"),s.filter(({command:r})=>r[0]==="-"),(r,t)=>v(r,t)))}function v(g,s){if(g.command!==s.command||g.key!==s.key)return!1;const r=k.$Ej.deserialize(g.when),t=k.$Ej.deserialize(s.when);return!(r&&!t||!r&&t||r&&t&&!r.equals(t)||!N.$io(g.args,s.args))}function d(g,s,r){for(const t of s)g=T.edit(g,[-1],t,r);return g}function p(g,s,r){const t=O(g);for(let a=t.length-1;a>=0;a--)(t[a].command===s||t[a].command===`-${s}`)&&(g=T.edit(g,[a],void 0,r));return g}function P(g,s,r,t){const a=O(g),i=a.findIndex(n=>n.command===s||n.command===`-${s}`);for(let n=a.length-1;n>=0;n--)(a[n].command===s||a[n].command===`-${s}`)&&(g=T.edit(g,[n],void 0,t));for(let n=r.length-1;n>=0;n--)g=T.edit(g,[i],r[n],t);return g}}),define(ce[245],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=R,e.$fcc=N;function R(k,T,O){const A={},w={},S=new Set;if(!T)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const m=c(k,T);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const u=c(O,k),$=c(O,T),h={},b={},v=new Set,d=new Set;for(const p of u.removed.values())$.updated.has(p)?A[p]=T[p]:v.add(p);for(const p of $.removed.values())d.has(p)||(u.updated.has(p)?d.add(p):S.add(p));for(const p of u.updated.values())d.has(p)||($.updated.has(p)?m.updated.has(p)&&d.add(p):b[p]=k[p]);for(const p of $.updated.values())d.has(p)||(u.updated.has(p)?m.updated.has(p)&&d.add(p):k[p]!==void 0&&(w[p]=T[p]));for(const p of u.added.values())d.has(p)||($.added.has(p)?m.updated.has(p)&&d.add(p):h[p]=k[p]);for(const p of $.added.values())d.has(p)||(u.added.has(p)?m.updated.has(p)&&d.add(p):A[p]=T[p]);return{local:{added:A,removed:[...S.values()],updated:w},remote:{added:h,removed:[...v.values()],updated:b},conflicts:[...d.values()]}}function c(k,T){const O=k?Object.keys(k):[],A=T?Object.keys(T):[],w=A.filter(u=>!O.includes(u)).reduce((u,$)=>(u.add($),u),new Set),S=O.filter(u=>!A.includes(u)).reduce((u,$)=>(u.add($),u),new Set),m=new Set;for(const u of O){if(S.has(u))continue;const $=k[u],h=T[u];$!==h&&m.add(u)}return{added:w,removed:S,updated:m}}function N(k,T){const{added:O,removed:A,updated:w}=c(k,T);return O.size===0&&A.size===0&&w.size===0}}),define(ce[246],le([0,1,30]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=c;function c(k,T,O,A){const w={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!T){const u=k.filter(({id:$})=>!A.includes($));return u.length?S.added=u:S=null,{local:w,remote:S}}const m=N(k,T,A);if(m.added.length>0||m.removed.length>0||m.updated.length>0){const u=N(O,k,A),$=N(O,T,A);for(const h of $.removed){const b=k.find(v=>v.id===h);b&&w.removed.push(b)}for(const h of $.added){const b=T.find(v=>v.id===h);u.added.includes(h)?m.updated.includes(h)&&w.updated.push(b):w.added.push(b)}for(const h of $.updated)w.updated.push(T.find(b=>b.id===h));for(const h of u.added)$.added.includes(h)||S.added.push(k.find(b=>b.id===h));for(const h of u.updated)$.removed.includes(h)||$.updated.includes(h)||S.updated.push(k.find(b=>b.id===h));for(const h of u.removed){const b=T.find(v=>v.id===h);b&&S.removed.push(b)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:w,remote:S}}function N(k,T,O){k=k?k.filter(({id:$})=>!O.includes($)):[],T=T.filter(({id:$})=>!O.includes($));const A=k.map(({id:$})=>$),w=T.map(({id:$})=>$),S=w.filter($=>!A.includes($)),m=A.filter($=>!w.includes($)),u=[];for(const{id:$,name:h,shortName:b,icon:v,useDefaultFlags:d}of k){if(m.includes($))continue;const p=T.find(P=>P.id===$);(!p||p.name!==h||p.shortName!==b||p.icon!==v||!(0,R.$io)(p.useDefaultFlags,d))&&u.push($)}return{added:S,removed:m,updated:u}}}),define(ce[25],le([0,1,19,13,185,48,28,4,104,44]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnb=e.$Knb=e.$Jnb=e.$Inb=e.$Hnb=e.$Gnb=e.$Fnb=e.$Enb=e.$Dnb=e.$Bnb=e.MergeState=e.Change=e.SyncStatus=e.$Anb=e.$znb=e.$ynb=e.UserDataSyncErrorCode=e.$wnb=e.$vnb=e.$unb=e.$tnb=e.$snb=e.$pnb=e.SyncResource=e.$mnb=e.$lnb=void 0,e.$jnb=S,e.$knb=m,e.$nnb=u,e.$onb=$,e.$qnb=b,e.$rnb=v,e.$xnb=d,e.$Cnb=i;function S(){const n=w.$ro.as(k.$wo.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function m(){const n=w.$ro.as(k.$wo.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(I=>!!n[I].ignoreSync),l=Object.keys(n).filter(I=>n[I].scope===k.ConfigurationScope.MACHINE||n[I].scope===k.ConfigurationScope.MACHINE_OVERRIDABLE),f=S();return(0,R.$Pb)([...o,...l,...f])}e.$lnb="settingsSync",e.$mnb="settingsSync.keybindingsPerPlatform";function u(){const n="vscode://schemas/ignoredSettings",o=w.$ro.as(k.$wo.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$mnb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:k.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:T.$9o,errorMessage:(0,N.localize)(3,null)}],default:[],scope:k.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:k.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=w.$ro.as(A.$so.JSONContribution),f=()=>{const I=S(),L=m(),E=Object.keys(k.$xo.properties).filter(F=>!L.includes(F)),y=L.filter(F=>!I.includes(F)),C={items:{type:"string",enum:[...E,...y.map(F=>`-${F}`)]}};l.registerSchema(n,C)};return o.onDidUpdateConfiguration(()=>f())}function $(n){return n&&(0,c.$ig)(n)&&(0,c.$gg)(n.id)&&Array.isArray(n.scopes)}var h;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(h||(e.SyncResource=h={})),e.$pnb=[h.Settings,h.Keybindings,h.Snippets,h.Tasks,h.Extensions,h.GlobalState,h.Profiles];function b(n,...o){return n?[n,...o]:o}function v(n,o,l,f){return f.joinPath(l.userDataSyncHome,...b(n,o,`lastSync${o}.json`))}e.$snb=(0,O.$Gi)("IUserDataSyncStoreManagementService"),e.$tnb=(0,O.$Gi)("IUserDataSyncStoreService"),e.$unb=(0,O.$Gi)("IUserDataSyncLocalStoreService"),e.$vnb="x-operation-id",e.$wnb="X-Execution-Id";function d(n){const o={};return o[e.$wnb]=n,o}var p;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class P extends Error{constructor(o,l,f,I){super(o),this.code=l,this.resource=f,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$ynb=P;class g extends P{constructor(o,l,f,I,L){super(o,f,void 0,L),this.url=l,this.serverCode=I}}e.$znb=g;class s extends P{constructor(o,l){super(o,l)}}e.$Anb=s,function(n){function o(l){if(l instanceof n)return l;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(f&&f[1]){const I=f[2]==="unknown"?void 0:f[2],L=f[3]==="unknown"?void 0:f[3];return new n(l.message,f[1],I,L)}return new n(l.message,p.Unknown)}n.toUserDataSyncError=o}(P||(e.$ynb=P={}));var r;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(r||(e.SyncStatus=r={}));var t;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(t||(e.Change=t={}));var a;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(a||(e.MergeState=a={})),e.$Bnb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$Dnb=(0,O.$Gi)("IUserDataSyncEnablementService"),e.$Enb=(0,O.$Gi)("IUserDataSyncService"),e.$Fnb=(0,O.$Gi)("IUserDataSyncResourceProviderService"),e.$Gnb=(0,O.$Gi)("IUserDataAutoSyncService"),e.$Hnb=(0,O.$Gi)("IUserDataSyncUtilService"),e.$Inb=(0,O.$Gi)("IUserDataSyncLogService"),e.$Jnb="userDataSync",e.$Knb="vscode-userdata-sync",e.$Lnb="preview"}),define(ce[247],le([0,1,30,25]),function(ne,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Nb=N,R=ke(R);function N(T,O,A,w,S){if(!O)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const m=k(T,O);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const u=A?k(A,O):{added:Object.keys(O).reduce((p,P)=>(p.add(P),p),new Set),removed:new Set,updated:new Set},$=A?k(A,T):{added:Object.keys(T).reduce((p,P)=>(p.add(P),p),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},b=R.$eo(O),v=!A;for(const p of $.added.values())p!==c.$Bnb&&v&&u.added.has(p)||(b[p]=T[p]);for(const p of $.updated.values())b[p]=T[p];for(const p of $.removed.values())w.unregistered.includes(p)||delete b[p];for(const p of u.added.values()){const P=O[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(A&&$.added.has(p))continue;const g=T[p];g&&g.value===P.value||p===c.$Bnb&&v&&$.added.has(p)||(g?h.updated[p]=P:h.added[p]=P)}for(const p of u.updated.values()){const P=O[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(p)||$.removed.has(p))continue;const g=T[p];g&&g.value===P.value||(h.updated[p]=P)}for(const p of u.removed.values()){if(w.machine.includes(p)){S.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}$.updated.has(p)||$.removed.has(p)||h.removed.push(p)}const d=k(O,b);return{local:h,remote:{added:[...d.added],updated:[...d.updated],removed:[...d.removed],all:d.added.size===0&&d.removed.size===0&&d.updated.size===0?null:b}}}function k(T,O){const A=Object.keys(T),w=Object.keys(O),S=w.filter($=>!A.includes($)).reduce(($,h)=>($.add(h),$),new Set),m=A.filter($=>!w.includes($)).reduce(($,h)=>($.add(h),$),new Set),u=new Set;for(const $ of A){if(m.has($))continue;const h=T[$],b=O[$];R.$io(h,b)||u.add($)}return{added:S,removed:m,updated:u}}}),define(ce[248],le([0,1,19,34,65,45,30,82,25]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yMb=w,e.$zMb=u,e.$AMb=$,e.$BMb=h,e.$CMb=v,e.$DMb=p,T=ke(T),O=ke(O);function w(l,f,I){let L=[];I?L=m(I):L=S(f);const E=[],y=[...(0,A.$jnb)()];if(Array.isArray(L))for(const C of L)C.startsWith("-")?y.push(C.substring(1)):E.push(C);return(0,R.$Pb)([...l,...E].filter(C=>!y.includes(C)))}function S(l){let f=l.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=l.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:l.getValue("settingsSync.ignoredSettings")||[]}function m(l){const f=(0,c.$Yn)(l);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function u(l,f){const I=(0,c.$Yn)(l)||{};let L="{}";for(const E of Object.keys(I)){const y=(0,N.$ao)(L,[E],I[E],f);L=(0,N.$do)(L,y)}return L}function $(l,f,I,L){if(I.length){const E=o(f),y=(0,c.$Yn)(f)||{},C=(0,c.$Yn)(l);if(!C)return l;const F=[];for(const D of I){const M=y[D],K=C[D];M===void 0?l=O.edit(l,[D],void 0,L):K!==void 0?l=O.edit(l,[D],M,L):F.push(r(D,E))}F.sort((D,M)=>D.startOffset-M.startOffset),F.forEach(D=>l=p(D.setting.key,f,l,L))}return l}function h(l,f,I,L,E,y){const C=$(l,f,L,y),F=I!==C,D=I!==f;if(!F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:C,hasConflicts:!1};if(D&&!F)return{conflictsSettings:[],localContent:$(f,l,L,y),remoteContent:null,hasConflicts:!1};if(I===null&&v(l)){const U=b(l,f,L)?null:$(f,l,L,y);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let M=l,K=f;const W=(0,c.$Yn)(l),_=(0,c.$Yn)(f),H=I?(0,c.$Yn)(I):null,ie=L.reduce((U,Q)=>(U.add(Q),U),new Set),V=d(W,_,ie),z=d(H,W,ie),te=d(H,_,ie),se=new Map,he=new Set,q=U=>{he.add(U);const Q=E.filter(({key:B})=>B===U)[0];Q?(M=O.edit(M,[U],Q.value,y),K=O.edit(K,[U],Q.value,y)):se.set(U,{key:U,localValue:W[U],remoteValue:_[U]})};for(const U of z.removed.values())te.updated.has(U)?q(U):K=O.edit(K,[U],void 0,y);for(const U of te.removed.values())he.has(U)||(z.updated.has(U)?q(U):M=O.edit(M,[U],void 0,y));for(const U of z.updated.values())he.has(U)||(te.updated.has(U)?V.updated.has(U)&&q(U):K=O.edit(K,[U],W[U],y));for(const U of te.updated.values())he.has(U)||(z.updated.has(U)?V.updated.has(U)&&q(U):M=O.edit(M,[U],_[U],y));for(const U of z.added.values())he.has(U)||(te.added.has(U)?V.updated.has(U)&&q(U):K=p(U,M,K,y));for(const U of te.added.values())he.has(U)||(z.added.has(U)?V.updated.has(U)&&q(U):M=p(U,K,M,y));const Z=se.size>0||!b(M,K,L),X=Z||!b(M,l,[]),G=Z||!b(K,f,[]);return{localContent:X?M:null,remoteContent:G?K:null,conflictsSettings:[...se.values()],hasConflicts:Z}}function b(l,f,I){if(l===f)return!0;const L=(0,c.$Yn)(l),E=(0,c.$Yn)(f),y=I.reduce((D,M)=>(D.add(M),D),new Set),C=o(l).filter(D=>!(D.setting&&y.has(D.setting.key))),F=o(f).filter(D=>!(D.setting&&y.has(D.setting.key)));if(C.length!==F.length)return!1;for(let D=0;D<C.length;D++){const M=C[D],K=F[D];if(M.setting&&K.setting){if(M.setting.key!==K.setting.key||!T.$io(L[M.setting.key],E[M.setting.key]))return!1}else if(!M.setting&&!K.setting){if(M.value!==K.value)return!1}else return!1}return!0}function v(l){return l?o(l).length===0:!0}function d(l,f,I){const L=l?Object.keys(l).filter(D=>!I.has(D)):[],E=Object.keys(f).filter(D=>!I.has(D)),y=E.filter(D=>!L.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),C=L.filter(D=>!E.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),F=new Set;if(l)for(const D of L){if(C.has(D))continue;const M=l[D],K=f[D];T.$io(M,K)||F.add(D)}return{added:y,removed:C,updated:F}}function p(l,f,I,L){const E=(0,c.$Yn)(f),y=o(f),C=o(I),F=P(l,y,C);return g(I,l,E[l],F,C,L)}function P(l,f,I){const L=f.findIndex(y=>y.setting?.key===l),E=f[L-1];if(E){if(E.setting){const C=r(E.setting.key,I);if(C)return{index:I.indexOf(C),insertAfter:!0}}else{const C=t(L,f);if(C){const F=r(C.setting.key,I);if(F){const D=a(I.indexOf(F),I),M=i(f,C,f[L]);if(D){const K=i(I,F,D),W=n(M,K);return W?{index:I.indexOf(W),insertAfter:!0}:{index:I.indexOf(D),insertAfter:!1}}else{const K=i(I,F,I[I.length-1]),W=n(M,K);return W?{index:I.indexOf(W),insertAfter:!0}:{index:I.length-1,insertAfter:!0}}}}}const y=f[L+1];if(y)if(y.setting){const C=r(y.setting.key,I);if(C)return{index:I.indexOf(C),insertAfter:!1}}else{const C=a(L,f);if(C){const F=r(C.setting.key,I);if(F){const D=t(I.indexOf(F),I),M=i(f,f[L],C);if(D){const K=i(I,D,F),W=n(M.reverse(),K.reverse());return W?{index:I.indexOf(W),insertAfter:!1}:{index:I.indexOf(D),insertAfter:!0}}else{const K=i(I,I[0],F),W=n(M.reverse(),K.reverse());return W?{index:I.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:I.length-1,insertAfter:!0}}function g(l,f,I,L,E,y){let C;return L.index===-1?C=(0,N.$ao)(l,[f],I,y):C=s(l,f,I,L,E,y).map(F=>(0,N.$bo)(l,F,y)[0]),(0,N.$do)(l,C)}function s(l,f,I,L,E,y){const C=`${JSON.stringify(f)}: ${JSON.stringify(I)}`,F=(0,k.$0n)(y,l),D=E[L.index];if(L.insertAfter){const M=[];if(D.setting)M.push({offset:D.endOffset,length:0,content:","+C});else{const K=a(L.index,E),W=t(L.index,E),_=W?.setting?.commaOffset;W&&_===void 0&&M.push({offset:W.endOffset,length:0,content:","});const H=_!==void 0&&_>D.endOffset;M.push({offset:H?_+1:D.endOffset,length:0,content:K?F+C+",":F+C})}return M}else{if(D.setting)return[{offset:D.startOffset,length:0,content:C+","}];const M=(E[L.index-1]&&!E[L.index-1].setting?F:"")+C+(a(L.index,E)?",":"")+F;return[{offset:D.startOffset,length:0,content:M}]}}function r(l,f){return f.filter(I=>I.setting?.key===l)[0]}function t(l,f){for(let I=l-1;I>=0;I--)if(f[I].setting)return f[I]}function a(l,f){for(let I=l+1;I<f.length;I++)if(f[I].setting)return f[I]}function i(l,f,I){const L=l.indexOf(f),E=l.indexOf(I);return l.filter((y,C)=>L<C&&C<E)}function n(l,f){if(l.length&&f.length){let I=0;for(;I<f.length&&I<l.length;I++)if(l[I].value!==f[I].value)return f[I-1];return f[I-1]}}function o(l){const f=[];let I=-1,L,E;const y={onObjectBegin:C=>{I++},onObjectProperty:(C,F,D)=>{I===0&&(L=F,E=C)},onObjectEnd:(C,F)=>{I--,I===0&&f.push({startOffset:L,endOffset:C+F,value:l.substring(L,C+F),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(C,F)=>{I++},onArrayEnd:(C,F)=>{I--,I===0&&f.push({startOffset:L,endOffset:C+F,value:l.substring(L,C+F),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(C,F,D)=>{I===0&&f.push({startOffset:L,endOffset:F+D,value:l.substring(L,F+D),setting:{key:E,commaOffset:void 0}})},onSeparator:(C,F,D)=>{if(I===0&&C===","){let M=f.length-1;for(;M>=0&&!f[M].setting;M--);const K=f[M];K&&f.splice(M,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:F}})}},onComment:(C,F)=>{I===0&&f.push({startOffset:C,endOffset:C+F,value:l.substring(C,C+F)})}};return(0,c.$6n)(l,y),f}}),define(ce[83],le([0,1,3,2,4,25]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jMb=e.$iMb=void 0,e.$iMb=(0,N.$Gi)("IUserDataSyncAccountService");let T=class extends c.$Xc{get account(){return this.a}constructor(A,w){super(),this.g=A,this.h=w,this.b=this.B(new R.$ne),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$ne),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===k.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$jMb=T,e.$jMb=T=ve([Y(0,k.$tnb),Y(1,k.$Inb)],T)}),define(ce[249],le([0,1,21,186,16,10,25]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OOb=void 0;let O=class extends k.$fk{constructor(w,S){super(),this.g=this.B(w.createLogger((0,R.$hh)(S.logsHome,`${T.$Jnb}.log`),{id:T.$Jnb,name:(0,c.localize)(0,null)}))}trace(w,...S){this.g.trace(w,...S)}debug(w,...S){this.g.debug(w,...S)}info(w,...S){this.g.info(w,...S)}warn(w,...S){this.g.warn(w,...S)}error(w,...S){this.g.error(w,...S)}flush(){this.g.flush()}};e.$OOb=O,e.$OOb=O=ve([Y(0,k.$bk),Y(1,N.$Ni)],O)}),define(ce[250],le([0,1,6,3,2]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class k extends N.$Xc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:A,getActiveWindowId:w}){super(),this.a=this.B(new N.$Wc),c.Event.latch(c.Event.any(O,A))(this.f,this,this.a),this.b=(0,R.$th)(()=>w()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$sgc=k}),define(ce[116],le([0,1,189,14,52,21,9,4,23]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=w,e.$Ri=S,e.$Ui=m,e.$Vi=u,e.$Wi=$,e.$Xi=b,e.$Yi=v,e.$2i=P,e.$7i=g,e.$8i=s,e.$0i=r,e.$$i=t,e.$_i=a,e.$Pi=(0,O.$Gi)("contextService");function w(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!w(i)&&!u(i)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function m(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,c.$qc)(i)}:n?e.$Si:e.$Ti;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}function $(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var h;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function v(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class d{constructor(n,o,l,f,I){this.h=n,this.j=l,this.k=f,this.l=I,this.c=N.$Mi.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=N.$Mi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=d;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.$hh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=p;function P(i){return new p({uri:i,index:0,name:(0,k.$dh)(i)},{uri:i.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,R.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function g(i,n){return k.$$g.isEqualOrParent(i,n.untitledWorkspacesHome)}function s(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===A.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(i){return i.id===e.$9i}function t(i,n){return!g(i,n)&&!s(i)}function a(i){return(typeof i=="string"?(0,c.$rc)(i):(0,k.$fh)(i))===e.$4i}}),define(ce[20],le([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=g,e.$Nl=s,e.$Ol=r;var P;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.$Ml=(0,S.$Gi)("IUserDataProfilesService");function s(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function r(i,n,o,l,f,I){return{id:i,name:n,location:o,isDefault:!1,shortName:f?.shortName,icon:f?.icon,globalStorageHome:I&&f?.useDefaultFlags?.globalState?I.globalStorageHome:(0,k.$hh)(o,"globalStorage"),settingsResource:I&&f?.useDefaultFlags?.settings?I.settingsResource:(0,k.$hh)(o,"settings.json"),keybindingsResource:I&&f?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,k.$hh)(o,"keybindings.json"),tasksResource:I&&f?.useDefaultFlags?.tasks?I.tasksResource:(0,k.$hh)(o,"tasks.json"),snippetsHome:I&&f?.useDefaultFlags?.snippets?I.snippetsHome:(0,k.$hh)(o,"snippets"),extensionsResource:I&&f?.useDefaultFlags?.extensions?I.extensionsResource:(0,k.$hh)(o,"extensions.json"),cacheHome:(0,k.$hh)(l,i),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}let t=class extends N.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,l,f){super(),this.t=n,this.u=o,this.w=l,this.y=f,this.f=!0,this.h=this.B(new c.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Dc,workspaces:new $.$Dc,emptyWindows:new Map},this.profilesHome=(0,k.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$gg)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(r((0,k.$eh)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const l=new $.$Dc,f=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[L,E]of Object.entries(I.workspaces)){const y=T.URI.parse(L),C=o.find(F=>F.id===E);C&&l.set(y,C)}if(I.emptyWindows)for(const[L,E]of Object.entries(I.emptyWindows)){const y=o.find(C=>C.id===E);y&&f.set(L,y)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:f}}return this.z}D(){const n=r("__default__profile__",(0,O.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,d.$jf)(o)}\\s(\\d+)`);let f=0;for(const L of this.profiles){const E=l.exec(L.name),y=E?parseInt(E[1]):0;f=y>f?y:f}const I=`${o} ${f+1}`;return this.createProfile((0,R.$uj)((0,v.$3g)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,R.$uj)((0,v.$3g)()).toString(16),n,o,l)}async createProfile(n,o,l,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,o,l);return f&&await this.setProfileForWorkspace(f,I),I}async F(n,o,l){if(!(0,p.$gg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let f=this.r.get(o);return f||(f=(async()=>{try{if(this.profiles.find(y=>y.name===o||y.id===n))throw new Error(`Profile with ${o} name already exists`);const L=r(n,o,(0,k.$hh)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(L.location);const E=[];return this.j.fire({profile:L,join(y){E.push(y)}}),await b.Promises.settled(E),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,f)),f}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(f=>f.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=r(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(f=>f.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:o,join(f){l.push(f)}});try{await Promise.allSettled(l)}catch(f){this.y.error(f)}for(const f of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(f)?.id&&this.C.emptyWindows.delete(f);for(const f of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(f)?.id&&this.C.workspaces.delete(f);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(f){(0,w.$rl)(f)!==w.FileOperationResult.FILE_NOT_FOUND&&this.y.error(f)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(f=>f.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),l=T.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,u.$Qi)(n)?this.s.folders.get(n.uri):(0,u.$Vi)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,u.$Qi)(n)?n.uri:(0,u.$Vi)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,l){const f=[...this.profiles,...n],I=[],L=this.s.profiles;this.s.profiles=[];for(let E of f){if(E.isDefault||o.some(C=>E.id===C.id))continue;E=l.find(C=>E.id===C.id)??E;const y=L.find(C=>E.id===C.id);if(E.isTransient)this.s.profiles.push(E);else{if(y){for(const[C,F]of this.s.emptyWindows.entries())if(E.id===F.id){this.L({id:C},E);break}for(const[C,F]of this.s.workspaces.entries())if(E.id===F.id){this.L({id:"",configPath:C},E);break}for(const[C,F]of this.s.folders.entries())if(E.id===F.id){this.L({id:"",uri:C},E);break}}I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.P(I),this.z=void 0,this.J(n,o,l)}J(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}L(n,o,l){if(l=o?.isTransient?!0:l,l)(0,u.$Qi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,u.$Vi)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const f=this.G(n);T.URI.isUri(f)?(this.C.workspaces.delete(f),o&&this.C.workspaces.set(f,o)):(this.C.emptyWindows.delete(f),o&&this.C.emptyWindows.set(f,o)),this.M()}}M(){const n={};for(const[l,f]of this.C.workspaces.entries())n[l.toString()]=f.id;const o={};for(const[l,f]of this.C.emptyWindows.entries())o[l.toString()]=f.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},l=this.D();if(n.workspaces)for(const[I,L]of Object.entries(n.workspaces)){const E=T.URI.parse(L);o[I]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}const f={};if(n.emptyWindows)for(const[I,L]of Object.entries(n.emptyWindows)){const E=T.URI.parse(L);f[I]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}return{workspaces:o,emptyWindows:f}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Pl=t,e.$Pl=t=ve([Y(0,A.$Ni),Y(1,w.$al),Y(2,h.$Kl),Y(3,m.$ak)],t);class a extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ql=a}),define(ce[251],le([0,1,6,2,20]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;let k=class extends c.$Xc{constructor(O){super(),this.B(new R.$Sh(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$yhc=k,e.$yhc=k=ve([Y(0,N.$Ml)],k)}),define(ce[84],le([0,1,19,6,26,8,3,2,5,13,9,162,28,33,36,60,10,24,18,29,20]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=void 0,e.$Eq=r,m=ke(m);let s=class extends O.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,o,l,f,I,L){super(),this.z=n,this.C=o,this.D=l,this.F=f,this.G=I,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$ne),this.s=this.B(new T.$ne),this.t=this.B(new T.$ne),this.u=this.B(new T.$ne),this.w=this.B(new T.$ne),this.y=[],this.B((0,O.$Vc)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.m.forEach(E=>E.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,u.$hp)(l,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const f=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:I})=>(0,$.$Kp)(I,n.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new u.$lp(`Unknown error while installing extension ${n.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(l){throw r(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new u.$lp(m.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];return await Promise.allSettled(n.map(async({extension:f,options:I})=>{try{const L=await this.N(f,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...L,options:I})}catch(L){o.push({identifier:f.identifier,operation:u.InstallOperation.Install,source:f,error:L,profileLocation:I.profileLocation??this.X()})}})),l.length&&o.push(...await this.I(l)),o}async uninstall(n,o={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,o)}async toggleAppliationScope(n,o){if((0,h.$un)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(n,this.H.defaultProfile.extensionsResource,o));for(const f of this.H.profiles){const I=(await this.getInstalled(h.ExtensionType.User,f.extensionsResource)).find(L=>(0,$.$Kp)(L.identifier,n.identifier));I?this.w.fire({local:I,profileLocation:f.extensionsResource}):this.u.fire({identifier:n.identifier,profileLocation:f.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:u.InstallOperation.Install,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const o=new Map,l=new Map,f=[],I=(E,y)=>`${$.$Lp.create(E).toString()}-${y.toString()}`,L=(E,y,C,F)=>{const D=this.Y(E,y,C),M=`${(0,$.$Pp)(E.publisher,E.name)}-${C.profileLocation.toString()}`;l.set(M,{task:D,root:F}),this.n.fire({identifier:D.identifier,source:y,profileLocation:C.profileLocation}),this.F.info("Installing extension:",D.identifier.id,C),S.URI.isUri(y)||this.j.set(I(y,C.profileLocation),{task:D,waitingTasks:[]})};try{for(const{manifest:E,extension:y,options:C}of n){const F=C.isApplicationScoped||C.isBuiltin||(0,h.$un)(E),D={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(y),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},M=S.URI.isUri(y)?void 0:this.j.get(I(y,D.profileLocation));M?(this.F.info("Extension is already requested to install",M.task.identifier.id,D.profileLocation.toString()),f.push(M.task.waitUntilTaskIsFinished())):L(E,y,D,void 0)}return await Promise.all([...l.values()].map(async({task:E})=>{if(E.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",E.identifier.id);else try{const y=await this.M(E.identifier,E.manifest,!!E.options.installOnlyNewlyAddedFromExtensionPack,!!E.options.installPreReleaseVersion,E.options.profileLocation,E.options.productVersion),C=await this.getInstalled(void 0,E.options.profileLocation,E.options.productVersion),F={...E.options,context:{...E.options.context,[u.$bp]:!0}};for(const{gallery:D,manifest:M}of(0,R.$Pb)(y,({gallery:K})=>K.identifier.id)){if(l.has(`${D.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const K=this.j.get(I(D,F.profileLocation));if(K){if(this.J(E,K.task)){const W=K.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,E.identifier.id,F.profileLocation.toString()),K.waitingTasks.push(E),f.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,_=>_.some(H=>(0,$.$Kp)(H.identifier,W)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,E.identifier.id,F.profileLocation.toString()),!_.find(ie=>(0,$.$Kp)(ie.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else C.some(({identifier:W})=>(0,$.$Kp)(W,D.identifier))||L(M,D,F,E)}}catch(y){if(S.URI.isUri(E.source))(0,R.$Ob)(E.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",E.identifier.id,y.message),(0,R.$Ob)(E.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",E.identifier.id,y.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",E.identifier.id),y}})),await this.L([...l.entries()].map(async([E,{task:y}])=>{const C=new Date().getTime();let F;try{F=await y.run(),await this.L(this.y.map(D=>D.postInstall(F,y.source,y.options,N.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(D){const M=r(D);throw S.URI.isUri(y.source)||t(this.C,y.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Sp)(y.source),error:M,source:y.options.context?.[u.$ap]}),o.set(E,{error:M,identifier:y.identifier,operation:y.operation,source:y.source,context:y.options.context,profileLocation:y.options.profileLocation,applicationScoped:y.options.isApplicationScoped}),this.F.error("Error while installing the extension",y.identifier.id,(0,k.$ab)(M),y.options.profileLocation.toString()),M}if(!S.URI.isUri(y.source)){const D=y.operation===u.InstallOperation.Update,M=D?void 0:(new Date().getTime()-y.source.lastUpdated)/1e3;if(t(this.C,D?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Sp)(y.source),verificationStatus:y.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:M,source:y.options.context?.[u.$ap]}),A.$o&&y.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,u.StatisticType.Install)}catch{}}o.set(E,{local:F,identifier:y.identifier,operation:y.operation,source:y.source,context:y.options.context,profileLocation:y.options.profileLocation,applicationScoped:F.isApplicationScoped})})),f.length&&await this.L(f),[...o.values()]}catch(E){const y=(D,M,K)=>{const W=[];D.manifest.extensionDependencies?.length&&W.push(...D.manifest.extensionDependencies),D.manifest.extensionPack?.length&&W.push(...D.manifest.extensionPack);for(const _ of W){if(K.includes(_.toLowerCase()))continue;K.push(_.toLowerCase());const H=o.get(`${_.toLowerCase()}-${M.toString()}`);H?.local&&(K=y(H.local,M,K))}return K},C=D=>({identifier:D.identifier,operation:u.InstallOperation.Install,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,error:E}),F=[];for(const[D,{task:M,root:K}]of l){const W=o.get(D);W?W.local&&K&&!o.get(`${K.identifier.id.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local&&(F.push(this.Z(W.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),o.set(D,C(M))):(M.cancel(),o.set(D,C(M)))}for(const[D,{task:M}]of l){const K=o.get(D);if(!K?.local||M.options.donotIncludePackAndDependencies)continue;y(K.local,M.options.profileLocation,[K.local.identifier.id.toLowerCase()]).slice(1).some(_=>l.has(`${_.toLowerCase()}-${M.options.profileLocation.toString()}`)&&!o.get(`${_.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local)&&(F.push(this.Z(K.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),o.set(D,C(M)))}throw F.length&&await Promise.allSettled(F.map(async D=>{try{await D.run(),this.F.info("Rollback: Uninstalled extension",D.extension.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",D.extension.identifier.id,(0,k.$ab)(M))}})),E}finally{for(const{task:E}of l.values())E.source&&!S.URI.isUri(E.source)&&this.j.delete(I(E.source,E.options.profileLocation));if(o.size){const E=[...o.values()];for(const y of E)y.local&&this.F.info("Extension installed successfully:",y.identifier.id,y.profileLocation.toString());this.s.fire(E)}}}J(n,o){for(const[,{task:l,waitingTasks:f}]of this.j.entries())if(l===n&&(f.includes(o)||f.some(I=>this.J(I,o)))||l===o&&f[0]&&!this.J(n,f[0]))return!1;return!0}async L(n,o){const l=[],f=[],I=await Promise.allSettled(n);for(const E of I)E.status==="fulfilled"?l.push(E.value):f.push(r(E.reason,o));if(!f.length)return l;if(f.length===1)throw f[0];let L=new u.$lp("",u.ExtensionManagementErrorCode.Unknown);for(const E of f)L=new u.$lp(L.message?`${L.message}, ${E.message}`:E.message,E.code!==u.ExtensionManagementErrorCode.Unknown&&E.code!==u.ExtensionManagementErrorCode.Internal?E.code:L.code);throw L}async M(n,o,l,f,I,L){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,I,L),y=[],C=[],F=async(D,M)=>{y.push(D);const K=M.extensionDependencies||[],W=[...K];if(M.extensionPack){const _=l?E.find(H=>(0,$.$Kp)(H.identifier,D)):void 0;for(const H of M.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(ie=>(0,$.$Kp)({id:ie},{id:H}))||W.every(ie=>!(0,$.$Kp)({id:ie},{id:H}))&&W.push(H)}if(W.length){const _=W.filter(H=>y.every(ie=>!(0,$.$Kp)(ie,{id:H})));if(_.length){const H=await this.z.getExtensions(_.map(ie=>({id:ie,preRelease:f})),N.CancellationToken.None);for(const ie of H){if(y.find(te=>(0,$.$Kp)(te,ie.identifier)))continue;const V=K.some(te=>(0,$.$Kp)({id:te},ie.identifier));let z;try{z=await this.N(ie,!1,f,L)}catch(te){if(V)throw te;this.F.info("Skipping the packed extension as it cannot be installed",ie.identifier.id,(0,k.$ab)(te));continue}C.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(n,o),C}async N(n,o,l,f){let I;const L=await this.getExtensionsControlManifest();if(L.malicious.some(C=>(0,$.$Kp)(n.identifier,C)))throw new u.$lp(m.localize(1,null,n.identifier.id),u.ExtensionManagementErrorCode.Malicious);const E=L.deprecated[n.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},N.CancellationToken.None))[0],!I)throw new u.$lp(m.localize(2,null,n.identifier.id,E.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const C=await this.getTargetPlatform();throw new u.$lp(m.localize(3,null,n.identifier.id,this.G.nameLong,(0,u.$dp)(C)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(n,o,l,f),!I){const C=[];throw(0,b.$5p)(n.properties.enabledApiProposals??[],C)?!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],N.CancellationToken.None))[0]?new u.$lp(m.localize(5,null,n.displayName??n.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$lp(m.localize(6,null,n.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible):new u.$lp(m.localize(4,null,n.displayName??n.identifier.id,C[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",I.identifier.id);const y=await this.z.getManifest(I,N.CancellationToken.None);if(y===null)throw new u.$lp(`Missing manifest for extension ${I.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(y.version!==I.version)throw new u.$lp(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:y}}async O(n,o,l,f){const I=await this.getTargetPlatform();let L=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(L=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:f},N.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(n,l,I,f)&&(L=n),L||(o?L=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:I,compatible:!0,productVersion:f},N.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(n,l,I,f)),L}async P(n,o){const l={...o,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},f=F=>`${F.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(f(n.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),I.waitUntilTaskIsFinished();const L=F=>{const D=this.Z(F,l);return this.m.set(f(D.extension.identifier),D),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:l.profileLocation,applicationScoped:F.isApplicationScoped}),D},E=(F,D)=>{D?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,l.profileLocation.toString(),D.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,D.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Rp)(F),error:D}),this.u.fire({identifier:F.identifier,error:D?.code,profileLocation:l.profileLocation,applicationScoped:F.isApplicationScoped})},y=[],C=[];try{y.push(L(n));const F=await this.getInstalled(h.ExtensionType.User,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const D=this.S(n,F);for(const M of D)this.m.has(f(M.identifier))?this.F.info("Extensions is already requested to uninstall",M.identifier.id):y.push(L(M))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(y.map(D=>D.extension),F,n),await this.L(y.map(async D=>{try{if(await D.run(),await this.L(this.y.map(M=>M.postUninstall(D.extension,l,N.CancellationToken.None))),D.extension.identifier.uuid)try{await this.z.reportStatistic(D.extension.manifest.publisher,D.extension.manifest.name,D.extension.manifest.version,u.StatisticType.Uninstall)}catch{}E(D.extension)}catch(M){const K=r(M);throw E(D.extension,K),K}finally{C.push(D)}}))}catch(F){const D=r(F);for(const M of y){try{M.cancel()}catch{}C.includes(M)||E(M.extension,D)}throw D}finally{for(const F of y)this.m.delete(f(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(n,o,l){for(const f of n){const I=this.U(f,o);if(I.length){const L=I.filter(E=>!n.some(y=>(0,$.$Kp)(y.identifier,E.identifier)));if(L.length)throw new Error(this.R(f,L,l))}}}R(n,o,l){return l===n?o.length===1?m.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(9,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?m.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(12,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(n,o,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const I=o.filter(E=>!E.isBuiltin&&f.some(y=>(0,$.$Kp)({id:y},E.identifier))),L=[];for(const E of I)L.push(...this.S(E,o,l));return[...I,...L]}return[]}U(n,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(f=>(0,$.$Kp)({id:f},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$ab)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$Dq=s,e.$Dq=s=ve([Y(0,u.$jp),Y(1,p.$_l),Y(2,P.$Kl),Y(3,v.$ak),Y(4,d.$tk),Y(5,g.$Ml)],s);function r(i,n){if(i instanceof u.$lp)return i;let o;return i instanceof u.$kp?o=new u.$lp(i.message,i.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):o=new u.$lp(i.message,(0,k.$7)(i)?u.ExtensionManagementErrorCode.Cancelled:n??u.ExtensionManagementErrorCode.Internal),o.stack=i.stack,o}function t(i,n,{extensionData:o,verificationStatus:l,duration:f,error:I,source:L,durationSinceUpdate:E}){let y,C;(0,w.$og)(l)&&(l===!0?l="Verified":(l===!1||(y=u.ExtensionManagementErrorCode.Signature,C=l),l="Unverified")),I&&(y=I.code,I.code===u.ExtensionManagementErrorCode.Signature&&(C=I.message)),i.publicLog(n,{...o,verificationStatus:l,success:!I,duration:f,errorcode:y,errorcodeDetail:C,durationSinceUpdate:E,source:L})}class a{constructor(){this.d=new c.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$th)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$th)(n=>new Promise((o,l)=>{const f=n.onCancellationRequested(()=>{f.dispose(),l(new k.$8)})})),this.d.open()),this.g.cancel()}}e.$Fq=a}),define(ce[53],le([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class P extends Error{constructor(a,i){super(a),this.code=i}}e.$Gq=P,e.$Hq=(0,m.$Gi)("IExtensionsProfileScannerService");let g=class extends N.$Xc{constructor(a,i,n,o,l,f){super(),this.j=a,this.m=i,this.n=n,this.r=o,this.s=l,this.t=f,this.b=this.B(new k.$ne),this.onAddExtensions=this.b.event,this.c=this.B(new k.$ne),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$ne),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$ne),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Dc}scanProfileExtensions(a,i){return this.u(a,void 0,i)}async addExtensionsToProfile(a,i,n){const o=[],l=[];try{return await this.u(i,f=>{const I=[];if(n)I.push(...f);else for(const L of f)a.some(([E])=>(0,w.$Kp)(E.identifier,L.identifier)&&E.manifest.version!==L.version)?o.push(L):I.push(L);for(const[L,E]of a){const y=I.findIndex(F=>(0,w.$Kp)(F.identifier,L.identifier)&&F.version===L.manifest.version),C={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:E};y===-1?(l.push(C),I.push(C)):I.splice(y,1,C)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),I}),l.length&&this.c.fire({extensions:l,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),l}catch(f){throw l.length&&this.c.fire({extensions:l,error:f,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:f,profileLocation:i}),f}}async updateMetadata(a,i){const n=[];return await this.u(i,o=>{const l=[];for(const f of o){const I=a.find(([L])=>(0,w.$Kp)(L.identifier,f.identifier)&&L.manifest.version===f.version);I&&(f.metadata={...f.metadata,...I[1]},n.push(f)),l.push(f)}return l}),n}async removeExtensionFromProfile(a,i){const n=[];try{await this.u(i,o=>{const l=[];for(const f of o)(0,w.$Kp)(f.identifier,a.identifier)?n.push(f):l.push(f);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(a,i,n){return this.F(a).queue(async()=>{let o=[],l;try{const f=await this.m.readFile(a);l=JSON.parse(f.value.toString().trim()||"[]")}catch(f){if((0,S.$rl)(f)!==S.FileOperationResult.FILE_NOT_FOUND)throw f;if(this.r.extUri.isEqual(a,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new P((0,v.$ab)(f),p.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(a);let f=!1;for(const I of l){s(I)||this.w(a);let L;if((0,b.$gg)(I.relativeLocation)&&I.relativeLocation)L=this.z(I.relativeLocation);else if((0,b.$gg)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{L=O.URI.revive(I.location);const E=this.y(L);E&&(f=!0,I.relativeLocation=E)}(0,b.$ng)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(f=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:L,version:I.version,metadata:I.metadata})}f&&await this.m.writeFile(a,c.$Pe.fromString(JSON.stringify(l)))}if(i){o=i(o);const f=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(a,c.$Pe.fromString(JSON.stringify(f)))}return o})}w(a){const i=new P(`Invalid extensions content in ${a.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(a){return this.r.extUri.isEqual(this.r.extUri.dirname(a),this.j)?this.r.extUri.basename(a):void 0}z(a){return this.r.extUri.joinPath(this.j,a)}async D(){return this.C||(this.C=(async()=>{const a=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(a)).value.toString()}catch(l){if((0,S.$rl)(l)===S.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",a.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(f=>s(f))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Pe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",a.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$rl)(l)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",a.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(a)}catch(l){(0,S.$rl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$rl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(a){let i=this.h.get(a);return i||(i=new R.$Nh,this.h.set(a,i)),i}};e.$Iq=g,e.$Iq=g=ve([Y(1,S.$al),Y(2,$.$Ml),Y(3,h.$Kl),Y(4,d.$_l),Y(5,u.$ak)],g);function s(t){return(0,b.$ig)(t)&&(0,A.$ip)(t.identifier)&&(r(t.location)||(0,b.$gg)(t.location)&&t.location)&&((0,b.$ng)(t.relativeLocation)||(0,b.$gg)(t.relativeLocation))&&t.version&&(0,b.$gg)(t.version)}function r(t){return t?(0,b.$gg)(t.path)&&(0,b.$gg)(t.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[85],le([0,1,19,6,30,15,8,34,144,2,23,14,5,21,61,92,13,9,165,16,33,36,60,7,4,10,24,3,69,53,20,29,194]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t,a,i,n,o,l,f,I,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=K,N=ke(N),m=ke(m),u=ke(u),h=ke(h),b=it(b);var y;(function(_){function H(ie,V){if(ie===V)return!0;const z=Object.keys(ie),te=new Set;for(const se of Object.keys(V))te.add(se);if(z.length!==te.size)return!1;for(const se of z){if(ie[se]!==V[se])return!1;te.delete(se)}return te.size===0}_.equals=H})(y||(e.Translations=y={})),e.$Lq=(0,a.$Gi)("IExtensionsScannerService");let C=class extends w.$Xc{constructor(H,ie,V,z,te,se,he,q,Z,X,G,U){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=te,this.u=se,this.w=he,this.y=q,this.z=Z,this.C=X,this.D=G,this.F=U,this.g=this.B(new o.$ne),this.onDidChangeCache=this.g.event,this.h=(0,$.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(D,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(H,ie,V){const[z,te]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(ie)]),se=V?await this.scanExtensionsUnderDevelopment(H,[...z,...te]):[];return this.L(z,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const ie=[];ie.push(this.M(!!H.useCache,H.language)),ie.push(this.N(H.language,!!H.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],s.ExtensionType.System,H,!1)}async scanUserExtensions(H){const ie=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!H.profileLocation,s.ExtensionType.User,!H.includeUninstalled,H.language,!0,V,H.productVersion??this.R()),te=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let se;try{se=await te.scanExtensions(z)}catch(he){if(he instanceof f.$Gq&&he.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),se=await te.scanExtensions(z);else throw he}return se=await this.J(se,s.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(H,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const te=await this.P(z,!1,s.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(te)).map(he=>(he.type=ie.find(q=>(0,g.$Kp)(q.identifier,he.identifier))?.type??he.type,this.n.validate(he,te)))}))).flat();return this.J(V,"development",H,!0)}return[]}async scanExistingExtension(H,ie,V){const z=await this.P(H,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanExtension(z);return!te||!V.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(H,ie,V){const z=await this.P(H,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),te=await this.n.scanOneOrMultipleExtensions(z);return this.J(te,ie,V,!0)}async scanMultipleExtensions(H,ie,V){const z=[];return await Promise.all(H.map(async te=>{const se=await this.scanOneOrMultipleExtensions(te,ie,V);z.push(...se)})),this.J(z,ie,V,!0)}async scanMetadata(H){const ie=(0,$.$hh)(H,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(H,ie){const V=(0,$.$hh)(H,"package.json"),z=(await this.w.readFile(V)).value.toString(),te=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,te.__metadata={...te.__metadata,...ie},await this.w.writeFile((0,$.$hh)(H,"package.json"),k.$Pe.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof f.$Gq&&H.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Pe.fromString(JSON.stringify([])))}catch(ie){(0,t.$rl)(ie)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$ab)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,ie,V,z){return V.includeAllVersions||(H=this.L(ie===s.ExtensionType.System?H:void 0,ie===s.ExtensionType.User?H:void 0,ie==="development"?H:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(H=H.filter(te=>te.isValid)),H.sort((te,se)=>{const he=m.$qc(te.location.fsPath),q=m.$qc(se.location.fsPath);return he<q?-1:he>q?1:0})}L(H,ie,V,z,te){const se=(q,Z,X)=>{if(q.isValid&&!Z.isValid)return!1;if(q.isValid===Z.isValid){if(te&&h.gt(q.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(h.eq(q.manifest.version,Z.manifest.version)){if(q.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`),!0},he=new s.$tn;return H?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),ie?.forEach(q=>{const Z=he.get(q.identifier.id);if(!Z&&H&&q.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),V?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!0))&&he.set(q.identifier.id,q),he.set(q.identifier.id,q)}),[...he.values()]}async M(H,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,ie,!0,void 0,this.R()),te=await(H&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",te.length),te}async N(H,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},te=[],se=d.URI.file(m.$kc(m.$mc(S.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const Z=z[q.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":te.push((0,$.$hh)(se,q.name));break;default:te.push(d.URI.file(Z));break}}const he=await Promise.all(te.map(async q=>this.n.scanExtension(await this.P(q,!1,s.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,R.$Kb)(he)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,ie,V,z,te,se,he,q){const Z=await this.f(te??u.$w),X=await this.Q(H),G=ie&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=G?await this.Q(G):void 0;return new F(H,X,G,U,ie,he,V,z,se,q.version,q.date,this.C.commit,!this.z.isBuilt,te,Z)}async Q(H){try{const ie=await this.w.stat(H);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=C,e.$Mq=C=ve([Y(4,I.$Ml),Y(5,f.$Hq),Y(6,t.$al),Y(7,i.$ak),Y(8,P.$Ni),Y(9,n.$tk),Y(10,L.$Kl),Y(11,a.$Fi)],C);class F{constructor(H,ie,V,z,te,se,he,q,Z,X,G,U,Q,B,j){this.location=H,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=te,this.profileScanOptions=se,this.type=he,this.excludeObsolete=q,this.validate=Z,this.productVersion=X,this.productDate=G,this.productCommit=U,this.devMode=Q,this.language=B,this.translations=j}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,ie){return(0,$.$ah)(H.location,ie.location)&&H.mtime===ie.mtime&&(0,$.$ah)(H.applicationExtensionslocation,ie.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&H.profile===ie.profile&&N.$io(H.profileScanOptions,ie.profileScanOptions)&&H.type===ie.type&&H.excludeObsolete===ie.excludeObsolete&&H.validate===ie.validate&&H.productVersion===ie.productVersion&&H.productDate===ie.productDate&&H.productCommit===ie.productCommit&&H.devMode===ie.devMode&&H.language===ie.language&&y.equals(H.translations,ie.translations)}}e.$Nq=F;let D=class extends w.$Xc{constructor(H,ie,V,z,te,se){super(),this.g=H,this.h=ie,this.j=V,this.m=z,this.n=se,this.f=te.extensionsEnabledWithApiProposalVersion?.map(he=>he.toLowerCase())??[]}async scanExtensions(H){const ie=H.profile?await this.s(H):await this.r(H);let V={};if(H.excludeObsolete&&H.type===s.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();V=JSON.parse(z)}catch{}return(0,v.$tg)(V)?ie:ie.filter(z=>!V[g.$Lp.create(z).toString()])}async r(H){const ie=await this.m.resolve(H.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||H.type===s.ExtensionType.User&&(0,$.$eh)(z.resource).indexOf(".")===0)return null;const te=new F(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(te)}));return(0,R.$Kb)(V).sort((z,te)=>z.location.path<te.location.path?-1:1)}async s(H){let ie=await this.t(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.t(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);ie.push(...V)}return ie}async t(H,ie,V){const z=await this.h.scanProfileExtensions(H,V.profileScanOptions);if(!z.length)return[];const te=await Promise.all(z.map(async se=>{if(ie(se)){const he=new F(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(he,se.metadata)}return null}));return(0,R.$Kb)(te)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,$.$hh)(H.location,"package.json"))){const ie=await this.scanExtension(H);return ie?[ie]:[]}else return await this.scanExtensions(H)}catch(ie){return this.n.error(`Error scanning extensions at ${H.location.path}:`,(0,T.$ab)(ie)),[]}}async scanExtension(H,ie){try{let V=await this.u(H.location);if(V){V.publisher||(V.publisher=s.$nn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,g.$Pp)(V.publisher,V.name),te=ie?.id?{id:z,uuid:ie.id}:{id:z},se=ie?.isSystem?s.ExtensionType.System:H.type,he=se===s.ExtensionType.System||!!ie?.isBuiltin;V=await this.w(H.location,V,F.createNlsConfiguration(H)),V.enabledApiProposals&&!this.f?.includes(z.toLowerCase())&&(V.enabledApiProposals=(0,s.$zn)([...V.enabledApiProposals]));const q={type:se,identifier:te,manifest:V,location:H.location,isBuiltin:he,targetPlatform:ie?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return H.validate?this.validate(q,H):q}}catch(V){H.type!==s.ExtensionType.System&&this.n.error(V)}return null}validate(H,ie){let V=!0;const z=(0,r.$2p)(ie.productVersion,ie.productDate,ie.location,H.manifest,H.isBuiltin);for(const[te,se]of z)te===b.default.Error&&(V=!1,this.n.error(this.D(ie.location,se)));return H.isValid=V,H.validations=z,H}async u(H){const ie=(0,$.$hh)(H,"package.json");let V;try{V=(await this.m.readFile(ie)).value.toString()}catch(te){return(0,t.$rl)(te)!==t.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(H,(0,p.localize)(0,null,ie.path,te.message))),null}let z;try{z=JSON.parse(V)}catch{const se=[];(0,O.$Yn)(V,se);for(const he of se)this.n.error(this.D(H,(0,p.localize)(1,null,ie.path,he.offset,he.length,(0,A.$Jq)(he.error))));return null}return(0,O.$7n)(z)!=="object"?(this.n.error(this.D(H,(0,p.localize)(2,null,ie.path))),null):z}async w(H,ie,V){const z=await this.y(H,ie,V);if(z)try{const te=[],se=await this.z(z.default,te);if(te.length>0)return te.forEach(q=>{this.n.error(this.D(H,(0,p.localize)(3,null,z.default?.path,(0,A.$Jq)(q.error))))}),ie;if((0,O.$7n)(z)!=="object")return this.n.error(this.D(H,(0,p.localize)(4,null,z.default?.path))),ie;const he=z.values||Object.create(null);return(0,E.$Kq)(this.n,ie,he,se)}catch{}return ie}async y(H,ie,V){const z=(0,$.$hh)(H,"package.nls.json"),te=(Z,X)=>{X.forEach(G=>{this.n.error(this.D(H,(0,p.localize)(5,null,Z?.path,(0,A.$Jq)(G.error))))})},se=Z=>{this.n.error(this.D(H,(0,p.localize)(6,null,Z?.path)))},he=`${ie.publisher}.${ie.name}`,q=V.translations[he];if(q)try{const Z=d.URI.file(q),X=(await this.m.readFile(Z)).value.toString(),G=[],U=(0,O.$Yn)(X,G);return G.length>0?(te(Z,G),{values:void 0,default:z}):(0,O.$7n)(U)!=="object"?(se(Z),{values:void 0,default:z}):{values:U.contents?U.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let X;try{X=await this.C(H,V)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const G=(await this.m.readFile(X.localized)).value.toString(),U=[],Q=(0,O.$Yn)(G,U);return U.length>0?(te(X.localized,U),{values:void 0,default:X.original}):(0,O.$7n)(Q)!=="object"?(se(X.localized),{values:void 0,default:X.original}):{values:Q,default:X.original}}catch{return{values:void 0,default:X.original}}}}async z(H,ie){if(H)try{const V=(await this.m.readFile(H)).value.toString();return(0,O.$Yn)(V,ie)}catch{}}C(H,ie){return new Promise((V,z)=>{const te=se=>{const he=(0,$.$hh)(H,`package.nls.${se}.json`);this.m.exists(he).then(q=>{q&&V({localized:he,original:(0,$.$hh)(H,"package.nls.json")});const Z=se.lastIndexOf("-");Z===-1?V({localized:(0,$.$hh)(H,"package.nls.json"),original:null}):(se=se.substring(0,Z),te(se))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$hh)(H,"package.nls.json"),original:null});te(ie.language)})}D(H,ie){return`[${H.path}]: ${ie}`}};D=ve([Y(1,f.$Hq),Y(2,L.$Kl),Y(3,t.$al),Y(4,n.$tk),Y(5,i.$ak)],D);let M=class extends D{constructor(H,ie,V,z,te,se,he,q){super(ie,z,te,se,he,q),this.I=H,this.J=V,this.G=this.B(new c.$Eh(3e3)),this.H=this.B(new o.$ne),this.onDidChangeCache=this.H.event}async scanExtensions(H){const ie=this.O(H),V=await this.L(ie);if(this.F=H,V&&V.input&&F.equals(V.input,this.F))return this.n.debug("Using cached extensions scan result",H.type===s.ExtensionType.System?"system":"user",H.location.toString()),this.G.trigger(()=>this.N()),V.result.map(te=>(te.location=d.URI.revive(te.location),te));const z=await super.scanExtensions(H);return await this.M(ie,{input:H,result:z}),z}async L(H){try{const ie=await this.m.readFile(H),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,l.$di)(V.input)}}catch(ie){this.n.debug("Error while reading the extension cache file:",H.path,(0,T.$ab)(ie))}return null}async M(H,ie){try{await this.m.writeFile(H,k.$Pe.fromString(JSON.stringify(ie)))}catch(V){this.n.debug("Error while writing the extension cache file:",H.path,(0,T.$ab)(V))}}async N(){if(!this.F)return;const H=this.O(this.F),ie=await this.L(H);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!N.$io(z,V))try{this.n.info("Invalidating Cache",V,z),await this.m.del(H),this.H.fire()}catch(te){this.n.error(te)}}O(H){const ie=this.P(H);return this.j.extUri.joinPath(ie.cacheHome,H.type===s.ExtensionType.System?s.$mn:s.$ln)}P(H){return H.type===s.ExtensionType.System?this.J.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ie=>this.j.extUri.isEqual(H.location,ie.extensionsResource))??this.I:this.J.defaultProfile}};M=ve([Y(2,I.$Ml),Y(3,f.$Hq),Y(4,L.$Kl),Y(5,t.$al),Y(6,n.$tk),Y(7,i.$ak)],M);function K(_,H){const ie=(0,g.$Np)(_.manifest.publisher,_.manifest.name);return{id:ie,identifier:new s.$rn(ie),isBuiltin:_.type===s.ExtensionType.System,isUserBuiltin:_.type===s.ExtensionType.User&&_.isBuiltin,isUnderDevelopment:H,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,publisherDisplayName:_.publisherDisplayName,..._.manifest}}class W extends C{constructor(H,ie,V,z,te,se,he,q,Z,X,G,U){super(H,ie,(0,$.$hh)(V,".vscode-oss-dev","extensions","control.json"),z,te,se,he,q,Z,X,G,U),this.S=(async()=>{if(u.$z)try{const Q=await this.w.readFile(d.URI.file(u.$z));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Pq=W}),define(ce[252],le([0,1,70,6,41,3,2,23,14,31,10,20]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let u=class extends T.$Xc{constructor(h,b){super(),this.b=h,this.f=b,this.a=new c.$Mh(5)}async postUninstall(h){const b=this.g(h,"uninstall");b&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,h),this.f.info("Finished running post uninstall script",h.identifier.id,h.manifest.version)}catch(v){this.f.error("Failed to run post uninstall script",h.identifier.id,h.manifest.version),this.f.error(v)}}));try{await w.Promises.rm(this.m(h))}catch(v){this.f.error("Error while removing extension storage path",h.identifier.id),this.f.error(v)}}g(h,b){const v=`vscode:${b}`;if(h.location.scheme===O.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const d=h.manifest.scripts[v].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,A.$mc)(h.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(h,b,v,d,p){return new Promise((P,g)=>{const s=this.j(h,b,v,p);let r;const t=a=>{r&&(clearTimeout(r),r=null),a?g(a):P(void 0)};s.on("error",a=>{t((0,N.$rj)(a)||"Unknown")}),s.on("exit",(a,i)=>{t(a?`post-${b} process exited with code ${a}`:void 0)}),d&&(r=setTimeout(()=>{r=null,s.kill(),g("timed out")},5e3))})}j(h,b,v,d){const p={silent:!0,execArgv:void 0},P=(0,R.fork)(h,[`--type=extension-post-${b}`,...v],p);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const g=k.Event.fromNodeEventEmitter(P.stdout,"data"),s=k.Event.fromNodeEventEmitter(P.stderr,"data");this.B(g(a=>this.f.info(d.identifier.id,d.manifest.version,`post-${b}`,a))),this.B(s(a=>this.f.error(d.identifier.id,d.manifest.version,`post-${b}`,a)));const r=k.Event.any(k.Event.map(g,a=>({data:`%c${a}`,format:[""]}),this.q),k.Event.map(s,a=>({data:`%c${a}`,format:["color: red"]}),this.q));return k.Event.debounce(r,(a,i)=>a?{data:a.data+i.data,format:[...a.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(a=>{console.group(d.identifier.id),console.log(a.data,...a.format),console.groupEnd()}),P}m(h){return(0,A.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};e.$Tq=u,e.$Tq=u=ve([Y(0,m.$Ml),Y(1,S.$ak)],u)}),define(ce[117],le([0,1,73,167,84,28]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=T,e.$Rq=O;function T(A){let w=k.ExtensionManagementErrorCode.Extract;return A instanceof R.$zq&&(A.type==="CorruptZip"?w=k.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(w=k.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$Eq)(A,w)}async function O(A){let w;try{w=await(0,R.$Cq)(A,"extension/package.json")}catch(S){throw T(S)}try{return JSON.parse(w.toString("utf8"))}catch{throw new k.$lp((0,c.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(ce[253],le([0,1,6,8,2,23,21,61,13,32,31,73,22,16,84,28,33,117,111,7,10,18]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,O=ke(O);let t=class extends N.$Xc{static{r=this}static{this.c=".sigzip"}constructor(i,n,o,l,f,I,L){super(),this.h=n,this.j=o,this.m=l,this.n=f,this.r=I,this.t=L,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,o,l){await this.g;const f=await this.w(i,n);let I=!1;if(o&&this.u(i)){let L;try{L=await this.y(i)}catch(E){try{await this.delete(f)}catch(y){this.t.error(y)}throw E}try{I=await this.n.verify(i,f.fsPath,L.fsPath,l)}catch(E){if(I=E.code,I===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||I===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(f)}catch(y){this.t.error(y)}throw new b.$lp(m.$yq,b.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(E){this.t.error(E)}}}return{location:f,verificationStatus:I}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,A.$mg)(n)?n:!0}async w(i,n){try{const o=(0,T.$hh)(this.extensionsDownloadDir,this.G(i)),l=await this.C(i,"vsix",async()=>{await this.z(i,o,f=>this.j.download(i,f,n));try{await this.D(o.fsPath,"extension/package.json")}catch(f){try{await this.h.del(o)}catch(I){this.t.warn(`Error while deleting: ${o.path}`,(0,c.$ab)(I))}throw f}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:l}),o}catch(o){throw(0,h.$Eq)(o,b.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,T.$hh)(this.extensionsDownloadDir,`.${(0,w.$3g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(l){try{await this.h.del(n)}catch(f){this.t.warn(`Error while deleting: ${n.path}`,(0,c.$ab)(f))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),n}catch(n){throw(0,h.$Eq)(n,b.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,o){if(await this.h.exists(n))return;if(n.scheme!==k.Schemas.file){await o(n);return}const l=(0,T.$hh)(this.extensionsDownloadDir,`.${(0,w.$3g)()}`);try{await o(l)}catch(f){try{await this.h.del(l)}catch{}throw f}try{await S.Promises.rename(l.fsPath,n.fsPath,2*60*1e3)}catch(f){try{await this.h.del(l)}catch{}let I=!1;try{I=await this.h.exists(n)}catch{}if(I)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,c.$ab)(f)}. Deleted the file from downloaded location`,l.path),f}}async C(i,n,o,l){let f=1;for(;;)try{return await o(),f}catch(I){if(f++>l)throw I;this.t.warn(`Failed downloading ${n}. ${(0,c.$ab)(I)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,m.$Cq)(i,n)}catch(o){throw(0,d.$Qq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],o=[],l=[];for(const L of i.children)if(L.name.endsWith(r.c))l.push(L.resource);else{const E=v.$Lp.parse(L.name);E&&o.push([E,L])}const f=(0,v.$Qp)(o,([L])=>L),I=[];for(const L of f)L.sort((E,y)=>O.rcompare(E[0].version,y[0].version)),n.push(...L.slice(1).map(E=>E[1].resource)),I.push(L[0][1]);I.sort((L,E)=>L.mtime-E.mtime),n.push(...I.slice(0,Math.max(0,I.length-this.f)).map(L=>L.resource)),n.push(...l),await R.Promises.settled(n.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(i){this.t.error(i)}}G(i){return this.f?v.$Lp.create(i).toString().toLowerCase():(0,w.$3g)()}};e.$Sq=t,e.$Sq=t=r=ve([Y(0,$.$Oi),Y(1,P.$al),Y(2,b.$jp),Y(3,u.$aj),Y(4,p.$rq),Y(5,s.$_l),Y(6,g.$ak)],t)}),define(ce[118],le([0,1,6,15,26,41,8,3,56,2,35,23,14,21,61,13,9,32,31,73,166,99,16,84,28,33,53,85,253,252,117,225,235,36,60,7,4,10,24,18,29,20]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t,a,i,n,o,l,f,I,L,E,y,C,F,D,M,K,W,_,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,u=ke(u),h=ke(h),p=ke(p),g=ke(g),e.$Wq=(0,D.$Hi)(a.$mp);const ie=".vsctmp";let V=class extends t.$Dq{constructor(q,Z,X,G,U,Q,B,j,x,ee,J,oe){super(q,Z,J,X,ee,oe),this.eb=U,this.fb=Q,this.gb=B,this.hb=j,this.ib=x,this.db=new Map,this.tb=new S.$Ec;const ue=this.B(j.createInstance(f.$Tq));this.ab=this.B(j.createInstance(z,pe=>ue.postUninstall(pe))),this.bb=this.B(new L.$Uq(oe,x,J,this,this.F)),this.cb=this.B(j.createInstance(l.$Sq));const ge=this.B(new E.$Vq(this,this.eb,oe,Q,J,x,X));this.B(ge.onDidChangeExtensionsByAnotherSource(pe=>this.sb(pe))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Vp)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const Z=await this.rb(q),X=await(0,P.zip)((0,$.$hh)(this.cb.extensionsDownloadDir,(0,d.$3g)()).fsPath,Z);return v.URI.file(X)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:Z,cleanup:X}=await this.lb(q),G=u.$nc(Z.fsPath);try{return await(0,I.$Rq)(G)}finally{await X()}}getInstalled(q,Z=this.H.defaultProfile.extensionsResource,X={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,Z,X)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,Z={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:X,cleanup:G}=await this.lb(q);try{const U=await(0,I.$Rq)(u.$nc(X.fsPath)),Q=(0,i.$Pp)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,C.$4p)(U.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,Q,this.G.version));const j=(await this.I([{manifest:U,extension:X,options:Z}])).find(({identifier:x})=>(0,i.$Kp)(x,{id:Q}));if(j?.local)return j.local;throw j?.error?j.error:(0,t.$Eq)(new Error(`Unknown error while installing extension ${Q}`))}finally{await G()}}async installFromLocation(q,Z){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const X=await this.ab.scanUserExtensionAtLocation(q);if(!X||!X.manifest.name||!X.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[X,{source:"resource"}]],Z),this.F.info("Successfully installed extension",X.identifier.id,Z.toString()),X}async installExtensionsFromProfile(q,Z,X){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,Z.toString(),X.toString());const G=(await this.getInstalled(y.ExtensionType.User,Z)).filter(U=>q.some(Q=>(0,i.$Kp)(Q,U.identifier)));if(G.length){const U=await Promise.all(G.map(Q=>this.ab.scanMetadata(Q,Z)));await this.wb(G.map((Q,B)=>[Q,U[B]]),X),this.F.info("Successfully installed extensions",G.map(Q=>Q.identifier.id),X.toString())}return G}async updateMetadata(q,Z,X){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0,Z.hasPreReleaseVersion=!0),Z.isMachineScoped===!1&&(Z.isMachineScoped=void 0),Z.isBuiltin===!1&&(Z.isBuiltin=void 0),Z.pinned===!1&&(Z.pinned=void 0),q=await this.ab.updateMetadata(q,Z,X),this.bb.invalidate(X),this.w.fire({local:q,profileLocation:X}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const Z=await this.getTargetPlatform(),[X]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:Z,compatible:!0},N.CancellationToken.None);if(!X)throw new Error(g.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(G){throw new Error(g.localize(3,null,(0,k.$rj)(G)))}return this.installFromGallery(X)}$(q,Z,X,G){return this.ab.copyExtension(q,Z,X,G)}copyExtensions(q,Z){return this.ab.copyExtensions(q,Z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,Z,X){const{location:G}=await this.cb.download(q,Z,!X);return G}async lb(q){if(q.scheme===m.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const Z=(0,$.$hh)(this.cb.extensionsDownloadDir,(0,d.$3g)());return await this.gb.download(q,Z),this.F.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.ib.del(Z)}catch(G){this.F.error(G)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,Z,X){const G=Z instanceof v.URI?new i.$Lp({id:(0,i.$Pp)(q.publisher,q.name)},q.version):i.$Lp.create(Z);return this.hb.createInstance(te,G,q,Z,X,(U,Q)=>{if(Z instanceof v.URI)return this.qb(G,Z,X,Q);let B=this.db.get(G.toString());return B||(this.db.set(G.toString(),B=this.pb(G,Z,U,X,Q)),B.finally(()=>this.db.delete(G.toString()))),B},this.ab)}Z(q,Z){return new se(q,Z.profileLocation,this.fb)}async pb(q,Z,X,G,U){const{verificationStatus:Q,location:B}=await this.cb.download(Z,X,!G.donotVerifySignature,G.context?.[a.$cp]);try{if(U.isCancellationRequested)throw new T.$8;return await(0,I.$Rq)(B.fsPath),{local:await this.ab.extractUserExtension(q,B.fsPath,{id:Z.identifier.uuid,publisherId:Z.publisherId,publisherDisplayName:Z.publisherDisplayName,targetPlatform:Z.properties.targetPlatform,isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,isPreReleaseVersion:Z.properties.isPreReleaseVersion,hasPreReleaseVersion:Z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,preRelease:(0,b.$mg)(G.preRelease)?G.preRelease:G.installPreReleaseVersion||Z.properties.isPreReleaseVersion,source:"gallery"},!1,U),verificationStatus:Q}}catch(j){try{await this.cb.delete(B)}catch(x){this.F.warn("Error while deleting the downloaded file",B.toString(),(0,T.$ab)(x))}throw(0,t.$Eq)(j)}}async qb(q,Z,X,G){return{local:await this.ab.extractUserExtension(q,u.$nc(Z.fsPath),{isApplicationScoped:X.isApplicationScoped,isMachineScoped:X.isMachineScoped,isBuiltin:X.isBuiltin,installedTimestamp:Date.now(),pinned:X.installGivenVersion?!0:!!X.pinned,source:"vsix"},!0,G)}}async rb(q){const Z=async G=>{let U=await p.Promises.readdir(G);U=U.map(j=>u.$mc(G,j));const Q=await Promise.all(U.map(j=>p.Promises.stat(j)));let B=Promise.resolve([]);return Q.forEach((j,x)=>{const ee=U[x];j.isFile()&&(B=B.then(J=>[...J,ee])),j.isDirectory()&&(B=B.then(J=>Z(ee).then(oe=>[...J,...oe])))}),B};return(await Z(q.location.fsPath)).map(G=>({path:`extension/${u.$oc(q.location.fsPath,G)}`,localPath:G}))}async sb({added:q,removed:Z}){if(Z){const X=q&&this.D.extUri.isEqual(Z.profileLocation,q.profileLocation)?Z.extensions.filter(G=>q.extensions.every(U=>!(0,i.$Kp)(U,G))):Z.extensions;for(const G of X)this.F.info("Extensions removed from another source",G.id,Z.profileLocation.toString()),this.u.fire({identifier:G,profileLocation:Z.profileLocation})}if(q){const G=(await this.getInstalled(y.ExtensionType.User,q.profileLocation)).filter(U=>q.extensions.some(Q=>(0,i.$Kp)(Q,U.identifier)));this.s.fire(G.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,q.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:q.profileLocation,operation:a.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(Z=>this.tb.add(Z)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const Z of q.children??[])Z.isDirectory&&this.tb.add(Z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(Z=>this.vb(Z)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,F.FileChangeType.ADDED))return;const Z=[];for(const X of q.rawAdded){if(this.tb.has(X)||!this.D.extUri.isEqual(this.D.extUri.dirname(X),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(X,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(X).startsWith(".")||!(await this.ib.stat(X)).isDirectory)continue;const G=await this.ab.scanUserExtensionAtLocation(X);G&&G.installedTimestamp===void 0&&(this.tb.add(X),Z.push(G))}Z.length&&(await this.wb(Z.map(X=>[X,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",Z.map(X=>X.identifier.id)))}async wb(q,Z){const X=q.map(G=>G[0]);await this.xb(X),await this.fb.addExtensionsToProfile(q,Z),this.s.fire(X.map(G=>({local:G,identifier:G.identifier,operation:a.InstallOperation.None,profileLocation:Z})))}async xb(q){const Z=await this.ab.getUninstalledExtensions();for(const X of q){const G=i.$Lp.create(X);Z[G.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",G.id),await this.ab.setInstalled(G),this.F.info("Removed the extension from uninstalled list:",G.id))}}};e.$Xq=V,e.$Xq=V=ve([Y(0,a.$jp),Y(1,W.$_l),Y(2,M.$ak),Y(3,r.$Oi),Y(4,o.$Lq),Y(5,n.$Hq),Y(6,s.$Zo),Y(7,D.$Fi),Y(8,F.$al),Y(9,K.$tk),Y(10,_.$Kl),Y(11,H.$Ml)],V);let z=class extends w.$Xc{constructor(q,Z,X,G,U,Q,B){super(),this.n=q,this.s=Z,this.t=X,this.u=G,this.w=U,this.y=Q,this.z=B,this.h=this.B(new O.$ne),this.onExtract=this.h.event,this.j=new S.$Dc,this.m=new S.$Dc,this.c=(0,$.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new R.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(q,Z,X){try{const G={includeInvalid:!0,profileLocation:Z,productVersion:X};let U=[];if(q===null||q===y.ExtensionType.System){let Q=this.j.get(Z);Q||(Q=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},G,!1).finally(()=>this.j.delete(Z)),this.j.set(Z,Q)),U.push(...await Q)}else if(q===y.ExtensionType.User){let Q=this.m.get(Z);Q||(Q=this.t.scanUserExtensions(G).finally(()=>this.m.delete(Z)),this.m.set(Z,Q)),U.push(...await Q)}return U=q!==null?U.filter(Q=>Q.type===q):U,await Promise.all(U.map(Q=>this.H(Q)))}catch(G){throw(0,t.$Eq)(G,a.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const Z=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(Z.map(X=>this.H(X)))}catch(Z){throw(0,t.$Eq)(Z,a.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const Z=await this.t.scanExistingExtension(q,y.ExtensionType.User,{includeInvalid:!0});if(Z)return await this.H(Z)}catch(Z){this.z.error(Z)}return null}async extractUserExtension(q,Z,X,G,U){const Q=q.toString(),B=v.URI.file(u.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$3g)()}`)),j=v.URI.file(u.$mc(this.t.userExtensionsLocation.fsPath,Q));let x=await this.s.exists(j);if(x&&G){try{await this.D(q.id,j,"removeExisting")}catch{throw new a.$lp(g.localize(4,null,j.fsPath,q.id),a.ExtensionManagementErrorCode.Delete)}x=!1}if(x)try{await this.t.updateMetadata(j,X)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:`${(0,F.$rl)(ee)}`}),(0,t.$Eq)(ee,a.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(U.isCancellationRequested)throw new T.$8;try{this.z.trace(`Started extracting the extension from ${Z} to ${j.fsPath}`),await(0,P.$Bq)(Z,B.fsPath,{sourcePath:"extension",overwrite:!0},U),this.z.info(`Extracted extension to ${j}:`,q.id)}catch(ee){throw(0,I.$Qq)(ee)}try{await this.t.updateMetadata(B,X)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:`${(0,F.$rl)(ee)}`}),(0,t.$Eq)(ee,a.ExtensionManagementErrorCode.UpdateMetadata)}if(U.isCancellationRequested)throw new T.$8;try{this.z.trace(`Started renaming the extension from ${B.fsPath} to ${j.fsPath}`),await this.G(B.fsPath,j.fsPath),this.z.info("Renamed to",j.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(B,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,T.$ab)(ee)}. Deleted from extracted location`,B),ee}this.h.fire(j)}catch(ee){try{await this.s.del(B,{recursive:!0})}catch{}throw ee}return this.scanLocalExtension(j,y.ExtensionType.User)}async scanMetadata(q,Z){return Z?(await this.C(q,Z))?.metadata:this.t.scanMetadata(q.location)}async C(q,Z){return(await this.u.scanProfileExtensions(Z)).find(G=>(0,i.$Kp)(G.identifier,q.identifier))}async updateMetadata(q,Z,X){try{X?await this.u.updateMetadata([[q,Z]],X):await this.t.updateMetadata(q.location,Z)}catch(G){throw this.y.publicLog2("extension:extract",{extensionId:q.identifier.id,code:`${(0,F.$rl)(G)}`}),(0,t.$Eq)(G,a.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(q.location,q.type,X)}async getUninstalledExtensions(){try{return await this.F()}catch(q){throw(0,t.$Eq)(q,a.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const Z=q.map(X=>i.$Lp.create(X));await this.F(X=>Z.forEach(G=>{X[G.toString()]=!0,this.z.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(q){try{await this.F(Z=>delete Z[q.toString()])}catch(Z){throw(0,t.$Eq)(Z,a.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,Z){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.D(q.identifier.id,q.location,Z)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.F(Z=>delete Z[i.$Lp.create(q).toString()])}async copyExtension(q,Z,X,G){const U=await this.C(q,Z),Q=await this.C(q,X);if(G={...U?.metadata,...G},Q)if(this.w.extUri.isEqual(Q.location,q.location))await this.u.updateMetadata([[q,{...Q.metadata,...G}]],X);else{const B=await this.scanLocalExtension(Q.location,q.type,X);await this.u.removeExtensionFromProfile(B,X),await this.u.addExtensionsToProfile([[q,{...Q.metadata,...G}]],X)}else await this.u.addExtensionsToProfile([[q,G]],X);return this.scanLocalExtension(q.location,q.type,X)}async copyExtensions(q,Z,X){const G=await this.scanExtensions(y.ExtensionType.User,q,X),U=await Promise.all(G.filter(Q=>!Q.isApplicationScoped).map(async Q=>[Q,await this.scanMetadata(Q,q)]));await this.u.addExtensionsToProfile(U,Z)}async D(q,Z,X){this.z.trace(`Deleting ${X} extension from disk`,q,Z.fsPath);const G=this.w.extUri.joinPath(this.w.extUri.dirname(Z),`${this.w.extUri.basename(Z)}.${(0,A.$uj)((0,d.$3g)()).toString(16)}${ie}`);await this.G(Z.fsPath,G.fsPath),await this.s.del(G,{recursive:!0}),this.z.info(`Deleted ${X} extension from disk`,q,Z.fsPath)}F(q){return this.g.queue(async()=>{let Z;try{Z=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(G){if((0,F.$rl)(G)!==F.FileOperationResult.FILE_NOT_FOUND)throw G}let X={};if(Z)try{X=JSON.parse(Z)}catch{}return q&&(q(X),Object.keys(X).length?await this.s.writeFile(this.c,c.$Pe.fromString(JSON.stringify(X))):await this.s.del(this.c)),X})}async G(q,Z){try{await p.Promises.rename(q,Z,2*60*1e3)}catch(X){throw(0,t.$Eq)(X,a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,Z,X){try{if(X){const U=(await this.t.scanUserExtensions({profileLocation:X})).find(Q=>this.w.extUri.isEqual(Q.location,q));if(U)return await this.H(U)}else{const G=await this.t.scanExistingExtension(q,Z,{includeInvalid:!0});if(G)return await this.H(G)}throw new a.$lp(g.localize(5,null,q.path),a.ExtensionManagementErrorCode.ScanningExtension)}catch(G){throw(0,t.$Eq)(G,a.ExtensionManagementErrorCode.ScanningExtension)}}async H(q){const Z=await this.s.resolve(q.location);let X,G;return Z.children&&(X=Z.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,G=Z.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:X,changelogUrl:G,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async I(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(q));const Z=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),X=new Set;for(const U of Z)q[i.$Lp.create(U).toString()]||X.add(U.identifier.id.toLowerCase());try{const U=(0,i.$Qp)(Z,Q=>Q.identifier);await R.Promises.settled(U.map(async Q=>{const B=Q.sort((j,x)=>h.rcompare(j.manifest.version,x.manifest.version))[0];X.has(B.identifier.id.toLowerCase())||await this.n(await this.H(B))}))}catch(U){this.z.error(U)}const G=Z.filter(U=>U.metadata&&q[i.$Lp.create(U).toString()]);await Promise.allSettled(G.map(U=>this.removeUninstalledExtension(U)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(Z){(0,F.$rl)(Z)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(Z);return}if(q?.children)try{await Promise.allSettled(q.children.map(async Z=>{if(!(!Z.isDirectory||!Z.name.endsWith(ie))){this.z.trace("Deleting the temporarily deleted folder",Z.resource.toString());try{await this.s.del(Z.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",Z.resource.toString())}catch(X){(0,F.$rl)(X)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(X)}}}))}catch{}}};e.$Yq=z,e.$Yq=z=ve([Y(1,F.$al),Y(2,o.$Lq),Y(3,n.$Hq),Y(4,_.$Kl),Y(5,W.$_l),Y(6,M.$ak)],z);let te=class extends t.$Fq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,Z,X,G,U,Q,B,j,x,ee,J,oe){super(),this.l=q,this.manifest=Z,this.source=X,this.options=G,this.m=U,this.n=Q,this.o=B,this.p=j,this.q=x,this.s=ee,this.t=J,this.u=oe,this.j=a.InstallOperation.Install,this.identifier=this.l.identifier}async h(q){const X=(await this.n.scanExtensions(y.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(B=>(0,i.$Kp)(B.identifier,this.identifier));X&&(this.j=a.InstallOperation.Update);const G={isApplicationScoped:this.options.isApplicationScoped||X?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||X?.isMachineScoped,isBuiltin:this.options.isBuiltin||X?.isBuiltin,isSystem:X?.type===y.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??X?.pinned,source:this.source instanceof v.URI?"vsix":"gallery"};let U;if(this.source instanceof v.URI){if(X&&this.l.equals(new i.$Lp(X.identifier,X.manifest.version)))try{await this.n.removeExtension(X,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}const B=await this.w(this.l);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(G.id=this.source.identifier.uuid,G.publisherId=this.source.publisherId,G.publisherDisplayName=this.source.publisherDisplayName,G.targetPlatform=this.source.properties.targetPlatform,G.updated=!!X,G.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,G.hasPreReleaseVersion=X?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,G.preRelease=(0,b.$mg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||X?.preRelease,X&&X.type!==y.ExtensionType.System&&X.manifest.version===this.source.version)return this.n.updateMetadata(X,G,this.options.profileLocation);U=await this.w(this.l)}if(q.isCancellationRequested)throw(0,t.$Eq)(new T.$8);if(!U){const B=await this.m(this.operation,q);U=B.local,this.k=B.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(B){throw(0,t.$Eq)(B,a.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,t.$Eq)(new T.$8);try{await this.t.addExtensionsToProfile([[U,G]],this.options.profileLocation,!U.isValid)}catch(B){throw(0,t.$Eq)(B,a.ExtensionManagementErrorCode.AddToProfile)}const Q=await this.n.scanLocalExtension(U.location,y.ExtensionType.User,this.options.profileLocation);if(!Q)throw new a.$lp("Cannot find the installed extension",a.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof v.URI&&this.x(U,q),Q}async w(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(G=>i.$Lp.create(G).equals(q))):void 0}async x(q,Z){try{let[X]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],Z);if(X||([X]=await this.p.getExtensions([{id:q.identifier.id}],Z)),X){const G={id:X.identifier.uuid,publisherDisplayName:X.publisherDisplayName,publisherId:X.publisherId,isPreReleaseVersion:X.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||X.properties.isPreReleaseVersion,preRelease:X.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,G,this.options.profileLocation)}}catch{}}};te=ve([Y(6,_.$Kl),Y(7,a.$jp),Y(8,H.$Ml),Y(9,o.$Lq),Y(10,n.$Hq),Y(11,M.$ak)],te);class se extends t.$Fq{constructor(q,Z,X){super(),this.extension=q,this.j=Z,this.k=X}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[254],le([0,1,10,20,29,18,53,7,16,9]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let S=class extends T.$Iq{constructor(u,$,h,b,v,d){super(w.URI.file(u.extensionsPath),$,h,b,v,d)}};e.$nR=S,e.$nR=S=ve([Y(0,A.$Oi),Y(1,O.$al),Y(2,c.$Ml),Y(3,N.$Kl),Y(4,k.$_l),Y(5,R.$ak)],S)}),define(ce[255],le([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;let u=class extends k.$Pq{constructor(h,b,v,d,p,P,g,s){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),p.userHome,h.defaultProfile,h,b,v,d,p,P,g,s)}};e.$wgc=u,e.$wgc=u=ve([Y(0,m.$Ml),Y(1,N.$Hq),Y(2,T.$al),Y(3,A.$ak),Y(4,c.$Oi),Y(5,w.$tk),Y(6,S.$Kl),Y(7,O.$Fi)],u)}),define(ce[17],le([0,1,6,3,2,101,13,72,4,20]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=$,e.$jq=b,e.$lq=d,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,A.$Gi)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var m;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var u;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function $(p){const P=p.get(e.$fq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class h extends N.$Xc{static{this.a=60*1e3}constructor(P={flushInterval:h.a}){super(),this.m=P,this.b=this.B(new c.$qe),this.c=this.B(new c.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,g,s){return c.Event.filter(this.b.event,r=>r.scope===P&&(g===void 0||r.key===g),s)}n(){this.j.value=(0,R.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,g){const{key:s,external:r}=g;if(s===e.$fq){switch(P){case m.APPLICATION:this.H=void 0;break;case m.PROFILE:this.F=void 0;break;case m.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:s,target:this.J(P)[s],external:r})}w(P){this.f.fire({reason:P})}get(P,g,s){return this.P(g)?.get(P,s)}getBoolean(P,g,s){return this.P(g)?.getBoolean(P,s)}getNumber(P,g,s){return this.P(g)?.getNumber(P,s)}getObject(P,g,s){return this.P(g)?.getObject(P,s)}storeAll(P,g){this.y(()=>{for(const s of P)this.store(s.key,s.value,s.scope,s.target,g)})}store(P,g,s,r,t=!1){if((0,T.$pg)(g)){this.remove(P,s,t);return}this.y(()=>{this.z(P,s,r),this.P(s)?.set(P,g,t)})}remove(P,g,s=!1){this.y(()=>{this.z(P,g,void 0),this.P(g)?.delete(P,s)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,g){const s=[],r=this.J(P);for(const t of Object.keys(r))r[t]===g&&s.push(t);return s}z(P,g,s,r=!1){const t=this.J(g);typeof s=="number"?t[P]!==s&&(t[P]=s,this.P(g)?.set(e.$fq,JSON.stringify(t),r)):typeof t[P]=="number"&&(delete t[P],this.P(g)?.set(e.$fq,JSON.stringify(t),r))}get D(){return this.C||(this.C=this.L(m.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(m.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(m.APPLICATION)),this.H}J(P){switch(P){case m.APPLICATION:return this.I;case m.PROFILE:return this.G;default:return this.D}}L(P){const g=this.P(P);return g?$(g):Object.create(null)}isNew(P){return this.getBoolean(e.$eq,P)===!0}async flush(P=S.NONE){this.f.fire({reason:P});const g=this.P(m.APPLICATION),s=this.P(m.PROFILE),r=this.P(m.WORKSPACE);switch(P){case S.NONE:await R.Promises.settled([g?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await R.Promises.settled([g?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(m.APPLICATION)?.items??new Map,g=this.P(m.PROFILE)?.items??new Map,s=this.P(m.WORKSPACE)?.items??new Map;return d(P,g,s,this.Q(m.APPLICATION)??"",this.Q(m.PROFILE)??"",this.Q(m.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,g){return this.w(S.NONE),(0,w.$Ll)(P)?this.R(P,g):this.S(P,g)}M(P,g){return!(P.id===g.id||b(g)&&b(P))}N(P,g,s){this.y(()=>{const r=new Set;for(const[t,a]of P)r.add(t),g.get(t)!==a&&this.u(s,{key:t,external:!0});for(const[t]of g.items)r.has(t)||this.u(s,{key:t,external:!0})})}}e.$iq=h;function b(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class v extends h{constructor(){super(),this.U=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(m.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(m.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(m.APPLICATION,P)))}P(P){switch(P){case m.APPLICATION:return this.U;case m.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case m.APPLICATION:return"inMemory (application)";case m.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$kq=v;async function d(p,P,g,s,r,t){const a=y=>{try{return JSON.parse(y)}catch{return y}},i=new Map,n=new Map;p.forEach((y,C)=>{i.set(C,y),n.set(C,a(y))});const o=new Map,l=new Map;P.forEach((y,C)=>{o.set(C,y),l.set(C,a(y))});const f=new Map,I=new Map;g.forEach((y,C)=>{f.set(C,y),I.set(C,a(y))}),console.group(s!==r?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const L=[];if(i.forEach((y,C)=>{L.push({key:C,value:y})}),console.table(L),console.groupEnd(),console.log(n),s!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const y=[];o.forEach((C,F)=>{y.push({key:F,value:C})}),console.table(y),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${t})`);const E=[];f.forEach((y,C)=>{E.push({key:C,value:y})}),console.table(E),console.groupEnd(),console.log(I)}}),define(ce[119],le([0,1,3,2,13,28,33,17]),function(ne,e,R,c,N,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hMb=e.$gMb=void 0;let A=class extends c.$Xc{constructor(m,u){super(),this.a=new R.$ne,this.onDidChangeEnablement=this.a.event,this.b=this.B(new w(m)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(u.onDidInstallExtensions($=>$.forEach(({local:h,operation:b})=>{h&&b===k.InstallOperation.Migrate&&this.f(h.identifier)})))}async enableExtension(m,u){return this.f(m)?(this.a.fire({extensions:[m],source:u}),!0):!1}async disableExtension(m,u){return this.c(m)?(this.a.fire({extensions:[m],source:u}),!0):!1}getDisabledExtensions(){return this.h(k.$np)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(m){const u=this.getDisabledExtensions();return u.every($=>!(0,T.$Kp)($,m))?(u.push(m),this.g(u),!0):!1}f(m){const u=this.getDisabledExtensions();for(let $=0;$<u.length;$++){const h=u[$];if((0,T.$Kp)(h,m))return u.splice($,1),this.g(u),!0}return!1}g(m){this.j(k.$np,m)}h(m){return this.b.get(m,O.StorageScope.PROFILE)}j(m,u){this.b.set(m,u,O.StorageScope.PROFILE)}};e.$gMb=A,e.$gMb=A=ve([Y(0,O.$gq),Y(1,k.$mp)],A);class w extends c.$Xc{constructor(m){super(),this.c=m,this.a=Object.create(null),this.b=this.B(new R.$ne),this.onDidChange=this.b.event,this.B(m.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new c.$Wc))(u=>this.f(u)))}get(m,u){let $;return u===O.StorageScope.PROFILE?((0,N.$pg)(this.a[m])&&(this.a[m]=this.g(m,u)),$=this.a[m]):$=this.g(m,u),JSON.parse($)}set(m,u,$){const h=JSON.stringify(u.map(({id:v,uuid:d})=>({id:v,uuid:d})));this.g(m,$)!==h&&($===O.StorageScope.PROFILE&&(u.length?this.a[m]=h:delete this.a[m]),this.h(m,u.length?h:void 0,$))}f(m){if(!(0,N.$pg)(this.a[m.key])&&this.g(m.key,m.scope)!==this.a[m.key]){const $=this.get(m.key,m.scope);delete this.a[m.key];const h=this.get(m.key,m.scope),b=$.filter(d=>!h.some(p=>(0,T.$Kp)(d,p))),v=h.filter(d=>!$.some(p=>(0,T.$Kp)(p,d)));(b.length||v.length)&&this.b.fire([...b,...v])}}g(m,u){return this.c.get(m,u,"[]")}h(m,u,$){u?this.c.store(m,u,$,O.StorageTarget.MACHINE):this.c.remove(m,$)}}e.$hMb=w}),define(ce[86],le([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=void 0,e.$nw=(0,R.$Gi)("IExtensionStorageService");const u=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends N.$Xc{static{m=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,T.$Op)(b.id)}@${b.version}`}static c(b){const v=u.exec(b);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(b,v){const d=await b.getInstalled(),p=[];for(const[P,g]of m.f(v)){const s=d.find(r=>(0,T.$Kp)(r.identifier,{id:P}))?.manifest.version;for(const r of g)s!==r&&p.push(m.b({id:P,version:r}))}for(const P of p)v.remove(P,k.StorageScope.PROFILE)}static f(b){const v=new Map,d=b.keys(k.StorageScope.PROFILE,k.StorageTarget.MACHINE);for(const p of d){const P=m.c(p);if(P){let g=v.get(P.id.toLowerCase());g||v.set(P.id.toLowerCase(),g=[]),g.push(P.version)}}return v}constructor(b,v,d){super(),this.j=b,this.m=v,this.n=d,this.g=this.B(new c.$ne),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=m.f(b),this.B(this.j.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new N.$Wc))(p=>this.r(p)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const v=m.c(b.key);if(v){if(this.j.get(b.key,k.StorageScope.PROFILE)===void 0)this.h.delete(v.id.toLowerCase());else{let d=this.h.get(v.id.toLowerCase());d||this.h.set(v.id.toLowerCase(),d=[]),d.push(v.version),this.g.fire()}return}}s(b){if((0,S.$gg)(b))return b;const v=b.manifest?b.manifest.publisher:b.publisher,d=b.manifest?b.manifest.name:b.name;return(0,T.$Np)(v,d)}getExtensionState(b,v){const d=this.s(b),p=this.getExtensionStateRaw(b,v);if(p)try{return JSON.parse(p)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${P}`)}}getExtensionStateRaw(b,v){const d=this.s(b),p=this.j.get(d,v?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE);return p&&p?.length>m.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${d}, global: ${v}): ${p.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),p}setExtensionState(b,v,d){const p=this.s(b);v===void 0?this.j.remove(p,d?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE):this.j.store(p,JSON.stringify(v),d?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE,k.StorageTarget.MACHINE)}setKeysForSync(b,v){this.j.store(m.b(b),JSON.stringify(v),k.StorageScope.PROFILE,k.StorageTarget.MACHINE)}getKeysForSync(b){const v=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],d=this.j.get(m.b(b),k.StorageScope.PROFILE),p=d?JSON.parse(d):void 0;return p&&v?(0,A.$Pb)([...p,...v]):p||v}addToMigrationList(b,v){if(b!==v){const d=this.t.filter(p=>!p.includes(b)&&!p.includes(v));d.push([b,v]),this.t=d}}getSourceExtensionToMigrate(b){const v=this.t.find(([,d])=>b===d);return v?v[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",k.StorageScope.APPLICATION,"[]");try{const v=JSON.parse(b);if(Array.isArray(v))return v}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),k.StorageScope.APPLICATION,k.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",k.StorageScope.APPLICATION)}};e.$ow=$,e.$ow=$=m=ve([Y(0,k.$gq),Y(1,O.$tk),Y(2,w.$ak)],$)}),define(ce[256],le([0,1,2,28,86,234,118,10,17]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;let w=class extends R.$Xc{constructor(m,u,$,h,b,v){super(),m.cleanUp(),(0,k.$26b)(m,u,$,h,v),N.$ow.removeOutdatedExtensionVersions(m,b)}};e.$Ghc=w,e.$Ghc=w=ve([Y(0,T.$Wq),Y(1,c.$jp),Y(2,N.$nw),Y(3,c.$pp),Y(4,A.$gq),Y(5,O.$ak)],w)}),define(ce[257],le([0,1,19,2,21,9,7,24,6,3,14,5,37,33,75,36,17]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0;let d=class extends c.$Xc{constructor(r,t){super(),this.b=r,this.c=t,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,a])=>this.a.set(a.configPath,a))}getConfigBasedTips(r){return this.f(r)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(r){const t=[];for(const[a,i]of this.a)if(!(i.configScheme&&i.configScheme!==r.scheme))try{const n=(await this.b.readFile((0,N.$hh)(r,a))).value.toString();for(const[o,l]of Object.entries(i.recommendations))(!l.contentPattern||new RegExp(l.contentPattern,"mig").test(n))&&t.push({extensionId:o,extensionName:l.name,configName:i.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})}catch{}return t}};e.$Zdc=d,e.$Zdc=d=ve([Y(0,T.$al),Y(1,O.$tk)],d);const p="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class g extends d{constructor(r,t,a,i,n,o,l,f){super(l,f),this.r=r,this.s=t,this.t=a,this.u=i,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,f.exeBasedExtensionTips&&Object.entries(f.exeBasedExtensionTips).forEach(([I,L])=>{const E=[],y=[],C=[];Object.entries(L.recommendations).forEach(([F,D])=>{D.important?L.important?E.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):y.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):C.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),E.length&&this.g.set(I,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:E}),y.length&&this.h.set(I,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:y}),C.length&&this.j.set(I,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:C})}),(0,A.$Ih)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const r=await this.O(this.g),t=await this.O(this.h);return[...r,...t]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const r=await this.O(this.g),t=await this.O(this.h),a=await this.u.getInstalled();this.m=this.D(r,a),this.n=this.D(t,a)}D(r,t){const a=new Map;r.forEach(f=>a.set(f.extensionId.toLowerCase(),f));const{installed:i,uninstalled:n}=this.N([...a.keys()],t);for(const f of i){const I=a.get(f);I&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:f,exeName:I.exeName})}for(const f of n){const I=a.get(f);I&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:f,exeName:I.exeName})}const o=this.L(),l=new Map;for(const f of n){const I=a.get(f);if(I&&(!o[I.exeName]||!o[I.exeName].includes(I.extensionId))){let L=l.get(I.exeName);L||(L=[],l.set(I.exeName,L)),L.push(I)}}return l}F(){if(this.m.size===0)return;const[r,t]=[...this.m.entries()][0];this.H(t).then(a=>{switch(a){case h.RecommendationsNotificationResult.Accepted:this.M(t[0].exeName,t);break;case h.RecommendationsNotificationResult.Ignored:this.m.delete(r);break;case h.RecommendationsNotificationResult.IncompatibleWindow:{const i=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case h.RecommendationsNotificationResult.TooMany:{const i=this.B(new c.$Yc);i.value=(0,A.$Ih)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const r=this.I(),t=Date.now()-r,a=7*24*60*60*1e3;if(t<a){const o=this.B(new c.$Yc);o.value=(0,A.$Ih)(()=>{o.dispose(),this.G()},a-t);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case h.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const l=this.B(new c.$Yc);l.value=(0,A.$Ih)(()=>{l.dispose(),this.G()},a);break}case h.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case h.RecommendationsNotificationResult.IncompatibleWindow:{const l=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(l(()=>this.G()));break}case h.RecommendationsNotificationResult.TooMany:{const l=this.B(new c.$Yc);l.value=(0,A.$Ih)(()=>{l.dispose(),this.G()},60*60*1e3);break}}})}async H(r){const t=await this.u.getInstalled(b.ExtensionType.User),a=r.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>t.every(o=>!(0,$.$Kp)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:a,source:h.RecommendationSource.EXE,name:r[0].exeFriendlyName,searchValue:`@exe:"${r[0].exeName}"`})}I(){let r=this.w.getNumber(P,v.StorageScope.APPLICATION);return r||(r=Date.now(),this.J(r)),r}J(r){this.w.store(P,r,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(p,v.StorageScope.APPLICATION,"{}"))}M(r,t){const a=this.L();a[r]=t.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(a),v.StorageScope.APPLICATION,v.StorageTarget.USER)}N(r,t){const a=[],i=[],n=t.reduce((o,l)=>(o.add(l.identifier.id.toLowerCase()),o),new Set);return r.forEach(o=>{n.has(o.toLowerCase())?a.push(o):i.push(o)}),{installed:a,uninstalled:i}}async O(r){const t=[],a=new Map;for(const i of r.keys()){const n=r.get(i);if(!n||!(0,R.$Ob)(n.recommendations))continue;const o=[];m.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>u.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>u.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>u.env.ProgramFiles).replace("%APPDATA%",()=>u.env.APPDATA).replace("%WINDIR%",()=>u.env.WINDIR)):(o.push((0,S.$mc)("/usr/local/bin",i)),o.push((0,S.$mc)("/usr/bin",i)),o.push((0,S.$mc)(this.r.fsPath,i)));for(const l of o){let f=a.get(l);if(f===void 0&&(f=await this.b.exists(k.URI.file(l)),a.set(l,f)),f)for(const{extensionId:I,extensionName:L,isExtensionPack:E,whenNotInstalled:y}of n.recommendations)t.push({extensionId:I,extensionName:L,isExtensionPack:E,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:y})}}return t}}e.$1dc=g}),define(ce[258],le([0,1,28,7,24,16,75,58,17,18,257]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let m=class extends S.$1dc{constructor($,h,b,v,d,p,P,g){super($.userHome,d,h,b,v,p,P,g)}};e.$Nhc=m,e.$Nhc=m=ve([Y(0,k.$Oi),Y(1,w.$_l),Y(2,R.$mp),Y(3,A.$gq),Y(4,O.$Ifc),Y(5,T.$J6b),Y(6,c.$al),Y(7,N.$tk)],m)}),define(ce[50],le([0,1,15,32,17]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;async function k(T,O,A){let w=A&&A.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(w)return w;try{const m=(await O.readFile(T.serviceMachineIdResource)).value.toString();w=(0,c.$2g)(m)?m:null}catch{w=null}if(!w){w=(0,c.$3g)();try{await O.writeFile(T.serviceMachineIdResource,R.$Pe.fromString(w))}catch{}}return A?.store("storage.serviceMachineId",w,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),w}}),define(ce[259],le([0,1,50,18,49]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=k;async function k(T,O,A,w,S,m,u){const $={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${O.nameShort})`};if((0,N.$Cp)(O,A)&&(0,N.$Ep)(w)===c.TelemetryLevel.USAGE){const h=await(0,R.$mq)(A,S,m);$["X-Market-User-Id"]=h,$["VSCode-SessionId"]=u.machineId||h}return $}}),define(ce[260],le([0,1,19,26,8,5,37,13,9,22,16,28,33,36,60,7,10,24,62,259,17,18,55]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0,e.$oq=q;const t=k.$o?$.TargetPlatform.WEB:(0,m.$fp)(k.$u,T.$hc),a="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((j,x)=>j|x,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(j=L){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,x=this.d.pageSize){return new E({...this.d,pageNumber:j,pageSize:x})}withFilter(j,...x){const ee=[...this.d.criteria,...x.length?x.map(J=>({filterType:j,value:J})):[{filterType:j}]];return new E({...this.d,criteria:ee})}withSortBy(j){return new E({...this.d,sortBy:j})}withSortOrder(j){return new E({...this.d,sortOrder:j})}withFlags(...j){return new E({...this.d,flags:j.reduce((x,ee)=>x|ee,0)})}withAssetTypes(...j){return new E({...this.d,assetTypes:j})}withSource(j){return new E({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:x,pageSize:ee,sortBy:J,sortOrder:oe,flags:ue,assetTypes:ge}=this.d;return{filters:[{criteria:j,pageNumber:x,pageSize:ee,sortBy:J,sortOrder:oe}],assetTypes:ge,flags:ue}}get searchText(){const j=this.d.criteria.filter(x=>x.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(B,j){const x=(B||[]).filter(ee=>ee.statisticName===j)[0];return x?x.value:0}function C(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(ee=>ee.assetType.indexOf(j)===0).reduce((ee,J)=>{const oe=M(B,J.assetType);return oe&&ee.push([J.assetType.substring(j.length),oe]),ee},[])}function F(B){if(B.properties){const j=B.properties.filter(J=>J.key===l.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=j.filter(J=>x.test(J.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return M(B,l.Repository)}function D(B){return{uri:`${B.fallbackAssetUri}/${l.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${l.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function M(B,j){return B.files.filter(ee=>ee.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function K(B,j){const x=B.properties?B.properties.filter(J=>J.key===j):[],ee=x.length>0&&x[0].value;return ee?ee.split(",").map(J=>(0,u.$Op)(J)):[]}function W(B){const j=B.properties?B.properties.filter(x=>x.key===f.Engine):[];return j.length>0&&j[0].value||""}function _(B){const j=B.properties?B.properties.filter(x=>x.key===f.PreRelease):[];return j.length>0&&j[0].value==="true"}function H(B){const j=B.properties?B.properties.filter(ee=>ee.key===f.EnabledApiProposals):[],x=j.length>0&&j[0].value||"";return x?x.split(","):[]}function ie(B){const j=B.properties?B.properties.filter(ee=>ee.key===f.LocalizedLanguages):[],x=j.length>0&&j[0].value||"";return x?x.split(","):[]}function V(B){return B.properties?.find(j=>j.key===f.SponsorLink)?.value}function z(B){return B.properties?.find(j=>j.key===f.SupportLink)?.value}function te(B){return B.indexOf("preview")!==-1}function se(B){return B.targetPlatform?(0,m.$ep)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function he(B){const j=(0,R.$Pb)(B.versions.map(se)),x=!!B.tags?.includes(m.$$o),ee=j.indexOf($.TargetPlatform.WEB);return x?ee===-1&&j.push($.TargetPlatform.WEB):ee!==-1&&j.splice(ee,1),j}function q(B,j){for(let x=0;x<B.length;x++){const ee=B[x];if(ee.version===B[x-1]?.version){let J=x;if(se(ee)===j)for(;J>0&&B[J-1].version===ee.version;)J--;J!==x&&(B.splice(x,1),B.splice(J,0,ee))}}return B}function Z(B,j,x){B.telemetryData={index:j,querySource:x,queryActivityId:B.queryContext?.[a]}}function X(B,j,x,ee){const J=B.versions[0],oe={manifest:M(j,l.Manifest),readme:M(j,l.Details),changelog:M(j,l.Changelog),license:M(j,l.License),repository:F(j),download:D(j),icon:M(j,l.Icon),signature:M(j,l.Signature),coreTranslations:C(j)};return{type:"gallery",identifier:{id:(0,u.$Pp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(J),description:B.shortDescription??"",installCount:y(B.statistics,"install"),rating:y(B.statistics,"averagerating"),ratingCount:y(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:x,assets:oe,properties:{dependencies:K(j,f.Dependency),extensionPack:K(j,f.ExtensionPack),engine:W(j),enabledApiProposals:H(j),localizedLanguages:ie(j),targetPlatform:se(j),isPreReleaseVersion:_(j)},hasPreReleaseVersion:_(J),hasReleaseVersion:!0,preview:te(B.flags),isSigned:!!oe.signature,queryContext:ee,supportLink:z(J)}}let G=class{constructor(j,x,ee,J,oe,ue,ge,pe){this.l=x,this.n=ee,this.o=J,this.q=oe,this.u=ue,this.w=ge,this.x=pe;const Ie=ge.extensionsGallery,we=Ie?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=we?Ie.servicePPEUrl:Ie?.serviceUrl,this.g=we?void 0:Ie?.searchUrl,this.h=Ie?.controlUrl,this.k=ge.extensionsEnabledWithApiProposalVersion?.map(be=>be.toLowerCase())??[],this.j=(0,P.$nq)(ge.version,ge,this.o,this.x,this.u,j,this.q)}y(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,x,ee){const J=c.CancellationToken.isCancellationToken(x)?{}:x,oe=c.CancellationToken.isCancellationToken(x)?x:ee,ue=[],ge=[],pe=[],Ie=[];let we=!0;for(const Se of j){Se.uuid?ge.push(Se.uuid):ue.push(Se.id);const ae=!!(Se.version||Se.preRelease);pe.push({id:Se.id,uuid:Se.uuid,includePreRelease:ae}),Se.version&&Ie.push({id:Se.id,uuid:Se.uuid,version:Se.version}),we=we&&!!Se.hasPreRelease&&!ae}if(!ge.length&&!ue.length)return[];let be=new E().withPage(1,j.length);ge.length&&(be=be.withFilter(o.ExtensionId,...ge)),ue.length&&(be=be.withFilter(o.ExtensionName,...ue)),(J.queryAllVersions||we)&&(be=be.withFlags(be.flags,i.IncludeVersions)),J.source&&(be=be.withSource(J.source));const{extensions:Ee}=await this.B(be,{targetPlatform:J.targetPlatform??t,includePreRelease:pe,versions:Ie,compatible:!!J.compatible,productVersion:J.productVersion??{version:this.w.version,date:this.w.date}},oe);return J.source&&Ee.forEach((Se,ae)=>Z(Se,ae,J.source)),Ee}async getCompatibleExtension(j,x,ee,J={version:this.w.version,date:this.w.date}){if((0,m.$gp)(j.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(j,x,ee))return j;const oe=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:ue}=await this.B(oe,{targetPlatform:ee,compatible:!0,includePreRelease:x,productVersion:J},c.CancellationToken.None);return ue[0]||null}async isExtensionCompatible(j,x,ee,J={version:this.w.version,date:this.w.date}){if(!(0,m.$hp)(j.properties.targetPlatform,j.allTargetPlatforms,ee)||!x&&j.properties.isPreReleaseVersion)return!1;let oe=j.properties.engine;if(!oe){const ue=await this.getManifest(j,c.CancellationToken.None);if(!ue)throw new Error("Manifest was not found");oe=ue.engines.vscode}return!(!(0,h.$4p)(oe,J.version,J.date)||!this.z(j.identifier,j.properties.enabledApiProposals))}z(j,x){return!x||!this.k.includes(j.id.toLowerCase())?!0:(0,h.$5p)(x)}async A(j,x,ee,J,oe,ue,ge={version:this.w.version,date:this.w.date}){if(!(0,m.$hp)(se(x),oe,ue)||ee!=="any"&&_(x)!==(ee==="prerelease"))return!1;if(J)try{const pe=await this.G(j,x);if(!(0,h.$4p)(pe,ge.version,ge.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${x.version}.`,(0,N.$ab)(pe)),!1}return!0}async query(j,x){let ee=j.text||"";const J=j.pageSize??50;let oe=new E().withPage(1,J);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Ee)=>(oe=oe.withFilter(o.Category,Ee||be),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Ee)=>(oe=oe.withFilter(o.Tag,Ee||be),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(o.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),oe=oe.withFilter(o.SearchText,ee)),oe=oe.withSortBy(m.SortBy.NoneOrRelevance)):j.ids?oe=oe.withFilter(o.ExtensionId,...j.ids):j.names?oe=oe.withFilter(o.ExtensionName,...j.names):oe=oe.withSortBy(m.SortBy.InstallCount),typeof j.sortBy=="number"&&(oe=oe.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(oe=oe.withSortOrder(j.sortOrder)),j.source&&(oe=oe.withSource(j.source));const ue=async(we,be)=>{const{extensions:Ee,total:Se}=await this.B(we,{targetPlatform:t,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.w.version,date:this.w.date}},be);return Ee.forEach((ae,de)=>Z(ae,(we.pageNumber-1)*we.pageSize+de,j.source)),{extensions:Ee,total:Se}},{extensions:ge,total:pe}=await ue(oe,x),Ie=async(we,be)=>{if(be.isCancellationRequested)throw new N.$8;const{extensions:Ee}=await ue(oe.withPage(we+1),be);return Ee};return{firstPage:ge,total:pe,pageSize:oe.pageSize,getPage:Ie}}async B(j,x,ee){const J=j.flags;j.flags&i.IncludeLatestVersionOnly&&j.flags&i.IncludeVersions&&(j=j.withFlags(j.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(j.flags&i.IncludeLatestVersionOnly)&&!(j.flags&i.IncludeVersions)&&(j=j.withFlags(j.flags,i.IncludeLatestVersionOnly)),x.versions?.length&&(j=j.withFlags(j.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),j=j.withFlags(j.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:ue,context:ge}=await this.D(j,ee);if(!(j.flags&i.IncludeLatestVersionOnly)){const be=[];for(const Ee of oe){const Se=await this.C(Ee,x,ge);Se&&be.push(Se)}return{extensions:be,total:ue}}const Ie=[],we=new Map;for(let be=0;be<oe.length;be++){const Ee=oe[be],Se={id:(0,u.$Pp)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},ae=(0,O.$mg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(me=>(0,u.$Kp)(me,Se))?.includePreRelease;if(x.compatible&&(0,m.$gp)(he(Ee),x.targetPlatform))continue;const de=await this.C(Ee,x,ge);!de||de.properties.isPreReleaseVersion&&(!ae||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==x.targetPlatform&&de.hasPreReleaseVersion?we.set(Ee.extensionId,be):Ie.push([be,de])}if(we.size){const be=new r.$he,Ee=new E().withFlags(J&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,we.size).withFilter(o.ExtensionId,...we.keys()),{extensions:Se}=await this.B(Ee,x,ee);this.q.publicLog2("galleryService:additionalQuery",{duration:be.elapsed(),count:we.size});for(const ae of Se){const de=we.get(ae.identifier.uuid);Ie.push([de,ae])}}return{extensions:Ie.sort((be,Ee)=>be[0]-Ee[0]).map(([,be])=>be),total:ue}}async C(j,x,ee){const J={id:(0,u.$Pp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},oe=x.versions?.find(Ie=>(0,u.$Kp)(Ie,J))?.version,ue=(0,O.$mg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Ie=>(0,u.$Kp)(Ie,J))?.includePreRelease,ge=he(j),pe=q(j.versions,x.targetPlatform);if(x.compatible&&(0,m.$gp)(ge,x.targetPlatform))return null;for(let Ie=0;Ie<pe.length;Ie++){const we=pe[Ie];if(!(oe&&we.version!==oe)){if(await this.A(J.id,we,ue?"any":"release",x.compatible,ge,x.targetPlatform,x.productVersion))return x.compatible&&!this.z(J,H(we))?null:X(j,we,ge,ee);if(oe&&we.version===oe)return null}}return oe||x.compatible?null:X(j,j.versions[0],ge)}async D(j,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const ee=await this.j,J=JSON.stringify(j.raw),oe={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},ue=new r.$he;let ge,pe,Ie=0;try{if(ge=await this.l.request({type:"POST",url:this.g&&j.criteria.some(be=>be.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:J,headers:oe},x),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ie};const we=await(0,p.$_p)(ge);if(we){const be=we.results[0],Ee=be.extensions,Se=be.resultMetadata&&be.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Ie=Se&&Se.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:Ie,context:{[a]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Ie}}catch(we){if((0,N.$7)(we))throw pe=m.ExtensionGalleryErrorCode.Cancelled,we;{const be=(0,N.$ab)(we);throw pe=be.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$kp(be,pe)}}finally{this.q.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(J.length),duration:ue.elapsed(),success:!!ge&&(0,p.$8p)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:pe,count:String(Ie)})}}async reportStatistic(j,x,ee,J){if(!this.isEnabled())return;const oe=k.$o?this.y(`/itemName/${j}.${x}/version/${ee}/statType/${J===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${j}/extensions/${x}/${ee}/stats?statType=${J}`),ue=k.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ue};try{await this.l.request({type:"POST",url:oe,headers:pe},c.CancellationToken.None)}catch{}}async download(j,x,ee){this.n.trace("ExtensionGalleryService#download",j.identifier.id);const J=(0,u.$Sp)(j),oe=new Date().getTime(),ue=ee===m.InstallOperation.Install?"install":ee===m.InstallOperation.Update?"update":"",ge=ue?{uri:`${j.assets.download.uri}${A.URI.parse(j.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${j.assets.download.fallbackUri}${A.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:j.assets.download,pe=j.queryContext?.[a]?{[a]:j.queryContext[a]}:void 0,Ie=await this.F(j.identifier.id,ge,l.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(x,Ie.stream)}catch(we){try{await this.u.del(x)}catch(be){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,N.$ab)(be))}throw new m.$kp((0,N.$ab)(we),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...J,duration:new Date().getTime()-oe})}async downloadSignatureArchive(j,x){if(!j.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const ee=await this.F(j.identifier.id,j.assets.signature,l.Signature);try{await this.u.writeFile(x,ee.stream)}catch(J){try{await this.u.del(x)}catch(oe){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,N.$ab)(oe))}throw new m.$kp((0,N.$ab)(J),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,x){if(j.assets.readme){const ee=await this.F(j.identifier.id,j.assets.readme,l.Details,{},x);return await(0,p.$$p)(ee)||""}return""}async getManifest(j,x){if(j.assets.manifest){const ee=await this.F(j.identifier.id,j.assets.manifest,l.Manifest,{},x),J=await(0,p.$$p)(ee);return J?JSON.parse(J):null}return null}async E(j,x,ee){const J=M(x,l.Manifest);if(!J)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},ue=await this.F(j,J,l.Manifest,{headers:oe});return await(0,p.$_p)(ue)}async getCoreTranslation(j,x){const ee=j.assets.coreTranslations.filter(J=>J[0]===x.toUpperCase())[0];if(ee){const J=await this.F(j.identifier.id,ee[1],ee[0]),oe=await(0,p.$$p)(J);return oe?JSON.parse(oe):null}return null}async getChangelog(j,x){if(j.assets.changelog){const ee=await this.F(j.identifier.id,j.assets.changelog,l.Changelog,{},x);return await(0,p.$$p)(ee)||""}return""}async getAllCompatibleVersions(j,x,ee){let J=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);j.uuid?J=J.withFilter(o.ExtensionId,j.uuid):J=J.withFilter(o.ExtensionName,j.id);const{galleryExtensions:oe}=await this.D(J,c.CancellationToken.None);if(!oe.length)return[];const ue=he(oe[0]);if((0,m.$gp)(ue,ee))return[];const ge=[];await Promise.all(oe[0].versions.map(async we=>{try{await this.A(j.id,we,x?"any":"release",!0,ue,ee)&&this.z(j,H(we))&&ge.push(we)}catch{}}));const pe=[],Ie=new Set;for(const we of q(ge,ee))Ie.has(we.version)||(Ie.add(we.version),pe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:_(we)}));return pe}async F(j,x,ee,J={},oe=c.CancellationToken.None){const ue=await this.j,ge={type:"GET"},pe={...ue,...J.headers||{}};J={...J,...ge,headers:pe};const Ie=x.uri,we=x.fallbackUri,be={...J,url:Ie};try{const Ee=await this.l.request(be,oe);if(Ee.res.statusCode===200)return Ee;const Se=await(0,p.$$p)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Se}`)}catch(Ee){if((0,N.$7)(Ee))throw Ee;const Se=(0,N.$ab)(Ee);this.q.publicLog2("galleryService:cdnFallback",{extension:j,assetType:ee,message:Se});const ae={...J,url:we};return this.l.request(ae,oe)}}async G(j,x){let ee=W(x);if(!ee){this.q.publicLog2("galleryService:engineFallback",{extension:j,version:x.version});const J=await this.E(j,x,c.CancellationToken.None);if(!J)throw new Error("Manifest was not found");ee=J.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,p.$_p)(j),ee=[],J={},oe=[],ue=[];if(x){for(const ge of x.malicious)ee.push({id:ge});if(x.migrateToPreRelease)for(const[ge,pe]of Object.entries(x.migrateToPreRelease))(!pe.engine||(0,h.$4p)(pe.engine,this.w.version,this.w.date))&&(J[ge.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[ge,pe]of Object.entries(x.deprecated))pe&&(J[ge.toLowerCase()]=(0,O.$mg)(pe)?{}:pe);if(x.search)for(const ge of x.search)oe.push(ge);if(Array.isArray(x.extensionsEnabledWithPreRelease))for(const ge of x.extensionsEnabledWithPreRelease)ue.push(ge.toLowerCase())}return{malicious:ee,deprecated:J,search:oe,extensionsEnabledWithPreRelease:ue}}};G=ve([Y(1,p.$6p),Y(2,v.$ak),Y(3,S.$Ni),Y(4,s.$_l),Y(5,b.$al),Y(6,d.$tk),Y(7,w.$aj)],G);let U=class extends G{constructor(j,x,ee,J,oe,ue,ge,pe){super(j,x,ee,J,oe,ue,ge,pe)}};e.$pq=U,e.$pq=U=ve([Y(0,g.$gq),Y(1,p.$6p),Y(2,v.$ak),Y(3,S.$Ni),Y(4,s.$_l),Y(5,b.$al),Y(6,d.$tk),Y(7,w.$aj)],U);let Q=class extends G{constructor(j,x,ee,J,oe,ue,ge){super(void 0,j,x,ee,J,oe,ue,ge)}};e.$qq=Q,e.$qq=Q=ve([Y(0,p.$6p),Y(1,v.$ak),Y(2,S.$Ni),Y(3,s.$_l),Y(4,b.$al),Y(5,d.$tk),Y(6,w.$aj)],Q)}),define(ce[261],le([0,1,108,3,18,16,2,10,14,70,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;const s=[R.$Chc,R.$Dhc],r="remoteTunnelSession",t="remoteTunnelIsService";let a=class extends T.$Xc{constructor(l,f,I,L,E,y,C){super(),this.y=l,this.z=f,this.C=I,this.D=y,this.F=C,this.f=new c.$ne,this.onDidTokenFailed=this.f.event,this.g=new c.$ne,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$ne,this.onDidChangeMode=this.h.event,this.n=R.$Ahc,this.w=!1,this.I=(F,D)=>{D?this.j.error(F):this.j.info(F)},this.j=this.B(L.createLogger((0,g.$hh)(I.logsHome,`${R.$Ehc}.log`),{id:R.$Ehc,name:R.$Fhc})),this.t=new u.$Dh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,O.$pk)(F)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(y.onDidChangeConfiguration(F=>{s.some(D=>F.affectsConfiguration(D))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(l){this.s=l,this.g.fire(l)}H(l){n(this.n,l)||(this.n=l,this.S(l),this.h.fire(this.n),l.active?(this.j.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this.j.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(l){if(this.w)return this.s;this.w=!0,this.H(l);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}J(){if(!this.u){let l;m.$j?l=this.C.appRoot:l=(0,A.$pc)((0,A.$pc)(this.C.appRoot)),this.u=(0,A.$mc)(l,"bin",`${this.z.tunnelApplicationName}${m.$i?".exe":""}`)}return this.u}async startTunnel(l){if(n(this.n,l)&&this.s.type!=="disconnected")return this.s;this.H(l);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const l=this.n.asService;this.H(R.$Ahc);try{l&&this.O("uninstallService",["service","uninstall"])}catch(f){this.j.error(f)}}try{await this.O("stop",["kill"])}catch(l){this.j.error(l)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let l="",f=!1;const I=(D,M)=>{M?this.j.error(D):l+=D,!this.C.isBuilt&&D.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,b.localize)(0,null)))},L=this.O("status",["status"],I);this.r=L;try{if(await L,this.r!==L)return;let D;try{D=JSON.parse(l.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(l.trim())}`),this.G(R.TunnelStates.disconnected());return}if(f=D.service_installed,this.j.info(D.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!D.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(D){this.j.error(D),this.G(R.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const D=E.token;this.G(R.TunnelStates.connecting((0,b.localize)(1,null,E.accountLabel,E.providerId)));const M=(W,_)=>{W=W.replaceAll(D,"*".repeat(4)),I(W,_)},K=this.O("login",["user","login","--provider",E.providerId,"--log",(0,O.$pk)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:D});this.r=K;try{if(await K,this.r!==K)return}catch(W){this.j.error(W),this.r=void 0,this.f.fire(E),this.G(R.TunnelStates.disconnected(E));return}}const y=this.Q();y?this.G(R.TunnelStates.connecting((0,b.localize)(2,null,y))):this.G(R.TunnelStates.connecting((0,b.localize)(3,null)));const C=["--accept-server-license-terms","--log",(0,O.$pk)(this.j.getLevel())];y?C.push("--name",y):C.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!f&&(F=await this.M(C)===!1),this.N(E,C,F)}async M(l){let f;try{f=await this.O("serviceInstall",["service","install",...l])}catch(I){this.j.error(I),f=1}if(f!==0){const I=(0,b.localize)(4,null);return this.j.warn(I),this.G(R.TunnelStates.connecting(I)),!1}return!0}async N(l,f,I){f.push("--parent-process-id",String(process.pid)),this.P()&&f.push("--no-sleep");let L=!1;const E=this.O("tunnel",f,(y,C)=>{C?this.j.error(y):this.j.info(y),y.includes("Connected to an existing tunnel process")&&(L=!0);const F=y.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const D={link:F[1],domain:F[2],tunnelName:F[4],isAttached:L};this.G(R.TunnelStates.connected(D,I))}else y.match(/error refreshing token/)&&(E.cancel(),this.f.fire(l),this.G(R.TunnelStates.disconnected(l)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Ahc,this.G(R.TunnelStates.disconnected()))})}O(l,f,I=this.I,L){return(0,u.$th)(E=>new Promise((y,C)=>{E.isCancellationRequested&&y(-1);let F;const D=["ignore","pipe","pipe"];if(E.onCancellationRequested(()=>{F&&(this.j.info(`${l} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)I(`Building tunnel CLI from sources and run
`,!1),I(`${l} Spawning: cargo run -- tunnel ${f.join(" ")}
`,!1),F=(0,w.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,A.$mc)(this.C.appRoot,"cli"),stdio:D,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{I(`Running tunnel CLI
`,!1);const M=this.J();I(`${l} Spawning: ${M} tunnel ${f.join(" ")}
`,!1),F=(0,w.spawn)(M,["tunnel",...f],{cwd:(0,v.homedir)(),stdio:D,env:{...process.env,...L}})}F.stdout.pipe(new P.$zX(`
`)).on("data",M=>{if(F){const K=M.toString();I(K,!1)}}),F.stderr.pipe(new P.$zX(`
`)).on("data",M=>{if(F){const K=M.toString();I(K,!0)}}),F.on("exit",M=>{F&&(I(`${l} exit(${F.pid}): + ${M} `,!1),F=void 0,y(M||0))}),F.on("error",M=>{F&&(I(`${l} error(${F.pid}): + ${M} `,!0),F=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Dhc)}Q(){let l=this.D.getValue(R.$Chc)||(0,v.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}R(){try{const l=this.F.get(r,d.StorageScope.APPLICATION),f=this.F.getBoolean(t,d.StorageScope.APPLICATION,!1);if(l){const I=JSON.parse(l);if(I&&(0,p.$gg)(I.accountLabel)&&(0,p.$gg)(I.sessionId)&&(0,p.$gg)(I.providerId))return{active:!0,session:I,asService:f};this.j.error("Problems restoring session from storage, invalid format",I)}}catch(l){this.j.error("Problems restoring session from storage",l)}return R.$Ahc}S(l){if(l.active){const f={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.F.store(r,JSON.stringify(f),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),this.F.store(t,l.asService,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}else this.F.remove(r,d.StorageScope.APPLICATION),this.F.remove(t,d.StorageScope.APPLICATION)}};e.$Jhc=a,e.$Jhc=a=ve([Y(0,N.$_l),Y(1,S.$tk),Y(2,k.$Oi),Y(3,O.$bk),Y(4,$.$Hhc),Y(5,h.$aj),Y(6,d.$gq)],a);function i(o,l){return o&&l?o.sessionId===l.sessionId&&o.providerId===l.providerId&&o.token===l.token:o===l}const n=(o,l)=>o.active!==l.active?!1:o.active&&l.active?o.asService===l.asService&&i(o.session,l.session):!0}),define(ce[262],le([0,1,6,2,23,21,72,17,80,20]),function(ne,e,R,c,N,k,T,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class S extends O.$iq{constructor(u,$,h,b){super(),this.bb=u,this.cb=$,this.db=h,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Wc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Wc),this.ab=this.hb(this.bb)}fb(){const u=this.B(new A.$QMb(this.db.getChannel("storage"))),$=this.B(new T.$cq(u));return this.B($.onDidChangeStorage(h=>this.u(O.StorageScope.APPLICATION,h))),$}gb(u){this.X.clear(),this.W=u;let $;if((0,O.$jq)(u))$=this.U;else{const h=this.X.add(new A.$RMb(this.db.getChannel("storage"),u));$=this.X.add(new T.$cq(h))}return this.X.add($.onDidChangeStorage(h=>this.u(O.StorageScope.PROFILE,h))),$}hb(u){this.$.clear(),this.Z=u?.id;let $;if(u){const h=this.$.add(new A.$SMb(this.db.getChannel("storage"),u));$=this.$.add(new T.$cq(h)),this.$.add($.onDidChangeStorage(b=>this.u(O.StorageScope.WORKSPACE,b)))}return $}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(u){switch(u){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(u){switch(u){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,k.$hh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(u){if(!this.M(this.W,u))return;const $=this.Y,h=$.items;$!==this.U&&await $.close(),this.Y=this.gb(u),await this.Y.init(),this.N(h,this.Y,O.StorageScope.PROFILE)}async S(u,$){const h=this.ab,b=h?.items??new Map;await h?.close(),this.ab=this.hb(u),await this.ab.init(),this.N(b,this.ab,O.StorageScope.WORKSPACE)}hasScope(u){return(0,w.$Ll)(u)?this.W.id===u.id:this.Z===u.id}}e.$Ohc=S}),define(ce[263],le([0,1,3,2,20,95]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0;class T{constructor(w,S){this.a=w,this.b=S}listen(w,S){const m=this.b(w);switch(S){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,u=>({all:u.all.map($=>(0,k.$On)({...$},m)),added:u.added.map($=>(0,k.$On)({...$},m)),removed:u.removed.map($=>(0,k.$On)({...$},m)),updated:u.updated.map($=>(0,k.$On)({...$},m))}))}throw new Error(`Invalid listen ${S}`)}async call(w,S,m){const u=this.b(w);switch(S){case"createProfile":{const $=await this.a.createProfile(m[0],m[1],m[2]);return(0,k.$On)({...$},u)}case"updateProfile":{let $=(0,N.$Nl)((0,k.$Pn)(m[0],u),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,m[1]),(0,k.$On)({...$},u)}case"removeProfile":{const $=(0,N.$Nl)((0,k.$Pn)(m[0],u),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$uR=T;class O extends c.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,S,m){super(),this.profilesHome=S,this.f=m,this.a=[],this.b=this.B(new R.$ne),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(u=>(0,N.$Nl)(u,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(u=>{const $=u.added.map(v=>(0,N.$Nl)(v,this.profilesHome.scheme)),h=u.removed.map(v=>(0,N.$Nl)(v,this.profilesHome.scheme)),b=u.updated.map(v=>(0,N.$Nl)(v,this.profilesHome.scheme));this.a=u.all.map(v=>(0,N.$Nl)(v,this.profilesHome.scheme)),this.b.fire({added:$,removed:h,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,S,m){const u=await this.f.call("createNamedProfile",[w,S,m]);return(0,N.$Nl)(u,this.profilesHome.scheme)}async createProfile(w,S,m,u){const $=await this.f.call("createProfile",[w,S,m,u]);return(0,N.$Nl)($,this.profilesHome.scheme)}async createTransientProfile(w){const S=await this.f.call("createTransientProfile",[w]);return(0,N.$Nl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(w,S){await this.f.call("setProfileForWorkspace",[w,S])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,S){const m=await this.f.call("updateProfile",[w,S]);return(0,N.$Nl)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$vR=O}),define(ce[63],le([0,1,2,72,4,17,3,80,20]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WMb=e.$VMb=e.$UMb=void 0,e.$UMb=(0,N.$Gi)("IUserDataProfileStorageService");let w=class extends R.$Xc{constructor($,h){super(),this.b=h,$&&(this.a=this.B(new R.$7c))}async readStorageData($){return this.withProfileScopedStorageService($,async h=>this.c(h))}async updateStorageData($,h,b){return this.withProfileScopedStorageService($,async v=>this.f(v,h,b))}async withProfileScopedStorageService($,h){if(this.b.hasScope($))return h(this.b);let b=this.a?.get($.id);if(!b){b=new m(this.g($)),this.a?.set($.id,b);try{await b.initialize()}catch(v){throw this.a?.has($.id)?this.a.deleteAndDispose($.id):b.dispose(),v}}try{const v=await h(b);return await b.flush(),v}finally{this.a?.has($.id)||b.dispose()}}c($){const h=new Map,b=v=>{for(const d of $.keys(k.StorageScope.PROFILE,v))h.set(d,{value:$.get(d,k.StorageScope.PROFILE),target:v})};return b(k.StorageTarget.USER),b(k.StorageTarget.MACHINE),h}f($,h,b){$.storeAll(Array.from(h.entries()).map(([v,d])=>({key:v,value:d,scope:k.StorageScope.PROFILE,target:b})),!0)}};e.$VMb=w,e.$VMb=w=ve([Y(1,k.$gq)],w);class S extends w{constructor($,h,b,v,d){super($,v),this.j=h;const p=h.getChannel("profileStorageListener"),P=this.B(new R.$Yc);this.h=this.B(new T.$ne({onWillAddFirstListener:()=>{P.value=p.listen("onDidChange")(g=>{d.trace("profile storage changes",g),this.h.fire({targetChanges:g.targetChanges.map(s=>(0,A.$Nl)(s,b.profilesHome.scheme)),valueChanges:g.valueChanges.map(s=>({...s,profile:(0,A.$Nl)(s.profile,b.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g($){const h=this.j.getChannel("storage");return(0,k.$jq)($)?new O.$QMb(h):new O.$RMb(h,$)}}e.$WMb=S;class m extends k.$iq{constructor($){super({flushInterval:100}),this.U=$}async O(){const $=await this.U,h=new c.$cq($);return this.B(h.onDidChangeStorage(b=>{this.u(k.StorageScope.PROFILE,b)})),this.B((0,R.$Vc)(()=>{h.close(),h.dispose(),(0,R.$Rc)($)&&$.dispose()})),this.s=h,this.s.init()}P($){return $===k.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ce[264],le([0,1,17,10,20,57,63]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;let O=class extends T.$WMb{constructor(w,S,m,u){super(!0,w,S,m,u)}};e.$thc=O,e.$thc=O=ve([Y(0,k.$1gc),Y(1,N.$Ml),Y(2,R.$gq),Y(3,c.$ak)],O)}),define(ce[40],le([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Nb=e.$3Nb=e.$2Nb=e.$1Nb=void 0,e.$XNb=r,e.$YNb=t,e.$ZNb=a;function r(f){return!!(f&&f.ref!==void 0&&typeof f.ref=="string"&&f.ref!==""&&f.syncData!==void 0&&(f.syncData===null||t(f.syncData)))}function t(f){return!!(f&&f.version!==void 0&&typeof f.version=="number"&&f.content!==void 0&&typeof f.content=="string"&&(Object.keys(f).length===2||Object.keys(f).length===3&&f.machineId!==void 0&&typeof f.machineId=="string"))}function a(f,I){return`${(0,w.$$f)(f)}${I.isDefault?"":` (${I.name})`}`}let i=class extends A.$Xc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(I,L,E,y,C,F,D,M,K,W,_,H){super(),this.syncResource=I,this.collection=L,this.G=E,this.H=y,this.I=C,this.J=F,this.L=D,this.M=M,this.N=K,this.O=W,this.P=_,this.c=null,this.m=g.SyncStatus.Idle,this.n=this.B(new T.$ne),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$ne),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Eh(50)),this.w=this.B(new T.$ne),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=a(I.syncResource,I.profile),this.h=H.extUri,this.f=this.h.joinPath(y.userDataSyncHome,...(0,g.$qnb)(I.profile.isDefault?void 0:I.profile.id,I.syncResource)),this.g=this.h.joinPath(this.f,g.$Lnb),this.y=(0,g.$rnb)(I.profile.isDefault?void 0:I.profile.id,I.syncResource,y,this.h),this.j=(0,v.$mq)(y,E,C)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===g.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const I=await this.c;this.c=null;const L=await this.Y(I.remoteUserData,I.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const I=await this.getLastSyncUserData();(I?await this.ub(I):!0)&&this.w.fire()}}S(I){this.m!==I&&(this.m=I,this.n.fire(I))}async sync(I,L={}){await this.U(I,!0,this.ob(),L)}async preview(I,L,E={}){return this.U(I,!1,L,E)}async apply(I,L={}){try{this.F={...L};const E=await this.ab(I);return this.S(E),this.c}finally{this.F={}}}async U(I,L,E,y){try{if(this.F={...y},this.status===g.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===g.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);let C=g.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),D=await this.X(I,F);return C=await this.Y(D,F,L,E),C===g.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):C===g.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(C)}}finally{this.F={}}}async replace(I){const L=this.kb(I);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);const E=await this.getLastSyncUserData(),y=await this.X(null,E),C=await this.W(y),F=await this.qb({ref:y.ref,syncData:L},E,C,this.ob(),k.CancellationToken.None),D=[];for(const M of F){const K=await this.sb(M,M.remoteResource,void 0,k.CancellationToken.None),{remoteChange:W}=await this.sb(M,M.previewResource,M.remoteContent,k.CancellationToken.None);D.push([M,{...K,remoteChange:W!==g.Change.None?W:g.Change.Modified}])}await this.tb(y,E,D,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(g.SyncStatus.Idle)}return!0}async W(I){const L=await this.j;return!!I.syncData?.machineId&&I.syncData.machineId===L}async X(I,L){if(L){const E=I?I[this.resource]:void 0;if(L.ref===E||E===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(I,L,E,y){if(I.syncData&&I.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$ynb((0,m.localize)(0,null,this.resource,this.pb,I.syncData.version),g.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(I,L,E,y)}catch(C){if(C instanceof g.$ynb)switch(C.code){case g.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(I,L,E,y);case g.UserDataSyncErrorCode.Conflict:case g.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),I=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(I,L,E,y)}throw C}}async Z(I,L,E,y){try{const C=await this.W(I),F=!C&&L===null&&this.gb()!==void 0,D=E&&!F;this.c||(this.c=(0,c.$th)(K=>this.eb(I,L,C,D,y,K)));let M=await this.c;if(E&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of M.resourcePreviews)M=await this.accept(K.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:K})=>K===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:E?await this.ab(!1):g.SyncStatus.Syncing}catch(C){throw this.c=null,C}}async merge(I){return await this.$(I,async L=>{const E=await this.rb(L,k.CancellationToken.None);await this.G.writeFile(L.previewResource,N.$Pe.fromString(E?.content||""));const y=E&&!E.hasConflicts?await this.sb(L,L.previewResource,void 0,k.CancellationToken.None):void 0;return L.acceptResult=y,L.mergeState=E.hasConflicts?g.MergeState.Conflict:y?g.MergeState.Accepted:g.MergeState.Preview,L.localChange=y?y.localChange:E.localChange,L.remoteChange=y?y.remoteChange:E.remoteChange,L}),this.c}async accept(I,L){return await this.$(I,async E=>{const y=await this.sb(E,I,L,k.CancellationToken.None);return E.acceptResult=y,E.mergeState=g.MergeState.Accepted,E.localChange=y.localChange,E.remoteChange=y.remoteChange,E}),this.c}async discard(I){return await this.$(I,async L=>{const E=await this.rb(L,k.CancellationToken.None);return await this.G.writeFile(L.previewResource,N.$Pe.fromString(E.content||"")),L.acceptResult=void 0,L.mergeState=g.MergeState.Preview,L.localChange=E.localChange,L.remoteChange=E.remoteChange,L}),this.c}async $(I,L){if(!this.c)return;let E=await this.c;const y=E.resourcePreviews.findIndex(({localResource:C,remoteResource:F,previewResource:D})=>this.h.isEqual(C,I)||this.h.isEqual(F,I)||this.h.isEqual(D,I));y!==-1&&(this.c=(0,c.$th)(async C=>{const F=[...E.resourcePreviews];return F[y]=await L(F[y]),{...E,resourcePreviews:F}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:C})=>C===g.MergeState.Conflict)?this.S(g.SyncStatus.HasConflicts):this.S(g.SyncStatus.Syncing))}async ab(I){if(!this.c)return g.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:E})=>E===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:E})=>E!==g.MergeState.Accepted)?g.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(E=>[E,E.acceptResult]),I),this.c=null,await this.bb(),g.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(I){const L=I.filter(({mergeState:E})=>E===g.MergeState.Conflict);(0,R.$xb)(this.s,L,(E,y)=>this.h.isEqual(E.previewResource,y.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const I=await this.getLastSyncUserData();return!!I&&I.syncData!==null}async db(I){const L=this.c?await this.c:null;if(L)for(const E of L.resourcePreviews){if(this.h.isEqual(E.acceptedResource,I))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,I))return E.remoteContent;if(this.h.isEqual(E.localResource,I))return E.localContent;if(this.h.isEqual(E.baseResource,I))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,d.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(I){(0,h.$rl)(I)!==h.FileOperationResult.FILE_NOT_FOUND&&this.O.error(I)}}async eb(I,L,E,y,C,F){const D=await this.qb(I,L,E,C,F),M=[];for(const K of D){const W=K.previewResource.with({scheme:g.$Knb,authority:"accepted"});if(K.localChange===g.Change.None&&K.remoteChange===g.Change.None)M.push({...K,acceptedResource:W,acceptResult:{content:null,localChange:g.Change.None,remoteChange:g.Change.None},mergeState:g.MergeState.Accepted});else{const _=y?await this.rb(K,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(K.previewResource,N.$Pe.fromString(_?.content||""));const H=_&&!_.hasConflicts?await this.sb(K,K.previewResource,void 0,F):void 0;M.push({...K,acceptResult:H,mergeState:_?.hasConflicts?g.MergeState.Conflict:H?g.MergeState.Accepted:g.MergeState.Preview,localChange:H?H.localChange:_?_.localChange:K.localChange,remoteChange:H?H.remoteChange:_?_.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:I,lastSyncUserData:L,resourcePreviews:M,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let I=this.gb();if(I||(I=await this.jb()),!I)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(I),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!E&&L.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let y,C=1;for(;y===void 0&&C++<6;)try{const F=await this.hb();F&&(F.ref===L.ref?y=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof h.$vl&&F.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof g.$ynb)throw F;this.O.error(F,C)}}if(y===void 0)try{const F=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);y=F===null?null:this.kb(F),await this.ib({ref:L.ref,syncData:y})}catch(F){if(F instanceof g.$ynb&&F.code===g.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return y===void 0?null:{...L,syncData:y}}async fb(I,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),y={ref:I.ref,version:E,...L};this.I.store(this.z,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.ib(I)}gb(){return this.I.get(this.z,d.StorageScope.APPLICATION)}async hb(){const I=(await this.G.readFile(this.y)).value.toString();try{const L=I?JSON.parse(I):void 0;if(r(L))return L}catch(L){this.O.error(L)}}async ib(I){await this.G.writeFile(this.y,N.$Pe.fromString(JSON.stringify(I)))}async jb(){try{const I=await this.G.readFile(this.y),L=JSON.parse(I.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(I){I instanceof h.$vl&&I.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(I)}return this.I.get(this.z,d.StorageScope.APPLICATION)}async getRemoteUserData(I){const{ref:L,content:E}=await this.lb(I);let y=null;return E!==null&&(y=this.kb(E)),{ref:L,syncData:y}}kb(I){try{const L=JSON.parse(I);if(t(L))return L}catch(L){this.O.error(L)}throw new g.$ynb((0,m.localize)(1,null),g.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(I){const L=I?{ref:I.ref,content:I.syncData?JSON.stringify(I.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(I,L){const E=await this.j,y={version:this.pb,machineId:E,content:I};try{return L=await this.J.writeResource(this.resource,JSON.stringify(y),L,this.collection,this.F),{ref:L,syncData:y}}catch(C){throw C instanceof g.$ynb&&C.code===g.UserDataSyncErrorCode.TooLarge&&(C=new g.$ynb(C.message,C.code,this.resource)),C}}async nb(I){const L={version:this.pb,content:I};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==g.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(g.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$lnb)}};e.$1Nb=i,e.$1Nb=i=ve([Y(2,h.$al),Y(3,$.$Ni),Y(4,d.$gq),Y(5,g.$tnb),Y(6,g.$unb),Y(7,g.$Dnb),Y(8,p.$_l),Y(9,g.$Inb),Y(10,u.$aj),Y(11,P.$Kl)],i);let n=class extends i{constructor(I,L,E,y,C,F,D,M,K,W,_,H,ie){super(L,E,y,C,F,D,M,K,W,_,H,ie),this.r=I,this.B(this.G.watch(this.h.dirname(I))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(I,L,E){try{L?await this.G.writeFile(this.r,N.$Pe.fromString(I),E?void 0:L):await this.G.createFile(this.r,N.$Pe.fromString(I),{overwrite:E})}catch(y){throw y instanceof h.$vl&&y.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND||y instanceof h.$vl&&y.fileOperationResult===h.FileOperationResult.FILE_MODIFIED_SINCE?new g.$ynb(y.message,g.UserDataSyncErrorCode.LocalPreconditionFailed):y}}async xb(){try{await this.G.del(this.r)}catch(I){if(!(I instanceof h.$vl&&I.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND))throw I}}yb(I){I.contains(this.r)&&this.Q()}};e.$2Nb=n,e.$2Nb=n=ve([Y(3,h.$al),Y(4,$.$Ni),Y(5,d.$gq),Y(6,g.$tnb),Y(7,g.$unb),Y(8,g.$Dnb),Y(9,p.$_l),Y(10,g.$Inb),Y(11,u.$aj),Y(12,P.$Kl)],n);let o=class extends n{constructor(I,L,E,y,C,F,D,M,K,W,_,H,ie,V){super(I,L,E,y,C,F,D,M,K,W,_,ie,V),this.zb=H,this.Bb=void 0}Ab(I,L){const E=[],y=(0,O.$Yn)(I,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$ng)(y)&&L!==Array.isArray(y)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$3Nb=o,e.$3Nb=o=ve([Y(3,h.$al),Y(4,$.$Ni),Y(5,d.$gq),Y(6,g.$tnb),Y(7,g.$unb),Y(8,g.$Dnb),Y(9,p.$_l),Y(10,g.$Inb),Y(11,g.$Hnb),Y(12,u.$aj),Y(13,P.$Kl)],o);let l=class{constructor(I,L,E,y,C,F,D){this.resource=I,this.g=L,this.h=E,this.j=y,this.k=C,this.l=F,this.d=D.extUri,this.f=(0,g.$rnb)(void 0,this.resource,E,this.d)}async initialize({ref:I,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(L);if(E)try{await this.o({ref:I,syncData:E})}catch(y){this.j.error(y)}}m(I){try{const L=JSON.parse(I);if(t(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(I,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const E={ref:I.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Pe.fromString(JSON.stringify(I)))}};e.$4Nb=l,e.$4Nb=l=ve([Y(1,s.$Ml),Y(2,$.$Ni),Y(3,b.$ak),Y(4,h.$al),Y(5,d.$gq),Y(6,P.$Kl)],l)}),define(ce[120],le([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,36,7,4,77,10,17,18,29,20,40,243,115,25,63]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t,a,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=e.$7bc=void 0,e.$5bc=I,e.$6bc=L;async function f(F,D){const M=JSON.parse(F.content);if(F.version===1||F.version===2){const K=(await D.getInstalled(b.ExtensionType.System)).filter(W=>W.isBuiltin);for(const W of M)F.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),F.version===2&&K.every(_=>!(0,$.$Kp)(_.identifier,W.identifier))&&(W.installed=!0)}return M}function I(F){return JSON.parse(F.content)}function L(F,D){return F.sort((M,K)=>!M.identifier.uuid&&K.identifier.uuid?-1:M.identifier.uuid&&!K.identifier.uuid?1:(0,A.$Af)(M.identifier.id,K.identifier.id)),D?(0,T.$9n)(F,{}):JSON.stringify(F)}let E=class extends a.$1Nb{constructor(D,M,K,W,_,H,ie,V,z,te,se,he,q,Z,X,G,U){super({syncResource:o.SyncResource.Extensions,profile:D},M,W,K,_,H,ie,he,q,te,se,X),this.Cb=V,this.Db=z,this.Eb=U,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$Knb,authority:"base"}),this.yb=this.wb.with({scheme:o.$Knb,authority:"local"}),this.zb=this.wb.with({scheme:o.$Knb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$Knb,authority:"accepted"}),this.Bb=this.Eb.createInstance(y),this.B(k.Event.any(k.Event.filter(this.Cb.onDidInstallExtensions,Q=>Q.some(({local:B})=>!!B)),k.Event.filter(this.Cb.onDidUninstallExtension,Q=>!Q.error),k.Event.filter(G.onDidChange,Q=>Q.valueChanges.some(({profile:B,changes:j})=>this.syncResource.profile.id===B.id&&j.some(x=>x.key===u.$np))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(D,M){const K=D.syncData?await f(D.syncData,this.Cb):null,W=M?.skippedExtensions??[],_=M?.builtinExtensions??null,H=M?.syncData?await f(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);K?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:te}=(0,i.$4bc)(ie,K,H,W,V,_),se={local:z,remote:te,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:te!==null?o.Change.Modified:o.Change.None},he=this.Ob(ie,!1);return[{skippedExtensions:W,builtinExtensions:_,baseResource:this.xb,baseContent:H?this.Ob(H,!1):he,localResource:this.yb,localContent:he,localExtensions:ie,remoteResource:this.zb,remoteExtensions:K,remoteContent:K?this.Ob(K,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(D){const M=D.syncData?await f(D.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:_}=(0,i.$4bc)(K,M,M,D.skippedExtensions||[],W,D.builtinExtensions||[]);return _!==null}Hb(D,M,K,W){const _=[...M,...K],H=new Set,ie=V=>{H.add(V.id.toLowerCase()),V.uuid&&H.add(V.uuid)};_.forEach(({identifier:V})=>ie(V)),W.forEach(ie);for(const V of D)H.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&H.has(V.identifier.uuid)||_.push(V);return this.Ob(_,!1)}async rb(D,M){return{...D.previewResult,hasConflicts:!1}}async sb(D,M,K,W){if(this.h.isEqual(M,this.yb))return this.Kb(D);if(this.h.isEqual(M,this.zb))return this.Lb(D);if(this.h.isEqual(M,this.wb))return D.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(M),W=(0,i.$4bc)(D.localExtensions,null,null,D.skippedExtensions,K,D.builtinExtensions),{local:_,remote:H}=W;return{content:D.localContent,local:_,remote:H,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:H!==null?o.Change.Modified:o.Change.None}}async Lb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(M),W=D.remoteContent?JSON.parse(D.remoteContent):null;if(W!==null){const _=(0,i.$4bc)(D.localExtensions,W,D.localExtensions,[],K,D.builtinExtensions),{local:H,remote:ie}=_;return{content:D.remoteContent,local:H,remote:ie,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:D.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(D,M,K,W){let{skippedExtensions:_,builtinExtensions:H,localExtensions:ie}=K[0][0];const{local:V,remote:z,localChange:te,remoteChange:se}=K[0][1];if(te===o.Change.None&&se===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==o.Change.None&&(await this.nb(JSON.stringify(ie)),_=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,_,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(z.all);D=await this.mb(he,W?null:D.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}M?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(ie,H),await this.fb(D,{skippedExtensions:_,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(he=>he.identifier.id))}.`:""}`))}Nb(D,M){const K=new Set,W=[];for(const _ of D)K.add(_.identifier.id.toLowerCase()),_.installed||W.push(_.identifier);if(M)for(const _ of M)K.has(_.id.toLowerCase())||W.push(_);return W}async resolveContent(D){if(this.h.isEqual(this.zb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.yb,D)||this.h.isEqual(this.Ab,D)){const M=await this.db(D);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(D,M){return L(D,M)}async hasLocalData(){try{const{localExtensions:D}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(D.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$7bc=E,e.$7bc=E=ve([Y(2,S.$Ni),Y(3,v.$al),Y(4,g.$gq),Y(5,o.$tnb),Y(6,o.$unb),Y(7,u.$mp),Y(8,n.$MOb),Y(9,o.$Inb),Y(10,w.$aj),Y(11,o.$Dnb),Y(12,s.$_l),Y(13,h.$nw),Y(14,r.$Kl),Y(15,l.$UMb),Y(16,d.$Fi)],E);let y=class{constructor(D,M,K,W,_,H){this.a=D,this.b=M,this.c=K,this.d=W,this.f=_,this.g=H}async getLocalExtensions(D){const M=await this.a.getInstalled(void 0,D.extensionsResource),K=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(D,async(_,H)=>{const ie=_.getDisabledExtensions();return M.map(V=>{const{identifier:z,isBuiltin:te,manifest:se,preRelease:he,pinned:q,isApplicationScoped:Z}=V,X={identifier:z,preRelease:he,version:se.version,pinned:!!q};Z&&!(0,b.$un)(se)&&(X.isApplicationScoped=Z),ie.some(G=>(0,$.$Kp)(G,z))&&(X.disabled=!0),te||(X.installed=!0);try{const G=H.getKeysForSync({id:z.id,version:se.version});if(G){const U=H.getExtensionState(V,!0)||{};X.state=Object.keys(U).reduce((Q,B)=>(G.includes(B)&&(Q[B]=U[B]),Q),{})}}catch(G){this.g.info(`${(0,a.$ZNb)(o.SyncResource.Extensions,D)}: Error while parsing extension state`,(0,N.$ab)(G))}return X})}),ignoredExtensions:K}}async updateLocalExtensions(D,M,K,W,_){const H=(0,a.$ZNb)(o.SyncResource.Extensions,_),ie=[],V=new Map,z=[],te=[],se=await this.a.getInstalled(void 0,_.extensionsResource);if((D.length||K.length)&&await this.j(_,async(Z,X)=>{await R.Promises.settled([...D,...K].map(async G=>{const U=se.find(j=>(0,$.$Kp)(j.identifier,G.identifier));if(U&&U.isBuiltin){G.state&&U.manifest.version===G.version&&this.h(G.state,U,U.manifest.version,X),Z.getDisabledExtensions().some(x=>(0,$.$Kp)(x,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${H}: Disabling extension...`,G.identifier.id),await Z.disableExtension(G.identifier),this.g.info(`${H}: Disabled extension`,G.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,G.identifier.id),await Z.enableExtension(G.identifier),this.g.info(`${H}: Enabled extension`,G.identifier.id))),z.push(G.identifier);return}const Q=G.pinned?G.version:void 0,B=(await this.c.getExtensions([{...G.identifier,version:Q,preRelease:Q?void 0:G.preRelease}],c.CancellationToken.None))[0];if(G.state&&(U?U.manifest.version===G.version:B)&&this.h(G.state,U||B,U?.manifest.version,X),B)try{Z.getDisabledExtensions().some(x=>(0,$.$Kp)(x,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${H}: Disabling extension...`,G.identifier.id,B.version),await Z.disableExtension(B.identifier),this.g.info(`${H}: Disabled extension`,G.identifier.id,B.version)):(this.g.trace(`${H}: Enabling extension...`,G.identifier.id,B.version),await Z.enableExtension(B.identifier),this.g.info(`${H}: Enabled extension`,G.identifier.id,B.version))),(!U||U.preRelease!==G.preRelease||U.pinned!==G.pinned||Q&&U.manifest.version!==Q)&&(await this.a.canInstall(B)?(ie.push({extension:B,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:G.pinned&&!!G.version,pinned:G.pinned,installPreReleaseVersion:G.preRelease,profileLocation:_.extensionsResource,isApplicationScoped:G.isApplicationScoped,context:{[u.$_o]:!0,[u.$ap]:u.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(B.identifier.id.toLowerCase(),G)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),te.push(G)))}catch(j){te.push(G),this.g.error(j),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else te.push(G),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,G.identifier.id)}))}),M.length){const Z=se.filter(({identifier:X,isBuiltin:G})=>!G&&M.some(U=>(0,$.$Kp)(X,U)));await R.Promises.settled(Z.map(async X=>{this.g.trace(`${H}: Uninstalling local extension...`,X.identifier.id),await this.a.uninstall(X,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:_.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,X.identifier.id),z.push(X.identifier)}))}const he=await this.a.installGalleryExtensions(ie);for(const{identifier:Z,local:X,error:G,source:U}of he){const Q=U;if(X)this.g.info(`${H}: Installed extension.`,Z.id,Q.version),z.push(Z);else{const B=V.get(Z.id.toLowerCase());B&&(te.push(B),this.g.info(`${H}: Skipped synchronizing extension`,Q.displayName||Q.identifier.id)),G instanceof u.$lp&&[u.ExtensionManagementErrorCode.Incompatible,u.ExtensionManagementErrorCode.IncompatibleApi,u.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(G.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,Q.displayName||Q.identifier.id):G&&this.g.error(G)}}const q=[];for(const Z of W)z.some(X=>(0,$.$Kp)(X,Z.identifier))||q.push(Z);for(const Z of te)q.some(X=>(0,$.$Kp)(X.identifier,Z.identifier))||q.push(Z);return q}h(D,M,K,W){const _=W.getExtensionState(M,!0)||{},H=K?W.getKeysForSync({id:M.identifier.id,version:K}):void 0;H?H.forEach(ie=>{_[ie]=D[ie]}):Object.keys(D).forEach(ie=>_[ie]=D[ie]),W.setExtensionState(M,_,!0)}async j(D,M){return this.b.withProfileScopedStorageService(D,async K=>{const W=new O.$Wc,_=W.add(this.f.createChild(new p.$Ei([g.$gq,K]))),H=W.add(_.createInstance(m.$gMb)),ie=W.add(_.createInstance(h.$ow));try{return await M(H,ie)}finally{W.dispose()}})}};e.$8bc=y,e.$8bc=y=ve([Y(0,u.$mp),Y(1,l.$UMb),Y(2,u.$jp),Y(3,n.$MOb),Y(4,d.$Fi),Y(5,o.$Inb)],y);let C=class extends a.$4Nb{constructor(D,M,K,W,_,H,ie,V){super(o.SyncResource.Extensions,W,_,H,K,ie,V),this.p=D,this.q=M}async t(D){return D.syncData?await f(D.syncData,this.p):null}u(D,M){const K=[],W=[],_=[];for(const H of D){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const ie=M.find(V=>(0,$.$Kp)(V.identifier,H.identifier));ie?(K.push(ie),H.disabled&&_.push(H.identifier)):H.installed&&(W.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&_.push(H.identifier))}return{installedExtensions:K,newExtensions:W,disabledExtensions:_,remoteExtensions:D}}};e.$9bc=C,e.$9bc=C=ve([Y(0,u.$mp),Y(1,n.$MOb),Y(2,v.$al),Y(3,t.$Ml),Y(4,S.$Ni),Y(5,P.$ak),Y(6,g.$gq),Y(7,r.$Kl)],C)}),define(ce[121],le([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,247,25,20,63,4]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Nb=e.$9Nb=e.$8Nb=e.$7Nb=void 0,e.$6Nb=n;const a="globalState.argv.",i=["locale"];function n(E,y){const C=E.storage?Object.keys(E.storage).sort():[],F={};return C.forEach(D=>F[D]=E.storage[D]),E.storage=F,y?(0,T.$9n)(E,{}):JSON.stringify(E)}const o=1;let l=class extends d.$1Nb{constructor(y,C,F,D,M,K,W,_,H,ie,V,z,te,se){super({syncResource:g.SyncResource.GlobalState,profile:y},C,D,_,z,M,K,H,ie,W,V,te),this.Bb=F,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$Knb,authority:"base"}),this.xb=this.vb.with({scheme:g.$Knb,authority:"local"}),this.yb=this.vb.with({scheme:g.$Knb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$Knb,authority:"accepted"}),this.Ab=se.createInstance(f),this.B(D.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(D.onDidFilesChange,he=>he.contains(this.H.argvResource)),N.Event.filter(F.onDidChange,he=>!!(he.targetChanges.some(q=>this.syncResource.profile.id===q.id)||he.valueChanges.some(({profile:q,changes:Z})=>this.syncResource.profile.id===q.id&&Z.some(X=>X.target===h.StorageTarget.USER)))))(()=>this.Q()))}async qb(y,C,F){const D=y.syncData?JSON.parse(y.syncData.content):null;C=C===null&&F?y:C;const M=C&&C.syncData?JSON.parse(C.syncData.content):null,K=await this.Ab.getLocalGlobalState(this.syncResource.profile);D?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Jb(M),{local:_,remote:H}=(0,P.$5Nb)(K.storage,D?D.storage:null,M?M.storage:null,W,this.O),ie={content:null,local:_,remote:H,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:H.all!==null?g.Change.Modified:g.Change.None},V=n(K,!1);return[{baseResource:this.wb,baseContent:M?n(M,!1):V,localResource:this.xb,localContent:V,localUserData:K,remoteResource:this.yb,remoteContent:D?n(D,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:W}]}async ub(y){const C=y.syncData?JSON.parse(y.syncData.content):null;if(C===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),D=await this.Jb(C),{remote:M}=(0,P.$5Nb)(F.storage,C.storage,C.storage,D,this.O);return M.all!==null}async rb(y,C){return{...y.previewResult,hasConflicts:!1}}async sb(y,C,F,D){if(this.h.isEqual(C,this.xb))return this.Gb(y);if(this.h.isEqual(C,this.yb))return this.Hb(y);if(this.h.isEqual(C,this.vb))return y.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async Gb(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(y.localUserData.storage),removed:[],updated:[],all:y.localUserData.storage},localChange:g.Change.None,remoteChange:g.Change.Modified}}async Hb(y){if(y.remoteContent!==null){const C=JSON.parse(y.remoteContent),{local:F,remote:D}=(0,P.$5Nb)(y.localUserData.storage,C.storage,null,y.storageKeys,this.O);return{content:y.remoteContent,local:F,remote:D,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:D!==null?g.Change.Modified:g.Change.None}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:g.Change.None,remoteChange:g.Change.None}}async tb(y,C,F,D){const{localUserData:M}=F[0][0],{local:K,remote:W,localChange:_,remoteChange:H}=F[0][1];if(_===g.Change.None&&H===g.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),_!==g.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(K,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==g.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:W.all});y=await this.mb(ie,D?null:y.ref),this.O.info(`${this.D}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}C?.ref!==y.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(y),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(y){if(this.h.isEqual(this.yb,y)||this.h.isEqual(this.wb,y)||this.h.isEqual(this.xb,y)||this.h.isEqual(this.zb,y)){const C=await this.db(y);return C&&n(JSON.parse(C),!0)}return null}async hasLocalData(){try{const{storage:y}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(y).length>1||y[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(y){const C=await this.Bb.readStorageData(this.syncResource.profile),F=[],D=[];for(const[W,_]of C)_.target===h.StorageTarget.USER?F.push(W):_.target===h.StorageTarget.MACHINE&&D.push(W);const M=[...F,...D],K=y?.storage?Object.keys(y.storage).filter(W=>!W.startsWith(a)&&!M.includes(W)&&C.get(W)!==void 0):[];if(!O.$o){const W=[...g.$pnb.map(_=>(0,g.$Cnb)(_)),g.$Bnb];K.push(...W),D.push(...W)}return{user:F,machine:D,unregistered:K}}};e.$7Nb=l,e.$7Nb=l=ve([Y(2,r.$UMb),Y(3,m.$al),Y(4,g.$tnb),Y(5,g.$unb),Y(6,g.$Inb),Y(7,S.$Ni),Y(8,g.$Dnb),Y(9,b.$_l),Y(10,w.$aj),Y(11,h.$gq),Y(12,v.$Kl),Y(13,t.$Fi)],l);let f=class{constructor(y,C,F,D){this.a=y,this.b=C,this.c=F,this.d=D}async getLocalGlobalState(y){const C={};if(y.isDefault){const D=await this.f(),M=(0,k.$Yn)(D);for(const K of i)M[K]!==void 0&&(C[`${a}${K}`]={version:1,value:M[K]})}const F=await this.c.readStorageData(y);for(const[D,M]of F)M.value&&M.target===h.StorageTarget.USER&&(C[D]={version:1,value:M.value});return{storage:C}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const y=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),y.value.toString()}catch(y){this.d.debug((0,c.$ab)(y))}return"{}"}async writeLocalGlobalState({added:y,removed:C,updated:F},D){const M=(0,d.$ZNb)(g.SyncResource.GlobalState,D),K={},W=new Map,_=await this.c.readStorageData(D),H=(ie,V)=>{for(const z of ie){if(z.startsWith(a)){K[z.substring(a.length)]=V?V[z].value:void 0;continue}if(V){const te=V[z];te.value!==_.get(z)?.value&&W.set(z,te.value)}else _.get(z)!==void 0&&W.set(z,void 0)}};if(H(Object.keys(y),y),H(Object.keys(F),F),H(C),Object.keys(K).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(K))V=(0,p.edit)(V,[z],K[z],{});ie!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Pe.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}W.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(D,W,h.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...W.keys()]))}};e.$8Nb=f,e.$8Nb=f=ve([Y(0,m.$al),Y(1,S.$Ni),Y(2,r.$UMb),Y(3,g.$Inb)],f);let I=class extends d.$4Nb{constructor(y,C,F,D,M,K){super(g.SyncResource.GlobalState,F,D,M,C,y,K)}async o(y){const C=y.syncData?JSON.parse(y.syncData.content):null;if(!C){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},D={};for(const M of Object.keys(C.storage))M.startsWith(a)?F[M.substring(a.length)]=C.storage[M].value:this.l.get(M,h.StorageScope.PROFILE)===void 0&&(D[M]=C.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const K of Object.keys(F))M=(0,p.edit)(M,[K],F[K],{});await this.k.writeFile(this.h.argvResource,R.$Pe.fromString(M))}if(Object.keys(D).length){const M=[];for(const K of Object.keys(D))M.push({key:K,value:D[K],scope:h.StorageScope.PROFILE,target:h.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$9Nb=I,e.$9Nb=I=ve([Y(0,h.$gq),Y(1,m.$al),Y(2,s.$Ml),Y(3,S.$Ni),Y(4,g.$Inb),Y(5,v.$Kl)],I);let L=class{constructor(y,C,F,D,M){this.a=y,this.b=C,this.c=F,this.d=D,this.f=M}getSyncStoreType(y){return this.h(y)?.storage[g.$Bnb]?.value}async sync(y){const C=(0,g.$xnb)((0,A.$3g)());try{return await this.g(y,C)}catch(F){if(F instanceof g.$ynb)switch(F.code){case g.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(y,C)}throw F}}async g(y,C){const F=await this.a.readResource(g.SyncResource.GlobalState,null,void 0,C),D=this.h(F)||{storage:{}};D.storage[g.$Bnb]={value:y,version:o};const M=await(0,$.$mq)(this.c,this.d,this.b),K={version:o,machineId:M,content:n(D,!1)};await this.a.writeResource(g.SyncResource.GlobalState,JSON.stringify(K),F.ref,void 0,C)}h({content:y}){if(!y)return null;const C=JSON.parse(y);if((0,d.$YNb)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};e.$0Nb=L,e.$0Nb=L=ve([Y(1,h.$gq),Y(2,S.$Ni),Y(3,m.$al),Y(4,u.$ak)],L)}),define(ce[122],le([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,244,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=void 0,e.$$bc=P;function P(r,t,a){try{const i=JSON.parse(r);if(!t)return(0,O.$ng)(i.all)?null:i.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,O.$ng)(i.mac)?null:i.mac;case T.OperatingSystem.Linux:return(0,O.$ng)(i.linux)?null:i.linux;case T.OperatingSystem.Windows:return(0,O.$ng)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}let g=class extends v.$3Nb{constructor(t,a,i,n,o,l,f,I,L,E,y,C,F){super(t.keybindingsResource,{syncResource:p.SyncResource.Keybindings,profile:t},a,I,L,E,i,n,f,C,o,y,l,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:p.$Knb,authority:"base"}),this.Gb=this.Eb.with({scheme:p.$Knb,authority:"local"}),this.Hb=this.Eb.with({scheme:p.$Knb,authority:"remote"}),this.Ib=this.Eb.with({scheme:p.$Knb,authority:"accepted"}),this.B(N.Event.filter(l.onDidChangeConfiguration,D=>D.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(t,a,i,n){const o=t.syncData?P(t.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;a=a===null&&i?t:a;const l=a?this.Ob(a):null,f=await this.vb(),I=await this.Cb();let L=null,E=!1,y=!1,C=!1;if(o){let M=f?f.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new p.$ynb((0,A.localize)(0,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==M||l!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const K=await(0,d.$0bc)(M,o,l,I,this.zb);K.hasChanges&&(L=K.mergeContent,C=K.hasConflicts,E=C||K.mergeContent!==M,y=C||K.mergeContent!==o)}}else f&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=f.value.toString(),y=!0);const F={content:C?l:L,localChange:E?f?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:y?p.Change.Modified:p.Change.None,hasConflicts:C},D=f?f.value.toString():null;return[{fileContent:f,baseResource:this.Fb,baseContent:l,localResource:this.Gb,localContent:D,localChange:F.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(t){const a=this.Ob(t);if(a===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",o=await this.Cb(),l=await(0,d.$0bc)(n||"[]",a,a,o,this.zb);return l.hasConflicts||l.mergeContent!==a}async rb(t,a){return t.previewResult}async sb(t,a,i,n){if(this.h.isEqual(a,this.Gb))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(a,this.Hb))return{content:t.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(a,this.Eb))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(t,a,i,n){const{fileContent:o}=i[0][0];let{content:l,localChange:f,remoteChange:I}=i[0][1];if(f===p.Change.None&&I===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.Ab(l,!0)))throw new p.$ynb((0,A.localize)(1,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(f!==p.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(l||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),I!==p.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(l||"[]",t.syncData?.content);t=await this.mb(L,n?null:t.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}a?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(t,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.vb();if(t){const a=(0,k.$Yn)(t.value.toString());if((0,R.$Ob)(a))return!0}}catch(t){if(t.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.Hb,t)||this.h.isEqual(this.Fb,t)||this.h.isEqual(this.Gb,t)||this.h.isEqual(this.Ib,t)?this.db(t):null}Ob(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.Qb()?null:P(t.syncData.content,this.Qb(),this.O)}Pb(t,a){let i={};try{i=JSON.parse(a||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=t,T.OS){case T.OperatingSystem.Macintosh:i.mac=t;break;case T.OperatingSystem.Linux:i.linux=t;break;case T.OperatingSystem.Windows:i.windows=t;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(p.$mnb)}};e.$_bc=g,e.$_bc=g=ve([Y(2,p.$tnb),Y(3,p.$unb),Y(4,p.$Inb),Y(5,w.$aj),Y(6,p.$Dnb),Y(7,m.$al),Y(8,S.$Ni),Y(9,u.$gq),Y(10,p.$Hnb),Y(11,$.$_l),Y(12,h.$Kl)],g);let s=class extends v.$4Nb{constructor(t,a,i,n,o,l){super(p.SyncResource.Keybindings,a,i,n,t,o,l)}async o(t){const a=t.syncData?this.p(t.syncData.content):null;if(!a){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Pe.fromString(a)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource),a=(0,k.$Yn)(t.value.toString());return!(0,R.$Ob)(a)}catch(t){return t.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return P(t,!0,this.j)}catch(a){return this.j.error(a),null}}};e.$acc=s,e.$acc=s=ve([Y(0,m.$al),Y(1,b.$Ml),Y(2,S.$Ni),Y(3,p.$Inb),Y(4,u.$gq),Y(5,h.$Kl)],s)}),define(ce[123],le([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,248,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0,e.$bcc=p;function d(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function p(s){const r=JSON.parse(s);return d(r)?r:{settings:s}}let P=class extends h.$3Nb{constructor(r,t,a,i,n,o,l,f,I,L,E,y,C,F){super(r.settingsResource,{syncResource:v.SyncResource.Settings,profile:r},t,a,i,n,o,l,E,y,f,I,L,F),this.Eb=C,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.$Knb,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.$Knb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.$Knb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.$Knb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.X(r,t),i=this.Lb(a),n=new T.$No(v.$lnb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(v.$lnb)||{}}async qb(r,t,a){const i=await this.vb(),n=await this.Cb(),o=this.Lb(r);t=t===null&&a?r:t;const l=t?this.Lb(t):null,f=await this.Pb();let I=null,L=!1,E=!1,y=!1;if(o){let M=i?i.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const K=(0,b.$BMb)(M,o.settings,l?l.settings:null,f,[],n);I=K.localContent||K.remoteContent,L=K.localContent!==null,E=K.remoteContent!==null,y=K.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),I=i.value.toString().trim()||"{}",this.Qb(I),E=!0);const C=i?i.value.toString():null,F=l?.settings??null,D={content:y?F:I,localChange:L?v.Change.Modified:v.Change.None,remoteChange:E?v.Change.Modified:v.Change.None,hasConflicts:y};return[{fileContent:i,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:C,localChange:D.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:D.remoteChange,previewResource:this.previewResource,previewResult:D,acceptedResource:this.acceptedResource}]}async ub(r){const t=this.Lb(r);if(t===null)return!0;const a=await this.vb(),i=a?a.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,b.$BMb)(i||"{}",t.settings,t.settings,n,[],o).remoteContent!==null}async rb(r,t){const a=await this.Cb(),i=await this.Pb();return{...r.previewResult,content:r.previewResult.content?(0,b.$AMb)(r.previewResult.content,"{}",i,a):null}}async sb(r,t,a,i){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,b.$AMb)(r.fileContent.value.toString(),"{}",o,n):null,localChange:v.Change.None,remoteChange:v.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,b.$AMb)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:v.Change.Modified,remoteChange:v.Change.None};if(this.h.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,b.$AMb)(a,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:v.Change.Modified,remoteChange:v.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(r,t,a,i){const{fileContent:n}=a[0][0];let{content:o,localChange:l,remoteChange:f}=a[0][1];if(l===v.Change.None&&f===v.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),l!==v.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,i),await this.P.reloadConfiguration(k.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),f!==v.Change.None){const I=await this.Cb(),L=this.Lb(r),E=await this.Pb(o);o=(0,b.$AMb)(o,L?L.settings:"{}",E,I),this.O.trace(`${this.D}: Updating remote settings...`),r=await this.mb(JSON.stringify(this.Nb(o)),i?null:r.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(r),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.vb();if(r)return!(0,b.$CMb)(r.value.toString())}catch(r){if(r.fileOperationResult!==w.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.db(r):null}async db(r){let t=await super.db(r);if(t){const a=await this.Cb(),i=await this.Pb();t=(0,b.$AMb)(t,"{}",i,a)}return t}Lb(r){return r.syncData?this.Mb(r.syncData.content):null}Mb(r){try{return p(r)}catch(t){this.O.error(t)}return null}Nb(r){return{settings:r}}async Pb(r){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const a=this.B(c.Event.any(c.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),c.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{a.dispose(),this.Ob=void 0}))}const t=await this.Ob;return(0,b.$yMb)(t,this.P,r)}Qb(r){if(this.Ab(r,!1))throw new v.$ynb((0,N.localize)(0,null),v.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$ccc=P,e.$ccc=P=ve([Y(2,w.$al),Y(3,O.$Ni),Y(4,S.$gq),Y(5,v.$tnb),Y(6,v.$unb),Y(7,v.$Inb),Y(8,v.$Hnb),Y(9,k.$aj),Y(10,v.$Dnb),Y(11,m.$_l),Y(12,A.$mp),Y(13,u.$Kl)],P);let g=class extends h.$4Nb{constructor(r,t,a,i,n,o){super(v.SyncResource.Settings,t,a,i,r,n,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$Pe.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$CMb)(r.value.toString().trim())}catch(r){return r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND}}p(r){try{return p(r)}catch(t){this.j.error(t)}return null}};e.$dcc=g,e.$dcc=g=ve([Y(0,w.$al),Y(1,$.$Ml),Y(2,O.$Ni),Y(3,v.$Inb),Y(4,S.$gq),Y(5,u.$Kl)],g)}),define(ce[124],le([0,1,15,3,30,22,16,7,17,18,29,20,40,245,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0,e.$gcc=b;function b(p){return JSON.parse(p.content)}let v=class extends u.$1Nb{constructor(P,g,s,r,t,a,i,n,o,l,f,I){super({syncResource:h.SyncResource.Snippets,profile:P},g,r,s,t,a,i,l,f,n,o,I),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(s.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(P,g,s){const r=await this.Hb(),t=this.Gb(r),a=P.syncData?this.Fb(P.syncData):null;g=g===null&&s?P:g;const i=g&&g.syncData?this.Fb(g.syncData):null;a?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$ecc)(t,a,i);return this.Bb(n,r,a||{},i||{})}async ub(P){const g=P.syncData?this.Fb(P.syncData):null;if(g===null)return!0;const s=await this.Hb(),r=this.Gb(s),t=(0,$.$ecc)(r,g,g);return Object.keys(t.remote.added).length>0||Object.keys(t.remote.updated).length>0||t.remote.removed.length>0||t.conflicts.length>0}async rb(P,g){return P.previewResult}async sb(P,g,s,r){if(this.h.isEqualOrParent(g,this.g.with({scheme:h.$Knb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:h.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?h.Change.Modified:h.Change.Added:h.Change.Deleted};if(this.h.isEqualOrParent(g,this.g.with({scheme:h.$Knb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?h.Change.Modified:h.Change.Added:h.Change.Deleted,remoteChange:h.Change.None};if(this.h.isEqualOrParent(g,this.g))return s===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:s,localChange:s===null?P.fileContent!==null?h.Change.Deleted:h.Change.None:h.Change.Modified,remoteChange:s===null?P.remoteContent!==null?h.Change.Deleted:h.Change.None:h.Change.Modified};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(P,g,s,r){const t=s.map(([a,i])=>({...a,acceptResult:i}));t.every(({localChange:a,remoteChange:i})=>a===h.Change.None&&i===h.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),t.some(({localChange:a})=>a!==h.Change.None)&&(await this.Cb(t),await this.Db(t,r)),t.some(({remoteChange:a})=>a!==h.Change.None)&&(P=await this.Eb(t,P,r)),g?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:a}of t)try{await this.G.del(a)}catch{}}Bb(P,g,s,r){const t=new Map;for(const a of Object.keys(P.local.added)){const i={content:P.local.added[a],hasConflicts:!1,localChange:h.Change.Added,remoteChange:h.Change.None};t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of Object.keys(P.local.updated)){const i={content:P.local.updated[a],hasConflicts:!1,localChange:h.Change.Modified,remoteChange:h.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of P.local.removed){const i={content:null,hasConflicts:!1,localChange:h.Change.Deleted,remoteChange:h.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of Object.keys(P.remote.added)){const i={content:P.remote.added[a],hasConflicts:!1,localChange:h.Change.None,remoteChange:h.Change.Added},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of Object.keys(P.remote.updated)){const i={content:P.remote.updated[a],hasConflicts:!1,localChange:h.Change.None,remoteChange:h.Change.Modified},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of P.remote.removed){const i={content:null,hasConflicts:!1,localChange:h.Change.None,remoteChange:h.Change.Deleted};t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of P.conflicts){const i={content:r[a]??null,hasConflicts:!0,localChange:g[a]?h.Change.Modified:h.Change.Added,remoteChange:s[a]?h.Change.Modified:h.Change.Added},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}for(const a of Object.keys(g))if(!t.has(a)){const i={content:g[a]?g[a].value.toString():null,hasConflicts:!1,localChange:h.Change.None,remoteChange:h.Change.None},n=g[a]?g[a].value.toString():null;t.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"local"}),fileContent:g[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:h.$Knb,authority:"accepted"})})}return[...t.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:h.$Knb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:h.$Knb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:h.$Knb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:h.$Knb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const g={};for(const s of P)s.fileContent&&(g[this.h.basename(s.localResource)]=s.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(P,g){for(const{fileContent:s,acceptResult:r,localResource:t,remoteResource:a,localChange:i}of P)if(i!==h.Change.None){const n=a?this.h.basename(a):this.h.basename(t),o=this.h.joinPath(this.vb,n);i===h.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):i===h.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,R.$Pe.fromString(r.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,R.$Pe.fromString(r.content),g?void 0:s),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(P,g,s){const r=g.syncData?this.Fb(g.syncData):{},t=(0,N.$eo)(r);for(const{acceptResult:a,localResource:i,remoteResource:n,remoteChange:o}of P)if(o!==h.Change.None){const l=i?this.h.basename(i):this.h.basename(n);o===h.Change.Deleted?delete t[l]:t[l]=a.content}return(0,$.$fcc)(r,t)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(t),s?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(P){return b(P)}Gb(P){const g={};for(const s of Object.keys(P))g[s]=P[s].value.toString();return g}async Hb(){const P={};let g;try{g=await this.G.resolve(this.vb)}catch(s){if(s instanceof O.$vl&&s.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return P;throw s}for(const s of g.children||[]){const r=s.resource,t=this.h.extname(r);if(t===".json"||t===".code-snippets"){const a=this.h.relativePath(this.vb,r),i=await this.G.readFile(r);P[a]=i}}return P}};e.$hcc=v,e.$hcc=v=ve([Y(2,T.$Ni),Y(3,O.$al),Y(4,A.$gq),Y(5,h.$tnb),Y(6,h.$unb),Y(7,h.$Inb),Y(8,k.$aj),Y(9,h.$Dnb),Y(10,w.$_l),Y(11,S.$Kl)],v);let d=class extends u.$4Nb{constructor(P,g,s,r,t,a){super(h.SyncResource.Snippets,g,s,r,P,t,a)}async o(P){const g=P.syncData?JSON.parse(P.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const r of Object.keys(g)){const t=g[r];if(t){const a=this.d.joinPath(this.g.defaultProfile.snippetsHome,r);await this.k.createFile(a,R.$Pe.fromString(t)),this.j.info("Created snippet",this.d.basename(a))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$icc=d,e.$icc=d=ve([Y(0,O.$al),Y(1,m.$Ml),Y(2,T.$Ni),Y(3,h.$Inb),Y(4,A.$gq),Y(5,S.$Kl)],d)}),define(ce[125],le([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0,e.$jcc=u;function u(v,d){try{return JSON.parse(v).tasks??null}catch(p){return d.error(p),null}}let $=class extends S.$2Nb{constructor(d,p,P,g,s,r,t,a,i,n,o,l){super(d.tasksResource,{syncResource:m.SyncResource.Tasks,profile:d},p,a,i,n,P,g,t,o,s,r,l),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:m.$Knb,authority:"base"}),this.Cb=this.Ab.with({scheme:m.$Knb,authority:"local"}),this.Db=this.Ab.with({scheme:m.$Knb,authority:"remote"}),this.Eb=this.Ab.with({scheme:m.$Knb,authority:"accepted"})}async qb(d,p,P,g){const s=d.syncData?u(d.syncData.content,this.O):null;p=p===null&&P?d:p;const r=p?.syncData?u(p.syncData.content,this.O):null,t=await this.vb();let a=null,i=!1,n=!1,o=!1;if(d.syncData){const I=t?t.value.toString():null;if(!r||r!==I||r!==s){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=b(I,s,r);a=L.content,o=L.hasConflicts,i=L.hasLocalChanged,n=L.hasRemoteChanged}}else t&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),a=t.value.toString(),n=!0);const l={content:o?r:a,localChange:i?t?m.Change.Modified:m.Change.Added:m.Change.None,remoteChange:n?m.Change.Modified:m.Change.None,hasConflicts:o},f=t?t.value.toString():null;return[{fileContent:t,baseResource:this.Bb,baseContent:r,localResource:this.Cb,localContent:f,localChange:l.localChange,remoteResource:this.Db,remoteContent:s,remoteChange:l.remoteChange,previewResource:this.Ab,previewResult:l,acceptedResource:this.Eb}]}async ub(d){const p=d?.syncData?u(d.syncData.content,this.O):null;if(p===null)return!0;const P=await this.vb(),g=P?P.value.toString():null,s=b(g,p,p);return s.hasLocalChanged||s.hasRemoteChanged}async rb(d,p){return d.previewResult}async sb(d,p,P,g){if(this.h.isEqual(p,this.Cb))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:m.Change.None,remoteChange:m.Change.Modified};if(this.h.isEqual(p,this.Db))return{content:d.remoteContent,localChange:m.Change.Modified,remoteChange:m.Change.None};if(this.h.isEqual(p,this.Ab))return P===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:P,localChange:m.Change.Modified,remoteChange:m.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(d,p,P,g){const{fileContent:s}=P[0][0],{content:r,localChange:t,remoteChange:a}=P[0][1];if(t===m.Change.None&&a===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),t!==m.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),s&&await this.nb(JSON.stringify(this.Kb(s.value.toString()))),r?await this.wb(r,s,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),a!==m.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(r));d=await this.mb(i,g?null:d.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}p?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(d){return this.h.isEqual(this.Db,d)||this.h.isEqual(this.Bb,d)||this.h.isEqual(this.Cb,d)||this.h.isEqual(this.Eb,d)?this.db(d):null}Kb(d){return d?{tasks:d}:{}}};e.$kcc=$,e.$kcc=$=ve([Y(2,m.$tnb),Y(3,m.$unb),Y(4,m.$Inb),Y(5,c.$aj),Y(6,m.$Dnb),Y(7,k.$al),Y(8,N.$Ni),Y(9,T.$gq),Y(10,O.$_l),Y(11,A.$Kl)],$);let h=class extends S.$4Nb{constructor(d,p,P,g,s,r){super(m.SyncResource.Tasks,p,P,g,d,s,r),this.c=this.g.defaultProfile.tasksResource}async o(d){const p=d.syncData?u(d.syncData.content,this.j):null;if(!p){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Pe.fromString(p)),await this.n(d)}async p(){return this.k.exists(this.c)}};e.$lcc=h,e.$lcc=h=ve([Y(0,k.$al),Y(1,w.$Ml),Y(2,N.$Ni),Y(3,m.$Inb),Y(4,T.$gq),Y(5,A.$Kl)],h);function b(v,d,p){if(v===null&&d===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=p!==v,g=p!==d;return!P&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!g?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!P?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[126],le([0,1,45,22,16,7,17,18,29,20,40,246,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0,e.$6dc=h,e.$7dc=b;let $=class extends S.$1Nb{constructor(d,p,P,g,s,r,t,a,i,n,o,l,f){super({syncResource:u.SyncResource.Profiles,profile:d},p,g,s,r,t,a,o,l,i,n,f),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:u.$Knb,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.$Knb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.$Knb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.$Knb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?b(d.syncData):null}async getRemoteSyncedProfiles(d){const p=await this.getLastSyncUserData(),P=await this.X(d,p);return P?.syncData?b(P.syncData):null}async qb(d,p,P){if(!this.vb.isEnabled())throw new u.$ynb("Cannot sync profiles because they are disabled",u.UserDataSyncErrorCode.LocalError);const g=d.syncData?b(d.syncData):null,s=p?.syncData?b(p.syncData):null,r=this.Db(),{local:t,remote:a}=(0,m.$4dc)(r,g,s,[]),i={local:t,remote:a,content:s?this.Eb(s):null,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:a!==null?u.Change.Modified:u.Change.None},n=h(r,!1);return[{baseResource:this.baseResource,baseContent:s?this.Eb(s):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(d){const p=d?.syncData?b(d.syncData):null,P=this.Db(),{remote:g}=(0,m.$4dc)(P,p,p,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(d,p){return{...d.previewResult,hasConflicts:!1}}async sb(d,p,P,g){if(this.h.isEqual(p,this.localResource))return this.Ab(d);if(this.h.isEqual(p,this.remoteResource))return this.Bb(d);if(this.h.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async Ab(d){const p=this.Db(),P=(0,m.$4dc)(p,null,null,[]),{local:g,remote:s}=P;return{content:d.localContent,local:g,remote:s,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:s!==null?u.Change.Modified:u.Change.None}}async Bb(d){const p=d.remoteContent?JSON.parse(d.remoteContent):null,P=[],g=[];for(const s of this.Db()){const r=p?.find(t=>t.id===s.id);r&&(P.push({id:s.id,name:s.name,collection:r.collection}),g.push(s))}if(p!==null){const s=(0,m.$4dc)(g,p,P,[]),{local:r,remote:t}=s;return{content:d.remoteContent,local:r,remote:t,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:t!==null?u.Change.Modified:u.Change.None}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:u.Change.None,remoteChange:u.Change.None}}async tb(d,p,P,g){const{local:s,remote:r,localChange:t,remoteChange:a}=P[0][1];t===u.Change.None&&a===u.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=P[0][0].remoteProfiles||[];if(i.length+(r?.added.length??0)-(r?.removed.length??0)>20)throw new u.$ynb("Too many profiles to sync. Please remove some profiles and try again.",u.UserDataSyncErrorCode.LocalTooManyProfiles);if(t!==u.Change.None&&(await this.nb(h(this.Db(),!1)),await Promise.all(s.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(s.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(s.updated.map(async n=>{const o=this.vb.profiles.find(l=>l.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),a!==u.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=i.length+(r?.added.length??0)<=20;if(o)for(const l of r?.added||[]){const f=await this.J.createCollection(this.F);n.push(f),i.push({id:l.id,name:l.name,collection:f,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const l of r?.removed||[])i.splice(i.findIndex(({id:f})=>l.id===f),1);for(const l of r?.updated||[]){const f=i.find(({id:I})=>l.id===I);f&&i.splice(i.indexOf(f),1,{...f,id:l.id,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}try{d=await this.updateRemoteProfiles(i,g?null:d.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&r?.added.length?` Added: ${JSON.stringify(r.added.map(l=>l.name))}.`:""}${r?.updated.length?` Updated: ${JSON.stringify(r.updated.map(l=>l.name))}.`:""}${r?.removed.length?` Removed: ${JSON.stringify(r.removed.map(l=>l.name))}.`:""}`)}catch(l){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const f of n)await this.J.deleteCollection(f,this.F)}throw l}for(const l of r?.removed||[])await this.J.deleteCollection(l.collection,this.F)}p?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(d,p){return this.mb(this.Eb(d),p)}async hasLocalData(){return this.Db().length>0}async resolveContent(d){if(this.h.isEqual(this.remoteResource,d)||this.h.isEqual(this.baseResource,d)||this.h.isEqual(this.localResource,d)||this.h.isEqual(this.acceptedResource,d)){const p=await this.db(d);return p&&(0,R.$9n)(JSON.parse(p),{})}return null}Db(){return this.vb.profiles.filter(d=>!d.isDefault&&!d.isTransient)}Eb(d){return JSON.stringify([...d].sort((p,P)=>p.name.localeCompare(P.name)))}};e.$5dc=$,e.$5dc=$=ve([Y(2,w.$Ml),Y(3,k.$al),Y(4,N.$Ni),Y(5,T.$gq),Y(6,u.$tnb),Y(7,u.$unb),Y(8,u.$Inb),Y(9,c.$aj),Y(10,u.$Dnb),Y(11,O.$_l),Y(12,A.$Kl)],$);function h(v,d){const p=[...v].sort((P,g)=>P.name.localeCompare(g.name)).map(P=>({id:P.id,name:P.name}));return d?(0,R.$9n)(p,{}):JSON.stringify(p)}function b(v){return JSON.parse(v.content)}}),define(ce[265],le([0,1,3,2,5,16,17,18,25]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;const w="sync.enable";let S=class extends c.$Xc{constructor(u,$,h,b){super(),this.c=u,this.f=$,this.g=h,this.h=b,this.a=new R.$ne,this.onDidChangeEnablement=this.a.event,this.b=new R.$ne,this.onDidChangeResourceEnablement=this.b.event,this.B(u.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new c.$Wc))(v=>this.m(v)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:u}),this.c.store(w,u,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(u){return this.c.getBoolean((0,A.$Cnb)(u),T.StorageScope.APPLICATION,!0)}setResourceEnablement(u,$){if(this.isResourceEnabled(u)!==$){const h=(0,A.$Cnb)(u);this.j(h,$)}}getResourceSyncStateVersion(u){}j(u,$){this.c.store(u,$,T.StorageScope.APPLICATION,N.$o?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(u){if(w===u.key){this.a.fire(this.isEnabled());return}const $=A.$pnb.filter(h=>(0,A.$Cnb)(h)===u.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$Rdc=S,e.$Rdc=S=ve([Y(0,T.$gq),Y(1,O.$_l),Y(2,k.$Ni),Y(3,A.$snb)],S)}),define(ce[266],le([0,1,6,15,68,2,21,22,16,7,20,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let u=class extends k.$Xc{constructor(h,b,v,d,p){super(),this.a=h,this.b=b,this.c=v,this.f=d,this.g=p,this.h()}async h(){for(const b of this.g.profiles)for(const v of m.$pnb)try{await this.m(this.j(v,b.isDefault?void 0:b.id))}catch(d){this.f.error(d)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,w.$rl)(b)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(b);return}if(h.children){for(const b of h.children)if(b.isDirectory&&!this.g.profiles.some(v=>v.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(v){this.f.error(v)}}}async getAllResourceRefs(h,b,v){const d=this.j(h,b,v);try{const p=await this.b.resolve(d);if(p.children)return p.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(p){if((0,w.$rl)(p)!==w.FileOperationResult.FILE_NOT_FOUND)throw p}return[]}async resolveResourceContent(h,b,v,d){const p=this.j(h,v,d),P=(0,T.$hh)(p,b);try{return(await this.b.readFile(P)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(h,b,v,d,p){const P=this.j(h,d,p),g=(0,T.$hh)(P,`${(0,N.$4m)(v).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,c.$Pe.fromString(b))}catch(s){this.f.error(s)}}j(h,b,v=this.a.userDataSyncHome){return(0,T.$hh)(v,...b?[b,h]:[h])}async m(h){try{try{if(!await this.b.exists(h))return}catch{return}const b=await this.b.resolve(h);if(b.children){const v=b.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),d=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let p=v.filter(g=>Date.now()-this.n(g)>d);const P=v.length-p.length;P<10&&(p=p.slice(10-P)),await R.Promises.settled(p.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(b){this.f.error(b)}}n(h){return new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};e.$3dc=u,e.$3dc=u=ve([Y(0,A.$Ni),Y(1,w.$al),Y(2,O.$aj),Y(3,m.$Inb),Y(4,S.$Ml)],u)}),define(ce[87],le([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$inb=e.$gnb=void 0,e.$hnb=s,e.$gnb=(0,w.$Gi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",v="Safari",d="Chrome",p="Edge",P="Firefox",g="Android";function s(a){switch(a){case v:case d:case p:case P:case g:case(0,N.$h)(N.Platform.Web):return!0}return!1}function r(){return N.$G?v:N.$E?d:N.$H?p:N.$F?P:N.$I?g:(0,N.$h)(N.$o?N.Platform.Web:N.$u)}let t=class extends c.$Xc{static{h=this}static{this.a=1}static{this.b="machines"}constructor(i,n,o,l,f,I){super(),this.h=o,this.j=l,this.m=f,this.n=I,this.c=this.B(new R.$ne),this.onDidChange=this.c.event,this.g=null,this.f=(0,m.$mq)(i,n,o)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(l=>({...l,isCurrent:l.id===n}))}async addCurrentMachine(i){const n=await this.f,o=await this.s(i);o.machines.some(({id:l})=>l===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:r()}),await this.t(o))}async removeCurrentMachine(i){const n=await this.f,o=await this.s(i),l=o.machines.filter(({id:f})=>f!==n);l.length!==o.machines.length&&(o.machines=l,await this.t(o))}async renameMachine(i,n,o){const l=await this.s(o),f=l.machines.find(({id:I})=>I===i);if(f){f.name=n,await this.t(l);const I=await this.f;i===I&&this.h.store(b,n,u.StorageScope.APPLICATION,u.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[o,l]of i){const f=n.machines.find(I=>I.id===o);f&&(f.disabled=l?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(b,u.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${r()} (${this.n.nameShort})`,l=new RegExp(`${(0,k.$jf)(o)}\\s#(\\d+)`);let f=0;for(const I of i){const L=l.exec(I.name),E=L?parseInt(L[1]):0;f=E>f?E:f}return`${o} #${f+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==h.a)throw new Error((0,T.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),o=await this.j.writeResource(h.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[h.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(h.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:h.a,machines:[]}}};e.$inb=t,e.$inb=t=h=ve([Y(0,O.$Ni),Y(1,A.$al),Y(2,u.$gq),Y(3,$.$tnb),Y(4,$.$Inb),Y(5,S.$tk)],t)}),define(ce[267],le([0,1,6,68,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;const p="sync.disableMachineEventually",P="sync.sessionId",g="sync.storeUrl",s="sync.productQuality";let r=class extends O.$Xc{get n(){const i=this.H.get(g,$.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(g,i.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(g,$.StorageScope.APPLICATION)}get s(){return this.H.get(s,$.StorageScope.APPLICATION)}set s(i){i?this.H.store(s,i,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(s,$.StorageScope.APPLICATION)}constructor(i,n,o,l,f,I,L,E,y,C){super(),this.u=n,this.w=o,this.y=l,this.z=f,this.C=I,this.D=L,this.F=E,this.G=y,this.H=C,this.a=this.B(new O.$Yc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$ne),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$Eh(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,w.$ah)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(f.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new t(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$4m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,$.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(l){if(this.C.error(l),n)this.M(!1);else throw l}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=b.$ynb.toUserDataSyncError(i);n instanceof b.$Anb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===b.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===b.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===b.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===b.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===b.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===b.UserDataSyncErrorCode.UpgradeRequired||n.code===b.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===b.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===b.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===b.UserDataSyncErrorCode.ServiceChanged||n.code===b.UserDataSyncErrorCode.DefaultServiceChanged?A.$o&&n.code===b.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(p,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,R.$Hh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(p,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(p,$.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const l=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:l}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$9dc=r,e.$9dc=r=ve([Y(0,u.$tk),Y(1,b.$snb),Y(2,b.$tnb),Y(3,b.$Dnb),Y(4,b.$Enb),Y(5,b.$Inb),Y(6,v.$iMb),Y(7,h.$_l),Y(8,d.$gnb),Y(9,$.$gq)],r);class t extends O.$Xc{static{this.a="Interval"}constructor(i,n,o,l,f,I,L,E,y){super(),this.m=i,this.n=n,this.r=o,this.s=l,this.u=f,this.w=I,this.y=L,this.z=E,this.C=y,this.b=this.B(new O.$Yc),this.c=this.B(new T.$ne),this.onDidStartSync=this.c.event,this.f=this.B(new T.$ne),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Vc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(t.a,!1)}D(){this.b.value=(0,R.$Ih)(()=>{this.sync(t.a,!1),this.b.value=void 0},this.n)}sync(i,n){const o=(0,R.$th)(async l=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(f){if((0,k.$7)(f))return}return this.H(i,n,l)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,w.$ah)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,w.$ah)(n.defaultUrl,i.defaultUrl)||!(0,w.$ah)(n.insidersUrl,i.insidersUrl)||!(0,w.$ah)(n.stableUrl,i.stableUrl))}async H(i,n,o){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let l;try{await this.I(n,o)}catch(f){if(this.y.error(f),l=f,b.$ynb.toUserDataSyncError(f).code===b.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),l=void 0}catch(I){this.y.error(I),l=I}}this.f.fire(l)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Anb((0,m.localize)(0,null),b.UserDataSyncErrorCode.DefaultServiceChanged):new b.$Anb((0,m.localize)(1,null),b.UserDataSyncErrorCode.ServiceChanged):new b.$Anb((0,m.localize)(2,null),b.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(P,$.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new b.$Anb((0,m.localize)(3,null),b.UserDataSyncErrorCode.DefaultServiceChanged):new b.$Anb((0,m.localize)(4,null),b.UserDataSyncErrorCode.ServiceChanged):new b.$Anb((0,m.localize)(5,null),b.UserDataSyncErrorCode.SessionExpired);const l=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const f=l.find(L=>L.isCurrent);if(f?.disabled)throw new b.$Anb((0,m.localize)(6,null),b.UserDataSyncErrorCode.TurnedOff);const I=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-I}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new b.$Anb((0,N.$rj)(L),L instanceof b.$ynb?L.code:b.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(P,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(f||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ce[268],le([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;let a=class{static{t=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,l,f,I,L,E,y,C,F){this.e=n,this.f=o,this.g=l,this.h=I,this.i=L,this.j=E,this.k=y,this.l=C,this.n=F,this.d=f.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(w.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,w.SyncResource.Profiles);return(0,g.$7dc)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(w.SyncResource.Profiles,void 0,n);if(o.length){const l=await this.f.resolveResourceContent(w.SyncResource.Profiles,o[0].ref,void 0,n);if(l){const f=this.L(l,w.SyncResource.Profiles);return(0,g.$7dc)(f)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const l=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(l)return JSON.parse(l).machines.map(I=>({...I,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:f,ref:I})=>({created:f,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:I,node:void 0})}))}async getLocalSyncResourceHandles(n,o,l){return(await this.f.getAllResourceRefs(n,o?.collection,l)).map(({created:I,ref:L})=>({created:I,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:L,node:void 0,location:l})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),l=o?this.k.profiles.find(f=>f.id===o.profile):void 0;return o&&l?{profile:l,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const l=this.k.profiles.find(f=>f.id===o.profile);switch(o.syncResource){case w.SyncResource.Settings:return this.s(n,l);case w.SyncResource.Keybindings:return this.u(n,l);case w.SyncResource.Tasks:return this.w(n,l);case w.SyncResource.Snippets:return this.y(n,l);case w.SyncResource.GlobalState:return this.D(n,l);case w.SyncResource.Extensions:return this.A(n,l);case w.SyncResource.Profiles:return this.G(n,l);case w.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:l}=await this.M(o.syncResource,o.ref,o.collection);if(l)return this.L(l,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const l=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(l)return this.L(l,o.syncResource)?.machineId}return}return(0,T.$mq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===t.a)return null;if(o.ref){const l=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&l?this.q(o.syncResource,l,o.node):l}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,l,f,I){if(n){const{content:L}=await this.M(o,f,l);return L}return this.f.resolveResourceContent(o,f,l,I)}q(n,o,l){const f=this.L(o,n);switch(n){case w.SyncResource.Settings:return this.t(f,l);case w.SyncResource.Keybindings:return this.v(f,l);case w.SyncResource.Tasks:return this.x(f,l);case w.SyncResource.Snippets:return this.z(f,l);case w.SyncResource.GlobalState:return this.E(f,l);case w.SyncResource.Extensions:return this.B(f,l);case w.SyncResource.Profiles:return this.H(f,l);case w.SyncResource.WorkspaceState:return null}}async r(n,o){const l=this.k.profiles.find(f=>f.id===o);if(!l)return null;switch(n){case w.SyncResource.GlobalState:return this.F(l);case w.SyncResource.Extensions:return this.C(l);case w.SyncResource.Profiles:return this.I(l);case w.SyncResource.Settings:return null;case w.SyncResource.Keybindings:return null;case w.SyncResource.Tasks:return null;case w.SyncResource.Snippets:return null;case w.SyncResource.WorkspaceState:return null}}s(n,o){const l=this.d.joinPath(n,"settings.json"),f=o?o.settingsResource:this.d.joinPath(n,t.a);return[{resource:l,comparableResource:f}]}t(n,o){switch(o){case"settings.json":return(0,$.$bcc)(n.content).settings}return null}u(n,o){const l=this.d.joinPath(n,"keybindings.json"),f=o?o.keybindingsResource:this.d.joinPath(n,t.a);return[{resource:l,comparableResource:f}]}v(n,o){switch(o){case"keybindings.json":return(0,h.$$bc)(n.content,!!this.l.getValue(w.$mnb),this.g)}return null}w(n,o){const l=this.d.joinPath(n,"tasks.json"),f=o?o.tasksResource:this.d.joinPath(n,t.a);return[{resource:l,comparableResource:f}]}x(n,o){switch(o){case"tasks.json":return(0,v.$jcc)(n.content,this.g)}return null}async y(n,o){const l=await this.resolveContent(n);if(l){const f=this.L(l,w.SyncResource.Snippets);if(f){const I=(0,u.$gcc)(f),L=[];for(const E of Object.keys(I)){const y=this.d.joinPath(n,E),C=o?this.d.joinPath(o.snippetsHome,E):this.d.joinPath(n,t.a);L.push({resource:y,comparableResource:C})}return L}}return[]}z(n,o){return(0,u.$gcc)(n)[o]||null}A(n,o){const l=this.d.joinPath(n,"extensions.json"),f=o?this.J({remote:!1,syncResource:w.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:l,comparableResource:f}]}B(n,o){switch(o){case"extensions.json":return(0,d.$6bc)((0,d.$5bc)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(d.$8bc).getLocalExtensions(n);return(0,d.$6bc)(o,!0)}D(n,o){const l=this.d.joinPath(n,"globalState.json"),f=o?this.J({remote:!1,syncResource:w.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:l,comparableResource:f}]}E(n,o){switch(o){case"globalState.json":return(0,p.$6Nb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(p.$8Nb).getLocalGlobalState(n);return(0,p.$6Nb)(o,!0)}G(n,o){const l=this.d.joinPath(n,"profiles.json"),f=this.J({remote:!1,syncResource:w.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:l,comparableResource:f}]}H(n,o){switch(o){case"profiles.json":return(0,s.$9n)(JSON.parse(n.content),{})}return null}async I(n){return(0,g.$6dc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?t.b:t.c,l=[];return n.location&&(l.push(`scheme:${n.location.scheme}`),l.push(`authority:${n.location.authority}`),l.push((0,r.$nf)(n.location.path,"/"))),l.push(`syncResource:${n.syncResource}`),l.push(`profile:${n.profile}`),n.collection&&l.push(`collection:${n.collection}`),n.ref&&l.push(`ref:${n.ref}`),n.node&&l.push(n.node),this.d.joinPath(R.URI.from({scheme:w.$Knb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...l)}K(n){if(n.scheme!==w.$Knb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const l=n.authority===t.b;let f,I;const L=[];let E,y,C,F,D;for(;o.length;){const M=o.shift();M.startsWith("scheme:")?f=M.substring(7):M.startsWith("authority:")?I=M.substring(10):M.startsWith("syncResource:")?E=M.substring(13):M.startsWith("profile:")?y=M.substring(8):M.startsWith("collection:")?C=M.substring(11):M.startsWith("ref:")?F=M.substring(4):E?D=M:L.push(M)}return{remote:l,syncResource:E,profile:y,collection:C,ref:F,node:D,location:f&&I!==void 0?this.d.joinPath(R.URI.from({scheme:f,authority:I,query:n.query,fragment:n.fragment,path:"/"}),...L):void 0}}L(n,o){try{const l=JSON.parse(n);if((0,m.$YNb)(l))return l}catch(l){this.g.error(l)}throw new w.$ynb((0,c.localize)(0,null),w.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,l){const f=await this.e.resolveResourceContent(n,o,l);return{ref:o,content:f}}};e.$Lec=a,e.$Lec=a=t=ve([Y(0,w.$tnb),Y(1,w.$unb),Y(2,w.$Inb),Y(3,A.$Kl),Y(4,N.$Ni),Y(5,O.$gq),Y(6,k.$al),Y(7,S.$Ml),Y(8,b.$aj),Y(9,P.$Fi)],a)}),define(ce[269],le([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;const n="sync.lastSyncTime";let o=class extends O.$Xc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,y,C,F,D,M,K,W,_,H,ie){super(),this.C=E,this.D=y,this.F=C,this.G=F,this.H=D,this.I=M,this.J=K,this.L=W,this.M=_,this.N=H,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new T.$ne),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$ne),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$ne),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$ne),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$ne),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$ne),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$ne),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=C.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,b.StorageScope.APPLICATION,void 0),this.B((0,O.$Vc)(()=>this.cb())),this.B(new c.$Sh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(E,y){this.db(),this.H.info("Sync started.");const C=new Date().getTime(),F=(0,S.$3g)();try{const W=(0,i.$xnb)(F);y&&(W["Cache-Control"]="no-cache"),E=await this.D.manifest(E,W)}catch(W){const _=i.$ynb.toUserDataSyncError(W);throw I(_,F,this.F,this.I),_}const D=!1,M=this;let K;return{manifest:E,async run(){if(D)throw new Error("Can run a task only once");K=(0,c.$th)(W=>M.P(E,!1,F,W)),await K.finally(()=>K=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-C}ms`),M.ab()},stop(){return K?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$ynb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const E=new Date().getTime(),y=(0,S.$3g)(),C=(0,i.$xnb)(y);let F;try{F=await this.D.manifest(null,C)}catch(K){const W=i.$ynb.toUserDataSyncError(K);throw I(W,y,this.F,this.I),W}await this.resetLocal();const D=this,M=new N.$ye;return{id:y,async merge(){return D.P(F,!0,y,M.token)},async apply(){try{try{await D.R(F,y,M.token)}catch(K){if(i.$ynb.toUserDataSyncError(K).code===i.UserDataSyncErrorCode.MethodNotFound)D.H.info("Client is making invalid requests. Cleaning up data..."),await D.cleanUpRemoteData(),D.H.info("Applying manual sync again..."),await D.R(F,y,M.token);else throw K}}catch(K){throw D.H.error(K),K}D.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),D.ab()},async stop(){M.cancel(),await D.U(),await D.resetLocal()}}}async P(E,y,C,F){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const D=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(D,E,y,C,F));const M=D.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(M){const K=await M.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(K,E,y,C,F)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(E,y,C,F,D){for(const M of E){if(D.isCancellationRequested)return;const K=this.M.profiles.find(_=>_.id===M.id);if(!K){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const W=this.getOrCreateActiveProfileSynchronizer(K,M);this.n.push(...await this.S(W,y,C,F,D))}for(const[M,K]of this.z.entries())this.M.profiles.some(W=>W.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.z.delete(M))}async R(E,y,C){const F=this.bb();for(const _ of F){if(C.isCancellationRequested)return;await _.apply(y,C)}const D=F.find(_=>_.profile.isDefault);if(!D)return;const M=D.enabled.find(_=>_.resource===i.SyncResource.Profiles);if(!M)return;const W=(await M.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(_=>F.every(H=>H.profile.id!==_.id));W.length&&await this.Q(W,E,!1,y,C)}async S(E,y,C,F,D){return(await E.sync(y,C,F,D)).map(([K,W])=>({profile:E.profile,syncResource:K,error:W}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(E=>E.stop()))}async resolveContent(E){const y=await this.N.resolveContent(E);if(y)return y;for(const C of this.bb())for(const F of C.enabled){const D=await F.resolveContent(E);if(D)return D}return null}async replace(E){this.db();const y=this.N.resolveUserDataSyncResource(E);if(!y)return;const C=await this.resolveContent(E.uri);C&&await this.X(y.profile,async F=>{if(y.syncResource===F.resource)return await F.replace(C),!0})}async accept(E,y,C,F){this.db(),await this.X(E.profile,async D=>{if(E.syncResource===D.resource)return await D.accept(y,C),F&&await D.apply((0,w.$mg)(F)?!1:F.force,(0,i.$xnb)((0,S.$3g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async y=>{if(y.resource!==i.SyncResource.GlobalState&&await y.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async y=>{if(await y.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,b.StorageScope.APPLICATION);for(const[E]of this.z.values())try{await E.resetLocal()}catch(y){this.H.error(y)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const E=this.J.keys(b.StorageScope.APPLICATION,b.StorageTarget.MACHINE),y=[];for(const F of E){if(!F.endsWith(".lastSyncUserData"))continue;const D=F.split(".");D.length===3&&y.push([F,D[0]])}if(!y.length)return;const C=new O.$Wc;try{let F=this.z.get(this.M.defaultProfile.id)?.[0];F||(F=C.add(this.G.createInstance(l,this.M.defaultProfile,void 0)));const D=F.enabled.find(W=>W.resource===i.SyncResource.Profiles);if(!D)return;const K=(await D.getLastSyncedProfiles())?.map(W=>W.collection)??[];for(const[W,_]of y)K.includes(_)||(this.H.info(`Removing last sync state for stale profile: ${_}`),this.J.remove(W,b.StorageScope.APPLICATION))}finally{C.dispose()}}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),y=E.map(M=>M.collection),C=await this.D.getAllCollections(),F=C.filter(M=>!y.includes(M));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const D=E.filter(M=>C.includes(M.collection));if(D.length!==E.length){const M=this.G.createInstance(a.$5dc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(D,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(E){this.db();const y=await this.D.getActivityData();await this.C.writeFile(E,y)}async extractActivityData(E,y){const C=(await this.C.readFile(E)).value.toString(),F=JSON.parse(C);if(F.resources)for(const D in F.resources)for(const M of F.resources[D])await this.O.writeResource(D,M.content,new Date(M.created*1e3),void 0,y);if(F.collections)for(const D in F.collections)for(const M in F.collections[D].resources)for(const K of F.collections[D].resources?.[M]??[])await this.O.writeResource(M,K.content,new Date(K.created*1e3),D,y)}async X(E,y){const C=new O.$Wc;try{const F=this.z.get(E.id);if(F){const _=await this.Y(F[0],y,C);return(0,w.$ng)(_)?null:_}if(E.isDefault){const _=C.add(this.G.createInstance(l,E,void 0)),H=await this.Y(_,y,C);return(0,w.$ng)(H)?null:H}if(this.M.isEnabled())return null;const D=C.add(this.G.createInstance(a.$5dc,E,void 0)),M=await this.D.manifest(null),W=(await D.getRemoteSyncedProfiles(M?.latest??null)||[]).find(_=>_.id===E.id);if(W){const _=C.add(this.G.createInstance(l,E,W.collection)),H=await this.Y(_,y,C);return(0,w.$ng)(H)?null:H}return null}finally{C.dispose()}}async Y(E,y,C){const F=[...E.enabled,...E.disabled.reduce((D,M)=>(M!==i.SyncResource.WorkspaceState&&D.push(C.add(E.createSynchronizer(M))),D),[])];for(const D of F){const M=await y(D);if(!(0,w.$ng)(M))return M}}Z(E){const y=this.f;this.f!==E&&(this.f=E,this.g.fire(E),y===i.SyncStatus.HasConflicts&&this.ab())}$(){const E=this.bb().map(y=>y.conflicts).flat();(0,R.$xb)(this.j,E,(y,C)=>y.profile.id===C.profile.id&&y.syncResource===C.syncResource&&(0,R.$xb)(y.conflicts,C.conflicts,(F,D)=>(0,A.$ah)(F.previewResource,D.previewResource)))||(this.j=E,this.m.fire(E))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,y){let C=this.z.get(E.id);if(C&&C[0].collection!==y?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),C[1].dispose(),C=void 0,this.z.delete(E.id)),!C){const F=new O.$Wc,D=F.add(this.G.createInstance(l,E,y?.collection));F.add(D.onDidChangeStatus(M=>this.Z(M))),F.add(D.onDidChangeConflicts(M=>this.$())),F.add(D.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(E.id,C=[D,F])}return C[0]}bb(){const E=[];for(const[y]of this.z.values())E.push(y);return E}cb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$8dc=o,e.$8dc=o=ve([Y(0,$.$al),Y(1,i.$tnb),Y(2,i.$snb),Y(3,h.$Fi),Y(4,i.$Inb),Y(5,v.$_l),Y(6,b.$gq),Y(7,i.$Dnb),Y(8,d.$Ml),Y(9,i.$Fnb),Y(10,i.$unb)],o);let l=class extends O.$Xc{get enabled(){return this.f.sort((E,y)=>E[1]-y[1]).map(([E])=>E)}get disabled(){return i.$pnb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,y,C,F,D,M,K,W,_,H){super(),this.profile=E,this.collection=y,this.r=C,this.t=F,this.u=D,this.w=M,this.y=K,this.z=W,this.C=_,this.D=H,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new T.$ne),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$ne),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$ne),this.onDidChangeConflicts=this.n.event,this.B(C.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,O.$Vc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$pnb)C.isResourceEnabled(ie)&&this.G(ie)}F(E,y){y?this.G(E):this.H(E)}G(E){if(this.f.some(([D])=>D.resource===E))return;if(E===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||E===i.SyncResource.WorkspaceState)return;if(E!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const y=new O.$Wc,C=y.add(this.createSynchronizer(E));y.add(C.onDidChangeStatus(()=>this.L())),y.add(C.onDidChangeConflicts(()=>this.M())),y.add(C.onDidChangeLocal(()=>this.j.fire(E)));const F=this.N(E);this.f.push([C,F,y])}H(E){const y=this.f.findIndex(([C])=>C.resource===E);if(y!==-1){const[[C,,F]]=this.f.splice(y,1);F.dispose(),this.L(),Promise.allSettled([C.stop(),C.resetLocal()]).then(null,D=>this.z.error(D))}}createSynchronizer(E){switch(E){case i.SyncResource.Settings:return this.t.createInstance(s.$ccc,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(g.$_bc,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(r.$hcc,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(t.$kcc,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(P.$7Nb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(p.$7bc,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(a.$5dc,this.profile,this.collection)}}async sync(E,y,C,F){if(F.isCancellationRequested)return[];const D=this.enabled;if(!D.length)return[];try{const M=[],K=(0,i.$xnb)(C),W=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,_=y?await this.I(W):{};for(const H of D){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(y){const ie=await H.preview(W,_,K);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==i.Change.None||V.remoteChange!==i.Change.None)&&V.mergeState===i.MergeState.Preview&&await H.merge(V.previewResource)}else await H.sync(W,K)}catch(ie){const V=i.$ynb.toUserDataSyncError(ie);if(I(V,C,this.w,this.y),f(ie))throw V;this.z.error(ie),this.z.error(`${H.resource}: ${(0,k.$rj)(ie)}`),M.push([H.resource,V])}}return M}finally{this.L()}}async apply(E,y){const C=(0,i.$xnb)(E);for(const F of this.enabled){if(y.isCancellationRequested)return;try{await F.apply(!1,C)}catch(D){const M=i.$ynb.toUserDataSyncError(D);if(I(M,E,this.w,this.y),f(D))throw M;this.z.error(D),this.z.error(`${F.resource}: ${(0,k.$rj)(D)}`)}}}async stop(){for(const E of this.enabled)try{E.status!==i.SyncStatus.Idle&&await E.stop()}catch(y){this.z.error(y)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(y){this.z.error(`${E.resource}: ${(0,k.$rj)(y)}`),this.z.error(y)}}async I(E){if(!this.profile.isDefault)return{};const y=this.D.getValue(i.$lnb),C=this.enabled.find(F=>F instanceof s.$ccc);if(C){const F=await C.getRemoteUserDataSyncConfiguration(E);return{...y,...F}}return y}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(E=>E.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const E=this.enabled.filter(y=>y.status===i.SyncStatus.HasConflicts).filter(y=>y.conflicts.conflicts.length>0).map(y=>y.conflicts);(0,R.$xb)(this.m,E,(y,C)=>y.syncResource===C.syncResource&&(0,R.$xb)(y.conflicts,C.conflicts,(F,D)=>(0,A.$ah)(F.previewResource,D.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};l=ve([Y(2,i.$Dnb),Y(3,h.$Fi),Y(4,u.$jp),Y(5,i.$snb),Y(6,v.$_l),Y(7,i.$Inb),Y(8,d.$Ml),Y(9,m.$aj)],l);function f(L){if(L instanceof i.$ynb)switch(L.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function I(L,E,y,C){C.publicLog2("sync/error",{code:L.code,serverCode:L instanceof i.$znb?String(L.serverCode):void 0,url:L instanceof i.$znb?L.url:void 0,resource:L.resource,executionId:E,service:y.userDataSyncStore.url.toString()})}}),define(ce[270],le([0,1,3,2,9,20,25]),function(ne,e,R,c,N,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=e.$rhc=void 0;function O(u,$){return{...u,profile:(0,k.$Nl)(u.profile,$.profilesHome.scheme)}}function A(u){return{created:u.created,uri:N.URI.revive(u.uri)}}class w{constructor($,h,b){this.c=$,this.d=h,this.f=b,this.a=new Map,this.b=new R.$ne}listen($,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${h}`)}async call($,h,b){try{return await this.g($,h,b)}catch(v){throw this.f.error(v),v}}async g($,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(b[0]));case"accept":return this.c.accept(O(b[0],this.d),N.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(A(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(b[0]),N.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const v=h.substring(11),d=b[0],p=this.h(d);switch(b=b.slice(1),v){case"merge":return p.merge();case"apply":return p.apply().then(()=>this.a.delete(this.j(p.id)));case"stop":return p.stop().finally(()=>this.a.delete(this.j(p.id)))}}throw new Error("Invalid call")}h($){const h=this.a.get(this.j($));if(!h)throw new Error(`Manual sync taks not found: ${$}`);return h}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$rhc=w;let S=class extends c.$Xc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,h){super(),this.n=h,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new R.$ne),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$ne),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$ne),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$ne),this.onSyncErrors=this.m.event,this.a={call(b,v,d){return $.call(b,v,d).then(null,p=>{throw T.$ynb.toUserDataSyncError(p)})},listen(b,v){return $.listen(b,v)}},this.a.call("_getInitialData").then(([b,v,d])=>{this.s(b),this.t(v),d&&this.u(d),this.B(this.a.listen("onDidChangeStatus")(p=>this.s(p))),this.B(this.a.listen("onDidChangeLastSyncTime")(p=>this.u(p)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(v=>({...v,error:T.$ynb.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),h=this;return new m($,{async call(v,d,p){return h.a.call(`manualSync/${v}`,[$,...Array.isArray(d)?d:[d]],p)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,h,b,v){return this.a.call("accept",[$,h,b,v])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,h){return this.a.call("extractActivityData",[$,h])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(h=>({syncResource:h.syncResource,profile:(0,k.$Nl)(h.profile,this.n.profilesHome.scheme),conflicts:h.conflicts.map(b=>({...b,baseResource:N.URI.revive(b.baseResource),localResource:N.URI.revive(b.localResource),remoteResource:N.URI.revive(b.remoteResource),previewResource:N.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$shc=S,e.$shc=S=ve([Y(1,k.$Ml)],S);class m extends c.$Xc{constructor($,h){super(),this.id=$,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ce[127],le([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,62,50,17,25]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WNb=e.$VNb=e.$UNb=e.$TNb=e.$SNb=void 0;const s="configurationSync.store",r="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends T.$Xc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$Bnb,P.StorageScope.APPLICATION)}set c(C){this.h.store(g.$Bnb,C,P.StorageScope.APPLICATION,A.$o?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(C,F,D){super(),this.f=C,this.g=F,this.h=D,this.a=this.B(new k.$ne),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new T.$Wc);this.B(k.Event.filter(D.onDidChangeValue(P.StorageScope.APPLICATION,g.$Bnb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[s]),this.a.fire()}m(C){if(C&&(C=A.$o&&C.web?{...C,...C.web}:C,(0,S.$gg)(C.url)&&(0,S.$ig)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(F=>Array.isArray(C.authenticationProviders[F].scopes)))){const F=C,D=!!F.canSwitch,M=F.url===F.insidersUrl?"insiders":"stable",K=(D?this.c:void 0)||M,W=K==="insiders"?F.insidersUrl:K==="stable"?F.stableUrl:F.url;return{url:m.URI.parse(W),type:K,defaultType:M,defaultUrl:m.URI.parse(F.url),stableUrl:m.URI.parse(F.stableUrl),insidersUrl:m.URI.parse(F.insidersUrl),canSwitch:D,authenticationProviders:Object.keys(F.authenticationProviders).reduce((_,H)=>(_.push({id:H,scopes:F.authenticationProviders[H].scopes}),_),[])}}}};e.$SNb=l,e.$SNb=l=ve([Y(0,v.$tk),Y(1,$.$aj),Y(2,P.$gq)],l);let f=class extends l{constructor(C,F,D){super(C,F,D);const M=this.h.get(r,P.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const K=this.f[s];K?this.h.store(r,JSON.stringify(K),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(r,P.StorageScope.APPLICATION)}async switch(C){C!==this.c&&(this.c=C,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$TNb=f,e.$TNb=f=ve([Y(0,v.$tk),Y(1,$.$aj),Y(2,P.$gq)],f);let I=class extends T.$Xc{get donotMakeRequestsUntil(){return this.j}constructor(C,F,D,M,K,W,_){super(),this.n=D,this.r=M,this.s=_,this.g=this.B(new k.$ne),this.onTokenFailed=this.g.event,this.h=this.B(new k.$ne),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new k.$ne),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(C),this.c=(0,p.$mq)(K,W,_).then(H=>{const ie={"X-Client-Name":`${F.applicationName}${A.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new E(n,o,this.n,this.r),this.u(),this.B((0,T.$Vc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(C,F){this.b={token:C,type:F}}t(C){this.a=C?(0,w.$hh)(C,"v1"):void 0}u(){const C=this.s.getNumber(t,P.StorageScope.APPLICATION);C&&Date.now()<C&&this.y(new Date(C))}y(C){this.j?.getTime()!==C?.getTime()&&(this.j=C,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(t,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,R.$th)(F=>(0,R.$Hh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(t,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$hh)(this.a,"collection").toString();C={...C},C["Content-Type"]="application/json";const D=await this.D(F,{type:"GET",headers:C},[],c.CancellationToken.None);return(await(0,d.$_p)(D))?.map(({id:M})=>M)||[]}async createCollection(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$hh)(this.a,"collection").toString();C={...C},C["Content-Type"]=O.$9s.text;const D=await this.D(F,{type:"POST",headers:C},[],c.CancellationToken.None),M=await(0,d.$$p)(D);if(!M)throw new g.$znb("Server did not return the collection id",F,g.UserDataSyncErrorCode.NoCollection,D.res.statusCode,D.res.headers[g.$vnb]);return M}async deleteCollection(C,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=C?(0,w.$hh)(this.a,"collection",C).toString():(0,w.$hh)(this.a,"collection").toString();F={...F},await this.D(D,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async getAllResourceRefs(C,F){if(!this.a)throw new Error("No settings sync store url configured.");const D=this.z(this.a,F,C),M={},K=await this.D(D.toString(),{type:"GET",headers:M},[],c.CancellationToken.None);return(await(0,d.$_p)(K)||[]).map(({url:_,created:H})=>({ref:(0,w.$jh)(D,D.with({path:_})),created:H*1e3}))}async resolveResourceContent(C,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,w.$hh)(this.z(this.a,D,C),F).toString();M={...M},M["Cache-Control"]="no-cache";const W=await this.D(K,{type:"GET",headers:M},[],c.CancellationToken.None);return await(0,d.$$p)(W)}async deleteResource(C,F,D){if(!this.a)throw new Error("No settings sync store url configured.");const M=F!==null?(0,w.$hh)(this.z(this.a,D,C),F).toString():this.z(this.a,D,C).toString(),K={};await this.D(M,{type:"DELETE",headers:K},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,w.$hh)(this.a,"resource").toString(),F={"Content-Type":O.$9s.text};await this.D(C,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async readResource(C,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,w.$hh)(this.z(this.a,D,C),"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const W=await this.D(K,{type:"GET",headers:M},[304],c.CancellationToken.None);let _=null;if(W.res.statusCode===304&&(_=F),_===null){const H=W.res.headers.etag;if(!H)throw new g.$znb("Server did not return the ref",K,g.UserDataSyncErrorCode.NoRef,W.res.statusCode,W.res.headers[g.$vnb]);const ie=await(0,d.$$p)(W);if(!ie&&W.res.statusCode===304)throw new g.$znb("Empty response",K,g.UserDataSyncErrorCode.EmptyResponse,W.res.statusCode,W.res.headers[g.$vnb]);_={ref:H,content:ie}}return _}async writeResource(C,F,D,M,K={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.z(this.a,M,C).toString();K={...K},K["Content-Type"]=O.$9s.text,D&&(K["If-Match"]=D);const _=await this.D(W,{type:"POST",data:F,headers:K},[],c.CancellationToken.None),H=_.res.headers.etag;if(!H)throw new g.$znb("Server did not return the ref",W,g.UserDataSyncErrorCode.NoRef,_.res.statusCode,_.res.headers[g.$vnb]);return H}async manifest(C,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,w.$hh)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",C&&(F["If-None-Match"]=C.ref);const M=await this.D(D,{type:"GET",headers:F},[304],c.CancellationToken.None);let K=null;if(M.res.statusCode===304&&(K=C),!K){const _=M.res.headers.etag;if(!_)throw new g.$znb("Server did not return the ref",D,g.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[g.$vnb]);const H=await(0,d.$$p)(M);if(!H&&M.res.statusCode===304)throw new g.$znb("Empty response",D,g.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[g.$vnb]);H&&(K={...JSON.parse(H),ref:_})}const W=this.s.get(a,P.StorageScope.APPLICATION);return W&&K&&W!==K.session&&this.C(),K===null&&W&&this.C(),K&&this.s.store(a,K.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),K}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,w.$hh)(this.a,"download").toString(),F={},D=await this.D(C,{type:"GET",headers:F},[],c.CancellationToken.None);if(!(0,d.$8p)(D))throw new g.$znb("Server returned "+D.res.statusCode,C,g.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[g.$vnb]);if((0,d.$9p)(D))throw new g.$znb("Empty response",C,g.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[g.$vnb]);return D.stream}z(C,F,D){return F?(0,w.$hh)(C,"collection",F,"resource",D):(0,w.$hh)(C,"resource",D)}C(){this.s.remove(a,P.StorageScope.APPLICATION),this.s.remove(i,P.StorageScope.APPLICATION)}async D(C,F,D,M){if(!this.b)throw new g.$znb("No Auth Token Available",C,g.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$znb(`${F.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const K=await this.c;F.headers={...F.headers||{},...K,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:C,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(C,F,M)}catch(z){if(!(z instanceof g.$znb)){let te=g.UserDataSyncErrorCode.RequestFailed;const se=(0,N.$ab)(z).toLowerCase();se.includes("xhr timeout")?te=g.UserDataSyncErrorCode.RequestTimeout:se.includes("protocol")&&se.includes("not supported")?te=g.UserDataSyncErrorCode.RequestProtocolNotSupported:se.includes("request path contains unescaped characters")?te=g.UserDataSyncErrorCode.RequestPathNotEscaped:se.includes("headers must be an object")?te=g.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$7)(z)&&(te=g.UserDataSyncErrorCode.RequestCanceled),z=new g.$znb(`Connection refused for the request '${C}'.`,C,te,void 0,void 0)}throw this.r.info("Request failed",C),z}const _=W.res.headers[g.$vnb],H={url:C,status:W.res.statusCode,"execution-id":F.headers[g.$wnb],"operation-id":_},ie=(0,d.$8p)(W)||W.res.statusCode&&D.includes(W.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",H):(V=await(0,d.$0p)(W)||"",this.r.info("Request failed",H,V)),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire(g.UserDataSyncErrorCode.Unauthorized),new g.$znb(`${F.type} request '${C}' failed because of Unauthorized (401).`,C,g.UserDataSyncErrorCode.Unauthorized,W.res.statusCode,_);if(W.res.statusCode===403)throw this.g.fire(g.UserDataSyncErrorCode.Forbidden),new g.$znb(`${F.type} request '${C}' failed because the access is forbidden (403).`,C,g.UserDataSyncErrorCode.Forbidden,W.res.statusCode,_)}if(this.h.fire(),W.res.statusCode===404)throw new g.$znb(`${F.type} request '${C}' failed because the requested resource is not found (404).`,C,g.UserDataSyncErrorCode.NotFound,W.res.statusCode,_);if(W.res.statusCode===405)throw new g.$znb(`${F.type} request '${C}' failed because the requested endpoint is not found (405). ${V}`,C,g.UserDataSyncErrorCode.MethodNotFound,W.res.statusCode,_);if(W.res.statusCode===409)throw new g.$znb(`${F.type} request '${C}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,C,g.UserDataSyncErrorCode.Conflict,W.res.statusCode,_);if(W.res.statusCode===410)throw new g.$znb(`${F.type} request '${C}' failed because the requested resource is not longer available (410).`,C,g.UserDataSyncErrorCode.Gone,W.res.statusCode,_);if(W.res.statusCode===412)throw new g.$znb(`${F.type} request '${C}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,C,g.UserDataSyncErrorCode.PreconditionFailed,W.res.statusCode,_);if(W.res.statusCode===413)throw new g.$znb(`${F.type} request '${C}' failed because of too large payload (413).`,C,g.UserDataSyncErrorCode.TooLarge,W.res.statusCode,_);if(W.res.statusCode===426)throw new g.$znb(`${F.type} request '${C}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,C,g.UserDataSyncErrorCode.UpgradeRequired,W.res.statusCode,_);if(W.res.statusCode===429){const z=W.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new g.$znb(`${F.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W.res.statusCode,_)):new g.$znb(`${F.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequests,W.res.statusCode,_)}if(!ie)throw new g.$znb("Server returned "+W.res.statusCode,C,g.UserDataSyncErrorCode.Unknown,W.res.statusCode,_);return W}F(C){let F=this.s.get(i,P.StorageScope.APPLICATION);F===void 0&&(F=(0,u.$3g)(),this.s.store(i,F,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),C["X-Machine-Session-Id"]=F;const D=this.s.get(a,P.StorageScope.APPLICATION);D!==void 0&&(C["X-User-Session-Id"]=D)}};e.$UNb=I,e.$UNb=I=ve([Y(1,v.$tk),Y(2,d.$6p),Y(3,g.$Inb),Y(4,h.$Ni),Y(5,b.$al),Y(6,P.$gq)],I);let L=class extends I{constructor(C,F,D,M,K,W,_){super(C.userDataSyncStore?.url,F,D,M,K,W,_),this.B(C.onDidChangeUserDataSyncStore(()=>this.t(C.userDataSyncStore?.url)))}};e.$VNb=L,e.$VNb=L=ve([Y(0,g.$snb),Y(1,v.$tk),Y(2,d.$6p),Y(3,g.$Inb),Y(4,h.$Ni),Y(5,b.$al),Y(6,P.$gq)],L);class E{constructor(C,F,D,M){this.c=C,this.d=F,this.f=D,this.g=M,this.a=[],this.b=void 0}request(C,F,D){if(this.h()&&this.i(),F.url=C,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$znb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,C,g.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(C),this.f.request(F,D)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$WNb=E}),define(ce[271],le([0,1,3,2,9,22,24,17,127]),function(ne,e,R,c,N,k,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=e.$ohc=e.$nhc=void 0;class w{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(h,b,v){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(v)}throw new Error("Invalid call")}}e.$nhc=w;class S extends c.$Xc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(h){super(),this.c=h,this.b=this.B(new R.$ne),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(v=>{this.a=v,this.b.fire(v)}))})}updateAccount(h){return this.c.call("updateAccount",h)}}e.$ohc=S;class m{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(h,b,v){switch(b){case"switch":return this.a.switch(v[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$phc=m;let u=class extends A.$SNb{constructor(h,b,v,d){super(b,v,d),this.n=h,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(h){return this.n.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.n.call("getPreviousUserDataSyncStore");return this.r(h)}r(h){return{url:N.URI.revive(h.url),type:h.type,defaultUrl:N.URI.revive(h.defaultUrl),insidersUrl:N.URI.revive(h.insidersUrl),stableUrl:N.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}};e.$qhc=u,e.$qhc=u=ve([Y(1,T.$tk),Y(2,k.$aj),Y(3,O.$gq)],u)}),define(ce[272],le([0,1,3,58,24,17,18,267,25,83,87]),function(ne,e,R,c,N,k,T,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;let m=class extends O.$9dc{constructor($,h,b,v,d,p,P,g,s,r,t){super($,h,b,v,d,P,g,s,r,t),this.B(R.Event.debounce(R.Event.any(R.Event.map(p.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(p.onDidOpenMainWindow,()=>"windowOpen")),(a,i)=>a?[...a,i]:[i],1e3)(a=>this.triggerSync(a,!0,!1)))}};e.$Mhc=m,e.$Mhc=m=ve([Y(0,N.$tk),Y(1,A.$snb),Y(2,A.$tnb),Y(3,A.$Dnb),Y(4,A.$Enb),Y(5,c.$Ifc),Y(6,A.$Inb),Y(7,w.$iMb),Y(8,T.$_l),Y(9,S.$gnb),Y(10,k.$gq)],m)}),define(ce[273],le([0,1,76,23,5,21]),function(ne,e,R,c,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0,e.$0ec=T,e.$$ec=O,e.$_ec=A,e.$9ec=128/4;function T(w){function S(){let m=w.scheme===c.Schemas.file?(0,k.$8g)(w):w.toString();return N.$k||(m=m.toLowerCase()),(0,R.createHash)("md5").update(m).digest("hex")}return{id:S(),configPath:w}}function O(w,S){function m(){if(w.scheme!==c.Schemas.file)return(0,R.createHash)("md5").update(w.toString()).digest("hex");if(!S)return;let $;return N.$k?$=S.ino:N.$j?$=S.birthtime.getTime():N.$i&&(typeof S.birthtimeMs=="number"?$=Math.floor(S.birthtimeMs):$=S.birthtime.getTime()),(0,R.createHash)("md5").update(w.fsPath).update($?String($):"").digest("hex")}const u=m();if(typeof u=="string")return{id:u,uri:w}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[274],le([0,1,6,8,2,14,31,16,10,80,116,273,58,57,23]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let b=class extends N.$Xc{constructor(d,p,P,g){super(),this.a=d,this.b=p,this.c=P,this.f=g,this.B(new R.$Sh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const d=this.a.workspaceStorageHome.with({scheme:h.Schemas.file}).fsPath,p=await T.Promises.readdir(d),P=new w.$TMb(this.f.getChannel("storage"));await Promise.all(p.map(async g=>{const s=(0,k.$mc)(d,g);g.length===m.$9ec||g===S.$Si.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(a=>a.workspace?.id===g)||await P.isUsed(s)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(s))}))}catch(d){(0,c.$3)(d)}}};e.$jhc=b,e.$jhc=b=ve([Y(0,O.$Oi),Y(1,A.$ak),Y(2,u.$Ifc),Y(3,$.$1gc)],b)}),define(ce[128],le([0,1,76,67,38,282,15,8,3,2,14,5,32,43,71]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=i,e.$zi=n,e.$Bi=f,e.$Ci=I;const b=3e4;class v{traceSocketEvent(E,y){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,y)}constructor(E,y=""){this.f=!0,this.debugLabel=y,this.socket=E,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,O.$3)(F)}},this.socket.on("error",this.a);let C;this.b=F=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,C&&clearTimeout(C)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,C=setTimeout(()=>E.destroy(),b)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const y=C=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,C),E(T.$Pe.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(E){const y=C=>{E({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(E){const y=()=>{E()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,O.$3)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,O.$3)(y)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$vi=v;var d;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var p;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(p||(p={}));class P extends w.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,y){this.socket.traceSocketEvent(E,y)}constructor(E,y,C,F){super(),this.f=this.B(new A.$ne),this.g=this.B(new A.$ne),this.h=!1,this.j={state:p.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new g(this,y,C,F,this.f,(D,M)=>this.m(D,M))),this.B(this.a.onError(D=>{console.error(D),(0,O.$3)(D),this.g.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:D})})),this.b=new h.$qi,this.B(this.socket.onData(D=>this.n(D))),this.B(this.socket.onClose(async D=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(D)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let y=0;for(;y<E.byteLength;)this.a.writeMessage(E.slice(y,Math.min(y+d.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),y+=d.MaxWebSocketMessageLength}m(E,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let F=d.MinHeaderByteSize;E.byteLength<126?F+=0:E.byteLength<2**16?F+=2:F+=8;const D=T.$Pe.alloc(F),M=y?64:0,K=C&15;if(D.writeUInt8(128|M|K,0),E.byteLength<126)D.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){D.writeUInt8(126,1);let W=1;D.writeUInt8(E.byteLength>>>8&255,++W),D.writeUInt8(E.byteLength>>>0&255,++W)}else{D.writeUInt8(127,1);let W=1;D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(0,++W),D.writeUInt8(E.byteLength>>>24&255,++W),D.writeUInt8(E.byteLength>>>16&255,++W),D.writeUInt8(E.byteLength>>>8&255,++W),D.writeUInt8(E.byteLength>>>0&255,++W)}this.socket.write(T.$Pe.concat([D,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===p.PeekHeader){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),F=(C&128)>>>7,D=(C&64)>>>6,M=C&15,K=y.readUInt8(1),W=(K&128)>>>7,_=K&127;this.j.state=p.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(W?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!D),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===p.ReadHeader){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),F=(C&128)>>>7;let D=C&127,M=1;D===126?D=y.readUInt8(++M)*2**8+y.readUInt8(++M):D===127&&(D=y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M));let K=0;F&&(K=y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M)),this.j.state=p.ReadBody,this.j.readLen=D,this.j.mask=K,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===p.ReadBody){const y=this.b.read(this.j.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,y),t(y,this.j.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,y),this.j.state=p.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=P;class g extends w.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Pe.alloc(0)}constructor(E,y,C,F,D,M){super(),this.n=E,this.r=D,this.s=M,this.a=this.B(new A.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,F,C,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(E,y){this.g.push({data:E,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,E);this.s(C,y)}else this.s(E,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,y){return new Promise((C,F)=>{E.write(y),E.flush(D=>C(D))})}acceptFrame(E,y,C){this.h.push({data:E,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const y=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,y,C){return new Promise((F,D)=>{E.write(y),C&&E.write(T.$Pe.fromByteArray([0,0,255,255])),E.flush(M=>F(M))})}}class s extends w.$Xc{get recordedInflateBytes(){return this.j?T.$Pe.concat(this.f):T.$Pe.alloc(0)}constructor(E,y,C,F){super(),this.h=E,this.j=y,this.a=this.B(new A.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(F),this.b.on("error",D=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,D),this.g.push(T.$Pe.wrap(D))}),C&&(this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const y=T.$Pe.concat(this.g);this.g.length=0,E(y)})}}class r extends w.$Xc{constructor(E,y){super(),this.g=E,this.a=this.B(new A.$ne),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,C),this.f.push(T.$Pe.wrap(C))})}write(E){this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let y=T.$Pe.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),E(y)})}}function t(L,E){if(E===0)return;const y=L.byteLength>>>2;for(let W=0;W<y;W++){const _=L.readUInt32BE(W*4);L.writeUInt32BE(_^E,W*4)}const C=y*4,F=L.byteLength-C,D=E>>>24&255,M=E>>>16&255,K=E>>>8&255;F>=1&&L.writeUInt8(L.readUInt8(C)^D,C),F>=2&&L.writeUInt8(L.readUInt8(C+1)^M,C+1),F>=3&&L.writeUInt8(L.readUInt8(C+2)^K,C+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const a={[m.Platform.Linux]:107,[m.Platform.Mac]:103};function i(){const L=(0,u.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const E=process.platform!=="darwin"&&e.$xi?e.$xi:(0,N.tmpdir)(),y=(0,S.$mc)(E,`vscode-ipc-${L}.sock`);return o(y),y}function n(L,E,y){const F=(0,R.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${y}-${E}-sock`;const D=y.substr(0,4),M=E.substr(0,6);let K;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?K=(0,S.$mc)(e.$xi,`vscode-${F}-${D}-${M}.sock`):K=(0,S.$mc)(L,`${D}-${M}.sock`),o(K),K}function o(L){const E=a[m.$u];typeof E=="number"&&L.length>=E&&console.warn(`WARNING: IPC handle "${L}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends $.$ki{static b(E){const y=A.Event.fromNodeEventEmitter(E,"connection");return A.Event.map(y,C=>({protocol:new h.$ri(new v(C,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(C,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=l;function f(L){return new Promise((E,y)=>{const C=(0,c.createServer)();C.on("error",y),C.listen(L,()=>{C.removeListener("error",y),E(new l(C))})})}function I(L,E){return new Promise((y,C)=>{const F=(0,c.createConnection)(L,()=>{F.removeListener("error",C),y(h.$si.fromSocket(new v(F,`ipc-client${E}`),E))});F.once("error",C)})}}),define(ce[275],le([0,1,67,128,222]),function(ne,e,R,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0,R=ke(R),e.$Phc=new class{supports(k){return!0}connect({host:k,port:T},O,A,w){return new Promise((S,m)=>{const u=R.createConnection({host:k,port:T},()=>{u.removeListener("error",m),u.write((0,N.$fxb)(O,A,w));const $=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(u.off("data",$),S(new c.$vi(u,w)))};u.on("data",$)});u.setNoDelay(!0),u.once("error",m)})}}}),define(ce[276],le([0,1,67,38,139,128,6,2,5,22,10,24,223,107,109,81,15]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,R=ke(R),c=ke(c);async function d(r,t,a,i,n){let o;for(let l=3;l&&(o?.dispose(),o=await new p(r,t,a,i,n).waitForReady(),!(n&&N.$6g[n]||!N.$6g[o.tunnelLocalPort]));l--);return o}class p extends O.$Xc{constructor(t,a,i,n,o){super(),this.m=a,this.n=o,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=R.createServer(),this.c=new T.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=l=>this.r(l),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,a=(0,b.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,N.$7g)(t,2,1e3,a),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(t){t.pause();const a=(0,b.$Hw)(this.tunnelRemoteHost)||(0,b.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,u.$3l)(this.a,a,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&t.write(o.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),n.end()}),t.on("close",()=>n.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),n instanceof k.$vi?n.socket.destroy():n.end()}),n instanceof k.$vi?this.t(t,n):this.s(t,n),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),n.end()})}s(t,a){a.onClose(()=>t.destroy()),a.onEnd(()=>t.end()),a.onData(i=>t.write(i.buffer)),t.on("data",i=>a.write(v.$Pe.wrap(i))),t.resume()}t(t,a){const i=a.socket;i.on("end",()=>t.end()),i.on("close",()=>t.end()),i.on("error",()=>{t.destroy()}),i.pipe(t),t.pipe(i)}}e.$Rgc=p;let P=class extends b.$Mw{constructor(t,a,i,n,o){super(a,o),this.H=t,this.I=i,this.J=n}isPortPrivileged(t){return(0,b.$Kw)(t,this.t,A.OS,c.release())}F(t,a,i,n,o,l,f,I){const L=this.D(a,i);if(L)return++L.refcount,L.value;if((0,b.$Dw)(t))return this.G(t,a,i,o,l,f,I);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${o}.`);const E={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},y=d(E,n,a,i,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(a,i,y),y}}};e.$Sgc=P,e.$Sgc=P=ve([Y(0,$.$Wl),Y(1,S.$ak),Y(2,h.$Zl),Y(3,m.$tk),Y(4,w.$aj)],P);let g=class extends P{constructor(t,a,i,n,o){super(t,a,i,n,o)}};e.$Tgc=g,e.$Tgc=g=ve([Y(0,$.$Wl),Y(1,S.$ak),Y(2,h.$Zl),Y(3,m.$tk),Y(4,w.$aj)],g);let s=class extends O.$Xc{constructor(t,a,i,n,o){super(),this.b=t,this.c=a,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(t,a,i,n,o,l,f,I,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${l}.`),!this.a.has(t)){const E=new g(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(t,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(a,i,n,o,l,f,I,L)}};e.$Ugc=s,e.$Ugc=s=ve([Y(0,$.$Wl),Y(1,S.$ak),Y(2,m.$tk),Y(3,h.$Zl),Y(4,w.$aj)],s)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[283],le([0,1,38,41,8,2,23,9,19,3,43,157,216,217,226,208,274,199,200,22,221,98,233,99,228,16,119,260,28,111,224,118,75,7,210,211,74,4,207,77,79,236,10,212,103,24,62,17,110,18,112,113,114,49,239,86,115,25,83,266,271,249,87,265,269,270,127,63,264,250,109,232,81,276,227,240,29,241,5,242,201,219,218,85,255,20,53,215,59,263,238,251,108,268,256,11,213,102,261,254,229,195,58,214,272,258,57,262,107,105,275,193,230,153,146,151]),function(ne,e,R,c,N,k,T,O,A,w,S,m,u,$,h,b,v,d,p,P,g,s,r,t,a,i,n,o,l,f,I,L,E,y,C,F,D,M,K,W,_,H,ie,V,z,te,se,he,q,Z,X,G,U,Q,B,j,x,ee,J,oe,ue,ge,pe,Ie,we,be,Ee,Se,ae,de,me,Re,Oe,Fe,Te,Ne,Ue,qe,Ge,Me,Be,ze,We,Le,re,fe,$e,ye,Ae,Ce,je,xe,Xe,Qe,Ve,_e,Ye,nt,at,Nt,Lt,Ct,Tt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends k.$Xc{constructor(Pe){super(),this.f=Pe,this.a=this.B(new m.$SX(this)),this.b=void 0,this.c=this.B(new w.$ne),this.g()}g(){let Pe=!1;const De=()=>{Pe||(Pe=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,m.$TX)(process.parentPort,ht.$5fc.exit,De)}async init(){const Pe=await this.h();(0,ee.$nnb)(),Pe.invokeFunction(De=>{const Ke=De.get(ie.$ak),He=De.get(Z.$_l),et=De.get(fe.$Ml);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(He,et),this.B(et.onDidChangeProfiles(()=>this.n(He,et))),this.r(He,Ke)}),this.B((0,k.$Uc)(Pe.createInstance(u.$fhc,this.f.codeCachePath),Pe.createInstance($.$ghc),Pe.createInstance(v.$jhc),Pe.createInstance(b.$ihc),Pe.createInstance(h.$hhc),Pe.createInstance(Ve.$Ghc),Pe.createInstance(xe.$yhc)))}async h(){const Pe=new W.$Ei,De={_serviceBrand:void 0,...z.default};Pe.set(te.$tk,De);const Ke=new S.$oi(Ze=>Ze==="main"),He=new yt.$2gc(this.a,Ke);Pe.set(yt.$1gc,He);const et=this.f.policiesData?new ye.$vgc(this.f.policiesData,He.getChannel("policy")):new Ae.$vo;Pe.set(Ae.$to,et);const Je=new Bt.$9m(this.f.args,De);Pe.set(i.$Oi,Je);const ot=new V.$rs(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:O.URI.revive(Ze.resource)})),He.getChannel("logger"));Pe.set(ie.$bk,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$ik(ft.getLevel())),tt=this.B(new Ye.$oR(ft,[$t]));Pe.set(ie.$ak,tt),this.b=this.B(new nt.$Ihc(tt)),Pe.set(nt.$Hhc,this.b);const st=this.B(new C.$1q(tt));Pe.set(y.$al,st);const pt=this.B(new F.$rr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new qe.$Ss(st);Pe.set(Ue.$Kl,dt);const rt=this.B(new Ce.$vR(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Pe.set(fe.$Ml,rt);const wt=this.B(new Me.$Zgc(T.Schemas.file,this.B(new Be.$0Q(He.getChannel(Be.$9Q),{pathCaseSensitive:Ge.$k})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new g.$Vo(rt.defaultProfile.settingsResource,st,et,tt));Pe.set(P.$aj,ct);const bt=new Mt.$Ohc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},He,Je);Pe.set(he.$gq,bt),this.B((0,k.$Vc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Lt.$bs(He.getChannel("request"));Pe.set(se.$6p,It),Pe.set(d.$khc,new D.$Di(p.$lhc,void 0,!1)),Pe.set(We.$NG,new D.$Di(ze.$xhc,void 0,!1));const Pt=new Dt.$4gc(-1,He);Pe.set(Tt.$Ifc,Pt),Pe.set(t.$Zo,new D.$Di(a.$DR,void 0,!0));const Ht=this.B(new de.$sgc(Pt)),Kt=new S.$oi(Ze=>Ht.getActiveClientId().then(mt=>Ze===mt));Pe.set(E.$J6b,new Ct.$Khc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Rt=(0,Q.$Hp)(De,ct);if((0,Q.$Cp)(De,Je)){const Ze=new G.$ndc(tt,ot,Je,De);if(lt.push(Ze),!(0,Q.$Dp)(De,Je)&&De.aiConfig?.ariaKey){const mt=new je.$cR(It,Rt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,k.$Vc)(()=>mt.flush())),lt.push(mt)}gt=new U.$fs({appenders:lt,commonProperties:(0,q.$tp)((0,R.release)(),(0,R.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Rt),sendErrorTelemetry:!0,piiPaths:(0,Q.$Ip)(Je)},ct,De)}else{gt=Q.$xp;const Ze=Q.$Bp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new X.$0fc(lt)),Pe.set(Z.$_l,gt);const Xt=new B.$mhc(ct,gt,tt,ot,Je,De);Pe.set(Z.$am,Xt),Pe.set($e.$Hq,new D.$Di(Nt.$nR,void 0,!0)),Pe.set(Le.$Lq,new D.$Di(re.$wgc,void 0,!0)),Pe.set(f.$rq,new D.$Di(f.$tq,void 0,!0)),Pe.set(L.$Wq,new D.$Di(L.$Xq,void 0,!0)),Pe.set(l.$jp,new D.$Di(o.$pq,void 0,!0)),Pe.set(l.$qp,new D.$Di(Ft.$Nhc,void 0,!1)),Pe.set(_.$0r,new D.$Di(H.$_r,void 0,!1)),Pe.set(s.$Tm,new D.$Di(r.$Zs,void 0,!1)),Pe.set(J.$iMb,new D.$Di(J.$jMb,void 0,!0)),Pe.set(ee.$Inb,new D.$Di(ge.$OOb,void 0,!0)),Pe.set(ee.$Hnb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Pe.set(l.$pp,new D.$Di(n.$gMb,void 0,!1)),Pe.set(x.$MOb,new D.$Di(x.$NOb,void 0,!0)),Pe.set(j.$nw,new D.$Di(j.$ow)),Pe.set(ee.$snb,new D.$Di(Ee.$TNb,void 0,!0)),Pe.set(ee.$tnb,new D.$Di(Ee.$VNb,void 0,!0)),Pe.set(pe.$gnb,new D.$Di(pe.$inb,void 0,!0)),Pe.set(ee.$unb,new D.$Di(oe.$3dc,void 0,!1)),Pe.set(ee.$Dnb,new D.$Di(Ie.$Rdc,void 0,!0)),Pe.set(ee.$Enb,new D.$Di(we.$8dc,void 0,!1)),Pe.set(Se.$UMb,new D.$Di(ae.$thc,void 0,!0)),Pe.set(ee.$Fnb,new D.$Di(Qe.$Lec,void 0,!0)),Pe.set(me.$Zl,new D.$Di(Re.$Wgc,void 0,!1));const kt=new vt.$Xl;return Pe.set(vt.$Wl,kt),kt.register(jt.RemoteConnectionType.WebSocket,qt.$Phc),Pe.set(Oe.$Cw,new D.$Di(Fe.$Ugc)),Pe.set(Te.$uhc,new D.$Di(Ne.$whc)),Pe.set(Xe.$zhc,new D.$Di(at.$Jhc)),new K.$ur(Pe)}j(Pe){const De=new I.$vq(Pe.get(l.$mp),()=>null);this.a.registerChannel("extensions",De);const Ke=S.ProxyChannel.fromService(Pe.get(_.$0r),this.q);this.a.registerChannel("languagePacks",Ke);const He=S.ProxyChannel.fromService(Pe.get(s.$Tm),this.q);this.a.registerChannel("diagnostics",He);const et=new I.$xq(Pe.get(l.$qp));this.a.registerChannel("extensionTipsService",et);const Je=S.ProxyChannel.fromService(Pe.get(d.$khc),this.q);this.a.registerChannel("checksum",Je);const ot=S.ProxyChannel.fromService(Pe.get(We.$NG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=S.ProxyChannel.fromService(Pe.get(pe.$gnb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=S.ProxyChannel.fromService(Pe.get(Z.$am),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$nhc(Pe.get(J.$iMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$phc(Pe.get(ee.$snb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$rhc(Pe.get(ee.$Enb),Pe.get(fe.$Ml),Pe.get(ie.$ak));this.a.registerChannel("userDataSync",pt);const dt=this.B(Pe.get(M.$Fi).createInstance(Ut.$Mhc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Pe.get(ee.$Fnb),this.q));const rt=S.ProxyChannel.fromService(Pe.get(Te.$uhc),this.q);this.a.registerChannel(Te.$vhc,rt);const wt=S.ProxyChannel.fromService(Pe.get(Xe.$zhc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Pe){process.on("uncaughtException",De=>(0,N.$3)(De)),process.on("unhandledRejection",De=>(0,N.$3)(De)),(0,N.setUnexpectedErrorHandler)(De=>{const Ke=(0,c.$rj)(De,!0);Ke&&Pe.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Pe,De){Pe.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Pe,De){if(Ge.$k){const[Ke,He]=await Promise.all([(0,zt.$4g)(De.error.bind(De)),(0,Et.$AX)(De.error.bind(De))]),et=(0,Wt.$gX)(),Je=(0,Et.$BX)(He,this.f.args["ozone-platform"]);Ke&&Pe.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:He,codeDisplayProtocol:Je})}}handledClientConnection(Pe){if(Pe.data!==ht.$7fc.response)return!1;const De=(0,A.$Rb)(Pe.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Pe=new Vt(ut);process.parentPort.postMessage(ht.$5fc.ipcReady),await Pe.init(),process.parentPort.postMessage(ht.$5fc.initDone)}catch(Pe){process.parentPort.postMessage({error:Pe.toString()})}}const Gt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Gt),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/b36286db80c68b7fdc6bfee2f55e0208c8833dfc/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
