/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ce){for(var e=[],s=0,h=ce.length;s<h;s++)e[s]=Ee[ce[s]];return e};define(Ee[174],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var s;(function(I){I[I.LoaderAvailable=1]="LoaderAvailable",I[I.BeginLoadingScript=10]="BeginLoadingScript",I[I.EndLoadingScriptOK=11]="EndLoadingScriptOK",I[I.EndLoadingScriptError=12]="EndLoadingScriptError",I[I.BeginInvokeFactory=21]="BeginInvokeFactory",I[I.EndInvokeFactory=22]="EndInvokeFactory",I[I.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",I[I.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",I[I.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",I[I.NodeEndNativeRequire=34]="NodeEndNativeRequire",I[I.CachedDataFound=60]="CachedDataFound",I[I.CachedDataMissed=61]="CachedDataMissed",I[I.CachedDataRejected=62]="CachedDataRejected",I[I.CachedDataCreated=63]="CachedDataCreated"})(s||(e.LoaderEventType=s={}));class h{static get(){const T=new Map,L=new Map,R=new Map,$=new Map;function a(b,c){b.has(c.detail)||b.set(c.detail,-c.timestamp)}function k(b,c){const m=b.get(c.detail);m&&(m>=0||b.set(c.detail,m+c.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((b,c)=>b.timestamp-c.timestamp));for(const b of E)switch(b.type){case s.BeginLoadingScript:a(T,b);break;case s.EndLoadingScriptOK:case s.EndLoadingScriptError:k(T,b);break;case s.BeginInvokeFactory:a(L,b);break;case s.EndInvokeFactory:k(L,b);break;case s.NodeBeginNativeRequire:a(R,b);break;case s.NodeEndNativeRequire:k(R,b);break;case s.NodeBeginEvaluatingScript:a($,b);break;case s.NodeEndEvaluatingScript:k($,b);break}let l=0;R.forEach(b=>l+=b);function P(b){const c=[];return b.forEach((m,d)=>c.push([d,m])),c}return{amdLoad:P(T),amdInvoke:P(L),nodeRequire:P(R),nodeEval:P($),nodeRequireTotal:l}}static toMarkdownTable(T,L){let R="";const $=[];return T.forEach((a,k)=>{$[k]=a.length}),L.forEach(a=>{a.forEach((k,E)=>{typeof k>"u"&&(k=a[E]="-");const l=k.toString().length;$[E]=Math.max(l,$[E])})}),T.forEach((a,k)=>{R+=`| ${a+" ".repeat($[k]-a.toString().length)} `}),R+=`|
`,T.forEach((a,k)=>{R+=`| ${"-".repeat($[k])} `}),R+=`|
`,L.forEach(a=>{a.forEach((k,E)=>{typeof k<"u"&&(R+=`| ${k+" ".repeat($[E]-k.toString().length)} `)}),R+=`|
`}),R}}e.$W=h}),define(Ee[132],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=s,e.$jb=h,e.$kb=I,e.$lb=T,e.$mb=L,e.$nb=R,e.$ob=$,e.$qb=k,e.$rb=E,e.$sb=l,e.$tb=P,e.$ub=b;function s(c,m){const d=h(c,m);if(d!==-1)return c[d]}function h(c,m,d=c.length-1){for(let g=d;g>=0;g--){const n=c[g];if(m(n))return g}return-1}function I(c,m){const d=T(c,m);return d===-1?void 0:c[d]}function T(c,m,d=0,g=c.length){let n=d,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(c[t])?n=t+1:o=t}return n-1}function L(c,m){const d=R(c,m);return d===c.length?void 0:c[d]}function R(c,m,d=0,g=c.length){let n=d,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(c[t])?o=t:n=t+1}return n}function $(c,m,d=0,g=c.length){const n=R(c,m,d,g);return n===c.length?-1:n}class a{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(a.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!m(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const d=T(this.e,m,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$pb=a;function k(c,m){if(c.length===0)return;let d=c[0];for(let g=1;g<c.length;g++){const n=c[g];m(n,d)>0&&(d=n)}return d}function E(c,m){if(c.length===0)return;let d=c[0];for(let g=1;g<c.length;g++){const n=c[g];m(n,d)>=0&&(d=n)}return d}function l(c,m){return k(c,(d,g)=>-m(d,g))}function P(c,m){if(c.length===0)return-1;let d=0;for(let g=1;g<c.length;g++){const n=c[g];m(n,c[d])>0&&(d=g)}return d}function b(c,m){for(const d of c){const g=m(d);if(g!==void 0)return g}}}),define(Ee[27],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var s;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(s||(e.CharCode=s={}))}),define(Ee[79],Se([1,0]),function(ce,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=h,e.$L=I,e.$M=T,e.$N=L;function h($,a){const k=Object.create(null);for(const E of $){const l=a(E);let P=k[l];P||(P=k[l]=[]),P.push(E)}return k}function I($,a){const k=[],E=[];for(const l of $)a.has(l)||k.push(l);for(const l of a)$.has(l)||E.push(l);return{removed:k,added:E}}function T($,a){const k=[],E=[];for(const[l,P]of $)a.has(l)||k.push(P);for(const[l,P]of a)$.has(l)||E.push(P);return{removed:k,added:E}}function L($,a){const k=new Set;for(const E of a)$.has(E)&&k.add(E);return k}class R{static{s=Symbol.toStringTag}constructor(a,k){this.b=k,this.a=new Map,this[s]="SetWithKey";for(const E of a)this.add(E)}get size(){return this.a.size}add(a){const k=this.b(a);return this.a.set(k,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,k){this.a.forEach(E=>a.call(k,E,E,this))}[Symbol.iterator](){return this.values()}}e.$O=R}),define(Ee[59],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=h,e.$_h=I,e.$ai=T;function s(L){return(R,$,a)=>{let k=null,E=null;if(typeof a.value=="function"?(k="value",E=a.value):typeof a.get=="function"&&(k="get",E=a.get),!E)throw new Error("not supported");a[k]=L(E,$)}}function h(L,R,$){let a=null,k=null;if(typeof $.value=="function"?(a="value",k=$.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(a="get",k=$.get),!k)throw new Error("not supported");const E=`$memoize$${R}`;$[a]=function(...l){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,l)}),this[E]}}function I(L,R,$){return s((a,k)=>{const E=`$debounce$${k}`,l=`$debounce$result$${k}`;return function(...P){this[l]||(this[l]=$?$():void 0),clearTimeout(this[E]),R&&(this[l]=R(this[l],...P),P=[this[l]]),this[E]=setTimeout(()=>{a.apply(this,P),this[l]=$?$():void 0},L)}})}function T(L,R,$){return s((a,k)=>{const E=`$throttle$timer$${k}`,l=`$throttle$result$${k}`,P=`$throttle$lastRun$${k}`,b=`$throttle$pending$${k}`;return function(...c){if(this[l]||(this[l]=$?$():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),R&&(this[l]=R(this[l],...c)),this[b])return;const m=this[P]+L;m<=Date.now()?(this[P]=Date.now(),a.apply(this,[this[l]]),this[l]=$?$():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[P]=Date.now(),a.apply(this,[this[l]]),this[l]=$?$():void 0},m-Date.now()))}})}}),define(Ee[14],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=h,e.$2=I,e.$3=T,e.$4=L,e.$5=R,e.$6=$,e.$7=k,e.$9=l,e.$0=P,e.$$=b,e.$ab=m;class s{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?o.isErrorNoTelemetry(r)?new o(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(f=>{f(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$Y=s,e.$Z=new s;function h(i){e.$Z.setUnexpectedErrorHandler(i)}function I(i){if(!i||typeof i!="object")return!1;const r=i;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function T(i){k(i)||e.$Z.onUnexpectedError(i)}function L(i){k(i)||e.$Z.onUnexpectedExternalError(i)}function R(i){if(i instanceof Error){const{name:r,message:f}=i,u=i.stacktrace||i.stack;return{$isError:!0,name:r,message:f,stack:u,noTelemetry:o.isErrorNoTelemetry(i)}}return i}function $(i){let r;return i.noTelemetry?r=new o:(r=new Error,r.name=i.name),r.message=i.message,r.stack=i.stack,r}const a="Canceled";function k(i){return i instanceof E?!0:i instanceof Error&&i.name===a&&i.message===a}class E extends Error{constructor(){super(a),this.name=this.message}}e.$8=E;function l(){const i=new Error(a);return i.name=i.message,i}function P(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function b(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=c;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class d extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$bb=d;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$cb=g;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=n;class o extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof o)return r;const f=new o;return f.message=r.message,f.stack=r.stack,f}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$eb=o;class t extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$fb=t}),define(Ee[19],Se([1,0,14,132]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=I,e.$wb=T,e.$xb=L,e.$yb=R,e.$zb=$,e.$Ab=a,e.$Bb=k,e.$Cb=E,e.$Db=l,e.$Eb=P,e.$Fb=b,e.$Gb=c,e.$Hb=m,e.top=d,e.$Jb=g,e.$Kb=o,e.$Lb=t,e.$Mb=i,e.$Nb=r,e.$Ob=f,e.$Pb=u,e.$Qb=w,e.$Rb=S,e.$Sb=D,e.$Tb=y,e.$Ub=C,e.$Vb=A,e.$Wb=p,e.$Xb=v,e.$Yb=F,e.$Zb=N,e.$1b=O,e.$2b=j,e.$3b=z,e.$4b=M,e.$5b=V,e.$6b=K,e.$7b=re,e.$8b=B,e.$9b=ee,e.$0b=de,e.$ac=$e;function I(ae,te=0){return ae[ae.length-(1+te)]}function T(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,te,le=(ue,Z)=>ue===Z){if(ae===te)return!0;if(!ae||!te||ae.length!==te.length)return!1;for(let ue=0,Z=ae.length;ue<Z;ue++)if(!le(ae[ue],te[ue]))return!1;return!0}function R(ae,te){const le=ae.length-1;te<le&&(ae[te]=ae[le]),ae.pop()}function $(ae,te,le){return a(ae.length,ue=>le(ae[ue],te))}function a(ae,te){let le=0,ue=ae-1;for(;le<=ue;){const Z=(le+ue)/2|0,oe=te(Z);if(oe<0)le=Z+1;else if(oe>0)ue=Z-1;else return Z}return-(le+1)}function k(ae,te,le){if(ae=ae|0,ae>=te.length)throw new TypeError("invalid index");const ue=te[Math.floor(te.length*Math.random())],Z=[],oe=[],pe=[];for(const we of te){const Fe=le(we,ue);Fe<0?Z.push(we):Fe>0?oe.push(we):pe.push(we)}return ae<Z.length?k(ae,Z,le):ae<Z.length+pe.length?pe[0]:k(ae-(Z.length+pe.length),oe,le)}function E(ae,te){const le=[];let ue;for(const Z of ae.slice(0).sort(te))!ue||te(ue[0],Z)!==0?(ue=[Z],le.push(ue)):ue.push(Z);return le}function*l(ae,te){let le,ue;for(const Z of ae)ue!==void 0&&te(ue,Z)?le.push(Z):(le&&(yield le),le=[Z]),ue=Z;le&&(yield le)}function P(ae,te){for(let le=0;le<=ae.length;le++)te(le===0?void 0:ae[le-1],le===ae.length?void 0:ae[le])}function b(ae,te){for(let le=0;le<ae.length;le++)te(le===0?void 0:ae[le-1],ae[le],le+1===ae.length?void 0:ae[le+1])}function c(ae,te,le){const ue=[];function Z(we,Fe,Ue){if(Fe===0&&Ue.length===0)return;const ke=ue[ue.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Fe,ke.toInsert.push(...Ue)):ue.push({start:we,deleteCount:Fe,toInsert:Ue})}let oe=0,pe=0;for(;;){if(oe===ae.length){Z(oe,0,te.slice(pe));break}if(pe===te.length){Z(oe,ae.length-oe,[]);break}const we=ae[oe],Fe=te[pe],Ue=le(we,Fe);Ue===0?(oe+=1,pe+=1):Ue<0?(Z(oe,1,[]),oe+=1):Ue>0&&(Z(oe,0,[Fe]),pe+=1)}return ue}function m(ae,te,le){const ue=c(ae,te,le),Z=[],oe=[];for(const pe of ue)Z.push(...ae.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:Z,added:oe}}function d(ae,te,le){if(le===0)return[];const ue=ae.slice(0,le).sort(te);return n(ae,te,ue,le,ae.length),ue}function g(ae,te,le,ue,Z){return le===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const we=ae.length,Fe=ae.slice(0,le).sort(te);for(let Ue=le,ke=Math.min(le+ue,we);Ue<we;Ue=ke,ke=Math.min(ke+ue,we)){if(Ue>le&&await new Promise(Pe=>setTimeout(Pe)),Z&&Z.isCancellationRequested)throw new s.$8;n(ae,te,Fe,Ue,ke)}return Fe})().then(oe,pe)})}function n(ae,te,le,ue,Z){for(const oe=le.length;ue<Z;ue++){const pe=ae[ue];if(te(pe,le[oe-1])<0){le.pop();const we=(0,h.$nb)(le,Fe=>te(pe,Fe)<0);le.splice(we,0,pe)}}}function o(ae){return ae.filter(te=>!!te)}function t(ae){let te=0;for(let le=0;le<ae.length;le++)ae[le]&&(ae[te]=ae[le],te+=1);ae.length=te}function i(ae,te,le){ae.splice(le,0,ae.splice(te,1)[0])}function r(ae){return!Array.isArray(ae)||ae.length===0}function f(ae){return Array.isArray(ae)&&ae.length>0}function u(ae,te=le=>le){const le=new Set;return ae.filter(ue=>{const Z=te(ue);return le.has(Z)?!1:(le.add(Z),!0)})}function w(ae){const te=new Set;return le=>{const ue=ae(le);return te.has(ue)?!1:(te.add(ue),!0)}}function S(ae,te){return ae.length>0?ae[0]:te}function D(ae,te){return ae.length>0?ae[ae.length-1]:te}function y(ae,te,le=(ue,Z)=>ue===Z){let ue=0;for(let Z=0,oe=Math.min(ae.length,te.length);Z<oe&&le(ae[Z],te[Z]);Z++)ue++;return ue}function C(ae,te){let le=typeof te=="number"?ae:0;typeof te=="number"?le=ae:(le=0,te=ae);const ue=[];if(le<=te)for(let Z=le;Z<te;Z++)ue.push(Z);else for(let Z=le;Z>te;Z--)ue.push(Z);return ue}function A(ae,te,le){return ae.reduce((ue,Z)=>(ue[te(Z)]=le?le(Z):Z,ue),Object.create(null))}function p(ae,te){return ae.push(te),()=>v(ae,te)}function v(ae,te){const le=ae.indexOf(te);if(le>-1)return ae.splice(le,1),te}function F(ae,te,le){const ue=ae.slice(0,te),Z=ae.slice(te);return ue.concat(le,Z)}function N(ae,te){let le;if(typeof te=="number"){let ue=te;le=()=>{const Z=Math.sin(ue++)*179426549;return Z-Math.floor(Z)}}else le=Math.random;for(let ue=ae.length-1;ue>0;ue-=1){const Z=Math.floor(le()*(ue+1)),oe=ae[ue];ae[ue]=ae[Z],ae[Z]=oe}}function O(ae,te){const le=ae.indexOf(te);le>-1&&(ae.splice(le,1),ae.unshift(te))}function j(ae,te){const le=ae.indexOf(te);le>-1&&(ae.splice(le,1),ae.push(te))}function z(ae,te){for(const le of te)ae.push(le)}function M(ae,te){return Array.isArray(ae)?ae.map(te):te(ae)}function V(ae){return Array.isArray(ae)?ae:[ae]}function K(ae){return ae[Math.floor(Math.random()*ae.length)]}function re(ae,te,le){const ue=G(ae,te),Z=ae.length,oe=le.length;ae.length=Z+oe;for(let pe=Z-1;pe>=ue;pe--)ae[pe+oe]=ae[pe];for(let pe=0;pe<oe;pe++)ae[pe+ue]=le[pe]}function B(ae,te,le,ue){const Z=G(ae,te);let oe=ae.splice(Z,le);return oe===void 0&&(oe=[]),re(ae,Z,ue),oe}function G(ae,te){return te<0?Math.max(te+ae.length,0):Math.min(te,ae.length)}var X;(function(ae){function te(oe){return oe<0}ae.isLessThan=te;function le(oe){return oe<=0}ae.isLessThanOrEqual=le;function ue(oe){return oe>0}ae.isGreaterThan=ue;function Z(oe){return oe===0}ae.isNeitherLessOrGreaterThan=Z,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(X||(e.CompareResult=X={}));function ee(ae,te){return(le,ue)=>te(ae(le),ae(ue))}function de(...ae){return(te,le)=>{for(const ue of ae){const Z=ue(te,le);if(!X.isNeitherLessOrGreaterThan(Z))return Z}return X.neitherLessOrGreaterThan}}const ne=(ae,te)=>ae-te;e.$$b=ne;const De=(ae,te)=>(0,e.$$b)(ae?1:0,te?1:0);e.$_b=De;function $e(ae){return(te,le)=>-ae(te,le)}class J{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const ue=le===this.c?null:this.g.slice(this.c,le);return this.c=le,ue}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const ue=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,ue}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$bc=J;class U{static{this.empty=new U(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new U(le=>this.iterate(ue=>te(ue)?le(ue):!0))}map(te){return new U(le=>this.iterate(ue=>le(te(ue))))}some(te){let le=!1;return this.iterate(ue=>(le=te(ue),!le)),le}findFirst(te){let le;return this.iterate(ue=>te(ue)?(le=ue,!1):!0),le}findLast(te){let le;return this.iterate(ue=>(te(ue)&&(le=ue),!0)),le}findLastMaxBy(te){let le,ue=!0;return this.iterate(Z=>((ue||X.isGreaterThan(te(Z,le)))&&(ue=!1,le=Z),!0)),le}}e.$cc=U;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const ue=Array.from(te.keys()).sort((Z,oe)=>le(te[Z],te[oe]));return new se(ue)}apply(te){return te.map((le,ue)=>te[this.c[ue]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$dc=se}),define(Ee[66],Se([1,0,14]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$hd=I,e.$id=T,e.$jd=L,e.$kd=R,e.$ld=$;function h(a,k){if(!a)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}function I(a,k="Unreachable"){throw new Error(k)}function T(a,k="unexpected state"){if(!a)throw new s.$fb(`Assertion Failed: ${k}`)}function L(a){a||(0,s.$3)(new s.$fb("Soft Assertion Failed"))}function R(a){if(!a()){debugger;a(),(0,s.$3)(new s.$fb("Assertion Failed"))}}function $(a,k){let E=0;for(;E<a.length-1;){const l=a[E],P=a[E+1];if(!k(l,P))return!1;E++}return!0}});var Un=this&&this.__createBinding||(Object.create?function(ce,e,s,h){h===void 0&&(h=s);var I=Object.getOwnPropertyDescriptor(e,s);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[s]}}),Object.defineProperty(ce,h,I)}:function(ce,e,s,h){h===void 0&&(h=s),ce[h]=e[s]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),We=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var s in ce)s!=="default"&&Object.prototype.hasOwnProperty.call(ce,s)&&Un(e,ce,s);return Wn(e,ce),e};define(Ee[175],Se([1,0,19]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=I,e.$$c=T,e.$_c=L,e.$ad=R,e.$bd=$,e.$cd=a,s=We(s);const h=(P,b)=>P===b;e.$9c=h;function I(P=e.$9c){return(b,c)=>s.$xb(b,c,P)}function T(){return(P,b)=>JSON.stringify(P)===JSON.stringify(b)}function L(){return(P,b)=>P.equals(b)}function R(P,b,c){if(c!==void 0){const m=P;return m==null||b===void 0||b===null?b===m:c(m,b)}else{const m=P;return(d,g)=>d==null||g===void 0||g===null?g===d:m(d,g)}}function $(P,b){if(P===b)return!0;if(Array.isArray(P)&&Array.isArray(b)){if(P.length!==b.length)return!1;for(let c=0;c<P.length;c++)if(!$(P[c],b[c]))return!1;return!0}if(P&&typeof P=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const c=P,m=b,d=Object.keys(c),g=Object.keys(m),n=new Set(g);if(d.length!==g.length)return!1;for(const o of d)if(!n.has(o)||!$(c[o],m[o]))return!1;return!0}return!1}function a(P){return JSON.stringify(l(P))}let k=0;const E=new WeakMap;function l(P){if(Array.isArray(P))return P.map(l);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const b=P,c=Object.create(null);for(const m of Object.keys(b).sort())c[m]=l(b[m]);return c}else{let b=E.get(P);return b===void 0&&(b=k++,E.set(P,b)),b+"----2b76a038c20c4bcc"}return P}}),define(Ee[80],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=s;function s(h,I){const T=this;let L=!1,R;return function(){if(L)return R;if(L=!0,I)try{R=h.apply(T,arguments)}finally{I()}else R=h.apply(T,arguments);return R}}}),define(Ee[133],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class s{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=s,e.$7P=new s("id#")}),define(Ee[40],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(h){function I(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}h.is=I;const T=Object.freeze([]);function L(){return T}h.empty=L;function*R(r){yield r}h.single=R;function $(r){return I(r)?r:R(r)}h.wrap=$;function a(r){return r||T}h.from=a;function*k(r){for(let f=r.length-1;f>=0;f--)yield r[f]}h.reverse=k;function E(r){return!r||r[Symbol.iterator]().next().done===!0}h.isEmpty=E;function l(r){return r[Symbol.iterator]().next().value}h.first=l;function P(r,f){let u=0;for(const w of r)if(f(w,u++))return!0;return!1}h.some=P;function b(r,f){for(const u of r)if(f(u))return u}h.find=b;function*c(r,f){for(const u of r)f(u)&&(yield u)}h.filter=c;function*m(r,f){let u=0;for(const w of r)yield f(w,u++)}h.map=m;function*d(r,f){let u=0;for(const w of r)yield*f(w,u++)}h.flatMap=d;function*g(...r){for(const f of r)yield*f}h.concat=g;function n(r,f,u){let w=u;for(const S of r)w=f(w,S);return w}h.reduce=n;function*o(r,f,u=r.length){for(f<0&&(f+=r.length),u<0?u+=r.length:u>r.length&&(u=r.length);f<u;f++)yield r[f]}h.slice=o;function t(r,f=Number.POSITIVE_INFINITY){const u=[];if(f===0)return[u,r];const w=r[Symbol.iterator]();for(let S=0;S<f;S++){const D=w.next();if(D.done)return[u,h.empty()];u.push(D.value)}return[u,{[Symbol.iterator](){return w}}]}h.consume=t;async function i(r){const f=[];for await(const u of r)f.push(u);return Promise.resolve(f)}h.asyncToArray=i})(s||(e.Iterable=s={}))}),define(Ee[176],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=L,e.$Xn=E,e.$Yn=l,e.$Zn=P,e.$1n=b,e.$2n=c,e.$3n=m,e.$4n=d,e.$5n=g,e.$6n=n,e.$7n=o;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function L(t,i=!1){let r=0;const f=t.length;let u="",w=0,S=h.Unknown,D=s.None;function y(O){let j=0,z=0;for(;j<O;){const M=t.charCodeAt(r);if(M>=k._0&&M<=k._9)z=z*16+M-k._0;else if(M>=k.A&&M<=k.F)z=z*16+M-k.A+10;else if(M>=k.a&&M<=k.f)z=z*16+M-k.a+10;else break;r++,j++}return j<O&&(z=-1),z}function C(O){r=O,u="",w=0,S=h.Unknown,D=s.None}function A(){const O=r;if(t.charCodeAt(r)===k._0)r++;else for(r++;r<t.length&&a(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===k.dot)if(r++,r<t.length&&a(t.charCodeAt(r)))for(r++;r<t.length&&a(t.charCodeAt(r));)r++;else return D=s.UnexpectedEndOfNumber,t.substring(O,r);let j=r;if(r<t.length&&(t.charCodeAt(r)===k.E||t.charCodeAt(r)===k.e))if(r++,(r<t.length&&t.charCodeAt(r)===k.plus||t.charCodeAt(r)===k.minus)&&r++,r<t.length&&a(t.charCodeAt(r))){for(r++;r<t.length&&a(t.charCodeAt(r));)r++;j=r}else D=s.UnexpectedEndOfNumber;return t.substring(O,j)}function p(){let O="",j=r;for(;;){if(r>=f){O+=t.substring(j,r),D=s.UnexpectedEndOfString;break}const z=t.charCodeAt(r);if(z===k.doubleQuote){O+=t.substring(j,r),r++;break}if(z===k.backslash){if(O+=t.substring(j,r),r++,r>=f){D=s.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case k.doubleQuote:O+='"';break;case k.backslash:O+="\\";break;case k.slash:O+="/";break;case k.b:O+="\b";break;case k.f:O+="\f";break;case k.n:O+=`
`;break;case k.r:O+="\r";break;case k.t:O+="	";break;case k.u:{const V=y(4);V>=0?O+=String.fromCharCode(V):D=s.InvalidUnicode;break}default:D=s.InvalidEscapeCharacter}j=r;continue}if(z>=0&&z<=31)if($(z)){O+=t.substring(j,r),D=s.UnexpectedEndOfString;break}else D=s.InvalidCharacter;r++}return O}function v(){if(u="",D=s.None,w=r,r>=f)return w=f,S=h.EOF;let O=t.charCodeAt(r);if(R(O)){do r++,u+=String.fromCharCode(O),O=t.charCodeAt(r);while(R(O));return S=h.Trivia}if($(O))return r++,u+=String.fromCharCode(O),O===k.carriageReturn&&t.charCodeAt(r)===k.lineFeed&&(r++,u+=`
`),S=h.LineBreakTrivia;switch(O){case k.openBrace:return r++,S=h.OpenBraceToken;case k.closeBrace:return r++,S=h.CloseBraceToken;case k.openBracket:return r++,S=h.OpenBracketToken;case k.closeBracket:return r++,S=h.CloseBracketToken;case k.colon:return r++,S=h.ColonToken;case k.comma:return r++,S=h.CommaToken;case k.doubleQuote:return r++,u=p(),S=h.StringLiteral;case k.slash:{const j=r-1;if(t.charCodeAt(r+1)===k.slash){for(r+=2;r<f&&!$(t.charCodeAt(r));)r++;return u=t.substring(j,r),S=h.LineCommentTrivia}if(t.charCodeAt(r+1)===k.asterisk){r+=2;const z=f-1;let M=!1;for(;r<z;){if(t.charCodeAt(r)===k.asterisk&&t.charCodeAt(r+1)===k.slash){r+=2,M=!0;break}r++}return M||(r++,D=s.UnexpectedEndOfComment),u=t.substring(j,r),S=h.BlockCommentTrivia}return u+=String.fromCharCode(O),r++,S=h.Unknown}case k.minus:if(u+=String.fromCharCode(O),r++,r===f||!a(t.charCodeAt(r)))return S=h.Unknown;case k._0:case k._1:case k._2:case k._3:case k._4:case k._5:case k._6:case k._7:case k._8:case k._9:return u+=A(),S=h.NumericLiteral;default:for(;r<f&&F(O);)r++,O=t.charCodeAt(r);if(w!==r){switch(u=t.substring(w,r),u){case"true":return S=h.TrueKeyword;case"false":return S=h.FalseKeyword;case"null":return S=h.NullKeyword}return S=h.Unknown}return u+=String.fromCharCode(O),r++,S=h.Unknown}}function F(O){if(R(O)||$(O))return!1;switch(O){case k.closeBrace:case k.closeBracket:case k.openBrace:case k.openBracket:case k.doubleQuote:case k.colon:case k.comma:case k.slash:return!1}return!0}function N(){let O;do O=v();while(O>=h.LineCommentTrivia&&O<=h.Trivia);return O}return{setPosition:C,getPosition:()=>r,scan:i?N:v,getToken:()=>S,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>r-w,getTokenError:()=>D}}function R(t){return t===k.space||t===k.tab||t===k.verticalTab||t===k.formFeed||t===k.nonBreakingSpace||t===k.ogham||t>=k.enQuad&&t<=k.zeroWidthSpace||t===k.narrowNoBreakSpace||t===k.mathematicalSpace||t===k.ideographicSpace||t===k.byteOrderMark}function $(t){return t===k.lineFeed||t===k.carriageReturn||t===k.lineSeparator||t===k.paragraphSeparator}function a(t){return t>=k._0&&t<=k._9}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function E(t,i){const r=[],f=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(y,C,A,p){w.value=y,w.offset=C,w.length=A,w.type=p,w.colonOffset=void 0,u=w}try{n(t,{onObjectBegin:(y,C)=>{if(i<=y)throw f;u=void 0,S=i>y,r.push("")},onObjectProperty:(y,C,A)=>{if(i<C||(D(y,C,A,"property"),r[r.length-1]=y,i<=C+A))throw f},onObjectEnd:(y,C)=>{if(i<=y)throw f;u=void 0,r.pop()},onArrayBegin:(y,C)=>{if(i<=y)throw f;u=void 0,r.push(0)},onArrayEnd:(y,C)=>{if(i<=y)throw f;u=void 0,r.pop()},onLiteralValue:(y,C,A)=>{if(i<C||(D(y,C,A,o(y)),i<=C+A))throw f},onSeparator:(y,C,A)=>{if(i<=C)throw f;if(y===":"&&u&&u.type==="property")u.colonOffset=C,S=!1,u=void 0;else if(y===","){const p=r[r.length-1];typeof p=="number"?r[r.length-1]=p+1:(S=!0,r[r.length-1]=""),u=void 0}}})}catch(y){if(y!==f)throw y}return{path:r,previousNode:u,isAtPropertyKey:S,matches:y=>{let C=0;for(let A=0;C<y.length&&A<r.length;A++)if(y[C]===r[A]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function l(t,i=[],r=T.DEFAULT){let f=null,u=[];const w=[];function S(y){Array.isArray(u)?u.push(y):f!==null&&(u[f]=y)}return n(t,{onObjectBegin:()=>{const y={};S(y),w.push(u),u=y,f=null},onObjectProperty:y=>{f=y},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const y=[];S(y),w.push(u),u=y,f=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:S,onError:(y,C,A)=>{i.push({error:y,offset:C,length:A})}},r),u[0]}function P(t,i=[],r=T.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(y){f.type==="property"&&(f.length=y-f.offset,f=f.parent)}function w(y){return f.children.push(y),y}n(t,{onObjectBegin:y=>{f=w({type:"object",offset:y,length:-1,parent:f,children:[]})},onObjectProperty:(y,C,A)=>{f=w({type:"property",offset:C,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:y,offset:C,length:A,parent:f})},onObjectEnd:(y,C)=>{f.length=y+C-f.offset,f=f.parent,u(y+C)},onArrayBegin:(y,C)=>{f=w({type:"array",offset:y,length:-1,parent:f,children:[]})},onArrayEnd:(y,C)=>{f.length=y+C-f.offset,f=f.parent,u(y+C)},onLiteralValue:(y,C,A)=>{w({type:o(y),offset:C,length:A,parent:f,value:y}),u(C+A)},onSeparator:(y,C,A)=>{f.type==="property"&&(y===":"?f.colonOffset=C:y===","&&u(C))},onError:(y,C,A)=>{i.push({error:y,offset:C,length:A})}},r);const D=f.children[0];return D&&delete D.parent,D}function b(t,i){if(!t)return;let r=t;for(const f of i)if(typeof f=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const w of r.children)if(Array.isArray(w.children)&&w.children[0].value===f){r=w.children[1],u=!0;break}if(!u)return}else{const u=f;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}function c(t){if(!t.parent||!t.parent.children)return[];const i=c(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;i.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&i.push(r)}return i}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const i=Object.create(null);for(const r of t.children){const f=r.children[1];f&&(i[r.children[0].value]=m(f))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,i,r=!1){return i>=t.offset&&i<t.offset+t.length||r&&i===t.offset+t.length}function g(t,i,r=!1){if(d(t,i,r)){const f=t.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=i;u++){const w=g(f[u],i,r);if(w)return w}return t}}function n(t,i,r=T.DEFAULT){const f=L(t,!1);function u(ee){return ee?()=>ee(f.getTokenOffset(),f.getTokenLength()):()=>!0}function w(ee){return ee?de=>ee(de,f.getTokenOffset(),f.getTokenLength()):()=>!0}const S=u(i.onObjectBegin),D=w(i.onObjectProperty),y=u(i.onObjectEnd),C=u(i.onArrayBegin),A=u(i.onArrayEnd),p=w(i.onLiteralValue),v=w(i.onSeparator),F=u(i.onComment),N=w(i.onError),O=r&&r.disallowComments,j=r&&r.allowTrailingComma;function z(){for(;;){const ee=f.scan();switch(f.getTokenError()){case s.InvalidUnicode:M(I.InvalidUnicode);break;case s.InvalidEscapeCharacter:M(I.InvalidEscapeCharacter);break;case s.UnexpectedEndOfNumber:M(I.UnexpectedEndOfNumber);break;case s.UnexpectedEndOfComment:O||M(I.UnexpectedEndOfComment);break;case s.UnexpectedEndOfString:M(I.UnexpectedEndOfString);break;case s.InvalidCharacter:M(I.InvalidCharacter);break}switch(ee){case h.LineCommentTrivia:case h.BlockCommentTrivia:O?M(I.InvalidCommentToken):F();break;case h.Unknown:M(I.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ee}}}function M(ee,de=[],ne=[]){if(N(ee),de.length+ne.length>0){let De=f.getToken();for(;De!==h.EOF;){if(de.indexOf(De)!==-1){z();break}else if(ne.indexOf(De)!==-1)break;De=z()}}}function V(ee){const de=f.getTokenValue();return ee?p(de):D(de),z(),!0}function K(){switch(f.getToken()){case h.NumericLiteral:{let ee=0;try{ee=JSON.parse(f.getTokenValue()),typeof ee!="number"&&(M(I.InvalidNumberFormat),ee=0)}catch{M(I.InvalidNumberFormat)}p(ee);break}case h.NullKeyword:p(null);break;case h.TrueKeyword:p(!0);break;case h.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function re(){return f.getToken()!==h.StringLiteral?(M(I.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(V(!1),f.getToken()===h.ColonToken?(v(":"),z(),X()||M(I.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):M(I.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){S(),z();let ee=!1;for(;f.getToken()!==h.CloseBraceToken&&f.getToken()!==h.EOF;){if(f.getToken()===h.CommaToken){if(ee||M(I.ValueExpected,[],[]),v(","),z(),f.getToken()===h.CloseBraceToken&&j)break}else ee&&M(I.CommaExpected,[],[]);re()||M(I.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ee=!0}return y(),f.getToken()!==h.CloseBraceToken?M(I.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function G(){C(),z();let ee=!1;for(;f.getToken()!==h.CloseBracketToken&&f.getToken()!==h.EOF;){if(f.getToken()===h.CommaToken){if(ee||M(I.ValueExpected,[],[]),v(","),z(),f.getToken()===h.CloseBracketToken&&j)break}else ee&&M(I.CommaExpected,[],[]);X()||M(I.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ee=!0}return A(),f.getToken()!==h.CloseBracketToken?M(I.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function X(){switch(f.getToken()){case h.OpenBracketToken:return G();case h.OpenBraceToken:return B();case h.StringLiteral:return V(!0);default:return K()}}return z(),f.getToken()===h.EOF?r.allowEmptyContent?!0:(M(I.ValueExpected,[],[]),!1):X()?(f.getToken()!==h.EOF&&M(I.EndOfFileExpected,[],[]),!0):(M(I.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class s{constructor(I){this.d=I,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=s}),define(Ee[81],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class s{static{this.Undefined=new s(void 0)}constructor(T){this.element=T,this.next=s.Undefined,this.prev=s.Undefined}}class h{constructor(){this.a=s.Undefined,this.b=s.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===s.Undefined}clear(){let T=this.a;for(;T!==s.Undefined;){const L=T.next;T.prev=s.Undefined,T.next=s.Undefined,T=L}this.a=s.Undefined,this.b=s.Undefined,this.c=0}unshift(T){return this.d(T,!1)}push(T){return this.d(T,!0)}d(T,L){const R=new s(T);if(this.a===s.Undefined)this.a=R,this.b=R;else if(L){const a=this.b;this.b=R,R.prev=a,a.next=R}else{const a=this.a;this.a=R,R.next=a,a.prev=R}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(R))}}shift(){if(this.a!==s.Undefined){const T=this.a.element;return this.e(this.a),T}}pop(){if(this.b!==s.Undefined){const T=this.b.element;return this.e(this.b),T}}e(T){if(T.prev!==s.Undefined&&T.next!==s.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===s.Undefined&&T.next===s.Undefined?(this.a=s.Undefined,this.b=s.Undefined):T.next===s.Undefined?(this.b=this.b.prev,this.b.next=s.Undefined):T.prev===s.Undefined&&(this.a=this.a.next,this.a.prev=s.Undefined);this.c-=1}*[Symbol.iterator](){let T=this.a;for(;T!==s.Undefined;)yield T.element,T=T.next}}e.$8c=h}),define(Ee[29],Se([1,0]),function(ce,e){"use strict";var s,h,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=T,e.$Bc=L,e.$Cc=R,e.$Lc=o;function T(t,i,r){let f=t.get(i);return f===void 0&&(f=r,t.set(i,f)),f}function L(t){const i=[];return t.forEach((r,f)=>{i.push(`${f} => ${r}`)}),`Map(${t.size}) {${i.join(", ")}}`}function R(t){const i=[];return t.forEach(r=>{i.push(r)}),`Set(${t.size}) {${i.join(", ")}}`}class ${constructor(i,r){this.uri=i,this.value=r}}function a(t){return Array.isArray(t)}class k{static{this.c=i=>i.toString()}constructor(i,r){if(this[s]="ResourceMap",i instanceof k)this.d=new Map(i.d),this.e=r??k.c;else if(a(i)){this.d=new Map,this.e=r??k.c;for(const[f,u]of i)this.set(f,u)}else this.d=new Map,this.e=i??k.c}set(i,r){return this.d.set(this.e(i),new $(i,r)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[f,u]of this.d)i(u.value,u.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Dc=k;class E{constructor(i,r){this[h]="ResourceSet",!i||typeof i=="function"?this.c=new k(i):(this.c=new k(r),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,r){this.c.forEach((f,u)=>i.call(r,u,u,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=E;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l||(e.Touch=l={}));class P{constructor(){this[I]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,r=l.None){const f=this.c.get(i);if(f)return r!==l.None&&this.m(f,r),f.value}set(i,r,f=l.None){let u=this.c.get(i);if(u)u.value=r,f!==l.None&&this.m(u,f);else{switch(u={key:i,value:r,next:void 0,previous:void 0},f){case l.None:this.k(u);break;case l.AsOld:this.j(u);break;case l.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(i,u),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this.c.get(i);if(r)return this.c.delete(i),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,r){const f=this.g;let u=this.d;for(;u;){if(r?i.bind(r)(u.value,u.key,this):i(u.value,u.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,r=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.key,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}values(){const i=this,r=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.value,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}entries(){const i=this,r=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:[f.key,f.value],done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return u}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this.d,f=this.size;for(;r&&f>i;)this.c.delete(r.key),r=r.next,f--;this.d=r,this.f=f,r&&(r.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this.e,f=this.size;for(;r&&f>i;)this.c.delete(r.key),r=r.previous,f--;this.e=r,this.f=f,r&&(r.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const r=i.next,f=i.previous;if(!r||!f)throw new Error("Invalid list");r.previous=f,f.next=r}i.next=void 0,i.previous=void 0,this.g++}m(i,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==l.AsOld&&r!==l.AsNew)){if(r===l.AsOld){if(i===this.d)return;const f=i.next,u=i.previous;i===this.e?(u.next=void 0,this.e=u):(f.previous=u,u.next=f),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(r===l.AsNew){if(i===this.e)return;const f=i.next,u=i.previous;i===this.d?(f.previous=void 0,this.d=f):(f.previous=u,u.next=f),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((r,f)=>{i.push([f,r])}),i}fromJSON(i){this.clear();for(const[r,f]of i)this.set(r,f)}}e.$Fc=P;class b extends P{constructor(i,r=1){super(),this.n=i,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,r=l.AsNew){return super.get(i,r)}peek(i){return super.get(i,l.None)}set(i,r){return super.set(i,r,l.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends b{constructor(i,r=1){super(i,r)}q(i){this.h(i)}set(i,r){return super.set(i,r),this.p(),this}}e.$Gc=c;class m extends b{constructor(i,r=1){super(i,r)}q(i){this.i(i)}set(i,r){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,r),this}}e.$Hc=m;class d{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let r=this.c.get(i)||0;return r===0?!1:(r--,r===0?this.c.delete(i):this.c.set(i,r),!0)}has(i){return this.c.has(i)}}e.$Ic=d;class g{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[r,f]of i)this.set(r,f)}clear(){this.c.clear(),this.d.clear()}set(i,r){this.c.set(i,r),this.d.set(r,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const r=this.c.get(i);return r===void 0?!1:(this.c.delete(i),this.d.delete(r),!0)}forEach(i,r){this.c.forEach((f,u)=>{i.call(r,f,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=g;class n{constructor(){this.c=new Map}add(i,r){let f=this.c.get(i);f||(f=new Set,this.c.set(i,f)),f.add(r)}delete(i,r){const f=this.c.get(i);f&&(f.delete(r),f.size===0&&this.c.delete(i))}forEach(i,r){const f=this.c.get(i);f&&f.forEach(r)}get(i){const r=this.c.get(i);return r||new Set}}e.$Kc=n;function o(t,i){if(t===i)return!0;if(t.size!==i.size)return!1;for(const[r,f]of t)if(!i.has(r)||i.get(r)!==f)return!1;for(const[r]of i)if(!t.has(r))return!1;return!0}}),define(Ee[3],Se([1,0,19,79,29,80,40]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=k,e.$Oc=E,e.$Pc=l,e.$Qc=c,e.$Rc=m,e.$Sc=d,e.$Tc=g,e.$Uc=n,e.$Vc=o,e.$6c=C;const R=!1;let $=null;class a{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:a.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const O=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,O),O}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const V=new Map,K=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,V).isSingleton);if(K.length===0)return;const re=new Set(K.map(B=>B.value));if(N=K.filter(B=>!(B.parent&&re.has(B.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(V){function K(B,G){for(;B.length>0&&G.some(X=>typeof X=="string"?X===B[0]:B[0].match(X));)B.shift()}const re=V.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return K(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new I.$Kc;for(const V of N){const K=O(V);for(let re=0;re<=K.length;re++)j.add(K.slice(0,re).join(`
`),V)}N.sort((0,s.$9b)(V=>V.idx,s.$$b));let z="",M=0;for(const V of N.slice(0,v)){M++;const K=O(V),re=[];for(let B=0;B<K.length;B++){let G=K[B];G=`(shared with ${j.get(K.slice(0,B+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const ee=j.get(K.slice(0,B).join(`
`)),de=(0,h.$K)([...ee].map(ne=>O(ne)[B]),ne=>ne);delete de[K[B]];for(const[ne,De]of Object.entries(de))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}z+=`


==================== Leaking disposable ${M}/${N.length}: ${V.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Mc=a;function k(p){$=p}if(R){const p="__is_disposable_tracked__";k(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==i.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==i.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function E(p){return $?.trackDisposable(p),p}function l(p){$?.markAsDisposed(p)}function P(p,v){$?.setParent(p,v)}function b(p,v){if($)for(const F of p)$.setParent(F,v)}function c(p){return $?.markAsSingleton(p),p}function m(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function d(p){if(L.Iterable.is(p)){const v=[];for(const F of p)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function g(p){for(const v of p)m(v)&&v.dispose();return[]}function n(...p){const v=o(()=>d(p));return b(p,v),v}function o(p){const v=E({dispose:(0,T.$gb)(()=>{l(v),p()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Wc=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,E(this),P(this.q,this)}dispose(){l(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Xc=i;class r{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Yc=r;class f{constructor(v){this.a=new r,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=f;class u{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=u;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,l(this))},this}}e.$2c=w;class S{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:O}=N,j=(0,T.$gb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:O,dispose:j}}}e.$3c=S;class D{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$4c=D;class y{constructor(v){this.object=v}dispose(){}}e.$5c=y;function C(p){const v=new t;try{p(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=A}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[177],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var ue=0;ue<le.length;ue++){var Z=le[ue];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(te,Z.key,Z)}}function s(te,le,ue){return le&&e(te.prototype,le),ue&&e(te,ue),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return I(te,le);var ue=Object.prototype.toString.call(te).slice(8,-1);if(ue==="Object"&&te.constructor&&(ue=te.constructor.name),ue==="Map"||ue==="Set")return Array.from(te);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return I(te,le)}}function I(te,le){(le==null||le>te.length)&&(le=te.length);for(var ue=0,Z=new Array(le);ue<le;ue++)Z[ue]=te[ue];return Z}function T(te,le){var ue=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(ue)return(ue=ue.call(te)).next.bind(ue);if(Array.isArray(te)||(ue=h(te))||le&&te&&typeof te.length=="number"){ue&&(te=ue);var Z=0;return function(){return Z>=te.length?{done:!0}:{done:!1,value:te[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=L();function R(te){ce.defaults=te}var $=/[&<>"']/,a=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(le){return l[le]};function b(te,le){if(le){if($.test(te))return te.replace(a,P)}else if(k.test(te))return te.replace(E,P);return te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(c,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(te,le){te=typeof te=="string"?te:te.source,le=le||"";var ue={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace(d,"$1"),te=te.replace(oe,pe),ue},getRegex:function(){return new RegExp(te,le)}};return ue}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,le,ue){if(te){var Z;try{Z=decodeURIComponent(m(ue)).replace(n,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!o.test(ue)&&(ue=w(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},r=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){i[" "+te]||(r.test(te)?i[" "+te]=te+"/":i[" "+te]=C(te,"/",!0)),te=i[" "+te];var ue=te.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:te.replace(f,"$1")+le:le.charAt(0)==="/"?ue?le:te.replace(u,"$1")+le:te+le}var S={exec:function(){}};function D(te){for(var le=1,ue,Z;le<arguments.length;le++){ue=arguments[le];for(Z in ue)Object.prototype.hasOwnProperty.call(ue,Z)&&(te[Z]=ue[Z])}return te}function y(te,le){var ue=te.replace(/\|/g,function(pe,we,Fe){for(var Ue=!1,ke=we;--ke>=0&&Fe[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),Z=ue.split(/ \|/),oe=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;oe<Z.length;oe++)Z[oe]=Z[oe].trim().replace(/\\\|/g,"|");return Z}function C(te,le,ue){var Z=te.length;if(Z===0)return"";for(var oe=0;oe<Z;){var pe=te.charAt(Z-oe-1);if(pe===le&&!ue)oe++;else if(pe!==le&&ue)oe++;else break}return te.slice(0,Z-oe)}function A(te,le){if(te.indexOf(le[1])===-1)return-1;for(var ue=te.length,Z=0,oe=0;oe<ue;oe++)if(te[oe]==="\\")oe++;else if(te[oe]===le[0])Z++;else if(te[oe]===le[1]&&(Z--,Z<0))return oe;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=te),le>>=1,te+=te;return ue+te}function F(te,le,ue,Z){var oe=le.href,pe=le.title?b(le.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Z.state.inLink=!0;var Fe={type:"link",raw:ue,href:oe,title:pe,text:we,tokens:Z.inlineTokens(we)};return Z.state.inLink=!1,Fe}return{type:"image",raw:ue,href:oe,title:pe,text:b(we)}}function N(te,le){var ue=te.match(/^(\s+)(?:```)/);if(ue===null)return le;var Z=ue[1];return le.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var we=pe[0];return we.length>=Z.length?oe.slice(Z.length):oe}).join(`
`)}var O=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.space=function(Z){var oe=this.rules.block.newline.exec(Z);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},le.code=function(Z){var oe=this.rules.block.code.exec(Z);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:C(pe,`
`)}}},le.fences=function(Z){var oe=this.rules.block.fences.exec(Z);if(oe){var pe=oe[0],we=N(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:we}}},le.heading=function(Z){var oe=this.rules.block.heading.exec(Z);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var we=C(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(Z){var oe=this.rules.block.hr.exec(Z);if(oe)return{type:"hr",raw:oe[0]}},le.blockquote=function(Z){var oe=this.rules.block.blockquote.exec(Z);if(oe){var pe=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(Z){var oe=this.rules.block.list.exec(Z);if(oe){var pe,we,Fe,Ue,ke,Pe,Te,W,q,Y,_,fe,be=oe[1].trim(),Ne=be.length>1,Ge={type:"list",raw:"",ordered:Ne,start:Ne?+be.slice(0,-1):"",loose:!1,items:[]};be=Ne?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Ne?be:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(fe=!1,!(!(oe=Ke.exec(Z))||this.rules.block.hr.test(Z)));){if(pe=oe[0],Z=Z.substring(pe.length),W=oe[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(Ue=2,_=W.trimLeft()):(Ue=oe[2].search(/[^ ]/),Ue=Ue>4?1:Ue,_=W.slice(Ue),Ue+=oe[1].length),Pe=!1,!W&&/^ *$/.test(q)&&(pe+=q+`
`,Z=Z.substring(q.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");Z&&(Y=Z.split(`
`,1)[0],W=Y,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(W)||nt.test(W)||tt.test(W)||rt.test(Z)));){if(W.search(/[^ ]/)>=Ue||!W.trim())_+=`
`+W.slice(Ue);else if(!Pe)_+=`
`+W;else break;!Pe&&!W.trim()&&(Pe=!0),pe+=Y+`
`,Z=Z.substring(Y.length+1)}Ge.loose||(Te?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(_),we&&(Fe=we[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:_}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=_.trimRight(),Ge.raw=Ge.raw.trimRight();var at=Ge.items.length;for(ke=0;ke<at;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var mt=Ge.items[ke].tokens.filter(function(ct){return ct.type==="space"}),ht=mt.every(function(ct){for(var Ie=ct.raw.split(""),ze=0,He=T(Ie),Oe;!(Oe=He()).done;){var je=Oe.value;if(je===`
`&&(ze+=1),ze>1)return!0}return!1});!Ge.loose&&mt.length&&ht&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},le.html=function(Z){var oe=this.rules.block.html.exec(Z);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},le.def=function(Z){var oe=this.rules.block.def.exec(Z);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},le.table=function(Z){var oe=this.rules.block.table.exec(Z);if(oe){var pe={type:"table",header:y(oe[1]).map(function(Te){return{text:Te}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var we=pe.align.length,Fe,Ue,ke,Pe;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Te){return{text:Te}});for(we=pe.header.length,Ue=0;Ue<we;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for(we=pe.rows.length,Ue=0;Ue<we;Ue++)for(Pe=pe.rows[Ue],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return pe}}},le.lheading=function(Z){var oe=this.rules.block.lheading.exec(Z);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},le.paragraph=function(Z){var oe=this.rules.block.paragraph.exec(Z);if(oe){var pe=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(Z){var oe=this.rules.block.text.exec(Z);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},le.escape=function(Z){var oe=this.rules.inline.escape.exec(Z);if(oe)return{type:"escape",raw:oe[0],text:b(oe[1])}},le.tag=function(Z){var oe=this.rules.inline.tag.exec(Z);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]):oe[0]}},le.link=function(Z){var oe=this.rules.inline.link.exec(Z);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=C(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=A(oe[2],"()");if(Fe>-1){var Ue=oe[0].indexOf("!")===0?5:4,ke=Ue+oe[1].length+Fe;oe[2]=oe[2].substring(0,Fe),oe[0]=oe[0].substring(0,ke).trim(),oe[3]=""}}var Pe=oe[2],Te="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);W&&(Pe=W[1],Te=W[3])}else Te=oe[3]?oe[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(pe)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),F(oe,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},le.reflink=function(Z,oe){var pe;if((pe=this.rules.inline.reflink.exec(Z))||(pe=this.rules.inline.nolink.exec(Z))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=oe[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,we,pe[0],this.lexer)}},le.emStrong=function(Z,oe,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(Z);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=we[0].length-1,ke,Pe,Te=Ue,W=0,q=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,oe=oe.slice(-1*Z.length+Ue);(we=q.exec(oe))!=null;)if(ke=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ke){if(Pe=ke.length,we[3]||we[4]){Te+=Pe;continue}else if((we[5]||we[6])&&Ue%3&&!((Ue+Pe)%3)){W+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+W),Math.min(Ue,Pe)%2){var Y=Z.slice(1,Ue+we.index+Pe);return{type:"em",raw:Z.slice(0,Ue+we.index+Pe+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var _=Z.slice(2,Ue+we.index+Pe-1);return{type:"strong",raw:Z.slice(0,Ue+we.index+Pe+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},le.codespan=function(Z){var oe=this.rules.inline.code.exec(Z);if(oe){var pe=oe[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=b(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},le.br=function(Z){var oe=this.rules.inline.br.exec(Z);if(oe)return{type:"br",raw:oe[0]}},le.del=function(Z){var oe=this.rules.inline.del.exec(Z);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},le.autolink=function(Z,oe){var pe=this.rules.inline.autolink.exec(Z);if(pe){var we,Fe;return pe[2]==="@"?(we=b(this.options.mangle?oe(pe[1]):pe[1]),Fe="mailto:"+we):(we=b(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},le.url=function(Z,oe){var pe;if(pe=this.rules.inline.url.exec(Z)){var we,Fe;if(pe[2]==="@")we=b(this.options.mangle?oe(pe[0]):pe[0]),Fe="mailto:"+we;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);we=b(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},le.inlineText=function(Z,oe){var pe=this.rules.inline.text.exec(Z);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):b(pe[0]):pe[0]:we=b(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=g(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=g(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=g(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=g(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=g(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=g(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:g(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=g(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=g(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=g(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=g(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=g(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=g(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=g(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=g(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=g(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=g(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=g(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:g(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=g(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:g(z.br).replace("{2,}","*").getRegex(),text:g(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(te){var le="",ue,Z,oe=te.length;for(ue=0;ue<oe;ue++)Z=te.charCodeAt(ue),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var K=function(){function te(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ce.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:j.normal,inline:z.normal};this.options.pedantic?(Z.block=j.pedantic,Z.inline=z.pedantic):this.options.gfm&&(Z.block=j.gfm,this.options.breaks?Z.inline=z.breaks:Z.inline=z.gfm),this.tokenizer.rules=Z}te.lex=function(Z,oe){var pe=new te(oe);return pe.lex(Z)},te.lexInline=function(Z,oe){var pe=new te(oe);return pe.inlineTokens(Z)};var le=te.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},le.blockTokens=function(Z,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Te,W,q){return W+"    ".repeat(q.length)});for(var we,Fe,Ue,ke;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(we=Te.call({lexer:pe},Z,oe))?(Z=Z.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.space(Z)){Z=Z.substring(we.raw.length),we.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(we);continue}if(we=this.tokenizer.code(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(we=this.tokenizer.fences(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.heading(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.hr(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.blockquote(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.list(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.html(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.def(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.lheading(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,W=Z.slice(1),q=void 0;pe.options.extensions.startBlock.forEach(function(Y){q=Y.call({lexer:this},W),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(Ue=Z.substring(0,Te+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ue))){Fe=oe[oe.length-1],ke&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we),ke=Ue.length!==Z.length,Z=Z.substring(we.raw.length);continue}if(we=this.tokenizer.text(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(Z){var Pe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,oe},le.inline=function(Z,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Z,tokens:oe}),oe},le.inlineTokens=function(Z,oe){var pe=this;oe===void 0&&(oe=[]);var we,Fe,Ue,ke=Z,Pe,Te,W;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)q.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+v("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+v("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Te||(W=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(we=_.call({lexer:pe},Z,oe))?(Z=Z.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.escape(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.tag(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.link(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.emStrong(Z,ke,W)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.codespan(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.br(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.del(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.autolink(Z,V)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(Z,V))){Z=Z.substring(we.raw.length),oe.push(we);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,fe=Z.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(Ne){be=Ne.call({lexer:this},fe),typeof be=="number"&&be>=0&&(_=Math.min(_,be))}),_<1/0&&_>=0&&(Ue=Z.substring(0,_+1))}(),we=this.tokenizer.inlineText(Ue,M)){Z=Z.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(W=we.raw.slice(-1)),Te=!0,Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(Z){var Y="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return oe},s(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),re=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.code=function(Z,oe,pe){var we=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Z,we);Fe!=null&&Fe!==Z&&(pe=!0,Z=Fe)}return Z=Z.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+b(we,!0)+'">'+(pe?Z:b(Z,!0))+`</code></pre>
`:"<pre><code>"+(pe?Z:b(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,oe,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+oe+' id="'+Fe+'">'+Z+"</h"+oe+`>
`}return"<h"+oe+">"+Z+"</h"+oe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,oe,pe){var we=oe?"ol":"ul",Fe=oe&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+Z+"</"+we+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+oe+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,oe){var pe=oe.header?"th":"td",we=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return we+Z+("</"+pe+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,oe,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<a href="'+b(Z)+'"';return oe&&(we+=' title="'+oe+'"'),we+=">"+pe+"</a>",we},le.image=function(Z,oe,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<img src="'+Z+'" alt="'+pe+'"';return oe&&(we+=' title="'+oe+'"'),we+=this.options.xhtml?"/>":">",we},le.text=function(Z){return Z},te}(),B=function(){function te(){}var le=te.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,oe,pe){return""+pe},le.image=function(Z,oe,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,oe){var pe=Z,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[Z];do we++,pe=Z+"-"+we;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[Z]=we,this.seen[pe]=0),pe},le.slug=function(Z,oe){oe===void 0&&(oe={});var pe=this.serialize(Z);return this.getNextSafeSlug(pe,oe.dryrun)},te}(),X=function(){function te(ue){this.options=ue||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new G}te.parse=function(Z,oe){var pe=new te(oe);return pe.parse(Z)},te.parseInline=function(Z,oe){var pe=new te(oe);return pe.parseInline(Z)};var le=te.prototype;return le.parse=function(Z,oe){oe===void 0&&(oe=!0);var pe="",we,Fe,Ue,ke,Pe,Te,W,q,Y,_,fe,be,Ne,Ge,Ke,tt,rt,ot,nt,at=Z.length;for(we=0;we<at;we++){if(_=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(nt=this.options.extensions.renderers[_.type].call({parser:this},_),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){pe+=nt||"";continue}switch(_.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(_.tokens),_.depth,m(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(q="",W="",ke=_.header.length,Fe=0;Fe<ke;Fe++)W+=this.renderer.tablecell(this.parseInline(_.header[Fe].tokens),{header:!0,align:_.align[Fe]});for(q+=this.renderer.tablerow(W),Y="",ke=_.rows.length,Fe=0;Fe<ke;Fe++){for(Te=_.rows[Fe],W="",Pe=Te.length,Ue=0;Ue<Pe;Ue++)W+=this.renderer.tablecell(this.parseInline(Te[Ue].tokens),{header:!1,align:_.align[Ue]});Y+=this.renderer.tablerow(W)}pe+=this.renderer.table(q,Y);continue}case"blockquote":{Y=this.parse(_.tokens),pe+=this.renderer.blockquote(Y);continue}case"list":{for(fe=_.ordered,be=_.start,Ne=_.loose,ke=_.items.length,Y="",Fe=0;Fe<ke;Fe++)Ke=_.items[Fe],tt=Ke.checked,rt=Ke.task,Ge="",Ke.task&&(ot=this.renderer.checkbox(tt),Ne?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ot+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ot+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ke.tokens,Ne),Y+=this.renderer.listitem(Ge,rt,tt);pe+=this.renderer.list(Y,fe,be);continue}case"html":{pe+=this.renderer.html(_.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Y=_.tokens?this.parseInline(_.tokens):_.text;we+1<at&&Z[we+1].type==="text";)_=Z[++we],Y+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);pe+=oe?this.renderer.paragraph(Y):Y;continue}default:{var mt='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return pe},le.parseInline=function(Z,oe){oe=oe||this.renderer;var pe="",we,Fe,Ue,ke=Z.length;for(we=0;we<ke;we++){if(Fe=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ue=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Ue||"";continue}switch(Fe.type){case"escape":{pe+=oe.text(Fe.text);break}case"html":{pe+=oe.html(Fe.text);break}case"link":{pe+=oe.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,oe));break}case"image":{pe+=oe.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=oe.strong(this.parseInline(Fe.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Fe.tokens,oe));break}case"codespan":{pe+=oe.codespan(Fe.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Fe.tokens,oe));break}case"text":{pe+=oe.text(Fe.text);break}default:{var Pe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return pe},te}();function ee(te,le,ue){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=D({},ee.defaults,le||{}),p(le),ue){var Z=le.highlight,oe;try{oe=K.lex(te,le)}catch(ke){return ue(ke)}var pe=function(Pe){var Te;if(!Pe)try{le.walkTokens&&ee.walkTokens(oe,le.walkTokens),Te=X.parse(oe,le)}catch(W){Pe=W}return le.highlight=Z,Pe?ue(Pe):ue(null,Te)};if(!Z||Z.length<3||(delete le.highlight,!oe.length))return pe();var we=0;ee.walkTokens(oe,function(ke){ke.type==="code"&&(we++,setTimeout(function(){Z(ke.text,ke.lang,function(Pe,Te){if(Pe)return pe(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=K.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(Ue,le.walkTokens)).then(function(){return X.parse(Ue,le)}).catch(Fe);ee.walkTokens(Ue,le.walkTokens)}return X.parse(Ue,le)}catch(ke){Fe(ke)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),R(ee.defaults),ee},ee.getDefaults=L,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),ue=0;ue<te;ue++)le[ue]=arguments[ue];var Z=D.apply(void 0,[{}].concat(le)),oe=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=oe.renderers?oe.renderers[Ue.name]:null;ke?oe.renderers[Ue.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),W=0;W<Pe;W++)Te[W]=arguments[W];var q=Ue.renderer.apply(this,Te);return q===!1&&(q=ke.apply(this,Te)),q}:oe.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[Ue.level]?oe[Ue.level].unshift(Ue.tokenizer):oe[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?oe.startBlock?oe.startBlock.push(Ue.start):oe.startBlock=[Ue.start]:Ue.level==="inline"&&(oe.startInline?oe.startInline.push(Ue.start):oe.startInline=[Ue.start]))}Ue.childTokens&&(oe.childTokens[Ue.name]=Ue.childTokens)})),we.renderer&&function(){var Ue=ee.defaults.renderer||new re,ke=function(W){var q=Ue[W];Ue[W]=function(){for(var Y=arguments.length,_=new Array(Y),fe=0;fe<Y;fe++)_[fe]=arguments[fe];var be=we.renderer[W].apply(Ue,_);return be===!1&&(be=q.apply(Ue,_)),be}};for(var Pe in we.renderer)ke(Pe);Z.renderer=Ue}(),we.tokenizer&&function(){var Ue=ee.defaults.tokenizer||new O,ke=function(W){var q=Ue[W];Ue[W]=function(){for(var Y=arguments.length,_=new Array(Y),fe=0;fe<Y;fe++)_[fe]=arguments[fe];var be=we.tokenizer[W].apply(Ue,_);return be===!1&&(be=q.apply(Ue,_)),be}};for(var Pe in we.tokenizer)ke(Pe);Z.tokenizer=Ue}(),we.walkTokens){var Fe=ee.defaults.walkTokens;Z.walkTokens=function(Ue){var ke=[];return ke.push(we.walkTokens.call(this,Ue)),Fe&&(ke=ke.concat(Fe.call(this,Ue))),ke}}pe&&(Z.extensions=oe),ee.setOptions(Z)})},ee.walkTokens=function(te,le){for(var ue=[],Z=function(){var Fe=pe.value;switch(ue=ue.concat(le.call(ee,Fe)),Fe.type){case"table":{for(var Ue=T(Fe.header),ke;!(ke=Ue()).done;){var Pe=ke.value;ue=ue.concat(ee.walkTokens(Pe.tokens,le))}for(var Te=T(Fe.rows),W;!(W=Te()).done;)for(var q=W.value,Y=T(q),_;!(_=Y()).done;){var fe=_.value;ue=ue.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{ue=ue.concat(ee.walkTokens(Fe.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(be){ue=ue.concat(ee.walkTokens(Fe[be],le))}):Fe.tokens&&(ue=ue.concat(ee.walkTokens(Fe.tokens,le)))}},oe=T(te),pe;!(pe=oe()).done;)Z();return ue},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=D({},ee.defaults,le||{}),p(le);try{var ue=K.lexInline(te,le);return le.walkTokens&&ee.walkTokens(ue,le.walkTokens),X.parseInline(ue,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(Z.message+"",!0)+"</pre>";throw Z}},ee.Parser=X,ee.parser=X.parse,ee.Renderer=re,ee.TextRenderer=B,ee.Lexer=K,ee.lexer=K.lex,ee.Tokenizer=O,ee.Slugger=G,ee.parse=ee;var de=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,J=ee.parseInline,U=ee,se=X.parse,ae=K.lex;ce.Lexer=K,ce.Parser=X,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=B,ce.Tokenizer=O,ce.getDefaults=L,ce.lexer=ae,ce.marked=ee,ce.options=de,ce.parse=U,ce.parseInline=J,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[41],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var s;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(s||(e.MarshalledId=s={}))}),define(Ee[178],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=s;function s(c){const m=T(c);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const I=new Uint32Array(10);function T(c){if(h=0,L(c,E,$.InitialConsonant),h>0||(L(c,l,$.Vowel),h>0)||(L(c,P,$.FinalConsonant),h>0)||(L(c,b,$.CompatibilityJamo),h))return I.subarray(0,h);if(c>=44032&&c<=55203){const m=c-44032,d=m%588,g=Math.floor(m/588),n=Math.floor(d/28),o=d%28-1;if(g<E.length?L(g,E,0):$.InitialConsonant+g-$.CompatibilityJamo<b.length&&L($.InitialConsonant+g,b,$.CompatibilityJamo),n<l.length?L(n,l,0):$.Vowel+n-$.CompatibilityJamo<b.length&&L($.Vowel+n-$.CompatibilityJamo,b,$.CompatibilityJamo),o>=0&&(o<P.length?L(o,P,0):$.FinalConsonant+o-$.CompatibilityJamo<b.length&&L($.FinalConsonant+o-$.CompatibilityJamo,b,$.CompatibilityJamo)),h>0)return I.subarray(0,h)}}function L(c,m,d){c>=d&&c<d+m.length&&R(m[c-d])}function R(c){c!==a.NUL&&(I[h++]=c&255,c>>8&&(I[h++]=c>>8&255),c>>16&&(I[h++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var a;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(a||(a={}));var k;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(k||(k={}));const E=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),l=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,k.hk,k.ho,k.hl,a.y,a.n,k.nj,k.np,k.nl,a.b,a.m,k.ml,a.l]),P=new Uint16Array([a.r,a.R,k.rt,a.s,k.sw,k.sg,a.e,a.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,a.a,a.q,k.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),b=new Uint16Array([a.r,a.R,k.rt,a.s,k.sw,k.sg,a.e,a.E,a.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,a.a,a.q,a.Q,k.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,k.hk,k.ho,k.hl,a.y,a.n,k.nj,k.np,k.nl,a.b,a.m,k.ml,a.l])}),define(Ee[82],Se([1,0,29]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=I,e.$om=L;const h=new s.$Gc(1e4);function I(a){return $(a,"NFC",h)}const T=new s.$Gc(1e4);function L(a){return $(a,"NFD",T)}const R=/[^\u0000-\u0080]/;function $(a,k,E){if(!a)return a;const l=E.get(a);if(l)return l;let P;return R.test(a)?P=a.normalize(k):P=a,E.set(a,P),P}e.$pm=function(){const a=/[\u0300-\u036f]/g;return function(k){return L(k).replace(a,"")}}()}),define(Ee[134],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=s,e.rot=h,e.$Qm=R;function s($,a,k){return Math.min(Math.max($,a),k)}function h($,a){return(a+$%a)%a}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=I;class T{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=T;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const k=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=L;function R($,a,k,E,l,P,b,c){const m=b-k,d=c-E,g=l-k,n=P-E,o=$-k,t=a-E,i=m*m+d*d,r=m*g+d*n,f=m*o+d*t,u=g*g+n*n,w=g*o+n*t,S=1/(i*u-r*r),D=(u*f-r*w)*S,y=(i*w-r*f)*S;return D>=0&&y>=0&&D+y<1}}),define(Ee[179],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=T,e.$fd=l;class s{constructor(b,c,m){this.owner=b,this.debugNameSource=c,this.referenceFn=m}getDebugName(b){return T(b,this)}}e.$dd=s;const h=new Map,I=new WeakMap;function T(P,b){const c=I.get(P);if(c)return c;const m=L(P,b);if(m){let d=h.get(m)??0;d++,h.set(m,d);const g=d===1?m:`${m}#${d}`;return I.set(P,g),g}}function L(P,b){const c=I.get(P);if(c)return c;const m=b.owner?k(b.owner)+".":"";let d;const g=b.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(d=g(),d!==void 0)return m+d}else return m+g;const n=b.referenceFn;if(n!==void 0&&(d=l(n),d!==void 0))return m+d;if(b.owner!==void 0){const o=R(b.owner,P);if(o!==void 0)return m+o}}function R(P,b){for(const c in P)if(P[c]===b)return c}const $=new Map,a=new WeakMap;function k(P){const b=a.get(P);if(b)return b;const c=E(P);let m=$.get(c)??0;m++,$.set(c,m);const d=m===1?c:`${c}#${m}`;return a.set(P,d),d}function E(P){const b=P.constructor;return b?b.name:"Object"}function l(P){const b=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(m?m[1]:void 0)?.trim()}}),define(Ee[180],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=h,e.$Nd=I;let s;function h(c){s=c}function I(){return s}class T{constructor(){this.a=0,this.d=new WeakMap}b(m){return L([R(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[R(" "),a(k(m.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),a(k(m.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),a(k(m.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(m,d){console.log(...this.b([$("observable value changed"),a(m.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(m){if(m.size!==0)return a(" (changed deps: "+[...m].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const d=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,n)=>(this.d.get(m).add(g),d.apply(m,[g,n]))}handleDerivedRecomputed(m,d){const g=this.d.get(m);console.log(...this.b([$("derived recomputed"),a(m.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(g),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(m,d){console.log(...this.b([$("observable from event triggered"),a(m.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const d=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,n)=>(this.d.get(m).add(g),d.apply(m,[g,n]))}handleAutorunTriggered(m){const d=this.d.get(m);console.log(...this.b([$("autorun"),a(m.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let d=m.getDebugName();d===void 0&&(d=""),console.log(...this.b([$("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=T;function L(c){const m=new Array,d=[];let g="";function n(t){if("length"in t)for(const i of t)i&&n(i);else"text"in t?(g+=`%c${t.text}`,m.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}n(c);const o=[g,...m];return o.push(...d),o}function R(c){return a(c,{color:"black"})}function $(c){return a(b(`${c}: `,10),{color:"black",bold:!0})}function a(c,m={color:"black"}){function d(n){return Object.entries(n).reduce((o,[t,i])=>`${o}${t}:${i};`,"")}const g={color:m.color};return m.strikeThrough&&(g["text-decoration"]="line-through"),m.bold&&(g["font-weight"]="bold"),{text:c,style:d(g)}}function k(c,m){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=m?`"${c}"`:`"${c.substr(0,m-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?E(c,m):l(c,m);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function E(c,m){let d="[ ",g=!0;for(const n of c){if(g||(d+=", "),d.length-5>m){d+="...";break}g=!1,d+=`${k(n,m-d.length)}`}return d+=" ]",d}function l(c,m){let d="{ ",g=!0;for(const[n,o]of Object.entries(c)){if(g||(d+=", "),d.length-5>m){d+="...";break}g=!1,d+=`${n}: ${k(o,m-d.length)}`}return d+=" }",d}function P(c,m){let d="";for(let g=1;g<=m;g++)d+=c;return d}function b(c,m){for(;c.length<m;)c+=" ";return c}}),define(Ee[181],Se([1,0,175,179,180]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=L,e.$Yd=$,e.$Zd=k,e.$3d=P,e.$4d=c,e.$5d=m,e.$6d=d,e.$8d=n,e.$0d=t;let T;function L(r){T=r}let R;function $(r){R=r}let a;function k(r){a=r}class E{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,u){const w=u===void 0?void 0:f,S=u===void 0?f:u;return a({owner:w,debugName:()=>{const D=(0,h.$fd)(S);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:S},D=>S(this.read(D),D))}recomputeInitiallyAndOnChange(f,u){return f.add(T(this,u)),this}keepObserved(f){return f.add(R(this)),this}get a(){return this.get()}}e.$1d=E;class l extends E{constructor(){super(...arguments),this.b=new Set}addObserver(f){const u=this.b.size;this.b.add(f),u===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=l;function P(r,f){const u=new g(r,f);try{r(u)}finally{u.finish()}}let b;function c(r){if(b)r(b);else{const f=new g(r,void 0);b=f;try{r(f)}finally{f.finish(),b=void 0}}}async function m(r,f){const u=new g(r,f);try{await r(u)}finally{u.finish()}}function d(r,f,u){r?f(r):P(f,u)}class g{constructor(f,u){this._fn=f,this.b=u,this.a=[],(0,I.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$fd)(this._fn)}updateObserver(f,u){this.a.push({observer:f,observable:u}),f.beginUpdate(u)}finish(){const f=this.a;for(let u=0;u<f.length;u++){const{observer:w,observable:S}=f[u];w.endUpdate(S)}this.a=null,(0,I.$Nd)()?.handleEndTransaction()}}e.$7d=g;function n(r,f){let u;return typeof r=="string"?u=new h.$dd(void 0,r,void 0):u=new h.$dd(r,void 0,void 0),new o(u,f,s.$9c)}class o extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,u,w){super(),this.e=f,this.g=w,this.d=u}get(){return this.d}set(f,u,w){if(w===void 0&&this.g(this.d,f))return;let S;u||(u=S=new g(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(f),(0,I.$Nd)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:w,didChange:!0,hadValue:!0});for(const y of this.b)u.updateObserver(y,this),y.handleChange(this,w)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$9d=o;function t(r,f){let u;return typeof r=="string"?u=new h.$dd(void 0,r,void 0):u=new h.$dd(r,void 0,void 0),new i(u,f,s.$9c)}class i extends o{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$$d=i}),function(){function ce(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function L($){T.push($,Date.now())}function R(){const $=[];for(let a=0;a<T.length;a+=2)$.push({name:T[a],startTime:T[a+1]});return $}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(I+L.startTime)});return T}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function s(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=s(h))}(),define(Ee[182],Se([1,0,40]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const h=Symbol("unset");class I{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||s.Iterable.empty()}insert($,a,k){this.d($,E=>E._value=a,k)}mutate($,a){this.d($,k=>k._value=a(k._value===h?void 0:k._value))}mutatePath($,a){this.d($,()=>{},k=>a(k))}delete($){const a=this.c($);if(!a)return;let k=a.length-1;const E=a[k].node._value;if(E!==h){for(this.b--,a[k].node._value=h;k>0;k--){const{node:l,part:P}=a[k];if(l.children?.size||l._value!==h)break;a[k-1].node.children.delete(P)}return E}}*deleteRecursive($){const a=this.c($);if(!a)return;const k=a[a.length-1].node;for(let E=a.length-1;E>0;E--){const l=a[E-1];if(l.node.children.delete(a[E].part),l.node.children.size>0||l.node._value!==h)break}for(const E of T(k))E._value!==h&&(this.b--,yield E._value)}find($){let a=this.a;for(const k of $){const E=a.children?.get(k);if(!E)return;a=E}return a._value===h?void 0:a._value}hasKeyOrParent($){let a=this.a;for(const k of $){const E=a.children?.get(k);if(!E)return!1;if(E._value!==h)return!0;a=E}return!1}hasKeyOrChildren($){let a=this.a;for(const k of $){const E=a.children?.get(k);if(!E)return!1;a=E}return!0}hasKey($){let a=this.a;for(const k of $){const E=a.children?.get(k);if(!E)return!1;a=E}return a._value!==h}c($){const a=[{part:"",node:this.a}];let k=0;for(const E of $){const l=a[k].node.children?.get(E);if(!l)return;a.push({part:E,node:l}),k++}return a}d($,a,k){let E=this.a;for(const b of $){if(E.children)if(E.children.has(b))E=E.children.get(b);else{const c=new L;E.children.set(b,c),E=c}else{const c=new L;E.children=new Map([[b,c]]),E=c}k?.(E)}const l=E._value===h?0:1;a(E);const P=E._value===h?0:1;this.b+=P-l}*values(){for(const{_value:$}of T(this.a))$!==h&&(yield $)}}e.$SI=I;function*T(R){const $=[R];for(;$.length>0;){const a=$.pop();if(yield a,a.children)for(const k of a.children.values())$.push(k)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var h in s)(typeof exports=="object"?exports:ce)[h]=s[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function s(h){if(e[h])return e[h].exports;var I=e[h]={i:h,l:!1,exports:{}};return ce[h].call(I.exports,I,I.exports,s),I.l=!0,I.exports}return s.m=ce,s.c=e,s.d=function(h,I,T){s.o(h,I)||Object.defineProperty(h,I,{enumerable:!0,get:T})},s.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},s.t=function(h,I){if(1&I&&(h=s(h)),8&I||4&I&&typeof h=="object"&&h&&h.__esModule)return h;var T=Object.create(null);if(s.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:h}),2&I&&typeof h!="string")for(var L in h)s.d(T,L,function(R){return h[R]}.bind(null,L));return T},s.n=function(h){var I=h&&h.__esModule?function(){return h.default}:function(){return h};return s.d(I,"a",I),I},s.o=function(h,I){return Object.prototype.hasOwnProperty.call(h,I)},s.p="",s(s.s=0)}([function(ce,e,s){(function(h){var I;e=ce.exports=De,I=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],$=e.src=[],a=0,k=a++;$[k]="0|[1-9]\\d*";var E=a++;$[E]="[0-9]+";var l=a++;$[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=a++;$[P]="("+$[k]+")\\.("+$[k]+")\\.("+$[k]+")";var b=a++;$[b]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var c=a++;$[c]="(?:"+$[k]+"|"+$[l]+")";var m=a++;$[m]="(?:"+$[E]+"|"+$[l]+")";var d=a++;$[d]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var g=a++;$[g]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var n=a++;$[n]="[0-9A-Za-z-]+";var o=a++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var t=a++,i="v?"+$[P]+$[d]+"?"+$[o]+"?";$[t]="^"+i+"$";var r="[v=\\s]*"+$[b]+$[g]+"?"+$[o]+"?",f=a++;$[f]="^"+r+"$";var u=a++;$[u]="((?:<|>)?=?)";var w=a++;$[w]=$[E]+"|x|X|\\*";var S=a++;$[S]=$[k]+"|x|X|\\*";var D=a++;$[D]="[v=\\s]*("+$[S]+")(?:\\.("+$[S]+")(?:\\.("+$[S]+")(?:"+$[d]+")?"+$[o]+"?)?)?";var y=a++;$[y]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[g]+")?"+$[o]+"?)?)?";var C=a++;$[C]="^"+$[u]+"\\s*"+$[D]+"$";var A=a++;$[A]="^"+$[u]+"\\s*"+$[y]+"$";var p=a++;$[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=a++;$[v]="(?:~>?)";var F=a++;$[F]="(\\s*)"+$[v]+"\\s+",R[F]=new RegExp($[F],"g");var N=a++;$[N]="^"+$[v]+$[D]+"$";var O=a++;$[O]="^"+$[v]+$[y]+"$";var j=a++;$[j]="(?:\\^)";var z=a++;$[z]="(\\s*)"+$[j]+"\\s+",R[z]=new RegExp($[z],"g");var M=a++;$[M]="^"+$[j]+$[D]+"$";var V=a++;$[V]="^"+$[j]+$[y]+"$";var K=a++;$[K]="^"+$[u]+"\\s*("+r+")$|^$";var re=a++;$[re]="^"+$[u]+"\\s*("+i+")$|^$";var B=a++;$[B]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[D]+")",R[B]=new RegExp($[B],"g");var G=a++;$[G]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var X=a++;$[X]="^\\s*("+$[y]+")\\s+-\\s+("+$[y]+")\\s*$";var ee=a++;$[ee]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)I(de,$[de]),R[de]||(R[de]=new RegExp($[de]));function ne(q,Y){if(q instanceof De)return q;if(typeof q!="string"||q.length>T||!(Y?R[f]:R[t]).test(q))return null;try{return new De(q,Y)}catch{return null}}function De(q,Y){if(q instanceof De){if(q.loose===Y)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof De))return new De(q,Y);I("SemVer",q,Y),this.loose=Y;var _=q.trim().match(Y?R[f]:R[t]);if(!_)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var be=+fe;if(be>=0&&be<L)return be}return fe}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=ne,e.valid=function(q,Y){var _=ne(q,Y);return _?_.version:null},e.clean=function(q,Y){var _=ne(q.trim().replace(/^[=v]+/,""),Y);return _?_.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(q){return I("SemVer.compare",this.version,this.loose,q),q instanceof De||(q=new De(q,this.loose)),this.compareMain(q)||this.comparePre(q)},De.prototype.compareMain=function(q){return q instanceof De||(q=new De(q,this.loose)),J(this.major,q.major)||J(this.minor,q.minor)||J(this.patch,q.patch)},De.prototype.comparePre=function(q){if(q instanceof De||(q=new De(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Y=0;do{var _=this.prerelease[Y],fe=q.prerelease[Y];if(I("prerelease compare",Y,_,fe),_===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(_===void 0)return-1;if(_!==fe)return J(_,fe)}while(++Y)},De.prototype.inc=function(q,Y){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Y,_,fe){typeof _=="string"&&(fe=_,_=void 0);try{return new De(q,_).inc(Y,fe).version}catch{return null}},e.diff=function(q,Y){if(te(q,Y))return null;var _=ne(q),fe=ne(Y);if(_.prerelease.length||fe.prerelease.length){for(var be in _)if((be==="major"||be==="minor"||be==="patch")&&_[be]!==fe[be])return"pre"+be;return"prerelease"}for(var be in _)if((be==="major"||be==="minor"||be==="patch")&&_[be]!==fe[be])return be},e.compareIdentifiers=J;var $e=/^[0-9]+$/;function J(q,Y){var _=$e.test(q),fe=$e.test(Y);return _&&fe&&(q=+q,Y=+Y),_&&!fe?-1:fe&&!_?1:q<Y?-1:q>Y?1:0}function U(q,Y,_){return new De(q,_).compare(new De(Y,_))}function se(q,Y,_){return U(q,Y,_)>0}function ae(q,Y,_){return U(q,Y,_)<0}function te(q,Y,_){return U(q,Y,_)===0}function le(q,Y,_){return U(q,Y,_)!==0}function ue(q,Y,_){return U(q,Y,_)>=0}function Z(q,Y,_){return U(q,Y,_)<=0}function oe(q,Y,_,fe){var be;switch(Y){case"===":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),be=q===_;break;case"!==":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),be=q!==_;break;case"":case"=":case"==":be=te(q,_,fe);break;case"!=":be=le(q,_,fe);break;case">":be=se(q,_,fe);break;case">=":be=ue(q,_,fe);break;case"<":be=ae(q,_,fe);break;case"<=":be=Z(q,_,fe);break;default:throw new TypeError("Invalid operator: "+Y)}return be}function pe(q,Y){if(q instanceof pe){if(q.loose===Y)return q;q=q.value}if(!(this instanceof pe))return new pe(q,Y);I("comparator",q,Y),this.loose=Y,this.parse(q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(q,Y){return J(Y,q)},e.major=function(q,Y){return new De(q,Y).major},e.minor=function(q,Y){return new De(q,Y).minor},e.patch=function(q,Y){return new De(q,Y).patch},e.compare=U,e.compareLoose=function(q,Y){return U(q,Y,!0)},e.rcompare=function(q,Y,_){return U(Y,q,_)},e.sort=function(q,Y){return q.sort(function(_,fe){return e.compare(_,fe,Y)})},e.rsort=function(q,Y){return q.sort(function(_,fe){return e.rcompare(_,fe,Y)})},e.gt=se,e.lt=ae,e.eq=te,e.neq=le,e.gte=ue,e.lte=Z,e.cmp=oe,e.Comparator=pe;var we={};function Fe(q,Y){if(q instanceof Fe)return q.loose===Y?q:new Fe(q.raw,Y);if(q instanceof pe)return new Fe(q.value,Y);if(!(this instanceof Fe))return new Fe(q,Y);if(this.loose=Y,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ue(q){return!q||q.toLowerCase()==="x"||q==="*"}function ke(q,Y,_,fe,be,Ne,Ge,Ke,tt,rt,ot,nt,at){return((Y=Ue(_)?"":Ue(fe)?">="+_+".0.0":Ue(be)?">="+_+"."+fe+".0":">="+Y)+" "+(Ke=Ue(tt)?"":Ue(rt)?"<"+(+tt+1)+".0.0":Ue(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+Ke)).trim()}function Pe(q,Y){for(var _=0;_<q.length;_++)if(!q[_].test(Y))return!1;if(Y.prerelease.length){for(_=0;_<q.length;_++)if(I(q[_].semver),q[_].semver!==we&&q[_].semver.prerelease.length>0){var fe=q[_].semver;if(fe.major===Y.major&&fe.minor===Y.minor&&fe.patch===Y.patch)return!0}return!1}return!0}function Te(q,Y,_){try{Y=new Fe(Y,_)}catch{return!1}return Y.test(q)}function W(q,Y,_,fe){var be,Ne,Ge,Ke,tt;switch(q=new De(q,fe),Y=new Fe(Y,fe),_){case">":be=se,Ne=Z,Ge=ae,Ke=">",tt=">=";break;case"<":be=ae,Ne=ue,Ge=se,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,Y,fe))return!1;for(var rt=0;rt<Y.set.length;++rt){var ot=Y.set[rt],nt=null,at=null;if(ot.forEach(function(mt){mt.semver===we&&(mt=new pe(">=0.0.0")),nt=nt||mt,at=at||mt,be(mt.semver,nt.semver,fe)?nt=mt:Ge(mt.semver,at.semver,fe)&&(at=mt)}),nt.operator===Ke||nt.operator===tt||(!at.operator||at.operator===Ke)&&Ne(q,at.semver)||at.operator===tt&&Ge(q,at.semver))return!1}return!0}pe.prototype.parse=function(q){var Y=this.loose?R[K]:R[re],_=q.match(Y);if(!_)throw new TypeError("Invalid comparator: "+q);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new De(_[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(q){return I("Comparator.test",q,this.loose),this.semver===we||(typeof q=="string"&&(q=new De(q,this.loose)),oe(q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(q,Y){if(!(q instanceof pe))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Fe(q.value,Y),Te(this.value,_,Y);if(q.operator==="")return _=new Fe(this.value,Y),Te(q.semver,_,Y);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ne=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ke=oe(this.semver,"<",q.semver,Y)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=oe(this.semver,">",q.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||be||Ne&&Ge||Ke||tt},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(q){var Y=this.loose;q=q.trim(),I("range",q,Y);var _=Y?R[X]:R[G];q=q.replace(_,ke),I("hyphen replace",q),q=q.replace(R[B],"$1$2$3"),I("comparator trim",q,R[B]),q=(q=(q=q.replace(R[F],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var fe=Y?R[K]:R[re],be=q.split(" ").map(function(Ne){return function(Ge,Ke){return I("comp",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){I("caret",nt,at);var mt=at?R[V]:R[M];return nt.replace(mt,function(ht,ct,Ie,ze,He){var Oe;return I("caret",nt,ht,ct,Ie,ze,He),Ue(ct)?Oe="":Ue(Ie)?Oe=">="+ct+".0.0 <"+(+ct+1)+".0.0":Ue(ze)?Oe=ct==="0"?">="+ct+"."+Ie+".0 <"+ct+"."+(+Ie+1)+".0":">="+ct+"."+Ie+".0 <"+(+ct+1)+".0.0":He?(I("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Oe=ct==="0"?Ie==="0"?">="+ct+"."+Ie+"."+ze+He+" <"+ct+"."+Ie+"."+(+ze+1):">="+ct+"."+Ie+"."+ze+He+" <"+ct+"."+(+Ie+1)+".0":">="+ct+"."+Ie+"."+ze+He+" <"+(+ct+1)+".0.0"):(I("no pr"),Oe=ct==="0"?Ie==="0"?">="+ct+"."+Ie+"."+ze+" <"+ct+"."+Ie+"."+(+ze+1):">="+ct+"."+Ie+"."+ze+" <"+ct+"."+(+Ie+1)+".0":">="+ct+"."+Ie+"."+ze+" <"+(+ct+1)+".0.0"),I("caret return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Ke),I("caret",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){var mt=at?R[O]:R[N];return nt.replace(mt,function(ht,ct,Ie,ze,He){var Oe;return I("tilde",nt,ht,ct,Ie,ze,He),Ue(ct)?Oe="":Ue(Ie)?Oe=">="+ct+".0.0 <"+(+ct+1)+".0.0":Ue(ze)?Oe=">="+ct+"."+Ie+".0 <"+ct+"."+(+Ie+1)+".0":He?(I("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Oe=">="+ct+"."+Ie+"."+ze+He+" <"+ct+"."+(+Ie+1)+".0"):Oe=">="+ct+"."+Ie+"."+ze+" <"+ct+"."+(+Ie+1)+".0",I("tilde return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Ke),I("tildes",Ge),Ge=function(tt,rt){return I("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,at){nt=nt.trim();var mt=at?R[A]:R[C];return nt.replace(mt,function(ht,ct,Ie,ze,He,Oe){I("xRange",nt,ht,ct,Ie,ze,He,Oe);var je=Ue(Ie),he=je||Ue(ze),x=he||Ue(He);return ct==="="&&x&&(ct=""),je?ht=ct===">"||ct==="<"?"<0.0.0":"*":ct&&x?(he&&(ze=0),x&&(He=0),ct===">"?(ct=">=",he?(Ie=+Ie+1,ze=0,He=0):x&&(ze=+ze+1,He=0)):ct==="<="&&(ct="<",he?Ie=+Ie+1:ze=+ze+1),ht=ct+Ie+"."+ze+"."+He):he?ht=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":x&&(ht=">="+Ie+"."+ze+".0 <"+Ie+"."+(+ze+1)+".0"),I("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Ke),I("xrange",Ge),Ge=function(tt,rt){return I("replaceStars",tt,rt),tt.trim().replace(R[ee],"")}(Ge,Ke),I("stars",Ge),Ge}(Ne,Y)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ne){return!!Ne.match(fe)})),be=be.map(function(Ne){return new pe(Ne,Y)})},Fe.prototype.intersects=function(q,Y){if(!(q instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(fe){return q.set.some(function(be){return be.every(function(Ne){return fe.intersects(Ne,Y)})})})})},e.toComparators=function(q,Y){return new Fe(q,Y).set.map(function(_){return _.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new De(q,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Pe(this.set[Y],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,Y,_){var fe=null,be=null;try{var Ne=new Fe(Y,_)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(fe&&be.compare(Ge)!==-1||(be=new De(fe=Ge,_)))}),fe},e.minSatisfying=function(q,Y,_){var fe=null,be=null;try{var Ne=new Fe(Y,_)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(fe&&be.compare(Ge)!==1||(be=new De(fe=Ge,_)))}),fe},e.validRange=function(q,Y){try{return new Fe(q,Y).range||"*"}catch{return null}},e.ltr=function(q,Y,_){return W(q,Y,"<",_)},e.gtr=function(q,Y,_){return W(q,Y,">",_)},e.outside=W,e.prerelease=function(q,Y){var _=ne(q,Y);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(q,Y,_){return q=new Fe(q,_),Y=new Fe(Y,_),q.intersects(Y)},e.coerce=function(q){if(q instanceof De)return q;if(typeof q!="string")return null;var Y=q.match(R[p]);return Y==null?null:ne((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,s(1))},function(ce,e){var s,h,I=ce.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(m){if(s===setTimeout)return setTimeout(m,0);if((s===T||!s)&&setTimeout)return s=setTimeout,setTimeout(m,0);try{return s(m,0)}catch{try{return s.call(null,m,0)}catch{return s.call(this,m,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:T}catch{s=T}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var $,a=[],k=!1,E=-1;function l(){k&&$&&(k=!1,$.length?a=$.concat(a):E=-1,a.length&&P())}function P(){if(!k){var m=R(l);k=!0;for(var d=a.length;d;){for($=a,a=[];++E<d;)$&&$[E].run();E=-1,d=a.length}$=null,k=!1,function(g){if(h===clearTimeout)return clearTimeout(g);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(g);try{h(g)}catch{try{return h.call(null,g)}catch{return h.call(this,g)}}}(m)}}function b(m,d){this.fun=m,this.array=d}function c(){}I.nextTick=function(m){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];a.push(new b(m,d)),a.length!==1||k||R(P)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=c,I.addListener=c,I.once=c,I.off=c,I.removeListener=c,I.removeAllListeners=c,I.emit=c,I.prependListener=c,I.prependOnceListener=c,I.listeners=function(m){return[]},I.binding=function(m){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(m){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ee[43],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(T){return new h(T)}constructor(T){this.c=s&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=h}),define(Ee[4],Se([1,0,14,80,3,81,43]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=P;const R=!1,$=!1,a=!1;var k;(function(O){O.None=()=>I.$Xc.None;function j(ke){if(a){const{onDidAddListener:Pe}=ke,Te=c.create();let W=0;ke.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),Pe?.()}}}function z(ke,Pe){return ne(ke,()=>{},0,void 0,!0,void 0,Pe)}O.defer=z;function M(ke){return(Pe,Te=null,W)=>{let q=!1,Y;return Y=ke(_=>{if(!q)return Y?Y.dispose():q=!0,Pe.call(Te,_)},null,W),q&&Y.dispose(),Y}}O.once=M;function V(ke,Pe,Te){return ee((W,q=null,Y)=>ke(_=>W.call(q,Pe(_)),null,Y),Te)}O.map=V;function K(ke,Pe,Te){return ee((W,q=null,Y)=>ke(_=>{Pe(_),W.call(q,_)},null,Y),Te)}O.forEach=K;function re(ke,Pe,Te){return ee((W,q=null,Y)=>ke(_=>Pe(_)&&W.call(q,_),null,Y),Te)}O.filter=re;function B(ke){return ke}O.signal=B;function G(...ke){return(Pe,Te=null,W)=>{const q=(0,I.$Uc)(...ke.map(Y=>Y(_=>Pe.call(Te,_))));return de(q,W)}}O.any=G;function X(ke,Pe,Te,W){let q=Te;return V(ke,Y=>(q=Pe(q,Y),q),W)}O.reduce=X;function ee(ke,Pe){let Te;const W={onWillAddFirstListener(){Te=ke(q.fire,q)},onDidRemoveLastListener(){Te?.dispose()}};Pe||j(W);const q=new r(W);return Pe?.add(q),q.event}function de(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function ne(ke,Pe,Te=100,W=!1,q=!1,Y,_){let fe,be,Ne,Ge=0,Ke;const tt={leakWarningThreshold:Y,onWillAddFirstListener(){fe=ke(ot=>{Ge++,be=Pe(be,ot),W&&!Ne&&(rt.fire(be),be=void 0),Ke=()=>{const nt=be;be=void 0,Ne=void 0,(!W||Ge>1)&&rt.fire(nt),Ge=0},typeof Te=="number"?(clearTimeout(Ne),Ne=setTimeout(Ke,Te)):Ne===void 0&&(Ne=0,queueMicrotask(Ke))})},onWillRemoveListener(){q&&Ge>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,fe.dispose()}};_||j(tt);const rt=new r(tt);return _?.add(rt),rt.event}O.debounce=ne;function De(ke,Pe=0,Te){return O.debounce(ke,(W,q)=>W?(W.push(q),W):[q],Pe,void 0,!0,void 0,Te)}O.accumulate=De;function $e(ke,Pe=(W,q)=>W===q,Te){let W=!0,q;return re(ke,Y=>{const _=W||!Pe(Y,q);return W=!1,q=Y,_},Te)}O.latch=$e;function J(ke,Pe,Te){return[O.filter(ke,Pe,Te),O.filter(ke,W=>!Pe(W),Te)]}O.split=J;function U(ke,Pe=!1,Te=[],W){let q=Te.slice(),Y=ke(be=>{q?q.push(be):fe.fire(be)});W&&W.add(Y);const _=()=>{q?.forEach(be=>fe.fire(be)),q=null},fe=new r({onWillAddFirstListener(){Y||(Y=ke(be=>fe.fire(be)),W&&W.add(Y))},onDidAddFirstListener(){q&&(Pe?setTimeout(_):_())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return W&&W.add(fe),fe.event}O.buffer=U;function se(ke,Pe){return(W,q,Y)=>{const _=Pe(new te);return ke(function(fe){const be=_.evaluate(fe);be!==ae&&W.call(q,be)},void 0,Y)}}O.chain=se;const ae=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Te=>(Pe(Te),Te)),this}filter(Pe){return this.f.push(Te=>Pe(Te)?Te:ae),this}reduce(Pe,Te){let W=Te;return this.f.push(q=>(W=Pe(W,q),W)),this}latch(Pe=(Te,W)=>Te===W){let Te=!0,W;return this.f.push(q=>{const Y=Te||!Pe(q,W);return Te=!1,W=q,Y?q:ae}),this}evaluate(Pe){for(const Te of this.f)if(Pe=Te(Pe),Pe===ae)break;return Pe}}function le(ke,Pe,Te=W=>W){const W=(...fe)=>_.fire(Te(...fe)),q=()=>ke.on(Pe,W),Y=()=>ke.removeListener(Pe,W),_=new r({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return _.event}O.fromNodeEventEmitter=le;function ue(ke,Pe,Te=W=>W){const W=(...fe)=>_.fire(Te(...fe)),q=()=>ke.addEventListener(Pe,W),Y=()=>ke.removeEventListener(Pe,W),_=new r({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return _.event}O.fromDOMEventEmitter=ue;function Z(ke){return new Promise(Pe=>M(ke)(Pe))}O.toPromise=Z;function oe(ke){const Pe=new r;return ke.then(Te=>{Pe.fire(Te)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}O.fromPromise=oe;function pe(ke,Pe,Te){return Pe(Te),ke(W=>Pe(W))}O.runAndSubscribe=pe;class we{constructor(Pe,Te){this._observable=Pe,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Te||j(W),this.emitter=new r(W),Te&&Te.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Te){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(ke,Pe){return new we(ke,Pe).emitter.event}O.fromObservable=Fe;function Ue(ke){return(Pe,Te,W)=>{let q=0,Y=!1;const _={beginUpdate(){q++},endUpdate(){q--,q===0&&(ke.reportChanges(),Y&&(Y=!1,Pe.call(Te)))},handlePossibleChange(){},handleChange(){Y=!0}};ke.addObserver(_),ke.reportChanges();const fe={dispose(){ke.removeObserver(_)}};return W instanceof I.$Wc?W.add(fe):Array.isArray(W)&&W.push(fe),fe}}O.fromObservableLight=Ue})(k||(e.Event=k={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new L.$he,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$je=E;let l=-1;function P(O){const j=l;return l=O,{dispose(){l=j}}}class b{static{this.f=1}constructor(j,z,M=(b.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=M,this.h=0}dispose(){this.g?.clear()}check(j,z){const M=this.threshold;if(M<=0||z<M)return;this.g||(this.g=new Map);const V=this.g.get(j.value)||0;if(this.g.set(j.value,V+1),this.h-=1,this.h<=0){this.h=M*.5;const[K,re]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${re}):`;console.warn(B),console.warn(K);const G=new m(B,K);this.j(G)}return()=>{const K=this.g.get(j.value)||0;this.g.set(j.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[M,V]of this.g)(!j||z<V)&&(j=[M,V],z=V);return j}}class c{static create(){const j=new Error;return new c(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$le=m;class d extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$me=d;let g=0;class n{constructor(j){this.value=j,this.id=g++}}const o=2,t=(O,j)=>{if(O instanceof n)j(O);else for(let z=0;z<O.length;z++){const M=O[z];M&&j(M)}};let i;if(R){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),i=new FinalizationRegistry(j=>{typeof j=="string"&&O.push(j)})}class r{constructor(j){this.z=0,this.f=j,this.g=l>0||this.f?.leakWarningThreshold?new b(j?.onListenerError??s.$3,this.f?.leakWarningThreshold??l):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,M)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const X=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new d(`${G}. HINT: Stack shows most frequent listener (${X[1]}-times)`,X[0]);return(this.f?.onListenerError||s.$3)(ee),I.$Xc.None}if(this.m)return I.$Xc.None;z&&(j=j.bind(z));const V=new n(j);let K,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(V.stack=c.create(),K=this.g.check(V.stack,this.z+1)),$&&(V.stack=re??c.create()),this.u?this.u instanceof n?(this.w??=new u,this.u=[this.u,V]):this.u.push(V):(this.f?.onWillAddFirstListener?.(this),this.u=V,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,I.$Vc)(()=>{i?.unregister(B),K?.(),this.A(V)});if(M instanceof I.$Wc?M.add(B):Array.isArray(M)&&M.push(B),i){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),X=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);i.register(B,X?.[2]??G,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,M=z.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[M]=void 0;const V=this.w.current===this;if(this.z*o<=z.length){let K=0;for(let re=0;re<z.length;re++)z[re]?z[K++]=z[re]:V&&(this.w.end--,K<this.w.i&&this.w.i--);z.length=K}}B(j,z){if(!j)return;const M=this.f?.onListenerError||s.$3;if(!M){j.value(z);return}try{j.value(z)}catch(V){M(V)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=r;const f=()=>new u;e.$oe=f;class u{constructor(){this.i=-1,this.end=0}enqueue(j,z,M){this.i=0,this.end=M,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends r{async fireAsync(j,z,M){if(this.u)for(this.h||(this.h=new T.$8c),t(this.u,V=>this.h.push([V.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[V,K]=this.h.shift(),re=[],B={...K,token:z,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");M&&(G=M(G,V)),re.push(G)}};try{V(B)}catch(G){(0,s.$3)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const X of G)X.status==="rejected"&&(0,s.$3)(X.reason)})}}}e.$pe=w;class S extends r{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new T.$8c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$qe=S;class D extends S{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$re=D;class y extends r{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$se=y;class C{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const M=()=>{this.g&&this.o(z);const V=this.h.indexOf(z);this.h.splice(V,1)};return(0,I.$Vc)((0,h.$gb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$te=C;class A{constructor(j,z,M,V){this.f=new I.$Wc;const K=this.f.add(new C),re=this.f.add(new I.$7c);function B(G){re.set(G,K.add(V(G)))}for(const G of j)B(G);this.f.add(z(G=>{B(G)})),this.f.add(M(G=>{re.deleteAndDispose(G)})),this.event=K.event}dispose(){this.f.dispose()}}e.$ue=A;class p{constructor(){this.f=[]}wrapEvent(j,z,M){return(V,K,re)=>j(B=>{const G=this.f[this.f.length-1];if(!z){G?G.buffers.push(()=>V.call(K,B)):V.call(K,B);return}const X=G;if(!X){V.call(K,z(M,B));return}X.items??=[],X.items.push(B),X.buffers.length===0&&G.buffers.push(()=>{X.reducedResult??=M?X.items.reduce(z,M):X.items.reduce(z),V.call(K,X.reducedResult)})},void 0,re)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const M=j();return this.f.pop(),z.buffers.forEach(V=>V()),M}}e.$ve=p;class v{constructor(){this.f=!1,this.g=k.None,this.h=I.$Xc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=v;class F{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$xe=F;class N{constructor(j){this.value=j,this.onDidChange=k.None}}}),define(Ee[21],Se([1,0,4]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=R;const h=Object.freeze(function($,a){const k=setTimeout($.bind(a),0);return{dispose(){clearTimeout(k)}}});var I;(function($){function a(k){return k===$.None||k===$.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}$.isCancellationToken=a,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(I||(e.CancellationToken=I={}));class T{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new s.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new T),this.f}cancel(){this.f?this.f instanceof T&&this.f.cancel():this.f=I.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof T&&this.f.dispose():this.f=I.None}}e.$ye=L;function R($){const a=new L;return $.add({dispose(){a.cancel()}}),a.token}}),define(Ee[183],Se([1,0,21]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=I;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new s.$ye,a=this.b($.token);return this.a={promise:a,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$$e=h;function I(R){return R}class T{constructor($,a){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=I):(this.c=a,this.d=$.getCacheKey)}get($){const a=this.d($);return this.b!==a&&(this.b=a,this.a=this.c($)),this.a}}e.$af=T;class L{get cachedValues(){return this.a}constructor($,a){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=I):(this.c=a,this.d=$.getCacheKey)}get($){const a=this.d($);if(this.b.has(a))return this.b.get(a);const k=this.c($);return this.a.set($,k),this.b.set(a,k),k}}e.$bf=L}),define(Ee[184],Se([1,0,4,3]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.ScrollbarVisibility=void 0;var I;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class T{constructor(b,c,m,d,g,n,o){this.c=b,this._scrollStateBrand=void 0,this.c&&(c=c|0,m=m|0,d=d|0,g=g|0,n=n|0,o=o|0),this.rawScrollLeft=d,this.rawScrollTop=o,c<0&&(c=0),d+c>m&&(d=m-c),d<0&&(d=0),g<0&&(g=0),o+g>n&&(o=n-g),o<0&&(o=0),this.width=c,this.scrollWidth=m,this.scrollLeft=d,this.height=g,this.scrollHeight=n,this.scrollTop=o}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,c){return new T(this.c,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new T(this.c,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,c){const m=this.width!==b.width,d=this.scrollWidth!==b.scrollWidth,g=this.scrollLeft!==b.scrollLeft,n=this.height!==b.height,o=this.scrollHeight!==b.scrollHeight,t=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:c,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:d,scrollLeftChanged:g,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:t}}}e.$bt=T;class L extends h.$Xc{constructor(b){super(),this._scrollableBrand=void 0,this.j=this.B(new s.$ne),this.onScroll=this.j.event,this.c=b.smoothScrollDuration,this.f=b.scheduleAtNextAnimationFrame,this.g=new T(b.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(b){this.c=b}validateScrollPosition(b){return this.g.withScrollPosition(b)}getScrollDimensions(){return this.g}setScrollDimensions(b,c){const m=this.g.withScrollDimensions(b,c);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(b){const c=this.g.withScrollPosition(b);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(b,c){if(this.c===0)return this.setScrollPositionNow(b);if(this.h){b={scrollLeft:typeof b.scrollLeft>"u"?this.h.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this.h.to.scrollTop:b.scrollTop};const m=this.g.withScrollPosition(b);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let d;c?d=new k(this.h.from,m,this.h.startTime,this.h.duration):d=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=d}else{const m=this.g.withScrollPosition(b);this.h=k.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const b=this.h.tick(),c=this.g.withScrollPosition(b);if(this.n(c,!0),!!this.h){if(b.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(b,c){const m=this.g;m.equals(b)||(this.g=b,this.j.fire(this.g.createScrollEvent(m,c)))}}e.$ct=L;class R{constructor(b,c,m){this.scrollLeft=b,this.scrollTop=c,this.isDone=m}}e.$dt=R;function $(P,b){const c=b-P;return function(m){return P+c*l(m)}}function a(P,b,c){return function(m){return m<c?P(m/c):b((m-c)/(1-c))}}class k{constructor(b,c,m,d){this.from=b,this.to=c,this.duration=d,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(b,c,m){if(Math.abs(b-c)>2.5*m){let g,n;return b<c?(g=b+.75*m,n=c-.75*m):(g=b-.75*m,n=c+.75*m),a($(b,g),$(n,c),.33)}return $(b,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(b){const c=(b-this.startTime)/this.duration;if(c<1){const m=this.c(c),d=this.d(c);return new R(m,d,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,c,m){return k.start(b,c,m)}static start(b,c,m){m=m+10;const d=Date.now()-10;return new k(b,c,d,m)}}e.$et=k;function E(P){return Math.pow(P,3)}function l(P){return 1-E(1-P)}}),define(Ee[104],Se([1,0,14,3]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=I,e.$Be=T,e.$Ce=L,e.$De=R,e.$Ee=a,e.$Fe=k,e.$Ge=E,e.$He=l,e.$Ie=P,e.$Je=b,e.$Ke=c,e.$Le=m,e.$Me=d,e.$Ne=g,e.$Oe=n;function I(o){const t=o;return t?typeof t.read=="function":!1}function T(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}function L(o){const t=o;return t?T(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(o,t){return new $(o,t)}class ${constructor(t,i){this.e=t,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(i=>i(t))}h(t){this.c.error.length===0?(0,s.$3)(t):this.c.error.slice(0).forEach(i=>i(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,i){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(t,i){if(this.a.destroyed)return;let r;switch(t){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const f=r.indexOf(i);f>=0&&r.splice(f,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(o,t){const i=[];let r;for(;(r=o.read())!==null;)i.push(r);return t(i)}function k(o,t,i){const r=[];let f;for(;(f=o.read())!==null&&r.length<i;)r.push(f);return f===null&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return o.read()}}}function E(o,t){return new Promise((i,r)=>{const f=[];l(o,{onData:u=>{t&&f.push(u)},onError:u=>{t?r(u):i(void 0)},onEnd:()=>{i(t?t(f):void 0)}})})}function l(o,t,i){o.on("error",r=>{i?.isCancellationRequested||t.onError(r)}),o.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),o.on("data",r=>{i?.isCancellationRequested||t.onData(r)})}function P(o,t){return new Promise((i,r)=>{const f=new h.$Wc,u=[],w=y=>{if(u.push(y),u.length>t)return f.dispose(),o.pause(),i({stream:o,buffer:u,ended:!1})},S=y=>(f.dispose(),r(y)),D=()=>(f.dispose(),i({stream:o,buffer:u,ended:!0}));f.add((0,h.$Vc)(()=>o.removeListener("error",S))),o.on("error",S),f.add((0,h.$Vc)(()=>o.removeListener("end",D))),o.on("end",D),f.add((0,h.$Vc)(()=>o.removeListener("data",w))),o.on("data",w)})}function b(o,t){const i=R(t);return i.end(o),i}function c(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}function m(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function d(o,t,i){const r=R(i);return l(o,{onData:f=>r.write(t.data(f)),onError:f=>r.error(t.error?t.error(f):f),onEnd:()=>r.end()}),r}function g(o,t,i){let r=!1;return{read:()=>{const f=t.read();return r?f:(r=!0,f!==null?i([o,f]):o)}}}function n(o,t,i){let r=!1;const f=R(i);return l(t,{onData:u=>r?f.write(u):(r=!0,f.write(i([o,u]))),onError:u=>f.error(u),onEnd:()=>{r||(r=!0,f.write(o)),f.end()}}),f}}),define(Ee[22],Se([1,0,49,104]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=a,e.$Re=k,e.$Se=E,e.$Te=l,e.$Ue=P,e.$Ve=b,e.$We=c,e.$Xe=m,e.$Ye=d,e.$Ze=g,e.$1e=n,e.$2e=o,e.$3e=t,e.$4e=i,e.$5e=r,e.$6e=f,e.$7e=u,e.$8e=w,e.$9e=S,e.$0e=C,h=We(h);const I=typeof Buffer<"u",T=new s.$X(()=>new Uint8Array(256));let L,R;class ${static alloc(p){return I?new $(Buffer.allocUnsafe(p)):new $(new Uint8Array(p))}static wrap(p){return I&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new $(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(p)):(L||(L=new TextEncoder),new $(L.encode(p)))}static fromByteArray(p){const v=$.alloc(p.length);for(let F=0,N=p.length;F<N;F++)v.buffer[F]=p[F];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let O=0,j=p.length;O<j;O++)v+=p[O].byteLength}const F=$.alloc(v);let N=0;for(let O=0,j=p.length;O<j;O++){const z=p[O];F.set(z,N),N+=z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=$.alloc(this.byteLength);return p.set(this),p}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,v){return new $(this.buffer.subarray(p,v))}set(p,v){if(p instanceof $)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,v){P(this.buffer,p,v)}readUInt32LE(p){return b(this.buffer,p)}writeUInt32LE(p,v){c(this.buffer,p,v)}readUInt8(p){return m(this.buffer,p)}writeUInt8(p,v){d(this.buffer,p,v)}indexOf(p,v=0){return a(this.buffer,p instanceof $?p.buffer:p,v)}}e.$Pe=$;function a(A,p,v=0){const F=p.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(p[0]);if(F>N-v)return-1;const O=T.value;O.fill(p.length);for(let V=0;V<p.length;V++)O[p[V]]=p.length-V-1;let j=v+p.length-1,z=j,M=-1;for(;j<N;)if(A[j]===p[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(p.length-z,O[A[j]]),z=p.length-1;return M}function k(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0}function E(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255}function l(A,p){return A[p]*2**24+A[p+1]*2**16+A[p+2]*2**8+A[p+3]}function P(A,p,v){A[v+3]=p,p=p>>>8,A[v+2]=p,p=p>>>8,A[v+1]=p,p=p>>>8,A[v]=p}function b(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0|A[p+2]<<16>>>0|A[p+3]<<24>>>0}function c(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255,p=p>>>8,A[v+2]=p&255,p=p>>>8,A[v+3]=p&255}function m(A,p){return A[p]}function d(A,p,v){A[v]=p}function g(A){return h.$Ee(A,p=>$.concat(p))}function n(A){return h.$Le(A)}function o(A){return h.$Ge(A,p=>$.concat(p))}async function t(A){return A.ended?$.concat(A.buffer):$.concat([...A.buffer,await o(A.stream)])}function i(A){return h.$Je(A,p=>$.concat(p))}function r(A){return h.$Me(A,{data:p=>typeof p=="string"?$.fromString(p):$.wrap(p)},p=>$.concat(p))}function f(A){return h.$De(p=>$.concat(p),A)}function u(A,p){return h.$Ne(A,p,v=>$.concat(v))}function w(A,p){return h.$Oe(A,p,v=>$.concat(v))}function S(A){let p=0,v=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),O=z=>{switch(v){case 3:N[F++]=p|z,v=0;break;case 2:N[F++]=p|z>>>2,p=z<<6,v=3;break;case 1:N[F++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<A.length;z++){const M=A.charCodeAt(z);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=F;for(;v>0;)O(0);return $.wrap(N).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:A},p=!0,v=!1){const F=v?y:D;let N="";const O=A.byteLength%3;let j=0;for(;j<A.byteLength-O;j+=3){const z=A[j+0],M=A[j+1],V=A[j+2];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[(M<<2|V>>>6)&63],N+=F[V&63]}if(O===1){const z=A[j+0];N+=F[z>>>2],N+=F[z<<4&63],p&&(N+="==")}else if(O===2){const z=A[j+0],M=A[j+1];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[M<<2&63],p&&(N+="=")}return N}}),define(Ee[185],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(Ee[18],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=s,e.$hg=h,e.$ig=I,e.$jg=T,e.$kg=L,e.$lg=R,e.$mg=$,e.$ng=a,e.$og=k,e.$pg=E,e.$qg=l,e.$rg=P,e.$sg=b,e.$tg=m,e.$ug=d,e.$vg=g,e.$wg=n,e.$xg=o;function s(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(i=>s(i))}function I(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function T(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}function L(t){return typeof t=="number"&&!isNaN(t)}function R(t){return!!t&&typeof t[Symbol.iterator]=="function"}function $(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function k(t){return!E(t)}function E(t){return a(t)||t===null}function l(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function P(t){if(E(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function b(...t){const i=[];for(let r=0;r<t.length;r++){const f=t[r];if(E(f))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(f)}return i}const c=Object.prototype.hasOwnProperty;function m(t){if(!I(t))return!1;for(const i in t)if(c.call(t,i))return!1;return!0}function d(t){return typeof t=="function"}function g(...t){return t.length>0&&t.every(d)}function n(t,i){const r=Math.min(t.length,i.length);for(let f=0;f<r;f++)o(t[f],i[f])}function o(t,i){if(s(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(t instanceof i)return}catch{}if(!E(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[105],Se([1,0,18]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=I,e.$2j=T;const h=Object.create(null);function I(L,R){if((0,s.$gg)(R)){const $=h[R];if($===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=$}return h[L]=R,{id:L}}function T(){return h}}),define(Ee[186],Se([1,0,105]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,s.$1j)("add",6e4),plus:(0,s.$1j)("plus",6e4),gistNew:(0,s.$1j)("gist-new",6e4),repoCreate:(0,s.$1j)("repo-create",6e4),lightbulb:(0,s.$1j)("lightbulb",60001),lightBulb:(0,s.$1j)("light-bulb",60001),repo:(0,s.$1j)("repo",60002),repoDelete:(0,s.$1j)("repo-delete",60002),gistFork:(0,s.$1j)("gist-fork",60003),repoForked:(0,s.$1j)("repo-forked",60003),gitPullRequest:(0,s.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,s.$1j)("record-keys",60005),keyboard:(0,s.$1j)("keyboard",60005),tag:(0,s.$1j)("tag",60006),gitPullRequestLabel:(0,s.$1j)("git-pull-request-label",60006),tagAdd:(0,s.$1j)("tag-add",60006),tagRemove:(0,s.$1j)("tag-remove",60006),person:(0,s.$1j)("person",60007),personFollow:(0,s.$1j)("person-follow",60007),personOutline:(0,s.$1j)("person-outline",60007),personFilled:(0,s.$1j)("person-filled",60007),gitBranch:(0,s.$1j)("git-branch",60008),gitBranchCreate:(0,s.$1j)("git-branch-create",60008),gitBranchDelete:(0,s.$1j)("git-branch-delete",60008),sourceControl:(0,s.$1j)("source-control",60008),mirror:(0,s.$1j)("mirror",60009),mirrorPublic:(0,s.$1j)("mirror-public",60009),star:(0,s.$1j)("star",60010),starAdd:(0,s.$1j)("star-add",60010),starDelete:(0,s.$1j)("star-delete",60010),starEmpty:(0,s.$1j)("star-empty",60010),comment:(0,s.$1j)("comment",60011),commentAdd:(0,s.$1j)("comment-add",60011),alert:(0,s.$1j)("alert",60012),warning:(0,s.$1j)("warning",60012),search:(0,s.$1j)("search",60013),searchSave:(0,s.$1j)("search-save",60013),logOut:(0,s.$1j)("log-out",60014),signOut:(0,s.$1j)("sign-out",60014),logIn:(0,s.$1j)("log-in",60015),signIn:(0,s.$1j)("sign-in",60015),eye:(0,s.$1j)("eye",60016),eyeUnwatch:(0,s.$1j)("eye-unwatch",60016),eyeWatch:(0,s.$1j)("eye-watch",60016),circleFilled:(0,s.$1j)("circle-filled",60017),primitiveDot:(0,s.$1j)("primitive-dot",60017),closeDirty:(0,s.$1j)("close-dirty",60017),debugBreakpoint:(0,s.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,s.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,s.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,s.$1j)("primitive-square",60018),edit:(0,s.$1j)("edit",60019),pencil:(0,s.$1j)("pencil",60019),info:(0,s.$1j)("info",60020),issueOpened:(0,s.$1j)("issue-opened",60020),gistPrivate:(0,s.$1j)("gist-private",60021),gitForkPrivate:(0,s.$1j)("git-fork-private",60021),lock:(0,s.$1j)("lock",60021),mirrorPrivate:(0,s.$1j)("mirror-private",60021),close:(0,s.$1j)("close",60022),removeClose:(0,s.$1j)("remove-close",60022),x:(0,s.$1j)("x",60022),repoSync:(0,s.$1j)("repo-sync",60023),sync:(0,s.$1j)("sync",60023),clone:(0,s.$1j)("clone",60024),desktopDownload:(0,s.$1j)("desktop-download",60024),beaker:(0,s.$1j)("beaker",60025),microscope:(0,s.$1j)("microscope",60025),vm:(0,s.$1j)("vm",60026),deviceDesktop:(0,s.$1j)("device-desktop",60026),file:(0,s.$1j)("file",60027),fileText:(0,s.$1j)("file-text",60027),more:(0,s.$1j)("more",60028),ellipsis:(0,s.$1j)("ellipsis",60028),kebabHorizontal:(0,s.$1j)("kebab-horizontal",60028),mailReply:(0,s.$1j)("mail-reply",60029),reply:(0,s.$1j)("reply",60029),organization:(0,s.$1j)("organization",60030),organizationFilled:(0,s.$1j)("organization-filled",60030),organizationOutline:(0,s.$1j)("organization-outline",60030),newFile:(0,s.$1j)("new-file",60031),fileAdd:(0,s.$1j)("file-add",60031),newFolder:(0,s.$1j)("new-folder",60032),fileDirectoryCreate:(0,s.$1j)("file-directory-create",60032),trash:(0,s.$1j)("trash",60033),trashcan:(0,s.$1j)("trashcan",60033),history:(0,s.$1j)("history",60034),clock:(0,s.$1j)("clock",60034),folder:(0,s.$1j)("folder",60035),fileDirectory:(0,s.$1j)("file-directory",60035),symbolFolder:(0,s.$1j)("symbol-folder",60035),logoGithub:(0,s.$1j)("logo-github",60036),markGithub:(0,s.$1j)("mark-github",60036),github:(0,s.$1j)("github",60036),terminal:(0,s.$1j)("terminal",60037),console:(0,s.$1j)("console",60037),repl:(0,s.$1j)("repl",60037),zap:(0,s.$1j)("zap",60038),symbolEvent:(0,s.$1j)("symbol-event",60038),error:(0,s.$1j)("error",60039),stop:(0,s.$1j)("stop",60039),variable:(0,s.$1j)("variable",60040),symbolVariable:(0,s.$1j)("symbol-variable",60040),array:(0,s.$1j)("array",60042),symbolArray:(0,s.$1j)("symbol-array",60042),symbolModule:(0,s.$1j)("symbol-module",60043),symbolPackage:(0,s.$1j)("symbol-package",60043),symbolNamespace:(0,s.$1j)("symbol-namespace",60043),symbolObject:(0,s.$1j)("symbol-object",60043),symbolMethod:(0,s.$1j)("symbol-method",60044),symbolFunction:(0,s.$1j)("symbol-function",60044),symbolConstructor:(0,s.$1j)("symbol-constructor",60044),symbolBoolean:(0,s.$1j)("symbol-boolean",60047),symbolNull:(0,s.$1j)("symbol-null",60047),symbolNumeric:(0,s.$1j)("symbol-numeric",60048),symbolNumber:(0,s.$1j)("symbol-number",60048),symbolStructure:(0,s.$1j)("symbol-structure",60049),symbolStruct:(0,s.$1j)("symbol-struct",60049),symbolParameter:(0,s.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,s.$1j)("symbol-type-parameter",60050),symbolKey:(0,s.$1j)("symbol-key",60051),symbolText:(0,s.$1j)("symbol-text",60051),symbolReference:(0,s.$1j)("symbol-reference",60052),goToFile:(0,s.$1j)("go-to-file",60052),symbolEnum:(0,s.$1j)("symbol-enum",60053),symbolValue:(0,s.$1j)("symbol-value",60053),symbolRuler:(0,s.$1j)("symbol-ruler",60054),symbolUnit:(0,s.$1j)("symbol-unit",60054),activateBreakpoints:(0,s.$1j)("activate-breakpoints",60055),archive:(0,s.$1j)("archive",60056),arrowBoth:(0,s.$1j)("arrow-both",60057),arrowDown:(0,s.$1j)("arrow-down",60058),arrowLeft:(0,s.$1j)("arrow-left",60059),arrowRight:(0,s.$1j)("arrow-right",60060),arrowSmallDown:(0,s.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,s.$1j)("arrow-small-left",60062),arrowSmallRight:(0,s.$1j)("arrow-small-right",60063),arrowSmallUp:(0,s.$1j)("arrow-small-up",60064),arrowUp:(0,s.$1j)("arrow-up",60065),bell:(0,s.$1j)("bell",60066),bold:(0,s.$1j)("bold",60067),book:(0,s.$1j)("book",60068),bookmark:(0,s.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.$1j)("briefcase",60076),broadcast:(0,s.$1j)("broadcast",60077),browser:(0,s.$1j)("browser",60078),bug:(0,s.$1j)("bug",60079),calendar:(0,s.$1j)("calendar",60080),caseSensitive:(0,s.$1j)("case-sensitive",60081),check:(0,s.$1j)("check",60082),checklist:(0,s.$1j)("checklist",60083),chevronDown:(0,s.$1j)("chevron-down",60084),chevronLeft:(0,s.$1j)("chevron-left",60085),chevronRight:(0,s.$1j)("chevron-right",60086),chevronUp:(0,s.$1j)("chevron-up",60087),chromeClose:(0,s.$1j)("chrome-close",60088),chromeMaximize:(0,s.$1j)("chrome-maximize",60089),chromeMinimize:(0,s.$1j)("chrome-minimize",60090),chromeRestore:(0,s.$1j)("chrome-restore",60091),circleOutline:(0,s.$1j)("circle-outline",60092),circle:(0,s.$1j)("circle",60092),debugBreakpointUnverified:(0,s.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,s.$1j)("circle-slash",60093),circuitBoard:(0,s.$1j)("circuit-board",60094),clearAll:(0,s.$1j)("clear-all",60095),clippy:(0,s.$1j)("clippy",60096),closeAll:(0,s.$1j)("close-all",60097),cloudDownload:(0,s.$1j)("cloud-download",60098),cloudUpload:(0,s.$1j)("cloud-upload",60099),code:(0,s.$1j)("code",60100),collapseAll:(0,s.$1j)("collapse-all",60101),colorMode:(0,s.$1j)("color-mode",60102),commentDiscussion:(0,s.$1j)("comment-discussion",60103),creditCard:(0,s.$1j)("credit-card",60105),dash:(0,s.$1j)("dash",60108),dashboard:(0,s.$1j)("dashboard",60109),database:(0,s.$1j)("database",60110),debugContinue:(0,s.$1j)("debug-continue",60111),debugDisconnect:(0,s.$1j)("debug-disconnect",60112),debugPause:(0,s.$1j)("debug-pause",60113),debugRestart:(0,s.$1j)("debug-restart",60114),debugStart:(0,s.$1j)("debug-start",60115),debugStepInto:(0,s.$1j)("debug-step-into",60116),debugStepOut:(0,s.$1j)("debug-step-out",60117),debugStepOver:(0,s.$1j)("debug-step-over",60118),debugStop:(0,s.$1j)("debug-stop",60119),debug:(0,s.$1j)("debug",60120),deviceCameraVideo:(0,s.$1j)("device-camera-video",60121),deviceCamera:(0,s.$1j)("device-camera",60122),deviceMobile:(0,s.$1j)("device-mobile",60123),diffAdded:(0,s.$1j)("diff-added",60124),diffIgnored:(0,s.$1j)("diff-ignored",60125),diffModified:(0,s.$1j)("diff-modified",60126),diffRemoved:(0,s.$1j)("diff-removed",60127),diffRenamed:(0,s.$1j)("diff-renamed",60128),diff:(0,s.$1j)("diff",60129),diffSidebyside:(0,s.$1j)("diff-sidebyside",60129),discard:(0,s.$1j)("discard",60130),editorLayout:(0,s.$1j)("editor-layout",60131),emptyWindow:(0,s.$1j)("empty-window",60132),exclude:(0,s.$1j)("exclude",60133),extensions:(0,s.$1j)("extensions",60134),eyeClosed:(0,s.$1j)("eye-closed",60135),fileBinary:(0,s.$1j)("file-binary",60136),fileCode:(0,s.$1j)("file-code",60137),fileMedia:(0,s.$1j)("file-media",60138),filePdf:(0,s.$1j)("file-pdf",60139),fileSubmodule:(0,s.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,s.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,s.$1j)("file-symlink-file",60142),fileZip:(0,s.$1j)("file-zip",60143),files:(0,s.$1j)("files",60144),filter:(0,s.$1j)("filter",60145),flame:(0,s.$1j)("flame",60146),foldDown:(0,s.$1j)("fold-down",60147),foldUp:(0,s.$1j)("fold-up",60148),fold:(0,s.$1j)("fold",60149),folderActive:(0,s.$1j)("folder-active",60150),folderOpened:(0,s.$1j)("folder-opened",60151),gear:(0,s.$1j)("gear",60152),gift:(0,s.$1j)("gift",60153),gistSecret:(0,s.$1j)("gist-secret",60154),gist:(0,s.$1j)("gist",60155),gitCommit:(0,s.$1j)("git-commit",60156),gitCompare:(0,s.$1j)("git-compare",60157),compareChanges:(0,s.$1j)("compare-changes",60157),gitMerge:(0,s.$1j)("git-merge",60158),githubAction:(0,s.$1j)("github-action",60159),githubAlt:(0,s.$1j)("github-alt",60160),globe:(0,s.$1j)("globe",60161),grabber:(0,s.$1j)("grabber",60162),graph:(0,s.$1j)("graph",60163),gripper:(0,s.$1j)("gripper",60164),heart:(0,s.$1j)("heart",60165),home:(0,s.$1j)("home",60166),horizontalRule:(0,s.$1j)("horizontal-rule",60167),hubot:(0,s.$1j)("hubot",60168),inbox:(0,s.$1j)("inbox",60169),issueReopened:(0,s.$1j)("issue-reopened",60171),issues:(0,s.$1j)("issues",60172),italic:(0,s.$1j)("italic",60173),jersey:(0,s.$1j)("jersey",60174),json:(0,s.$1j)("json",60175),kebabVertical:(0,s.$1j)("kebab-vertical",60176),key:(0,s.$1j)("key",60177),law:(0,s.$1j)("law",60178),lightbulbAutofix:(0,s.$1j)("lightbulb-autofix",60179),linkExternal:(0,s.$1j)("link-external",60180),link:(0,s.$1j)("link",60181),listOrdered:(0,s.$1j)("list-ordered",60182),listUnordered:(0,s.$1j)("list-unordered",60183),liveShare:(0,s.$1j)("live-share",60184),loading:(0,s.$1j)("loading",60185),location:(0,s.$1j)("location",60186),mailRead:(0,s.$1j)("mail-read",60187),mail:(0,s.$1j)("mail",60188),markdown:(0,s.$1j)("markdown",60189),megaphone:(0,s.$1j)("megaphone",60190),mention:(0,s.$1j)("mention",60191),milestone:(0,s.$1j)("milestone",60192),gitPullRequestMilestone:(0,s.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,s.$1j)("mortar-board",60193),move:(0,s.$1j)("move",60194),multipleWindows:(0,s.$1j)("multiple-windows",60195),mute:(0,s.$1j)("mute",60196),noNewline:(0,s.$1j)("no-newline",60197),note:(0,s.$1j)("note",60198),octoface:(0,s.$1j)("octoface",60199),openPreview:(0,s.$1j)("open-preview",60200),package:(0,s.$1j)("package",60201),paintcan:(0,s.$1j)("paintcan",60202),pin:(0,s.$1j)("pin",60203),play:(0,s.$1j)("play",60204),run:(0,s.$1j)("run",60204),plug:(0,s.$1j)("plug",60205),preserveCase:(0,s.$1j)("preserve-case",60206),preview:(0,s.$1j)("preview",60207),project:(0,s.$1j)("project",60208),pulse:(0,s.$1j)("pulse",60209),question:(0,s.$1j)("question",60210),quote:(0,s.$1j)("quote",60211),radioTower:(0,s.$1j)("radio-tower",60212),reactions:(0,s.$1j)("reactions",60213),references:(0,s.$1j)("references",60214),refresh:(0,s.$1j)("refresh",60215),regex:(0,s.$1j)("regex",60216),remoteExplorer:(0,s.$1j)("remote-explorer",60217),remote:(0,s.$1j)("remote",60218),remove:(0,s.$1j)("remove",60219),replaceAll:(0,s.$1j)("replace-all",60220),replace:(0,s.$1j)("replace",60221),repoClone:(0,s.$1j)("repo-clone",60222),repoForcePush:(0,s.$1j)("repo-force-push",60223),repoPull:(0,s.$1j)("repo-pull",60224),repoPush:(0,s.$1j)("repo-push",60225),report:(0,s.$1j)("report",60226),requestChanges:(0,s.$1j)("request-changes",60227),rocket:(0,s.$1j)("rocket",60228),rootFolderOpened:(0,s.$1j)("root-folder-opened",60229),rootFolder:(0,s.$1j)("root-folder",60230),rss:(0,s.$1j)("rss",60231),ruby:(0,s.$1j)("ruby",60232),saveAll:(0,s.$1j)("save-all",60233),saveAs:(0,s.$1j)("save-as",60234),save:(0,s.$1j)("save",60235),screenFull:(0,s.$1j)("screen-full",60236),screenNormal:(0,s.$1j)("screen-normal",60237),searchStop:(0,s.$1j)("search-stop",60238),server:(0,s.$1j)("server",60240),settingsGear:(0,s.$1j)("settings-gear",60241),settings:(0,s.$1j)("settings",60242),shield:(0,s.$1j)("shield",60243),smiley:(0,s.$1j)("smiley",60244),sortPrecedence:(0,s.$1j)("sort-precedence",60245),splitHorizontal:(0,s.$1j)("split-horizontal",60246),splitVertical:(0,s.$1j)("split-vertical",60247),squirrel:(0,s.$1j)("squirrel",60248),starFull:(0,s.$1j)("star-full",60249),starHalf:(0,s.$1j)("star-half",60250),symbolClass:(0,s.$1j)("symbol-class",60251),symbolColor:(0,s.$1j)("symbol-color",60252),symbolConstant:(0,s.$1j)("symbol-constant",60253),symbolEnumMember:(0,s.$1j)("symbol-enum-member",60254),symbolField:(0,s.$1j)("symbol-field",60255),symbolFile:(0,s.$1j)("symbol-file",60256),symbolInterface:(0,s.$1j)("symbol-interface",60257),symbolKeyword:(0,s.$1j)("symbol-keyword",60258),symbolMisc:(0,s.$1j)("symbol-misc",60259),symbolOperator:(0,s.$1j)("symbol-operator",60260),symbolProperty:(0,s.$1j)("symbol-property",60261),wrench:(0,s.$1j)("wrench",60261),wrenchSubaction:(0,s.$1j)("wrench-subaction",60261),symbolSnippet:(0,s.$1j)("symbol-snippet",60262),tasklist:(0,s.$1j)("tasklist",60263),telescope:(0,s.$1j)("telescope",60264),textSize:(0,s.$1j)("text-size",60265),threeBars:(0,s.$1j)("three-bars",60266),thumbsdown:(0,s.$1j)("thumbsdown",60267),thumbsup:(0,s.$1j)("thumbsup",60268),tools:(0,s.$1j)("tools",60269),triangleDown:(0,s.$1j)("triangle-down",60270),triangleLeft:(0,s.$1j)("triangle-left",60271),triangleRight:(0,s.$1j)("triangle-right",60272),triangleUp:(0,s.$1j)("triangle-up",60273),twitter:(0,s.$1j)("twitter",60274),unfold:(0,s.$1j)("unfold",60275),unlock:(0,s.$1j)("unlock",60276),unmute:(0,s.$1j)("unmute",60277),unverified:(0,s.$1j)("unverified",60278),verified:(0,s.$1j)("verified",60279),versions:(0,s.$1j)("versions",60280),vmActive:(0,s.$1j)("vm-active",60281),vmOutline:(0,s.$1j)("vm-outline",60282),vmRunning:(0,s.$1j)("vm-running",60283),watch:(0,s.$1j)("watch",60284),whitespace:(0,s.$1j)("whitespace",60285),wholeWord:(0,s.$1j)("whole-word",60286),window:(0,s.$1j)("window",60287),wordWrap:(0,s.$1j)("word-wrap",60288),zoomIn:(0,s.$1j)("zoom-in",60289),zoomOut:(0,s.$1j)("zoom-out",60290),listFilter:(0,s.$1j)("list-filter",60291),listFlat:(0,s.$1j)("list-flat",60292),listSelection:(0,s.$1j)("list-selection",60293),selection:(0,s.$1j)("selection",60293),listTree:(0,s.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,s.$1j)("circle-small-filled",60298),debugStackframeDot:(0,s.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,s.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,s.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,s.$1j)("symbol-string",60301),debugReverseContinue:(0,s.$1j)("debug-reverse-continue",60302),debugStepBack:(0,s.$1j)("debug-step-back",60303),debugRestartFrame:(0,s.$1j)("debug-restart-frame",60304),debugAlt:(0,s.$1j)("debug-alt",60305),callIncoming:(0,s.$1j)("call-incoming",60306),callOutgoing:(0,s.$1j)("call-outgoing",60307),menu:(0,s.$1j)("menu",60308),expandAll:(0,s.$1j)("expand-all",60309),feedback:(0,s.$1j)("feedback",60310),gitPullRequestReviewer:(0,s.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,s.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,s.$1j)("ungroup-by-ref-type",60312),account:(0,s.$1j)("account",60313),gitPullRequestAssignee:(0,s.$1j)("git-pull-request-assignee",60313),bellDot:(0,s.$1j)("bell-dot",60314),debugConsole:(0,s.$1j)("debug-console",60315),library:(0,s.$1j)("library",60316),output:(0,s.$1j)("output",60317),runAll:(0,s.$1j)("run-all",60318),syncIgnored:(0,s.$1j)("sync-ignored",60319),pinned:(0,s.$1j)("pinned",60320),githubInverted:(0,s.$1j)("github-inverted",60321),serverProcess:(0,s.$1j)("server-process",60322),serverEnvironment:(0,s.$1j)("server-environment",60323),pass:(0,s.$1j)("pass",60324),issueClosed:(0,s.$1j)("issue-closed",60324),stopCircle:(0,s.$1j)("stop-circle",60325),playCircle:(0,s.$1j)("play-circle",60326),record:(0,s.$1j)("record",60327),debugAltSmall:(0,s.$1j)("debug-alt-small",60328),vmConnect:(0,s.$1j)("vm-connect",60329),cloud:(0,s.$1j)("cloud",60330),merge:(0,s.$1j)("merge",60331),export:(0,s.$1j)("export",60332),graphLeft:(0,s.$1j)("graph-left",60333),magnet:(0,s.$1j)("magnet",60334),notebook:(0,s.$1j)("notebook",60335),redo:(0,s.$1j)("redo",60336),checkAll:(0,s.$1j)("check-all",60337),pinnedDirty:(0,s.$1j)("pinned-dirty",60338),passFilled:(0,s.$1j)("pass-filled",60339),circleLargeFilled:(0,s.$1j)("circle-large-filled",60340),circleLarge:(0,s.$1j)("circle-large",60341),circleLargeOutline:(0,s.$1j)("circle-large-outline",60341),combine:(0,s.$1j)("combine",60342),gather:(0,s.$1j)("gather",60342),table:(0,s.$1j)("table",60343),variableGroup:(0,s.$1j)("variable-group",60344),typeHierarchy:(0,s.$1j)("type-hierarchy",60345),typeHierarchySub:(0,s.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.$1j)("git-pull-request-create",60348),runAbove:(0,s.$1j)("run-above",60349),runBelow:(0,s.$1j)("run-below",60350),notebookTemplate:(0,s.$1j)("notebook-template",60351),debugRerun:(0,s.$1j)("debug-rerun",60352),workspaceTrusted:(0,s.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,s.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,s.$1j)("workspace-unknown",60355),terminalCmd:(0,s.$1j)("terminal-cmd",60356),terminalDebian:(0,s.$1j)("terminal-debian",60357),terminalLinux:(0,s.$1j)("terminal-linux",60358),terminalPowershell:(0,s.$1j)("terminal-powershell",60359),terminalTmux:(0,s.$1j)("terminal-tmux",60360),terminalUbuntu:(0,s.$1j)("terminal-ubuntu",60361),terminalBash:(0,s.$1j)("terminal-bash",60362),arrowSwap:(0,s.$1j)("arrow-swap",60363),copy:(0,s.$1j)("copy",60364),personAdd:(0,s.$1j)("person-add",60365),filterFilled:(0,s.$1j)("filter-filled",60366),wand:(0,s.$1j)("wand",60367),debugLineByLine:(0,s.$1j)("debug-line-by-line",60368),inspect:(0,s.$1j)("inspect",60369),layers:(0,s.$1j)("layers",60370),layersDot:(0,s.$1j)("layers-dot",60371),layersActive:(0,s.$1j)("layers-active",60372),compass:(0,s.$1j)("compass",60373),compassDot:(0,s.$1j)("compass-dot",60374),compassActive:(0,s.$1j)("compass-active",60375),azure:(0,s.$1j)("azure",60376),issueDraft:(0,s.$1j)("issue-draft",60377),gitPullRequestClosed:(0,s.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.$1j)("git-pull-request-draft",60379),debugAll:(0,s.$1j)("debug-all",60380),debugCoverage:(0,s.$1j)("debug-coverage",60381),runErrors:(0,s.$1j)("run-errors",60382),folderLibrary:(0,s.$1j)("folder-library",60383),debugContinueSmall:(0,s.$1j)("debug-continue-small",60384),beakerStop:(0,s.$1j)("beaker-stop",60385),graphLine:(0,s.$1j)("graph-line",60386),graphScatter:(0,s.$1j)("graph-scatter",60387),pieChart:(0,s.$1j)("pie-chart",60388),bracket:(0,s.$1j)("bracket",60175),bracketDot:(0,s.$1j)("bracket-dot",60389),bracketError:(0,s.$1j)("bracket-error",60390),lockSmall:(0,s.$1j)("lock-small",60391),azureDevops:(0,s.$1j)("azure-devops",60392),verifiedFilled:(0,s.$1j)("verified-filled",60393),newline:(0,s.$1j)("newline",60394),layout:(0,s.$1j)("layout",60395),layoutActivitybarLeft:(0,s.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,s.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,s.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,s.$1j)("layout-panel-right",60401),layoutPanel:(0,s.$1j)("layout-panel",60402),layoutSidebarLeft:(0,s.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,s.$1j)("layout-statusbar",60405),layoutMenubar:(0,s.$1j)("layout-menubar",60406),layoutCentered:(0,s.$1j)("layout-centered",60407),target:(0,s.$1j)("target",60408),indent:(0,s.$1j)("indent",60409),recordSmall:(0,s.$1j)("record-small",60410),errorSmall:(0,s.$1j)("error-small",60411),terminalDecorationError:(0,s.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,s.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,s.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,s.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,s.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.$1j)("layout-sidebar-left-off",60418),blank:(0,s.$1j)("blank",60419),heartFilled:(0,s.$1j)("heart-filled",60420),map:(0,s.$1j)("map",60421),mapHorizontal:(0,s.$1j)("map-horizontal",60421),foldHorizontal:(0,s.$1j)("fold-horizontal",60421),mapFilled:(0,s.$1j)("map-filled",60422),mapHorizontalFilled:(0,s.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.$1j)("fold-horizontal-filled",60422),circleSmall:(0,s.$1j)("circle-small",60423),bellSlash:(0,s.$1j)("bell-slash",60424),bellSlashDot:(0,s.$1j)("bell-slash-dot",60425),commentUnresolved:(0,s.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.$1j)("search-fuzzy",60429),commentDraft:(0,s.$1j)("comment-draft",60430),send:(0,s.$1j)("send",60431),sparkle:(0,s.$1j)("sparkle",60432),insert:(0,s.$1j)("insert",60433),mic:(0,s.$1j)("mic",60434),thumbsdownFilled:(0,s.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,s.$1j)("thumbsup-filled",60436),coffee:(0,s.$1j)("coffee",60437),snake:(0,s.$1j)("snake",60438),game:(0,s.$1j)("game",60439),vr:(0,s.$1j)("vr",60440),chip:(0,s.$1j)("chip",60441),piano:(0,s.$1j)("piano",60442),music:(0,s.$1j)("music",60443),micFilled:(0,s.$1j)("mic-filled",60444),repoFetch:(0,s.$1j)("repo-fetch",60445),copilot:(0,s.$1j)("copilot",60446),lightbulbSparkle:(0,s.$1j)("lightbulb-sparkle",60447),robot:(0,s.$1j)("robot",60448),sparkleFilled:(0,s.$1j)("sparkle-filled",60449),diffSingle:(0,s.$1j)("diff-single",60450),diffMultiple:(0,s.$1j)("diff-multiple",60451),surroundWith:(0,s.$1j)("surround-with",60452),share:(0,s.$1j)("share",60453),gitStash:(0,s.$1j)("git-stash",60454),gitStashApply:(0,s.$1j)("git-stash-apply",60455),gitStashPop:(0,s.$1j)("git-stash-pop",60456),vscode:(0,s.$1j)("vscode",60457),vscodeInsiders:(0,s.$1j)("vscode-insiders",60458),codeOss:(0,s.$1j)("code-oss",60459),runCoverage:(0,s.$1j)("run-coverage",60460),runAllCoverage:(0,s.$1j)("run-all-coverage",60461),coverage:(0,s.$1j)("coverage",60462),githubProject:(0,s.$1j)("github-project",60463),mapVertical:(0,s.$1j)("map-vertical",60464),foldVertical:(0,s.$1j)("fold-vertical",60464),mapVerticalFilled:(0,s.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,s.$1j)("fold-vertical-filled",60465),goToSearch:(0,s.$1j)("go-to-search",60466),percentage:(0,s.$1j)("percentage",60467),sortPercentage:(0,s.$1j)("sort-percentage",60467),attach:(0,s.$1j)("attach",60468)}}),define(Ee[83],Se([1,0,105,186]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=I;function I(){return Object.values(e.$6j)}e.$5j={dialogError:(0,s.$1j)("dialog-error","error"),dialogWarning:(0,s.$1j)("dialog-warning","warning"),dialogInfo:(0,s.$1j)("dialog-info","info"),dialogClose:(0,s.$1j)("dialog-close","close"),treeItemExpanded:(0,s.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.$1j)("tree-filter-clear","close"),treeItemLoading:(0,s.$1j)("tree-item-loading","loading"),menuSelection:(0,s.$1j)("menu-selection","check"),menuSubmenu:(0,s.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,s.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,s.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.$1j)("toolbar-more","more"),quickInputBack:(0,s.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,s.$1j)("drop-down-button",60084),symbolCustomColor:(0,s.$1j)("symbol-customcolor",60252),exportIcon:(0,s.$1j)("export",60332),workspaceUnspecified:(0,s.$1j)("workspace-unspecified",60355),newLine:(0,s.$1j)("newline",60394),thumbsDownFilled:(0,s.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.$1j)("thumbsup-filled",60436),gitFetch:(0,s.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.$1j)("debug-breakpoint-pending",60377)},e.$6j={...h.$3j,...e.$5j}}),define(Ee[25],Se([1,0,18]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=h,e.$fo=I,e.$go=L,e.$ho=$,e.$io=a,e.$jo=k,e.$ko=E,e.$lo=l,e.$mo=P,e.$no=b,e.$oo=c,e.$po=m,e.$qo=d;function h(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([o,t])=>{n[o]=t&&typeof t=="object"?h(t):t}),n}function I(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const t in o)if(T.call(o,t)){const i=o[t];typeof i=="object"&&!Object.isFrozen(i)&&!(0,s.$jg)(i)&&n.push(i)}}return g}const T=Object.prototype.hasOwnProperty;function L(g,n){return R(g,n,new Set)}function R(g,n,o){if((0,s.$pg)(g))return g;const t=n(g);if(typeof t<"u")return t;if(Array.isArray(g)){const i=[];for(const r of g)i.push(R(r,n,o));return i}if((0,s.$ig)(g)){if(o.has(g))throw new Error("Cannot clone recursive data-structure");o.add(g);const i={};for(const r in g)T.call(g,r)&&(i[r]=R(g[r],n,o));return o.delete(g),i}return g}function $(g,n,o=!0){return(0,s.$ig)(g)?((0,s.$ig)(n)&&Object.keys(n).forEach(t=>{t in g?o&&((0,s.$ig)(g[t])&&(0,s.$ig)(n[t])?$(g[t],n[t],o):g[t]=n[t]):g[t]=n[t]}),g):n}function a(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let o,t;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(o=0;o<g.length;o++)if(!a(g[o],n[o]))return!1}else{const i=[];for(t in g)i.push(t);i.sort();const r=[];for(t in n)r.push(t);if(r.sort(),!a(i,r))return!1;for(o=0;o<i.length;o++)if(!a(g[i[o]],n[i[o]]))return!1}return!0}function k(g){const n=new Set;return JSON.stringify(g,(o,t)=>{if((0,s.$ig)(t)||Array.isArray(t)){if(n.has(t))return"[Circular]";n.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function E(g,n){const o=Object.create(null);return!g||!n||Object.keys(n).forEach(i=>{const r=g[i],f=n[i];a(r,f)||(o[i]=f)}),o}function l(g,n){const o=n.toLowerCase(),t=Object.keys(g).find(i=>i.toLowerCase()===o);return t?g[t]:g[n]}function P(g,n){const o=Object.create(null);for(const[t,i]of Object.entries(g))n(t,i)&&(o[t]=i);return o}function b(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}function c(g){const n=[];for(const o of b(g))typeof g[o]=="function"&&n.push(o);return n}function m(g,n){const o=i=>function(){const r=Array.prototype.slice.call(arguments,0);return n(i,r)},t={};for(const i of g)t[i]=o(i);return t}function d(g,n){const o={};for(const[t,i]of Object.entries(g))o[t]=n(i,t);return o}}),define(Ee[50],Se([1,0,83]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=I;var h;(function(L){function R($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=R})(h||(e.ThemeColor=h={}));function I(L){return{id:L}}var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(g){const n=R.exec(g.id);if(!n)return $(s.$6j.error);const[,o,t]=n,i=["codicon","codicon-"+o];return t&&i.push("codicon-modifier-"+t.substring(1)),i}L.asClassNameArray=$;function a(g){return $(g).join(" ")}L.asClassName=a;function k(g){return"."+$(g).join(".")}L.asCSSSelector=k;function E(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||h.isThemeColor(g.color))}L.isThemeIcon=E;const l=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(g){const n=l.exec(g);if(!n)return;const[,o]=n;return{id:o}}L.fromString=P;function b(g){return{id:g}}L.fromId=b;function c(g,n){let o=g.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),n&&(o=`${o}~${n}`),{id:o}}L.modify=c;function m(g){const n=g.id.lastIndexOf("~");if(n!==-1)return g.id.substring(n+1)}L.getModifier=m;function d(g,n){return g.id===n.id&&g.color?.id===n.color?.id}L.isEqual=d})(T||(e.ThemeIcon=T={}))}),define(Ee[84],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=h,e.$df=I;var s;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(s||(e.Constants=s={}));function h(T){return T<0?0:T>s.MAX_UINT_8?s.MAX_UINT_8:T|0}function I(T){return T<0?0:T>s.MAX_UINT_32?s.MAX_UINT_32:T|0}}),define(Ee[13],Se([1,0,183,27,49,84]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=L,e.$ff=$,e.$gf=k,e.$hf=E,e.$if=l,e.$jf=P,e.$kf=b,e.$lf=c,e.$mf=m,e.$nf=d,e.$of=g,e.$pf=n,e.$qf=o,e.$rf=t,e.$sf=i,e.$tf=r,e.$uf=f,e.$vf=u,e.$wf=w,e.$xf=S,e.$yf=D,e.$zf=y,e.$Af=C,e.$Bf=A,e.$Cf=p,e.$Df=v,e.$Ef=F,e.$Ff=N,e.$Gf=O,e.$Hf=j,e.$If=z,e.$Jf=M,e.$Kf=V,e.$Lf=K,e.$Mf=re,e.$Nf=B,e.$Of=G,e.$Rf=ne,e.$Sf=De,e.$Tf=$e,e.$Uf=J,e.$Vf=ae,e.$Wf=le,e.$Yf=ue,e.$Zf=Z,e.$1f=oe,e.$2f=pe,e.$3f=Fe,e.$4f=Ue,e.$5f=Pe,e.$7f=Te,e.$8f=W,e.$9f=q,e.$0f=Y,e.$$f=_,e.$_f=fe,e.$ag=be,e.$bg=Ne,e.$cg=ot;function L(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}const R=/{(\d+)}/g;function $(Ie,...ze){return ze.length===0?Ie:Ie.replace(R,function(He,Oe){const je=parseInt(Oe,10);return isNaN(je)||je<0||je>=ze.length?He:ze[je]})}const a=/{([^}]+)}/g;function k(Ie,ze){return Object.keys(ze).length===0?Ie:Ie.replace(a,(He,Oe)=>ze[Oe]??He)}function E(Ie){return Ie.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function l(Ie){return Ie.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function P(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Ie,ze){let He=0,Oe=Ie.indexOf(ze);for(;Oe!==-1;)He++,Oe=Ie.indexOf(ze,Oe+ze.length);return He}function c(Ie,ze,He="\u2026"){return Ie.length<=ze?Ie:`${Ie.substr(0,ze)}${He}`}function m(Ie,ze,He="\u2026"){if(Ie.length<=ze)return Ie;const Oe=Math.ceil(ze/2)-He.length/2,je=Math.floor(ze/2)-He.length/2;return`${Ie.substr(0,Oe)}${He}${Ie.substr(Ie.length-je)}`}function d(Ie,ze=" "){const He=g(Ie,ze);return n(He,ze)}function g(Ie,ze){if(!Ie||!ze)return Ie;const He=ze.length;if(He===0||Ie.length===0)return Ie;let Oe=0;for(;Ie.indexOf(ze,Oe)===Oe;)Oe=Oe+He;return Ie.substring(Oe)}function n(Ie,ze){if(!Ie||!ze)return Ie;const He=ze.length,Oe=Ie.length;if(He===0||Oe===0)return Ie;let je=Oe,he=-1;for(;he=Ie.lastIndexOf(ze,je-1),!(he===-1||he+He!==je);){if(he===0)return"";je=he}return Ie.substring(0,je)}function o(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Ie){return Ie.replace(/\*/g,"")}function i(Ie,ze,He={}){if(!Ie)throw new Error("Cannot create regex from empty string");ze||(Ie=P(Ie)),He.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Oe="";return He.global&&(Oe+="g"),He.matchCase||(Oe+="i"),He.multiline&&(Oe+="m"),He.unicode&&(Oe+="u"),new RegExp(Ie,Oe)}function r(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}function f(Ie){return Ie.split(/\r\n|\r|\n/)}function u(Ie){const ze=[],He=Ie.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(He.length/2);Oe++)ze.push(He[2*Oe]+(He[2*Oe+1]??""));return ze}function w(Ie){for(let ze=0,He=Ie.length;ze<He;ze++){const Oe=Ie.charCodeAt(ze);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return ze}return-1}function S(Ie,ze=0,He=Ie.length){for(let Oe=ze;Oe<He;Oe++){const je=Ie.charCodeAt(Oe);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Ie.substring(ze,Oe)}return Ie.substring(ze,He)}function D(Ie,ze=Ie.length-1){for(let He=ze;He>=0;He--){const Oe=Ie.charCodeAt(He);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return He}return-1}function y(Ie,ze,He){const Oe=[];let je=0;for(const he of Ie.matchAll(ze)){if(Oe.push(Ie.slice(je,he.index)),he.index===void 0)throw new Error("match.index should be defined");je=he.index+he[0].length,Oe.push(He(he[0],...he.slice(1),he.index,Ie,he.groups))}return Oe.push(Ie.slice(je)),Promise.all(Oe).then(he=>he.join(""))}function C(Ie,ze){return Ie<ze?-1:Ie>ze?1:0}function A(Ie,ze,He=0,Oe=Ie.length,je=0,he=ze.length){for(;He<Oe&&je<he;He++,je++){const Ye=Ie.charCodeAt(He),et=ze.charCodeAt(je);if(Ye<et)return-1;if(Ye>et)return 1}const x=Oe-He,Ce=he-je;return x<Ce?-1:x>Ce?1:0}function p(Ie,ze){return v(Ie,ze,0,Ie.length,0,ze.length)}function v(Ie,ze,He=0,Oe=Ie.length,je=0,he=ze.length){for(;He<Oe&&je<he;He++,je++){let Ye=Ie.charCodeAt(He),et=ze.charCodeAt(je);if(Ye===et)continue;if(Ye>=128||et>=128)return A(Ie.toLowerCase(),ze.toLowerCase(),He,Oe,je,he);N(Ye)&&(Ye-=32),N(et)&&(et-=32);const ut=Ye-et;if(ut!==0)return ut}const x=Oe-He,Ce=he-je;return x<Ce?-1:x>Ce?1:0}function F(Ie){return Ie>=h.CharCode.Digit0&&Ie<=h.CharCode.Digit9}function N(Ie){return Ie>=h.CharCode.a&&Ie<=h.CharCode.z}function O(Ie){return Ie>=h.CharCode.A&&Ie<=h.CharCode.Z}function j(Ie,ze){return Ie.length===ze.length&&v(Ie,ze)===0}function z(Ie,ze){const He=ze.length;return ze.length>Ie.length?!1:v(Ie,ze,0,He)===0}function M(Ie,ze){const He=Math.min(Ie.length,ze.length);let Oe;for(Oe=0;Oe<He;Oe++)if(Ie.charCodeAt(Oe)!==ze.charCodeAt(Oe))return Oe;return He}function V(Ie,ze){const He=Math.min(Ie.length,ze.length);let Oe;const je=Ie.length-1,he=ze.length-1;for(Oe=0;Oe<He;Oe++)if(Ie.charCodeAt(je-Oe)!==ze.charCodeAt(he-Oe))return Oe;return He}function K(Ie){return 55296<=Ie&&Ie<=56319}function re(Ie){return 56320<=Ie&&Ie<=57343}function B(Ie,ze){return(Ie-55296<<10)+(ze-56320)+65536}function G(Ie,ze,He){const Oe=Ie.charCodeAt(He);if(K(Oe)&&He+1<ze){const je=Ie.charCodeAt(He+1);if(re(je))return B(Oe,je)}return Oe}function X(Ie,ze){const He=Ie.charCodeAt(ze-1);if(re(He)&&ze>1){const Oe=Ie.charCodeAt(ze-2);if(K(Oe))return B(Oe,He)}return He}class ee{get offset(){return this.e}constructor(ze,He=0){this.c=ze,this.d=ze.length,this.e=He}setOffset(ze){this.e=ze}prevCodePoint(){const ze=X(this.c,this.e);return this.e-=ze>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=G(this.c,this.d,this.e);return this.e+=ze>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Pf=ee;class de{get offset(){return this.c.offset}constructor(ze,He=0){this.c=new ee(ze,He)}nextGraphemeLength(){const ze=tt.getInstance(),He=this.c,Oe=He.offset;let je=ze.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const he=He.offset,x=ze.getGraphemeBreakType(He.nextCodePoint());if(Ge(je,x)){He.setOffset(he);break}je=x}return He.offset-Oe}prevGraphemeLength(){const ze=tt.getInstance(),He=this.c,Oe=He.offset;let je=ze.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const he=He.offset,x=ze.getGraphemeBreakType(He.prevCodePoint());if(Ge(x,je)){He.setOffset(he);break}je=x}return Oe-He.offset}eol(){return this.c.eol()}}e.$Qf=de;function ne(Ie,ze){return new de(Ie,ze).nextGraphemeLength()}function De(Ie,ze){return new de(Ie,ze).prevGraphemeLength()}function $e(Ie,ze){ze>0&&re(Ie.charCodeAt(ze))&&ze--;const He=ze+ne(Ie,ze);return[He-De(Ie,He),He]}function J(Ie){const ze=new de(Ie);let He=0;for(;!ze.eol();)He++,ze.nextGraphemeLength();return He}let U;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Ie){return U||(U=se()),U.test(Ie)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Ie){return te.test(Ie)}e.$Xf=/[\u2028\u2029]/;function ue(Ie){return e.$Xf.test(Ie)}function Z(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}function oe(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}function pe(Ie,ze,He=""){const Oe=Ie.trimStart();if(Oe.length<ze)return Oe;const je=/\b/g;let he=0;for(;je.test(Oe)&&!(Oe.length-je.lastIndex<ze);)he=je.lastIndex,je.lastIndex+=1;return he===0?Oe:He+Oe.substring(he).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Ie){let ze=0;for(const He of Ie.matchAll(we))ze!==He.index&&(yield{isCode:!1,str:Ie.substring(ze,He.index)}),yield{isCode:!0,str:He[0]},ze=He.index+He[0].length;ze!==Ie.length&&(yield{isCode:!1,str:Ie.substring(ze)})}function Ue(Ie){return Ie&&(Ie=Ie.replace(we,"")),Ie}const ke=/\\\[.*?\\\]/g;function Pe(Ie){return Ue(Ie).replace(ke,"")}e.$6f=String.fromCharCode(h.CharCode.UTF8_BOM);function Te(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===h.CharCode.UTF8_BOM)}function W(Ie){return Te(Ie)?Ie.substr(1):Ie}function q(Ie,ze){if(!Ie||!ze||Ie.length<ze.length)return!1;const He=ze.length,Oe=Ie.toLowerCase();let je=0,he=-1;for(;je<He;){const x=Oe.indexOf(ze[je],he+1);if(x<0)return!1;he=x,je++}return!0}function Y(Ie,ze=!1){return Ie?(ze&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}function _(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}function fe(Ie,ze=1){if(ze===0)return"";let He=-1;do He=Ie.indexOf(`
`,He+1),ze--;while(ze>0&&He>=0);return He===-1?Ie:(Ie[He-1]==="\r"&&He--,Ie.substr(0,He))}function be(Ie){const ze=h.CharCode.Z-h.CharCode.A+1;return Ie=Ie%(2*ze),Ie<ze?String.fromCharCode(h.CharCode.a+Ie):String.fromCharCode(h.CharCode.A+Ie-ze)}function Ne(Ie){return tt.getInstance().getGraphemeBreakType(Ie)}function Ge(Ie,ze){return Ie===Ke.Other?ze!==Ke.Extend&&ze!==Ke.SpacingMark:Ie===Ke.CR&&ze===Ke.LF?!1:Ie===Ke.Control||Ie===Ke.CR||Ie===Ke.LF||ze===Ke.Control||ze===Ke.CR||ze===Ke.LF?!0:!(Ie===Ke.L&&(ze===Ke.L||ze===Ke.V||ze===Ke.LV||ze===Ke.LVT)||(Ie===Ke.LV||Ie===Ke.V)&&(ze===Ke.V||ze===Ke.T)||(Ie===Ke.LVT||Ie===Ke.T)&&ze===Ke.T||ze===Ke.Extend||ze===Ke.ZWJ||ze===Ke.SpacingMark||Ie===Ke.Prepend||Ie===Ke.ZWJ&&ze===Ke.Extended_Pictographic||Ie===Ke.Regional_Indicator&&ze===Ke.Regional_Indicator)}var Ke;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=rt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ke.LF:ze===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(ze<127)return Ke.Other;const He=this.d,Oe=He.length/3;let je=1;for(;je<=Oe;)if(ze<He[3*je])je=2*je;else if(ze>He[3*je+1])je=2*je+1;else return He[3*je+2];return Ke.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Ie,ze){if(Ie===0)return 0;const He=nt(Ie,ze);if(He!==void 0)return He;const Oe=new ee(ze,Ie);return Oe.prevCodePoint(),Oe.offset}function nt(Ie,ze){const He=new ee(ze,Ie);let Oe=He.prevCodePoint();for(;at(Oe)||Oe===mt.emojiVariantSelector||Oe===mt.enclosingKeyCap;){if(He.offset===0)return;Oe=He.prevCodePoint()}if(!oe(Oe))return;let je=He.offset;return je>0&&He.prevCodePoint()===mt.zwj&&(je=He.offset),je}function at(Ie){return 127995<=Ie&&Ie<=127999}var mt;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.$dg="\xA0";class ht{static{this.c=new I.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new s.$af({getCacheKey:JSON.stringify},ze=>{function He(ut){const gt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)gt.set(ut[Dt],ut[Dt+1]);return gt}function Oe(ut,gt){const Dt=new Map(ut);for(const[Ot,qt]of gt)Dt.set(Ot,qt);return Dt}function je(ut,gt){if(!ut)return gt;const Dt=new Map;for(const[Ot,qt]of ut)gt.has(Ot)&&Dt.set(Ot,qt);return Dt}const he=this.c.value;let x=ze.filter(ut=>!ut.startsWith("_")&&ut in he);x.length===0&&(x=["_default"]);let Ce;for(const ut of x){const gt=He(he[ut]);Ce=je(Ce,gt)}const Ye=He(he._common),et=Oe(Ye,Ce);return new ht(et)})}static getInstance(ze){return ht.d.get(Array.from(ze))}static{this.e=new I.$X(()=>Object.keys(ht.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ht.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let He=0;He<ze.length;He++){const Oe=ze.codePointAt(He);if(typeof Oe=="number"&&this.isAmbiguous(Oe))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=ht;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(ze){return ct.e().has(ze)}static containsInvisibleCharacter(ze){for(let He=0;He<ze.length;He++){const Oe=ze.codePointAt(He);if(typeof Oe=="number"&&ct.isInvisibleCharacter(Oe))return!0}return!1}static get codePoints(){return ct.e()}}e.$fg=ct}),define(Ee[135],Se([1,0,27,29,178,13]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=L,e.$Jk=$,e.$Kk=a,e.$Lk=l,e.$Mk=D,e.$Nk=y,e.$Ok=N,e.$Pk=O,e.$Qk=j,e.$Rk=z,e.$Sk=se,e.$Uk=ue,e.$Vk=pe,e.$Wk=we,T=We(T);function L(...ke){return function(Pe,Te){for(let W=0,q=ke.length;W<q;W++){const Y=ke[W](Pe,Te);if(Y)return Y}return null}}e.$Hk=R.bind(void 0,!1),e.$Ik=R.bind(void 0,!0);function R(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let W;return ke?W=T.$If(Te,Pe):W=Te.indexOf(Pe)===0,W?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function a(ke,Pe){return k(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function k(ke,Pe,Te,W){if(Te===ke.length)return[];if(W===Pe.length)return null;if(ke[Te]===Pe[W]){let q=null;return(q=k(ke,Pe,Te+1,W+1))?t({start:W,end:W+1},q):null}return k(ke,Pe,Te,W+1)}function E(ke){return s.CharCode.a<=ke&&ke<=s.CharCode.z}function l(ke){return s.CharCode.A<=ke&&ke<=s.CharCode.Z}function P(ke){return s.CharCode.Digit0<=ke&&ke<=s.CharCode.Digit9}function b(ke){return ke===s.CharCode.Space||ke===s.CharCode.Tab||ke===s.CharCode.LineFeed||ke===s.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>c.add(ke.charCodeAt(0)));function m(ke){return b(ke)||c.has(ke)}function d(ke,Pe){return ke===Pe||m(ke)&&m(Pe)}const g=new Map;function n(ke){if(g.has(ke))return g.get(ke);let Pe;const Te=(0,I.$Fk)(ke);return Te&&(Pe=Te),g.set(ke,Pe),Pe}function o(ke){return E(ke)||l(ke)||P(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function i(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const W=ke.charCodeAt(Te);if(l(W)||P(W)||Te>0&&!o(ke.charCodeAt(Te-1)))return Te}return ke.length}function r(ke,Pe,Te,W){if(Te===ke.length)return[];if(W===Pe.length)return null;if(ke[Te]!==Pe[W].toLowerCase())return null;{let q=null,Y=W+1;for(q=r(ke,Pe,Te+1,W+1);!q&&(Y=i(Pe,Y))<Pe.length;)q=r(ke,Pe,Te+1,Y),Y++;return q===null?null:t({start:W,end:W+1},q)}}function f(ke){let Pe=0,Te=0,W=0,q=0,Y=0;for(let Ge=0;Ge<ke.length;Ge++)Y=ke.charCodeAt(Ge),l(Y)&&Pe++,E(Y)&&Te++,o(Y)&&W++,P(Y)&&q++;const _=Pe/ke.length,fe=Te/ke.length,be=W/ke.length,Ne=q/ke.length;return{upperPercent:_,lowerPercent:fe,alphaPercent:be,numericPercent:Ne}}function u(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function w(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:W,numericPercent:q}=ke;return Te>.2&&Pe<.8&&W>.6&&q<.2}function S(ke){let Pe=0,Te=0,W=0,q=0;for(let Y=0;Y<ke.length;Y++)W=ke.charCodeAt(Y),l(W)&&Pe++,E(W)&&Te++,b(W)&&q++;return(Pe===0||Te===0)&&q===0?ke.length<=30:Pe<=5}function D(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!S(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=f(Pe);if(!w(Te)){if(!u(Te))return null;Pe=Pe.toLowerCase()}let W=null,q=0;for(ke=ke.toLowerCase();q<Pe.length&&(W=r(ke,Pe,0,q))===null;)q=i(Pe,q+1);return W}function y(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let W=null,q=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();q<Pe.length&&(W=C(ke,Pe,0,q,Te),W===null);)q=A(Pe,q+1);return W}function C(ke,Pe,Te,W,q){let Y=0;if(Te===ke.length)return[];if(W===Pe.length)return null;if(!d(ke.charCodeAt(Te),Pe.charCodeAt(W))){const be=n(ke.charCodeAt(Te));if(!be)return null;for(let Ne=0;Ne<be.length;Ne++)if(!d(be[Ne],Pe.charCodeAt(W+Ne)))return null;Y+=be.length-1}let _=null,fe=W+Y+1;if(_=C(ke,Pe,Te+1,fe,q),!q)for(;!_&&(fe=A(Pe,fe))<Pe.length;)_=C(ke,Pe,Te+1,fe,q),fe++;if(!_)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(W)){const be=n(ke.charCodeAt(Te));if(!be)return _;for(let Ne=0;Ne<be.length;Ne++)if(be[Ne]!==Pe.charCodeAt(W+Ne))return _}return t({start:W,end:W+Y+1},_)}function A(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(m(ke.charCodeAt(Te))||Te>0&&m(ke.charCodeAt(Te-1)))return Te;return ke.length}const p=L(e.$Ik,D,$),v=L(e.$Ik,D,a),F=new h.$Gc(1e4);function N(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let W=F.get(ke);W||(W=new RegExp(T.$qf(ke),"i"),F.set(ke,W));const q=W.exec(Pe);return q?[{start:q.index,end:q.index+q[0].length}]:Te?v(ke,Pe):p(ke,Pe)}function O(ke,Pe){const Te=ue(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?z(Te):null}function j(ke,Pe,Te,W,q,Y){const _=Math.min(13,ke.length);for(;Te<_;Te++){const fe=ue(ke,Pe,Te,W,q,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Y]}function z(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let W=ke.length-1;W>1;W--){const q=ke[W]+Te,Y=Pe[Pe.length-1];Y&&Y.end===q?Y.end=q+1:Pe.push({start:q,end:q+1})}return Pe}const M=128;function V(){const ke=[],Pe=[];for(let Te=0;Te<=M;Te++)Pe[Te]=0;for(let Te=0;Te<=M;Te++)ke.push(Pe.slice(0));return ke}function K(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const re=K(2*M),B=K(2*M),G=V(),X=V(),ee=V(),de=!1;function ne(ke,Pe,Te,W,q){function Y(fe,be,Ne=" "){for(;fe.length<be;)fe=Ne+fe;return fe}let _=` |   |${W.split("").map(fe=>Y(fe,3)).join("|")}
`;for(let fe=0;fe<=Te;fe++)fe===0?_+=" |":_+=`${Pe[fe-1]}|`,_+=ke[fe].slice(0,q+1).map(be=>Y(be.toString(),3)).join("|")+`
`;return _}function De(ke,Pe,Te,W){ke=ke.substr(Pe),Te=Te.substr(W),console.log(ne(X,ke,ke.length,Te,Te.length)),console.log(ne(ee,ke,ke.length,Te,Te.length)),console.log(ne(G,ke,ke.length,Te,Te.length))}function $e(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.Slash:case s.CharCode.Backslash:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:case s.CharCode.DollarSign:case s.CharCode.LessThan:case s.CharCode.GreaterThan:case s.CharCode.OpenParen:case s.CharCode.CloseParen:case s.CharCode.OpenSquareBracket:case s.CharCode.CloseSquareBracket:case s.CharCode.OpenCurlyBrace:case s.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$1f(Te)}}function J(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case s.CharCode.Space:case s.CharCode.Tab:return!0;default:return!1}}function U(ke,Pe,Te){return Pe[ke]!==Te[ke]}function se(ke,Pe,Te,W,q,Y,_=!1){for(;Pe<Te&&q<Y;)ke[Pe]===W[q]&&(_&&(re[Pe]=q),Pe+=1),q+=1;return Pe===Te}var ae;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var te;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Tk=le;function ue(ke,Pe,Te,W,q,Y,_=le.default){const fe=ke.length>M?M:ke.length,be=W.length>M?M:W.length;if(Te>=fe||Y>=be||fe-Te>be-Y||!se(Pe,Te,fe,q,Y,be,!0))return;Z(fe,be,Te,Y,Pe,q);let Ne=1,Ge=1,Ke=Te,tt=Y;const rt=[!1];for(Ne=1,Ke=Te;Ke<fe;Ne++,Ke++){const ht=re[Ke],ct=B[Ke],Ie=Ke+1<fe?B[Ke+1]:be;for(Ge=ht-Y+1,tt=ht;tt<Ie;Ge++,tt++){let ze=Number.MIN_SAFE_INTEGER,He=!1;tt<=ct&&(ze=oe(ke,Pe,Ke,Te,W,q,tt,be,Y,G[Ne-1][Ge-1]===0,rt));let Oe=0;ze!==Number.MAX_SAFE_INTEGER&&(He=!0,Oe=ze+X[Ne-1][Ge-1]);const je=tt>ht,he=je?X[Ne][Ge-1]+(G[Ne][Ge-1]>0?-5:0):0,x=tt>ht+1&&G[Ne][Ge-1]>0,Ce=x?X[Ne][Ge-2]+(G[Ne][Ge-2]>0?-5:0):0;if(x&&(!je||Ce>=he)&&(!He||Ce>=Oe))X[Ne][Ge]=Ce,ee[Ne][Ge]=ae.LeftLeft,G[Ne][Ge]=0;else if(je&&(!He||he>=Oe))X[Ne][Ge]=he,ee[Ne][Ge]=ae.Left,G[Ne][Ge]=0;else if(He)X[Ne][Ge]=Oe,ee[Ne][Ge]=ae.Diag,G[Ne][Ge]=G[Ne-1][Ge-1]+1;else throw new Error("not possible")}}if(de&&De(ke,Te,W,Y),!rt[0]&&!_.firstMatchCanBeWeak)return;Ne--,Ge--;const ot=[X[Ne][Ge],Y];let nt=0,at=0;for(;Ne>=1;){let ht=Ge;do{const ct=ee[Ne][ht];if(ct===ae.LeftLeft)ht=ht-2;else if(ct===ae.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Pe[Te+Ne-1]===q[Y+Ge-1]&&!U(ht+Y-1,W,q)&&nt+1>G[Ne][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,at||(at=ht),Ne--,Ge=ht-1,ot.push(Ge)}be-Y===fe&&_.boostFullMatch&&(ot[0]+=2);const mt=at-fe;return ot[0]-=mt,ot}function Z(ke,Pe,Te,W,q,Y){let _=ke-1,fe=Pe-1;for(;_>=Te&&fe>=W;)q[_]===Y[fe]&&(B[_]=fe,_--),fe--}function oe(ke,Pe,Te,W,q,Y,_,fe,be,Ne,Ge){if(Pe[Te]!==Y[_])return Number.MIN_SAFE_INTEGER;let Ke=1,tt=!1;return _===Te-W?Ke=ke[Te]===q[_]?7:5:U(_,q,Y)&&(_===0||!U(_-1,q,Y))?(Ke=ke[Te]===q[_]?7:5,tt=!0):$e(Y,_)&&(_===0||!$e(Y,_-1))?Ke=5:($e(Y,_-1)||J(Y,_-1))&&(Ke=5,tt=!0),Ke>1&&Te===W&&(Ge[0]=!0),tt||(tt=U(_,q,Y)||$e(Y,_-1)||J(Y,_-1)),Te===W?_>be&&(Ke-=tt?3:5):Ne?Ke+=tt?2:0:Ke+=tt?0:1,_+1===fe&&(Ke-=tt?3:5),Ke}function pe(ke,Pe,Te,W,q,Y,_){return Fe(ke,Pe,Te,W,q,Y,!0,_)}function we(ke,Pe,Te,W,q,Y,_){return Fe(ke,Pe,Te,W,q,Y,!1,_)}function Fe(ke,Pe,Te,W,q,Y,_,fe){let be=ue(ke,Pe,Te,W,q,Y,fe);if(be&&!_)return be;if(ke.length>=3){const Ne=Math.min(7,ke.length-1);for(let Ge=Te+1;Ge<Ne;Ge++){const Ke=Ue(ke,Ge);if(Ke){const tt=ue(Ke,Ke.toLowerCase(),Te,W,q,Y,fe);tt&&(tt[0]-=3,(!be||tt[0]>be[0])&&(be=tt))}}}return be}function Ue(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],W=ke[Pe+1];if(Te!==W)return ke.slice(0,Pe)+W+Te+ke.slice(Pe+2)}}),define(Ee[60],Se([1,0,13]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=h,e.$vj=I,e.$wj=T,e.$xj=R,e.$zj=c,s=We(s);function h(d){return I(d,0)}function I(d,g){switch(typeof d){case"object":return d===null?T(349,g):Array.isArray(d)?$(d,g):a(d,g);case"string":return R(d,g);case"boolean":return L(d,g);case"number":return T(d,g);case"undefined":return T(937,g);default:return T(617,g)}}function T(d,g){return(g<<5)-g+d|0}function L(d,g){return T(d?433:863,g)}function R(d,g){g=T(149417,g);for(let n=0,o=d.length;n<o;n++)g=T(d.charCodeAt(n),g);return g}function $(d,g){return g=T(104579,g),d.reduce((n,o)=>I(o,n),g)}function a(d,g){return g=T(181387,g),Object.keys(d).sort().reduce((n,o)=>(n=R(o,n),I(d[o],n)),g)}class k{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=I(g,this.g),this.g}}e.$yj=k;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function l(d,g,n=32){const o=n-g,t=~((1<<o)-1);return(d<<g|(t&d)>>>o)>>>0}function P(d,g=0,n=d.byteLength,o=0){for(let t=0;t<n;t++)d[g+t]=o}function b(d,g,n="0"){for(;d.length<g;)d=n+d;return d}function c(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(n=>n.toString(16).padStart(2,"0")).join(""):b((d>>>0).toString(16),g/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const n=g.length;if(n===0)return;const o=this.p;let t=this.r,i=this.u,r,f;for(i!==0?(r=i,f=-1,i=0):(r=g.charCodeAt(0),f=0);;){let u=r;if(s.$Lf(r))if(f+1<n){const w=g.charCodeAt(f+1);s.$Mf(w)?(f++,u=s.$Nf(r,w)):u=E.UNICODE_REPLACEMENT}else{i=r;break}else s.$Mf(r)&&(u=E.UNICODE_REPLACEMENT);if(t=this.w(o,t,u),f++,f<n)r=g.charCodeAt(f);else break}this.r=t,this.u=i}w(g,n,o){return o<128?g[n++]=o:o<2048?(g[n++]=192|(o&1984)>>>6,g[n++]=128|(o&63)>>>0):o<65536?(g[n++]=224|(o&61440)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0):(g[n++]=240|(o&1835008)>>>18,g[n++]=128|(o&258048)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,g[0]=g[E.BLOCK_SIZE+0],g[1]=g[E.BLOCK_SIZE+1],g[2]=g[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=m.g,n=this.q;for(let D=0;D<64;D+=4)g.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)g.setUint32(D,l(g.getUint32(D-12,!1)^g.getUint32(D-32,!1)^g.getUint32(D-56,!1)^g.getUint32(D-64,!1),1),!1);let o=this.h,t=this.l,i=this.m,r=this.n,f=this.o,u,w,S;for(let D=0;D<80;D++)D<20?(u=t&i|~t&r,w=1518500249):D<40?(u=t^i^r,w=1859775393):D<60?(u=t&i|t&r|i&r,w=2400959708):(u=t^i^r,w=3395469782),S=l(o,5)+u+f+w+g.getUint32(D*4,!1)&4294967295,f=r,r=i,i=l(t,30),t=o,o=S;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+f&4294967295}}e.$Aj=m}),define(Ee[136],Se([1,0,135,13,50]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=$,e.$Yk=k,e.$Zk=l,e.$1k=P,e.$2k=c,e.$3k=m;const T="$(",L=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function $(d){return d.replace(R,(g,n)=>n?g:`\\${g}`)}const a=new RegExp(`\\\\${L.source}`,"g");function k(d){return d.replace(a,g=>`\\${g}`)}const E=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function l(d){return d.indexOf(T)===-1?d:d.replace(E,(g,n,o,t)=>o?g:n||t||"")}function P(d){return d?d.replace(/\$\((.*?)\)/g,(g,n)=>` ${n} `).trim():""}const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(d){b.lastIndex=0;let g="";const n=[];let o=0;for(;;){const t=b.lastIndex,i=b.exec(d),r=d.substring(t,i?.index);if(r.length>0){g+=r;for(let f=0;f<r.length;f++)n.push(o)}if(!i)break;o+=i[0].length}return{text:g,iconOffsets:n}}function m(d,g,n=!1){const{text:o,iconOffsets:t}=g;if(!t||t.length===0)return(0,s.$Ok)(d,o,n);const i=(0,h.$of)(o," "),r=o.length-i.length,f=(0,s.$Ok)(d,i,n);if(f)for(const u of f){const w=t[u.start+r]+r;u.start+=w,u.end+=w}return f}}),define(Ee[44],Se([1,0,13]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=We(s);var h;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(h||(h={})),function(I){const T="error",L="warning",R="warn",$="info",a="ignore";function k(l){return l?s.$Hf(T,l)?I.Error:s.$Hf(L,l)||s.$Hf(R,l)?I.Warning:s.$Hf($,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=k;function E(l){switch(l){case I.Error:return T;case I.Warning:return L;case I.Info:return $;default:return a}}I.toString=E}(h||(h={})),e.default=h}),define(Ee[85],Se([1,0,19,27,13]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class T{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const c=b.charCodeAt(0),m=this.b.charCodeAt(this.c);return c-m}value(){return this.b[this.c]}}e.$Ii=T;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,I.$Bf)(b,this.b,0,b.length,this.c,this.d):(0,I.$Df)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=L;class R{constructor(b=!0,c=!0){this.f=b,this.g=c}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let c=b.length-1;c>=0;c--,this.c--){const m=this.b.charCodeAt(c);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===h.CharCode.Slash||this.f&&c===h.CharCode.Backslash)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,I.$Bf)(b,this.b,0,b.length,this.d,this.e):(0,I.$Df)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=R;var $;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})($||($={}));class a{constructor(b,c){this.f=b,this.g=c,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push($.Path)),this.g(b)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===$.Scheme)return(0,I.$Cf)(b,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,I.$Cf)(b,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(b);if(this.d[this.e]===$.Query)return(0,I.$Af)(b,this.c.query);if(this.d[this.e]===$.Fragment)return(0,I.$Af)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Li=a;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(E||(E={}));class l{static forUris(b=()=>!1,c=()=>!1){return new l(new a(b,c))}static forPaths(b=!1){return new l(new R(void 0,!b))}static forStrings(){return new l(new T)}static forConfigKeys(){return new l(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,c){if(c){const m=c.slice(0);(0,s.$Zb)(m);for(const d of m)this.set(d,b)}else{const m=b.slice(0);(0,s.$Zb)(m);for(const d of m)this.set(d[0],d[1])}}set(b,c){const m=this.b.reset(b);let d;this.c||(this.c=new k,this.c.segment=m.value());const g=[];for(d=this.c;;){const o=m.cmp(d.segment);if(o>0)d.left||(d.left=new k,d.left.segment=m.value()),g.push([E.Left,d]),d=d.left;else if(o<0)d.right||(d.right=new k,d.right.segment=m.value()),g.push([E.Right,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new k,d.mid.segment=m.value()),g.push([E.Mid,d]),d=d.mid;else break}const n=d.value;d.value=c,d.key=b;for(let o=g.length-1;o>=0;o--){const t=g[o][1];t.updateHeight();const i=t.balanceFactor();if(i<-1||i>1){const r=g[o][0],f=g[o+1][0];if(r===E.Right&&f===E.Right)g[o][1]=t.rotateLeft();else if(r===E.Left&&f===E.Left)g[o][1]=t.rotateRight();else if(r===E.Right&&f===E.Left)t.right=g[o+1][1]=g[o+1][1].rotateRight(),g[o][1]=t.rotateLeft();else if(r===E.Left&&f===E.Right)t.left=g[o+1][1]=g[o+1][1].rotateLeft(),g[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(g[o-1][0]){case E.Left:g[o-1][1].left=g[o][1];break;case E.Right:g[o-1][1].right=g[o][1];break;case E.Mid:g[o-1][1].mid=g[o][1];break}else this.c=g[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const c=this.b.reset(b);let m=this.c;for(;m;){const d=c.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else break}return m}has(b){const c=this.d(b);return!(c?.value===void 0&&c?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,c){const m=this.b.reset(b),d=[];let g=this.c;for(;g;){const n=m.cmp(g.segment);if(n>0)d.push([E.Left,g]),g=g.left;else if(n<0)d.push([E.Right,g]),g=g.right;else if(m.hasNext())m.next(),d.push([E.Mid,g]),g=g.mid;else break}if(g){if(c?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this.f(g.right);if(n.key){const{key:o,value:t,segment:i}=n;this.e(n.key,!1),g.key=o,g.value=t,g.segment=i}}else{const n=g.left??g.right;if(d.length>0){const[o,t]=d[d.length-1];switch(o){case E.Left:t.left=n;break;case E.Mid:t.mid=n;break;case E.Right:t.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const o=d[n][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),d[n][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),d[n][1]=o.rotateRight()),n>0)switch(d[n-1][0]){case E.Left:d[n-1][1].left=d[n][1];break;case E.Right:d[n-1][1].right=d[n][1];break;case E.Mid:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const c=this.b.reset(b);let m=this.c,d;for(;m;){const g=c.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(c.hasNext())c.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(b){return this.g(b,!1)}g(b,c){const m=this.b.reset(b);let d=this.c;for(;d;){const g=m.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):c?d.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[c,m]of this)b(m,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const c=[];return this.j(b,c),c[Symbol.iterator]()}j(b,c){b&&(b.left&&this.j(b.left,c),b.value&&c.push([b.key,b.value]),b.mid&&this.j(b.mid,c),b.right&&this.j(b.right,c))}_isBalanced(){const b=c=>{if(!c)return!0;const m=c.balanceFactor();return m<-1||m>1?!1:b(c.left)&&b(c.right)};return b(this.c)}}e.$Mi=l}),define(Ee[32],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=h;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(I){return s.test(I)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(R){for(let $=0;$<R.length;$++)R[$]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){I(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let $=0,a="";return a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a+="-",a+=L[T[$++]],a+=L[T[$++]],a+="-",a+=L[T[$++]],a+=L[T[$++]],a+="-",a+=L[T[$++]],a+=L[T[$++]],a+="-",a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a+=L[T[$++]],a}}()}),define(Ee[187],Se([1,0,19,40,32]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=T,e.$nu=L,e.$pu=a;function T(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function L(E,l,P){const b={id:(0,I.$3g)(),name:E,uri:l,data:P};return{asString:async()=>"",asFile:()=>b,value:void 0}}class R{constructor(){this.a=new Map}get size(){let l=0;for(const P of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const P=[...this.a.keys()];return h.Iterable.some(this,([b,c])=>c.asFile())&&P.push("files"),k($(l),P)}get(l){return this.a.get(this.b(l))?.[0]}append(l,P){const b=this.a.get(l);b?b.push(P):this.a.set(this.b(l),[P])}replace(l,P){this.a.set(this.b(l),[P])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,P]of this.a)for(const b of P)yield[l,b]}b(l){return $(l)}}e.$ou=R;function $(E){return E.toLowerCase()}function a(E,l){return k($(E),l.map($))}function k(E,l){if(E==="*/*")return l.length>0;if(l.includes(E))return!0;const P=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[b,c,m]=P;return m==="*"?l.some(d=>d.startsWith(c+"/")):!1}e.$qu=Object.freeze({create:E=>(0,s.$Pb)(E.map(l=>l.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$qu.split(E).filter(l=>!l.startsWith("#"))})}),define(Ee[188],Se([1,0,67]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=h,e.$7g=T,s=We(s);function h(R,$,a,k=1){let E=!1;return new Promise(l=>{const P=setTimeout(()=>{if(!E)return E=!0,l(0)},a);I(R,$,k,b=>{if(!E)return E=!0,clearTimeout(P),l(b)})})}function I(R,$,a,k){if($===0)return k(0);const E=new s.Socket;E.once("connect",()=>(L(E),I(R+a,$-1,a,k))),E.once("data",()=>{}),E.once("error",l=>(L(E),l.code!=="ECONNREFUSED"?I(R+a,$-1,a,k):k(R))),E.connect(R,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,$,a,k="127.0.0.1"){let E=!1,l,P=1;const b=s.createServer({pauseOnConnect:!0});function c(m,d){E||(E=!0,b.removeAllListeners(),b.close(),l&&clearTimeout(l),d(m))}return new Promise(m=>{l=setTimeout(()=>{c(0,m)},a),b.on("listening",()=>{c(R,m)}),b.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&P<$?(R++,P++,b.listen(R,k)):c(0,m)}),b.on("close",()=>{c(0,m)}),b.listen(R,k)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch($){console.error($)}}}),define(Ee[137],Se([1,0,84]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=e.$eu=void 0;class h{constructor(R){const $=(0,s.$cf)(R);this.c=$,this.a=h.d($),this.b=new Map}static d(R){const $=new Uint8Array(256);return $.fill(R),$}set(R,$){const a=(0,s.$cf)($);R>=0&&R<256?this.a[R]=a:this.b.set(R,a)}get(R){return R>=0&&R<256?this.a[R]:this.b.get(R)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$eu=h;var I;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(I||(I={}));class T{constructor(){this.a=new h(I.False)}add(R){this.a.set(R,I.True)}has(R){return this.a.get(R)===I.True}clear(){return this.a.clear()}}e.$fu=T}),define(Ee[189],Se([1,0,27]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$wu=I;var h;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function I(T){let L=0,R=0,$=0,a=h.Unknown;for(let k=0,E=T.length;k<E;k++){const l=T.charCodeAt(k);l===s.CharCode.CarriageReturn?(L===0&&(R=k),L++,k+1<E&&T.charCodeAt(k+1)===s.CharCode.LineFeed?(a|=h.CRLF,k++):a|=h.Invalid,$=k+1):l===s.CharCode.LineFeed&&(a|=h.LF,L===0&&(R=k),L++,$=k+1)}return L===0&&(R=T.length),[L,R,T.length-$,a]}}),define(Ee[54],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class s{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new s(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return s.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return s.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return s.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){const L=I.lineNumber|0,R=T.lineNumber|0;if(L===R){const $=I.column|0,a=T.column|0;return $-a}return L-R}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new s(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Lt=s}),define(Ee[31],Se([1,0,54]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class h{constructor(T,L,R,$){T>R||T===R&&L>$?(this.startLineNumber=R,this.startColumn=$,this.endLineNumber=T,this.endColumn=L):(this.startLineNumber=T,this.startColumn=L,this.endLineNumber=R,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return h.containsPosition(this,T)}static containsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<T.startColumn||L.lineNumber===T.endLineNumber&&L.column>T.endColumn)}static strictContainsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<=T.startColumn||L.lineNumber===T.endLineNumber&&L.column>=T.endColumn)}containsRange(T){return h.containsRange(this,T)}static containsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>T.endColumn)}strictContainsRange(T){return h.strictContainsRange(this,T)}static strictContainsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<=T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>=T.endColumn)}plusRange(T){return h.plusRange(this,T)}static plusRange(T,L){let R,$,a,k;return L.startLineNumber<T.startLineNumber?(R=L.startLineNumber,$=L.startColumn):L.startLineNumber===T.startLineNumber?(R=L.startLineNumber,$=Math.min(L.startColumn,T.startColumn)):(R=T.startLineNumber,$=T.startColumn),L.endLineNumber>T.endLineNumber?(a=L.endLineNumber,k=L.endColumn):L.endLineNumber===T.endLineNumber?(a=L.endLineNumber,k=Math.max(L.endColumn,T.endColumn)):(a=T.endLineNumber,k=T.endColumn),new h(R,$,a,k)}intersectRanges(T){return h.intersectRanges(this,T)}static intersectRanges(T,L){let R=T.startLineNumber,$=T.startColumn,a=T.endLineNumber,k=T.endColumn;const E=L.startLineNumber,l=L.startColumn,P=L.endLineNumber,b=L.endColumn;return R<E?(R=E,$=l):R===E&&($=Math.max($,l)),a>P?(a=P,k=b):a===P&&(k=Math.min(k,b)),R>a||R===a&&$>k?null:new h(R,$,a,k)}equalsRange(T){return h.equalsRange(this,T)}static equalsRange(T,L){return!T&&!L?!0:!!T&&!!L&&T.startLineNumber===L.startLineNumber&&T.startColumn===L.startColumn&&T.endLineNumber===L.endLineNumber&&T.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(T){return new s.$Lt(T.endLineNumber,T.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(T){return new s.$Lt(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,L){return new h(this.startLineNumber,this.startColumn,T,L)}setStartPosition(T,L){return new h(T,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(T){return new h(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(T){return new h(T.endLineNumber,T.endColumn,T.endLineNumber,T.endColumn)}delta(T){return new h(this.startLineNumber+T,this.startColumn,this.endLineNumber+T,this.endColumn)}static fromPositions(T,L=T){return new h(T.lineNumber,T.column,L.lineNumber,L.column)}static lift(T){return T?new h(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<T.startColumn)}static areIntersecting(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<=L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,L){if(T&&L){const a=T.startLineNumber|0,k=L.startLineNumber|0;if(a===k){const E=T.startColumn|0,l=L.startColumn|0;if(E===l){const P=T.endLineNumber|0,b=L.endLineNumber|0;if(P===b){const c=T.endColumn|0,m=L.endColumn|0;return c-m}return P-b}return E-l}return a-k}return(T?1:0)-(L?1:0)}static compareRangesUsingEnds(T,L){return T.endLineNumber===L.endLineNumber?T.endColumn===L.endColumn?T.startLineNumber===L.startLineNumber?T.startColumn-L.startColumn:T.startLineNumber-L.startLineNumber:T.endColumn-L.endColumn:T.endLineNumber-L.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.$Mt=h}),define(Ee[190],Se([1,0,31]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class h{static insert(T,L){return{range:new s.$Mt(T.lineNumber,T.column,T.lineNumber,T.column),text:L,forceMoveMarkers:!0}}static delete(T){return{range:T,text:null}}static replace(T,L){return{range:T,text:L}}static replaceMove(T,L){return{range:T,text:L,forceMoveMarkers:!0}}}e.$Nt=h}),define(Ee[191],Se([1,0,54,31]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.SelectionDirection=void 0;var I;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(I||(e.SelectionDirection=I={}));class T extends h.$Mt{constructor(R,$,a,k){super(R,$,a,k),this.selectionStartLineNumber=R,this.selectionStartColumn=$,this.positionLineNumber=a,this.positionColumn=k}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return T.selectionsEqual(this,R)}static selectionsEqual(R,$){return R.selectionStartLineNumber===$.selectionStartLineNumber&&R.selectionStartColumn===$.selectionStartColumn&&R.positionLineNumber===$.positionLineNumber&&R.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?I.LTR:I.RTL}setEndPosition(R,$){return this.getDirection()===I.LTR?new T(this.startLineNumber,this.startColumn,R,$):new T(R,$,this.startLineNumber,this.startColumn)}getPosition(){return new s.$Lt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new s.$Lt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,$){return this.getDirection()===I.LTR?new T(R,$,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,R,$)}static fromPositions(R,$=R){return new T(R.lineNumber,R.column,$.lineNumber,$.column)}static fromRange(R,$){return $===I.LTR?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new T(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new T(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,$){if(R&&!$||!R&&$)return!1;if(!R&&!$)return!0;if(R.length!==$.length)return!1;for(let a=0,k=R.length;a<k;a++)if(!this.selectionsEqual(R[a],$[a]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,$,a,k,E){return E===I.LTR?new T(R,$,a,k):new T(a,k,R,$)}}e.$Ot=T}),define(Ee[192],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0,e.$jt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[193],Se([1,0,27,29,137]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.WordCharacterClass=void 0,e.$hu=$;var T;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class L extends I.$eu{constructor(k,E){super(T.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let l=0,P=k.length;l<P;l++)this.set(k.charCodeAt(l),T.WordSeparator);this.set(s.CharCode.Space,T.Whitespace),this.set(s.CharCode.Tab,T.Whitespace)}findPrevIntlWordBeforeOrAtOffset(k,E){let l=null;for(const P of this.h(k)){if(P.index>E)break;l=P}return l}findNextIntlWordAtOrAfterOffset(k,E){for(const l of this.h(k))if(!(l.index<E))return l;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const E=[];for(const l of k)this.k(l)&&E.push(l);return E}k(k){return!!k.isWordLike}}e.$gu=L;const R=new h.$Gc(10);function $(a,k){const E=`${a}/${k.join(",")}`;let l=R.get(E);return l||(l=new L(a,k),R.set(E,l)),l}}),define(Ee[138],Se([1,0,40,3,81]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=void 0,e.$mt=L,e.$nt=$,e.$ot=a,e.$kt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function T(E=""){let l="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$kt)E.indexOf(P)>=0||(l+="\\"+P);return l+="\\s]+)",new RegExp(l,"g")}e.$lt=T();function L(E){let l=e.$lt;if(E&&E instanceof RegExp)if(E.global)l=E;else{let P="g";E.ignoreCase&&(P+="i"),E.multiline&&(P+="m"),E.unicode&&(P+="u"),l=new RegExp(E.source,P)}return l.lastIndex=0,l}const R=new I.$8c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const l=R.unshift(E);return(0,h.$Vc)(l)}function a(E,l,P,b,c){if(l=L(l),c||(c=s.Iterable.first(R)),P.length>c.maxLen){let o=E-c.maxLen/2;return o<0?o=0:b+=o,P=P.substring(o,E+c.maxLen/2),a(E,l,P,b,c)}const m=Date.now(),d=E-1-b;let g=-1,n=null;for(let o=1;!(Date.now()-m>=c.timeBudget);o++){const t=d-c.windowSize*o;l.lastIndex=Math.max(0,t);const i=k(l,P,d,g);if(!i&&n||(n=i,t<=0))break;g=t}if(n){const o={word:n[0],startColumn:b+1+n.index,endColumn:b+1+n.index+n[0].length};return l.lastIndex=0,o}return null}function k(E,l,P,b){let c;for(;c=E.exec(l);){const m=c.index||0;if(m<=P&&E.lastIndex>=P)return c;if(b>0&&m>b)return null}return null}}),define(Ee[106],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var s;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(s||(e.LanguageId=s={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var I;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(I||(e.ColorId=I={}));var T;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var L;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(a){return(a&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(a){return(a&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(a){return(a&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(a){return(a&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(a){return(a&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(a){return(a&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(a){let E="mtk"+this.getForeground(a);const l=this.getFontStyle(a);return l&h.Italic&&(E+=" mtki"),l&h.Bold&&(E+=" mtkb"),l&h.Underline&&(E+=" mtku"),l&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(a,k){const E=this.getForeground(a),l=this.getFontStyle(a);let P=`color: ${k[E]};`;l&h.Italic&&(P+="font-style: italic;"),l&h.Bold&&(P+="font-weight: bold;");let b="";return l&h.Underline&&(b+=" underline"),l&h.Strikethrough&&(b+=" line-through"),b&&(P+=`text-decoration:${b};`),P}static getPresentationFromMetadata(a){const k=this.getForeground(a),E=this.getFontStyle(a);return{foreground:k,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$su=R}),define(Ee[194],Se([1,0,27,106]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.IndentAction=void 0;var I;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let k=0,E=a.notIn.length;k<E;k++)switch(a.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,k){if(a.getTokenCount()===0)return!0;const E=a.findTokenIndexAtOffset(k-2),l=a.getStandardTokenType(E);return this.isOK(l)}g(a,k){for(let E=a;E<=k;E++){const l=String.fromCharCode(E);if(!this.open.includes(l)&&!this.close.includes(l))return l}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(s.CharCode.Digit0,s.CharCode.Digit9)),this.e||(this.e=this.g(s.CharCode.a,s.CharCode.z)),this.e||(this.e=this.g(s.CharCode.A,s.CharCode.Z))),this.e}}e.$Tu=T;class L{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of a)R(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),R(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),R(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),R(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&R(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$Uu=L;function R($,a,k){$.has(a)?$.get(a).push(k):$.set(a,[k])}}),define(Ee[195],Se([1,0,27,137]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4=e.$p4=e.State=void 0,e.$r4=P;var I;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(I||(e.State=I={}));class T{constructor(c,m,d){const g=new Uint8Array(c*m);for(let n=0,o=c*m;n<o;n++)g[n]=d;this.a=g,this.rows=c,this.cols=m}get(c,m){return this.a[c*this.cols+m]}set(c,m,d){this.a[c*this.cols+m]=d}}class L{constructor(c){let m=0,d=I.Invalid;for(let n=0,o=c.length;n<o;n++){const[t,i,r]=c[n];i>m&&(m=i),t>d&&(d=t),r>d&&(d=r)}m++,d++;const g=new T(d,m,I.Invalid);for(let n=0,o=c.length;n<o;n++){const[t,i,r]=c[n];g.set(t,i,r)}this.a=g,this.b=m}nextState(c,m){return m<0||m>=this.b?I.Invalid:this.a.get(c,m)}}e.$p4=L;let R=null;function $(){return R===null&&(R=new L([[I.Start,s.CharCode.h,I.H],[I.Start,s.CharCode.H,I.H],[I.Start,s.CharCode.f,I.F],[I.Start,s.CharCode.F,I.F],[I.H,s.CharCode.t,I.HT],[I.H,s.CharCode.T,I.HT],[I.HT,s.CharCode.t,I.HTT],[I.HT,s.CharCode.T,I.HTT],[I.HTT,s.CharCode.p,I.HTTP],[I.HTT,s.CharCode.P,I.HTTP],[I.HTTP,s.CharCode.s,I.BeforeColon],[I.HTTP,s.CharCode.S,I.BeforeColon],[I.HTTP,s.CharCode.Colon,I.AfterColon],[I.F,s.CharCode.i,I.FI],[I.F,s.CharCode.I,I.FI],[I.FI,s.CharCode.l,I.FIL],[I.FI,s.CharCode.L,I.FIL],[I.FIL,s.CharCode.e,I.BeforeColon],[I.FIL,s.CharCode.E,I.BeforeColon],[I.BeforeColon,s.CharCode.Colon,I.AfterColon],[I.AfterColon,s.CharCode.Slash,I.AlmostThere],[I.AlmostThere,s.CharCode.Slash,I.End]])),R}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let k=null;function E(){if(k===null){k=new h.$eu(a.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<b.length;m++)k.set(b.charCodeAt(m),a.ForceTermination);const c=".,;:";for(let m=0;m<c.length;m++)k.set(c.charCodeAt(m),a.CannotEndIn)}return k}class l{static a(c,m,d,g,n){let o=n-1;do{const t=m.charCodeAt(o);if(c.get(t)!==a.CannotEndIn)break;o--}while(o>g);if(g>0){const t=m.charCodeAt(g-1),i=m.charCodeAt(o);(t===s.CharCode.OpenParen&&i===s.CharCode.CloseParen||t===s.CharCode.OpenSquareBracket&&i===s.CharCode.CloseSquareBracket||t===s.CharCode.OpenCurlyBrace&&i===s.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:d,startColumn:g+1,endLineNumber:d,endColumn:o+2},url:m.substring(g,o+1)}}static computeLinks(c,m=$()){const d=E(),g=[];for(let n=1,o=c.getLineCount();n<=o;n++){const t=c.getLineContent(n),i=t.length;let r=0,f=0,u=0,w=I.Start,S=!1,D=!1,y=!1,C=!1;for(;r<i;){let A=!1;const p=t.charCodeAt(r);if(w===I.Accept){let v;switch(p){case s.CharCode.OpenParen:S=!0,v=a.None;break;case s.CharCode.CloseParen:v=S?a.None:a.ForceTermination;break;case s.CharCode.OpenSquareBracket:y=!0,D=!0,v=a.None;break;case s.CharCode.CloseSquareBracket:y=!1,v=D?a.None:a.ForceTermination;break;case s.CharCode.OpenCurlyBrace:C=!0,v=a.None;break;case s.CharCode.CloseCurlyBrace:v=C?a.None:a.ForceTermination;break;case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.BackTick:u===p?v=a.ForceTermination:u===s.CharCode.SingleQuote||u===s.CharCode.DoubleQuote||u===s.CharCode.BackTick?v=a.None:v=a.ForceTermination;break;case s.CharCode.Asterisk:v=u===s.CharCode.Asterisk?a.ForceTermination:a.None;break;case s.CharCode.Pipe:v=u===s.CharCode.Pipe?a.ForceTermination:a.None;break;case s.CharCode.Space:v=y?a.None:a.ForceTermination;break;default:v=d.get(p)}v===a.ForceTermination&&(g.push(l.a(d,t,n,f,r)),A=!0)}else if(w===I.End){let v;p===s.CharCode.OpenSquareBracket?(D=!0,v=a.None):v=d.get(p),v===a.ForceTermination?A=!0:w=I.Accept}else w=m.nextState(w,p),w===I.Invalid&&(A=!0);A&&(w=I.Start,S=!1,D=!1,C=!1,f=r+1,u=p),r++}w===I.Accept&&g.push(l.a(d,t,n,f,i))}return g}}e.$q4=l;function P(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:l.computeLinks(b)}}),define(Ee[55],Se([1,0,25]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$bw=e.$aw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$cw=b,e.$gw=o;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var I;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(I||(e.GlyphMarginLane=I={}));var T;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(T||(e.MinimapPosition=T={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var $;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var a;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(a||(e.DefaultEndOfLine=a={}));var k;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,i.indentSize|0),this.a=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.a===i.a&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,s.$io)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.$aw=E;class l{constructor(i,r){this._findMatchBrand=void 0,this.range=i,this.matches=r}}e.$bw=l;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function b(t){return t&&typeof t.read=="function"}var c;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class d{constructor(i,r,f,u,w,S){this.identifier=i,this.range=r,this.text=f,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=w,this._isTracked=S}}e.$dw=d;class g{constructor(i,r,f){this.regex=i,this.wordSeparators=r,this.simpleSearch=f}}e.$ew=g;class n{constructor(i,r,f){this.reverseEdits=i,this.changes=r,this.trimAutoWhitespaceLineNumbers=f}}e.$fw=n;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Ee[196],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=I,e.$6C=T,e.$7C=a,e.$8C=k,e.$9C=E,e.$0C=l,e.$$C=P,e.$_C=b;class s{constructor(m,d){this.piece=m,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return I(this.right);let m=this;for(;m.parent!==e.$4C&&m.parent.left!==m;)m=m.parent;return m.parent===e.$4C?e.$4C:m.parent}prev(){if(this.left!==e.$4C)return T(this.left);let m=this;for(;m.parent!==e.$4C&&m.parent.right!==m;)m=m.parent;return m.parent===e.$4C?e.$4C:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=s;var h;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$4C=new s(null,h.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=h.Black;function I(c){for(;c.left!==e.$4C;)c=c.left;return c}function T(c){for(;c.right!==e.$4C;)c=c.right;return c}function L(c){return c===e.$4C?0:c.size_left+c.piece.length+L(c.right)}function R(c){return c===e.$4C?0:c.lf_left+c.piece.lineFeedCnt+R(c.right)}function $(){e.$4C.parent=e.$4C}function a(c,m){const d=m.right;d.size_left+=m.size_left+(m.piece?m.piece.length:0),d.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=d.left,d.left!==e.$4C&&(d.left.parent=m),d.parent=m.parent,m.parent===e.$4C?c.root=d:m.parent.left===m?m.parent.left=d:m.parent.right=d,d.left=m,m.parent=d}function k(c,m){const d=m.left;m.left=d.right,d.right!==e.$4C&&(d.right.parent=m),d.parent=m.parent,m.size_left-=d.size_left+(d.piece?d.piece.length:0),m.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),m.parent===e.$4C?c.root=d:m===m.parent.right?m.parent.right=d:m.parent.left=d,d.right=m,m.parent=d}function E(c,m){let d,g;if(m.left===e.$4C?(g=m,d=g.right):m.right===e.$4C?(g=m,d=g.left):(g=I(m.right),d=g.right),g===c.root){c.root=d,d.color=h.Black,m.detach(),$(),c.root.parent=e.$4C;return}const n=g.color===h.Red;if(g===g.parent.left?g.parent.left=d:g.parent.right=d,g===m?(d.parent=g.parent,b(c,d)):(g.parent===m?d.parent=g:d.parent=g.parent,b(c,d),g.left=m.left,g.right=m.right,g.parent=m.parent,g.color=m.color,m===c.root?c.root=g:m===m.parent.left?m.parent.left=g:m.parent.right=g,g.left!==e.$4C&&(g.left.parent=g),g.right!==e.$4C&&(g.right.parent=g),g.size_left=m.size_left,g.lf_left=m.lf_left,b(c,g)),m.detach(),d.parent.left===d){const t=L(d),i=R(d);if(t!==d.parent.size_left||i!==d.parent.lf_left){const r=t-d.parent.size_left,f=i-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=i,P(c,d.parent,r,f)}}if(b(c,d.parent),n){$();return}let o;for(;d!==c.root&&d.color===h.Black;)d===d.parent.left?(o=d.parent.right,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,a(c,d.parent),o=d.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,k(c,o),o=d.parent.right),o.color=d.parent.color,d.parent.color=h.Black,o.right.color=h.Black,a(c,d.parent),d=c.root)):(o=d.parent.left,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,k(c,d.parent),o=d.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,a(c,o),o=d.parent.left),o.color=d.parent.color,d.parent.color=h.Black,o.left.color=h.Black,k(c,d.parent),d=c.root));d.color=h.Black,$()}function l(c,m){for(b(c,m);m!==c.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const d=m.parent.parent.right;d.color===h.Red?(m.parent.color=h.Black,d.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,a(c,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,k(c,m.parent.parent))}else{const d=m.parent.parent.left;d.color===h.Red?(m.parent.color=h.Black,d.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,k(c,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,a(c,m.parent.parent))}c.root.color=h.Black}function P(c,m,d,g){for(;m!==c.root&&m!==e.$4C;)m.parent.left===m&&(m.parent.size_left+=d,m.parent.lf_left+=g),m=m.parent}function b(c,m){let d=0,g=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,d=L(m.left)-m.size_left,g=R(m.left)-m.lf_left,m.size_left+=d,m.lf_left+=g;m!==c.root&&(d!==0||g!==0);)m.parent.left===m&&(m.parent.size_left+=d,m.parent.lf_left+=g),m=m.parent}}}),define(Ee[197],Se([1,0,19,84]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=void 0;class I{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,a){$=(0,h.$df)($);const k=this.a,E=this.b,l=a.length;return l===0?!1:(this.a=new Uint32Array(k.length+l),this.a.set(k.subarray(0,$),0),this.a.set(k.subarray($),$+l),this.a.set(a,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,a){return $=(0,h.$df)($),a=(0,h.$df)(a),this.a[$]===a?!1:(this.a[$]=a,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,a){$=(0,h.$df)($),a=(0,h.$df)(a);const k=this.a,E=this.b;if($>=k.length)return!1;const l=k.length-$;return a>=l&&(a=l),a===0?!1:(this.a=new Uint32Array(k.length-a),this.a.set(k.subarray(0,$),0),this.a.set(k.subarray($+a),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$df)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let a=this.c[0]+1;a===0&&(this.b[0]=this.a[0],a++),$>=this.a.length&&($=this.a.length-1);for(let k=a;k<=$;k++)this.b[k]=this.b[k-1]+this.a[k];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let a=0,k=this.a.length-1,E=0,l=0,P=0;for(;a<=k;)if(E=a+(k-a)/2|0,l=this.b[E],P=l-this.a[E],$<P)k=E-1;else if($>=l)a=E+1;else break;return new L(E,$-P)}}e.$jw=I;class T{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const a=this.e[$],k=a>0?this.d[a-1]:0;return new L(a,$-k)}removeValues($,a){this.a.splice($,a),this.f($)}insertValues($,a){this.a=(0,s.$Yb)(this.a,$,a),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,a=this.a.length;$<a;$++){const k=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+k;for(let l=0;l<k;l++)this.e[E+l]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,a){this.a[$]!==a&&(this.a[$]=a,this.f($))}}e.$kw=T;class L{constructor($,a){this.index=$,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=a}}e.$lw=L}),define(Ee[198],Se([1,0,13,54,197]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=void 0;class T{constructor(R,$,a,k){this.d=R,this.f=$,this.g=a,this.h=k,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(R){R.eol&&R.eol!==this.g&&(this.g=R.eol,this.j=null);const $=R.changes;for(const a of $)this.o(a.range),this.p(new h.$Lt(a.range.startLineNumber,a.range.startColumn),a.text);this.h=R.versionId,this.k=null}l(){if(!this.j){const R=this.g.length,$=this.f.length,a=new Uint32Array($);for(let k=0;k<$;k++)a[k]=this.f[k].length+R;this.j=new I.$jw(a)}}n(R,$){this.f[R]=$,this.j&&this.j.setValue(R,this.f[R].length+this.g.length)}o(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.startLineNumber-1].substring(R.endColumn-1));return}this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.endLineNumber-1].substring(R.endColumn-1)),this.f.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this.j&&this.j.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}p(R,$){if($.length===0)return;const a=(0,s.$uf)($);if(a.length===1){this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+a[0]+this.f[R.lineNumber-1].substring(R.column-1));return}a[a.length-1]+=this.f[R.lineNumber-1].substring(R.column-1),this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+a[0]);const k=new Uint32Array(a.length-1);for(let E=1;E<a.length;E++)this.f.splice(R.lineNumber+E-1,0,a[E]),k[E-1]=a[E].length+this.g.length;this.j&&this.j.insertValues(R.lineNumber,k)}}e.$mw=T}),define(Ee[107],Se([1,0,27,13,193,54,31,55]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=e.$dD=e.$aD=void 0,e.$bD=k,e.$cD=E,e.$eD=m,h=We(h);const $=999;class a{constructor(n,o,t,i){this.searchString=n,this.isRegex=o,this.matchCase=t,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=k(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$sf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!n;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.$ew(o,this.wordSeparators?(0,I.$hu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$aD=a;function k(g){if(!g||g.length===0)return!1;for(let n=0,o=g.length;n<o;n++){const t=g.charCodeAt(n);if(t===s.CharCode.LineFeed)return!0;if(t===s.CharCode.Backslash){if(n++,n>=o)break;const i=g.charCodeAt(n);if(i===s.CharCode.n||i===s.CharCode.r||i===s.CharCode.W)return!0}}return!1}function E(g,n,o){if(!o)return new R.$bw(g,null);const t=[];for(let i=0,r=n.length;i<r;i++)t[i]=n[i];return new R.$bw(g,t)}class l{constructor(n){const o=[];let t=0;for(let i=0,r=n.length;i<r;i++)n.charCodeAt(i)===s.CharCode.LineFeed&&(o[t++]=i);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let t=0,i=o.length-1;if(i===-1||n<=o[0])return 0;for(;t<i;){const r=t+((i-t)/2>>0);o[r]>=n?i=r-1:o[r+1]>=n?(t=r,i=r):t=r+1}return t+1}}class P{static findMatches(n,o,t,i,r){const f=o.parseSearchRequest();return f?f.regex.multiline?this.b(n,t,new d(f.wordSeparators,f.regex),i,r):this.c(n,t,f,i,r):[]}static a(n,o,t,i,r,f){let u,w=0;i?(w=i.findLineFeedCountBeforeOffset(r),u=o+r+w):u=o+r;let S;if(i){const A=i.findLineFeedCountBeforeOffset(r+f.length)-w;S=u+f.length+A}else S=u+f.length;const D=n.getPositionAt(u),y=n.getPositionAt(S);return new L.$Mt(D.lineNumber,D.column,y.lineNumber,y.column)}static b(n,o,t,i,r){const f=n.getOffsetAt(o.getStartPosition()),u=n.getValueInRange(o,R.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new l(u):null,S=[];let D=0,y;for(t.reset(0);y=t.next(u);)if(S[D++]=E(this.a(n,f,u,w,y.index,y[0]),y,i),D>=r)return S;return S}static c(n,o,t,i,r){const f=[];let u=0;if(o.startLineNumber===o.endLineNumber){const S=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return u=this.d(t,S,o.startLineNumber,o.startColumn-1,u,f,i,r),f}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);u=this.d(t,w,o.startLineNumber,o.startColumn-1,u,f,i,r);for(let S=o.startLineNumber+1;S<o.endLineNumber&&u<r;S++)u=this.d(t,n.getLineContent(S),S,0,u,f,i,r);if(u<r){const S=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);u=this.d(t,S,o.endLineNumber,0,u,f,i,r)}return f}static d(n,o,t,i,r,f,u,w){const S=n.wordSeparators;if(!u&&n.simpleSearch){const C=n.simpleSearch,A=C.length,p=o.length;let v=-A;for(;(v=o.indexOf(C,v+A))!==-1;)if((!S||m(S,o,p,v,A))&&(f[r++]=new R.$bw(new L.$Mt(t,v+1+i,t,v+1+A+i),null),r>=w))return r;return r}const D=new d(n.wordSeparators,n.regex);let y;D.reset(0);do if(y=D.next(o),y&&(f[r++]=E(new L.$Mt(t,y.index+1+i,t,y.index+1+y[0].length+i),y,u),r>=w))return r;while(y);return r}static findNextMatch(n,o,t,i){const r=o.parseSearchRequest();if(!r)return null;const f=new d(r.wordSeparators,r.regex);return r.regex.multiline?this.e(n,t,f,i):this.f(n,t,f,i)}static e(n,o,t,i){const r=new T.$Lt(o.lineNumber,1),f=n.getOffsetAt(r),u=n.getLineCount(),w=n.getValueInRange(new L.$Mt(r.lineNumber,r.column,u,n.getLineMaxColumn(u)),R.EndOfLinePreference.LF),S=n.getEOL()===`\r
`?new l(w):null;t.reset(o.column-1);const D=t.next(w);return D?E(this.a(n,f,w,S,D.index,D[0]),D,i):o.lineNumber!==1||o.column!==1?this.e(n,new T.$Lt(1,1),t,i):null}static f(n,o,t,i){const r=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f),w=this.g(t,u,f,o.column,i);if(w)return w;for(let S=1;S<=r;S++){const D=(f+S-1)%r,y=n.getLineContent(D+1),C=this.g(t,y,D+1,1,i);if(C)return C}return null}static g(n,o,t,i,r){n.reset(i-1);const f=n.next(o);return f?E(new L.$Mt(t,f.index+1,t,f.index+1+f[0].length),f,r):null}static findPreviousMatch(n,o,t,i){const r=o.parseSearchRequest();if(!r)return null;const f=new d(r.wordSeparators,r.regex);return r.regex.multiline?this.h(n,t,f,i):this.j(n,t,f,i)}static h(n,o,t,i){const r=this.b(n,new L.$Mt(1,1,o.lineNumber,o.column),t,i,10*$);if(r.length>0)return r[r.length-1];const f=n.getLineCount();return o.lineNumber!==f||o.column!==n.getLineMaxColumn(f)?this.h(n,new T.$Lt(f,n.getLineMaxColumn(f)),t,i):null}static j(n,o,t,i){const r=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f).substring(0,o.column-1),w=this.k(t,u,f,i);if(w)return w;for(let S=1;S<=r;S++){const D=(r+f-S-1)%r,y=n.getLineContent(D+1),C=this.k(t,y,D+1,i);if(C)return C}return null}static k(n,o,t,i){let r=null,f;for(n.reset(0);f=n.next(o);)r=E(new L.$Mt(t,f.index+1,t,f.index+1+f[0].length),f,i);return r}}e.$dD=P;function b(g,n,o,t,i){if(t===0)return!0;const r=n.charCodeAt(t-1);if(g.get(r)!==I.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t);if(g.get(f)!==I.WordCharacterClass.Regular)return!0}return!1}function c(g,n,o,t,i){if(t+i===o)return!0;const r=n.charCodeAt(t+i);if(g.get(r)!==I.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t+i-1);if(g.get(f)!==I.WordCharacterClass.Regular)return!0}return!1}function m(g,n,o,t,i){return b(g,n,o,t,i)&&c(g,n,o,t,i)}class d{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(n),!t))return null;const i=t.index,r=t[0].length;if(i===this.b&&r===this.c){if(r===0){h.$Of(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=r,!this._wordSeparators||m(this._wordSeparators,n,o,i,r))return t}while(t);return null}}e.$fD=d}),define(Ee[139],Se([1,0,27,54,31,55,196,107]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=E,e.$hD=l;const $=65535;function a(g){let n;return g[g.length-1]<65536?n=new Uint16Array(g.length):n=new Uint32Array(g.length),n.set(g,0),n}class k{constructor(n,o,t,i,r){this.lineStarts=n,this.cr=o,this.lf=t,this.crlf=i,this.isBasicASCII=r}}function E(g,n=!0){const o=[0];let t=1;for(let i=0,r=g.length;i<r;i++){const f=g.charCodeAt(i);f===s.CharCode.CarriageReturn?i+1<r&&g.charCodeAt(i+1)===s.CharCode.LineFeed?(o[t++]=i+2,i++):o[t++]=i+1:f===s.CharCode.LineFeed&&(o[t++]=i+1)}return n?a(o):o}function l(g,n){g.length=0,g[0]=0;let o=1,t=0,i=0,r=0,f=!0;for(let w=0,S=n.length;w<S;w++){const D=n.charCodeAt(w);D===s.CharCode.CarriageReturn?w+1<S&&n.charCodeAt(w+1)===s.CharCode.LineFeed?(r++,g[o++]=w+2,w++):(t++,g[o++]=w+1):D===s.CharCode.LineFeed?(i++,g[o++]=w+1):f&&D!==s.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const u=new k(a(g),t,i,r,f);return g.length=0,u}class P{constructor(n,o,t,i,r){this.bufferIndex=n,this.start=o,this.end=t,this.lineFeedCnt=i,this.length=r}}e.$iD=P;class b{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$jD=b;class c{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==L.$4C&&n.iterate(n.root,t=>(t!==L.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=n&&t.nodeStartOffset+t.node.piece.length>=n)return t}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<n&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=n)return t}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const t=this.b;for(let i=0;i<t.length;i++){const r=t[i];if(r.node.parent===null||r.nodeStartOffset>=n){t[i]=null,o=!0;continue}}if(o){const i=[];for(const r of t)r!==null&&i.push(r);this.b=i}}}class d{constructor(n,o,t){this.create(n,o,t)}create(n,o,t){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=L.$4C,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let i=null;for(let r=0,f=n.length;r<f;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=E(n[r].buffer));const u=new P(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this.a.push(n[r]),i=this.S(i,u)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,t=o-Math.floor(o/3),i=t*2;let r="",f=0;const u=[];if(this.iterate(this.root,w=>{const S=this.R(w),D=S.length;if(f<=t||f+D<i)return r+=S,f+=D,!0;const y=r.replace(/\r\n|\r|\n/g,n);return u.push(new b(y,E(y))),r=S,f=D,!0}),f>0){const w=r.replace(/\r\n|\r|\n/g,n);u.push(new b(w,E(w)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new c(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,i=>{if(i===L.$4C)return!0;const r=this.R(i),f=r.length,u=n.G(o),w=n.G(o+f),S=n.getValueInRange2(u,w);return o+=f,r===S})}getOffsetAt(n,o){let t=0,i=this.root;for(;i!==L.$4C;)if(i.left!==L.$4C&&i.lf_left+1>=n)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=n){t+=i.size_left;const r=this.B(i,n-i.lf_left-2);return t+=r+o-1}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;return t}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,t=0;const i=n;for(;o!==L.$4C;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const r=this.A(o,n-o.size_left);if(t+=o.lf_left+r.index,r.index===0){const f=this.getOffsetAt(t+1,1),u=i-f;return new h.$Lt(t+1,u+1)}return new h.$Lt(t+1,r.remainder+1)}else if(n-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$4C){const r=this.getOffsetAt(t+1,1),f=i-n-r;return new h.$Lt(t+1,f+1)}else o=o.right;return new h.$Lt(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const t=this.H(n.startLineNumber,n.startColumn),i=this.H(n.endLineNumber,n.endColumn),r=this.getValueInRange2(t,i);return o?o!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,o):r}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,w=this.a[u.piece.bufferIndex].buffer,S=this.u(u.piece.bufferIndex,u.piece.start);return w.substring(S+n.remainder,S+o.remainder)}let t=n.node;const i=this.a[t.piece.bufferIndex].buffer,r=this.u(t.piece.bufferIndex,t.piece.start);let f=i.substring(r+n.remainder,r+t.piece.length);for(t=t.next();t!==L.$4C;){const u=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){f+=u.substring(w,w+o.remainder);break}else f+=u.substr(w,t.piece.length);t=t.next()}return f}getLinesContent(){const n=[];let o=0,t="",i=!1;return this.iterate(this.root,r=>{if(r===L.$4C)return!0;const f=r.piece;let u=f.length;if(u===0)return!0;const w=this.a[f.bufferIndex].buffer,S=this.a[f.bufferIndex].lineStarts,D=f.start.line,y=f.end.line;let C=S[D]+f.start.column;if(i&&(w.charCodeAt(C)===s.CharCode.LineFeed&&(C++,u--),n[o++]=t,t="",i=!1,u===0))return!0;if(D===y)return!this.f&&w.charCodeAt(C+u-1)===s.CharCode.CarriageReturn?(i=!0,t+=w.substr(C,u-1)):t+=w.substr(C,u),!0;t+=this.f?w.substring(C,Math.max(C,S[D+1]-this.e)):w.substring(C,S[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;for(let A=D+1;A<y;A++)t=this.f?w.substring(S[A],S[A+1]-this.e):w.substring(S[A],S[A+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;return!this.f&&w.charCodeAt(S[y]+f.end.column-1)===s.CharCode.CarriageReturn?(i=!0,f.end.column===0?o--:t=w.substr(S[y],f.end.column-1)):t=w.substr(S[y],f.end.column),!0}),i&&(n[o++]=t,t=""),n[o++]=t,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],i=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(i)}else{const o=this.a[n.node.piece.bufferIndex],i=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(i)}}getLineCharCode(n,o){const t=this.H(n,o+1);return this.l(t)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===L.$4C)return"";const i=this.a[t.piece.bufferIndex],r=this.u(t.piece.bufferIndex,t.piece.start);return i.buffer.substring(r,r+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],i=this.u(o.node.piece.bufferIndex,o.node.piece.start),r=i+o.remainder,f=i+o.node.piece.length;return t.buffer.substring(r,f)}}findMatchesInNode(n,o,t,i,r,f,u,w,S,D,y){const C=this.a[n.piece.bufferIndex],A=this.u(n.piece.bufferIndex,n.piece.start),p=this.u(n.piece.bufferIndex,r),v=this.u(n.piece.bufferIndex,f);let F;const N={line:0,column:0};let O,j;o._wordSeparators?(O=C.buffer.substring(p,v),j=z=>z+p,o.reset(0)):(O=C.buffer,j=z=>z,o.reset(p));do if(F=o.next(O),F){if(j(F.index)>=v)return D;this.s(n,j(F.index)-A,N);const z=this.t(n.piece.bufferIndex,r,N),M=N.line===r.line?N.column-r.column+i:N.column+1,V=M+F[0].length;if(y[D++]=(0,R.$cD)(new I.$Mt(t+z,M,t+z,V),F,w),j(F.index)+F[0].length>=v||D>=S)return D}while(F);return D}findMatchesLineByLine(n,o,t,i){const r=[];let f=0;const u=new R.$fD(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const S=this.H(n.endLineNumber,n.endColumn);if(S===null)return[];let D=this.s(w.node,w.remainder);const y=this.s(S.node,S.remainder);if(w.node===S.node)return this.findMatchesInNode(w.node,u,n.startLineNumber,n.startColumn,D,y,o,t,i,f,r),r;let C=n.startLineNumber,A=w.node;for(;A!==S.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,O=this.u(A.piece.bufferIndex,A.piece.start),j=N[D.line+v],z=C===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(A,u,C,z,D,this.s(A,j-O),o,t,i,f,r),f>=i)return r;C+=v}const F=C===n.startLineNumber?n.startColumn-1:0;if(C===n.endLineNumber){const N=this.getLineContent(C).substring(F,n.endColumn-1);return f=this.n(o,u,N,n.endLineNumber,F,f,r,t,i),r}if(f=this.n(o,u,this.getLineContent(C).substr(F),C,F,f,r,t,i),f>=i)return r;C++,w=this.H(C,1),A=w.node,D=this.s(w.node,w.remainder)}if(C===n.endLineNumber){const v=C===n.startLineNumber?n.startColumn-1:0,F=this.getLineContent(C).substring(v,n.endColumn-1);return f=this.n(o,u,F,n.endLineNumber,v,f,r,t,i),r}const p=C===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(S.node,u,C,p,D,y,o,t,i,f,r),r}n(n,o,t,i,r,f,u,w,S){const D=n.wordSeparators;if(!w&&n.simpleSearch){const C=n.simpleSearch,A=C.length,p=t.length;let v=-A;for(;(v=t.indexOf(C,v+A))!==-1;)if((!D||(0,R.$eD)(D,t,p,v,A))&&(u[f++]=new T.$bw(new I.$Mt(i,v+1+r,i,v+1+A+r),null),f>=S))return f;return f}let y;o.reset(0);do if(y=o.next(t),y&&(u[f++]=(0,R.$cD)(new I.$Mt(i,y.index+1+r,i,y.index+1+y[0].length+r),y,w),f>=S))return f;while(y);return f}insert(n,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==L.$4C){const{node:i,remainder:r,nodeStartOffset:f}=this.G(n),u=i.piece,w=u.bufferIndex,S=this.s(i,r);if(i.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&f+u.length===n&&o.length<$){this.F(i,o),this.y();return}if(f===n)this.o(o,i),this.h.validate(n);else if(f+i.piece.length>n){const D=[];let y=new P(u.bufferIndex,S,u.end,this.t(u.bufferIndex,S,u.end),this.u(w,u.end)-this.u(w,S));if(this.K()&&this.M(o)&&this.I(i,r)===10){const v={line:y.start.line+1,column:0};y=new P(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(i,r-1)===13){const v=this.s(i,r-1);this.C(i,v),o="\r"+o,i.piece.length===0&&D.push(i)}else this.C(i,S);else this.C(i,S);const C=this.w(o);y.length>0&&this.S(i,y);let A=i;for(let p=0;p<C.length;p++)A=this.S(A,C[p]);this.v(D)}else this.q(o,i)}else{const i=this.w(o);let r=this.T(null,i[0]);for(let f=1;f<i.length;f++)r=this.S(r,i[f])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$4C)return;const t=this.G(n),i=this.G(n+o),r=t.node,f=i.node;if(r===f){const C=this.s(r,t.remainder),A=this.s(r,i.remainder);if(t.nodeStartOffset===n){if(o===r.piece.length){const p=r.next();(0,L.$9C)(this,r),this.N(p),this.y();return}this.D(r,A),this.h.validate(n),this.N(r),this.y();return}if(t.nodeStartOffset+r.piece.length===n+o){this.C(r,C),this.O(r),this.y();return}this.E(r,C,A),this.y();return}const u=[],w=this.s(r,t.remainder);this.C(r,w),this.h.validate(n),r.piece.length===0&&u.push(r);const S=this.s(f,i.remainder);this.D(f,S),f.piece.length===0&&u.push(f);const D=r.next();for(let C=D;C!==L.$4C&&C!==f;C=C.next())u.push(C);const y=r.piece.length===0?r.prev():r;this.v(u),this.O(y),this.y()}o(n,o){const t=[];if(this.K()&&this.M(n)&&this.L(o)){const f=o.piece,u={line:f.start.line+1,column:0},w=new P(f.bufferIndex,u,f.end,this.t(f.bufferIndex,u,f.end),f.length-1);o.piece=w,n+=`
`,(0,L.$$C)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const i=this.w(n);let r=this.T(o,i[i.length-1]);for(let f=i.length-2;f>=0;f--)r=this.T(r,i[f]);this.N(r),this.v(t)}q(n,o){this.Q(n,o)&&(n+=`
`);const t=this.w(n),i=this.S(o,t[0]);let r=i;for(let f=1;f<t.length;f++)r=this.S(r,t[f]);this.N(i)}s(n,o,t){const i=n.piece,r=n.piece.bufferIndex,f=this.a[r].lineStarts,w=f[i.start.line]+i.start.column+o;let S=i.start.line,D=i.end.line,y=0,C=0,A=0;for(;S<=D&&(y=S+(D-S)/2|0,A=f[y],y!==D);)if(C=f[y+1],w<A)D=y-1;else if(w>=C)S=y+1;else break;return t?(t.line=y,t.column=w-A,null):{line:y,column:w-A}}t(n,o,t){if(t.column===0)return t.line-o.line;const i=this.a[n].lineStarts;if(t.line===i.length-1)return t.line-o.line;const r=i[t.line+1],f=i[t.line]+t.column;if(r>f+1)return t.line-o.line;const u=f-1;return this.a[n].buffer.charCodeAt(u)===13?t.line-o.line+1:t.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,L.$9C)(this,n[o])}w(n){if(n.length>$){const D=[];for(;n.length>$;){const C=n.charCodeAt($-1);let A;C===s.CharCode.CarriageReturn||C>=55296&&C<=56319?(A=n.substring(0,$-1),n=n.substring($-1)):(A=n.substring(0,$),n=n.substring($));const p=E(A);D.push(new P(this.a.length,{line:0,column:0},{line:p.length-1,column:A.length-p[p.length-1]},p.length-1,A.length)),this.a.push(new b(A,p))}const y=E(n);return D.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:n.length-y[y.length-1]},y.length-1,n.length)),this.a.push(new b(n,y)),D}let o=this.a[0].buffer.length;const t=E(n,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let D=0;D<t.length;D++)t[D]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<t.length;D++)t[D]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=n}const r=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,u=r-this.a[0].lineStarts[f],w={line:f,column:u},S=new P(0,i,w,this.t(0,i,w),r-o);return this.g=w,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let t=this.root,i="";const r=this.h.get2(n);if(r){t=r.node;const f=this.B(t,n-r.nodeStartLineNumber-1),u=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(r.nodeStartLineNumber+t.piece.lineFeedCnt===n)i=u.substring(w+f,w+t.piece.length);else{const S=this.B(t,n-r.nodeStartLineNumber);return u.substring(w+f,w+S-o)}}else{let f=0;const u=n;for(;t!==L.$4C;)if(t.left!==L.$4C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const w=this.B(t,n-t.lf_left-2),S=this.B(t,n-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return f+=t.size_left,this.h.set({node:t,nodeStartOffset:f,nodeStartLineNumber:u-(n-1-t.lf_left)}),D.substring(y+w,y+S-o)}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const w=this.B(t,n-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);i=S.substring(D+w,D+t.piece.length);break}else n-=t.lf_left+t.piece.lineFeedCnt,f+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.$4C;){const f=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const u=this.B(t,0),w=this.u(t.piece.bufferIndex,t.piece.start);return i+=f.substring(w,w+u-o),i}else{const u=this.u(t.piece.bufferIndex,t.piece.start);i+=f.substr(u,t.piece.length)}t=t.next()}return i}y(){let n=this.root,o=1,t=0;for(;n!==L.$4C;)o+=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=t,this.h.validate(this.c)}A(n,o){const t=n.piece,i=this.s(n,o),r=i.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const f=this.t(n.piece.bufferIndex,t.start,i);if(f!==r)return{index:f,remainder:0}}return{index:r,remainder:i.column}}B(n,o){if(o<0)return 0;const t=n.piece,i=this.a[t.bufferIndex].lineStarts,r=t.start.line+o+1;return r>t.end.line?i[t.end.line]+t.end.column-i[t.start.line]-t.start.column:i[r]-i[t.start.line]-t.start.column}C(n,o){const t=n.piece,i=t.lineFeedCnt,r=this.u(t.bufferIndex,t.end),f=o,u=this.u(t.bufferIndex,f),w=this.t(t.bufferIndex,t.start,f),S=w-i,D=u-r,y=t.length+D;n.piece=new P(t.bufferIndex,t.start,f,w,y),(0,L.$$C)(this,n,D,S)}D(n,o){const t=n.piece,i=t.lineFeedCnt,r=this.u(t.bufferIndex,t.start),f=o,u=this.t(t.bufferIndex,f,t.end),w=this.u(t.bufferIndex,f),S=u-i,D=r-w,y=t.length+D;n.piece=new P(t.bufferIndex,f,t.end,u,y),(0,L.$$C)(this,n,D,S)}E(n,o,t){const i=n.piece,r=i.start,f=i.end,u=i.length,w=i.lineFeedCnt,S=o,D=this.t(i.bufferIndex,i.start,S),y=this.u(i.bufferIndex,o)-this.u(i.bufferIndex,r);n.piece=new P(i.bufferIndex,i.start,S,D,y),(0,L.$$C)(this,n,y-u,D-w);const C=new P(i.bufferIndex,t,f,this.t(i.bufferIndex,t,f),this.u(i.bufferIndex,f)-this.u(i.bufferIndex,t)),A=this.S(n,C);this.N(A)}F(n,o){this.Q(o,n)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(n),i=this.a[0].buffer.length;this.a[0].buffer+=o;const r=E(o,!1);for(let A=0;A<r.length;A++)r[A]+=i;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const f=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[f],w={line:f,column:u},S=n.piece.length+o.length,D=n.piece.lineFeedCnt,y=this.t(0,n.piece.start,w),C=y-D;n.piece=new P(n.piece.bufferIndex,n.piece.start,w,y,S),this.g=w,(0,L.$$C)(this,n,o.length,C)}G(n){let o=this.root;const t=this.h.get(n);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:n-t.nodeStartOffset};let i=0;for(;o!==L.$4C;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){i+=o.size_left;const r={node:o,remainder:n-o.size_left,nodeStartOffset:i};return this.h.set(r),r}else n-=o.size_left+o.piece.length,i+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let t=this.root,i=0;for(;t!==L.$4C;)if(t.left!==L.$4C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const r=this.B(t,n-t.lf_left-2),f=this.B(t,n-t.lf_left-1);return i+=t.size_left,{node:t,remainder:Math.min(r+o-1,f),nodeStartOffset:i}}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const r=this.B(t,n-t.lf_left-2);if(r+o-1<=t.piece.length)return{node:t,remainder:r+o-1,nodeStartOffset:i};o-=t.piece.length-r;break}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.$4C;){if(t.piece.lineFeedCnt>0){const r=this.B(t,0),f=this.J(t);return{node:t,remainder:Math.min(o-1,r),nodeStartOffset:f}}else if(t.piece.length>=o-1){const r=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:r}}else o-=t.piece.length;t=t.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const t=this.a[n.piece.bufferIndex],i=this.u(n.piece.bufferIndex,n.piece.start)+o;return t.buffer.charCodeAt(i)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$4C||n.piece.lineFeedCnt===0)return!1;const o=n.piece,t=this.a[o.bufferIndex].lineStarts,i=o.start.line,r=t[i]+o.start.column;return i===t.length-1||t[i+1]>r+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(r)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$4C||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const t=[],i=this.a[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:i[n.piece.end.line]-i[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new P(n.piece.bufferIndex,n.piece.start,r,u,f),(0,L.$$C)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w={line:o.piece.start.line+1,column:0},S=o.piece.length-1,D=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new P(o.piece.bufferIndex,w,o.piece.end,D,S),(0,L.$$C)(this,o,-1,-1),o.piece.length===0&&t.push(o);const y=this.w(`\r
`);this.S(n,y[0]);for(let C=0;C<t.length;C++)(0,L.$9C)(this,t[C])}Q(n,o){if(this.K()&&this.M(n)){const t=o.next();if(this.L(t)){if(n+=`
`,t.piece.length===1)(0,L.$9C)(this,t);else{const i=t.piece,r={line:i.start.line+1,column:0},f=i.length-1,u=this.t(i.bufferIndex,r,i.end);t.piece=new P(i.bufferIndex,r,i.end,u,f),(0,L.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.$4C)return o(L.$4C);const t=this.iterate(n.left,o);return t&&o(n)&&this.iterate(n.right,o)}R(n){if(n===L.$4C)return"";const o=this.a[n.piece.bufferIndex],t=n.piece,i=this.u(t.bufferIndex,t.start),r=this.u(t.bufferIndex,t.end);return o.buffer.substring(i,r)}getPieceContent(n){const o=this.a[n.bufferIndex],t=this.u(n.bufferIndex,n.start),i=this.u(n.bufferIndex,n.end);return o.buffer.substring(t,i)}S(n,o){const t=new L.$3C(o,L.NodeColor.Red);if(t.left=L.$4C,t.right=L.$4C,t.parent=L.$4C,t.size_left=0,t.lf_left=0,this.root===L.$4C)this.root=t,t.color=L.NodeColor.Black;else if(n.right===L.$4C)n.right=t,t.parent=n;else{const r=(0,L.$5C)(n.right);r.left=t,t.parent=r}return(0,L.$0C)(this,t),t}T(n,o){const t=new L.$3C(o,L.NodeColor.Red);if(t.left=L.$4C,t.right=L.$4C,t.parent=L.$4C,t.size_left=0,t.lf_left=0,this.root===L.$4C)this.root=t,t.color=L.NodeColor.Black;else if(n.left===L.$4C)n.left=t,t.parent=n;else{const i=(0,L.$6C)(n.left);i.right=t,t.parent=i}return(0,L.$0C)(this,t),t}U(n){let o="";return this.iterate(n,t=>(o+=this.R(t),!0)),o}}e.$kD=d}),define(Ee[199],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_=e.$w_=void 0;class s{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const L=this.a.get(T);return this.a.delete(T),L}}addDragOperationTransfer(T,L){this.a.set(T,L)}}e.$w_=s;class h{constructor(T){this.identifier=T}}e.$x_=h}),define(Ee[200],Se([1,0,4,3,106]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new s.$ne,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,a){return this.a.set($,a),this.handleChange([$]),(0,h.$Vc)(()=>{this.a.get($)===a&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,a){this.b.get($)?.dispose();const k=new L(this,$,a);return this.b.set($,k),(0,h.$Vc)(()=>{const E=this.b.get($);!E||E!==k||(this.b.delete($),E.dispose())})}async getOrCreate($){const a=this.get($);if(a)return a;const k=this.b.get($);return!k||k.isResolved?null:(await k.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const k=this.b.get($);return!!(!k||k.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>I.ColorId.DefaultBackground?this.d[I.ColorId.DefaultBackground]:null}}e.$vu=T;class L extends h.$Xc{get isResolved(){return this.c}constructor($,a,k){super(),this.f=$,this.g=a,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Ee[201],Se([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[202],Se([1,0,4,3,201]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=k,I=We(I);class T extends h.$Xc{constructor(l,P="",b="",c=!0,m){super(),this.j=this.B(new s.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=l,this.n=P,this.w=b,this.z=c,this.D=m}get id(){return this.m}get label(){return this.n}set label(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.j.fire({label:l}))}get tooltip(){return this.u||""}set tooltip(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.j.fire({tooltip:l}))}get class(){return this.w}set class(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.j.fire({class:l}))}get enabled(){return this.z}set enabled(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.j.fire({enabled:l}))}get checked(){return this.C}set checked(l){this.J(l)}J(l){this.C!==l&&(this.C=l,this.j.fire({checked:l}))}async run(l,P){this.D&&await this.D(l)}}e.$lj=T;class L extends h.$Xc{constructor(){super(...arguments),this.f=this.B(new s.$ne),this.onWillRun=this.f.event,this.m=this.B(new s.$ne),this.onDidRun=this.m.event}async run(l,P){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,P)}catch(c){b=c}this.m.fire({action:l,error:b})}async u(l,P){await l.run(P)}}e.$mj=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let P=[];for(const b of l)b.length&&(P.length?P=[...P,new R,...b]:P=b);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=R;class ${get actions(){return this.a}constructor(l,P,b,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=P,this.class=c,this.a=b}async run(){}}e.$oj=$;class a extends T{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,I.localize(0,null),void 0,!1)}}e.$pj=a;function k(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...l)=>E.run(...l)}}}),define(Ee[203],Se([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[204],Se([1,0,203]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=a,e.$3m=k,e.$4m=E;const h=60,I=h*60,T=I*24,L=T*7,R=T*30,$=T*365;function a(l,P,b,c){typeof l!="number"&&(l=l.getTime());const m=Math.round((new Date().getTime()-l)/1e3);if(m<-30)return(0,s.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,s.localize)(1,null);let d;return m<h?(d=m,P?d===1?b?(0,s.localize)(2,null,d):(0,s.localize)(3,null,d):b?(0,s.localize)(4,null,d):(0,s.localize)(5,null,d):d===1?b?(0,s.localize)(6,null,d):(0,s.localize)(7,null,d):b?(0,s.localize)(8,null,d):(0,s.localize)(9,null,d)):m<I?(d=Math.floor(m/h),P?d===1?b?(0,s.localize)(10,null,d):(0,s.localize)(11,null,d):b?(0,s.localize)(12,null,d):(0,s.localize)(13,null,d):d===1?b?(0,s.localize)(14,null,d):(0,s.localize)(15,null,d):b?(0,s.localize)(16,null,d):(0,s.localize)(17,null,d)):m<T?(d=Math.floor(m/I),P?d===1?b?(0,s.localize)(18,null,d):(0,s.localize)(19,null,d):b?(0,s.localize)(20,null,d):(0,s.localize)(21,null,d):d===1?b?(0,s.localize)(22,null,d):(0,s.localize)(23,null,d):b?(0,s.localize)(24,null,d):(0,s.localize)(25,null,d)):m<L?(d=Math.floor(m/T),P?d===1?(0,s.localize)(26,null,d):(0,s.localize)(27,null,d):d===1?(0,s.localize)(28,null,d):(0,s.localize)(29,null,d)):m<R?(d=Math.floor(m/L),P?d===1?b?(0,s.localize)(30,null,d):(0,s.localize)(31,null,d):b?(0,s.localize)(32,null,d):(0,s.localize)(33,null,d):d===1?b?(0,s.localize)(34,null,d):(0,s.localize)(35,null,d):b?(0,s.localize)(36,null,d):(0,s.localize)(37,null,d)):m<$?(d=Math.floor(m/R),P?d===1?b?(0,s.localize)(38,null,d):(0,s.localize)(39,null,d):b?(0,s.localize)(40,null,d):(0,s.localize)(41,null,d):d===1?b?(0,s.localize)(42,null,d):(0,s.localize)(43,null,d):b?(0,s.localize)(44,null,d):(0,s.localize)(45,null,d)):(d=Math.floor(m/$),P?d===1?b?(0,s.localize)(46,null,d):(0,s.localize)(47,null,d):b?(0,s.localize)(48,null,d):(0,s.localize)(49,null,d):d===1?b?(0,s.localize)(50,null,d):(0,s.localize)(51,null,d):b?(0,s.localize)(52,null,d):(0,s.localize)(53,null,d))}function k(l,P){const b=Math.abs(l/1e3);return b<1?P?(0,s.localize)(54,null,l):(0,s.localize)(55,null,l):b<h?P?(0,s.localize)(56,null,Math.round(l)/1e3):(0,s.localize)(57,null,Math.round(l)/1e3):b<I?P?(0,s.localize)(58,null,Math.round(l/(1e3*h))):(0,s.localize)(59,null,Math.round(l/(1e3*h))):b<T?P?(0,s.localize)(60,null,Math.round(l/(1e3*I))):(0,s.localize)(61,null,Math.round(l/(1e3*I))):(0,s.localize)(62,null,Math.round(l/(1e3*T)))}function E(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[205],Se([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[51],Se([1,0,19,18,205]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=$,e.$sj=a,e.$tj=k,s=We(s),h=We(h),I=We(I);function T(E,l){return l&&(E.stack||E.stacktrace)?I.localize(0,null,R(E),L(E.stack)||L(E.stacktrace)):R(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?I.localize(1,null,E.message):E.message||I.localize(2,null)}function $(E=null,l=!1){if(!E)return I.localize(3,null);if(Array.isArray(E)){const P=s.$Kb(E),b=$(P[0],l);return P.length>1?I.localize(4,null,b,P.length):b}if(h.$gg(E))return E;if(E.detail){const P=E.detail;if(P.error)return T(P.error,l);if(P.exception)return T(P.exception,l)}return E.stack?T(E,l):E.message?E.message:I.localize(5,null)}function a(E){const l=E;return l instanceof Error&&Array.isArray(l.actions)}function k(E,l){let P;return typeof E=="string"?P=new Error(E):P=E,P.actions=l,P}}),define(Ee[206],Se([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,206]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=y,e.$J=C,s=We(s),e.$g="en";let h=!1,I=!1,T=!1,L=!1,R=!1,$=!1,a=!1,k=!1,E=!1,l=!1,P,b=e.$g,c=e.$g,m,d;const g=globalThis;let n;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?n=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",t=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",I=n.platform==="darwin",T=n.platform==="linux",L=T&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,a=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.$g,b=e.$g;const A=n.env.VSCODE_NLS_CONFIG;if(A)try{const p=JSON.parse(A),v=p.availableLanguages["*"];P=p.locale,c=p.osLocale,b=v||e.$g,m=p._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!t?(d=navigator.userAgent,h=d.indexOf("Windows")>=0,I=d.indexOf("Macintosh")>=0,k=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,l=d?.indexOf("Mobi")>=0,$=!0,P=s.getConfiguredDefaultLocale(s.localize(0,null))||e.$g,b=P,c=navigator.language):console.error("Unable to resolve platform.");var i;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(i||(e.Platform=i={}));function r(A){switch(A){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let f=i.Web;I?f=i.Mac:h?f=i.Windows:T&&(f=i.Linux),e.$i=h,e.$j=I,e.$k=T,e.$l=L,e.$m=R,e.$n=a,e.$o=$,e.$p=$&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=k,e.$s=l,e.$t=E,e.$u=f,e.$v=d,e.$w=b;var u;(function(A){function p(){return e.$w}A.value=p;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=v;function F(){return e.$w==="en"}A.isDefault=F})(u||(e.Language=u={})),e.$x=P,e.$y=c,e.$z=m,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const A=[];g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let F=0,N=A.length;F<N;F++){const O=A[F];if(O.id===v.data.vscodeScheduleAsyncWork){A.splice(F,1),O.callback();return}}});let p=0;return v=>{const F=++p;A.push({id:F,callback:v}),g.postMessage({vscodeScheduleAsyncWork:F},"*")}}return A=>setTimeout(A)})();var w;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=I||k?w.Macintosh:h?w.Windows:w.Linux;let S=!0,D=!1;function y(){if(!D){D=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,S=new Uint16Array(A.buffer)[0]===513}return S}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(A){return parseFloat(A)>=20}}),define(Ee[56],Se([1,0,11]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let h;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const T=I.process;h={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return s.$i?"win32":s.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$gc=h.platform,e.$hc=h.arch}),define(Ee[17],Se([1,0,56]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,s=We(s);const h=65,I=97,T=90,L=122,R=46,$=47,a=92,k=58,E=63;class l extends Error{constructor(r,f,u){let w;typeof f=="string"&&f.indexOf("not ")===0?(w="must not be",f=f.replace(/^not /,"")):w="must be";const S=r.indexOf(".")!==-1?"property":"argument";let D=`The "${r}" ${S} ${w} of type ${f}`;D+=`. Received type ${typeof u}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function P(i,r){if(i===null||typeof i!="object")throw new l(r,"Object",i)}function b(i,r){if(typeof i!="string")throw new l(r,"string",i)}const c=s.$gc==="win32";function m(i){return i===$||i===a}function d(i){return i===$}function g(i){return i>=h&&i<=T||i>=I&&i<=L}function n(i,r,f,u){let w="",S=0,D=-1,y=0,C=0;for(let A=0;A<=i.length;++A){if(A<i.length)C=i.charCodeAt(A);else{if(u(C))break;C=$}if(u(C)){if(!(D===A-1||y===1))if(y===2){if(w.length<2||S!==2||w.charCodeAt(w.length-1)!==R||w.charCodeAt(w.length-2)!==R){if(w.length>2){const p=w.lastIndexOf(f);p===-1?(w="",S=0):(w=w.slice(0,p),S=w.length-1-w.lastIndexOf(f)),D=A,y=0;continue}else if(w.length!==0){w="",S=0,D=A,y=0;continue}}r&&(w+=w.length>0?`${f}..`:"..",S=2)}else w.length>0?w+=`${f}${i.slice(D+1,A)}`:w=i.slice(D+1,A),S=A-D-1;D=A,y=0}else C===R&&y!==-1?++y:y=-1}return w}function o(i,r){P(r,"pathObject");const f=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return f?f===r.root?`${f}${u}`:`${f}${i}${u}`:u}e.$ic={resolve(...i){let r="",f="",u=!1;for(let w=i.length-1;w>=-1;w--){let S;if(w>=0){if(S=i[w],b(S,"path"),S.length===0)continue}else r.length===0?S=s.cwd():(S=s.env[`=${r}`]||s.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==r.toLowerCase()&&S.charCodeAt(2)===a)&&(S=`${r}\\`));const D=S.length;let y=0,C="",A=!1;const p=S.charCodeAt(0);if(D===1)m(p)&&(y=1,A=!0);else if(m(p))if(A=!0,m(S.charCodeAt(1))){let v=2,F=v;for(;v<D&&!m(S.charCodeAt(v));)v++;if(v<D&&v!==F){const N=S.slice(F,v);for(F=v;v<D&&m(S.charCodeAt(v));)v++;if(v<D&&v!==F){for(F=v;v<D&&!m(S.charCodeAt(v));)v++;(v===D||v!==F)&&(C=`\\\\${N}\\${S.slice(F,v)}`,y=v)}}}else y=1;else g(p)&&S.charCodeAt(1)===k&&(C=S.slice(0,2),y=2,D>2&&m(S.charCodeAt(2))&&(A=!0,y=3));if(C.length>0)if(r.length>0){if(C.toLowerCase()!==r.toLowerCase())continue}else r=C;if(u){if(r.length>0)break}else if(f=`${S.slice(y)}\\${f}`,u=A,A&&r.length>0)break}return f=n(f,!u,"\\",m),u?`${r}\\${f}`:`${r}${f}`||"."},normalize(i){b(i,"path");const r=i.length;if(r===0)return".";let f=0,u,w=!1;const S=i.charCodeAt(0);if(r===1)return d(S)?"\\":i;if(m(S))if(w=!0,m(i.charCodeAt(1))){let y=2,C=y;for(;y<r&&!m(i.charCodeAt(y));)y++;if(y<r&&y!==C){const A=i.slice(C,y);for(C=y;y<r&&m(i.charCodeAt(y));)y++;if(y<r&&y!==C){for(C=y;y<r&&!m(i.charCodeAt(y));)y++;if(y===r)return`\\\\${A}\\${i.slice(C)}\\`;y!==C&&(u=`\\\\${A}\\${i.slice(C,y)}`,f=y)}}}else f=1;else g(S)&&i.charCodeAt(1)===k&&(u=i.slice(0,2),f=2,r>2&&m(i.charCodeAt(2))&&(w=!0,f=3));let D=f<r?n(i.slice(f),!w,"\\",m):"";return D.length===0&&!w&&(D="."),D.length>0&&m(i.charCodeAt(r-1))&&(D+="\\"),u===void 0?w?`\\${D}`:D:w?`${u}\\${D}`:`${u}${D}`},isAbsolute(i){b(i,"path");const r=i.length;if(r===0)return!1;const f=i.charCodeAt(0);return m(f)||r>2&&g(f)&&i.charCodeAt(1)===k&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,f;for(let S=0;S<i.length;++S){const D=i[S];b(D,"path"),D.length>0&&(r===void 0?r=f=D:r+=`\\${D}`)}if(r===void 0)return".";let u=!0,w=0;if(typeof f=="string"&&m(f.charCodeAt(0))){++w;const S=f.length;S>1&&m(f.charCodeAt(1))&&(++w,S>2&&(m(f.charCodeAt(2))?++w:u=!1))}if(u){for(;w<r.length&&m(r.charCodeAt(w));)w++;w>=2&&(r=`\\${r.slice(w)}`)}return e.$ic.normalize(r)},relative(i,r){if(b(i,"from"),b(r,"to"),i===r)return"";const f=e.$ic.resolve(i),u=e.$ic.resolve(r);if(f===u||(i=f.toLowerCase(),r=u.toLowerCase(),i===r))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===a;)w++;let S=i.length;for(;S-1>w&&i.charCodeAt(S-1)===a;)S--;const D=S-w;let y=0;for(;y<r.length&&r.charCodeAt(y)===a;)y++;let C=r.length;for(;C-1>y&&r.charCodeAt(C-1)===a;)C--;const A=C-y,p=D<A?D:A;let v=-1,F=0;for(;F<p;F++){const O=i.charCodeAt(w+F);if(O!==r.charCodeAt(y+F))break;O===a&&(v=F)}if(F!==p){if(v===-1)return u}else{if(A>p){if(r.charCodeAt(y+F)===a)return u.slice(y+F+1);if(F===2)return u.slice(y+F)}D>p&&(i.charCodeAt(w+F)===a?v=F:F===2&&(v=3)),v===-1&&(v=0)}let N="";for(F=w+v+1;F<=S;++F)(F===S||i.charCodeAt(F)===a)&&(N+=N.length===0?"..":"\\..");return y+=v,N.length>0?`${N}${u.slice(y,C)}`:(u.charCodeAt(y)===a&&++y,u.slice(y,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.$ic.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===a){if(r.charCodeAt(1)===a){const f=r.charCodeAt(2);if(f!==E&&f!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===k&&r.charCodeAt(2)===a)return`\\\\?\\${r}`;return i},dirname(i){b(i,"path");const r=i.length;if(r===0)return".";let f=-1,u=0;const w=i.charCodeAt(0);if(r===1)return m(w)?i:".";if(m(w)){if(f=u=1,m(i.charCodeAt(1))){let y=2,C=y;for(;y<r&&!m(i.charCodeAt(y));)y++;if(y<r&&y!==C){for(C=y;y<r&&m(i.charCodeAt(y));)y++;if(y<r&&y!==C){for(C=y;y<r&&!m(i.charCodeAt(y));)y++;if(y===r)return i;y!==C&&(f=u=y+1)}}}}else g(w)&&i.charCodeAt(1)===k&&(f=r>2&&m(i.charCodeAt(2))?3:2,u=f);let S=-1,D=!0;for(let y=r-1;y>=u;--y)if(m(i.charCodeAt(y))){if(!D){S=y;break}}else D=!1;if(S===-1){if(f===-1)return".";S=f}return i.slice(0,S)},basename(i,r){r!==void 0&&b(r,"ext"),b(i,"path");let f=0,u=-1,w=!0,S;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===k&&(f=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let D=r.length-1,y=-1;for(S=i.length-1;S>=f;--S){const C=i.charCodeAt(S);if(m(C)){if(!w){f=S+1;break}}else y===-1&&(w=!1,y=S+1),D>=0&&(C===r.charCodeAt(D)?--D===-1&&(u=S):(D=-1,u=y))}return f===u?u=y:u===-1&&(u=i.length),i.slice(f,u)}for(S=i.length-1;S>=f;--S)if(m(i.charCodeAt(S))){if(!w){f=S+1;break}}else u===-1&&(w=!1,u=S+1);return u===-1?"":i.slice(f,u)},extname(i){b(i,"path");let r=0,f=-1,u=0,w=-1,S=!0,D=0;i.length>=2&&i.charCodeAt(1)===k&&g(i.charCodeAt(0))&&(r=u=2);for(let y=i.length-1;y>=r;--y){const C=i.charCodeAt(y);if(m(C)){if(!S){u=y+1;break}continue}w===-1&&(S=!1,w=y+1),C===R?f===-1?f=y:D!==1&&(D=1):f!==-1&&(D=-1)}return f===-1||w===-1||D===0||D===1&&f===w-1&&f===u+1?"":i.slice(f,w)},format:o.bind(null,"\\"),parse(i){b(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const f=i.length;let u=0,w=i.charCodeAt(0);if(f===1)return m(w)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(m(w)){if(u=1,m(i.charCodeAt(1))){let v=2,F=v;for(;v<f&&!m(i.charCodeAt(v));)v++;if(v<f&&v!==F){for(F=v;v<f&&m(i.charCodeAt(v));)v++;if(v<f&&v!==F){for(F=v;v<f&&!m(i.charCodeAt(v));)v++;v===f?u=v:v!==F&&(u=v+1)}}}}else if(g(w)&&i.charCodeAt(1)===k){if(f<=2)return r.root=r.dir=i,r;if(u=2,m(i.charCodeAt(2))){if(f===3)return r.root=r.dir=i,r;u=3}}u>0&&(r.root=i.slice(0,u));let S=-1,D=u,y=-1,C=!0,A=i.length-1,p=0;for(;A>=u;--A){if(w=i.charCodeAt(A),m(w)){if(!C){D=A+1;break}continue}y===-1&&(C=!1,y=A+1),w===R?S===-1?S=A:p!==1&&(p=1):S!==-1&&(p=-1)}return y!==-1&&(S===-1||p===0||p===1&&S===y-1&&S===D+1?r.base=r.name=i.slice(D,y):(r.name=i.slice(D,S),r.base=i.slice(D,y),r.ext=i.slice(S,y))),D>0&&D!==u?r.dir=i.slice(0,D-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(c){const i=/\\/g;return()=>{const r=s.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>s.cwd()})();e.$jc={resolve(...i){let r="",f=!1;for(let u=i.length-1;u>=-1&&!f;u--){const w=u>=0?i[u]:t();b(w,"path"),w.length!==0&&(r=`${w}/${r}`,f=w.charCodeAt(0)===$)}return r=n(r,!f,"/",d),f?`/${r}`:r.length>0?r:"."},normalize(i){if(b(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===$,f=i.charCodeAt(i.length-1)===$;return i=n(i,!r,"/",d),i.length===0?r?"/":f?"./":".":(f&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return b(i,"path"),i.length>0&&i.charCodeAt(0)===$},join(...i){if(i.length===0)return".";let r;for(let f=0;f<i.length;++f){const u=i[f];b(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$jc.normalize(r)},relative(i,r){if(b(i,"from"),b(r,"to"),i===r||(i=e.$jc.resolve(i),r=e.$jc.resolve(r),i===r))return"";const f=1,u=i.length,w=u-f,S=1,D=r.length-S,y=w<D?w:D;let C=-1,A=0;for(;A<y;A++){const v=i.charCodeAt(f+A);if(v!==r.charCodeAt(S+A))break;v===$&&(C=A)}if(A===y)if(D>y){if(r.charCodeAt(S+A)===$)return r.slice(S+A+1);if(A===0)return r.slice(S+A)}else w>y&&(i.charCodeAt(f+A)===$?C=A:A===0&&(C=0));let p="";for(A=f+C+1;A<=u;++A)(A===u||i.charCodeAt(A)===$)&&(p+=p.length===0?"..":"/..");return`${p}${r.slice(S+C)}`},toNamespacedPath(i){return i},dirname(i){if(b(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===$;let f=-1,u=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===$){if(!u){f=w;break}}else u=!1;return f===-1?r?"/":".":r&&f===1?"//":i.slice(0,f)},basename(i,r){r!==void 0&&b(r,"ext"),b(i,"path");let f=0,u=-1,w=!0,S;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let D=r.length-1,y=-1;for(S=i.length-1;S>=0;--S){const C=i.charCodeAt(S);if(C===$){if(!w){f=S+1;break}}else y===-1&&(w=!1,y=S+1),D>=0&&(C===r.charCodeAt(D)?--D===-1&&(u=S):(D=-1,u=y))}return f===u?u=y:u===-1&&(u=i.length),i.slice(f,u)}for(S=i.length-1;S>=0;--S)if(i.charCodeAt(S)===$){if(!w){f=S+1;break}}else u===-1&&(w=!1,u=S+1);return u===-1?"":i.slice(f,u)},extname(i){b(i,"path");let r=-1,f=0,u=-1,w=!0,S=0;for(let D=i.length-1;D>=0;--D){const y=i.charCodeAt(D);if(y===$){if(!w){f=D+1;break}continue}u===-1&&(w=!1,u=D+1),y===R?r===-1?r=D:S!==1&&(S=1):r!==-1&&(S=-1)}return r===-1||u===-1||S===0||S===1&&r===u-1&&r===f+1?"":i.slice(r,u)},format:o.bind(null,"/"),parse(i){b(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const f=i.charCodeAt(0)===$;let u;f?(r.root="/",u=1):u=0;let w=-1,S=0,D=-1,y=!0,C=i.length-1,A=0;for(;C>=u;--C){const p=i.charCodeAt(C);if(p===$){if(!y){S=C+1;break}continue}D===-1&&(y=!1,D=C+1),p===R?w===-1?w=C:A!==1&&(A=1):w!==-1&&(A=-1)}if(D!==-1){const p=S===0&&f?1:S;w===-1||A===0||A===1&&w===D-1&&w===S+1?r.base=r.name=i.slice(p,D):(r.name=i.slice(p,w),r.base=i.slice(p,D),r.ext=i.slice(w,D))}return S>0?r.dir=i.slice(0,S-1):f&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=c?e.$ic.normalize:e.$jc.normalize,e.$lc=c?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=c?e.$ic.join:e.$jc.join,e.$nc=c?e.$ic.resolve:e.$jc.resolve,e.$oc=c?e.$ic.relative:e.$jc.relative,e.$pc=c?e.$ic.dirname:e.$jc.dirname,e.$qc=c?e.$ic.basename:e.$jc.basename,e.$rc=c?e.$ic.extname:e.$jc.extname,e.$sc=c?e.$ic.format:e.$jc.format,e.$tc=c?e.$ic.parse:e.$jc.parse,e.$uc=c?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=c?e.$ic.sep:e.$jc.sep,e.$wc=c?e.$ic.delimiter:e.$jc.delimiter}),define(Ee[140],Se([1,0,49,17]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=R,e.$zr=$,e.$Ar=a,e.$Br=k,e.$Cr=E,e.$Dr=l,e.$Er=P,e.$Fr=b,e.$Gr=c,e.$Hr=m,e.$Ir=w,e.$Jr=S,e.$Kr=D;const I=new s.$X(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new s.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new s.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(y,C,A=!1){const p=y||"",v=C||"",F=I.value.collator.compare(p,v);return I.value.collatorIsNumeric&&F===0&&p!==v?p<v?-1:1:F}function $(y,C){const A=T.value.collator;return y=y||"",C=C||"",o(A,y,C)}function a(y,C){const A=T.value.collator;return y=y||"",C=C||"",f(y,C)||o(A,y,C)}function k(y,C){const A=T.value.collator;return y=y||"",C=C||"",r(y,C)||o(A,y,C)}function E(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function l(y,C){const[A,p]=g(y),[v,F]=g(C);let N=I.value.collator.compare(p,F);if(N===0){if(I.value.collatorIsNumeric&&p!==F)return p<F?-1:1;if(N=I.value.collator.compare(A,v),I.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(y,C){y=y||"",C=C||"";const A=n(y),p=n(C),v=T.value.collator,F=L.value.collator;return o(F,A,p)||o(v,y,C)}function b(y,C){y=y||"",C=C||"";const A=n(y),p=n(C),v=T.value.collator,F=L.value.collator;return o(F,A,p)||f(y,C)||o(v,y,C)}function c(y,C){y=y||"",C=C||"";const A=n(y),p=n(C),v=T.value.collator,F=L.value.collator;return o(F,A,p)||r(y,C)||o(v,y,C)}function m(y,C){y=y||"",C=C||"";const A=n(y).toLowerCase(),p=n(C).toLowerCase();return A!==p?A<p?-1:1:y!==C?y<C?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function g(y,C=!1){const A=y?d.exec(y):[];let p=[A&&A[1]||"",A&&A[3]||""];return C&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function n(y){const C=y?d.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function o(y,C,A){const p=y.compare(C,A);return p!==0?p:C.length!==A.length?C.length<A.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function i(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function r(y,C){return t(y)&&i(C)?-1:i(y)&&t(C)?1:0}function f(y,C){return i(y)&&t(C)?-1:t(y)&&i(C)?1:0}function u(y,C,A=!1){return A||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function w(y,C,A=!1){const p=y.split(h.sep),v=C.split(h.sep),F=p.length-1,N=v.length-1;let O,j;for(let z=0;;z++){if(O=F===z,j=N===z,O&&j)return R(p[z],v[z],A);if(O)return-1;if(j)return 1;const M=u(p[z],v[z],A);if(M!==0)return M}}function S(y,C,A){const p=y.toLowerCase(),v=C.toLowerCase(),F=D(y,C,A);if(F)return F;const N=p.endsWith(A),O=v.endsWith(A);if(N!==O)return N?-1:1;const j=R(p,v);return j!==0?j:p.localeCompare(v)}function D(y,C,A){const p=y.toLowerCase(),v=C.toLowerCase(),F=p.startsWith(A),N=v.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(Ee[33],Se([1,0,27,17,11,13,18]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=R,e.$zg=$,e.$Ag=a,e.$Bg=k,e.$Cg=E,e.$Dg=c,e.$Eg=m,e.$Fg=d,e.$Gg=g,e.$Hg=n,e.$Ig=o,e.$Jg=t,e.$Kg=i,e.$Lg=r,e.$Mg=f,e.$Ng=u,e.$Og=D;function R(y){return y===s.CharCode.Slash||y===s.CharCode.Backslash}function $(y){return y.replace(/[\\/]/g,h.$jc.sep)}function a(y){return y.indexOf("/")===-1&&(y=$(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function k(y,C=h.$jc.sep){if(!y)return"";const A=y.length,p=y.charCodeAt(0);if(R(p)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!R(y.charCodeAt(F));F++);if(N!==F&&!R(y.charCodeAt(F+1))){for(F+=1;F<A;F++)if(R(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,C)}}return C}else if(g(p)&&y.charCodeAt(1)===s.CharCode.Colon)return R(y.charCodeAt(2))?y.slice(0,2)+C:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(R(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function E(y){if(!I.$i||!y||y.length<5)return!1;let C=y.charCodeAt(0);if(C!==s.CharCode.Backslash||(C=y.charCodeAt(1),C!==s.CharCode.Backslash))return!1;let A=2;const p=A;for(;A<y.length&&(C=y.charCodeAt(A),C!==s.CharCode.Backslash);A++);return!(p===A||(C=y.charCodeAt(A+1),isNaN(C)||C===s.CharCode.Backslash))}const l=/[\\/:\*\?"<>\|]/g,P=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(y,C=I.$i){const A=C?l:P;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||C&&b.test(y)||y==="."||y===".."||C&&y[y.length-1]==="."||C&&y.length!==y.trim().length||y.length>255)}function m(y,C,A){const p=y===C;return!A||p?p:!y||!C?!1:(0,T.$Hf)(y,C)}function d(y,C,A,p=h.sep){if(y===C)return!0;if(!y||!C||C.length>y.length)return!1;if(A){if(!(0,T.$If)(y,C))return!1;if(C.length===y.length)return!0;let F=C.length;return C.charAt(C.length-1)===p&&F--,y.charAt(F)===p}return C.charAt(C.length-1)!==p&&(C+=p),y.indexOf(C)===0}function g(y){return y>=s.CharCode.A&&y<=s.CharCode.Z||y>=s.CharCode.a&&y<=s.CharCode.z}function n(y,C){return I.$i&&y.endsWith(":")&&(y+=h.sep),(0,h.$lc)(y)||(y=(0,h.$mc)(C,y)),y=(0,h.$kc)(y),o(y)}function o(y){return I.$i?(y=(0,T.$pf)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,T.$pf)(y,h.sep),y||(y=h.sep)),y}function t(y){const C=(0,h.$kc)(y);return I.$i?y.length>3?!1:i(C)&&(y.length===2||C.charCodeAt(2)===s.CharCode.Backslash):C===h.$jc.sep}function i(y,C=I.$i){return C?g(y.charCodeAt(0))&&y.charCodeAt(1)===s.CharCode.Colon:!1}function r(y,C=I.$i){return i(y,C)?y[0]:void 0}function f(y,C,A){return C.length>y.length?-1:y===C?0:(A&&(y=y.toLowerCase(),C=C.toLowerCase()),y.indexOf(C))}function u(y){const C=y.split(":");let A,p,v;for(const F of C){const N=Number(F);(0,L.$kg)(N)?p===void 0?p=N:v===void 0&&(v=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,C,A=8){let p="";for(let F=0;F<A;F++){let N;F===0&&I.$i&&!C&&(A===3||A===4)?N=S:N=w,p+=N.charAt(Math.floor(Math.random()*N.length))}let v;return C?v=`${C}-${p}`:v=p,y?(0,h.$mc)(y,v):v}}),define(Ee[141],Se([1,0,27,140,135,60,17,11,13]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=E,e.$Mr=d,e.$Nr=u,e.$Or=p,e.$Pr=z,e.$Qr=V;const a=0,k=[a,[]];function E(K,re,B,G){if(!K||!re)return k;const X=K.length,ee=re.length;if(X<ee)return k;const de=K.toLowerCase();return l(re,B,ee,K,de,X,G)}function l(K,re,B,G,X,ee,de){const ne=[],De=[];for(let se=0;se<B;se++){const ae=se*ee,te=ae-ee,le=se>0,ue=K[se],Z=re[se];for(let oe=0;oe<ee;oe++){const pe=oe>0,we=ae+oe,Fe=we-1,Ue=te+oe-1,ke=pe?ne[Fe]:0,Pe=le&&pe?ne[Ue]:0,Te=le&&pe?De[Ue]:0;let W;!Pe&&le?W=0:W=P(ue,Z,G,X,oe,Te),W&&Pe+W>=ke&&(de||le||X.startsWith(re,oe))?(De[we]=Te+1,ne[we]=Pe+W):(De[we]=a,ne[we]=ke)}}const $e=[];let J=B-1,U=ee-1;for(;J>=0&&U>=0;){const se=J*ee+U;De[se]===a||($e.push(U),J--),U--}return[ne[B*ee-1],$e.reverse()]}function P(K,re,B,G,X,ee){let de=0;if(!b(re,G[X]))return de;if(de+=1,ee>0&&(de+=ee*5),K===B[X]&&(de+=1),X===0)de+=8;else{const ne=c(B.charCodeAt(X-1));ne?de+=ne:(0,I.$Lk)(B.charCodeAt(X))&&ee===0&&(de+=2)}return de}function b(K,re){return K===re?!0:K==="/"||K==="\\"?re==="/"||re==="\\":!1}function c(K){switch(K){case s.CharCode.Slash:case s.CharCode.Backslash:return 5;case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function d(K,re,B=0,G=0){const X=re;return X.values&&X.values.length>1?g(K,X.values,B,G):n(K,re,B,G)}function g(K,re,B,G){let X=0;const ee=[];for(const de of re){const[ne,De]=n(K,de,B,G);if(typeof ne!="number")return m;X+=ne,ee.push(...De)}return[X,C(ee)]}function n(K,re,B,G){const X=(0,I.$Uk)(re.original,re.originalLowercase,B,K,K.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,I.$Rk)(X)]:m}const o=Object.freeze({score:0}),t=1<<18,i=1<<17,r=65536;function f(K,re,B,G){const X=G.values?G.values:[G];return(0,T.$uj)({[G.normalized]:{values:X.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:K,description:re,allowNonContiguousMatches:B}})}function u(K,re,B,G,X){if(!K||!re.normalized)return o;const ee=G.getItemLabel(K);if(!ee)return o;const de=G.getItemDescription(K),ne=f(ee,de,B,re),De=X[ne];if(De)return De;const $e=w(ee,de,G.getItemPath(K),re,B);return X[ne]=$e,$e}function w(K,re,B,G,X){const ee=!B||!G.containsPathSeparator;return B&&(R.$k?G.pathNormalized===B:(0,$.$Hf)(G.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:K.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?S(K,re,B,G.values,ee,X):D(K,re,B,G,ee,X)}function S(K,re,B,G,X,ee){let de=0;const ne=[],De=[];for(const $e of G){const{score:J,labelMatch:U,descriptionMatch:se}=D(K,re,B,$e,X,ee);if(J===a)return o;de+=J,U&&ne.push(...U),se&&De.push(...se)}return{score:de,labelMatch:C(ne),descriptionMatch:C(De)}}function D(K,re,B,G,X,ee){if(X||!re){const[de,ne]=E(K,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(de){const De=(0,I.$Ik)(G.normalized,K);let $e;if(De){$e=i;const J=Math.round(G.normalized.length/K.length*100);$e+=J}else $e=r;return{score:$e+de,labelMatch:De||y(ne)}}}if(re){let de=re;B&&(de=`${re}${L.sep}`);const ne=de.length,De=`${de}${K}`,[$e,J]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const U=y(J),se=[],ae=[];return U.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),ae.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):ae.push(te)}),{score:$e,labelMatch:se,descriptionMatch:ae}}}return o}function y(K){const re=[];if(!K)return re;let B;for(const G of K)B&&B.end===G?B.end+=1:(B={start:G,end:G+1},re.push(B));return re}function C(K){const re=K.sort((X,ee)=>X.start-ee.start),B=[];let G;for(const X of re)!G||!A(G,X)?(G=X,B.push(X)):(G.start=Math.min(G.start,X.start),G.end=Math.max(G.end,X.end));return B}function A(K,re){return!(K.end<re.start||re.end<K.start)}function p(K,re,B,G,X,ee){const de=u(K,B,G,X,ee),ne=u(re,B,G,X,ee),De=de.score,$e=ne.score;if((De===t||$e===t)&&De!==$e)return De===t?-1:1;if(De>r||$e>r){if(De!==$e)return De>$e?-1:1;if(De<i&&$e<i){const ue=F(de.labelMatch,ne.labelMatch);if(ue!==0)return ue}const te=X.getItemLabel(K)||"",le=X.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const J=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(J&&!U)return-1;if(U&&!J)return 1;const se=v(K,de,X),ae=v(re,ne,X);return se&&ae&&se!==ae?ae>se?-1:1:N(K,re,B,X)}function v(K,re,B){let G=-1,X=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(X=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=B.getItemDescription(K);ee&&(X+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(X=re.descriptionMatch[re.descriptionMatch.length-1].end);return X-G}function F(K,re){if(!K&&!re||(!K||!K.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!K||!K.length)return 1;const B=K[0].start,X=K[K.length-1].end-B,ee=re[0].start,ne=re[re.length-1].end-ee;return X===ne?0:ne<X?1:-1}function N(K,re,B,G){const X=G.getItemLabel(K)||"",ee=G.getItemLabel(re)||"",de=G.getItemDescription(K),ne=G.getItemDescription(re),De=X.length+(de?de.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const J=G.getItemPath(K),U=G.getItemPath(re);return J&&U&&J.length!==U.length?J.length-U.length:X!==ee?(0,h.$Jr)(X,ee,B.normalized):de&&ne&&de!==ne?(0,h.$Jr)(de,ne,B.normalized):J&&U&&J!==U?(0,h.$Jr)(J,U,B.normalized):0}function O(K){return K.startsWith('"')&&K.endsWith('"')}const j=" ";function z(K){typeof K!="string"&&(K="");const re=K.toLowerCase(),{pathNormalized:B,normalized:G,normalizedLowercase:X}=M(K),ee=B.indexOf(L.sep)>=0,de=O(K);let ne;const De=K.split(j);if(De.length>1)for(const $e of De){const J=O($e),{pathNormalized:U,normalized:se,normalizedLowercase:ae}=M($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:U,normalized:se,normalizedLowercase:ae,expectContiguousMatch:J}))}return{original:K,originalLowercase:re,pathNormalized:B,normalized:G,normalizedLowercase:X,values:ne,containsPathSeparator:ee,expectContiguousMatch:de}}function M(K){let re;R.$i?re=K.replace(/\//g,L.sep):re=K.replace(/\\/g,L.sep);const B=(0,$.$rf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:B,normalizedLowercase:B.toLowerCase()}}function V(K){return Array.isArray(K)?z(K.map(re=>re.original).join(j)):z(K.original)}}),define(Ee[108],Se([1,0,17]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=T,e.$$s=L,e.$_s=R,e.$at=a,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(k){const E=(0,s.$rc)(k),l=h[E.toLowerCase()];return l!==void 0?l:L(k)}function L(k){const E=(0,s.$rc)(k);return I[E.toLowerCase()]}function R(k){for(const E in I)if(I[E]===k)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function a(k,E){const l=$.exec(k);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:E?void 0:k}}),define(Ee[109],Se([1,0,11]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=T,e.$mm=L;var h;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(h||(e.Source=h={}));var I;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function T(R,...$){const a=$.reduce((l,P)=>(l[P]=!0,l),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(l=>!a[l]).forEach(l=>{for(let P=0;P<k.length;P++)if(l.search(k[P])!==-1){delete R[l];break}})}function L(R){R&&(delete R.DEBUG,s.$j&&delete R.DYLD_LIBRARY_PATH,s.$k&&delete R.LD_PRELOAD)}}),define(Ee[2],Se([1,0,27,41,17,11]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=m,e.$zc=i,I=We(I);const L=/^\w[\w\d+.-]*$/,R=/^\//,$=/^\/\//;function a(S,D){if(!S.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${S.authority}", path: "${S.path}", query: "${S.query}", fragment: "${S.fragment}"}`);if(S.scheme&&!L.test(S.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(S.path){if(S.authority){if(!R.test(S.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(S.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(S,D){return!S&&!D?"file":S}function E(S,D){switch(S){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const l="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(D){return D instanceof c?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,C,A,p,v=!1){typeof D=="object"?(this.scheme=D.scheme||l,this.authority=D.authority||l,this.path=D.path||l,this.query=D.query||l,this.fragment=D.fragment||l):(this.scheme=k(D,v),this.authority=y||l,this.path=E(this.scheme,C||l),this.query=A||l,this.fragment=p||l,a(this,v))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:C,path:A,query:p,fragment:v}=D;return y===void 0?y=this.scheme:y===null&&(y=l),C===void 0?C=this.authority:C===null&&(C=l),A===void 0?A=this.path:A===null&&(A=l),p===void 0?p=this.query:p===null&&(p=l),v===void 0?v=this.fragment:v===null&&(v=l),y===this.scheme&&C===this.authority&&A===this.path&&p===this.query&&v===this.fragment?this:new g(y,C,A,p,v)}static parse(D,y=!1){const C=b.exec(D);return C?new g(C[2]||l,w(C[4]||l),w(C[5]||l),w(C[7]||l),w(C[9]||l),y):new g(l,l,l,l,l)}static file(D){let y=l;if(T.$i&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const C=D.indexOf(P,2);C===-1?(y=D.substring(2),D=P):(y=D.substring(2,C),D=D.substring(C)||P)}return new g("file",y,D,l,l)}static from(D,y){return new g(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return T.$i&&D.scheme==="file"?C=c.file(I.$ic.join(i(D,!0),...y)).path:C=I.$jc.join(D.path,...y),D.with({path:C})}toString(D=!1){return r(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof c)return D;{const y=new g(D);return y._formatted=D.external??null,y._fsPath=D._sep===d?D.fsPath??null:null,y}}else return D}}e.URI=c;function m(S){return!S||typeof S!="object"?!1:typeof S.scheme=="string"&&(typeof S.authority=="string"||typeof S.authority>"u")&&(typeof S.path=="string"||typeof S.path>"u")&&(typeof S.query=="string"||typeof S.query>"u")&&(typeof S.fragment=="string"||typeof S.fragment>"u")}const d=T.$i?1:void 0;class g extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=d),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[s.CharCode.Colon]:"%3A",[s.CharCode.Slash]:"%2F",[s.CharCode.QuestionMark]:"%3F",[s.CharCode.Hash]:"%23",[s.CharCode.OpenSquareBracket]:"%5B",[s.CharCode.CloseSquareBracket]:"%5D",[s.CharCode.AtSign]:"%40",[s.CharCode.ExclamationMark]:"%21",[s.CharCode.DollarSign]:"%24",[s.CharCode.Ampersand]:"%26",[s.CharCode.SingleQuote]:"%27",[s.CharCode.OpenParen]:"%28",[s.CharCode.CloseParen]:"%29",[s.CharCode.Asterisk]:"%2A",[s.CharCode.Plus]:"%2B",[s.CharCode.Comma]:"%2C",[s.CharCode.Semicolon]:"%3B",[s.CharCode.Equals]:"%3D",[s.CharCode.Space]:"%20"};function o(S,D,y){let C,A=-1;for(let p=0;p<S.length;p++){const v=S.charCodeAt(p);if(v>=s.CharCode.a&&v<=s.CharCode.z||v>=s.CharCode.A&&v<=s.CharCode.Z||v>=s.CharCode.Digit0&&v<=s.CharCode.Digit9||v===s.CharCode.Dash||v===s.CharCode.Period||v===s.CharCode.Underline||v===s.CharCode.Tilde||D&&v===s.CharCode.Slash||y&&v===s.CharCode.OpenSquareBracket||y&&v===s.CharCode.CloseSquareBracket||y&&v===s.CharCode.Colon)A!==-1&&(C+=encodeURIComponent(S.substring(A,p)),A=-1),C!==void 0&&(C+=S.charAt(p));else{C===void 0&&(C=S.substr(0,p));const F=n[v];F!==void 0?(A!==-1&&(C+=encodeURIComponent(S.substring(A,p)),A=-1),C+=F):A===-1&&(A=p)}}return A!==-1&&(C+=encodeURIComponent(S.substring(A))),C!==void 0?C:S}function t(S){let D;for(let y=0;y<S.length;y++){const C=S.charCodeAt(y);C===s.CharCode.Hash||C===s.CharCode.QuestionMark?(D===void 0&&(D=S.substr(0,y)),D+=n[C]):D!==void 0&&(D+=S[y])}return D!==void 0?D:S}function i(S,D){let y;return S.authority&&S.path.length>1&&S.scheme==="file"?y=`//${S.authority}${S.path}`:S.path.charCodeAt(0)===s.CharCode.Slash&&(S.path.charCodeAt(1)>=s.CharCode.A&&S.path.charCodeAt(1)<=s.CharCode.Z||S.path.charCodeAt(1)>=s.CharCode.a&&S.path.charCodeAt(1)<=s.CharCode.z)&&S.path.charCodeAt(2)===s.CharCode.Colon?D?y=S.path.substr(1):y=S.path[1].toLowerCase()+S.path.substr(2):y=S.path,T.$i&&(y=y.replace(/\//g,"\\")),y}function r(S,D){const y=D?t:o;let C="",{scheme:A,authority:p,path:v,query:F,fragment:N}=S;if(A&&(C+=A,C+=":"),(p||A==="file")&&(C+=P,C+=P),p){let O=p.indexOf("@");if(O!==-1){const j=p.substr(0,O);p=p.substr(O+1),O=j.lastIndexOf(":"),O===-1?C+=y(j,!1,!1):(C+=y(j.substr(0,O),!1,!1),C+=":",C+=y(j.substr(O+1),!1,!0)),C+="@"}p=p.toLowerCase(),O=p.lastIndexOf(":"),O===-1?C+=y(p,!1,!0):(C+=y(p.substr(0,O),!1,!0),C+=p.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===s.CharCode.Slash&&v.charCodeAt(2)===s.CharCode.Colon){const O=v.charCodeAt(1);O>=s.CharCode.A&&O<=s.CharCode.Z&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===s.CharCode.Colon){const O=v.charCodeAt(0);O>=s.CharCode.A&&O<=s.CharCode.Z&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}C+=y(v,!0,!1)}return F&&(C+="?",C+=y(F,!1,!1)),N&&(C+="#",C+=D?N:o(N,!1,!1)),C}function f(S){try{return decodeURIComponent(S)}catch{return S.length>3?S.substr(0,3)+f(S.substr(3)):S}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(S){return S.match(u)?S.replace(u,D=>f(D)):S}}),define(Ee[207],Se([1,0,2]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=h,e.$cr=I,e.$dr=T,e.log=R;function h(a){const k=a;return k&&typeof k.type=="string"&&typeof k.severity=="string"}function I(a){const k=[];let E;try{const l=JSON.parse(a.arguments),P=l[l.length-1];P&&P.__$stack&&(l.pop(),E=P.__$stack),k.push(...l)}catch{k.push("Unable to log remote console arguments",a.arguments)}return{args:k,stack:E}}function T(a){if(typeof a!="string")return T(I(a).stack);const k=a;if(k){const E=L(k),l=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(l&&l.length===4)return{uri:s.URI.file(l[1]),line:Number(l[2]),column:Number(l[3])}}}function L(a){if(!a)return a;const k=a.indexOf(`
`);return k===-1?a:a.substring(0,k)}function R(a,k){const{args:E,stack:l}=I(a),P=typeof E[0]=="string"&&E.length===1;let b=L(l);b&&(b=`(${b.trim()})`);let c=[];if(typeof E[0]=="string"?b&&P?c=[`%c[${k}] %c${E[0]} %c${b}`,$("blue"),$(""),$("grey")]:c=[`%c[${k}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:c=[`%c[${k}]%`,$("blue"),...E],b&&!P&&c.push(b),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,c)}function $(a){return`color: ${a}`}}),define(Ee[57],Se([1,0,22,2,41]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=T,e.$ci=L,e.$di=$;function T(a){return JSON.stringify(a,R)}function L(a){let k=JSON.parse(a);return k=$(k),k}function R(a,k){return k instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function $(a,k=0){if(!a||k>200)return a;if(typeof a=="object"){switch(a.$mid){case I.MarshalledId.Uri:return h.URI.revive(a);case I.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case I.MarshalledId.Date:return new Date(a.source)}if(a instanceof s.$Pe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let E=0;E<a.length;++E)a[E]=$(a[E],k+1);else for(const E in a)Object.hasOwnProperty.call(a,E)&&(a[E]=$(a[E],k+1))}return a}}),define(Ee[15],Se([1,0,14,11,13,2,17]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=$,e.$Qg=a,e.$Ug=E,s=We(s),h=We(h),L=We(L);var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(R||(e.Schemas=R={}));function $(b,c){return T.URI.isUri(b)?(0,I.$Hf)(b.scheme,c):(0,I.$If)(b,c+":")}function a(b,...c){return c.some(m=>$(b,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=E(c,m)}getServerRootPath(){return this.f}get g(){return L.$jc.join(this.f,R.vscodeRemoteResource)}set(c,m,d){this.a[c]=m,this.b[c]=d}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(t){return s.$3(t),c}const m=c.authority;let d=this.a[m];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const g=this.b[m],n=this.c[m];let o=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(o+=`&${e.$Sg}=${encodeURIComponent(n)}`),T.URI.from({scheme:h.$o?this.d:R.vscodeRemoteResource,authority:`${d}:${g}`,path:this.g,query:o})}}e.$Tg=new k;function E(b,c){return L.$jc.join(c??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class l{static{this.a=e.$Zg}asBrowserUri(c){const m=this.b(c,ce);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===R.vscodeRemote?e.$Tg.rewrite(c):c.scheme===R.file&&(h.$m||h.$q===`${R.vscodeFileResource}://${l.a}`)?c.with({scheme:R.vscodeFileResource,authority:c.authority||l.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,ce);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===R.vscodeFileResource?c.with({scheme:R.file,authority:c.authority!==l.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return T.URI.isUri(c)?c:T.URI.parse(m.toUrl(c))}}e.$1g=new l;var P;(function(b){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function d(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:T.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const t=o?.get(m);if(t)return c.get(t)}b.getHeadersFromQuery=d;function g(n,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";n instanceof URLSearchParams?n.set(m,i):n[m]=i}b.addSearchParam=g})(P||(e.COI=P={}))}),define(Ee[208],Se([1,0,174,15,11,2]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=k,I=We(I);class L{constructor(l,P,b){this.id=l,this.dependencies=P,this.callback=b}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,P,b)=>{typeof l!="string"&&(b=P,P=l,l=null),(typeof P!="object"||!Array.isArray(P))&&(b=P,P=null),this.c.push(new L(l,P,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const P=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!P)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(l){return new Promise((P,b)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",d),c.removeEventListener("error",g)},d=n=>{m(),P(this.c.pop())},g=n=>{m(),b(n)};c.addEventListener("load",d),c.addEventListener("error",g),this.f&&(l=this.f.createScriptURL(l)),c.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(l){return new Promise((P,b)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),P(this.c.pop())}catch(c){b(c)}})}async j(l){try{const P=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=T.URI.parse(l).fsPath,d=P.readFileSync(m).toString(),g=c.wrap(d.replace(/^#!.*/,""));return new b.Script(g).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}const $=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function k(E,l,P){if(s.$V){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const b=`${E}/${l}`;if($.has(b))return $.get(b);let c;if(/^\w[\w\d+.-]*:\/\//.test(b))c=b;else{const n=`${P&&!I.$o?h.$Xg:h.$Wg}/${b}`;c=h.$1g.asBrowserUri(n).toString(!0)}const m=R.INSTANCE.load(c);return $.set(b,m),m}else return await new Promise((b,c)=>{ce([E],b,c)}).then(We)}}),define(Ee[23],Se([1,0,27,33,15,17,11,13,2]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=a,e.$qh=E,e.$rh=P,h=We(h),T=We(T);function a(b){return(0,$.$zc)(b,!0)}class k{constructor(c){this.a=c}compare(c,m,d=!1){return c===m?0:(0,R.$Af)(this.getComparisonKey(c,d),this.getComparisonKey(m,d))}isEqual(c,m,d=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,d)===this.getComparisonKey(m,d)}getComparisonKey(c,m=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,m,d=!1){if(c.scheme===m.scheme){if(c.scheme===I.Schemas.file)return h.$Fg(a(c),a(m),this.a(c))&&c.query===m.query&&(d||c.fragment===m.fragment);if((0,e.$mh)(c.authority,m.authority))return h.$Fg(c.path,m.path,this.a(c),"/")&&c.query===m.query&&(d||c.fragment===m.fragment)}return!1}joinPath(c,...m){return $.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.$eh)(c)||c.authority}basename(c){return T.$jc.basename(c.path)}extname(c){return T.$jc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===I.Schemas.file?m=$.URI.file(T.$pc(a(c))).path:(m=T.$jc.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==s.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===I.Schemas.file?m=$.URI.file(T.$kc(a(c))).path:m=T.$jc.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.$mh)(c.authority,m.authority))return;if(c.scheme===I.Schemas.file){const n=T.$oc(a(c),a(m));return L.$i?h.$zg(n):n}let d=c.path||"/";const g=m.path||"/";if(this.a(c)){let n=0;for(const o=Math.min(d.length,g.length);n<o&&!(d.charCodeAt(n)!==g.charCodeAt(n)&&d.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);d=g.substr(0,n)+d.substr(n)}return T.$jc.relative(d,g)}resolvePath(c,m){if(c.scheme===I.Schemas.file){const d=$.URI.file(T.$nc(a(c),m));return c.with({authority:d.authority,path:d.path})}return m=h.$Ag(m),c.with({path:T.$jc.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||c!==void 0&&m!==void 0&&(0,R.$Hf)(c,m)}hasTrailingPathSeparator(c,m=T.sep){if(c.scheme===I.Schemas.file){const d=a(c);return d.length>h.$Bg(d).length&&d[d.length-1]===m}else{const d=c.path;return d.length>1&&d.charCodeAt(d.length-1)===s.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=T.sep){return(0,e.$nh)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=T.sep){let d=!1;if(c.scheme===I.Schemas.file){const g=a(c);d=g!==void 0&&g.length===h.$Bg(g).length&&g[g.length-1]===m}else{m="/";const g=c.path;d=g.length===1&&g.charCodeAt(g.length-1)===s.CharCode.Slash}return!d&&!(0,e.$nh)(c,m)?c.with({path:c.path+"/"}):c}}e.$9g=k,e.$0g=new k(()=>!1),e.$$g=new k(b=>b.scheme===I.Schemas.file?!L.$k:!0),e.$_g=new k(b=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function E(b,c){const m=[];for(let d=0;d<b.length;d++){const g=c(b[d]);b.some((n,o)=>o===d?!1:(0,e.$bh)(g,c(n)))||m.push(b[d])}return m}var l;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,i]=o.split(":");t&&i&&d.set(t,i)});const n=m.path.substring(0,m.path.indexOf(";"));return n&&d.set(b.META_DATA_MIME,n),d}b.parseMetaData=c})(l||(e.DataUri=l={}));function P(b,c,m){if(c){let d=b.path;return d&&d[0]!==T.$jc.sep&&(d=T.$jc.sep+d),b.with({scheme:m,authority:c,path:d})}return b.with({scheme:m})}}),define(Ee[9],Se([1,0,21,14,4,3,23,11,185,49]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=k,e.$th=E,e.$uh=l,e.$vh=P,e.$wh=b,e.$xh=c,e.$yh=m,e.$zh=d,e.$Hh=S,e.$Ih=D,e.$Jh=y,e.$Kh=C,e.$Lh=A,e.$1h=G,e.$9h=te;function k(ue){return!!ue&&typeof ue.then=="function"}function E(ue){const Z=new s.$ye,oe=ue(Z.token),pe=new Promise((we,Fe)=>{const Ue=Z.token.onCancellationRequested(()=>{Ue.dispose(),Fe(new h.$8)});Promise.resolve(oe).then(ke=>{Ue.dispose(),Z.dispose(),we(ke)},ke=>{Ue.dispose(),Z.dispose(),Fe(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function l(ue,Z,oe){return new Promise((pe,we)=>{const Fe=Z.onCancellationRequested(()=>{Fe.dispose(),pe(oe)});ue.then(pe,we).finally(()=>Fe.dispose())})}function P(ue,Z){return new Promise((oe,pe)=>{const we=Z.onCancellationRequested(()=>{we.dispose(),pe(new h.$8)});ue.then(oe,pe).finally(()=>we.dispose())})}async function b(ue){let Z=-1;const oe=ue.map((pe,we)=>pe.then(Fe=>(Z=we,Fe)));try{return await Promise.race(oe)}finally{ue.forEach((pe,we)=>{we!==Z&&pe.cancel()})}}function c(ue,Z,oe){let pe;const we=setTimeout(()=>{pe?.(void 0),oe?.()},Z);return Promise.race([ue.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function m(ue){return new Promise((Z,oe)=>{const pe=ue();k(pe)?pe.then(Z,oe):Z(pe)})}function d(){let ue,Z;return{promise:new Promise((pe,we)=>{ue=pe,Z=we}),resolve:ue,reject:Z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const oe=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(oe,oe).then(pe)})}return new Promise((oe,pe)=>{this.b.then(oe,pe)})}return this.a=Z(),new Promise((oe,pe)=>{this.a.then(we=>{this.a=null,oe(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$Ah=g;class n{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Bh=n;class o{constructor(){this.a=new Map}queue(Z,oe){const we=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(Z)===we&&this.a.delete(Z)});return this.a.set(Z,we),we}}e.$Ch=o;const t=(ue,Z)=>{let oe=!0;const pe=setTimeout(()=>{oe=!1,Z()},ue);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(pe),oe=!1}}},i=ue=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,ue())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class r{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,oe=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=oe===$.$ie?i(pe):t(oe,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=r;class f{constructor(Z){this.a=new r(Z),this.b=new g}trigger(Z,oe){return this.a.trigger(()=>this.b.queue(Z),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=f;class u{constructor(){this.a=!1,this.b=new Promise((Z,oe)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=u;class w extends u{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Gh=w;function S(ue,Z){return Z?new Promise((oe,pe)=>{const we=setTimeout(()=>{Fe.dispose(),oe()},ue),Fe=Z.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$8)})}):E(oe=>S(ue,oe))}function D(ue,Z=0,oe){const pe=setTimeout(()=>{ue(),oe&&we.dispose()},Z),we=(0,T.$Vc)(()=>{clearTimeout(pe),oe?.deleteAndLeak(we)});return oe?.add(we),we}function y(ue){const Z=[];let oe=0;const pe=ue.length;function we(){return oe<pe?ue[oe++]():null}function Fe(Ue){Ue!=null&&Z.push(Ue);const ke=we();return ke?ke.then(Fe):Promise.resolve(Z)}return Promise.resolve(null).then(Fe)}function C(ue,Z=pe=>!!pe,oe=null){let pe=0;const we=ue.length,Fe=()=>{if(pe>=we)return Promise.resolve(oe);const Ue=ue[pe++];return Promise.resolve(Ue()).then(Pe=>Z(Pe)?Promise.resolve(Pe):Fe())};return Fe()}function A(ue,Z=pe=>!!pe,oe=null){if(ue.length===0)return Promise.resolve(oe);let pe=ue.length;const we=()=>{pe=-1;for(const Fe of ue)Fe.cancel?.()};return new Promise((Fe,Ue)=>{for(const ke of ue)ke.then(Pe=>{--pe>=0&&Z(Pe)?(we(),Fe(Pe)):pe===0&&Fe(oe)}).catch(Pe=>{--pe>=0&&(we(),Ue(Pe))})})}class p{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new I.$ne}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,pe)=>{this.g.push({factory:Z,c:oe,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const oe=Z.factory();oe.then(Z.c,Z.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=p;class v extends p{constructor(){super(1)}}e.$Nh=v;class F{constructor(){this.a=new X,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Oh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ne;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,oe=L.$0g){const pe=oe.getComparisonKey(Z);return this.a.get(pe)?.size??0}queueFor(Z,oe,pe=L.$0g){const we=pe.getComparisonKey(Z);let Fe=this.a.get(we);if(!Fe){Fe=new v;const Ue=this.f++,ke=I.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$7c),this.d.set(Ue,ke),this.a.set(we,Fe)}return Fe.queue(oe)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=N;class O{constructor(Z,oe){this.b=!1,this.a=-1,typeof Z=="function"&&typeof oe=="number"&&this.setIfNotSet(Z,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,oe){if(this.b)throw new h.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},oe)}setIfNotSet(Z,oe){if(this.b)throw new h.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},oe))}}e.$Qh=O;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,oe,pe=globalThis){if(this.f)throw new h.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{Z()},oe);this.d=(0,T.$Vc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=j;class z{constructor(Z,oe){this.b=-1,this.a=Z,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=z;class M{constructor(Z,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=Z,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=M;class V extends z{constructor(Z,oe){super(Z,oe),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Uh=V;class K extends T.$Xc{constructor(Z,oe){super(),this.g=Z,this.h=oe,this.a=[],this.b=this.B(new T.$Yc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of Z)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(ue,Z)=>{(0,R.$B)(()=>{if(oe)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Xh=(ue,Z,oe)=>{const pe=ue.requestIdleCallback(Z,typeof oe=="number"?{timeout:oe}:void 0);let we=!1;return{dispose(){we||(we=!0,ue.cancelIdleCallback(pe))}}},e.$Wh=ue=>(0,e.$Xh)(globalThis,ue)}();class re{constructor(Z,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Xh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=re;class B extends re{constructor(Z){super(globalThis,Z)}}e.$Zh=B;async function G(ue,Z,oe){let pe;for(let we=0;we<oe;we++)try{return await ue()}catch(Fe){pe=Fe,await S(Z)}throw pe}class X{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,oe,pe){return this.a={taskId:Z,cancel:()=>pe?.(),promise:oe},oe.then(()=>this.d(Z),()=>this.d(Z)),oe}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:oe,resolve:pe,reject:we}=d();this.b={run:Z,promise:oe,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=X;class ee{constructor(Z,oe=()=>Date.now()){this.d=Z,this.f=oe,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$3h=ee;var de;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(de||(de={}));class ne{get isRejected(){return this.d?.outcome===de.Rejected}get isResolved(){return this.d?.outcome===de.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===de.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,oe)=>{this.a=Z,this.b=oe})}complete(Z){return new Promise(oe=>{this.a(Z),this.d={outcome:de.Resolved,value:Z},oe()})}error(Z){return new Promise(oe=>{this.b(Z),this.d={outcome:de.Rejected,value:Z},oe()})}cancel(){return this.error(new h.$8)}}e.$4h=ne;var De;(function(ue){async function Z(pe){let we;const Fe=await Promise.all(pe.map(Ue=>Ue.then(ke=>ke,ke=>{we||(we=ke)})));if(typeof we<"u")throw we;return Fe}ue.settled=Z;function oe(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(Ue){Fe(Ue)}})}ue.withAsyncBody=oe})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new h.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=$e;class J{constructor(Z){this.b=Z,this.a=new a.$X(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=J;var U;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(U||(U={}));class se{static fromArray(Z){return new se(oe=>{oe.emitMany(Z)})}static fromPromise(Z){return new se(async oe=>{oe.emitMany(await Z)})}static fromPromises(Z){return new se(async oe=>{await Promise.all(Z.map(async pe=>oe.emitOne(await pe)))})}static merge(Z){return new se(async oe=>{await Promise.all(Z.map(async pe=>{for await(const we of pe)oe.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(Z,oe){this.a=U.Initial,this.b=[],this.d=null,this.f=oe,this.g=new I.$ne,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(Z(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,oe){return new se(async pe=>{for await(const we of Z)pe.emitOne(oe(we))})}map(Z){return se.map(this,Z)}static filter(Z,oe){return new se(async pe=>{for await(const we of Z)oe(we)&&pe.emitOne(we)})}filter(Z){return se.filter(this,Z)}static coalesce(Z){return se.filter(Z,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Z){const oe=[];for await(const pe of Z)oe.push(pe);return oe}toPromise(){return se.toPromise(this)}h(Z){this.a===U.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===U.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(Z){this.a===U.Initial&&(this.a=U.DoneError,this.d=Z,this.g.fire())}}e.$7h=se;class ae extends se{constructor(Z,oe){super(oe),this.m=Z}cancel(){this.m.cancel()}}e.$8h=ae;function te(ue){const Z=new s.$ye,oe=ue(Z.token);return new ae(Z,async pe=>{const we=Z.token.onCancellationRequested(()=>{we.dispose(),Z.dispose(),pe.reject(new h.$8)});try{for await(const Fe of oe){if(Z.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),Z.dispose()}catch(Fe){we.dispose(),Z.dispose(),pe.reject(Fe)}})}class le{constructor(Z){this.a=new ne,this.b=new se(we=>{if(oe){we.reject(oe);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},Z);let oe,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{oe||(oe=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$0h=le}),define(Ee[39],Se([1,0,19,9,27,33,29,17,11,13]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=k,e.$yk=c,e.$zk=F,e.$Ak=N,e.$Bk=O,e.$Ck=j,e.$Dk=z,e.$Ek=re;function k(){return Object.create(null)}e.$wk="**",e.$xk="/";const E="[/\\\\]",l="[^/\\\\]",P=/\//g;function b(B,G){switch(B){case 0:return"";case 1:return`${l}*?`;default:return`(?:${E}|${l}+${E}${G?`|${E}${l}+`:""})*?`}}function c(B,G){if(!B)return[];const X=[];let ee=!1,de=!1,ne="";for(const De of B){switch(De){case G:if(!ee&&!de){X.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":de=!0;break;case"]":de=!1;break}ne+=De}return ne&&X.push(ne),X}function m(B){if(!B)return"";let G="";const X=c(B,e.$xk);if(X.every(ee=>ee===e.$wk))G=".*";else{let ee=!1;X.forEach((de,ne)=>{if(de===e.$wk){if(ee)return;G+=b(2,ne===X.length-1)}else{let De=!1,$e="",J=!1,U="";for(const se of de){if(se!=="}"&&De){$e+=se;continue}if(J&&(se!=="]"||!U)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!U?ae="^":se===e.$xk?ae="":ae=(0,a.$jf)(se),U+=ae;continue}switch(se){case"{":De=!0;continue;case"[":J=!0;continue;case"}":{const te=`(?:${c($e,",").map(le=>m(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+U+"]",J=!1,U="";break}case"?":G+=l;continue;case"*":G+=b(1);continue;default:G+=(0,a.$jf)(se)}}ne<X.length-1&&(X[ne+1]!==e.$wk||ne+2<X.length)&&(G+=E)}ee=de===e.$wk})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.$Gc(1e4),f=function(){return!1},u=function(){return null};function w(B,G){if(!B)return u;let X;typeof B!="string"?X=B.pattern:X=B,X=X.trim();const ee=`${X}_${!!G.trimForExclusions}`;let de=r.get(ee);if(de)return S(de,B);let ne;return d.test(X)?de=y(X.substr(4),X):(ne=g.exec(D(X,G)))?de=C(ne[1],X):(G.trimForExclusions?o:n).test(X)?de=A(X,G):(ne=t.exec(D(X,G)))?de=p(ne[1].substr(1),X,!0):(ne=i.exec(D(X,G)))?de=p(ne[1],X,!1):de=v(X),r.set(ee,de),S(de,B)}function S(B,G){if(typeof G=="string")return B;const X=function(ee,de){return(0,T.$Fg)(ee,G.base,!$.$k)?B((0,a.$of)(ee.substr(G.base.length),R.sep),de):null};return X.allBasenames=B.allBasenames,X.allPaths=B.allPaths,X.basenames=B.basenames,X.patterns=B.patterns,X}function D(B,G){return G.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,G){return function(X,ee){return typeof X=="string"&&X.endsWith(B)?G:null}}function C(B,G){const X=`/${B}`,ee=`\\${B}`,de=function(De,$e){return typeof De!="string"?null:$e?$e===B?G:null:De===B||De.endsWith(X)||De.endsWith(ee)?G:null},ne=[B];return de.basenames=ne,de.patterns=[G],de.allBasenames=ne,de}function A(B,G){const X=K(B.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==u),B),ee=X.length;if(!ee)return u;if(ee===1)return X[0];const de=function($e,J){for(let U=0,se=X.length;U<se;U++)if(X[U]($e,J))return B;return null},ne=X.find($e=>!!$e.allBasenames);ne&&(de.allBasenames=ne.allBasenames);const De=X.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return De.length&&(de.allPaths=De),de}function p(B,G,X){const ee=R.sep===R.$jc.sep,de=ee?B:B.replace(P,R.sep),ne=R.sep+de,De=R.$jc.sep+B;let $e;return X?$e=function(J,U){return typeof J=="string"&&(J===de||J.endsWith(ne)||!ee&&(J===B||J.endsWith(De)))?G:null}:$e=function(J,U){return typeof J=="string"&&(J===de||!ee&&J===B)?G:null},$e.allPaths=[(X?"*/":"./")+B],$e}function v(B){try{const G=new RegExp(`^${m(B)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?B:null}}catch{return u}}function F(B,G,X){return!B||typeof G!="string"?!1:N(B)(G,void 0,X)}function N(B,G={}){if(!B)return f;if(typeof B=="string"||O(B)){const X=w(B,G);if(X===u)return f;const ee=function(de,ne){return!!X(de,ne)};return X.allBasenames&&(ee.allBasenames=X.allBasenames),X.allPaths&&(ee.allPaths=X.allPaths),ee}return M(B,G)}function O(B){const G=B;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(B){return B.allBasenames||[]}function z(B){return B.allPaths||[]}function M(B,G){const X=K(Object.getOwnPropertyNames(B).map($e=>V($e,B[$e],G)).filter($e=>$e!==u)),ee=X.length;if(!ee)return u;if(!X.some($e=>!!$e.requiresSiblings)){if(ee===1)return X[0];const $e=function(se,ae){let te;for(let le=0,ue=X.length;le<ue;le++){const Z=X[le](se,ae);if(typeof Z=="string")return Z;(0,h.$sh)(Z)&&(te||(te=[]),te.push(Z))}return te?(async()=>{for(const le of te){const ue=await le;if(typeof ue=="string")return ue}return null})():null},J=X.find(se=>!!se.allBasenames);J&&($e.allBasenames=J.allBasenames);const U=X.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return U.length&&($e.allPaths=U),$e}const de=function($e,J,U){let se,ae;for(let te=0,le=X.length;te<le;te++){const ue=X[te];ue.requiresSiblings&&U&&(J||(J=(0,R.$qc)($e)),se||(se=J.substr(0,J.length-(0,R.$rc)($e).length)));const Z=ue($e,J,se,U);if(typeof Z=="string")return Z;(0,h.$sh)(Z)&&(ae||(ae=[]),ae.push(Z))}return ae?(async()=>{for(const te of ae){const le=await te;if(typeof le=="string")return le}return null})():null},ne=X.find($e=>!!$e.allBasenames);ne&&(de.allBasenames=ne.allBasenames);const De=X.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return De.length&&(de.allPaths=De),de}function V(B,G,X){if(G===!1)return u;const ee=w(B,X);if(ee===u)return u;if(typeof G=="boolean")return ee;if(G){const de=G.when;if(typeof de=="string"){const ne=(De,$e,J,U)=>{if(!U||!ee(De,$e))return null;const se=de.replace("$(basename)",()=>J),ae=U(se);return(0,h.$sh)(ae)?ae.then(te=>te?B:null):ae?B:null};return ne.requiresSiblings=!0,ne}}return ee}function K(B,G){const X=B.filter($e=>!!$e.basenames);if(X.length<2)return B;const ee=X.reduce(($e,J)=>{const U=J.basenames;return U?$e.concat(U):$e},[]);let de;if(G){de=[];for(let $e=0,J=ee.length;$e<J;$e++)de.push(G)}else de=X.reduce(($e,J)=>{const U=J.patterns;return U?$e.concat(U):$e},[]);const ne=function($e,J){if(typeof $e!="string")return null;if(!J){let se;for(se=$e.length;se>0;se--){const ae=$e.charCodeAt(se-1);if(ae===I.CharCode.Slash||ae===I.CharCode.Backslash)break}J=$e.substr(se)}const U=ee.indexOf(J);return U!==-1?de[U]:null};ne.basenames=ee,ne.patterns=de,ne.allBasenames=ee;const De=B.filter($e=>!$e.basenames);return De.push(ne),De}function re(B,G){return(0,s.$xb)(B,G,(X,ee)=>typeof X=="string"&&typeof ee=="string"?X===ee:typeof X!="string"&&typeof ee!="string"?X.base===ee.base&&X.pattern===ee.pattern:!1)}}),define(Ee[86],Se([1,0,14,136,23,13,2]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=a,e.$6k=k,e.$7k=E,e.$8k=l,e.$9k=P,e.$0k=b,e.$$k=c,e.$_k=m;var R;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class ${constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,s.$0)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=R.Paragraph){return this.value+=l(this.supportThemeIcons?(0,h.$Xk)(g):g).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===R.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+=`
${P(n,g)}
`,this}appendLink(g,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(g),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(g,n){const o=new RegExp((0,T.$jf)(n),"g");return g.replace(o,(t,i)=>g.charAt(i-1)!=="\\"?`\\${t}`:t)}}e.$4k=$;function a(d){return k(d)?!d.value:Array.isArray(d)?d.every(a):!0}function k(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function E(d,g){return d===g?!0:!d||!g?!1:d.value===g.value&&d.isTrusted===g.isTrusted&&d.supportThemeIcons===g.supportThemeIcons&&d.supportHtml===g.supportHtml&&(d.baseUri===g.baseUri||!!d.baseUri&&!!g.baseUri&&(0,I.$ah)(L.URI.from(d.baseUri),L.URI.from(g.baseUri)))}function l(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(d,g){const n=d.match(/^`+/gm)?.reduce((t,i)=>t.length>i.length?t:i).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${g}`,d,`${"`".repeat(o)}`].join(`
`)}function b(d){return d.replace(/"/g,"&quot;")}function c(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(d){const g=[],n=d.split("|").map(t=>t.trim());d=n[0];const o=n[1];if(o){const t=/height=(\d+)/.exec(o),i=/width=(\d+)/.exec(o),r=t?t[1]:"",f=i?i[1]:"",u=isFinite(parseInt(f)),w=isFinite(parseInt(r));u&&g.push(`width="${f}"`),w&&g.push(`height="${r}"`)}return{href:d,dimensions:g}}}),define(Ee[110],Se([1,0,19,33,17,11,23,13]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=$,e.$Xw=k,e.$Yw=l,e.$Zw=P,e.$1w=d,e.$2w=n,e.$3w=o,e.$4w=t,e.$5w=i,e.$6w=r;function $(u,w){const{os:S,tildify:D,relative:y}=w;if(y){const p=a(u,y,S);if(typeof p=="string")return p}let C=u.fsPath;if(S===T.OperatingSystem.Windows&&!T.$i?C=C.replace(/\//g,"\\"):S!==T.OperatingSystem.Windows&&T.$i&&(C=C.replace(/\\/g,"/")),S!==T.OperatingSystem.Windows&&D?.userHome){const p=D.userHome.fsPath;let v;u.scheme!==D.userHome.scheme&&u.path[0]===I.$jc.sep&&u.path[1]!==I.$jc.sep?v=D.userHome.with({path:u.path}).fsPath:v=C,C=l(v,p,S)}return(S===T.OperatingSystem.Windows?I.$ic:I.$jc).normalize(k(C,S===T.OperatingSystem.Windows))}function a(u,w,S){const D=S===T.OperatingSystem.Windows?I.$ic:I.$jc,y=S===T.OperatingSystem.Linux?L.$0g:L.$_g,C=w.getWorkspace(),A=(0,s.$Rb)(C.folders);if(!A)return;u.scheme!==A.uri.scheme&&u.path[0]===I.$jc.sep&&u.path[1]!==I.$jc.sep&&(u=A.uri.with({path:u.path}));const p=w.getWorkspaceFolder(u);if(!p)return;let v;if(y.isEqual(p.uri,u)?v="":v=y.relativePath(p.uri,u)??"",v&&(v=D.normalize(v)),C.folders.length>1&&!w.noPrefix){const F=p.name?p.name:y.basenameOrAuthority(p.uri);v=v?`${F} \u2022 ${v}`:F}return v}function k(u,w=T.$i){return(0,h.$Kg)(u,w)?u.charAt(0).toUpperCase()+u.slice(1):u}let E=Object.create(null);function l(u,w,S=T.OS){if(S===T.OperatingSystem.Windows||!u||!w)return u;let D=E.original===w?E.normalized:void 0;D||(D=w,T.$i&&(D=(0,h.$zg)(D)),D=`${(0,R.$pf)(D,I.$jc.sep)}${I.$jc.sep}`,E={original:w,normalized:D});let y=u;return T.$i&&(y=(0,h.$zg)(y)),(S===T.OperatingSystem.Linux?y.startsWith(D):(0,R.$If)(y,D))?`~/${y.substr(D.length)}`:u}function P(u,w){return u.replace(/^~($|\/|\\)/,`${w}$1`)}const b="\u2026",c="\\\\",m="~";function d(u,w=I.sep){const S=new Array(u.length);let D=!1;for(let y=0;y<u.length;y++){const C=u[y];if(C===""){S[y]=`.${w}`;continue}if(!C){S[y]=C;continue}D=!0;let A="",p=C;p.indexOf(c)===0?(A=p.substr(0,p.indexOf(c)+c.length),p=p.substr(p.indexOf(c)+c.length)):p.indexOf(w)===0?(A=p.substr(0,p.indexOf(w)+w.length),p=p.substr(p.indexOf(w)+w.length)):p.indexOf(m)===0&&(A=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const v=p.split(w);for(let F=1;D&&F<=v.length;F++)for(let N=v.length-F;D&&N>=0;N--){D=!1;let O=v.slice(N,N+F).join(w);for(let j=0;!D&&j<u.length;j++)if(j!==y&&u[j]&&u[j].indexOf(O)>-1){const z=N+F===v.length,M=N>0&&u[j].indexOf(w)>-1?w+O:O,V=u[j].endsWith(M);D=!z||V}if(!D){let j="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,O=v[0]+w+O),N>0&&(j=v[0]+w),j=A+j),N>0&&(j=j+b+w),j=j+O,N+F<v.length&&(j=j+w+b),S[y]=j}}D&&(S[y]=C)}return S}var g;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function n(u,w=Object.create(null)){const S=[];let D=!1,y="";for(const C of u)if(C==="$"||D&&C==="{")y&&S.push({value:y,type:g.TEXT}),y="",D=!0;else if(C==="}"&&D){const A=w[y];if(typeof A=="string")A.length&&S.push({value:A,type:g.VARIABLE});else if(A){const p=S[S.length-1];(!p||p.type!==g.SEPARATOR)&&S.push({value:A.label,type:g.SEPARATOR})}y="",D=!1}else y+=C;return y&&!D&&S.push({value:y,type:g.TEXT}),S.filter((C,A)=>{if(C.type===g.SEPARATOR){const p=S[A-1],v=S[A+1];return[p,v].every(F=>F&&(F.type===g.VARIABLE||F.type===g.TEXT)&&F.value.length>0)}return!0}).map(C=>C.value).join("")}function o(u,w){return T.$j||w?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):u.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(u,w){return T.$j||w?u.replace(/\(&&\w\)|&&/g,""):T.$i?u.replace(/&&|&/g,S=>S==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function r(u){if(u.endsWith("]")){const w=u.lastIndexOf(" [",u.length-2);if(w!==-1){const S=f(u.substring(0,w)),D=u.substring(w);return{name:S.name+D,parentPath:S.parentPath}}}return f(u)}function f(u){const w=u.indexOf("/")!==-1?I.$jc:I.$ic,S=w.basename(u),D=w.dirname(u);return S.length?{name:S,parentPath:D}:{name:D,parentPath:""}}}),define(Ee[142],Se([1,0,22,41,2]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=$,e.$Pn=k,e.$Qn=E;function T(l){return l.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const b=this.a.transformIncoming(P);return b===P?P:T(I.URI.from(b))}transformOutgoing(P){const b=this.a.transformOutgoing(P);return b===P?P:T(I.URI.from(b))}transformOutgoingURI(P){const b=this.a.transformOutgoing(P);return b===P?P:I.URI.from(b)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Mn=L,e.$Nn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function R(l,P,b){if(!l||b>200)return null;if(typeof l=="object"){if(l instanceof I.URI)return P.transformOutgoing(l);for(const c in l)if(Object.hasOwnProperty.call(l,c)){const m=R(l[c],P,b+1);m!==null&&(l[c]=m)}}return null}function $(l,P){const b=R(l,P,0);return b===null?l:b}function a(l,P,b,c){if(!l||c>200)return null;if(typeof l=="object"){if(l.$mid===h.MarshalledId.Uri)return b?I.URI.revive(P.transformIncoming(l)):P.transformIncoming(l);if(l instanceof s.$Pe)return null;for(const m in l)if(Object.hasOwnProperty.call(l,m)){const d=a(l[m],P,b,c+1);d!==null&&(l[m]=d)}}return null}function k(l,P){const b=a(l,P,!1,0);return b===null?l:b}function E(l,P){const b=a(l,P,!0,0);return b===null?l:b}}),define(Ee[34],Se([1,0,61,68,411,9,33,82,17,11,23,2]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=i,e.configureFlushOnWrite=S,e.writeFileSync=y,s=We(s);var l;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(l||(e.RimRafMode=l={}));async function P(M,V=l.UNLINK,K){if((0,L.$Jg)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?c(M):b(M,K)}async function b(M,V=(0,L.$Og)((0,h.tmpdir)())){try{try{await s.promises.rename(M,V)}catch(K){return K.code==="ENOENT"?void 0:c(M)}c(V).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function c(M){return s.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function m(M){if((0,L.$Jg)(M))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function d(M,V){return o(await(V?g(M):s.promises.readdir(M)))}async function g(M){try{return await s.promises.readdir(M,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const V=[],K=await d(M);for(const re of K){let B=!1,G=!1,X=!1;try{const ee=await e.Promises.lstat((0,$.$mc)(M,re));B=ee.isFile(),G=ee.isDirectory(),X=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}V.push({name:re,isFile:()=>B,isDirectory:()=>G,isSymbolicLink:()=>X})}return V}function n(M){return o(s.readdirSync(M))}function o(M){return M.map(V=>typeof V=="string"?a.$j?(0,R.$nm)(V):V:(V.name=a.$j?(0,R.$nm)(V.name):V.name,V))}async function t(M){const V=await d(M),K=[];for(const re of V)await r.existsDirectory((0,$.$mc)(M,re))&&K.push(re);return K}function i(M,V=1e3){return new Promise(K=>{let re=!1;const B=setInterval(()=>{re||(re=!0,s.access(M,G=>{re=!1,G&&(clearInterval(B),K(void 0))}))},V)})}var r;(function(M){async function V(B){let G;try{if(G=await e.Promises.lstat(B),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(a.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw X}}M.stat=V;async function K(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isFile()&&X?.dangling!==!0}catch{}return!1}M.existsFile=K;async function re(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isDirectory()&&X?.dangling!==!0}catch{}return!1}M.existsDirectory=re})(r||(e.SymlinkSupport=r={}));const f=new T.$Ph;function u(M,V,K){return f.queueFor(E.URI.file(M),()=>{const re=C(K);return new Promise((B,G)=>D(M,V,re,X=>X?G(X):B()))},k.$$g)}let w=!0;function S(M){w=M}function D(M,V,K,re){if(!w)return s.writeFile(M,V,{mode:K.mode,flag:K.flag},re);s.open(M,K.flag,K.mode,(B,G)=>{if(B)return re(B);s.writeFile(G,V,X=>{if(X)return s.close(G,()=>re(X));s.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),S(!1)),s.close(G,de=>re(de))))})})}function y(M,V,K){const re=C(K);if(!w)return s.writeFileSync(M,V,{mode:re.mode,flag:re.flag});const B=s.openSync(M,re.flag,re.mode);try{s.writeFileSync(B,V);try{s.fdatasyncSync(B)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),S(!1)}}finally{s.closeSync(B)}}function C(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,V,K=6e4){if(M!==V)try{a.$i&&typeof K=="number"?await p(M,V,Date.now(),K):await s.promises.rename(M,V)}catch(re){if(M.toLowerCase()!==V.toLowerCase()&&re.code==="EXDEV"||M.endsWith("."))await v(M,V,{preserveSymlinks:!1}),await P(M,l.MOVE);else throw re}}async function p(M,V,K,re,B=0){try{return await s.promises.rename(M,V)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-K>=re)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${G}`),G;if(B===0){let X=!1;try{const{stat:ee}=await r.stat(V);ee.isFile()||(X=!0)}catch{}if(X)throw G}return await(0,T.$Hh)(Math.min(100,B*10)),p(M,V,K,re,B+1)}}async function v(M,V,K){return N(M,V,{root:{source:M,target:V},options:K,handledSourcePaths:new Set})}const F=511;async function N(M,V,K){if(K.handledSourcePaths.has(M))return;K.handledSourcePaths.add(M);const{stat:re,symbolicLink:B}=await r.stat(M);if(B){if(K.options.preserveSymlinks)try{return await z(M,V,K)}catch{}if(B.dangling)return}return re.isDirectory()?O(M,V,re.mode&F,K):j(M,V,re.mode&F)}async function O(M,V,K,re){await e.Promises.mkdir(V,{recursive:!0,mode:K});const B=await d(M);for(const G of B)await N((0,$.$mc)(M,G),(0,$.$mc)(V,G),re)}async function j(M,V,K){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,K)}async function z(M,V,K){let re=await e.Promises.readlink(M);(0,L.$Fg)(re,K.root.source,!a.$k)&&(re=(0,$.$mc)(K.root.target,re.substr(K.root.source.length+1))),await e.Promises.symlink(re,V)}e.Promises=new class{get access(){return s.promises.access}get stat(){return s.promises.stat}get lstat(){return s.promises.lstat}get utimes(){return s.promises.utimes}get read(){return(M,V,K,re,B)=>new Promise((G,X)=>{s.read(M,V,K,re,B,(ee,de,ne)=>ee?X(ee):G({bytesRead:de,buffer:ne}))})}get readFile(){return s.promises.readFile}get write(){return(M,V,K,re,B)=>new Promise((G,X)=>{s.write(M,V,K,re,B,(ee,de,ne)=>ee?X(ee):G({bytesWritten:de,buffer:ne}))})}get appendFile(){return s.promises.appendFile}get fdatasync(){return(0,I.promisify)(s.fdatasync)}get truncate(){return s.promises.truncate}get copyFile(){return s.promises.copyFile}get open(){return(0,I.promisify)(s.open)}get close(){return(0,I.promisify)(s.close)}get symlink(){return s.promises.symlink}get readlink(){return s.promises.readlink}get chmod(){return s.promises.chmod}get mkdir(){return s.promises.mkdir}get unlink(){return s.promises.unlink}get rmdir(){return s.promises.rmdir}get realpath(){return(0,I.promisify)(s.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(Ee[111],Se([1,0,61,17,11,13,34]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=R,e.$kr=$,e.$lr=a,e.$mr=k,s=We(s);function R(l){if(I.$k)return l;const P=(0,h.$pc)(l);if(l===P)return l;const b=((0,h.$qc)(l)||l).toLowerCase();try{const m=(0,L.readdirSync)(P).filter(d=>d.toLowerCase()===b);if(m.length===1){const d=R(P);if(d)return(0,h.$mc)(d,m[0])}else if(m.length>1){const d=m.indexOf(b);if(d>=0){const g=R(P);if(g)return(0,h.$mc)(g,m[d])}}}catch{}return null}async function $(l,P){if(I.$k)return l;const b=(0,h.$pc)(l);if(l===b)return l;const c=((0,h.$qc)(l)||l).toLowerCase();try{if(P?.isCancellationRequested)return null;const d=(await L.Promises.readdir(b)).filter(g=>g.toLowerCase()===c);if(d.length===1){const g=await $(b,P);if(g)return(0,h.$mc)(g,d[0])}else if(d.length>1){const g=d.indexOf(c);if(g>=0){const n=await $(b,P);if(n)return(0,h.$mc)(n,d[g])}}}catch{}return null}async function a(l){try{return await L.Promises.realpath(l)}catch{const b=E(l);return await L.Promises.access(b,s.constants.R_OK),b}}function k(l){try{return s.realpathSync(l)}catch{const b=E(l);return s.accessSync(b,s.constants.R_OK),b}}function E(l){return(0,T.$pf)((0,h.$kc)(l),h.sep)}}),define(Ee[112],Se([1,0,17,11,56,109,18,34]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=$,e.$zm=a,s=We(s),h=We(h),I=We(I),L=We(L),R=We(R),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function $(E=I.env){return E.comspec||"cmd.exe"}function a(E){let l=[],P=!1;const b=function(c){if(P){l.push(c);return}(!E.send(c,d=>{if(d&&console.error(d),P=!1,l.length>0){const g=l.slice(0);l=[],g.forEach(n=>b(n))}})||h.$i)&&(P=!0)};return{send:b}}var k;(function(E){async function l(P,b,c){if(s.$lc(P))return P;if(b===void 0&&(b=I.cwd()),s.$pc(P)!=="."||(c===void 0&&L.$gg(I.env.PATH)&&(c=I.env.PATH.split(s.$wc)),c===void 0||c.length===0))return s.$mc(b,P);async function d(g){if(await R.Promises.exists(g)){let n;try{n=await R.Promises.stat(g)}catch(o){o.message.startsWith("EACCES")&&(n=await R.Promises.lstat(g))}return n?!n.isDirectory():!1}return!1}for(const g of c){let n;if(s.$lc(g)?n=s.$mc(g,P):n=s.$mc(b,g,P),await d(n))return n;let o=n+".com";if(await d(o)||(o=n+".exe",await d(o)))return o}return s.$mc(b,P)}E.findExecutable=l})(k||(e.win32=k={}))});var Xe=this&&this.__decorate||function(ce,e,s,h){var I=arguments.length,T=I<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,s):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ce,e,s,h);else for(var R=ce.length-1;R>=0;R--)(L=ce[R])&&(T=(I<3?L(T):I>3?L(e,s,T):L(e,s))||T);return I>3&&T&&Object.defineProperty(e,s,T),T};define(Ee[87],Se([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=S,e.$hi=D,e.$mi=F,e.$ni=N,E=We(E);var P;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(P||(P={}));function b(B){switch(B){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var c;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(c||(c={}));function m(B){switch(B){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function g(B){let G=0;for(let X=0;;X+=7){const ee=B.read(1);if(G|=(ee.buffer[0]&127)<<X,!(ee.buffer[0]&128))return G}}const n=f(0);function o(B,G){if(G===0){B.write(n);return}let X=0;for(let de=G;de!==0;de=de>>>7)X++;const ee=I.$Pe.alloc(X);for(let de=0;G!==0;de++)ee.buffer[de]=G&127,G=G>>>7,G>0&&(ee.buffer[de]|=128);B.write(ee)}class t{constructor(G){this.b=G,this.a=0}read(G){const X=this.b.slice(this.a,this.a+G);return this.a+=X.byteLength,X}}e.$ei=t;class i{constructor(){this.a=[]}get buffer(){return I.$Pe.concat(this.a)}write(G){this.a.push(G)}}e.$fi=i;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function f(B){const G=I.$Pe.alloc(1);return G.writeUInt8(B,0),G}const u={Undefined:f(r.Undefined),String:f(r.String),Buffer:f(r.Buffer),VSBuffer:f(r.VSBuffer),Array:f(r.Array),Object:f(r.Object),Uint:f(r.Int)},w=typeof Buffer<"u";function S(B,G){if(typeof G>"u")B.write(u.Undefined);else if(typeof G=="string"){const X=I.$Pe.fromString(G);B.write(u.String),o(B,X.byteLength),B.write(X)}else if(w&&Buffer.isBuffer(G)){const X=I.$Pe.wrap(G);B.write(u.Buffer),o(B,X.byteLength),B.write(X)}else if(G instanceof I.$Pe)B.write(u.VSBuffer),o(B,G.byteLength),B.write(G);else if(Array.isArray(G)){B.write(u.Array),o(B,G.length);for(const X of G)S(B,X)}else if(typeof G=="number"&&(G|0)===G)B.write(u.Uint),o(B,G);else{const X=I.$Pe.fromString(JSON.stringify(G));B.write(u.Object),o(B,X.byteLength),B.write(X)}}function D(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(g(B)).toString();case r.Buffer:return B.read(g(B)).buffer;case r.VSBuffer:return B.read(g(B));case r.Array:{const X=g(B),ee=[];for(let de=0;de<X;de++)ee.push(D(B));return ee}case r.Object:return JSON.parse(B.read(g(B)).toString());case r.Int:return g(B)}}class y{constructor(G,X,ee=null,de=1e3){this.h=G,this.j=X,this.k=ee,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:c.Initialize})}registerChannel(G,X){this.b.set(G,X),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case c.Initialize:{const X=this.o([G.type]);this.k?.logOutgoing(X,0,C.OtherSide,m(G.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const X=this.o([G.type,G.id],G.data);this.k?.logOutgoing(X,G.id,C.OtherSide,m(G.type),G.data);return}}}o(G,X=void 0){const ee=new i;return S(ee,G),S(ee,X),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const X=new t(G),ee=D(X),de=D(X),ne=ee[0];switch(ne){case P.Promise:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,de),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:de});case P.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,de),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:de});case P.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]});case P.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ee=new T.$ye;let de;try{de=X.call(this.j,G.name,G.arg,ee.token)}catch($e){de=Promise.reject($e)}const ne=G.id;de.then($e=>{this.m({id:ne,data:$e,type:c.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:ne,data:$e,type:c.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,a.$Vc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ee=G.id,ne=X.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:c.EventFire}));this.d.set(G.id,ne)}u(G){const X=this.d.get(G.id);X&&(X.dispose(),this.d.delete(G.id))}v(G){let X=this.g.get(G.channelName);X||(X=[],this.g.set(G.channelName,X));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===P.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);X.push({request:G,timeoutTimer:ee})}w(G){const X=this.g.get(G);if(X){for(const ee of X)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case P.Promise:this.s(ee.request);break;case P.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Sc)(this.d.values()),this.d.clear()}}e.$ii=y;var C;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class A{constructor(G,X=null){this.l=G,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=X}getChannel(G){const X=this;return{call(ee,de,ne){return X.a?Promise.reject(new R.$8):X.m(G,ee,de,ne)},listen(ee,de){return X.a?$.Event.None:X.o(G,ee,de)}}}m(G,X,ee,de=T.CancellationToken.None){const ne=this.g++,De=P.Promise,$e={id:ne,type:De,channelName:G,name:X,arg:ee};if(de.isCancellationRequested)return Promise.reject(new R.$8);let J;return new Promise((se,ae)=>{if(de.isCancellationRequested)return ae(new R.$8);const te=()=>{const oe=pe=>{switch(pe.type){case c.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case c.PromiseError:{this.f.delete(ne);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ae(we);break}case c.PromiseErrorObj:this.f.delete(ne),ae(pe.data);break}};this.f.set(ne,oe),this.p($e)};let le=null;this.b===d.Idle?te():(le=(0,h.$th)(oe=>this.u()),le.then(()=>{le=null,te()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:P.PromiseCancel}),ae(new R.$8)},Z=de.onCancellationRequested(ue);J=(0,a.$Uc)((0,a.$Vc)(ue),Z),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(G,X,ee){const de=this.g++,ne=P.EventListen,De={id:de,type:ne,channelName:G,name:X,arg:ee};let $e=null;const J=new $.$ne({onWillAddFirstListener:()=>{$e=(0,h.$th)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(J),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(J),this.p({id:de,type:P.EventDispose}))}}),U=se=>J.fire(se.data);return this.f.set(de,U),J.event}p(G){switch(G.type){case P.Promise:case P.EventListen:{const X=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(X,G.id,C.LocalSide,`${b(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case P.PromiseCancel:case P.EventDispose:{const X=this.q([G.type,G.id]);this.j?.logOutgoing(X,G.id,C.LocalSide,b(G.type));return}}}q(G,X=void 0){const ee=new i;return S(ee,G),S(ee,X),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const X=new t(G),ee=D(X),de=D(X),ne=ee[0];switch(ne){case c.Initialize:return this.j?.logIncoming(G.byteLength,0,C.LocalSide,m(ne)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],C.LocalSide,m(ne),de),this.t({type:ee[0],id:ee[1],data:de})}}t(G){if(G.type===c.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Sc)(this.d.values()),this.d.clear()}}e.$ji=A,Xe([L.$$h],A.prototype,"onDidInitializePromise",null);class p{get connections(){const G=[];return this.f.forEach(X=>G.push(X)),G}constructor(G,X,ee){this.a=new Map,this.f=new Set,this.g=new $.$ne,this.onDidAddConnection=this.g.event,this.h=new $.$ne,this.onDidRemoveConnection=this.h.event,this.j=new a.$Wc,this.j.add(G(({protocol:de,onDidClientDisconnect:ne})=>{const De=$.Event.once(de.onMessage);this.j.add(De($e=>{const J=new t($e),U=D(J),se=new y(de,U,X,ee),ae=new A(de,X);this.a.forEach((le,ue)=>se.registerChannel(ue,le));const te={channelServer:se,channelClient:ae,ctx:U};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),ae.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,X){const ee=this;return{call(de,ne,De){let $e;if((0,l.$ug)(X)){const U=(0,s.$6b)(ee.connections.filter(X));$e=U?Promise.resolve(U):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,X))}else $e=X.routeCall(ee,de,ne);const J=$e.then(U=>U.channelClient.getChannel(G));return F(J).call(de,ne,De)},listen(de,ne){if((0,l.$ug)(X))return ee.k(G,X,de,ne);const De=X.routeEvent(ee,de,ne).then($e=>$e.channelClient.getChannel(G));return F(De).listen(de,ne)}}}k(G,X,ee,de){const ne=this;let De;const $e=new $.$ne({onWillAddFirstListener:()=>{De=new a.$Wc;const J=new $.$te,U=new Map,se=te=>{const ue=te.channelClient.getChannel(G).listen(ee,de),Z=J.add(ue);U.set(te,Z)},ae=te=>{const le=U.get(te);le&&(le.dispose(),U.delete(te))};ne.connections.filter(X).forEach(se),$.Event.filter(ne.onDidAddConnection,X)(se,void 0,De),ne.onDidRemoveConnection(ae,void 0,De),J.event($e.fire,$e,De),De.add(J)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,X){this.a.set(G,X);for(const ee of this.f)ee.channelServer.registerChannel(G,X)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=p;class v{constructor(G,X,ee=null){const de=new i;S(de,X),G.send(de.buffer),this.a=new A(G,ee),this.d=new y(G,X,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,X){this.d.registerChannel(G,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=v;function F(B){return{call(G,X,ee){return B.then(de=>de.call(G,X,ee))},listen(G,X){const ee=new $.$we;return B.then(de=>ee.input=de.listen(G,X)),ee.event}}}function N(B){let G=!1;return{call(X,ee,de){return G?B.call(X,ee,de):(0,h.$Hh)(0).then(()=>G=!0).then(()=>B.call(X,ee,de))},listen(X,ee){if(G)return B.listen(X,ee);const de=new $.$we;return(0,h.$Hh)(0).then(()=>G=!0).then(()=>de.input=B.listen(X,ee)),de.event}}}class O{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const X of G.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$oi=O;var j;(function(B){function G(ne,De,$e){const J=ne,U=$e&&$e.disableMarshalling,se=new Map;for(const ae in J)ee(ae)&&se.set(ae,$.Event.buffer(J[ae],!0,void 0,De));return new class{listen(ae,te,le){const ue=se.get(te);if(ue)return ue;const Z=J[te];if(typeof Z=="function"){if(de(te))return Z.call(J,le);if(ee(te))return se.set(te,$.Event.buffer(J[te],!0,void 0,De)),se.get(te)}throw new R.$eb(`Event not found: ${te}`)}call(ae,te,le){const ue=J[te];if(typeof ue=="function"){if(!U&&Array.isArray(le))for(let oe=0;oe<le.length;oe++)le[oe]=(0,k.$di)(le[oe]);let Z=ue.apply(J,le);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new R.$eb(`Method not found: ${te}`)}}}B.fromService=G;function X(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(J,U){if(typeof U=="string")return De?.properties?.has(U)?De.properties.get(U):de(U)?function(se){return ne.listen(U,se)}:ee(U)?ne.listen(U):async function(...se){let ae;De&&!(0,l.$pg)(De.context)?ae=[De.context,...se]:ae=se;const te=await ne.call(U,ae);return $e?te:(0,k.$di)(te)};throw new R.$eb(`Property not found: ${String(U)}`)}})}B.toService=X;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Gf(ne.charCodeAt(2))}function de(ne){return/^onDynamic/.test(ne)&&E.$Gf(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const G=B.toString();if(G!=="[object Object]")return G}return B}function V(B){return Array.isArray(B)?B.map(M):M(B)}function K(B,G,X,ee,de,ne,De){De=V(De);const $e=z[de],J=$e[ee%$e.length];let U=[`%c[${B}]%c[${String(G).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(ne)?(U=U.concat(De),U.push(")")):U.push(De),console.log.apply(console,U)}class re{constructor(G,X){this.d=G,this.f=X,this.a=0,this.b=0}logOutgoing(G,X,ee,de,ne){this.b+=G,K(this.d,this.b,G,X,ee,de,ne)}logIncoming(G,X,ee,de,ne){this.a+=G,K(this.f,this.a,G,X,ee,de,ne)}}e.$pi=re}),define(Ee[69],Se([1,0,22,4,3,87]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(u){u.enableDiagnostics=!1,u.records=[];const w=new WeakMap;let S=0;function D(C,A){if(!w.has(C)){const p=String(++S);w.set(C,p)}return w.get(C)}function y(C,A,p,v){if(!u.enableDiagnostics)return;const F=D(C,A);if(v instanceof s.$Pe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=s.$Pe.alloc(v.byteLength);N.set(v),u.records.push({timestamp:Date.now(),id:F,label:A,type:p,buff:N})}else u.records.push({timestamp:Date.now(),id:F,label:A,type:p,data:v})}u.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let a=null;function k(){return a||(a=s.$Pe.alloc(0)),a}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,S){if(w===0)return k();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const A=this.a[0];return S&&(this.a.shift(),this.b-=w),A}if(this.a[0].byteLength>w){const A=this.a[0].slice(0,w);return S&&(this.a[0]=this.a[0].slice(w),this.b-=w),A}const D=s.$Pe.alloc(w);let y=0,C=0;for(;w>0;){const A=this.a[C];if(A.byteLength>w){const p=A.slice(0,w);D.set(p,y),y+=w,S&&(this.a[C]=A.slice(w),this.b-=w),w-=w}else D.set(A,y),y+=A.byteLength,S?(this.a.shift(),this.b-=A.byteLength):C++,w-=A.byteLength}return D}}e.$qi=E;var l;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(l||(l={}));function P(u){switch(u){case l.None:return"None";case l.Regular:return"Regular";case l.Control:return"Control";case l.Ack:return"Ack";case l.Disconnect:return"Disconnect";case l.ReplayRequest:return"ReplayRequest";case l.Pause:return"PauseWriting";case l.Resume:return"ResumeWriting";case l.KeepAlive:return"KeepAlive"}}var b;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class c{constructor(w,S,D,y){this.type=w,this.id=S,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends I.$Xc{constructor(w){super(),this.f=this.B(new h.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:b.HeaderLength,messageType:l.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(S=>this.acceptChunk(S))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const S=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=S.readUInt32BE(9),this.g.messageType=S.readUInt8(0),this.g.id=S.readUInt32BE(1),this.g.ack=S.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=b.HeaderLength,this.g.messageType=l.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,S),this.f.fire(new c(D,y,C,S)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const S=s.$Pe.alloc(b.HeaderLength);S.writeUInt8(w.type,0),S.writeUInt32BE(w.id,1),S.writeUInt32BE(w.ack,5),S.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,w.data),this.j(S,w.data)}g(w,S){const D=this.f===0;return this.d.push(w,S),this.f+=w.byteLength+S.byteLength,D}h(){const w=s.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,S){this.g(w,S)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class g extends I.$Xc{constructor(w){super(),this.f=new h.$ne,this.onMessage=this.f.event,this.g=new h.$ne,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new d(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(S=>{S.type===l.Regular&&this.f.fire(S.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new c(l.Regular,0,0,w))}}e.$ri=g;class n extends T.$li{static fromSocket(w,S){return new n(new g(w),S)}get onDidDispose(){return this.b.onDidDispose}constructor(w,S,D=null){super(w,S,D),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$si=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$ti=o;class t{constructor(w){this.data=w,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let w=0,S=this.a;for(;S;)S=S.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let S=0,D=this.a;for(;D;)w[S++]=D.data,D=D.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const S=new t(w);if(!this.a){this.a=S,this.b=S;return}this.b.next=S,this.b=S}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const w=Date.now();for(let S=0;S<r.a;S++)this.c[S]=w-1e3*S;setInterval(()=>{for(let S=r.a;S>=1;S--)this.c[S]=this.c[S-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),S=(1+r.a)*1e3;let D=0;for(let y=0;y<r.a;y++)w-this.c[y]<=S&&D++;return 1-D/r.a}hasHighLoad(){return this.d()>=.5}}class f{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??r.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new I.$Wc,this.o=w.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},b.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new c(l.Disconnect,0,0,k());this.p.write(w),this.p.flush()}sendPause(){const w=new c(l.Pause,0,0,k());this.p.write(w)}sendResume(){const w=new c(l.Resume,0,0,k());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,S){this.a=!0,this.r.dispose(),this.r=new I.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(S)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new c(l.Ack,0,this.h,k());this.p.write(w);const S=this.b.toArray();for(let D=0,y=S.length;D<y;D++)this.p.write(S[D]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const S=this.b.peek();if(S&&S.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case l.None:break;case l.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const S=Date.now();S-this.m>1e4&&(this.m=S,this.p.write(new c(l.ReplayRequest,0,0,k())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case l.Control:{this.u.fire(w.data);break}case l.Ack:break;case l.Disconnect:{this.w.fire();break}case l.ReplayRequest:{const S=this.b.toArray();for(let D=0,y=S.length;D<y;D++)this.p.write(S[D]);this.B();break}case l.Pause:{this.p.pause();break}case l.Resume:{this.p.resume();break}case l.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const S=++this.c;this.h=this.g;const D=new c(l.Regular,S,this.h,w);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(w){const S=new c(l.Control,0,0,w);this.p.write(S)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=b.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},b.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),S=Date.now()-w.writtenTime,D=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(S>=b.TimeoutTime&&D>=b.TimeoutTime&&y>=b.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:S,timeSinceLastReceivedSomeData:D});return}const C=Math.max(b.TimeoutTime-S,b.TimeoutTime-D,b.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new c(l.Ack,0,this.h,k());this.p.write(w)}D(){this.h=this.g;const w=new c(l.KeepAlive,0,this.h,k());this.p.write(w)}}e.$ui=f}),define(Ee[209],Se([1,0,58,9,22,21,207,14,4,3,25,112,109,87]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,R=We(R);class b extends P.$ii{constructor(d){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",g=>I.$Pe.wrap(Buffer.from(g,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$fr=b;class c{constructor(d,g){this.i=d,this.j=g,this.c=new Set,this.g=new Map,this.h=new $.$ne,this.onDidProcessExit=this.h.event;const n=g&&g.timeout?g.timeout:6e4;this.b=new h.$Dh(n),this.d=null,this.f=null}getChannel(d){const g=this;return{call(n,o,t){return g.k(d,n,o,t)},listen(n,o){return g.l(d,n,o)}}}k(d,g,n,o=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.$9());this.b.cancel();const t=this.n(d),i=(0,h.$th)(u=>t.call(g,n,u)),r=o.onCancellationRequested(()=>i.cancel()),f=(0,a.$Vc)(()=>i.cancel());return this.c.add(f),i.finally(()=>{r.dispose(),this.c.delete(f),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,g,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const t=new $.$ne({onWillAddFirstListener:()=>{o=this.n(d).listen(g,n)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,k.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(S=>!/^--inspect(-brk)?=/.test(S)).filter(S=>!S.startsWith("--vscode-"))),(0,l.$mm)(g.env),this.d=(0,s.fork)(this.i,d,g);const n=new $.$ne,t=$.Event.fromNodeEventEmitter(this.d,"message",S=>S)(S=>{if((0,L.$br)(S)){(0,L.log)(S,`IPC Library: ${this.j.serverName}`);return}n.fire(I.$Pe.wrap(Buffer.from(S,"base64")))}),i=this.j.useQueue?(0,E.$zm)(this.d):this.d,r=S=>this.d&&this.d.connected&&i.send(S.buffer.toString("base64")),f=n.event,u={send:r,onMessage:f};this.f=new P.$ji(u);const w=()=>this.o();process.once("exit",w),this.d.on("error",S=>console.warn('IPC "'+this.j.serverName+'" errored with '+S)),this.d.on("exit",(S,D)=>{process.removeListener("exit",w),t.dispose(),this.c.forEach(y=>(0,a.$Sc)(y)),this.c.clear(),S!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+S+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:S,signal:D})})}return this.f}n(d){let g=this.g.get(d);return g||(g=this.m.getChannel(d),this.g.set(d,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=c}),define(Ee[210],Se([1,0,9,4,3,57,18]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=$;var R;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function $(l){const P=l;return P?.changed instanceof Map||P?.deleted instanceof Set}var a;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(a||(e.StorageState=a={}));class k extends I.$Xc{static{this.a=100}constructor(P,b=Object.create(null)){super(),this.r=P,this.s=b,this.b=this.B(new h.$qe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new s.$Eh(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((b,c)=>this.w(c,b)),P.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(P,b){if(this.c===a.Closed)return;let c=!1;(0,L.$pg)(b)?c=this.f.delete(P):this.f.get(P)!==b&&(this.f.set(P,b),c=!0),c&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,b){const c=this.f.get(P);return(0,L.$pg)(c)?b:c}getBoolean(P,b){const c=this.get(P);return(0,L.$pg)(c)?b:c==="true"}getNumber(P,b){const c=this.get(P);return(0,L.$pg)(c)?b:parseInt(c,10)}getObject(P,b){const c=this.get(P);return(0,L.$pg)(c)?b:(0,T.$ci)(c)}async set(P,b,c=!1){if(this.c===a.Closed)return;if((0,L.$pg)(b))return this.delete(P,c);const m=(0,L.$ig)(b)||Array.isArray(b)?(0,T.$bi)(b):String(b);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:c}),this.D()}async delete(P,b=!1){if(!(this.c===a.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:b}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===a.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$cq=k;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((b,c)=>this.a.set(c,b)),P.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$dq=E}),define(Ee[211],Se([1,0,13,11,22]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$_t=k,e.$au=E,s=We(s),h=We(h),I=We(I);let T;function L(){return T||(T=new TextDecoder("UTF-16LE")),T}let R;function $(){return R||(R=new TextDecoder("UTF-16BE")),R}let a;function k(){return a||(a=h.$D()?L():$()),a}function E(b,c,m){const d=new Uint16Array(b.buffer,c,m);return m>0&&(d[0]===65279||d[0]===65534)?l(b,c,m):L().decode(d)}function l(b,c,m){const d=[];let g=0;for(let n=0;n<m;n++){const o=I.$Re(b,c);c+=2,d[g++]=String.fromCharCode(o)}return d.join("")}class P{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return k().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||s.$Lf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let d=0;d<m;d++)this.b[this.d++]=c.charCodeAt(d)}}e.$bu=P}),define(Ee[212],Se([1,0,22,211]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$du=L,s=We(s);function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,k,E,l){this.oldPosition=a,this.oldText=k,this.newPosition=E,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,k,E){const l=k.length;s.$Ue(a,l,E),E+=4;for(let P=0;P<l;P++)s.$Se(a,k.charCodeAt(P),E),E+=2;return E}static d(a,k){const E=s.$Te(a,k);return k+=4,(0,h.$au)(a,k,E)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(a,k){return s.$Ue(a,this.oldPosition,k),k+=4,s.$Ue(a,this.newPosition,k),k+=4,k=T.c(a,this.oldText,k),k=T.c(a,this.newText,k),k}static read(a,k,E){const l=s.$Te(a,k);k+=4;const P=s.$Te(a,k);k+=4;const b=T.d(a,k);k+=T.a(b);const c=T.d(a,k);return k+=T.a(c),E.push(new T(l,b,P,c)),k}}e.$cu=T;function L($,a){return $===null||$.length===0?a:new R($,a).compress()}class R{constructor(a,k){this.a=a,this.c=k,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,k=0,E=this.n(a),l=this.l(k);for(;a<this.f||k<this.h;){if(E===null){this.k(l),l=this.l(++k);continue}if(l===null){this.m(E),E=this.n(++a);continue}if(l.oldEnd<=E.newPosition){this.k(l),l=this.l(++k);continue}if(E.newEnd<=l.oldPosition){this.m(E),E=this.n(++a);continue}if(l.oldPosition<E.newPosition){const[d,g]=R.r(l,E.newPosition-l.oldPosition);this.k(d),l=g;continue}if(E.newPosition<l.oldPosition){const[d,g]=R.q(E,l.oldPosition-E.newPosition);this.m(d),E=g;continue}let c,m;if(l.oldEnd===E.newEnd)c=E,m=l,E=this.n(++a),l=this.l(++k);else if(l.oldEnd<E.newEnd){const[d,g]=R.q(E,l.oldLength);c=d,m=l,E=g,l=this.l(++k)}else{const[d,g]=R.r(l,E.newLength);c=E,m=d,E=this.n(++a),l=g}this.d[this.e++]=new T(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const P=R.s(this.d);return R.t(P)}k(a){this.d[this.e++]=R.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=R.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,k){return new T(k.oldPosition-a,k.oldText,k.newPosition,k.newText)}static p(a,k){return new T(k.oldPosition,k.oldText,k.newPosition+a,k.newText)}static q(a,k){const E=a.newText.substr(0,k),l=a.newText.substr(k);return[new T(a.oldPosition,a.oldText,a.newPosition,E),new T(a.oldEnd,"",a.newPosition+k,l)]}static r(a,k){const E=a.oldText.substr(0,k),l=a.oldText.substr(k);return[new T(a.oldPosition,E,a.newPosition,a.newText),new T(a.oldPosition+k,l,a.newEnd,"")]}static s(a){if(a.length===0)return a;const k=[];let E=0,l=a[0];for(let P=1;P<a.length;P++){const b=a[P];l.oldEnd===b.oldPosition?l=new T(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(k[E++]=l,l=b)}return k[E++]=l,k}static t(a){if(a.length===0)return a;const k=[];let E=0;for(let l=0;l<a.length;l++){const P=a[l];P.oldText!==P.newText&&(k[E++]=P)}return k}}}),define(Ee[213],Se([1,0,39,17]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=I,e.$uu=T;function I(L,R,$,a,k,E){if(Array.isArray(L)){let l=0;for(const P of L){const b=I(P,R,$,a,k,E);if(b===10)return b;b>l&&(l=b)}return l}else{if(typeof L=="string")return a?L==="*"?5:L===$?10:0:0;if(L){const{language:l,pattern:P,scheme:b,hasAccessToAllModels:c,notebookType:m}=L;if(!a&&!c)return 0;m&&k&&(R=k);let d=0;if(b)if(b===R.scheme)d=10;else if(b==="*")d=5;else return 0;if(l)if(l===$)d=10;else if(l==="*")d=Math.max(d,5);else return 0;if(m)if(m===E)d=10;else if(m==="*"&&E!==void 0)d=Math.max(d,5);else return 0;if(P){let g;if(typeof P=="string"?g=P:g={...P,base:(0,h.$kc)(P.base)},g===R.fsPath||(0,s.$zk)(g,R.fsPath))d=10;else return 0}return d}else return 0}}function T(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(T):!!L.notebookType}}),define(Ee[214],Se([1,0,4,13,31,55,139,189,212,3]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,h=We(h);class k extends a.$Xc{constructor(l,P,b,c,m,d,g){super(),this.m=this.B(new s.$ne),this.onDidChangeContent=this.m.event,this.f=P,this.j=!d,this.g=c,this.h=m,this.c=new L.$kD(l,b,g)}equals(l){return!(l instanceof k)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,P){return this.c.getOffsetAt(l,P)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,P){const b=l+P,c=this.getPositionAt(l),m=this.getPositionAt(b);return new I.$Mt(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(l,P=T.EndOfLinePreference.TextDefined){if(l.isEmpty())return"";const b=this.n(P);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,P=T.EndOfLinePreference.TextDefined){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),c=this.getOffsetAt(l.endLineNumber,l.endColumn);let m=0;const d=this.n(P),g=this.getEOL();if(d.length!==g.length){const n=d.length-g.length,o=l.endLineNumber-l.startLineNumber;m=n*o}return c-b+m}getCharacterCountInRange(l,P=T.EndOfLinePreference.TextDefined){if(this.j){let b=0;const c=l.startLineNumber,m=l.endLineNumber;for(let d=c;d<=m;d++){const g=this.getLineContent(d),n=d===c?l.startColumn-1:0,o=d===m?l.endColumn-1:g.length;for(let t=n;t<o;t++)h.$Lf(g.charCodeAt(t))?(b=b+1,t=t+1):b=b+1}return b+=this.n(P).length*(m-c),b}return this.getValueLengthInRange(l,P)}getNearestChunk(l){return this.c.getNearestChunk(l)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,P){return this.c.getLineCharCode(l,P)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const P=h.$wf(this.getLineContent(l));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(l){const P=h.$yf(this.getLineContent(l));return P===-1?0:P+2}n(l){switch(l){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,P,b){let c=this.g,m=this.h,d=this.j,g=!0,n=[];for(let w=0;w<l.length;w++){const S=l[w];g&&S._isTracked&&(g=!1);const D=S.range;if(S.text){let v=!0;d||(v=!h.$Wf(S.text),d=v),!c&&v&&(c=h.$Vf(S.text)),!m&&v&&(m=h.$Yf(S.text))}let y="",C=0,A=0,p=0;if(S.text){let v;[C,A,p,v]=(0,R.$wu)(S.text);const F=this.getEOL(),N=F===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;v===R.StringEOL.Unknown||v===N?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,F)}n[w]={sortIndex:w,identifier:S.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:C,firstLineLength:A,lastLineLength:p,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}n.sort(k.u);let o=!1;for(let w=0,S=n.length-1;w<S;w++){const D=n[w].range.getEndPosition(),y=n[w+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}g&&(n=this.s(n));const t=b||P?k._getInverseEditRanges(n):[],i=[];if(P)for(let w=0;w<n.length;w++){const S=n[w],D=t[w];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let C="";y===D.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),h.$wf(C)!==-1)||i.push({lineNumber:y,oldContent:C})}}let r=null;if(b){let w=0;r=[];for(let S=0;S<n.length;S++){const D=n[S],y=t[S],C=this.getValueInRange(D.range),A=D.rangeOffset+w;w+=D.text.length-C.length,r[S]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:C,textChange:new $.$cu(D.rangeOffset,C,A,D.text)}}o||r.sort((S,D)=>S.sortIndex-D.sortIndex)}this.g=c,this.h=m,this.j=d;const f=this.t(n);let u=null;if(P&&i.length>0){i.sort((w,S)=>S.lineNumber-w.lineNumber),u=[];for(let w=0,S=i.length;w<S;w++){const D=i[w].lineNumber;if(w>0&&i[w-1].lineNumber===D)continue;const y=i[w].oldContent,C=this.getLineContent(D);C.length===0||C===y||h.$wf(C)!==-1||u.push(D)}}return this.m.fire(),new T.$fw(r,f,u)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let P=!1;const b=l[0].range,c=l[l.length-1].range,m=new I.$Mt(b.startLineNumber,b.startColumn,c.endLineNumber,c.endColumn);let d=b.startLineNumber,g=b.startColumn;const n=[];for(let f=0,u=l.length;f<u;f++){const w=l[f],S=w.range;P=P||w.forceMoveMarkers,n.push(this.getValueInRange(new I.$Mt(d,g,S.startLineNumber,S.startColumn))),w.text.length>0&&n.push(w.text),d=S.endLineNumber,g=S.endColumn}const o=n.join(""),[t,i,r]=(0,R.$wu)(o);return{sortIndex:0,identifier:l[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,T.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:i,lastLineLength:r,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(l){l.sort(k.w);const P=[];for(let b=0;b<l.length;b++){const c=l[b],m=c.range.startLineNumber,d=c.range.startColumn,g=c.range.endLineNumber,n=c.range.endColumn;if(m===g&&d===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const o=new I.$Mt(m,d,g,n);P.push({range:o,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return P}findMatchesLineByLine(l,P,b,c){return this.c.findMatchesLineByLine(l,P,b,c)}getPieceTree(){return this.c}static _getInverseEditRange(l,P){const b=l.startLineNumber,c=l.startColumn,[m,d,g]=(0,R.$wu)(P);let n;if(P.length>0){const o=m+1;o===1?n=new I.$Mt(b,c,b,c+d):n=new I.$Mt(b,c,b+o-1,g+1)}else n=new I.$Mt(b,c,b,c);return n}static _getInverseEditRanges(l){const P=[];let b=0,c=0,m=null;for(let d=0,g=l.length;d<g;d++){const n=l[d];let o,t;m?m.range.endLineNumber===n.range.startLineNumber?(o=b,t=c+(n.range.startColumn-m.range.endColumn)):(o=b+(n.range.startLineNumber-m.range.endLineNumber),t=n.range.startColumn):(o=n.range.startLineNumber,t=n.range.startColumn);let i;if(n.text.length>0){const r=n.eolCount+1;r===1?i=new I.$Mt(o,t,o,t+n.firstLineLength):i=new I.$Mt(o,t,o+r-1,n.lastLineLength+1)}else i=new I.$Mt(o,t,o,t);b=i.endLineNumber,c=i.endColumn,P.push(i),m=n}return P}static u(l,P){const b=I.$Mt.compareRangesUsingEnds(l.range,P.range);return b===0?l.sortIndex-P.sortIndex:b}static w(l,P){const b=I.$Mt.compareRangesUsingEnds(l.range,P.range);return b===0?P.sortIndex-l.sortIndex:-b}}e.$lD=k}),define(Ee[215],Se([1,0,27,13,55,139,214]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,h=We(h);class R{constructor(k,E,l,P,b,c,m,d,g){this.a=k,this.b=E,this.c=l,this.d=P,this.e=b,this.f=c,this.g=m,this.h=d,this.j=g}k(k){const E=this.c+this.d+this.e,l=this.c+this.e;return E===0?k===I.DefaultEndOfLine.LF?`
`:`\r
`:l>E/2?`\r
`:`
`}create(k){const E=this.k(k),l=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let b=0,c=l.length;b<c;b++){const m=l[b].buffer.replace(/\r\n|\r|\n/g,E),d=(0,T.$gD)(m);l[b]=new T.$jD(m,d)}const P=new L.$lD(l,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(k){return this.a[0].buffer.substr(0,k).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(k){if(k.length===0)return;this.a.length===0&&h.$7f(k)&&(this.b=h.$6f,k=k.substr(1));const E=k.charCodeAt(k.length-1);E===s.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(k.substr(0,k.length-1),!1),this.c=!0,this.d=E):(this.m(k,!1),this.c=!1,this.d=E)}m(k,E){!E&&k.length===0||(this.c?this.n(String.fromCharCode(this.d)+k):this.n(k))}n(k){const E=(0,T.$hD)(this.e,k);this.a.push(new T.$jD(k,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Vf(k)),this.k||(this.k=h.$Yf(k)))}finish(k=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,k)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const k=this.a[this.a.length-1];k.buffer+=String.fromCharCode(this.d);const E=(0,T.$gD)(k.buffer);k.lineStarts=E,this.d===s.CharCode.CarriageReturn&&this.f++}}}e.$mD=$}),define(Ee[143],Se([1,0,22,11]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdb=$,e.$Hdb=k,h=We(h);var I;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(I||(I={}));function T(E){for(let l=0,P=E.length;l<P;l+=4){const b=E[l+0],c=E[l+1],m=E[l+2],d=E[l+3];E[l+0]=d,E[l+1]=m,E[l+2]=c,E[l+3]=b}}function L(E){const l=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||T(l),s.$Pe.wrap(l)}function R(E){const l=E.buffer;if(h.$D()||T(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const P=new Uint8Array(l.byteLength);return P.set(l),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function $(E){const l=new Uint32Array(a(E));let P=0;if(l[P++]=E.id,E.type==="full")l[P++]=I.Full,l[P++]=E.data.length,l.set(E.data,P),P+=E.data.length;else{l[P++]=I.Delta,l[P++]=E.deltas.length;for(const b of E.deltas)l[P++]=b.start,l[P++]=b.deleteCount,b.data?(l[P++]=b.data.length,l.set(b.data,P),P+=b.data.length):l[P++]=0}return L(l)}function a(E){let l=0;if(l+=2,E.type==="full")l+=1+E.data.length;else{l+=1,l+=3*E.deltas.length;for(const P of E.deltas)P.data&&(l+=P.data.length)}return l}function k(E){const l=R(E);let P=0;const b=l[P++];if(l[P++]===I.Full){const g=l[P++],n=l.subarray(P,P+g);return P+=g,{id:b,type:"full",data:n}}const m=l[P++],d=[];for(let g=0;g<m;g++){const n=l[P++],o=l[P++],t=l[P++];let i;t>0&&(i=l.subarray(P,P+t),P+=t),d[g]={start:n,deleteCount:o,data:i}}return{id:b,type:"delta",deltas:d}}}),define(Ee[216],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(Ee[217],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[88],Se([1,0,83,2,190,31,200,217]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ou=e.$Nu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Mu=e.$Lu=e.SymbolKinds=e.SymbolTag=e.$Ju=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Hu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Gu=e.$Fu=e.$Eu=void 0,e.$Iu=f,e.$Ku=w;class ${constructor(G,X,ee){this.offset=G,this.type=X,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Eu=$;class a{constructor(G,X){this.tokens=G,this.endState=X,this._tokenizationResultBrand=void 0}}e.$Fu=a;class k{constructor(G,X){this.tokens=G,this.endState=X,this._encodedTokenizationResultBrand=void 0}}e.$Gu=k;var E;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var l;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(l||(e.CompletionItemKind=l={}));var P;(function(B){const G=new Map;G.set(l.Method,s.$6j.symbolMethod),G.set(l.Function,s.$6j.symbolFunction),G.set(l.Constructor,s.$6j.symbolConstructor),G.set(l.Field,s.$6j.symbolField),G.set(l.Variable,s.$6j.symbolVariable),G.set(l.Class,s.$6j.symbolClass),G.set(l.Struct,s.$6j.symbolStruct),G.set(l.Interface,s.$6j.symbolInterface),G.set(l.Module,s.$6j.symbolModule),G.set(l.Property,s.$6j.symbolProperty),G.set(l.Event,s.$6j.symbolEvent),G.set(l.Operator,s.$6j.symbolOperator),G.set(l.Unit,s.$6j.symbolUnit),G.set(l.Value,s.$6j.symbolValue),G.set(l.Enum,s.$6j.symbolEnum),G.set(l.Constant,s.$6j.symbolConstant),G.set(l.Enum,s.$6j.symbolEnum),G.set(l.EnumMember,s.$6j.symbolEnumMember),G.set(l.Keyword,s.$6j.symbolKeyword),G.set(l.Snippet,s.$6j.symbolSnippet),G.set(l.Text,s.$6j.symbolText),G.set(l.Color,s.$6j.symbolColor),G.set(l.File,s.$6j.symbolFile),G.set(l.Reference,s.$6j.symbolReference),G.set(l.Customcolor,s.$6j.symbolCustomColor),G.set(l.Folder,s.$6j.symbolFolder),G.set(l.TypeParameter,s.$6j.symbolTypeParameter),G.set(l.User,s.$6j.account),G.set(l.Issue,s.$6j.issues);function X(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=s.$6j.symbolProperty),De}B.toIcon=X;const ee=new Map;ee.set("method",l.Method),ee.set("function",l.Function),ee.set("constructor",l.Constructor),ee.set("field",l.Field),ee.set("variable",l.Variable),ee.set("class",l.Class),ee.set("struct",l.Struct),ee.set("interface",l.Interface),ee.set("module",l.Module),ee.set("property",l.Property),ee.set("event",l.Event),ee.set("operator",l.Operator),ee.set("unit",l.Unit),ee.set("value",l.Value),ee.set("constant",l.Constant),ee.set("enum",l.Enum),ee.set("enum-member",l.EnumMember),ee.set("enumMember",l.EnumMember),ee.set("keyword",l.Keyword),ee.set("snippet",l.Snippet),ee.set("text",l.Text),ee.set("color",l.Color),ee.set("file",l.File),ee.set("reference",l.Reference),ee.set("customcolor",l.Customcolor),ee.set("folder",l.Folder),ee.set("type-parameter",l.TypeParameter),ee.set("typeParameter",l.TypeParameter),ee.set("account",l.User),ee.set("issue",l.Issue);function de(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=l.Property),$e}B.fromString=de})(P||(e.CompletionItemKinds=P={}));var b;(function(B){B[B.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var c;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var d;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var g;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class n{constructor(G,X,ee,de){this.range=G,this.text=X,this.completionKind=ee,this.isSnippetText=de}equals(G){return T.$Mt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Hu=n;var o;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var i;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var r;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function f(B){return B&&h.URI.isUri(B.uri)&&T.$Mt.isIRange(B.range)&&(T.$Mt.isIRange(B.originSelectionRange)||T.$Mt.isIRange(B.targetSelectionRange))}var u;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(u||(e.SymbolKind=u={})),e.$Ju={[u.Array]:(0,R.localize)(0,null),[u.Boolean]:(0,R.localize)(1,null),[u.Class]:(0,R.localize)(2,null),[u.Constant]:(0,R.localize)(3,null),[u.Constructor]:(0,R.localize)(4,null),[u.Enum]:(0,R.localize)(5,null),[u.EnumMember]:(0,R.localize)(6,null),[u.Event]:(0,R.localize)(7,null),[u.Field]:(0,R.localize)(8,null),[u.File]:(0,R.localize)(9,null),[u.Function]:(0,R.localize)(10,null),[u.Interface]:(0,R.localize)(11,null),[u.Key]:(0,R.localize)(12,null),[u.Method]:(0,R.localize)(13,null),[u.Module]:(0,R.localize)(14,null),[u.Namespace]:(0,R.localize)(15,null),[u.Null]:(0,R.localize)(16,null),[u.Number]:(0,R.localize)(17,null),[u.Object]:(0,R.localize)(18,null),[u.Operator]:(0,R.localize)(19,null),[u.Package]:(0,R.localize)(20,null),[u.Property]:(0,R.localize)(21,null),[u.String]:(0,R.localize)(22,null),[u.Struct]:(0,R.localize)(23,null),[u.TypeParameter]:(0,R.localize)(24,null),[u.Variable]:(0,R.localize)(25,null)};function w(B,G){return(0,R.localize)(26,null,B,e.$Ju[G])}var S;(function(B){B[B.Deprecated=1]="Deprecated"})(S||(e.SymbolTag=S={}));var D;(function(B){const G=new Map;G.set(u.File,s.$6j.symbolFile),G.set(u.Module,s.$6j.symbolModule),G.set(u.Namespace,s.$6j.symbolNamespace),G.set(u.Package,s.$6j.symbolPackage),G.set(u.Class,s.$6j.symbolClass),G.set(u.Method,s.$6j.symbolMethod),G.set(u.Property,s.$6j.symbolProperty),G.set(u.Field,s.$6j.symbolField),G.set(u.Constructor,s.$6j.symbolConstructor),G.set(u.Enum,s.$6j.symbolEnum),G.set(u.Interface,s.$6j.symbolInterface),G.set(u.Function,s.$6j.symbolFunction),G.set(u.Variable,s.$6j.symbolVariable),G.set(u.Constant,s.$6j.symbolConstant),G.set(u.String,s.$6j.symbolString),G.set(u.Number,s.$6j.symbolNumber),G.set(u.Boolean,s.$6j.symbolBoolean),G.set(u.Array,s.$6j.symbolArray),G.set(u.Object,s.$6j.symbolObject),G.set(u.Key,s.$6j.symbolKey),G.set(u.Null,s.$6j.symbolNull),G.set(u.EnumMember,s.$6j.symbolEnumMember),G.set(u.Struct,s.$6j.symbolStruct),G.set(u.Event,s.$6j.symbolEvent),G.set(u.Operator,s.$6j.symbolOperator),G.set(u.TypeParameter,s.$6j.symbolTypeParameter);function X(ee){let de=G.get(ee);return de||(console.info("No codicon found for SymbolKind "+ee),de=s.$6j.symbolProperty),de}B.toIcon=X})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(G){return I.$Nt.replace(T.$Mt.lift(G.range),G.text)}}e.$Lu=y;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(G){switch(G){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(G)}constructor(G){this.value=G}}e.$Mu=C;var A;(function(B){B[B.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var p;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(B){function G(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}B.is=G})(v||(e.Command=v={}));var F;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var j;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(z||(e.CommentState=z={}));var M;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class V{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nu=V,e.$Ou=new L.$vu;var K;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var re;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(Ee[218],Se([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[219],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[220],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[221],Se([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[222],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[223],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[224],Se([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[225],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[226],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[227],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[228],Se([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[229],Se([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[230],Se([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[231],Se([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[232],Se([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[233],Se([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[234],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[235],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[236],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[237],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[238],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[239],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[240],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[241],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[242],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[243],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[244],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[245],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[246],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[247],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(Ee[248],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[249],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(Ee[250],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[251],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[252],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[253],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[254],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[255],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[256],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[257],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[258],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[259],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[260],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[261],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[262],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[263],Se([1,0,27,14,220]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var T;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(T||(e.TokenType=T={}));function L(...k){switch(k.length){case 1:return(0,I.localize)(0,null,k[0]);case 2:return(0,I.localize)(1,null,k[0],k[1]);case 3:return(0,I.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,I.localize)(3,null),$=(0,I.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return E.isTripleEq?"===":"==";case T.NotEq:return E.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return E.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return E.lexeme;case T.QuotedStr:return E.lexeme;case T.Error:return E.lexeme;case T.EOF:return"EOF";default:throw(0,h.$$)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case s.CharCode.OpenParen:this.k(T.LParen);break;case s.CharCode.CloseParen:this.k(T.RParen);break;case s.CharCode.ExclamationMark:if(this.h(s.CharCode.Equals)){const l=this.h(s.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:l})}else this.k(T.Neg);break;case s.CharCode.SingleQuote:this.o();break;case s.CharCode.Slash:this.q();break;case s.CharCode.Equals:if(this.h(s.CharCode.Equals)){const l=this.h(s.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:l})}else this.h(s.CharCode.Tilde)?this.k(T.RegexOp):this.l(L("==","=~"));break;case s.CharCode.LessThan:this.k(this.h(s.CharCode.Equals)?T.LtEq:T.Lt);break;case s.CharCode.GreaterThan:this.k(this.h(s.CharCode.Equals)?T.GtEq:T.Gt);break;case s.CharCode.Ampersand:this.h(s.CharCode.Ampersand)?this.k(T.And):this.l(L("&&"));break;case s.CharCode.Pipe:this.h(s.CharCode.Pipe)?this.k(T.Or):this.l(L("||"));break;case s.CharCode.Space:case s.CharCode.CarriageReturn:case s.CharCode.Tab:case s.CharCode.LineFeed:case s.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?s.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const l=this.d,P=this.c.substring(this.d,this.e),b={type:T.Error,offset:this.d,lexeme:P};this.g.push({offset:l,lexeme:P,additionalInfo:E}),this.f.push(b)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const l=this.c.substring(this.d,this.e),P=a.b.get(l);P?this.k(P):this.f.push({type:T.Str,lexeme:l,offset:this.d})}}o(){for(;this.j()!==s.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,l=!1,P=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const c=this.c.charCodeAt(E);if(l)l=!1;else if(c===s.CharCode.Slash&&!P){E++;break}else c===s.CharCode.OpenSquareBracket?P=!0:c===s.CharCode.Backslash?l=!0:c===s.CharCode.CloseSquareBracket&&(P=!1);E++}for(;E<this.c.length&&a.a.has(this.c.charCodeAt(E));)E++;this.e=E;const b=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=a}),define(Ee[144],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const s={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(s)}),define(Ee[113],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class s{constructor(I,T=[],L=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.$Di=s}),define(Ee[89],Se([1,0,113]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=T,e.$Qs=L;const h=[];var I;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function T(R,$,a){$ instanceof s.$Di||($=new s.$Di($,[],!!a)),h.push([R,$])}function L(){return h}}),define(Ee[264],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class s{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$sr=s;class h{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const L of this.a.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const R=this.lookupOrInsertNode(T),$=this.lookupOrInsertNode(L);R.outgoing.set($.key,$),$.incoming.set(R.key,R)}removeNode(T){const L=this.b(T);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(T){const L=this.b(T);let R=this.a.get(L);return R||(R=new s(L,T),this.a.set(L,R)),R}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[L,R]of this.a)T.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this.a){const R=new Set([T]),$=this.c(L,R);if($)return $}}c(T,L){for(const[R,$]of T.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const a=this.c($,L);if(a)return a;L.delete(R)}}}e.$tr=h}),define(Ee[5],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=I,e.$Hi=T;var s;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(s||(e._util=s={})),e.$Fi=I("instantiationService");function h(L,R,$){R[s.DI_TARGET]===R?R[s.DI_DEPENDENCIES].push({id:L,index:$}):(R[s.DI_DEPENDENCIES]=[{id:L,index:$}],R[s.DI_TARGET]=R)}function I(L){if(s.serviceIds.has(L))return s.serviceIds.get(L);const R=function($,a,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(R,$,k)};return R.toString=()=>L,s.serviceIds.set(L,R),R}function T(L){return L}}),define(Ee[45],Se([1,0,18,2,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=T,e.$cj=L,e.$dj=$,e.$ej=a,e.$fj=k,e.$gj=E,e.$hj=l,e.$ij=b,e.$jj=c,e.$kj=m,s=We(s),e.$aj=(0,I.$Gi)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof h.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof h.URI)}var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function $(d){switch(d){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function k(d,g){const n=Object.create(null);for(const o in d)E(n,o,d[o],g);return n}function E(d,g,n,o){const t=g.split("."),i=t.pop();let r=d;for(let f=0;f<t.length;f++){const u=t[f];let w=r[u];switch(typeof w){case"undefined":w=r[u]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is null`);return}break;default:o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[i]=n}catch{o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(r)}`)}function l(d,g){const n=g.split(".");P(d,n)}function P(d,g){const n=g.shift();if(g.length===0){delete d[n];return}if(Object.keys(d).indexOf(n)!==-1){const o=d[n];typeof o=="object"&&!Array.isArray(o)&&(P(o,g),Object.keys(o).length===0&&delete d[n])}}function b(d,g,n){function o(r,f){let u=r;for(const w of f){if(typeof u!="object"||u===null)return;u=u[w]}return u}const t=g.split("."),i=o(d,t);return typeof i>"u"?n:i}function c(d,g,n){Object.keys(g).forEach(o=>{o!=="__proto__"&&(o in d?s.$ig(d[o])&&s.$ig(g[o])?c(d[o],g[o],n):n&&(d[o]=g[o]):d[o]=g[o])})}function m(d){return d.replace(/[\[\]]/g,"")}}),define(Ee[36],Se([1,0,27,11,13,263,5,219,14]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=k,e.$Fj=f,e.$Gj=u,e.$Zj=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",h.$j),a.set("isLinux",h.$k),a.set("isWindows",h.$i),a.set("isWeb",h.$o),a.set("isMacNative",h.$j&&!h.$o),a.set("isEdge",h.$H),a.set("isFirefox",h.$F),a.set("isChrome",h.$E),a.set("isSafari",h.$G);function k(J,U){if(a.get(J)!==void 0)throw(0,$.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(J,U)}const E=Object.prototype.hasOwnProperty;var l;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const P={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),c=(0,R.localize)(1,null),m=(0,R.localize)(2,null),d=(0,R.localize)(3,null),g=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),t=(0,R.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=P){this.k=U,this.d=new T.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ae=this.D(),te=ae.type===T.TokenType.Str?n:void 0;throw this.h.push({message:g,offset:ae.offset,lexeme:T.$Bj.getLexeme(ae),additionalInfo:te}),i.c}return se}catch(se){if(se!==i.c)throw se;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(T.TokenType.Or);){const se=this.o();U.push(se)}return U.length===1?U[0]:r.or(...U)}o(){const U=[this.s()];for(;this.y(T.TokenType.And);){const se=this.s();U.push(se)}return U.length===1?U[0]:r.and(...U)}s(){if(this.y(T.TokenType.Neg)){const U=this.D();switch(U.type){case T.TokenType.True:return this.z(),S.INSTANCE;case T.TokenType.False:return this.z(),D.INSTANCE;case T.TokenType.LParen:{this.z();const se=this.l();return this.A(T.TokenType.RParen,d),se?.negate()}case T.TokenType.Str:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case T.TokenType.True:return this.z(),r.true();case T.TokenType.False:return this.z(),r.false();case T.TokenType.LParen:{this.z();const se=this.l();return this.A(T.TokenType.RParen,d),se}case T.TokenType.Str:{const se=U.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==T.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,ue=le.lastIndexOf("/"),Z=ue===le.length-1?void 0:this.w(le.substring(ue+1));let oe;try{oe=new RegExp(le.substring(1,ue),Z)}catch{throw this.B("REGEX",te)}return V.create(se,oe)}switch(te.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const le=[te.lexeme];this.z();let ue=this.D(),Z=0;for(let Ue=0;Ue<te.lexeme.length;Ue++)te.lexeme.charCodeAt(Ue)===s.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(Ue)===s.CharCode.CloseParen&&Z--;for(;!this.E()&&ue.type!==T.TokenType.And&&ue.type!==T.TokenType.Or;){switch(ue.type){case T.TokenType.LParen:Z++;break;case T.TokenType.RParen:Z--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let Ue=0;Ue<ue.lexeme.length;Ue++)ue.lexeme.charCodeAt(Ue)===s.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(Ue)===s.CharCode.CloseParen&&Z--}if(Z<0)break;le.push(T.$Bj.getLexeme(ue)),this.z(),ue=this.D()}const oe=le.join(""),pe=oe.lastIndexOf("/"),we=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let Fe;try{Fe=new RegExp(oe.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return r.regex(se,Fe)}case T.TokenType.QuotedStr:{const le=te.lexeme;this.z();let ue=null;if(!(0,I.$ef)(le)){const Z=le.indexOf("/"),oe=le.lastIndexOf("/");if(Z!==oe&&Z>=0){const pe=le.slice(Z+1,oe),we=le[oe+1]==="i"?"i":"";try{ue=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(ue===null)throw this.B("REGEX",te);return V.create(se,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,m);const te=this.u();return r.notIn(se,te)}switch(this.D().type){case T.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===T.TokenType.QuotedStr)return r.equals(se,te);switch(te){case"true":return r.has(se);case"false":return r.not(se);default:return r.equals(se,te)}}case T.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===T.TokenType.QuotedStr)return r.notEquals(se,te);switch(te){case"true":return r.not(se);case"false":return r.has(se);default:return r.notEquals(se,te)}}case T.TokenType.Lt:return this.z(),z.create(se,this.u());case T.TokenType.LtEq:return this.z(),M.create(se,this.u());case T.TokenType.Gt:return this.z(),O.create(se,this.u());case T.TokenType.GtEq:return this.z(),j.create(se,this.u());case T.TokenType.In:return this.z(),r.in(se,this.u());default:return r.has(se)}}case T.TokenType.EOF:throw this.h.push({message:o,offset:U.offset,lexeme:"",additionalInfo:t}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),U.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,se){if(this.C(U))return this.z();throw this.B(se,this.D())}B(U,se,ae){const te=(0,R.localize)(8,null,U,T.$Bj.getLexeme(se)),le=se.offset,ue=T.$Bj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:ue,additionalInfo:ae}),i.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$Dj=i;class r{static false(){return S.INSTANCE}static true(){return D.INSTANCE}static has(U){return y.create(U)}static equals(U,se){return C.create(U,se)}static notEquals(U,se){return v.create(U,se)}static regex(U,se){return V.create(U,se)}static in(U,se){return A.create(U,se)}static notIn(U,se){return p.create(U,se)}static not(U){return F.create(U)}static and(...U){return B.create(U,null,!0)}static or(...U){return G.create(U,null,!0)}static greater(U,se){return O.create(U,se)}static greaterEquals(U,se){return j.create(U,se)}static smaller(U,se){return z.create(U,se)}static smallerEquals(U,se){return M.create(U,se)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ej=r;function f(J){const U=new i({regexParsingWithErrorRecovery:!1});return J.map(se=>(U.parse(se),U.lexingErrors.length>0?U.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,R.localize)(9,null,ae.additionalInfo):(0,R.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function u(J,U){const se=J?J.substituteConstants():void 0,ae=U?U.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function w(J,U){return J.cmp(U)}class S{static{this.INSTANCE=new S}constructor(){this.type=l.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return D.INSTANCE}}e.$Hj=S;class D{static{this.INSTANCE=new D}constructor(){this.type=l.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return S.INSTANCE}}e.$Ij=D;class y{static create(U,se=null){const ae=a.get(U);return typeof ae=="boolean"?ae?D.INSTANCE:S.INSTANCE:new y(U,se)}constructor(U,se){this.key=U,this.c=se,this.type=l.Defined}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=a.get(this.key);return typeof U=="boolean"?U?D.INSTANCE:S.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Jj=y;class C{static create(U,se,ae=null){if(typeof se=="boolean")return se?y.create(U,ae):F.create(U,ae);const te=a.get(U);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:S.INSTANCE:new C(U,se,ae)}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.Equals}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=a.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?D.INSTANCE:S.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Kj=C;class A{static create(U,se){return new A(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=l.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:de(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.f),ae=U.getValue(this.d);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?E.call(se,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Lj=A;class p{static create(U,se){return new p(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=l.NotIn,this.c=A.create(U,se)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=p;class v{static create(U,se,ae=null){if(typeof se=="boolean")return se?F.create(U,ae):y.create(U,ae);const te=a.get(U);return typeof te=="boolean"?se===(te?"true":"false")?S.INSTANCE:D.INSTANCE:new v(U,se,ae)}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=a.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?S.INSTANCE:D.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Nj=v;class F{static create(U,se=null){const ae=a.get(U);return typeof ae=="boolean"?ae?S.INSTANCE:D.INSTANCE:new F(U,se)}constructor(U,se){this.c=U,this.d=se,this.type=l.Not}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=a.get(this.c);return typeof U=="boolean"?U?S.INSTANCE:D.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Oj=F;function N(J,U){if(typeof J=="string"){const se=parseFloat(J);isNaN(se)||(J=se)}return typeof J=="string"||typeof J=="number"?U(J):S.INSTANCE}class O{static create(U,se,ae=null){return N(se,te=>new O(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.Greater}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Pj=O;class j{static create(U,se,ae=null){return N(se,te=>new j(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=j;class z{static create(U,se,ae=null){return N(se,te=>new z(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Rj=z;class M{static create(U,se,ae=null){return N(se,te=>new M(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=l.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Sj=M;class V{static create(U,se){return new V(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=l.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const se=this.f?this.f.source:"",ae=U.f?U.f.source:"";return se<ae?-1:se>ae?1:0}equals(U){if(U.type===this.type){const se=this.f?this.f.source:"",ae=U.f?U.f.source:"";return this.d===U.d&&se===ae}return!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Tj=V;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=l.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Uj=K;function re(J){let U=null;for(let se=0,ae=J.length;se<ae;se++){const te=J[se].substituteConstants();if(J[se]!==te&&U===null){U=[];for(let le=0;le<se;le++)U[le]=J[le]}U!==null&&(U[se]=te)}return U===null?J:U}class B{static create(U,se,ae){return B.d(U,se,ae)}constructor(U,se){this.expr=U,this.c=se,this.type=l.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=w(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=re(this.expr);return U===this.expr?this:B.create(U,this.c,!1)}evaluate(U){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(U))return!1;return!0}static d(U,se,ae){const te=[];let le=!1;for(const ue of U)if(ue){if(ue.type===l.True){le=!0;continue}if(ue.type===l.False)return S.INSTANCE;if(ue.type===l.And){te.push(...ue.expr);continue}te.push(ue)}if(te.length===0&&le)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];for(;te.length>1;){const ue=te[te.length-1];if(ue.type!==l.Or)break;te.pop();const Z=te.pop(),oe=te.length===0,pe=G.create(ue.expr.map(we=>B.create([we,Z],null,ae)),null,oe);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let Z=ue+1;Z<te.length;Z++)if(te[ue].negate().equals(te[Z]))return S.INSTANCE;if(te.length===1)return te[0]}return new B(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new B(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());this.c=G.create(U,this,!0)}return this.c}}e.$Vj=B;class G{static create(U,se,ae){return G.d(U,se,ae)}constructor(U,se){this.expr=U,this.c=se,this.type=l.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=w(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=re(this.expr);return U===this.expr?this:G.create(U,this.c,!1)}evaluate(U){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(U))return!0;return!1}static d(U,se,ae){let te=[],le=!1;if(U){for(let ue=0,Z=U.length;ue<Z;ue++){const oe=U[ue];if(oe){if(oe.type===l.False){le=!0;continue}if(oe.type===l.True)return D.INSTANCE;if(oe.type===l.Or){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&le)return S.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let Z=ue+1;Z<te.length;Z++)if(te[ue].negate().equals(te[Z]))return D.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new G(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());for(;U.length>1;){const se=U.shift(),ae=U.shift(),te=[];for(const le of $e(se))for(const ue of $e(ae))te.push(B.create([le,ue],null,!1));U.unshift(G.create(te,null,!1))}this.c=G.create(U,this,!0)}return this.c}}e.$Wj=G;class X extends y{static{this.d=[]}static all(){return X.d.values()}constructor(U,se,ae){super(U,null),this.f=se,typeof ae=="object"?X.d.push({...ae,key:U}):ae!==!0&&X.d.push({key:U,description:ae,type:se!=null?typeof se:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return C.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Xj=X,e.$Yj=(0,L.$Gi)("contextKeyService");function ee(J,U){return J<U?-1:J>U?1:0}function de(J,U,se,ae){return J<se?-1:J>se?1:U<ae?-1:U>ae?1:0}function ne(J,U){if(J.type===l.False||U.type===l.True)return!0;if(J.type===l.Or)return U.type===l.Or?De(J.expr,U.expr):!1;if(U.type===l.Or){for(const se of U.expr)if(ne(J,se))return!0;return!1}if(J.type===l.And){if(U.type===l.And)return De(U.expr,J.expr);for(const se of J.expr)if(ne(se,U))return!0;return!1}return J.equals(U)}function De(J,U){let se=0,ae=0;for(;se<J.length&&ae<U.length;){const te=J[se].cmp(U[ae]);if(te<0)return!1;te===0&&se++,ae++}return se===J.length}function $e(J){return J.type===l.Or?J.expr:[J]}}),define(Ee[265],Se([1,0,36,5]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$qt=e.AccessibilitySupport=e.$pt=void 0,e.$rt=T,e.$pt=(0,h.$Gi)("accessibilityService");var I;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.$qt=new s.$Xj("accessibilityModeEnabled",!1);function T(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$st="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[114],Se([1,0,19,25,11,184,84,192,138,216,265]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=t,e.clampedFloat=r,e.stringSet=w,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,s=We(s),h=We(h),I=We(I),a=We(a);var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class l{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=l;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class b{constructor(x,Ce,Ye,et){this.id=x,this.name=Ce,this.defaultValue=Ye,this.schema=et}applyUpdate(x,Ce){return m(x,Ce)}compute(x,Ce,Ye){return Ye}}class c{constructor(x,Ce){this.newValue=x,this.didChange=Ce}}e.ApplyUpdateResult=c;function m(he,x){if(typeof he!="object"||typeof x!="object"||!he||!x)return new c(x,he!==x);if(Array.isArray(he)||Array.isArray(x)){const Ye=Array.isArray(he)&&Array.isArray(x)&&s.$xb(he,x);return new c(x,!Ye)}let Ce=!1;for(const Ye in x)if(x.hasOwnProperty(Ye)){const et=m(he[Ye],x[Ye]);et.didChange&&(he[Ye]=et.newValue,Ce=!0)}return new c(he,Ce)}class d{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,Ce){return m(x,Ce)}validate(x){return this.defaultValue}}class g{constructor(x,Ce,Ye,et){this.id=x,this.name=Ce,this.defaultValue=Ye,this.schema=et}applyUpdate(x,Ce){return m(x,Ce)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,Ce,Ye){return Ye}}function n(he,x){return typeof he>"u"?x:he==="false"?!1:!!he}class o extends g{constructor(x,Ce,Ye,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Ye),super(x,Ce,Ye,et)}validate(x){return n(x,this.defaultValue)}}function t(he,x,Ce,Ye){if(typeof he>"u")return x;let et=parseInt(he,10);return isNaN(et)?x:(et=Math.max(Ce,et),et=Math.min(Ye,et),et|0)}class i extends g{static clampedInt(x,Ce,Ye,et){return t(x,Ce,Ye,et)}constructor(x,Ce,Ye,et,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Ye,gt.minimum=et,gt.maximum=ut),super(x,Ce,Ye,gt),this.minimum=et,this.maximum=ut}validate(x){return i.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function r(he,x,Ce,Ye){if(typeof he>"u")return x;const et=f.float(he,x);return f.clamp(et,Ce,Ye)}class f extends g{static clamp(x,Ce,Ye){return x<Ce?Ce:x>Ye?Ye:x}static float(x,Ce){if(typeof x=="number")return x;if(typeof x>"u")return Ce;const Ye=parseFloat(x);return isNaN(Ye)?Ce:Ye}constructor(x,Ce,Ye,et,ut){typeof ut<"u"&&(ut.type="number",ut.default=Ye),super(x,Ce,Ye,ut),this.validationFn=et}validate(x){return this.validationFn(f.float(x,this.defaultValue))}}class u extends g{static string(x,Ce){return typeof x!="string"?Ce:x}constructor(x,Ce,Ye,et=void 0){typeof et<"u"&&(et.type="string",et.default=Ye),super(x,Ce,Ye,et)}validate(x){return u.string(x,this.defaultValue)}}function w(he,x,Ce,Ye){return typeof he!="string"?x:Ye&&he in Ye?Ye[he]:Ce.indexOf(he)===-1?x:he}class S extends g{constructor(x,Ce,Ye,et,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Ye),super(x,Ce,Ye,ut),this.c=et}validate(x){return w(x,this.defaultValue,this.c)}}class D extends b{constructor(x,Ce,Ye,et,ut,gt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=et),super(x,Ce,Ye,Dt),this.c=ut,this.d=gt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function y(he){switch(he){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class C extends b{constructor(){super(je.accessibilitySupport,"accessibilitySupport",k.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(x){switch(x){case"auto":return k.AccessibilitySupport.Unknown;case"off":return k.AccessibilitySupport.Disabled;case"on":return k.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,Ce,Ye){return Ye===k.AccessibilitySupport.Unknown?x.accessibilitySupport:Ye}}class A extends b{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:a.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(he){switch(he){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var F;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(he){switch(he){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function O(he){switch(he){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class j extends d{constructor(){super(je.editorClassName)}compute(x,Ce,Ye){const et=["monaco-editor"];return Ce.get(je.extraEditorClassName)&&et.push(Ce.get(je.extraEditorClassName)),x.extraEditorClassName&&et.push(x.extraEditorClassName),Ce.get(je.mouseStyle)==="default"?et.push("mouse-default"):Ce.get(je.mouseStyle)==="copy"&&et.push("mouse-copy"),Ce.get(je.showUnused)&&et.push("showUnused"),Ce.get(je.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class z extends o{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(x,Ce,Ye){return Ye&&x.emptySelectionClipboard}}class M extends b{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:a.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:a.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":w(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":w(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class V extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class K extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?K.OFF:x==="true"?K.TRANSLATE:x:x?K.TRANSLATE:K.OFF}compute(x,Ce,Ye){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class re extends d{constructor(){super(je.fontInfo)}compute(x,Ce,Ye){return x.fontInfo}}class B extends g{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(x){const Ce=f.float(x,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ce,6,100)}compute(x,Ce,Ye){return x.fontInfo.fontSize}}class G extends b{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(i.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class X extends b{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ye=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ye,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ye,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ye,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ye,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ye,description:a.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends b{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:a.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var de;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(de||(e.RenderMinimap=de={}));class ne extends d{constructor(){super(je.layoutInfo)}compute(x,Ce,Ye){return ne.computeLayout(Ce,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const Ce=x.height/x.lineHeight,Ye=Math.floor(x.paddingTop/x.lineHeight);let et=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(et=Math.max(et,Ce-1));const ut=(Ye+x.viewLineCount+et)/(x.pixelRatio*x.height),gt=Math.floor(x.viewLineCount/ut);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ye,extraLinesBeyondLastLine:et,desiredRatio:ut,minimapLineCount:gt}}static c(x,Ce){const Ye=x.outerWidth,et=x.outerHeight,ut=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:de.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const gt=Ce.stableMinimapLayoutInput,Dt=gt&&x.outerHeight===gt.outerHeight&&x.lineHeight===gt.lineHeight&&x.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&x.pixelRatio===gt.pixelRatio&&x.scrollBeyondLastLine===gt.scrollBeyondLastLine&&x.paddingTop===gt.paddingTop&&x.paddingBottom===gt.paddingBottom&&x.minimap.enabled===gt.minimap.enabled&&x.minimap.side===gt.minimap.side&&x.minimap.size===gt.minimap.size&&x.minimap.showSlider===gt.minimap.showSlider&&x.minimap.renderCharacters===gt.minimap.renderCharacters&&x.minimap.maxColumn===gt.minimap.maxColumn&&x.minimap.scale===gt.minimap.scale&&x.verticalScrollbarWidth===gt.verticalScrollbarWidth&&x.isViewportWrapping===gt.isViewportWrapping,Ot=x.lineHeight,qt=x.typicalHalfwidthCharacterWidth,ui=x.scrollBeyondLastLine,ti=x.minimap.renderCharacters;let _e=ut>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Kt=x.minimap.maxColumn,Qt=x.minimap.size,pt=x.minimap.side,It=x.verticalScrollbarWidth,ii=x.viewLineCount,Zt=x.remainingWidth,Vt=x.isViewportWrapping,vt=ti?2:3;let Nt=Math.floor(ut*et);const hi=Nt/ut;let Gt=!1,xe=!1,xt=vt*_e,ni=_e/ut,di=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Bt,extraLinesBeyondLastLine:Jt,desiredRatio:oi,minimapLineCount:At}=ne.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:ui,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:et,lineHeight:Ot,pixelRatio:ut});if(ii/At>1)Gt=!0,xe=!0,_e=1,xt=1,ni=_e/ut;else{let wt=!1,ei=_e+1;if(Qt==="fit"){const Pt=Math.ceil((Bt+ii+Jt)*xt);Vt&&Dt&&Zt<=Ce.stableFitRemainingWidth?(wt=!0,ei=Ce.stableFitMaxMinimapScale):wt=Pt>Nt}if(Qt==="fill"||wt){Gt=!0;const Pt=_e;xt=Math.min(Ot*ut,Math.max(1,Math.floor(1/oi))),Vt&&Dt&&Zt<=Ce.stableFitRemainingWidth&&(ei=Ce.stableFitMaxMinimapScale),_e=Math.min(ei,Math.max(1,Math.floor(xt/vt))),_e>Pt&&(di=Math.min(2,_e/Pt)),ni=_e/ut/di,Nt=Math.ceil(Math.max(si,Bt+ii+Jt)*xt),Vt?(Ce.stableMinimapLayoutInput=x,Ce.stableFitRemainingWidth=Zt,Ce.stableFitMaxMinimapScale=_e):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const kt=Math.floor(Kt*ni),Ft=Math.min(kt,Math.max(0,Math.floor((Zt-It-2)*ni/(qt+ni)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(ut*Ft);const zt=Rt/ut;Rt=Math.floor(Rt*di);const ri=ti?de.Text:de.Blocks,_t=pt==="left"?0:Ye-Ft-It;return{renderMinimap:ri,minimapLeft:_t,minimapWidth:Ft,minimapHeightIsEditorHeight:Gt,minimapIsSampling:xe,minimapScale:_e,minimapLineHeight:xt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:hi}}static computeLayout(x,Ce){const Ye=Ce.outerWidth|0,et=Ce.outerHeight|0,ut=Ce.lineHeight|0,gt=Ce.lineNumbersDigitCount|0,Dt=Ce.typicalHalfwidthCharacterWidth,Ot=Ce.maxDigitWidth,qt=Ce.pixelRatio,ui=Ce.viewLineCount,ti=x.get(je.wordWrapOverride2),_e=ti==="inherit"?x.get(je.wordWrapOverride1):ti,Kt=_e==="inherit"?x.get(je.wordWrap):_e,Qt=x.get(je.wordWrapColumn),pt=Ce.isDominatedByLongLines,It=x.get(je.glyphMargin),ii=x.get(je.lineNumbers).renderType!==Ue.Off,Zt=x.get(je.lineNumbersMinChars),Vt=x.get(je.scrollBeyondLastLine),vt=x.get(je.padding),Nt=x.get(je.minimap),hi=x.get(je.scrollbar),Gt=hi.verticalScrollbarSize,xe=hi.verticalHasArrows,xt=hi.arrowSize,ni=hi.horizontalScrollbarSize,di=x.get(je.folding),kt=x.get(je.showFoldingControls)!=="never";let Ft=x.get(je.lineDecorationsWidth);di&&kt&&(Ft+=16);let Rt=0;if(ii){const Ht=Math.max(gt,Zt);Rt=Math.round(Ht*Ot)}let zt=0;It&&(zt=ut*Ce.glyphMarginDecorationLaneCount);let ri=0,_t=ri+zt,si=_t+Rt,Bt=si+Ft;const Jt=Ye-zt-Rt-Ft;let oi=!1,At=!1,St=-1;_e==="inherit"&&pt?(oi=!0,At=!0):Kt==="on"||Kt==="bounded"?At=!0:Kt==="wordWrapColumn"&&(St=Qt);const wt=ne.c({outerWidth:Ye,outerHeight:et,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:qt,scrollBeyondLastLine:Vt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Nt,verticalScrollbarWidth:Gt,viewLineCount:ui,remainingWidth:Jt,isViewportWrapping:At},Ce.memory||new P);wt.renderMinimap!==de.None&&wt.minimapLeft===0&&(ri+=wt.minimapWidth,_t+=wt.minimapWidth,si+=wt.minimapWidth,Bt+=wt.minimapWidth);const ei=Jt-wt.minimapWidth,Pt=Math.max(1,Math.floor((ei-Gt-2)/Dt)),fi=xe?xt:0;return At&&(St=Math.max(1,Pt),Kt==="bounded"&&(St=Math.min(St,Qt))),{width:Ye,height:et,glyphMarginLeft:ri,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:Rt,decorationsLeft:si,decorationsWidth:Ft,contentLeft:Bt,contentWidth:ei,minimap:wt,viewportColumn:Pt,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:St,verticalScrollbarWidth:Gt,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Gt,height:et-2*fi,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends b{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(x){return w(x,"simple",["simple","advanced"])}compute(x,Ce,Ye){return Ce.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?"advanced":Ye}}var $e;(function(he){he.Off="off",he.OnCode="onCode",he.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class J extends b{constructor(){const x={enabled:$e.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:x.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:w(x.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class U extends b{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:a.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:a.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:w(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class ae extends b{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):i.clampedInt(x,this.defaultValue,0,1e3)}compute(x,Ce,Ye){return Ye<0?i.clampedInt(-Ye*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ye}}class te extends f{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>f.clamp(x,0,150),{markdownDescription:a.localize(66,null)})}compute(x,Ce,Ye){return x.fontInfo.lineHeight}}class le extends b{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:x.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:w(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ce.side,this.defaultValue.side,["right","left"]),showSlider:w(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(he){return he==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Z extends b{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends b{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:a.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class pe extends d{constructor(){super(je.pixelRatio)}compute(x,Ce,Ye){return x.pixelRatio}}class we extends b{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Fe extends b{constructor(){const x={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:x.strings,description:a.localize(89,null)},comments:{anyOf:Ce,default:x.comments,description:a.localize(90,null)},other:{anyOf:Ce,default:x.other,description:a.localize(91,null)}},default:x,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const qt=x?"on":"off";return{comments:qt,strings:qt,other:qt}}if(!x||typeof x!="object")return this.defaultValue;const{other:Ce,comments:Ye,strings:et}=x,ut=["on","inline","off"];let gt,Dt,Ot;return typeof Ce=="boolean"?gt=Ce?"on":"off":gt=w(Ce,this.defaultValue.other,ut),typeof Ye=="boolean"?Dt=Ye?"on":"off":Dt=w(Ye,this.defaultValue.comments,ut),typeof et=="boolean"?Ot=et?"on":"off":Ot=w(et,this.defaultValue.strings,ut),{other:gt,comments:Dt,strings:Ot}}}var Ue;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends b{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(x){let Ce=this.defaultValue.renderType,Ye=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(Ce=Ue.Custom,Ye=x):x==="interval"?Ce=Ue.Interval:x==="relative"?Ce=Ue.Relative:x==="on"?Ce=Ue.On:Ce=Ue.Off),{renderType:Ce,renderFn:Ye}}}function Pe(he){const x=he.get(je.renderValidationDecorations);return x==="editable"?he.get(je.readOnly):x!=="on"}class Te extends b{constructor(){const x=[],Ce={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:x,description:a.localize(100,null)})}validate(x){if(Array.isArray(x)){const Ce=[];for(const Ye of x)if(typeof Ye=="number")Ce.push({column:i.clampedInt(Ye,0,0,1e4),color:null});else if(Ye&&typeof Ye=="object"){const et=Ye;Ce.push({column:i.clampedInt(et.column,0,0,1e4),color:et.color})}return Ce.sort((Ye,et)=>Ye.column-et.column),Ce}return this.defaultValue}}class W extends b{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function q(he,x){if(typeof he!="string")return x;switch(he){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class Y extends b{constructor(){const x={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x,Ye=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(Ce.vertical,this.defaultValue.vertical),horizontal:q(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ye,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Ye,0,1e3),verticalScrollbarSize:et,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,et,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends b{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:a.localize(119,null)}})}applyUpdate(x,Ce){let Ye=!1;Ce.allowedCharacters&&x&&(h.$io(x.allowedCharacters,Ce.allowedCharacters)||(x={...x,allowedCharacters:Ce.allowedCharacters},Ye=!0)),Ce.allowedLocales&&x&&(h.$io(x.allowedLocales,Ce.allowedLocales)||(x={...x,allowedLocales:Ce.allowedLocales},Ye=!0));const et=super.applyUpdate(x,Ce);return Ye?new c(et.newValue,!0):et}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{nonBasicASCII:Ke(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,Ce){if(typeof x!="object"||!x)return Ce;const Ye={};for(const[et,ut]of Object.entries(x))ut===!0&&(Ye[et]=!0);return Ye}}class fe extends b{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:w(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class be extends b{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:a.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends b{constructor(){const x={enabled:R.$jt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$jt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends b{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:x.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:x.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:x.highlightActiveIndentation,description:a.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{bracketPairs:Ke(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(he,x,Ce){const Ye=Ce.indexOf(he);return Ye===-1?x:Ce[Ye]}class tt extends b{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:x.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:x.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{insertMode:w(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:w(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends b{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(x.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends b{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const Ce=[];for(const Ye of x)if(typeof Ye=="string")try{Intl.Segmenter.supportedLocalesOf(Ye).length>0&&Ce.push(Ye)}catch{}return Ce}return this.defaultValue}}var nt;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class at extends b{constructor(){super(je.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(x,Ce,Ye){return Ce.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?nt.None:Ye}}class mt extends d{constructor(){super(je.wrappingInfo)}compute(x,Ce,Ye){const et=Ce.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class ht extends b{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:w(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends b{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:w(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ie="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?ze:I.$k?He:Ie,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(he){return e.editorOptionsRegistry[he.id]=he,he}var je;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.inlineEdit=63]="inlineEdit",he[he.letterSpacing=64]="letterSpacing",he[he.lightbulb=65]="lightbulb",he[he.lineDecorationsWidth=66]="lineDecorationsWidth",he[he.lineHeight=67]="lineHeight",he[he.lineNumbers=68]="lineNumbers",he[he.lineNumbersMinChars=69]="lineNumbersMinChars",he[he.linkedEditing=70]="linkedEditing",he[he.links=71]="links",he[he.matchBrackets=72]="matchBrackets",he[he.minimap=73]="minimap",he[he.mouseStyle=74]="mouseStyle",he[he.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=76]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",he[he.multiCursorModifier=78]="multiCursorModifier",he[he.multiCursorPaste=79]="multiCursorPaste",he[he.multiCursorLimit=80]="multiCursorLimit",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.placeholder=88]="placeholder",he[he.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",he[he.quickSuggestions=90]="quickSuggestions",he[he.quickSuggestionsDelay=91]="quickSuggestionsDelay",he[he.readOnly=92]="readOnly",he[he.readOnlyMessage=93]="readOnlyMessage",he[he.renameOnType=94]="renameOnType",he[he.renderControlCharacters=95]="renderControlCharacters",he[he.renderFinalNewline=96]="renderFinalNewline",he[he.renderLineHighlight=97]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=99]="renderValidationDecorations",he[he.renderWhitespace=100]="renderWhitespace",he[he.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",he[he.roundedSelection=102]="roundedSelection",he[he.rulers=103]="rulers",he[he.scrollbar=104]="scrollbar",he[he.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=106]="scrollBeyondLastLine",he[he.scrollPredominantAxis=107]="scrollPredominantAxis",he[he.selectionClipboard=108]="selectionClipboard",he[he.selectionHighlight=109]="selectionHighlight",he[he.selectOnLineNumbers=110]="selectOnLineNumbers",he[he.showFoldingControls=111]="showFoldingControls",he[he.showUnused=112]="showUnused",he[he.snippetSuggestions=113]="snippetSuggestions",he[he.smartSelect=114]="smartSelect",he[he.smoothScrolling=115]="smoothScrolling",he[he.stickyScroll=116]="stickyScroll",he[he.stickyTabStops=117]="stickyTabStops",he[he.stopRenderingLineAfter=118]="stopRenderingLineAfter",he[he.suggest=119]="suggest",he[he.suggestFontSize=120]="suggestFontSize",he[he.suggestLineHeight=121]="suggestLineHeight",he[he.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",he[he.suggestSelection=123]="suggestSelection",he[he.tabCompletion=124]="tabCompletion",he[he.tabIndex=125]="tabIndex",he[he.unicodeHighlighting=126]="unicodeHighlighting",he[he.unusualLineTerminators=127]="unusualLineTerminators",he[he.useShadowDOM=128]="useShadowDOM",he[he.useTabStops=129]="useTabStops",he[he.wordBreak=130]="wordBreak",he[he.wordSegmenterLocales=131]="wordSegmenterLocales",he[he.wordSeparators=132]="wordSeparators",he[he.wordWrap=133]="wordWrap",he[he.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=136]="wordWrapColumn",he[he.wordWrapOverride1=137]="wordWrapOverride1",he[he.wordWrapOverride2=138]="wordWrapOverride2",he[he.wrappingIndent=139]="wrappingIndent",he[he.wrappingStrategy=140]="wrappingStrategy",he[he.showDeprecated=141]="showDeprecated",he[he.inlayHints=142]="inlayHints",he[he.editorClassName=143]="editorClassName",he[he.pixelRatio=144]="pixelRatio",he[he.tabFocusMode=145]="tabFocusMode",he[he.layoutInfo=146]="layoutInfo",he[he.wrappingInfo=147]="wrappingInfo",he[he.defaultColorDecorators=148]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new o(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Oe(new S(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Oe(new C),accessibilityPageSize:Oe(new i(je.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Oe(new u(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Oe(new o(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new o(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new S(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Oe(new S(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Oe(new S(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Oe(new S(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Oe(new S(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Oe(new D(je.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Oe(new o(je.automaticLayout,"automaticLayout",!1)),autoSurround:Oe(new S(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Oe(new Ne),bracketPairGuides:Oe(new Ge),stickyTabStops:Oe(new o(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Oe(new o(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Oe(new u(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Oe(new i(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Oe(new o(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Oe(new S(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Oe(new i(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Oe(new o(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Oe(new A),contextmenu:Oe(new o(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new o(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Oe(new D(je.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Oe(new S(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Oe(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:a.localize(261,null)})),cursorSurroundingLines:Oe(new i(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Oe(new S(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Oe(new i(je.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Oe(new o(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new o(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new o(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Oe(new o(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Oe(new z),dropIntoEditor:Oe(new ht),stickyScroll:Oe(new U),experimentalWhitespaceRendering:Oe(new S(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Oe(new u(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Oe(new f(je.fastScrollSensitivity,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:a.localize(272,null)})),find:Oe(new M),fixedOverflowWidgets:Oe(new o(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Oe(new o(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Oe(new S(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Oe(new o(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Oe(new o(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Oe(new i(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Oe(new o(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Oe(new u(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Oe(new re),fontLigatures2:Oe(new V),fontSize:Oe(new B),fontWeight:Oe(new G),fontVariations:Oe(new K),formatOnPaste:Oe(new o(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Oe(new o(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Oe(new o(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Oe(new X),hideCursorInOverviewRuler:Oe(new o(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Oe(new ee),inDiffEditor:Oe(new o(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Oe(new f(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>f.clamp(he,-5,20),{description:a.localize(286,null)})),lightbulb:Oe(new J),lineDecorationsWidth:Oe(new ae),lineHeight:Oe(new te),lineNumbers:Oe(new ke),lineNumbersMinChars:Oe(new i(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new o(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Oe(new o(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Oe(new S(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Oe(new le),mouseStyle:Oe(new S(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new f(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Oe(new o(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Oe(new o(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Oe(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Oe(new S(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Oe(new i(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Oe(new S(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Oe(new o(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Oe(new i(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Oe(new Z),pasteAs:Oe(new ct),parameterHints:Oe(new oe),peekWidgetDefaultFocus:Oe(new S(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Oe(new we),definitionLinkOpensInPeek:Oe(new o(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Oe(new Fe),quickSuggestionsDelay:Oe(new i(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Oe(new o(je.readOnly,"readOnly",!1)),readOnlyMessage:Oe(new W),renameOnType:Oe(new o(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Oe(new o(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Oe(new S(je.renderFinalNewline,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Oe(new S(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Oe(new o(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Oe(new S(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new S(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Oe(new i(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new o(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Oe(new Te),scrollbar:Oe(new Y),scrollBeyondLastColumn:Oe(new i(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Oe(new o(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Oe(new o(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Oe(new o(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:I.$k})),selectionHighlight:Oe(new o(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Oe(new o(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new S(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Oe(new o(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Oe(new o(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Oe(new se),snippetSuggestions:Oe(new S(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Oe(new rt),smoothScrolling:Oe(new o(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Oe(new i(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Oe(new tt),inlineSuggest:Oe(new fe),inlineEdit:Oe(new be),inlineCompletionsAccessibilityVerbose:Oe(new o(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Oe(new i(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new i(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new o(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Oe(new S(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Oe(new S(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Oe(new i(je.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Oe(new _),unusualLineTerminators:Oe(new S(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Oe(new o(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Oe(new o(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Oe(new S(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Oe(new ot),wordSeparators:Oe(new u(je.wordSeparators,"wordSeparators",$.$kt,{description:a.localize(360,null)})),wordWrap:Oe(new S(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Oe(new u(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new u(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new i(je.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Oe(new S(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new S(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new j),defaultColorDecorators:Oe(new o(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Oe(new pe),tabFocusMode:Oe(new o(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Oe(new ne),wrappingInfo:Oe(new mt),wrappingIndent:Oe(new at),wrappingStrategy:Oe(new De)}});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[266],Se([1,0,23,44,221,5,110,11,25]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$9w=e.$8w=e.$7w=void 0,e.$0w=P,e.$$w=b,h=jt(h),e.$7w=(0,T.$Gi)("dialogService");var a;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(a||(a={}));class k{a(m){return this.d(m,a.Confirmation)}b(m){return this.d(m,a.Prompt)}c(m){return this.d(m,a.Input)}d(m,d){const g=[];switch(d){case a.Confirmation:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,I.localize)(0,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,I.localize)(1,null));break}case a.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&g.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?g.push((0,I.localize)(2,null)):typeof n.cancelButton=="string"?g.push(n.cancelButton):n.cancelButton.label?g.push(n.cancelButton.label):g.push((0,I.localize)(3,null))),g.length===0&&g.push((0,I.localize)(4,null));break}case a.Input:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,I.localize)(5,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,I.localize)(6,null));break}}return g}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,d,g){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let o=n[d]?.run({checkboxChecked:g});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:g}}}e.$8w=k,e.$9w=(0,T.$Gi)("fileDialogService");var E;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const l=10;function P(c){const m=[];return m.push(...c.slice(0,l).map(d=>typeof d=="string"?d:(0,s.$eh)(d))),c.length>l&&(c.length-l===1?m.push((0,I.localize)(7,null)):m.push((0,I.localize)(8,null,c.length-l))),m.push(""),m.join(`
`)}function b(c,m){const d=(0,$.$eo)(c);let g=(d.buttons??[]).map(i=>(0,L.$4w)(i)),n=(c.buttons||[]).map((i,r)=>r),o=0,t=d.cancelId??g.length-1;if(g.length>1){const i=typeof t=="number"?g[t]:void 0;if(R.$k||R.$j){if(typeof i=="string"&&g.length>1&&t!==1){g.splice(t,1),g.splice(1,0,i);const r=n[t];n.splice(t,1),n.splice(1,0,r),t=1}R.$k&&g.length>1&&(g=g.reverse(),n=n.reverse(),o=g.length-1,typeof i=="string"&&(t=o-1))}else if(R.$i&&typeof i=="string"&&g.length>1&&t!==g.length-1){g.splice(t,1),g.push(i);const r=n[t];n.splice(t,1),n.push(r),t=g.length-1}}return d.buttons=g,d.defaultId=o,d.cancelId=t,d.noLink=!0,d.title=d.title||m.nameLong,{options:d,buttonIndeces:n}}}),define(Ee[145],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,s.$Gi)("environmentService"),e.$Oi=(0,s.$Hi)(e.$Ni)}),define(Ee[267],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=void 0,e.$Q9b=(0,s.$Gi)("externalTerminal"),e.$R9b="Terminal.app"}),define(Ee[268],Se([1,0,58,59,15,17,11,109,34,112,224,267]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=e.$Efc=void 0,s=We(s),T=We(T),L=We(L),$=We($),a=We(a),k=We(k);const l=k.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends P{static{this.b="cmd.exe"}openTerminal(t,i){return this.spawnTerminal(s,t,a.$ym(),i)}spawnTerminal(t,i,r,f){const u=i.windowsExec||b.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const w=T.$qc(u,".exe").toLowerCase();if(w==="cmder")return t.spawn(u,f?[f]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return u.indexOf(" ")>=0&&S.push('""'),S.push(u),w==="wt"&&S.push("-d ."),new Promise((D,y)=>{const C=d(process),A=t.spawn(r,S,{cwd:f,env:C,detached:!0});A.on("error",y),A.on("exit",()=>D())})}async runInTerminal(t,i,r,f,u){const w="windowsExec"in u&&u.windowsExec?u.windowsExec:b.getDefaultTerminalWindows(),S=await b.f();return new Promise((D,y)=>{const C=`"${i} - ${l}"`,A=`"${r.join('" "')}" & pause`,p=Object.assign({},d(process),f);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:i,env:p,windowsVerbatimArguments:!0};let F,N;T.$qc(w,".exe")==="wt"?(F=w,N=["-d",".",b.b,"/c",A]):S?(F=S,N=["-d",".",w,"/c",A]):(F=b.b,N=["/c","start",C,"/wait",w,"/c",`"${A}"`]),s.spawn(F,N,v).on("error",j=>{y(g(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await $.Promises.exists(t)?t:void 0}catch{return}}}e.$Efc=b,Xe([h.$$h],b,"f",null);class c extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,i){return this.spawnTerminal(s,t,i)}runInTerminal(t,i,r,f,u){const w=u.osxExec||E.$R9b;return new Promise((S,D)=>{if(w===E.$R9b||w==="iTerm.app"){const y=w===E.$R9b?"TerminalHelper":"iTermHelper",A=[I.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||l,"-w",i];for(const F of r)A.push("-a"),A.push(F);if(f){const F=Object.assign({},d(process),f);for(const N in F){const O=F[N];O===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${O}`))}}let p="";const v=s.spawn(c.b,A);v.on("error",F=>{D(g(F))}),v.stderr.on("data",F=>{p+=F.toString()}),v.on("exit",F=>{if(F===0)S(void 0);else if(p){const N=p.split(`
`,1);D(new Error(N[0]))}else D(new Error(k.localize(1,null,y,F)))})}else D(new Error(k.localize(2,null,w)))})}spawnTerminal(t,i,r){const f=i.osxExec||E.$R9b;return new Promise((u,w)=>{const S=["-a",f];r&&S.push(r);const D=d(process),y=t.spawn("/usr/bin/open",S,{cwd:r,env:D});y.on("error",w),y.on("exit",()=>u())})}}e.$Ffc=c;class m extends P{static{this.b=k.localize(3,null)}openTerminal(t,i){return this.spawnTerminal(s,t,i)}runInTerminal(t,i,r,f,u){const w=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((S,D)=>{const y=[];w.then(C=>{C.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${n(r)}; echo; read -p "${m.b}" -n1;`;y.push(`''${A}''`);const p=Object.assign({},d(process),f);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const v={cwd:i,env:p};let F="";const N=s.spawn(C,y,v);N.on("error",O=>{D(g(O))}),N.stderr.on("data",O=>{F+=O.toString()}),N.on("exit",O=>{if(O===0)S(void 0);else if(F){const j=F.split(`
`,1);D(new Error(j[0]))}else D(new Error(k.localize(4,null,C,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!L.$k)m.d=Promise.resolve("xterm");else{const t=await $.Promises.exists("/etc/debian_version");m.d=new Promise(i=>{t?i("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?i("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?i("konsole"):process.env.COLORTERM?i(process.env.COLORTERM):process.env.TERM?i(process.env.TERM):i("xterm")})}return m.d}spawnTerminal(t,i,r){const f=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,w)=>{f.then(S=>{const D=d(process),y=t.spawn(S,[],{cwd:r,env:D});y.on("error",w),y.on("exit",()=>u())})})}}e.$Gfc=m;function d(o){const t={...o.env};return(0,R.$lm)(t),t}function g(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(k.localize(5,null,o.path)):o}function n(o){let t="";for(const i of o)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Ee[28],Se([1,0,85,17,13,18,2,225,5,11,15,49]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=l,e.$cl=m,e.$dl=g,e.$el=n,e.$fl=o,e.$gl=t,e.$hl=i,e.$il=r,e.$jl=f,e.$kl=u,e.$ll=w,e.$nl=y,e.$ol=C,e.$pl=A,e.$ql=p,e.$rl=v,e.$ul=z,e.$Gl=G,e.$Hl=X,e.$Jl=de,e.$al=(0,$.$Gi)("fileService");function l(ne){return ne.create===!0}var P;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var c;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function m(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var d;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function g(ne){return!!(ne.capabilities&d.FileReadWrite)}function n(ne){return!!(ne.capabilities&d.FileFolderCopy)}function o(ne){return!!(ne.capabilities&d.FileClone)}function t(ne){return!!(ne.capabilities&d.FileOpenReadWriteClose)}function i(ne){return!!(ne.capabilities&d.FileReadStream)}function r(ne){return g(ne)?!!(ne.capabilities&d.FileAtomicRead):!1}function f(ne){return g(ne)?!!(ne.capabilities&d.FileAtomicWrite):!1}function u(ne){return!!(ne.capabilities&d.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&d.Readonly)}var S;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class D extends Error{static create(De,$e){const J=new D(De.toString(),$e);return A(J,$e),J}constructor(De,$e){super(De),this.code=$e}}e.$ml=D;function y(ne,De){return D.create(ne,De)}function C(ne){return ne||y((0,R.localize)(0,null),S.Unknown)}function A(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function p(ne){if(!ne)return S.Unknown;if(ne instanceof D)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return S.Unknown;switch(De[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function v(ne){if(ne instanceof M)return ne.fileOperationResult;switch(p(ne)){case S.FileNotFound:return re.FILE_NOT_FOUND;case S.FileIsADirectory:return re.FILE_IS_DIRECTORY;case S.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return re.FILE_WRITE_LOCKED;case S.NoPermissions:return re.FILE_PERMISSION_DENIED;case S.FileExists:return re.FILE_MOVE_CONFLICT;case S.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var F;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(De,$e,J){this.resource=De,this.operation=$e,this.target=J}isOperation(De){return this.operation===De}}e.$sl=N;var O;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$X(()=>{const J=s.$Mi.forUris(()=>this.c);return J.fill(this.rawAdded.map(U=>[U,!0])),J}),this.f=new E.$X(()=>{const J=s.$Mi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(U=>[U,!0])),J}),this.g=new E.$X(()=>{const J=s.$Mi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(U=>[U,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of De){switch(J.type){case O.ADDED:this.rawAdded.push(J.resource);break;case O.UPDATED:this.rawUpdated.push(J.resource);break;case O.DELETED:this.rawDeleted.push(J.resource);break}this.b!==j.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...J){if(!De)return!1;const U=J.length>0;return!!((!U||J.includes(O.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!U||J.includes(O.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!U||J.includes(O.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$tl=j;function z(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,I.$If)(ne,De):ne.indexOf(De)===0)}class M extends Error{constructor(De,$e,J){super(De),this.fileOperationResult=$e,this.options=J}}e.$vl=M;class V extends M{constructor(De,$e,J,U){super(De,$e,U),this.fileOperationResult=$e,this.size=J}}e.$wl=V;class K extends M{constructor(De,$e,J){super(De,re.FILE_NOT_MODIFIED_SINCE,J),this.stat=$e}}e.$xl=K;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var B;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Fl="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function X(ne,De){if(!De.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise($e=>{const J=De.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(J.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,T.$kg)(De)||(De=0),De<ee.KB?(0,R.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,R.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,R.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,R.localize)(4,null,(De/ee.GB).toFixed(2)):(0,R.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$Il=ee;function de(ne){const De=typeof ne=="string"||ne?.scheme===k.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===k.Schemas.file?1024*ee.MB:De?10*ee.MB:a.$o?50*ee.MB:1024*ee.MB}}),define(Ee[269],Se([1,0,22,14,226,28]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=L;async function L(k,E,l,P,b,c){let m;try{await R(k,E,l,P,b,c)}catch(d){m=d}finally{m&&b.errorTransformer&&(m=b.errorTransformer(m)),typeof m<"u"&&l.error(m),l.end()}}async function R(k,E,l,P,b,c){$(c);const m=await k.open(E,{create:!1});try{$(c);let d=0,g=0,n=b&&typeof b.length=="number"?b.length:void 0,o=s.$Pe.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),t=b&&typeof b.position=="number"?b.position:0,i=0;do g=await k.read(m,t,o.buffer,i,o.byteLength-i),t+=g,i+=g,d+=g,typeof n=="number"&&(n-=g),i===o.byteLength&&(await l.write(P(o)),o=s.$Pe.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),i=0);while(g>0&&(typeof n!="number"||n>0)&&$(c)&&a(d,b));if(i>0){let r=i;typeof n=="number"&&(r=Math.min(i,n)),l.write(P(o.slice(0,r)))}}catch(d){throw(0,T.$ol)(d)}finally{await k.close(m)}}function $(k){if(k.isCancellationRequested)throw(0,h.$9)();return!0}function a(k,E){if(typeof E?.limits?.size=="number"&&k>E.limits.size)throw(0,T.$nl)((0,I.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[70],Se([1,0,39,3,17,11,2,28]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=$,e.$3q=a,e.$7q=P,e.$8q=b,e.$9q=c,e.$0q=m,e.$$q=g,e.$_q=n;function $(o){return typeof o.correlationId=="number"}function a(o){return o.recursive===!0}class k extends h.$Xc{static{this.a=5}constructor(t,i,r,f){super(),this.h=t,this.j=i,this.m=r,this.n=f,this.c=this.B(new h.$Yc),this.f=void 0,this.g=0}s(){const t=new h.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(i=>this.h(i))),t.add(this.b.onDidLogMessage(i=>this.j(i))),t.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(t,i){this.u(t,i)?this.g<k.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,i){return!(!this.n.restartOnError||i||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=k;class E extends k{constructor(t,i,r){super(t,i,r,{type:"node.js",restartOnError:!1})}}e.$5q=E;class l extends k{constructor(t,i,r){super(t,i,r,{type:"universal",restartOnError:!0})}}e.$6q=l;function P(o){return o.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function b(o){const t=new d;for(const i of o)t.processEvent(i);return t.coalesce()}function c(o,t){return typeof t=="string"&&!t.startsWith(s.$wk)&&!(0,I.$lc)(t)?{base:o,pattern:t}:t}function m(o,t){const i=[];for(const r of t)i.push((0,s.$Ak)(c(o,r)));return i}class d{constructor(){this.a=new Set,this.b=new Map}c(t){return T.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const i=this.b.get(this.c(t));let r=!1;if(i){const f=i.type,u=t.type;i.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?r=!0:f===R.FileChangeType.ADDED&&u===R.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(i)):f===R.FileChangeType.DELETED&&u===R.FileChangeType.ADDED?i.type=R.FileChangeType.UPDATED:f===R.FileChangeType.ADDED&&u===R.FileChangeType.UPDATED||(i.type=u)}else r=!0;r&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],i=[];return Array.from(this.a).filter(r=>r.type!==R.FileChangeType.DELETED?(t.push(r),!1):!0).sort((r,f)=>r.resource.fsPath.length-f.resource.fsPath.length).filter(r=>i.some(f=>(0,R.$ul)(r.resource.fsPath,f,!T.$k))?!1:(i.push(r.resource.fsPath),!0)).concat(t)}}function g(o,t){if(typeof t=="number")switch(o.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const t=[];return o&R.FileChangeFilter.ADDED&&t.push("Added"),o&R.FileChangeFilter.DELETED&&t.push("Deleted"),o&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Ee[270],Se([1,0,61,3,70,4,28,2,9]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class a extends h.$Xc{constructor(){super(),this.a=this.B(new T.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new T.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new T.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$7c),this.m=new Set,this.n=this.B(new $.$Eh(this.y())),this.r=5007,this.s=new $.$4h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,I.$2q)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new $.$4h;try{this.h.clear(),this.g.clear();for(const l of E)this.u(l)?this.h.set(l.correlationId,l):this.g.add(l);for(const[l]of this.j)this.h.has(l)||(this.j.deleteAndDispose(l),this.m.delete(l));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(l=>!this.j.has(l.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const l=new h.$Wc;this.j.set(E.correlationId,l),await this.s.p,!l.isDisposed&&(this.D(E,l),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,l){this.F(E,l)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,l),this.m.add(E.correlationId))}F(E,l){const P=this.O?.subscribe(E.path,(b,c)=>{l.isDisposed||(b?this.D(E,l):c?.type===L.FileChangeType.ADDED&&this.H(E))});return P?(l.add(P),!0):!1}G(E,l){let P=!1;const b=(c,m)=>{if(l.isDisposed)return;const d=this.I(c),g=this.I(m),n=P;P=d,!d&&(g||n)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.watchFile)(E.path,{persistent:!1,interval:this.r},b)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}l.add((0,h.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.unwatchFile)(E.path,b)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const l={resource:R.URI.file(E.path),type:L.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([l]),this.J(l,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,l){if(this.R){const P=` >> normalized ${E.type===L.FileChangeType.ADDED?"[ADDED]":E.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(P,l)}}L(E,l){this.R&&this.P(`${E}${typeof l.correlationId=="number"?` <${l.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,I.$_q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$ir=a}),define(Ee[271],Se([1,0,61,9,21,33,3,82,17,11,23,2,111,34,28,70]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=d;class m extends L.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,t,i,r,f){super(),this.s=n,this.t=o,this.u=t,this.w=i,this.y=r,this.z=f,this.c=this.B(new h.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.u(u))),this.f=this.B(new h.$Uh(u=>this.M(u),m.b)),this.g=(0,c.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,c.$2q)(this.s)?this.s.filter:void 0,this.m=new I.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await P.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await P.Promises.realpath(n.path),n.path===o&&(o=await(0,l.$kr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const t=new L.$Wc;return this.H(n,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,t)),t}H(n,o,t){if(o)return!1;const i=E.URI.file(this.s.path),r=this.t?.subscribe(this.s.path,async(f,u)=>{if(!t.isDisposed)if(f){const w=await this.G(n,o);t.isDisposed?w.dispose():t.add(w)}else u&&(typeof u.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:u.type,cId:this.s.correlationId},!0)});return r?(t.add(r),!0):!1}async I(n,o,t){if(a.$j&&(0,T.$Fg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new I.$ye(this.m.token);t.add((0,L.$Vc)(()=>i.dispose(!0)));const r=new L.$Wc;t.add(r);try{const f=E.URI.file(this.s.path),u=(0,$.$qc)(n),w=(0,s.watch)(n);r.add((0,L.$Vc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const S=new Set;if(o)try{for(const y of await P.Promises.readdir(n))S.add(y)}catch(y){this.O(y)}if(i.token.isCancellationRequested)return;const D=new Map;r.add((0,L.$Vc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),w.on("error",(y,C)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${y}, ${C})`),this.D())}),w.on("change",(y,C)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${C}`);let A="";if(C&&(A=C.toString(),a.$j&&(A=(0,R.$nm)(A))),!(!A||y!=="change"&&y!=="rename"))if(o)if(y==="rename"){D.get(A)?.dispose();const p=setTimeout(async()=>{if(D.delete(A),A===u&&!await P.Promises.exists(n)){this.J(f);return}if(i.token.isCancellationRequested)return;const v=await this.N((0,$.$mc)(n,A));if(i.token.isCancellationRequested)return;let F;v?S.has(A)?F=b.FileChangeType.UPDATED:(F=b.FileChangeType.ADDED,S.add(A)):(S.delete(A),F=b.FileChangeType.DELETED),this.L({resource:(0,k.$hh)(f,A),type:F,cId:this.s.correlationId})},m.a);D.set(A,(0,L.$Vc)(()=>clearTimeout(p)))}else{let p;S.has(A)?p=b.FileChangeType.UPDATED:(p=b.FileChangeType.ADDED,S.add(A)),this.L({resource:(0,k.$hh)(f,A),type:p,cId:this.s.correlationId})}else if(y==="rename"||A!==u){const p=setTimeout(async()=>{const v=await P.Promises.exists(n);i.token.isCancellationRequested||(v?(this.L({resource:f,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0),r.add(await this.G(n,!1))):this.J(f))},m.a);r.clear(),r.add((0,L.$Vc)(()=>clearTimeout(p)))}else this.L({resource:f,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(f){i.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:b.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,c.$8q)(n),t=[];for(const r of o){if((0,c.$$q)(r,this.j)){this.z&&this.R(` >> ignored (filtered) ${r.resource.fsPath}`);continue}t.push(r)}if(t.length===0)return;if(this.z)for(const r of t)this.R(` >> normalized ${r.type===b.FileChangeType.ADDED?"[ADDED]":r.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(a.$k)return P.Promises.exists(n);try{const o=(0,$.$qc)(n);return(await P.Promises.readdir((0,$.$pc)(n))).some(i=>i===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=m;async function d(g,n,o,t,i=512){const r=await P.Promises.open(g,"r"),f=Buffer.allocUnsafe(i),u=new I.$ye(t);let w,S=!1;const D={path:g,excludes:[],recursive:!1},y=new m(D,void 0,C=>{(async()=>{for(const{type:A}of C)if(A===b.FileChangeType.UPDATED){if(S)return;S=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:p}=await P.Promises.read(r,f,0,i,null);if(!p||u.token.isCancellationRequested)break;n(f.slice(0,p))}}catch(p){w=new Error(p),u.dispose(!0)}finally{S=!1}}})()});return await y.ready,o(),new Promise((C,A)=>{u.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(r)}catch(p){w=new Error(p)}w?A(w):C()})})}}),define(Ee[272],Se([1,0,4,39,270,11,271,33]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class $ extends I.$ir{constructor(k){super(),this.O=k,this.onDidError=s.Event.None,this.watchers=new Set}async N(k){k=this.Z(k);const E=[],l=new Set(Array.from(this.watchers));for(const P of k){const b=this.W(P);b&&(0,h.$Ek)(b.request.excludes,P.excludes)&&(0,h.$Ek)(b.request.includes,P.includes)?l.delete(b):E.push(P)}E.length&&this.P(`Request to start watching: ${E.map(P=>this.M(P)).join(",")}`),l.size&&this.P(`Request to stop watching: ${Array.from(l).map(P=>this.M(P.request)).join(",")}`);for(const P of l)this.Y(P);for(const P of E)this.X(P)}W(k){for(const E of this.watchers)if(typeof k.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===k.correlationId)return E}else if((0,R.$Eg)(E.request.path,k.path,!T.$k))return E}X(k){const E=new L.$nr(k,this.O,P=>this.a.fire(P),()=>this.c.fire(k),P=>this.b.fire(P),this.R),l={request:k,instance:E};this.watchers.add(l)}async stop(){await super.stop();for(const k of this.watchers)this.Y(k)}Y(k){this.P("stopping file watcher",k),this.watchers.delete(k),k.instance.dispose()}Z(k){const E=new Map;for(const l of k){const P=T.$k?l.path:l.path.toLowerCase();let b=E.get(l.correlationId);b||(b=new Map,E.set(l.correlationId,b)),b.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(l)}`),b.set(P,l)}return Array.from(E.values()).map(l=>Array.from(l.values())).flat()}async setVerboseLogging(k){super.setVerboseLogging(k);for(const E of this.watchers)E.instance.setVerboseLogging(k)}P(k,E){this.R&&this.b.fire({type:"trace",message:this.bb(k,E)})}Q(k){this.b.fire({type:"warn",message:this.bb(k)})}bb(k,E){return E?`[File Watcher (node.js)] ${k} (${this.M(E.request)})`:`[File Watcher (node.js)] ${k}`}}e.$pr=$}),define(Ee[273],Se([1,0,70,272]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class I extends s.$5q{constructor(L,R,$){super(L,R,$),this.s()}r(L){return L.add(new h.$pr(void 0))}}e.$qr=I}),define(Ee[274],Se([1,0,15,87,209,70]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class L extends T.$6q{constructor($,a,k){super($,a,k),this.s()}r($){const a=$.add(new I.$gr(s.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(a.onDidProcessExit(({code:k,signal:E})=>this.t(`terminated by itself with code ${k}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$ni)(a.getChannel("watcher")))}}e.$hr=L}),define(Ee[115],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class s{constructor(...I){this.a=new Map;for(const[T,L]of I)this.set(T,L)}set(I,T){const L=this.a.get(I);return this.a.set(I,T),L}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Ei=s}),define(Ee[275],Se([1,0,9,14,3,113,264,5,115,81]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const k=!1;class E extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class l{constructor(m=new $.$Ei,d=!1,g,n=k){this.i=m,this.j=d,this.k=g,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Fi,this),this._globalGraph=n?g?._globalGraph??new L.$tr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Sc)(this.h),this.h.clear();for(const m of this.g)(0,I.$Rc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,d){this.m();const g=this,n=new class extends l{dispose(){g.h.delete(n),super.dispose()}}(m,this.j,this,this.l);return this.h.add(n),d?.add(n),n}invokeFunction(m,...d){this.m();const g=b.traceInvocation(this.l,m);let n=!1;try{return m({get:t=>{if(n)throw(0,h.$$)("service accessor is only valid during the invocation of its target method");const i=this.s(t,g);if(!i)throw new Error(`[invokeFunction] unknown service '${t}'`);return i}},...d)}finally{n=!0,g.stop()}}createInstance(m,...d){this.m();let g,n;return m instanceof T.$Di?(g=b.traceCreation(this.l,m.ctor),n=this.o(m.ctor,m.staticArguments.concat(d),g)):(g=b.traceCreation(this.l,m),n=this.o(m,d,g)),g.stop(),n}o(m,d=[],g){const n=R._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),o=[];for(const i of n){const r=this.s(i.id,g);r||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),o.push(r)}const t=n.length>0?n[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${d.length} static arguments`);const i=t-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,t)}return Reflect.construct(m,d.concat(o))}q(m,d){if(this.i.get(m)instanceof T.$Di)this.i.set(m,d);else if(this.k)this.k.q(m,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const d=this.i.get(m);return!d&&this.k?this.k.r(m):d}s(m,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const g=this.r(m);return g instanceof T.$Di?this.u(m,g,d.branch(m,!0)):(d.branch(m,!1),g)}u(m,d,g){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,d,g)}finally{this.t.delete(m)}}v(m,d,g){const n=new L.$tr(i=>i.id.toString());let o=0;const t=[{id:m,desc:d,_trace:g}];for(;t.length;){const i=t.pop();if(n.lookupOrInsertNode(i),o++>1e3)throw new E(n);for(const r of R._util.getServiceDependencies(i.desc.ctor)){const f=this.r(r.id);if(f||this.y(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),f instanceof T.$Di){const u={id:r.id,desc:f,_trace:i._trace.branch(r.id,!0)};n.insertEdge(i,u),t.push(u)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:r}of i){if(this.r(r.id)instanceof T.$Di){const u=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,u)}n.removeNode(r)}}return this.r(m)}w(m,d,g=[],n,o){if(this.i.get(m)instanceof T.$Di)return this.x(m,d,g,n,o,this.g);if(this.k)return this.k.w(m,d,g,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(m,d,g=[],n,o,t){if(n){const i=new l(void 0,this.j,this,this.l);i.c=String(m);const r=new Map,f=new s.$Zh(()=>{const u=i.o(d,g,o);for(const[w,S]of r){const D=u[w];if(typeof D=="function")for(const y of S)y.disposable=D.apply(u,y.listener)}return r.clear(),t.add(u),u});return new Proxy(Object.create(null),{get(u,w){if(!f.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let y=r.get(w);return y||(y=new a.$8c,r.set(w,y)),(A,p,v)=>{if(f.isInitialized)return f.value[w](A,p,v);{const F={listener:[A,p,v],disposable:void 0},N=y.push(F);return(0,I.$Vc)(()=>{N(),F.disposable?.dispose()})}}}if(w in u)return u[w];const S=f.value;let D=S[w];return typeof D!="function"||(D=D.bind(S),u[w]=D),D},set(u,w,S){return f.value[w]=S,!0},getPrototypeOf(u){return d.prototype}})}else{const i=this.o(d,g,o);return t.add(i),i}}y(m,d){if(d&&console.warn(m),this.j)throw new Error(m)}}e.$ur=l;var P;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(P||(P={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,d){return m?new b(P.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(m,d){return m?new b(P.Creation,d.name):b.c}static{this.f=0}constructor(m,d){this.type=m,this.name=d,this.g=Date.now(),this.h=[]}branch(m,d){const g=new b(P.Branch,m.toString());return this.h.push([m,d,g]),g}stop(){const m=Date.now()-this.g;b.f+=m;let d=!1;function g(o,t){const i=[],r=new Array(o+1).join("	");for(const[f,u,w]of t.h)if(u&&w){d=!0,i.push(`${r}CREATES -> ${f}`);const S=g(o+1,w);S&&i.push(S)}else i.push(`${r}uses -> ${f}`);return i.join(`
`)}const n=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(m>2||d)&&b.all.add(n.join(`
`))}}e.$vr=b}),define(Ee[12],Se([1,0,228,51,4,60,3,29,11,23,18,2,36,5]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=c,e.log=d,e.$ok=D,e.$pk=y,e.$qk=C,e.$rk=A,s=We(s),e.$ak=(0,P.$Gi)("logService"),e.$bk=(0,P.$Gi)("loggerService");function b(){return new Date().toISOString()}function c(p){return(0,k.$kg)(p)}var m;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$dk=m.Info;function d(p,v,F){switch(v){case m.Trace:p.trace(F);break;case m.Debug:p.debug(F);break;case m.Info:p.info(F);break;case m.Warning:p.warn(F);break;case m.Error:p.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function g(p,v=!1){let F="";for(let N=0;N<p.length;N++){let O=p[N];if(O instanceof Error&&(O=(0,h.$rj)(O,v)),typeof O=="object")try{O=JSON.stringify(O)}catch{}F+=(N>0?" ":"")+O}return F}class n extends L.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new I.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$fk=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(m.Trace)&&this.g(m.Trace,g([v,...F],!0))}debug(v,...F){this.f(m.Debug)&&this.g(m.Debug,g([v,...F]))}info(v,...F){this.f(m.Info)&&this.g(m.Info,g([v,...F]))}warn(v,...F){this.f(m.Warning)&&this.g(m.Warning,g([v,...F]))}error(v,...F){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,g(N))}else this.g(m.Error,g([v,...F]))}flush(){}}e.$gk=o;class t extends n{constructor(v=e.$dk){super(),this.setLevel(v),this.g=!$.$i}trace(v,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...F):console.log(`[main ${b()}]`,v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...F):console.log(`[main ${b()}]`,v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...F):console.log(`[main ${b()}]`,v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,v,...F):console.warn(`[main ${b()}]`,v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,v,...F):console.error(`[main ${b()}]`,v,...F))}flush(){}}e.$hk=t;class i extends n{constructor(v=e.$dk,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$ik=i;class r extends n{constructor(v,F=e.$dk){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...F])}debug(v,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...F])}info(v,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...F])}warn(v,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...F])}error(v,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$rj)(v,this.f(m.Trace))}flush(){}}e.$jk=r;class f extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$kk=f;class u extends L.$Xc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new R.$Dc,this.c=this.B(new I.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$ne),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(v){return(0,k.$gg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),O=(0,k.$gg)(v)?v:F?.id??(0,T.$uj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const z=F?.logLevel==="always"?m.Trace:F?.logLevel;j||(j=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:O}));const M={logger:j,info:{resource:N,id:O,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(N,M),j}n(v){return(0,k.$gg)(v)?(0,a.$hh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(E.URI.isUri(v)){const N=v,O=F,j=this.b.get(N);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([N,O]))}else{this.h=v;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=u;class w{constructor(){this.onDidChangeLogLevel=new I.$ne().event}setLevel(v){}getLevel(){return m.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$mk=w;class S extends w{}e.$nk=S;function D(p){if(p.verbose)return m.Trace;if(typeof p.logLevel=="string"){const v=A(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$dk}function y(p){switch(p){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function C(p){switch(p){case m.Trace:return{original:"Trace",value:s.localize(0,null)};case m.Debug:return{original:"Debug",value:s.localize(1,null)};case m.Info:return{original:"Info",value:s.localize(2,null)};case m.Warning:return{original:"Warning",value:s.localize(3,null)};case m.Error:return{original:"Error",value:s.localize(4,null)};case m.Off:return{original:"Off",value:s.localize(5,null)}}}function A(p){switch(p){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$sk=new l.$Xj("logLevel",y(m.Info))}),define(Ee[276],Se([1,0,19,9,14,4,33,3,17,70,12]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class E extends R.$Xc{constructor(P,b){super(),this.a=P,this.b=b,this.c=this.B(new T.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new T.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Eh(0)),this.w=[],this.y=this.B(new h.$Eh(0))}watch(P,b){return b.recursive||this.b?.watcher?.forceUniversal?this.n(P,b):this.z(P,b)}n(P,b){const c={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},m=(0,s.$Wb)(this.j,c);return this.r(),(0,R.$Vc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,I.$3)(P))}s(){this.h||(this.h=this.B(this.t(b=>this.c.fire((0,a.$7q)(b)),b=>this.G(b),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const b of this.j)(0,a.$3q)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const b of this.j)(0,a.$3q)(b)&&P.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,b){const c={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},m=(0,s.$Wb)(this.w,c);return this.C(),(0,R.$Vc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,I.$3)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,a.$7q)(P)),P=>this.G(P),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,$.$kc)(P.fsPath)}J(P){const b=this.I(P);return(0,L.$Ig)(b)}}e.$ar=E}),define(Ee[277],Se([1,0,9,29,22,4,33,3,17,11,23,104,34,227,28,269,276,274,273]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class n extends m.$ar{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=T.Event.None,this.P=new h.$Dc(r=>k.$$g.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=b.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:i,symbolicLink:r}=await l.SymlinkSupport.stat(this.I(t));return{type:this.O(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:b.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await l.Promises.readdir(this.I(t),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async f=>{try{let u;f.isSymbolicLink()?u=(await this.stat((0,k.$hh)(t,f.name))).type:u=this.O(f),r.push([f.name,u])}catch(u){this.a.trace(u)}})),r}catch(i){throw this.hb(i)}}O(t,i){let r;return i?.dangling?r=b.FileType.Unknown:t.isFile()?r=b.FileType.File:t.isDirectory()?r=b.FileType.Directory:r=b.FileType.Unknown,i&&(r|=b.FileType.SymbolicLink),r}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const f=new s.$Fh;return this.P.set(t,f),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,R.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===f&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),f.open()})}async readFile(t,i){let r;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),r=await this.Q(t));const f=this.I(t);return await l.Promises.readFile(f)}catch(f){throw this.hb(f)}finally{r?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,r){const f=(0,E.$De)(u=>I.$Pe.concat(u.map(w=>I.$Pe.wrap(w))).buffer);return(0,c.$Zq)(this,t,f,u=>u.buffer,{...i,bufferSize:256*1024},r),f}async writeFile(t,i,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(t)?this.U(t,(0,k.$hh)((0,k.$gh)(t),`${(0,k.$eh)(t)}${r.atomic.postfix}`),i,r):this.W(t,i,r)}async S(t){try{const i=this.I(t),{symbolicLink:r}=await l.SymlinkSupport.stat(i);if(r)return!1}catch{}return!0}async U(t,i,r,f){const u=new R.$Wc;try{u.add(await this.Q(t)),u.add(await this.Q(i)),await this.W(i,r,f,!0);try{await this.rename(i,t,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{u.dispose()}}async W(t,i,r,f){let u;try{const w=this.I(t);if(!r.create||!r.overwrite){if(await l.Promises.exists(w)){if(!r.overwrite)throw(0,b.$nl)((0,P.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,b.$nl)((0,P.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:r.unlock},f),await this.write(u,0,i,0,i.byteLength)}catch(w){throw await this.ib(t,w)}finally{typeof u=="number"&&await this.close(u)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,r){const f=this.I(t);let u;(0,b.$bl)(i)&&!r&&(u=await this.Q(t));let w;try{if((0,b.$bl)(i)&&i.unlock)try{const{stat:D}=await l.SymlinkSupport.stat(f);D.mode&128||await l.Promises.chmod(f,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let S;if((0,b.$bl)(i)){if(a.$i)try{await l.Promises.truncate(f,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}S||(S="w")}else S="r";w=await l.Promises.open(f,S)}catch(S){throw u?.dispose(),(0,b.$bl)(i)?await this.ib(t,S):this.hb(S)}if(this.X.set(w,0),(0,b.$bl)(i)&&this.Z.set(w,t),u){const S=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${f})`),this.Y.set(w,u),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${f})`),S.dispose())}return w}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await l.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.a.error(r)}return await l.Promises.close(t)}catch(r){throw this.hb(r)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,r,f,u){const w=this.ab(t,i);let S=null;try{S=(await l.Promises.read(t,r,f,u,w)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(t,w,S)}return S}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,r){const f=this.X.get(t);typeof f=="number"&&(typeof i=="number"||(typeof r=="number"?this.X.set(t,f+r):this.X.delete(t)))}async write(t,i,r,f,u){return(0,s.$1h)(()=>this.cb(t,i,r,f,u),100,3)}async cb(t,i,r,f,u){const w=this.ab(t,i);let S=null;try{S=(await l.Promises.write(t,r,f,u,w)).bytesWritten}catch(D){throw await this.ib(this.Z.get(t),D)}finally{this.bb(t,w,S)}return S}async mkdir(t){try{await l.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const r=this.I(t);if(i.recursive){let f;i?.atomic!==!1&&i.atomic.postfix&&(f=(0,$.$mc)((0,$.$pc)(r),`${(0,$.$qc)(r)}${i.atomic.postfix}`)),await l.Promises.rm(r,l.RimRafMode.MOVE,f)}else try{await l.Promises.unlink(r)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let u=!1;try{const{stat:w,symbolicLink:S}=await l.SymlinkSupport.stat(r);u=w.isDirectory()&&!S}catch{}if(u)await l.Promises.rmdir(r);else throw f}else throw f}}catch(r){throw this.hb(r)}}async rename(t,i,r){const f=this.I(t),u=this.I(i);if(f!==u)try{await this.db(t,i,"move",r.overwrite),await l.Promises.rename(f,u)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,P.localize)(2,null,(0,$.$qc)(f),(0,$.$qc)((0,$.$pc)(u)),w.toString()))),this.hb(w)}}async copy(t,i,r){const f=this.I(t),u=this.I(i);if(f!==u)try{await this.db(t,i,"copy",r.overwrite),await l.Promises.copy(f,u,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,P.localize)(3,null,(0,$.$qc)(f),(0,$.$qc)((0,$.$pc)(u)),w.toString()))),this.hb(w)}}async db(t,i,r,f){const u=this.I(t),w=this.I(i);let S=!1;if(!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,L.$Eg)(u,w,!0)),S){if(r==="copy")throw(0,b.$nl)((0,P.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const y=await this.N(t);if(!y)throw(0,b.$nl)((0,P.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!f)throw(0,b.$nl)((0,P.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);y.type&b.FileType.File&&C.type&b.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,r){const f=this.I(t),u=this.I(i),w=!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.$Eg)(f,u,!w))return;const S=new R.$Wc;try{S.add(await this.Q(t)),S.add(await this.Q(i)),r&&await l.Promises.mkdir((0,$.$pc)(u),{recursive:!0}),await l.Promises.copyFile(f,u)}catch(D){if(D.code==="ENOENT"&&!r)return this.eb(t,i,!0);throw this.hb(D)}finally{S.dispose()}}t(t,i,r){return new d.$hr(f=>t(f),f=>i(f),r)}F(t,i,r){return new g.$qr(f=>t(f),f=>i(f),r)}hb(t){if(t instanceof b.$ml)return t;let i=t,r;switch(t.code){case"ENOENT":r=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=b.FileSystemProviderErrorCode.Unknown;break;default:r=b.FileSystemProviderErrorCode.Unknown}return(0,b.$nl)(i,r)}async ib(t,i){let r=this.hb(i);if(t&&r.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await l.SymlinkSupport.stat(this.I(t));f.mode&128||(r=(0,b.$nl)(i,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.a.trace(f)}return r}}e.$rr=n}),define(Ee[278],Se([1,0,3,12]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class I extends s.$Xc{constructor(L,R=[]){super(),this.a=new h.$kk([L,...R]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$oR=I}),define(Ee[279],Se([1,0,28,12]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function T(a,k,E,l,P){try{const b=await new Promise((m,d)=>{ce(["@vscode/spdlog"],m,d)}).then(We);b.setFlushOn(I.Trace);const c=await b.createAsyncRotatingLogger(a,k,E,l);return P?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(b){console.error(b)}return null}function L(a,k,E){switch(k){case h.LogLevel.Trace:a.trace(E);break;case h.LogLevel.Debug:a.debug(E);break;case h.LogLevel.Info:a.info(E);break;case h.LogLevel.Warning:a.warn(E);break;case h.LogLevel.Error:a.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function R(a,k){switch(k){case h.LogLevel.Trace:a.setLevel(I.Trace);break;case h.LogLevel.Debug:a.setLevel(I.Debug);break;case h.LogLevel.Info:a.setLevel(I.Info);break;case h.LogLevel.Warning:a.setLevel(I.Warning);break;case h.LogLevel.Error:a.setLevel(I.Error);break;case h.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${k}`)}}class $ extends h.$gk{constructor(k,E,l,P,b){super(),this.m=[],this.setLevel(b),this.n=this.s(k,E,l,P),this.B(this.onDidChangeLogLevel(c=>{this.r&&R(this.r,c)}))}async s(k,E,l,P){const b=l?6:1,c=30/b*s.$Il.MB,m=await T(k,E,c,b,P);if(m){this.r=m,R(this.r,this.getLevel());for(const{level:d,message:g}of this.m)L(this.r,d,g);this.m=[]}}g(k,E){this.r?L(this.r,k,E):this.getLevel()<=k&&this.m.push({level:k,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=$});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[146],Se([1,0,44,229,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,s=jt(s);var T;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function a(b,c){return c-b}$.compare=a;const k=Object.create(null);k[$.Error]=(0,h.localize)(0,null),k[$.Warning]=(0,h.localize)(1,null),k[$.Info]=(0,h.localize)(2,null);function E(b){return k[b]||""}$.toString=E;function l(b){switch(b){case s.default.Error:return $.Error;case s.default.Warning:return $.Warning;case s.default.Info:return $.Info;case s.default.Ignore:return $.Hint}}$.fromSeverity=l;function P(b){switch(b){case $.Error:return s.default.Error;case $.Warning:return s.default.Warning;case $.Info:return s.default.Info;case $.Hint:return s.default.Ignore}}$.toSeverity=P}(L||(e.MarkerSeverity=L={}));var R;(function($){const a="";function k(l){return E(l,!0)}$.makeKey=k;function E(l,P){const b=[a];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(a),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(a),l.severity!==void 0&&l.severity!==null?b.push(L.toString(l.severity)):b.push(a),l.message&&P?b.push(l.message.replace("\xA6","\\\xA6")):b.push(a),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(a),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(a),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(a),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(a),b.push(a),b.join("\xA6")}$.makeKeyOptionalMessage=E})(R||(e.IMarkerData=R={})),e.$Du=(0,I.$Gi)("markerService")});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[280],Se([1,0,4,44,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$qw=e.Severity=void 0,e.$rw=R,h=jt(h),e.Severity=h.default,e.$qw=(0,I.$Gi)("notificationService");var T;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var L;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(E){if(E){const l=E;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class a{constructor(){this.progress=new k,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$sw=a;class k{infinite(){}done(){}total(l){}worked(l){}}e.$tw=k}),define(Ee[281],Se([1,0,56]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const T=I.context.configuration();if(T)h=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,s.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const T=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:T.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Ee[116],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,s.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(ce,e){return function(s,h){e(s,h,ce)}};define(Ee[90],Se([1,0,9,21,3,5]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,T.$Gi)("progressService");var L;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$ww=R;class ${get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const P=this.d;this.d=()=>{P?.(),l()}}):Promise.resolve()}}e.$xw=$;let a=class extends I.$Xc{constructor(l,P){super(),this.a=new s.$4h,P.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$Vc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$yw=a,e.$yw=a=Xe([Ve(1,e.$uw)],a);class k extends I.$Xc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Wc)}start(l){this.stop();const P=++this.a,b=new h.$ye;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Vc)(()=>b.cancel())),this.b.add((0,I.$Vc)(()=>this.c?this.c.done():void 0)),{id:P,token:b.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$zw=k,e.$Aw=(0,T.$Gi)("editorProgressService")}),define(Ee[37],Se([1,0,66,18]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,s=We(s),h=We(h);class I{constructor(){this.a=new Map}add(L,R){s.ok(h.$gg(L)),s.ok(h.$ig(R)),s.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$ro=new I}),define(Ee[117],Se([1,0,4,37]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,h=We(h),e.$so={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this.b=new s.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,a){this.a[I($)]=a,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new T;h.$ro.add(e.$so.JSONContribution,L)}),define(Ee[71],Se([1,0,19,4,18,218,45,117,37]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=c,e.$Io=m,e.$Jo=d,e.$Ko=n,e.$Lo=o,I=We(I),T=We(T);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$wo={Configuration:"base.contributions.configuration"};var k;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const E=$.$ro.as(R.$so.JSONContribution);class l{constructor(){this.h=new Set,this.i=new h.$ne,this.onDidSchemaChange=this.i.event,this.j=new h.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Do,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const f=new Set;this.n(i,r,f),E.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const f=new Set;this.o(r,f),this.n(i,!1,f),E.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const f=[];for(const{overrides:u,source:w}of i)for(const S in u)if(r.add(S),e.$Go.test(S)){const D=this.a.get(S),y=D?.valuesSources??new Map,C=D?.value||{};for(const v of Object.keys(u[S])){const F=u[S][v];if(I.$ig(F)&&(I.$ng(C[v])||I.$ig(C[v]))){if(C[v]={...C[v]??{},...F},w){let O=y.get(v);if(O||(O=new Map,y.set(v,O)),!(O instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const j in F)O.set(j,w)}}else C[v]=F,w&&y.set(v,w)}this.a.set(S,{source:w,value:C,valuesSources:y});const A=(0,L.$kj)(S),p={type:"object",default:C,description:T.localize(1,null,A),$ref:e.$Do,defaultDefaultValue:C,source:I.$gg(w)?void 0:w,defaultValueSource:w};f.push(...c(S)),this.d[S]=p,this.b.properties[S]=p}else{const D=this.d[S],y=this.a.get(S);let C=y?.value??D?.defaultDefaultValue,A=u[S],p=w;if(I.$ig(A)&&(D!==void 0&&D.type==="object"||D===void 0&&(I.$ng(C)||I.$ig(C)))){if(I.$ig(C)||(C={}),A={...C,...A},p=y?.source??new Map,!(p instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const F in u[S])w?p.set(F,w):p.delete(F)}this.a.set(S,{value:A,source:p}),D&&(this.w(S,D),this.r(S,D))}this.m(f)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:f,source:u}of i)for(const w in f){const S=I.$gg(u)?u:u?.id,D=this.a.get(w);if(D){if(e.$Go.test(w)){for(const C of Object.keys(f[w])){const A=f[w][C];if(I.$ig(A)){const p=D.valuesSources?.get(C);for(const v of Object.keys(A)){const F=p?.get(v);(I.$gg(F)?F:F?.id)===S&&(p?.delete(v),delete D.value[C][v])}Object.keys(D.value[C]).length===0&&(delete D.value[C],D.valuesSources?.delete(C))}else{const p=D.valuesSources?.get(C);(I.$gg(p)?p:p?.id)===S&&(D.valuesSources?.delete(C),delete D.value[C])}}const y=this.a.get(w);y&&Object.keys(y.value).length===0&&(this.a.delete(w),delete this.d[w],delete this.b.properties[w])}else{if(D.source instanceof Map){const C=D.source;for(const A in f[w]){const p=C.get(A);(I.$gg(p)?p:p?.id)===S&&(C.delete(A),delete D.value[A])}C.size===0&&this.a.delete(w)}else{const C=I.$gg(D.source)?D.source:D.source?.id;if(S!==C)continue;this.a.delete(w)}const y=this.d[w];y&&(this.w(w,y),this.r(w,y))}r.add(w)}}this.u()}deltaConfiguration(i){let r=!1;const f=new Set;i.removedDefaults&&(this.l(i.removedDefaults,f),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,f),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,f),i.addedConfigurations&&this.n(i.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,f){i.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,f),this.c.push(u),this.q(u)})}o(i,r){const f=u=>{if(u.properties)for(const w in u.properties){r.add(w);const S=this.d[w];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[w],this.s(w,u.properties[w])}u.allOf?.forEach(w=>f(w))};for(const u of i){f(u);const w=this.c.indexOf(u);w!==-1&&this.c.splice(w,1)}}p(i,r=!0,f,u,w=k.WINDOW,S){w=I.$pg(i.scope)?w:i.scope;const D=i.properties;if(D)for(const C in D){const A=D[C];if(r&&n(C,A)){delete D[C];continue}if(A.source=f,A.defaultDefaultValue=D[C].default,this.w(C,A),e.$Go.test(C)?A.scope=void 0:(A.scope=I.$pg(A.scope)?w:A.scope,A.restricted=I.$pg(A.restricted)?!!u?.includes(C):A.restricted),D[C].hasOwnProperty("included")&&!D[C].included){this.f[C]=D[C],delete D[C];continue}else this.d[C]=D[C],D[C].policy?.name&&this.e.set(D[C].policy.name,C);!D[C].deprecationMessage&&D[C].markdownDeprecationMessage&&(D[C].deprecationMessage=D[C].markdownDeprecationMessage),S.add(C)}const y=i.allOf;if(y)for(const C of y)this.p(C,r,f,u,w,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=f=>{const u=f.properties;if(u)for(const S in u)this.r(S,u[S]);f.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$xo.properties[i]=r,r.scope){case k.APPLICATION:e.$yo.properties[i]=r;break;case k.MACHINE:e.$zo.properties[i]=r;break;case k.MACHINE_OVERRIDABLE:e.$Ao.properties[i]=r;break;case k.WINDOW:e.$Bo.properties[i]=r;break;case k.RESOURCE:e.$Co.properties[i]=r;break;case k.LANGUAGE_OVERRIDABLE:e.$Co.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$xo.properties[i],r.scope){case k.APPLICATION:delete e.$yo.properties[i];break;case k.MACHINE:delete e.$zo.properties[i];break;case k.MACHINE_OVERRIDABLE:delete e.$Ao.properties[i];break;case k.WINDOW:delete e.$Bo.properties[i];break;case k.RESOURCE:case k.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,f={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$Do};this.w(r,f),e.$xo.properties[r]=f,e.$yo.properties[r]=f,e.$zo.properties[r]=f,e.$Ao.properties[r]=f,e.$Bo.properties[r]=f,e.$Co.properties[r]=f}}v(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=i,e.$yo.patternProperties[e.$Fo]=i,e.$zo.patternProperties[e.$Fo]=i,e.$Ao.patternProperties[e.$Fo]=i,e.$Bo.patternProperties[e.$Fo]=i,e.$Co.patternProperties[e.$Fo]=i,this.i.fire()}w(i,r){const f=this.a.get(i);let u=f?.value,w=f?.source;I.$ng(u)&&(u=r.defaultDefaultValue,w=void 0),I.$ng(u)&&(u=d(r.type)),r.default=u,r.defaultValueSource=w}}const P="\\[([^\\]]+)\\]",b=new RegExp(P,"g");e.$Fo=`^(${P})+$`,e.$Go=new RegExp(e.$Fo);function c(t){const i=[];if(e.$Go.test(t)){let r=b.exec(t);for(;r?.length;){const f=r[1].trim();f&&i.push(f),r=b.exec(t)}}return(0,s.$Pb)(i)}function m(t){return t.reduce((i,r)=>`${i}[${r}]`,"")}function d(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new l;$.$ro.add(e.$wo.Configuration,g);function n(t,i){return t.trim()?e.$Go.test(t)?T.localize(7,null,t):g.getConfigurationProperties()[t]!==void 0?T.localize(8,null,t):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,t,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}function o(){const t=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))t.push([r,i[r].scope]);return t.push(["launch",k.RESOURCE]),t.push(["task",k.RESOURCE]),t}}),define(Ee[282],Se([1,0,19,4,176,3,29,25,18,2,45,71,28,37]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=o,s=We(s),I=We(I),R=We(R),$=We($);function b(f){return Object.isFrozen(f)?f:R.$fo(f)}class c{static createEmptyModel(u){return new c({},[],[],void 0,u)}constructor(u,w,S,D,y){this.b=u,this.c=w,this.d=S,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const u=this.raw.map(w=>{if(w instanceof c)return w;const S=new m("",this.f);return S.parseRaw(w),S.configurationModel});this.g=u.reduce((w,S)=>S===w?S:w.merge(S),u[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,k.$ij)(this.contents,u):this.contents}inspect(u,w){const S=this;return{get value(){return b(S.rawConfiguration.getValue(u))},get override(){return w?b(S.rawConfiguration.getOverrideValue(u,w)):void 0},get merged(){return b(w?S.rawConfiguration.override(w).getValue(u):S.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:y,identifiers:C,keys:A}of S.rawConfiguration.overrides){const p=new c(y,A,[],void 0,S.f).getValue(u);p!==void 0&&D.push({identifiers:C,value:p})}return D.length?b(D):void 0}}}getOverrideValue(u,w){const S=this.j(w);return S?u?(0,k.$ij)(S,u):S:void 0}getKeysForOverrideIdentifier(u){const w=[];for(const S of this.overrides)S.identifiers.includes(u)&&w.push(...S.keys);return s.$Pb(w)}getAllOverrideIdentifiers(){const u=[];for(const w of this.overrides)u.push(...w.identifiers);return s.$Pb(u)}override(u){let w=this.a.get(u);return w||(w=this.h(u),this.a.set(u,w)),w}merge(...u){const w=R.$eo(this.contents),S=R.$eo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of u)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(w,C.contents);for(const A of C.overrides){const[p]=S.filter(v=>s.$xb(v.identifiers,A.identifiers));p?(this.i(p.contents,A.contents),p.keys.push(...A.keys),p.keys=s.$Pb(p.keys)):S.push(R.$eo(A))}for(const A of C.keys)D.indexOf(A)===-1&&D.push(A)}return new c(w,D,S,y.every(C=>C instanceof c)?void 0:y,this.f)}h(u){const w=this.j(u);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const S={};for(const D of s.$Pb([...Object.keys(this.contents),...Object.keys(w)])){let y=this.contents[D];const C=w[D];C&&(typeof y=="object"&&typeof C=="object"?(y=R.$eo(y),this.i(y,C)):y=C),S[D]=y}return new c(S,this.keys,this.overrides,void 0,this.f)}i(u,w){for(const S of Object.keys(w)){if(S in u&&$.$ig(u[S])&&$.$ig(w[S])){this.i(u[S],w[S]);continue}u[S]=R.$eo(w[S])}}j(u){let w=null,S=null;const D=y=>{y&&(S?this.i(S,y):S=R.$eo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===u?w=y.contents:y.identifiers.includes(u)&&D(y.contents);return D(w),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,w){this.k(u,w,!0)}setValue(u,w){this.k(u,w,!1)}removeValue(u){const w=this.keys.indexOf(u);w!==-1&&(this.keys.splice(w,1),(0,k.$hj)(this.contents,u),E.$Go.test(u)&&this.overrides.splice(this.overrides.findIndex(S=>s.$xb(S.identifiers,(0,E.$Ho)(u))),1))}k(u,w,S){(0,k.$gj)(this.contents,u,w,D=>this.f.error(D)),S=S||this.keys.indexOf(u)===-1,S&&this.keys.push(u),E.$Go.test(u)&&this.overrides.push({identifiers:(0,E.$Ho)(u),keys:Object.keys(this.contents[u]),contents:(0,k.$fj)(this.contents[u],D=>this.f.error(D))})}}e.$Mo=c;class m{constructor(u,w){this.f=u,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,w){if(!$.$pg(u)){const S=this.h(u);this.parseRaw(S,w)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,w){this.a=u;const{contents:S,keys:D,overrides:y,restricted:C,hasExcludedProperties:A}=this.i(u,w);this.b=new c(S,D,y,A?[u]:void 0,this.g),this.c=C||[]}h(u){let w={},S=null,D=[];const y=[],C=[];function A(v){Array.isArray(D)?D.push(v):S!==null&&(D[S]=v)}const p={onObjectBegin:()=>{const v={};A(v),y.push(D),D=v,S=null},onObjectProperty:v=>{S=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(D),D=v,S=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:A,onError:(v,F,N)=>{C.push({error:v,offset:F,length:N})}};if(u)try{I.$6n(u,p),w=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(u,w){const S=P.$ro.as(E.$wo.Configuration).getConfigurationProperties(),D=this.j(u,S,!0,w);u=D.raw;const y=(0,k.$fj)(u,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),C=Object.keys(u),A=this.l(u,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:C,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(u,w,S,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:y};const C={},A=[];for(const p in u)if(E.$Go.test(p)&&S){const v=this.j(u[p],w,!1,D);C[p]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=w[p],F=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(p),!D.exclude?.includes(p)&&(D.include?.includes(p)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&v?.restricted))?C[p]=u[p]:y=!0}return{raw:C,restricted:A,hasExcludedProperties:y}}l(u,w){const S=[];for(const D of Object.keys(u))if(E.$Go.test(D)){const y={};for(const C in u[D])y[C]=u[D][C];S.push({identifiers:(0,E.$Ho)(D),keys:Object.keys(y),contents:(0,k.$fj)(y,w)})}return S}}e.$No=m;class d extends T.$Xc{constructor(u,w,S,D,y){super(),this.c=u,this.f=w,this.g=D,this.h=y,this.b=this.B(new h.$ne),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(l.FileOperation.CREATE)||C.isOperation(l.FileOperation.COPY)||C.isOperation(l.FileOperation.DELETE)||C.isOperation(l.FileOperation.WRITE))&&S.isEqual(C.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=d;class g{constructor(u,w,S,D,y,C,A,p,v,F,N,O,j){this.a=u,this.b=w,this.c=S,this.overrideIdentifiers=D,this.d=y,this.f=C,this.g=A,this.h=p,this.i=v,this.j=F,this.k=N,this.l=O,this.m=j}get value(){return b(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,w,S,D,y,C,A,p,v,F){this.j=u,this.l=w,this.m=S,this.n=D,this.p=y,this.q=C,this.r=A,this.s=p,this.t=v,this.u=F,this.h=null,this.i=new L.$Dc,this.v=null}getValue(u,w,S){return this.w(u,w,S).getValue(u)}updateValue(u,w,S={}){let D;S.resource?(D=this.t.get(S.resource),D||(D=c.createEmptyModel(this.u),this.t.set(S.resource,D))):D=this.s,w===void 0?D.removeValue(u):D.setValue(u,w),S.resource||(this.h=null)}inspect(u,w,S){const D=this.w(u,w,S),y=this.A(w.resource,S),C=w.resource?this.t.get(w.resource)||this.s:this.s,A=new Set;for(const p of D.overrides)for(const v of p.identifiers)D.getOverrideValue(u,v)!==void 0&&A.add(v);return new g(u,w,D.getValue(u),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(u){const w=this.A(void 0,u);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(u){this.j=u,this.h=null,this.i.clear()}updatePolicyConfiguration(u){this.l=u}updateApplicationConfiguration(u){this.m=u,this.h=null,this.i.clear()}updateLocalUserConfiguration(u){this.n=u,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(u){this.p=u,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(u){this.q=u,this.h=null,this.i.clear()}updateFolderConfiguration(u,w){this.r.set(u,w),this.i.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.i.delete(u)}compareAndUpdateDefaultConfiguration(u,w){const S=[];if(!w){const{added:D,updated:y,removed:C}=i(this.j,u);w=[...D,...y,...C]}for(const D of w)for(const y of(0,E.$Ho)(D)){const C=this.j.getKeysForOverrideIdentifier(y),A=u.getKeysForOverrideIdentifier(y),p=[...A.filter(v=>C.indexOf(v)===-1),...C.filter(v=>A.indexOf(v)===-1),...C.filter(v=>!R.$io(this.j.override(y).getValue(v),u.override(y).getValue(v)))];S.push([y,p])}return this.updateDefaultConfiguration(u),{keys:w,overrides:S}}compareAndUpdatePolicyConfiguration(u){const{added:w,updated:S,removed:D}=i(this.l,u),y=[...w,...S,...D];return y.length&&this.updatePolicyConfiguration(u),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:w,updated:S,removed:D,overrides:y}=i(this.applicationConfiguration,u),C=[...w,...S,...D];return C.length&&this.updateApplicationConfiguration(u),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(u){const{added:w,updated:S,removed:D,overrides:y}=i(this.localUserConfiguration,u),C=[...w,...S,...D];return C.length&&this.updateLocalUserConfiguration(u),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(u){const{added:w,updated:S,removed:D,overrides:y}=i(this.remoteUserConfiguration,u),C=[...w,...S,...D];return C.length&&this.updateRemoteUserConfiguration(u),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(u){const{added:w,updated:S,removed:D,overrides:y}=i(this.workspaceConfiguration,u),C=[...w,...S,...D];return C.length&&this.updateWorkspaceConfiguration(u),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(u,w){const S=this.folderConfigurations.get(u),{added:D,updated:y,removed:C,overrides:A}=i(S,w),p=[...D,...y,...C];return(p.length||!S)&&this.updateFolderConfiguration(u,w),{keys:p,overrides:A}}compareAndDeleteFolderConfiguration(u){const w=this.folderConfigurations.get(u);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:S,updated:D,removed:y,overrides:C}=i(w,void 0);return{keys:[...S,...D,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(u,w,S){let D=this.x(w,S);return w.overrideIdentifier&&(D=D.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(u)!==void 0&&(D=D.merge(this.l)),D}x({resource:u},w){let S=this.y();if(w&&u){const D=w.getFolder(u);D&&(S=this.z(D.uri)||S);const y=this.t.get(u);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(u){let w=this.i.get(u);if(!w){const S=this.y(),D=this.r.get(u);D?(w=S.merge(D),this.i.set(u,w)):w=S}return w}A(u,w){if(w&&u){const S=w.getFolder(u);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((u,w)=>{const{contents:S,overrides:D,keys:y}=this.r.get(w);return u.push([w,{contents:S,overrides:D,keys:y}]),u},[])}}allKeys(){const u=new Set;return this.j.keys.forEach(w=>u.add(w)),this.userConfiguration.keys.forEach(w=>u.add(w)),this.q.keys.forEach(w=>u.add(w)),this.r.forEach(w=>w.keys.forEach(S=>u.add(S))),[...u.values()]}B(){const u=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>u.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(S=>u.add(S))),[...u.values()]}D(u){const w=new Set;return this.j.getKeysForOverrideIdentifier(u).forEach(S=>w.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(S=>w.add(S)),this.q.getKeysForOverrideIdentifier(u).forEach(S=>w.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(u).forEach(D=>w.add(D))),[...w.values()]}static parse(u,w){const S=this.E(u.defaults,w),D=this.E(u.policy,w),y=this.E(u.application,w),C=this.E(u.user,w),A=this.E(u.workspace,w),p=u.folders.reduce((v,F)=>(v.set(a.URI.revive(F[0]),this.E(F[1],w)),v),new L.$Dc);return new n(S,D,y,C,c.createEmptyModel(w),A,p,c.createEmptyModel(w),new L.$Dc,w)}static E(u,w){return new c(u.contents,u.keys,u.overrides,void 0,w)}}e.$Po=n;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,w=new Map;for(const D of f)D.keys.forEach(y=>u.add(y)),D.overrides.forEach(([y,C])=>{const A=(0,L.$Ac)(w,y,new Set);C.forEach(p=>A.add(p))});const S=[];return w.forEach((D,y)=>S.push([y,[...D.values()]])),{keys:[...u.values()],overrides:S}}class t{constructor(u,w,S,D,y){this.change=u,this.f=w,this.g=S,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of u.keys)this.affectedKeys.add(C);for(const[,C]of u.overrides)for(const A of C)this.affectedKeys.add(A);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(u,w){const S=this.a+u,D=this.d.indexOf(S);if(D<0)return!1;const y=D+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(w){const A=this.previousConfiguration?this.previousConfiguration.getValue(u,w,this.f?.workspace):void 0,p=this.g.getValue(u,w,this.h);return!R.$io(A,p)}return!0}}e.$Ro=t;function i(f,u){const{added:w,removed:S,updated:D}=r(u?.rawConfiguration,f?.rawConfiguration),y=[],C=f?.getAllOverrideIdentifiers()||[],A=u?.getAllOverrideIdentifiers()||[];if(u){const p=A.filter(v=>!C.includes(v));for(const v of p)y.push([v,u.getKeysForOverrideIdentifier(v)])}if(f){const p=C.filter(v=>!A.includes(v));for(const v of p)y.push([v,f.getKeysForOverrideIdentifier(v)])}if(u&&f){for(const p of C)if(A.includes(p)){const v=r({contents:f.getOverrideValue(void 0,p)||{},keys:f.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});y.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:S,updated:D,overrides:y}}function r(f,u){const w=f?u?f.keys.filter(y=>u.keys.indexOf(y)===-1):[...f.keys]:[],S=u?f?u.keys.filter(y=>f.keys.indexOf(y)===-1):[...u.keys]:[],D=[];if(f&&u){for(const y of u.keys)if(f.keys.indexOf(y)!==-1){const C=(0,k.$ij)(u.contents,y),A=(0,k.$ij)(f.contents,y);R.$io(C,A)||D.push(y)}}return{added:w,removed:S,updated:D}}}),define(Ee[283],Se([1,0,22,4,3,69]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ixb=e.$gxb=e.$fxb=void 0,e.$hxb=R;const L=(a,k,E)=>{const l=new Uint8Array(16);for(let c=0;c<16;c++)l[c]=Math.round(Math.random()*256);const P=(0,s.$0e)(s.$Pe.wrap(l));return[`GET ws://localhost${a}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$fxb=L,e.$gxb=s.$Pe.fromString(`\r
\r
`);async function R(a,k,E,l,P){a.write(s.$Pe.fromString((0,e.$fxb)(k,E,l)));const b=new I.$Wc;try{return await new Promise((c,m)=>{let d;b.add(a.onData(g=>{d?d=s.$Pe.concat([d,g],d.byteLength+g.byteLength):d=g;const n=d.indexOf(e.$gxb);if(n===-1)return;c(a),a.pauseData();const o=d.slice(n+e.$gxb.byteLength);o.byteLength&&P.onData.fire(o)})),b.add(a.onClose(g=>m(g??new Error("socket closed")))),b.add(a.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw a.dispose(),c}finally{b.dispose()}}class $ extends I.$Xc{constructor(k,E){super(),this.g=k,this.a=this.B(new h.$qe),this.onData=(...l)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...l)),this.b=this.B(new h.$ne),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(l=>this.a.fire(l))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(k,E){T.SocketDiagnostics.traceSocketEvent(this,this.g,k,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ixb=$}),define(Ee[72],Se([1,0,14,5]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=a,e.$Rl=(0,h.$Gi)("remoteAuthorityResolverService");var I;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class T{constructor(E){this.id=E,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=T;class L{constructor(E,l){this.host=E,this.port=l,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=L;var R;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class $ extends s.$eb{static isNotAvailable(E){return E instanceof $&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,l=R.Unknown,P){super(E),this._message=E,this._code=l,this._detail=P,this.isHandled=l===R.NotAvailable&&P===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ul=$;function a(k){const E=k.indexOf("+");return E===-1?k:k.substring(0,E)}}),define(Ee[284],Se([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=y,e.$2l=C,e.$3l=p,a=We(a);const b=30*1e3;var c;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m($e){switch($e){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function d($e){const J=new I.$ye;return setTimeout(()=>J.cancel(),$e),J.token}function g($e,J){if($e.isCancellationRequested||J.isCancellationRequested)return I.CancellationToken.Cancelled;const U=new I.$ye;return $e.onCancellationRequested(()=>U.cancel()),J.onCancellationRequested(()=>U.cancel()),U.token}class n{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new R.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,s.$zh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function o($e,J){const U=new n(J);return U.registerDisposable($e.onControlMessage(se=>{const ae=JSON.parse(se.toString()),te=G(ae);te?U.reject(te):U.resolve(ae)})),U.promise}function t($e,J,U,se,ae,te,le,ue){const Z=new n(ue),oe=k.$he.create(!1);return $e.info(`Creating a socket (${le})...`),a.mark(`code/willCreateSocket/${te}`),J.connect(U,se,ae,le).then(pe=>{Z.didTimeout?(a.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(a.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${oe.elapsed()} ms.`),Z.resolve(pe))},pe=>{a.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${oe.elapsed()} ms.`),$e.error(pe),Z.reject(pe)}),Z.promise}function i($e,J){const U=new n(J);return $e.then(se=>{U.didTimeout||U.resolve(se)},se=>{U.didTimeout||U.reject(se)}),U.promise}async function r($e,J,U,se){const ae=ne($e,J);$e.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let te;try{te=await t($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Tg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,m(J),`renderer-${m(J)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let le,ue;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,ue=!1):(le=new l.$ui({socket:te}),ue=!0),$e.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const Z=await i($e.signService.createNewMessage((0,E.$3g)()),se),oe={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:Z.data};le.sendControl(h.$Pe.fromString(JSON.stringify(oe)));try{const pe=await o(le,g(se,d(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await i($e.signService.validate(Z,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Fe=await i($e.signService.sign(pe.data),se),Ue={type:"connectionType",commit:$e.commit,signedData:Fe,desiredConnectionType:J};return U&&(Ue.args=U),$e.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Pe.fromString(JSON.stringify(Ue))),{protocol:le,ownsProtocol:ue}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${ae} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${ae} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),ue&&B(le),pe}}async function f($e,J,U,se){const ae=Date.now(),te=ne($e,J),{protocol:le,ownsProtocol:ue}=await r($e,J,U,se),Z=new n(se);return Z.registerDisposable(le.onControlMessage(oe=>{const pe=JSON.parse(oe.toString()),we=G(pe);we?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(we),ue&&B(le),Z.reject(we)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(ae)}!`),Z.resolve({protocol:le,firstMessage:pe}))})),Z.promise}async function u($e,J){const{protocol:U}=await f($e,c.Management,void 0,J);return{protocol:U}}async function w($e,J,U){const{protocol:se,firstMessage:ae}=await f($e,c.ExtensionHost,J,U),te=ae&&ae.debugPort;return{protocol:se,debugPort:te}}async function S($e,J,U){const se=Date.now(),ae=ne($e,c.Tunnel),{protocol:te}=await r($e,c.Tunnel,J,U);return $e.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function D($e,J,U){const{connectTo:se,connectionToken:ae}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:ae,reconnectionToken:J,reconnectionProtocol:U,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function y($e,J,U){return A($e,async se=>{const{protocol:ae}=await u(se,I.CancellationToken.None);return new K($e,J,U,se.reconnectionToken,ae)})}async function C($e,J){return A($e,async U=>{const{protocol:se,debugPort:ae}=await w(U,J,I.CancellationToken.None);return new re($e,J,U.reconnectionToken,se,ae)})}async function A($e,J){for(let se=1;;se++)try{const ae=(0,E.$3g)(),te=await D($e,ae,null);return await J(te)}catch(ae){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(ae);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(ae),V.triggerPermanentFailure(0,0,P.$Ul.isHandled(ae)),ae}}async function p($e,J,U){const se=await D($e,(0,E.$3g)(),null);return await S(se,{host:J,port:U},I.CancellationToken.None)}function v($e){return(0,s.$th)(J=>new Promise((U,se)=>{const ae=setTimeout(U,$e*1e3);J.onCancellationRequested(()=>{clearTimeout(ae),U()})}))}var F;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(J,U){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.type=F.ConnectionLost}}e.$4l=N;class O{constructor(J,U,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.durationSeconds=se,this.c=ae,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=O;class j{constructor(J,U,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=F.ReconnectionRunning}}e.$6l=j;class z{constructor(J,U,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=F.ConnectionGain}}e.$7l=z;class M{constructor(J,U,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.handled=ae,this.type=F.ReconnectionPermanentFailure}}e.$8l=M;class V extends R.$Xc{static triggerPermanentFailure(J,U,se){this._permanentFailure=!0,this.f=J,this.g=U,this.h=se,this.j.forEach(ae=>ae.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(J,U,se,ae,te){super(),this.t=J,this.u=U,this.reconnectionToken=se,this.protocol=ae,this.w=te,this.m=this.B(new L.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(le=>{const ue=de(this.t,this.reconnectionToken,!0);le?le.type===l.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ue} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${ue} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${ue} received socket close event.`),this.y()})),this.B(ae.onSocketTimeout(le=>{const ue=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,R.$Vc)(()=>{const le=V.j.indexOf(this);le>=0&&V.j.splice(le,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<U.length?U[se]:U[U.length-1];try{if(ae>0){const le=v(ae);this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,le)),this.u.logService.info(`${J} waiting for ${ae} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${J} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${te.connectTo}...`),await this.G(te,d(b)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Ul.isTemporarilyNotAvailable(te)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,T.$7)(te)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof P.$Ul){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Ul.isHandled(te));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(J,U,se){this.w?V.triggerPermanentFailure(J,U,se):this.D(J,U,se)}D(J,U,se){this.m.fire(new M(this.reconnectionToken,J,U,se)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=V;class K extends V{constructor(J,U,se,ae,te){super(c.Management,J,ae,te,!0),this.client=this.B(new l.$si(te,{remoteAuthority:U,clientId:se},J.ipcLogger))}async G(J,U){await u(J,U)}}e.$0l=K;class re extends V{constructor(J,U,se,ae,te){super(c.ExtensionHost,J,se,ae,!1),this.H=U,this.debugPort=te}async G(J,U){await w(J,this.H,U)}}e.$$l=re;function B($e){try{$e.acceptDisconnect();const J=$e.getSocket();$e.dispose(),J.dispose()}catch(J){(0,T.$3)(J)}}function G($e){if($e&&$e.type==="error"){const J=new Error(`Connection error: ${$e.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function X($e,J){for(;$e.length<J;)$e+=" ";return $e}function ee($e,J){return`[remote-connection][${X(m($e),13)}][${J.substr(0,5)}\u2026]`}function de($e,J,U){return`${ee($e,J)}[${U?"reconnect":"initial"}]`}function ne($e,J){return`${de(J,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(Ee[91],Se([1,0,15]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=h,e.$in=I,e.$jn=T,e.$kn=L;function h($){return $.scheme===s.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const a=$.indexOf("+");return a<0?$:$.substr(0,a)}function T($){const{host:a,port:k}=R($);if(typeof k>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:k}}function L($,a){let{host:k,port:E}=R($);return typeof E>"u"&&(E=a),{host:k,port:E}}function R($){const a=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(Ee[24],Se([1,0,13,5,91]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=T,e.$un=E,e.$vn=l,e.$wn=P,e.$xn=b,e.$yn=c,e.$zn=m,s=We(s),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,n){if(typeof g>"u"||g===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof g=="string"||typeof n=="string"){const o=typeof g=="string"?g:g.value,t=typeof n=="string"?n:n.value;return s.$Hf(o,t)}return g._lower===n._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$rn=$;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const n of g)this.add(n)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$sn=a;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,n){this.c.set($.toKey(g),n)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=k;function E(d){return l(d)}function l(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function P(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function b(d,g){if(g){const n=`onResolveRemoteAuthority:${(0,I.$in)(g)}`;return!!d.activationEvents?.includes(n)}return!1}function c(d){return d.map(g=>{const[n,o]=g.split("@");return{proposalName:n,version:o?parseInt(o):void 0}})}function m(d){return d.map(g=>g.split("@")[0])}e.$An=(0,h.$Gi)("IBuiltinExtensionsScannerService")}),define(Ee[147],Se([1,0,11,222,24,5]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=R,e.$ep=$,e.$fp=a,e.$gp=k,e.$hp=E,e.$ip=l,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(t){switch(t){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function $(t){switch(t){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function a(t,i){switch(t){case s.Platform.Windows:return i==="x64"?I.TargetPlatform.WIN32_X64:i==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case s.Platform.Linux:return i==="x64"?I.TargetPlatform.LINUX_X64:i==="arm64"?I.TargetPlatform.LINUX_ARM64:i==="arm"?I.TargetPlatform.LINUX_ARMHF:I.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?I.TargetPlatform.ALPINE_X64:i==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case s.Platform.Mac:return i==="x64"?I.TargetPlatform.DARWIN_X64:i==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case s.Platform.Web:return I.TargetPlatform.WEB}}function k(t,i){return i===I.TargetPlatform.WEB&&!t.includes(I.TargetPlatform.WEB)}function E(t,i,r){return k(i,r)?!1:t===I.TargetPlatform.UNDEFINED||t===I.TargetPlatform.UNIVERSAL?!0:t===I.TargetPlatform.UNKNOWN?!1:t===r}function l(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var b;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var c;(function(t){t.Install="install",t.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$jp=(0,T.$Gi)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class g extends Error{constructor(i,r){super(i),this.code=r,this.name=r}}e.$kp=g;var n;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(i,r){super(i),this.code=r,this.name=r}}e.$lp=o,e.$mp=(0,T.$Gi)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,T.$Gi)("IGlobalExtensionEnablementService"),e.$qp=(0,T.$Gi)("IExtensionTipsService"),e.$rp=(0,h.localize2)(0,"Extensions"),e.$sp=(0,h.localize2)(1,"Preferences")}),define(Ee[148],Se([1,0,14,24]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(L,R){this.a.set(L,R)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const $ of L){const a=this.readActivationEvents($);a.length>0&&(R[h.$rn.toKey($.identifier)]=a)}return R}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<R.length;$++)R[$]==="onUri"&&(R[$]=`onUri:${h.$rn.toKey(L.identifier)}`);if(!L.contributes)return R;for(const $ in L.contributes){const a=this.a.get($);if(!a)continue;const k=L.contributes[$],E=Array.isArray(k)?k:[k];try{a(E,R)}catch(l){(0,s.$3)(l)}}return R}}e.$LG=I,e.$MG=new I});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[285],Se([1,0,23,44,223,412,24,144]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=k,e.$Yp=E,e.$Zp=l,e.$1p=P,e.$2p=b,e.$3p=c,e.$4p=m,e.$5p=d,h=jt(h),I=We(I),T=We(T);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function k(o){return o=o.trim(),o==="*"||$.test(o)}function E(o){if(!k(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function l(o){if(!o)return null;const t=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let f=o.minorMustEqual;const u=o.patchBase;let w=o.patchMustEqual;o.hasCaret&&(t===0||(f=!1),w=!1);let S=0;if(o.preRelease){const D=a.exec(o.preRelease);if(D){const[,y,C,A]=D;S=Date.UTC(Number(y),Number(C)-1,Number(A))}}return{majorBase:t,majorMustEqual:i,minorBase:r,minorMustEqual:f,patchBase:u,patchMustEqual:w,isMinimum:o.hasGreaterEquals,notBefore:S}}function P(o,t,i){let r;typeof o=="string"?r=l(E(o)):r=o;let f;t instanceof Date?f=t.getTime():typeof t=="string"&&(f=new Date(t).getTime());let u;if(typeof i=="string"?u=l(E(i)):u=i,!r||!u)return!1;const w=r.majorBase,S=r.minorBase,D=r.patchBase;let y=u.majorBase,C=u.minorBase,A=u.patchBase;const p=u.notBefore;let v=u.majorMustEqual,F=u.minorMustEqual,N=u.patchMustEqual;return u.isMinimum?w>y?!0:w<y?!1:S>C?!0:S<C||f&&f<p?!1:D>=A:(w===1&&y===0&&(!v||!F||!N)&&(y=1,C=0,A=0,v=!0,F=!1,N=!1),w<y?!1:w>y?!v:S<C?!1:S>C?!F:D<A?!1:D>A?!N:!(f&&f<p))}function b(o,t,i,r,f){const u=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return u.push([h.default.Error,I.localize(0,null)]),u;if(typeof r.name!="string")return u.push([h.default.Error,I.localize(1,null,"name")]),u;if(typeof r.version!="string")return u.push([h.default.Error,I.localize(2,null,"version")]),u;if(!r.engines)return u.push([h.default.Error,I.localize(3,null,"engines")]),u;if(typeof r.engines.vscode!="string")return u.push([h.default.Error,I.localize(4,null,"engines.vscode")]),u;if(typeof r.extensionDependencies<"u"&&!n(r.extensionDependencies))return u.push([h.default.Error,I.localize(5,null,"extensionDependencies")]),u;if(typeof r.activationEvents<"u"){if(!n(r.activationEvents))return u.push([h.default.Error,I.localize(6,null,"activationEvents")]),u;if(typeof r.main>"u"&&typeof r.browser>"u")return u.push([h.default.Error,I.localize(7,null,"activationEvents","main","browser")]),u}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&u.push([h.default.Warning,I.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return u.push([h.default.Error,I.localize(9,null,"main")]),u;{const D=(0,s.$hh)(i,r.main);(0,s.$bh)(D,i)||u.push([h.default.Warning,I.localize(10,null,D.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return u.push([h.default.Error,I.localize(11,null,"browser")]),u;{const D=(0,s.$hh)(i,r.browser);(0,s.$bh)(D,i)||u.push([h.default.Warning,I.localize(12,null,D.path,i.path)])}}if(!T.valid(r.version))return u.push([h.default.Error,I.localize(13,null)]),u;const w=[];if(!c(o,t,r,f,w))for(const D of w)u.push([h.default.Error,D]);if(r.enabledApiProposals?.length){const D=[];if(!d([...r.enabledApiProposals],D))for(const y of D)u.push([h.default.Error,y])}return u}function c(o,t,i,r,f){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:g(o,t,i.engines.vscode,f)}function m(o,t,i){return o==="*"||g(t,i,o)}function d(o,t){if(o.length===0)return!0;const i=Array.isArray(t)?t:void 0,r=(i?void 0:t)??R.allApiProposals,f=[],u=(0,L.$yn)(o);for(const{proposalName:w,version:S}of u){const D=r[w];D&&S&&D.version!==S&&f.push(I.localize(14,null,w))}return i?.push(...f),f.length===0}function g(o,t,i,r=[]){const f=l(E(i));if(!f)return r.push(I.localize(15,null,i)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return r.push(I.localize(16,null,i)),!1}else if(!f.majorMustEqual)return r.push(I.localize(17,null,i)),!1;return P(o,t,f)?!0:(r.push(I.localize(18,null,o,i)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let t=0,i=o.length;t<i;t++)if(typeof o[t]!="string")return!1;return!0}}),define(Ee[286],Se([1,0,3,5]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,h.$Gi)("remoteSocketFactoryService");class I{constructor(){this.a={}}register(L,R){return this.a[L]??=[],this.a[L].push(R),(0,s.$Vc)(()=>{const $=this.a[L]?.indexOf(R);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,R,$,a){const k=this.b(L);if(!k)throw new Error(`No socket factory found for ${L}`);return k.connect(L,R,$,a)}}e.$Xl=I}),define(Ee[287],Se([1,0,22,14,3,230,71,5,12,37]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=l,e.$9p=P,e.$0p=b,e.$$p=c,e.$_p=m,e.$aq=d,e.$6p=(0,R.$Gi)("requestService");class k{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?t[i]="*****":t[i]=this.b[i];this.a=t}return this.a}}class E extends I.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,T.localize)(0,null),when:$.$sk.isEqualTo((0,$.$pk)($.LogLevel.Trace)).serialize()})}async c(t,i,r){const f=`${t} #${++this.b}: ${i.url}`;this.a.trace(`${f} - begin`,i.type,new k(i.headers??{}));try{const u=await r();return this.a.trace(`${f} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.a.error(`${f} - error`,i.type,(0,h.$ab)(u)),u}}}e.$7p=E;function l(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function b(o){return P(o)?null:(await(0,s.$2e)(o.stream)).toString()}async function c(o){if(!l(o))throw new Error("Server returned "+o.res.statusCode);return b(o)}async function m(o){if(!l(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const i=(await(0,s.$2e)(o.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function d(o){n(o)}let g;function n(o){const t=a.$ro.as(L.$wo.Configuration),i=g;g={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null),(0,T.localize)(10,null)],default:"override",description:(0,T.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[g],remove:i?[i]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(Ee[288],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class s{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(I){try{const T=await this.c();if(T){const L=String(s.a++);return this.b.set(L,T),{id:L,data:T.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,T){if(!I.id)return!0;const L=this.b.get(I.id);if(!L)return!1;this.b.delete(I.id);try{return L.validate(T)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(I){try{return await this.d(I)}catch{}return I}}e.$Qbc=s}),define(Ee[118],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,s.$Gi)(e.$Yl)}),define(Ee[149],Se([1,0,288]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class h extends s.$Qbc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(L=>new L.signer().sign(T))}h(){return new Promise((T,L)=>ce(["vsda"],T,L))}}e.$Wgc=h}),define(Ee[289],Se([1,0,11,56,32]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=L,e.$up=R;function T($){if(s.$u===s.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,a,k,E,l,P,b,c,m,d){const g=Object.create(null);g["common.machineId"]=P,g["common.sqmId"]=b,g["common.devDeviceId"]=c,g.sessionID=(0,I.$3g)()+Date.now(),g.commitHash=E,g.version=l,g["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,s.$h)(s.$u),g["common.nodePlatform"]=h.$gc,g["common.nodeArch"]=k,g["common.product"]=d||"desktop",m&&(g["common.msftInternal"]=m);let n=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),s.$l&&(g["common.snap"]="true");const t=T(a);return t&&(g["common.platformDetail"]=t),g}function R($){const a=h.env.USERDNSDOMAIN;if(!a)return!1;const k=a.toLowerCase();return $.some(E=>k===E)}}),define(Ee[150],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,s.$Gi)("telemetryService"),e.$am=(0,s.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var h;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var I;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ee[92],Se([1,0,25,18,91,289,150]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=k,e.$Dp=E,e.$Ep=l,e.$Fp=P,e.$Gp=c,e.$Hp=d,e.$Ip=g,e.$Jp=t;class R{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$vp=R;class ${constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=$,e.$xp=new $;class a{async publicLog(r,f,u){}async publicLogError(r,f,u){}}e.$yp=a,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function k(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const r=i.getValue(L.$im),f=i.getValue(L.$jm);if(i.getValue(L.$km)===!1||f===!1)return L.TelemetryLevel.NONE;switch(r??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(i){const r={},f={},u={};m(i,u);for(let w in u){w=w.length>150?w.substr(w.length-149):w;const S=u[w];typeof S=="number"?f[w]=S:typeof S=="boolean"?f[w]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${S.length}`),r[w]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(r[w]=S)}return{properties:r,measurements:f}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const r=(0,I.$in)(i);return b.has(r)?r:"other"}function m(i,r,f=0,u){if(i)for(const w of Object.getOwnPropertyNames(i)){const S=i[w],D=u?u+w:w;Array.isArray(S)?r[D]=(0,s.$jo)(S):S instanceof Date?r[D]=S.toISOString():(0,h.$ig)(S)?f<2?m(S,r,f+1,D+"."):r[D]=(0,s.$jo)(S):r[D]=S}}function d(i,r){const f=i.msftInternalDomains||[],u=r.getValue("telemetry.internalTesting");return(0,T.$up)(f)||u}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const u=[];for(const y of r)for(;;){const C=y.exec(i);if(!C)break;u.push([C.index,y.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const y=S.exec(i);if(!y)break;const C=u.some(([A,p])=>y.index<p&&A<S.lastIndex);!w.test(y[0])&&!C&&(f+=i.substring(D,y.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<i.length&&(f+=i.substr(D)),f}function o(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of r)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function t(i,r){return(0,s.$go)(i,f=>{if(f instanceof R||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=n(u,r);for(const w of r)u=u.replace(w,"");return u=o(u),u}})}}),define(Ee[290],Se([1,0,13,147,24,11,2,14,56,92]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=k,e.$Mp=b,e.$Np=c,e.$Op=m,e.$Pp=d,e.$Qp=g,e.$Rp=n,e.$Sp=o,e.$Up=t,e.$Vp=r;function k(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,s.$Cf)(f.id,u.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(u){const w=u.manifest?u.manifest.version:u.version,S=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new l(u.identifier,w,S)}static parse(u){const w=E.exec(u);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(u,w,S=I.TargetPlatform.UNDEFINED){this.identifier=u,this.version=w,this.targetPlatform=S,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof l?k(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Lp=l;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(f){const u=P.exec(f);return u&&u[1]?[m(u[1]),u[2]]:[m(f),void 0]}function c(f,u){return`${f}.${u}`}function m(f){return f.toLowerCase()}function d(f,u){return m(c(f??I.$nn,u))}function g(f,u){const w=[],S=D=>{for(const y of w)if(y.some(C=>k(u(C),u(D))))return y;return null};for(const D of f){const y=S(D);y?y.push(D):w.push([D])}return w}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function o(f){return{id:new a.$vp(f.identifier.id),name:new a.$vp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Tp=new I.$rn("pprice.better-merge");function t(f,u){const w=[],S=u.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const D=S.shift();if(D&&w.every(y=>!k(y.identifier,{id:D}))){const y=f.filter(C=>k(C.identifier,{id:D}));y.length===1&&(w.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function i(f,u){if(!T.$k)return!1;let w;try{w=(await f.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await f.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,R.$ab)(D))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(f,u){const w=await i(f,u),S=(0,h.$fp)(w?"alpine":T.$u,$.$hc);return u.debug("ComputeTargetPlatform:",S),S}}),define(Ee[291],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=s,e.$Es=h,e.$Fs=I,e.$Gs=T,e.$Hs=L,e.$Is=R;function s($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function I($){return new Map($)}function T($){return new Map($??[])}function L($){return Array.from($.entries()).map(a=>[a[0],s(a[1].map),h(a[1].descriptionMap)])}function R($){return new Map($.map(a=>[a[0],{map:I(a[1]),descriptionMap:T(a[2])}]))}}),define(Ee[292],Se([1,0,5,36,37]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new h.$Xj("terminalTabFocusMode",!1,!0);var T;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var k;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(k||(e.TerminalIpcChannels=k={}));var E;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$ns=(0,s.$Gi)("ptyService");var l;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var b;(function(t){t.TerminalView="view",t.Editor="editor"})(b||(e.TerminalLocationString=b={}));var c;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var d;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var g;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var n;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const r=this.b(i.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}I.$ro.add(e.$os.Backend,new o),e.$ps=(0,s.$Gi)("localPtyService"),e.$qs=(0,s.$Gi)("terminalLogService")}),define(Ee[293],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Axb=void 0;class s{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,T,L=5){const R=T($=>{const a=typeof $=="string"?$:$.data;let k=this.a.get(I);if(k){k.data.push(a);return}const E=setTimeout(()=>this.flushBuffer(I),L);k={data:[a],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(I),R.dispose()}},this.a.set(I,k)});return R}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const T=this.a.get(I);T&&(this.a.delete(I),this.b(I,T.data.join("")))}}e.$Axb=s}),define(Ee[294],Se([1,0,9,83,105,50,4,18,2,231,117,37]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.IconFontDefinition=e.IconContribution=e.$xx=void 0,e.$yx=m,e.$zx=d,E=We(E),e.$xx={IconContribution:"base.contributions.icons"};var l;(function(t){function i(r,f){let u=r.defaults;for(;T.ThemeIcon.isThemeIcon(u);){const w=c.getIcon(u.id);if(!w)return;u=w.defaults}return u}t.getDefinition=i})(l||(e.IconContribution=l={}));var P;(function(t){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}t.toJSONObject=i;function r(f){const u=w=>(0,R.$gg)(w)?w:void 0;if(f&&Array.isArray(f.src)&&f.src.every(w=>(0,R.$gg)(w.format)&&(0,R.$gg)(w.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}t.fromJSONObject=r})(P||(e.IconFontDefinition=P={}));class b{constructor(){this.a=new L.$ne,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,r,f,u){const w=this.b[i];if(w){if(f&&!w.description){w.description=f,this.d.properties[i].markdownDescription=`${f} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return w}const S={id:i,description:f,defaults:r,deprecationMessage:u};this.b[i]=S;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),f&&(D.markdownDescription=`${f}: $(${i})`),this.d.properties[i]=D,this.e.enum.push(i),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const r=this.e.enum.indexOf(i);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,r){const f=this.f[i];return f||(this.f[i]=r,this.a.fire(),r)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(w,S)=>w.id.localeCompare(S.id),r=w=>{for(;T.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(w=>this.b[w]);for(const w of u.filter(S=>!!S.description).sort(i))f.push(`|<i class="${r(w)}"></i>|${w.id}|${T.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const w of u.filter(S=>!T.ThemeIcon.isThemeIcon(S.defaults)).sort(i))f.push(`|<i class="${r(w)}"></i>|${w.id}|`);return f.join(`
`)}}const c=new b;E.$ro.add(e.$xx.IconContribution,c);function m(t,i,r,f){return c.registerIcon(t,i,r,f)}function d(){return c}function g(){const t=(0,I.$2j)();for(const i in t){const r="\\"+t[i].toString(16);c.registerIcon(i,{fontCharacter:r})}}g(),e.$Ax="vscode://schemas/icons";const n=E.$ro.as(k.$so.JSONContribution);n.registerSchema(e.$Ax,c.getIconSchema());const o=new s.$Sh(()=>n.notifySchemaChanged(e.$Ax),200);c.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Bx=m("widget-close",h.$6j.close,(0,a.localize)(2,null)),e.$Cx=m("goto-previous-location",h.$6j.arrowUp,(0,a.localize)(3,null)),e.$Dx=m("goto-next-location",h.$6j.arrowDown,(0,a.localize)(4,null)),e.$Ex=T.ThemeIcon.modify(h.$6j.sync,"spin"),e.$Fx=T.ThemeIcon.modify(h.$6j.loading,"spin")}),define(Ee[93],Se([1,0,4,3,11,2,45,5,12]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=E,e.$Ew=P,e.$Fw=b,e.$Hw=c,e.$Jw=m,e.$Kw=d,e.$Bw=(0,R.$Gi)("tunnelService"),e.$Cw=(0,R.$Gi)("sharedTunnelsService");var a;(function(o){o.Http="http",o.Https="https"})(a||(e.TunnelProtocol=a={}));var k;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(k||(e.TunnelPrivacyId=k={}));function E(o){return!!o.forwardPort}var l;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function b(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const i of t){const r=i.split("=")[1];if(/^https?:/.exec(r)){const f=P(T.URI.parse(r));if(f)return f}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(o){return e.$Gw.indexOf(o)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(o){return e.$Iw.indexOf(o)>=0}function d(o,t,i,r){if(i===I.OperatingSystem.Windows)return!1;if(i===I.OperatingSystem.Macintosh&&m(t)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(f?.length===4&&parseInt(f[1])>=18)return!1}return o<1024}class g{constructor(t,i,r){this.remoteAddress=t,this.localAddress=i,this.b=r,this.a=new s.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=g;let n=class extends h.$Xc{constructor(t,i){super(),this.r=t,this.s=i,this.a=new s.$ne,this.onTunnelOpened=this.a.event,this.b=new s.$ne,this.onTunnelClosed=this.b.event,this.c=new s.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],i=Array.from(this.f.values());for(const r of i){const f=Array.from(r.values());for(const u of f){const w=await u.value;w&&typeof w!="string"&&t.push(w)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:i}of t.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,i,r,f,u){this.z(t,i,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:i,localAddress:r,privacy:f,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,i){(m(t)||c(t))&&(t=e.$Gw[0]);const r=this.D(t,i);if(r)return++r.refcount,r.value}openTunnel(t,i,r,f,u,w=!1,S,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${u}.`);const y=this.g??t;if(!y)return;if(i||(i="localhost"),f||(f=this.t),this.g&&this.n.has(r)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,i,r,f,u,w,S,D);return C?C.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(i,r),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(i,r);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(A);return(A.tunnelRemoteHost!==i||A.tunnelRemotePort!==r)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&A.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const i=this.f.get(t.tunnelRemoteHost);if(i){const r=i.get(t.tunnelRemotePort);r&&(r.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async y(t,i,r){if(r.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${i}.`);const f=r.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(i),f}}async closeTunnel(t,i){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${i} `);const r=this.f.get(t);if(r&&r.has(i)){const f=r.get(i);f.refcount=0,await this.y(t,i,f)}}z(t,i,r){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(i,{refcount:1,value:r})}async C(t,i){const r=this.f.get(t);if(r){const f=r.get(i),u=f?await f.value:void 0;(!u||typeof u=="string")&&r.delete(i),r.size===0&&this.f.delete(t)}}D(t,i){const r=[t];c(t)?(r.push(...e.$Gw),r.push(...e.$Iw)):m(t)&&r.push(...e.$Iw);const f=r.map(u=>this.f.get(u));for(const u of f){const w=u?.get(i);if(w)return w}}canTunnel(t){return!!P(t)}G(t,i,r,f,u,w,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${f}.`);const D=r;this.n.add(D);const y=f===void 0?r:f,C={elevationRequired:u?this.isPortPrivileged(y):!1},A={remoteAddress:{host:i,port:r},localAddressPort:f,privacy:w,public:w?w!==k.Private:void 0,protocol:S},p=t.forwardPort(A,C);return p?(this.z(i,r,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),p}};e.$Mw=n,e.$Mw=n=Xe([Ve(0,$.$ak),Ve(1,L.$aj)],n)}),define(Ee[295],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,s.$Gi)("IUriIdentityService")}),define(Ee[296],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nw=void 0,e.$Nw=(0,s.$Gi)("editSessionIdentityService");var h;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Ee[297],Se([1,0,15]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=h,e.$5M=I,e.$6M=T,e.$7M=L,e.$8M=R;function h($){return $.scheme!==s.Schemas.file&&$.scheme!==s.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(a=>h(a.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function T($){return I($)?.scheme}function L($){return I($)?.authority}function R($){return I($)!==void 0}}),define(Ee[46],Se([1,0,233,17,85,23,2,5,15]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=a,e.$Ri=k,e.$Ui=E,e.$Vi=l,e.$Wi=P,e.$Xi=c,e.$Yi=m,e.$2i=n,e.$7i=o,e.$8i=t,e.$0i=i,e.$$i=r,e.$_i=f,e.$Pi=(0,R.$Gi)("contextService");function a(u){const w=u;return typeof w?.id=="string"&&L.URI.isUri(w.uri)}function k(u){return typeof u?.id=="string"&&!a(u)&&!l(u)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function E(u,w){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,h.$qc)(u)}:w?e.$Si:e.$Ti;const S=u;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function l(u){const w=u;return typeof w?.id=="string"&&L.URI.isUri(w.configPath)}function P(u){const w=u;if(w?.uri)return{id:w.id,uri:L.URI.revive(w.uri)};const S=u;if(S?.configPath)return{id:S.id,configPath:L.URI.revive(S.configPath)};if(u?.id)return{id:u.id}}var b;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function c(u){const w=u;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function m(u){const w=u;return!!(w&&typeof w=="object"&&L.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class d{constructor(w,S,D,y,C){this.h=w,this.j=D,this.k=y,this.l=C,this.c=I.$Mi.forUris(this.l,()=>!0),this.folders=S}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=I.$Mi.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=d;class g{constructor(w,S){this.raw=S,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$hh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=g;function n(u){return new g({uri:u,index:0,name:(0,T.$dh)(u)},{uri:u.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,s.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function o(u,w){return T.$$g.isEqualOrParent(u,w.untitledWorkspacesHome)}function t(u){let w;return L.URI.isUri(u)?w=u:w=u.configuration,w?.scheme===$.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.$9i}function r(u,w){return!o(u,w)&&!t(u)}function f(u){return(typeof u=="string"?(0,h.$rc)(u):(0,T.$fh)(u))===e.$4i}}),define(Ee[151],Se([1,0,60,4,3,23,2,232,145,28,5,12,46,29,295,9,32,13,18]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=o,e.$Nl=t,e.$Ol=i;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const w=u;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&L.URI.isUri(w.location)&&L.URI.isUri(w.globalStorageHome)&&L.URI.isUri(w.settingsResource)&&L.URI.isUri(w.keybindingsResource)&&L.URI.isUri(w.tasksResource)&&L.URI.isUri(w.snippetsHome)&&L.URI.isUri(w.extensionsResource))}e.$Ml=(0,k.$Gi)("IUserDataProfilesService");function t(u,w){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:L.URI.revive(u.location).with({scheme:w}),globalStorageHome:L.URI.revive(u.globalStorageHome).with({scheme:w}),settingsResource:L.URI.revive(u.settingsResource).with({scheme:w}),keybindingsResource:L.URI.revive(u.keybindingsResource).with({scheme:w}),tasksResource:L.URI.revive(u.tasksResource).with({scheme:w}),snippetsHome:L.URI.revive(u.snippetsHome).with({scheme:w}),extensionsResource:L.URI.revive(u.extensionsResource).with({scheme:w}),cacheHome:L.URI.revive(u.cacheHome).with({scheme:w}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,w,S,D,y,C){return{id:u,name:w,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,T.$hh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,T.$hh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,T.$hh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,T.$hh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,T.$hh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,T.$hh)(S,"extensions.json"),cacheHome:(0,T.$hh)(D,u),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let r=class extends I.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,S,D,y){super(),this.t=w,this.u=S,this.w=D,this.y=y,this.f=!0,this.h=this.B(new h.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Dc,workspaces:new P.$Dc,emptyWindows:new Map},this.profilesHome=(0,T.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),S=[w];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,g.$gg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(i((0,T.$eh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},w))}}catch(C){this.y.error(C)}const D=new P.$Dc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[A,p]of Object.entries(C.workspaces)){const v=L.URI.parse(A),F=S.find(N=>N.id===p);F&&D.set(v,F)}if(C.emptyWindows)for(const[A,p]of Object.entries(C.emptyWindows)){const v=S.find(F=>F.id===p);v&&y.set(A,v)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:D,emptyWindows:y}}return this.z}D(){const w=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const S="Temp",D=new RegExp(`${(0,d.$jf)(S)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const p=D.exec(A.name),v=p?parseInt(p[1]):0;y=v>y?v:y}const C=`${S} ${y+1}`;return this.createProfile((0,s.$uj)((0,m.$3g)()).toString(16),C,{transient:!0},w)}async createNamedProfile(w,S,D){return this.createProfile((0,s.$uj)((0,m.$3g)()).toString(16),w,S,D)}async createProfile(w,S,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(w,S,D);return y&&await this.setProfileForWorkspace(y,C),C}async F(w,S,D){if(!(0,g.$gg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===S||v.id===w))throw new Error(`Profile with ${S} name already exists`);const A=i(w,S,(0,T.$hh)(this.profilesHome,w),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const p=[];return this.j.fire({profile:A,join(v){p.push(v)}}),await c.Promises.settled(p),this.I([A],[],[]),A}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===w.id);if(!D)throw new Error(`Profile '${w.name}' does not exist`);return D=i(D.id,S.name??D.name,D.location,this.g,{shortName:S.shortName??D.shortName,icon:S.icon===null?void 0:S.icon??D.icon,transient:S.transient??D.isTransient,useDefaultFlags:S.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===w.id);if(!S)throw new Error(`Profile '${w.name}' does not exist`);const D=[];this.m.fire({profile:S,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,a.$rl)(y)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===S.id);if(!D)throw new Error(`Profile '${S.name}' does not exist`);this.L(w,D)}unsetWorkspace(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(S=>S.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(w.map(S=>this.removeProfile(S)))}getProfileForWorkspace(w){const S=this.G(w),D=L.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return D||((0,l.$Qi)(w)?this.s.folders.get(w.uri):(0,l.$Vi)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,l.$Qi)(w)?w.uri:(0,l.$Vi)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,w.location)))}I(w,S,D){const y=[...this.profiles,...w],C=[],A=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||S.some(F=>p.id===F.id))continue;p=D.find(F=>p.id===F.id)??p;const v=A.find(F=>p.id===F.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(p.id===N.id){this.L({id:F},p);break}for(const[F,N]of this.s.workspaces.entries())if(p.id===N.id){this.L({id:"",configPath:F},p);break}for(const[F,N]of this.s.folders.entries())if(p.id===N.id){this.L({id:"",uri:F},p);break}}C.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(w,S,D)}J(w,S,D){this.h.fire({added:w,removed:S,updated:D,all:this.profiles})}L(w,S,D){if(D=S?.isTransient?!0:D,D)(0,l.$Qi)(w)?(this.s.folders.delete(w.uri),S&&this.s.folders.set(w.uri,S)):(0,l.$Vi)(w)?(this.s.workspaces.delete(w.configPath),S&&this.s.workspaces.set(w.configPath,S)):(this.s.emptyWindows.delete(w.id),S&&this.s.emptyWindows.set(w.id,S));else{this.L(w,void 0,!0);const y=this.G(w);L.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const w={};for(const[D,y]of this.C.workspaces.entries())w[D.toString()]=y.id;const S={};for(const[D,y]of this.C.emptyWindows.entries())S[D.toString()]=y.id;this.R({workspaces:w,emptyWindows:S}),this.z=void 0}N(w){const S={},D=this.D();if(w.workspaces)for(const[C,A]of Object.entries(w.workspaces)){const p=L.URI.parse(A);S[C]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}const y={};if(w.emptyWindows)for(const[C,A]of Object.entries(w.emptyWindows)){const p=L.URI.parse(A);y[C]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Pl=r,e.$Pl=r=Xe([Ve(0,$.$Ni),Ve(1,a.$al),Ve(2,b.$Kl),Ve(3,E.$ak)],r);class f extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Ql=f}),define(Ee[152],Se([1,0,9,4,3,62,18,210,5,151]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=P,e.$jq=c,e.$lq=d,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,$.$Gi)("storageService");var k;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var E;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var l;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function P(g){const n=g.get(e.$fq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class b extends I.$Xc{static{this.a=60*1e3}constructor(n={flushInterval:b.a}){super(),this.m=n,this.b=this.B(new h.$qe),this.c=this.B(new h.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new s.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,t){return h.Event.filter(this.b.event,i=>i.scope===n&&(o===void 0||i.key===o),t)}n(){this.j.value=(0,s.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:t,external:i}=o;if(t===e.$fq){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:t,target:this.J(n)[t],external:i})}w(n){this.f.fire({reason:n})}get(n,o,t){return this.P(o)?.get(n,t)}getBoolean(n,o,t){return this.P(o)?.getBoolean(n,t)}getNumber(n,o,t){return this.P(o)?.getNumber(n,t)}getObject(n,o,t){return this.P(o)?.getObject(n,t)}storeAll(n,o){this.y(()=>{for(const t of n)this.store(t.key,t.value,t.scope,t.target,o)})}store(n,o,t,i,r=!1){if((0,L.$pg)(o)){this.remove(n,t,r);return}this.y(()=>{this.z(n,t,i),this.P(t)?.set(n,o,r)})}remove(n,o,t=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,t)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const t=[],i=this.J(n);for(const r of Object.keys(i))i[r]===o&&t.push(r);return t}z(n,o,t,i=!1){const r=this.J(o);typeof t=="number"?r[n]!==t&&(r[n]=t,this.P(o)?.set(e.$fq,JSON.stringify(r),i)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$fq,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?P(o):Object.create(null)}isNew(n){return this.getBoolean(e.$eq,n)===!0}async flush(n=k.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),t=this.P(E.PROFILE),i=this.P(E.WORKSPACE);switch(n){case k.NONE:await s.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await s.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return d(n,o,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(k.NONE),(0,a.$Ll)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||c(o)&&c(n))}N(n,o,t){this.y(()=>{const i=new Set;for(const[r,f]of n)i.add(r),o.get(r)!==f&&this.u(t,{key:r,external:!0});for(const[r]of o.items)i.has(r)||this.u(t,{key:r,external:!0})})}}e.$iq=b;function c(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class m extends b{constructor(){super(),this.U=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$kq=m;async function d(g,n,o,t,i,r){const f=v=>{try{return JSON.parse(v)}catch{return v}},u=new Map,w=new Map;g.forEach((v,F)=>{u.set(F,v),w.set(F,f(v))});const S=new Map,D=new Map;n.forEach((v,F)=>{S.set(F,v),D.set(F,f(v))});const y=new Map,C=new Map;o.forEach((v,F)=>{y.set(F,v),C.set(F,f(v))}),console.group(t!==i?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(u.forEach((v,F)=>{A.push({key:F,value:v})}),console.table(A),console.groupEnd(),console.log(w),t!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const v=[];S.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${r})`);const p=[];y.forEach((v,F)=>{p.push({key:F,value:v})}),console.table(p),console.groupEnd(),console.log(C)}}),define(Ee[119],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;class s{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const T=this.c++;return this.b.set(T,I),this.e(),T}get(I,T){return this.b.has(I)?this.b.get(I)[T]:void 0}delete(I){this.b.delete(I),this.e()}e(){s.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$noc=s}),define(Ee[63],Se([1,0,15,23,28,5]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0;class L{constructor(){this.a=new Set(Object.keys(s.Schemas)),this.b=new Map,this.extUri=new h.$9g($=>{const a=this.b.get($.scheme);return!(a===void 0||a&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,a){a===null?this.b.delete($.scheme):this.b.set($.scheme,a)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$soc=L,e.$toc=(0,T.$Gi)("IExtHostFileSystemInfo")}),define(Ee[30],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,s.$Gi)("IExtHostInitDataService")}),define(Ee[298],Se([1,0,238,12,278,30]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;let L=class extends I.$oR{constructor($,a,k){const E=k.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",l=k.remote.isRemote?(0,s.localize)(0,null):$?(0,s.localize)(1,null):(0,s.localize)(2,null);super(a.createLogger(E,{name:l}))}};e.$Bqc=L,e.$Bqc=L=Xe([Ve(1,h.$bk),Ve(2,T.$eQ)],L)}),define(Ee[299],Se([1,0,9]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0;class h{constructor(L,R,$){this.h=new Map,this.a=L,this.b=R,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new s.$Sh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const k of a.values())k.complete()}catch(k){for(const E of a.values())E.error(k)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,R){let $=this.f[L];return typeof $>"u"&&($=R),$}update(L,R){this.f[L]=R;const $=this.h.get(L);if($!==void 0)return $.p;const a=new s.$4h;return this.h.set(L,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$$oc=h;class I extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this.j=L}}e.$_oc=I}),define(Ee[300],Se([1,0,4,2]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class I{constructor(L){this.c=L,this.a=new s.$ne,this.onDidSaveNotebookDocument=this.a.event,this.b=new s.$ne,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,R,$,a){const E=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(R.value,$,a);this.b.fire(E)}$acceptDirtyStateChanged(L,R){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(R.apiNotebook)}}e.$6pc=I}),define(Ee[20],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,s.$Gi)("IExtHostRpcService");class h{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$2P=h}),define(Ee[301],Se([1,0,24,4,3]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0;class T{#e;constructor(R,$){this.disposables=new I.$Wc,this.a=s.$rn.toKey(R.identifier),this.#e=$,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this.a),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$ipc=T}),define(Ee[73],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0,e.$Ioc=(0,s.$Gi)("IURITransformerService");class h{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Joc=h}),define(Ee[302],Se([1,0,303,413,414,67,2,12,415]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=k,s=We(s),h=We(h),I=We(I),T=We(T);const a=!1;function k(n,o,t,i,r,f){const u=f.environment.useHostProxy,w=typeof u=="boolean"?u:!f.remote.isRemote,S={resolveProxy:C=>n.resolveProxy(C),lookupProxyAuthorization:m.bind(void 0,i,r,o,{},f.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>o.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>l(o),addCertificatesV2:()=>P(o),log:i,getLogLevel:()=>{const C=i.getLevel();switch(C){case R.LogLevel.Trace:return $.LogLevel.Trace;case R.LogLevel.Debug:return $.LogLevel.Debug;case R.LogLevel.Info:return $.LogLevel.Info;case R.LogLevel.Warning:return $.LogLevel.Warning;case R.LogLevel.Error:return $.LogLevel.Error;case R.LogLevel.Off:return $.LogLevel.Off;default:return A(C)}function A(p){return i.error("Unknown log level",p),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const C=[];if(f.remote.isRemote&&C.push((0,$.loadSystemCertificates)({log:i})),w){i.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=n.loadCertificates();A.then(p=>i.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),C.push(A)}return f.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(i.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),C.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(C)).flat()},env:process.env},D=(0,$.createProxyResolver)(S),y=E(S,D);return c(t,y)}function E(n,o){function t(i,r){return Object.assign(i.default||i,r)}return{http:t(s,(0,$.createHttpPatch)(n,s,o)),https:t(h,(0,$.createHttpPatch)(n,h,o)),net:t(T,(0,$.createNetPatch)(n,T)),tls:t(I,(0,$.createTlsPatch)(n,I))}}function l(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}function P(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}const b=new Map;function c(n,o){return n.getExtensionPathIndex().then(t=>{const i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(u,w,S){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const D=t.findSubstr(L.URI.file(w.filename));let y=b.get(D);if(y||b.set(D,y={}),!y[u]){const C=o[u];y[u]={...C}}return y[u]}})}async function m(n,o,t,i,r,f,u,w){const S=i[f];u&&(i[f]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${f}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${S}`);const D=u||S,y=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(g(o,y,r),y.some(C=>/^(Negotiate|Kerberos)( |$)/i.test(C))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const C=await new Promise((N,O)=>{ce(["kerberos"],N,O)}).then(We),A=new URL(f),p=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${A.hostname}`:`HTTP@${A.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${f}`,`spn:${p}`),"Negotiate "+await(await C.initializeClient(p)).step("")}catch(C){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",C)}}let d=!1;function g(n,o,t){d||!o.length||(d=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(i=>i.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Ee[304],Se([1,0,142]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=I;function h(T){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:T,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function I(T){return new s.$Mn(h(T))}});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[153],Se([1,0,248,18,2,3,5,37,28,15,51,202,44]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=c,e.$XF=m,e.$YF=d,e.$ZF=g,e.$1F=n,e.$2F=o,e.$3F=t,e.$4F=i,e.$5F=r,e.$8F=y,e.$9F=A,e.$0F=p,e.$$F=v,e.$_F=F,e.$aG=N,e.$bG=O,e.$cG=j,e.$dG=B,e.$fG=ee,e.$gG=ne,e.$hG=De,e.$iG=$e,l=jt(l),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var P;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var b;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function c(J){const U=J;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(J){const U=J;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function d(J,U,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===U&&J.matches(ae.input))return ae.getViewState()}function g(J){if(y(J))return!1;const U=J;return I.URI.isUri(U?.resource)}function n(J){if(y(J))return!1;const U=J;return U?.original!==void 0&&U.modified!==void 0}function o(J){if(y(J))return!1;const U=J;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function t(J){if(y(J)||n(J))return!1;const U=J;return U?.primary!==void 0&&U.secondary!==void 0}function i(J){if(y(J))return!1;const U=J;return U?U.resource===void 0||U.resource.scheme===a.Schemas.untitled||U.forceUntitled===!0:!1}function r(J){if(y(J))return!1;const U=J;return I.URI.isUri(U?.base?.resource)&&I.URI.isUri(U?.input1?.resource)&&I.URI.isUri(U?.input2?.resource)&&I.URI.isUri(U?.result?.resource)}var f;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class w{constructor(){this.a=new Map}registerSource(U,se){let ae=this.a.get(U);return ae||(ae={source:U,label:se},this.a.set(U,ae)),ae.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$6F=new w;var S;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors",J[J.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class D extends T.$Xc{}e.$7F=D;function y(J){return J instanceof D}function C(J){const U=J;return I.URI.isUri(U?.preferredResource)}function A(J){const U=J;return y(U?.primary)&&y(U?.secondary)}function p(J){const U=J;return y(U?.modified)&&y(U?.original)}function v(J,U,se,ae,te){return $e(ae,[(0,E.$qj)({id:"workbench.action.openLargeFile",label:(0,s.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};J.openEditor(U,le)}}),(0,E.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function F(J){return y(J?.editor)}function N(J){const U=J;return F(J)&&U?.group!==void 0}function O(J){const U=J;return typeof U?.groupId=="number"&&y(U.editor)}function j(J){return typeof J?.groupId=="number"}var z;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LABEL=2]="GROUP_LABEL",J[J.GROUP_LOCKED=3]="GROUP_LOCKED",J[J.EDITORS_SELECTION=4]="EDITORS_SELECTION",J[J.EDITOR_OPEN=5]="EDITOR_OPEN",J[J.EDITOR_CLOSE=6]="EDITOR_CLOSE",J[J.EDITOR_MOVE=7]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=9]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=11]="EDITOR_PIN",J[J.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",J[J.EDITOR_STICKY=13]="EDITOR_STICKY",J[J.EDITOR_DIRTY=14]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var V;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class K{getOriginalUri(U,se){if(!U)return;if(r(U))return e.$eG.getOriginalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(U);if(te&&le){if(se?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===V.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===V.PRIMARY?te:le}}if(n(U)||o(U)||t(U)||r(U))return;const ae=C(U)?U.preferredResource:U.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}a(U){return A(U)||t(U)?{primary:U.primary,secondary:U.secondary}:p(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,se){if(!U)return;if(r(U))return e.$eG.getCanonicalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(U);if(te&&le){if(se?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===V.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===V.PRIMARY?te:le}}if(n(U)||o(U)||t(U)||r(U))return;const ae=U.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}b(U,se){if(Array.isArray(se)){if(se.some(ae=>U.scheme===ae))return U}else if(se===U.scheme)return U}}var re;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.KEYBOARD=1]="KEYBOARD",J[J.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function B(J,U,se,ae){if(!J.isSticky(U))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$eG=new K;var G;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class X{constructor(){this.c=new Map,this.d=new Map}start(U){const se=this.a=U.get(L.$Fi);for(const[ae,te]of this.c)this.e(ae,te,se);this.c.clear()}e(U,se,ae){const te=ae.createInstance(se);this.d.set(U,te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,h.$rg)(this.b)}registerEditorSerializer(U,se){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,se,this.a):this.c.set(U,se),(0,T.$Vc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}R.$ro.add(e.$RF.EditorFactory,new X);async function ee(J,U,se){return!J||!J.length?[]:await Promise.all(J.map(async ae=>{const te=I.URI.revive(ae.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await U.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let ue=ae.exists,Z=ae.type;if(typeof ue!="boolean"||typeof Z!="number")try{Z=(await U.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch(pe){se.error(pe),ue=!1}if(!ue&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(Z===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return ue?{resource:te,options:oe}:{resource:te,options:oe,forceUntitled:!0}}))}var de;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function ne(J){const U=J;if(!U)return!1;const se=U;if(se.modified)return ne(se.modified);const ae=U;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function De(J){return(0,k.$sj)(J)}function $e(J,U,se){const ae=(0,k.$tj)(J,U);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(Ee[305],Se([1,0,4,249,5,3,29,37,25,83,294]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oG=e.ViewContentGroups=e.$mG=e.ViewContainerLocation=e.Extensions=e.$lG=e.$kG=e.$jG=void 0,e.$nG=P,e.$jG="views",e.$kG=(0,h.localize)(0,null),e.$lG=(0,k.$yx)("default-view-icon",a.$6j.window,(0,h.localize)(1,null));var E;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var l;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$mG=[l.Sidebar,l.Panel,l.AuxiliaryBar];function P(i){switch(i){case l.Sidebar:return"sidebar";case l.Panel:return"panel";case l.AuxiliaryBar:return"auxiliarybar"}}class b extends T.$Xc{constructor(){super(...arguments),this.c=this.B(new s.$ne),this.onDidRegister=this.c.event,this.f=this.B(new s.$ne),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(r,f,u){const w=this.get(r.id);if(w)return w;const S=r;return S.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,L.$Ac)(this.g,f,[]).push(S),u?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:f}),S}deregisterViewContainer(r){for(const f of this.g.keys()){const u=this.g.get(f),w=u?.indexOf(r);if(w!==-1){u?.splice(w,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:r,viewContainerLocation:f});return}}}get(r){return this.all.filter(f=>f.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(f=>this.getViewContainerLocation(f)===r)}}R.$ro.add(E.ViewContainersRegistry,new b);var c;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(c||(e.ViewContentGroups=c={}));function m(i,r){const f=i.group??c.More,u=r.group??c.More;return f!==u?f.localeCompare(u):(i.order??5)-(r.order??5)}class d extends T.$Xc{constructor(){super(...arguments),this.c=this.B(new s.$ne),this.onViewsRegistered=this.c.event,this.f=this.B(new s.$ne),this.onViewsDeregistered=this.f.event,this.g=this.B(new s.$ne),this.onDidChangeContainer=this.g.event,this.h=this.B(new s.$ne),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Kc}registerViews(r,f){this.registerViews2([{views:r,viewContainer:f}])}registerViews2(r){r.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(r)}deregisterViews(r,f){const u=this.s(r,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(r,f){for(const u of this.m.keys())if(u!==f){const w=this.s(r,u);w.length&&(this.r(w,f),this.g.fire({views:w,from:u,to:f}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const f of this.j){const u=(this.m.get(f)||[]).filter(w=>w.id===r)[0];if(u)return u}return null}getViewContainer(r){for(const f of this.j)if((this.m.get(f)||[]).filter(w=>w.id===r)[0])return f;return null}registerViewWelcomeContent(r,f){return this.n.add(r,f),this.h.fire(r),(0,T.$Vc)(()=>{this.n.delete(r,f),this.h.fire(r)})}registerViewWelcomeContent2(r,f){const u=new Map;for(const[w,S]of f)this.n.add(r,S),u.set(w,(0,T.$Vc)(()=>{this.n.delete(r,S),this.h.fire(r)}));return this.h.fire(r),u}getViewWelcomeContent(r){const f=[];return this.n.forEach(r,u=>f.push(u)),f.sort(m)}r(r,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const w of r){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));u.push(w)}}s(r,f){const u=this.m.get(f);if(!u)return[];const w=[],S=[];for(const D of u)r.includes(D)?w.push(D):S.push(D);return w.length&&(S.length?this.m.set(f,S):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),w}}R.$ro.add(E.ViewsRegistry,new d),e.$oG=(0,I.$Gi)("viewDescriptorService");var g;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(g||(e.ViewVisibilityState=g={}));var n;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(r,f){this.c=!1,this.d=!1,(0,$.$ho)(this,r),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const w=await f(u);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pG=o;class t extends Error{constructor(r){super((0,h.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$qG=t}),define(Ee[306],Se([1,0,250,36]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new h.$Xj("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(0,null)}),e.$vG=new h.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(1,null)}),e.$wG=new h.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(2,null)}),e.$xG=new h.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(3,null)}),e.$yG=new h.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4,null)}),e.$zG=new h.$Xj("chatResponse",!1,{type:"boolean",description:(0,s.localize)(5,null)}),e.$AG=new h.$Xj("chatRequest",!1,{type:"boolean",description:(0,s.localize)(6,null)}),e.$BG=new h.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(7,null)}),e.$CG=new h.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(8,null)}),e.$DG=new h.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(9,null)}),e.$EG=new h.$Xj("inChatInput",!1,{type:"boolean",description:(0,s.localize)(10,null)}),e.$FG=new h.$Xj("inChat",!1,{type:"boolean",description:(0,s.localize)(11,null)}),e.$GG=new h.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(12,null)}),e.$HG=new h.$Xj("chatCursorAtTop",!1),e.$IG=new h.$Xj("chatInputHasAgent",!1),e.$JG=new h.$Xj("chatLocation",void 0),e.$KG=new h.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,s.localize)(13,null)})}),define(Ee[307],Se([1,0,132,9,21,4,40,3,57,181,13,36,24,5,12,116,287,152,306]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=f,e.$PH=u;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function S(D){switch(D){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=S}(o||(e.ChatAgentLocation=o={})),e.$JH=(0,P.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new T.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=g.$GG.bindTo(this.f)}registerAgent(S,D){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const C=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||C.f.contextMatchesRules(E.$Ej.deserialize(v.when)))}};const p={data:D};return this.b.set(S,p),(0,R.$Vc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,D){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new i(y.data,D)),(0,R.$Vc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,D){S.isDynamic=!0;const y={data:S,impl:D};return this.b.set(S.id,y),this.d.fire(new i(S,D)),(0,R.$Vc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,D){return this.g.set(S,D),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,D,y){return await this.g.get(S)?.(D,y)??[]}updateAgent(S,D){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new i(y.data,y.impl))}getDefaultAgent(S){return(0,s.$ib)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(S))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const D=this.b.get(S);return!D?.data.when||this.f.contextMatchesRules(E.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(S){const D=L.Iterable.find(this.b.values(),y=>f(y.data)===S)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new i(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(D=>D.name===S)}agentHasDupeName(S){const D=this.getAgent(S);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(S,D,y,C,A){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return await p.impl.invoke(D,y,C,A)}async getFollowups(S,D,y,C,A){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(D,y,C,A):[]}};e.$KH=t,e.$KH=t=Xe([Ve(0,E.$Yj)],t);class i{constructor(S,D){this.b=S,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(S,D,y,C){return this.d.invoke(S,D,y,C)}async provideFollowups(S,D,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,D,y,C):[]}provideWelcomeMessage(S,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,D)}provideSampleQuestions(S,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,D)}}e.$LH=i,e.$MH=(0,P.$Gi)("chatAgentNameService");let r=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(S,D,y,C){if(this.g=D,this.h=y,this.i=C,this.e=(0,a.$8d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const A=C.get(n.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{C.remove(n.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,h.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},I.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$_p)(S);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(n.b,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(S){const D=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return D&&y}l(S,D){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(A=>(0,k.$Hf)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=r,e.$NH=r=n=Xe([Ve(0,c.$tk),Ve(1,m.$6p),Ve(2,b.$ak),Ve(3,d.$gq)],r);function f(w){return`${w.extensionId.value}.${w.id}`}function u(w){const S="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new l.$rn("")),(0,$.$di)(S)}}),define(Ee[308],Se([1,0,2,31,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$fH=T,e.$gH=L;function T(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof s.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(h.$Mt.isIRange)}function L(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(T)}var R;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var $;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$hH=(0,I.$Gi)("IChatService"),e.$iH="accessibility.voice.keywordActivation"}),define(Ee[154],Se([1,0,4,9,252]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mtb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new s.$ne,this.o=new s.$ne,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(R){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=R}onEvent(R){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=R}onRequest(R){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.u("response",R)}sendRequest(R,$,a,k){const E={command:R};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof k=="number"){const l=setTimeout(()=>{clearTimeout(l);const P=this.f.get(E.seq);if(P){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:R,message:(0,I.localize)(0,null,k,R)};P(b)}},k)}return a&&this.f.set(E.seq,a),E.seq}acceptMessage(R){this.k?this.k(R):(this.m.push(R),this.m.length===1&&this.s())}q(R,$){return R.type!=="event"||$.type!=="event"}async s(){let R;for(;this.m.length;){if((!R||this.q(this.m[0],R))&&await(0,h.$Hh)(0),R=this.m.shift(),!R)return;switch(R.type){case"event":this.j?.(R);break;case"request":this.g?.(R);break;case"response":{const $=R,a=this.f.get($.request_seq);a&&(this.f.delete($.request_seq),a($));break}}}}u(R,$){$.type=R,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach(($,a)=>R.set(a,$)),await(0,h.$Hh)(500),R.forEach(($,a)=>{$({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Mtb=T}),define(Ee[120],Se([1,0,2,253,36,5]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=$,e.$BK=k,h=We(h),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new I.$Xj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$xJ=new I.$Xj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$yJ=new I.$Xj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new I.$Xj(e.$zJ,"default",{type:"string",description:h.localize(3,null)}),e.$BJ=new I.$Xj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$CJ=new I.$Xj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$DJ=new I.$Xj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$EJ=new I.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$FJ=new I.$Xj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$GJ=new I.$Xj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$HJ=new I.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$IJ=new I.$Xj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$JJ=new I.$Xj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$KJ=new I.$Xj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$LJ=new I.$Xj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$MJ=new I.$Xj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$NJ=new I.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$OJ=new I.$Xj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$PJ=new I.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$QJ=new I.$Xj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$RJ=new I.$Xj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$SJ=new I.$Xj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$TJ=new I.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$UJ=new I.$Xj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$VJ=new I.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$WJ=new I.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$XJ=new I.$Xj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$YJ=new I.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$ZJ=new I.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$1J=new I.$Xj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$2J=new I.$Xj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$3J=new I.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$4J=new I.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$5J=new I.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$6J=new I.$Xj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$7J=new I.$Xj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$8J=new I.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$9J=new I.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$0J=new I.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$$J=new I.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$_J=new I.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$aK=new I.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$bK=new I.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$cK=new I.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$dK=new I.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$eK=new I.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$fK=new I.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$gK=new I.$Xj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$hK=new I.$Xj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$iK=new I.$Xj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$jK=new I.$Xj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$kK=new I.$Xj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$lK=new I.$Xj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$mK=new I.$Xj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$nK=new I.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$oK=new I.$Xj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$pK=new I.$Xj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$qK=new I.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$rK=new I.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$sK=new I.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$tK=new I.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const L=n=>h.localize(61,null,n);e.$uK=L,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var R;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(R||(e.State=R={}));function $(n){switch(n){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var a;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$AK="vscode-debug-memory";function k(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var P;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$CK=(0,T.$Gi)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var c;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var d;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(d||(e.IDebugVisualizationTreeItem=d={}));var g;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:s.URI.revive(o.iconPath.light),dark:s.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(g||(e.IDebugVisualization=g={}))}),define(Ee[309],Se([1,0,13,2,17,25,15,31,21,19]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=void 0,e.$UH=E,e.$VH=l,e.$WH=P,e.$XH=b,e.$YH=c,e.$ZH=m,e.$1H=d,e.$2H=n,e.$3H=i,e.$4H=r,e.$5H=u,e.$6H=S;const k=/{([^}]+)}/g;function E(y,C,A){return y.replace(k,function(p,v){return C&&v.length>0&&v[0]!=="_"?p:A&&A.hasOwnProperty(v)?A[v]:p})}function l(y){const C={};for(const A of Object.keys(y))A.startsWith("!")||(C[A]=y[A]);return C}function P(y){return y.configuration.request==="attach"&&!b(y)&&(!y.parentSession||P(y.parentSession))}function b(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,s.$Hf)(C,"extensionhost")||(0,s.$Hf)(C,"pwa-extensionhost")?y:y.parentSession?b(y.parentSession):void 0}function c(y){return y.type&&(y.label||y.program||y.runtime)}function m(y,C,A){let p,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(y);){const O=N.index+1,j=O+N[0].length;if(O<=C&&j>=A){p=N[0],v=O;break}}if(p){const O=/\w+/g;let j=null;for(;(j=O.exec(p))&&!(j.index+1+v+j[0].length>=A););j&&(p=p.substring(0,O.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function d(y,C,A,p){if(y.evaluatableExpressionProvider.has(C)){const v=y.evaluatableExpressionProvider.ordered(C),F=(0,a.$Kb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(C,A,p??$.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const O=F[0].range;return N||(N=C.getLineContent(A.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const v=C.getLineContent(A.lineNumber),{start:F,end:N}=m(v,A.column,A.column),O=v.substring(F-1,N);return{matchingExpression:O,range:new R.$Mt(A.lineNumber,F,A.lineNumber,F+O.length)}}return null}const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(g))}function o(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return h.URI.parse(y.path);if((0,I.$lc)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=h.URI.revive(y.path);if(C)return C.scheme===L.Schemas.file?C.fsPath:C.toString()}return y.path}function i(y,C){const A=C?o:t,p=(0,T.$eo)(y);return f(p,(v,F)=>{v&&F&&(F.path=A(F))}),p}function r(y,C){const A=C?o:t,p=(0,T.$eo)(y);return f(p,(v,F)=>{!v&&F&&(F.path=A(F))}),p}function f(y,C){switch(y.type){case"event":{const A=y;switch(A.event){case"output":C(!1,A.body.source);break;case"loadedSource":C(!1,A.body.source);break;case"breakpoint":C(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":C(!0,A.arguments.source);break;case"breakpointLocations":C(!0,A.arguments.source);break;case"source":C(!0,A.arguments.source);break;case"gotoTargets":C(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(p=>C(!1,p));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(p=>C(!1,p.source));break;case"loadedSources":A.body.sources.forEach(p=>C(!1,p));break;case"scopes":A.body.scopes.forEach(p=>C(!1,p.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(p=>C(!1,p.source));break;case"setBreakpoints":A.body.breakpoints.forEach(p=>C(!1,p.source));break;case"disassemble":A.body?.instructions.forEach(v=>C(!1,v.location));break;default:break}break}}}function u(y){return y.filter(C=>!C.presentation?.hidden).sort((C,A)=>C.presentation?A.presentation?C.presentation.group?A.presentation.group?C.presentation.group!==A.presentation.group?C.presentation.group.localeCompare(A.presentation.group):w(C.presentation.order,A.presentation.order):-1:A.presentation.group?1:w(C.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function w(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(A!=="none"&&(await C.saveAll(),A==="allEditorsInActiveGroup")){const p=C.activeEditorPane;p&&p.input.resource?.scheme===L.Schemas.untitled&&await C.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const D=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$7H=D}),define(Ee[310],Se([1,0,58,67,25,17,11,13,34,254,154]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Kqc=e.$Jqc=e.$Iqc=e.$Hqc=void 0,s=We(s),h=We(h),I=We(I),T=We(T),L=We(L),R=We(R),a=We(a);class E extends k.$Mtb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(d,g){this.l=g,this.p=Buffer.allocUnsafe(0),this.r=-1,d.on("data",n=>this.v(n))}sendMessage(d){if(this.l){const g=JSON.stringify(d);this.l.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${E.a}${g}`,"utf8")}}v(d){for(this.p=Buffer.concat([this.p,d]);;){if(this.r>=0){if(this.p.length>=this.r){const g=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(n){this.n.fire(new Error((n.message||n)+`
`+g))}continue}}else{const g=this.p.indexOf(E.a);if(g!==-1){const o=this.p.toString("utf8",0,g).split(E.b);for(const t of o){const i=t.split(E.i);i[0]==="Content-Length"&&(this.r=Number(i[1]))}this.p=this.p.slice(g+E.a.length);continue}}break}}}e.$Hqc=E;class l extends E{startSession(){return new Promise((d,g)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),d(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):g(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Iqc=l;class P extends l{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.$Jqc=P;class b extends l{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.path,d)}}e.$Kqc=b;class c extends E{constructor(d,g){super(),this.y=d,this.z=g}async startSession(){const d=this.y.command,g=this.y.args,n=this.y.options||{};try{if(d)if(T.$lc(d)){if(!await $.Promises.exists(d))throw new Error(a.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(a.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=I.$ho(I.$eo(process.env),n.env)),d==="node")if(Array.isArray(g)&&g.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(i.cwd=n.cwd);const r=s.fork(g[0],g.slice(1),i);if(!r.pid)throw new Error(a.localize(2,null,g[0]));this.x=r}else throw new Error(a.localize(3,null));else{const t={env:o};n.cwd&&(t.cwd=n.cwd),this.x=s.spawn(d,g,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,i)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),L.$i?new Promise((d,g)=>{const n=s.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,t,i){if(o)return g(o)});n.on("exit",d),n.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,g){if(!d)return;const n=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?n.runtime=T.$mc(g,d.runtime):n.runtime=d.runtime),d.runtimeArgs&&(n.runtimeArgs=d.runtimeArgs),d.program&&(T.$lc(d.program)?n.program=d.program:n.program=T.$mc(g,d.program)),d.args&&(n.args=d.args);const o=d;return o.win&&(n.win=c.A(o.win,g)),o.winx86&&(n.winx86=c.A(o.winx86,g)),o.windows&&(n.windows=c.A(o.windows,g)),o.osx&&(n.osx=c.A(o.osx,g)),o.linux&&(n.linux=c.A(o.linux,g)),n}static platformAdapterExecutable(d,g){let n=Object.create(null);g=g.toLowerCase();for(const u of d)if(u.contributes){const w=u.contributes.debuggers;w&&w.length>0&&w.filter(S=>typeof S.type=="string"&&R.$Hf(S.type,g)).forEach(S=>{const D=c.A(S,u.extensionLocation.fsPath);n=I.$ho(n,D,u.isBuiltin)})}let o;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.$i?o=n.win||n.windows:L.$j?o=n.osx:L.$k&&(o=n.linux),o=o||n;const t=o.program||n.program,i=o.args||n.args,r=o.runtime||n.runtime,f=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(f||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.$Lqc=c}),define(Ee[311],Se([1,0,58,33,11]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=L,e.$Nqc=$,s=We(s),I=We(I);function T(a,k){return new Promise((E,l)=>{let P="";const b=s.spawn(a,k);b.pid&&b.stdout.on("data",c=>{P+=c.toString()}),b.on("error",c=>{l(c)}),b.on("close",c=>{E(P)})})}async function L(a){if(a)if(I.$i){const k=await new Promise((E,l)=>{ce(["@vscode/windows-process-tree"],E,l)}).then(We);return new Promise(E=>{k.getProcessTree(a,l=>{E(!!l&&l.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(a)]).then(k=>{const E=k.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},k=>!0);return Promise.resolve(!0)}var R;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(R||(R={}));function $(a,k,E,l,P){a=a.trim().toLowerCase();let b;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?b=R.powershell:a.indexOf("cmd.exe")>=0?b=R.cmd:a.indexOf("bash")>=0?b=R.bash:I.$i?b=R.cmd:b=R.bash;let c,m=" ";switch(b){case R.powershell:if(c=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),l){const d=(0,h.$Lg)(l);d&&(m+=`${d}:; `),m+=`cd ${c(l)}; `}if(P)for(const d in P){const g=P[d];g===null?m+=`Remove-Item env:${d}; `:m+=`\${env:${d}}='${g}'; `}if(k.length>0){const d=k.shift(),g=E?d:c(d);m+=g[0]==="'"?`& ${g} `:`${g} `;for(const n of k)m+=n==="<"||n===">"||E?n:c(n),m+=" "}break;case R.cmd:if(c=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>d.includes(g))||d.length===0?`"${d}"`:d),l){const d=(0,h.$Lg)(l);d&&(m+=`${d}: && `),m+=`cd ${c(l)} && `}if(P){m+='cmd /C "';for(const d in P){let g=P[d];g===null?m+=`set "${d}=" && `:(g=g.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${d}=${g}" && `)}}for(const d of k)m+=d==="<"||d===">"||E?d:c(d),m+=" ";P&&(m+='"');break;case R.bash:{c=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g);const d=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(l&&(m+=`cd ${c(l)} ; `),P){m+="/usr/bin/env";for(const g in P){const n=P[g];n===null?m+=` -u ${d(g)}`:m+=` ${d(`${g}=${n}`)}`}m+=" "}for(const g of k)m+=g==="<"||g===">"||E?g:c(g),m+=" ";break}}return m}}),define(Ee[312],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.CellExecutionUpdateType=void 0;var h;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$KK=(0,s.$Gi)("INotebookExecutionService")}),define(Ee[313],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ProxyKernelState=e.$MK=void 0,e.$MK=100;var h;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$NK=(0,s.$Gi)("INotebookKernelService"),e.$OK=(0,s.$Gi)("INotebookKernelHistoryService")}),define(Ee[314],Se([1,0,3,31,55,215,107]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CZb=void 0;class R extends s.$Xc{constructor(a,k,E){super(),this._source=a,this.b=k,this.c=E,this.a=void 0}f(a){const k=a.getLineCount();return new h.$Mt(1,1,k,this.g(a,k))}g(a,k){if(k<1||k>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const a=new T.$mD;a.acceptChunk(this._source);const k=a.finish(!0),{textBuffer:E,disposable:l}=k.create(I.DefaultEndOfLine.LF);this.b=E,this.B(l)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const k=new T.$mD;k.acceptChunk(a);const E=k.finish(!0),{textBuffer:l,disposable:P}=E.create(I.DefaultEndOfLine.LF);return this.B(P),l})),this.a}findInInputs(a){const E=new L.$aD(a,!1,!1,null).parseSearchRequest();if(!E)return[];const l=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(l,E,!0,5e3)}findInOutputs(a){const E=new L.$aD(a,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(l=>{const P=l.findMatchesLineByLine(this.f(l),E,!0,5e3);if(P.length!==0)return{textBuffer:l,matches:P}}).filter(l=>!!l):[]}}e.$CZb=R}),define(Ee[74],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(T){T.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var h;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class I{static fromExtHostTestItem(L,R,$=L.parent){if(L._isRoot)return new I([R]);const a=[L.id];for(let k=$;k&&k.id!==R;k=k.parent)a.push(k.id);return a.push(R),new I(a.reverse())}static isRoot(L){return!L.includes(s.Delimiter)}static root(L){const R=L.indexOf(s.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new I(L.split(s.Delimiter))}static join(L,R){return new I([...L.path,R])}static joinToString(L,R){return L.toString()+s.Delimiter+R}static parentId(L){const R=L.lastIndexOf(s.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(s.Delimiter);return R===-1?L:L.slice(R+s.Delimiter.length)}static isChild(L,R){return R.startsWith(L)&&R[L.length]===s.Delimiter}static compare(L,R){return L===R?h.IsSame:I.isChild(L,R)?h.IsChild:I.isChild(R,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let $=0;for(;$<L-1;){for(let a=1;a<L;a++){const k=R(a-1),E=R(a);if(k.path[$]!==E.path[$])return $}$++}return $}constructor(L,R=L.length){if(this.path=L,this.d=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new I(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new I(this.path,L)}compare(L){if(typeof L=="string")return I.compare(this.toString(),L);for(let R=0;R<L.d&&R<this.d;R++)if(L.path[R]!==this.path[R])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=s.Delimiter,this.c+=this.path[L]}return this.c}}e.$TI=I}),define(Ee[75],Se([1,0,2,54,31,74]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var L;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$UI={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$VI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const a=z=>"runId"in z;e.$WI=a;var k;(function(z){z.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),z.deserialize=(M,V)=>({range:I.$Mt.lift(V.range),uri:M.asCanonicalUri(s.URI.revive(V.uri))})})(k||(e.IRichLocation=k={}));var E;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var l;(function(z){z.serialize=M=>({message:M.message,type:E.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&k.serialize(M.location)}),z.deserialize=(M,V)=>({message:V.message,type:E.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&k.deserialize(M,V.location)})})(l||(e.ITestErrorMessage=l={}));const P=(z,M)=>`${M?"s":"e"}${z}`;e.$XI=P;var b;(function(z){z.serialize=M=>({message:M.message,type:E.Output,offset:M.offset,length:M.length,location:M.location&&k.serialize(M.location)}),z.deserialize=(M,V)=>({message:V.message,type:E.Output,offset:V.offset,length:V.length,location:V.location&&k.deserialize(M,V.location)})})(b||(e.ITestOutputMessage=b={}));var c;(function(z){z.serialize=M=>M.type===E.Error?l.serialize(M):b.serialize(M),z.deserialize=(M,V)=>V.type===E.Error?l.deserialize(M,V):b.deserialize(M,V)})(c||(e.ITestMessage=c={}));var m;(function(z){z.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),z.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(c.serialize)}),z.deserialize=(M,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(K=>c.deserialize(M,K))})})(m||(e.ITestTaskState=m={}));const d="\0",g=(z,M)=>z+d+M;e.$YI=g;const n=z=>{const M=z.indexOf(d);return{ctrlId:z.slice(0,M),tagId:z.slice(M+1)}};e.$ZI=n;var o;(function(z){z.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),z.deserialize=(M,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?M.asCanonicalUri(s.URI.revive(V.uri)):void 0,range:V.range?I.$Mt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(o||(e.ITestItem=o={}));var t;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var i;(function(z){z.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),z.deserialize=(M,V)=>({controllerId:T.$TI.root(V.item.extId),expand:V.expand,item:o.deserialize(M,V.item)})})(i||(e.InternalTestItem=i={}));var r;(function(z){z.serialize=M=>{let V;return M.item&&(V={},M.item.label!==void 0&&(V.label=M.item.label),M.item.tags!==void 0&&(V.tags=M.item.tags),M.item.busy!==void 0&&(V.busy=M.item.busy),M.item.uri!==void 0&&(V.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(V.range=M.item.range?.toJSON()),M.item.description!==void 0&&(V.description=M.item.description),M.item.error!==void 0&&(V.error=M.item.error),M.item.sortText!==void 0&&(V.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:V}},z.deserialize=M=>{let V;return M.item&&(V={},M.item.label!==void 0&&(V.label=M.item.label),M.item.tags!==void 0&&(V.tags=M.item.tags),M.item.busy!==void 0&&(V.busy=M.item.busy),M.item.range!==void 0&&(V.range=M.item.range?I.$Mt.lift(M.item.range):null),M.item.description!==void 0&&(V.description=M.item.description),M.item.error!==void 0&&(V.error=M.item.error),M.item.sortText!==void 0&&(V.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:V}}})(r||(e.ITestItemUpdate=r={}));const f=(z,M)=>{M.expand!==void 0&&(z.expand=M.expand),M.item!==void 0&&(z.item=z.item?Object.assign(z.item,M.item):M.item)};e.$1I=f;var u;(function(z){z.serializeWithoutMessages=M=>({...i.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(m.serializeWithoutMessages)}),z.serialize=M=>({...i.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(m.serialize)}),z.deserialize=(M,V)=>({...i.deserialize(M,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(K=>m.deserialize(M,K)),retired:!0})})(u||(e.TestResultItem=u={}));var w;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(M,V)=>{M.covered+=V.covered,M.total+=V.total}})(w||(e.ICoverageCount=w={}));var S;(function(z){z.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testIds:M.testIds,uri:M.uri.toJSON()}),z.deserialize=(M,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:M.asCanonicalUri(s.URI.revive(V.uri))}),z.empty=(M,V)=>({id:M,uri:V,statement:w.empty()})})(S||(e.IFileCoverage=S={}));function D(z){return{...z,location:z.location?.toJSON()}}function y(z){return z.location=z.location?h.$Lt.isIPosition(z.location)?h.$Lt.lift(z.location):I.$Mt.lift(z.location):void 0,z}e.$2I=3;var C;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(C||(e.DetailType=C={}));var A;(function(z){z.serialize=M=>M.type===C.Declaration?v.serialize(M):F.serialize(M),z.deserialize=M=>M.type===C.Declaration?v.deserialize(M):F.deserialize(M)})(A||(e.CoverageDetails=A={}));var p;(function(z){z.serialize=D,z.deserialize=y})(p||(e.IBranchCoverage=p={}));var v;(function(z){z.serialize=D,z.deserialize=y})(v||(e.IDeclarationCoverage=v={}));var F;(function(z){z.serialize=M=>({...D(M),branches:M.branches?.map(p.serialize)}),z.deserialize=M=>({...y(M),branches:M.branches?.map(p.deserialize)})})(F||(e.IStatementCoverage=F={}));var N;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var O;(function(z){z.deserialize=(M,V)=>V.op===N.Add?{op:V.op,item:i.deserialize(M,V.item)}:V.op===N.Update?{op:V.op,item:r.deserialize(V.item)}:V.op===N.DocumentSynced?{op:V.op,uri:M.asCanonicalUri(s.URI.revive(V.uri)),docv:V.docv}:V,z.serialize=M=>M.op===N.Add?{op:M.op,item:i.serialize(M.item)}:M.op===N.Update?{op:M.op,item:r.serialize(M.item)}:M})(O||(e.TestsDiffOp=O={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const V=this.w();for(const K of M)switch(K.op){case N.Add:this.l(i.deserialize(this.k,K.item),V);break;case N.Update:this.p(r.deserialize(K.item),V);break;case N.Remove:this.q(K.itemId,V);break;case N.Retire:this.v(K.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(K.amount);break;case N.AddTag:this.c.set(K.tag.id,K.tag);break;case N.RemoveTag:this.c.delete(K.id);break}V.complete?.()}l(M,V){const K=T.$TI.parentId(M.item.extId)?.toString();let re;if(!K)re=this.x(M),this.g.add(re),this.f.set(M.item.extId,re);else if(this.f.has(K)){const B=this.f.get(K);B.children.add(M.item.extId),re=this.x(M,B),this.f.set(M.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return V.add?.(re),M.expand===t.BusyExpanding&&this.h++,re}p(M,V){const K=this.f.get(M.extId);if(K)return M.expand!==void 0&&(K.expand===t.BusyExpanding&&this.h--,M.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(K,M),V.update?.(K),K}q(M,V){const K=this.f.get(M);if(!K)return;const re=T.$TI.parentId(K.item.extId)?.toString();re?this.f.get(re).children.delete(K.item.extId):this.g.delete(K);const B=[[M]];for(;B.length;)for(const G of B.pop()){const X=this.f.get(G);X&&(B.push(X.children),this.f.delete(G),V.remove?.(X,X!==K),X.expand===t.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$3I=j}),define(Ee[315],Se([1,0,136,257,75]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$tGb=e.$sGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var L;(function(E){E.List="list",E.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const $={[I.TestResultState.Errored]:(0,h.localize)(0,null),[I.TestResultState.Failed]:(0,h.localize)(1,null),[I.TestResultState.Passed]:(0,h.localize)(2,null),[I.TestResultState.Queued]:(0,h.localize)(3,null),[I.TestResultState.Running]:(0,h.localize)(4,null),[I.TestResultState.Skipped]:(0,h.localize)(5,null),[I.TestResultState.Unset]:(0,h.localize)(6,null)},a=(E,l)=>(0,h.localize)(7,null,(0,s.$Zk)(E),$[l]);e.$sGb=a,e.$tGb={[I.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[I.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[I.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var k;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(k||(e.TestCommandId=k={}))}),define(Ee[121],Se([1,0,9,4,3,66,75,74]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var $;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const a=(g,n)=>g===n,E=Object.entries({range:(g,n)=>g===n?!0:!g||!n?!1:g.equalsRange(n),busy:a,label:a,description:a,error:a,sortText:a,tags:(g,n)=>!(g.length!==n.length||g.some(o=>!n.includes(o)))}),l=(g,n)=>{let o;for(const[t,i]of E)i(g[t],n[t])||(o?o[t]=n[t]:o={[t]:n[t]});return o};class P extends I.$Xc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new s.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new h.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,L.$1I)(o.item,n.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,L.$1I)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const t=this.tree.get(n);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===L.TestItemExpandState.Expandable){const i=this.M(t);return i.isOpen()?this.L(t,o-1):i.wait().then(()=>this.L(t,o-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(R.$TI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const t of o.ops)this.w(n,t);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,T.$hd)(o)}}y(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const t=R.$TI.fromExtHostTestItem(n,this.root.id,o?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==o?.actual&&this.s.getChildren(i.parent).delete(n.id);let r=this.tree.get(t.toString());if(!r){r={fullId:t,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(r.fullId.toString(),r),this.G(n,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.I(n,r,o);return}if(r.actual===n){this.H(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.O(t.toString()),this.z(n,o);const f=this.s.getChildren(r.actual),u=r.actual,w=l(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.resolveBarrier=void 0,r.expand=L.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,t.toString()),delete w.tags),this.w(r,{op:$.SetProp,update:w})),this.I(n,r,o);for(const[D,y]of f)this.s.getChildren(n).get(y.id)||this.O(R.$TI.joinToString(t,y.id));const S=r.expandLevels;S!==void 0&&queueMicrotask(()=>{r.expand===L.TestItemExpandState.Expandable&&(r.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(r.actual.uri)}C(n,o,t){const i=new Set(o.map(r=>r.id));for(const r of n)i.delete(r.id)||this.D(r);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:n.map(r=>(0,L.$YI)(this.s.controllerId,r.id))}}}),i.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$YI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$YI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,t){this.G(n,t);const i=this.s.getApiFor(n);i.parent=t?.actual,i.listener=r=>this.w(o,r),this.J(o)}I(n,o,t){this.H(n,o,t);for(const[i,r]of this.s.getChildren(n))this.z(r,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const t=[];for(const[i,r]of this.s.getChildren(n.actual)){const f=this.expand(R.$TI.joinToString(n.fullId,r.id),o);(0,s.$sh)(f)&&t.push(f)}if(t.length)return Promise.all(t).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new s.$Fh;return r.open(),r}n.expand=L.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new s.$Fh,t=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch(r){t(r)}return(0,s.$sh)(i)?i.catch(t).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const t=[o];for(;t.length;){const i=t.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.F(r.id);this.tree.delete(i.fullId.toString());for(const[r,f]of this.s.getChildren(i.actual))t.push(this.tree.get(R.$TI.joinToString(i.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$QP=P;class b extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$RP=b;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=c;class m extends Error{constructor(n,o,t){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=m;const d=(g,n,o)=>{let t=new Map;return{get size(){return t.size},forEach(i,r){for(const f of t.values())i.call(r,f,this)},[Symbol.iterator](){return t.entries()},replace(i){const r=new Map,f=new Set(t.keys()),u={op:$.Bulk,ops:[]};for(const w of i){if(!(w instanceof o))throw new c(w.id);const S=n(w).controllerId;if(S!==g.controllerId)throw new m(w.id,S,g.controllerId);if(r.has(w.id))throw new b(w.id);r.set(w.id,w),f.delete(w.id),u.ops.push({op:$.Upsert,item:w})}for(const w of f.keys())u.ops.push({op:$.RemoveChild,id:w});g.listener?.(u),t=r},add(i){if(!(i instanceof o))throw new c(i.id);t.set(i.id,i),g.listener?.({op:$.Upsert,item:i})},delete(i){t.delete(i)&&g.listener?.({op:$.RemoveChild,id:i})},get(i){return t.get(i)},toJSON(){return Array.from(t.values())}}};e.$UP=d}),define(Ee[155],Se([1,0,121]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const h=new WeakMap,I=(L,R)=>{const $={controllerId:R};return h.set(L,$),$};e.$VP=I;const T=L=>{const R=h.get(L);if(!R)throw new s.$SP(L?.id||"<unknown>");return R};e.$WP=T}),define(Ee[122],Se([1,0,27,15,2]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gDb=e.$fDb=e.$eDb=void 0,e.$hDb=T,e.$iDb=R,e.$eDb="vscode-cdn.net",e.$fDb=`vscode-resource.${e.$eDb}`,e.$gDb=`'self' https://*.${e.$eDb}`;function T($,a){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(a&&a.authority&&a.isRemote&&$.scheme===h.Schemas.file&&($=I.URI.from({scheme:h.Schemas.vscodeRemote,authority:a.authority,path:$.path})),I.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$fDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function L($){return $.replace(/./g,a=>{const k=a.charCodeAt(0);return k>=s.CharCode.a&&k<=s.CharCode.z||k>=s.CharCode.A&&k<=s.CharCode.Z||k>=s.CharCode.Digit0&&k<=s.CharCode.Digit9?a:"-"+k.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(a,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ee[316],Se([1,0,4,3,122]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0;class T{constructor(R,$,a){this.d=R,this.e=$,this.f=a,this.a=0,this.b=new h.$Wc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const k=$.getVisibleTextEditors();for(const E of this.c.values())k.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,$,a,k,E){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===R){l=n;break}if(!l)throw new Error("not a visible editor");const P=this,b=this.a++,c=new s.$ne,m=new s.$ne,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,I.$hDb)(n,P.f)}get cspSource(){return I.$gDb}set options(n){this.b=n,P.d.$setOptions(b,n)}get options(){return this.b}set html(n){this.a=n,P.d.$setHtml(b,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return P.d.$postMessage(b,n)}},g=new class{constructor(){this.editor=R,this.line=$,this.height=a,this.webview=d,this.onDidDispose=m.event}dispose(){P.c.has(b)&&(P.c.delete(b),P.d.$disposeEditorInset(b),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,$+1,a,k||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:R,inset:g,onDidReceiveMessage:c}),g}$onDidDispose(R){const $=this.c.get(R);$&&$.inset.dispose()}$onDidReceiveMessage(R,$){this.c.get(R)?.onDidReceiveMessage.fire($)}}e.$Goc=T}),define(Ee[156],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0,e.$wM="__",e.$xM=(0,s.$Gi)("IAuthenticationService"),e.$yM=(0,s.$Gi)("IAuthenticationExtensionsService")}),define(Ee[317],Se([1,0,5]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,s.$Gi)("configurationResolverService");var h;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class I extends Error{constructor(L,R){super(R),this.variable=L}}e.$PQ=I}),define(Ee[318],Se([1,0,17,56,18,25,11,110,258,317,13]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,s=We(s),h=We(h),I=We(I),T=We(T);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,b,c,m){this.h=new Map,this.a=P,this.b=b,this.g=c,m&&(this.c=m.then(d=>this.i(d)))}i(P){if(L.$i){const b=Object.create(null);return Object.keys(P).forEach(c=>{b[c.toLowerCase()]=P[c]}),b}return P}resolveWithEnvironment(P,b,c){return this.l({env:this.i(P),userHome:void 0},b?b.uri:void 0,c)}async resolveAsync(P,b){const c={env:await this.c,userHome:await this.g};return this.l(c,P?P.uri:void 0,b)}async j(P,b,c,m){const d=T.$eo(b);L.$i&&d.windows?Object.keys(d.windows).forEach(n=>d[n]=d.windows[n]):L.$j&&d.osx?Object.keys(d.osx).forEach(n=>d[n]=d.osx[n]):L.$k&&d.linux&&Object.keys(d.linux).forEach(n=>d[n]=d.linux[n]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,P?P.uri:void 0,d,c,m)}async resolveAnyAsync(P,b,c){return this.j(P,b,c)}async resolveAnyMap(P,b,c){const m=new Map;return{newConfig:await this.j(P,b,c,m),resolvedVariables:m}}resolveWithInteractionReplace(P,b,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,b,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,b){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,b)}async l(P,b,c,m,d){if(I.$gg(c))return this.m(P,b,c,m,d);if(Array.isArray(c))return Promise.all(c.map(g=>this.l(P,b,g,m,d)));if(I.$ig(c)){const g=Object.create(null),n=await Promise.all(Object.keys(c).map(async o=>[await this.m(P,b,o,m,d),await this.l(P,b,c[o],m,d)]));for(const[o,t]of n)g[o]=t;return g}return c}m(P,b,c,m,d){return(0,k.$zf)(c,E.VARIABLE_REGEXP,async(g,n)=>{if(n.includes(E.VARIABLE_LHS))return g;let o=await this.o(P,g,n,b,m);return d?.set(n,o),o!==g&&I.$gg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(P,b,o,m,d)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,b,c,m,d){let g;const n=c.split(":");n.length>1&&(c=n[0],g=n[1]);const o=r=>{const f=this.a.getFilePath();if(f)return(0,R.$Xw)(f);throw new a.$PQ(r,(0,$.localize)(0,null,b))},t=r=>{const f=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.$Xw)(u)}throw new a.$PQ(r,(0,$.localize)(1,null,b,s.$qc(f)))},i=r=>{if(g){const f=this.a.getFolderUri(g);if(f)return f;throw new a.$PQ(r,(0,$.localize)(2,null,b,g))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(r,(0,$.localize)(3,null,b)):new a.$PQ(r,(0,$.localize)(4,null,b))};switch(c){case"env":if(g){if(P.env){const r=P.env[L.$i?g.toLowerCase():g];if(I.$gg(r))return r}return""}throw new a.$PQ(a.VariableKind.Env,(0,$.localize)(5,null,b));case"config":if(g){const r=this.a.getConfigurationValue(m,g);if(I.$pg(r))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(6,null,b,g));if(I.$ig(r))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(7,null,b,g));return r}throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(8,null,b));case"command":return this.p(a.VariableKind.Command,b,g,d,"command");case"input":return this.p(a.VariableKind.Input,b,g,d,"input");case"extensionInstallFolder":if(g){const r=await this.a.getExtension(g);if(!r)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,b,g));return this.n(r.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,b));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,R.$Xw)(this.n(i(a.VariableKind.WorkspaceFolder)));case"cwd":return m||g?(0,R.$Xw)(this.n(i(a.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Xw)(s.$qc(this.n(i(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,$.localize)(11,null,b))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new a.$PQ(a.VariableKind.LineNumber,(0,$.localize)(12,null,b))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new a.$PQ(a.VariableKind.SelectedText,(0,$.localize)(13,null,b))}case"file":return o(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.$qc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||g?s.$oc(this.n(i(a.VariableKind.RelativeFile)),o(a.VariableKind.RelativeFile)):o(a.VariableKind.RelativeFile);case"relativeFileDirname":{const r=s.$pc(o(a.VariableKind.RelativeFileDirname));if(m||g){const f=s.$oc(this.n(i(a.VariableKind.RelativeFileDirname)),r);return f.length===0?".":f}return r}case"fileDirname":return s.$pc(o(a.VariableKind.FileDirname));case"fileExtname":return s.$rc(o(a.VariableKind.FileExtname));case"fileBasename":return s.$qc(o(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=s.$qc(o(a.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-s.$rc(r).length)}case"fileDirnameBasename":return s.$qc(s.$pc(o(a.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||b}case"execInstallFolder":{const r=this.a.getAppRoot();return r||b}case"pathSeparator":case"/":return s.sep;default:try{const r=g?`${c}:${g}`:c;return this.p(a.VariableKind.Unknown,b,r,d,void 0)}catch{return b}}}}p(P,b,c,m,d){if(c&&m){const g=d===void 0?m[c]:m[d+":"+c];if(typeof g=="string")return g;throw new a.$PQ(P,(0,$.localize)(14,null,b))}return b}}e.$5Q=E}),define(Ee[157],Se([1,0,5,153]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=l,e.$mE=P,e.$jE=(0,s.$Gi)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var T;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var L;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var $;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function a(b){const c=b;return(0,h.$8F)(c?.editor)&&(0,h.$8F)(c?.replacement)}var k;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k||(e.GroupsOrder=k={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function l(b){const c=b;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function P(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Ee[319],Se([1,0,5,157]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=I,e.$nE=(0,s.$Gi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function I(T){const L=T;return typeof T=="number"||(0,h.$lE)(L)}}),define(Ee[158],Se([1,0,5,145]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,s.$Hi)(h.$Ni)}),define(Ee[159],Se([1,0,24,4,17,3,9]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=e.$Pcc=void 0,I=We(I);class R{constructor(g,n){this.versionId=g,this.removedDueToLooping=n}}e.$Pcc=R;class ${static isHostExtension(g,n,o){if(n.getExtensionDescription(g))return!1;const t=o.getExtensionDescription(g);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(g,n){this.j=g,this.c=new h.$ne,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new s.$tn,this.g=[],this.h=new Map;for(const g of this.e){if(this.f.has(g.identifier)){console.error("Extension `"+g.identifier.value+"` is already registered");continue}this.f.set(g.identifier,g),this.g.push(g);const n=this.j.readActivationEvents(g);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(g)}}set(g){return this.e=g,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(g,n){this.e=m(this.e,n),this.e=this.e.concat(g);const o=$.l(this.e);return this.e=m(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(g){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this.c.has(f)?this.c.get(f).push(u):this.c.set(f,[u])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,u){const w=n.getArcs(f);for(let S=0;S<w.length;S++)if(!u.has(w[S]))return!1;return!0}getNodes(){return this.e}},o=new s.$tn;for(const f of g)if(o.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)n.addArc(s.$rn.toKey(f.identifier),s.$rn.toKey(u));const t=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>t.add(f));const i=n.getNodes().filter(f=>!t.has(f));let r;do{r=!1;for(let f=0;f<i.length;f++){const u=i[f];n.hasOnlyGoodArcs(u,t)&&(i.splice(f,1),f--,t.add(u),r=!0)}}while(r);return i.map(f=>o.get(f))}containsActivationEvent(g){return this.h.has(g)}containsExtension(g){return this.f.has(g)}getExtensionDescriptionsForActivationEvent(g){const n=this.h.get(g);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(g){const n=this.f.get(g);return n||void 0}getExtensionDescriptionByUUID(g){for(const n of this.g)if(n.uuid===g)return n}getExtensionDescriptionByIdOrUUID(g,n){return this.getExtensionDescription(g)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Qcc=$;class a{constructor(g,n){this.versionId=g,this.extensions=n}}e.$Rcc=a;class k{constructor(g){this.d=new P,this.c=new $(g,[])}async acquireLock(g){const n=await this.d.acquire(g);return new E(this,n)}deltaExtensions(g,n,o){if(!g.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(g){return this.c.containsActivationEvent(g)}containsExtension(g){return this.c.containsExtension(g)}getExtensionDescriptionsForActivationEvent(g){return this.c.getExtensionDescriptionsForActivationEvent(g)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(g){return this.c.getExtensionDescription(g)}getExtensionDescriptionByUUID(g){return this.c.getExtensionDescriptionByUUID(g)}getExtensionDescriptionByIdOrUUID(g,n){return this.c.getExtensionDescriptionByIdOrUUID(g,n)}}e.$Scc=k;class E extends T.$Xc{constructor(g,n){super(),this.f=g,this.c=!1,this.B(n)}isAcquiredFor(g){return!this.c&&this.f===g}}e.$Tcc=E;class l{constructor(g){this.name=g;const n=(0,L.$zh)();this.promise=n.promise,this.c=n.resolve}resolve(g){this.c(g)}}class P{constructor(){this.c=[],this.d=!1}async acquire(g){const n=new l(g);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const g=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${g.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};g.resolve((0,T.$Vc)(t))}}var b;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(b||(b={}));function c(d,g){const n=d.isBuiltin?b.Builtin:d.isUnderDevelopment?b.Dev:b.User,o=g.isBuiltin?b.Builtin:g.isUnderDevelopment?b.Dev:b.User;if(n!==o)return n-o;const t=I.$jc.basename(d.extensionLocation.path),i=I.$jc.basename(g.extensionLocation.path);return t<i?-1:t>i?1:0}function m(d,g){const n=new s.$sn(g);return d.filter(o=>!n.has(o.identifier))}}),define(Ee[320],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.ExtHostConnectionType=void 0,e.$fn=R,e.$gn=$;var s;(function(k){k[k.IPC=1]="IPC",k[k.Socket=2]="Socket",k[k.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=s.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$cn=h;class I{constructor(){this.type=s.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[I.ENV_KEY]="1"}}e.$dn=I;class T{constructor(){this.type=s.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[T.ENV_KEY]="1"}}e.$en=T;function L(k){delete k[h.ENV_KEY],delete k[I.ENV_KEY],delete k[T.ENV_KEY]}function R(k,E){L(E),k.serialize(E)}function $(k){if(k[h.ENV_KEY])return a(k,new h(k[h.ENV_KEY]));if(k[I.ENV_KEY])return a(k,new I);if(k[T.ENV_KEY])return a(k,new T);throw new Error("No connection information defined in environment!")}function a(k,E){return L(k),E}}),define(Ee[94],Se([1,0,22]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=L,e.$Cn=R;var h;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(h||(e.UIKind=h={}));var I;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var T;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function L(a){const k=s.$Pe.alloc(1);switch(a){case T.Initialized:k.writeUInt8(1,0);break;case T.Ready:k.writeUInt8(2,0);break;case T.Terminate:k.writeUInt8(3,0);break}return k}function R(a,k){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return k===T.Initialized;case 2:return k===T.Ready;case 3:return k===T.Terminate;default:return!1}}var $;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[95],Se([1,0,5,4,150,12,30,94,91,92,25,2,3,241]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=m;let b=class extends l.$Xc{constructor(g,n){super(),this.s=g,this.t=n,this.a=this.B(new h.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=I.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:a.$Ap,name:(0,P.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,T.$ck)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=I.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(g,n,o){const t=this.getTelemetryDetails(),i=new c(n,o,g,this.n,this.j,this.getBuiltInCommonProperties(g),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),r=this.r.get(g.identifier.value)??[];return this.r.set(g.identifier.value,[...r,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(g,n,o){this.f=g,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(g){const n=Object.create(null);switch(n["common.extname"]=`${g.publisher}.${g.name}`,n["common.extversion"]=g.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$in)((0,a.$Gp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(g){this.h=this.getTelemetryConfiguration(),this.f=g;const n=this.getTelemetryDetails();this.r.forEach((o,t)=>{const i=o.filter(r=>!r.isDisposed);i.length===0?this.r.delete(t):this.r.set(t,i)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(g,n){const t=this.r.get(g.value)?.filter(r=>!r.isDisposed);if(!t)return this.r.delete(g.value),!1;let i=!1;for(const r of t)r.ignoreUnhandledExtHostErrors||(r.logError(n),i=!0);return i}};e.$fQ=b,e.$fQ=b=Xe([Ve(0,L.$eQ),Ve(1,T.$bk)],b);class c{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,n,o,t,i,r,f){this.g=o,this.h=t,this.i=i,this.j=r,this.a=new h.$ne,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=g,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(g,n){this.e&&(this.d={isUsageEnabled:g,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(g){let n="properties"in g?g.properties??{}:g;return n=(0,a.$Jp)(n,[]),this.c&&(n=(0,k.$ho)(n,this.c)),this.b||(n=(0,k.$ho)(n,this.j)),"properties"in g?g.properties=n:g=n,g}k(g,n){this.f&&(this.g.publisher==="vscode"?g=this.g.name+"/"+g:g=this.g.identifier.value+"/"+g,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(g,n),this.h.trace(g,n))}logUsage(g,n){this.d.isUsageEnabled&&this.k(g,n)}logError(g,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof g=="string")this.k(g,n);else{const o={name:g.name,message:g.message,stack:g.stack,cause:g.cause},t=(0,a.$Jp)(o,[]),i=new Error(t.message,{cause:t.cause});i.stack=t.stack,i.name=t.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(i,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const g=this,n={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g.d.isUsageEnabled},get isErrorsEnabled(){return g.d.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g.a.event.bind(g)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let g=this.f;this.f=void 0,Promise.resolve(g.flush()).then(g=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=c;function m(d){const g=Date.now()-new Date(d).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.$iQ=(0,s.$Gi)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,290,148,24,5]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=l,e.$7G=P,e.$0G=d,e.$$G=g,e.$1G=Object.freeze({identifier:new L.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,R.$Gi)("extensionService");class ${constructor(t){this.dependency=t}}e.$4G=$;var a;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class k{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,i,r){this.c=t,this.d=i.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$MG.createActivationEventsMap(this.d)}}set(t,i,r){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const f=[],u=[],w=[],S=[],D=E(this.d),y=E(i),C=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this.d){const O=y.get(N.identifier);if(!O){f.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,O)){f.push(N.identifier),D.delete(N.identifier);continue}}for(const N of i){const O=D.get(N.identifier);if(!O){u.push(N);continue}if(!C(O,N)){f.push(O.identifier),D.delete(O.identifier);continue}}const A=new L.$sn(this.e),p=new L.$sn(r);for(const N of this.e)p.has(N)||w.push(N);for(const N of r)A.has(N)||S.push(N);const v=T.$MG.createActivationEventsMap(u),F={versionId:t,toRemove:f,toAdd:u,addActivationEvents:v,myToRemove:w,myToAdd:S};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:f,myToAdd:u}=t,w=new L.$sn(i),S=new L.$sn(f);for(let D=0;D<this.d.length;D++)w.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)S.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of r)this.d.push(D);for(const D of u)this.e.push(D);return this.f=null,t}containsExtension(t){for(const i of this.e)if(L.$rn.equals(i,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const r=T.$MG.readActivationEvents(i);for(const f of r)t.add(f)}return t}}e.$5G=k;function E(o){const t=new L.$tn;for(const i of o)t.set(i.identifier,i);return t}function l(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function P(o,t){if(!l(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class b{constructor(t,i,r,f){this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=f}}e.$8G=b;class c{constructor(t,i){this.description=t,this.value=i}}e.$9G=c;var m;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function d(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,I.$Pp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function g(o,t){const i=(0,I.$Np)(o.manifest.publisher,o.manifest.name);return{id:i,identifier:new L.$rn(i),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.onWillStop=s.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,i){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=n}),define(Ee[321],Se([1,0,14,159,24,26,12,9]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=e.$6oc=e.$5oc=e.$4oc=e.$3oc=void 0,s=We(s);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(d,g,n,o){this.startup=d,this.codeLoadingTime=g,this.activateCallTime=n,this.activateResolvedTime=o}}e.$3oc=$;class a{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,g){return d===-1||g===-1?-1:g-d}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$4oc=a;class k{constructor(d,g,n,o,t,i){this.activationFailed=d,this.activationFailedError=g,this.activationTimes=n,this.module=o,this.exports=t,this.subscriptions=i}}e.$5oc=k;class E extends k{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.$6oc=E;class l extends k{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$7oc=l;class P extends k{constructor(d){super(!0,d,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(d,g,n,o){this.g=o,this.a=d,this.b=g,this.c=n,this.d=new I.$tn,this.f=Object.create(null)}dispose(){for(const[d,g]of this.d)g.dispose()}async waitForActivatingExtensions(){const d=[];for(const[g,n]of this.d)d.push(n.wait());await Promise.all(d)}isActivated(d){const g=this.d.get(d);return!!(g&&g.value)}getActivatedExtension(d){const g=this.d.get(d);if(!g||!g.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return g.value}async activateByEvent(d,g){if(this.f[d])return;const n=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(n.map(o=>({id:o.identifier,reason:{startup:g,extensionId:o.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,g){const n=this.a.getExtensionDescription(d);if(!n)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:n.identifier,reason:g}])}async h(d){const g=d.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(g.map(n=>n.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const g=this.a.getExtensionDescription(d.id);if(!g){const t=new Error(`Cannot activate unknown extension '${d.id.value}'`),i=this.k(d,null,[],new P(t));return this.c.onExtensionActivationError(d.id,t,new T.$4G(d.id.value)),i}const n=[],o=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const t of o){if(this.m(t))continue;const i=this.d.get(t);if(i){n.push(i);continue}if(this.l(t)){n.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:d.reason}));continue}const r=this.a.getExtensionDescription(t);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:d.reason}));continue}const f=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${t}'`),w=this.k(d,g.displayName,[],new P(u));return this.c.onExtensionActivationError(g.identifier,u,new T.$4G(t)),w}return this.k(d,g.displayName,n,null)}k(d,g,n,o){const t=new c(d.id,g,d.reason,n,o,this.c,this.g);return this.d.set(d.id,t),t}l(d){return h.$Qcc.isHostExtension(d,this.a,this.b)}m(d){const g=this.b.getExtensionDescription(d);return g?!g.main&&!g.browser:!1}};e.$8oc=b,e.$8oc=b=Xe([Ve(3,L.$ak)],b);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,g,n,o,t,i,r){this.c=d,this.d=g,this.f=n,this.g=o,this.h=t,this.j=i,this.k=r,this.a=new R.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const g=this.g[d];if(g.value&&!g.value.activationFailed){this.g.splice(d,1),d--;continue}if(g.value&&g.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);n.detail=g.value.activationFailedError,this.h=new P(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const g=new Error;if(d&&d.name&&(g.name=d.name),d&&d.message?g.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(g.stack=d.stack),this.h=new P(g),this.b&&s.$7(d))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};c=Xe([Ve(6,L.$ak)],c)});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[160],Se([1,0,260,14,44,147,117,37,24,116,148,144]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,s=We(s),I=jt(I);const l=R.$ro.as(L.$so.JSONContribution);class P{constructor(t,i,r){this.a=t,this.b=i,this.c=r}d(t,i){this.a({type:t,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(I.default.Error,t)}warn(t){this.d(I.default.Warning,t)}info(t){this.d(I.default.Info,t)}}e.$UG=P;class b{static a(t){const i=new $.$sn;for(let r=0,f=t.length;r<f;r++)i.add(t[r].description.identifier);return i}static compute(t,i){if(!t||!t.length)return new b(i,[]);if(!i||!i.length)return new b([],t);const r=this.a(t),f=this.a(i),u=i.filter(S=>!r.has(S.description.identifier)),w=t.filter(S=>!f.has(S.description.identifier));return new b(u,w)}constructor(t,i){this.added=t,this.removed=i}}e.$VG=b;class c{constructor(t,i){this.name=t,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=b.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$3)(t)}}}e.$WG=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(0,null),s.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:s.localize(2,null),properties:{vscode:{type:"string",description:s.localize(3,null),default:"^1.22.0"}}},publisher:{description:s.localize(4,null),type:"string"},displayName:{description:s.localize(5,null),type:"string"},categories:{description:s.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$qn},{type:"string",const:"Languages",deprecationMessage:s.localize(7,null)}]}},galleryBanner:{type:"object",description:s.localize(8,null),properties:{color:{description:s.localize(9,null),type:"string"},theme:{description:s.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(13,null)},enabledApiProposals:{markdownDescription:s.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:s.localize(15,null),type:"string",enum:["none"],enumDescriptions:[s.localize(16,null)]},activationEvents:{description:s.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(32,null)},{label:"onUri",body:"onUri",description:s.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(37,null)},{label:"onRenderer",description:s.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:s.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:s.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:s.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:s.localize(44,null)},{label:"*",description:s.localize(45,null),body:"*"}]}},badges:{type:"array",description:s.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(47,null)},href:{type:"string",description:s.localize(48,null)},description:{type:"string",description:s.localize(49,null)}}}},markdown:{type:"string",description:s.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$9o}},extensionPack:{description:s.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$9o}},extensionKind:{description:s.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(55,null)},{body:["workspace"],description:s.localize(56,null)},{body:["ui","workspace"],description:s.localize(57,null)},{body:["workspace","ui"],description:s.localize(58,null)},{body:[],description:s.localize(59,null)}]},capabilities:{description:s.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(63,null),s.localize(64,null),s.localize(65,null)]},description:{type:"string",markdownDescription:s.localize(66,null)}}},untrustedWorkspaces:{description:s.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(69,null),s.localize(70,null),s.localize(71,null)]},restrictedConfigurations:{description:s.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(73,null)}}}}},sponsor:{description:s.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(76,null),type:"string"},"vscode:uninstall":{description:s.localize(77,null),type:"string"}}},icon:{type:"string",description:s.localize(78,null)},l10n:{type:"string",description:s.localize(79,null)},pricing:{type:"string",markdownDescription:s.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const i=new c(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,i),t.activationEventsGenerator&&k.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,l.registerSchema(d,e.$XG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=g;const n={ExtensionsRegistry:"ExtensionsRegistry"};R.$ro.add(n.ExtensionsRegistry,new g),e.$ZG=R.$ro.as(n.ExtensionsRegistry),l.registerSchema(d,e.$XG),l.registerSchema(a.$uk,{properties:{extensionEnabledApiProposals:{description:s.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(Ee[322],Se([1,0,4,40,3,13,251,24,5,12,26,160]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var l;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(l||(e.ChatMessageRole=l={})),e.$aH=(0,$.$Gi)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.$bH=E.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(c,m)=>{for(const d of c)m.push(`onLanguageModelChat:${d.vendor}`)}});let b=class{constructor(m,d){this.e=m,this.f=d,this.a=new I.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new s.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(g=>{this.c.clear();for(const o of g){if(!(0,k.$6G)(o.description,"chatProvider")){o.collector.error((0,L.localize)(2,null));continue}for(const t of h.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,L.localize)(3,null,t.vendor));continue}if((0,T.$ef)(t.vendor)){o.collector.error((0,L.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,L.localize)(5,null));continue}this.c.add(t.vendor)}}const n=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const g=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(g)}const d=[];for(const[g,n]of this.b)(m.vendor===void 0||n.metadata.vendor===m.vendor)&&(m.family===void 0||n.metadata.family===m.family)&&(m.version===void 0||n.metadata.version===m.version)&&(m.identifier===void 0||n.metadata.id===m.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>R.$rn.equals(o,m.extension)))&&d.push(g);return this.f.trace("[LM] selected language models",m,d),d}registerLanguageModelChat(m,d){if(this.f.trace("[LM] registering language model chat",m,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,d),this.d.fire({added:[{identifier:m,metadata:d.metadata}]}),(0,I.$Vc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,d.metadata))})}async sendChatRequest(m,d,g,n,o){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(g,d,n,o)}computeTokenLength(m,d,g){const n=this.b.get(m);if(!n)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return n.provideTokenCount(d,g)}};e.$cH=b,e.$cH=b=Xe([Ve(0,k.$3G),Ve(1,a.$ak)],b)}),define(Ee[323],Se([1,0,255,18,25,160,36,4]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=void 0,s=We(s),h=We(h),I=We(I);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(2,null),default:""}}};var a;(function(l){function P(b,c,m){if(!b)return;const d=h.$gg(b.type)?b.type:void 0;if(!d||d.length===0){m.error(s.localize(3,null));return}const g=[];if(Array.isArray(b.required))for(const n of b.required)h.$gg(n)&&g.push(n);return{extensionId:c.value,taskType:d,required:g,properties:b.properties?I.$eo(b.properties):{},when:b.when?L.$Ej.deserialize(b.when):void 0}}l.from=P})(a||(a={}));const k=T.$ZG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,P)=>{for(const b of l)b.type&&P.push(`onTaskType:${b.type}`)},jsonSchema:{description:s.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new R.$ne,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,b)=>{k.setHandler((c,m)=>{this.c=void 0;try{for(const d of m.removed){const g=d.value;for(const n of g)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const d of m.added){const g=d.value;for(const n of g){const o=a.from(n,d.description.identifier,d.collector);o&&(this.a[o.taskType]=o)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const b of this.all()){const c={type:"object",additionalProperties:!1};b.required.length>0&&(c.required=b.required.slice(0)),b.properties!==void 0?c.properties=I.$eo(b.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[b.taskType]},P.push(c)}this.c={oneOf:P}}return this.c}}e.$HI=new E}),define(Ee[324],Se([1,0,256,18,23,25,36,323,45]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RI=e.JsonSchemaVersion=e.ExecutionEngine=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LI=e.ShellQuoting=e.$KI=e.$JI=e.$II=void 0,s=We(s),h=We(h),I=We(I),T=We(T),e.$II="settings",e.$JI=new L.$Xj("taskRunning",!1,s.localize(0,null)),e.$KI=s.localize2(2,"Tasks");var a;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$LI="$customized",function(M){function V(K){if(!K)return M.Strong;switch(K.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=V}(a||(e.ShellQuoting=a={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var E;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(E||(e.RevealKind=E={})),function(M){function V(K){switch(K.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=V}(E||(e.RevealKind=E={}));var l;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(l||(e.RevealProblemKind=l={})),function(M){function V(K){switch(K.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=V}(l||(e.RevealProblemKind=l={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function V(K){switch(K.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=V}(P||(e.PanelKind=P={}));var b;(function(M){M.defaults={echo:!0,reveal:E.Always,revealProblems:l.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var c;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(c||(e.RuntimeType=c={})),function(M){function V(re){switch(re.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=V;function K(re){switch(re){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=K}(c||(e.RuntimeType=c={}));var m;(function(M){function V(K){return h.$gg(K)?K:K.value}M.value=V})(m||(e.CommandString=m={}));var d;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function V(re){return re===M.Clean._id||re===M.Build._id||re===M.Rebuild._id||re===M.Test._id}M.is=V;function K(re){if(re!==void 0)return h.$gg(re)?V(re)?{_id:re,isDefault:!1}:void 0:re}M.from=K})(d||(e.TaskGroup=d={}));var g;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function V(K){switch(K){case M.User:return $.ConfigurationTarget.USER;case M.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=V})(n||(e.TaskSourceKind=n={}));var o;(function(M){M.parallel="parallel",M.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var i;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class r{constructor(V,K,re,B,G,X){this._label="",this._id=V,K&&(this._label=K),re&&(this.type=re),this.runOptions=B,this.configurationProperties=G,this._source=X}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,K=!1){if(V===void 0)return!1;if(h.$gg(V))return V===this._label||V===this.configurationProperties.identifier||K&&V===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$MI=r;class f extends r{constructor(V,K,re,B,G,X,ee,de){super(V,re,void 0,ee,de,K),this.command={},this._source=K,this.hasDefinedMatchers=X,G&&(this.command=G)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case c.Shell:K="shell";break;case c.Process:K="process";break;case c.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(V){return V instanceof f}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const re={type:e.$LI,folder:V,id:K};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new f(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$NI=f;class u extends r{constructor(V,K,re,B,G,X,ee){super(V,re,B,X,ee,K),this._source=K,this.configures=G}static is(V){return V instanceof u}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const re={type:e.$LI,folder:V,id:K};return JSON.stringify(re)}}e.$OI=u;class w extends r{constructor(V,K,re,B,G,X,ee,de,ne){super(V,re,B,de,ne,K),this.defines=G,this.hasDefinedMatchers=ee,this.command=X,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof w}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===g.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new w(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$PI=w;class S extends r{constructor(V,K,re,B,G,X){super(V,re,B,G,X,K),this._source=K}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new S(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$QI=S;var D;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(M){M._default=M.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(V){this.c=new Map;for(let K=0;K<V.length;K++)this.c.set(V[K].uri.toString(),K)}compare(V,K){const re=V.getWorkspaceFolder(),B=K.getWorkspaceFolder();if(re&&B){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let X=this.c.get(B.uri.toString());return X=X===void 0?0:X+1,G===X?V._label.localeCompare(K._label):G-X}else return!re&&B?-1:re&&!B?1:0}}e.$RI=C;var A;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(A||(e.TaskEventKind=A={}));var p;(function(M){M.SingleRun="singleRun",M.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(M){function V(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?p.Background:p.SingleRun,group:de.configurationProperties.group,__task:de}}function K(de,ne,De){return{...V(de),kind:A.Start,terminalId:ne,resolvedVariables:De}}M.start=K;function re(de,ne,De){return{...V(de),kind:A.ProcessStarted,terminalId:ne,processId:De}}M.processStarted=re;function B(de,ne,De){return{...V(de),kind:A.ProcessEnded,terminalId:ne,exitCode:De}}M.processEnded=B;function G(de,ne,De){return{...V(de),kind:A.Terminated,exitReason:De,terminalId:ne}}M.terminated=G;function X(de,ne,De){return{...V(ne),kind:de,terminalId:De}}M.general=X;function ee(){return{kind:A.Changed}}M.changed=ee})(F||(e.TaskEvent=F={}));var N;(function(M){function V(re){const B=Object.keys(re).sort();let G="";for(const X of B){let ee=re[X];ee instanceof Object?ee=V(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=X+","+ee+","}return G}function K(re){const G={_key:V(re),type:re.taskType};return Object.assign(G,re),G}M.create=K})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function V(K,re){const B=R.$HI.get(K.type);if(B===void 0){const de=T.$eo(K);return delete de._key,N.create(de)}const G=Object.create(null);G.type=B.taskType;const X=new Set;B.required.forEach(de=>X.add(de));const ee=B.properties;for(const de of Object.keys(ee)){const ne=K[de];if(ne!=null)G[de]=ne;else if(X.has(de)){const De=ee[de];if(De.default!==void 0)G[de]=T.$eo(De.default);else switch(De.type){case"boolean":G[de]=!1;break;case"number":case"integer":G[de]=0;break;case"string":G[de]="";break;default:re.error(s.localize(1,null,JSON.stringify(K,void 0,0),de));return}}}return N.create(G)}M.createTaskIdentifier=V})(z||(e.TaskDefinition=z={}))}),define(Ee[325],Se([1,0,14]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,R)=>{this.b=L,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,s.$3)(L))}then(L,R){return this.j().then(L,R)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Ucc=h;class I extends h{constructor(){super(),this.h=!0,this.i=new s.$8}}e.$Vcc=I}),define(Ee[52],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=I,e.$Tw=T;class s{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++s.count}}e.$Rw=s;const h=[];function I(R){const $=new s(R);return h[$.nid]=$,$}function T(R){return h[R].sid}class L{constructor($){this.value=$}}e.$Uw=L}),define(Ee[6],Se([1,0,52]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var I;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var T;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var L;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var a;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var k;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(k||(e.CandidatePortSource=k={}));class E{static{this.a=0}static mixin(m){return m._id=E.a++,m}}e.$tN=E;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var P;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$uN={MainThreadAuthentication:(0,s.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,s.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,s.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,s.$Sw)("MainThreadCommands"),MainThreadComments:(0,s.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,s.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,s.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,s.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,s.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,s.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,s.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,s.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,s.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,s.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,s.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,s.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,s.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,s.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,s.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,s.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,s.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,s.$Sw)("MainThreadSCM"),MainThreadSearch:(0,s.$Sw)("MainThreadSearch"),MainThreadShare:(0,s.$Sw)("MainThreadShare"),MainThreadTask:(0,s.$Sw)("MainThreadTask"),MainThreadWindow:(0,s.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,s.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,s.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,s.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,s.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,s.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,s.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.$Sw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,s.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,s.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,s.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,s.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,s.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,s.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.$Sw)("ExtHostSCM"),ExtHostSearch:(0,s.$Sw)("ExtHostSearch"),ExtHostTask:(0,s.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,s.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,s.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,s.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,s.$Sw)("ExtHostProgress"),ExtHostComments:(0,s.$Sw)("ExtHostComments"),ExtHostSecretState:(0,s.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,s.$Sw)("ExtHostStorage"),ExtHostUrls:(0,s.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,s.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,s.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,s.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,s.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,s.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,s.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,s.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,s.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,s.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,s.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,s.$Sw)("ExtHostLocalization")}}),define(Ee[96],Se([1,0,5,12,6,20]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=e.$qoc=e.$poc=void 0,I=We(I),e.$poc=(0,s.$Gi)("IExtHostApiDeprecationService");let L=class{constructor($,a){this.c=a,this.a=new Set,this.b=$.getProxy(I.$uN.MainThreadTelemetry)}report($,a,k){const E=this.d($,a);this.a.has(E)||(this.a.add(E),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${k}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:$}))}d($,a){return`${$}-${a.identifier.value}`}};e.$qoc=L,e.$qoc=L=Xe([Ve(0,T.$1P),Ve(1,h.$ak)],L),e.$roc=Object.freeze(new class{report(R,$,a){}})}),define(Ee[326],Se([1,0,6]),function(ce,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class h{constructor(T){const L=T.getProxy(s.$uN.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.$Eoc=h}),define(Ee[327],Se([1,0,25,6,30,20]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;let L=class{constructor(k,E){this.a=k.getProxy(h.$uN.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(k,E){const l=this,P=console[k];Object.defineProperty(console,k,{set:()=>{},get:()=>function(){l.e(k,E,P,arguments)}})}e(k,E,l,P){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(P,this.b)}),this.c&&this.f(k,l,P)}};e.$Aqc=L,e.$Aqc=L=Xe([Ve(0,T.$1P),Ve(1,I.$eQ)],L);const R=1e5;function $(a,k){const E=[];if(a.length)for(let l=0;l<a.length;l++){let P=a[l];if(typeof P>"u")P="undefined";else if(P instanceof Error){const b=P;b.stack?P=b.stack:P=b.toString()}E.push(P)}if(k){const l=new Error().stack;l&&E.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,s.$jo)(E);return l.length>R?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ee[328],Se([1,0,2,6,26]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0;class T{constructor(R){this.a=R.getProxy(h.$uN.MainThreadDialogs)}showOpenDialog(R,$){return $?.allowUIResources&&(0,I.$7G)(R,"showLocal"),this.a.$showOpenDialog($).then(a=>a?a.map(k=>s.URI.revive(k)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then($=>$?s.URI.revive($):void 0)}}e.$Gpc=T}),define(Ee[329],Se([1,0,21,4,3,6]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class L{constructor($){this.b=new Map,this.c=new h.$ne,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(T.$uN.MainThreadEmbeddings)}registerEmbeddingsProvider($,a,k){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,a),this.b.set(E,{id:a,provider:k}),(0,I.$Vc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,a,k){k??=s.CancellationToken.None;let E=!1;typeof a=="string"&&(a=[a],E=!0);const l=await this.a.$computeEmbeddings($,a,k);if(l.length!==a.length)throw new Error;if(E){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings($,a,k){const E=this.b.get($);if(!E)return[];const l=await E.provider.provideEmbeddings(a,k);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Jpc=L}),define(Ee[330],Se([1,0,3,6]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0;class I{constructor(L){this.b=0,this.a=L.getProxy(h.$uN.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,L),(0,s.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.$1pc=I}),define(Ee[123],Se([1,0,11,13,2,5,12,6,30,20]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0;let k=class{constructor(l,P,b){this.f=b,this.d=new Map,this.a=P.getProxy(R.$uN.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===s.$g}getMessage(l,P){const{message:b,args:c,comment:m}=P;if(this.c)return(0,h.$gf)(b,c??{});let d=b;m&&m.length>0&&(d+=`/${Array.isArray(m)?m.join(""):m}`);const g=this.d.get(l)?.contents[d];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,h.$gf)(g??b,c??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let P;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(b),m=JSON.parse(c);P=l.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${c.message}`);return}P&&this.d.set(l.identifier.value,{contents:P,uri:b})}async g(l){if(l.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(P)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$jpc=k,e.$jpc=k=Xe([Ve(0,$.$eQ),Ve(1,a.$1P),Ve(2,L.$ak)],k),e.$kpc=(0,T.$Gi)("IExtHostLocalizationService")}),define(Ee[161],Se([1,0,12,6,30,20,2,57]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;let $=class extends s.$lk{constructor(E,l){super(l.logLevel,l.logsLocation,l.loggers.map(P=>(0,R.$di)(P))),this.r=E.getProxy(h.$uN.MainThreadLogger)}$setLogLevel(E,l){l?this.setLogLevel(L.URI.revive(l),E):this.setLogLevel(E)}setVisibility(E,l){super.setVisibility(E,l),this.r.$setVisibility(E,l)}s(E,l,P){return new a(this.r,E,l,P)}};e.$zqc=$,e.$zqc=$=Xe([Ve(0,T.$1P),Ve(1,I.$eQ)],$);class a extends s.$gk{constructor(E,l,P,b){super(b?.logLevel==="always"),this.r=E,this.s=l,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(E,l){const P=[[E,l]];this.m?this.u(P):this.n.push(...P)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],Se([1,0,6,5,3,20,22]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,e.$lpc=(0,h.$Gi)("IExtHostManagedSockets");let R=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(s.$uN.MainThreadManagedSockets)}setFactory(E,l){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const l=++this.b,P=await this.c.makeConnection(),b=new I.$Wc;return this.d.set(l,new a(l,P,b)),b.add((0,I.$Vc)(()=>this.d.delete(l))),b.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(P.onDidClose(c=>{this.a.$onDidManagedSocketClose(l,c?.stack??c?.message),b.dispose()})),b.add(P.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(l,L.$Pe.wrap(c)))),l}$remoteSocketWrite(E,l){this.d.get(E)?.actual.send(l.buffer)}$remoteSocketEnd(E){const l=this.d.get(E);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$mpc=R,e.$mpc=R=Xe([Ve(0,T.$1P)],R);class ${constructor(E,l){this.socketFactoryId=E,this.makeConnection=l}}class a extends I.$Xc{constructor(E,l,P){super(),this.socketId=E,this.actual=l,this.B(P)}}}),define(Ee[331],Se([1,0,6,12,26]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;function T(R){return R&&R.title}let L=class{constructor($,a){this.b=a,this.a=$.getProxy(s.$uN.MainThreadMessageService)}showMessage($,a,k,E,l){const P={source:{identifier:$.identifier,label:$.displayName||$.name}};let b;typeof E=="string"||T(E)?b=[E,...l]:(P.modal=E?.modal,P.useCustom=E?.useCustom,P.detail=E?.detail,b=l),P.useCustom&&(0,I.$7G)($,"resolvers");const c=[];let m=!1;for(let d=0;d<b.length;d++){const g=b[d];if(typeof g=="string")c.push({title:g,handle:d,isCloseAffordance:!1});else if(typeof g=="object"){const{title:n,isCloseAffordance:o}=g;c.push({title:n,isCloseAffordance:!!o,handle:d}),o&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,g):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,g)}return this.a.$showMessage(a,k,P,c).then(d=>{if(typeof d=="number")return b[d]})}};e.$4pc=L,e.$4pc=L=Xe([Ve(1,h.$ak)],L)}),define(Ee[332],Se([1,0,3,18,2,26,6]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class R{constructor(a){this.b=new Map,this.a=a.getProxy(L.$uN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,k,E){if((0,T.$7G)(a,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,E),this.a.$registerProfileContentHandler(k,E.name,E.description,a.identifier.value),(0,s.$Vc)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(a,k,E,l){const P=this.b.get(a);if(!P)throw new Error(`Unknown handler with id: ${a}`);return P.saveProfile(k,E,l)}async $readProfile(a,k,E){const l=this.b.get(a);if(!l)throw new Error(`Unknown handler with id: ${a}`);return l.readProfile((0,h.$gg)(k)?k:I.URI.revive(k),E)}}e.$aqc=R}),define(Ee[125],Se([1,0,6,4,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;class T{constructor(R){this.b=new h.$ne,this.onDidChangePassword=this.b.event,this.a=R.getProxy(s.$uN.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,$){return this.a.$getPassword(R,$)}store(R,$,a){return this.a.$setPassword(R,$,a)}delete(R,$){return this.a.$deletePassword(R,$)}}e.$gpc=T,e.$hpc=(0,I.$Gi)("IExtHostSecretState")}),define(Ee[333],Se([1,0,21,3,6]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0;class T{static{this.a=1}constructor(R){this.c=new Map,this.d=new Map,this.f=new Map,this.b=R.getProxy(I.$uN.MainThreadSpeech)}async $createSpeechToTextSession(R,$,a){const k=this.c.get(R);if(!k)return;const E=new h.$Wc,l=new s.$ye;this.d.set($,l);const P=await k.provideSpeechToTextSession(l.token,a?{language:a}:void 0);P&&(E.add(P.onDidChange(b=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,b)})),E.add(l.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}async $createTextToSpeechSession(R,$,a){const k=this.c.get(R);if(!k)return;const E=new h.$Wc,l=new s.$ye;this.d.set($,l);const P=await k.provideTextToSpeechSession(l.token,a?{language:a}:void 0);P&&(this.f.set($,P),E.add(P.onDidChange(b=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,b)})),E.add(l.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(R,$){this.f.get(R)?.synthesize($)}async $cancelTextToSpeechSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R),this.f.delete(R)}async $createKeywordRecognitionSession(R,$){const a=this.c.get(R);if(!a)return;const k=new h.$Wc,E=new s.$ye;this.d.set($,E);const l=await a.provideKeywordRecognitionSession(E.token);l&&(k.add(l.onDidChange(P=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,P)})),k.add(E.token.onCancellationRequested(()=>k.dispose())))}async $cancelKeywordRecognitionSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}registerProvider(R,$,a){const k=T.a++;return this.c.set(k,a),this.b.$registerProvider(k,$,{extension:R,displayName:R.value}),(0,h.$Vc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}}e.$hqc=T}),define(Ee[126],Se([1,0,6,4,5]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;class T{constructor(R,$){this.c=$,this.b=new h.$ne,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(s.$uN.MainThreadStorage)}registerExtensionStorageKeysToSync(R,$){this.a.$registerExtensionStorageKeysToSync(R,$)}async initializeExtensionStorage(R,$,a){const k=await this.a.$initializeExtensionStorage(R,$);let E;return k&&(E=this.d(R,$,k)),E||a}setValue(R,$,a){return this.a.$setValue(R,$,a)}$acceptValue(R,$,a){const k=this.d(R,$,a);k&&this.b.fire({shared:R,key:$,value:k})}d(R,$,a){try{return JSON.parse(a)}catch(k){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${R}): ${k}`)}}}e.$9oc=T,e.$0oc=(0,I.$Gi)("IExtHostStorage")}),define(Ee[334],Se([1,0,3,15,2,6]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(T.$uN.MainThreadUriOpeners)}registerExternalUriOpener($,a,k,E){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const l=E.schemes.find(P=>!L.a.has(P));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(a,k),this.b.$registerUriOpener(a,E.schemes,$,E.label),(0,s.$Vc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri($,a,k){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const l=I.URI.revive(a);return E.canOpenExternalUri(l,k)}async $openUri($,a,k){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(I.URI.revive(a.resolvedUri),{sourceUri:I.URI.revive(a.sourceUri)},k)}}e.$tqc=L}),define(Ee[335],Se([1,0,6,2,3,14,24]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0;class R{static{this.a=0}constructor(a){this.c=new L.$sn,this.d=new Map,this.b=a.getProxy(s.$uN.MainThreadUrls)}registerUriHandler(a,k){const E=a.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const l=R.a++;return this.c.add(E),this.d.set(l,k),this.b.$registerUriHandler(l,E,a.displayName||a.name),(0,I.$Vc)(()=>{this.c.delete(E),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(a,k){const E=this.d.get(a);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(k))}catch(l){(0,T.$3)(l)}return Promise.resolve(void 0)}async createAppUri(a){return h.URI.revive(await this.b.$createAppUri(a))}}e.$uqc=R}),define(Ee[336],Se([1,0,22,6]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ztb=T,e.$Atb=R,h=We(h);class I{constructor(){this.buffers=[]}add(a){let k=this.buffers.indexOf(a);return k<0&&(k=this.buffers.length,this.buffers.push(a)),k}}function T($,a){if(a.serializeBuffersForPostMessage){const k=new I,l=JSON.stringify($,(b,c)=>{if(c instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(c)};if(ArrayBuffer.isView(c)){const m=L(c);if(m)return{$$vscode_array_buffer_reference$$:!0,index:k.add(c.buffer),view:{type:m,byteLength:c.byteLength,byteOffset:c.byteOffset}}}return c}),P=k.buffers.map(b=>{const c=new Uint8Array(b);return s.$Pe.wrap(c)});return{message:l,buffers:P}}else return{message:JSON.stringify($),buffers:[]}}function L($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function R($,a){const k=a.map(P=>{const b=new ArrayBuffer(P.byteLength);return new Uint8Array(b).set(P.buffer),b}),E=a.length?(P,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const c=b,{index:m}=c,d=k[m];if(c.view)switch(c.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return b}:void 0;return{message:JSON.parse($,E),arrayBuffers:k}}}),define(Ee[97],Se([1,0,4,3,15,25,2,285,336,122,6]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Toc=void 0,e.$Uoc=l,e.$Woc=c,e.$Xoc=m,T=We(T),k=We(k);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,t,i,r,f,u,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new s.$ne,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new s.$ne,this._onDidDispose=this.#h.event,this.#e=o,this.#t=t,this.#o=i,this.#n=r,this.#s=f,this.#r=u,this.#u=l(u),this.#d=P(u),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,a.$hDb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===I.Schemas.https||o.scheme===I.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$gDb}return a.$gDb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),T.$io(this.#o,o)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const t=(0,$.$ztb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const t=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,f,u,w,S,D)=>{const y=L.URI.from({scheme:w||"file",path:decodeURIComponent(S)}),C=(0,a.$hDb)(y,{isRemote:t,authority:i}).toString();return`${f}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,f,u,w,S,D)=>{const y=L.URI.from({scheme:w||"file",path:decodeURIComponent(S)}),C=(0,a.$hDb)(y,{isRemote:t,authority:i}).toString();return`${f}${C}${D}`})}}e.$Toc=E;function l(n){try{const o=(0,R.$Zp)((0,R.$Yp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function P(n){try{const o=(0,R.$Zp)((0,R.$Yp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class b extends h.$Xc{constructor(o,t,i,r,f){super(),this.c=t,this.f=i,this.g=r,this.h=f,this.b=new Map,this.a=o.getProxy(k.$uN.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,t,i){const r=this.j(o);if(r){const{message:f}=(0,$.$Atb)(t,i.value);r._onMessageEmitter.fire(f)}}$onMissingCsp(o,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,i){const r=new E(o,this.a,d(t),this.c,this.f,i,this.h);this.b.set(o,r);const f=r._onDidDispose(()=>{f.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Voc=b;function c(n){return{id:n.identifier,location:n.extensionLocation}}function m(n,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||g(n,o)}}function d(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function g(n,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),n.extensionLocation]}}),define(Ee[162],Se([1,0,4,15,13,2,5,20,6]),function(ce,e,s,h,I,T,L,R,$){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=e.$wqc=void 0;let k=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new s.$ne,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=l.getProxy($.$uN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:b})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,P){P!==this.d[l]&&(this.d={...this.d,[l]:P},this.c.fire(this.d))}openUri(l,P){let b;if(typeof l=="string"){b=l;try{l=T.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,I.$ef)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,b,P)}async asExternalUri(l,P){if((0,I.$ef)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(l,P);return T.URI.from(b)}};e.$wqc=k,e.$wqc=k=a=Xe([Ve(0,R.$1P)],k),e.$xqc=(0,L.$Gi)("IExtHostWindow")}),define(Ee[337],Se([1,0,327,30,20,94]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0;const L=1024*1024;let R=class extends s.$Aqc{constructor(a,k){super(a,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(a,k,E){const l=a==="error"||a==="warn"?process.stderr:process.stdout;this.g=!0,l.write(`
${T.NativeLogMarkers.Start}
`),k.apply(console,E),l.write(`
${T.NativeLogMarkers.End}
`),this.g=!1}j(a,k){const E=process[a],l=E.write;let P="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(b,c,m)=>{if(!this.g){P+=b.toString(c);const d=P.length>L?P.length:P.lastIndexOf(`
`);d!==-1&&(console[k](P.slice(0,d)),P=P.slice(d+1))}l.call(E,b,c,m)}})}};e.$_qc=R,e.$_qc=R=Xe([Ve(0,I.$1P),Ve(1,h.$eQ)],R)}),define(Ee[338],Se([1,0,161,15,279,32]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;class L extends s.$zqc{s($,a,k){return $.scheme===h.Schemas.file?new I.$dR(k?.name||(0,T.$3g)(),$.fsPath,!k?.donotRotate,!!k?.donotUseFormatters,a):super.s($,a,k)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$lrc=L}),define(Ee[339],Se([1,0,9,22,21,27,14,4,3,41,142,325,52]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Wcc=g,e.$Xcc=n,L=We(L);function b(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const c="$$ref$$",m={[c]:-1};class d{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function g(F,N=null,O=!1){const j=[];return{jsonString:(O?b:JSON.stringify)(F,(M,V)=>{if(typeof V>"u")return m;if(typeof V=="object"){if(V instanceof h.$Pe){const K=j.push(V)-1;return{[c]:K}}if(N)return N(M,V)}return V}),referencedBuffers:j}}function n(F,N,O){return JSON.parse(F,(j,z)=>{if(z){const M=z[c];if(typeof M=="number")return N[M];if(O&&z.$mid===a.MarshalledId.Uri)return O.transformIncoming(z)}return z})}function o(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,O)=>O&&O.$mid===a.MarshalledId.Uri?F.transformOutgoing(O):O:null}var i;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var r;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const f=()=>{},u=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class S extends $.$Xc{static{P=u}static{this.a=3*1e3}constructor(N,O=null,j=null){super(),this[P]=!0,this.b=this.B(new R.$ne),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=l.$Rw.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=r.Responsive,this.z=0,this.C=0,this.D=this.B(new s.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$9())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(r.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(r.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,k.$Pn)(N,this.g):N}getProxy(N){const{nid:O,sid:j}=N;return this.s[O]||(this.s[O]=this.J(O,j)),this.s[O]}J(N,O){const j={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===T.CharCode.DollarSign&&(z[M]=(...V)=>this.U(N,M,V)),M===w?O:z[M])};return new Proxy(Object.create(null),j)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,j=N.length;O<j;O++){const z=N[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,j=y.read(N,0),z=j.readUInt8(),M=j.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:V,method:K,args:re}=A.deserializeRequestJSONArgs(j);this.g&&(re=(0,k.$Pn)(re,this.g)),this.M(O,M,V,K,re,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:V,method:K,args:re}=A.deserializeRequestMixedArgs(j);this.g&&(re=(0,k.$Pn)(re,this.g)),this.M(O,M,V,K,re,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(O,M,i.LocalSide,"ack"),this.G(M);break}case p.Cancel:{this.N(O,M);break}case p.ReplyOKEmpty:{this.O(O,M,void 0);break}case p.ReplyOKJSON:{let V=A.deserializeReplyOKJSON(j);this.g&&(V=(0,k.$Pn)(V,this.g)),this.O(O,M,V);break}case p.ReplyOKJSONWithBuffers:{const V=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(O,M,V);break}case p.ReplyOKVSBuffer:{const V=A.deserializeReplyOKVSBuffer(j);this.O(O,M,V);break}case p.ReplyErrError:{let V=A.deserializeReplyErrError(j);this.g&&(V=(0,k.$Pn)(V,this.g)),this.P(O,M,V);break}case p.ReplyErrEmpty:{this.P(O,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,j,z,M,V){this.f?.logIncoming(N,O,i.OtherSide,`receiveRequest ${(0,l.$Tw)(j)}.${z}(`,M);const K=String(O);let re,B;if(V){const X=new I.$ye;M.push(X.token),re=this.Q(j,z,M),B=()=>X.cancel()}else re=this.Q(j,z,M),B=f;this.u[K]=B;const G=A.serializeAcknowledged(O);this.f?.logOutgoing(G.byteLength,O,i.OtherSide,"ack"),this.c.send(G),re.then(X=>{delete this.u[K];const ee=A.serializeReplyOK(O,X,this.h);this.f?.logOutgoing(ee.byteLength,O,i.OtherSide,"reply:",X),this.c.send(ee)},X=>{delete this.u[K];const ee=A.serializeReplyErr(O,X);this.f?.logOutgoing(ee.byteLength,O,i.OtherSide,"replyErr:",X),this.c.send(ee)})}N(N,O){this.f?.logIncoming(N,O,i.OtherSide,"receiveCancel");const j=String(O);this.u[j]?.()}O(N,O,j){this.f?.logIncoming(N,O,i.LocalSide,"receiveReply:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(j)}P(N,O,j){this.f?.logIncoming(N,O,i.LocalSide,"receiveReplyErr:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let V;j&&(j.$isError?(V=new Error,V.name=j.name,V.message=j.message,V.stack=j.stack):V=j),M.resolveErr(V)}Q(N,O,j){try{return Promise.resolve(this.S(N,O,j))}catch(z){return Promise.reject(z)}}S(N,O,j){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,l.$Tw)(N));const M=z[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,l.$Tw)(N));return M.apply(z,j)}U(N,O,j){if(this.j)return new E.$Vcc;let z=null;if(j.length>0&&I.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$9());const M=A.serializeRequestArguments(j,this.h),V=++this.t,K=String(V),re=new E.$Ucc,B=new $.$Wc;z&&B.add(z.onCancellationRequested(()=>{const X=A.serializeCancel(V);this.f?.logOutgoing(X.byteLength,V,i.LocalSide,"cancel"),this.c.send(A.serializeCancel(V))})),this.w[K]=new D(re,B),this.F(V);const G=A.serializeRequest(V,N,O,M,!!z);return this.f?.logOutgoing(G.byteLength,V,i.LocalSide,`request: ${(0,l.$Tw)(N)}.${O}(`,j),this.c.send(G),re}}e.$Ycc=S;class D{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class y{static alloc(N,O,j){const z=new y(h.$Pe.alloc(j+1+4),0);return z.writeUInt8(N),z.writeUInt32(O),z}static read(N,O){return new y(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let j=0,z=N.length;j<z;j++){const M=N[j];switch(O+=1,M.type){case v.String:O+=this.sizeLongString(M.value);break;case v.VSBuffer:O+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let V=0;V<M.buffers.length;++V)O+=this.sizeVSBuffer(M.buffers[V]);break;case v.Undefined:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,j=N.length;O<j;O++){const z=N[O];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case v.String:O[j]=this.readLongString();break;case v.VSBuffer:O[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),V=this.readLongString(),K=[];for(let re=0;re<M;++re)K.push(this.readVSBuffer());O[j]=new l.$Uw(n(V,K,null));break}case v.Undefined:O[j]=void 0;break}return O}}var C;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(C||(C={}));class A{static a(N){for(let O=0,j=N.length;O<j;O++)if(N[O]instanceof h.$Pe||N[O]instanceof l.$Uw||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const j=[];for(let z=0,M=N.length;z<M;z++){const V=N[z];if(V instanceof h.$Pe)j[z]={type:v.VSBuffer,value:V};else if(typeof V>"u")j[z]={type:v.Undefined};else if(V instanceof l.$Uw){const{jsonString:K,referencedBuffers:re}=g(V.value,O);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Pe.fromString(K),buffers:re}}else j[z]={type:v.String,value:h.$Pe.fromString(o(V,O))}}return{type:C.Mixed,args:j}}return{type:C.Simple,args:o(N,O)}}static serializeRequest(N,O,j,z,M){switch(z.type){case C.Simple:return this.b(N,O,j,z.args,M);case C.Mixed:return this.c(N,O,j,z.args,M)}}static b(N,O,j,z,M){const V=h.$Pe.fromString(j),K=h.$Pe.fromString(z);let re=0;re+=y.sizeUInt8(),re+=y.sizeShortString(V),re+=y.sizeLongString(K);const B=y.alloc(M?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,N,re);return B.writeUInt8(O),B.writeShortString(V),B.writeLongString(K),B.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readLongString();return{rpcId:O,method:j,args:JSON.parse(z)}}static c(N,O,j,z,M){const V=h.$Pe.fromString(j);let K=0;K+=y.sizeUInt8(),K+=y.sizeShortString(V),K+=y.sizeMixedArray(z);const re=y.alloc(M?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,N,K);return re.writeUInt8(O),re.writeShortString(V),re.writeMixedArray(z),re.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readMixedArray(),M=new Array(z.length);for(let V=0,K=z.length;V<K;V++){const re=z[V];typeof re=="string"?M[V]=JSON.parse(re):M[V]=re}return{rpcId:O,method:j,args:M}}static serializeAcknowledged(N){return y.alloc(p.Acknowledged,N,0).buffer}static serializeCancel(N){return y.alloc(p.Cancel,N,0).buffer}static serializeReplyOK(N,O,j){if(typeof O>"u")return this.d(N);if(O instanceof h.$Pe)return this.e(N,O);if(O instanceof l.$Uw){const{jsonString:z,referencedBuffers:M}=g(O.value,j,!0);return this.g(N,z,M)}else return this.f(N,b(O,j))}static d(N){return y.alloc(p.ReplyOKEmpty,N,0).buffer}static e(N,O){let j=0;j+=y.sizeVSBuffer(O);const z=y.alloc(p.ReplyOKVSBuffer,N,j);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const j=h.$Pe.fromString(O);let z=0;z+=y.sizeLongString(j);const M=y.alloc(p.ReplyOKJSON,N,z);return M.writeLongString(j),M.buffer}static g(N,O,j){const z=h.$Pe.fromString(O);let M=0;M+=y.sizeUInt32,M+=y.sizeLongString(z);for(const K of j)M+=y.sizeVSBuffer(K);const V=y.alloc(p.ReplyOKJSONWithBuffers,N,M);V.writeUInt32(j.length),V.writeLongString(z);for(const K of j)V.writeBuffer(K);return V.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const j=N.readUInt32(),z=N.readLongString(),M=[];for(let V=0;V<j;++V)M.push(N.readVSBuffer());return new l.$Uw(n(z,M,O))}static serializeReplyErr(N,O){const j=O?b(L.$5(O),null):void 0;if(typeof j!="string")return this.h(N);const z=h.$Pe.fromString(j);let M=0;M+=y.sizeLongString(z);const V=y.alloc(p.ReplyErrError,N,M);return V.writeLongString(z),V.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return y.alloc(p.ReplyErrEmpty,N,0).buffer}}var p;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[340],Se([1,0,22,29,15,89,5]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$eL=void 0,e.$fL=k,e.$gL=E,e.$eL=(0,L.$Gi)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${R.join("")}]+`),a=7;function k(P){if(P.scheme!==I.Schemas.vscodeNotebookCell)return;const b=P.fragment.indexOf("s");if(b<0)return;const c=parseInt(P.fragment.substring(0,b).replace($,""),a),m=(0,s.$9e)(P.fragment.substring(b+1)).toString();if(!isNaN(c))return{handle:c,notebook:P.with({scheme:m,fragment:null})}}function E(P,b){const c=b.toString(a),d=`${c.length<R.length?R[c.length-1]:"z"}${c}s${(0,s.$0e)(s.$Pe.fromString(P.scheme),!0,!0)}`;return P.with({scheme:I.Schemas.vscodeNotebookCell,fragment:d})}class l{constructor(){this.a=new h.$Dc}getNotebook(b){if(b.scheme===I.Schemas.vscodeNotebookCell){const c=k(b);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$hL=l,(0,T.$Ps)(e.$eL,l,T.InstantiationType.Delayed)}),define(Ee[127],Se([1,0,22,39,40,108,15,17,11,36,340]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=r,e.$vL=w,e.$wL=S,e.$zL=C,e.$AL=p,h=We(h),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var E;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(E||(e.CellKind=E={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",T.$9s.latex,T.$9s.markdown,"image/png","image/jpeg",T.$9s.text],e.$oL=[T.$9s.latex,T.$9s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$9s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var P;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var c;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var d;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var g;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(K){K.scheme=L.Schemas.vscodeNotebookCell;function re(ne,De){return(0,k.$gL)(ne,De)}K.generate=re;function B(ne){return(0,k.$fL)(ne)}K.parse=B;function G(ne,De){return ne.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${ne.scheme!==L.Schemas.file?ne.scheme:""}`})}K.generateCellOutputUri=G;function X(ne){if(ne.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!De)return;const $e=De[1]&&De[1]!==""?De[1]:void 0,J=De[2];return{outputId:$e,notebook:ne.with({scheme:J||L.Schemas.file,fragment:null})}}K.parseCellOutputUri=X;function ee(ne,De,$e){return K.generate(ne,De).with({scheme:$e})}K.generateCellPropertyUri=ee;function de(ne,De){if(ne.scheme===De)return K.parse(ne.with({scheme:K.scheme}))}K.parseCellPropertyUri=de})(o||(e.CellUri=o={}));const t=K=>$.$i?K.replace(/\//g,"\\"):K;class i{constructor(re=[],B=e.$nL){this.e=B,this.d=[...new Set(re)].map(G=>({pattern:G,matches:h.$Ak(t(G))}))}sort(re){const B=new Map(I.Iterable.map(re,X=>[X,t(X)]));let G=[];for(const{matches:X}of this.d)for(const[ee,de]of B)if(X(de)){G.push(ee),B.delete(ee);break}return B.size&&(G=G.concat([...B.keys()].sort((X,ee)=>this.e.indexOf(X)-this.e.indexOf(ee)))),G}prioritize(re,B){const G=this.f(re);if(G===-1){this.d.unshift({pattern:re,matches:h.$Ak(t(re))});return}const X=new Set(B.map(de=>this.f(de,G)));X.delete(-1);const ee=Array.from(X).sort();this.d.splice(G+1,0,...ee.map(de=>this.d[de]));for(let de=ee.length-1;de>=0;de--)this.d.splice(ee[de],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,B=this.d.length){const G=t(re);for(let X=0;X<B;X++)if(this.d[X].matches(G))return X;return-1}}e.$rL=i;function r(K,re,B,G=(X,ee)=>X===ee){const X=[];function ee(De,$e,J){if($e===0&&J.length===0)return;const U=X[X.length-1];U&&U.start+U.deleteCount===De?(U.deleteCount+=$e,U.toInsert.push(...J)):X.push({start:De,deleteCount:$e,toInsert:J})}let de=0,ne=0;for(;;){if(de===K.length){ee(de,0,re.slice(ne));break}if(ne===re.length){ee(de,K.length-de,[]);break}const De=K[de],$e=re[ne];if(G(De,$e)){de+=1,ne+=1;continue}B($e)?(ee(de,1,[]),de+=1):(ee(de,0,[$e]),ne+=1)}return X}e.$tL=new a.$Xj("notebookEditorCursorAtBoundary","none"),e.$uL=new a.$Xj("notebookEditorCursorAtLineBoundary","none");var f;(function(K){K.default="default",K.option="option"})(f||(e.NotebookEditorPriority=f={}));var u;(function(K){K.Cells="cells",K.Text="text",K.None="none"})(u||(e.NotebookFindScopeType=u={}));function w(K){const re=K;return!!((typeof re.include=="string"||h.$Bk(re.include))&&(typeof re.exclude=="string"||h.$Bk(re.exclude)))}function S(K,re,B){if(Array.isArray(K.viewType)&&K.viewType.indexOf(re)>=0||K.viewType===re)return!0;if(K.filenamePattern){const G=w(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,X=w(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(h.$zk(G,(0,R.$qc)(B.fsPath).toLowerCase()))return!(X&&h.$zk(X,(0,R.$qc)(B.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class y{static{this.d="notebook/"}static create(re){return`${y.d}${re}`}static parse(re){if(re.startsWith(y.d))return re.substring(y.d.length)}}e.$yL=y;function C(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const A=new TextDecoder;function p(K){const re=[];let B=!1;for(const de of K)(re.length===0||B)&&(re.push(de),B=!0);let G=N(re);const X=s.$Pe.concat(re.map(de=>s.$Pe.wrap(de))),ee=V(X);return G=G||ee.byteLength!==X.byteLength,{data:ee,didCompression:G}}e.$BL="\x1B[A";const v=e.$BL.split("").map(K=>K.charCodeAt(0)),F=10;function N(K){let re=!1;return K.forEach((B,G)=>{if(G===0||B.length<e.$BL.length)return;const X=K[G-1],ee=B.subarray(0,e.$BL.length);if(ee[0]===v[0]&&ee[1]===v[1]&&ee[2]===v[2]){const de=X.lastIndexOf(F);if(de===-1)return;re=!0,K[G-1]=X.subarray(0,de),K[G]=B.subarray(e.$BL.length)}}),re}function O(K){let re=K;do K=re,re=K.replace(/[^\n]\x08/gm,"");while(re.length<K.length);return K}function j(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const re=K.match(/^(.*)\r+/m)[1];let B=K.match(/\r+(.*)$/m)[1];B=B+re.slice(B.length,re.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return K}const z=8,M=13;function V(K){return!K.buffer.includes(z)&&!K.buffer.includes(M)?K:s.$Pe.fromString(j(O(A.decode(K.buffer))))}}),define(Ee[10],Se([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b){"use strict";var c,m,d,g,n,o,t,i,r,f,u,w,S,D,y,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=et,e.$wO=Di,e.$bP=Ri;function p(Q){return Object.assign(Q,{apply:function(...me){if(me.length===0)return Reflect.construct(Q,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(Q,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Q,[]);{const[Le,...Ze]=me;return Reflect.construct(Q,Ze,Le.constructor)}}})}var v;(function(Q){Q[Q.Top=0]="Top",Q[Q.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(Q){Q[Q.TerminalCommand=0]="TerminalCommand",Q[Q.Opener=1]="Opener",Q[Q.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=c=class{static from(...H){let me=H;return new c(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=N,e.$wN=N=c=Xe([p],N);let O=m=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isBefore(me)&&(me=Ze)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isAfter(me)&&(me=Ze)}return me}static isPosition(H){if(!H)return!1;if(H instanceof m)return!0;const{line:me,character:Le}=H;return typeof me=="number"&&typeof Le=="number"}static of(H){if(H instanceof m)return H;if(this.isPosition(H))return new m(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$0)("line must be non-negative");if(me<0)throw(0,h.$0)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$0)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&me===0?this:new m(this.line+Le,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$0)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Le===this.line&&me===this.character?this:new m(Le,me)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=O,e.$xN=O=m=Xe([p],O);let j=d=class{static isRange(H){return H instanceof d?!0:H?O.isPosition(H.start)&&O.isPosition(H.end):!1}static of(H){if(H instanceof d)return H;if(this.isRange(H))return new d(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Le,Ze){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new O(H,me),$t=new O(Le,Ze)):O.isPosition(H)&&O.isPosition(me)&&(st=O.of(H),$t=O.of(me)),!st||!$t)throw new Error("Invalid arguments");st.isBefore($t)?(this.c=st,this.e=$t):(this.c=$t,this.e=st)}contains(H){return d.isRange(H)?this.contains(H.start)&&this.contains(H.end):O.isPosition(H)?!(O.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=O.Max(H.start,this.c),Le=O.Min(H.end,this.e);if(!me.isAfter(Le))return new d(me,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=O.Min(H.start,this.c),Le=O.Max(H.end,this.end);return new d(me,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$0)();let Le;return H?O.isPosition(H)?Le=H:(Le=H.start||this.start,me=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&me.isEqual(this.end)?this:new d(Le,me)}toJSON(){return[this.start,this.end]}};e.$yN=j,e.$yN=j=d=Xe([p],j);let z=g=class extends j{static isSelection(H){return H instanceof g?!0:H?j.isRange(H)&&O.isPosition(H.anchor)&&O.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Le,Ze){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new O(H,me),$t=new O(Le,Ze)):O.isPosition(H)&&O.isPosition(me)&&(st=O.of(H),$t=O.of(me)),!st||!$t)throw new Error("Invalid arguments");super(st,$t),this.f=st,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=z,e.$zN=z=g=Xe([p],z);const M=Q=>{if(typeof Q!="string"||Q.length===0||!/^[0-9A-Za-z_\-]+$/.test(Q))throw(0,h.$0)("connectionToken")};class V{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Le){if(typeof H!="string"||H.length===0)throw(0,h.$0)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$0)("port");typeof Le<"u"&&M(Le),this.host=H,this.port=Math.round(me),this.connectionToken=Le}}e.$AN=V;class K{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&M(me)}}e.$BN=K;class re extends Error{static NotAvailable(H,me){return new re(H,P.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=me,this._detail=Le,Object.setPrototypeOf(this,re.prototype)}}e.$CN=re;var B;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(B||(e.EndOfLine=B={}));var G;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let X=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new O(0,0),new O(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$0)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$0)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$0)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=X,e.$DN=X=n=Xe([p],X);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?bt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new bt(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Le=new o(new bt(H,H),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(H){const me=new o(new bt(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$EN=ee,e.$EN=ee=o=Xe([p],ee);class de{static isSnippetTextEdit(H){return H instanceof de?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new de(H,me)}static insert(H,me){return de.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$FN=de;var ne;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace",Q[Q.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Le,Ze){this.c.push({_type:ne.File,from:H,to:me,options:Le,metadata:Ze})}createFile(H,me,Le){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Le})}deleteFile(H,me,Le){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Le})}e(H,me,Le){this.c.push({_type:ne.Cell,metadata:Le,uri:H,edit:{editType:b.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Le,Ze){const st=me.start,$t=me.end;(st!==$t||Le.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:$t-st,cells:Le,metadata:Ze})}g(H,me,Le,Ze){this.c.push({_type:ne.Cell,metadata:Ze,uri:H,edit:{editType:b.CellEditType.Metadata,index:me,metadata:Le}})}replace(H,me,Le,Ze){this.c.push({_type:ne.Text,uri:H,edit:new X(me,Le),metadata:Ze})}insert(H,me,Le,Ze){this.replace(H,new j(me,me),Le,Ze)}delete(H,me,Le){this.replace(H,me,"",Le)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Le of me){if(!Le)continue;let Ze,st;Array.isArray(Le)?(Ze=Le[0],st=Le[1]):Ze=Le,ee.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(H,Ze.range.start,Ze.newCellMetadata,st):Ze.newNotebookMetadata?this.e(H,Ze.newNotebookMetadata,st):this.f(H,Ze.range,Ze.newCells,st):de.isSnippetTextEdit(Ze)?this.c.push({_type:ne.Snippet,uri:H,range:Ze.range,edit:Ze.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Ze,metadata:st})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ze.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,s.$Lb)(this.c)}}get(H){const me=[];for(const Le of this.c)Le._type===ne.Text&&Le.uri.toString()===H.toString()&&me.push(Le.edit);return me}entries(){const H=new T.$Dc;for(const me of this.c)if(me._type===ne.Text){let Le=H.get(me.uri);Le||(Le=[me.uri,[]],H.set(me.uri,Le)),Le[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=De,e.$GN=De=Xe([p],De);let $e=t=class{static isSnippetString(H){return H instanceof t?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=t.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Le=new t;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=t.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Le=H.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Le=new t;Le.e=this.e,me(Le),this.e=Le.e,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$HN=$e,e.$HN=$e=t=Xe([p],$e);var J;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var U;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(U||(e.DiagnosticSeverity=U={}));let se=i=class{static isLocation(H){return H instanceof i?!0:H?j.isRange(H.range)&&a.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(O.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=se,e.$IN=se=i=Xe([p],se);let ae=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&a.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$JN=ae,e.$JN=ae=Xe([p],ae);let te=class{constructor(H,me,Le=U.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Le}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,s.$xb)(H.tags,me.tags)&&(0,s.$xb)(H.relatedInformation,me.relatedInformation,ae.isEqual)}};e.$KN=te,e.$KN=te=Xe([p],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$LN=le,e.$LN=le=Xe([p],le);let ue=class extends le{constructor(H,me,Le,Ze){super(H,me),this.canIncreaseHover=Le,this.canDecreaseHover=Ze}};e.$MN=ue,e.$MN=ue=Xe([p],ue);var Z;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(Z||(e.HoverVerbosityAction=Z={}));var oe;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let pe=class{constructor(H,me=oe.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$NN=pe,e.$NN=pe=Xe([p],pe);let we=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$ON=we,e.$ON=we=Xe([p],we);var Fe;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var Ue;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ke=r=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Le,Ze,st){this.name=H,this.kind=me,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),Ze instanceof se?this.location=Ze:Le instanceof j&&(this.location=new se(Ze,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=ke,e.$PN=ke=r=Xe([p],ke);let Pe=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(f.validate)}constructor(H,me,Le,Ze,st){this.name=H,this.detail=me,this.kind=Le,this.range=Ze,this.selectionRange=st,this.children=[],f.validate(this)}};e.$QN=Pe,e.$QN=Pe=f=Xe([p],Pe);var Te;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let W=class{constructor(H,me){this.title=H,this.kind=me}};e.$RN=W,e.$RN=W=Xe([p],W);let q=class{static{u=this}static{this.c="."}constructor(H){this.value=H}append(H){return new u(this.value?this.value+u.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+u.c)}};e.$SN=q,e.$SN=q=u=Xe([p],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let Y=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=Y,e.$TN=Y=Xe([p],Y);class _{constructor(H,me,Le,Ze,st,$t){this.kind=H,this.name=me,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=$t}}e.$UN=_;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$VN=fe;class be{constructor(H,me){this.fromRanges=me,this.to=H}}e.$WN=be;var Ne;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ge=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$XN=Ge,e.$XN=Ge=Xe([p],Ge);let Ke=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new I.$4k(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$YN=Ke,e.$YN=Ke=w=Xe([p],Ke);let tt=class{constructor(H,me){this.label=H,this.documentation=me}};e.$ZN=tt,e.$ZN=tt=Xe([p],tt);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$1N=rt,e.$1N=rt=Xe([p],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=ot,e.$2N=ot=Xe([p],ot);var nt;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let mt=class{constructor(H){this.value=H}};e.$3N=mt,e.$3N=mt=Xe([p],mt);let ht=class{constructor(H,me,Le){this.position=H,this.label=me,this.kind=Le}};e.$4N=ht,e.$4N=ht=Xe([p],ht);var ct;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var Ie;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(Ie||(e.CompletionItemKind=Ie={}));var ze;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(ze||(e.CompletionItemTag=ze={}));let He=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Ie[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=He,e.$5N=He=Xe([p],He);let Oe=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$6N=Oe,e.$6N=Oe=Xe([p],Oe);let je=class{constructor(H,me,Le){this.insertText=H,this.range=me,this.command=Le}};e.$7N=je,e.$7N=je=Xe([p],je);let he=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$8N=he,e.$8N=he=Xe([p],he);var x;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Word=1]="Word",Q[Q.Line=2]="Line",Q[Q.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var Ce;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Ye;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(Ye||(e.StatusBarAlignment=Ye={}));function et(Q,H){return`${E.$rn.toKey(Q)}.${H}`}var ut;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var Dt;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(Dt||(e.TextEditorRevealType=Dt={}));var Ot;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var qt;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(qt||(e.TextDocumentChangeReason=qt={}));var ui;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(Q){function H(me){switch(me){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=H}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var ti;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(Q){function H(me){switch(me){case Q.Other:return"other";case Q.Comment:return"comment";case Q.String:return"string";case Q.RegEx:return"regex"}return"other"}Q.toString=H}(ti||(e.SyntaxTokenType=ti={}));let _e=class{constructor(H,me){if(me&&!a.URI.isUri(me))throw(0,h.$0)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$0)("range");this.range=H,this.target=me}};e.$0N=_e,e.$0N=_e=Xe([p],_e);let Kt=class{constructor(H,me,Le,Ze){this.red=H,this.green=me,this.blue=Le,this.alpha=Ze}};e.$$N=Kt,e.$$N=Kt=Xe([p],Kt);let Qt=class{constructor(H,me){if(me&&!(me instanceof Kt))throw(0,h.$0)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$0)("range");this.range=H,this.color=me}};e.$_N=Qt,e.$_N=Qt=Xe([p],Qt);let pt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$0)("label");this.label=H}};e.$aO=pt,e.$aO=pt=Xe([p],pt);var It;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(It||(e.ColorFormat=It={}));var ii;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Zt;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Shutdown=1]="Shutdown",Q[Q.Process=2]="Process",Q[Q.User=3]="User",Q[Q.Extension=4]="Extension"})(Zt||(e.TerminalExitReason=Zt={}));var Vt;(function(Q){Q[Q.Low=0]="Low",Q[Q.Medium=1]="Medium",Q[Q.High=2]="High"})(Vt||(e.TerminalShellExecutionCommandLineConfidence=Vt={}));class vt{constructor(H,me,Le){if(this.startIndex=H,this.length=me,this.tooltip=Le,typeof H!="number"||H<0)throw(0,h.$0)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$0)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$0)("tooltip")}}e.$bO=vt;class Nt{constructor(H){this.uri=H}}e.$cO=Nt;class hi{constructor(H){this.terminalCommand=H}}e.$dO=hi;var Gt;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Gt||(e.TerminalLocation=Gt={}));class xe{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$0)("options")}}e.$eO=xe;var xt;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(xt||(e.TaskRevealKind=xt={}));var ni;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let di=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(H){switch(H){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$0)("name");this.c=H}get id(){return this.c}};e.$fO=di,e.$fO=di=S=Xe([p],di);function kt(Q){let H="";for(let me=0;me<Q.length;me++)H+=Q[me].replace(/,/g,",,")+",";return H}let Ft=class{constructor(H,me,Le){if(typeof H!="string")throw(0,h.$0)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Le):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$0)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return kt(H)}};e.$gO=Ft,e.$gO=Ft=Xe([p],Ft);let Rt=class{constructor(H,me,Le){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$0)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$0)("command");this.e=H,this.f=me,this.g=Le}else{if(typeof H!="string")throw(0,h.$0)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$0)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$0)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return kt(H)}};e.$hO=Rt,e.$hO=Rt=Xe([p],Rt);var zt;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(zt||(e.ShellQuoting=zt={}));var ri;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class _t{constructor(H){this.c=H}computeId(){return"customExecution"+(0,k.$3g)()}set callback(H){this.c=H}get callback(){return this.c}}e.$iO=_t;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Le,Ze,st,$t){this.k=!1,this.l=this.definition=H;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Le,this.execution=Ze,yt=st,this.k=!0):me===ri.Global||me===ri.Workspace?(this.target=me,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,yt=$t):(this.target=me,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof _t?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,k.$3g)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$0)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$0)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$0)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$jO=si,e.$jO=si=D=Xe([p],si);var Bt;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var Jt;(function(Q){function H(me){const Le=me;return(0,$.$kg)(Le.value)?Le.tooltip&&!(0,$.$gg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}Q.isViewBadge=H})(Jt||(e.ViewBadge=Jt={}));let oi=y=class{static isTreeItem(H,me){const Le=H;if(Le.checkboxState!==void 0){const Ze=(0,$.$kg)(Le.checkboxState)?Le.checkboxState:(0,$.$ig)(Le.checkboxState)&&(0,$.$kg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,$.$kg)(Le.checkboxState)&&(0,$.$ig)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==St.Checked&&Ze!==St.Unchecked||st!==void 0&&!(0,$.$gg)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof y)return!0;if(Le.label!==void 0&&!(0,$.$gg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$gg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$gg)(Le.iconPath)&&!a.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$gg)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$gg)(Ze.light)&&!a.URI.isUri(Ze.light)&&!(0,$.$gg)(Ze.dark)&&!a.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$gg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!a.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$gg)(Le.tooltip)&&!(Le.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<At.None&&Le.collapsibleState>At.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$gg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,me=At.None){this.collapsibleState=me,a.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$kO=oi,e.$kO=oi=y=Xe([p],oi);var At;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(At||(e.TreeItemCollapsibleState=At={}));var St;(function(Q){Q[Q.Unchecked=0]="Unchecked",Q[Q.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$lO=wt,e.$lO=wt=Xe([p],wt);class ei extends wt{}e.$mO=ei;class Pt extends ei{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$nO=Pt;class fi{constructor(H,me,Le,Ze){this.name=H,this.uri=me,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$oO=fi;let Ht=class{#e=new Map;constructor(H){for(const[me,Le]of H??[]){const Ze=this.#e.get(this.#t(me));Ze?Ze.push(Le):this.#e.set(this.#t(me),[Le])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Le,Ze]of this.#e)for(const st of Ze)H.call(me,st,Le,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Le of me)yield[H,Le]}#t(H){return H.toLowerCase()}};e.$pO=Ht,e.$pO=Ht=Xe([p],Ht);let wi=class{constructor(H,me,Le){this.insertText=H,this.title=me,this.kind=Le}};e.$qO=wi,e.$qO=wi=Xe([p],wi);var vi;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(H){this.value=H}append(...H){return new gi((this.value?[this.value,...H]:H).join(gi.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+gi.c)}}e.$rO=gi,gi.Empty=new gi("");class Ut{constructor(H,me,Le){this.title=me,this.insertText=H,this.kind=Le}}e.$sO=Ut;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$tO=ai,e.$tO=ai=Xe([p],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(H){this.id=H}};e.$uO=Ii,e.$uO=Ii=Xe([p],Ii);var Tt;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Si=class{get base(){return this.c}set base(H){this.c=H,this.e=a.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!a.URI.isUri(H)&&!a.URI.isUri(H.uri)))throw(0,h.$0)("base");if(typeof me!="string")throw(0,h.$0)("pattern");typeof H=="string"?this.baseUri=a.URI.file(H):a.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=Si,e.$vO=Si=Xe([p],Si);const Ci=new WeakMap;function Di(Q,H){Ci.set(Q,H)}let $i=class{constructor(H,me,Le,Ze,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=Ci.get(this)??(0,k.$3g)()),this.c}};e.$xO=$i,e.$xO=$i=Xe([p],$i);let Ai=class extends $i{constructor(H,me,Le,Ze,st,$t){if(super(me,Le,Ze,st,$t),H===null)throw(0,h.$0)("location");this.location=H}};e.$yO=Ai,e.$yO=Ai=Xe([p],Ai);let Wt=class extends $i{constructor(H,me,Le,Ze,st,$t){super(me,Le,Ze,st,$t),this.functionName=H}};e.$zO=Wt,e.$zO=Wt=Xe([p],Wt);let Ae=class extends $i{constructor(H,me,Le,Ze,st,$t,yt,Yt){if(super(Ze,st,$t,yt,Yt),!me)throw(0,h.$0)("dataId");this.label=H,this.dataId=me,this.canPersist=Le}};e.$AO=Ae,e.$AO=Ae=Xe([p],Ae);let Me=class{constructor(H,me,Le){this.command=H,this.args=me||[],this.options=Le}};e.$BO=Me,e.$BO=Me=Xe([p],Me);let ve=class{constructor(H,me){this.port=H,this.host=me}};e.$CO=ve,e.$CO=ve=Xe([p],ve);let ie=class{constructor(H){this.path=H}};e.$DO=ie,e.$DO=ie=Xe([p],ie);let Re=class{constructor(H){this.implementation=H}};e.$EO=Re,e.$EO=Re=Xe([p],Re);class Qe{constructor(H,me,Le){this.session=H,this.threadId=me,this.frameId=Le}}e.$FO=Qe;class it{constructor(H,me){this.session=H,this.threadId=me}}e.$GO=it;let Je=class{constructor(H,me){this.range=H,this.expression=me}};e.$HO=Je,e.$HO=Je=Xe([p],Je);var ft;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Ct=class{constructor(H,me){this.range=H,this.text=me}};e.$IO=Ct,e.$IO=Ct=Xe([p],Ct);let Xt=class{constructor(H,me,Le=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Le}};e.$JO=Xt,e.$JO=Xt=Xe([p],Xt);let ci=class{constructor(H,me){this.range=H,this.expression=me}};e.$KO=ci,e.$KO=ci=Xe([p],ci);let Mt=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$LO=Mt,e.$LO=Mt=Xe([p],Mt);var li;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(li||(e.NewSymbolNameTag=li={}));var qi;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(qi||(e.NewSymbolNameTriggerKind=qi={}));class pn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$MO=pn;var Fi;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Li=C=class extends Error{static FileExists(H){return new C(H,l.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(H){return new C(H,l.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(H){return new C(H,l.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(H){return new C(H,l.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(H){return new C(H,l.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(H){return new C(H,l.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(H,me=l.FileSystemProviderErrorCode.Unknown,Le){super(a.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,l.$pl)(this,me),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$NO=Li,e.$NO=Li=C=Xe([p],Li);let Vi=class{constructor(H,me,Le){this.start=H,this.end=me,this.kind=Le}};e.$OO=Vi,e.$OO=Vi=Xe([p],Vi);var xi;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$PO=Gi;function nn(Q){return typeof Q>"u"||(0,$.$hg)(Q)}class Hi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Le=H.tokenTypes.length;me<Le;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Le=H.tokenModifiers.length;me<Le;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Le,Ze,st){if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Le,Ze,st);if(j.isRange(H)&&typeof me=="string"&&nn(Le))return this.o(H,me,Le);throw(0,h.$0)()}o(H,me,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,st=H.start.character,$t=H.end.character-H.start.character,yt=this.k.get(me);let Yt=0;if(Le)for(const pi of Le){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(pi);Yt|=1<<bi>>>0}this.q(Ze,st,$t,yt,Yt)}q(H,me,Le,Ze,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let pi=0,bi=0;for(let Ei=0;Ei<Yt;Ei++){let Pi=this.g[5*Ei],Yi=this.g[5*Ei+1];Pi===0?(Pi=pi,Yi+=bi):Pi+=pi,this.g[5*Ei]=Pi,this.g[5*Ei+1]=Yi,pi=Pi,bi=Yi}}let $t=H,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Le=H.length/5|0;for(let yt=0;yt<Le;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const pi=H[5*yt],bi=H[5*Yt];if(pi===bi){const Ei=H[5*yt+1],Pi=H[5*Yt+1];return Ei-Pi}return pi-bi});const Ze=new Uint32Array(H.length);let st=0,$t=0;for(let yt=0;yt<Le;yt++){const Yt=5*me[yt],pi=H[Yt+0],bi=H[Yt+1],Ei=H[Yt+2],Pi=H[Yt+3],Yi=H[Yt+4],Bn=pi-st,kr=Bn===0?bi-$t:bi,Zi=5*yt;Ze[Zi+0]=Bn,Ze[Zi+1]=kr,Ze[Zi+2]=Ei,Ze[Zi+3]=Pi,Ze[Zi+4]=Yi,st=pi,$t=bi}return Ze}build(H){return this.f?new ji(new Uint32Array(this.g),H):new ji(Hi.r(this.g),H)}}e.$QO=Hi;class ji{constructor(H,me){this.resultId=me,this.data=H}}e.$RO=ji;class bn{constructor(H,me,Le){this.start=H,this.deleteCount=me,this.data=Le}}e.$SO=bn;class Oi{constructor(H,me){this.resultId=me,this.edits=H}}e.$TO=Oi;var rn;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class wn{constructor(H){this.name=H}}e.$UO=wn;let Ki=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VO=Ki,e.$VO=Ki=Xe([p],Ki);var zi;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var Qi;(function(Q){Q[Q.Info=1]="Info",Q[Q.Warning=2]="Warning",Q[Q.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var qe;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(qe||(e.ExtensionKind=qe={}));class yi{static validate(H){if(typeof H.badge=="string"){let me=(0,R.$Rf)(H.badge,0);if(me<H.badge.length&&(me+=(0,R.$Rf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Le){this.badge=H,this.tooltip=me,this.color=Le}}e.$WO=yi;let Bi=class{constructor(H){this.kind=H}};e.$XO=Bi,e.$XO=Bi=Xe([p],Bi);var lt;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast",Q[Q.HighContrastLight=4]="HighContrastLight"})(lt||(e.ColorThemeKind=lt={}));class bt{static isNotebookRange(H){return H instanceof bt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$0)("start must be positive");if(me<0)throw(0,h.$0)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Le=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Le=H.end),me===this.c&&Le===this.e?this:new bt(me,Le)}}e.$YO=bt;class Ui{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Ui.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Le,Ze,st,$t,yt){this.kind=H,this.value=me,this.languageId=Le,this.mime=Ze,this.outputs=st??[],this.metadata=$t,this.executionSummary=yt,Ui.validate(this)}}e.$ZO=Ui;class vn{constructor(H){this.cells=H}}e.$1O=vn;class mi{static isNotebookCellOutputItem(H){return H instanceof mi?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return mi.json(me,"application/vnd.code.notebook.error")}static stdout(H){return mi.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return mi.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new mi(H,me)}static#e=new TextEncoder;static text(H,me=L.$9s.text){const Le=mi.#e.encode(String(H));return new mi(Le,me)}static json(H,me="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return mi.text(Le,me)}constructor(H,me){this.data=H,this.mime=me;const Le=(0,L.$at)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$2O=mi;class Wi{static isNotebookCellOutput(H){return H instanceof Wi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Le=new Set,Ze=new Set;for(let st=0;st<H.length;st++){const $t=H[st],yt=(0,L.$at)($t.mime);if(!Le.has(yt)||(0,b.$zL)(yt)){Le.add(yt);continue}Ze.add(st),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ze.size===0?H:H.filter((st,$t)=>!Ze.has($t))}constructor(H,me,Le){this.items=Wi.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,k.$3g)(),this.metadata=me??Le)}}e.$3O=Wi;var Ni;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(Ni||(e.NotebookCellKind=Ni={}));var sn;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(H,me){this.text=H,this.alignment=me}}e.$4O=cn;var ln;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(ln||(e.NotebookControllerAffinity=ln={}));var un;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred",Q[Q.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class yn{constructor(H,me=[]){this.uri=H,this.provides=(0,s.$5b)(me)}}e.$5O=yn;class En{constructor(H){this.label=H}}e.$6O=En;var hn;(function(Q){Q[Q.Named=1]="Named",Q[Q.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$7O=Ji,e.$7O=Ji=Xe([p],Ji);var dn;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Sn{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$8O=Sn;class Dn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$9O=Dn;var ge;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(ge||(e.TestResultState=ge={}));var ye;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(ye||(e.TestRunProfileKind=ye={}));let Be=class{constructor(H=void 0,me=void 0,Le=void 0,Ze=!1,st=!0){this.include=H,this.exclude=me,this.profile=Le,this.continuous=Ze,this.preserveFocus=st}};e.$0O=Be,e.$0O=Be=Xe([p],Be);let dt=A=class{static diff(H,me,Le){const Ze=new A(H);return Ze.expectedOutput=me,Ze.actualOutput=Le,Ze}constructor(H){this.message=H}};e.$$O=dt,e.$$O=dt=A=Xe([p],dt);let Et=class{constructor(H){this.id=H}};e.$_O=Et,e.$_O=Et=Xe([p],Et);class Lt{constructor(H,me){this.covered=H,this.total=me,Ri(this)}}e.$aP=Lt;function Ri(Q){if(Q){if(Q.covered>Q.total)throw new Error(`The total number of covered items (${Q.covered}) cannot be greater than the total (${Q.total})`);if(Q.total<0)throw new Error(`The number of covered items (${Q.total}) cannot be negative`)}}class Xi{static fromDetails(H,me){const Le=new Lt(0,0),Ze=new Lt(0,0),st=new Lt(0,0);for(const yt of me)if("branches"in yt){Le.total+=1,Le.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ze.total+=1,Ze.covered+=Yt.executed?1:0}else st.total+=1,st.covered+=yt.executed?1:0;const $t=new Xi(H,Le,Ze.total>0?Ze:void 0,st.total>0?st:void 0);return $t.detailedCoverage=me,$t}constructor(H,me,Le,Ze,st=[]){this.uri=H,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Ze,this.fromTests=st}}e.$cP=Xi;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le=[]){this.executed=H,this.location=me,this.branches=Le}}e.$dP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.executed=H,this.location=me,this.label=Le}}e.$eP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.name=H,this.executed=me,this.location=Le}}e.$fP=Gn;var kn;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Pn;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Pn||(e.WorkspaceTrustState=Pn={}));var In;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Hn{constructor(H,me,Le,Ze,st,$t){this.kind=H,this.name=me,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=$t}}e.$gP=Hn;class Kn{constructor(H){this.uri=H}}e.$hP=Kn;class Qn{constructor(H,me){this.original=H,this.modified=me}}e.$iP=Qn;class Jn{constructor(H,me,Le,Ze){this.base=H,this.input1=me,this.input2=Le,this.result=Ze}}e.$jP=Jn;class Xn{constructor(H,me){this.uri=H,this.viewType=me}}e.$kP=Xn;class Yn{constructor(H){this.viewType=H}}e.$lP=Yn;class Zn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$mP=Zn;class xn{constructor(H,me,Le){this.original=H,this.modified=me,this.notebookType=Le}}e.$nP=xn;class _n{constructor(){}}e.$oP=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class ir{constructor(H){this.textDiffs=H}}e.$rP=ir;var Cn;(function(Q){Q[Q.Down=0]="Down",Q[Q.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Q){Q[Q.Action=1]="Action",Q[Q.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Q){Q[Q.Short=1]="Short",Q[Q.Medium=2]="Medium",Q[Q.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Le){this.id=H,this.label=me,this.values=Le}}e.$sP=nr;var Tn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful",Q[Q.Undone=2]="Undone",Q[Q.Accepted=3]="Accepted",Q[Q.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Ln;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$tP=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H,this.vulnerabilities=me}}e.$uP=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$vP=or;class ar{constructor(H,me,Le){this.title=H,this.message=me,this.data=Le}}e.$wP=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$xP=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$yP=lr;class ur{constructor(H){this.value=H}}e.$zP=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$AP=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$BP=dr;class fr{constructor(H){this.value=H}}e.$CP=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$DP=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$EP=mr;class $r{constructor(H,me,Le,Ze){this.prompt=H,this.command=me,this.references=Le,this.participant=Ze}}e.$FP=$r;class pr{constructor(H,me,Le,Ze){this.response=H,this.result=me,this.participant=Le,this.command=Ze}}e.$GP=pr;var On;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Terminal=2]="Terminal",Q[Q.Notebook=3]="Notebook",Q[Q.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var mn;(function(Q){Q[Q.User=1]="User",Q[Q.Assistant=2]="Assistant",Q[Q.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class br{constructor(H,me,Le){this.name=H,this.content=me,this.isError=Le??!1}}e.$HP=br;class $n{static User(H,me){const Le=new $n(mn.User,typeof H=="string"?H:"",me);return Le.content2=H,Le}static Assistant(H,me){return new $n(mn.Assistant,H,me)}constructor(H,me,Le){this.role=H,this.content=me,this.content2=me,this.name=Le}}e.$IP=$n;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$JP=wr;class vr{constructor(H){this.value=H}}e.$KP=vr;class yr{constructor(H){this.content=H}}e.$LP=yr;class Er{constructor(H,me){this.content=H,this.name=me}}e.$MP=Er;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$NP=Sr;class Ti extends Error{static NotFound(H){return new Ti(H,Ti.NotFound.name)}static NoPermissions(H){return new Ti(H,Ti.NoPermissions.name)}static Blocked(H){return new Ti(H,Ti.Blocked.name)}constructor(H,me,Le){super(H,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.$OP=Ti;var Nn;(function(Q){Q[Q.SymbolInformation=1]="SymbolInformation",Q[Q.CommandInformation=2]="CommandInformation",Q[Q.SearchInformation=3]="SearchInformation",Q[Q.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Fn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Recognizing=2]="Recognizing",Q[Q.Recognized=3]="Recognized",Q[Q.Stopped=4]="Stopped",Q[Q.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Stopped=2]="Stopped",Q[Q.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var jn;(function(Q){Q[Q.Recognized=1]="Recognized",Q[Q.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$PP=Dr;var zn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(Ee[341],Se([1,0,6,10]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(s.$uN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,$){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(L);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(R,$)??[]}getRelatedInformation(L,R,$){return this.c.$getAiRelatedInformation(R,$)}registerRelatedInformationProvider(L,R,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiRelatedInformationProvider(a,R),new h.$wN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$ooc=I}),define(Ee[128],Se([1,0,4,6,10,24,156,5,20]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=e.$zoc=void 0,e.$zoc=(0,R.$Gi)("IExtHostAuthentication");let a=class{constructor(l){this.b=new Map,this.c=new s.$ne,this.onDidChangeSessions=this.c.event,this.d=new k,this.f=new k,this.a=l.getProxy(h.$uN.MainThreadAuthentication)}async getSession(l,P,b,c={}){const m=T.$rn.toKey(l.identifier),d=[...b].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${d}`,async()=>{await this.a.$ensureProvider(P);const g=l.displayName||l.name;return this.a.$getSession(P,b,m,g,c)})}async getSessions(l,P,b){const c=T.$rn.toKey(l.identifier),m=[...b].sort().join(" ");return await this.f.getOrCreate(`${c} ${m}`,async()=>{await this.a.$ensureProvider(P);const d=l.displayName||l.name;return this.a.$getSessions(P,b,c,d)})}async getAccounts(l){return await this.a.$ensureProvider(l),await this.a.$getAccounts(l)}async removeSession(l,P){const b=this.b.get(l);return b?b.provider.removeSession(P):this.a.$removeSession(l,P)}registerAuthenticationProvider(l,P,b,c){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:P,provider:b,options:c??{supportsMultipleAccounts:!1}});const m=b.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(l,d));return this.a.$registerAuthenticationProvider(l,P,c?.supportsMultipleAccounts??!1),new I.$wN(()=>{m.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,P,b){const c=this.b.get(l);if(c)return await c.provider.createSession(P,b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,P){const b=this.b.get(l);if(b)return await b.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,P,b){const c=this.b.get(l);if(c)return await c.provider.getSessions(P,b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,P){return l.startsWith(L.$wM)||this.c.fire({provider:{id:l,label:P}}),Promise.resolve()}};e.$Aoc=a,e.$Aoc=a=Xe([Ve(0,$.$1P)],a);class k{constructor(){this.a=new Map}getOrCreate(l,P){const b=this.a.get(l);if(b)return b;const c=P().finally(()=>this.a.delete(l));return this.a.set(l,c),c}}}),define(Ee[163],Se([1,0,2,6,10,5,20,12,19,13,17,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=void 0;let P=class{static{l=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(h.$uN.MainThreadDecorations)}registerFileDecorationProvider(c,m){const d=l.c++;this.f.set(d,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(d,m.identifier.value);const g=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(d,null);return}const o=(0,$.$5b)(n);if(o.length<=l.d){this.g.$onDidChange(d,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,o.length);const t=o.map(f=>({uri:f,rank:(0,a.$kf)(f.path,"/")})),i=(0,$.$Cb)(t,(f,u)=>f.rank-u.rank||(0,a.$Af)(f.uri.path,u.uri.path)),r=[];e:for(const f of i){let u;for(const w of f){const S=(0,k.$pc)(w.uri.path);if(u!==S&&(u=S,r.push(w.uri)>=l.d))break e}}this.g.$onDidChange(d,r)});return new I.$wN(()=>{g?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(c,m,d){if(!this.f.has(c))return Object.create(null);const g=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(c);return await Promise.all(m.map(async t=>{try{const{uri:i,id:r}=t,f=await Promise.resolve(n.provideFileDecoration(s.URI.revive(i),d));if(!f)return;try{I.$WO.validate(f),f.badge&&typeof f.badge!="string"&&(0,E.$7G)(o,"codiconDecoration"),g[r]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(i){this.h.error(i)}})),g}};e.$Epc=P,e.$Epc=P=l=Xe([Ve(0,L.$1P),Ve(1,R.$ak)],P),e.$Fpc=(0,T.$Gi)("IExtHostDecorations")}),define(Ee[342],Se([1,0,14,2,10,6,15,21,13]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class a{static{this.a=0}constructor(E,l,P){this.d=l,this.e=P,this.b=new Map,this.c=E.getProxy(T.$uN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,l){if(Object.keys(L.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const P=a.a++;this.b.set(P,l),this.c.$registerTextContentProvider(P,E);let b;if(typeof l.onDidChange=="function"){let c;b=l.onDidChange(async m=>{if(m.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const d=this.$provideTextDocumentContent(P,m).then(async g=>{if(!g&&typeof g!="string")return;const n=this.d.getDocument(m);if(!n)return;const o=(0,$.$uf)(g);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(m,g)}).catch(s.$3).finally(()=>{c===d&&(c=void 0)});c=d})}return new I.$wN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,l){const P=this.b.get(E);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(l),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Hpc=a}),define(Ee[164],Se([1,0,66,15,13,198,138,10,19]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=k;const a=new Map;function k(b,c){c?a.set(b,c):a.delete(b)}function E(b){return a.get(b)}class l extends T.$mw{constructor(c,m,d,g,n,o,t){super(m,d,g,n),this.c=c,this.m=o,this.q=t,this.b=!1}dispose(){(0,s.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$xb)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===h.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,d){return c.y(m,d)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,s.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,s.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const d=this.g,g=m.start.line,n=m.end.line,o=[];o.push(this.f[g].substring(m.start.character));for(let t=g+1;t<n;t++)o.push(this.f[t]);return o.push(this.f[n].substring(0,m.end.character)),o.join(d)}t(c){let m;if(c instanceof R.$xN?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),d=this.f[m.index].length;return new R.$xN(m.index,Math.min(m.remainder,d))}w(c){if(!(c instanceof R.$yN))throw new Error("Invalid argument");const m=this.x(c.start),d=this.x(c.end);return m===c.start&&d===c.end?c:new R.$yN(m.line,m.character,d.line,d.character)}x(c){if(!(c instanceof R.$xN))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:d}=c,g=!1;if(m<0)m=0,d=0,g=!0;else if(m>=this.f.length)m=this.f.length-1,d=this.f[m].length,g=!0;else{const n=this.f[m].length;d<0?(d=0,g=!0):d>n&&(d=n,g=!0)}return g?new R.$xN(m,d):c}y(c,m){const d=this.x(c);if(!m)m=E(this.m);else if((0,I.$tf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const g=(0,L.$ot)(d.character+1,(0,L.$mt)(m),this.f[d.line],0);if(g)return new R.$yN(d.line,g.startColumn-1,d.line,g.endColumn-1)}}e.$4P=l;class P{constructor(c,m,d){this.a=c,this.b=m,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.$yN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.$yN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=P}),define(Ee[343],Se([1,0,6,10]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(s.$uN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(L);if(!a)throw new Error("Embedding vector provider not found");const k=await a.provideEmbeddingVector(R,$);if(!k)throw new Error("Embedding vector provider returned undefined");return k}registerEmbeddingVectorProvider(L,R,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiEmbeddingVectorProvider(R,a),new h.$wN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Kpc=I}),define(Ee[76],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,h=We(h);let b=P=class{constructor(m,d){this.b=new Map,this.c=new k.$Ph,this.a=m.getProxy(s.$uN.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(n){try{let o;const t=g.b.get(n.scheme);return t?(await g.a.$ensureActivation(n.scheme),o=await t.impl.stat(n)):o=await g.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(n){try{const o=g.b.get(n.scheme);return o?(await g.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await g.a.$readdir(n)}catch(o){return P.e(o)}},async createDirectory(n){try{const o=g.b.get(n.scheme);return o&&!o.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(o.impl,o.extUri,n)):await g.a.$mkdir(n)}catch(o){return P.e(o)}},async readFile(n){try{const o=g.b.get(n.scheme);return o?(await g.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await g.a.$readFile(n)).buffer}catch(o){return P.e(o)}},async writeFile(n,o){try{const t=g.b.get(n.scheme);return t&&!t.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(t.impl,t.extUri,t.extUri.dirname(n)),await g.c.queueFor(n,()=>Promise.resolve(t.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await g.a.$writeFile(n,T.$Pe.wrap(o))}catch(t){return P.e(t)}},async delete(n,o){try{const t=g.b.get(n.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await g.a.$ensureActivation(n.scheme),await t.impl.delete(n,{recursive:!1,...o})):await g.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return P.e(t)}},async rename(n,o,t){try{return await g.a.$rename(n,o,{overwrite:!1,...t})}catch(i){return P.e(i)}},async copy(n,o,t){try{return await g.a.$copy(n,o,{overwrite:!1,...t})}catch(i){return P.e(i)}},isWritableFileSystem(n){const o=d.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,d,g){const n=[];for(;!d.isEqual(g,d.dirname(g));)try{if(!((await m.stat(g)).type&h.FileType.Directory))throw I.$NO.FileExists(`Unable to create folder '${g.scheme===l.Schemas.file?g.fsPath:g.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$ql(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(d.basename(g)),g=d.dirname(g)}for(let o=n.length-1;o>=0;o--){g=d.joinPath(g,n[o]);try{await m.createDirectory(g)}catch(t){if(h.$ql(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof I.$NO)throw m;if(m instanceof h.$ml)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw I.$NO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw I.$NO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw I.$NO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw I.$NO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw I.$NO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw I.$NO.Unavailable(m.message);default:throw new I.$NO(m.message,m.name)}if(!(m instanceof Error))throw new I.$NO(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw I.$NO.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw I.$NO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw I.$NO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw I.$NO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw I.$NO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw I.$NO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw I.$NO.Unavailable(m.message);default:throw new I.$NO(m.message,m.name)}}addFileSystemProvider(m,d,g){return this.b.set(m,{impl:d,extUri:g?.isCaseSensitive?E.$0g:E.$_g,isReadonly:!!g?.isReadonly}),(0,a.$Vc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??E.$0g}};e.$Poc=b,e.$Poc=b=P=Xe([Ve(0,R.$1P),Ve(1,$.$toc)],b),e.$Qoc=(0,L.$Gi)("IExtHostConsumerFileSystem")}),define(Ee[98],Se([1,0,5,30,12,76,2]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=e.$Roc=void 0,e.$Roc=(0,s.$Gi)("IExtensionStoragePaths");let R=class{constructor(a,k,E){this.d=k,this.f=E,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(a){return L.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,k=await this.g(a);try{return await this.f.value.stat(k),this.d.trace("[ExtHostStorage] storage dir already exists",k),k}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",k),await this.f.value.createDirectory(k),await this.f.value.writeFile(L.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),k}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(a){if(this.c)return L.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return L.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Soc=R,e.$Soc=R=Xe([Ve(0,h.$eQ),Ve(1,I.$ak),Ve(2,T.$Qoc)],R)}),define(Ee[344],Se([1,0,10,20,4]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=void 0;let T=class{constructor(R){this.a=new s.$XO(s.ColorThemeKind.Dark),this.b=new I.$ne}get activeColorTheme(){return this.a}$onColorThemeChange(R){let $;switch(R){case"light":$=s.ColorThemeKind.Light;break;case"hcDark":$=s.ColorThemeKind.HighContrast;break;case"hcLight":$=s.ColorThemeKind.HighContrastLight;break;default:$=s.ColorThemeKind.Dark}this.a=new s.$XO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pqc=T,e.$pqc=T=Xe([Ve(0,h.$1P)],T)}),define(Ee[77],Se([1,0,21,4,3,244,5,12,93,6,30,20,10]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Fb=e.$3Fb=e.TunnelDtoConverter=void 0,T=We(T),l=We(l);class P extends $.$Lw{}var b;(function(m){function d(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=d;function g(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=g})(b||(e.TunnelDtoConverter=b={})),e.$3Fb=(0,L.$Gi)("IExtHostTunnelService");let c=class extends I.$Xc{constructor(d,g,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$ne,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(a.$uN.MainThreadTunnelService)}async openTunnel(d,g){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const n=await this.a.$openTunnel(g,d.displayName);if(n){const o=new P(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,g){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:d,provider:g}),this.a.$registerPortsAttributesProvider(d,n),new l.$wN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(d,g,n,o,t){const i=[];for(const f of d){const u=this.r.get(f);if(!u)return[];i.push(...await Promise.all(g.map(async w=>{let S;try{S=await u.provider.providePortAttributes({port:w,pid:n,commandLine:o},t)}catch{S=await u.provider.providePortAttributes(w,n,o,t)}return{providedAttributes:S,port:w}})))}const r=i.filter(f=>!!f.providedAttributes);return r.length>0?r.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,g){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await d.provideTunnel(o,t,s.CancellationToken.None)??void 0;const n=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,privacyOptions:g.tunnelFeatures?.privacyOptions,protocol:g.tunnelFeatures.protocol===void 0?!0:g.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,I.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,g){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const n=d.tunnelFactory??(g?this.w(g):void 0);if(n){this.b=n;let o=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,I.$Vc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,g){if(this.g.has(d.host)){const n=this.g.get(d.host);n.has(d.port)&&(g&&n.get(d.port).disposeListener.dispose(),await n.get(d.port).tunnel.dispose(),n.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,g){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(d,g);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:o,disposeListener:t}),b.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(d){const g=await Promise.all(d.map(o=>this.f(o.host,o.port,o.detail??""))),n=d.filter((o,t)=>g[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$4Fb=c,e.$4Fb=c=Xe([Ve(0,E.$1P),Ve(1,k.$eQ),Ve(2,R.$ak)],c)}),define(Ee[16],Se([1,0,19,22,187,80,86,29,177,57,108,25,182,23,50,18,2,114,31,106,88,55,146,90,155,153,307,322,120,127,74,75,319,10]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u,w,S,D,y,C,A,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ee,e.$YP=ne,e.$ZP=De,L=We(L),g=We(g),n=We(n),o=We(o),S=We(S),y=We(y),v=We(v);var F;(function(Ae){function Me(ie){const{selectionStartLineNumber:Re,selectionStartColumn:Qe,positionLineNumber:it,positionColumn:Je}=ie,ft=new v.$xN(Re-1,Qe-1),Ct=new v.$xN(it-1,Je-1);return new v.$zN(ft,Ct)}Ae.to=Me;function ve(ie){const{anchor:Re,active:Qe}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Ae.from=ve})(F||(e.Selection=F={}));var N;(function(Ae){function Me(ie){if(!ie)return;const{start:Re,end:Qe}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Ae.from=Me;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:Qe,endLineNumber:it,endColumn:Je}=ie;return new v.$yN(Re-1,Qe-1,it-1,Je-1)}Ae.to=ve})(N||(e.Range=N={}));var O;(function(Ae){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$IN(m.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(O||(e.Location=O={}));var j;(function(Ae){function Me(ve){switch(ve){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=Me})(j||(e.TokenType=j={}));var z;(function(Ae){function Me(ie){return new v.$xN(ie.lineNumber-1,ie.column-1)}Ae.to=Me;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(z||(e.Position=z={}));var M;(function(Ae){function Me(Re,Qe,it){return(0,s.$Kb)((0,s.$5b)(Re).map(Je=>ve(Je,Qe,it)))}Ae.from=Me;function ve(Re,Qe,it){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:it?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,Qe),pattern:et.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:it?.isBuiltin}}function ie(Re,Qe){return Qe&&typeof Re=="string"?Qe.transformOutgoingScheme(Re):Re}})(M||(e.DocumentSelector=M={}));var V;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case i.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(V||(e.DiagnosticTag=V={}));var K;(function(Ae){function Me(ie){let Re;return ie.code&&((0,c.$gg)(ie.code)||(0,c.$kg)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,s.$Kb)(ie.tags.map(V.from)):void 0}}Ae.from=Me;function ve(ie){const Re=new v.$KN(N.to(ie),ie.message,B.to(ie.severity));return Re.source=ie.source,Re.code=(0,c.$gg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Re.tags=ie.tags&&(0,s.$Kb)(ie.tags.map(V.to)),Re}Ae.to=ve})(K||(e.Diagnostic=K={}));var re;(function(Ae){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=Me;function ve(ie){return new v.$JN(new v.$IN(ie.resource,N.to(ie)),ie.message)}Ae.to=ve})(re||(e.DiagnosticRelatedInformation=re={}));var B;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Ae.from=Me;function ve(ie){switch(ie){case i.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(B||(e.DiagnosticSeverity=B={}));var G;(function(Ae){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$pE:p.$oE}Ae.from=Me;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function X(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!X(Ae[0])}var de;(function(Ae){function Me(Je){return Je.map(Ae.from)}Ae.fromMany=Me;function ve(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let ft;if(ve(Je)){const{language:Mt,value:li}=Je;ft={value:"```"+Mt+`
`+li+"\n```\n"}}else v.$YN.isMarkdownString(Je)?ft={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ft={value:Je}:ft={value:""};const Ct=Object.create(null);ft.uris=Ct;const Xt=Mt=>{try{let li=m.URI.parse(Mt,!0);li=li.with({query:Re(li.query,Ct)}),Ct[Mt]=li}catch{}return""},ci=new $.marked.Renderer;return ci.link=Xt,ci.image=Mt=>typeof Mt=="string"?Xt(L.$_k(Mt).href):"",(0,$.marked)(ft.value,{renderer:ci}),ft}Ae.from=ie;function Re(Je,ft){if(!Je)return Je;let Ct;try{Ct=(0,a.$ci)(Je)}catch{}if(!Ct)return Je;let Xt=!1;return Ct=(0,E.$go)(Ct,ci=>{if(m.URI.isUri(ci)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Mt]=ci,Xt=!0,Mt}else return}),Xt?JSON.stringify(Ct):Je}function Qe(Je){const ft=new v.$YN(Je.value,Je.supportThemeIcons);return ft.isTrusted=Je.isTrusted,ft.supportHtml=Je.supportHtml,ft.baseUri=Je.baseUri?m.URI.from(Je.baseUri):void 0,ft}Ae.to=Qe;function it(Je){if(Je)return typeof Je=="string"?Je:Ae.from(Je)}Ae.fromStrict=it})(de||(e.MarkdownString=de={}));function ne(Ae){return ee(Ae)?Ae.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?de.fromMany(Me.hoverMessage):Me.hoverMessage?de.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ae.map(Me=>({range:N.from(Me)}))}function De(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?m.URI.file(Ae):Ae}var $e;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?De(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=Me})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var J;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(J||(e.ThemableDecorationRenderOptions=J={}));var U;(function(Ae){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=Me})(U||(e.DecorationRangeBehavior=U={}));var se;(function(Ae){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?U.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?J.from(ve.light):void 0,dark:ve.dark?J.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Ae){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Ae.from=Me;function ve(ie){const Re=new v.$DN(N.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Re}Ae.to=ve})(ae||(e.TextEdit=ae={}));var te;(function(Ae){function Me(ie,Re){const Qe={edits:[]};if(ie instanceof v.$GN){const it=new R.$Ec;for(const Je of ie._allEntries())Je._type===v.FileEditType.File&&m.URI.isUri(Je.to)&&Je.from===void 0&&it.add(Je.to);for(const Je of ie._allEntries())if(Je._type===v.FileEditType.File){let ft;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ft={type:"base64",value:(0,h.$0e)(h.$Pe.wrap(Je.options.contents))}:ft={type:"dataTransferItem",id:Je.options.contents._itemId}),Qe.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ft},metadata:Je.metadata})}else Je._type===v.FileEditType.Text?Qe.edits.push({resource:Je.uri,textEdit:ae.from(Je.edit),versionId:it.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Snippet?Qe.edits.push({resource:Je.uri,textEdit:{range:N.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:it.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Cell?Qe.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri)}):Je._type===v.FileEditType.CellReplace&&Qe.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:y.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(_e.from)}})}return Qe}Ae.from=Me;function ve(ie){const Re=new v.$GN,Qe=new R.$Dc;for(const it of ie.edits)if(it.textEdit){const Je=it,ft=m.URI.revive(Je.resource),Ct=N.to(Je.textEdit.range),Xt=Je.textEdit.text,ci=Je.textEdit.insertAsSnippet;let Mt;ci?Mt=v.$FN.replace(Ct,new v.$HN(Xt)):Mt=v.$DN.replace(Ct,Xt);const li=Qe.get(ft);li?li.push(Mt):Qe.set(ft,[Mt])}else Re.renameFile(m.URI.revive(it.oldResource),m.URI.revive(it.newResource),it.options);for(const[it,Je]of Qe)Re.set(it,Je);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var le;(function(Ae){const Me=Object.create(null);Me[v.SymbolKind.File]=o.SymbolKind.File,Me[v.SymbolKind.Module]=o.SymbolKind.Module,Me[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,Me[v.SymbolKind.Package]=o.SymbolKind.Package,Me[v.SymbolKind.Class]=o.SymbolKind.Class,Me[v.SymbolKind.Method]=o.SymbolKind.Method,Me[v.SymbolKind.Property]=o.SymbolKind.Property,Me[v.SymbolKind.Field]=o.SymbolKind.Field,Me[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=o.SymbolKind.Enum,Me[v.SymbolKind.Interface]=o.SymbolKind.Interface,Me[v.SymbolKind.Function]=o.SymbolKind.Function,Me[v.SymbolKind.Variable]=o.SymbolKind.Variable,Me[v.SymbolKind.Constant]=o.SymbolKind.Constant,Me[v.SymbolKind.String]=o.SymbolKind.String,Me[v.SymbolKind.Number]=o.SymbolKind.Number,Me[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,Me[v.SymbolKind.Array]=o.SymbolKind.Array,Me[v.SymbolKind.Object]=o.SymbolKind.Object,Me[v.SymbolKind.Key]=o.SymbolKind.Key,Me[v.SymbolKind.Null]=o.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=o.SymbolKind.Struct,Me[v.SymbolKind.Event]=o.SymbolKind.Event,Me[v.SymbolKind.Operator]=o.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof Me[Re]=="number"?Me[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const Qe in Me)if(Me[Qe]===Re)return Number(Qe);return v.SymbolKind.Property}Ae.to=ie})(le||(e.SymbolKind=le={}));var ue;(function(Ae){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(ue||(e.SymbolTag=ue={}));var Z;(function(Ae){function Me(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(ue.from),containerName:ie.containerName,location:Ue.from(ie.location)}}Ae.from=Me;function ve(ie){const Re=new v.$PN(ie.name,le.to(ie.kind),ie.containerName,Ue.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(ue.to),Re}Ae.to=ve})(Z||(e.WorkspaceSymbol=Z={}));var oe;(function(Ae){function Me(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(ue.from)??[]};return ie.children&&(Re.children=ie.children.map(Me)),Re}Ae.from=Me;function ve(ie){const Re=new v.$QN(ie.name,ie.detail,le.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,s.$Ob)(ie.tags)&&(Re.tags=ie.tags.map(ue.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(oe||(e.DocumentSymbol=oe={}));var pe;(function(Ae){function Me(ie){const Re=new v.$UN(le.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Qe){if(Re=Re??ie._sessionId,Qe=Qe??ie._itemId,Re===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Qe,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Ae){function Me(ve){return new v.$VN(pe.to(ve.from),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Ae){function Me(ve){return new v.$WN(pe.to(ve.to),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Ue;(function(Ae){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Ae.from=Me;function ve(ie){return new v.$IN(m.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(Ue||(e.location=Ue={}));var ke;(function(Ae){function Me(ie){const Re=ie,Qe=ie;return{originSelectionRange:Re.originSelectionRange?N.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Qe.uri,range:N.from(Re.targetRange?Re.targetRange:Qe.range),targetSelectionRange:Re.targetSelectionRange?N.from(Re.targetSelectionRange):void 0}}Ae.from=Me;function ve(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Ae.to=ve})(ke||(e.DefinitionLink=ke={}));var Pe;(function(Ae){function Me(ie){return{range:N.from(ie.range),contents:de.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=Me;function ve(ie){const Re=ie.contents.map(de.to),Qe=N.to(ie.range),it=ie.canIncreaseVerbosity,Je=ie.canDecreaseVerbosity;return new v.$MN(Re,Qe,it,Je)}Ae.to=ve})(Pe||(e.Hover=Pe={}));var Te;(function(Ae){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Ae.from=Me;function ve(ie){return new v.$HO(N.to(ie.range),ie.expression)}Ae.to=ve})(Te||(e.EvaluatableExpression=Te={}));var W;(function(Ae){function Me(ie){if(ie instanceof v.$IO)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$JO)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$KO)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Me;function ve(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Ae.to=ve})(W||(e.InlineValue=W={}));var q;(function(Ae){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Ae.from=Me;function ve(ie){return new v.$LO(ie.frameId,N.to(ie.stoppedLocation))}Ae.to=ve})(q||(e.InlineValueContext=q={}));var Y;(function(Ae){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Ae.from=Me;function ve(ie){return new v.$NN(N.to(ie.range),ie.kind)}Ae.to=ve})(Y||(e.DocumentHighlight=Y={}));var _;(function(Ae){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(Y.from)}}Ae.from=Me;function ve(ie){return new v.$ON(m.URI.revive(ie.uri),ie.highlights.map(Y.to))}Ae.to=ve})(_||(e.MultiDocumentHighlight=_={}));var fe;(function(Ae){function Me(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=Me})(fe||(e.CompletionTriggerKind=fe={}));var be;(function(Ae){function Me(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=Me})(be||(e.CompletionContext=be={}));var Ne;(function(Ae){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Ne||(e.CompletionItemTag=Ne={}));var Ge;(function(Ae){const Me=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(Qe){return Me.get(Qe)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(Qe){return ie.get(Qe)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Ke;(function(Ae){function Me(ve,ie){const Re=new v.$5N(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Ne.to),Re.detail=ve.detail,Re.documentation=L.$6k(ve.documentation)?de.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,g.$Mt.isIRange(ve.range)?Re.range=N.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:N.to(ve.range.insert),replacing:N.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$HN(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$yN?new v.$DN(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(Qe=>ae.to(Qe))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=Me})(Ke||(e.CompletionItem=Ke={}));var tt;(function(Ae){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:de.fromStrict(ie.documentation)}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:L.$6k(ie.documentation)?de.to(ie.documentation):ie.documentation}}Ae.to=ve})(tt||(e.ParameterInformation=tt={}));var rt;(function(Ae){function Me(ie){return{label:ie.label,documentation:de.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:L.$6k(ie.documentation)?de.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=Me;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function Me(ve,ie){const Re=new v.$4N(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,ve)),ie.kind&&mt.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(ae.to),Re.tooltip=L.$6k(ie.tooltip)?de.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=Me})(nt||(e.InlayHint=nt={}));var at;(function(Ae){function Me(ve,ie){const Re=new v.$3N(ie.label);return Re.tooltip=L.$6k(ie.tooltip)?de.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=Ue.to(ie.location)),Re}Ae.to=Me})(at||(e.InlayHintLabelPart=at={}));var mt;(function(Ae){function Me(ie){return ie}Ae.from=Me;function ve(ie){return ie}Ae.to=ve})(mt||(e.InlayHintKind=mt={}));var ht;(function(Ae){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=Me;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Qe=new v.$0N(N.to(ie.range),Re);return Qe.tooltip=ie.tooltip,Qe}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var ct;(function(Ae){function Me(ie){const Re=new v.$aO(ie.label);return ie.textEdit&&(Re.textEdit=ae.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(Qe=>ae.to(Qe))),Re}Ae.to=Me;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?ae.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>ae.from(Re)):void 0}}Ae.from=ve})(ct||(e.ColorPresentation=ct={}));var Ie;(function(Ae){function Me(ie){return new v.$$N(ie[0],ie[1],ie[2],ie[3])}Ae.to=Me;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Ie||(e.Color=Ie={}));var ze;(function(Ae){function Me(ie){return{range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$TN(N.to(ie.range))}Ae.to=ve})(ze||(e.SelectionRange=ze={}));var He;(function(Ae){function Me(ve){switch(ve){case u.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=Me})(He||(e.TextDocumentSaveReason=He={}));var Oe;(function(Ae){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}Ae.from=Me;function ve(ie){switch(ie){case d.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var je;(function(Ae){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Ae.from=Me;function ve(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(je||(e.EndOfLine=je={}));var he;(function(Ae){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return r.ProgressLocation.Scm;case v.ProgressLocation.Window:return r.ProgressLocation.Window;case v.ProgressLocation.Notification:return r.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Me})(he||(e.ProgressLocation=he={}));var x;(function(Ae){function Me(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=Me;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(x||(e.FoldingRange=x={}));var Ce;(function(Ae){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Mu.Comment;case v.FoldingRangeKind.Imports:return o.$Mu.Imports;case v.FoldingRangeKind.Region:return o.$Mu.Region}}Ae.from=Me;function ve(ie){if(ie)switch(ie.value){case o.$Mu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Mu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Mu.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Ye;(function(Ae){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?N.from(ve.selection):void 0,override:typeof ve.override=="boolean"?u.$SF.id:void 0}}Ae.from=Me})(Ye||(e.TextEditorOpenOptions=Ye={}));var et;(function(Ae){function Me(Qe){return Qe instanceof v.$vO?Qe.toJSON():typeof Qe=="string"?Qe:ve(Qe)||ie(Qe)?new v.$vO(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Ae.from=Me;function ve(Qe){const it=Qe;return it?m.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function ie(Qe){const it=Qe;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Re(Qe){return typeof Qe=="string"?Qe:new v.$vO(m.URI.revive(Qe.baseUri),Qe.pattern)}Ae.to=Re})(et||(e.GlobPattern=et={}));var ut;(function(Ae){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:et.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=Me})(ut||(e.LanguageSelector=ut={}));var gt;(function(Ae){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&m.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(it=>it instanceof v.$yN)))}Ae.is=Me;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(Qe=>({uri:m.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(it=>N.from(it))})))}}Ae.from=ve})(gt||(e.MappedEditsContext=gt={}));var Dt;(function(Ae){function Me(ie){return{start:ie.start,end:ie.end}}Ae.from=Me;function ve(ie){return new v.$YO(ie.start,ie.end)}Ae.to=ve})(Dt||(e.NotebookRange=Dt={}));var Ot;(function(Ae){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=Me;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var qt;(function(Ae){function Me(ve){if(ve===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===y.NotebookCellExecutionState.Pending)return;if(ve===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=Me})(qt||(e.NotebookCellExecutionState=qt={}));var ui;(function(Ae){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Ae.from=Me;function ve(ie){switch(ie){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(ui||(e.NotebookCellKind=ui={}));var ti;(function(Ae){function Me(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const Qe of ie.cells)v.$ZO.validate(Qe),Re.cells.push(_e.from(Qe));return Re}Ae.from=Me;function ve(ie){const Re=new v.$1O(ie.cells.map(_e.to));return(0,c.$tg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(ti||(e.NotebookData=ti={}));var _e;(function(Ae){function Me(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ot.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Qt.from):[]}}Ae.from=Me;function ve(ie){return new v.$ZO(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Qt.to):void 0,ie.metadata,ie.internalMetadata?Ot.to(ie.internalMetadata):void 0)}Ae.to=ve})(_e||(e.NotebookCellData=_e={}));var Kt;(function(Ae){function Me(ie){return{mime:ie.mime,valueBytes:h.$Pe.wrap(ie.data)}}Ae.from=Me;function ve(ie){return new v.$2O(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Kt||(e.NotebookCellOutputItem=Kt={}));var Qt;(function(Ae){function Me(ie){return{outputId:ie.id,items:ie.items.map(Kt.from),metadata:ie.metadata}}Ae.from=Me;function ve(ie){const Re=ie.items.map(Kt.to);return new v.$3O(Re,ie.outputId,ie.metadata)}Ae.to=ve})(Qt||(e.NotebookCellOutput=Qt={}));var pt;(function(Ae){function Me(Re){return ie(Re)?{include:et.from(Re.include)??void 0,exclude:et.from(Re.exclude)??void 0}:et.from(Re)??void 0}Ae.from=Me;function ve(Re){return ie(Re)?{include:et.to(Re.include),exclude:et.to(Re.exclude)}:et.to(Re)}Ae.to=ve;function ie(Re){const Qe=Re;return Qe?!(0,c.$pg)(Qe.include)&&!(0,c.$pg)(Qe.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var It;(function(Ae){function Me(ve,ie,Re){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:ie.toInternal(Qe,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=Me})(It||(e.NotebookStatusBarItem=It={}));var ii;(function(Ae){function Me(ve,ie,Re){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(Qe,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=Me})(ii||(e.NotebookKernelSourceAction=ii={}));var Zt;(function(Ae){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=Me})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Vt;(function(Ae){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=Me;function ve(ie){return new v.$5O(m.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(Vt||(e.NotebookRendererScript=Vt={}));var vt;(function(Ae){function Me(ie){return{message:de.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri}}}Ae.from=Me;function ve(ie){const Re=new v.$$O(typeof ie.message=="string"?ie.message:de.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?Ue.to(ie.location):void 0,Re}Ae.to=ve})(vt||(e.TestMessage=vt={}));var Nt;(function(Ae){Ae.namespace=A.$YI,Ae.denamespace=A.$ZI})(Nt||(e.TestTag=Nt={}));var hi;(function(Ae){function Me(ie){const Re=(0,f.$WP)(ie).controllerId;return{extId:C.$TI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Qe=>Nt.namespace(Re,Qe.id)),range:g.$Mt.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&de.fromStrict(ie.error)||null}}Ae.from=Me;function ve(ie){return{parent:void 0,error:void 0,id:C.$TI.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:Qe}=Nt.denamespace(Re);return new v.$_O(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(hi||(e.TestItem=hi={})),function(Ae){function Me(ie){return{id:ie.id}}Ae.from=Me;function ve(ie){return new v.$_O(ie.id)}Ae.to=ve}(Nt||(e.TestTag=Nt={}));var Gt;(function(Ae){const Me=(ie,Re)=>{const Qe=ie.value;if(!Qe)return;const it={...hi.toPlain(Qe.item),parent:Re,taskStates:Qe.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(vt.to)})),children:[]};if(ie.children)for(const Je of ie.children.values()){const ft=Me(Je,it);ft&&it.children.push(ft)}return it};function ve(ie){const Re=new l.$SI;for(const Je of ie.items)Re.insert(C.$TI.fromString(Je.item.extId).path,Je);const Qe=[Re.nodes],it=[];for(;Qe.length;)for(const Je of Qe.pop())Je.value?it.push(Je):Je.children&&Qe.push(Je.children.values());return{completedAt:ie.completedAt,results:it.map(Je=>Me(Je)).filter(c.$og)}}Ae.to=ve})(Gt||(e.TestResults=Gt={}));var xe;(function(Ae){function Me(Qe){return{covered:Qe.covered,total:Qe.total}}function ve(Qe){return"line"in Qe?z.from(Qe):N.from(Qe)}function ie(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ve(Qe.location),type:A.DetailType.Statement,branches:Qe.branches.length?Qe.branches.map(it=>({count:it.executed,location:it.location&&ve(it.location),label:it.label})):void 0}:{type:A.DetailType.Declaration,name:Qe.name,count:Qe.executed,location:ve(Qe.location)}}Ae.fromDetails=ie;function Re(Qe,it,Je){return v.$bP(Je.statementCoverage),v.$bP(Je.branchCoverage),v.$bP(Je.declarationCoverage),{id:it,uri:Je.uri,statement:Me(Je.statementCoverage),branch:Je.branchCoverage&&Me(Je.branchCoverage),declaration:Je.declarationCoverage&&Me(Je.declarationCoverage),testIds:Je instanceof v.$cP&&Je.fromTests.length?Je.fromTests.map(ft=>C.$TI.fromExtHostTestItem(ft,Qe).toString()):void 0}}Ae.fromFile=Re})(xe||(e.TestCoverage=xe={}));var xt;(function(Ae){function Me(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=Me})(xt||(e.CodeActionTriggerKind=xt={}));var ni;(function(Ae){function Me(ie){const Re=new v.$gP(le.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Qe){if(Re=Re??ie._sessionId,Qe=Qe??ie._itemId,Re===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Qe,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ae.from=ve})(ni||(e.TypeHierarchyItem=ni={}));var di;(function(Ae){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=Me})(di||(e.ViewBadge=di={}));var kt;(function(Ae){function Me(Qe,it,Je){const ft=it.fileData;return ft?new v.$nO(new v.$oO(ft.name,m.URI.revive(ft.uri),ft.id,(0,T.$gb)(()=>Je(ft.id)))):Qe===k.$9s.uriList&&it.uriListData?new v.$mO(Re(it.uriListData)):new v.$mO(it.asString)}Ae.to=Me;async function ve(Qe,it){const Je=await it.asString();if(Qe===k.$9s.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const ft=it.asFile();return{asString:Je,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Ae.from=ve;function ie(Qe){return I.$qu.split(Qe).map(it=>{if(it.startsWith("#"))return it;try{return m.URI.parse(it)}catch{}return it})}function Re(Qe){return I.$qu.create(Qe.map(it=>typeof it=="string"?it:m.URI.revive(it)))}})(kt||(e.DataTransferItem=kt={}));var Ft;(function(Ae){function Me(ie,Re){const Qe=ie.items.map(([it,Je])=>[it,kt.to(it,Je,Re)]);return new v.$pO(Qe)}Ae.toDataTransfer=Me;async function ve(ie){const Re={items:[]},Qe=[];for(const[it,Je]of ie)Qe.push((async()=>{Re.items.push([it,await kt.from(it,Je)])})());return await Promise.all(Qe),Re}Ae.from=ve})(Ft||(e.DataTransfer=Ft={}));var Rt;(function(Ae){function Me(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=Me;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Rt||(e.ChatFollowup=Rt={}));var zt;(function(Ae){function Me(ie){switch(ie){case S.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=Me;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}Ae.from=ve})(zt||(e.LanguageModelChatMessageRole=zt={}));var ri;(function(Ae){function Me(ie){let Re="",Qe;ie.content.type==="text"?Re=ie.content.value:Qe=new v.$HP(ie.content.name,ie.content.value,ie.content.isError);const it=zt.to(ie.role),Je=new v.$IP(it,Re,ie.name);return Qe!==void 0&&(Je.content2=Qe),Je}Ae.to=Me;function ve(ie){const Re=zt.from(ie.role),Qe=ie.name;let it;return ie.content2 instanceof v.$HP?it={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:it={type:"text",value:ie.content},{role:Re,name:Qe,content:it}}Ae.from=ve})(ri||(e.LanguageModelChatMessage=ri={}));var _t;(function(Ae){function Me(ie){return{kind:"markdownContent",content:de.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$tP(de.to(ie.content))}Ae.to=ve})(_t||(e.ChatResponseMarkdownPart=_t={}));var si;(function(Ae){function Me(ie){return{kind:"markdownVuln",content:de.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=Me;function ve(ie){return new v.$uP(de.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Bt;(function(Ae){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=Me;function ve(ie){return new v.$vP(ie.agentId,ie.command)}Ae.to=ve})(Bt||(e.ChatResponseDetectedParticipantPart=Bt={}));var Jt;(function(Ae){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=Me})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var oi;(function(Ae){function Me(ie){const{value:Re,baseUri:Qe}=ie;function it(Je,ft){return Je.map(Ct=>{const Xt=m.URI.joinPath(ft,Ct.name);return{label:Ct.name,uri:Xt,children:Ct.children&&it(Ct.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,P.$eh)(Qe),uri:Qe,children:it(Re,Qe)}}}Ae.from=Me;function ve(ie){const Re=(0,a.$di)(ie.treeData);function Qe(ft){return ft.map(Ct=>({name:Ct.label,children:Ct.children&&Qe(Ct.children)}))}const it=Re.uri,Je=Re.children?Qe(Re.children):[];return new v.$xP(Je,it)}Ae.to=ve})(oi||(e.ChatResponseFilesPart=oi={}));var At;(function(Ae){function Me(ie){const Re=Qe=>m.URI.isUri(Qe);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:O.from(ie.value)}}Ae.from=Me;function ve(ie){const Re=(0,a.$di)(ie);return new v.$yP(m.URI.isUri(Re.inlineReference)?Re.inlineReference:O.to(Re.inlineReference),ie.name)}Ae.to=ve})(At||(e.ChatResponseAnchorPart=At={}));var St;(function(Ae){function Me(ie){return{kind:"progressMessage",content:de.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$zP(ie.content.value)}Ae.to=ve})(St||(e.ChatResponseProgressPart=St={}));var wt;(function(Ae){function Me(ie){return{kind:"warning",content:de.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$BP(ie.content.value)}Ae.to=ve})(wt||(e.ChatResponseWarningPart=wt={}));var ei;(function(Ae){function Me(ve){return{kind:"progressTask",content:de.from(ve.value)}}Ae.from=Me})(ei||(e.ChatTask=ei={}));var Pt;(function(Ae){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?de.from(ve):void 0}}Ae.from=Me})(Pt||(e.ChatTaskResult=Pt={}));var fi;(function(Ae){function Me(ie,Re,Qe){return{kind:"command",command:Re.toInternal(ie.value,Qe)??{command:ie.value.command,title:ie.value.title}}}Ae.from=Me;function ve(ie,Re){return new v.$CP(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(fi||(e.ChatResponseCommandButtonPart=fi={}));var Ht;(function(Ae){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>ae.from(Re))}}Ae.from=Me;function ve(ie){return new v.$EP(m.URI.revive(ie.uri),ie.edits.map(Re=>ae.to(Re)))}Ae.to=ve})(Ht||(e.ChatResponseTextEditPart=Ht={}));var wi;(function(Ae){function Me(ie){const Re=b.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:O.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:O.from(ie.value),iconPath:Re}}Ae.from=Me;function ve(ie){const Re=(0,a.$di)(ie),Qe=it=>m.URI.isUri(it)?it:O.to(it);return new v.$DP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Qe(Re.reference.value)}:Qe(Re.reference))}Ae.to=ve})(wi||(e.ChatResponseReferencePart=wi={}));var vi;(function(Ae){function Me(Re,Qe,it){return Re instanceof v.$tP?_t.from(Re):Re instanceof v.$yP?At.from(Re):Re instanceof v.$DP?wi.from(Re):Re instanceof v.$zP?St.from(Re):Re instanceof v.$xP?oi.from(Re):Re instanceof v.$CP?fi.from(Re,Qe,it):Re instanceof v.$EP?Ht.from(Re):Re instanceof v.$uP?si.from(Re):Re instanceof v.$vP?Bt.from(Re):Re instanceof v.$BP?wt.from(Re):{kind:"markdownContent",content:de.from("")}}Ae.from=Me;function ve(Re,Qe){switch(Re.kind){case"reference":return wi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,Qe)}}Ae.to=ve;function ie(Re,Qe){switch(Re.kind){case"markdownContent":return _t.to(Re);case"inlineReference":return At.to(Re);case"progressMessage":return;case"treeData":return oi.to(Re);case"command":return fi.to(Re,Qe)}}Ae.toContent=ie})(vi||(e.ChatResponsePart=vi={}));var gi;(function(Ae){function Me(ve){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:Ut.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData}}Ae.to=Me})(gi||(e.ChatAgentRequest=gi={}));var Ut;(function(Ae){function Me(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=Me;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ae.from=ve})(Ut||(e.ChatLocation=Ut={}));var ai;(function(Ae){function Me(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,m.$yc)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$yc)(ie.uri)?O.to((0,a.$di)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=Me})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(Ae){function Me(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=Me})(Ii||(e.ChatAgentCompletionItem=Ii={}));var Tt;(function(Ae){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=Me})(Tt||(e.ChatAgentResult=Tt={}));var Si;(function(Ae){function Me(ve,ie,Re){if(ie.action.kind==="vote")return;const Qe=Tt.to(ve);if(ie.action.kind==="command"){const it=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(it)??{command:it.id,title:it.title}}},result:Qe}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(ie.action.followup)},result:Qe}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Qe}:{action:ie.action,result:Qe}}Ae.to=Me})(Si||(e.ChatAgentUserActionEvent=Si={}));var Ci;(function(Ae){function Me(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=Me})(Ci||(e.TerminalQuickFix=Ci={}));var Di;(function(Ae){function Me(ve){return{kind:$i.to(ve.kind)}}Ae.to=Me})(Di||(e.PartialAcceptInfo=Di={}));var $i;(function(Ae){function Me(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=Me})($i||(e.PartialAcceptTriggerKind=$i={}));var Ai;(function(Ae){function Me(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=Me})(Ai||(e.DebugTreeItem=Ai={}));var Wt;(function(Ae){function Me(ve){return{name:ve.name,description:ve.description,parametersSchema:ve.parametersSchema}}Ae.to=Me})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(Ee[345],Se([1,0,6,20,16,52]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0;let L=class{constructor($,a){this.a=$.getProxy(s.$uN.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>a.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,a,k){const E=new T.$Uw(I.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,k?.isRefactoring??!1)}};e.$Boc=L,e.$Boc=L=Xe([Ve(0,h.$1P)],L)}),define(Ee[346],Se([1,0,19,9,51,4,40,3,43,18,2,24,6,16,10,308,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0,P=We(P),b=We(b);class d{constructor(t,i,r,f,u){this.j=t,this.k=i,this.l=r,this.m=f,this.n=u,this.b=$.$he.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(f){if(t.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const t=this;this.b.reset();const r=(f,u)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),u){const w=this.l.$handleProgressChunk(this.k.requestId,f),S={report:D=>{w?.then(y=>{y&&(b.$YN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseReferencePart.from(D),y))})}};Promise.all([w,u?.(S)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,P.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){i(this.markdown);const u=new b.$tP(f),w=P.ChatResponseMarkdownPart.from(u);return r(w),this},markdownWithVulnerabilities(f,u){i(this.markdown),u&&(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new b.$uP(f,u),S=P.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return r(S),this},filetree(f,u){i(this.filetree);const w=new b.$xP(f,u),S=P.ChatResponseFilesPart.from(w);return r(S),this},anchor(f,u){i(this.anchor);const w=new b.$yP(f,u),S=P.ChatResponseAnchorPart.from(w);return r(S),this},button(f){i(this.anchor);const u=new b.$CP(f),w=P.ChatResponseCommandButtonPart.from(u,t.m,t.n);return r(w),this},progress(f,u){i(this.progress);const w=new b.$AP(f,u),S=u?P.ChatTask.from(w):P.ChatResponseProgressPart.from(w);return r(S,u),this},warning(f){i(this.progress),(0,m.$7G)(t.j,"chatParticipantAdditions");const u=new b.$BP(f),w=P.ChatResponseWarningPart.from(u);return r(w),this},reference(f,u){if(i(this.reference),"variableName"in f&&(0,m.$7G)(t.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const w=t.k.variables.variables.find(S=>S.name===f.variableName);if(w){let S;if(w.references?.length)S=w.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new b.$DP(f,u);S=[P.ChatResponseReferencePart.from(D)]}return S.forEach(D=>r(D)),this}}else{const w=new b.$DP(f,u),S=P.ChatResponseReferencePart.from(w);r(S)}return this},textEdit(f,u){i(this.textEdit),(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new b.$EP(f,u),S=P.ChatResponseTextEditPart.from(w);return r(S),this},detectedParticipant(f,u){i(this.detectedParticipant),(0,m.$7G)(t.j,"chatParticipantAdditions");const w=new b.$vP(f,u),S=P.ChatResponseDetectedParticipantPart.from(w);return r(S),this},confirmation(f,u,w){i(this.confirmation),(0,m.$7G)(t.j,"chatParticipantAdditions");const S=new b.$wP(f,u,w),D=P.ChatResponseConfirmationPart.from(S);return r(D),this},push(f){if(i(this.push),(f instanceof b.$EP||f instanceof b.$uP||f instanceof b.$vP||f instanceof b.$BP||f instanceof b.$wP)&&(0,m.$7G)(t.j,"chatParticipantAdditions"),f instanceof b.$DP)this.reference(f.value,f.iconPath);else{const u=P.ChatResponsePart.from(f,t.m,t.n);r(u)}return this}}}return this.g}}class g extends R.$Xc{static{this.b=0}constructor(t,i,r){super(),this.n=i,this.s=r,this.c=new Map,this.j=this.B(new R.$7c),this.m=this.B(new R.$7c),this.g=t.getProxy(l.$uN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,i,r){const f=g.b++,u=new n(t,i,this.g,f,r);return this.c.set(f,u),this.g.$registerAgent(f,t.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(t,i,r,f){const u=g.b++,w=new n(t,i,this.g,u,f);return this.c.set(u,w),this.g.$registerAgent(u,t.identifier,i,{isSticky:!0},r),w.apiAgent}async $invokeAgent(t,i,r,f){const u=this.c.get(t);if(!u)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(i.sessionId);w||(w=new R.$Wc,this.j.set(i.sessionId,w));const S=new d(u.extension,i,this.g,this.s.converter,w);try{const D=await this.t(i.agentId,r),y=u.invoke(P.ChatAgentRequest.to(i),{history:D},S.apiObject,f);return await(0,h.$uh)(Promise.resolve(y).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(p){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${p.message}`;return this.n.error(`[${u.extension.identifier.value}] [@${u.id}] ${v}`,u.extension),{errorDetails:{message:v},timings:S.timings}}let A;return C?.errorDetails&&(A={...C.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,m.$7G)(u.extension,"chatParticipantPrivate"),{errorDetails:A,timings:S.timings,metadata:C?.metadata}}),f)}catch(D){return this.n.error(D,u.extension),D instanceof b.$OP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,I.$rj)(D),responseIsIncomplete:!0}}}finally{S.close()}}async t(t,i){const r=[];for(const f of i.history){const u=P.ChatAgentResult.to(f.result),w=t===f.request.agentId?u:{...u,metadata:void 0};r.push(new b.$FP(f.request.message,f.request.command,f.request.variables.variables.map(P.ChatAgentValueReference.to),f.request.agentId));const S=(0,s.$Kb)(f.response.map(D=>P.ChatResponsePart.toContent(D,this.s.converter)));r.push(new b.$GP(S,w,f.request.agentId,f.request.command))}return r}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,i,r,f,u){const w=this.c.get(i);if(!w)return Promise.resolve([]);const S=await this.t(w.id,f),D=P.ChatAgentResult.to(r);return(await w.provideFollowups(D,{history:S},u)).filter(y=>{const C=!y.participant||L.Iterable.some(this.c.values(),A=>A.id===y.participant&&E.$rn.equals(A.extension.identifier,w.extension.identifier));return C||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),C}).map(y=>P.ChatFollowup.from(y,t))}$acceptFeedback(t,i,r,f){const u=this.c.get(t);if(!u)return;const w=P.ChatAgentResult.to(i);let S;switch(r){case c.ChatAgentVoteDirection.Down:S=b.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:S=b.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:w,kind:S,reportIssue:f}:{result:w,kind:S}))}$acceptAction(t,i,r){const f=this.c.get(t);if(!f||r.action.kind==="vote")return;const u=P.ChatAgentUserActionEvent.to(i,r,this.s.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(t,i,r){const f=this.c.get(t);if(!f)return[];let u=this.m.get(t);return u?u.clear():(u=new R.$Wc,this.m.set(t,u)),(await f.invokeCompletionProvider(i,r)).map(S=>P.ChatAgentCompletionItem.from(S,this.s.converter,u))}async $provideWelcomeMessage(t,i,r){const f=this.c.get(t);if(f)return await f.provideWelcomeMessage(P.ChatLocation.to(i),r)}async $provideSampleQuestions(t,i,r){const f=this.c.get(t);if(f)return(await f.provideSampleQuestions(P.ChatLocation.to(i),r)).map(u=>P.ChatFollowup.from(u,void 0))}}e.$Coc=g;class n{constructor(t,i,r,f,u){this.extension=t,this.id=i,this.w=r,this.x=f,this.y=u,this.m=new T.$ne,this.n=new T.$ne}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,i){return this.q?await this.q.provider.provideCompletionItems(t,i)??[]:[]}async provideFollowups(t,i,r){if(!this.b)return[];const f=await this.b.provideFollowups(t,i,r);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(t,i){if(!this.s)return[];const r=await this.s.provideWelcomeMessage(t,i);return r?r.map(f=>typeof f=="string"?f:P.MarkdownString.from(f)):[]}async provideSampleQuestions(t,i){if(!this.s||!this.s.provideSampleQuestions)return[];const r=await this.s.provideSampleQuestions(t,i);return r||[]}get apiAgent(){let t=!1,i=!1;const r=()=>{t||i||(i=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof k.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof b.$tO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:P.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:P.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:P.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(u){f.c=u,r()},get requestHandler(){return f.y},set requestHandler(u){(0,a.$qg)(typeof u=="function","Invalid request handler"),f.y=u},get followupProvider(){return f.b},set followupProvider(u){f.b=u,r()},get isDefault(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.d=u,r()},get helpTextPrefix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.g=u,r()},get helpTextVariablesPrefix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.j=u,r()},get helpTextPostfix(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.k=u,r()},get isSecondary(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.l=u,r()},get supportIssueReporting(){return(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(u){(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.o=u,r()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(u){if((0,m.$7G)(f.extension,"chatParticipantAdditions"),f.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f.w.$registerAgentCompletionsProvider(f.x,f.id,u.triggerCharacters)}else f.w.$unregisterAgentCompletionsProvider(f.x,f.id)},get participantVariableProvider(){return(0,m.$7G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(u){(0,m.$7G)(f.extension,"defaultChatParticipant"),f.s=u,r()},get welcomeMessageProvider(){return(0,m.$7G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,m.$6G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(u){f.t=u,r()},get requester(){return f.t},set supportsSlowReferences(u){(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.u=u,r()},get supportsSlowReferences(){return(0,m.$7G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){t=!0,f.b=void 0,f.m.dispose(),f.w.$unregisterAgent(f.x)}}}invoke(t,i,r,f){return this.y(t,i,r,f)}}}),define(Ee[347],Se([1,0,14,3,50,6,16,10,26]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0,L=We(L),R=We(R);class a{static{this.a=0}constructor(l){this.b=new Map,this.c=l.getProxy(T.$uN.MainThreadChatVariables)}async $resolveVariable(l,P,b,c){const m=this.b.get(l);if(m)try{if(m.resolver.resolve2){(0,$.$7G)(m.extension,"chatParticipantAdditions");const d=new k(P,this.c),g=await m.resolver.resolve2(m.data.name,{prompt:b},d.apiObject,c);if(g&&g[0])return g[0].value}else{const d=await m.resolver.resolve(m.data.name,{prompt:b},c);if(d&&d[0])return d[0].value}}catch(d){(0,s.$4)(d)}}registerVariableResolver(l,P,b,c,m,d,g,n,o){const t=a.a++,i=o?I.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:l,data:{id:P,name:b,description:c,modelDescription:m,icon:i},resolver:g}),this.c.$registerVariable(t,{id:P,name:b,description:c,modelDescription:m,isSlow:d,fullName:n,icon:i}),(0,h.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Doc=a;class k{constructor(l,P){this.c=l,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(c){if(l.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,c),m}};const l=this,b=c=>{this.d.$handleProgressChunk(this.c,c)};this.b={progress(c){P(this.progress);const m=new R.$zP(c),d=L.ChatResponseProgressPart.from(m);return b(d),this},reference(c){P(this.reference);const m=new R.$DP(c),d=L.ChatResponseReferencePart.from(m);return b(d),this},push(c){return P(this.push),c instanceof R.$DP?b(L.ChatResponseReferencePart.from(c)):c instanceof R.$zP&&b(L.ChatResponseProgressPart.from(c)),this}}}return this.b}}}),define(Ee[348],Se([1,0,9,59,4,3,41,2,88,24,16,10,6,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=b,$=We($),k=We(k),E=We(E);function b(c,m,d){const g=c.getProxy(l.$uN.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$tn,m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===L.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===L.MarshalledId.CommentThread){const C=y,A=this.b.get(C.commentControlHandle);if(!A)return C;const p=A.getCommentThread(C.commentThreadHandle);return p?p.value:C}else if(y&&(y.$mid===L.MarshalledId.CommentThreadReply||y.$mid===L.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===L.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===L.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.commentUniqueId,v=A.getCommentByUniqueId(p);return v||y}else if(y&&y.$mid===L.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.text,v=y.commentUniqueId,F=A.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=p:F.body=new E.$YN(p),F):y}return y}})}createCommentController(y,C,A){const p=n.a++,v=new t(y,p,C,A);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,C,A,p){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(C,A,p)}async $setActiveComment(y,C){const A=this.b.get(y);A&&A.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,A){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(C,A)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,A){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await d.ensureDocumentData(R.URI.revive(C));return(0,s.$yh)(async()=>{const F=await p.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(O=>k.Range.from(O)),fileComments:F.fileComments}),N})}$toggleReaction(y,C,A,p,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,s.$yh)(()=>{const N=F.getCommentThread(C);if(N){const O=N.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&O&&F.reactionHandler)return F.reactionHandler(O,f(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$7G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,A,p,v,F,N,O,j){this.m=C,this.n=A,this.o=p,this.p=v,this.q=F,this.extensionDescription=N,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$ne,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Yc,this.l.value=new T.$Wc,this.n===void 0&&(this.n=`${y}.${this.handle}`),g.$createCommentThread(C,this.handle,this.n,this.o,k.Range.from(this.p),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{g.$deleteCommentThread(C,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},reveal:M=>z.reveal(M),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Wc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),C={};y("range")&&(C.range=k.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(A=>i(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=u(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=w(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},g.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const A=C[0],p=C[1];if(y===p)return A}}async reveal(y){return(0,P.$7G)(this.extensionDescription,"commentReveal"),g.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Xe([(0,h.$_h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$7G)(this.h,"commentingRangeHint"),g.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,g.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$7G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$7G)(this.h,"activeComment"),this.f}constructor(y,C,A,p){this.h=y,this.i=C,this.j=A,this.k=p,this.a=new Map,g.$registerCommentController(this.handle,A,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,O){return v.createCommentThread(F,N,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,A){C===void 0&&(0,P.$7G)(this.h,"fileComments");const p=new o(this.id,this.handle,void 0,y,C,A,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,A){const p=new o(this.id,this.handle,void 0,R.URI.revive(y),k.Range.to(C),[],this.h,!0,A);return p.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,C){const A=this.a.get(y);A&&(A.range=k.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function i(D,y,C,A){let p=C.get(y);return p||(p=++D.commentHandle,C.set(y,p)),y.state!==void 0&&(0,P.$7G)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$7G)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:k.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>r(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function r(D){return{label:D.label,iconPath:D.iconPath?k.$ZP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?R.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function u(D){if(D!==void 0)switch(D){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function S(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Ee[349],Se([1,0,21,60,3,15,23,2,16,97,119,6,10]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=void 0,$=We($),E=We(E),l=We(l);class P{constructor(r,f){this.document=r,this.b=f,this.a=1,this.c=new k.$noc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,f){await this.f(r).undo(),f||this.disposeBackup()}async redo(r,f){await this.f(r).redo(),f||this.disposeBackup()}disposeEdits(r){for(const f of r)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=t(this.document.uri)+this.a++;return(0,L.$hh)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const f=this.c.get(r,0);if(!f)throw new Error("No edit found");return f}}class b{constructor(){this.a=new Map}get(r,f){return this.a.get(this.b(r,f))}add(r,f,u){const w=this.b(r,f.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${f.uri}`);const S=new P(f,u);return this.a.set(w,S),S}delete(r,f){const u=this.b(r,f.uri);this.a.delete(u)}b(r,f){return`${r}@@@${f}`}}var c;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(r,f,u){return this.b(r,{type:c.Text,extension:f,provider:u})}addCustomProvider(r,f,u){return this.b(r,{type:c.Custom,extension:f,provider:u})}get(r){return this.a.get(r)}b(r,f){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,f),new l.$wN(()=>this.a.delete(r))}}class d{constructor(r,f,u,w,S){this.d=f,this.f=u,this.g=w,this.h=S,this.b=new m,this.c=new b,this.a=r.getProxy(E.$uN.MainThreadCustomEditors)}registerCustomEditorProvider(r,f,u,w){const S=new I.$Wc;return n(u)?(S.add(this.b.addTextProvider(f,r,u)),this.a.$registerTextEditorProvider((0,a.$Woc)(r),f,w.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,a.$Uoc)(r))):(S.add(this.b.addCustomProvider(f,r,u)),g(u)&&S.add(u.onDidChangeCustomDocument(D=>{const y=this.i(f,D.document.uri);if(o(D)){const C=y.addEdit(D);this.a.$onDidEdit(D.document.uri,f,C,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,a.$Woc)(r),f,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,a.$Uoc)(r))),l.$wN.from(S,new l.$wN(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(r,f,u,w,S){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==c.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=R.URI.revive(r),C=await D.provider.openCustomDocument(y,{backupId:u,untitledDocumentData:w?.buffer},S);let A;return g(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,C,A),{editable:g(D.provider)}}async $disposeCustomDocument(r,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==c.Custom)throw new Error(`Invalid provider type for '${f}'`);const w=R.URI.revive(r),{document:S}=this.i(f,w);this.c.delete(f,S),S.dispose()}async $resolveCustomEditor(r,f,u,w,S,D){const y=this.b.get(u);if(!y)throw new Error(`No provider found for '${u}'`);const C=$.ViewColumn.to(S),A=this.g.createNewWebview(f,w.contentOptions,y.extension),p=this.h.createNewWebviewPanel(f,u,w.title,C,w.options,A,w.active),v=R.URI.revive(r);switch(y.type){case c.Custom:{const{document:F}=this.i(u,v);return y.provider.resolveCustomEditor(F,p,D)}case c.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,p,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,f,u){this.i(f,r).disposeEdits(u)}async $onMoveCustomEditor(r,f,u){const w=this.b.get(u);if(!w)throw new Error(`No provider found for '${u}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const S=this.h.getWebviewPanel(r);if(!S)throw new Error("No webview found");const D=R.URI.revive(f),y=this.d.getDocument(D);await w.provider.moveCustomTextEditor(y,S,s.CancellationToken.None)}async $undo(r,f,u,w){return this.i(f,r).undo(u,w)}async $redo(r,f,u,w){return this.i(f,r).redo(u,w)}async $revert(r,f,u){const w=this.i(f,r);await this.j(f).revertCustomDocument(w.document,u),w.disposeBackup()}async $onSave(r,f,u){const w=this.i(f,r);await this.j(f).saveCustomDocument(w.document,u),w.disposeBackup()}async $onSaveAs(r,f,u,w){const S=this.i(f,r);return this.j(f).saveCustomDocumentAs(S.document,R.URI.revive(u),w)}async $backup(r,f,u){const w=this.i(f,r),D=await this.j(f).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},u);return w.updateBackup(D),D.id}i(r,f){const u=this.c.get(r,R.URI.revive(f));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.$Zoc=d;function g(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function o(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function t(i){const r=i.scheme===T.Schemas.file||i.scheme===T.Schemas.untitled?i.fsPath:i.toString();return(0,h.$uj)(r)+""}}),define(Ee[350],Se([1,0,234,146,2,6,10,16,4,12,29,63]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$uoc=void 0,R=We(R);class P{#e;#t;#i;constructor(m,d,g,n,o,t,i,r){this.d=m,this.e=d,this.f=g,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,g),this.#i=new k.$Dc(f=>t.getComparisonKey(f)),this.#e=i,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,d){if(!m){this.clear();return}this.j();let g=[];if(I.URI.isUri(m)){if(!d){this.delete(m);return}this.#i.set(m,d.slice()),g=[m]}else if(Array.isArray(m)){g=[];let t;m=[...m].sort(P.k);for(const i of m){const[r,f]=i;if((!t||r.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=r,g.push(r),this.#i.set(r,[])),f)this.#i.get(r)?.push(...f);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(g),!this.#e)return;const n=[];let o=0;for(const t of g){let i=[];const r=this.#i.get(t);if(r)if(r.length>this.g){i=[];const f=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const w of r)if(w.severity===f[u]&&i.push({...R.Diagnostic.from(w),modelVersionId:this.h(t)})===this.g)break e;i.push({severity:h.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(f=>({...R.Diagnostic.from(f),modelVersionId:this.h(t)}));if(n.push([t,i]),o+=i.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,d){this.j();for(const[g,n]of this)m.call(d,g,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const d=this.#i.get(m);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,d){return m[0].toString()<d[0].toString()?-1:m[0].toString()>d[0].toString()?1:0}}e.$uoc=P;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(m){const d=new k.$Dc;for(const g of m)d.set(g,g);return{uris:Object.freeze(Array.from(d.values()))}}constructor(m,d,g,n){this.j=d,this.k=g,this.l=n,this.g=new Map,this.h=new $.$re({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,l._mapper),this.f=m.getProxy(T.$uN.MainThreadDiagnostics)}createDiagnosticCollection(m,d){const{g,f:n,h:o,j:t,k:i,l:r}=this,f=new class{$changeMany(S,D){n.$changeMany(S,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,S,D.length===0?"CLEARING":D)}$clear(S){n.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,S)}dispose(){n.dispose()}};let u;if(!d)d="_generated_diagnostic_collection_name_#"+l.c++,u=d;else if(!g.has(d))u=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do u=d+l.c++;while(g.has(u))}return new class extends P{constructor(){super(d,u,l.e,l.d,S=>r.getDocument(S)?.version,i.extUri,f,o),g.set(u,this)}dispose(){super.dispose(),g.delete(u)}}}getDiagnostics(m){if(m)return this.m(m);{const d=new Map,g=[];for(const n of this.g.values())n.forEach((o,t)=>{let i=d.get(o.toString());typeof i>"u"&&(i=g.length,d.set(o.toString(),i),g.push([o,[]])),g[i][1]=g[i][1].concat(...t)});return g}}m(m){let d=[];for(const g of this.g.values())g.has(m)&&(d=d.concat(g.get(m)));return d}$acceptMarkersChange(m){if(!this.n){const d="_generated_mirror",g=new P(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(d,g),this.n=g}for(const[d,g]of m)this.n.set(I.URI.revive(d),g.map(R.Diagnostic.to))}};e.$voc=b,e.$voc=b=l=Xe([Ve(1,a.$ak),Ve(2,E.$toc)],b)}),define(Ee[351],Se([1,0,2,14,10,16,81,52]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class ${constructor(k,E,l,P={timeout:1500,errors:3}){this.c=k,this.d=E,this.f=l,this.g=P,this.a=new L.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(E,l,P)=>{const c={dispose:this.a.push([E,l,k])};return Array.isArray(P)&&P.push(c),c}}async $participateInSave(k,E){const l=s.URI.revive(k);let P=!1;const b=setTimeout(()=>P=!0,this.g.timeout),c=[];try{for(const m of[...this.a]){if(P)break;const d=this.d.getDocument(l),g=await this.h(m,{document:d,reason:T.TextDocumentSaveReason.to(E)});c.push(g)}}finally{clearTimeout(b)}return c}h([k,E,l],P){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(l,k,E,P).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const m=this.b.get(k);this.b.set(k,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,E,l,P){const b=[],c=Date.now(),{document:m,reason:d}=P,{version:g}=m,n=Object.freeze({document:m,reason:d,waitUntil(o){if(Object.isFrozen(b))throw(0,h.$$)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{E.apply(l,[n])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,t)=>{const i=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(i),o(r)}).catch(r=>{clearTimeout(i),t(r)})}).then(o=>{const t={edits:[]};for(const i of o)if(Array.isArray(i)&&i.every(r=>r instanceof I.$DN))for(const{newText:r,newEol:f,range:u}of i)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:u&&T.Range.from(u),text:r,eol:f&&T.EndOfLine.from(f)}});if(t.edits.length!==0)return g===m.version?this.f.$tryApplyWorkspaceEdit(new R.$Uw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Ipc=$}),define(Ee[352],Se([1,0,4,3,2,6,164,16,18,25,10]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,R=We(R);class E{constructor(P,b){this.a=new s.$ne,this.b=new s.$ne,this.c=new s.$ne,this.d=new s.$ne,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Wc,this.h=new Map,this.f=P.getProxy(T.$uN.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const b=this.g.getDocument(P);if(b)return b}getDocument(P){const b=this.getDocumentData(P);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return b.document}ensureDocumentData(P){const b=this.g.getDocument(P);if(b)return Promise.resolve(b);let c=this.h.get(P.toString());return c||(c=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const d=I.URI.revive(m);return(0,$.$rg)(this.g.getDocument(d))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),c)),c}createDocumentData(P){return this.f.$tryCreateDocument(P).then(b=>I.URI.revive(b))}$acceptModelLanguageChanged(P,b){const c=I.URI.revive(P),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(b),this.a.fire(m.document)}$acceptModelSaved(P){const b=I.URI.revive(P),c=this.g.getDocument(b);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(P,b){const c=I.URI.revive(P),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(b),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,b,c){const m=I.URI.revive(P),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");d._acceptIsDirty(c),d.onEvents(b);let g;b.isUndoing?g=k.TextDocumentChangeReason.Undo:b.isRedoing&&(g=k.TextDocumentChangeReason.Redo),this.c.fire((0,a.$fo)({document:d.document,contentChanges:b.changes.map(n=>({range:R.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:g}))}setWordDefinitionFor(P,b){(0,L.$3P)(P,b)}}e.$woc=E}),define(Ee[78],Se([1,0,79,4,18,2,5,6,20,16,10]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0,a=We(a),e.$1oc=(0,L.$Gi)("IExtHostEditorTabs");class E{constructor(m,d,g){this.e=g,this.d=d,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,d={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case R.TabInputKind.TextInput:return new k.$hP(T.URI.revive(this.b.input.uri));case R.TabInputKind.TextDiffInput:return new k.$iP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case R.TabInputKind.TextMergeInput:return new k.$jP(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case R.TabInputKind.CustomEditorInput:return new k.$kP(T.URI.revive(this.b.input.uri),this.b.input.viewType);case R.TabInputKind.WebviewEditorInput:return new k.$lP(this.b.input.viewType);case R.TabInputKind.NotebookInput:return new k.$mP(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new k.$nP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new k.$oP;case R.TabInputKind.InteractiveEditorInput:return new k.$pP(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new k.$qP;case R.TabInputKind.MultiDiffEditorInput:return new k.$rP(this.b.input.diffEditors.map(m=>new k.$iP(T.URI.revive(m.original),T.URI.revive(m.modified))));default:return}}}class l{constructor(m,d){this.c=[],this.d="",this.b=m,this.e=d;for(const g of m.tabs)g.isActive&&(this.d=g.id),this.c.push(new E(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,d={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return a.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(g=>g.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(g=>g.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===R.TabModelOperationKind.TAB_OPEN){const g=new E(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,g),m.tabDto.isActive&&(this.d=g.tabId),g}else if(m.kind===R.TabModelOperationKind.TAB_CLOSE){const g=this.c.splice(m.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(m.kind===R.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(m.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,g),g}const d=this.c.find(g=>g.tabId===m.tabDto.id);if(!d)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(m.tabDto),d}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$ne,this.c=new h.$ne,this.e=[],this.a=m.getProxy(R.$uN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,d={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(g=>g.apiObject))},get activeTabGroup(){const g=m.d;return(0,I.$rg)(m.e.find(o=>o.groupId===g)?.apiObject)},close:async(g,n)=>{const o=Array.isArray(g)?g:[g];return o.length?b(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(m){const d=new Set(this.e.map(f=>f.groupId)),g=new Set(m.map(f=>f.groupId)),n=(0,s.$L)(d,g),o=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),t=[],i=[];this.e=m.map(f=>{const u=new l(f,()=>this.d);return n.added.includes(u.groupId)?t.push(u.apiObject):i.push(u.apiObject),u});const r=(0,I.$rg)(m.find(f=>f.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:t,closed:o,changed:i}))}$acceptTabGroupUpdate(m){const d=this.e.find(g=>g.groupId===m.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const d=this.e.find(n=>n.groupId===m.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const g=d.acceptTabOperation(m);switch(m.kind){case R.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(m){for(const d of this.e)for(const g of d.tabs)if(g.apiObject===m)return g}h(m){return this.e.find(d=>d.apiObject===m)}async i(m,d){const g=[];for(const n of m){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");g.push(o.tabId)}return this.a.$closeTab(g,d)}async j(m,d){const g=[];for(const n of m){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");g.push(o.groupId)}return this.a.$closeGroup(g,d)}};e.$2oc=P,e.$2oc=P=Xe([Ve(0,$.$1P)],P);function b(c){return c.tabs!==void 0}}),define(Ee[353],Se([1,0,2,6,28,3,10,16,195,13,27,22,26,86]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0,I=We(I),R=We(R);class b{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const g=this.a.indexOf(d);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),g=[];let n,o,t=$.State.LastKnownState,i=$.State.LastKnownState;for(const r of d){let f=n?(0,a.$Jf)(n,r):0;for(f===0?o=$.State.Start:o=i;f<r.length;f++)f+1===r.length?(t=i,i=$.State.BeforeColon):i+=1,g.push([o,r.toUpperCase().charCodeAt(f),i]),g.push([o,r.toLowerCase().charCodeAt(f),i]),o=i;n=r,i=t}g.push([$.State.BeforeColon,k.CharCode.Colon,$.State.AfterColon]),g.push([$.State.AfterColon,k.CharCode.Slash,$.State.End]),this.b=new $.$p4(g)}}provideDocumentLinks(d){this.c();const g=[],n=$.$q4.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of n){const t=R.DocumentLink.to(o);t.target&&g.push(t)}return g}}class c{constructor(d,g){this.i=g,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(h.$uN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,g,n,o={}){if(c.j(n),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const t=this.h++;this.b.add(g),this.d.add(g),this.c.set(t,n);let i=I.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(i+=I.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(i+=I.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(i+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,l.$7G)(d,"fsChunks"),i+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let r;o.isReadonly&&(0,P.$6k)(o.isReadonly)&&o.isReadonly.value!==""&&(r={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,g,i,r).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${g}`),console.error(u)});const f=n.onDidChangeFile(u=>{const w=[];for(const S of u){const{uri:D,type:y}=S;if(D.scheme!==g)continue;let C;switch(y){case L.FileChangeType.Changed:C=I.FileChangeType.UPDATED;break;case L.FileChangeType.Created:C=I.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:C=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:D,type:C})}this.a.$onFileSystemChange(t,w)});return(0,T.$Vc)(()=>{f.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:g,ctime:n,mtime:o,size:t,permissions:i}=d;return{type:g,ctime:n,mtime:o,size:t,permissions:i}}$stat(d,g){return Promise.resolve(this.l(d).stat(s.URI.revive(g))).then(n=>c.k(n))}$readdir(d,g){return Promise.resolve(this.l(d).readDirectory(s.URI.revive(g)))}$readFile(d,g){return Promise.resolve(this.l(d).readFile(s.URI.revive(g))).then(n=>E.$Pe.wrap(n))}$writeFile(d,g,n,o){return Promise.resolve(this.l(d).writeFile(s.URI.revive(g),n.buffer,o))}$delete(d,g,n){return Promise.resolve(this.l(d).delete(s.URI.revive(g),n))}$rename(d,g,n,o){return Promise.resolve(this.l(d).rename(s.URI.revive(g),s.URI.revive(n),o))}$copy(d,g,n,o){const t=this.l(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(s.URI.revive(g),s.URI.revive(n),o))}$mkdir(d,g){return Promise.resolve(this.l(d).createDirectory(s.URI.revive(g)))}$watch(d,g,n,o){const t=this.l(d).watch(s.URI.revive(n),o);this.f.set(g,t)}$unwatch(d,g){const n=this.f.get(g);n&&(n.dispose(),this.f.delete(g))}$open(d,g,n){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(s.URI.revive(g),n))}$close(d,g){const n=this.l(d);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(g))}$read(d,g,n,o){const t=this.l(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const i=E.$Pe.alloc(o);return Promise.resolve(t.read(g,n,i.buffer,0,o)).then(r=>i.slice(0,r))}$write(d,g,n,o){const t=this.l(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(g,n,o.buffer,0,o.byteLength))}l(d){const g=this.c.get(d);if(!g){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return g}}e.$Lpc=c}),define(Ee[354],Se([1,0,4,39,2,6,16,10,28,49]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,L=We(L);class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,c,m,d,g,n){this.a=Math.random(),this.b=new s.$ne,this.c=new s.$ne,this.d=new s.$ne,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$Ak)(g),t=typeof g=="string",i=n?.correlate,r=d(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(i&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const u of f.created){const w=I.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const u of f.changed){const w=I.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const u of f.deleted){const w=I.URI.revive(u);o(w.fsPath)&&(!t||c.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=R.$wN.from(this.i(b,m,g,n,n?.correlate),this.b,this.c,this.d,r)}i(b,c,m,d,g){const n=R.$wN.from();if(typeof m=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const o=b.getProxy(T.$uN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$wk)||m.pattern.includes(h.$xk))&&(t=!0);let i;return g&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),o.$watch(c.identifier.value,this.a,m.baseUri,{recursive:t,excludes:d?.excludes??[],filter:i},!!g),R.$wN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(b){this.a=b,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(I.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(I.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class l{constructor(b,c,m){this.j=b,this.k=c,this.l=m,this.a=new s.$ne,this.b=new s.$ne,this.c=new s.$ne,this.d=new s.$ne,this.g=new s.$pe,this.h=new s.$pe,this.i=new s.$pe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,c,m,d){return new k(this.j,b,c,this.a.event,L.GlobPattern.from(m),d)}$onFileEvent(b){this.a.fire(new E(b))}$onDidRunFileOperation(b,c){switch(b){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:c.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:c.map(m=>I.URI.revive(m.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:c.map(m=>I.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,c){return(m,d,g)=>{const n=function(t){m.call(d,t)};return n.extension=b,c.event(n,void 0,g)}}async $onWillRunFileOperation(b,c,m,d){switch(b){case $.FileOperation.MOVE:return await this.n(this.g,{files:c.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))},m,d);case $.FileOperation.DELETE:return await this.n(this.i,{files:c.map(g=>I.URI.revive(g.target))},m,d);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:c.map(g=>I.URI.revive(g.target))},m,d)}}async n(b,c,m,d){const g=new Set,n=[];if(await b.fireAsync(c,d,async(t,i)=>{const r=Date.now(),f=await Promise.resolve(t);f instanceof R.$GN&&(n.push([i.extension,f]),g.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-r>m&&this.k.warn("SLOW file-participant",i.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,t]of n){const{edits:i}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(i)}return{edit:o,extensionNames:Array.from(g)}}}e.$Mpc=l}),define(Ee[355],Se([1,0,19,9,21,14,133,3,25,43,13,18,2,31,191,88,143,236,24,16,10,26,119,6]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,c=We(c),n=We(n),r=We(r);class f{constructor(W,q){this.d=W,this.e=q}async provideDocumentSymbols(W,q){const Y=this.d.getDocument(W),_=await this.e.provideDocumentSymbols(Y,q);if(!(0,s.$Nb)(_))return _[0]instanceof o.$QN?_.map(n.DocumentSymbol.from):f.f(_)}static f(W){W=W.slice(0).sort((_,fe)=>{let be=_.location.range.start.compareTo(fe.location.range.start);return be===0&&(be=fe.location.range.end.compareTo(_.location.range.end)),be});const q=[],Y=[];for(const _ of W){const fe={name:_.name||"!!MISSING: name!!",kind:n.SymbolKind.from(_.kind),tags:_.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:n.Range.from(_.location.range),selectionRange:n.Range.from(_.location.range),children:[]};for(;;){if(Y.length===0){Y.push(fe),q.push(fe);break}const be=Y[Y.length-1];if(P.$Mt.containsRange(be.range,fe.range)&&!P.$Mt.equalsRange(be.range,fe.range)){be.children?.push(fe),Y.push(fe);break}Y.pop()}}return q}}class u{constructor(W,q,Y,_,fe,be){this.f=W,this.g=q,this.h=Y,this.j=_,this.k=fe,this.l=be,this.d=new i.$noc("CodeLens"),this.e=new Map}async provideCodeLenses(W,q){const Y=this.f.getDocument(W),_=await this.h.provideCodeLenses(Y,q);if(!_||q.isCancellationRequested)return;const fe=this.d.add(_),be=new R.$Wc;this.e.set(fe,be);const Ne={cacheId:fe,lenses:[]};for(let Ge=0;Ge<_.length;Ge++)Ne.lenses.push({cacheId:[fe,Ge],range:n.Range.from(_[Ge].range),command:this.g.toInternal(_[Ge].command,be)});return Ne}async resolveCodeLens(W,q){const Y=W.cacheId&&this.d.get(...W.cacheId);if(!Y)return;let _;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?_=Y:_=await this.h.resolveCodeLens(Y,q),_||(_=Y),q.isCancellationRequested)return;const fe=W.cacheId&&this.e.get(W.cacheId[0]);if(fe){if(!_.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return W.command=this.g.toInternal(_.command,fe),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function w(Te){return Array.isArray(Te)?Te.map(n.DefinitionLink.from):Te?[n.DefinitionLink.from(Te)]:[]}class S{constructor(W,q){this.d=W,this.e=q}async provideDefinition(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideDefinition(_,fe,Y);return w(be)}}class D{constructor(W,q){this.d=W,this.e=q}async provideDeclaration(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideDeclaration(_,fe,Y);return w(be)}}class y{constructor(W,q){this.d=W,this.e=q}async provideImplementation(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideImplementation(_,fe,Y);return w(be)}}class C{constructor(W,q){this.d=W,this.e=q}async provideTypeDefinition(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideTypeDefinition(_,fe,Y);return w(be)}}class A{static{this.f=10}constructor(W,q){this.g=W,this.h=q,this.d=0,this.e=new Map}async provideHover(W,q,Y,_){const fe=this.g.getDocument(W),be=n.Position.to(q);let Ne;if(Y&&Y.verbosityRequest){const rt=Y.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:Y.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this.h.provideHover(fe,be,_,nt)}else Ne=await this.h.provideHover(fe,be,_);if(!Ne||(0,s.$Nb)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(be)),Ne.range||(Ne.range=new o.$yN(be,be));const Ge=n.Hover.from(Ne),Ke=this.d;if(this.e.size===A.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ke,Ne),this.d+=1,{...Ge,id:Ke}}releaseHover(W){this.e.delete(W)}}class p{constructor(W,q){this.d=W,this.e=q}async provideEvaluatableExpression(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideEvaluatableExpression(_,fe,Y);if(be)return n.EvaluatableExpression.from(be)}}class v{constructor(W,q){this.d=W,this.e=q}async provideInlineValues(W,q,Y,_){const fe=this.d.getDocument(W),be=await this.e.provideInlineValues(fe,n.Range.to(q),n.InlineValueContext.to(Y),_);if(Array.isArray(be))return be.map(Ne=>n.InlineValue.from(Ne))}}class F{constructor(W,q){this.d=W,this.e=q}async provideDocumentHighlights(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideDocumentHighlights(_,fe,Y);if(Array.isArray(be))return be.map(n.DocumentHighlight.from)}}class N{constructor(W,q){this.d=W,this.e=q}async provideMultiDocumentHighlights(W,q,Y,_){const fe=this.d.getDocument(W),be=Y.map(Ke=>this.d.getDocument(Ke)),Ne=n.Position.to(q),Ge=await this.e.provideMultiDocumentHighlights(fe,Ne,be,_);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class O{constructor(W,q){this.d=W,this.e=q}async provideLinkedEditingRanges(W,q,Y){const _=this.d.getDocument(W),fe=n.Position.to(q),be=await this.e.provideLinkedEditingRanges(_,fe,Y);if(be&&Array.isArray(be.ranges))return{ranges:(0,s.$Kb)(be.ranges.map(n.Range.from)),wordPattern:be.wordPattern}}}class j{constructor(W,q){this.d=W,this.e=q}async provideReferences(W,q,Y,_){const fe=this.d.getDocument(W),be=n.Position.to(q),Ne=await this.e.provideReferences(fe,be,Y,_);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class z{static{this.d=1e3}constructor(W,q,Y,_,fe,be,Ne){this.g=W,this.h=q,this.j=Y,this.k=_,this.l=fe,this.m=be,this.n=Ne,this.e=new i.$noc("CodeAction"),this.f=new Map}async provideCodeActions(W,q,Y,_){const fe=this.g.getDocument(W),be=b.$Ot.isISelection(q)?n.Selection.to(q):n.Range.to(q),Ne=[];for(const nt of this.j.getDiagnostics(W))if(be.intersection(nt.range)&&Ne.push(nt)>z.d)break;const Ge={diagnostics:Ne,only:Y.only?new o.$SN(Y.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Y.trigger)},Ke=await this.k.provideCodeActions(fe,be,Ge,_);if(!(0,s.$Ob)(Ke)||_.isCancellationRequested)return;const tt=this.e.add(Ke),rt=new R.$Wc;this.f.set(tt,rt);const ot=[];for(let nt=0;nt<Ke.length;nt++){const at=Ke[nt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,rt)});else{Ge.only&&(at.kind?Ge.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=at.ranges??[];ot.push({cacheId:[tt,nt],title:at.title,command:at.command&&this.h.toInternal(at.command,rt),diagnostics:at.diagnostics&&at.diagnostics.map(n.Diagnostic.from),edit:at.edit&&n.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$6G)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$6G)(this.m,"codeActionRanges")?(0,s.$Kb)(mt.map(n.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(W,q){const[Y,_]=W,fe=this.e.get(Y,_);if(!fe||z.o(fe))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(fe,q)??fe;let Ne;be.edit&&(Ne=n.WorkspaceEdit.from(be.edit,void 0));let Ge;if(be.command){const Ke=this.f.get(Y);Ke&&(Ge=this.h.toInternal(be.command,Ke))}return{edit:Ne,command:Ge}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class M{constructor(W,q,Y,_,fe){this.e=W,this.f=q,this.g=Y,this.h=_,this.j=fe,this.d=new i.$noc("DocumentPasteEdit")}async prepareDocumentPaste(W,q,Y,_){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(W),be=q.map(Ke=>n.Range.to(Ke)),Ne=n.DataTransfer.toDataTransfer(Y,()=>{throw new T.$bb});if(await this.g.prepareDocumentPaste(fe,be,Ne,_),_.isCancellationRequested)return;const Ge=Array.from(Ne).filter(([,Ke])=>!(Ke instanceof o.$mO));return n.DataTransfer.from(Ge)}async providePasteEdits(W,q,Y,_,fe,be){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(q),Ge=Y.map(ot=>n.Range.to(ot)),Ke=n.DataTransfer.toDataTransfer(_,async ot=>(await this.e.$resolvePasteFileData(this.h,W,ot)).buffer),tt=await this.g.provideDocumentPasteEdits(Ne,Ge,Ke,{only:fe.only?new o.$rO(fe.only):void 0,triggerKind:fe.triggerKind},be);if(!tt||be.isCancellationRequested)return[];const rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,q){const[Y,_]=W,fe=this.d.get(Y,_);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class V{constructor(W,q){this.d=W,this.e=q}async provideDocumentFormattingEdits(W,q,Y){const _=this.d.getDocument(W),fe=await this.e.provideDocumentFormattingEdits(_,q,Y);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class K{constructor(W,q){this.d=W,this.e=q}async provideDocumentRangeFormattingEdits(W,q,Y,_){const fe=this.d.getDocument(W),be=n.Range.to(q),Ne=await this.e.provideDocumentRangeFormattingEdits(fe,be,Y,_);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,q,Y,_){(0,E.$qg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(W),be=q.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(fe,be,Y,_);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class re{constructor(W,q){this.d=W,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,q,Y,_,fe){const be=this.d.getDocument(W),Ne=n.Position.to(q),Ge=await this.e.provideOnTypeFormattingEdits(be,Ne,Y,_,fe);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class B{constructor(W,q){this.e=W,this.f=q,this.d=new i.$noc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,q){const Y=await this.e.provideWorkspaceSymbols(W,q);if(!(0,s.$Ob)(Y))return{symbols:[]};const _=this.d.add(Y),fe={cacheId:_,symbols:[]};for(let be=0;be<Y.length;be++){const Ne=Y[be];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[_,be]})}return fe}async resolveWorkspaceSymbol(W,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const Y=this.d.get(...W.cacheId);if(Y){const _=await this.e.resolveWorkspaceSymbol(Y,q);return _&&(0,$.$ho)(W,n.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class G{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,q,Y){this.d=W,this.e=q,this.f=Y}async provideRenameEdits(W,q,Y,_){const fe=this.d.getDocument(W),be=n.Position.to(q);try{const Ne=await this.e.provideRenameEdits(fe,be,Y,_);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ge=G.g(Ne);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(W,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(W),fe=n.Position.to(q);try{const be=await this.e.prepareRename(_,fe,Y);let Ne,Ge;if(o.$yN.isRange(be)?(Ne=be,Ge=_.getText(be)):(0,E.$ig)(be)&&(Ne=be.range,Ge=be.placeholder),!Ne||!Ge)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ge}}catch(be){const Ne=G.g(be);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(be)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class X{static{this.d={[c.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[c.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(W,q,Y){this.e=W,this.f=q,this.g=Y}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,q,Y,_){const fe=this.e.getDocument(W),be=n.Range.to(q);try{const Ne=X.d[Y],Ge=await this.f.provideNewSymbolNames(fe,be,Ne,_);return Ge?Ge.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ne){this.g.error(X.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ee{constructor(W,q){this.resultId=W,this.tokens=q}}class de{constructor(W,q){this.f=W,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,q,Y){const _=this.f.getDocument(W),fe=q!==0?this.d.get(q):null;let be=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,fe.resultId,Y):await this.g.provideDocumentSemanticTokens(_,Y);return fe&&this.d.delete(q),be?(be=de.h(be),this.o(de.n(fe,be),be)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return de.j(W)?de.k(W)?W:new o.$RO(new Uint32Array(W.data),W.resultId):de.l(W)?de.m(W)?W:new o.$TO(W.edits.map(q=>new o.$SO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const q of W.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(W,q){if(!de.j(q)||!W||!W.tokens)return q;const Y=W.tokens,_=Y.length,fe=q.data,be=fe.length;let Ne=0;const Ge=Math.min(_,be);for(;Ne<Ge&&Y[Ne]===fe[Ne];)Ne++;if(Ne===_&&Ne===be)return new o.$TO([],q.resultId);let Ke=0;const tt=Ge-Ne;for(;Ke<tt&&Y[_-Ke-1]===fe[be-Ke-1];)Ke++;return new o.$TO([{start:Ne,deleteCount:_-Ne-Ke,data:fe.subarray(Ne,be-Ke)}],q.resultId)}o(W,q){if(de.j(W)){const Y=this.e++;return this.d.set(Y,new ee(W.resultId,W.data)),(0,m.$Gdb)({id:Y,type:"full",data:W.data})}if(de.l(W)){const Y=this.e++;return de.j(q)?this.d.set(Y,new ee(q.resultId,q.data)):this.d.set(Y,new ee(W.resultId)),(0,m.$Gdb)({id:Y,type:"delta",deltas:(W.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class ne{constructor(W,q){this.d=W,this.e=q}async provideDocumentRangeSemanticTokens(W,q,Y){const _=this.d.getDocument(W),fe=await this.e.provideDocumentRangeSemanticTokens(_,n.Range.to(q),Y);return fe?this.f(fe):null}f(W){return(0,m.$Gdb)({id:0,type:"full",data:W.data})}}class De{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,q,Y,_,fe){this.f=W,this.g=q,this.h=Y,this.j=_,this.k=fe,this.d=new i.$noc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,q,Y,_){const fe=this.f.getDocument(W),be=n.Position.to(q),Ne=fe.getWordRangeAtPosition(be)||new o.$yN(be,be),Ge=Ne.with({end:be}),Ke=new a.$he,tt=await this.h.provideCompletionItems(fe,be,_,n.CompletionContext.to(Y));if(!tt||_.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.$6N(tt):tt,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new R.$Wc;this.e.set(ot,nt);const at=[],mt={x:ot,[r.ISuggestResultDtoField.completions]:at,[r.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ne),insert:n.Range.from(Ge)},[r.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[r.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const ct=rt.items[ht],Ie=this.l(ct,[ot,ht],Ge,Ne);at.push(Ie)}return mt}async resolveCompletionItem(W,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...W);if(!Y)return;const _=this.l(Y,W),fe=await this.h.resolveCompletionItem(Y,q);if(!fe)return;const be=this.l(fe,W);return(_[r.ISuggestDataDtoField.insertText]!==be[r.ISuggestDataDtoField.insertText]||_[r.ISuggestDataDtoField.insertTextRules]!==be[r.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(_[r.ISuggestDataDtoField.commandIdent]!==be[r.ISuggestDataDtoField.commandIdent]||_[r.ISuggestDataDtoField.commandId]!==be[r.ISuggestDataDtoField.commandId]||!(0,$.$io)(_[r.ISuggestDataDtoField.commandArguments],be[r.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{..._,[r.ISuggestDataDtoField.documentation]:be[r.ISuggestDataDtoField.documentation],[r.ISuggestDataDtoField.detail]:be[r.ISuggestDataDtoField.detail],[r.ISuggestDataDtoField.additionalTextEdits]:be[r.ISuggestDataDtoField.additionalTextEdits],[r.ISuggestDataDtoField.insertText]:be[r.ISuggestDataDtoField.insertText],[r.ISuggestDataDtoField.insertTextRules]:be[r.ISuggestDataDtoField.insertTextRules],[r.ISuggestDataDtoField.commandIdent]:be[r.ISuggestDataDtoField.commandIdent],[r.ISuggestDataDtoField.commandId]:be[r.ISuggestDataDtoField.commandId],[r.ISuggestDataDtoField.commandArguments]:be[r.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,q,Y,_){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const be=this.g.toInternal(W.command,fe),Ne={x:q,[r.ISuggestDataDtoField.label]:W.label,[r.ISuggestDataDtoField.kind]:W.kind!==void 0?n.CompletionItemKind.from(W.kind):void 0,[r.ISuggestDataDtoField.kindModifier]:W.tags&&W.tags.map(n.CompletionItemTag.from),[r.ISuggestDataDtoField.detail]:W.detail,[r.ISuggestDataDtoField.documentation]:typeof W.documentation>"u"?void 0:n.MarkdownString.fromStrict(W.documentation),[r.ISuggestDataDtoField.sortText]:W.sortText!==W.label?W.sortText:void 0,[r.ISuggestDataDtoField.filterText]:W.filterText!==W.label?W.filterText:void 0,[r.ISuggestDataDtoField.preselect]:W.preselect||void 0,[r.ISuggestDataDtoField.insertTextRules]:W.keepWhitespace?c.CompletionItemInsertTextRule.KeepWhitespace:c.CompletionItemInsertTextRule.None,[r.ISuggestDataDtoField.commitCharacters]:W.commitCharacters?.join(""),[r.ISuggestDataDtoField.additionalTextEdits]:W.additionalTextEdits&&W.additionalTextEdits.map(n.TextEdit.from),[r.ISuggestDataDtoField.commandIdent]:be?.$ident,[r.ISuggestDataDtoField.commandId]:be?.id,[r.ISuggestDataDtoField.commandArguments]:be?.$ident?void 0:be?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[r.ISuggestDataDtoField.insertText]=W.textEdit.newText):typeof W.insertText=="string"?Ne[r.ISuggestDataDtoField.insertText]=W.insertText:W.insertText instanceof o.$HN&&(Ne[r.ISuggestDataDtoField.insertText]=W.insertText.value,Ne[r.ISuggestDataDtoField.insertTextRules]|=c.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return W.textEdit?Ge=W.textEdit.range:W.range&&(Ge=W.range),o.$yN.isRange(Ge)?Ne[r.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!Y?.isEqual(Ge.inserting)||!_?.isEqual(Ge.replacing))&&(Ne[r.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Ne}}class $e{async provideInlineCompletions(W,q,Y,_){}async provideInlineEdits(W,q,Y,_){}disposeCompletions(W){}handleDidShowCompletionItem(W,q,Y){}handlePartialAccept(W,q,Y,_){}}class J extends $e{constructor(W,q,Y,_){super(),this.f=W,this.g=q,this.h=Y,this.j=_,this.d=new se,this.e=(0,t.$6G)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$6G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,q,Y,_){const fe=this.g.getDocument(W),be=n.Position.to(q),Ne=await this.h.provideInlineCompletionItems(fe,be,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},_);if(!Ne||_.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new R.$Wc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new R.$Wc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}async provideInlineEdits(W,q,Y,_){if(!this.h.provideInlineEdits)return;(0,t.$7G)(this.f,"inlineCompletionsAdditions");const fe=this.g.getDocument(W),be=n.Range.to(q),Ne=await this.h.provideInlineEdits(fe,be,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind],userPrompt:Y.userPrompt},_);if(!Ne||_.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new R.$Wc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new R.$Wc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,q,Y){const _=this.d.get(W)?.items[q];_&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(_,Y)}handlePartialAccept(W,q,Y,_){const fe=this.d.get(W)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Y),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(_)))}}class U{async provideInlineEdits(W,q,Y){const _=this.f.getDocument(W),fe=await this.g.provideInlineEdit(_,{triggerKind:this.e[q.triggerKind]},Y);if(!fe||Y.isCancellationRequested)return;let be;const Ne=this.d.createReferenceId({dispose(){be?.dispose()},item:fe});let Ge;fe.accepted&&(be||(be=new R.$Wc),Ge=this.h.toInternal(fe.accepted,be));let Ke;return fe.rejected&&(be||(be=new R.$Wc),Ke=this.h.toInternal(fe.rejected,be)),{pid:Ne,text:fe.text,range:n.Range.from(fe.range),accepted:Ge,rejected:Ke}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,q,Y,_){this.f=q,this.g=Y,this.h=_,this.d=new se,this.e={[c.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const q=this.e++;return this.d.set(q,W),q}disposeReferenceId(W){const q=this.d.get(W);return this.d.delete(W),q}get(W){return this.d.get(W)}}class ae{constructor(W,q){this.e=W,this.f=q,this.d=new i.$noc("SignatureHelp")}async provideSignatureHelp(W,q,Y,_){const fe=this.e.getDocument(W),be=n.Position.to(q),Ne=this.g(Y),Ge=await this.f.provideSignatureHelp(fe,be,_,Ne);if(Ge){const Ke=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Ke}}}g(W){let q;if(W.activeSignatureHelp){const Y=n.SignatureHelp.to(W.activeSignatureHelp),_=this.d.get(W.activeSignatureHelp.id,0);_?(q=_,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...W,activeSignatureHelp:q}}releaseSignatureHelp(W){this.d.delete(W)}}class te{constructor(W,q,Y,_,fe){this.f=W,this.g=q,this.h=Y,this.j=_,this.k=fe,this.d=new i.$noc("InlayHints"),this.e=new Map}async provideInlayHints(W,q,Y){const _=this.f.getDocument(W),fe=n.Range.to(q),be=await this.h.provideInlayHints(_,fe,Y);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Y.isCancellationRequested)return;const Ne=this.d.add(be);this.e.set(Ne,new R.$Wc);const Ge={hints:[],cacheId:Ne};for(let Ke=0;Ke<be.length;Ke++)this.l(be[Ke],fe)&&Ge.hints.push(this.m(be[Ke],[Ne,Ke]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Ge}async resolveInlayHint(W,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...W);if(!Y)return;const _=await this.h.resolveInlayHint(Y,q);if(_&&this.l(_))return this.m(_,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,q){return W.label.length===0||Array.isArray(W.label)&&W.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(q&&!q.contains(W.position))}m(W,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const _={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(W.tooltip),position:n.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(n.TextEdit.from),kind:W.kind&&n.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")_.label=W.label;else{const fe=[];_.label=fe;for(const be of W.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:be.value,tooltip:n.MarkdownString.fromStrict(be.tooltip)};o.$IN.isLocation(be.location)&&(Ne.location=n.location.from(be.location)),be.command&&(Ne.command=this.g.toInternal(be.command,Y)),fe.push(Ne)}}return _}}class le{constructor(W,q){this.e=W,this.f=q,this.d=new i.$noc("DocumentLink")}async provideLinks(W,q){const Y=this.e.getDocument(W),_=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(_)||_.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(_),be={links:[],cacheId:fe};for(let Ne=0;Ne<_.length;Ne++){if(!le.g(_[Ne]))continue;const Ge=n.DocumentLink.from(_[Ne]);Ge.cacheId=[fe,Ne],be.links.push(Ge)}return be}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...W);if(!Y)return;const _=await this.f.resolveDocumentLink(Y,q);if(!(!_||!le.g(_)))return n.DocumentLink.from(_)}releaseLinks(W){this.d.delete(W)}}class ue{constructor(W,q){this.d=W,this.e=q}async provideColors(W,q){const Y=this.d.getDocument(W),_=await this.e.provideDocumentColors(Y,q);return Array.isArray(_)?_.map(be=>({color:n.Color.from(be.color),range:n.Range.from(be.range)})):[]}async provideColorPresentations(W,q,Y){const _=this.d.getDocument(W),fe=n.Range.to(q.range),be=n.Color.to(q.color),Ne=await this.e.provideColorPresentations(be,{document:_,range:fe},Y);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class Z{constructor(W,q){this.d=W,this.e=q}async provideFoldingRanges(W,q,Y){const _=this.d.getDocument(W),fe=await this.e.provideFoldingRanges(_,q,Y);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(W,q,Y){this.d=W,this.e=q,this.f=Y}async provideSelectionRanges(W,q,Y){const _=this.d.getDocument(W),fe=q.map(n.Position.to),be=await this.e.provideSelectionRanges(_,fe,Y);if(!(0,s.$Ob)(be))return[];if(be.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ge=0;Ge<fe.length;Ge++){const Ke=[];Ne.push(Ke);let tt=fe[Ge],rt=be[Ge];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Ne}}class pe{constructor(W,q){this.f=W,this.g=q,this.d=new L.$6P(""),this.e=new Map}async prepareSession(W,q,Y){const _=this.f.getDocument(W),fe=n.Position.to(q),be=await this.g.prepareCallHierarchy(_,fe,Y);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideCallsTo(W,q,Y){const _=this.j(W,q);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(_,Y);if(fe)return fe.map(be=>({from:this.h(W,be.from),fromRanges:be.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(W,q,Y){const _=this.j(W,q);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(_,Y);if(fe)return fe.map(be=>({to:this.h(W,be.to),fromRanges:be.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(W){this.e.delete(W)}h(W,q){const Y=this.e.get(W),_=n.CallHierarchyItem.from(q,W,Y.size.toString(36));return Y.set(_._itemId,q),_}j(W,q){return this.e.get(W)?.get(q)}}class we{constructor(W,q){this.f=W,this.g=q,this.d=new L.$6P(""),this.e=new Map}async prepareSession(W,q,Y){const _=this.f.getDocument(W),fe=n.Position.to(q),be=await this.g.prepareTypeHierarchy(_,fe,Y);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideSupertypes(W,q,Y){const _=this.j(W,q);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(_,Y);if(fe)return fe.map(be=>this.h(W,be))}async provideSubtypes(W,q,Y){const _=this.j(W,q);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(_,Y);if(fe)return fe.map(be=>this.h(W,be))}releaseSession(W){this.e.delete(W)}h(W,q){const Y=this.e.get(W),_=n.TypeHierarchyItem.from(q,W,Y.size.toString(36));return Y.set(_._itemId,q),_}j(W,q){return this.e.get(W)?.get(q)}}class Fe{constructor(W,q,Y,_,fe){this.e=W,this.f=q,this.g=Y,this.h=_,this.j=fe,this.d=new i.$noc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,q,Y,_,fe){const be=this.f.getDocument(q),Ne=n.Position.to(Y),Ge=n.DataTransfer.toDataTransfer(_,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,ot)).buffer),Ke=await this.g.provideDocumentDropEdits(be,Ne,Ge,fe);if(!Ke)return;const tt=(0,s.$5b)(Ke),rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,q){const[Y,_]=W,fe=this.d.get(Y,_);if(!fe||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class Ue{constructor(W,q){this.d=W,this.e=q}async provideMappedEdits(W,q,Y,_){const fe=l.URI.revive(W),be=this.d.getDocument(fe),Ne=Y.documents.map(tt=>tt.map(rt=>({uri:l.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ge={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(be,q,Ge,_);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(W,q){this.adapter=W,this.extension=q}}class Pe{static{this.d=0}constructor(W,q,Y,_,fe,be,Ne,Ge){this.g=q,this.h=Y,this.j=_,this.k=fe,this.l=be,this.m=Ne,this.n=Ge,this.f=new Map,this.e=W.getProxy(r.$uN.MainThreadLanguageFeatures)}o(W,q){return n.DocumentSelector.from(W,this.g,q)}p(W){return new o.$wN(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Pe.d++}async s(W,q,Y,_,fe,be=!1){const Ne=this.f.get(W);if(!Ne||!(Ne.adapter instanceof q))return _;const Ge=Date.now();be||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Ke=Y(Ne.adapter,Ne.extension);return Promise.resolve(Ke).catch(tt=>{(0,T.$7)(tt)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Ne.extension.identifier,tt))}).finally(()=>{be||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),I.CancellationToken.isCancellationToken(fe)?(0,h.$vh)(Ke,fe):Ke}t(W,q){const Y=this.q();return this.f.set(Y,new ke(W,q)),Y}static u(W){return W.displayName||W.name}static w(W){return W.identifier.value}registerDocumentSymbolProvider(W,q,Y,_){const fe=this.t(new f(this.h,Y),W),be=_&&_.label||Pe.u(W);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,W),be),this.p(fe)}$provideDocumentSymbols(W,q,Y){return this.s(W,f,_=>_.provideDocumentSymbols(l.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(W,q,Y){const _=this.q(),fe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new ke(new u(this.h,this.j.converter,Y,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(_,this.o(q,W),fe);let be=this.p(_);if(fe!==void 0){const Ne=Y.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(fe));be=o.$wN.from(be,Ne)}return be}$provideCodeLenses(W,q,Y){return this.s(W,u,_=>_.provideCodeLenses(l.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(W,q,Y){return this.s(W,u,_=>_.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(W,q){this.s(W,u,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(W,q,Y){const _=this.t(new S(this.h,Y),W);return this.e.$registerDefinitionSupport(_,this.o(q,W)),this.p(_)}$provideDefinition(W,q,Y,_){return this.s(W,S,fe=>fe.provideDefinition(l.URI.revive(q),Y,_),[],_)}registerDeclarationProvider(W,q,Y){const _=this.t(new D(this.h,Y),W);return this.e.$registerDeclarationSupport(_,this.o(q,W)),this.p(_)}$provideDeclaration(W,q,Y,_){return this.s(W,D,fe=>fe.provideDeclaration(l.URI.revive(q),Y,_),[],_)}registerImplementationProvider(W,q,Y){const _=this.t(new y(this.h,Y),W);return this.e.$registerImplementationSupport(_,this.o(q,W)),this.p(_)}$provideImplementation(W,q,Y,_){return this.s(W,y,fe=>fe.provideImplementation(l.URI.revive(q),Y,_),[],_)}registerTypeDefinitionProvider(W,q,Y){const _=this.t(new C(this.h,Y),W);return this.e.$registerTypeDefinitionSupport(_,this.o(q,W)),this.p(_)}$provideTypeDefinition(W,q,Y,_){return this.s(W,C,fe=>fe.provideTypeDefinition(l.URI.revive(q),Y,_),[],_)}registerHoverProvider(W,q,Y,_){const fe=this.t(new A(this.h,Y),W);return this.e.$registerHoverProvider(fe,this.o(q,W)),this.p(fe)}$provideHover(W,q,Y,_,fe){return this.s(W,A,be=>be.provideHover(l.URI.revive(q),Y,_,fe),void 0,fe)}$releaseHover(W,q){this.s(W,A,Y=>Promise.resolve(Y.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(W,q,Y,_){const fe=this.t(new p(this.h,Y),W);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,W)),this.p(fe)}$provideEvaluatableExpression(W,q,Y,_){return this.s(W,p,fe=>fe.provideEvaluatableExpression(l.URI.revive(q),Y,_),void 0,_)}registerInlineValuesProvider(W,q,Y,_){const fe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new v(this.h,Y),W);this.e.$registerInlineValuesProvider(be,this.o(q,W),fe);let Ne=this.p(be);if(fe!==void 0){const Ge=Y.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(fe));Ne=o.$wN.from(Ne,Ge)}return Ne}$provideInlineValues(W,q,Y,_,fe){return this.s(W,v,be=>be.provideInlineValues(l.URI.revive(q),Y,_,fe),void 0,fe)}registerDocumentHighlightProvider(W,q,Y){const _=this.t(new F(this.h,Y),W);return this.e.$registerDocumentHighlightProvider(_,this.o(q,W)),this.p(_)}registerMultiDocumentHighlightProvider(W,q,Y){const _=this.t(new N(this.h,Y),W);return this.e.$registerMultiDocumentHighlightProvider(_,this.o(q,W)),this.p(_)}$provideDocumentHighlights(W,q,Y,_){return this.s(W,F,fe=>fe.provideDocumentHighlights(l.URI.revive(q),Y,_),void 0,_)}$provideMultiDocumentHighlights(W,q,Y,_,fe){return this.s(W,N,be=>be.provideMultiDocumentHighlights(l.URI.revive(q),Y,_.map(Ne=>l.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(W,q,Y){const _=this.t(new O(this.h,Y),W);return this.e.$registerLinkedEditingRangeProvider(_,this.o(q,W)),this.p(_)}$provideLinkedEditingRanges(W,q,Y,_){return this.s(W,O,async fe=>{const be=await fe.provideLinkedEditingRanges(l.URI.revive(q),Y,_);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Pe.y(be.wordPattern):void 0}},void 0,_)}registerReferenceProvider(W,q,Y){const _=this.t(new j(this.h,Y),W);return this.e.$registerReferenceSupport(_,this.o(q,W)),this.p(_)}$provideReferences(W,q,Y,_,fe){return this.s(W,j,be=>be.provideReferences(l.URI.revive(q),Y,_,fe),void 0,fe)}registerCodeActionProvider(W,q,Y,_){const fe=new R.$Wc,be=this.t(new z(this.h,this.j.converter,this.k,Y,this.l,W,this.m),W);return this.e.$registerCodeActionSupport(be,this.o(q,W),{providedKinds:_?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:_?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,fe)}))},Pe.u(W),Pe.w(W),!!Y.resolveCodeAction),fe.add(this.p(be)),fe}$provideCodeActions(W,q,Y,_,fe){return this.s(W,z,be=>be.provideCodeActions(l.URI.revive(q),Y,_,fe),void 0,fe)}$resolveCodeAction(W,q,Y){return this.s(W,z,_=>_.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(W,q){this.s(W,z,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(W,q,Y){const _=this.t(new V(this.h,Y),W);return this.e.$registerDocumentFormattingSupport(_,this.o(q,W),W.identifier,W.displayName||W.name),this.p(_)}$provideDocumentFormattingEdits(W,q,Y,_){return this.s(W,V,fe=>fe.provideDocumentFormattingEdits(l.URI.revive(q),Y,_),void 0,_)}registerDocumentRangeFormattingEditProvider(W,q,Y){const _=typeof Y.provideDocumentRangesFormattingEdits=="function",fe=this.t(new K(this.h,Y),W);return this.e.$registerRangeFormattingSupport(fe,this.o(q,W),W.identifier,W.displayName||W.name,_),this.p(fe)}$provideDocumentRangeFormattingEdits(W,q,Y,_,fe){return this.s(W,K,be=>be.provideDocumentRangeFormattingEdits(l.URI.revive(q),Y,_,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(W,q,Y,_,fe){return this.s(W,K,be=>be.provideDocumentRangesFormattingEdits(l.URI.revive(q),Y,_,fe),void 0,fe)}registerOnTypeFormattingEditProvider(W,q,Y,_){const fe=this.t(new re(this.h,Y),W);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,W),_,W.identifier),this.p(fe)}$provideOnTypeFormattingEdits(W,q,Y,_,fe,be){return this.s(W,re,Ne=>Ne.provideOnTypeFormattingEdits(l.URI.revive(q),Y,_,fe,be),void 0,be)}registerWorkspaceSymbolProvider(W,q){const Y=this.t(new B(q,this.l),W);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(W,q,Y){return this.s(W,B,_=>_.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(W,q,Y){return this.s(W,B,_=>_.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(W,q){this.s(W,B,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(W,q,Y){const _=this.t(new G(this.h,Y,this.l),W);return this.e.$registerRenameSupport(_,this.o(q,W),G.supportsResolving(Y)),this.p(_)}$provideRenameEdits(W,q,Y,_,fe){return this.s(W,G,be=>be.provideRenameEdits(l.URI.revive(q),Y,_,fe),void 0,fe)}$resolveRenameLocation(W,q,Y,_){return this.s(W,G,fe=>fe.resolveRenameLocation(l.URI.revive(q),Y,_),void 0,_)}registerNewSymbolNamesProvider(W,q,Y){const _=this.t(new X(this.h,Y,this.l),W);return this.e.$registerNewSymbolNamesProvider(_,this.o(q,W)),this.p(_)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,X,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,q,Y,_,fe){return this.s(W,X,be=>be.provideNewSymbolNames(l.URI.revive(q),Y,_,fe),void 0,fe)}registerDocumentSemanticTokensProvider(W,q,Y,_){const fe=this.t(new de(this.h,Y),W),be=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,W),_,be);let Ne=this.p(fe);if(be){const Ge=Y.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(be));Ne=o.$wN.from(Ne,Ge)}return Ne}$provideDocumentSemanticTokens(W,q,Y,_){return this.s(W,de,fe=>fe.provideDocumentSemanticTokens(l.URI.revive(q),Y,_),null,_)}$releaseDocumentSemanticTokens(W,q){this.s(W,de,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,q,Y,_){const fe=this.t(new ne(this.h,Y),W);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,W),_),this.p(fe)}$provideDocumentRangeSemanticTokens(W,q,Y,_){return this.s(W,ne,fe=>fe.provideDocumentRangeSemanticTokens(l.URI.revive(q),Y,_),null,_)}registerCompletionItemProvider(W,q,Y,_){const fe=this.t(new De(this.h,this.j.converter,Y,this.m,W),W);return this.e.$registerCompletionsProvider(fe,this.o(q,W),_,De.supportsResolving(Y),W.identifier),this.p(fe)}$provideCompletionItems(W,q,Y,_,fe){return this.s(W,De,be=>be.provideCompletionItems(l.URI.revive(q),Y,_,fe),void 0,fe)}$resolveCompletionItem(W,q,Y){return this.s(W,De,_=>_.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(W,q){this.s(W,De,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(W,q,Y,_){const fe=new J(W,this.h,Y,this.j.converter),be=this.t(fe,W);return this.e.$registerInlineCompletionsSupport(be,this.o(q,W),fe.supportsHandleEvents,g.$rn.toKey(W.identifier.value),_?.yieldTo?.map(Ne=>g.$rn.toKey(Ne))||[]),this.p(be)}$provideInlineCompletions(W,q,Y,_,fe){return this.s(W,$e,be=>be.provideInlineCompletions(l.URI.revive(q),Y,_,fe),void 0,fe)}$provideInlineEdits(W,q,Y,_,fe){return this.s(W,$e,be=>be.provideInlineEdits(l.URI.revive(q),Y,_,fe),void 0,fe)}$handleInlineCompletionDidShow(W,q,Y,_){this.s(W,$e,async fe=>{fe.handleDidShowCompletionItem(q,Y,_)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,q,Y,_,fe){this.s(W,$e,async be=>{be.handlePartialAccept(q,Y,_,fe)},void 0,void 0)}$freeInlineCompletionsList(W,q){this.s(W,$e,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(W,q,Y){const _=new U(W,this.h,Y,this.j.converter),fe=this.t(_,W);return this.e.$registerInlineEditProvider(fe,this.o(q,W),W.identifier),this.p(fe)}$provideInlineEdit(W,q,Y,_){return this.s(W,U,fe=>fe.provideInlineEdits(l.URI.revive(q),Y,_),void 0,_)}$freeInlineEdit(W,q){this.s(W,U,async Y=>{Y.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(W,q,Y,_){const fe=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,be=this.t(new ae(this.h,Y),W);return this.e.$registerSignatureHelpProvider(be,this.o(q,W),fe),this.p(be)}$provideSignatureHelp(W,q,Y,_,fe){return this.s(W,ae,be=>be.provideSignatureHelp(l.URI.revive(q),Y,_,fe),void 0,fe)}$releaseSignatureHelp(W,q){this.s(W,ae,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(W,q,Y){const _=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,Y,this.l,W),W);this.e.$registerInlayHintsProvider(fe,this.o(q,W),typeof Y.resolveInlayHint=="function",_,Pe.u(W));let be=this.p(fe);if(_!==void 0){const Ne=Y.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(_));be=o.$wN.from(be,Ne)}return be}$provideInlayHints(W,q,Y,_){return this.s(W,te,fe=>fe.provideInlayHints(l.URI.revive(q),Y,_),void 0,_)}$resolveInlayHint(W,q,Y){return this.s(W,te,_=>_.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(W,q){this.s(W,te,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(W,q,Y){const _=this.t(new le(this.h,Y),W);return this.e.$registerDocumentLinkProvider(_,this.o(q,W),typeof Y.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(W,q,Y){return this.s(W,le,_=>_.provideLinks(l.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(W,q,Y){return this.s(W,le,_=>_.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(W,q){this.s(W,le,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(W,q,Y){const _=this.t(new ue(this.h,Y),W);return this.e.$registerDocumentColorProvider(_,this.o(q,W)),this.p(_)}$provideDocumentColors(W,q,Y){return this.s(W,ue,_=>_.provideColors(l.URI.revive(q),Y),[],Y)}$provideColorPresentations(W,q,Y,_){return this.s(W,ue,fe=>fe.provideColorPresentations(l.URI.revive(q),Y,_),void 0,_)}registerFoldingRangeProvider(W,q,Y){const _=this.q(),fe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new ke(new Z(this.h,Y),W)),this.e.$registerFoldingRangeProvider(_,this.o(q,W),W.identifier,fe);let be=this.p(_);if(fe!==void 0){const Ne=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));be=o.$wN.from(be,Ne)}return be}$provideFoldingRanges(W,q,Y,_){return this.s(W,Z,fe=>fe.provideFoldingRanges(l.URI.revive(q),Y,_),void 0,_)}registerSelectionRangeProvider(W,q,Y){const _=this.t(new oe(this.h,Y,this.l),W);return this.e.$registerSelectionRangeProvider(_,this.o(q,W)),this.p(_)}$provideSelectionRanges(W,q,Y,_){return this.s(W,oe,fe=>fe.provideSelectionRanges(l.URI.revive(q),Y,_),[],_)}registerCallHierarchyProvider(W,q,Y){const _=this.t(new pe(this.h,Y),W);return this.e.$registerCallHierarchyProvider(_,this.o(q,W)),this.p(_)}$prepareCallHierarchy(W,q,Y,_){return this.s(W,pe,fe=>Promise.resolve(fe.prepareSession(l.URI.revive(q),Y,_)),void 0,_)}$provideCallHierarchyIncomingCalls(W,q,Y,_){return this.s(W,pe,fe=>fe.provideCallsTo(q,Y,_),void 0,_)}$provideCallHierarchyOutgoingCalls(W,q,Y,_){return this.s(W,pe,fe=>fe.provideCallsFrom(q,Y,_),void 0,_)}$releaseCallHierarchy(W,q){this.s(W,pe,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(W,q,Y){const _=this.t(new we(this.h,Y),W);return this.e.$registerTypeHierarchyProvider(_,this.o(q,W)),this.p(_)}$prepareTypeHierarchy(W,q,Y,_){return this.s(W,we,fe=>Promise.resolve(fe.prepareSession(l.URI.revive(q),Y,_)),void 0,_)}$provideTypeHierarchySupertypes(W,q,Y,_){return this.s(W,we,fe=>fe.provideSupertypes(q,Y,_),void 0,_)}$provideTypeHierarchySubtypes(W,q,Y,_){return this.s(W,we,fe=>fe.provideSubtypes(q,Y,_),void 0,_)}$releaseTypeHierarchy(W,q){this.s(W,we,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(W,q,Y,_){const fe=this.q();return this.f.set(fe,new ke(new Fe(this.e,this.h,Y,fe,W),W)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,W),(0,t.$6G)(W,"documentPaste")&&_?{supportsResolve:!!Y.resolveDocumentDropEdit,dropMimeTypes:_.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(W,q,Y,_,fe,be){return this.s(W,Fe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(q,l.URI.revive(Y),_,fe,be)),void 0,void 0)}$resolveDropEdit(W,q,Y){return this.s(W,Fe,_=>_.resolveDropEdit(q,Y),{},void 0)}$releaseDocumentOnDropEdits(W,q){this.s(W,Fe,Y=>Promise.resolve(Y.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(W,q,Y){const _=this.t(new Ue(this.h,Y),W);return this.e.$registerMappedEditsProvider(_,this.o(q,W)),this.p(_)}$provideMappedEdits(W,q,Y,_,fe){return this.s(W,Ue,be=>Promise.resolve(be.provideMappedEdits(q,Y,_,fe)),null,fe)}registerDocumentPasteEditProvider(W,q,Y,_){const fe=this.q();return this.f.set(fe,new ke(new M(this.e,this.h,Y,fe,W),W)),this.e.$registerPasteEditProvider(fe,this.o(q,W),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:_.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:_.copyMimeTypes,pasteMimeTypes:_.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(W,q,Y,_,fe){return this.s(W,M,be=>be.prepareDocumentPaste(l.URI.revive(q),Y,_,fe),void 0,fe)}$providePasteEdits(W,q,Y,_,fe,be,Ne){return this.s(W,M,Ge=>Ge.providePasteEdits(q,l.URI.revive(Y),_,fe,be,Ne),void 0,Ne)}$resolvePasteEdit(W,q,Y){return this.s(W,M,_=>_.resolvePasteEdit(q,Y),{},void 0)}$releasePasteEdits(W,q){this.s(W,M,Y=>Promise.resolve(Y.releasePasteEdits(q)),void 0,void 0)}static y(W){return{pattern:W.source,flags:W.flags}}static z(W){return{decreaseIndentPattern:Pe.y(W.decreaseIndentPattern),increaseIndentPattern:Pe.y(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Pe.y(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Pe.y(W.unIndentedLinePattern):void 0}}static B(W){return{beforeText:Pe.y(W.beforeText),afterText:W.afterText?Pe.y(W.afterText):void 0,previousLineText:W.previousLineText?Pe.y(W.previousLineText):void 0,action:W.action}}static C(W){return W.map(Pe.B)}static D(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(W){return W.map(Pe.D)}setLanguageConfiguration(W,q,Y){const{wordPattern:_}=Y;if(_&&(0,k.$tf)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(q,_):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const fe=this.q(),be={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Pe.y(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Pe.z(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Pe.C(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Pe.E(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,be),this.p(fe)}$setWordDefinitions(W){for(const q of W)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$xoc=Pe}),define(Ee[356],Se([1,0,3,6,16]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,I=We(I);class T{constructor(R){this.a=new Map,this.c=new Map,this.b=R.getProxy(h.$uN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const a of $)this.c.set(a.name,a)})}async invokeTool(R,$,a){return await this.b.$invokeTool(R,$,a)}async $acceptToolDelta(R){R.added&&this.c.set(R.added.name,R.added),R.removed&&this.c.delete(R.removed)}get tools(){return Array.from(this.c.values()).map(R=>I.LanguageModelToolDescription.to(R))}async $invokeTool(R,$,a){const k=this.a.get(R);if(!k)throw new Error(`Unknown tool ${R}`);return await k.tool.invoke($,a)}registerTool(R,$,a){return this.a.set($,{extension:R,tool:a}),this.b.$registerTool($),(0,s.$Vc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$2pc=T}),define(Ee[129],Se([1,0,9,21,51,14,4,40,3,237,24,5,12,90,6,128,20,16,10,156,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0,d=We(d),g=We(g),e.$epc=(0,E.$Gi)("IExtHostLanguageModels");class i{constructor(w,S){this.option=w,this.stream=new s.$0h,this.stream=S??new s.$0h}}class r{constructor(){this.a=new Map,this.b=new s.$0h,this.c=!1;const w=this;this.apiObject={get stream(){return w.b.asyncIterable},get text(){return s.$7h.map(w.b.asyncIterable,S=>{if(S instanceof g.$KP)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,w]of this.a)yield w.stream;else yield this.b}handleFragment(w){if(this.c)return;let S=this.a.get(w.index);S||(this.a.size===0?S=new i(w.index,this.b):S=new i(w.index),this.a.set(w.index,S));let D;w.part.type==="text"?D=new g.$KP(w.part.value):D=new g.$JP(w.part.name,w.part.parameters),S.stream.emitOne(D)}reject(w){this.c=!0;for(const S of this.d())S.reject(w)}resolve(){this.c=!0;for(const w of this.d())w.resolve()}}let f=class{static{t=this}static{this.a=1}constructor(w,S,D){this.j=S,this.k=D,this.c=new L.$ne,this.d=new L.$ne,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new k.$tn,this.i=new Map,this.s=new Set,this.b=w.getProxy(b.$uN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(w,S,D,y){const C=t.a++;this.f.set(C,{extension:w.identifier,provider:D,languageModelId:S});let A;y.auth&&(A={providerLabel:w.displayName||w.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${k.$rn.toKey(w.identifier)}/${C}/${S}`,{extension:w.identifier,id:S,vendor:y.vendor??k.$rn.toKey(w.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:A,targetExtensions:y.extensions});const p=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(S,new k.$rn(v),F,N)});return(0,$.$Vc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),p?.dispose()})}async $startChatRequest(w,S,D,y,C,A){const p=this.f.get(w);if(!p)throw new Error("Provider not found");const v=new P.$ww(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof g.$JP?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof g.$KP&&(O={type:"text",value:N.part.value}),!O){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(S,{index:N.index,part:O})});let F;if(p.provider.provideLanguageModelResponse2)F=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map(d.LanguageModelChatMessage.to),C,k.$rn.toKey(D),v,A));else{const N=new P.$ww(async O=>{v.report({index:O.index,part:new g.$KP(O.part)})});F=Promise.resolve(p.provider.provideLanguageModelResponse(y.map(d.LanguageModelChatMessage.to),C?.modelOptions??{},k.$rn.toKey(D),N,A))}F.then(()=>{this.b.$reportResponseDone(S,void 0)},N=>{this.b.$reportResponseDone(S,(0,T.$5)(N))})}$provideTokenLength(w,S,D){const y=this.f.get(w);return y?Promise.resolve(y.provider.provideTokenCount(S,D)):Promise.resolve(0)}$acceptChatModelMetadata(w){if(w.added)for(const{identifier:S,metadata:D}of w.added)this.g.set(S,{metadata:D,apiObjects:new k.$tn});if(w.removed)for(const S of w.removed){this.g.delete(S);for(const[D,y]of this.i)y.languageModelId===S&&(y.res.reject(new T.$8),this.i.delete(D))}w.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(w,S){const D=await this.b.$selectChatModels({...S,extension:w.identifier}),y=[],C=this;for(const A of D){const p=this.g.get(A);if(!p)continue;this.o(w.identifier,p.metadata)&&await this.q(p.metadata);let v=p.apiObjects.get(w.identifier);v||(v={id:A,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(F,N){if(!C.g.has(A))throw g.$OP.NotFound(A);return C.r(A,F,N??h.CancellationToken.None)},sendRequest(F,N,O){if(!C.g.has(A))throw g.$OP.NotFound(A);return C.l(w,A,F,N??{},O??h.CancellationToken.None)}},Object.freeze(v),p.apiObjects.set(w.identifier,v)),y.push(v)}return y}async l(w,S,D,y,C){const A=this.m(w,D),p=w.identifier,v=this.g.get(S)?.metadata;if(!v||!this.g.has(S))throw g.$OP.NotFound(`Language model '${S}' is unknown.`);if(this.o(p,v)&&(!await this.n(w,{identifier:v.extension,displayName:v.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(v.extension)))throw g.$OP.NoPermissions(`Language model '${S}' cannot be used by '${p.value}'.`);try{const F=Math.random()*1e6|0,N=new r;this.i.set(F,{languageModelId:S,res:N});try{await this.b.$tryStartChatRequest(p,S,F,A,y,C)}catch(O){throw this.i.delete(F),O}return N.apiObject}catch(F){throw F.name===g.$OP.name?F:new g.$OP(`Language model '${S}' errored: ${(0,I.$rj)(F)}`,"Unknown",F)}}m(w,S){const D=[];for(const y of S)y.role===g.LanguageModelChatMessageRole.System&&(0,o.$7G)(w,"languageModelSystem"),y.content2 instanceof g.$HP&&(0,o.$7G)(w,"lmTools"),D.push(d.LanguageModelChatMessage.from(y));return D}async $acceptResponsePart(w,S){const D=this.i.get(w);D&&D.res.handleFragment(S)}async $acceptResponseDone(w,S){const D=this.i.get(w);D&&(this.i.delete(w),S?D.res.reject((0,T.$6)(S)):D.res.resolve())}async n(w,S,D,y){const C=n.$wM+S.identifier.value;if(await this.k.getSession(w,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:w.identifier,to:S.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=D?(0,a.localize)(0,null,S.displayName,D):void 0;return await this.k.getSession(w,C,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:w.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(w,S){return!!S.auth&&!k.$rn.equals(S.extension,w)}async q(w){if(w.auth)for(const S of this.s)try{await this.n(S,{identifier:w.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(w,S,D){if(!this.g.get(w))throw g.$OP.NotFound(`Language model '${w}' is unknown.`);const C=R.Iterable.find(this.f.values(),A=>A.languageModelId===w);return C?C.provider.provideTokenCount(S,D):this.b.$countTokens(w,typeof S=="string"?S:d.LanguageModelChatMessage.from(S),D)}$updateModelAccesslist(w){const S=new Array;for(const{from:D,to:y,enabled:C}of w){const A=this.h.get(D)??new k.$sn;if(A.has(y)!==C){C?A.add(y):A.delete(y),this.h.set(D,A);const v={from:D,to:y};S.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(w){this.s.add(w);const S=this,D=L.Event.signal(L.Event.filter(this.c.event,C=>k.$rn.equals(C.from,w.identifier))),y=L.Event.signal(this.d.event);return{get onDidChange(){return L.Event.any(D,y)},canSendRequest(C){let A;e:for(const[v,F]of S.g)for(const N of F.apiObjects.values())if(N===C){A=F.metadata;break e}if(!A)return;if(!S.o(w.identifier,A))return!0;const p=S.h.get(w.identifier);if(p)return p.has(A.extension)}}}};e.$fpc=f,e.$fpc=f=t=Xe([Ve(0,m.$1P),Ve(1,l.$ak),Ve(2,c.$zoc)],f)});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[357],Se([1,0,6,16,10,44,9,3,26]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0,h=We(h),T=jt(T);class a{constructor(E,l,P,b){this.c=l,this.d=P,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(s.$uN.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,l){await this.a.$changeLanguage(E,l);const P=this.c.getDocumentData(E);if(!P)throw new Error(`document '${E.toString()}' NOT found`);return P.document}async tokenAtPosition(E,l){const P=E.version,b=h.Position.from(l),c=await this.a.$tokensAtPosition(E.uri,b),m={type:I.StandardTokenType.Other,range:E.getWordRangeAtPosition(l)??new I.$yN(l.line,l.character,l.line,l.character)};if(!c)return m;const d={range:h.Range.to(c.range),type:h.TokenType.to(c.type)};return!d.range.contains(l)||P!==E.version?m:d}createLanguageStatusItem(E,l,P){const b=this.f++,c=this.a,m=this.g,d=`${E.identifier.value}/${l}`;if(m.has(d))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);m.add(d);const g={selector:P,id:l,name:E.displayName??E.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new R.$Wc,t=()=>{if(n?.dispose(),!m.has(d)){console.warn(`LanguageStatusItem (${l}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Ih)(()=>{o.clear(),this.a.$setLanguageStatus(b,{id:d,name:g.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(g.selector,this.e),label:g.text,detail:g.detail??"",severity:g.severity===I.LanguageStatusSeverity.Error?T.default.Error:g.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:g.command&&this.d.toInternal(g.command,o),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},i={dispose(){o.dispose(),n?.dispose(),c.$removeLanguageStatus(b),m.delete(d)},get id(){return g.id},get name(){return g.name},set name(r){g.name=r,t()},get selector(){return g.selector},set selector(r){g.selector=r,t()},get text(){return g.text},set text(r){g.text=r,t()},set text2(r){(0,$.$7G)(E,"languageStatusText"),g.text=r,t()},get text2(){return(0,$.$7G)(E,"languageStatusText"),g.text},get detail(){return g.detail},set detail(r){g.detail=r,t()},get severity(){return g.severity},set severity(r){g.severity=r,t()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(r){g.accessibilityInformation=r,t()},get command(){return g.command},set command(r){g.command=r,t()},get busy(){return g.busy},set busy(r){g.busy=r,t()}};return t(),i}}e.$3pc=a}),define(Ee[358],Se([1,0,15,2,16,10,127]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0,I=We(I),L=We(L);class R{constructor(E,l,P,b){this.start=E,this.deletedCount=l,this.deletedItems=P,this.items=b}asApiEvent(){return{range:new T.$YO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,l,P){this.notebook=E,this.h=l,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(I.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(P)}return this.f}setOutputs(E){this.a=E.map(I.NotebookCellOutput.to)}setOutputItems(E,l,P){const b=P.map(I.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===E);if(c&&(l||(c.items.length=0),c.items.push(...b),c.items.length>1&&c.items.every(m=>L.$zL(m.mime)))){const m=new Map,d=[];c.items.forEach(g=>{let n;m.has(g.mime)?n=m.get(g.mime):(n=[],m.set(g.mime,n),d.push(g.mime)),n.push(g.data)}),c.items.length=0,d.forEach(g=>{const n=L.$AL(m.get(g));c.items.push({mime:g,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Npc=$;class a{static{this.a=0}constructor(E,l,P,b,c){this.k=E,this.l=l,this.m=P,this.uri=b,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,l={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===s.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(P){return P=E.n(P),E.b[P].apiCell},getCells(P){return(P?E.p(P):E.b).map(c=>c.apiCell)},save(){return E.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,l,P){this.g=E.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:P});const b={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},c=[];for(const d of E.rawEvents)d.kind===L.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,b.contentChanges):d.kind===L.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,b.contentChanges):d.kind===L.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===L.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===L.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),c.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),c.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const m=new Map;for(let d=0;d<c.length;d++){const g=c[d],n=m.get(g.cell);if(n===void 0){const o=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});m.set(g.cell,o-1)}else b.cellChanges[n]={...b.cellChanges[n],...g}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let l=E.start|0,P=E.end|0;return l<0&&(l=0),P>this.b.length&&(P=this.b.length),E.with({start:l,end:P})}p(E){E=this.o(E);const l=[];for(let P=E.start;P<E.end;P++)l.push(this.b[P]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,l,P){if(this.j)return;const b=[],c=[],m=[];if(E.reverse().forEach(d=>{const n=d[2].map(i=>{const r=new $(this,this.l,i);return l||c.push($.asModelAddData(i)),r}),o=new R(d[0],d[1],[],n),t=this.b.splice(d[0],d[1],...n);for(const i of t)m.push(i.uri),o.deletedItems.push(i.apiCell);b.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),P)for(const d of b)P.push(d.asApiEvent())}s(E,l,P,b){const c=this.b.splice(E,l);this.b.splice(P,0,...c);const m=[new R(E,l,c.map(d=>d.apiCell),[]),new R(P,0,[],c)];for(const d of m)b.push(d.asApiEvent())}t(E,l){this.b[E].setOutputs(l)}u(E,l,P,b){this.b[E].setOutputItems(l,P,b)}v(E,l){const P=this.b[E];P.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(P.uri,l)}w(E,l){const P=this.b[E];P.apiCell.mime=l}x(E,l){this.b[E].setMetadata(l)}y(E,l){this.b[E].setInternalMetadata(l)}getCellFromApiCell(E){return this.b.find(l=>l.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(l=>l.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Opc=a}),define(Ee[359],Se([1,0,4,2,16,10,52]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0;class R{constructor(a,k,E,l={timeout:1500,errors:3}){this.b=a,this.c=k,this.d=E,this.f=l,this.a=new s.$pe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(k,E,l)=>{const P=function(c){k.call(E,c)};return P.extension=a,this.a.event(P,void 0,l)}}async $participateInSave(a,k,E){const l=h.URI.revive(a),P=this.c.getNotebookDocument(l);if(!P)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:I.TextDocumentSaveReason.to(k)},E,async(m,d)=>{const g=Date.now(),n=await await Promise.resolve(m);Date.now()-g>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof T.$GN?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(b.length===0)return!0;const c={edits:[]};for(const m of b){const{edits:d}=I.WorkspaceEdit.from(m);c.edits=c.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new L.$Uw(c))}}e.$5pc=R}),define(Ee[165],Se([1,0,14,16,10]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,h=We(h),I=We(I);class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,$,a,k,E,l){this.id=R,this.f=$,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=k,this.c=l}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection($){this.selections=[$]},get selections(){return R.a},set selections($){if(!Array.isArray($)||!$.every(I.$YO.isNotebookRange))throw(0,s.$0)("selections");R.a=$,R.g($)},get visibleRanges(){return R.b},revealRange($,a){R.f.$tryRevealRange(R.id,h.NotebookRange.from($),a??I.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(h.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.$Ppc=T}),define(Ee[360],Se([1,0,4,12,16]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,I=We(I);let T=class{constructor(R,$){this.c=R,this.d=$,this.a=new s.$ne,this.b=new s.$ne,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,$);const a=this.d.getEditorById(R);$.visibleRanges&&a._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&a._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const $ in R)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(R[$]))}};e.$7pc=T,e.$7pc=T=Xe([Ve(0,h.$ak)],T)}),define(Ee[361],Se([1,0,4,6,165]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0;class T{constructor(R,$){this.c=$,this.a=new Map,this.b=R.getProxy(h.$uN.MainThreadNotebookRenderers)}$postRendererMessage(R,$,a){const k=this.c.getEditorById(R);this.a.get($)?.fire({editor:k.apiEditor,message:a})}createRendererMessaging(R,$){if(!R.contributes?.notebookRenderer?.some(k=>k.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(k,E,l)=>this.d($).event(k,E,l),postMessage:(k,E)=>{I.$Ppc.apiEditorsToExtHost.has(k)&&([k,E]=[E,k]);const l=E&&I.$Ppc.apiEditorsToExtHost.get(E);return this.b.$postMessage(l?.id,$,k)}}}d(R){let $=this.a.get(R);return $||($=new s.$ne({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(R)}}),this.a.set(R,$),$)}}e.$0pc=T}),define(Ee[362],Se([1,0,16,90,21,59,14]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=void 0;class R{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,l,P){const b=this.b++,{title:c,location:m,cancellable:d}=l,g={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(b,{location:s.ProgressLocation.from(m),title:c,source:g,cancellable:d},E.isUnderDevelopment?void 0:E.identifier.value).catch(L.$4),this.d(b,P,!!d)}d(E,l,P){let b;P&&(b=new I.$ye,this.c.set(E,b));const c=d=>{this.a.$progressEnd(d),this.c.delete(d),b?.dispose()};let m;try{m=l(new a(this.a,E),P&&b?b.token:I.CancellationToken.None)}catch(d){throw c(E),d}return m.then(d=>c(E),d=>c(E)),m}$acceptProgressCanceled(E){const l=this.c.get(E);l&&(l.cancel(),this.c.delete(E))}}e.$bqc=R;function $(k,E){return k.message=E.message,typeof E.increment=="number"&&(typeof k.increment=="number"?k.increment+=E.increment:k.increment=E.increment),k}class a extends h.$ww{constructor(E,l){super(P=>this.throttledReport(P)),this.c=E,this.d=l}throttledReport(E){this.c.$progressReport(this.d,E)}}Xe([(0,T.$ai)(100,(k,E)=>$(k,E),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ee[363],Se([1,0,2,6,9,16]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0;class L{static{this.a=0}constructor($,a){this.d=a,this.c=new Map,this.b=$.getProxy(h.$uN.MainThreadQuickDiff)}$provideOriginalResource($,a,k){const E=s.URI.revive(a),l=this.c.get($);return l?(0,I.$yh)(()=>l.provideOriginalResource(E,k)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider($,a,k,E){const l=L.a++;return this.c.set(l,a),this.b.$registerQuickDiffProvider(l,T.DocumentSelector.from($,this.d),k,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$cqc=L});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[364],Se([1,0,21,4,3,6,2,10,14,19,44,50,26,16]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=b,k=jt(k);function b(c,m,d){const g=c.getProxy(T.$uN.MainThreadQuickOpen);class n{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,C,A=s.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),v=++this.f,F=g.$show(v,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},A),N={},O=F.then(()=>N);return Promise.race([O,p]).then(j=>{if(j===N)return;const z=(0,l.$6G)(D,"quickPickItemTooltip");return p.then(M=>{const V=[];for(let K=0;K<M.length;K++){const re=M[K];if(typeof re=="string")V.push({label:re,handle:K});else if(re.kind===R.QuickPickItemKind.Separator)V.push({type:"separator",label:re.label});else{re.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const B=re.iconPath?f(re.iconPath):void 0;V.push({label:re.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(re.tooltip):void 0,handle:K})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=K=>{C.onDidSelectItem(M[K])}),g.$setItems(v,V),F.then(K=>{if(typeof K=="number")return M[K];if(Array.isArray(K))return K.map(re=>M[re])})})}).then(void 0,j=>{if(!(0,$.$7)(j))return g.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=s.CancellationToken.None){return this.d=D?.validateInput,g.$input(D,typeof this.d=="function",y).then(void 0,C=>{if(!(0,$.$7)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let C;switch(y.severity){case R.InputBoxValidationSeverity.Info:C=k.default.Info;break;case R.InputBoxValidationSeverity.Warning:C=k.default.Warning;break;case R.InputBoxValidationSeverity.Error:C=k.default.Error;break;default:C=y.message?k.default.Error:k.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(D,y=s.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(p=>p.uri.toString()===C.uri.toString())}createQuickPick(D){const y=new u(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new w(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const C=this.e.get(D);C instanceof u&&C._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const C=this.e.get(D);C instanceof u&&C._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,C){const A=this.e.get(D);A instanceof u&&A._fireDidTriggerItemButton(y,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class o{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$ne,this.q=new h.$ne,this.r=new h.$ne,this.s=new h.$ne,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,C)=>{const A=y===R.$VO.Back?-1:C;this.o.set(A,y)}),this.z({buttons:D.map((y,C)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===R.$VO.Back?-1:C}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const C=D[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof R.$tO)return{id:S.id};const D=r(S),y=i(S);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof y=="string"?L.URI.file(y):y}}function i(S){return typeof S=="object"&&"light"in S?S.light:S}function r(S){return typeof S=="object"&&"dark"in S?S.dark:S}function f(S){const D=t(S);let y,C;return"id"in D?C=E.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:C}}class u extends o{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$ne,this.L=[],this.M=new h.$ne,this.N=new h.$ne,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,p)=>{this.C.set(p,A),this.D.set(A,p)});const y=(0,l.$6G)(this.O,"quickPickItemTooltip"),C=[];for(let A=0;A<D.length;A++){const p=D[A];if(p.kind===R.QuickPickItemKind.Separator)C.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=p.iconPath?f(p.iconPath):void 0;C.push({handle:A,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((F,N)=>({...f(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,a.$Kb)(D.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,a.$Kb)(D.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const A=C.buttons[y];A&&this.N.fire({button:A,item:C})}}class w extends o{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:k.default.Error}):this.z({validationMessage:D.message,severity:D.severity??k.default.Error}):this.z({validationMessage:void 0,severity:k.default.Ignore})}}return new n(m,d)}}),define(Ee[365],Se([1,0,2,4,59,3,9,6,19,140,12,24,41,50,16,26,15,11]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=void 0;function n(N){return N instanceof s.URI}function o(N,O){return N.scheme===m.Schemas.file&&O.scheme===m.Schemas.file&&d.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?s.URI.file(N.iconPath):s.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function i(N){if(N){if(s.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function r(N){const O=i(N.icon),j=N.labels?.map(z=>({title:z.title,icon:i(z.icon)}));return{...N,icon:O,labels:j}}function f(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:s.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:s.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,a.$Ir)(j,z)}function u(N,O){let j=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(j=f(N,O),j!==0)return j;if(N.light&&O.light)j=f(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(j!==0)return j;if(N.dark&&O.dark)j=f(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return j}function w(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const z=N.arguments[j],M=O.arguments[j];if(z!==M&&!(n(z)&&n(M)&&o(z,M)))return z<M?-1:1}return 0}function S(N,O){let j=(0,a.$Ir)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&O.command)j=w(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(j!==0)return j;if(N.decorations&&O.decorations)j=u(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)j=(0,a.$Ir)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)j=(0,a.$Ir)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return j}function D(N,O){for(let j=0;j<N.length;j++)if(N[j]!==O[j])return!1;return!0}function y(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?D(N.arguments,O.arguments):N.arguments===O.arguments)}function C(N,O){return(0,$.$xb)(N,O,y)}class A{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.m,O),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.m,O),this.f=O}get validateInput(){return(0,c.$7G)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,c.$7G)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.m,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.m,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.m,O))}get document(){return(0,c.$7G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(O,j,z,M,V){this.k=O,this.m=M,this.n=V,this.d="",this.e=new h.$ne,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=z}showValidationMessage(O,j){(0,c.$7G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,O,j)}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$eqc=A;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.s.$updateGroupLabel(this.u,this.handle,O)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(O){this.q=O,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,j,z,M,V,K,re){this.s=O,this.t=j,this.u=z,this.v=M,this.w=V,this.multiDiffEditorEnableViewChanges=K,this.x=re,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$ne,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$ne,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,j){const z=this.h.get(O);return z?(0,L.$yh)(()=>this.t.executeCommand(z.command,...z.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(S),z=(0,$.$Gb)(this.p,O,S).map(K=>{const re=K.toInsert.map(B=>{const G=this.e++;this.g.set(G,B);const X=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const oe=new T.$Wc;ee=this.t.converter.toInternal(B.command,oe),this.j.set(G,oe)}else this.h.set(G,B.command);const de=(0,c.$6G)(this.x,"scmMultiDiffEditor"),ne=de?B.multiDiffEditorOriginalUri:void 0,De=de?B.multiFileDiffEditorModifiedUri:void 0,$e=t(B.decorations),J=B.decorations&&t(B.decorations.light)||$e,U=B.decorations&&t(B.decorations.dark)||$e,se=[J,U],ae=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,le=B.decorations&&!!B.decorations.faded,ue=B.contextValue||"";return{rawResource:[G,X,se,ae,te,le,ue,ee,ne,De],handle:G}});return{start:K.start,deleteCount:K.deleteCount,toInsert:re}}),M=z.map(({start:K,deleteCount:re,toInsert:B})=>[K,re,B.map(G=>G.rawResource)]),V=z.reverse();for(const{start:K,deleteCount:re,toInsert:B}of V){const G=B.map(ee=>ee.handle),X=this.o.splice(K,re,...G);for(const ee of X)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.p=O,M}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.x,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let j;(0,c.$6G)(this.y,"quickDiffProvider")&&(j=O?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:j})}get historyProvider(){return(0,c.$7G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(O){(0,c.$7G)(this.y,"scmHistoryProvider"),this.j=O,this.k.value=new T.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.#e.$updateSourceControl(this.x,{commitTemplate:O}))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new T.$Wc,this.p=O;const j=this.z.converter.toInternal(O,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,c.$7G)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,c.$7G)(this.y,"scmActionButton"),this.q.value=new T.$Wc,this.s=O;const j=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(O??[]).map(z=>z.command).join(", ")),this.u&&O&&C(this.u,O)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new T.$Wc,this.u=O;const j=(O||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(O,j,z,M,V,K,re,B){this.y=O,this.z=M,this.A=V,this.B=K,this.C=re,this.D=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Yc,this.n=void 0,this.o=new T.$Yc,this.p=void 0,this.q=new T.$Yc,this.t=new T.$Yc,this.u=void 0,this.v=!1,this.w=new h.$ne,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.E=new Map,this.F=new Set,this.#e=z;const G=s.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${K}/scm${this.x}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new A(O,j,this.#e,this.x,G),this.#e.$registerSourceControl(this.x,K,re,B,G)}createResourceGroup(O,j,z){const M=(0,c.$6G)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,V=new p(this.#e,this.z,this.x,O,j,M,this.y),K=h.Event.once(V.onDidDispose)(()=>this.E.delete(V));return this.E.set(V,K),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const O=[],j=[];for(const[z,M]of this.E){M.dispose();const V=z.onDidUpdateResourceStates(()=>{this.F.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.F.delete(z),V.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),O.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const K=z._takeResourceStateSnapshot();K.length>0&&j.push([z.handle,K]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,O,j),this.E.clear()}eventuallyUpdateResourceStates(){const O=[];this.F.forEach(j=>{const z=j._takeResourceStateSnapshot();z.length!==0&&O.push([j.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.x,O),this.F.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.x)}}Xe([(0,I.$_h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Xe([(0,I.$_h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{g=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,j,z,M){this.m=j,this.n=z,this.o=M,this.g=new Map,this.h=new E.$tn,this.j=new h.$ne,this.e=O.getProxy(R.$uN.MainThreadSCM),this.f=O.getProxy(R.$uN.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===l.MarshalledId.ScmResource){const K=this.g.get(V.sourceControlHandle);if(!K)return V;const re=K.getResourceGroup(V.groupHandle);return re?re.getResourceState(V.handle):V}else if(V&&V.$mid===l.MarshalledId.ScmResourceGroup){const K=this.g.get(V.sourceControlHandle);return K?K.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===l.MarshalledId.ScmProvider){const K=this.g.get(V.handle);return K||V}return V}})}createSourceControl(O,j,z,M){this.o.trace("ExtHostSCM#createSourceControl",O.identifier.value,j,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const V=g.d++,K=new v(O,this.n,this.e,this.m,this.o,j,z,M);this.g.set(V,K);const re=this.h.get(O.identifier)||[];return re.push(K),this.h.set(O.identifier,re),K}getLastInputBox(O){this.o.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const j=this.h.get(O.identifier),z=j&&j[j.length-1];return z&&z.inputBox}$provideOriginalResource(O,j,z){const M=s.URI.revive(j);this.o.trace("ExtHostSCM#$provideOriginalResource",O,M.toString());const V=this.g.get(O);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$yh)(()=>V.quickDiffProvider.provideOriginalResource(M,z)).then(K=>K||null)}$onInputBoxValueChange(O,j){this.o.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(O,j,z,M){this.o.trace("ExtHostSCM#$executeResourceCommand",O,j,z);const V=this.g.get(O);if(!V)return Promise.resolve(void 0);const K=V.getResourceGroup(j);return K?K.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(O,j,z){this.o.trace("ExtHostSCM#$validateInput",O);const M=this.g.get(O);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,L.$yh)(()=>M.inputBox.validateInput(j,z)).then(V=>{if(!V)return Promise.resolve(void 0);const K=b.MarkdownString.fromStrict(V.message);return K?Promise.resolve([K,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,j,z,M){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,z,M)??void 0}async $provideHistoryItems(O,j,z,M){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(j,z,M))?.map(re=>r(re))??void 0}async $provideHistoryItems2(O,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems2(j,z))?.map(K=>r(K))??void 0}async $provideHistoryItemSummary(O,j,z,M){const V=this.g.get(O)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const K=await V.provideHistoryItemSummary(j,z,M);return K?r(K):void 0}async $provideHistoryItemChanges(O,j,z,M){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(j,z,M)??void 0}};e.$fqc=F,e.$fqc=F=g=Xe([Ve(3,k.$ak)],F)}),define(Ee[366],Se([1,0,6,16,2]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;class T{static{this.a=0}constructor(R,$){this.d=$,this.c=new Map,this.b=R.getProxy(s.$uN.MainThreadShare)}async $provideShare(R,$,a){return await this.c.get(R)?.provideShare({selection:h.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},a)??void 0}registerShareProvider(R,$){const a=T.a++;return this.c.set(a,$),this.b.$registerShareProvider(a,h.DocumentSelector.from(R,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$gqc=T}),define(Ee[367],Se([1,0,10,6,240,3,16,18]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=e.$iqc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new s.$uO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.$uO("statusBarItem.warningForeground")]])}#e;#t;constructor(l,P,b,c,m,d=s.StatusBarAlignment.Left,g){if(this.i=!1,this.k="",this.q=new T.$Wc,this.#e=l,this.#t=P,m&&c){this.c=(0,s.$9N)(c.identifier,m);const n=b.get(this.c);n&&(d=n.alignLeft?s.StatusBarAlignment.Left:s.StatusBarAlignment.Right,g=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=d,this.h=this.u(g)}u(l){if((0,R.$kg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!$.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new T.$Wc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let P;this.m?P=this.m:P=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=$.b.get(this.o.id));const c=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,P,this.k,c,this.r?.internal,b,this.o,this.g===s.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$iqc=$;class a{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const P={message:l};return this.b.unshift(P),this.c(),new s.$wN(()=>{const b=this.b.indexOf(P);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class k{constructor(l,P){this.e=new Map,this.a=l.getProxy(h.$uN.MainThreadStatusBar),this.b=P,this.c=new a(this)}$acceptStaticEntries(l){for(const P of l)this.e.set(P.entryId,P)}createStatusBarEntry(l,P,b,c){return new $(this.a,this.b,this.e,l,P,b,c)}setStatusBarMessage(l,P){const b=this.c.setMessage(l);let c;return typeof P=="number"?c=setTimeout(()=>b.dispose(),P):typeof P<"u"&&P.then(()=>b.dispose(),()=>b.dispose()),new s.$wN(()=>{b.dispose(),clearTimeout(c)})}}e.$jqc=k}),define(Ee[166],Se([1,0,31,155,74,121,75,16,2]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,s=We(s),R=We(R);const a=(n,o,t,i)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(f){if(!t(r,f)){const u=r;r=f,n.listener?.(i(f,u))}}}},k=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(n,o)=>!(n.length!==o.length||n.some(t=>!o.find(i=>t.id===i.id)))},l=n=>o=>({op:T.TestItemEventOp.SetProp,update:n(o)}),P=(n,o)=>({range:(()=>{let t;const i=l(r=>({range:s.$Mt.lift(R.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return t},set(r){n.listener?.({op:T.TestItemEventOp.DocumentSynced}),E.range(t,r)||(t=r,n.listener?.(i(r)))}}})(),label:a(n,o,E.label,l(t=>({label:t}))),description:a(n,void 0,E.description,l(t=>({description:t}))),sortText:a(n,void 0,E.sortText,l(t=>({sortText:t}))),canResolveChildren:a(n,!1,E.canResolveChildren,t=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(n,!1,E.busy,l(t=>({busy:t}))),error:a(n,void 0,E.error,l(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:a(n,[],E.tags,(t,i)=>({op:T.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:i.map(R.TestTag.from)}))}),b=n=>{const o=I.$TI.fromString(n.extId),t=new m(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return t.range=R.Range.to(n.range||void 0),t.description=n.description||void 0,t.sortText=n.sortText||void 0,t.tags=n.tags.map(i=>R.TestTag.to({id:(0,L.$ZI)(i).tagId})),t},c=n=>{let o;for(const t of n.tests){const i=b(t.item);(0,h.$WP)(i).parent=o,o=i}return o};e.$aQ=c;class m{constructor(o,t,i,r){if(t.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const f=(0,h.$VP)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof d?void 0:f.parent}},children:{value:(0,T.$UP)(f,h.$WP,m),enumerable:!0,writable:!1},...P(f,i)})}}e.$bQ=m;class d extends m{constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$cQ=d;class g extends T.$QP{constructor(o,t,i){super({controllerId:o,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:h.$WP,getChildren:r=>r.children,root:new d(o,t),toITestItem:R.TestItem.from})}}e.$dQ=g}),define(Ee[35],Se([1,0,18,10,16,25,6,19,12,57,31,54,2,3,5,20,166,22,52,51,43,92,95,32]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,h=We(h),I=We(I);let f=class{#e;#t;#i;constructor(C,A,p){this.b=new Map,this.c=new Map,this.#e=C.getProxy(L.$uN.MainThreadCommands),this.d=A,this.#i=p,this.#t=C.getProxy(L.$uN.MainThreadTelemetry),this.converter=new u(this,v=>{const F=this.c.get(v);return F?.result===S.Void?F:void 0},A),this.f=[{processArgument(v){return(0,a.$di)(v)}},{processArgument(v){return(0,T.$go)(v,function(F){if(k.$Mt.isIRange(F))return I.Range.to(F);if(E.$Lt.isIPosition(F))return I.Position.to(F);if(k.$Mt.isIRange(F.range)&&l.URI.isUri(F.uri))return I.location.to(F);if(F instanceof d.$Pe)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const A=this.registerCommand(!1,C.id,async(...p)=>{const v=C.args.map((N,O)=>{if(!N.validate(p[O]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof p[O]=="object"?JSON.stringify(p[O],null,"	"):p[O]} `);return N.convert(p[O])}),F=await this.executeCommand(C.internalId,...v);return C.result.convert(F,p,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new h.$wN(()=>{A.dispose(),this.c.delete(C.id)})}registerCommand(C,A,p,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:p,thisArg:v,metadata:F,extension:N}),C&&this.#e.$registerCommand(A),new h.$wN(()=>{this.b.delete(A)&&C&&this.#e.$unregisterCommand(A)})}executeCommand(C,...A){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,A,!0)}async g(C,A,p){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,A,!1);{let v=!1;const F=(0,T.$go)(A,function(N){if(N instanceof h.$xN)return I.Position.from(N);if(N instanceof h.$yN)return I.Range.from(N);if(N instanceof h.$IN)return I.location.from(N);if(h.$YO.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,d.$Pe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,d.$Pe.wrap(N);if(N instanceof d.$Pe)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,v?new g.$Uw(F):F,p);return(0,a.$di)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,A,!1);throw N}}}async h(C,A,p){const v=this.b.get(C);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:O}=v;if(O?.args)for(let z=0;z<O.args.length;z++)try{(0,s.$xg)(A[z],O.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${O.args[z].name}' - ${O.args[z].description}`)}const j=o.$he.create();try{return await F.apply(N,A)}catch(z){if(C===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(C=M.command)}if(this.d.error(z,C,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$rj)(z)),this.id=C,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,C,j.elapsed())}}j(C,A,p){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$vp(A),duration:p})}$executeContributedCommand(C,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const p=this.b.get(C);return p?(A=A.map(v=>this.f.reduce((F,N)=>N.processArgument(F,p.extension?.identifier),v)),this.h(C,A,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(A=>(C&&(A=A.filter(p=>p[0]!=="_")),A))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[A,p]of this.b){const{metadata:v}=p;v&&(C[A]=v)}return Promise.resolve(C)}};e.$jQ=f,e.$jQ=f=Xe([Ve(0,c.$1P),Ve(1,$.$ak),Ve(2,i.$iQ)],f),e.$kQ=(0,b.$Gi)("IExtHostCommands");class u{constructor(C,A,p){this.d=C,this.f=A,this.g=p,this.delegatingCommandId=`__vsc${(0,r.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,A){if(!C)return;const p={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return p;const v=this.f(C.command);if(v)p.id=v.internalId,p.arguments=v.args.map((F,N)=>F.convert(C.arguments&&C.arguments[N]));else if((0,R.$Ob)(C.arguments)){const F=`${C.command} /${++this.c}`;this.b.set(F,C),A.add((0,P.$Vc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this.g.trace("CommandsConverter#CREATE",C.command,F)}return p}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const A=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$lQ=u;class w{static{this.Uri=new w("uri","Uri of a text document",C=>l.URI.isUri(C),C=>C)}static{this.Position=new w("position","A position in a text document",C=>h.$xN.isPosition(C),I.Position.from)}static{this.Range=new w("range","A range in a text document",C=>h.$yN.isRange(C),I.Range.from)}static{this.Selection=new w("selection","A selection in a text document",C=>h.$zN.isSelection(C),I.Selection.from)}static{this.Number=new w("number","",C=>typeof C=="number",C=>C)}static{this.String=new w("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=w.Arr(w.String)}static Arr(C){return new w(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,A=>Array.isArray(A)&&A.every(p=>C.validate(p)),A=>A.map(p=>C.convert(p)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",C=>C instanceof h.$UN,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",C=>C instanceof h.$gP,I.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",C=>C instanceof m.$bQ,I.TestItem.from)}constructor(C,A,p,v){this.name=C,this.description=A,this.validate=p,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,A){return new w(C??this.name,A??this.description,this.validate,this.convert)}}e.$mQ=w;class S{static{this.Void=new S("no result",C=>C)}constructor(C,A){this.description=C,this.convert=A}}e.$nQ=S;class D{constructor(C,A,p,v,F){this.id=C,this.internalId=A,this.description=p,this.args=v,this.result=F}}e.$oQ=D}),define(Ee[368],Se([1,0,19,15,2,88,143,36,35,16,10]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0,T=We(T),a=We(a),k=We(k);const E=[new $.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",P(a.DocumentHighlight.to))),new $.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,s.$Nb)(c))return;class d extends k.$PN{static to(n){const o=new d(n.name,a.SymbolKind.to(n.kind),n.containerName||"",new k.$IN(m[0],a.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=a.Range.to(n.selectionRange),o.children=n.children?n.children.map(d.to):[],o}}return c.map(d.to)})),new $.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$mQ.Uri,new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",P(a.TextEdit.to))),new $.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",P(a.TextEdit.to))),new $.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$mQ.Uri,$.$mQ.Position,new $.$mQ("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$mQ("options","Formatting options",c=>!0,c=>c)],new $.$nQ("A promise that resolves to an array of TextEdits.",P(a.TextEdit.to))),new $.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location-instances.",P(a.location.to))),new $.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Hover-instances.",P(a.Hover.to))),new $.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$mQ.Uri,new $.$mQ("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>k.$xN.isPosition(m)),c=>c.map(a.Position.from))],new $.$nQ("A promise that resolves to an array of ranges.",c=>c.map(m=>{let d;for(const g of m.reverse())d=new k.$TN(a.Range.to(g),d);return d}))),new $.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$mQ.String.with("query","Search string")],new $.$nQ("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(a.WorkspaceSymbol.to))),new $.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(a.CallHierarchyItem.to))),new $.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(a.CallHierarchyIncomingCall.to))),new $.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(a.CallHierarchyOutgoingCall.to))),new $.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:a.Range.to(c.range),placeholder:c.text}})),new $.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("newName","The new symbol name")],new $.$nQ("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return a.WorkspaceEdit.to(c)}})),new $.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$mQ.Uri,$.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$nQ("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(a.DocumentLink.to))),new $.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new k.$PO(c.tokenTypes,c.tokenModifiers)})),new $.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,L.$Hdb)(c);if(m.type==="full")return new k.$RO(m.data,void 0)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$mQ.Uri,$.$mQ.Range.optional()],new $.$nQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new k.$PO(c.tokenTypes,c.tokenModifiers)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,L.$Hdb)(c);if(m.type==="full")return new k.$RO(m.data,void 0)})),new $.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$nQ("A promise that resolves to a CompletionList-instance.",(c,m,d)=>{if(!c)return new k.$6N([]);const g=c.suggestions.map(n=>a.CompletionItem.to(n,d));return new k.$6N(g,c.incomplete)})),new $.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$nQ("A promise that resolves to SignatureHelp.",c=>{if(c)return a.SignatureHelp.to(c)})),new $.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$mQ.Uri,$.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$nQ("A promise that resolves to an array of CodeLens-instances.",(c,m,d)=>P(g=>new k.$XN(a.Range.to(g.range),g.command&&d.fromInternal(g.command)))(c))),new $.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$mQ.Uri,new $.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>k.$yN.isRange(c),c=>k.$zN.isSelection(c)?a.Selection.from(c):a.Range.from(c)),$.$mQ.String.with("kind","Code action kind to return code actions for").optional(),$.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$nQ("A promise that resolves to an array of Command-instances.",(c,m,d)=>P(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const n=new k.$RN(g.title,g.kind?new k.$SN(g.kind):void 0);return g.edit&&(n.edit=a.WorkspaceEdit.to(g.edit)),g.command&&(n.command=d.fromInternal(g.command)),n.isPreferred=g.isPreferred,n}})(c))),new $.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new k.$_N(a.Range.to(m.range),a.Color.to(m.color))):[])),new $.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$mQ("color","The color to show and insert",c=>c instanceof k.$$N,a.Color.from),new $.$mQ("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:a.Range.from(c.range)}))],new $.$nQ("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(a.ColorPresentation.to):[])),new $.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to an array of Inlay objects",(c,m,d)=>c.map(a.InlayHint.to.bind(void 0,d)))),new $.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(a.FoldingRange.to)})),new $.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>a.NotebookExclusiveDocumentPattern.to(m))})))),new $.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof k.$yN,c=>a.InlineValueContext.from(c))],new $.$nQ("A promise that resolves to an array of InlineValue objects",c=>c.map(a.InlineValue.to))),new $.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$mQ("uriOrString","Uri-instance or string (only http/https)",c=>I.URI.isUri(c)||typeof c=="string"&&(0,h.$Qg)(c,h.Schemas.http,h.Schemas.https),c=>c),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[a.ViewColumn.from(c),void 0]:[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)])).optional(),$.$mQ.String.with("label","").optional()],$.$nQ.Void),new $.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$mQ.Uri.with("resource","Resource to open"),$.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[a.ViewColumn.from(c),void 0]:[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)])).optional()],$.$nQ.Void),new $.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$mQ.String.with("title","Human readable title for the diff editor").optional(),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[a.ViewColumn.from(c.viewColumn),a.TextEditorOpenOptions.from(c)]).optional()],$.$nQ.Void),new $.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$mQ.String.with("title","Human readable title for the changes editor"),new $.$mQ("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[d,g,n]=m;if(!I.URI.isUri(d)||!I.URI.isUri(g)&&g!==void 0&&g!==null||!I.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],$.$nQ.Void),new $.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$mQ.TestItem],$.$nQ.Void),new $.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$nQ.Void),new $.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$mQ.String.with("name","The context key name"),new $.$mQ("value","The context key value",()=>!0,c=>c)],$.$nQ.Void),new $.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$mQ.Uri,$.$mQ.StringArray,new $.$mQ("MappedEditsContext","Mapped Edits Context",c=>a.MappedEditsContext.is(c),c=>a.MappedEditsContext.from(c))],new $.$nQ("A promise that resolves to a workspace edit or null",c=>c?a.WorkspaceEdit.to(c):null)),new $.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$mQ("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?a.Range.from(c.initialRange):void 0,initialSelection:k.$zN.isSelection(c.initialSelection)?a.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?a.Position.from(c.position):void 0}})],$.$nQ.Void)];class l{static register(m){E.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",R.$Fj)}}e.$yoc=l;function P(c){return m=>{if(Array.isArray(m))return m.map(c)}}function b(c){if(!Array.isArray(c))return;const m=[];for(const d of c)T.$Iu(d)?m.push(a.DefinitionLink.to(d)):m.push(a.location.to(d));return m}}),define(Ee[369],Se([1,0,2,35]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0;class I{constructor(L,R,$,a,k){this.a=R,this.b=$,this.c=a;const E=new h.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$mQ("showOptions","Show Options",l=>!0,l=>l),new h.$mQ("resource","Interactive resource Uri",l=>!0,l=>l),new h.$mQ("controllerId","Notebook controller Id",l=>!0,l=>l),new h.$mQ("title","Interactive editor title",l=>!0,l=>l)],new h.$nQ("Notebook and input URI",l=>{if(k.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const P=this.a.getEditorById(l.notebookEditorId);return k.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:s.URI.revive(l.notebookUri),inputUri:s.URI.revive(l.inputUri),notebookEditor:P.apiEditor}}return k.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:s.URI.revive(l.notebookUri),inputUri:s.URI.revive(l.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(L,R,$,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Zpc=I}),define(Ee[370],Se([1,0,19,9,21,4,3,29,2,24,12,6,35,16,10,122,312,26,52,313]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0,e.$9pc=w,P=We(P);let o=class{constructor(D,y,C,A,p){this.m=y,this.n=C,this.o=A,this.q=p,this.b=new R.$Dc,this.c=new R.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$ne,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(E.$uN.MainThreadNotebookKernels);const v=new l.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$mQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$nQ.Void),F=new l.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$mQ.Uri],new l.$nQ("A promise that resolves to an array of variables",(N,O)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(D,y,C,A,p,v){for(const ne of this.j.values())if(ne.controller.id===y&&a.$rn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const O=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${D.identifier}'`);let j=!1;const z=new T.$ne,M=new T.$ne,V={id:w(D.identifier,y),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let K=p??O,re,B;this.a.$addKernel(F,V).catch(ne=>{console.log(ne),j=!0});let G=0;const X=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(F,V)})},ee=new R.$Dc,de={get id(){return y},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return V.label},set label(ne){V.label=ne??D.displayName??D.name,X()},get detail(){return V.detail??""},set detail(ne){V.detail=ne,X()},get description(){return V.description??""},set description(ne){V.description=ne,X()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(ne){V.supportedLanguages=ne,X()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){V.supportsExecutionOrder=ne,X()},get rendererScripts(){return V.preloads?V.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ne){K=ne??O},get interruptHandler(){return re},set interruptHandler(ne){re=ne,V.supportsInterrupt=!!ne,X()},set variableProvider(ne){(0,d.$7G)(D,"notebookVariableProvider"),B=ne,V.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>N.a.$variablesUpdated(De.uri)),X()},get variableProvider(){return B},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,w(D.identifier,this.id))},createNotebookExecution(ne){if((0,d.$7G)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,w(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),z.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ne,De){De===b.NotebookControllerAffinity2.Hidden&&(0,d.$7G)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,ne.uri,De)},onDidReceiveMessage:M.event,postMessage(ne,De){return(0,d.$7G)(D,"notebookMessaging"),N.a.$postMessage(F,De&&N.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,d.$7G)(D,"notebookMessaging"),(0,c.$hDb)(ne,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:de,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:ee}),de}getIdByController(D){for(const[y,C]of this.j)if(C.controller===D)return w(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const C=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const p={dispose:()=>{this.f.delete(C),A.a.$removeKernelDetectionTask(C)}};return this.f.set(C,p),p}registerKernelSourceActionProvider(D,y,C){const A=this.i++,p=typeof C.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,C),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let F;return p!==void 0&&(F=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(D,y){const C=this.h.get(D);if(C){const A=new L.$Wc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,y,C){const A=this.j.get(D);if(A){const p=this.n.getNotebookDocument($.URI.revive(y));C?A.associatedNotebooks.set(p.uri,!0):A.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,p.uri.toString(),C),A.onDidChangeSelection.fire({selected:C,notebook:p.apiNotebook})}}async $executeCells(D,y,C){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument($.URI.revive(y)),v=[];for(const F of C){const N=p.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,p.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,p.apiNotebook,A.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,C){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument($.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,p.apiNotebook);else for(const v of C){const F=p.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),C.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(D,y,C,A,p,v,F){const N=this.j.get(D);if(!N)return;const O=this.n.getNotebookDocument($.URI.revive(C)),j=N.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const M=p==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,V=j.provideVariables(O.apiNotebook,z,M,v,F);let K=0;for await(const re of V){if(F.isCancellationRequested)return;const B={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[B.id]=re.variable,this.a.$receiveVariable(y,B),K++>=n.$MK)return}}$acceptKernelMessageFromRenderer(D,y,C){const A=this.j.get(D);if(!A)return;const p=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:C}))}$cellExecutionChanged(D,y,C){const p=this.n.getNotebookDocument($.URI.revive(D)).getCell(y);if(p){const v=C?P.NotebookCellExecutionState.to(C):b.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const p=new i(y,A,this.a);this.b.set(A.uri,p);const v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.b.delete(A.uri))});return p.asApiObject()}_createNotebookExecution(D,y){const C=this.n.getNotebookDocument(D.uri),A=D.getCells().find(F=>{const N=C.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const p=new f(y,C,this.a),v=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),v.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[p,v]),p.asApiObject()}};e.$8pc=o,e.$8pc=o=Xe([Ve(4,k.$ak)],o);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class i extends L.$Xc{static{this.a=0}get state(){return this.f}constructor(D,y,C){super(),this.m=y,this.n=C,this.b=i.a++,this.c=new T.$ne,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new I.$ye),this.h=new u(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new g.$Uw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const C=b.$3O.ensureUniqueMimeTypes(y.items,!0);return C===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(D,y,C){const A=this.w(y),p=this.y((0,s.$5b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:C,outputs:p})}async C(D,y,C){return D=b.$3O.ensureUniqueMimeTypes((0,s.$5b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,A,p){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;D.n.$completeExecution(D.b,new g.$Uw({runEndTime:A,lastRunSuccess:C,error:v}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,A){return D.t(),D.z(C,A,!0)},replaceOutput(C,A){return D.t(),D.z(C,A,!1)},appendOutputItems(C,A){return D.t(),D.C(C,A,!0)},replaceOutputItems(C,A){return D.t(),D.C(C,A,!1)}})}}var r;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(r||(r={}));class f extends L.$Xc{static{this.a=0}get state(){return this.f}constructor(D,y,C){super(),this.h=y,this.j=C,this.b=f.a++,this.c=new T.$ne,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new I.$ye),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$4h,this.b=Date.now(),(0,h.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function w(S,D){return`${S.value}/${D}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,10,242,14,291,21,32,292,293,50,9,16,35,41]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=e.$bpc=e.$apc=void 0,e.$apc=(0,I.$Gi)("IExtHostTerminalService");class t extends R.$Xc{constructor(p,v,F,N){super(),this.u=p,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new s.$ne),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const O=this;this.value={get name(){return O.y||""},get processId(){return O.b},get creationOptions(){return O.w},get exitStatus(){return O.j},get state(){return O.m},get selection(){return O.n},get shellIntegration(){return O.shellIntegration},sendText(j,z=!0){O.C(),O.u.$sendText(O._id,j,z)},show(j){O.C(),O.u.$show(O._id,j)},hide(){O.C(),O.u.$hide(O._id)},dispose(){O.a||(O.a=!0,O.u.$dispose(O._id))},get dimensions(){if(!(O.f===void 0||O.h===void 0))return{columns:O.f,rows:O.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:D(p.iconPath)??void 0,color:m.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,F,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.z(p,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$bpc=t;class i{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new s.$ne,this.onProcessData=this.a.event,this.b=new s.$ne,this.d=new s.$ne,this.onDidChangeProperty=this.d.event,this.f=new s.$ne,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:b.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,f=class extends R.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new R.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new s.$ne,this.onDidCloseTerminal=this.H.event,this.I=new s.$ne,this.onDidOpenTerminal=this.I.event,this.J=new s.$ne,this.onDidChangeActiveTerminal=this.J.event,this.L=new s.$ne,this.onDidChangeTerminalDimensions=this.L.event,this.M=new s.$ne,this.onDidChangeTerminalState=this.M.event,this.N=new s.$ne,this.onDidChangeShell=this.N.event,this.O=new s.$ne({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new s.$ne({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$uN.MainThreadTerminalService),this.y=new c.$Axb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const O=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case o.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===o.MarshalledId.TerminalContext;j++)N[j]=O(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const F=new t(this.a,(0,P.$3g)(),p,p.name),N=new i(p.pty);return F.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,D(p.iconPath),y(p.color)).then(O=>{const j=this.S(O,N);this.h[O]=j}),this.f.push(F),F.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const F=p.location.parentTerminal;if(F){const N=this.f.find(O=>O.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new i(v),O=this.S(p,N);this.h[p]=O}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(p);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const F=this.getTerminalById(p);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(p,v,F){const N=this.getTerminalById(p);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,v){const F=this.getTerminalById(p);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(p,v,F){this.g.get(p)?.resize(v,F)}async $acceptTerminalTitleChange(p,v){const F=this.getTerminalById(p);F&&(F.name=v)}async $acceptTerminalClosed(p,v,F){const N=this.X(this.f,p);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(v,F),this.H.fire(O.value)}}$acceptTerminalOpened(p,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:T.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new t(this.a,p,O,F);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const F=this.getTerminalById(p);if(!F)return{message:(0,a.localize)(0,null,p)};F.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async z=>{z===F.value&&(j.dispose(),O())})});const N=this.g.get(p);N?N.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const F=new R.$Wc;F.add(v.onProcessReady(O=>this.a.$sendProcessReady(p,O.pid,O.cwd,O.windowsPty))),F.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(p,O))),this.y.startBuffering(p,v.onProcessData),F.add(v.onProcessExit(O=>this.U(p,O))),this.g.set(p,v);const N=this.j[p];return N&&v instanceof i&&(v.startSendingEvents(N.initialDimensions),delete this.j[p]),F}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,F){try{this.g.get(p)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$wN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,p.identifier.value),new $.$wN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,F){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,F),this.a.$registerQuickFixProvider(p,v),new $.$wN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const F=new l.$ye().token;if(F.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const O=await N.provideTerminalQuickFixes(v,F);if(O===null||Array.isArray(O)&&O.length===0)return;const j=new R.$Wc;if(this.w.value=j,!Array.isArray(O))return O?g.TerminalQuickFix.from(O,this.Q.converter,j):void 0;const z=[];for(const M of O){const V=g.TerminalQuickFix.from(M,this.Q.converter,j);V&&z.push(V)}return z}async $createContributedProfileTerminal(p,v){const F=new l.$ye().token;let N=await this.C.get(p)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(p,v){const F=this.getTerminalById(p);if(!F)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const O=new l.$ye;this.G.set(p,O);const j=[],z={terminal:F.value,line:v},M=[];for(const re of this.z)M.push(d.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:re,links:[]}));const G=await re.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||B({provider:re,links:G})}));const V=await Promise.all(M);if(O.token.isCancellationRequested)return[];const K=new Map;for(const re of V)re&&re.links.length>0&&j.push(...re.links.map(B=>{const G={id:r++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return K.set(G.id,{provider:re.provider,link:B}),G}));return this.F.set(p,K),j}$activateLink(p,v){const F=this.F.get(p)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const F=this.h[p];F&&(F.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(F=>F.value===p);return v>=0?v:null}W(p,v){const F=this.X(p,v);return F!==null?p[F]:null}X(p,v){const F=p.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new u),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const F=(0,E.$Ds)(v.map),N=(0,E.$Es)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const F=v[0],N=this.B(new u(v[1]));this.Z(F,N)})}$acceptDefaultProfile(p,v){const F=this.s;this.s=p,this.u=v,F?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$cpc=f,e.$cpc=f=Xe([Ve(1,n.$kQ),Ve(2,L.$1P)],f);class u extends R.$Xc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new s.$ne,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let F=this.a.get(v);return F||(F=new w(this,p),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(p,v,F,N){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(p,v,F,N){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(p,v,F,N){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(p,v.scope),N=this.map.get(F),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),z={variable:p,...v,options:O};this.map.set(j,z),this.f.fire()}}get(p,v){const F=this.h(p,v),N=this.map.get(F);return N?C(N):void 0}h(p,v){const F=this.j(v);return F.length?`${p}:::${F}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(p)&&v.set(N.variable,C(N));return v}delete(p,v){const F=this.h(p,v);this.map.delete(F),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==p){let O;typeof p=="string"?O=p:O=p?.value.split(`

`)[0];const j={description:O,scope:v};this.descriptionMap.set(F,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new s.$ne}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,F){this.b.replace(p,v,F,this.d)}append(p,v,F){this.b.append(p,v,F,this.d)}prepend(p,v,F){this.b.prepend(p,v,F,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((F,N)=>p.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends f{constructor(p,v){super(!1,p,v)}createTerminal(p,v,F){throw new k.$cb}createTerminalFromOptions(p,v){throw new k.$cb}};e.$dpc=S,e.$dpc=S=Xe([Ve(0,n.$kQ),Ve(1,L.$1P)],S);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function C(A){const p={...A};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Ee[167],Se([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=e.$nqc=void 0,e.$nqc=(0,I.$Gi)("IExtHostTerminalShellIntegration");let E=class extends h.$Xc{constructor(m,d){super(),this.h=d,this.b=new Map,this.c=new $.$ne,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$ne,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$ne,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(T.$uN.MainThreadTerminalShellIntegration),this.B((0,h.$Vc)(()=>{for(const[g,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(m){const d=this.h.getTerminalById(m);if(!d)return;const g=d.value;let n=this.b.get(m);n||(n=new l(d.value,this.f),this.b.set(m,n),n.store.add(d.onWillDispose(()=>this.b.get(m)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(m,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),d.shellIntegration=n.value),this.c.fire({terminal:g,shellIntegration:n.value})}$shellExecutionStart(m,d,g,n,o){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:d,confidence:g,isTrusted:n};this.b.get(m)?.startShellExecution(t,o)}$shellExecutionEnd(m,d,g,n,o){const t={value:d,confidence:g,isTrusted:n};this.b.get(m)?.endShellExecution(t,o)}$shellExecutionData(m,d){this.b.get(m)?.emitData(d)}$cwdChange(m,d){this.b.get(m)?.setCwd((0,a.$yc)(d)?a.URI.revive(d):d)}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$oqc=E,e.$oqc=E=Xe([Ve(0,L.$1P),Ve(1,R.$apc)],E);class l extends h.$Xc{get currentExecution(){return this.a}constructor(m,d){super(),this.j=m,this.m=d,this.b=!1,this.store=this.B(new h.$Wc),this.f=this.B(new $.$ne),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$ne),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$ne),this.onDidRequestEndExecution=this.h.event;const g=this;this.value={get cwd(){return g.c},executeCommand(n,o){let t=n;o&&(t+=` "${o.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),g.g.fire(t);const i={value:t,confidence:s.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},r=g.startShellExecution(i,g.c,!0).value;return g.b=!0,r}}}startShellExecution(m,d,g){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new P(m,d);g?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,d){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(m){let d=!1;a.URI.isUri(this.c)?d=!a.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&(d=!0),d&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,d){this.c=m,this.cwd=d,this.b=!1;const g=this;this.value={get commandLine(){return g.c},get cwd(){return g.cwd},read(){return g.d()}}}d(){if(!this.a){if(this.b)return k.$7h.EMPTY;this.a=new b}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends h.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new k.$Fh);const m=this.a;return new k.$7h(async g=>{this.b.push(g),await m.wait()})}emitData(m){for(const d of this.b)d.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ee[168],Se([1,0,66,14,133,16,10]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,T=We(T);class R{static{this.c=new I.$6P("TextEditorDecorationType")}constructor(l,P,b){const c=R.c.nextId();l.$registerTextEditorDecorationType(P.identifier,c,T.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:c,dispose(){l.$removeTextEditorDecorationType(c)}})}}e.$8P=R;class ${constructor(l,P){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,P){this.k();let b=null;if(l instanceof L.$xN)b=new L.$yN(l,l);else if(l instanceof L.$yN)b=l;else throw new Error("Unrecognized location");this.l(b,P,!1)}insert(l,P){this.k(),this.l(new L.$yN(l,l),P,!0)}delete(l){this.k();let P=null;if(l instanceof L.$yN)P=l;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(l,P,b){const c=this.c.validateRange(l);this.g.push({range:c,text:P,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==L.EndOfLine.LF&&l!==L.EndOfLine.CRLF)throw(0,h.$0)("endOfLine");this.h=l}}class a{constructor(l,P,b,c){this.c=l,this.d=P,this._accept(b),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(d){m.n(d)},get indentSize(){return m.g},set indentSize(d){m.p(d)},get insertSpaces(){return m.j},set insertSpaces(d){m.s(d)},get cursorStyle(){return m.k},set cursorStyle(d){m.t(d)},get lineNumbers(){return m.l},set lineNumbers(d){m.u(d)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const P=Math.floor(l);return P>0?P:null}if(typeof l=="string"){const P=parseInt(l,10);return isNaN(P)?null:P>0?P:null}return null}n(l){const P=this.m(l);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const P=Math.floor(l);return P>0?P:null}if(typeof l=="string"){const P=parseInt(l,10);return isNaN(P)?null:P>0?P:null}return null}p(l){const P=this.o(l);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const P=this.q(l);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(l)})))}assign(l){const P={};let b=!1;if(typeof l.tabSize<"u"){const c=this.m(l.tabSize);c==="auto"?(b=!0,P.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,b=!0,P.tabSize=c)}if(typeof l.indentSize<"u"){const c=this.o(l.indentSize);c==="tabSize"?(b=!0,P.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,b=!0,P.indentSize=c)}if(typeof l.insertSpaces<"u"){const c=this.q(l.insertSpaces);c==="auto"?(b=!0,P.insertSpaces=c):this.j!==c&&(this.j=c,b=!0,P.insertSpaces=c)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,b=!0,P.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,b=!0,P.lineNumbers=T.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(l,P){P.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$9P=a;class k{constructor(l,P,b,c,m,d,g,n){this.id=l,this.j=P,this.k=b,this.g=!1,this.h=new Set,this.c=m,this.d=new a(this.j,this.id,d,b),this.e=g,this.f=n;const o=this;this.value=Object.freeze({get document(){return c.value},set document(t){throw new h.$_("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof L.$zN))throw(0,h.$0)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(i=>!(i instanceof L.$zN)))throw(0,h.$0)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new h.$_("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new h.$_("viewColumn")},edit(t,i={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(c.value,i);return t(r),o.m(r)},insertSnippet(t,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=o.c.map(u=>T.Range.from(u));else if(i instanceof L.$xN){const{lineNumber:u,column:w}=T.Position.from(i);f=[{startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w}]}else if(i instanceof L.$yN)f=[T.Range.from(i)];else{f=[];for(const u of i)if(u instanceof L.$yN)f.push(T.Range.from(u));else{const{lineNumber:w,column:S}=T.Position.from(u);f.push({startLineNumber:w,startColumn:S,endLineNumber:w,endColumn:S})}}return P.$tryInsertSnippet(l,c.value.version,t.value,f,r)},setDecorations(t,i){const r=i.length===0;r&&!o.h.has(t.key)||(r?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(T.$XP(i))return P.$trySetDecorations(l,t.key,T.$YP(i));{const f=new Array(4*i.length);for(let u=0,w=i.length;u<w;u++){const S=i[u];f[4*u]=S.start.line+1,f[4*u+1]=S.start.character+1,f[4*u+2]=S.end.line+1,f[4*u+3]=S.end.character+1}return P.$trySetDecorationsFast(l,t.key,f)}}))},revealRange(t,i){o.n(()=>P.$tryRevealRange(l,T.Range.from(t),i||L.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(l,T.ViewColumn.from(t))},hide(){P.$tryHideEditor(l)}})}dispose(){(0,s.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,s.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,s.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,s.ok)(!this.g),this.f=l}_acceptSelections(l){(0,s.ok)(!this.g),this.c=l}async l(){const l=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const P=l.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const b=P.edits.map(m=>m.range);b.sort((m,d)=>m.end.line===d.end.line?m.end.character===d.end.character?m.start.line===d.start.line?m.start.character-d.start.character:m.start.line-d.start.line:m.end.character-d.end.character:m.end.line-d.end.line);for(let m=0,d=b.length-1;m<d;m++){const g=b[m].end;if(b[m+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=P.edits.map(m=>({range:T.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,c,{setEndOfLine:typeof P.setEndOfLine=="number"?T.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$0P=k}),define(Ee[64],Se([1,0,66,4,3,2,5,6,164,20,168,16,12,29,15,40,49]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,s=We(s),E=We(E);class d{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Dc,this.d=new h.$ne,this.e=new h.$ne,this.f=new h.$ne,this.g=new h.$ne,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],i=[],r=[];if(o.removedDocuments)for(const f of o.removedDocuments){const u=T.URI.revive(f),w=this.c.get(u);w?.unref()&&(this.c.delete(u),t.push(w.value))}if(o.addedDocuments)for(const f of o.addedDocuments){const u=T.URI.revive(f.uri);let w=this.c.get(u);if(w&&u.scheme!==b.Schemas.vscodeNotebookCell&&u.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);w||(w=new d(new $.$4P(this.h.getProxy(R.$uN.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(u,w),i.push(w.value)),w.ref()}if(o.removedEditors)for(const f of o.removedEditors){const u=this.b.get(f);this.b.delete(f),u&&r.push(u)}if(o.addedEditors)for(const f of o.addedEditors){const u=T.URI.revive(f.documentUri);s.ok(this.c.has(u),`document '${u}' does not exist`),s.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const w=this.c.get(u).value,S=new k.$0P(f.id,this.h.getProxy(R.$uN.MainThreadTextEditors),this.i,new m.$X(()=>w.document),f.selections.map(E.Selection.to),f.options,f.visibleRanges.map(D=>E.Range.to(D)),typeof f.editorPosition=="number"?E.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,S)}o.newActiveEditor!==void 0&&(s.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,I.$Sc)(t),(0,I.$Sc)(r),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(i),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return c.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=g,e.$$P=g=Xe([Ve(0,a.$1P),Ve(1,l.$ak)],g),e.$_P=(0,L.$Gi)("IExtHostDocumentsAndEditors")}),define(Ee[99],Se([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,166,16,10,315,74,121,75,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=e.$wpc=e.$vpc=e.$upc=void 0,n=We(n);let w=0;const S=new WeakMap;e.$upc=(0,l.$Gi)("IExtHostTesting");let D=class extends $.$Xc{constructor(B,G,X,ee){super(),this.C=G,this.D=X,this.F=ee,this.f=this.B(new T.$ne),this.g=new Map,this.w=this.B(new T.$ne),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=B.getProxy(b.$uN.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,G),X.registerArgumentProcessor({processArgument:de=>{switch(de?.$mid){case a.MarshalledId.TestItemContext:{const ne=de,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$TI.root(De))?.collection.tree.get(De)?.actual??(0,g.$aQ)(de)}case a.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=de,$e=ne.item.extId;return{test:this.g.get(i.$TI.root($e))?.collection.tree.get($e)?.actual??(0,g.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return de}}}),X.registerCommand(!1,"testing.getExplorerSelection",async()=>{const de=await X.executeCommand(t.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(i.$TI.root(De));if($e)return i.$TI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:de?.include.map(ne).filter(k.$og)||[],exclude:de?.exclude.map(ne).filter(k.$og)||[]}})}createTestController(B,G,X,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const de=new $.$Wc,ne=de.add(new g.$dQ(G,X,this.F));ne.root.label=X;const De=new Map,$e=new Set,J=this.h,U={items:ne.root.children,get label(){return X},set label(ae){X=ae,ne.root.label=ae,J.$updateController(G,{label:X})},get refreshHandler(){return ee},set refreshHandler(ae){ee=ae,J.$updateController(G,{canRefresh:!!ae})},get id(){return G},createRunProfile:(ae,te,le,ue,Z,oe)=>{let pe=(0,R.$uj)(ae);for(;De.has(pe);)pe++;return new M(this.h,De,$e,this.w.event,G,pe,ae,te,le,ue,Z,oe)},createTestItem(ae,te,le){return new g.$bQ(G,ae,te,le)},createTestRun:(ae,te,le=!0)=>this.j.createTestRun(B,G,ne,ae,te,le),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const te=ae instanceof Array?ae:[ae];this.h.$markTestRetired(te.map(le=>i.$TI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(ae){ne.resolveHandler=ae},get resolveHandler(){return ne.resolveHandler},dispose:()=>{de.dispose()}};J.$registerTestController(G,X,!!ee),de.add((0,$.$Vc)(()=>J.$unregisterTestController(G)));const se={controller:U,collection:ne,profiles:De,extension:B,activeProfiles:$e};return this.g.set(G,se),de.add((0,$.$Vc)(()=>this.g.delete(G))),de.add(ne.onDidGenerateDiff(ae=>J.$publishDiff(G,ae.map(f.TestsDiffOp.serialize)))),U}createTestObserver(){return this.m.checkout()}async runTests(B,G=I.CancellationToken.None){const X=v(B);if(!X)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(X.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:B.preserveFocus??!0,group:V[X.kind],targets:[{testIds:B.include?.map(de=>i.$TI.fromExtHostTestItem(de,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:X.profileId,controllerId:X.controllerId}],exclude:B.exclude?.map(de=>de.id)},G)}registerTestFollowupProvider(B){return this.y.add(B),{dispose:()=>{this.y.delete(B)}}}$syncTests(){for(const{collection:B}of this.g.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,G,X){return(await this.j.getCoverageDetails(B,G,X))?.map(n.TestCoverage.fromDetails)}async $disposeRun(B){this.j.disposeTestRun(B)}$configureRunProfile(B,G){this.g.get(B)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(B){const G=new Map;for(const[X,ee]of Object.entries(B)){const de=this.g.get(X);if(!de)continue;const ne=new Map,De=ee.filter(J=>!de.activeProfiles.has(J)),$e=[...de.activeProfiles].filter(J=>!ee.includes(J));for(const J of De)ne.set(J,!0),de.activeProfiles.add(J);for(const J of $e)ne.set(J,!1),de.activeProfiles.delete(J);ne.size&&G.set(X,ne)}this.w.fire(G)}async $refreshTests(B,G){await this.g.get(B)?.controller.refreshHandler?.(G)}$publishTestResults(B){this.results=Object.freeze(B.map(G=>{const X=n.TestResults.to(G);return S.set(X,G.id),X}).concat(this.results).sort((G,X)=>X.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(B,G){const X=this.g.get(i.$TI.fromString(B).controllerId)?.collection;X&&(await X.expand(B,G<0?1/0:G),X.flushDiff())}$acceptDiff(B){this.m.applyDiff(B.map(G=>f.TestsDiffOp.deserialize({asCanonicalUri:X=>X},G)))}async $runControllerTests(B,G){return Promise.all(B.map(X=>this.G(X,!1,G)))}async $startContinuousRun(B,G){const X=new I.$ye(G),ee=await Promise.all(B.map(de=>this.G(de,!0,X.token)));return!G.isCancellationRequested&&!ee.some(de=>de.error)&&await new Promise(de=>G.onCancellationRequested(de)),X.dispose(!0),ee}async $provideTestFollowups(B,G){const X=this.results.find(ne=>S.get(ne)===B.resultId),ee=X&&K(i.$TI.fromString(B.extId),X?.results);if(!ee)return[];let de=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(X,ee,B.taskIndex,B.messageIndex,G);De&&(de=de.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:de.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(B){for(const G of B)this.z.delete(G)}$executeTestFollowup(B){const G=this.z.get(B);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B){B===void 0?this.j.cancelAllRuns():this.j.cancelRunById(B)}getMetadataForRun(B){for(const G of this.j.trackers){const X=G.getTaskIdForRun(B);if(X)return{taskId:X,runId:G.id}}}async G(B,G,X){const ee=this.g.get(B.controllerId);if(!ee)return{};const{collection:de,profiles:ne,extension:De}=ee,$e=ne.get(B.profileId);if(!$e)return{};const J=B.testIds.map(te=>de.tree.get(te)).filter(k.$og),U=B.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(k.$og).filter(te=>J.some(le=>le.fullId.compare(te.fullId)===i.TestPosition.IsChild));if(!J.length)return{};const se=new o.$0O(J.some(te=>te.actual instanceof g.$cQ)?void 0:J.map(te=>te.actual),U.map(te=>te.actual),$e,G),ae=(0,f.$WI)(B)&&this.j.prepareForMainThreadTestRun(De,se,F.fromInternal(B,ee.collection),$e,X);try{return await $e.runHandler(se,X),{}}catch(te){return{error:String(te)}}finally{ae&&ae.hasRunningTasks&&!X.isCancellationRequested&&await T.Event.toPromise(ae.onEnd)}}};e.$vpc=D,e.$vpc=D=Xe([Ve(0,d.$1P),Ve(1,P.$ak),Ve(2,c.$kQ),Ve(3,m.$_P)],D);const y=1e4;var C;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(C||(C={}));class A extends $.$Xc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(B,G,X,ee,de,ne){super(),this.z=B,this.C=G,this.D=X,this.F=ee,this.G=de,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$ne),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new I.$ye(ne));const De=this.B(new s.$Sh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new T.$ne;this.w=$e.event,this.B((0,$.$Vc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(B){for(const[G,{run:X}]of this.g)if(X===B)return G}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}async getCoverageDetails(B,G,X){const[,ee]=i.$TI.fromString(B).path,de=this.y.get(B);if(!de)return[];const{report:ne,extIds:De}=de,$e=this.g.get(ee);if(!$e)throw new Error("unreachable: run task was not found");let J;if(G&&ne instanceof o.$cP){const se=De.indexOf(G);if(se===-1)return[];J=ne.fromTests[se]}return await(J?this.F?.loadDetailedCoverageForTest?.($e.run,ne,J,X):this.F?.loadDetailedCoverage?.($e.run,ne,X))??[]}createRun(B){const G=this.z.id,X=this.z.controllerId,ee=(0,E.$3g)(),de=J=>(U,...se)=>{if(De){this.D.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}this.J(U),J(U,...se)},ne=(J,U)=>{const se=U instanceof Array?U.map(n.TestMessage.from):[n.TestMessage.from(U)];if(J.uri&&J.range){const ae={range:n.Range.from(J.range),uri:J.uri};for(const te of se)te.location=te.location||ae}this.C.$appendTestMessagesInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),se)};let De=!1;const $e={isPersisted:this.z.isPersisted,token:this.j.token,name:B,onDidDispose:this.w,addCoverage:J=>{if(De)return;const U=J instanceof o.$cP?J.fromTests:[];if(U.length){(0,u.$7G)(this.G,"attributableCoverage");for(const te of U)this.J(te)}const se=J.uri.toString(),ae=new i.$TI([G,ee,se]).toString();this.y.set(ae,{report:J,extIds:U.map(te=>i.$TI.fromExtHostTestItem(te,X).toString())}),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(X,ae,J))},enqueued:de(J=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),f.TestResultState.Queued)}),skipped:de(J=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),f.TestResultState.Skipped)}),started:de(J=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),f.TestResultState.Running)}),errored:de((J,U,se)=>{ne(J,U),this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),f.TestResultState.Errored,se)}),failed:de((J,U,se)=>{ne(J,U),this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,X).toString(),f.TestResultState.Failed,se)}),passed:de((J,U)=>{this.C.$updateTestStateInRun(G,ee,i.$TI.fromExtHostTestItem(J,this.z.controllerId).toString(),f.TestResultState.Passed,U)}),appendOutput:(J,U,se)=>{De||(se&&this.J(se),this.C.$appendOutputToRun(G,ee,h.$Pe.fromString(J),U&&n.location.from(U),se&&i.$TI.fromExtHostTestItem(se,X).toString()))},end:()=>{De||(De=!0,this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:$e}),this.C.$startedTestRunTask(G,{id:ee,name:B,running:!0}),$e}H(){for(const{run:B}of this.g.values())B.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(B){if(!(B instanceof g.$bQ))throw new r.$SP(B.id);if(this.h.has(i.$TI.fromExtHostTestItem(B,this.z.controllerId).toString()))return;const G=[],X=this.z.colllection.root;for(;;){const ee=n.TestItem.from(B);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),B===X))break;B=B.parent||X}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(B,G){this.g=B,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(B,G,X){const ee=i.$TI.root(B);return this.f.get(ee)?.getCoverageDetails(B,G,X)||[]}disposeTestRun(B){this.f.get(B)?.dispose(),this.f.delete(B);for(const[G,{id:X}]of this.c)X===B&&this.c.delete(G)}prepareForMainThreadTestRun(B,G,X,ee,de){return this.j(G,X,ee,B,de)}cancelRunById(B){this.f.get(B)?.cancel()}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,G,X,ee,de,ne){const De=this.c.get(ee);if(De)return De.createRun(de);const $e=F.fromPublic(G,X,ee,ne),J=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:J&&{group:V[J.kind],id:J.profileId},exclude:ee.exclude?.map(se=>i.$TI.fromExtHostTestItem(se,X.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>i.$TI.fromExtHostTestItem(se,X.root.id).toString())??[X.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const U=this.j(ee,$e,ee.profile,B);return T.Event.once(U.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),U.createRun(de)}j(B,G,X,ee,de){const ne=new A(G,this.g,this.h,X,ee,de);return this.c.set(B,ne),this.f.set(ne.id,ne),ne}}e.$wpc=p;const v=re=>{if(re.profile){if(!(re.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class F{static fromPublic(B,G,X,ee){return new F(B,(0,E.$3g)(),ee,G)}static fromInternal(B,G){return new F(B.controllerId,B.runId,!0,G)}constructor(B,G,X,ee){this.controllerId=B,this.id=G,this.isPersisted=X,this.colllection=ee}}e.$xpc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,n.TestItem.toPlain(B.item)),this.c.has(B)||this.f.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.f.delete(B);const G=i.$TI.parentId(B.item.extId);if(G&&this.h.has(G.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{c:B,f:G,g:X}=this;return{get added(){return[...B].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...X].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class O extends f.$3I{constructor(){super(...arguments),this.y=new T.$ne,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}x(B,G){return{...B,revived:n.TestItem.toPlain(B.item),depth:G?G.depth+1:0,children:new Set}}w(){return new N(this.y)}}class j{constructor(B){this.f=B}checkout(){this.c||(this.c=this.g());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(G=>G.revived)},dispose:(0,L.$gb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}g(){const B=new O({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}const z=(re,B,G,X)=>{G?Object.assign(G,X):B.$updateTestRunConfig(re.controllerId,re.profileId,X)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,z(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,z(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,z(this,this.#e,this.#n,{tag:B?n.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,z(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return T.Event.chain(this.#i,B=>B.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(k.$og))}constructor(B,G,X,ee,de,ne,De,$e,J,U=!1,se=void 0,ae=!1){this.controllerId=de,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=J,this._tag=se,this.g=ae,this.#e=B,this.#s=G,this.#t=X,this.#i=ee,G.set(ne,this);const te=V[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);U&&X.add(ne),this.#n={profileId:ne,controllerId:de,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:U,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$ypc=M;const V={[o.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function K(re,B){for(let G=0;G<re.path.length;G++){const X=B.find(ee=>ee.id===re.path[G]);if(!X)return;if(G===re.path.length-1)return X;B=X.children}}}),define(Ee[371],Se([1,0,19,4,3,6,168,16,10]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,s=We(s),R=We(R);class a extends I.$Xc{constructor(E,l){super(),this.m=l,this.a=new h.$ne,this.b=new h.$ne,this.c=new h.$ne,this.f=new h.$ne,this.g=new h.$ne,this.h=new h.$ne,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(T.$uN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const l=this.m.allEditors();return E?l:l.map(P=>P.value)}async showTextDocument(E,l,P){let b;typeof l=="number"?b={position:R.ViewColumn.from(l),preserveFocus:P}:typeof l=="object"?b={position:R.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?R.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:b={preserveFocus:!1};const c=await this.j.$tryShowTextDocument(E.uri,b),m=c&&this.m.getEditor(c);if(m)return m.value;throw c?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,l){return new L.$8P(this.j,E,l).value}$acceptEditorPropertiesChanged(E,l){const P=this.m.getEditor(E);if(!P)throw new Error("unknown text editor");if(l.options&&P._acceptOptions(l.options),l.selections){const b=l.selections.selections.map(R.Selection.to);P._acceptSelections(b)}if(l.visibleRanges){const b=s.$Kb(l.visibleRanges.map(R.Range.to));P._acceptVisibleRanges(b)}if(l.options&&this.b.fire({textEditor:P.value,options:{...l.options,lineNumbers:R.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const b=$.TextEditorSelectionChangeKind.fromValue(l.selections.source),c=l.selections.selections.map(R.Selection.to);this.a.fire({textEditor:P.value,selections:c,kind:b})}if(l.visibleRanges){const b=s.$Kb(l.visibleRanges.map(R.Range.to));this.c.fire({textEditor:P.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const l in E){const P=this.m.getEditor(l);if(!P)throw new Error("Unknown text editor");const b=R.ViewColumn.to(E[l]);P.value.viewColumn!==b&&(P._acceptViewColumn(b),this.f.fire({textEditor:P.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$Foc=a}),define(Ee[372],Se([1,0,2,5,6,3,10,16,24,41,18]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0,e.$qqc=(0,h.$Gi)("IExtHostTimeline");class E{constructor(b,c){this.b=new Map,this.c=new Map,this.a=b.getProxy(I.$uN.MainThreadTimeline),c.registerArgumentProcessor({processArgument:(m,d)=>{if(m&&m.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&$.$rn.equals(d,this.b.get(m.source)?.extension)){const g=m.uri===void 0?void 0:s.URI.revive(m.uri);return this.c.get(m.source)?.get(l(g))?.get(m.handle)}else return;return m}})}async $getTimeline(b,c,m,d){return this.b.get(b)?.provider.provideTimeline(s.URI.revive(c),m,d)}registerTimelineProvider(b,c,m,d){const g=new T.$Wc,n=this.d(c.id,d,g).bind(this);let o;c.onDidChange&&(o=c.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:c.id}),this));const t=this.c;return this.f({...c,scheme:b,onDidChange:void 0,async provideTimeline(i,r,f){r?.resetCache&&(g.clear(),t.get(c.id)?.clear());const u=await c.provideTimeline(i,r,f);if(u==null)return;const w=n(i,r);return{...u,source:c.id,items:u.items.map(w)}},dispose(){for(const i of t.values())i.get(c.id)?.clear();o?.dispose(),g.dispose()}},m)}d(b,c,m){return(d,g)=>{let n;if(g?.cacheResults){let o=this.c.get(b);o===void 0&&(o=new Map,this.c.set(b,o));const t=l(d);n=o.get(t),n===void 0&&(n=new Map,o.set(t,n))}return o=>{const{iconPath:t,...i}=o,r=`${b}|${o.id??o.timestamp}`;n?.set(r,o);let f,u,w;o.iconPath&&(t instanceof L.$tO?w={id:t.id,color:t.color}:s.URI.isUri(t)?(f=t,u=t):{light:f,dark:u}=t);let S;return L.$YN.isMarkdownString(i.tooltip)?S=R.MarkdownString.from(i.tooltip):(0,k.$gg)(i.tooltip)?S=i.tooltip:L.$YN.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=R.MarkdownString.from(i.detail)):(0,k.$gg)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=i.detail),{...i,id:i.id??void 0,handle:r,source:b,command:o.command?c.toInternal(o.command,m):void 0,icon:f,iconDark:u,themeIcon:w,tooltip:S,accessibilityInformation:o.accessibilityInformation}}}}f(b,c){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:c}),(0,T.$Vc)(()=>{for(const d of this.c.values())d.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$rqc=E;function l(P){return P?.toString()}}),define(Ee[373],Se([1,0,243,23,2,4,3,305,9,10,18,19,16,86,21,199,26]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0,a=We(a);function d(o,t){if((0,k.$gg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let i;return Array.isArray(o.highlights)&&(i=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:o.label,highlights:i}}}class g extends L.$Xc{constructor(t,i,r){super(),this.f=t,this.g=i,this.h=r,this.a=new Map,this.b=new c.$w_;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>f(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(w=>f(w)?this.r(w):w):u})}registerTreeDataProvider(t,i,r){const f=this.createTreeView(t,{treeDataProvider:i},r);return{dispose:()=>f.dispose()}}createTreeView(t,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],w=!!i.dragAndDropController?.handleDrag,S=!!i.dragAndDropController?.handleDrop,D=this.m(t,i,r),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:w,hasHandleDrop:S,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$7G)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$7G)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(p){(0,P.$6k)(p)&&(0,m.$7G)(r,"treeViewMarkdownMessage"),D.message=p},get title(){return D.title},set title(p){D.title=p},get description(){return D.description},set description(p){D.description=p},get badge(){return D.badge},set badge(p){p!==void 0&&a.ViewBadge.isViewBadge(p)?D.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(D.badge=void 0)},reveal:(p,v)=>D.reveal(p,v),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,i){const r=this.a.get(t);return r?r.getChildren(i):Promise.reject(new R.$qG(t))}async $handleDrop(t,i,r,f,u,w,S,D){const y=this.a.get(t);if(!y)return Promise.reject(new R.$qG(t));const C=l.DataTransfer.toDataTransfer(r,async A=>(await this.f.$resolveDropFileData(t,i,A)).buffer);return S===t&&D&&await this.j(C,y,D,u,w),y.onDrop(C,f,u)}async j(t,i,r,f,u){const w=this.b.removeDragOperationTransfer(u);if(w)(await w)?.forEach((S,D)=>{S&&t.set(D,S)});else if(u&&i.handleDrag){const S=i.handleDrag(r,t,f);this.b.addDragOperationTransfer(u,S),await S}return t}async $handleDrag(t,i,r,f){const u=this.a.get(t);if(!u)return Promise.reject(new R.$qG(t));const w=await this.j(new a.$pO,u,i,f,r);if(!(!w||f.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(t){const i=this.a.get(t);if(!i)throw new R.$qG(t);return i.hasResolve}$resolve(t,i,r){const f=this.a.get(t);if(!f)throw new R.$qG(t);return f.resolveTreeItem(i,r)}$setExpanded(t,i,r){const f=this.a.get(t);if(!f)throw new R.$qG(t);f.setExpanded(i,r)}$setSelectionAndFocus(t,i,r){const f=this.a.get(t);if(!f)throw new R.$qG(t);f.setSelectionAndFocus(i,r)}$setVisible(t,i){const r=this.a.get(t);if(!r){if(!i)return;throw new R.$qG(t)}r.setVisible(i)}$changeCheckboxState(t,i){const r=this.a.get(t);if(!r)throw new R.$qG(t);r.setCheckboxState(i)}m(t,i,r){const f=this.B(new n(t,i,this.f,this.g.converter,this.h,r));return this.a.set(t,f),f}r(t){const i=this.a.get(t.$treeViewId);return i&&"$treeItemHandle"in t?i.getExtensionElement(t.$treeItemHandle):i&&"$focusedTreeItem"in t&&t.$focusedTreeItem?i.focusedElement:null}}e.$sqc=g;class n extends L.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.$pg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,i,r,f,u,w){if(super(),this.I=t,this.J=r,this.L=f,this.M=u,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$ne),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$ne),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$ne),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$ne),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$ne),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$ne),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$ne),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$ye,w.contributes&&w.contributes.views)for(const C in w.contributes.views)for(const A of w.contributes.views[C])A.id===t&&(this.P=A.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,D;const y=T.Event.debounce(this.F.event,(C,A)=>(C||(C={message:!1,elements:[]}),A.element!==!1&&(S||(S=new Promise(p=>D=p),this.G=this.G.then(()=>S)),Array.isArray(A.element)?C.elements.push(...A.element):C.elements.push(A.element)),A.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const p=D;return S=null,this.$(A).then(()=>p())})),C&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const i=t?this.getExtensionElement(t):void 0;if(t&&!i)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let r=this.X(t);return r||(r=await this.Y(i)),r?r.map(f=>f.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,i){i=i||{select:!0,focus:!1};const r=(0,k.$pg)(i.select)?!0:i.select,f=(0,k.$pg)(i.focus)?!1:i.focus,u=(0,k.$pg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(w=>this.W(t,w[w.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:w.map(D=>D.item)},{select:r,focus:f,expand:u})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:f,expand:u})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=l.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,i){const r=this.getExtensionElement(t);r&&(i?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(t,i){const r=!(0,E.$xb)(this.s,t);this.s=t;const f=this.t!==i;this.t=i,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const i=(await Promise.all(t.map(async r=>{const f=this.getExtensionElement(r.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:r.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(t,i,r){const f=[];for(const u of t){const w=this.getExtensionElement(u);w&&f.push(w)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,i,r),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,i,r){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.g?.handleDrop))return(0,$.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(f,t,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,i){if(!this.f.resolveTreeItem)return;const r=this.j.get(t);if(r){const f=this.m.get(r);if(f){const u=await this.f.resolveTreeItem(f.extensionItem,r,i)??f.extensionItem;return this.hb(u),f.item.tooltip=this.eb(u.tooltip),f.item.command=this.fb(f.disposableStore,u.command),f.item}}}S(t){return this.U(t).then(i=>i?this.S(i).then(r=>this.W(i,r[r.length-1]).then(f=>(r.push(f),r))):Promise.resolve([]))}U(t){const i=this.m.get(t);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$yh)(()=>this.f.getParent(t))}W(t,i){const r=this.m.get(t);return r?Promise.resolve(r):(0,$.$yh)(()=>this.f.getTreeItem(t)).then(f=>this.kb(t,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const w=this.m.get(u);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let i;if(typeof t=="string"){const r=this.getExtensionElement(t);i=r?this.m.get(r):void 0}else i=t;return i&&i.children||void 0}return this.h}async Y(t){this.rb(t);const i=new b.$ye(this.Z.token);try{const r=t?this.m.get(t):void 0,f=await this.f.getChildren(t);if(i.token.isCancellationRequested)return;const u=(0,E.$Kb)(f||[]),w=await Promise.all((0,E.$Kb)(u).map(D=>this.f.getTreeItem(D)));if(i.token.isCancellationRequested)return;const S=w.map((D,y)=>D?this.db(u[y],D,r):null);return(0,E.$Kb)(S)}finally{i.dispose()}}$(t){if(t.some(r=>!r))return this.Z.dispose(!0),this.Z=new b.$ye,this.tb(),this.J.$refresh(this.I);{const r=this.ab(t);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(t){const i=new Set,r=t.map(u=>this.m.get(u));for(const u of r)if(u&&!i.has(u.item.handle)){let w=u;for(;w&&w.parent&&r.findIndex(S=>w&&w.parent&&S&&S.item.handle===w.parent.item.handle)===-1;){const S=this.j.get(w.parent.item.handle);w=S?this.m.get(S):void 0}w&&!w.parent&&i.add(u.item.handle)}const f=[];return i.forEach(u=>{const w=this.j.get(u);if(w){const S=this.m.get(w);S&&(!S.parent||!i.has(S.parent.item.handle))&&f.push(u)}}),f}bb(t){const i={};return Promise.all(t.map(r=>this.cb(r).then(f=>{f&&(i[r]=f.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(t){const i=this.getExtensionElement(t);if(i){const r=this.m.get(i);if(r)return this.rb(i),(0,$.$yh)(()=>this.f.getTreeItem(i)).then(f=>{if(f){const u=this.ib(i,f,r.parent);return this.pb(i,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(t,i,r){const f=this.ib(t,i,r);if(i.id&&this.j.has(f.item.handle))throw new Error((0,s.localize)(0,null,i.id));return this.ob(t,f),this.qb(f,r),f}eb(t){return a.$YN.isMarkdownString(t)?l.MarkdownString.from(t):t}fb(t,i){return i?{...this.L.toInternal(i,t),originalId:i.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let i,r,f;return typeof t.checkboxState=="number"?i=t.checkboxState:(i=t.checkboxState.state,r=t.checkboxState.tooltip,f=t.checkboxState.accessibilityInformation),{isChecked:i===a.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:f}}hb(t){if(!a.$kO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,i,r){this.hb(i);const f=this.B(new L.$Wc),u=this.kb(t,i,r),w=this.lb(i);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:d(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(f,i.command),contextValue:i.contextValue,icon:w,iconDark:this.mb(i)||w,themeIcon:this.jb(i),collapsibleState:(0,k.$pg)(i.collapsibleState)?a.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:r,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(t){return t.iconPath instanceof a.$tO?t.iconPath:void 0}kb(t,{id:i,label:r,resourceUri:f},u,w){if(i)return`${n.b}/${i}`;const S=d(r,this.N),D=u?u.item.handle:n.a;let y=S?S.label:f?(0,h.$eh)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(u)||[];let p,v=0;do{if(p=`${D}/${v}:${y}`,w||!this.j.has(p)||C===p)break;v++}while(v<=A.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO))return typeof t.iconPath=="string"||I.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return I.URI.isUri(t)?t:I.URI.file(t)}ob(t,i){this.j.set(i.item.handle,t),this.m.set(t,i)}pb(t,i,r,f){this.j.delete(i.item.handle),this.m.delete(t),i.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(t,i);const u=this.X(f)||[],w=u.filter(S=>S.item.handle===r.item.handle)[0];w&&u.splice(u.indexOf(w),1,i)}qb(t,i){i?(i.children||(i.children=[]),i.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const i=this.m.get(t);if(i){if(i.children)for(const r of i.children){const f=this.j.get(r.item.handle);f&&this.sb(f)}i.children=void 0}}else this.tb()}sb(t){const i=this.m.get(t);if(i){if(i.children)for(const r of i.children){const f=this.j.get(r.item.handle);f&&this.sb(f)}this.m.delete(t),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[374],Se([1,0,4,3,2,32,16,97,6,10]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0,L=We(L),$=We($),a=We(a);class k extends h.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(b,c,m,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new s.$ne),this.onDidDispose=this.#d.event,this.#h=this.B(new s.$ne),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=c,this.#n=m,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#l=b.active,this.#c=b.visible,this.#o=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:L.ViewColumn.from(b),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Xc{static c(){return(0,T.$3g)()}constructor(b,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=b.getProxy($.$uN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,c,m,d,g={}){const n=typeof d=="object"?d.viewColumn:d,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,R.$Uoc)(b),i=E.c();this.f.$createWebviewPanel((0,R.$Woc)(b),i,c,{title:m,panelOptions:l(g),webviewOptions:(0,R.$Xoc)(b,this.m,g),serializeBuffersForPostMessage:t},o);const r=this.j.createNewWebview(i,g,b);return this.createNewWebviewPanel(i,c,m,n,g,r,!0)}$onDidChangeWebviewPanelViewStates(b){const c=Object.keys(b);c.sort((m,d)=>{const g=b[m],n=b[d];return g.active?1:n.active?-1:+g.visible-+n.visible});for(const m of c){const d=this.getWebviewPanel(m);if(!d)continue;const g=b[m];d._updateViewState({active:g.active,visible:g.visible,viewColumn:L.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:b}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.$Uoc)(b)}),new a.$wN(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(b,c,m,d){const g=this.h.get(c);if(!g)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:o}=g,t=this.j.createNewWebview(b,m.webviewOptions,o),i=this.createNewWebviewPanel(b,c,m.title,d,m.panelOptions,t,m.active);await n.deserializeWebviewPanel(i,m.state)}createNewWebviewPanel(b,c,m,d,g,n,o){const t=new k(b,this.f,n,{viewType:c,title:m,viewColumn:d,panelOptions:g,active:o});return this.g.set(b,t),t}getWebviewPanel(b){return this.g.get(b)}}e.$Yoc=E;function l(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(Ee[375],Se([1,0,4,3,97,16,6,10]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0,L=We(L),R=We(R);class $ extends h.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,l,P,b,c,m){super(),this.#s=!1,this.#l=this.B(new s.$ne),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new s.$ne),this.onDidDispose=this.#u.event,this.#i=P,this.#a=b,this.#e=E,this.#t=l,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(E,l){this.d=l,this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$uN.MainThreadWebviewViews)}registerWebviewViewProvider(E,l,P,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:P,extension:E}),this.a.$registerWebviewViewProvider((0,I.$Woc)(E),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Uoc)(E)}),new R.$wN(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(E,l,P,b,c){const m=this.b.get(l);if(!m)throw new Error(`No view provider found for '${l}'`);const{provider:d,extension:g}=m,n=this.d.createNewWebview(E,{},g),o=new $(E,this.a,l,P,n,!0);this.c.set(E,o),await d.resolveWebviewView(o,{state:b},c)}async $onDidChangeWebviewViewVisibility(E,l){this.e(E)._setVisible(l)}async $disposeWebviewView(E){const l=this.e(E);this.c.delete(E),l.dispose(),this.d.deleteWebview(E)}e(E){const l=this.c.get(E);if(!l)throw new Error("No webview found");return l}}e.$vqc=a}),define(Ee[376],Se([1,0,76,15,12,277,28,11]),function(ce,e,s,h,I,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;let $=class{constructor(E,l){E.addFileSystemProvider(h.Schemas.file,new a(l),{isCaseSensitive:R.$k})}};e.$arc=$,e.$arc=$=Xe([Ve(0,s.$Qoc),Ve(1,I.$ak)],$);class a{constructor(E){this.b=E,this.a=new T.$rr(this.b)}async stat(E){const l=await this.a.stat(E);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,l,P){return this.a.writeFile(E,l,{...P,unlock:!1,atomic:!1})}delete(E,l){return this.a.delete(E,{...l,useTrash:!1,atomic:!1})}rename(E,l,P){return this.a.rename(E,l,P)}copy(E,l,P){return this.a.copy(E,l,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,l){throw new Error("Method not implemented.")}}}),define(Ee[377],Se([1,0,17,68,32,35,3,6,2,20]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0;let k=class extends L.$Xc{constructor(l,P){super();const b=l.getProxy(R.$uN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,s.$mc)((0,h.tmpdir)(),(0,I.$3g)()));return await b.$download(c,m),m})}};e.$$qc=k,e.$$qc=k=Xe([Ve(0,a.$1P),Ve(1,T.$kQ)],k)}),define(Ee[378],Se([1,0,61,17,2,98,3,15,9,34]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,s=We(s),h=We(h);class k extends T.$Soc{constructor(){super(...arguments),this.i=null}async g(i){const r=await super.g(i);if(r.scheme!==R.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const f=r.fsPath;let u=0;do{let w;u===0?w=f:w=/[/\\]$/.test(f)?`${f.substr(0,f.length-1)}-${u}`:`${f}-${u}`,await E(w);const S=h.$mc(w,"vscode.lock"),D=await c(this.d,S,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),I.URI.file(w);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$krc=k;async function E(t){try{await a.Promises.stat(t);return}catch{}try{await a.Promises.mkdir(t,{recursive:!0})}catch{}}const l=1e3,P=10*60*1e3;class b extends L.$Xc{constructor(i,r){super(),this.b=i,this.c=r,this.a=this.B(new $.$Rh),this.a.cancelAndSet(async()=>{const f=await m(i,r);(!f||f.pid!==process.pid)&&(i.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await a.Promises.utimes(r,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${r}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{s.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+i};await a.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function c(t,i,r){try{const u={pid:process.pid,willReleaseAt:0};await a.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){t.error(u)}const f=await m(t,i);return!f||f.pid!==process.pid?r?(t.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),n(t,i)):(t.info(`Lock '${i}': Lock acquired.`),new b(t,i))}async function m(t,i){let r;try{r=await a.Promises.readFile(i)}catch(f){return t.error(f),null}try{return JSON.parse(String(r))}catch(f){return t.error(f),null}}async function d(t,i){let r;try{r=await a.Promises.stat(i)}catch(f){return t.error(f),0}return r.mtime.getTime()}function g(t){try{return process.kill(t,0),!0}catch{return!1}}async function n(t,i){const r=await m(t,i);if(!r)return t.info(`Lock '${i}': Could not read pid of lock holder.`),o(t,i);if(r.willReleaseAt){let D=r.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${i}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${i}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,$.$Hh)(Math.min(100,D)),await d(t,i)===0)return o(t,i);D=r.willReleaseAt-Date.now()}return o(t,i)}}if(!g(r.pid))return t.info(`Lock '${i}': The pid ${r.pid} appears to be gone.`),o(t,i);const f=await d(t,i),u=Date.now()-f;if(u<=P)return t.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;t.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,$.$Hh)(2e3);const w=await d(t,i),S=Date.now()-w;return S<=P?(t.info(`Lock '${i}': The lock does not look stale, elapsed: ${S} ms, giving up.`),null):(t.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),o(t,i))}async function o(t,i){t.info(`Lock '${i}': Deleting a stale lock.`);try{await a.Promises.unlink(i)}catch{}return c(t,i,!0)}}),define(Ee[379],Se([1,0,32,20,47,35]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0;let L=class extends I.$cpc{constructor($,a){super(!0,$,a)}createTerminal($,a,k){return this.createTerminalFromOptions({name:$,shellPath:a,shellArgs:k})}createTerminalFromOptions($,a){const k=new I.$bpc(this.a,(0,s.$3g)(),$,$.name);return this.f.push(k),k.create($,this.R($,a)),k.value}};e.$Fqc=L,e.$Fqc=L=Xe([Ve(0,T.$kQ),Ve(1,h.$1P)],L)}),define(Ee[380],Se([1,0,4,37,36,5]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.OutputChannelUpdateMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0,e.$CM="text/x-code-output",e.$DM="output",e.$EM="Log",e.$FM="text/x-code-log-output",e.$GM="log",e.$HM="workbench.panel.output",e.$IM=new I.$Xj("inOutput",!1),e.$JM=new I.$Xj("activeLogOutput",!1),e.$KM=new I.$Xj("activeLogOutput.levelSettable",!1),e.$LM=new I.$Xj("activeLogOutput.level",""),e.$MM=new I.$Xj("activeLogOutput.levelIsDefault",!1),e.$NM=new I.$Xj("outputView.scrollLock",!1),e.$OM=(0,T.$Gi)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$PM={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new s.$ne,this.onDidRegisterChannel=this.b.event,this.c=new s.$ne,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(k=>a.push(k)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}h.$ro.add(e.$PM.OutputChannels,new R),e.$QM=new I.$Xj("activeOutputChannel","")}),define(Ee[169],Se([1,0,6,5,20,24,12,380,76,30,63,204,22,18,28,4,3]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=e.$$pc=void 0;class d extends L.$gk{get disposed(){return this.n}constructor(t,i,r,f,u){super(),this.id=t,this.name=i,this.r=r,this.s=f,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const i=this.m;this.info(t),this.s.$update(this.id,R.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(t,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:i))}hide(){this.s.$close(this.id)}g(t,i){this.m+=l.$Pe.fromString(i).byteLength,(0,L.log)(this.r,t,i),this.visible&&(this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class g extends d{appendLine(t){this.append(t)}}let n=class{constructor(t,i,r,f,u,w){this.i=i,this.j=r,this.k=f,this.l=u,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(s.$uN.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,E.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[i,r]of this.g)r.visible=i===this.h}createOutputChannel(t,i,r){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,u=(0,P.$gg)(i)?i:void 0;if((0,P.$gg)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const S=this.i.environment.extensionLogLevel?.find(([y])=>T.$rn.equals(r.identifier,y))?.[1];S&&(w=(0,L.$rk)(S));const D=f?this.o(t,w,r):this.n(t,u,r);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(t,w??this.m.getLevel(),D):this.q(t,D)}async n(t,i,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,u=this.k.extUri.joinPath(f,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,u,i,r.identifier.value);return new d(S,t,w,this.a,r)}async o(t,i,r){const f=await this.p(r),u=t.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(f,`${u}.log`),S=`${r.identifier.value}.${u}`,D=this.l.createLogger(w,{id:S,name:t,logLevel:i,extensionId:r.identifier.value});return new g(S,t,D,this.a,r)}p(t){let i=this.d.get(t.identifier.value);if(!i){const r=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(r)}catch(f){if((0,b.$ql)(f)!==b.FileSystemProviderErrorCode.FileExists)throw f}return r})())}return i}q(t,i){let r=!1;const f=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return t},append(u){f(),i.then(w=>w.append(u))},appendLine(u){f(),i.then(w=>w.appendLine(u))},clear(){f(),i.then(u=>u.clear())},replace(u){f(),i.then(w=>w.replace(u))},show(u,w){f(),i.then(S=>S.show(u,w))},hide(){f(),i.then(u=>u.hide())},dispose(){r=!0,i.then(u=>u.dispose())}}}r(t,i,r){const f=new m.$Wc,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},w=f.add(new c.$ne);function S(D){i=D,w.fire(D)}return r.then(D=>{f.add(D),D.logLevel!==i&&S(D.logLevel),f.add(D.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,r),get logLevel(){return i},onDidChangeLogLevel:w.event,trace(D,...y){u(),r.then(C=>C.trace(D,...y))},debug(D,...y){u(),r.then(C=>C.debug(D,...y))},info(D,...y){u(),r.then(C=>C.info(D,...y))},warn(D,...y){u(),r.then(C=>C.warn(D,...y))},error(D,...y){u(),r.then(C=>C.error(D,...y))},dispose(){f.dispose()}}}};e.$$pc=n,e.$$pc=n=Xe([Ve(0,I.$1P),Ve(1,a.$eQ),Ve(2,$.$Qoc),Ve(3,k.$toc),Ve(4,L.$bk),Ve(5,L.$ak)],n),e.$_pc=(0,h.$Gi)("IExtHostOutputService")}),define(Ee[170],Se([1,0,5,9]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,s.$Gi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let T=1/0;for(let R=0;R<this.maxSampleCount;R++){const $=await I.getRoundTripTime();if($===void 0)return;T=Math.min(T,$/2),await(0,h.$Hh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(T):L=this.initial.reduce((R,$)=>R+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:T,average:this.average.reduce((R,$)=>R+$,0)/this.average.length,high:typeof L>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[381],Se([1,0,247,71,37,46,45,3,4,170,11,25,9,151]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=void 0,e.$3K=Object.freeze({id:"application",order:100,title:(0,s.localize)(0,null),type:"object"}),e.$4K=Object.freeze({id:"workbench",order:7,title:(0,s.localize)(1,null),type:"object"}),e.$5K=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,s.localize)(2,null),type:"object",order:7}),e.$6K=Object.freeze({id:"problems",title:(0,s.localize)(3,null),type:"object",order:101}),e.$7K=Object.freeze({id:"window",order:8,title:(0,s.localize)(4,null),type:"object"}),e.$8K={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new $.$ne,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const c=new b;I.$ro.add(e.$8K.ConfigurationMigration,c);let m=class extends R.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const r of i.added)await this.f(r,c.migrations)})),this.c(c.migrations),this.B(c.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(i=>this.g(i,o?.uri))])}async g(o,t){const i=this.a.inspect(o.key,{resource:t}),r=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[f,u]of r){const w=i[f];if(!w)continue;const S=[];if(w.value!==void 0){const D=await this.h(o,f,w.value,t,void 0);for(const y of D??[])S.push([y,[]])}for(const{identifiers:D,value:y}of w.overrides??[])if(y!==void 0){const C=await this.h(o,f,y,t,D);for(const A of C??[])S.push([A,D])}S.length&&await Promise.allSettled(S.map(async([[D,y],C])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:C},u)))}}async h(o,t,i,r,f){const u=S=>{const y=this.a.inspect(S,{resource:r})[t];if(y)return f?y.overrides?.find(({identifiers:C})=>(0,E.$io)(C,f))?.value:y.value},w=await o.migrateFn(i,u);return Array.isArray(w)?w:[[o.key,w]]}};e.$9K=m,e.$9K=m=Xe([Ve(0,L.$aj),Ve(1,T.$Pi)],m);let d=class extends R.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new l.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!k.$i&&(await this.b.getEnvironment())?.os!==k.OperatingSystem.Windows)return;I.$ro.as(h.$wo.Configuration).registerConfiguration({...e.$5K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,s.localize)(5,null)},default:[],markdownDescription:(0,s.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,s.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$0K=d,e.$0K=d=Xe([Ve(0,a.$Wm)],d),e.$$K="window.newWindowProfile";let g=class extends R.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(i=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(i=>{i.source!==L.ConfigurationTarget.DEFAULT&&i.affectsConfiguration(e.$$K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=I.$ro.as(h.$wo.Configuration),t={...e.$7K,properties:{[e.$$K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(i=>i.name),null],enumItemLabels:[...this.c.profiles.map(i=>""),(0,s.localize)(8,null)],description:(0,s.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$$K);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$$K);if(!o)return;const t=this.b?this.c.profiles.find(i=>i.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$$K,t?.name)}};e.$_K=g,e.$_K=g=Xe([Ve(0,P.$Ml),Ve(1,L.$aj)],g)}),define(Ee[382],Se([1,0,39,15,17,23,259,381,71,5,37]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$bL=e.$aL=void 0,e.$cL=c,e.$dL=m,s=We(s),e.$aL=(0,a.$Gi)("editorResolverService"),e.$bL="workbench.editorAssociations";const E=k.$ro.as($.$wo.Configuration),l={...R.$4K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(l);var P;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(P||(e.RegisteredEditorPriority=P={}));var b;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function c(d){switch(d){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m(d,g){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(g.scheme))return!1;const t=typeof d=="string"&&d.indexOf(I.$jc.sep)>=0?`${g.scheme}:${g.path}`:(0,T.$eh)(g);return s.$zk(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(Ee[383],Se([1,0,33,15,17,11,23,2,5,297,46,158,170]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,$.$Gi)("pathService");let b=P=class{constructor(m,d,g,n){this.d=m,this.e=d,this.f=g,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??m})()}hasValidBasename(m,d,g){return typeof d=="string"||typeof d>"u"?this.a.then(n=>this.h(m,n,d)):this.h(m,d,g)}h(m,d,g){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,s.$Dg)(g??(0,L.$eh)(m),d===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const g=(0,a.$6M)(d.getWorkspace());if(g)return g;const n=d.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=d.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===T.OperatingSystem.Windows?I.$ic:I.$jc)}async fileURI(m){let d="";if(await this.a===T.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(d=m.substring(2),m="/"):(d=m.substring(2,n),m=m.substring(n)||"/")}return R.URI.from({scheme:h.Schemas.file,authority:d,path:m,query:"",fragment:""})}};e.$0M=b,e.$0M=b=P=Xe([Ve(1,l.$Wm),Ve(2,E.$RM),Ve(3,k.$Pi)],b)}),define(Ee[384],Se([1,0,261,59,4,60,3,2,45,266,12,72,152,93,46,158,26,21,18,25,36]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=e.OnPortForward=e.$WM=e.$VM=e.TunnelSource=e.TunnelCloseReason=e.$TM=e.$SM=void 0,e.$UM=u,e.$XM=D,e.$YM=y,e.$ZM=C,e.$1M=p,s=We(s);const t=10*1e3,i="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.$SM="onTunnel",e.$TM=new o.$Xj("forwardedPortsViewEnabled",!1,s.localize(0,null));function u(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var w;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var S;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(S||(e.TunnelSource=S={})),e.$VM={source:S.User,description:s.localize(1,null)},e.$WM={source:S.Auto,description:s.localize(2,null)};function D(N,O,j){const z=N.get(C(O,j));if(z)return z;if((0,P.$Hw)(O))for(const M of P.$Gw){const V=C(M,j);if(N.has(V))return N.get(V)}else if((0,P.$Jw)(O))for(const M of P.$Iw){const V=C(M,j);if(N.has(V))return N.get(V)}}function y(N,O,j){const z=D(N,O,j);if(z)return z;const M=(0,P.$Jw)(O)?"localhost":(0,P.$Hw)(O)?"0.0.0.0":void 0;if(M)return D(N,M,j)}function C(N,O){return N+":"+O}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends L.$Xc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new I.$ne,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,j,z){let M=this.w(O,j,z,this.j,0);const V={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const K=this.j[M];K.key===O?(V.onAutoForward=K.onAutoForward??V.onAutoForward,V.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:V.elevateIfNeeded,V.label=K.label??V.label,V.requireLocalPort=K.requireLocalPort,V.protocol=K.protocol):(V.onAutoForward=V.onAutoForward??K.onAutoForward,V.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:K.elevateIfNeeded,V.label=V.label??K.label,V.requireLocalPort=V.requireLocalPort!==void 0?V.requireLocalPort:void 0,V.protocol=V.protocol??K.protocol),M=this.w(O,j,z,this.j,M+1)}return V.onAutoForward!==void 0||V.elevateIfNeeded!==void 0||V.label!==void 0||V.requireLocalPort!==void 0||V.protocol!==void 0?V:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,g.$gg)(O.host)&&(0,g.$kg)(O.port)}w(O,j,z,M,V){if(V>=M.length)return-1;const K=!(0,P.$Hw)(j)&&!(0,P.$Jw)(j),B=M.slice(V).findIndex(G=>(0,g.$kg)(G.key)?K?!1:G.key===O:this.t(G.key)?K?!1:O>=G.key.start&&O<=G.key.end:this.u(G.key)?O===G.key.port&&j===G.key.host:z?G.key.test(z):!1);return B>=0?B+V:-1}y(){const O=this.r.getValue(v.c);if(!O||!(0,g.$ig)(O))return[];const j=[];for(const M in O){if(M===void 0)continue;const V=O[M];let K;if(Number(M))K=Number(M);else if((0,g.$gg)(M))if(v.g.test(M)){const re=M.match(v.g);K={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(M)){const re=M.match(v.h);K={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(M)}catch{}re&&(K=re)}K&&j.push({key:K,elevateIfNeeded:V.elevateIfNeeded,onAutoForward:V.onAutoForward,label:V.label,requireLocalPort:V.requireLocalPort,protocol:V.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(O){function j(z,M){return(0,g.$kg)(z.key)?z.key:M.t(z.key)?z.key.start:M.u(z.key)?z.key.port:Number.MAX_VALUE}return O.sort((z,M)=>j(z,this)-j(M,this))}C(){return this.m}static providedActionToAction(O){switch(O){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(O,j,z){const V=this.r.inspect(v.c).userRemoteValue;let K;!V||!(0,g.$ig)(V)?K={}:K=(0,n.$eo)(V),K[`${O}`]||(K[`${O}`]={});for(const re in j)K[`${O}`][re]=j[re];return this.r.updateValue(v.c,K,z)}}e.$2M=v;let F=class extends L.$Xc{constructor(O,j,z,M,V,K,re,B,G,X){super(),this.H=O,this.I=j,this.J=z,this.L=M,this.M=V,this.N=K,this.O=re,this.P=B,this.Q=G,this.R=X,this.c=new Map,this.g=new I.$ne,this.onForwardPort=this.g.event,this.h=new I.$ne,this.onClosePort=this.h.event,this.j=new I.$ne,this.onPortName=this.j.event,this.n=new I.$ne,this.onCandidatesChanged=this.n.event,this.t=new I.$ne,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$ne,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const de=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=C(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=y(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:de?.get(ne.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,de?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$VM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const de=C(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!y(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=y(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(de,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$VM})}await this.cb(),this.f.set(de,ee),this.g.fire(this.forwarded.get(de))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$SM))?(this.R.createKey(e.$TM.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,j){const z=C(O.host,O.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(O))}X(O,j){if(O.startsWith("http"))return R.URI.parse(O);const z=j?.protocol??"http";return R.URI.parse(`${z}://${O}`)}async Y(O){const j=this.N.getWorkspace(),z=j.configuration?(0,T.$uj)(j.configuration.path):j.folders.length>0?(0,T.$uj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(i)}async $(){return this.Y(r)}async ab(){const O=this.I.get(i,l.StorageScope.WORKSPACE);if(O)return this.I.remove(i,l.StorageScope.WORKSPACE),await this.cb(),O;const j=await this.Z();if(j)return this.I.get(j,l.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const j=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const M=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==S.Extension&&!M||z.source.source===S.Extension&&M?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===S.Extension&&!M&&this.D.set(C(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Z();this.w=this.B(new L.$Wc),this.w.add(this.I.onDidChangeValue(l.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===O&&(this.s=Promise.resolve(this.I.get(O,l.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const O=this.I.keys(l.StorageScope.PROFILE,l.StorageTarget.USER).filter(j=>j.startsWith(r));for(const j of O){const z=this.I.getNumber(j,l.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(r,i);this.I.remove(j,l.StorageScope.PROFILE),this.I.remove(M,l.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),j=O.map(K=>({remoteHost:K.remoteHost,remotePort:K.remotePort,localPort:K.localPort,name:K.name,localAddress:K.localAddress,localUri:K.localUri,protocol:K.protocol,source:K.source}));let z;O.length>0&&(z=JSON.stringify(j));const M=await this.Z(),V=await this.$();!z&&M&&V?(this.I.remove(M,l.StorageScope.PROFILE),this.I.remove(V,l.StorageScope.PROFILE)):z!==this.y&&M&&V&&(this.I.store(M,z,l.StorageScope.PROFILE,l.StorageTarget.USER),this.I.store(V,Date.now()+f,l.StorageScope.PROFILE,l.StorageTarget.USER)),this.y=z}}async eb(O,j,z){if(!O.tunnelLocalPort||!z?.requireLocalPort||O.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+t>M.getTime())return;this.db=M;const V=s.localize(3,null,j,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(V)}async forward(O,j){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.fb(O,j)}async fb(O,j){await this.Q.activateByEvent(e.$SM);const z=y(this.forwarded,O.remote.host,O.remote.port);j=j??(j!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const M=O.local!==void 0?O.local:O.remote.port;let V;if(z)return this.hb(z,O,j);{const K=this.L.remoteAuthority,re=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,B=C(O.remote.host,O.remote.port);this.c.set(B,!0),O=this.gb(B,O);const G=await this.H.openTunnel(re,O.remote.host,O.remote.port,void 0,M,O.elevateIfNeeded?O.elevateIfNeeded:j?.elevateIfNeeded,O.privacy,j?.protocol);if(typeof G=="string")V=G;else if(G&&G.localAddress){const X=y(this.m??new Map,O.remote.host,O.remote.port),ee=G.protocol?G.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,de={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??O.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:O.source??e.$VM,privacy:G.privacy};return this.forwarded.set(B,de),this.f.set(B,G),this.c.delete(B),await this.cb(),await this.eb(G,M,j),this.g.fire(de),G}this.c.delete(B)}return V}gb(O,j){const z=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(z){const M=z.get(O);z.delete(O),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(O,j,z){const M=z?.label??j.name;let V;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(V||(V={}));let K=V.None;switch(M!==O.name&&(O.name=M,K=V.Fire),(z?.protocol||O.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&(j.source=O.source,K=V.Reopen),j.privacy&&O.privacy!==j.privacy&&(K=V.Reopen),K){case V.Fire:{this.g.fire();break}case V.Reopen:await this.close(O.remoteHost,O.remotePort,w.User),await this.fb(j,z)}return y(this.f,j.remote.host,j.remote.port)}async name(O,j,z){const M=y(this.forwarded,O,j),V=C(O,j);if(M){M.name=z,await this.cb(),this.j.fire({host:O,port:j});return}else this.detected.has(V)&&(this.detected.get(V).name=z,this.j.fire({host:O,port:j}))}async close(O,j,z){const M=C(O,j),V=this.forwarded.get(M);return z===w.AutoForwardEnd&&V&&V.source.source===S.Auto&&this.F.set(M,{local:V.localPort,name:V.name,privacy:V.privacy}),await this.H.closeTunnel(O,j),this.W({host:O,port:j},z)}address(O,j){const z=C(O,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const j of O){const z=y(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:C(j.localAddress.host,j.localAddress.port);this.detected.set(C(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:S.Extension,description:s.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let j=O;this.r&&(j=await this.r(O));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(M=>M.port).join(", ")}`),this.n.fire(z)}ib(O){const j=this.m??new Map,z=new Map;return this.m=z,O.forEach(M=>{const V=C(M.host,M.port);z.set(V,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(V)&&j.delete(V);const K=y(this.forwarded,M.host,M.port);K&&(K.runningProcess=M.detail,K.hasRunningProcess=!0,K.pid=M.pid)}),j.forEach((M,V)=>{const K=u(V);if(!K)return;const re=y(this.forwarded,K.host,K.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const B=y(this.detected,K.host,K.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const O=Array.from(this.forwarded.values()),j=await this.getAttributes(O.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of O){const M=j.get(z.remotePort);(M?.protocol||z.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},M),M&&M.label&&M.label!==z.name&&await this.name(z.remoteHost,z.remotePort,M.label)}}async getAttributes(O,j=!0){const z=new Map,M=new Map;O.forEach(G=>{const X=y(this.m??new Map,P.$Gw[0],G.port)??G;if(X){z.set(G.port,X);const ee=p(X)?X.pid:void 0;M.has(ee)||M.set(ee,[]),M.get(ee)?.push(G.port)}});const V=new Map;if(O.forEach(G=>{const X=this.configPortsAttributes.getAttributes(G.port,G.host,z.get(G.port)?.detail);X&&V.set(G.port,X)}),this.G.length===0||!j)return V.size>0?V:void 0;const K=await Promise.all(this.G.flatMap(G=>Array.from(M.entries()).map(X=>{const ee=X[1],de=z.get(ee[0]);return G.providePortAttributes(ee,de?.pid,de?.detail,d.CancellationToken.None)}))),re=new Map;if(K.forEach(G=>G.forEach(X=>{X&&re.set(X.port,X)})),!V&&!re)return;const B=new Map;return O.forEach(G=>{const X=V.get(G.port),ee=re.get(G.port);B.set(G.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),B}addAttributesProvider(O){this.G.push(O)}};e.$3M=F,Xe([(0,h.$_h)(1e3)],F.prototype,"cb",null),e.$3M=F=Xe([Ve(0,P.$Bw),Ve(1,l.$gq),Ve(2,$.$aj),Ve(3,c.$RM),Ve(4,E.$Rl),Ve(5,b.$Pi),Ve(6,k.$ak),Ve(7,a.$7w),Ve(8,m.$3G),Ve(9,o.$Yj)],F)}),define(Ee[100],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KL=e.$JL=void 0;class s{constructor(L,R){this.line=L,this.character=R}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,R){return new s(0,0)}with(L){return new s(0,0)}}e.$JL=s;class h{constructor(L,R,$,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(L,R),this.end=new s($,a)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new h(0,0,0,0)}with(L){return new h(0,0,0,0)}}e.$KL=h;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ee[38],Se([1,0,19,39,25,33,13,5,17,14,100,9]),function(ce,e,s,h,I,T,L,R,$,a,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$9L=e.$2L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$YL=e.$XL=e.$WL=e.$VL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TextSearchCompleteMessageType=void 0,e.$SL=d,e.$TL=g,e.$UL=n,e.$ZL=D,e.$1L=y,e.$3L=p,e.$4L=v,e.$5L=F,e.$6L=N,e.$7L=O,e.$8L=j,e.$0L=M,e.$_L=re,e.$aM=B,h=We(h),I=We(I),T=We(T),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return k.TextSearchCompleteMessageType}}),e.$LL="workbench.view.search",e.$ML="workbench.panel.search",e.$NL="workbench.view.search",e.$OL="search-result",e.$PL="search.exclude",e.$QL=2e4;const l="\u27EA ",P=" characters skipped \u27EB",b=(l.length+P.length+5)*2;e.$RL=(0,R.$Gi)("searchService");var c;(function(X){X[X.file=0]="file",X[X.text=1]="text",X[X.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var m;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.aiText=3]="aiText"})(m||(e.QueryType=m={}));function d(X){return!!X.preview}function g(X){return!!X.resource}function n(X){return!!X.message}var o;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.$VL=t;class i{constructor(ee,de,ne,De){this.ranges=de,this.webviewIndex=De;const $e=Array.isArray(de)?de:[de];if(ne&&ne.matchLines===1&&r($e)){ee=(0,L.$_f)(ee,ne.matchLines);let J="",U=0,se=0;const ae=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const ue=Math.max(le.startColumn-ae,0),Z=le.startColumn+ne.charsPerLine;if(ue>se+ae+b){const oe=l+(ue-se)+P;J+=oe+ee.slice(ue,Z),U+=ue-(se+oe.length)}else J+=ee.slice(se,Z);te.push(new u(0,le.startColumn-U,le.endColumn-U)),se=Z}this.preview={text:J,matches:Array.isArray(this.ranges)?te:te[0]}}else{const J=Array.isArray(de)?de[0].startLineNumber:de.startLineNumber;this.preview={text:ee,matches:(0,s.$4b)(de,U=>new f(U.startLineNumber-J,U.startColumn,U.endLineNumber-J,U.endColumn))}}}}e.$WL=i;function r(X){const ee=X[0].startLineNumber;for(const de of X)if(de.startLineNumber!==ee||de.endLineNumber!==ee)return!1;return!0}class f{constructor(ee,de,ne,De){this.startLineNumber=ee,this.startColumn=de,this.endLineNumber=ne,this.endColumn=De}}e.$XL=f;class u extends f{constructor(ee,de,ne){super(ee,de,ee,ne)}}e.$YL=u;var w;(function(X){X.List="list",X.Tree="tree"})(w||(e.ViewMode=w={}));var S;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function D(X,ee=!0){const de=X&&X.files&&X.files.exclude,ne=ee&&X&&X.search&&X.search.exclude;if(!de&&!ne)return;if(!de||!ne)return de||ne;let De=Object.create(null);return De=I.$ho(De,I.$eo(de)),De=I.$ho(De,I.$eo(ne),!0),De}function y(X,ee){return X.excludePattern&&h.$zk(X.excludePattern,ee)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&h.$zk(X.includePattern,ee)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(de=>{const ne=de.folder.fsPath;if(T.$Fg(ee,ne)){const De=$.$oc(ne,ee);return!de.includePattern||!!h.$zk(de.includePattern,De)}else return!1}):!1:!0}var C;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class A extends Error{constructor(ee,de){super(ee),this.code=de}}e.$2L=A;function p(X){const ee=X.message;if((0,a.$7)(X))return new A(ee,C.canceled);try{const de=JSON.parse(ee);return new A(de.message,de.code)}catch{return new A(ee,C.other)}}function v(X){const ee={message:X.message,code:X.code};return new Error(JSON.stringify(ee))}function F(X){return X.type==="error"?!0:X.type==="success"}function N(X){return X.type==="success"}function O(X){return!!X.path}function j(X,ee,de=!0){const ne=X.searchPath?X.searchPath:X.relativePath;return de?(0,L.$9f)(ne,ee):h.$zk(ee,ne)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9L=z;function M(X,ee){const de={...X||{},...ee||{}};return Object.keys(de).filter(ne=>{const De=de[ne];return typeof De=="boolean"&&De})}class V{constructor(ee,de){this.c=null,this.a={...ee.excludePattern||{},...de.excludePattern||{}},this.b=h.$Ak(this.a);let ne=ee.includePattern;de.includePattern&&(ne?ne={...ne,...de.includePattern}:ne=de.includePattern),ne&&(this.c=h.$Ak(ne))}matchesExcludesSync(ee,de,ne){return!!(this.b&&this.b(ee,de,ne))}includedInQuerySync(ee,de,ne){return!(this.b&&this.b(ee,de,ne)||this.c&&!this.c(ee,de,ne))}includedInQuery(ee,de,ne){const De=this.b(ee,de,ne),$e=()=>this.c?!!this.c(ee,de,ne):!0;return(0,E.$sh)(De)?De.then(J=>J?!1:$e()):$e()}hasSiblingExcludeClauses(){return K(this.a)}}e.$$L=V;function K(X){for(const ee in X)if(typeof X[ee]!="boolean")return!0;return!1}function re(X){if(!X)return;let ee;return de=>(ee||(ee=(X()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[de]))}function B(X){if(!X)return;let ee;return de=>{if(!ee){const ne=X();ee=ne?G(ne):{}}return!!ee[de]}}function G(X){const ee={};for(const de of X)ee[de]=!0;return ee}}),define(Ee[48],Se([1,0,19,9,21,4,3,85,15,134,23,13,2,245,28,5,12,280,46,63,30,20,16,10,73,38,6,57]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;function D(O,j,z){return new k.$9g(M=>p(M,z)).isEqual(O,j)}function y(O,j,z){return D(O.uri,j.uri,z)?0:(0,E.$Af)(O.uri.toString(),j.uri.toString())}function C(O,j,z){return O.index!==j.index?O.index<j.index?-1:1:D(O.uri,j.uri,z)?(0,E.$Af)(O.name,j.name):(0,E.$Af)(O.uri.toString(),j.uri.toString())}function A(O,j,z,M){const V=O.slice(0).sort((re,B)=>z(re,B,M)),K=j.slice(0).sort((re,B)=>z(re,B,M));return(0,s.$Hb)(V,K,(re,B)=>z(re,B,M))}function p(O,j){const z=j.getCapabilities(O.scheme);return!(z&&z&b.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends g.$Zi{static toExtHostWorkspace(j,z,M,V){if(!j)return{workspace:null,added:[],removed:[]};const{id:K,name:re,folders:B,configuration:G,transient:X,isUntitled:ee}=j,de=[],ne=z;z?B.forEach((U,se)=>{const ae=l.URI.revive(U.uri),te=v.o(M||z,ae,V);te?(te.name=U.name,te.index=U.index,de.push(te)):de.push({uri:ae,name:U.name,index:se})}):de.push(...B.map(({uri:U,name:se,index:ae})=>({uri:l.URI.revive(U),name:se,index:ae}))),de.sort((U,se)=>U.index<se.index?-1:1);const De=new v(K,re,de,!!X,G?l.URI.revive(G):null,!!ee,U=>p(U,V)),{added:$e,removed:J}=A(ne?ne.workspaceFolders:[],De.workspaceFolders,y,V);return{workspace:De,added:$e,removed:J}}static o(j,z,M){for(let V=0;V<j.folders.length;V++){const K=j.workspaceFolders[V];if(D(K.uri,z,M))return K}}constructor(j,z,M,V,K,re,B){super(j,M.map(G=>new g.$1i(G)),V,K,B),this.t=z,this.u=re,this.q=[],this.s=R.$Mi.forUris(B,()=>!0),M.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,k.$gh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let F=class{constructor(j,z,M,V,K){this.c=new T.$ne,this.onDidChangeWorkspace=this.c.event,this.g=new T.$ne,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$pe,this.C=new Map,this.h=V,this.s=M,this.t=K,this.j=new a.$Nm,this.k=new h.$Fh,this.o=j.getProxy(w.$uN.MainThreadWorkspace),this.q=j.getProxy(w.$uN.MainThreadMessageService);const re=z.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,B=>p(B,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:$.Schemas.untitled,path:(0,k.$eh)((0,k.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...V){const K=[];if(Array.isArray(V)&&V.forEach(ee=>{l.URI.isUri(ee.uri)&&!K.some(de=>D(de.uri,ee.uri,this.s))&&K.push({uri:ee.uri,name:ee.name||(0,k.$dh)(ee.uri)})}),this.n||[z,M].some(ee=>typeof ee!="number"||ee<0)||M===0&&K.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(z+M>re.length)return!1;const B=re.slice(0);B.splice(z,M,...K.map(ee=>({uri:ee.uri,name:ee.name||(0,k.$dh)(ee.uri),index:void 0})));for(let ee=0;ee<B.length;ee++){const de=B[ee];if(B.some((ne,De)=>De!==ee&&D(de.uri,ne.uri,this.s)))return!1}B.forEach((ee,de)=>ee.index=de);const{added:G,removed:X}=A(re,B,C,this.s);if(G.length===0&&X.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,M,K).then(void 0,de=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,P.localize)(0,null,ee,de.toString()),ne,[])})}return this.y(B),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,V="";if(typeof j=="string"?(M=l.URI.file(j),V=j):typeof j<"u"&&(M=j,V=j.fsPath),!M)return V;const K=this.getWorkspaceFolder(M,!0);if(!K)return V;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let re=(0,k.$jh)(K.uri,M);return z&&K.name&&(re=`${K.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:V}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:V}))}findFiles(j,z,M,V,K=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let re="",B=!0;return z===null?B=!1:z!==void 0&&(typeof z=="string"?re=z:re=z.pattern),this.z(j,void 0,{exclude:re,maxResults:M,useDefaultExcludes:B,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(j,z={},M,V=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,V)}async z(j,z,M,V=I.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const K=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,re={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:K,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let B;if(j){const{includePattern:G,folder:X}=N(i.GlobPattern.from(j));B=X,re.includePattern=G}else{const{includePattern:G,folder:X}=N(i.GlobPattern.from(z));B=X,re.filePattern=G}return this.o.$startFileSearch(B??null,re,V).then(G=>Array.isArray(G)?G.map(X=>l.URI.revive(X)):[])}async findTextInFiles(j,z,M,V,K=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),B=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:G,folder:X}=N(i.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,de={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:B,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=l.URI.revive(De.resource);De.results.forEach(J=>{const U=(0,S.$di)(J);(0,u.$SL)(U)?M({uri:$e,preview:{text:U.preview.text,matches:(0,s.$4b)(U.preview.matches,se=>new r.$yN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,s.$4b)(U.ranges,se=>new r.$yN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:$e,text:U.text,lineNumber:U.lineNumber})})},K.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,X??null,de,re,K);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return l.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return l.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,M),(0,L.$Vc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const V=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(j,z,M,V){this.h.info("Getting edit session identifier for workspaceFolder",j);const K=await this.resolveWorkspaceFolder(l.URI.revive(j));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const re=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!re),!re)return;const B=await re.provideEditSessionIdentityMatch?.(z,M,V);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,V)=>{const K=function(B){z.call(M,B)};return K.extension=j,this.B.event(K,void 0,V)}}async $onWillCreateEditSessionIdentity(j,z,M){const V=await this.resolveWorkspaceFolder(l.URI.revive(j));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},z,async(K,re)=>{const B=Date.now();await Promise.resolve(K),Date.now()-B>M&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),V=this.A++;return this.o.$registerCanonicalUriProvider(V,M),(0,L.$Vc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(j,z,M){const V=this.C.get(j.scheme);if(!V)return;const K=await V.provideCanonicalUri?.(l.URI.revive(j),z,M);if(K)return K}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(l.URI.revive(j),{targetScheme:z},M)}};e.$Koc=F,e.$Koc=F=Xe([Ve(0,t.$1P),Ve(1,o.$eQ),Ve(2,n.$toc),Ve(3,m.$ak),Ve(4,f.$Ioc)],F),e.$Loc=(0,c.$Gi)("IExtHostWorkspace");function N(O){let j,z;return O&&(typeof O=="string"?j=O:(j=O.pattern,z=l.URI.revive(O.baseUri))),{includePattern:j,folder:z}}}),define(Ee[42],Se([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=e.$Moc=void 0;function m(f,u){if(u){const w=u.split(".");let S=f;for(let D=0;S&&D<w.length;D++)S=S[w[D]];return S}}function d(f){return f instanceof c.URI}function g(f){return f&&f.uri instanceof c.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof c.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function t(f){if(d(f))return{resource:f};if(g(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(u,w,S){this.a=u.getProxy(T.$uN.MainThreadConfiguration),this.c=w,this.b=S,this.d=new E.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new r(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,w){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(u,w))}};e.$Moc=i,e.$Moc=i=Xe([Ve(0,P.$1P),Ve(1,I.$Loc),Ve(2,b.$ak)],i);class r{constructor(u,w,S,D){this.a=new h.$ne,this.b=u,this.f=D,this.c=w,this.e=$.$Po.parse(S,D),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,w){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Po.parse(u,this.f),this.d=this.k(u.configurationScopes),this.a.fire(this.j(w,S))}getConfiguration(u,w,S){const D=t(w)||{},y=this.g(u?m(this.e.getValue(void 0,D,this.c.workspace),u):this.e.getValue(void 0,D,this.c.workspace));u&&this.h(u,D,S?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(p){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(p){return typeof m(y,p)<"u"},get:(p,v)=>{this.h(u?`${u}.${p}`:p,D,S?.identifier);let F=m(y,p);if(typeof F>"u")F=v;else{let N;const O=(j,z)=>{if((0,k.$ig)(j)){let M;const V=()=>{N=N||(0,s.$eo)(y),M=M||m(N,z)};return new Proxy(j,{get:(K,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return V(),()=>M;if(N)return M=M||m(N,z),M[re];const B=K[re];return typeof re=="string"?O(B,`${z}.${re}`):B},set:(K,re,B)=>(V(),M&&(M[re]=B),!0),deleteProperty:(K,re)=>(V(),M&&delete M[re],!0),defineProperty:(K,re,B)=>(V(),M&&Object.defineProperty(M,re,B),!0)})}return Array.isArray(j)?(0,s.$eo)(j):j};F=O(F,p)}return F},update:(p,v,F,N)=>{p=u?`${u}.${p}`:p;const O=C(F);return v!==void 0?this.b.$updateConfigurationOption(O,p,v,D,N):this.b.$removeConfigurationOption(O,p,D,N)},inspect:p=>{p=u?`${u}.${p}`:p;const v=this.e.inspect(p,D,this.c.workspace);if(v)return{key:p,defaultValue:(0,s.$eo)(v.policy?.value??v.default?.value),globalValue:(0,s.$eo)(v.user?.value??v.application?.value),workspaceValue:(0,s.$eo)(v.workspace?.value),workspaceFolderValue:(0,s.$eo)(v.workspaceFolder?.value),defaultLanguageValue:(0,s.$eo)(v.default?.override),globalLanguageValue:(0,s.$eo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,s.$eo)(v.workspace?.override),workspaceFolderLanguageValue:(0,s.$eo)(v.workspaceFolder?.override),languageIds:(0,s.$eo)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,s.$ho)(A,y,!1),Object.freeze(A)}g(u){const w=S=>(0,k.$ig)(S)?new Proxy(S,{get:(D,y)=>w(D[y]),set:(D,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return w(u)}h(u,w,S){const D=a.$Go.test(u)?a.ConfigurationScope.RESOURCE:this.d.get(u),y=S?`[${S.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof w?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){w?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,w){const S=new $.$Ro(u,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>S.affectsConfiguration(D,t(y))})}k(u){return u.reduce((w,S)=>(w.set(S[0],S[1]),w),new Map)}}e.$Noc=r,e.$Ooc=(0,l.$Gi)("IExtHostConfiguration")}),define(Ee[101],Se([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=e.$kqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=We(L),m=We(m);var t;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var i;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(i||(i={}));var r;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(r||(r={}));var f;(function(N){function O(M){if(M){const V=M;return V&&!!V.process}else return!1}N.is=O;function j(M){if(M==null)return;const V={process:M.process,args:M.args};return M.options&&(V.options=r.from(M.options)),V}N.from=j;function z(M){if(M!=null)return new L.$gO(M.process,M.args,M.options)}N.to=z})(f||(f={}));var u;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(u||(u={}));var w;(function(N){function O(M){if(M){const V=M;return V&&(!!V.commandLine||!!V.command)}else return!1}N.is=O;function j(M){if(M==null)return;const V={};return M.commandLine!==void 0?V.commandLine=M.commandLine:(V.command=M.command,V.args=M.args),M.options&&(V.options=u.from(M.options)),V}N.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$hO(M.commandLine,M.options):new L.$hO(M.command,M.args?M.args:[],M.options)}N.to=z})(w||(w={}));var S;(function(N){function O(M){if(M){const V=M;return V&&V.customExecution==="customExecution"}else return!1}N.is=O;function j(M){return{customExecution:"customExecution"}}N.from=j;function z(M,V){return V.get(M)}N.to=z})(S||(e.CustomExecutionDTO=S={}));var D;(function(N){function O(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=n.$II),{id:j._id,workspaceFolder:M}}N.from=O})(D||(e.TaskHandleDTO=D={}));var y;(function(N){function O(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=O})(y||(y={}));var C;(function(N){function O(M,V){if(M==null)return[];const K=[];for(const re of M){const B=j(re,V);B&&K.push(B)}return K}N.fromMany=O;function j(M,V){if(M==null)return;let K;M.execution instanceof L.$gO?K=f.from(M.execution):M.execution instanceof L.$hO?K=w.from(M.execution):M.execution&&M.execution instanceof L.$iO&&(K=S.from(M.execution));const re=t.from(M.definition);let B;return M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=L.TaskScope.Workspace,!re||!B?void 0:{_id:M._id,definition:re,name:M.name,source:{extensionId:V.identifier.value,label:M.source,scope:B},execution:K,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function z(M,V,K){if(M==null)return;let re;f.is(M.execution)?re=f.to(M.execution):w.is(M.execution)?re=w.to(M.execution):S.is(M.execution)&&(re=S.to(M._id,K));const B=t.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await V.resolveWorkspaceFolder(s.URI.revive(M.source.scope)):G=L.TaskScope.Workspace),!B||!G)return;const X=new L.$jO(B,G,M.name,M.source.label,re,M.problemMatchers);return M.isBackground!==void 0&&(X.isBackground=M.isBackground),M.group!==void 0&&(X.group=L.$fO.from(M.group._id),X.group&&M.group.isDefault&&(X.group=new L.$fO(X.group.id,X.group.label),M.group.isDefault===!0&&(X.group.isDefault=M.group.isDefault))),M.presentationOptions&&(X.presentationOptions=i.to(M.presentationOptions)),M._id&&(X._id=M._id),M.detail&&(X.detail=M.detail),X}N.to=z})(C||(e.TaskDTO=C={}));var A;(function(N){function O(z){return z}N.from=O;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(A||(A={}));class p{#e;constructor(O,j,z){this._id=j,this.a=z,this.#e=O}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let v=class{constructor(O,j,z,M,V,K,re,B){this.q=new I.$ne,this.r=new I.$ne,this.s=new I.$ne,this.u=new I.$ne,this.a=O.getProxy(T.$uN.MainThreadTask),this.b=z,this.c=M,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=B,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(O,j,z){if(!z)return new L.$wN(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:z,extension:O}),this.a.$registerTaskProvider(M,j),new L.$wN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(O,j){this.a.$registerTaskSystem(O,j)}fetchTasks(O){return this.a.$fetchTasks(A.from(O)).then(async j=>{const z=[];for(const M of j){const V=await C.to(M,this.b,this.m);V&&z.push(V)}return z})}get taskExecutions(){const O=[];return this.k.forEach(j=>O.push(j)),O}terminateTask(O){if(!(O instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(O._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(O,j,z){const M=this.m.get(O.id);M&&(this.o.set(O.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=O.id,this.q.fire({execution:await this.z(O)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(O){if(!this.l.has(O.id))return;const j=await this.z(O);this.l.delete(O.id),this.k.delete(O.id),this.B(O),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(O){const j=await this.z(O.id);this.s.fire({execution:j,processId:O.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(O){const j=await this.z(O.id);this.u.fire({execution:j,exitCode:O.exitCode})}$provideTasks(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));const M=[],V=(0,h.$yh)(()=>z.provider.provideTasks(k.CancellationToken.None)).then(K=>this.v(j,M,z,K));return new Promise(K=>{V.then(re=>{Promise.all(M).then(()=>{K(re)})})})}async $resolveTask(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await C.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const V=await z.provider.resolveTask(M,k.CancellationToken.None);if(!V)return;this.A(V,z);const K=C.from(V,z.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(K.execution)&&await this.y(K,V,!0),await this.w(K)}x(){return this.h++}async y(O,j,z){const M=await this.a.$createTaskId(O);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(O,j){if(typeof O=="string"){const V=this.l.get(O);if(!V)throw new o.$eb("Unexpected: The specified task is missing an execution");return V}const z=this.l.get(O.id);if(z)return z;let M;return j?M=Promise.resolve(new p(this,O.id,j)):M=C.to(O.task,this.b,this.m).then(V=>{if(!V)throw new o.$eb("Unexpected: Task does not exist.");return new p(this,O.id,V)}),this.l.set(O.id,M),M.then(V=>(this.k.set(O.id,V),V))}A(O,j){O._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(O){this.o.get(O.id)&&this.o.delete(O.id),this.n.has(O.id)&&this.p!==O.id&&(this.m.delete(O.id),this.n.delete(O.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$kqc=v,e.$kqc=v=Xe([Ve(0,l.$1P),Ve(1,P.$eQ),Ve(2,R.$Loc),Ve(3,$.$_P),Ve(4,a.$Ooc),Ve(5,E.$apc),Ve(6,d.$ak),Ve(7,g.$poc)],v);let F=class extends v{constructor(O,j,z,M,V,K,re,B){super(O,j,z,M,V,K,re,B),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(m.Platform.Web)})}async executeTask(O,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=C.from(j,O);if(z===void 0)throw new Error("Task is not valid");if(S.is(z.execution))await this.y(z,j,!1);else throw new o.$cb;const M=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(V=>{throw new Error(V)}),M}v(O,j,z,M){const V=[];if(M)for(const K of M){if(this.A(K,z),!K.definition||!O[K.definition.type]){const B=K.source?K.source:"No task source";this.f.warn(`The task [${B}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=C.from(K,z.extension);re&&S.is(re.execution)?(V.push(re),j.push(this.y(re,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:z.extension}}async w(O){if(S.is(O.execution))return O;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(O,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,j,z){}};e.$lqc=F,e.$lqc=F=Xe([Ve(0,l.$1P),Ve(1,P.$eQ),Ve(2,R.$Loc),Ve(3,$.$_P),Ve(4,a.$Ooc),Ve(5,E.$apc),Ve(6,d.$ak),Ve(7,g.$poc)],F),e.$mqc=(0,b.$Gi)("IExtHostTask")}),define(Ee[385],Se([1,0,38,31]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=void 0,e.$gM=I,e.$iM=T;function I(L){return"cellResults"in L}e.$hM="rawCell#";function T(L,R){let $=-1;const a=[];let k=[];return L.forEach(l=>{l.range.startLineNumber!==$&&k.length>0&&(a.push([...k]),k=[]),k.push(l),$=l.range.endLineNumber}),k.length>0&&a.push([...k]),a.map(l=>{const P=[],b=l[0].range.startLineNumber,c=l[l.length-1].range.endLineNumber;for(let m=b;m<=c;m++)P.push(R.getLineContent(m));return new s.$WL(P.join(`
`)+`
`,l.map(m=>new h.$Mt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Ee[386],Se([1,0,239,22,4,3,29,41,13,18,2,28,119,6,35,16,10,52,358,165,25,15,38,314,385,382]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,E=We(E),c=We(c),m=We(m);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,C,A,p,v,F){this.q=C,this.r=A,this.s=p,this.t=v,this.u=F,this.f=new Map,this.g=new L.$Dc,this.h=new Map,this.j=new I.$ne,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$ne,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$ne,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$ne,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new l.$noc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$uN.MainThreadNotebook),this.c=D.getProxy(P.$uN.MainThreadNotebookDocuments),this.d=D.getProxy(P.$uN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===R.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,j=N.cell.handle,M=this.g.get(O)?.getCell(j);if(M)return M.apiCell}if(N&&N.$mid===R.MarshalledId.NotebookActionContext){const O=N.uri,j=this.g.get(O);if(j)return j.apiNotebook}return N}}),w.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,C]of this.h)if(C.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const C=this.g.get(D);if(!C&&!y)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,y){if(!y)return;const C=y.filenamePattern.map(A=>c.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?u.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,C){const A=w.a++,p=typeof C.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(A,C),this.b.$registerNotebookCellStatusBarItemProvider(A,p,y);let v;return p!==void 0&&(v=C.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(p))),new m.$wN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,p),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&c.NotebookData.from(D.content)});return k.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(D),A=this.g.get(k.URI.revive(C));return(0,a.$rg)(A?.apiNotebook)}async showNotebookDocument(D,y){k.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof y=="object"?C={position:c.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(c.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:C={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),p=A&&this.h.get(A)?.apiEditor;if(p)return p;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,C,A){const p=this.f.get(D),v=k.URI.revive(y),F=this.g.get(v);if(!F||!p)return;const N=F.getCellFromIndex(C);if(!N)return;const O=await p.provideCellStatusBarItems(N.apiCell,A);if(!O)return;const j=new T.$Wc,z=this.p.add([j]),V=(Array.isArray(O)?O:[O]).map(K=>c.NotebookStatusBarItem.from(K,this.i,j));return{cacheId:z,items:V}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,C,A,p){if((0,$.$ef)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:C,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,c.NotebookDocumentContentOptions.from(A),w.w(D,p)),(0,T.$Vc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.deserializeNotebook(y.buffer,C);return new d.$Uw(c.NotebookData.from(p))}async $notebookToData(D,y,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.serializeNotebook(c.NotebookData.to(y.value),C);return h.$Pe.wrap(p)}async $saveNotebook(D,y,C,A,p){const v=k.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$vl((0,s.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,o.$mo)(N.apiNotebook.metadata,K=>!(F.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of N.apiNotebook.getCells()){const re=new m.$ZO(K.kind,K.document.getText(),K.document.languageId,K.mime,F.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);re.metadata=(0,o.$mo)(K.metadata,B=>!(F.options?.transientCellMetadata??{})[B]),O.cells.push(re)}if(await this.z(v,A),p.isCancellationRequested)throw new Error("canceled");const j=await F.serializer.serializeNotebook(O,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${C} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),V={name:z.basename(v),isFile:(M.type&E.FileType.File)!==0,isDirectory:(M.type&E.FileType.Directory)!==0,isSymbolicLink:(M.type&E.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&E.FilePermission.Locked),etag:E.$Gl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${v.toString()})`),V}async $searchInNotebooks(D,y,C,A,p){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new L.$Ec;await(async(M,V,K)=>{await Promise.all(M.map(async re=>await Promise.all(re.filenamePatterns.map(B=>{const G={_reason:K._reason,folderQueries:K.folderQueries,includePattern:K.includePattern,excludePattern:K.excludePattern,maxResults:K.maxResults,type:i.QueryType.File,filePattern:B};return this.t.doInternalFileSearchWithCustomCallback(G,V,X=>{X.forEach(ee=>{F.has(ee)||A.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,u.$dL)(De,ee)))||F.add(ee)})}).catch(X=>{if(X.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw X})}))))})(C,p,y);const O=new L.$Dc;let j=!1;const z=Array.from(F).map(async M=>{const V=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...O.values()].reduce((G,X)=>G+X.cellResults.length,0)>y.maxResults){j=!0;return}const K=[],re=this.g.get(M);if(re)re.apiNotebook.getCells().forEach(X=>K.push({input:X.document.getText(),outputs:X.outputs.flatMap(ee=>ee.items.map(de=>de.data.toString()))}));else{const G=await this.s.value.readFile(M),X=h.$Pe.fromString(G.toString()),ee=await v.deserializeNotebook(X.buffer,p);if(p.isCancellationRequested)return;c.NotebookData.from(ee).cells.forEach(ne=>K.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;K.forEach((G,X)=>{const ee=y.contentPattern.pattern,de=new r.$CZb(G.input,void 0,G.outputs),ne=de.findInInputs(ee),De=de.findInOutputs(ee),$e=De.flatMap(J=>(0,f.$iM)(J.matches,J.textBuffer)).map((J,U)=>(J.webviewIndex=U,J));if(ne.length>0||De.length>0){const J={index:X,contentResults:(0,f.$iM)(ne,de.inputTextBuffer),webviewResults:$e};V.push(J)}});const B={resource:M,cellResults:V};O.set(M,B);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...O.values()]}}async z(D,y){const C=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==E.$Fl&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==E.$Gl({mtime:y.mtime,size:C.size}))throw new E.$vl((0,s.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new n.$Ppc(y,this.d,D,C.visibleRanges.map(c.NotebookRange.to),C.selections.map(c.NotebookRange.to),typeof C.viewColumn=="number"?c.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const A=k.URI.revive(C),p=this.g.get(A);p&&(p.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const C=[];for(const A of D.value.addedDocuments){const p=k.URI.revive(A.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new g.$Opc(this.c,this.q,this.r,p,A);C.push(...A.cells.map(F=>g.$Npc.asModelAddData(F))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const A=k.URI.revive(C.documentUri),p=this.g.get(A);p&&this.B(p,C.id,C)}const y=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const A=this.h.get(C);A&&(this.h.delete(C),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const C=new Set;this.l.forEach(A=>C.add(A.id));for(const A of this.h.values()){const p=C.has(A.id);A._acceptVisibility(p)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=b.$mQ.String.with("notebookType","A notebook type"),C=new b.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new b.$mQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Pe.wrap(p))],new b.$nQ("Notebook Data",p=>c.NotebookData.to(p.value))),A=new b.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new b.$mQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.$Uw(c.NotebookData.from(p)))],new b.$nQ("Bytes",p=>p.buffer));D.registerApiCommand(C),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Ypc=w}),define(Ee[387],Se([1,0,17,21,51,39,23,43,38]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,s=We(s),T=We(T),L=We(L);class a{constructor(l,P,b){this.k=l,this.l=P,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&T.$Ak(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&T.$Ak(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const P=this.k.folderQueries||[];return new Promise((b,c)=>{const m=d=>{this.f++,l(d)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const g=d.toString(),n=s.$qc(g);this.j&&this.j(g,n)||this.v(m,{base:d,basename:n})}),Promise.all(P.map(d=>this.p(d,m))).then(d=>{b({limitHit:this.e,stats:d[0]||void 0})},d=>{c(new Error((0,I.$rj)(d)))})})}async p(l,P){const b=new h.$ye,c=this.q(l),m=this.r(),d=new $.$$L(this.k,l),g=!d.hasSiblingExcludeClauses();let n;try{this.h.add(b),n=R.$he.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,b.token),t=n.elapsed(),i=R.$he.create();return this.g&&!this.e||(o&&o.forEach(r=>{const f=s.$jc.relative(l.folder.path,r.path);if(g){const u=s.$qc(r.path);this.v(P,{base:l.folder,relativePath:f,basename:u});return}this.s(m,l.folder,f,P)}),this.g&&!this.e)?null:(this.u(m,d,P),{providerTime:t,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const P=(0,$.$0L)(this.k.includePattern,l.includePattern),b=(0,$.$0L)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:P,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},P,b,c){if(b===this.a){const d=s.$qc(this.a);this.v(c,{base:P,relativePath:this.a,basename:d})}function m(d){const g=s.$qc(d),n=s.$pc(d);let o=l[n];o||(o=l[n]=[],m(n)),o.push({base:P,relativePath:d,basename:g})}m(b)}u({rootEntries:l,pathToEntries:P},b,c){const m=this,d=this.a;function g(n){const o=(0,$.$aM)(()=>n.map(t=>t.basename));for(let t=0,i=n.length;t<i;t++){const r=n[t],{relativePath:f,basename:u}=r;if(b.matchesExcludesSync(f,u,d!==u?o:void 0))continue;const w=P[f];if(w)g(w);else{if(f===d)continue;m.v(c,r)}if(m.e)break}}g(l)}v(l,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(P))}}class k{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,P,b,c){const m=this.c(l.cacheKey),d=new a(l,P,m&&m.token);let g=0;const n=o=>{g+=o.length,b(o.map(t=>this.d(t)))};return this.e(d,k.a,n,c).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new h.$ye),this.b.get(l)}d(l){return l.relativePath?{resource:L.$hh(l.base,l.relativePath)}:{resource:l.base}}e(l,P,b,c){const m=c.onCancellationRequested(()=>{l.cancel()}),d=n=>{n&&(g.push(n),P>0&&g.length>=P&&(b(g),g=[]))};let g=[];return l.search(d).then(n=>(g.length&&b(g),m.dispose(),n),n=>(g.length&&b(g),m.dispose(),Promise.reject(n)))}}e.$Qpc=k}),define(Ee[388],Se([1,0,19,79,39,110,29,15,17,23,13,18,2,107,262,45,12,46,157,383,38]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$_M=y,s=We(s),h=We(h),I=We(I),$=We($),k=We(k),b=We(b);let t=class{constructor(A,p,v,F,N){this.a=A,this.b=p,this.c=v,this.d=F,this.e=N}text(A,p,v={}){A=this.f(A,v);const F=this.a.getValue(),N=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map(d.$2i),v),type:o.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,p){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,p)&&(F.isCaseSensitive=!0),this.k(A)&&(F.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),F}file(A,p={}){return{...this.h(A,p),type:o.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(A,p){return A?(A=Array.isArray(A)?A.map(w):w(A),p?this.parseSearchPaths(A):{pattern:r(...Array.isArray(A)?A:[A])}):{}}h(A=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),F=this.g(p.excludePattern,p.expandPatterns),N=A.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,p,F)):A.map(M=>this.r(M,p,F,N))).filter(M=>!!M),j={_reason:p._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=s.$Kb(this.c.groups.flatMap(re=>re.editors.map(B=>B.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const V=M.filter(re=>(0,o.$1L)(j,re.fsPath)),K=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...j,...K}}const z=p.extraFileResources&&p.extraFileResources.filter(M=>(0,o.$1L)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const p=[],v=new L.$Dc,F={};let N=!1;return A.forEach(O=>{if(O.scheme===R.Schemas.walkThrough)return;if((0,a.$lh)(O)){const z=this.b.getWorkspaceFolder(O)?.uri??O.with({path:$.$pc(O.fsPath)});let M=v.get(z);M||(N=!0,M={folder:z,includePattern:{}},p.push(M),v.set(z,M));const V=$.$oc(z.fsPath,O.fsPath);(0,E.$rg)(M.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,F[O.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,p){if(p.isSmartCase){if(A.isRegExp){if(k.$0f(A.pattern,!0))return!0}else if(k.$0f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,P.$bD)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const p=K=>$.$lc(K)||/^\.\.?([\/\\]|$)/.test(K),F=(Array.isArray(A)?A:f(A)).map(K=>{const re=this.e.resolvedUserHome;return re?(0,T.$Zw)(K,re.scheme===R.Schemas.file?re.fsPath:re.path):K}),N=h.$K(F,K=>p(K)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(K=>k.$pf(K,"/")).map(K=>k.$pf(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),u(K))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=O.flat(),V=r(...M);return V&&(j.pattern=V),j}l(A,p){return p.disregardExcludeSettings?void 0:(0,o.$ZL)(A,!p.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const p=A.flatMap(F=>{let{pathPortion:N,globPortion:O}=i(F);return O&&(O=S(O)),this.n(N).flatMap(z=>this.o(z,O))}),v=new Map;return p.forEach(F=>{const N=F.searchPath.toString(),O=v.get(N);O?F.pattern&&(O.pattern=O.pattern||{},O.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?r(F.pattern):void 0})}),Array.from(v.values())}n(A){if($.$lc(A)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==R.Schemas.file?[{searchPath:p[0].uri.with({path:A})}]:[{searchPath:l.URI.file($.$kc(A))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(A=w(A),A.startsWith("../")||A===".."){const F=$.$jc.resolve(p.path,A);return[{searchPath:p.with({path:F})}]}const v=S(A);return[{searchPath:p,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const p=A.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const O=p.match(new RegExp(`^${k.$jf(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(E.$og);if(F.length)return F.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&S(O)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:A,j=b.localize(0,null,O);throw new Error(j)}}}}o(A,p){const v=A.pattern&&p?`${A.pattern}/${p}`:A.pattern||p,F=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:v+"/**"}),F}q(A,p,v){const F=this.r((0,d.$2i)(A.searchPath),p,v,!1);return F?{...F,includePattern:A.pattern}:null}r(A,p,v,F){let N;const O=l.URI.isUri(A)?A:A.uri;if(v.searchPaths){const K=v.searchPaths.filter(re=>(0,a.$ah)(re.searchPath,O))[0];if(K&&!K.pattern)return null;K&&(N=K.pattern)}const j=this.a.getValue({resource:O}),M={...this.l(j,p)||{},...N||{}},V=l.URI.isUri(A)?(0,a.$eh)(A):A.name;return{folder:O,folderName:F?V:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$$M=t,e.$$M=t=Xe([Ve(0,c.$aj),Ve(1,d.$Pi),Ve(2,g.$jE),Ve(3,m.$ak),Ve(4,n.$9M)],t);function i(C){const A=C.match(/[\*\{\}\(\)\[\]\?]/);if(A){const p=A.index,v=C.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let F=C.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:C.substr((v.index||0)+1)}}}return{pathPortion:C}}function r(...C){return C.length?C.reduce((A,p)=>(A[p]=!0,A),Object.create(null)):void 0}function f(C){return I.$yk(C,",").map(A=>A.trim()).filter(A=>!!A.length)}function u(C){return[`**/${C}/**`,`**/${C}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function w(C){return C.replace(/\\/g,"/")}function S(C){return w(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function y(C,A){C=s.$Pb(C,F=>F.toString());const p=[],v=A.getWorkspace();return C&&C.forEach(F=>{let N;if(A.getWorkbenchState()===d.WorkbenchState.FOLDER)N=(0,a.$jh)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const O=A.getWorkspaceFolder(F);if(O){const j=O.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,a.$jh)(O.uri,F);M===""?N=`./${O.name}`:N=`./${O.name}/${M}`}else N=F.fsPath}}N&&p.push(D(N))}),p}}),define(Ee[389],Se([1,0,23,2,21,14,5,388,38,46,9]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gyb=l,e.$hyb=c,s=We(s),T=We(T);const E=7e3;function l(m,d){const g=d.activationEvents;if(!g)return Promise.resolve(void 0);const n=[],o=[];for(const w of g)if(/^workspaceContains:/.test(w)){const S=w.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||m.forceUsingSearch?o.push(S):n.push(S)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:i}=(0,k.$zh)(),r=w=>i({activationEvent:w}),f=Promise.all(n.map(w=>P(m,w,r))).then(()=>{}),u=b(m,d.identifier,o,r);return Promise.all([f,u]).then(()=>{i(void 0)}),t}async function P(m,d,g){for(const n of m.folders)if(await m.exists(s.$hh(h.URI.revive(n),d))){g(`workspaceContains:${d}`);return}}async function b(m,d,g,n){if(g.length===0)return Promise.resolve(void 0);const o=new I.$ye,t=m.checkExists(m.folders,g,o.token),i=setTimeout(async()=>{o.cancel(),m.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},E);let r=!1;try{r=await t}catch(f){T.$7(f)||T.$3(f)}o.dispose(),clearTimeout(i),r&&n(`workspaceContains:${g.join(",")}`)}function c(m,d,g,n){const o=m.get(L.$Fi),t=m.get($.$RL),r=o.createInstance(R.$$M).file(d.map(f=>(0,a.$2i)(h.URI.revive(f))),{_reason:"checkExists",includePattern:g,exists:!0});return t.fileSearch(r,n).then(f=>!!f.limitHit,f=>T.$7(f)?!1:Promise.reject(f))}}),define(Ee[53],Se([1,0,235,17,62,23,9,3,85,2,12,6,42,321,126,48,26,159,14,24,22,299,10,72,5,30,98,20,115,77,47,129,4,389,125,301,15,123,43,11,124]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u,w,S,D,y,C,A,p,v,F,N,O,j,z,M,V){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=e.$ppc=e.$opc=e.$npc=void 0,s=We(s),h=We(h),I=We(I),g=We(g),e.$npc=(0,f.$Gi)("IHostUtils");let re=K=class extends R.$Xc{constructor(J,U,se,ae,te,le,ue,Z,oe,pe,we,Fe,Ue){super(),this.Y=Fe,this.Z=Ue,this.a=this.B(new p.$ne),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=U,this.g=se,this.f=ue,this.j=ae,this.m=te,this.s=le,this.t=oe,this.u=pe,this.w=we,this.y=this.g.getProxy(E.$uN.MainThreadWorkspace),this.z=this.g.getProxy(E.$uN.MainThreadTelemetry),this.C=this.g.getProxy(E.$uN.MainThreadExtensionService),this.D=new L.$Fh,this.F=new L.$Fh,this.G=new L.$Fh,this.H=new L.$Fh,this.I=new De(this.f.extensions.activationEvents),this.L=new d.$Qcc(this.I,this.f.extensions.allExtensions);const ke=new n.$sn(this.f.extensions.myExtensions);this.J=new d.$Qcc(this.I,de(this.L,ke)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new b.$9oc(this.g,this.s),this.N=new F.$gpc(this.g),this.O=Z,this.h=J.createChild(new D.$Ei([b.$0oc,this.M],[F.$hpc,this.N])),this.P=this.B(new P.$8oc(this.J,this.L,{onExtensionActivationError:(Pe,Te,W)=>{this.C.$onExtensionActivationError(Pe,g.$5(Te),W)},actualActivateExtension:async(Pe,Te)=>{if(d.$Qcc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new P.$7oc;const W=this.J.getExtensionDescription(Pe);return this.fb(W,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(J){g.$3(J)}}async $(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(J)}terminate(J,U=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),g.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Hh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const U=await this.C.$getExtension(J);return U&&{...U,identifier:new n.$rn(U.identifier.value),extensionLocation:a.URI.revive(U.extensionLocation)}}ab(J,U){return this.P.activateByEvent(J,U)}bb(J,U){return this.P.activateById(J,U)}activateByIdWithErrors(J,U){return this.bb(J,U).then(()=>{const se=this.P.getActivatedExtension(J);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async cb(J){if(J.scheme===O.Schemas.file&&this.c.fsRealpath){const U=J.fsPath;this.R.has(U)||this.R.set(U,this.c.fsRealpath(U));const se=await this.R.get(U);return a.URI.file(se)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(J=>new ne(J))),this.Q}async db(J){const U=$.$Mi.forUris(se=>T.$$g.ignorePathCasing(se));return await Promise.all(J.map(async se=>{if(this.wb(se)){const ae=await this.cb(se.extensionLocation);U.set(ae,se)}})),U}eb(J){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return U;const se=this.P.getActivatedExtension(J);if(!se)return U;try{typeof se.module.deactivate=="function"&&(U=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ae)}try{(0,R.$Sc)(se.subscriptions)}catch(ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(ae)}return U}async fb(J,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.hb(J,U).then(se=>{const ae=se.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,U),this.gb(J,U,"success",ae),se},se=>{throw this.gb(J,U,"failure"),se})}gb(J,U,se,ae){const te=G(J,U);this.z.$publicLog2("extensionActivationTimes",{...te,...ae||{},outcome:se})}hb(J,U){const se=G(J,U);this.z.$publicLog2("activatePlugin",se);const ae=this.wb(J);if(!ae)return Promise.resolve(new P.$6oc(P.$3oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${J.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new P.$4oc(U.startup);return Promise.all([this.xb(J,(0,T.$hh)(J.extensionLocation,ae),te),this.ib(J)]).then(le=>(I.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),K.jb(this.s,J.identifier,le[0],le[1],te))).then(le=>(I.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),le))}ib(J){const U=this.Z.createLanguageModelAccessInformation(J),se=this.B(new t.$_oc(J,this.M)),ae=this.B(new t.$$oc(J.identifier.value,!1,this.M)),te=this.B(new N.$ipc(J,this.N)),le=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ue=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const Z=this;let oe,pe;const we=(0,m.$6G)(J,"ipc")?this.f.messagePorts?.get(n.$rn.toKey(J.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:te,subscriptions:[],get languageModelAccessInformation(){return U},get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(Fe){return h.$mc(J.extensionLocation.fsPath,Fe)},get storagePath(){return Z.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return Z.O.globalValue(J).fsPath},get logPath(){return h.$mc(Z.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return a.URI.joinPath(Z.f.logsLocation,J.identifier.value)},get storageUri(){return Z.O.workspaceValue(J)},get globalStorageUri(){return Z.O.globalValue(J)},get extensionMode(){return le},get extension(){return oe===void 0&&(oe=new ee(Z,J.identifier,J,ue,!1)),oe},get extensionRuntime(){return(0,m.$7G)(J,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!pe){if(!we)return;const Fe=p.Event.buffer(p.Event.fromDOMEventEmitter(we,"message",Ue=>Ue.data));we.start(),pe={onDidReceiveMessage:Fe,postMessage:we.postMessage.bind(we)}}return pe}})})}static jb(J,U,se,ae,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(J,U,se,ae,te).then(le=>new P.$5oc(!1,null,te.build(),se,le,ae.subscriptions))}static kb(J,U,se,ae,te){if(typeof se.activate=="function")try{te.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${U.value}`);const le=typeof global=="object"?global:self,ue=se.activate.apply(le,[ae]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ue).then(Z=>(te.activateResolveStop(),Z))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(J,U){this.bb(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:U}).then(void 0,se=>{this.s.error(se)})}mb(J,U=0){const ae=Date.now();(0,M.$B)(()=>{for(let te=U;te<J.length;te+=1){const le=J[te];for(const ue of le.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ae>50){this.mb(J,te);break}else this.lb(le,ue)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(J=>{const U=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(U)this.mb(se);else for(const ae of se)if(ae.activationEvents)for(const te of ae.activationEvents)te==="onStartupFinished"&&this.lb(ae,te)})}ob(){const J=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const U=this.j.workspace?this.j.workspace.folders:[],se=this.pb(U),ae=this.rb(),te=Promise.all([ae,J,se]).then(()=>{});return Promise.race([te,(0,L.$Hh)(1e4)]).then(()=>{this.nb()}),te}pb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.qb(J,U))).then(()=>{})}async qb(J,U){if(this.isActivated(U.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:J.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ue,Z)=>this.y.$checkExists(le,ue,Z)},te=await(0,v.$gyb)(ae,U);if(te)return this.bb(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(J){throw console.error(J),J}}async sb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:U}=this.f.environment;if(!J||!U)throw new Error(s.localize(0,null));const se=await this.xb(null,U,new P.$4oc(!1));if(!se||typeof se.run!="function")throw new Error(s.localize(1,null,U.toString()));return new Promise((ae,te)=>{const le=(oe,pe)=>{oe?(M.$t&&this.s.error("Test runner called back with error",oe),te(oe)):(M.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof pe=="number"&&pe>0?1:0))},ue=(0,T.$8g)(U),Z=se.run(ue,le);Z&&Z.then&&Z.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ae(0)}).catch(oe=>{M.$t&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,U){return this.S[J]=U,(0,R.$Vc)(()=>{delete this.S[J]})}async getRemoteExecServer(J){const{resolver:U}=await this.ub(J);return U?.resolveExecServer?.(J,{resolveAttempt:0})}async ub(J){const U=J.indexOf("+");if(U===-1)throw new i.$CN("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=J.substr(0,U);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(J,U){const se=z.$he.create(!1),ae=()=>`[resolveAuthority(${(0,r.$Vl)(J)},${U})][${se.elapsed()}ms] `,te=q=>this.s.info(`${ae()}${q}`),le=q=>this.s.warn(`${ae()}${q}`),ue=(q,Y=void 0)=>this.s.error(`${ae()}${q}`,Y),Z=q=>{if(q instanceof i.$CN)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},oe=async q=>{te(`activating resolver for ${q}...`);const{resolver:Y,authorityPrefix:_}=await this.ub(q);if(!Y)throw ue(`no resolver for ${_}`),new i.$CN(`No remote extension installed to resolve ${_}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:_,remoteAuthority:q}},pe=J.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(oe)).catch(async q=>{if(!(q instanceof i.$CN)||q._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return le(`resolving nested authorities failed: ${q.message}`),[await oe(J)]})}catch(q){return Z(q)}const Fe=new L.$Rh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Ue,ke;for(const[q,{authorityPrefix:Y,resolver:_,remoteAuthority:fe}]of we.entries())try{if(q===we.length-1)te("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${Y}`),Ue=await _.resolve(fe,{resolveAttempt:U,execServer:ke}),I.mark(`code/extHost/didResolveAuthorityOK/${Y}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,i.$BN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),I.mark(`code/extHost/willResolveExecServer/${Y}`),ke=await _.resolveExecServer?.(fe,{resolveAttempt:U,execServer:ke}),!ke)throw new i.$CN(`Exec server was not available for ${fe}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(be){return I.mark(`code/extHost/didResolveAuthorityError/${Y}`),ue("returned an error",be),Fe.dispose(),Z(be)}Fe.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${i.$BN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let W;if(i.$BN.isManagedResolvedAuthority(Ue)){const q=U;this.Y.setFactory(q,Ue.makeConnection),W={authority:J,connectTo:new r.$Sl(q),connectionToken:Ue.connectionToken}}else W={authority:J,connectTo:new r.$Tl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:W,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(J,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Vl)(J)})`);const{resolver:se}=await this.ub(J);if(!se)return null;const ae=a.URI.revive(U);if(typeof se.getCanonicalURI>"u")return ae;const te=await(0,L.$yh)(()=>se.getCanonicalURI(ae));return te||ae}async $startExtensionHost(J){J.toAdd.forEach(le=>le.extensionLocation=a.URI.revive(le.extensionLocation));const{globalRegistry:U,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.tb()}$activateByEvent(J,U){return U===m.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(J,!1)):this.G.wait().then(se=>this.ab(J,!1))}async $activate(J,U){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.bb(J,U),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(le=>le.extensionLocation=a.URI.revive(le.extensionLocation));const{globalRegistry:U,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const U=o.$Pe.alloc(J),se=Math.random()%256;for(let ae=0;ae<J;ae++)U.writeUInt8(se,ae);return U}async $updateRemoteConnectionData(J){this.X=J,this.a.fire()}};e.$opc=re,e.$opc=re=K=Xe([Ve(0,f.$Fi),Ve(1,e.$npc),Ve(2,S.$1P),Ve(3,c.$Loc),Ve(4,l.$Ooc),Ve(5,k.$ak),Ve(6,u.$eQ),Ve(7,w.$Roc),Ve(8,y.$3Fb),Ve(9,C.$apc),Ve(10,j.$kpc),Ve(11,V.$lpc),Ve(12,A.$epc)],re);function B($e,J,U,se){$e.addActivationEvents(se.addActivationEvents);const ae=new d.$Qcc($e,J.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$sn(U.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)te.delete(ue);for(const ue of se.myToAdd)te.add(ue);const le=de(ae,te);return{globalRegistry:ae,myExtensions:le}}function G($e,J){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function X($e){return $e.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$ppc=(0,f.$Gi)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(J,U,se,ae,te){this.#e=J,this.#t=U,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$kc((0,T.$8g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$qpc=ee;function de($e,J){return $e.getAllExtensionDescriptions().filter(U=>J.has(U.identifier))}class ne{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$rpc=ne;class De{constructor(J){this.a=new n.$tn,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const U of Object.keys(J))this.a.set(U,J[U])}}}),define(Ee[390],Se([1,0,62,2,6,42,26,24,20,30,5,53,12,13]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,s=We(s);let c=class{constructor(o,t,i,r,f,u,w){this.c=o,this.d=t,this.e=i,this.f=r,this.g=f,this.h=u,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),s.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,o,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,t,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$Cqc=c,e.$Cqc=c=Xe([Ve(2,k.$Fi),Ve(3,T.$Ooc),Ve(4,E.$ppc),Ve(5,a.$eQ),Ve(6,l.$ak)],c);let m=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&b.a.size){const t=(0,P.$jf)(this.c(o.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${f}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,i,r,f]=t,u=b.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),i+u+f}c(o){return o.replace(/\\/g,"/")}};m=b=Xe([Ve(0,a.$eQ)],m);class d{constructor(o,t,i,r,f){this.c=o,this.d=t,this.e=i,this.f=r,this.g=f,this.nodeModuleName="vscode",this.a=new R.$tn}load(o,t){const i=this.d.findSubstr(t);if(i){let r=this.a.get(i.identifier);return r||(r=this.c(i,this.e,this.f),this.a.set(i.identifier,r)),r}if(!this.b){let r="";this.d.forEach((f,u)=>r+=`	${u} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(L.$1G,this.e,this.f)}return this.b}}let g=class{constructor(o,t,i){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$uN.MainThreadTelemetry);const r=i.getProxy(I.$uN.MainThreadWindow);this.c=(f,u)=>{const w=h.URI.parse(f);return u?this.g(f,u):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,f,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,f,{}):this.g(f,u)}}load(o,t,i){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=i(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=Xe([Ve(2,$.$1P)],g)}),define(Ee[65],Se([1,0,49,3,17,56,5,64,78,53,10,48,318,42]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=void 0,I=We(I),T=We(T),e.$spc=(0,L.$Gi)("IExtHostVariableResolverProvider");class b extends l.$5Q{constructor(d,g,n,o,t,i,r){function f(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const w=o.tabGroups.all.find(S=>S.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof k.$iP||w.input instanceof k.$nP)return w.input.modified;if(w.input instanceof k.$hP||w.input instanceof k.$mP||w.input instanceof k.$kP)return w.input.uri}}}super({getFolderUri:u=>{const w=i.folders.filter(S=>S.name===u);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,w)=>t.getConfiguration(void 0,u).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return I.$kc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=f();if(u){const w=g.getWorkspaceFolder(u);if(w)return I.$kc(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>d.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let c=class extends h.$Xc{constructor(d,g,n,o,t){super(),this.b=d,this.c=g,this.g=n,this.h=o,this.j=t,this.a=new s.$X(async()=>{const i=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$tpc=c,e.$tpc=c=Xe([Ve(0,a.$ppc),Ve(1,E.$Loc),Ve(2,R.$_P),Ve(3,P.$Ooc),Ve(4,$.$1oc)],c)}),define(Ee[102],Se([1,0,9,4,2,3,24,5,6,78,53,20,10,48,154,120,309,42,65,50,35,16,19,99]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=e.$Bpc=e.$Apc=e.$zpc=void 0,t=We(t),e.$zpc=(0,R.$Gi)("IExtHostDebugService");let f=class extends T.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,p,v,F,N,O,j,z){super(),this.Y=p,this.Z=v,this.$=F,this.ab=N,this.bb=O,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$ne),this.z=this.B(new h.$ne),this.C=this.B(new h.$ne),this.F=this.B(new h.$ne),this.u=A.getProxy($.$uN.MainThreadDebugService),this.I=this.B(new h.$ne),this.L=this.B(new h.$ne),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(V=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(A,p){const v=this.gb(p);if(!v)return;const F=await this.Q.get(A)?.getTreeItem?.(v);return F?this.eb(A,F):void 0}registerDebugVisualizationTree(A,p,v){const F=L.$rn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,T.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(A,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,p){const v=this.S.get(A);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(A){const p=this.S.get(A);if(!p)return;const v=[p.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:A,item:p})),t.DebugTreeItem.from(p,v)}asDebugSourceUri(A,p){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return p&&(F+=`${N}session=${encodeURIComponent(p.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,I.URI.parse(F)}else{if(v.path)return I.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const p=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.$YH)(N)&&p.push(N.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(p=>A.push(p)),A}async $resolveDebugVisualizer(A,p){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:O}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,p)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(O,F.visualization)}async $executeDebugVisualizerCommand(A){const p=this.W.get(A);if(!p)throw new Error(`No debug visualizer found with id '${A}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const p=this.w.get(A.sessionId);return p&&{session:p.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,p,v,F){const N=this.gb(v),O=this.ub(A,p),j=this.P.get(O);if(!N||!j)return[];const z=await j.provideDebugVisualization(N,F);return z?z.map(M=>{const V=++this.X;this.W.set(V,{v:M,provider:j,extensionId:A});const K=M.iconPath?this.wb(M.iconPath):void 0;return{id:V,name:M.name,iconClass:K?.iconClass,iconPath:K?.iconPath,visualization:this.vb(A,M.visualization)}}):[]}$disposeDebugVisualizers(A){for(const p of A)this.W.delete(p)}registerDebugVisualizationProvider(A,p,v){if(!A.contributes?.debugVisualizers?.some(O=>O.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const F=L.$rn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,p),(0,T.$Vc)(()=>{this.u.$unregisterDebugVisualizer(F,p),this.P.delete(p)})}addBreakpoints(A){const p=A.filter(N=>{const O=N.id;return this.H.has(O)?!1:(this.H.set(O,N),!0)});this.rb(p,[],[]);const v=[],F=new Map;for(const N of p)if(N instanceof l.$yO){let O=F.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),O),v.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof l.$zO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const p=A.filter(O=>this.H.delete(O.id));this.rb([],p,[]);const v=p.filter(O=>O instanceof l.$yO).map(O=>O.id),F=p.filter(O=>O instanceof l.$zO).map(O=>O.id),N=p.filter(O=>O instanceof l.$AO).map(O=>O.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(A,p,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===l.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,p,v){if(!p)return new l.$wN(()=>{});const F=this.f++;return this.g.push({type:A,handle:F,provider:p}),this.u.$registerDebugConfigurationProvider(A,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,F),new l.$wN(()=>{this.g=this.g.filter(N=>N.provider!==p),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,p,v){if(!v)return new l.$wN(()=>{});if(!this.nb(A,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:p,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,F),new l.$wN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,p){if(!p)return new l.$wN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:p}),new l.$wN(()=>{this.n=this.n.filter(F=>F.factory!==p)})}async $runInTerminal(A,p){return Promise.resolve(void 0)}async $substituteVariables(A,p){let v;const F=await this.tb(A);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(A,p){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,p){const v=this,F=await this.sb(p);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const O=this.jb(N),j=this.hb(O,F);if(!j)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=j;return this.M.set(A,z),this.ob(F).then(M=>(M&&this.N.set(A,M),z.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const K=V,re={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const B=await this.U.sign(K.arguments.value);re.body={signature:B},z.sendResponse(re)}else throw new Error("no signer")}catch(B){re.success=!1,re.message=B.message,z.sendResponse(re)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(V),V=(0,m.$4H)(V,!0),v.u.$acceptDAMessage(A,V)}),z.onError(V=>{M&&M.onError&&M.onError(V),this.u.$acceptDAError(A,V.name,V.message,V.stack)}),z.onExit(V=>{M&&M.onExit&&M.onExit(V??void 0,void 0),this.u.$acceptDAExit(A,V??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,p){p=(0,m.$3H)(p,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(A)?.sendMessage(p)}$stopDASession(A){const p=this.N.get(A);this.N.delete(A),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const p=[],v=[],F=[];if(A.added)for(const N of A.added){const O=N.id;if(O&&!this.H.has(O)){let j;if(N.type==="function")j=new l.$zO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")j=new l.$AO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=I.URI.revive(N.uri);j=new l.$yO(new l.$IN(z,new l.$xN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,l.$wO)(j,O),this.H.set(O,j),p.push(j)}}if(A.removed)for(const N of A.removed){const O=this.H.get(N);O&&(this.H.delete(N),v.push(O))}if(A.changed){for(const N of A.changed)if(N.id){const O=this.H.get(N.id);if(O){if(O instanceof l.$zO&&N.type==="function"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.functionName=N.functionName}else if(O instanceof l.$yO&&N.type==="source"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.location=new l.$IN(I.URI.revive(N.uri),new l.$xN(N.line,N.character))}F.push(O)}}}this.rb(p,v,F)}async $acceptStackFrameFocus(A){let p;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?p=new l.$GO(v.api,A.threadId):p=new l.$FO(v.api,A.threadId,A.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(A,p,v){return(0,s.$yh)(async()=>{const F=this.mb(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(p);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,p,v,F){return(0,s.$yh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.tb(p);return N.resolveDebugConfiguration(O,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,p,v,F){return(0,s.$yh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.tb(p);return N.resolveDebugConfigurationWithSubstitutedVariables(O,v,F)})}async $provideDebugAdapter(A,p){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(p);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const p=await this.sb(A);this.y.fire(p.api)}async $acceptDebugSessionTerminated(A){const p=await this.sb(A);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,p){(await this.sb(A))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(A,p){const F={session:(await this.sb(A)).api,event:p.event,body:p.body};this.F.fire(F)}jb(A){if(A instanceof l.$BO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof l.$CO)return{type:"server",port:A.port,host:A.host};if(A instanceof l.$DO)return{type:"pipeServer",path:A.path};if(A instanceof l.$EO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const p=this.j.filter(v=>v.type===A);if(p.length>0)return p[0].factory}lb(A){const p=this.j.filter(v=>v.handle===A);if(p.length>0)return p[0].factory}mb(A){const p=this.g.filter(v=>v.handle===A);if(p.length>0)return p[0].provider}nb(A,p){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===p)return!0}}return!1}ob(A){const v=A.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,s.$yh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(O=>O,O=>null));return Promise.race([Promise.all(F).then(N=>{const O=(0,i.$Kb)(N);if(O.length>0)return new S(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new l.$CO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,s.$yh)(()=>A.createDebugAdapterDescriptor(p.api,this.qb(p,N))).then(O=>{if(O)return O})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,F))}qb(A,p){}rb(A,p,v){(A.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:p,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const p=this.w.get(A);if(p)return p}else{let p=this.w.get(A.id);if(!p){const v=await this.tb(A.folderUri),F=A.parent?this.w.get(A.parent):void 0;p=new u(this.u,A.id,A.type,A.name,v,A.configuration,F?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(A){if(A){const p=I.URI.revive(A);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(A,p){return`${A}\0${p}`}vb(A,p){if(p){if("title"in p&&"command"in p)return{type:c.DebugVisualizationType.Command};if("treeId"in p)return{type:c.DebugVisualizationType.Tree,id:`${A}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const p=this.xb(A);let v,F;return"id"in p?F=n.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:F}}xb(A){if(A instanceof l.$tO)return{id:A.id};const p=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof p=="string"?I.URI.file(p):p,light:typeof v=="string"?I.URI.file(v):v}}};e.$Apc=f,e.$Apc=f=Xe([Ve(0,E.$1P),Ve(1,P.$Loc),Ve(2,k.$ppc),Ve(3,d.$Ooc),Ve(4,a.$1oc),Ve(5,g.$spc),Ve(6,o.$kQ),Ve(7,r.$upc)],f);class u{constructor(A,p,v,F,N,O,j){this.f=A,this.g=p,this.h=v,this.j=F,this.k=N,this.l=O,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(p){A.j=p,A.f.$setDebugSessionName(A.g,p)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(p,v){return A.f.$customDebugAdapterRequest(A.g,p,v)},getDebugProtocolBreakpoint(p){return A.f.$getDebugProtocolBreakpoint(A.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$Bpc=u;class w{constructor(A){this.value=Object.freeze({append(p){A.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Cpc=w;class S{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(p=>p.onError?p.onError(A):void 0)}onExit(A,p){this.d.forEach(v=>v.onExit?v.onExit(A,p):void 0)}}class D extends b.$Mtb{constructor(A){super(),this.h=A,A.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends f{constructor(A,p,v,F,N,O,j,z){super(A,p,v,F,N,O,j,z)}};e.$Dpc=y,e.$Dpc=y=Xe([Ve(0,E.$1P),Ve(1,P.$Loc),Ve(2,k.$ppc),Ve(3,d.$Ooc),Ve(4,a.$1oc),Ve(5,g.$spc),Ve(6,o.$kQ),Ve(7,r.$upc)],y)}),define(Ee[391],Se([1,0,14,62,2,6,339,12,89,115,30,275,20,73,53,95]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=e.$Dqc=void 0,s=We(s),h=We(h);class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(R.$ak),i=n.get(l.$1P).getProxy(T.$uN.MainThreadErrors);s.setUnexpectedErrorHandler(r=>{o.error(r);const f=s.$5(r);i.$onUnexpectedError(f)})}static async installFullHandler(n){const o=n.get(R.$ak),t=n.get(l.$1P),i=n.get(b.$ppc),r=n.get(c.$iQ),f=t.getProxy(T.$uN.MainThreadExtensionService),u=t.getProxy(T.$uN.MainThreadErrors),w=await i.getExtensionPathIndex(),S=new WeakMap;function D(A,p){if(S.has(A))return S.get(A).stack;let v="",F,N;for(const j of p)v+=`
	at ${j.toString()}`,N=j.getFileName(),!F&&N&&(F=w.findSubstr(I.URI.file(N)));const O=`${A.name||"Error"}: ${A.message||""}${v}`;return S.set(A,{extensionIdentifier:F?.identifier,stack:O}),O}const y=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(A){if(A===D||!A||A[y]){C=A||D;return}C=function(p,v){return D(p,v),A.call(Error,p,v)},Object.assign(C,{[y]:!0})}}),s.setUnexpectedErrorHandler(A=>{o.error(A);const p=s.$5(A),v=S.get(A);if(!v?.extensionIdentifier){u.$onUnexpectedError(p);return}f.$onExtensionRuntimeError(v.extensionIdentifier,p);const F=r.onExtensionError(v.extensionIdentifier,A);o.trace("forwarded error to extension?",F,v)})}}e.$Dqc=m;class d{constructor(n,o,t,i,r){this.a=t,this.b=new L.$Ycc(n,null,i),o=d.e(o,this.b);const f=new a.$Ei(...(0,$.$Qs)());f.set(k.$eQ,{_serviceBrand:void 0,...o,messagePorts:r}),f.set(l.$1P,new l.$2P(this.b)),f.set(P.$Ioc,new P.$Joc(i)),f.set(b.$npc,t);const u=new E.$ur(f,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(w=>w.get(R.$ak)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(w=>w.get(b.$ppc)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(T.$uN.MainThreadExtensionService);return I.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(o.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=I.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const t=n.environment.extensionDevelopmentLocationURI;return t&&(n.environment.extensionDevelopmentLocationURI=t.map(i=>I.URI.revive(o.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=I.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=I.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=I.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=I.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=I.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=I.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$Eqc=d}),define(Ee[392],Se([1,0,9,11,246,268,149,102,78,53,20,47,10,65,48,310,311,42,35,99]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,h=We(h),I=We(I);let o=class extends R.$Apc{constructor(u,w,S,D,y,C,A,p,v){super(u,w,S,D,C,A,p,v),this.Ab=y,this.yb=new r}hb(u,w){switch(u.type){case"server":return new c.$Jqc(u);case"pipeServer":return new c.$Kqc(u);case"executable":return new c.$Lqc(u,w.type)}return super.hb(u,w)}qb(u,w){const S=c.$Lqc.platformAdapterExecutable(w.getAllExtensionDescriptions(),u.type);if(S)return new l.$BO(S.command,S.args,S.options)}ib(){return new L.$Wgc}async $runInTerminal(u,w){if(u.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const S=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),C=u.title||I.localize(0,null),A=JSON.stringify({shell:D,shellArgs:y});let p=await this.yb.checkout(A,C),v,F=!1;if(p)v=u.cwd;else{const z={shellPath:D,shellArgs:y,cwd:u.cwd,name:C,iconPath:new l.$tO("debug")};F=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,A)}p.show(!0);const N=await p.processId;F?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,s.$Hh)(200)),S.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?p.sendText("cls"):D.indexOf("bash")>=0?p.sendText("clear"):h.$i?p.sendText("cls"):p.sendText("clear")));const O=(0,m.$Nqc)(D,u.args,!!u.argsCanBeInterpretedByShell,v,u.env);p.sendText(O);const j=this.onDidTerminateDebugSession(z=>{z.id===w&&(this.yb.free(p),j.dispose())});return N}else if(u.kind==="external")return i(u,await this.$.getConfigProvider());return super.$runInTerminal(u,w)}};e.$Oqc=o,e.$Oqc=o=Xe([Ve(0,k.$1P),Ve(1,b.$Loc),Ve(2,a.$ppc),Ve(3,d.$Ooc),Ve(4,E.$apc),Ve(5,$.$1oc),Ve(6,P.$spc),Ve(7,g.$kQ),Ve(8,n.$upc)],o);let t;function i(f,u){if(!t)if(h.$i)t=new T.$Efc;else if(h.$j)t=new T.$Ffc;else if(h.$k)t=new T.$Gfc;else throw new Error("external terminals not supported on this platform");const w=u.getConfiguration("terminal");return t.runInTerminal(f.title,f.cwd,f.args,f.env||{},w.external||{})}class r{constructor(){this.b=new Map}static{this.a=1e3}async checkout(u,w,S=!1){const y=[...this.b.entries()].map(([C,A])=>(0,s.$th)(async p=>{if(C.name!==w||A.lastUsedAt!==-1&&await(0,m.$Mqc)(await C.processId))return null;const v=Date.now();return A.lastUsedAt+r.a>v||p.isCancellationRequested?null:A.config!==u?(S&&C.dispose(),null):(A.lastUsedAt=v,C)}));return await(0,s.$Lh)(y,C=>!!C)}insert(u,w){this.b.set(u,{lastUsedAt:Date.now(),config:w})}free(u){const w=this.b.get(u);w&&(w.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}}),define(Ee[393],Se([1,0,17,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,s=We(s),m=We(m);let n=class extends l.$kqc{constructor(t,i,r,f,u,w,S,D,y){super(t,i,r,f,u,w,S,D),this.C=r,this.D=y,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,i){const r=i;if(!i.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const f=l.TaskHandleDTO.from(r,this.C),u=await this.a.$getTaskExecution(f);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(u,i);return this.a.$executeTask(f).catch(()=>{}),w}else{const f=l.TaskDTO.from(i,t);if(f===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(f.execution)&&await this.y(f,i,!1);const u=await this.z(await this.a.$getTaskExecution(f),i);return this.a.$executeTask(f).catch(()=>{}),u}}v(t,i,r,f){const u=[];if(f)for(const w of f){this.A(w,r),(!w.definition||!t[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const S=l.TaskDTO.from(w,r.extension);S&&(u.push(S),l.CustomExecutionDTO.is(S.execution)&&i.push(this.y(S,w,!0)))}return{tasks:u,extension:r.extension}}async w(t){return t}async G(t){let i=t&&t.length>0?t[0]:void 0;if(!i){const r=h.URI.file((0,d.homedir)());i=new $.$1i({uri:r,name:m.$eh(r),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,i){const r=h.URI.revive(t),f={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),w=await this.b.getWorkspaceFolders2()??[],S=await this.D.getResolver(),D=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const y of i.variables)f.variables[y]=await S.resolveAsync(D,y);if(i.process!==void 0){let y;if(i.process.path!==void 0){y=i.process.path.split(s.$wc);for(let C=0;C<y.length;C++)y[C]=await S.resolveAsync(D,y[C])}f.process=await I.win32.findExecutable(await S.resolveAsync(D,i.process.name),i.process.cwd!==void 0?await S.resolveAsync(D,i.process.cwd):void 0,y)}return f}async $jsonTasksSupported(){return!0}async $findExecutable(t,i,r){return I.win32.findExecutable(t,i,r)}};e.$Gqc=n,e.$Gqc=n=Xe([Ve(0,k.$1P),Ve(1,E.$eQ),Ve(2,T.$Loc),Ve(3,L.$_P),Ve(4,R.$Ooc),Ve(5,a.$apc),Ve(6,b.$ak),Ve(7,c.$poc),Ve(8,g.$spc)],n)}),define(Ee[394],Se([1,0,68,65]),function(ce,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0;class I extends h.$tpc{m(){return(0,s.homedir)()}}e.$mrc=I}),define(Ee[171],Se([1,0,19,9,21,51,15,17,23,2,38]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Spc=e.$Rpc=void 0,e.$Tpc=c,R=We(R),$=We($);class E{constructor(g,n,o){this.d=g,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(g,n){const o=this.g.folderQueries||[],t=new I.$ye(n);return new Promise((i,r)=>{this.a=new P(g);let f=!1;const u=(w,S)=>{if(!f&&!this.b){const D=this.h(w);c(w)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,t.cancel(),w=this.j(w,this.g.maxResults-this.c));const y=this.h(w);this.c+=y,(y>0||!c(w))&&this.a.add(w,S)}};Promise.all(o.map((w,S)=>this.k(w,D=>u(D,S),t.token))).then(w=>{t.dispose(),this.a.flush();const S=w.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||S,messages:w.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},w=>{t.dispose();const S=(0,T.$rj)(w);r(new Error(S))})})}h(g){return c(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,n){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,n),preview:{matches:t.slice(0,n),text:g.preview.text},uri:g.uri}}async k(g,n,o){const t=new k.$$L(this.g,g),i=[],r={report:w=>{if(!this.l(w))return;const S=g.folder.scheme===L.Schemas.file?(0,k.$_L)(()=>this.e.readdir($.$gh(w.uri))):void 0,D=$.$jh(g.folder,w.uri);if(D){const y=t.includedInQuery(D,R.$qc(D),S);(0,h.$sh)(y)?i.push(y.then(C=>{C&&n(w)})):y&&n(w)}}},f=this.n(g);let u;return this.d.query.type===k.QueryType.aiText?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,r,o):u=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),f,r,o),i.length&&await Promise.all(i),u}l(g){if(c(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const n=(0,k.$0L)(this.g.includePattern,g.includePattern),o=(0,k.$0L)(this.g.excludePattern,g.excludePattern),t={folder:a.URI.from(g.folder),excludes:o,includes:n,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.e.toCanonicalName(g.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??k.$QL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Rpc=E;function l(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class P{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(g,n){this.d&&(this.b!==n||!$.$ah(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:g.uri,results:[]}),this.d.results.push(b(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.$Spc=P;function b(d){return c(d)?{preview:{matches:(0,s.$4b)(d.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:d.preview.text},ranges:(0,s.$4b)(d.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function c(d){return!!d.preview}class m{static{this.a=4e3}static{this.b=50}constructor(g,n){this.g=g,this.h=n,this.c=0,this.d=[],this.e=0}addItem(g,n){g&&this.j(g,n)}addItems(g,n){g&&this.k(g,n)}j(g,n){this.d.push(g),this.e+=n,this.l()}k(g,n){this.d=this.d.concat(g),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Upc=m}),define(Ee[103],Se([1,0,3,6,5,387,20,73,12,2,171]),function(ce,e,s,h,I,T,L,R,$,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=e.$Vpc=void 0,e.$Xpc=l,e.$Vpc=(0,I.$Gi)("IExtHostSearch");let E=class{constructor(c,m,d){this.n=c,this.o=m,this.q=d,this.c=this.n.getProxy(h.$uN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$Qpc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const d=this.d++;return this.e.set(d,m),this.c.$registerTextSearchProvider(d,this.s(c)),(0,s.$Vc)(()=>{this.g.delete(c),this.e.delete(d),this.c.$unregisterProvider(d)})}registerAITextSearchProvider(c,m){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const d=this.d++;return this.h.set(d,m),this.c.$registerAITextSearchProvider(d,this.s(c)),(0,s.$Vc)(()=>{this.i.delete(c),this.h.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(c,m){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const d=this.d++;return this.j.set(d,m),this.c.$registerFileSearchProvider(d,this.s(c)),(0,s.$Vc)(()=>{this.k.delete(c),this.j.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(c,m,d,g){const n=l(d),o=this.j.get(c);if(o)return this.l.fileSearch(n,o,t=>{this.c.$handleFileMatch(c,m,t.map(i=>i.resource))},g);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,d){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,d,g){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=l(d);return this.t(o,n).search(i=>this.c.$handleTextMatch(c,m,i),g)}$provideAITextSearchResults(c,m,d,g){const n=this.h.get(c);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=l(d);return this.v(o,n).search(i=>this.c.$handleTextMatch(c,m,i),g)}$enableExtensionHostSearch(){}t(c,m){return new k.$Rpc({query:c,provider:m},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}v(c,m){return new k.$Rpc({query:c,provider:m},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"aiTextSearchProvider")}};e.$Wpc=E,e.$Wpc=E=Xe([Ve(0,L.$1P),Ve(1,R.$Ioc),Ve(2,$.$ak)],E);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(P),extraFileResources:b.extraFileResources&&b.extraFileResources.map(c=>a.URI.revive(c))}}function P(b){return{...b,folder:a.URI.revive(b.folder)}}});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[395],Se([1,0,21,14,4,3,15,44,2,114,213,194,55,24,28,12,91,92,296,6,341,368,96,128,345,346,347,326,316,35,348,42,349,102,163,350,328,342,351,352,64,78,329,343,53,353,76,354,63,30,369,330,355,356,129,357,123,124,331,386,359,300,360,370,361,169,332,362,363,364,20,365,103,125,366,333,367,126,98,101,95,47,167,99,371,344,372,373,77,16,10,334,73,335,97,374,375,162,48,120,94,26,100]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u,w,S,D,y,C,A,p,v,F,N,O,j,z,M,V,K,re,B,G,X,ee,de,ne,De,$e,J,U,se,ae,te,le,ue,Z,oe,pe,we,Fe,Ue,ke,Pe,Te,W,q,Y,_,fe,be,Ne,Ge,Ke,tt,rt,ot,nt,at,mt,ht,ct,Ie,ze,He,Oe,je,he,x,Ce,Ye,et,ut,gt,Dt,Ot,qt,ui,ti,_e,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=Qt,h=We(h),R=jt(R),E=We(E),b=We(b),he=We(he),x=We(x);function Qt(pt){const It=pt.get(De.$eQ),ii=pt.get(ne.$toc),Zt=pt.get(ee.$Qoc),Vt=pt.get(G.$ppc),vt=pt.get(qt.$Loc),Nt=pt.get(at.$iQ),hi=pt.get(A.$Ooc),Gt=pt.get(Ye.$Ioc),xe=pt.get(_.$1P),xt=pt.get(rt.$0oc),ni=pt.get(ot.$Roc),di=pt.get(c.$bk),kt=pt.get(c.$ak),Ft=pt.get(je.$3Fb),Rt=pt.get(i.$poc),zt=pt.get(Ot.$xqc),ri=pt.get(Ne.$hpc),_t=pt.get(K.$1oc),si=pt.get(ue.$lpc),Bt=pt.get(r.$zoc),Jt=pt.get(ae.$epc);xe.set(n.$vN.ExtHostFileSystemInfo,ii),xe.set(n.$vN.ExtHostLogLevelServiceShape,di),xe.set(n.$vN.ExtHostWorkspace,vt),xe.set(n.$vN.ExtHostConfiguration,hi),xe.set(n.$vN.ExtHostExtensionService,Vt),xe.set(n.$vN.ExtHostStorage,xt),xe.set(n.$vN.ExtHostTunnelService,Ft),xe.set(n.$vN.ExtHostWindow,zt),xe.set(n.$vN.ExtHostSecretState,ri),xe.set(n.$vN.ExtHostTelemetry,Nt),xe.set(n.$vN.ExtHostEditorTabs,_t),xe.set(n.$vN.ExtHostManagedSockets,si),xe.set(n.$vN.ExtHostAuthentication,Bt),xe.set(n.$vN.ExtHostChatProvider,Jt);const oi=xe.set(n.$vN.ExtHostDecorations,pt.get(F.$Fpc)),At=xe.set(n.$vN.ExtHostDocumentsAndEditors,pt.get(V.$_P)),St=xe.set(n.$vN.ExtHostCommands,pt.get(y.$kQ)),wt=xe.set(n.$vN.ExtHostTerminalService,pt.get(mt.$apc)),ei=xe.set(n.$vN.ExtHostTerminalShellIntegration,pt.get(ht.$nqc)),Pt=xe.set(n.$vN.ExtHostDebugService,pt.get(v.$zpc)),fi=xe.set(n.$vN.ExtHostSearch,pt.get(be.$Vpc)),Ht=xe.set(n.$vN.ExtHostTask,pt.get(nt.$mqc)),wi=xe.set(n.$vN.ExtHostOutputService,pt.get(Pe.$_pc)),vi=xe.set(n.$vN.ExtHostLocalization,pt.get(le.$kpc)),gi=xe.set(n.$vN.ExtHostUrls,new et.$uqc(xe)),Ut=xe.set(n.$vN.ExtHostDocuments,new M.$woc(xe,At)),ai=xe.set(n.$vN.ExtHostDocumentContentProviders,new j.$Hpc(xe,At,kt)),Ii=xe.set(n.$vN.ExtHostDocumentSaveParticipant,new z.$Ipc(kt,Ut,xe.getProxy(n.$uN.MainThreadBulkEdits))),Tt=xe.set(n.$vN.ExtHostNotebook,new oe.$Ypc(xe,St,At,Ut,Zt,fi,kt)),Si=xe.set(n.$vN.ExtHostNotebookDocuments,new we.$6pc(Tt)),Ci=xe.set(n.$vN.ExtHostNotebookEditors,new Fe.$7pc(kt,Tt)),Di=xe.set(n.$vN.ExtHostNotebookKernels,new Ue.$8pc(xe,It,Tt,St,kt)),$i=xe.set(n.$vN.ExtHostNotebookRenderers,new ke.$0pc(xe,Tt)),Ai=xe.set(n.$vN.ExtHostNotebookDocumentSaveParticipant,new pe.$5pc(kt,Tt,xe.getProxy(n.$uN.MainThreadBulkEdits))),Wt=xe.set(n.$vN.ExtHostEditors,new Ie.$Foc(xe,At)),Ae=xe.set(n.$vN.ExtHostTreeViews,new Oe.$sqc(xe.getProxy(n.$uN.MainThreadTreeViews),St,kt)),Me=xe.set(n.$vN.ExtHostEditorInsets,new D.$Goc(xe.getProxy(n.$uN.MainThreadEditorInsets),Wt,It.remote)),ve=xe.set(n.$vN.ExtHostDiagnostics,new N.$voc(xe,kt,ii,At)),ie=xe.set(n.$vN.ExtHostLanguages,new te.$3pc(xe,Ut,St.converter,Gt)),Re=xe.set(n.$vN.ExtHostLanguageFeatures,new U.$xoc(xe,Gt,Ut,St,ve,kt,Rt,Nt)),Qe=xe.set(n.$vN.ExtHostFileSystem,new X.$Lpc(xe,Re)),it=xe.set(n.$vN.ExtHostFileSystemEventService,new de.$Mpc(xe,kt,At)),Je=xe.set(n.$vN.ExtHostQuickOpen,(0,Y.$dqc)(xe,vt,St)),ft=xe.set(n.$vN.ExtHostSCM,new fe.$fqc(xe,St,Ut,kt)),Ct=xe.set(n.$vN.ExtHostQuickDiff,new q.$cqc(xe,Gt)),Xt=xe.set(n.$vN.ExtHostShare,new Ge.$gqc(xe,Gt)),ci=xe.set(n.$vN.ExtHostComments,(0,C.$Hoc)(xe,St,Ut)),Mt=xe.set(n.$vN.ExtHostProgress,new W.$bqc(xe.getProxy(n.$uN.MainThreadProgress))),li=xe.set(n.$vN.ExtHostLabelService,new J.$1pc(xe)),qi=xe.set(n.$vN.ExtHostTheming,new ze.$pqc(xe)),pn=xe.set(n.$vN.ExtHostTimeline,new He.$rqc(xe,St)),Fi=xe.set(n.$vN.ExtHostWebviews,new ut.$Voc(xe,It.remote,vt,kt,Rt)),Li=xe.set(n.$vN.ExtHostWebviewPanels,new gt.$Yoc(xe,Fi,vt)),Vi=xe.set(n.$vN.ExtHostCustomEditors,new p.$Zoc(xe,Ut,ni,Fi,Li)),xi=xe.set(n.$vN.ExtHostWebviewViews,new Dt.$vqc(xe,Fi)),ki=xe.set(n.$vN.ExtHostTesting,pt.get(ct.$upc)),_i=xe.set(n.$vN.ExtHostUriOpeners,new Ce.$tqc(xe)),en=xe.set(n.$vN.ExtHostProfileContentHandlers,new Te.$aqc(xe));xe.set(n.$vN.ExtHostInteractive,new $e.$Zpc(xe,Tt,At,St,kt));const Mi=xe.set(n.$vN.ExtHostChatAgents2,new u.$Coc(xe,kt,St)),tn=xe.set(n.$vN.ExtHostChatVariables,new w.$Doc(xe)),Gi=xe.set(n.$vN.ExtHostLanguageModelTools,new se.$2pc(xe)),nn=xe.set(n.$vN.ExtHostAiRelatedInformation,new o.$ooc(xe)),Hi=xe.set(n.$vN.ExtHostAiEmbeddingVector,new B.$Kpc(xe)),ji=xe.set(n.$vN.ExtHostStatusBar,new tt.$jqc(xe,St.converter)),bn=xe.set(n.$vN.ExtHostSpeech,new Ke.$hqc(xe)),Oi=xe.set(n.$vN.ExtHostEmbeddings,new re.$Jpc(xe)),rn=Object.values(n.$vN);xe.assertRegistered(rn);const wn=new f.$Boc(xe,At),Ki=new S.$Eoc(xe),zi=new Z.$4pc(xe,kt),Qi=new O.$Gpc(xe);return t.$yoc.register(St),function(qe,yi,Bi){function lt(ge){return(ye,Be,dt)=>{const Et=ge(Lt=>{try{ye.call(Be,Lt)}catch(Ri){h.$4(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Nt.onExtensionError(qe.identifier,Ri)}});return dt?.push(Et),Et}}const bt=function(){let ge=!qe.isUnderDevelopment;function ye(){ge||(kt.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(dt){if(Array.isArray(dt))dt.forEach(Be);else if(typeof dt=="string")ye();else{const Et=dt;typeof Et.scheme>"u"&&ye(),typeof Et.exclusive=="boolean"&&(0,_e.$7G)(qe,"documentFiltersExclusive")}return dt}}(),Ui={getSession(ge,ye,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,_e.$7G)(qe,"authLearnMore"),Be?.account&&(0,_e.$7G)(qe,"authGetSessions"),Bt.getSession(qe,ge,ye,Be)},getSessions(ge,ye){return(0,_e.$7G)(qe,"authGetSessions"),Bt.getSessions(qe,ge,ye)},getAccounts(ge){return(0,_e.$7G)(qe,"authGetSessions"),Bt.getAccounts(ge)},async hasSession(ge,ye){return(0,_e.$7G)(qe,"authSession"),!!await Bt.getSession(qe,ge,ye,{silent:!0})},get onDidChangeSessions(){return lt(Bt.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,Be,dt){return Bt.registerAuthenticationProvider(ge,ye,Be,dt)}},vn={registerCommand(ge,ye,Be){return St.registerCommand(!0,ge,ye,Be,void 0,qe)},registerTextEditorCommand(ge,ye,Be){return St.registerCommand(!0,ge,(...dt)=>{const Et=Wt.getActiveTextEditor();if(!Et){kt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Et.edit(Lt=>{ye.apply(Be,[Et,Lt,...dt])}).then(Lt=>{Lt||kt.warn("Edits from command "+ge+" were not applied.")},Lt=>{kt.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,qe)},registerDiffInformationCommand:(ge,ye,Be)=>((0,_e.$7G)(qe,"diffCommand"),St.registerCommand(!0,ge,async(...dt)=>{const Et=At.activeEditor(!0);if(!Et){kt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Wt.getDiffInformation(Et.id);ye.apply(Be,[Lt,...dt])},void 0,void 0,qe)),executeCommand(ge,...ye){return St.executeCommand(ge,...ye)},getCommands(ge=!1){return St.getCommands(ge)}},mi={get machineId(){return It.telemetryInfo.machineId},get sessionId(){return It.telemetryInfo.sessionId},get language(){return It.environment.appLanguage},get appName(){return It.environment.appName},get appRoot(){return It.environment.appRoot?.fsPath??""},get appHost(){return It.environment.appHost},get uriScheme(){return It.environment.appUriScheme},get clipboard(){return Ki.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return lt(wt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$7G)(qe,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$7G)(qe,"telemetry"),lt(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$hQ)(It.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return at.$gQ.validateSender(ge),Nt.instantiateLogger(qe,ge,ye)},openExternal(ge,ye){return zt.openUri(ge,{allowTunneling:!!It.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===It.environment.appUriScheme)return gi.createAppUri(ge);try{return await zt.asExternalUri(ge,{allowTunneling:!!It.remote.authority})}catch(ye){if((0,L.$Pg)(ge,L.Schemas.http)||(0,L.$Pg)(ge,L.Schemas.https))return ge;throw ye}},get remoteName(){return(0,m.$in)(It.remote.authority)},get remoteAuthority(){return(0,_e.$7G)(qe,"resolvers"),It.remote.authority},get uiKind(){return It.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,_e.$7G)(qe,"resolvers"),It.quality},get appCommit(){return(0,_e.$7G)(qe,"resolvers"),It.commit}};It.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(ge,ye,Be){return ki.createTestController(qe,ge,ye,Be)},createTestObserver(){return(0,_e.$7G)(qe,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,_e.$7G)(qe,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,_e.$7G)(qe,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,_e.$7G)(qe,"testObserver"),lt(ki.onResultsChanged)},get testResults(){return(0,_e.$7G)(qe,"testObserver"),ki.results}},Ni=It.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,sn={getExtension(ge,ye){(0,_e.$6G)(qe,"extensionsAny")||(ye=!1);const Be=yi.mine.getExtensionDescription(ge);if(Be)return new G.$qpc(Vt,qe.identifier,Be,Ni,!1);if(ye){const dt=yi.all.getExtensionDescription(ge);if(dt)return new G.$qpc(Vt,qe.identifier,dt,Ni,!0)}},get all(){const ge=[];for(const ye of yi.mine.getAllExtensionDescriptions())ge.push(new G.$qpc(Vt,qe.identifier,ye,Ni,!1));return ge},get allAcrossExtensionHosts(){(0,_e.$7G)(qe,"extensionsAny");const ge=new P.$sn(yi.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ye=[];for(const Be of yi.all.getAllExtensionDescriptions()){const dt=!ge.has(Be.identifier);ye.push(new G.$qpc(Vt,qe.identifier,Be,Ni,dt))}return ye},get onDidChange(){return(0,_e.$6G)(qe,"extensionsAny")?lt(I.Event.any(yi.mine.onDidChange,yi.all.onDidChange)):lt(yi.mine.onDidChange)}},on={createDiagnosticCollection(ge){return ve.createDiagnosticCollection(qe.identifier,ge)},get onDidChangeDiagnostics(){return lt(ve.onDidChangeDiagnostics)},getDiagnostics:ge=>ve.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,ye){return ie.changeLanguage(ge.uri,ye)},match(ge,ye){const Be=he.LanguageSelector.from(ge);let dt;return(0,k.$uu)(Be)&&(dt=Tt.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Lt=>Lt.document===ye))?.apiNotebook),(0,k.$tu)(Be,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,ye,Be){return Re.registerCodeActionProvider(qe,bt(ge),ye,Be)},registerDocumentPasteEditProvider(ge,ye,Be){return(0,_e.$7G)(qe,"documentPaste"),Re.registerDocumentPasteEditProvider(qe,bt(ge),ye,Be)},registerCodeLensProvider(ge,ye){return Re.registerCodeLensProvider(qe,bt(ge),ye)},registerDefinitionProvider(ge,ye){return Re.registerDefinitionProvider(qe,bt(ge),ye)},registerDeclarationProvider(ge,ye){return Re.registerDeclarationProvider(qe,bt(ge),ye)},registerImplementationProvider(ge,ye){return Re.registerImplementationProvider(qe,bt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return Re.registerTypeDefinitionProvider(qe,bt(ge),ye)},registerHoverProvider(ge,ye){return Re.registerHoverProvider(qe,bt(ge),ye,qe.identifier)},registerEvaluatableExpressionProvider(ge,ye){return Re.registerEvaluatableExpressionProvider(qe,bt(ge),ye,qe.identifier)},registerInlineValuesProvider(ge,ye){return Re.registerInlineValuesProvider(qe,bt(ge),ye,qe.identifier)},registerDocumentHighlightProvider(ge,ye){return Re.registerDocumentHighlightProvider(qe,bt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return Re.registerMultiDocumentHighlightProvider(qe,bt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return Re.registerLinkedEditingRangeProvider(qe,bt(ge),ye)},registerReferenceProvider(ge,ye){return Re.registerReferenceProvider(qe,bt(ge),ye)},registerRenameProvider(ge,ye){return Re.registerRenameProvider(qe,bt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,_e.$7G)(qe,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(qe,bt(ge),ye)},registerDocumentSymbolProvider(ge,ye,Be){return Re.registerDocumentSymbolProvider(qe,bt(ge),ye,Be)},registerWorkspaceSymbolProvider(ge){return Re.registerWorkspaceSymbolProvider(qe,ge)},registerDocumentFormattingEditProvider(ge,ye){return Re.registerDocumentFormattingEditProvider(qe,bt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return Re.registerDocumentRangeFormattingEditProvider(qe,bt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,Be,...dt){return Re.registerOnTypeFormattingEditProvider(qe,bt(ge),ye,[Be].concat(dt))},registerDocumentSemanticTokensProvider(ge,ye,Be){return Re.registerDocumentSemanticTokensProvider(qe,bt(ge),ye,Be)},registerDocumentRangeSemanticTokensProvider(ge,ye,Be){return Re.registerDocumentRangeSemanticTokensProvider(qe,bt(ge),ye,Be)},registerSignatureHelpProvider(ge,ye,Be,...dt){return typeof Be=="object"?Re.registerSignatureHelpProvider(qe,bt(ge),ye,Be):Re.registerSignatureHelpProvider(qe,bt(ge),ye,typeof Be>"u"?[]:[Be,...dt])},registerCompletionItemProvider(ge,ye,...Be){return Re.registerCompletionItemProvider(qe,bt(ge),ye,Be)},registerInlineCompletionItemProvider(ge,ye,Be){return ye.handleDidShowCompletionItem&&(0,_e.$7G)(qe,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,_e.$7G)(qe,"inlineCompletionsAdditions"),Be&&(0,_e.$7G)(qe,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(qe,bt(ge),ye,Be)},registerInlineEditProvider(ge,ye){return(0,_e.$7G)(qe,"inlineEdit"),Re.registerInlineEditProvider(qe,bt(ge),ye)},registerDocumentLinkProvider(ge,ye){return Re.registerDocumentLinkProvider(qe,bt(ge),ye)},registerColorProvider(ge,ye){return Re.registerColorProvider(qe,bt(ge),ye)},registerFoldingRangeProvider(ge,ye){return Re.registerFoldingRangeProvider(qe,bt(ge),ye)},registerSelectionRangeProvider(ge,ye){return Re.registerSelectionRangeProvider(qe,ge,ye)},registerCallHierarchyProvider(ge,ye){return Re.registerCallHierarchyProvider(qe,ge,ye)},registerTypeHierarchyProvider(ge,ye){return Re.registerTypeHierarchyProvider(qe,ge,ye)},setLanguageConfiguration:(ge,ye)=>Re.setLanguageConfiguration(qe,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,_e.$7G)(qe,"tokenInformation"),ie.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return Re.registerInlayHintsProvider(qe,ge,ye)},createLanguageStatusItem(ge,ye){return ie.createLanguageStatusItem(qe,ge,ye)},registerDocumentDropEditProvider(ge,ye,Be){return Re.registerDocumentOnDropEditProvider(qe,ge,ye,(0,_e.$6G)(qe,"documentPaste")?Be:void 0)}},an={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ge,ye,Be){$.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&Rt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(cn.openTextDocument(ge)):Promise.resolve(ge));return Wt.showTextDocument(dt,ye,Be)},createTextEditorDecorationType(ge){return Wt.createTextEditorDecorationType(qe,ge)},onDidChangeActiveTextEditor(ge,ye,Be){return lt(Wt.onDidChangeActiveTextEditor)(ge,ye,Be)},onDidChangeVisibleTextEditors(ge,ye,Be){return lt(Wt.onDidChangeVisibleTextEditors)(ge,ye,Be)},onDidChangeTextEditorSelection(ge,ye,Be){return lt(Wt.onDidChangeTextEditorSelection)(ge,ye,Be)},onDidChangeTextEditorOptions(ge,ye,Be){return lt(Wt.onDidChangeTextEditorOptions)(ge,ye,Be)},onDidChangeTextEditorVisibleRanges(ge,ye,Be){return lt(Wt.onDidChangeTextEditorVisibleRanges)(ge,ye,Be)},onDidChangeTextEditorViewColumn(ge,ye,Be){return lt(Wt.onDidChangeTextEditorViewColumn)(ge,ye,Be)},onDidCloseTerminal(ge,ye,Be){return lt(wt.onDidCloseTerminal)(ge,ye,Be)},onDidOpenTerminal(ge,ye,Be){return lt(wt.onDidOpenTerminal)(ge,ye,Be)},onDidChangeActiveTerminal(ge,ye,Be){return lt(wt.onDidChangeActiveTerminal)(ge,ye,Be)},onDidChangeTerminalDimensions(ge,ye,Be){return(0,_e.$7G)(qe,"terminalDimensions"),lt(wt.onDidChangeTerminalDimensions)(ge,ye,Be)},onDidChangeTerminalState(ge,ye,Be){return lt(wt.onDidChangeTerminalState)(ge,ye,Be)},onDidWriteTerminalData(ge,ye,Be){return(0,_e.$7G)(qe,"terminalDataWriteEvent"),lt(wt.onDidWriteTerminalData)(ge,ye,Be)},onDidExecuteTerminalCommand(ge,ye,Be){return(0,_e.$7G)(qe,"terminalExecuteCommandEvent"),lt(wt.onDidExecuteTerminalCommand)(ge,ye,Be)},onDidChangeTerminalShellIntegration(ge,ye,Be){return(0,_e.$7G)(qe,"terminalShellIntegration"),lt(ei.onDidChangeTerminalShellIntegration)(ge,ye,Be)},onDidStartTerminalShellExecution(ge,ye,Be){return(0,_e.$7G)(qe,"terminalShellIntegration"),lt(ei.onDidStartTerminalShellExecution)(ge,ye,Be)},onDidEndTerminalShellExecution(ge,ye,Be){return(0,_e.$7G)(qe,"terminalShellIntegration"),lt(ei.onDidEndTerminalShellExecution)(ge,ye,Be)},get state(){return zt.getState()},onDidChangeWindowState(ge,ye,Be){return lt(zt.onDidChangeWindowState)(ge,ye,Be)},showInformationMessage(ge,...ye){return zi.showMessage(qe,R.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return zi.showMessage(qe,R.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return zi.showMessage(qe,R.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,Be){return Je.showQuickPick(qe,ge,ye,Be)},showWorkspaceFolderPick(ge){return Je.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return Je.showInput(ge,ye)},showOpenDialog(ge){return Qi.showOpenDialog(qe,ge)},showSaveDialog(ge){return Qi.showSaveDialog(ge)},createStatusBarItem(ge,ye,Be){let dt,Et,Lt;return typeof ge=="string"?(dt=ge,Et=ye,Lt=Be):(Et=ge,Lt=ye),ji.createStatusBarEntry(qe,dt,Et,Lt)},setStatusBarMessage(ge,ye){return ji.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Rt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),Mt.withProgress(qe,{location:x.ProgressLocation.SourceControl},(ye,Be)=>ge({report(dt){}}))},withProgress(ge,ye){return Mt.withProgress(qe,ge,ye)},createOutputChannel(ge,ye){return wi.createOutputChannel(ge,ye,qe)},createWebviewPanel(ge,ye,Be,dt){return Li.createWebviewPanel(qe,ge,ye,Be,dt)},createWebviewTextEditorInset(ge,ye,Be,dt){return(0,_e.$7G)(qe,"editorInsets"),Me.createWebviewEditorInset(ge,ye,Be,dt,qe)},createTerminal(ge,ye,Be){return typeof ge=="object"?"pty"in ge?wt.createExtensionTerminal(ge):wt.createTerminalFromOptions(ge):wt.createTerminal(ge,ye,Be)},registerTerminalLinkProvider(ge){return wt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return wt.registerProfileProvider(qe,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,_e.$7G)(qe,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ge,qe.identifier.value,ye)},registerTreeDataProvider(ge,ye){return Ae.registerTreeDataProvider(ge,ye,qe)},createTreeView(ge,ye){return Ae.createTreeView(ge,ye,qe)},registerWebviewPanelSerializer:(ge,ye)=>Li.registerWebviewPanelSerializer(qe,ge,ye),registerCustomEditorProvider:(ge,ye,Be={})=>Vi.registerCustomEditorProvider(qe,ge,ye,Be),registerFileDecorationProvider(ge){return oi.registerFileDecorationProvider(ge,qe)},registerUriHandler(ge){return gi.registerUriHandler(qe,ge)},createQuickPick(){return Je.createQuickPick(qe)},createInputBox(){return Je.createInputBox(qe)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,Be){return lt(qi.onDidChangeActiveColorTheme)(ge,ye,Be)},registerWebviewViewProvider(ge,ye,Be){return xi.registerWebviewViewProvider(qe,ge,ye,Be?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,Be){return lt(Tt.onDidChangeActiveNotebookEditor)(ge,ye,Be)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,Be){return lt(Ci.onDidChangeNotebookEditorSelection)(ge,ye,Be)},onDidChangeNotebookEditorVisibleRanges(ge,ye,Be){return lt(Ci.onDidChangeNotebookEditorVisibleRanges)(ge,ye,Be)},showNotebookDocument(ge,ye){return Tt.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,Be){return(0,_e.$7G)(qe,"externalUriOpener"),_i.registerExternalUriOpener(qe.identifier,ge,ye,Be)},registerProfileContentHandler(ge,ye){return(0,_e.$7G)(qe,"profileContentHandlers"),en.registerProfileContentHandler(qe,ge,ye)},registerQuickDiffProvider(ge,ye,Be,dt){return(0,_e.$7G)(qe,"quickDiffProvider"),Ct.registerQuickDiffProvider(bt(ge),ye,Be,dt)},get tabGroups(){return _t.tabGroups},registerShareProvider(ge,ye){return(0,_e.$7G)(qe,"shareProvider"),Xt.registerShareProvider(bt(ge),ye)}},cn={get rootPath(){return Rt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(ge){throw new h.$_("rootPath")},getWorkspaceFolder(ge){return vt.getWorkspaceFolder(ge)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(ge){throw new h.$_("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(ge){throw new h.$_("workspaceFile")},updateWorkspaceFolders:(ge,ye,...Be)=>vt.updateWorkspaceFolders(qe,ge,ye||0,...Be),onDidChangeWorkspaceFolders:function(ge,ye,Be){return lt(vt.onDidChangeWorkspace)(ge,ye,Be)},asRelativePath:(ge,ye)=>vt.getRelativePath(ge,ye),findFiles:(ge,ye,Be,dt)=>vt.findFiles(ge,ye,Be,qe.identifier,dt),findFiles2:(ge,ye,Be)=>((0,_e.$7G)(qe,"findFiles2"),vt.findFiles2(ge,ye,qe.identifier,Be)),findTextInFiles:(ge,ye,Be,dt)=>{(0,_e.$7G)(qe,"findTextInFiles");let Et,Lt;return typeof ye=="object"?(Et=ye,Lt=Be):(Et={},Lt=ye,dt=Be),vt.findTextInFiles(ge,Et||{},Lt,qe.identifier,dt)},save:ge=>vt.save(ge),saveAs:ge=>vt.saveAs(ge),saveAll:ge=>vt.saveAll(ge),applyEdit(ge,ye){return wn.applyWorkspaceEdit(ge,qe,ye)},createFileSystemWatcher:(ge,ye,Be,dt)=>{let Et;return typeof ye=="boolean"?Et={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,_e.$7G)(qe,"createFileSystemWatcher"),Et={...ye,correlate:!0}),it.createFileSystemWatcher(vt,qe,ge,Et)},get textDocuments(){return Ut.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$_("textDocuments")},openTextDocument(ge){let ye;const Be=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!Be||typeof Be=="object")ye=Ut.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Rt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),Ut.ensureDocumentData(dt).then(Et=>Et.document)))},onDidOpenTextDocument:(ge,ye,Be)=>lt(Ut.onDidAddDocument)(ge,ye,Be),onDidCloseTextDocument:(ge,ye,Be)=>lt(Ut.onDidRemoveDocument)(ge,ye,Be),onDidChangeTextDocument:(ge,ye,Be)=>lt(Ut.onDidChangeDocument)(ge,ye,Be),onDidSaveTextDocument:(ge,ye,Be)=>lt(Ut.onDidSaveDocument)(ge,ye,Be),onWillSaveTextDocument:(ge,ye,Be)=>lt(Ii.getOnWillSaveTextDocumentEvent(qe))(ge,ye,Be),get notebookDocuments(){return Tt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let Be;if($.URI.isUri(ge))Be=ge,await Tt.openNotebookDocument(ge);else if(typeof ge=="string")Be=$.URI.revive(await Tt.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,ye,Be){return lt(Si.onDidSaveNotebookDocument)(ge,ye,Be)},onDidChangeNotebookDocument(ge,ye,Be){return lt(Si.onDidChangeNotebookDocument)(ge,ye,Be)},onWillSaveNotebookDocument(ge,ye,Be){return lt(Ai.getOnWillSaveNotebookDocumentEvent(qe))(ge,ye,Be)},get onDidOpenNotebookDocument(){return lt(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,Be,dt){return Tt.registerNotebookSerializer(qe,ge,ye,Be,(0,_e.$6G)(qe,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,ye,Be)=>lt(Bi.onDidChangeConfiguration)(ge,ye,Be),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,Bi.getConfiguration(ge,ye,qe)},registerTextDocumentContentProvider(ge,ye){return ai.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Rt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(qe,ge,ye)),registerFileSystemProvider(ge,ye,Be){return(0,T.$Uc)(Qe.registerFileSystemProvider(qe,ge,ye,Be),Zt.addFileSystemProvider(ge,ye,Be))},get fs(){return Zt.value},registerFileSearchProvider:(ge,ye)=>((0,_e.$7G)(qe,"fileSearchProvider"),fi.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,_e.$7G)(qe,"textSearchProvider"),fi.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,_e.$7G)(qe,"aiTextSearchProvider"),(0,_e.$7G)(qe,"textSearchProvider"),fi.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,_e.$7G)(qe,"resolvers"),Vt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,_e.$7G)(qe,"resolvers"),li.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,_e.$7G)(qe,"resolvers"),Vt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,Be)=>lt(it.onDidCreateFile)(ge,ye,Be),onDidDeleteFiles:(ge,ye,Be)=>lt(it.onDidDeleteFile)(ge,ye,Be),onDidRenameFiles:(ge,ye,Be)=>lt(it.onDidRenameFile)(ge,ye,Be),onWillCreateFiles:(ge,ye,Be)=>lt(it.getOnWillCreateFileEvent(qe))(ge,ye,Be),onWillDeleteFiles:(ge,ye,Be)=>lt(it.getOnWillDeleteFileEvent(qe))(ge,ye,Be),onWillRenameFiles:(ge,ye,Be)=>lt(it.getOnWillRenameFileEvent(qe))(ge,ye,Be),openTunnel:ge=>((0,_e.$7G)(qe,"tunnels"),Ft.openTunnel(qe,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,_e.$7G)(qe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ge,ye,Be)=>((0,_e.$7G)(qe,"tunnels"),lt(Ft.onDidChangeTunnels)(ge,ye,Be)),registerPortAttributesProvider:(ge,ye)=>((0,_e.$7G)(qe,"portsAttributes"),Ft.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,_e.$7G)(qe,"tunnelFactory"),Ft.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,_e.$7G)(qe,"timeline"),pn.registerTimelineProvider(ge,ye,qe.identifier,St.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:ge=>((0,_e.$7G)(qe,"workspaceTrust"),vt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,Be)=>lt(vt.onDidGrantWorkspaceTrust)(ge,ye,Be),registerEditSessionIdentityProvider:(ge,ye)=>((0,_e.$7G)(qe,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,Be)=>((0,_e.$7G)(qe,"editSessionIdentityProvider"),lt(vt.getOnWillCreateEditSessionIdentityEvent(qe))(ge,ye,Be)),registerCanonicalUriProvider:(ge,ye)=>((0,_e.$7G)(qe,"canonicalUriProvider"),vt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,Be)=>((0,_e.$7G)(qe,"canonicalUriProvider"),vt.provideCanonicalUri(ge,ye,Be))},ln={get inputBox(){return Rt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(ge,ye,Be){return ft.createSourceControl(qe,ge,ye,Be)}},un={createCommentController(ge,ye){return ci.createCommentController(qe,ge,ye)}},yn={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,_e.$7G)(qe,"debugVisualization"),Pt.registerDebugVisualizationProvider(qe,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,_e.$7G)(qe,"debugVisualization"),Pt.registerDebugVisualizationTree(qe,ge,ye)},onDidStartDebugSession(ge,ye,Be){return lt(Pt.onDidStartDebugSession)(ge,ye,Be)},onDidTerminateDebugSession(ge,ye,Be){return lt(Pt.onDidTerminateDebugSession)(ge,ye,Be)},onDidChangeActiveDebugSession(ge,ye,Be){return lt(Pt.onDidChangeActiveDebugSession)(ge,ye,Be)},onDidReceiveDebugSessionCustomEvent(ge,ye,Be){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(ge,ye,Be)},onDidChangeBreakpoints(ge,ye,Be){return lt(Pt.onDidChangeBreakpoints)(ge,ye,Be)},onDidChangeActiveStackItem(ge,ye,Be){return lt(Pt.onDidChangeActiveStackItem)(ge,ye,Be)},registerDebugConfigurationProvider(ge,ye,Be){return Pt.registerDebugConfigurationProvider(ge,ye,Be||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return Pt.registerDebugAdapterDescriptorFactory(qe,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return Pt.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Pt.startDebugging(ge,ye,{parentSession:Be}):Pt.startDebugging(ge,ye,Be||{})},stopDebugging(ge){return Pt.stopDebugging(ge)},addBreakpoints(ge){return Pt.addBreakpoints(ge)},removeBreakpoints(ge){return Pt.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return Pt.asDebugSourceUri(ge,ye)}},En={registerTaskProvider:(ge,ye)=>Ht.registerTaskProvider(qe,ge,ye),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(qe,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,ye,Be)=>lt(Ht.onDidStartTask)(ge,ye,Be),onDidEndTask:(ge,ye,Be)=>lt(Ht.onDidEndTask)(ge,ye,Be),onDidStartTaskProcess:(ge,ye,Be)=>lt(Ht.onDidStartTaskProcess)(ge,ye,Be),onDidEndTaskProcess:(ge,ye,Be)=>lt(Ht.onDidEndTaskProcess)(ge,ye,Be)},hn={createNotebookController(ge,ye,Be,dt,Et){return Di.createNotebookController(qe,ge,ye,Be,dt,(0,_e.$6G)(qe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>Tt.registerNotebookCellStatusBarItemProvider(qe,ge,ye),createRendererMessaging(ge){return $i.createRendererMessaging(qe,ge)},createNotebookControllerDetectionTask(ge){return(0,_e.$7G)(qe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(qe,ge)},registerKernelSourceActionProvider(ge,ye){return(0,_e.$7G)(qe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(qe,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,Be){return(0,_e.$7G)(qe,"notebookCellExecutionState"),lt(Di.onDidChangeNotebookCellExecutionState)(ge,ye,Be)}},Ji={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return vi.getMessage(qe.identifier.value,{message:ye,args:Be})}return vi.getMessage(qe.identifier.value,ge[0])},get bundle(){return vi.getBundle(qe.identifier.value)},get uri(){return vi.getBundleUri(qe.identifier.value)}},dn={_version:1,transferActiveChat(ge){return(0,_e.$7G)(qe,"interactive"),Mi.transferActiveChat(ge)}},fn={getRelatedInformation(ge,ye){return(0,_e.$7G)(qe,"aiRelatedInformation"),nn.getRelatedInformation(qe,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,_e.$7G)(qe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(qe,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,_e.$7G)(qe,"aiRelatedInformation"),Hi.registerEmbeddingVectorProvider(qe,ge,ye)}},gn={_version:1,registerChatResponseProvider(ge,ye,Be){return(0,_e.$7G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,ge,ye,Be)},registerChatVariableResolver(ge,ye,Be,dt,Et,Lt,Ri,Xi){return(0,_e.$7G)(qe,"chatVariableResolver"),tn.registerVariableResolver(qe,ge,ye,Be,dt,Et,Lt,Ri,Xi?.id)},registerMappedEditsProvider(ge,ye){return(0,_e.$7G)(qe,"mappedEditsProvider"),Re.registerMappedEditsProvider(qe,ge,ye)},createChatParticipant(ge,ye){return Mi.createChatAgent(qe,ge,ye)},createDynamicChatParticipant(ge,ye,Be){return(0,_e.$7G)(qe,"chatParticipantPrivate"),Mi.createDynamicChatAgent(qe,ge,ye,Be)}},Sn={selectChatModels:ge=>Jt.selectLanguageModels(qe,ge??{}),onDidChangeChatModels:(ge,ye,Be)=>Jt.onDidChangeProviders(ge,ye,Be),registerChatModelProvider:(ge,ye,Be)=>((0,_e.$7G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,ge,ye,Be)),get embeddingModels(){return(0,_e.$7G)(qe,"embeddings"),Oi.embeddingsModels},onDidChangeEmbeddingModels:(ge,ye,Be)=>((0,_e.$7G)(qe,"embeddings"),Oi.onDidChange(ge,ye,Be)),registerEmbeddingsProvider(ge,ye){return(0,_e.$7G)(qe,"embeddings"),Oi.registerEmbeddingsProvider(qe,ge,ye)},async computeEmbeddings(ge,ye,Be){return(0,_e.$7G)(qe,"embeddings"),Oi.computeEmbeddings(ge,ye,Be)},registerTool(ge,ye){return(0,_e.$7G)(qe,"lmTools"),Gi.registerTool(qe,ge,ye)},invokeTool(ge,ye,Be){return(0,_e.$7G)(qe,"lmTools"),Gi.invokeTool(ge,ye,Be)},get tools(){return(0,_e.$7G)(qe,"lmTools"),Gi.tools}},Dn={registerSpeechProvider(ge,ye){return(0,_e.$7G)(qe,"speech"),bn.registerProvider(qe.identifier,ge,ye)}};return{version:It.version,ai:fn,authentication:Ui,commands:vn,comments:un,chat:gn,debug:yn,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Sn,notebooks:hn,scm:ln,speech:Dn,tasks:En,tests:Wi,window:an,workspace:cn,Breakpoint:x.$xO,TerminalOutputAnchor:x.TerminalOutputAnchor,ChatResultFeedbackKind:x.ChatResultFeedbackKind,ChatVariableLevel:x.ChatVariableLevel,ChatCompletionItem:x.$sP,CallHierarchyIncomingCall:x.$VN,CallHierarchyItem:x.$UN,CallHierarchyOutgoingCall:x.$WN,CancellationError:h.$8,CancellationTokenSource:s.$ye,CandidatePortSource:n.CandidatePortSource,CodeAction:x.$RN,CodeActionKind:x.$SN,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.$XN,Color:x.$$N,ColorInformation:x.$_N,ColorPresentation:x.$aO,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentState:x.CommentState,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CommentThreadState:x.CommentThreadState,CommentThreadApplicability:x.CommentThreadApplicability,CompletionItem:x.$5N,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.$6N,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.$iO,DebugAdapterExecutable:x.$BO,DebugAdapterInlineImplementation:x.$EO,DebugAdapterNamedPipeServer:x.$DO,DebugAdapterServer:x.$CO,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DebugVisualization:x.$UO,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.$KN,DiagnosticRelatedInformation:x.$JN,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.$wN,DocumentHighlight:x.$NN,DocumentHighlightKind:x.DocumentHighlightKind,MultiDocumentHighlight:x.$ON,DocumentLink:x.$0N,DocumentSymbol:x.$QN,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.$HO,InlineValueText:x.$IO,InlineValueVariableLookup:x.$JO,InlineValueEvaluatableExpression:x.$KO,InlineCompletionTriggerKind:x.InlineCompletionTriggerKind,EventEmitter:I.$ne,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.$WO,FileDecoration2:x.$WO,FileSystemError:x.$NO,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:x.$OO,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.$zO,InlineCompletionItem:x.$7N,InlineCompletionList:x.$8N,Hover:x.$LN,VerboseHover:x.$MN,HoverVerbosityAction:x.HoverVerbosityAction,IndentAction:E.IndentAction,Location:x.$IN,MarkdownString:x.$YN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:x.$ZN,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.$xN,ProcessExecution:x.$gO,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.$VO,Range:x.$yN,RelativePattern:x.$vO,Selection:x.$zN,SelectionRange:x.$TN,SemanticTokens:x.$RO,SemanticTokensBuilder:x.$QO,SemanticTokensEdit:x.$SO,SemanticTokensEdits:x.$TO,SemanticTokensLegend:x.$PO,ShellExecution:x.$hO,ShellQuoting:x.ShellQuoting,SignatureHelp:x.$2N,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.$1N,SnippetString:x.$HN,SourceBreakpoint:x.$yO,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.$PN,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.$jO,TaskGroup:x.$fO,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TerminalLink:x.$bO,TerminalQuickFixTerminalCommand:x.$dO,TerminalQuickFixOpener:x.$cO,TerminalLocation:x.TerminalLocation,TerminalProfile:x.$eO,TerminalExitReason:x.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:x.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.$DN,SnippetTextEdit:x.$FN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,SyntaxTokenType:x.SyntaxTokenType,TextDocumentChangeReason:x.TextDocumentChangeReason,ThemeColor:x.$uO,ThemeIcon:x.$tO,TreeItem:x.$kO,TreeItemCheckboxState:x.TreeItemCheckboxState,TreeItemCollapsibleState:x.TreeItemCollapsibleState,TypeHierarchyItem:x.$gP,UIKind:ti.UIKind,Uri:$.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.$GN,DocumentPasteTriggerKind:x.DocumentPasteTriggerKind,DocumentDropEdit:x.$qO,DocumentDropOrPasteEditKind:x.$rO,DocumentPasteEdit:x.$sO,InlayHint:x.$4N,InlayHintLabelPart:x.$3N,InlayHintKind:x.InlayHintKind,RemoteAuthorityResolverError:x.$CN,ResolvedAuthority:x.$AN,ManagedResolvedAuthority:x.$BN,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.$7O,NotebookRange:x.$YO,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookCellData:x.$ZO,NotebookData:x.$1O,NotebookRendererScript:x.$5O,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.$3O,NotebookCellOutputItem:x.$2O,NotebookCellStatusBarItem:x.$4O,NotebookControllerAffinity:x.NotebookControllerAffinity,NotebookControllerAffinity2:x.NotebookControllerAffinity2,NotebookEdit:x.$EN,NotebookKernelSourceAction:x.$6O,NotebookVariablesRequestKind:x.NotebookVariablesRequestKind,PortAttributes:x.$9O,LinkedEditingRanges:x.$8O,TestResultState:x.TestResultState,TestRunRequest:x.$0O,TestMessage:x.$$O,TestTag:x.$_O,TestRunProfileKind:x.TestRunProfileKind,TextSearchCompleteMessageType:Kt.TextSearchCompleteMessageType,DataTransfer:x.$pO,DataTransferItem:x.$lO,TestCoverageCount:x.$aP,FileCoverage:x.$cP,FileCoverage2:x.$cP,StatementCoverage:x.$dP,BranchCoverage:x.$eP,DeclarationCoverage:x.$fP,WorkspaceTrustState:x.WorkspaceTrustState,LanguageStatusSeverity:x.LanguageStatusSeverity,QuickPickItemKind:x.QuickPickItemKind,InputBoxValidationSeverity:x.InputBoxValidationSeverity,TabInputText:x.$hP,TabInputTextDiff:x.$iP,TabInputTextMerge:x.$jP,TabInputCustom:x.$kP,TabInputNotebook:x.$mP,TabInputNotebookDiff:x.$nP,TabInputWebview:x.$lP,TabInputTerminal:x.$oP,TabInputInteractiveWindow:x.$pP,TabInputChat:x.$qP,TabInputTextMultiDiff:x.$rP,TelemetryTrustedValue:d.$vp,LogLevel:c.LogLevel,EditSessionIdentityMatch:g.EditSessionIdentityMatch,InteractiveSessionVoteDirection:x.InteractiveSessionVoteDirection,ChatCopyKind:x.ChatCopyKind,InteractiveEditorResponseFeedbackKind:x.InteractiveEditorResponseFeedbackKind,DebugStackFrame:x.$FO,DebugThread:x.$GO,RelatedInformationType:x.RelatedInformationType,SpeechToTextStatus:x.SpeechToTextStatus,TextToSpeechStatus:x.TextToSpeechStatus,PartialAcceptTriggerKind:x.PartialAcceptTriggerKind,KeywordRecognitionStatus:x.KeywordRecognitionStatus,ChatResponseMarkdownPart:x.$tP,ChatResponseFileTreePart:x.$xP,ChatResponseAnchorPart:x.$yP,ChatResponseProgressPart:x.$zP,ChatResponseProgressPart2:x.$AP,ChatResponseReferencePart:x.$DP,ChatResponseWarningPart:x.$BP,ChatResponseTextEditPart:x.$EP,ChatResponseMarkdownWithVulnerabilitiesPart:x.$uP,ChatResponseCommandButtonPart:x.$CP,ChatResponseDetectedParticipantPart:x.$vP,ChatResponseConfirmationPart:x.$wP,ChatRequestTurn:x.$FP,ChatResponseTurn:x.$GP,ChatLocation:x.ChatLocation,LanguageModelChatMessageRole:x.LanguageModelChatMessageRole,LanguageModelChatMessage:x.$IP,LanguageModelChatMessageFunctionResultPart:x.$HP,LanguageModelChatResponseTextPart:x.$KP,LanguageModelChatResponseFunctionUsePart:x.$JP,LanguageModelChatMessage2:x.$IP,LanguageModelChatSystemMessage:x.$LP,LanguageModelChatUserMessage:x.$MP,LanguageModelChatAssistantMessage:x.$NP,LanguageModelError:x.$OP,NewSymbolName:x.$MO,NewSymbolNameTag:x.NewSymbolNameTag,NewSymbolNameTriggerKind:x.NewSymbolNameTriggerKind,InlineEdit:x.$PP,InlineEditTriggerKind:x.InlineEditTriggerKind}}}}),define(Ee[396],Se([1,0,89,169,48,163,42,35,64,47,101,102,103,126,77,96,162,76,63,125,95,78,161,12,65,123,124,128,129,167,99]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f,u,w,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$Ps)(u.$kpc,u.$jpc,s.InstantiationType.Delayed),(0,s.$Ps)(r.$bk,i.$zqc,s.InstantiationType.Delayed),(0,s.$Ps)(c.$poc,c.$qoc,s.InstantiationType.Delayed),(0,s.$Ps)(R.$kQ,R.$jQ,s.InstantiationType.Eager),(0,s.$Ps)(S.$zoc,S.$Aoc,s.InstantiationType.Eager),(0,s.$Ps)(D.$epc,D.$fpc,s.InstantiationType.Eager),(0,s.$Ps)(L.$Ooc,L.$Moc,s.InstantiationType.Eager),(0,s.$Ps)(d.$Qoc,d.$Poc,s.InstantiationType.Eager),(0,s.$Ps)(C.$upc,C.$vpc,s.InstantiationType.Eager),(0,s.$Ps)(E.$zpc,E.$Dpc,s.InstantiationType.Eager),(0,s.$Ps)(T.$Fpc,T.$Epc,s.InstantiationType.Eager),(0,s.$Ps)($.$_P,$.$$P,s.InstantiationType.Eager),(0,s.$Ps)(w.$lpc,w.$mpc,s.InstantiationType.Eager),(0,s.$Ps)(g.$toc,g.$soc,s.InstantiationType.Eager),(0,s.$Ps)(h.$_pc,h.$$pc,s.InstantiationType.Delayed),(0,s.$Ps)(l.$Vpc,l.$Wpc,s.InstantiationType.Eager),(0,s.$Ps)(P.$0oc,P.$9oc,s.InstantiationType.Eager),(0,s.$Ps)(k.$mqc,k.$lqc,s.InstantiationType.Eager),(0,s.$Ps)(a.$apc,a.$dpc,s.InstantiationType.Eager),(0,s.$Ps)(y.$nqc,y.$oqc,s.InstantiationType.Eager),(0,s.$Ps)(b.$3Fb,b.$4Fb,s.InstantiationType.Eager),(0,s.$Ps)(m.$xqc,m.$wqc,s.InstantiationType.Eager),(0,s.$Ps)(I.$Loc,I.$Koc,s.InstantiationType.Eager),(0,s.$Ps)(n.$hpc,n.$gpc,s.InstantiationType.Eager),(0,s.$Ps)(o.$iQ,o.$fQ,s.InstantiationType.Eager),(0,s.$Ps)(t.$1oc,t.$2oc,s.InstantiationType.Eager),(0,s.$Ps)(f.$spc,f.$tpc,s.InstantiationType.Eager)}),define(Ee[130],Se([1,0,19,12,38,100]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=void 0,e.$Pqc=L,e.$Qqc=R,T=We(T);function L(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function R(E,l,P,b){const c=(0,s.$4b)(P,$),m=new I.$WL(l,c,b),d=m.preview.matches;return{ranges:(0,s.$4b)(c,a),uri:E,preview:{text:m.preview.text,matches:(0,s.$4b)(d,a)}}}function $(E){return new I.$XL(E.start.line,E.start.character,E.end.line,E.end.character)}function a(E){return new T.$KL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let k=class{constructor(l,P){this.a=l,this.b=P}appendLine(l){this.b.debug(`${this.a}#search`,l)}};e.$Rqc=k,e.$Rqc=k=Xe([Ve(1,h.$ak)],k)}),define(Ee[397],Se([1,0,58,17,82,33,11,13,130,398]),function(ce,e,s,h,I,T,L,R,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=E,e.$Tqc=m,e.$Uqc=g,s=We(s),h=We(h),T=We(T),R=We(R);const k=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,t,i,r){const f=l(n,o,t,i,r),u=o.folder.fsPath;return{cmd:s.spawn(k,f.args,{cwd:u}),rgDiskPath:k,siblingClauses:f.siblingClauses,rgArgs:f,cwd:u}}function l(n,o,t,i,r){const f=["--files","--hidden","--case-sensitive","--no-require-git"];b([o],t,!1).forEach(w=>{const S=(0,$.$Pqc)(w);if(f.push("-g",S),L.$j){const D=(0,I.$om)(S);D!==S&&f.push("-g",D)}});const u=P([o],i,void 0,!1);return u.globArgs.forEach(w=>{const S=`!${(0,$.$Pqc)(w)}`;if(f.push("-g",S),L.$j){const D=(0,I.$om)(S);D!==S&&f.push("-g",D)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),r&&f.push("--threads",`${r}`),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:u.siblingClauses}}function P(n,o,t,i=!0){const r=[];let f={};return n.forEach(u=>{const w=Object.assign({},u.excludePattern||{},o||{}),S=c(w,i?u.folder.fsPath:void 0,t);r.push(...S.globArgs),S.siblingClauses&&(f=Object.assign(f,S.siblingClauses))}),{globArgs:r,siblingClauses:f}}function b(n,o,t=!0){const i=[];return n.forEach(r=>{const f=Object.assign({},o||{},r.includePattern||{}),u=c(f,t?r.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function c(n,o,t){const i=[],r={};return Object.keys(n).forEach(f=>{if(t&&t.has(f)||!f)return;const u=n[f];f=d(o?m(o,f):f),f.startsWith("\\\\")?f="\\\\"+f.substr(2).replace(/\\/g,"/"):f=f.replace(/\\/g,"/"),typeof u=="boolean"&&u?(f.startsWith("\\\\")&&(f+="**"),i.push(g(f))):u&&u.when&&(r[f]=u)}),{globArgs:i,siblingClauses:r}}function m(n,o){return h.$lc(o)?o:h.$mc(n,o)}function d(n){return n=R.$pf(n,"\\"),R.$pf(n,"/")}function g(n){return T.$Bg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[399],Se([1,0,58,61,17,400,19,51,39,82,33,11,43,13,18,34,38,397,141]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=e.$Vqc=void 0,s=We(s),h=We(h),I=We(I),L=We(L),$=We($),a=We(a),E=We(E),P=We(P),b=We(b);const n=new Set;process.on("exit",()=>{n.forEach(f=>f())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Ak(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=u.shouldGlobMatchFilePattern?null:(0,g.$Pr)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Ak(u.excludePattern),this.t=new Map,u.folderQueries.forEach(w=>{const S=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),D=w.folder.fsPath;u.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,k.$Fg)(y,D)&&(S[I.$oc(D,y)]=!0)}),this.t.set(D,new i(S,D))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,w,S,D,y,C){if(this.m=l.$he.create(!1),this.l)return C(null,this.j);w.forEach(A=>{const p=I.$qc(A.fsPath);this.u&&this.u(A.fsPath,p)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=l.$he.create(!1),this.w(u,(A,p)=>{this.x(this.y,this,A,S,D,y,v=>{if(v){const F=(0,R.$rj)(v);console.error(F),this.q.push(F),p(v,void 0)}else p(null,void 0)})},(A,p)=>{this.m.stop();const v=A?L.$Kb(A)[0]:null;C(v,this.j)})}w(u,w,S){const D=new Array(u.length),y=new Array(u.length);let C=!1,A=0;if(u.length===0)return S(null,[]);u.forEach((p,v)=>{w(p,(F,N)=>{if(F?(C=!0,D[v]=null,y[v]=F):(D[v]=N,y[v]=null),++A===u.length)return S(C?y:null,D)})})}x(u,w,...S){try{u.apply(w,S)}catch(D){S[S.length-1](D)}}y(u,w,S,D,y){const C=u.folder.fsPath,A=E.$j,p=()=>j&&j.kill();n.add(p);let v=K=>{n.delete(p),v=()=>{},y(K)},F="";const N=this.D(),O=(0,d.$Sqc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression,w),j=O.cmd,z=!Object.keys(O.siblingClauses).length,M=O.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let V=`${O.rgDiskPath} ${M}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),D({message:V}),this.s=0,this.z(j,"utf8",D,(K,re,B)=>{if(K){v(K);return}if(this.j){v();return}const X=(F+(A?a.$nm(re||""):re)).split(`
`);if(B){const ee=X.length;X[ee-1]=X[ee-1].trim(),X[ee-1]||X.pop()}else F=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=X.length,z){for(const ee of X)if(this.J(S,{base:C,relativePath:ee,searchPath:this.N(u,ee)}),this.j){p();break}(B||this.j)&&v();return}this.G(u,N,C,X,S),B&&(this.H(N,C,S),v())})}spawnFindCmd(u){const w=this.t.get(u.folder.fsPath),S=w.getBasenameTerms(),D=w.getPathTerms(),y=["-L","."];if(S.length||D.length){y.push("-not","(","(");for(const C of S)y.push("-name",C),y.push("-o");for(const C of D)y.push("-path",C),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),s.spawn("find",y,{cwd:u.folder.fsPath})}readStdout(u,w,S){let D="";this.z(u,w,()=>{},(y,C,A)=>{if(y){S(y);return}D+=C,A&&S(null,D)})}z(u,w,S,D){let y=(p,v,F)=>{(p||F)&&(y=()=>{},this.r?.stop()),D(p,v,F)},C=!1;u.stdout?(this.A(u.stdout,w,y),u.stdout.once("data",()=>C=!0)):S({message:"stdout is null"});let A;u.stderr?A=this.B(u.stderr):S({message:"stderr is null"}),u.on("error",p=>{y(p)}),u.on("close",p=>{let v;!C&&(v=this.C(A,w))&&r(v)?y(new Error(`command failed with error code ${p}: ${this.C(A,w)}`)):(this.g&&p===0&&(this.j=!0),y(null,"",!0))})}A(u,w,S){const D=new T.StringDecoder(w);return u.on("data",y=>{S(null,D.write(y))}),D}B(u){const w=[];return u.on("data",S=>{w.push(S)}),w}C(u,w){const S=new T.StringDecoder(w);return u.map(D=>S.write(D)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:w},S,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:S,relativePath:this.b,searchPath:this.N(u,this.b)});const C=A=>{const p=I.$qc(A),v=I.$pc(A);let F=w[v];F||(F=w[v]=[],C(v)),F.push({base:S,relativePath:A,basename:p,searchPath:this.N(u,A)})};D.forEach(C)}H({rootEntries:u,pathToEntries:w},S,D){const y=this,C=this.t.get(S),A=this.b;function p(v){y.o++;const F=(0,m.$aM)(()=>v.map(N=>N.basename));for(let N=0,O=v.length;N<O;N++){const j=v[N],{relativePath:z,basename:M}=j;if(C.test(z,M,A!==M?F:void 0))continue;const V=w[z];if(V)p(V);else{if(y.p++,z===A)continue;y.J(D,j)}if(y.j)break}}p(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,w,S,D,y){const C=u.folder,A=(0,m.$aM)(()=>S);this.w(S,(p,v)=>{if(this.l||this.j)return v(null);const F=w?[w,p].join(I.sep):p;if(this.t.get(u.folder.fsPath).test(F,p,this.a.filePattern!==p?A:void 0))return v(null);const N=[C.fsPath,F].join(I.sep);h.lstat(N,(O,j)=>{if(O||this.l||this.j)return v(null);this.L(N,j,(z,M)=>z||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(N,j,(V,K)=>V||this.l||this.j||(K=K||"",this.v[K])?v(null):(this.v[K]=!0,c.Promises.readdir(N).then(re=>{if(this.l||this.j)return v(null);this.I(u,F,re,D,B=>v(B||null))},re=>{v(null)})))):(this.p++,F===this.b||this.h&&b.$kg(M.size)&&M.size>this.h||this.J(D,{base:C.fsPath,relativePath:F,searchPath:this.N(u,F)}),v(null,void 0)))})},p=>{const v=p&&L.$Kb(p);return y(v&&v.length>0?v[0]:void 0)})}J(u,w){this.K(w)&&(!this.d||this.d(w.relativePath,I.$qc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(w))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$8L)(u,this.c);if(this.b)return(0,m.$8L)(u,this.b,!1)}return!0}L(u,w,S){return w.isSymbolicLink()?h.stat(u,S):S(null,w)}M(u,w,S){return w.isSymbolicLink()?h.realpath(u,(D,y)=>D?S(D):S(null,y)):S(null,u)}N(u,w){return u.folderName?I.$mc(u.folderName,w):w}}e.$Vqc=o;class t{constructor(u,w){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.d=w,this.c=new o(u)}search(u,w,S){this.c.walk(this.a,this.b,this.d,u,w,(D,y)=>{S(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Wqc=t;class i{constructor(u,w){this.expression=u,this.c=w,this.d(u)}d(u){let w,S;Object.keys(u).filter(D=>u[D]).forEach(D=>{I.$lc(D)?(w=w||$.$vk(),w[D]=u[D]):(S=S||$.$vk(),S[D]=u[D])}),this.a=w&&$.$Ak(w,{trimForExclusions:!0}),this.b=S&&$.$Ak(S,{trimForExclusions:!0})}test(u,w,S){return this.b&&this.b(u,w,S)||this.a&&this.a(I.$mc(this.c,u),w,S)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Ck(this.a)),this.b&&u.push(...$.$Ck(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Dk(this.a)),this.b&&u.push(...$.$Dk(this.b)),u}}function r(f){const u=f.trim().split(`
`),w=u[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return P.$$f(u[u.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(Ee[401],Se([1,0,104,22,208,21,19]),function(ce,e,s,h,I,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.$BE=e.DecodeStreamErrorKind=e.$AE=e.$zE=e.$yE=e.$wE=e.$vE=e.$uE=e.$tE=void 0,e.$xE=R,e.$CE=c,e.$DE=m,e.$EE=d,e.$FE=g,e.$GE=n,e.$HE=S,e.$IE=D,e.$tE="utf8",e.$uE="utf8bom",e.$vE="utf16be",e.$wE="utf16le";function R(y){return[e.$tE,e.$uE,e.$vE,e.$wE].some(C=>C===y)}e.$yE=[254,255],e.$zE=[255,254],e.$AE=[239,187,191];const $=512,a=512,k=512*8,E=512*128;var l;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(l||(e.DecodeStreamErrorKind=l={}));class P extends Error{constructor(C,A){super(C),this.decodeStreamErrorKind=A}}e.$BE=P;class b{static async create(C){let A;if(C!==e.$tE)A=(await(0,I.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(g(C));else{const p=new TextDecoder;A={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new b(A)}constructor(C){this.a=C}write(C){return this.a.write(C)}end(){return this.a.end()}}function c(y,C){const A=C.minBytesRequiredForDetection??C.guessEncoding?k:a;return new Promise((p,v)=>{const F=(0,s.$De)(V=>V.join("")),N=[];let O=0,j;const z=new T.$ye,M=async()=>{try{const V=await D({buffer:h.$Pe.concat(N),bytesRead:O},C.guessEncoding,C.candidateGuessEncodings);if(V.seemsBinary&&C.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",l.STREAM_IS_BINARY);V.encoding=await C.overwriteEncoding(V.encoding),j=await b.create(V.encoding);const K=j.write(h.$Pe.concat(N).buffer);F.write(K),N.length=0,O=0,p({stream:F,detected:V})}catch(V){z.cancel(),F.destroy(),v(V)}};(0,s.$He)(y,{onData:async V=>{j?F.write(j.write(V.buffer)):(N.push(V),O+=V.byteLength,O>=A&&(y.pause(),await M(),setTimeout(()=>y.resume())))},onError:V=>F.error(V),onEnd:async()=>{j||await M(),F.end(j?.end())}},z.token)})}async function m(y,C,A){const v=(await(0,I.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(g(C),A);let F=!1,N=!1;return{read(){if(N)return null;const O=y.read();if(typeof O!="string"){if(N=!0,!F&&A?.addBOM)switch(C){case e.$tE:case e.$uE:return h.$Pe.wrap(Uint8Array.from(e.$AE));case e.$vE:return h.$Pe.wrap(Uint8Array.from(e.$yE));case e.$wE:return h.$Pe.wrap(Uint8Array.from(e.$zE))}const j=v.end();return j&&j.length>0?(F=!0,h.$Pe.wrap(j)):null}return F=!0,h.$Pe.wrap(v.write(O))}}}async function d(y){return(await(0,I.$sE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(g(y))}function g(y){return y===e.$uE||y===null?e.$tE:y}function n(y,C){if(!y||C<e.$yE.length)return null;const A=y.readUInt8(0),p=y.readUInt8(1);if(A===e.$yE[0]&&p===e.$yE[1])return e.$vE;if(A===e.$zE[0]&&p===e.$zE[1])return e.$wE;if(C<e.$AE.length)return null;const v=y.readUInt8(2);return A===e.$AE[0]&&p===e.$AE[1]&&v===e.$AE[2]?e.$uE:null}const o=["ascii","utf-16","utf-32"];async function t(y,C){const A=await(0,I.$sE)("jschardet","dist/jschardet.min.js"),p=y.slice(0,E),v=w(p.buffer);C&&(C=(0,L.$Kb)(C.map(O=>u(O))),C.length===0&&(C=void 0));const F=A.detect(v,C?{detectEncodings:C}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=o.indexOf(N)?null:f(F.encoding)}const i={ibm866:"cp866",big5:"cp950"};function r(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function f(y){const C=r(y);return i[C]||C}function u(y){const C=r(y);return e.$KE[C].guessableName}function w(y){let C="";for(let A=0;A<y.length;A++)C+=String.fromCharCode(y[A]);return C}function S(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const C=y.match(/windows(\d+)/);return C?"windows-"+C[1]:y}}}function D({buffer:y,bytesRead:C},A,p){let v=n(y,C),F=!1;if(v!==e.$vE&&v!==e.$wE&&y){let N=!0,O=!0,j=!1;for(let z=0;z<C&&z<$;z++){const M=z%2===1,V=y.readUInt8(z)===0;if(V&&(j=!0),N&&(M&&!V||!M&&V)&&(N=!1),O&&(M&&V||!M&&!V)&&(O=!1),V&&!N&&!O)break}j&&(N?v=e.$wE:O?v=e.$vE:F=!0)}return A&&!F&&!v&&y?t(y.slice(0,C),p).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:v}}e.$JE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$KE=(()=>{const y={};for(const C in e.$JE)e.$JE[C].guessableName&&(y[C]=e.$JE[C]);return y})()}),define(Ee[172],Se([1,0,401,34,171]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,h=We(h);class T extends I.$Rpc{constructor(R,$,a=h,k="searchProcess"){super({query:R,provider:$},{readdir:E=>a.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,s.$HE)(E)},k)}}e.$5qc=T}),define(Ee[173],Se([1,0,58,416,400,19,79,39,13,2,38,100,417,398,130]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=e.$Xqc=void 0,e.$Zqc=i,e.$1qc=f,e.$2qc=w,e.$3qc=S,e.$4qc=y,s=We(s);const c=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,p){this.a=A,this.b=p}provideTextSearchResults(A,p,v,F){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((N,O)=>{F.onCancellationRequested(()=>X());const j={...p,numThreads:this.b},z=i(A,j),M=p.folder.fsPath,V=z.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${c} ${V}
 - cwd: ${M}`);let K=s.spawn(c,z,{cwd:M});K.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),O((0,k.$4L)(new k.$2L($e&&$e.message,k.SearchErrorCode.rgProcessError)))});let re=!1;const B=new n(p.maxResults,p.folder,p.previewOptions);B.on("result",$e=>{re=!0,de="",v.report($e)});let G=!1;const X=()=>{G=!0,K?.kill(),B?.cancel()};let ee=!1;B.on("hitLimit",()=>{ee=!0,X()});let de="";K.stdout.on("data",$e=>{B.handleData($e),re||(de+=$e)});let ne=!1;K.stdout.once("data",()=>ne=!0);let De="";K.stderr.on("data",$e=>{const J=$e.toString();this.a.appendLine(J),De.length+J.length<1e6&&(De+=J)}),K.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),de&&this.a.appendLine(`Got data without result: ${de}`),this.a.appendLine(""),G)N({limitHit:ee});else{B.flush(),K=null;let $e;De&&!ne&&($e=d(De))?O((0,k.$4L)(new k.$2L($e.message,$e.code))):N({limitHit:ee})}})})}}e.$Xqc=m;function d(C){const A=C.split(`
`),p=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new k.$2L(g(A),k.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new k.$2L(`Unknown encoding: ${v[1]}`,k.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new k.$2L(p.charAt(0).toUpperCase()+p.substr(1),k.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new k.$2L(p.charAt(0).toUpperCase()+p.substr(1),k.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new k.$2L(p,k.SearchErrorCode.regexParseError)}function g(C){const A=["Regex parse error"],p=C.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];A.push(":"+F)}}return A.join("")}class n extends h.EventEmitter{constructor(A,p,v){super(),this.g=A,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,p){return super.on(A,p),this}handleData(A){if(this.b)return;const p=typeof A=="string"?A:this.d.write(A);this.k(p)}k(A){let p=A.indexOf(`
`);const v=this.a+A;if(p>=0)p+=this.a.length;else{this.a=v;return}let F=0;for(;p>=0;)this.m(v.substring(F,p).trim()),F=p+1,p=v.indexOf(`
`,F);this.a=v.substring(F)}m(A){if(this.b||!A)return;let p;try{p=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(p.type==="match"){const v=o(p.data.path),F=a.URI.joinPath(this.h,v),N=this.n(p.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=o(p.data.path),F=a.URI.joinPath(this.h,v);this.o(p.data,F).forEach(O=>this.p(O))}}n(A,p){const v=A.line_number-1,F=o(A.lines),N=Buffer.from(F);let O=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const M=(0,T.$Kb)(A.submatches.map((V,K)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(V.match),B=N.slice(O,V.start).toString(),G=t(B),X=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=t(re),de=G.numLines+z,ne=ee.numLines+de,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+X;return O=V.end,j=De,z=ne,new E.$KL(de,X,ne,De)}));return(0,b.$Qqc)(p,F,M,this.j)}o(A,p){const v=o(A.lines),F=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:p,lineNumber:F+O}))}p(A){this.emit("result",A)}}e.$Yqc=n;function o(C){return C.bytes?Buffer.from(C.bytes,"base64").toString():C.text}function t(C){const A=/\n/g;let p=0,v=-1,F;for(;F=A.exec(C);)p++,v=F.index;const N=v>=0?C.length-v-1:C.length;return{numLines:p,lastLineLength:N}}function i(C,A){const p=["--hidden","--no-require-git"];p.push(C.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,L.$K)(A.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const O=new Set;F.forEach(j=>{O.add(j)}),p.push("-g","!*"),O.forEach(j=>{r(j).map(b.$Pqc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(O=>{p.push("-g",O)}),A.excludes.map(b.$Pqc).forEach(O=>p.push("-g",`!${O}`)),A.maxFileSize&&p.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),A.followSymlinks&&p.push("--follow"),A.encoding&&A.encoding!=="utf8"&&p.push("--encoding",A.encoding),A.numThreads&&p.push("--threads",`${A.numThreads}`),C.pattern==="--"&&(C.isRegExp=!0,C.pattern="\\-\\-"),C.isMultiline&&!C.isRegExp&&(C.pattern=(0,$.$jf)(C.pattern),C.isRegExp=!0),A.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),C.isRegExp&&(C.pattern=f(C.pattern),p.push("--engine","auto"));let N;if(C.isWordMatch){const j=(0,$.$sf)(C.pattern,!!C.isRegExp,{wholeWord:C.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(C.isRegExp){let O=w(C.pattern);O=S(O),p.push("--regexp",O)}else N=C.pattern,p.push("--fixed-strings");return p.push("--no-config"),A.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),C.isMultiline&&p.push("--multiline"),A.beforeContext&&p.push("--before-context",A.beforeContext+""),A.afterContext&&p.push("--after-context",A.afterContext+""),p.push("--"),N&&p.push(N),p.push("."),p}function r(C){return y(C).flatMap(p=>{const v=(0,R.$yk)(p,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function f(C){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;C.match(A);)C=C.replace(A,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;C.match(p);)C=C.replace(p,"$1\\x{$2}");return C}const u=C=>C.type==="Assertion"&&C.kind==="lookbehind";function w(C){let A;try{A=new l.RegExpParser().parsePattern(C)}catch{return C}let p="",v=0;const F=(j,z,M)=>{p+=C.slice(v,j)+M,v=z},N=[];return new l.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=N[0];if(!z)F(j.start,j.end,"\\r?\\n");else if(!N.some(u))if(z.type==="CharacterClass")if(z.negate){const M=C.slice(z.start+2,j.start)+C.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,M?`[^${M}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=C.slice(z.start+1,j.start)+C.slice(j.end,z.end-1);F(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){u(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(A),p+=C.slice(v),p}function S(C){return C.replace(/\n/g,"\\r?\\n")}function D(C){let A=!1,p=!1,v="",F="";for(let N=0;N<C.length;N++){const O=C[N];switch(O){case"\\":p?(A?F+="\\"+O:v+="\\"+O,p=!1):p=!0;break;case"{":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{strInBraces:v+"{"+F+"{"+C.substring(N+1)};A=!0}break;case"}":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{fixedStart:v,strInBraces:F,fixedEnd:C.substring(N+1)};v+=O}break;default:A?F+=(p?"\\":"")+O:v+=(p?"\\":"")+O,p=!1;break}}return{strInBraces:v+(A?"{"+F:"")}}function y(C){const{fixedStart:A,strInBraces:p,fixedEnd:v}=D(C);if(A===void 0||v===void 0)return[p];let F=(0,R.$yk)(p,",");F.length||(F=[""]);const N=y(v);return F.flatMap(O=>{const j=A+O;return N.map(z=>j+z)})}}),define(Ee[402],Se([1,0,21,173,90,15]),function(ce,e,s,h,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;class L{constructor(a,k){this.b=a,this.c=k,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(a,k,E,l){const P=await this.c(),b=new h.$Xqc(this.b,P),c={...k,numThreads:P};if(k.folder.scheme===T.Schemas.vscodeUserData){const m={...c,folder:k.folder.with({scheme:T.Schemas.file})},d=new I.$ww(g=>E.report({...g,uri:g.uri.with({scheme:k.folder.scheme})}));return this.d(l,g=>b.provideTextSearchResults(a,m,d,g))}else return this.d(l,m=>b.provideTextSearchResults(a,c,E,m))}async d(a,k){const E=R(a);this.a.add(E);const l=await k(E.token);return this.a.delete(E),l}e(){this.a.forEach(a=>a.cancel())}}e.$8qc=L;function R($){const a=new s.$ye;return $.onCancellationRequested(()=>a.cancel()),a}}),define(Ee[403],Se([1,0,34,173,172]),function(ce,e,s,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,s=We(s);class T{constructor($,a){this.a=$,this.b=a}search($,a,k){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(P){k({message:P})}},l=new I.$5qc(this.a,new h.$Xqc(E,this.b),s);return new Promise((P,b)=>l.search(c=>{a(c.map(L))},$).then(c=>P({limitHit:c.limitHit??!1,type:"success",stats:c.stats,messages:[]}),b))}}e.$6qc=T;function L(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce(($,a)=>{if(a.ranges){const k=a;return $+(Array.isArray(k.ranges)?k.ranges.length:1)}else return $+1},0)}}}),define(Ee[404],Se([1,0,19,9,14,4,141,17,43,2,28,38,399,403]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,s=We(s);class b{static{this.a=512}constructor(o="searchProcess",t){this.d=o,this.f=t,this.b=Object.create(null)}fileSearch(o){let t;const i=d(o),r=new T.$ne({onDidAddFirstListener:()=>{t=(0,h.$th)(async f=>{const u=await this.f?.();return this.doFileSearchWithEngine(l.$Wqc,i,w=>r.fire(w),f,b.a,u)}),t.then(f=>r.fire(f),f=>r.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return r.event}textSearch(o){let t;const i=d(o),r=new T.$ne({onDidAddFirstListener:()=>{t=(0,h.$th)(f=>this.g(i,u=>r.fire(u),f)),t.then(f=>r.fire(f),f=>r.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return r.event}async g(o,t,i){o.maxFileSize=this.h().maxFileSize;const r=await this.f?.();return new P.$6qc(o,r).search(i,t,t)}h(){return{maxFileSize:16*k.$Il.GB}}doFileSearch(o,t,i,r){return this.doFileSearchWithEngine(l.$Wqc,o,i,r,b.a,t)}doFileSearchWithEngine(o,t,i,r,f=b.a,u){let w=0;const S=y=>{Array.isArray(y)?(w+=y.length,i(y.map(C=>this.j(C)))):y.relativePath?(w++,i(this.j(y))):i(y)};if(t.sortByScore){let y=this.n(t,S,r);if(!y){const C=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new o(C,u);y=this.k(A,t,i,S,r)}return new Promise((C,A)=>{y.then(([p,v])=>{const F=v.map(N=>this.j(N));this.q(F,i,f),C(p)},A)})}const D=new o(t,u);return this.s(D,S,f,r).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,R.$mc)(o.base,o.relativePath):o.relativePath}}k(o,t,i,r,f){const u=new T.$ne;let w=(0,h.$th)(D=>{let y=[];const C=A=>{Array.isArray(A)?y=A:(r(A),u.fire(A))};return this.s(o,C,-1,D).then(A=>[A,y])}),S;if(t.cacheKey){S=this.l(t.cacheKey);const D={promise:w,event:u.event,resolved:!1};S.resultsToSearchCache[t.filePattern||""]=D,w.then(()=>{D.resolved=!0},y=>{delete S.resultsToSearchCache[t.filePattern||""]}),w=this.t(w)}return w.then(([D,y])=>{const C=S?S.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&$.$he.create(!1);return this.o(t,y,C,f).then(p=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},p]})})}l(o){const t=this.b[o];return t||(this.b[o]=new c)}n(o,t,i){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const f=this.r(r,o.filePattern||"",t,i);if(f)return f.then(([u,w,S])=>{const D=$.$he.create(!1);return this.o(o,w,r.scorerCache,i).then(y=>{const C=D.elapsed(),A={fromCache:!0,detailStats:S,type:this.d,resultCount:w.length,sortingTime:C};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:A,messages:[]},y]})})}o(o,t,i,r){const f=(0,L.$Pr)(o.filePattern||""),u=(S,D)=>(0,L.$Or)(S,D,f,!0,m,i),w=typeof o.maxResults=="number"?o.maxResults:E.$QL;return s.$Jb(t,u,w,1e4,r)}q(o,t,i){if(i&&i>0)for(let r=0;r<o.length;r+=i)t(o.slice(r,r+i));else t(o)}r(o,t,i,r){const f=$.$he.create(!1),u=t.indexOf(R.sep)>=0;let w;for(const C in o.resultsToSearchCache)if(t.startsWith(C)){if(u&&C.indexOf(R.sep)<0&&C!=="")continue;const A=o.resultsToSearchCache[C];w={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!w)return null;const S=f.elapsed(),D=$.$he.create(!1),y=w.event(i);return r&&r.onCancellationRequested(()=>{y.dispose()}),w.promise.then(([C,A])=>{if(r&&r.isCancellationRequested)throw(0,I.$9)();const p=[],v=(0,L.$Pr)(t).normalizedLowercase;for(const F of A)(0,E.$8L)(F,v)&&p.push(F);return[C,p,{cacheWasResolved:w.resolved,cacheLookupTime:S,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(o,t,i,r){return new Promise((f,u)=>{let w=[];r?.onCancellationRequested(()=>o.cancel()),o.search(S=>{S&&(i?(w.push(S),i>0&&w.length>=i&&(t(w),w=[])):t(S))},S=>{t(S)},(S,D)=>{w.length&&t(w),S?(t({message:"Search finished. Error: "+S.message}),u(S)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),f(D))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return o.then(t,i)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.$7qc=b;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,R.$qc)(n.relativePath)}getItemDescription(n){return(0,R.$pc)(n.relativePath)}getItemPath(n){return n.relativePath}};function d(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(g),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>a.URI.revive(o))}}function g(n){return{...n,folder:a.URI.revive(n.folder)}}}),define(Ee[405],Se([1,0,3,15,2,34,12,42,30,20,103,73,38,404,402,130,172]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0,T=We(T);let d=class extends k.$Wpc{constructor(n,o,t,i,r){super(n,t,r),this.D=i,this.w=T,this.x=-1,this.y=null,this.z=!1,this.B=new s.$Wc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const f=new c.$Rqc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new b.$8qc(f,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),i.getConfigProvider().then(u=>{this.C||this.B.add(u.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new c.$Rqc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new b.$8qc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$7qc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(n)),(0,s.$Vc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,i){const r=(0,k.$Xpc)(t);if(n===this.x){const f=Date.now();return this.H(n,o,r,i).then(u=>{const w=Date.now()-f;return this.q.debug(`Ext host file search time: ${w}ms`),u})}return super.$provideFileSearchResults(n,o,t,i)}async doInternalFileSearchWithCustomCallback(n,o,t){const i=f=>{if((0,l.$7L)(f)&&(f=[f]),Array.isArray(f)){t(f.map(u=>I.URI.file(u.path)));return}f.message&&this.q.debug("ExtHostSearch",f.message)};if(!this.y)throw new Error("No internal file search handler");const r=await this.getNumThreadsCached();return this.y.doFileSearch(n,r,i,o)}async H(n,o,t,i){return this.doInternalFileSearchWithCustomCallback(t,i,r=>{this.c.$handleFileMatch(n,o,r)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new m.$5qc(n,o,void 0,"textSearchProvider")}};e.$9qc=d,e.$9qc=d=Xe([Ve(0,a.$1P),Ve(1,$.$eQ),Ve(2,E.$Ioc),Ve(3,R.$Ooc),Ve(4,L.$ak)],d)}),define(Ee[131],Se([1,0,418,67,68,419,22,14,4,3,17,11,32,87,69]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=u,e.$zi=w,e.$Bi=y,e.$Ci=C;const c=3e4;class m{traceSocketEvent(p,v){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.$3)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>p.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=F=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,F),p(L.$Pe.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=F=>{p({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,R.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,R.$3)(v)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$vi=m;var d;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class n extends a.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,F,N){super(),this.f=this.B(new $.$ne),this.g=this.B(new $.$ne),this.h=!1,this.j={state:g.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,v,F,N,this.f,(O,j)=>this.m(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,R.$3)(O),this.g.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new b.$qi,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+d.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=d.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let N=d.MinHeaderByteSize;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const O=L.$Pe.alloc(N),j=v?64:0,z=F&15;if(O.writeUInt8(128|j|z,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let M=1;O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}else{O.writeUInt8(127,1);let M=1;O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(p.byteLength>>>24&255,++M),O.writeUInt8(p.byteLength>>>16&255,++M),O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}this.socket.write(L.$Pe.concat([O,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,O=(F&64)>>>6,j=F&15,z=v.readUInt8(1),M=(z&128)>>>7,V=z&127;this.j.state=g.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(M?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let O=F&127,j=1;O===126?O=v.readUInt8(++j)*2**8+v.readUInt8(++j):O===127&&(O=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;N&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=g.ReadBody,this.j.readLen=O,this.j.mask=z,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),r(v,this.j.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=g.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=n;class o extends a.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Pe.alloc(0)}constructor(p,v,F,N,O,j){super(),this.n=p,this.r=O,this.s=j,this.a=this.B(new $.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,p);this.s(F,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((F,N)=>{p.write(v),p.flush(O=>F(O))})}acceptFrame(p,v,F){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,F){return new Promise((N,O)=>{p.write(v),F&&p.write(L.$Pe.fromByteArray([0,0,255,255])),p.flush(j=>N(j))})}}class t extends a.$Xc{get recordedInflateBytes(){return this.j?L.$Pe.concat(this.f):L.$Pe.alloc(0)}constructor(p,v,F,N){super(),this.h=p,this.j=v,this.a=this.B(new $.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,T.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Pe.wrap(O))}),F&&(this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Pe.concat(this.g);this.g.length=0,p(v)})}}class i extends a.$Xc{constructor(p,v){super(),this.g=p,this.a=this.B(new $.$ne),this.onError=this.a.event,this.f=[],this.b=(0,T.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(L.$Pe.wrap(F))})}write(p){this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Pe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function r(A,p){if(p===0)return;const v=A.byteLength>>>2;for(let M=0;M<v;M++){const V=A.readUInt32BE(M*4);A.writeUInt32BE(V^p,M*4)}const F=v*4,N=A.byteLength-F,O=p>>>24&255,j=p>>>16&255,z=p>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^O,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^j,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^z,F+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const f={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function u(){const A=(0,l.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const p=process.platform!=="darwin"&&e.$xi?e.$xi:(0,I.tmpdir)(),v=(0,k.$mc)(p,`vscode-ipc-${A}.sock`);return S(v),v}function w(A,p,v){const N=(0,s.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${p}-sock`;const O=v.substr(0,4),j=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?z=(0,k.$mc)(e.$xi,`vscode-${N}-${O}-${j}.sock`):z=(0,k.$mc)(A,`${O}-${j}.sock`),S(z),z}function S(A){const p=f[E.$u];typeof p=="number"&&A.length>=p&&console.warn(`WARNING: IPC handle "${A}" is longer than ${p} chars, try a shorter --user-data-dir`)}class D extends P.$ki{static b(p){const v=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(v,F=>({protocol:new b.$ri(new m(F,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(D.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=D;function y(A){return new Promise((p,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(A,()=>{F.removeListener("error",v),p(new D(F))})})}function C(A,p){return new Promise((v,F)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",F),v(b.$si.fromSocket(new m(N,`ipc-client${p}`),p))});N.once("error",F)})}}),define(Ee[406],Se([1,0,67,68,188,131,9,3,11,45,12,116,284,286,118,93,22]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,s=We(s),h=We(h);async function d(i,r,f,u,w){let S;for(let D=3;D&&(S?.dispose(),S=await new g(i,r,f,u,w).waitForReady(),!(w&&I.$6g[w]||!I.$6g[S.tunnelLocalPort]));D--);return S}class g extends R.$Xc{constructor(r,f,u,w,S){super(),this.m=f,this.n=S,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=s.createServer(),this.c=new L.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(f=>{f()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,f=(0,c.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,I.$7g)(r,2,1e3,f),w=null;return this.b.listen(u,this.m),await this.c.wait(),w=this.b.address(),w||(u=0,this.b.listen(u,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(r){r.pause();const f=(0,c.$Hw)(this.tunnelRemoteHost)||(0,c.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,l.$3l)(this.a,f,this.tunnelRemotePort),w=u.getSocket(),S=u.readEntireBuffer();u.dispose(),S.byteLength>0&&r.write(S.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),w.end()}),r.on("close",()=>w.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),w instanceof T.$vi?w.socket.destroy():w.end()}),w instanceof T.$vi?this.t(r,w):this.s(r,w),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),w.end()})}s(r,f){f.onClose(()=>r.destroy()),f.onEnd(()=>r.end()),f.onData(u=>r.write(u.buffer)),r.on("data",u=>f.write(m.$Pe.wrap(u))),r.resume()}t(r,f){const u=f.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$Rgc=g;let n=class extends c.$Mw{constructor(r,f,u,w,S){super(f,S),this.H=r,this.I=u,this.J=w}isPortPrivileged(r){return(0,c.$Kw)(r,this.t,$.OS,h.release())}F(r,f,u,w,S,D,y,C){const A=this.D(f,u);if(A)return++A.refcount,A.value;if((0,c.$Dw)(r))return this.G(r,f,u,S,D,y,C);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${S}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:r,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=d(p,w,f,u,S);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(f,u,v),v}}};e.$Sgc=n,e.$Sgc=n=Xe([Ve(0,P.$Wl),Ve(1,k.$ak),Ve(2,b.$Zl),Ve(3,E.$tk),Ve(4,a.$aj)],n);let o=class extends n{constructor(r,f,u,w,S){super(r,f,u,w,S)}};e.$Tgc=o,e.$Tgc=o=Xe([Ve(0,P.$Wl),Ve(1,k.$ak),Ve(2,b.$Zl),Ve(3,E.$tk),Ve(4,a.$aj)],o);let t=class extends R.$Xc{constructor(r,f,u,w,S){super(),this.b=r,this.c=f,this.f=u,this.g=w,this.h=S,this.a=new Map}async openTunnel(r,f,u,w,S,D,y,C,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${w} on local port ${D}.`),!this.a.has(r)){const p=new o(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(r,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(f,u,w,S,D,y,C,A)}};e.$Ugc=t,e.$Ugc=t=Xe([Ve(0,P.$Wl),Ve(1,k.$ak),Ve(2,E.$tk),Ve(3,b.$Zl),Ve(4,a.$aj)],t)}),define(Ee[407],Se([1,0,131,303,61,35,2,12,46]),function(ce,e,s,h,I,T,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0,h=We(h),I=We(I);class a{constructor(l,P,b){this.b=l,this.c=P,this.f=b,this.a=h.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(P.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",l=>this.c.error(l))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(l,P){const b=(m,d)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify(d||null),g=>g&&this.c.error(g))},c=[];l.setEncoding("utf8"),l.on("data",m=>c.push(m)),l.on("end",async()=>{try{const m=JSON.parse(c.join(""));let d;switch(m.type){case"open":d=await this.i(m);break;case"openExternal":d=await this.j(m);break;case"status":d=await this.l(m);break;case"extensionManagement":d=await this.k(m);break;default:b(404,`Unknown message type: ${m.type}`);break}b(200,d)}catch(m){const d=m instanceof Error?m.message:JSON.stringify(m);b(500,d),this.c.error("Error while processing pipe request",m)}})}async i(l){const{fileURIs:P,folderURIs:b,forceNewWindow:c,diffMode:m,mergeMode:d,addMode:g,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:i}=l,r=[];if(Array.isArray(b))for(const S of b)try{r.push({folderUri:L.URI.parse(S)})}catch{}if(Array.isArray(P))for(const S of P)try{(0,$.$_i)(S)?r.push({workspaceUri:L.URI.parse(S)}):r.push({fileUri:L.URI.parse(S)})}catch{}const f=t?L.URI.file(t):void 0,w={forceNewWindow:c,diffMode:m,mergeMode:d,addMode:g,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!f&&!g,waitMarkerFileURI:f,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",r,w)}async j(l){for(const P of l.uris){const b=L.URI.parse(P),c=b.scheme==="file"?b:P;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(l){const P=c=>c?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),b={list:l.list,install:P(l.install),uninstall:P(l.uninstall),force:l.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(l){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.$pQ=a;let k=class extends a{constructor(l,P){super(l,P,(0,s.$yi)())}};e.$qQ=k,e.$qQ=k=Xe([Ve(0,T.$kQ),Ve(1,R.$ak)],k)}),define(Ee[408],Se([1,0,62,395,390,302,53,377,2,15,10,407,111,337,376]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,s=We(s);class c extends I.$Cqc{j(){const g=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(f,u,w){return f=i(f),g.a.has(f)?g.a.get(f).load(f,$.URI.file((0,l.$mr)(u.filename)),S=>o.apply(this,[S,u,w])):o.apply(this,arguments)};const t=n._resolveLookupPaths;n._resolveLookupPaths=(r,f)=>t.call(this,i(r),f);const i=r=>{for(const f of g.b){const u=f(r);if(u){r=u;break}}return r}}}class m extends L.$opc{constructor(){super(...arguments),this.extensionRuntime=k.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$_qc);const g=this.h.invokeFunction(h.$yqc);if(this.h.createInstance(R.$$qc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(E.$qQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(b.$arc),await this.h.createInstance(c,g,{mine:this.J,all:this.L}).install(),s.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,T.$0qc)(this.j,o,this,this.s,this.z,this.f),s.mark("code/extHost/didInitProxyResolver")}wb(g){return g.main}async xb(g,n,o){if(n.scheme!==a.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const i=g?.identifier.value;g&&await this.w.initializeLocalizedMessages(g);try{i&&s.mark(`code/extHost/willLoadExtensionCode/${i}`),t=ce.__$__nodeRequire(n.fsPath)}finally{i&&s.mark(`code/extHost/didLoadExtensionCode/${i}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(g){if(this.f.remote.isRemote)for(const n in g){const o=g[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$brc=m}),define(Ee[409],Se([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,406,30,20,77,384]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,e.$crc=i,e.$drc=r,e.$erc=f,e.$frc=u,e.$grc=S,e.$hrc=D,e.$irc=y,$=We($),k=We(k);function i(p){const v=p.trim().split(`
`),F=[];return v.forEach(O=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);j&&j.length>=3&&F.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),F.reduce((O,j)=>(O[j.socket]=j,O),{})}function r(...p){const v=[].concat(...p.map(u));return[...new Map(v.filter(F=>F.st==="0A").map(F=>{const N=F.local_address.split(":");return{socket:parseInt(F.inode,10),ip:f(N[0]),port:parseInt(N[1],16)}}).map(F=>[F.ip+":"+F.port,F])).values()]}function f(p){let v="";if(p.length===8)for(let F=p.length-2;F>=0;F-=2)v+=parseInt(p.substr(F,2),16),F!==0&&(v+=".");else for(let F=0;F<p.length;F+=8){const N=p.substring(F,F+8);let O="";for(let j=8;j>=2;j-=2)O+=N.substring(j-2,j),(j===6||j===2)&&(O=parseInt(O,16).toString(16),v+=`${O}`,O="",F+j!==p.length-6&&(v+=":"))}return v}function u(p){const v=p.trim().split(`
`),F=v.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return v.map(O=>O.trim().split(/\s+/).reduce((j,z,M)=>(j[F[M]||M]=z,j),{}))}function w(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function S(p){const v=p.trim().split(`
`),F=[];return v.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&F.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),F}async function D(p,v,F){const N=F.reduce((j,z)=>(j[z.pid]=z,j),{}),O=[];return p.forEach(({socket:j,ip:z,port:M})=>{const V=v[j]?v[j].pid:void 0,K=V?N[V]?.cmd:void 0;V&&K&&!w(K)&&O.push({host:z,port:M,detail:K,pid:V})}),O}function y(p,v,F){const N=new Map,O=S(v);for(const j of p){const z=F.get(j.port);if(z){N.set(j.port,z);continue}const M=O.find(V=>V.cmd.includes(`${j.port}`));if(M){let V=M,K;do K=O.find(re=>re.ppid===V.pid),K&&(V=K);while(K);N.set(j.port,{host:j.ip,port:j.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else N.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return N}let C=class extends o.$4Fb{constructor(v,F,N,O){super(v,F,N),this.D=F,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,R.$k&&F.remote.isRemote&&F.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let F;this.y&&(F=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new L.$Om;let O=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(K=>(0,m.$Hw)(K.host)||(0,m.$Jw)(K.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(K=>K.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),O++>3&&N.update(M),(!F||JSON.stringify(F)!==JSON.stringify(z))&&(F=z,await this.a.$onFoundNewCandidates(F));const V=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${V} ms.`),await new Promise(K=>setTimeout(()=>K(),V))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",F="";try{v=await k.Promises.readFile("/proc/net/tcp","utf8"),F=await k.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=r(v,F),O=await new Promise(G=>{(0,s.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,ee,de)=>{G(ee)})}),j=i(O),z=await k.Promises.readdir("/proc"),M=[];for(const G of z)try{const X=Number(G),ee=$.$hh(a.URI.file("/proc"),G);if((await k.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(X)){const ne=await k.Promises.readlink($.$hh(ee,"cwd").fsPath),De=await k.Promises.readFile($.$hh(ee,"cmdline").fsPath,"utf8");M.push({pid:X,cwd:ne,cmd:De})}}catch{}const V=[],K=N.filter(G=>{const X=j[G.socket];return X||V.push(G),X}),re=D(K,j,M);let B;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const G=await new Promise(X=>{(0,s.exec)("ps -F -A -l | grep root",(ee,de,ne)=>{X(de)})});this.z=y(V,G,this.z),B=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(X=>X.port).join(", ")}`)}return re.then(G=>B?G.concat(B):G)}w(v){return async F=>{const N=new d.$Rgc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,M,V){const K=await v.makeConnection();return A.connect(K,z,M,V)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new b.$Sl(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",F.remoteAddress.host||"localhost",F.remoteAddress.port,F.localAddressPort);await N.waitForReady();const O=new I.$ne;return{localAddress:(0,t.$UM)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$jrc=C,e.$jrc=C=Xe([Ve(0,n.$1P),Ve(1,g.$eQ),Ve(2,l.$ak),Ve(3,c.$Zl)],C);class A extends P.$ixb{static connect(v,F,N,O){const j=new T.$Wc,z={onClose:j.add(new I.$ne),onData:j.add(new I.$ne),onEnd:j.add(new I.$ne)};j.add(v.onDidReceiveMessage(V=>z.onData.fire(h.$Pe.wrap(V)))),j.add(v.onDidEnd(()=>z.onEnd.fire())),j.add(v.onDidClose(V=>z.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:V,hadError:!!V})));const M=new A(v,O,z);return M.B(j),(0,P.$hxb)(M,F,N,O,z)}constructor(v,F,N){super(F,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[410],Se([1,0,89,379,393,392,405,408,409,102,53,103,101,47,77,98,378,338,12,394,65,298,113,118,149]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d,g,n,o,t,i,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$Ps)(k.$ppc,R.$brc,s.InstantiationType.Eager),(0,s.$Ps)(g.$bk,d.$lrc,s.InstantiationType.Delayed),(0,s.$Ps)(g.$ak,new i.$Di(t.$Bqc,[!1],!0)),(0,s.$Ps)(r.$Zl,f.$Wgc,s.InstantiationType.Delayed),(0,s.$Ps)(c.$Roc,m.$krc,s.InstantiationType.Eager),(0,s.$Ps)(a.$zpc,T.$Oqc,s.InstantiationType.Eager),(0,s.$Ps)(E.$Vpc,L.$9qc,s.InstantiationType.Eager),(0,s.$Ps)(l.$mqc,I.$Gqc,s.InstantiationType.Eager),(0,s.$Ps)(P.$apc,h.$Fqc,s.InstantiationType.Eager),(0,s.$Ps)(b.$3Fb,$.$jrc,s.InstantiationType.Eager),(0,s.$Ps)(o.$spc,n.$mrc,s.InstantiationType.Eager)});var jt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[420],Se([1,0,421,67,9,22,14,62,111,34,69,131,114,281,391,304,320,94,396,410]),function(ce,e,s,h,I,T,L,R,$,a,k,E,l,P,b,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=jt(s),h=We(h),R=We(R),P=jt(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const g=(0,s.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const S=globalThis._VSCODE_NODE_MODULES.module,D=S._load;S._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function t(S){process.exit=function(D){if(S)n(D);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,y){D==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),o(D,y)}}let i=function(S){n()};function r(){const S=(0,m.$gn)(process.env);if(S.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,y)=>{const C=A=>{const p=A[0],v=new k.$ti;p.on("message",F=>v.fire(T.$Pe.wrap(F.data))),p.on("close",()=>{i("renderer closed the MessagePort")}),p.start(),D({onMessage:v.event,send:F=>p.postMessage(F.buffer)})};process.parentPort.on("message",A=>C(A.ports))});if(S.type===m.ExtHostConnectionType.Socket)return new Promise((D,y)=>{let C=null;const A=setTimeout(()=>{i("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=k.ProtocolConstants.ReconnectionGraceTime,v=k.ProtocolConstants.ReconnectionShortGraceTime,F=new I.$Th(()=>i("renderer disconnected for too long (1)"),p),N=new I.$Th(()=>i("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const M=T.$Pe.wrap(Buffer.from(j.initialDataChunk,"base64"));let V;if(j.skipWebSocketFrames)V=new E.$vi(z,"extHost-socket");else{const K=T.$Pe.wrap(Buffer.from(j.inflateBytes,"base64"));V=new E.$wi(new E.$vi(z,"extHost-socket"),j.permessageDeflate,K,!1)}C?(F.cancel(),N.cancel(),C.beginAcceptReconnection(V,M),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(A),C=new k.$ui({socket:V,initialChunk:M}),C.sendResume(),C.onDidDispose(()=>i("renderer disconnected")),D(C),C.onSocketClose(()=>{F.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const D=S.pipeName;return new Promise((y,C)=>{const A=h.createConnection(D,()=>{A.removeListener("error",C);const p=new k.$ui({socket:new E.$vi(A,"extHost-renderer")});p.sendResume(),y(p)});A.once("error",C),A.on("close",()=>{i("renderer closed the socket")})})}}async function f(){const S=await r();return new class{constructor(){this.a=new k.$ti,this.onMessage=this.a.event,this.b=!1,this.d=S.onMessage(D=>{(0,d.$Cn)(D,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),i("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||S.send(D)}async drain(){if(S.drain)return S.drain()}}}function u(S){return new Promise(D=>{const y=S.onMessage(C=>{y.dispose();const A=JSON.parse(C.toString()),p=A.commit,v=P.default.commit;if(p&&v&&p!==v&&n(d.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(O){O&&O.code==="EPERM"?(F++,F>=3&&i(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):i(`parent process ${A.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(O){(0,L.$3)(O)}}S.send((0,d.$Bn)(d.MessageType.Initialized)),D({protocol:S,initData:A})});S.send((0,d.$Bn)(d.MessageType.Ready))})}async function w(){const S=[];process.on("unhandledRejection",(F,N)=>{S.push(N),setTimeout(()=>{const O=S.indexOf(N);O>=0&&N.catch(j=>{S.splice(O,1),(0,L.$7)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),F&&(0,L.$3)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=S.indexOf(F);N>=0&&S.splice(N,1)}),process.on("uncaughtException",function(F){(0,L.$2)(F)||(0,L.$3)(F)}),R.mark("code/extHost/willConnectToRenderer");const D=await f();R.mark("code/extHost/didConnectToRenderer");const y=await u(D);R.mark("code/extHost/didWaitForInitData");const{initData:C}=y;t(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,l.boolean)(g.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return a.Promises.exists(N)}fsRealpath(N){return(0,$.$lr)(N)}};let p=null;C.remote.authority&&g.transformURIs&&(p=(0,c.$Ts)(C.remote.authority));const v=new b.$Eqc(y.protocol,C,A,p);i=F=>v.terminate(F)}w().catch(S=>console.log(S))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/b36286db80c68b7fdc6bfee2f55e0208c8833dfc/core/vs/workbench/api/node/extensionHostProcess.js.map
