/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(ae){for(var e=[],v=0,I=ae.length;v<I;v++)e[v]=Ie[ae[v]];return e};define(Ie[72],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=I,e.$_h=C,e.$ai=N;function v(A){return(T,p,a)=>{let R=null,y=null;if(typeof a.value=="function"?(R="value",y=a.value):typeof a.get=="function"&&(R="get",y=a.get),!y)throw new Error("not supported");a[R]=A(y,p)}}function I(A,T,p){let a=null,R=null;if(typeof p.value=="function"?(a="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",R=p.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;p[a]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[y]}}function C(A,T,p){return v((a,R)=>{const y=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[y]),T&&(this[u]=T(this[u],...E),E=[this[u]]),this[y]=setTimeout(()=>{a.apply(this,E),this[u]=p?p():void 0},A)}})}function N(A,T,p){return v((a,R)=>{const y=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...n){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...n)),this[d])return;const s=this[E]+A;s<=Date.now()?(this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0},s-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(ae,e,v,I){I===void 0&&(I=v);var C=Object.getOwnPropertyDescriptor(e,v);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(ae,I,C)}:function(ae,e,v,I){I===void 0&&(I=v),ae[I]=e[v]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Ve=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var v in ae)v!=="default"&&Object.prototype.hasOwnProperty.call(ae,v)&&Bn(e,ae,v);return Wn(e,ae),e};define(Ie[135],Pe([1,0,18]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=C,e.$$c=N,e.$_c=A,e.$ad=T,e.$bd=p,e.$cd=a,v=Ve(v);const I=(E,d)=>E===d;e.$9c=I;function C(E=e.$9c){return(d,n)=>v.$xb(d,n,E)}function N(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function T(E,d,n){if(n!==void 0){const s=E;return s==null||d===void 0||d===null?d===s:n(s,d)}else{const s=E;return(o,h)=>o==null||h===void 0||h===null?h===o:s(o,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let n=0;n<E.length;n++)if(!p(E[n],d[n]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=E,s=d,o=Object.keys(n),h=Object.keys(s),i=new Set(h);if(o.length!==h.length)return!1;for(const r of o)if(!i.has(r)||!p(n[r],s[r]))return!1;return!0}return!1}function a(E){return JSON.stringify(u(E))}let R=0;const y=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,n=Object.create(null);for(const s of Object.keys(d).sort())n[s]=u(d[s]);return n}else{let d=y.get(E);return d===void 0&&(d=R++,y.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(Ie[97],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class v{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=v,e.$7P=new v("id#")}),define(Ie[136],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=A,e.$Xn=y,e.$Yn=u,e.$Zn=E,e.$1n=d,e.$2n=n,e.$3n=s,e.$4n=o,e.$5n=h,e.$6n=i,e.$7n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,c=!1){let l=0;const g=t.length;let m="",$=0,D=I.Unknown,S=v.None;function b(L){let q=0,W=0;for(;q<L;){const M=t.charCodeAt(l);if(M>=R._0&&M<=R._9)W=W*16+M-R._0;else if(M>=R.A&&M<=R.F)W=W*16+M-R.A+10;else if(M>=R.a&&M<=R.f)W=W*16+M-R.a+10;else break;l++,q++}return q<L&&(W=-1),W}function k(L){l=L,m="",$=0,D=I.Unknown,S=v.None}function P(){const L=l;if(t.charCodeAt(l)===R._0)l++;else for(l++;l<t.length&&a(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===R.dot)if(l++,l<t.length&&a(t.charCodeAt(l)))for(l++;l<t.length&&a(t.charCodeAt(l));)l++;else return S=v.UnexpectedEndOfNumber,t.substring(L,l);let q=l;if(l<t.length&&(t.charCodeAt(l)===R.E||t.charCodeAt(l)===R.e))if(l++,(l<t.length&&t.charCodeAt(l)===R.plus||t.charCodeAt(l)===R.minus)&&l++,l<t.length&&a(t.charCodeAt(l))){for(l++;l<t.length&&a(t.charCodeAt(l));)l++;q=l}else S=v.UnexpectedEndOfNumber;return t.substring(L,q)}function f(){let L="",q=l;for(;;){if(l>=g){L+=t.substring(q,l),S=v.UnexpectedEndOfString;break}const W=t.charCodeAt(l);if(W===R.doubleQuote){L+=t.substring(q,l),l++;break}if(W===R.backslash){if(L+=t.substring(q,l),l++,l>=g){S=v.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case R.doubleQuote:L+='"';break;case R.backslash:L+="\\";break;case R.slash:L+="/";break;case R.b:L+="\b";break;case R.f:L+="\f";break;case R.n:L+=`
`;break;case R.r:L+="\r";break;case R.t:L+="	";break;case R.u:{const Y=b(4);Y>=0?L+=String.fromCharCode(Y):S=v.InvalidUnicode;break}default:S=v.InvalidEscapeCharacter}q=l;continue}if(W>=0&&W<=31)if(p(W)){L+=t.substring(q,l),S=v.UnexpectedEndOfString;break}else S=v.InvalidCharacter;l++}return L}function w(){if(m="",S=v.None,$=l,l>=g)return $=g,D=I.EOF;let L=t.charCodeAt(l);if(T(L)){do l++,m+=String.fromCharCode(L),L=t.charCodeAt(l);while(T(L));return D=I.Trivia}if(p(L))return l++,m+=String.fromCharCode(L),L===R.carriageReturn&&t.charCodeAt(l)===R.lineFeed&&(l++,m+=`
`),D=I.LineBreakTrivia;switch(L){case R.openBrace:return l++,D=I.OpenBraceToken;case R.closeBrace:return l++,D=I.CloseBraceToken;case R.openBracket:return l++,D=I.OpenBracketToken;case R.closeBracket:return l++,D=I.CloseBracketToken;case R.colon:return l++,D=I.ColonToken;case R.comma:return l++,D=I.CommaToken;case R.doubleQuote:return l++,m=f(),D=I.StringLiteral;case R.slash:{const q=l-1;if(t.charCodeAt(l+1)===R.slash){for(l+=2;l<g&&!p(t.charCodeAt(l));)l++;return m=t.substring(q,l),D=I.LineCommentTrivia}if(t.charCodeAt(l+1)===R.asterisk){l+=2;const W=g-1;let M=!1;for(;l<W;){if(t.charCodeAt(l)===R.asterisk&&t.charCodeAt(l+1)===R.slash){l+=2,M=!0;break}l++}return M||(l++,S=v.UnexpectedEndOfComment),m=t.substring(q,l),D=I.BlockCommentTrivia}return m+=String.fromCharCode(L),l++,D=I.Unknown}case R.minus:if(m+=String.fromCharCode(L),l++,l===g||!a(t.charCodeAt(l)))return D=I.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return m+=P(),D=I.NumericLiteral;default:for(;l<g&&F(L);)l++,L=t.charCodeAt(l);if($!==l){switch(m=t.substring($,l),m){case"true":return D=I.TrueKeyword;case"false":return D=I.FalseKeyword;case"null":return D=I.NullKeyword}return D=I.Unknown}return m+=String.fromCharCode(L),l++,D=I.Unknown}}function F(L){if(T(L)||p(L))return!1;switch(L){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function O(){let L;do L=w();while(L>=I.LineCommentTrivia&&L<=I.Trivia);return L}return{setPosition:k,getPosition:()=>l,scan:c?O:w,getToken:()=>D,getTokenValue:()=>m,getTokenOffset:()=>$,getTokenLength:()=>l-$,getTokenError:()=>S}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function a(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,c){const l=[],g=new Object;let m;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function S(b,k,P,f){$.value=b,$.offset=k,$.length=P,$.type=f,$.colonOffset=void 0,m=$}try{i(t,{onObjectBegin:(b,k)=>{if(c<=b)throw g;m=void 0,D=c>b,l.push("")},onObjectProperty:(b,k,P)=>{if(c<k||(S(b,k,P,"property"),l[l.length-1]=b,c<=k+P))throw g},onObjectEnd:(b,k)=>{if(c<=b)throw g;m=void 0,l.pop()},onArrayBegin:(b,k)=>{if(c<=b)throw g;m=void 0,l.push(0)},onArrayEnd:(b,k)=>{if(c<=b)throw g;m=void 0,l.pop()},onLiteralValue:(b,k,P)=>{if(c<k||(S(b,k,P,r(b)),c<=k+P))throw g},onSeparator:(b,k,P)=>{if(c<=k)throw g;if(b===":"&&m&&m.type==="property")m.colonOffset=k,D=!1,m=void 0;else if(b===","){const f=l[l.length-1];typeof f=="number"?l[l.length-1]=f+1:(D=!0,l[l.length-1]=""),m=void 0}}})}catch(b){if(b!==g)throw b}return{path:l,previousNode:m,isAtPropertyKey:D,matches:b=>{let k=0;for(let P=0;k<b.length&&P<l.length;P++)if(b[k]===l[P]||b[k]==="*")k++;else if(b[k]!=="**")return!1;return k===b.length}}}function u(t,c=[],l=N.DEFAULT){let g=null,m=[];const $=[];function D(b){Array.isArray(m)?m.push(b):g!==null&&(m[g]=b)}return i(t,{onObjectBegin:()=>{const b={};D(b),$.push(m),m=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{m=$.pop()},onArrayBegin:()=>{const b=[];D(b),$.push(m),m=b,g=null},onArrayEnd:()=>{m=$.pop()},onLiteralValue:D,onError:(b,k,P)=>{c.push({error:b,offset:k,length:P})}},l),m[0]}function E(t,c=[],l=N.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(b){g.type==="property"&&(g.length=b-g.offset,g=g.parent)}function $(b){return g.children.push(b),b}i(t,{onObjectBegin:b=>{g=$({type:"object",offset:b,length:-1,parent:g,children:[]})},onObjectProperty:(b,k,P)=>{g=$({type:"property",offset:k,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:b,offset:k,length:P,parent:g})},onObjectEnd:(b,k)=>{g.length=b+k-g.offset,g=g.parent,m(b+k)},onArrayBegin:(b,k)=>{g=$({type:"array",offset:b,length:-1,parent:g,children:[]})},onArrayEnd:(b,k)=>{g.length=b+k-g.offset,g=g.parent,m(b+k)},onLiteralValue:(b,k,P)=>{$({type:r(b),offset:k,length:P,parent:g,value:b}),m(k+P)},onSeparator:(b,k,P)=>{g.type==="property"&&(b===":"?g.colonOffset=k:b===","&&m(k))},onError:(b,k,P)=>{c.push({error:b,offset:k,length:P})}},l);const S=g.children[0];return S&&delete S.parent,S}function d(t,c){if(!t)return;let l=t;for(const g of c)if(typeof g=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let m=!1;for(const $ of l.children)if(Array.isArray($.children)&&$.children[0].value===g){l=$.children[1],m=!0;break}if(!m)return}else{const m=g;if(l.type!=="array"||m<0||!Array.isArray(l.children)||m>=l.children.length)return;l=l.children[m]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const c=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;c.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&c.push(l)}return c}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const l of t.children){const g=l.children[1];g&&(c[l.children[0].value]=s(g))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,l=!1){return c>=t.offset&&c<t.offset+t.length||l&&c===t.offset+t.length}function h(t,c,l=!1){if(o(t,c,l)){const g=t.children;if(Array.isArray(g))for(let m=0;m<g.length&&g[m].offset<=c;m++){const $=h(g[m],c,l);if($)return $}return t}}function i(t,c,l=N.DEFAULT){const g=A(t,!1);function m(ce){return ce?()=>ce(g.getTokenOffset(),g.getTokenLength()):()=>!0}function $(ce){return ce?we=>ce(we,g.getTokenOffset(),g.getTokenLength()):()=>!0}const D=m(c.onObjectBegin),S=$(c.onObjectProperty),b=m(c.onObjectEnd),k=m(c.onArrayBegin),P=m(c.onArrayEnd),f=$(c.onLiteralValue),w=$(c.onSeparator),F=m(c.onComment),O=$(c.onError),L=l&&l.disallowComments,q=l&&l.allowTrailingComma;function W(){for(;;){const ce=g.scan();switch(g.getTokenError()){case v.InvalidUnicode:M(C.InvalidUnicode);break;case v.InvalidEscapeCharacter:M(C.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:M(C.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||M(C.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:M(C.UnexpectedEndOfString);break;case v.InvalidCharacter:M(C.InvalidCharacter);break}switch(ce){case I.LineCommentTrivia:case I.BlockCommentTrivia:L?M(C.InvalidCommentToken):F();break;case I.Unknown:M(C.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return ce}}}function M(ce,we=[],oe=[]){if(O(ce),we.length+oe.length>0){let Ce=g.getToken();for(;Ce!==I.EOF;){if(we.indexOf(Ce)!==-1){W();break}else if(oe.indexOf(Ce)!==-1)break;Ce=W()}}}function Y(ce){const we=g.getTokenValue();return ce?f(we):S(we),W(),!0}function Z(){switch(g.getToken()){case I.NumericLiteral:{let ce=0;try{ce=JSON.parse(g.getTokenValue()),typeof ce!="number"&&(M(C.InvalidNumberFormat),ce=0)}catch{M(C.InvalidNumberFormat)}f(ce);break}case I.NullKeyword:f(null);break;case I.TrueKeyword:f(!0);break;case I.FalseKeyword:f(!1);break;default:return!1}return W(),!0}function ge(){return g.getToken()!==I.StringLiteral?(M(C.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(Y(!1),g.getToken()===I.ColonToken?(w(":"),W(),se()||M(C.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):M(C.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function _(){D(),W();let ce=!1;for(;g.getToken()!==I.CloseBraceToken&&g.getToken()!==I.EOF;){if(g.getToken()===I.CommaToken){if(ce||M(C.ValueExpected,[],[]),w(","),W(),g.getToken()===I.CloseBraceToken&&q)break}else ce&&M(C.CommaExpected,[],[]);ge()||M(C.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),ce=!0}return b(),g.getToken()!==I.CloseBraceToken?M(C.CloseBraceExpected,[I.CloseBraceToken],[]):W(),!0}function me(){k(),W();let ce=!1;for(;g.getToken()!==I.CloseBracketToken&&g.getToken()!==I.EOF;){if(g.getToken()===I.CommaToken){if(ce||M(C.ValueExpected,[],[]),w(","),W(),g.getToken()===I.CloseBracketToken&&q)break}else ce&&M(C.CommaExpected,[],[]);se()||M(C.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),ce=!0}return P(),g.getToken()!==I.CloseBracketToken?M(C.CloseBracketExpected,[I.CloseBracketToken],[]):W(),!0}function se(){switch(g.getToken()){case I.OpenBracketToken:return me();case I.OpenBraceToken:return _();case I.StringLiteral:return Y(!0);default:return Z()}}return W(),g.getToken()===I.EOF?l.allowEmptyContent?!0:(M(C.ValueExpected,[],[]),!1):se()?(g.getToken()!==I.EOF&&M(C.EndOfFileExpected,[],[]),!0):(M(C.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ae,e){typeof define=="function"&&define.amd?define(Ie[137],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(ue,be){for(var de=0;de<be.length;de++){var J=be[de];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ue,J.key,J)}}function v(ue,be,de){return be&&e(ue.prototype,be),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function I(ue,be){if(ue){if(typeof ue=="string")return C(ue,be);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return C(ue,be)}}function C(ue,be){(be==null||be>ue.length)&&(be=ue.length);for(var de=0,J=new Array(be);de<be;de++)J[de]=ue[de];return J}function N(ue,be){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=I(ue))||be&&ue&&typeof ue.length=="number"){de&&(ue=de);var J=0;return function(){return J>=ue.length?{done:!0}:{done:!1,value:ue[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=A();function T(ue){ae.defaults=ue}var p=/[&<>"']/,a=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(be){return u[be]};function d(ue,be){if(be){if(p.test(ue))return ue.replace(a,E)}else if(R.test(ue))return ue.replace(y,E);return ue}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ue){return ue.replace(n,function(be,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function h(ue,be){ue=typeof ue=="string"?ue:ue.source,be=be||"";var de={replace:function(x,pe){return pe=pe.source||pe,pe=pe.replace(o,"$1"),ue=ue.replace(x,pe),de},getRegex:function(){return new RegExp(ue,be)}};return de}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ue,be,de){if(ue){var J;try{J=decodeURIComponent(s(de)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}be&&!r.test(de)&&(de=$(be,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var c={},l=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ue,be){c[" "+ue]||(l.test(ue)?c[" "+ue]=ue+"/":c[" "+ue]=k(ue,"/",!0)),ue=c[" "+ue];var de=ue.indexOf(":")===-1;return be.substring(0,2)==="//"?de?be:ue.replace(g,"$1")+be:be.charAt(0)==="/"?de?be:ue.replace(m,"$1")+be:ue+be}var D={exec:function(){}};function S(ue){for(var be=1,de,J;be<arguments.length;be++){de=arguments[be];for(J in de)Object.prototype.hasOwnProperty.call(de,J)&&(ue[J]=de[J])}return ue}function b(ue,be){var de=ue.replace(/\|/g,function(pe,$e,Ne){for(var ze=!1,ke=$e;--ke>=0&&Ne[ke]==="\\";)ze=!ze;return ze?"|":" |"}),J=de.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>be)J.splice(be);else for(;J.length<be;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function k(ue,be,de){var J=ue.length;if(J===0)return"";for(var x=0;x<J;){var pe=ue.charAt(J-x-1);if(pe===be&&!de)x++;else if(pe!==be&&de)x++;else break}return ue.slice(0,J-x)}function P(ue,be){if(ue.indexOf(be[1])===-1)return-1;for(var de=ue.length,J=0,x=0;x<de;x++)if(ue[x]==="\\")x++;else if(ue[x]===be[0])J++;else if(ue[x]===be[1]&&(J--,J<0))return x;return-1}function f(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ue,be){if(be<1)return"";for(var de="";be>1;)be&1&&(de+=ue),be>>=1,ue+=ue;return de+ue}function F(ue,be,de,J){var x=be.href,pe=be.title?d(be.title):null,$e=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:de,href:x,title:pe,text:$e,tokens:J.inlineTokens($e)};return J.state.inLink=!1,Ne}return{type:"image",raw:de,href:x,title:pe,text:d($e)}}function O(ue,be){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return be;var J=de[1];return be.split(`
`).map(function(x){var pe=x.match(/^\s+/);if(pe===null)return x;var $e=pe[0];return $e.length>=J.length?x.slice(J.length):x}).join(`
`)}var L=function(){function ue(de){this.options=de||ae.defaults}var be=ue.prototype;return be.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(J){var x=this.rules.block.code.exec(J);if(x){var pe=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},be.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var pe=x[0],$e=O(pe,x[3]||"");return{type:"code",raw:pe,lang:x[2]?x[2].trim():x[2],text:$e}}},be.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var pe=x[2].trim();if(/#$/.test(pe)){var $e=k(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:pe,tokens:this.lexer.inline(pe)}}},be.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var pe=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},be.list=function(J){var x=this.rules.block.list.exec(J);if(x){var pe,$e,Ne,ze,ke,Ae,Oe,j,U,G,H,ne,fe=x[1].trim(),Re=fe.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Re?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Re?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ne=!1,!(!(x=Ke.exec(J))||this.rules.block.hr.test(J)));){if(pe=x[0],J=J.substring(pe.length),j=x[2].split(`
`,1)[0],U=J.split(`
`,1)[0],this.options.pedantic?(ze=2,H=j.trimLeft()):(ze=x[2].search(/[^ ]/),ze=ze>4?1:ze,H=j.slice(ze),ze+=x[1].length),Ae=!1,!j&&/^ *$/.test(U)&&(pe+=U+`
`,J=J.substring(U.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");J&&(G=J.split(`
`,1)[0],j=G,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(j)||et.test(j)||_e.test(j)||tt.test(J)));){if(j.search(/[^ ]/)>=ze||!j.trim())H+=`
`+j.slice(ze);else if(!Ae)H+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),pe+=G+`
`,J=J.substring(G.length+1)}Ue.loose||(Oe?Ue.loose=!0:/\n *\n *$/.test(pe)&&(Oe=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(H),$e&&(Ne=$e[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:pe,task:!!$e,checked:Ne,loose:!1,text:H}),Ue.raw+=pe}Ue.items[Ue.items.length-1].raw=pe.trimRight(),Ue.items[Ue.items.length-1].text=H.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var ft=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),ct=ft.every(function(st){for(var ut=st.raw.split(""),gt=0,pt=N(ut),Be;!(Be=pt()).done;){var je=Be.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!Ue.loose&&ft.length&&ct&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},be.html=function(J){var x=this.rules.block.html.exec(J);if(x){var pe={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},be.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var pe=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:x[0],href:x[2],title:x[3]}}},be.table=function(J){var x=this.rules.block.table.exec(J);if(x){var pe={type:"table",header:b(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=x[0];var $e=pe.align.length,Ne,ze,ke,Ae;for(Ne=0;Ne<$e;Ne++)/^ *-+: *$/.test(pe.align[Ne])?pe.align[Ne]="right":/^ *:-+: *$/.test(pe.align[Ne])?pe.align[Ne]="center":/^ *:-+ *$/.test(pe.align[Ne])?pe.align[Ne]="left":pe.align[Ne]=null;for($e=pe.rows.length,Ne=0;Ne<$e;Ne++)pe.rows[Ne]=b(pe.rows[Ne],pe.header.length).map(function(Oe){return{text:Oe}});for($e=pe.header.length,ze=0;ze<$e;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for($e=pe.rows.length,ze=0;ze<$e;ze++)for(Ae=pe.rows[ze],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return pe}}},be.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var pe=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:pe,tokens:this.lexer.inline(pe)}}},be.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},be.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},be.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var pe=x[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=k(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Ne=P(x[2],"()");if(Ne>-1){var ze=x[0].indexOf("!")===0?5:4,ke=ze+x[1].length+Ne;x[2]=x[2].substring(0,Ne),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Ae=x[2],Oe="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Oe=j[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),F(x,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(J,x){var pe;if((pe=this.rules.inline.reflink.exec(J))||(pe=this.rules.inline.nolink.exec(J))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=x[$e.toLowerCase()],!$e||!$e.href){var Ne=pe[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return F(pe,$e,pe[0],this.lexer)}},be.emStrong=function(J,x,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(J);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=$e[1]||$e[2]||"";if(!Ne||Ne&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=$e[0].length-1,ke,Ae,Oe=ze,j=0,U=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,x=x.slice(-1*J.length+ze);($e=U.exec(x))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Ae=ke.length,$e[3]||$e[4]){Oe+=Ae;continue}else if(($e[5]||$e[6])&&ze%3&&!((ze+Ae)%3)){j+=Ae;continue}if(Oe-=Ae,!(Oe>0)){if(Ae=Math.min(Ae,Ae+Oe+j),Math.min(ze,Ae)%2){var G=J.slice(1,ze+$e.index+Ae);return{type:"em",raw:J.slice(0,ze+$e.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=J.slice(2,ze+$e.index+Ae-1);return{type:"strong",raw:J.slice(0,ze+$e.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var pe=x[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Ne=/^ /.test(pe)&&/ $/.test(pe);return $e&&Ne&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:x[0],text:pe}}},be.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},be.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(J,x){var pe=this.rules.inline.autolink.exec(J);if(pe){var $e,Ne;return pe[2]==="@"?($e=d(this.options.mangle?x(pe[1]):pe[1]),Ne="mailto:"+$e):($e=d(pe[1]),Ne=$e),{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},be.url=function(J,x){var pe;if(pe=this.rules.inline.url.exec(J)){var $e,Ne;if(pe[2]==="@")$e=d(this.options.mangle?x(pe[0]):pe[0]),Ne="mailto:"+$e;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Ne="http://"+$e:Ne=$e}return{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},be.inlineText=function(J,x){var pe=this.rules.inline.text.exec(J);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?x(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},ue}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=h(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=h(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=h(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=h(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=h(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=S({},q),q.gfm=S({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=h(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=S({},q.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:h(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=h(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=h(q._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=h(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=h(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=h(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=h(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=h(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=h(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=h(W.reflink).replace("label",W._label).replace("ref",q._label).getRegex(),W.nolink=h(W.nolink).replace("ref",q._label).getRegex(),W.reflinkSearch=h(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=S({},W),W.pedantic=S({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=S({},W.normal,{escape:h(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=h(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=S({},W.gfm,{br:h(W.br).replace("{2,}","*").getRegex(),text:h(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ue){var be="",de,J,x=ue.length;for(de=0;de<x;de++)J=ue.charCodeAt(de),Math.random()>.5&&(J="x"+J.toString(16)),be+="&#"+J+";";return be}var Z=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ae.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:W.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=W.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=W.breaks:J.inline=W.gfm),this.tokenizer.rules=J}ue.lex=function(J,x){var pe=new ue(x);return pe.lex(J)},ue.lexInline=function(J,x){var pe=new ue(x);return pe.inlineTokens(J)};var be=ue.prototype;return be.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(J,x){var pe=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Oe,j,U){return j+"    ".repeat(U.length)});for(var $e,Ne,ze,ke;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return($e=Oe.call({lexer:pe},J,x))?(J=J.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.space(J)){J=J.substring($e.raw.length),$e.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push($e);continue}if($e=this.tokenizer.code(J)){J=J.substring($e.raw.length),Ne=x[x.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):x.push($e);continue}if($e=this.tokenizer.fences(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.heading(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.hr(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.blockquote(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.list(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.html(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.def(J)){J=J.substring($e.raw.length),Ne=x[x.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.lheading(J)){J=J.substring($e.raw.length),x.push($e);continue}if(ze=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,j=J.slice(1),U=void 0;pe.options.extensions.startBlock.forEach(function(G){U=G.call({lexer:this},j),typeof U=="number"&&U>=0&&(Oe=Math.min(Oe,U))}),Oe<1/0&&Oe>=0&&(ze=J.substring(0,Oe+1))}(),this.state.top&&($e=this.tokenizer.paragraph(ze))){Ne=x[x.length-1],ke&&Ne.type==="paragraph"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):x.push($e),ke=ze.length!==J.length,J=J.substring($e.raw.length);continue}if($e=this.tokenizer.text(J)){J=J.substring($e.raw.length),Ne=x[x.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):x.push($e);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,x},be.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},be.inlineTokens=function(J,x){var pe=this;x===void 0&&(x=[]);var $e,Ne,ze,ke=J,Ae,Oe,j;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)U.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Oe||(j=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return($e=H.call({lexer:pe},J,x))?(J=J.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.escape(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.tag(J)){J=J.substring($e.raw.length),Ne=x[x.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.link(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring($e.raw.length),Ne=x[x.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.emStrong(J,ke,j)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.codespan(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.br(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.del(J)){J=J.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.autolink(J,Y)){J=J.substring($e.raw.length),x.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(J,Y))){J=J.substring($e.raw.length),x.push($e);continue}if(ze=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ne=J.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(Re){fe=Re.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(H=Math.min(H,fe))}),H<1/0&&H>=0&&(ze=J.substring(0,H+1))}(),$e=this.tokenizer.inlineText(ze,M)){J=J.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(j=$e.raw.slice(-1)),Oe=!0,Ne=x[x.length-1],Ne&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):x.push($e);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return x},v(ue,null,[{key:"rules",get:function(){return{block:q,inline:W}}}]),ue}(),ge=function(){function ue(de){this.options=de||ae.defaults}var be=ue.prototype;return be.code=function(J,x,pe){var $e=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,$e);Ne!=null&&Ne!==J&&(pe=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?J:d(J,!0))+`</code></pre>
`:"<pre><code>"+(pe?J:d(J,!0))+`</code></pre>
`},be.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},be.html=function(J){return J},be.heading=function(J,x,pe,$e){if(this.options.headerIds){var Ne=this.options.headerPrefix+$e.slug(pe);return"<h"+x+' id="'+Ne+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(J,x,pe){var $e=x?"ol":"ul",Ne=x&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Ne+`>
`+J+"</"+$e+`>
`},be.listitem=function(J){return"<li>"+J+`</li>
`},be.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(J){return"<p>"+J+`</p>
`},be.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},be.tablerow=function(J){return`<tr>
`+J+`</tr>
`},be.tablecell=function(J,x){var pe=x.header?"th":"td",$e=x.align?"<"+pe+' align="'+x.align+'">':"<"+pe+">";return $e+J+("</"+pe+`>
`)},be.strong=function(J){return"<strong>"+J+"</strong>"},be.em=function(J){return"<em>"+J+"</em>"},be.codespan=function(J){return"<code>"+J+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(J){return"<del>"+J+"</del>"},be.link=function(J,x,pe){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var $e='<a href="'+d(J)+'"';return x&&($e+=' title="'+x+'"'),$e+=">"+pe+"</a>",$e},be.image=function(J,x,pe){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var $e='<img src="'+J+'" alt="'+pe+'"';return x&&($e+=' title="'+x+'"'),$e+=this.options.xhtml?"/>":">",$e},be.text=function(J){return J},ue}(),_=function(){function ue(){}var be=ue.prototype;return be.strong=function(J){return J},be.em=function(J){return J},be.codespan=function(J){return J},be.del=function(J){return J},be.html=function(J){return J},be.text=function(J){return J},be.link=function(J,x,pe){return""+pe},be.image=function(J,x,pe){return""+pe},be.br=function(){return""},ue}(),me=function(){function ue(){this.seen={}}var be=ue.prototype;return be.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(J,x){var pe=J,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[J];do $e++,pe=J+"-"+$e;while(this.seen.hasOwnProperty(pe))}return x||(this.seen[J]=$e,this.seen[pe]=0),pe},be.slug=function(J,x){x===void 0&&(x={});var pe=this.serialize(J);return this.getNextSafeSlug(pe,x.dryrun)},ue}(),se=function(){function ue(de){this.options=de||ae.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new me}ue.parse=function(J,x){var pe=new ue(x);return pe.parse(J)},ue.parseInline=function(J,x){var pe=new ue(x);return pe.parseInline(J)};var be=ue.prototype;return be.parse=function(J,x){x===void 0&&(x=!0);var pe="",$e,Ne,ze,ke,Ae,Oe,j,U,G,H,ne,fe,Re,Ue,Ke,_e,tt,nt,et,rt=J.length;for($e=0;$e<rt;$e++){if(H=J[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(et=this.options.extensions.renderers[H.type].call({parser:this},H),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){pe+=et||"";continue}switch(H.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(H.tokens),H.depth,s(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(U="",j="",ke=H.header.length,Ne=0;Ne<ke;Ne++)j+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(U+=this.renderer.tablerow(j),G="",ke=H.rows.length,Ne=0;Ne<ke;Ne++){for(Oe=H.rows[Ne],j="",Ae=Oe.length,ze=0;ze<Ae;ze++)j+=this.renderer.tablecell(this.parseInline(Oe[ze].tokens),{header:!1,align:H.align[ze]});G+=this.renderer.tablerow(j)}pe+=this.renderer.table(U,G);continue}case"blockquote":{G=this.parse(H.tokens),pe+=this.renderer.blockquote(G);continue}case"list":{for(ne=H.ordered,fe=H.start,Re=H.loose,ke=H.items.length,G="",Ne=0;Ne<ke;Ne++)Ke=H.items[Ne],_e=Ke.checked,tt=Ke.task,Ue="",Ke.task&&(nt=this.renderer.checkbox(_e),Re?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Ke.tokens,Re),G+=this.renderer.listitem(Ue,tt,_e);pe+=this.renderer.list(G,ne,fe);continue}case"html":{pe+=this.renderer.html(H.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;$e+1<rt&&J[$e+1].type==="text";)H=J[++$e],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);pe+=x?this.renderer.paragraph(G):G;continue}default:{var ft='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return pe},be.parseInline=function(J,x){x=x||this.renderer;var pe="",$e,Ne,ze,ke=J.length;for($e=0;$e<ke;$e++){if(Ne=J[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(ze=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){pe+=ze||"";continue}switch(Ne.type){case"escape":{pe+=x.text(Ne.text);break}case"html":{pe+=x.html(Ne.text);break}case"link":{pe+=x.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,x));break}case"image":{pe+=x.image(Ne.href,Ne.title,Ne.text);break}case"strong":{pe+=x.strong(this.parseInline(Ne.tokens,x));break}case"em":{pe+=x.em(this.parseInline(Ne.tokens,x));break}case"codespan":{pe+=x.codespan(Ne.text);break}case"br":{pe+=x.br();break}case"del":{pe+=x.del(this.parseInline(Ne.tokens,x));break}case"text":{pe+=x.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return pe},ue}();function ce(ue,be,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof be=="function"&&(de=be,be=null),be=S({},ce.defaults,be||{}),f(be),de){var J=be.highlight,x;try{x=Z.lex(ue,be)}catch(ke){return de(ke)}var pe=function(Ae){var Oe;if(!Ae)try{be.walkTokens&&ce.walkTokens(x,be.walkTokens),Oe=se.parse(x,be)}catch(j){Ae=j}return be.highlight=J,Ae?de(Ae):de(null,Oe)};if(!J||J.length<3||(delete be.highlight,!x.length))return pe();var $e=0;ce.walkTokens(x,function(ke){ke.type==="code"&&($e++,setTimeout(function(){J(ke.text,ke.lang,function(Ae,Oe){if(Ae)return pe(Ae);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Ne(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var ze=Z.lex(ue,be);if(be.walkTokens){if(be.async)return Promise.all(ce.walkTokens(ze,be.walkTokens)).then(function(){return se.parse(ze,be)}).catch(Ne);ce.walkTokens(ze,be.walkTokens)}return se.parse(ze,be)}catch(ke){Ne(ke)}}ce.options=ce.setOptions=function(ue){return S(ce.defaults,ue),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=ae.defaults,ce.use=function(){for(var ue=arguments.length,be=new Array(ue),de=0;de<ue;de++)be[de]=arguments[de];var J=S.apply(void 0,[{}].concat(be)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},pe;be.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=x.renderers?x.renderers[ze.name]:null;ke?x.renderers[ze.name]=function(){for(var Ae=arguments.length,Oe=new Array(Ae),j=0;j<Ae;j++)Oe[j]=arguments[j];var U=ze.renderer.apply(this,Oe);return U===!1&&(U=ke.apply(this,Oe)),U}:x.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ze.level]?x[ze.level].unshift(ze.tokenizer):x[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?x.startBlock?x.startBlock.push(ze.start):x.startBlock=[ze.start]:ze.level==="inline"&&(x.startInline?x.startInline.push(ze.start):x.startInline=[ze.start]))}ze.childTokens&&(x.childTokens[ze.name]=ze.childTokens)})),$e.renderer&&function(){var ze=ce.defaults.renderer||new ge,ke=function(j){var U=ze[j];ze[j]=function(){for(var G=arguments.length,H=new Array(G),ne=0;ne<G;ne++)H[ne]=arguments[ne];var fe=$e.renderer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in $e.renderer)ke(Ae);J.renderer=ze}(),$e.tokenizer&&function(){var ze=ce.defaults.tokenizer||new L,ke=function(j){var U=ze[j];ze[j]=function(){for(var G=arguments.length,H=new Array(G),ne=0;ne<G;ne++)H[ne]=arguments[ne];var fe=$e.tokenizer[j].apply(ze,H);return fe===!1&&(fe=U.apply(ze,H)),fe}};for(var Ae in $e.tokenizer)ke(Ae);J.tokenizer=ze}(),$e.walkTokens){var Ne=ce.defaults.walkTokens;J.walkTokens=function(ze){var ke=[];return ke.push($e.walkTokens.call(this,ze)),Ne&&(ke=ke.concat(Ne.call(this,ze))),ke}}pe&&(J.extensions=x),ce.setOptions(J)})},ce.walkTokens=function(ue,be){for(var de=[],J=function(){var Ne=pe.value;switch(de=de.concat(be.call(ce,Ne)),Ne.type){case"table":{for(var ze=N(Ne.header),ke;!(ke=ze()).done;){var Ae=ke.value;de=de.concat(ce.walkTokens(Ae.tokens,be))}for(var Oe=N(Ne.rows),j;!(j=Oe()).done;)for(var U=j.value,G=N(U),H;!(H=G()).done;){var ne=H.value;de=de.concat(ce.walkTokens(ne.tokens,be))}break}case"list":{de=de.concat(ce.walkTokens(Ne.items,be));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ne.type]?ce.defaults.extensions.childTokens[Ne.type].forEach(function(fe){de=de.concat(ce.walkTokens(Ne[fe],be))}):Ne.tokens&&(de=de.concat(ce.walkTokens(Ne.tokens,be)))}},x=N(ue),pe;!(pe=x()).done;)J();return de},ce.parseInline=function(ue,be){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");be=S({},ce.defaults,be||{}),f(be);try{var de=Z.lexInline(ue,be);return be.walkTokens&&ce.walkTokens(de,be.walkTokens),se.parseInline(de,be)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(J.message+"",!0)+"</pre>";throw J}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=ge,ce.TextRenderer=_,ce.Lexer=Z,ce.lexer=Z.lex,ce.Tokenizer=L,ce.Slugger=me,ce.parse=ce;var we=ce.options,oe=ce.setOptions,Ce=ce.use,Le=ce.walkTokens,X=ce.parseInline,V=ce,te=se.parse,ve=Z.lex;ae.Lexer=Z,ae.Parser=se,ae.Renderer=ge,ae.Slugger=me,ae.TextRenderer=_,ae.Tokenizer=L,ae.getDefaults=A,ae.lexer=ve,ae.marked=ce,ae.options=we,ae.parse=V,ae.parseInline=X,ae.parser=te,ae.setOptions=oe,ae.use=Ce,ae.walkTokens=Le,Object.defineProperty(ae,"__esModule",{value:!0})}),define(Ie[138],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=v;function v(n){const s=N(n);if(s&&s.length>0)return new Uint32Array(s)}let I=0;const C=new Uint32Array(10);function N(n){if(I=0,A(n,y,p.InitialConsonant),I>0||(A(n,u,p.Vowel),I>0)||(A(n,E,p.FinalConsonant),I>0)||(A(n,d,p.CompatibilityJamo),I))return C.subarray(0,I);if(n>=44032&&n<=55203){const s=n-44032,o=s%588,h=Math.floor(s/588),i=Math.floor(o/28),r=o%28-1;if(h<y.length?A(h,y,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),i<u.length?A(i,u,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),r>=0&&(r<E.length?A(r,E,0):p.FinalConsonant+r-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+r-p.CompatibilityJamo,d,p.CompatibilityJamo)),I>0)return C.subarray(0,I)}}function A(n,s,o){n>=o&&n<o+s.length&&T(s[n-o])}function T(n){n!==a.NUL&&(C[I++]=n&255,n>>8&&(C[I++]=n>>8&255),n>>16&&(C[I++]=n>>16&255))}var p;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),u=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l]),E=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,R.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),d=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.E,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,a.Q,R.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l])}),define(Ie[139],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=v,e.rot=I,e.$Qm=T;function v(p,a,R){return Math.min(Math.max(p,a),R)}function I(p,a){return(a+p%a)%a}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=C;class N{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=N;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const R=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=A;function T(p,a,R,y,u,E,d,n){const s=d-R,o=n-y,h=u-R,i=E-y,r=p-R,t=a-y,c=s*s+o*o,l=s*h+o*i,g=s*r+o*t,m=h*h+i*i,$=h*r+i*t,D=1/(c*m-l*l),S=(m*g-l*$)*D,b=(c*$-l*g)*D;return S>=0&&b>=0&&S+b<1}}),define(Ie[140],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=N,e.$fd=u;class v{constructor(d,n,s){this.owner=d,this.debugNameSource=n,this.referenceFn=s}getDebugName(d){return N(d,this)}}e.$dd=v;const I=new Map,C=new WeakMap;function N(E,d){const n=C.get(E);if(n)return n;const s=A(E,d);if(s){let o=I.get(s)??0;o++,I.set(s,o);const h=o===1?s:`${s}#${o}`;return C.set(E,h),h}}function A(E,d){const n=C.get(E);if(n)return n;const s=d.owner?R(d.owner)+".":"";let o;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(o=h(),o!==void 0)return s+o}else return s+h;const i=d.referenceFn;if(i!==void 0&&(o=u(i),o!==void 0))return s+o;if(d.owner!==void 0){const r=T(d.owner,E);if(r!==void 0)return s+r}}function T(E,d){for(const n in E)if(E[n]===d)return n}const p=new Map,a=new WeakMap;function R(E){const d=a.get(E);if(d)return d;const n=y(E);let s=p.get(n)??0;s++,p.set(n,s);const o=s===1?n:`${n}#${s}`;return a.set(E,o),o}function y(E){const d=E.constructor;return d?d.name:"Object"}function u(E){const d=E.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(Ie[141],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=I,e.$Nd=C;let v;function I(n){v=n}function C(){return v}class N{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(E("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),a(R(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(R(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(R(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([p("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleDerivedRecomputed(s,o){const h=this.d.get(s);console.log(...this.b([p("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(h),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([p("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([p("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([p("transaction"),a(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=N;function A(n){const s=new Array,o=[];let h="";function i(t){if("length"in t)for(const c of t)c&&i(c);else"text"in t?(h+=`%c${t.text}`,s.push(t.style),t.data&&o.push(...t.data)):"data"in t&&o.push(...t.data)}i(n);const r=[h,...s];return r.push(...o),r}function T(n){return a(n,{color:"black"})}function p(n){return a(d(`${n}: `,10),{color:"black",bold:!0})}function a(n,s={color:"black"}){function o(i){return Object.entries(i).reduce((r,[t,c])=>`${r}${t}:${c};`,"")}const h={color:s.color};return s.strikeThrough&&(h["text-decoration"]="line-through"),s.bold&&(h["font-weight"]="bold"),{text:n,style:o(h)}}function R(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,s):u(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,s){let o="[ ",h=!0;for(const i of n){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${R(i,s-o.length)}`}return o+=" ]",o}function u(n,s){let o="{ ",h=!0;for(const[i,r]of Object.entries(n)){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${i}: ${R(r,s-o.length)}`}return o+=" }",o}function E(n,s){let o="";for(let h=1;h<=s;h++)o+=n;return o}function d(n,s){for(;n.length<s;)n+=" ";return n}}),define(Ie[142],Pe([1,0,135,140,141]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=A,e.$Yd=p,e.$Zd=R,e.$3d=E,e.$4d=n,e.$5d=s,e.$6d=o,e.$8d=i,e.$0d=t;let N;function A(l){N=l}let T;function p(l){T=l}let a;function R(l){a=l}class y{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,m){const $=m===void 0?void 0:g,D=m===void 0?g:m;return a({owner:$,debugName:()=>{const S=(0,I.$fd)(D);if(S!==void 0)return S;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(D.toString());if(k)return`${this.debugName}.${k[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:D},S=>D(this.read(S),S))}recomputeInitiallyAndOnChange(g,m){return g.add(N(this,m)),this}keepObserved(g){return g.add(T(this)),this}get a(){return this.get()}}e.$1d=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(g){const m=this.b.size;this.b.add(g),m===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=u;function E(l,g){const m=new h(l,g);try{l(m)}finally{m.finish()}}let d;function n(l){if(d)l(d);else{const g=new h(l,void 0);d=g;try{l(g)}finally{g.finish(),d=void 0}}}async function s(l,g){const m=new h(l,g);try{await l(m)}finally{m.finish()}}function o(l,g,m){l?g(l):E(g,m)}class h{constructor(g,m){this._fn=g,this.b=m,this.a=[],(0,C.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,I.$fd)(this._fn)}updateObserver(g,m){this.a.push({observer:g,observable:m}),g.beginUpdate(m)}finish(){const g=this.a;for(let m=0;m<g.length;m++){const{observer:$,observable:D}=g[m];$.endUpdate(D)}this.a=null,(0,C.$Nd)()?.handleEndTransaction()}}e.$7d=h;function i(l,g){let m;return typeof l=="string"?m=new I.$dd(void 0,l,void 0):m=new I.$dd(l,void 0,void 0),new r(m,g,v.$9c)}class r extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,m,$){super(),this.e=g,this.g=$,this.d=m}get(){return this.d}set(g,m,$){if($===void 0&&this.g(this.d,g))return;let D;m||(m=D=new h(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(g),(0,C.$Nd)()?.handleObservableChanged(this,{oldValue:S,newValue:g,change:$,didChange:!0,hadValue:!0});for(const b of this.b)m.updateObserver(b,this),b.handleChange(this,$)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$9d=r;function t(l,g){let m;return typeof l=="string"?m=new I.$dd(void 0,l,void 0):m=new I.$dd(l,void 0,void 0),new c(m,g,v.$9c)}class c extends r{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$$d=c}),function(){function ae(C){const N=[];typeof C=="number"&&N.push("code/timeOrigin",C);function A(p){N.push(p,Date.now())}function T(){const p=[];for(let a=0;a<N.length;a+=2)p.push({name:N[a],startTime:N[a+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(C+A.startTime)});return N}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=v(I))}(),define(Ie[143],Pe([1,0,40]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const I=Symbol("unset");class C{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}insert(p,a,R){this.d(p,y=>y._value=a,R)}mutate(p,a){this.d(p,R=>R._value=a(R._value===I?void 0:R._value))}mutatePath(p,a){this.d(p,()=>{},R=>a(R))}delete(p){const a=this.c(p);if(!a)return;let R=a.length-1;const y=a[R].node._value;if(y!==I){for(this.b--,a[R].node._value=I;R>0;R--){const{node:u,part:E}=a[R];if(u.children?.size||u._value!==I)break;a[R-1].node.children.delete(E)}return y}}*deleteRecursive(p){const a=this.c(p);if(!a)return;const R=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const u=a[y-1];if(u.node.children.delete(a[y].part),u.node.children.size>0||u.node._value!==I)break}for(const y of N(R))y._value!==I&&(this.b--,yield y._value)}find(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return;a=y}return a._value===I?void 0:a._value}hasKeyOrParent(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;if(y._value!==I)return!0;a=y}return!1}hasKeyOrChildren(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return!0}hasKey(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return a._value!==I}c(p){const a=[{part:"",node:this.a}];let R=0;for(const y of p){const u=a[R].node.children?.get(y);if(!u)return;a.push({part:y,node:u}),R++}return a}d(p,a,R){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const n=new A;y.children.set(d,n),y=n}else{const n=new A;y.children=new Map([[d,n]]),y=n}R?.(y)}const u=y._value===I?0:1;a(y);const E=y._value===I?0:1;this.b+=E-u}*values(){for(const{_value:p}of N(this.a))p!==I&&(yield p)}}e.$SI=C;function*N(T){const p=[T];for(;p.length>0;){const a=p.pop();if(yield a,a.children)for(const R of a.children.values())p.push(R)}}class A{constructor(){this._value=I}get value(){return this._value===I?void 0:this._value}set value(p){this._value=p===void 0?I:p}}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var I in v)(typeof exports=="object"?exports:ae)[I]=v[I]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function v(I){if(e[I])return e[I].exports;var C=e[I]={i:I,l:!1,exports:{}};return ae[I].call(C.exports,C,C.exports,v),C.l=!0,C.exports}return v.m=ae,v.c=e,v.d=function(I,C,N){v.o(I,C)||Object.defineProperty(I,C,{enumerable:!0,get:N})},v.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},v.t=function(I,C){if(1&C&&(I=v(I)),8&C||4&C&&typeof I=="object"&&I&&I.__esModule)return I;var N=Object.create(null);if(v.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:I}),2&C&&typeof I!="string")for(var A in I)v.d(N,A,function(T){return I[T]}.bind(null,A));return N},v.n=function(I){var C=I&&I.__esModule?function(){return I.default}:function(){return I};return v.d(C,"a",C),C},v.o=function(I,C){return Object.prototype.hasOwnProperty.call(I,C)},v.p="",v(v.s=0)}([function(ae,e,v){(function(I){var C;e=ae.exports=Ce,C=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],a=0,R=a++;p[R]="0|[1-9]\\d*";var y=a++;p[y]="[0-9]+";var u=a++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=a++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var d=a++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var n=a++;p[n]="(?:"+p[R]+"|"+p[u]+")";var s=a++;p[s]="(?:"+p[y]+"|"+p[u]+")";var o=a++;p[o]="(?:-("+p[n]+"(?:\\."+p[n]+")*))";var h=a++;p[h]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=a++;p[i]="[0-9A-Za-z-]+";var r=a++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=a++,c="v?"+p[E]+p[o]+"?"+p[r]+"?";p[t]="^"+c+"$";var l="[v=\\s]*"+p[d]+p[h]+"?"+p[r]+"?",g=a++;p[g]="^"+l+"$";var m=a++;p[m]="((?:<|>)?=?)";var $=a++;p[$]=p[y]+"|x|X|\\*";var D=a++;p[D]=p[R]+"|x|X|\\*";var S=a++;p[S]="[v=\\s]*("+p[D]+")(?:\\.("+p[D]+")(?:\\.("+p[D]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var b=a++;p[b]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[r]+"?)?)?";var k=a++;p[k]="^"+p[m]+"\\s*"+p[S]+"$";var P=a++;p[P]="^"+p[m]+"\\s*"+p[b]+"$";var f=a++;p[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=a++;p[w]="(?:~>?)";var F=a++;p[F]="(\\s*)"+p[w]+"\\s+",T[F]=new RegExp(p[F],"g");var O=a++;p[O]="^"+p[w]+p[S]+"$";var L=a++;p[L]="^"+p[w]+p[b]+"$";var q=a++;p[q]="(?:\\^)";var W=a++;p[W]="(\\s*)"+p[q]+"\\s+",T[W]=new RegExp(p[W],"g");var M=a++;p[M]="^"+p[q]+p[S]+"$";var Y=a++;p[Y]="^"+p[q]+p[b]+"$";var Z=a++;p[Z]="^"+p[m]+"\\s*("+l+")$|^$";var ge=a++;p[ge]="^"+p[m]+"\\s*("+c+")$|^$";var _=a++;p[_]="(\\s*)"+p[m]+"\\s*("+l+"|"+p[S]+")",T[_]=new RegExp(p[_],"g");var me=a++;p[me]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var se=a++;p[se]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var ce=a++;p[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)C(we,p[we]),T[we]||(T[we]=new RegExp(p[we]));function oe(U,G){if(U instanceof Ce)return U;if(typeof U!="string"||U.length>N||!(G?T[g]:T[t]).test(U))return null;try{return new Ce(U,G)}catch{return null}}function Ce(U,G){if(U instanceof Ce){if(U.loose===G)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Ce))return new Ce(U,G);C("SemVer",U,G),this.loose=G;var H=U.trim().match(G?T[g]:T[t]);if(!H)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=oe,e.valid=function(U,G){var H=oe(U,G);return H?H.version:null},e.clean=function(U,G){var H=oe(U.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(U){return C("SemVer.compare",this.version,this.loose,U),U instanceof Ce||(U=new Ce(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Ce.prototype.compareMain=function(U){return U instanceof Ce||(U=new Ce(U,this.loose)),X(this.major,U.major)||X(this.minor,U.minor)||X(this.patch,U.patch)},Ce.prototype.comparePre=function(U){if(U instanceof Ce||(U=new Ce(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ne=U.prerelease[G];if(C("prerelease compare",G,H,ne),H===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(H===void 0)return-1;if(H!==ne)return X(H,ne)}while(++G)},Ce.prototype.inc=function(U,G){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,G,H,ne){typeof H=="string"&&(ne=H,H=void 0);try{return new Ce(U,H).inc(G,ne).version}catch{return null}},e.diff=function(U,G){if(ue(U,G))return null;var H=oe(U),ne=oe(G);if(H.prerelease.length||ne.prerelease.length){for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ne[fe])return fe},e.compareIdentifiers=X;var Le=/^[0-9]+$/;function X(U,G){var H=Le.test(U),ne=Le.test(G);return H&&ne&&(U=+U,G=+G),H&&!ne?-1:ne&&!H?1:U<G?-1:U>G?1:0}function V(U,G,H){return new Ce(U,H).compare(new Ce(G,H))}function te(U,G,H){return V(U,G,H)>0}function ve(U,G,H){return V(U,G,H)<0}function ue(U,G,H){return V(U,G,H)===0}function be(U,G,H){return V(U,G,H)!==0}function de(U,G,H){return V(U,G,H)>=0}function J(U,G,H){return V(U,G,H)<=0}function x(U,G,H,ne){var fe;switch(G){case"===":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U===H;break;case"!==":typeof U=="object"&&(U=U.version),typeof H=="object"&&(H=H.version),fe=U!==H;break;case"":case"=":case"==":fe=ue(U,H,ne);break;case"!=":fe=be(U,H,ne);break;case">":fe=te(U,H,ne);break;case">=":fe=de(U,H,ne);break;case"<":fe=ve(U,H,ne);break;case"<=":fe=J(U,H,ne);break;default:throw new TypeError("Invalid operator: "+G)}return fe}function pe(U,G){if(U instanceof pe){if(U.loose===G)return U;U=U.value}if(!(this instanceof pe))return new pe(U,G);C("comparator",U,G),this.loose=G,this.parse(U),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(U,G){return X(G,U)},e.major=function(U,G){return new Ce(U,G).major},e.minor=function(U,G){return new Ce(U,G).minor},e.patch=function(U,G){return new Ce(U,G).patch},e.compare=V,e.compareLoose=function(U,G){return V(U,G,!0)},e.rcompare=function(U,G,H){return V(G,U,H)},e.sort=function(U,G){return U.sort(function(H,ne){return e.compare(H,ne,G)})},e.rsort=function(U,G){return U.sort(function(H,ne){return e.rcompare(H,ne,G)})},e.gt=te,e.lt=ve,e.eq=ue,e.neq=be,e.gte=de,e.lte=J,e.cmp=x,e.Comparator=pe;var $e={};function Ne(U,G){if(U instanceof Ne)return U.loose===G?U:new Ne(U.raw,G);if(U instanceof pe)return new Ne(U.value,G);if(!(this instanceof Ne))return new Ne(U,G);if(this.loose=G,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ze(U){return!U||U.toLowerCase()==="x"||U==="*"}function ke(U,G,H,ne,fe,Re,Ue,Ke,_e,tt,nt,et,rt){return((G=ze(H)?"":ze(ne)?">="+H+".0.0":ze(fe)?">="+H+"."+ne+".0":">="+G)+" "+(Ke=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Ke)).trim()}function Ae(U,G){for(var H=0;H<U.length;H++)if(!U[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<U.length;H++)if(C(U[H].semver),U[H].semver!==$e&&U[H].semver.prerelease.length>0){var ne=U[H].semver;if(ne.major===G.major&&ne.minor===G.minor&&ne.patch===G.patch)return!0}return!1}return!0}function Oe(U,G,H){try{G=new Ne(G,H)}catch{return!1}return G.test(U)}function j(U,G,H,ne){var fe,Re,Ue,Ke,_e;switch(U=new Ce(U,ne),G=new Ne(G,ne),H){case">":fe=te,Re=J,Ue=ve,Ke=">",_e=">=";break;case"<":fe=ve,Re=de,Ue=te,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(U,G,ne))return!1;for(var tt=0;tt<G.set.length;++tt){var nt=G.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===$e&&(ft=new pe(">=0.0.0")),et=et||ft,rt=rt||ft,fe(ft.semver,et.semver,ne)?et=ft:Ue(ft.semver,rt.semver,ne)&&(rt=ft)}),et.operator===Ke||et.operator===_e||(!rt.operator||rt.operator===Ke)&&Re(U,rt.semver)||rt.operator===_e&&Ue(U,rt.semver))return!1}return!0}pe.prototype.parse=function(U){var G=this.loose?T[Z]:T[ge],H=U.match(G);if(!H)throw new TypeError("Invalid comparator: "+U);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Ce(H[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(U){return C("Comparator.test",U,this.loose),this.semver===$e||(typeof U=="string"&&(U=new Ce(U,this.loose)),x(U,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(U,G){if(!(U instanceof pe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(U.value,G),Oe(this.value,H,G);if(U.operator==="")return H=new Ne(this.value,G),Oe(U.semver,H,G);var ne=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=x(this.semver,"<",U.semver,G)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),_e=x(this.semver,">",U.semver,G)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ne||fe||Re&&Ue||Ke||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(U){var G=this.loose;U=U.trim(),C("range",U,G);var H=G?T[se]:T[me];U=U.replace(H,ke),C("hyphen replace",U),U=U.replace(T[_],"$1$2$3"),C("comparator trim",U,T[_]),U=(U=(U=U.replace(T[F],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var ne=G?T[Z]:T[ge],fe=U.split(" ").map(function(Re){return function(Ue,Ke){return C("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){C("caret",et,rt);var ft=rt?T[Y]:T[M];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return C("caret",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=st==="0"?">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+".0 <"+(+st+1)+".0.0":pt?(C("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+pt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+pt+" <"+(+st+1)+".0.0"):(C("no pr"),Be=st==="0"?ut==="0"?">="+st+"."+ut+"."+gt+" <"+st+"."+ut+"."+(+gt+1):">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+gt+" <"+(+st+1)+".0.0"),C("caret return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),C("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[L]:T[O];return et.replace(ft,function(ct,st,ut,gt,pt){var Be;return C("tilde",et,ct,st,ut,gt,pt),ze(st)?Be="":ze(ut)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":pt?(C("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=">="+st+"."+ut+"."+gt+pt+" <"+st+"."+(+ut+1)+".0"):Be=">="+st+"."+ut+"."+gt+" <"+st+"."+(+ut+1)+".0",C("tilde return",Be),Be})}(nt,tt)}).join(" ")}(Ue,Ke),C("tildes",Ue),Ue=function(_e,tt){return C("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[P]:T[k];return et.replace(ft,function(ct,st,ut,gt,pt,Be){C("xRange",et,ct,st,ut,gt,pt,Be);var je=ze(ut),ee=je||ze(gt),K=ee||ze(pt);return st==="="&&K&&(st=""),je?ct=st===">"||st==="<"?"<0.0.0":"*":st&&K?(ee&&(gt=0),K&&(pt=0),st===">"?(st=">=",ee?(ut=+ut+1,gt=0,pt=0):K&&(gt=+gt+1,pt=0)):st==="<="&&(st="<",ee?ut=+ut+1:gt=+gt+1),ct=st+ut+"."+gt+"."+pt):ee?ct=">="+ut+".0.0 <"+(+ut+1)+".0.0":K&&(ct=">="+ut+"."+gt+".0 <"+ut+"."+(+gt+1)+".0"),C("xRange return",ct),ct})}(nt,tt)}).join(" ")}(Ue,Ke),C("xrange",Ue),Ue=function(_e,tt){return C("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(Ue,Ke),C("stars",Ue),Ue}(Re,G)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Re){return!!Re.match(ne)})),fe=fe.map(function(Re){return new pe(Re,G)})},Ne.prototype.intersects=function(U,G){if(!(U instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ne){return U.set.some(function(fe){return fe.every(function(Re){return ne.intersects(Re,G)})})})})},e.toComparators=function(U,G){return new Ne(U,G).set.map(function(H){return H.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Ce(U,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],U))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(U,G,H){var ne=null,fe=null;try{var Re=new Ne(G,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ne&&fe.compare(Ue)!==-1||(fe=new Ce(ne=Ue,H)))}),ne},e.minSatisfying=function(U,G,H){var ne=null,fe=null;try{var Re=new Ne(G,H)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ne&&fe.compare(Ue)!==1||(fe=new Ce(ne=Ue,H)))}),ne},e.validRange=function(U,G){try{return new Ne(U,G).range||"*"}catch{return null}},e.ltr=function(U,G,H){return j(U,G,"<",H)},e.gtr=function(U,G,H){return j(U,G,">",H)},e.outside=j,e.prerelease=function(U,G){var H=oe(U,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(U,G,H){return U=new Ne(U,H),G=new Ne(G,H),U.intersects(G)},e.coerce=function(U){if(U instanceof Ce)return U;if(typeof U!="string")return null;var G=U.match(T[f]);return G==null?null:oe((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,v(1))},function(ae,e){var v,I,C=ae.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(v===setTimeout)return setTimeout(s,0);if((v===N||!v)&&setTimeout)return v=setTimeout,setTimeout(s,0);try{return v(s,0)}catch{try{return v.call(null,s,0)}catch{return v.call(this,s,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:N}catch{v=N}try{I=typeof clearTimeout=="function"?clearTimeout:A}catch{I=A}})();var p,a=[],R=!1,y=-1;function u(){R&&p&&(R=!1,p.length?a=p.concat(a):y=-1,a.length&&E())}function E(){if(!R){var s=T(u);R=!0;for(var o=a.length;o;){for(p=a,a=[];++y<o;)p&&p[y].run();y=-1,o=a.length}p=null,R=!1,function(h){if(I===clearTimeout)return clearTimeout(h);if((I===A||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(h);try{I(h)}catch{try{return I.call(null,h)}catch{return I.call(this,h)}}}(s)}}function d(s,o){this.fun=s,this.array=o}function n(){}C.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)o[h-1]=arguments[h];a.push(new d(s,o)),a.length!==1||R||T(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=n,C.addListener=n,C.once=n,C.off=n,C.removeListener=n,C.removeAllListeners=n,C.emit=n,C.prependListener=n,C.prependOnceListener=n,C.listeners=function(s){return[]},C.binding=function(s){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(s){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ie[144],Pe([1,0,6,4]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.ScrollbarVisibility=void 0;var C;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class N{constructor(d,n,s,o,h,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,s=s|0,o=o|0,h=h|0,i=i|0,r=r|0),this.rawScrollLeft=o,this.rawScrollTop=r,n<0&&(n=0),o+n>s&&(o=s-n),o<0&&(o=0),h<0&&(h=0),r+h>i&&(r=i-h),r<0&&(r=0),this.width=n,this.scrollWidth=s,this.scrollLeft=o,this.height=h,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new N(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new N(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const s=this.width!==d.width,o=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:o,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$bt=N;class A extends I.$Xc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$ne),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new N(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const s=this.g.withScrollDimensions(d,n);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let o;n?o=new R(this.h.from,s,this.h.startTime,this.h.duration):o=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=o}else{const s=this.g.withScrollPosition(d);this.h=R.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,n)))}}e.$ct=A;class T{constructor(d,n,s){this.scrollLeft=d,this.scrollTop=n,this.isDone=s}}e.$dt=T;function p(E,d){const n=d-E;return function(s){return E+n*u(s)}}function a(E,d,n){return function(s){return s<n?E(s/n):d((s-n)/(1-n))}}class R{constructor(d,n,s,o){this.from=d,this.to=n,this.duration=o,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,s){if(Math.abs(d-n)>2.5*s){let h,i;return d<n?(h=d+.75*s,i=n-.75*s):(h=d-.75*s,i=n+.75*s),a(p(d,h),p(i,n),.33)}return p(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const s=this.c(n),o=this.d(n);return new T(s,o,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,s){return R.start(d,n,s)}static start(d,n,s){s=s+10;const o=Date.now()-10;return new R(d,n,o,s)}}e.$et=R;function y(E){return Math.pow(E,3)}function u(E){return 1-y(1-E)}}),define(Ie[145],Pe([1,0,14,4]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=C,e.$Be=N,e.$Ce=A,e.$De=T,e.$Ee=a,e.$Fe=R,e.$Ge=y,e.$He=u,e.$Ie=E,e.$Je=d,e.$Ke=n,e.$Le=s,e.$Me=o,e.$Ne=h,e.$Oe=i;function C(r){const t=r;return t?typeof t.read=="function":!1}function N(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(c=>typeof c=="function"):!1}function A(r){const t=r;return t?N(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new p(r,t)}class p{constructor(t,c){this.e=t,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(c=>c(t))}h(t){this.c.error.length===0?(0,v.$3)(t):this.c.error.slice(0).forEach(c=>c(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,c){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(t,c){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const g=l.indexOf(c);g>=0&&l.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const c=[];let l;for(;(l=r.read())!==null;)c.push(l);return t(c)}function R(r,t,c){const l=[];let g;for(;(g=r.read())!==null&&l.length<c;)l.push(g);return g===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof g<"u"){const m=g;return g=void 0,m}return r.read()}}}function y(r,t){return new Promise((c,l)=>{const g=[];u(r,{onData:m=>{t&&g.push(m)},onError:m=>{t?l(m):c(void 0)},onEnd:()=>{c(t?t(g):void 0)}})})}function u(r,t,c){r.on("error",l=>{c?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{c?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{c?.isCancellationRequested||t.onData(l)})}function E(r,t){return new Promise((c,l)=>{const g=new I.$Wc,m=[],$=b=>{if(m.push(b),m.length>t)return g.dispose(),r.pause(),c({stream:r,buffer:m,ended:!1})},D=b=>(g.dispose(),l(b)),S=()=>(g.dispose(),c({stream:r,buffer:m,ended:!0}));g.add((0,I.$Vc)(()=>r.removeListener("error",D))),r.on("error",D),g.add((0,I.$Vc)(()=>r.removeListener("end",S))),r.on("end",S),g.add((0,I.$Vc)(()=>r.removeListener("data",$))),r.on("data",$)})}function d(r,t){const c=T(t);return c.end(r),c}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function o(r,t,c){const l=T(c);return u(r,{onData:g=>l.write(t.data(g)),onError:g=>l.error(t.error?t.error(g):g),onEnd:()=>l.end()}),l}function h(r,t,c){let l=!1;return{read:()=>{const g=t.read();return l?g:(l=!0,g!==null?c([r,g]):r)}}}function i(r,t,c){let l=!1;const g=T(c);return u(t,{onData:m=>l?g.write(m):(l=!0,g.write(c([r,m]))),onError:m=>g.error(m),onEnd:()=>{l||(l=!0,g.write(r)),g.end()}}),g}}),define(Ie[23],Pe([1,0,48,145]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=a,e.$Re=R,e.$Se=y,e.$Te=u,e.$Ue=E,e.$Ve=d,e.$We=n,e.$Xe=s,e.$Ye=o,e.$Ze=h,e.$1e=i,e.$2e=r,e.$3e=t,e.$4e=c,e.$5e=l,e.$6e=g,e.$7e=m,e.$8e=$,e.$9e=D,e.$0e=k,I=Ve(I);const C=typeof Buffer<"u",N=new v.$X(()=>new Uint8Array(256));let A,T;class p{static alloc(f){return C?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&C?new p(Buffer.from(f)):(A||(A=new TextEncoder),new p(A.encode(f)))}static fromByteArray(f){const w=p.alloc(f.length);for(let F=0,O=f.length;F<O;F++)w.buffer[F]=f[F];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let L=0,q=f.length;L<q;L++)w+=f[L].byteLength}const F=p.alloc(w);let O=0;for(let L=0,q=f.length;L<q;L++){const W=f[L];F.set(W,O),O+=W.byteLength}return F}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=p.alloc(this.byteLength);return f.set(this),f}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,w){return new p(this.buffer.subarray(f,w))}set(f,w){if(f instanceof p)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,w){E(this.buffer,f,w)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,w){n(this.buffer,f,w)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,w){o(this.buffer,f,w)}indexOf(f,w=0){return a(this.buffer,f instanceof p?f.buffer:f,w)}}e.$Pe=p;function a(P,f,w=0){const F=f.byteLength,O=P.byteLength;if(F===0)return 0;if(F===1)return P.indexOf(f[0]);if(F>O-w)return-1;const L=N.value;L.fill(f.length);for(let Y=0;Y<f.length;Y++)L[f[Y]]=f.length-Y-1;let q=w+f.length-1,W=q,M=-1;for(;q<O;)if(P[q]===f[W]){if(W===0){M=q;break}q--,W--}else q+=Math.max(f.length-W,L[P[q]]),W=f.length-1;return M}function R(P,f){return P[f+0]<<0>>>0|P[f+1]<<8>>>0}function y(P,f,w){P[w+0]=f&255,f=f>>>8,P[w+1]=f&255}function u(P,f){return P[f]*2**24+P[f+1]*2**16+P[f+2]*2**8+P[f+3]}function E(P,f,w){P[w+3]=f,f=f>>>8,P[w+2]=f,f=f>>>8,P[w+1]=f,f=f>>>8,P[w]=f}function d(P,f){return P[f+0]<<0>>>0|P[f+1]<<8>>>0|P[f+2]<<16>>>0|P[f+3]<<24>>>0}function n(P,f,w){P[w+0]=f&255,f=f>>>8,P[w+1]=f&255,f=f>>>8,P[w+2]=f&255,f=f>>>8,P[w+3]=f&255}function s(P,f){return P[f]}function o(P,f,w){P[w]=f}function h(P){return I.$Ee(P,f=>p.concat(f))}function i(P){return I.$Le(P)}function r(P){return I.$Ge(P,f=>p.concat(f))}async function t(P){return P.ended?p.concat(P.buffer):p.concat([...P.buffer,await r(P.stream)])}function c(P){return I.$Je(P,f=>p.concat(f))}function l(P){return I.$Me(P,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}function g(P){return I.$De(f=>p.concat(f),P)}function m(P,f){return I.$Ne(P,f,w=>p.concat(w))}function $(P,f){return I.$Oe(P,f,w=>p.concat(w))}function D(P){let f=0,w=0,F=0;const O=new Uint8Array(Math.floor(P.length/4*3)),L=W=>{switch(w){case 3:O[F++]=f|W,w=0;break;case 2:O[F++]=f|W>>>2,f=W<<6,w=3;break;case 1:O[F++]=f|W>>>4,f=W<<4,w=2;break;default:f=W<<2,w=1}};for(let W=0;W<P.length;W++){const M=P.charCodeAt(W);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${P[W]}`)}}const q=F;for(;w>0;)L(0);return p.wrap(O).slice(0,q)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:P},f=!0,w=!1){const F=w?b:S;let O="";const L=P.byteLength%3;let q=0;for(;q<P.byteLength-L;q+=3){const W=P[q+0],M=P[q+1],Y=P[q+2];O+=F[W>>>2],O+=F[(W<<4|M>>>4)&63],O+=F[(M<<2|Y>>>6)&63],O+=F[Y&63]}if(L===1){const W=P[q+0];O+=F[W>>>2],O+=F[W<<4&63],f&&(O+="==")}else if(L===2){const W=P[q+0],M=P[q+1];O+=F[W>>>2],O+=F[(W<<4|M>>>4)&63],O+=F[M<<2&63],f&&(O+="=")}return O}}),define(Ie[146],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(Ie[35],Pe([1,0,98]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=C;var I;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(I||(e.ThemeColor=I={}));function C(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const i=T.exec(h.id);if(!i)return p(v.$6j.error);const[,r,t]=i,c=["codicon","codicon-"+r];return t&&c.push("codicon-modifier-"+t.substring(1)),c}A.asClassNameArray=p;function a(h){return p(h).join(" ")}A.asClassName=a;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||I.isThemeColor(h.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,r]=i;return{id:r}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function n(h,i){let r=h.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function s(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}A.getModifier=s;function o(h,i){return h.id===i.id&&h.color?.id===i.color?.id}A.isEqual=o})(N||(e.ThemeIcon=N={}))}),define(Ie[147],Pe([1,0,28,29,138,13]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=A,e.$Jk=p,e.$Kk=a,e.$Lk=u,e.$Mk=S,e.$Nk=b,e.$Ok=O,e.$Pk=L,e.$Qk=q,e.$Rk=W,e.$Sk=te,e.$Uk=de,e.$Vk=pe,e.$Wk=$e,N=Ve(N);function A(...ke){return function(Ae,Oe){for(let j=0,U=ke.length;j<U;j++){const G=ke[j](Ae,Oe);if(G)return G}return null}}e.$Hk=T.bind(void 0,!1),e.$Ik=T.bind(void 0,!0);function T(ke,Ae,Oe){if(!Oe||Oe.length<Ae.length)return null;let j;return ke?j=N.$If(Oe,Ae):j=Oe.indexOf(Ae)===0,j?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function p(ke,Ae){const Oe=Ae.toLowerCase().indexOf(ke.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ke.length}]}function a(ke,Ae){return R(ke.toLowerCase(),Ae.toLowerCase(),0,0)}function R(ke,Ae,Oe,j){if(Oe===ke.length)return[];if(j===Ae.length)return null;if(ke[Oe]===Ae[j]){let U=null;return(U=R(ke,Ae,Oe+1,j+1))?t({start:j,end:j+1},U):null}return R(ke,Ae,Oe,j+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function u(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function E(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function d(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function s(ke){return d(ke)||n.has(ke)}function o(ke,Ae){return ke===Ae||s(ke)&&s(Ae)}const h=new Map;function i(ke){if(h.has(ke))return h.get(ke);let Ae;const Oe=(0,C.$Fk)(ke);return Oe&&(Ae=Oe),h.set(ke,Ae),Ae}function r(ke){return y(ke)||u(ke)||E(ke)}function t(ke,Ae){return Ae.length===0?Ae=[ke]:ke.end===Ae[0].start?Ae[0].start=ke.start:Ae.unshift(ke),Ae}function c(ke,Ae){for(let Oe=Ae;Oe<ke.length;Oe++){const j=ke.charCodeAt(Oe);if(u(j)||E(j)||Oe>0&&!r(ke.charCodeAt(Oe-1)))return Oe}return ke.length}function l(ke,Ae,Oe,j){if(Oe===ke.length)return[];if(j===Ae.length)return null;if(ke[Oe]!==Ae[j].toLowerCase())return null;{let U=null,G=j+1;for(U=l(ke,Ae,Oe+1,j+1);!U&&(G=c(Ae,G))<Ae.length;)U=l(ke,Ae,Oe+1,G),G++;return U===null?null:t({start:j,end:j+1},U)}}function g(ke){let Ae=0,Oe=0,j=0,U=0,G=0;for(let Ue=0;Ue<ke.length;Ue++)G=ke.charCodeAt(Ue),u(G)&&Ae++,y(G)&&Oe++,r(G)&&j++,E(G)&&U++;const H=Ae/ke.length,ne=Oe/ke.length,fe=j/ke.length,Re=U/ke.length;return{upperPercent:H,lowerPercent:ne,alphaPercent:fe,numericPercent:Re}}function m(ke){const{upperPercent:Ae,lowerPercent:Oe}=ke;return Oe===0&&Ae>.6}function $(ke){const{upperPercent:Ae,lowerPercent:Oe,alphaPercent:j,numericPercent:U}=ke;return Oe>.2&&Ae<.8&&j>.6&&U<.2}function D(ke){let Ae=0,Oe=0,j=0,U=0;for(let G=0;G<ke.length;G++)j=ke.charCodeAt(G),u(j)&&Ae++,y(j)&&Oe++,d(j)&&U++;return(Ae===0||Oe===0)&&U===0?ke.length<=30:Ae<=5}function S(ke,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!D(ke))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Oe=g(Ae);if(!$(Oe)){if(!m(Oe))return null;Ae=Ae.toLowerCase()}let j=null,U=0;for(ke=ke.toLowerCase();U<Ae.length&&(j=l(ke,Ae,0,U))===null;)U=c(Ae,U+1);return j}function b(ke,Ae,Oe=!1){if(!Ae||Ae.length===0)return null;let j=null,U=0;for(ke=ke.toLowerCase(),Ae=Ae.toLowerCase();U<Ae.length&&(j=k(ke,Ae,0,U,Oe),j===null);)U=P(Ae,U+1);return j}function k(ke,Ae,Oe,j,U){let G=0;if(Oe===ke.length)return[];if(j===Ae.length)return null;if(!o(ke.charCodeAt(Oe),Ae.charCodeAt(j))){const fe=i(ke.charCodeAt(Oe));if(!fe)return null;for(let Re=0;Re<fe.length;Re++)if(!o(fe[Re],Ae.charCodeAt(j+Re)))return null;G+=fe.length-1}let H=null,ne=j+G+1;if(H=k(ke,Ae,Oe+1,ne,U),!U)for(;!H&&(ne=P(Ae,ne))<Ae.length;)H=k(ke,Ae,Oe+1,ne,U),ne++;if(!H)return null;if(ke.charCodeAt(Oe)!==Ae.charCodeAt(j)){const fe=i(ke.charCodeAt(Oe));if(!fe)return H;for(let Re=0;Re<fe.length;Re++)if(fe[Re]!==Ae.charCodeAt(j+Re))return H}return t({start:j,end:j+G+1},H)}function P(ke,Ae){for(let Oe=Ae;Oe<ke.length;Oe++)if(s(ke.charCodeAt(Oe))||Oe>0&&s(ke.charCodeAt(Oe-1)))return Oe;return ke.length}const f=A(e.$Ik,S,p),w=A(e.$Ik,S,a),F=new I.$Gc(1e4);function O(ke,Ae,Oe=!1){if(typeof ke!="string"||typeof Ae!="string")return null;let j=F.get(ke);j||(j=new RegExp(N.$qf(ke),"i"),F.set(ke,j));const U=j.exec(Ae);return U?[{start:U.index,end:U.index+U[0].length}]:Oe?w(ke,Ae):f(ke,Ae)}function L(ke,Ae){const Oe=de(ke,ke.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?W(Oe):null}function q(ke,Ae,Oe,j,U,G){const H=Math.min(13,ke.length);for(;Oe<H;Oe++){const ne=de(ke,Ae,Oe,j,U,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,G]}function W(ke){if(typeof ke>"u")return[];const Ae=[],Oe=ke[1];for(let j=ke.length-1;j>1;j--){const U=ke[j]+Oe,G=Ae[Ae.length-1];G&&G.end===U?G.end=U+1:Ae.push({start:U,end:U+1})}return Ae}const M=128;function Y(){const ke=[],Ae=[];for(let Oe=0;Oe<=M;Oe++)Ae[Oe]=0;for(let Oe=0;Oe<=M;Oe++)ke.push(Ae.slice(0));return ke}function Z(ke){const Ae=[];for(let Oe=0;Oe<=ke;Oe++)Ae[Oe]=0;return Ae}const ge=Z(2*M),_=Z(2*M),me=Y(),se=Y(),ce=Y(),we=!1;function oe(ke,Ae,Oe,j,U){function G(ne,fe,Re=" "){for(;ne.length<fe;)ne=Re+ne;return ne}let H=` |   |${j.split("").map(ne=>G(ne,3)).join("|")}
`;for(let ne=0;ne<=Oe;ne++)ne===0?H+=" |":H+=`${Ae[ne-1]}|`,H+=ke[ne].slice(0,U+1).map(fe=>G(fe.toString(),3)).join("|")+`
`;return H}function Ce(ke,Ae,Oe,j){ke=ke.substr(Ae),Oe=Oe.substr(j),console.log(oe(se,ke,ke.length,Oe,Oe.length)),console.log(oe(ce,ke,ke.length,Oe,Oe.length)),console.log(oe(me,ke,ke.length,Oe,Oe.length))}function Le(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;const Oe=ke.codePointAt(Ae);switch(Oe){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$1f(Oe)}}function X(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;switch(ke.charCodeAt(Ae)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function V(ke,Ae,Oe){return Ae[ke]!==Oe[ke]}function te(ke,Ae,Oe,j,U,G,H=!1){for(;Ae<Oe&&U<G;)ke[Ae]===j[U]&&(H&&(ge[Ae]=U),Ae+=1),U+=1;return Ae===Oe}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ue;(function(ke){ke.Default=[-100,0];function Ae(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ke.isDefault=Ae})(ue||(e.FuzzyScore=ue={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Oe){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Oe}}e.$Tk=be;function de(ke,Ae,Oe,j,U,G,H=be.default){const ne=ke.length>M?M:ke.length,fe=j.length>M?M:j.length;if(Oe>=ne||G>=fe||ne-Oe>fe-G||!te(Ae,Oe,ne,U,G,fe,!0))return;J(ne,fe,Oe,G,Ae,U);let Re=1,Ue=1,Ke=Oe,_e=G;const tt=[!1];for(Re=1,Ke=Oe;Ke<ne;Re++,Ke++){const ct=ge[Ke],st=_[Ke],ut=Ke+1<ne?_[Ke+1]:fe;for(Ue=ct-G+1,_e=ct;_e<ut;Ue++,_e++){let gt=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(gt=x(ke,Ae,Ke,Oe,j,U,_e,fe,G,me[Re-1][Ue-1]===0,tt));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(pt=!0,Be=gt+se[Re-1][Ue-1]);const je=_e>ct,ee=je?se[Re][Ue-1]+(me[Re][Ue-1]>0?-5:0):0,K=_e>ct+1&&me[Re][Ue-1]>0,Se=K?se[Re][Ue-2]+(me[Re][Ue-2]>0?-5:0):0;if(K&&(!je||Se>=ee)&&(!pt||Se>=Be))se[Re][Ue]=Se,ce[Re][Ue]=ve.LeftLeft,me[Re][Ue]=0;else if(je&&(!pt||ee>=Be))se[Re][Ue]=ee,ce[Re][Ue]=ve.Left,me[Re][Ue]=0;else if(pt)se[Re][Ue]=Be,ce[Re][Ue]=ve.Diag,me[Re][Ue]=me[Re-1][Ue-1]+1;else throw new Error("not possible")}}if(we&&Ce(ke,Oe,j,G),!tt[0]&&!H.firstMatchCanBeWeak)return;Re--,Ue--;const nt=[se[Re][Ue],G];let et=0,rt=0;for(;Re>=1;){let ct=Ue;do{const st=ce[Re][ct];if(st===ve.LeftLeft)ct=ct-2;else if(st===ve.Left)ct=ct-1;else break}while(ct>=1);et>1&&Ae[Oe+Re-1]===U[G+Ue-1]&&!V(ct+G-1,j,U)&&et+1>me[Re][ct]&&(ct=Ue),ct===Ue?et++:et=1,rt||(rt=ct),Re--,Ue=ct-1,nt.push(Ue)}fe-G===ne&&H.boostFullMatch&&(nt[0]+=2);const ft=rt-ne;return nt[0]-=ft,nt}function J(ke,Ae,Oe,j,U,G){let H=ke-1,ne=Ae-1;for(;H>=Oe&&ne>=j;)U[H]===G[ne]&&(_[H]=ne,H--),ne--}function x(ke,Ae,Oe,j,U,G,H,ne,fe,Re,Ue){if(Ae[Oe]!==G[H])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return H===Oe-j?Ke=ke[Oe]===U[H]?7:5:V(H,U,G)&&(H===0||!V(H-1,U,G))?(Ke=ke[Oe]===U[H]?7:5,_e=!0):Le(G,H)&&(H===0||!Le(G,H-1))?Ke=5:(Le(G,H-1)||X(G,H-1))&&(Ke=5,_e=!0),Ke>1&&Oe===j&&(Ue[0]=!0),_e||(_e=V(H,U,G)||Le(G,H-1)||X(G,H-1)),Oe===j?H>fe&&(Ke-=_e?3:5):Re?Ke+=_e?2:0:Ke+=_e?0:1,H+1===ne&&(Ke-=_e?3:5),Ke}function pe(ke,Ae,Oe,j,U,G,H){return Ne(ke,Ae,Oe,j,U,G,!0,H)}function $e(ke,Ae,Oe,j,U,G,H){return Ne(ke,Ae,Oe,j,U,G,!1,H)}function Ne(ke,Ae,Oe,j,U,G,H,ne){let fe=de(ke,Ae,Oe,j,U,G,ne);if(fe&&!H)return fe;if(ke.length>=3){const Re=Math.min(7,ke.length-1);for(let Ue=Oe+1;Ue<Re;Ue++){const Ke=ze(ke,Ue);if(Ke){const _e=de(Ke,Ke.toLowerCase(),Oe,j,U,G,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(ke,Ae){if(Ae+1>=ke.length)return;const Oe=ke[Ae],j=ke[Ae+1];if(Oe!==j)return ke.slice(0,Ae)+j+Oe+ke.slice(Ae+2)}}),define(Ie[99],Pe([1,0,147,13,35]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=p,e.$Yk=R,e.$Zk=u,e.$1k=E,e.$2k=n,e.$3k=s;const N="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(o){return o.replace(T,(h,i)=>i?h:`\\${h}`)}const a=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(a,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(o){return o.indexOf(N)===-1?o:o.replace(y,(h,i,r,t)=>r?h:i||t||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(o){d.lastIndex=0;let h="";const i=[];let r=0;for(;;){const t=d.lastIndex,c=d.exec(o),l=o.substring(t,c?.index);if(l.length>0){h+=l;for(let g=0;g<l.length;g++)i.push(r)}if(!c)break;r+=c[0].length}return{text:h,iconOffsets:i}}function s(o,h,i=!1){const{text:r,iconOffsets:t}=h;if(!t||t.length===0)return(0,v.$Ok)(o,r,i);const c=(0,I.$of)(r," "),l=r.length-c.length,g=(0,v.$Ok)(o,c,i);if(g)for(const m of g){const $=t[m.start+l]+l;m.start+=$,m.end+=$}return g}}),define(Ie[36],Pe([1,0,13]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var I;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(I||(I={})),function(C){const N="error",A="warning",T="warn",p="info",a="ignore";function R(u){return u?v.$Hf(N,u)?C.Error:v.$Hf(A,u)||v.$Hf(T,u)?C.Warning:v.$Hf(p,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function y(u){switch(u){case C.Error:return N;case C.Warning:return A;case C.Info:return p;default:return a}}C.toString=y}(I||(I={})),e.default=I}),define(Ie[59],Pe([1,0,18,28,13]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class N{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return n-s}value(){return this.b[this.c]}}e.$Ii=N;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===I.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,C.$Bf)(d,this.b,0,d.length,this.c,this.d):(0,C.$Df)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=A;class T{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const s=this.b.charCodeAt(n);if(!(s===I.CharCode.Slash||this.f&&s===I.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===I.CharCode.Slash||this.f&&n===I.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,C.$Bf)(d,this.b,0,d.length,this.d,this.e):(0,C.$Df)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=T;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,C.$Cf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,C.$Cf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,C.$Af)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,C.$Af)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Li=a;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class u{static forUris(d=()=>!1,n=()=>!1){return new u(new a(d,n))}static forPaths(d=!1){return new u(new T(void 0,!d))}static forStrings(){return new u(new N)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const s=n.slice(0);(0,v.$Zb)(s);for(const o of s)this.set(o,d)}else{const s=d.slice(0);(0,v.$Zb)(s);for(const o of s)this.set(o[0],o[1])}}set(d,n){const s=this.b.reset(d);let o;this.c||(this.c=new R,this.c.segment=s.value());const h=[];for(o=this.c;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new R,o.left.segment=s.value()),h.push([y.Left,o]),o=o.left;else if(r<0)o.right||(o.right=new R,o.right.segment=s.value()),h.push([y.Right,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new R,o.mid.segment=s.value()),h.push([y.Mid,o]),o=o.mid;else break}const i=o.value;o.value=n,o.key=d;for(let r=h.length-1;r>=0;r--){const t=h[r][1];t.updateHeight();const c=t.balanceFactor();if(c<-1||c>1){const l=h[r][0],g=h[r+1][0];if(l===y.Right&&g===y.Right)h[r][1]=t.rotateLeft();else if(l===y.Left&&g===y.Left)h[r][1]=t.rotateRight();else if(l===y.Right&&g===y.Left)t.right=h[r+1][1]=h[r+1][1].rotateRight(),h[r][1]=t.rotateLeft();else if(l===y.Left&&g===y.Right)t.left=h[r+1][1]=h[r+1][1].rotateLeft(),h[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(h[r-1][0]){case y.Left:h[r-1][1].left=h[r][1];break;case y.Right:h[r-1][1].right=h[r][1];break;case y.Mid:h[r-1][1].mid=h[r][1];break}else this.c=h[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let s=this.c;for(;s;){const o=n.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const s=this.b.reset(d),o=[];let h=this.c;for(;h;){const i=s.cmp(h.segment);if(i>0)o.push([y.Left,h]),h=h.left;else if(i<0)o.push([y.Right,h]),h=h.right;else if(s.hasNext())s.next(),o.push([y.Mid,h]),h=h.mid;else break}if(h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:r,value:t,segment:c}=i;this.e(i.key,!1),h.key=r,h.value=t,h.segment=c}}else{const i=h.left??h.right;if(o.length>0){const[r,t]=o[o.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[i][1]=r.rotateRight()),i>0)switch(o[i-1][0]){case y.Left:o[i-1][1].left=o[i][1];break;case y.Right:o[i-1][1].right=o[i][1];break;case y.Mid:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let s=this.c,o;for(;s;){const h=n.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(n.hasNext())n.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(d){return this.g(d,!1)}g(d,n){const s=this.b.reset(d);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):n?o.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,s]of this)d(s,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const s=n.balanceFactor();return s<-1||s>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Mi=u}),define(Ie[37],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=I;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(C){return v.test(C)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const N=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){C(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let p=0,a="";return a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a+="-",a+=A[N[p++]],a+=A[N[p++]],a+="-",a+=A[N[p++]],a+=A[N[p++]],a+="-",a+=A[N[p++]],a+=A[N[p++]],a+="-",a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a+=A[N[p++]],a}}()}),define(Ie[148],Pe([1,0,18,40,37]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=N,e.$nu=A,e.$pu=a;function N(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,E){const d={id:(0,C.$3g)(),name:y,uri:u,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return I.Iterable.some(this,([d,n])=>n.asFile())&&E.push("files"),R(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const d=this.a.get(u);d?d.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const d of E)yield[u,d]}b(u){return p(u)}}e.$ou=T;function p(y){return y.toLowerCase()}function a(y,u){return R(p(y),u.map(p))}function R(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,n,s]=E;return s==="*"?u.some(o=>o.startsWith(n+"/")):!1}e.$qu=Object.freeze({create:y=>(0,v.$Pb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$qu.split(y).filter(u=>!u.startsWith("#"))})}),define(Ie[149],Pe([1,0,28]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$wu=C;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.Invalid=3]="Invalid",N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function C(N){let A=0,T=0,p=0,a=I.Unknown;for(let R=0,y=N.length;R<y;R++){const u=N.charCodeAt(R);u===v.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&N.charCodeAt(R+1)===v.CharCode.LineFeed?(a|=I.CRLF,R++):a|=I.Invalid,p=R+1):u===v.CharCode.LineFeed&&(a|=I.LF,A===0&&(T=R),A++,p=R+1)}return A===0&&(T=N.length),[A,T,N.length-p,a]}}),define(Ie[150],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0,e.$jt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[151],Pe([1,0,28,152]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.IndentAction=void 0;var C;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class N{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let R=0,y=a.notIn.length;R<y;R++)switch(a.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case I.StandardTokenType.Other:return!0;case I.StandardTokenType.Comment:return this.c;case I.StandardTokenType.String:return this.b;case I.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,R){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(R-2),u=a.getStandardTokenType(y);return this.isOK(u)}g(a,R){for(let y=a;y<=R;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Tu=N;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of a)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Uu=A;function T(p,a,R){p.has(a)?p.get(a).push(R):p.set(a,[R])}}),define(Ie[153],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=C,e.$6C=N,e.$7C=a,e.$8C=R,e.$9C=y,e.$0C=u,e.$$C=E,e.$_C=d;class v{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return C(this.right);let s=this;for(;s.parent!==e.$4C&&s.parent.left!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}prev(){if(this.left!==e.$4C)return N(this.left);let s=this;for(;s.parent!==e.$4C&&s.parent.right!==s;)s=s.parent;return s.parent===e.$4C?e.$4C:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=v;var I;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(I||(e.NodeColor=I={})),e.$4C=new v(null,I.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=I.Black;function C(n){for(;n.left!==e.$4C;)n=n.left;return n}function N(n){for(;n.right!==e.$4C;)n=n.right;return n}function A(n){return n===e.$4C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$4C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function p(){e.$4C.parent=e.$4C}function a(n,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$4C&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$4C?n.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function R(n,s){const o=s.left;s.left=o.right,o.right!==e.$4C&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$4C?n.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function y(n,s){let o,h;if(s.left===e.$4C?(h=s,o=h.right):s.right===e.$4C?(h=s,o=h.left):(h=C(s.right),o=h.right),h===n.root){n.root=o,o.color=I.Black,s.detach(),p(),n.root.parent=e.$4C;return}const i=h.color===I.Red;if(h===h.parent.left?h.parent.left=o:h.parent.right=o,h===s?(o.parent=h.parent,d(n,o)):(h.parent===s?o.parent=h:o.parent=h.parent,d(n,o),h.left=s.left,h.right=s.right,h.parent=s.parent,h.color=s.color,s===n.root?n.root=h:s===s.parent.left?s.parent.left=h:s.parent.right=h,h.left!==e.$4C&&(h.left.parent=h),h.right!==e.$4C&&(h.right.parent=h),h.size_left=s.size_left,h.lf_left=s.lf_left,d(n,h)),s.detach(),o.parent.left===o){const t=A(o),c=T(o);if(t!==o.parent.size_left||c!==o.parent.lf_left){const l=t-o.parent.size_left,g=c-o.parent.lf_left;o.parent.size_left=t,o.parent.lf_left=c,E(n,o.parent,l,g)}}if(d(n,o.parent),i){p();return}let r;for(;o!==n.root&&o.color===I.Black;)o===o.parent.left?(r=o.parent.right,r.color===I.Red&&(r.color=I.Black,o.parent.color=I.Red,a(n,o.parent),r=o.parent.right),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,o=o.parent):(r.right.color===I.Black&&(r.left.color=I.Black,r.color=I.Red,R(n,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=I.Black,r.right.color=I.Black,a(n,o.parent),o=n.root)):(r=o.parent.left,r.color===I.Red&&(r.color=I.Black,o.parent.color=I.Red,R(n,o.parent),r=o.parent.left),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,o=o.parent):(r.left.color===I.Black&&(r.right.color=I.Black,r.color=I.Red,a(n,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=I.Black,r.left.color=I.Black,R(n,o.parent),o=n.root));o.color=I.Black,p()}function u(n,s){for(d(n,s);s!==n.root&&s.parent.color===I.Red;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===I.Red?(s.parent.color=I.Black,o.color=I.Black,s.parent.parent.color=I.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,a(n,s)),s.parent.color=I.Black,s.parent.parent.color=I.Red,R(n,s.parent.parent))}else{const o=s.parent.parent.left;o.color===I.Red?(s.parent.color=I.Black,o.color=I.Black,s.parent.parent.color=I.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,R(n,s)),s.parent.color=I.Black,s.parent.parent.color=I.Red,a(n,s.parent.parent))}n.root.color=I.Black}function E(n,s,o,h){for(;s!==n.root&&s!==e.$4C;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}function d(n,s){let o=0,h=0;if(s!==n.root){for(;s!==n.root&&s===s.parent.right;)s=s.parent;if(s!==n.root)for(s=s.parent,o=A(s.left)-s.size_left,h=T(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=h;s!==n.root&&(o!==0||h!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}}}),define(Ie[100],Pe([1,0,28,101,33,52,153,102]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=y,e.$hD=u;const p=65535;function a(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class R{constructor(i,r,t,c,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=c,this.isBasicASCII=l}}function y(h,i=!0){const r=[0];let t=1;for(let c=0,l=h.length;c<l;c++){const g=h.charCodeAt(c);g===v.CharCode.CarriageReturn?c+1<l&&h.charCodeAt(c+1)===v.CharCode.LineFeed?(r[t++]=c+2,c++):r[t++]=c+1:g===v.CharCode.LineFeed&&(r[t++]=c+1)}return i?a(r):r}function u(h,i){h.length=0,h[0]=0;let r=1,t=0,c=0,l=0,g=!0;for(let $=0,D=i.length;$<D;$++){const S=i.charCodeAt($);S===v.CharCode.CarriageReturn?$+1<D&&i.charCodeAt($+1)===v.CharCode.LineFeed?(l++,h[r++]=$+2,$++):(t++,h[r++]=$+1):S===v.CharCode.LineFeed?(c++,h[r++]=$+1):g&&S!==v.CharCode.Tab&&(S<32||S>126)&&(g=!1)}const m=new R(a(h),t,c,l,g);return h.length=0,m}class E{constructor(i,r,t,c,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=c,this.length=l}}e.$iD=E;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$jD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$4C&&i.iterate(i.root,t=>(t!==A.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let c=0;c<t.length;c++){const l=t[c];if(l.node.parent===null||l.nodeStartOffset>=i){t[c]=null,r=!0;continue}}if(r){const c=[];for(const l of t)l!==null&&c.push(l);this.b=c}}}class o{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$4C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let c=null;for(let l=0,g=i.length;l<g;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=y(i[l].buffer));const m=new E(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),c=this.S(c,m)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=p,t=r-Math.floor(r/3),c=t*2;let l="",g=0;const m=[];if(this.iterate(this.root,$=>{const D=this.R($),S=D.length;if(g<=t||g+S<c)return l+=D,g+=S,!0;const b=l.replace(/\r\n|\r|\n/g,i);return m.push(new d(b,y(b))),l=D,g=S,!0}),g>0){const $=l.replace(/\r\n|\r|\n/g,i);m.push(new d($,y($)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===A.$4C)return!0;const l=this.R(c),g=l.length,m=i.G(r),$=i.G(r+g),D=i.getValueInRange2(m,$);return r+=g,l===D})}getOffsetAt(i,r){let t=0,c=this.root;for(;c!==A.$4C;)if(c.left!==A.$4C&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){t+=c.size_left;const l=this.B(c,i-c.lf_left-2);return t+=l+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,t+=c.size_left+c.piece.length,c=c.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const c=i;for(;r!==A.$4C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const g=this.getOffsetAt(t+1,1),m=c-g;return new I.$Lt(t+1,m+1)}return new I.$Lt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$4C){const l=this.getOffsetAt(t+1,1),g=c-i-l;return new I.$Lt(t+1,g+1)}else r=r.right;return new I.$Lt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,c);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,$=this.a[m.piece.bufferIndex].buffer,D=this.u(m.piece.bufferIndex,m.piece.start);return $.substring(D+i.remainder,D+r.remainder)}let t=i.node;const c=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let g=c.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==A.$4C;){const m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){g+=m.substring($,$+r.remainder);break}else g+=m.substr($,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let r=0,t="",c=!1;return this.iterate(this.root,l=>{if(l===A.$4C)return!0;const g=l.piece;let m=g.length;if(m===0)return!0;const $=this.a[g.bufferIndex].buffer,D=this.a[g.bufferIndex].lineStarts,S=g.start.line,b=g.end.line;let k=D[S]+g.start.column;if(c&&($.charCodeAt(k)===v.CharCode.LineFeed&&(k++,m--),i[r++]=t,t="",c=!1,m===0))return!0;if(S===b)return!this.f&&$.charCodeAt(k+m-1)===v.CharCode.CarriageReturn?(c=!0,t+=$.substr(k,m-1)):t+=$.substr(k,m),!0;t+=this.f?$.substring(k,Math.max(k,D[S+1]-this.e)):$.substring(k,D[S+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=S+1;P<b;P++)t=this.f?$.substring(D[P],D[P+1]-this.e):$.substring(D[P],D[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&$.charCodeAt(D[b]+g.end.column-1)===v.CharCode.CarriageReturn?(c=!0,g.end.column===0?r--:t=$.substr(D[b],g.end.column-1)):t=$.substr(D[b],g.end.column),!0}),c&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$4C)return"";const c=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],c=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=c+r.remainder,g=c+r.node.piece.length;return t.buffer.substring(l,g)}}findMatchesInNode(i,r,t,c,l,g,m,$,D,S,b){const k=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,l),w=this.u(i.piece.bufferIndex,g);let F;const O={line:0,column:0};let L,q;r._wordSeparators?(L=k.buffer.substring(f,w),q=W=>W+f,r.reset(0)):(L=k.buffer,q=W=>W,r.reset(f));do if(F=r.next(L),F){if(q(F.index)>=w)return S;this.s(i,q(F.index)-P,O);const W=this.t(i.piece.bufferIndex,l,O),M=O.line===l.line?O.column-l.column+c:O.column+1,Y=M+F[0].length;if(b[S++]=(0,T.$cD)(new C.$Mt(t+W,M,t+W,Y),F,$),q(F.index)+F[0].length>=w||S>=D)return S}while(F);return S}findMatchesLineByLine(i,r,t,c){const l=[];let g=0;const m=new T.$fD(r.wordSeparators,r.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const D=this.H(i.endLineNumber,i.endColumn);if(D===null)return[];let S=this.s($.node,$.remainder);const b=this.s(D.node,D.remainder);if($.node===D.node)return this.findMatchesInNode($.node,m,i.startLineNumber,i.startColumn,S,b,r,t,c,g,l),l;let k=i.startLineNumber,P=$.node;for(;P!==D.node;){const w=this.t(P.piece.bufferIndex,S,P.piece.end);if(w>=1){const O=this.a[P.piece.bufferIndex].lineStarts,L=this.u(P.piece.bufferIndex,P.piece.start),q=O[S.line+w],W=k===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(P,m,k,W,S,this.s(P,q-L),r,t,c,g,l),g>=c)return l;k+=w}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const O=this.getLineContent(k).substring(F,i.endColumn-1);return g=this.n(r,m,O,i.endLineNumber,F,g,l,t,c),l}if(g=this.n(r,m,this.getLineContent(k).substr(F),k,F,g,l,t,c),g>=c)return l;k++,$=this.H(k,1),P=$.node,S=this.s($.node,$.remainder)}if(k===i.endLineNumber){const w=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(w,i.endColumn-1);return g=this.n(r,m,F,i.endLineNumber,w,g,l,t,c),l}const f=k===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(D.node,m,k,f,S,b,r,t,c,g,l),l}n(i,r,t,c,l,g,m,$,D){const S=i.wordSeparators;if(!$&&i.simpleSearch){const k=i.simpleSearch,P=k.length,f=t.length;let w=-P;for(;(w=t.indexOf(k,w+P))!==-1;)if((!S||(0,T.$eD)(S,t,f,w,P))&&(m[g++]=new N.$bw(new C.$Mt(c,w+1+l,c,w+1+P+l),null),g>=D))return g;return g}let b;r.reset(0);do if(b=r.next(t),b&&(m[g++]=(0,T.$cD)(new C.$Mt(c,b.index+1+l,c,b.index+1+b[0].length+l),b,$),g>=D))return g;while(b);return g}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$4C){const{node:c,remainder:l,nodeStartOffset:g}=this.G(i),m=c.piece,$=m.bufferIndex,D=this.s(c,l);if(c.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&g+m.length===i&&r.length<p){this.F(c,r),this.y();return}if(g===i)this.o(r,c),this.h.validate(i);else if(g+c.piece.length>i){const S=[];let b=new E(m.bufferIndex,D,m.end,this.t(m.bufferIndex,D,m.end),this.u($,m.end)-this.u($,D));if(this.K()&&this.M(r)&&this.I(c,l)===10){const w={line:b.start.line+1,column:0};b=new E(b.bufferIndex,w,b.end,this.t(b.bufferIndex,w,b.end),b.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,l-1)===13){const w=this.s(c,l-1);this.C(c,w),r="\r"+r,c.piece.length===0&&S.push(c)}else this.C(c,D);else this.C(c,D);const k=this.w(r);b.length>0&&this.S(c,b);let P=c;for(let f=0;f<k.length;f++)P=this.S(P,k[f]);this.v(S)}else this.q(r,c)}else{const c=this.w(r);let l=this.T(null,c[0]);for(let g=1;g<c.length;g++)l=this.S(l,c[g])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$4C)return;const t=this.G(i),c=this.G(i+r),l=t.node,g=c.node;if(l===g){const k=this.s(l,t.remainder),P=this.s(l,c.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const f=l.next();(0,A.$9C)(this,l),this.N(f),this.y();return}this.D(l,P),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,k),this.O(l),this.y();return}this.E(l,k,P),this.y();return}const m=[],$=this.s(l,t.remainder);this.C(l,$),this.h.validate(i),l.piece.length===0&&m.push(l);const D=this.s(g,c.remainder);this.D(g,D),g.piece.length===0&&m.push(g);const S=l.next();for(let k=S;k!==A.$4C&&k!==g;k=k.next())m.push(k);const b=l.piece.length===0?l.prev():l;this.v(m),this.O(b),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const g=r.piece,m={line:g.start.line+1,column:0},$=new E(g.bufferIndex,m,g.end,this.t(g.bufferIndex,m,g.end),g.length-1);r.piece=$,i+=`
`,(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const c=this.w(i);let l=this.T(r,c[c.length-1]);for(let g=c.length-2;g>=0;g--)l=this.T(l,c[g]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),c=this.S(r,t[0]);let l=c;for(let g=1;g<t.length;g++)l=this.S(l,t[g]);this.N(c)}s(i,r,t){const c=i.piece,l=i.piece.bufferIndex,g=this.a[l].lineStarts,$=g[c.start.line]+c.start.column+r;let D=c.start.line,S=c.end.line,b=0,k=0,P=0;for(;D<=S&&(b=D+(S-D)/2|0,P=g[b],b!==S);)if(k=g[b+1],$<P)S=b-1;else if($>=k)D=b+1;else break;return t?(t.line=b,t.column=$-P,null):{line:b,column:$-P}}t(i,r,t){if(t.column===0)return t.line-r.line;const c=this.a[i].lineStarts;if(t.line===c.length-1)return t.line-r.line;const l=c[t.line+1],g=c[t.line]+t.column;if(l>g+1)return t.line-r.line;const m=g-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$9C)(this,i[r])}w(i){if(i.length>p){const S=[];for(;i.length>p;){const k=i.charCodeAt(p-1);let P;k===v.CharCode.CarriageReturn||k>=55296&&k<=56319?(P=i.substring(0,p-1),i=i.substring(p-1)):(P=i.substring(0,p),i=i.substring(p));const f=y(P);S.push(new E(this.a.length,{line:0,column:0},{line:f.length-1,column:P.length-f[f.length-1]},f.length-1,P.length)),this.a.push(new d(P,f))}const b=y(i);return S.push(new E(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),S}let r=this.a[0].buffer.length;const t=y(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let S=0;S<t.length;S++)t[S]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let S=0;S<t.length;S++)t[S]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,m=l-this.a[0].lineStarts[g],$={line:g,column:m},D=new E(0,c,$,this.t(0,c,$),l-r);return this.g=$,[D]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,c="";const l=this.h.get2(i);if(l){t=l.node;const g=this.B(t,i-l.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)c=m.substring($+g,$+t.piece.length);else{const D=this.B(t,i-l.nodeStartLineNumber);return m.substring($+g,$+D-r)}}else{let g=0;const m=i;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const $=this.B(t,i-t.lf_left-2),D=this.B(t,i-t.lf_left-1),S=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:m-(i-1-t.lf_left)}),S.substring(b+$,b+D-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const $=this.B(t,i-t.lf_left-2),D=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);c=D.substring(S+$,S+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$4C;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),$=this.u(t.piece.bufferIndex,t.piece.start);return c+=g.substring($,$+m-r),c}else{const m=this.u(t.piece.bufferIndex,t.piece.start);c+=g.substr(m,t.piece.length)}t=t.next()}return c}y(){let i=this.root,r=1,t=0;for(;i!==A.$4C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,c=this.s(i,r),l=c.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const g=this.t(i.piece.bufferIndex,t.start,c);if(g!==l)return{index:g,remainder:0}}return{index:l,remainder:c.column}}B(i,r){if(r<0)return 0;const t=i.piece,c=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?c[t.end.line]+t.end.column-c[t.start.line]-t.start.column:c[l]-c[t.start.line]-t.start.column}C(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),g=r,m=this.u(t.bufferIndex,g),$=this.t(t.bufferIndex,t.start,g),D=$-c,S=m-l,b=t.length+S;i.piece=new E(t.bufferIndex,t.start,g,$,b),(0,A.$$C)(this,i,S,D)}D(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),g=r,m=this.t(t.bufferIndex,g,t.end),$=this.u(t.bufferIndex,g),D=m-c,S=l-$,b=t.length+S;i.piece=new E(t.bufferIndex,g,t.end,m,b),(0,A.$$C)(this,i,S,D)}E(i,r,t){const c=i.piece,l=c.start,g=c.end,m=c.length,$=c.lineFeedCnt,D=r,S=this.t(c.bufferIndex,c.start,D),b=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,l);i.piece=new E(c.bufferIndex,c.start,D,S,b),(0,A.$$C)(this,i,b-m,S-$);const k=new E(c.bufferIndex,t,g,this.t(c.bufferIndex,t,g),this.u(c.bufferIndex,g)-this.u(c.bufferIndex,t)),P=this.S(i,k);this.N(P)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const l=y(r,!1);for(let P=0;P<l.length;P++)l[P]+=c;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const g=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[g],$={line:g,column:m},D=i.piece.length+r.length,S=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,$),k=b-S;i.piece=new E(i.piece.bufferIndex,i.piece.start,$,b,D),this.g=$,(0,A.$$C)(this,i,r.length,k)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let c=0;for(;r!==A.$4C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(l),l}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,c=0;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return c+=t.size_left,{node:t,remainder:Math.min(l+r-1,g),nodeStartOffset:c}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:c};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$4C;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:g}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$4C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,c=r.start.line,l=t[c]+r.start.column;return c===t.length-1||t[c+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$4C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],c=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,l,m,g),(0,A.$$C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const $={line:r.piece.start.line+1,column:0},D=r.piece.length-1,S=this.t(r.piece.bufferIndex,$,r.piece.end);r.piece=new E(r.piece.bufferIndex,$,r.piece.end,S,D),(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.w(`\r
`);this.S(i,b[0]);for(let k=0;k<t.length;k++)(0,A.$9C)(this,t[k])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$9C)(this,t);else{const c=t.piece,l={line:c.start.line+1,column:0},g=c.length-1,m=this.t(c.bufferIndex,l,c.end);t.piece=new E(c.bufferIndex,l,c.end,m,g),(0,A.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$4C)return r(A.$4C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$4C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,c=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(c,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,c)}S(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$4C)i.right=t,t.parent=i;else{const l=(0,A.$5C)(i.right);l.left=t,t.parent=l}return(0,A.$0C)(this,t),t}T(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$4C)i.left=t,t.parent=i;else{const c=(0,A.$6C)(i.left);c.right=t,t.parent=c}return(0,A.$0C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$kD=o}),define(Ie[154],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_=e.$w_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$w_=v;class I{constructor(N){this.identifier=N}}e.$x_=I}),define(Ie[155],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(Ie[156],Pe([1,0,6,4,155]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=R,C=Ve(C);class N extends I.$Xc{constructor(u,E="",d="",n=!0,s){super(),this.j=this.B(new v.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=d,this.z=n,this.D=s}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$lj=N;class A extends I.$Xc{constructor(){super(...arguments),this.f=this.B(new v.$ne),this.onWillRun=this.f.event,this.m=this.B(new v.$ne),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,E)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,E){await u.run(E)}}e.$mj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const d of u)d.length&&(E.length?E=[...E,new T,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=T;class p{get actions(){return this.a}constructor(u,E,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=n,this.a=d}async run(){}}e.$oj=p;class a extends N{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,C.localize(0,null),void 0,!1)}}e.$pj=a;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ie[157],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(Ie[158],Pe([1,0,157]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=a,e.$3m=R,e.$4m=y;const I=60,C=I*60,N=C*24,A=N*7,T=N*30,p=N*365;function a(u,E,d,n){typeof u!="number"&&(u=u.getTime());const s=Math.round((new Date().getTime()-u)/1e3);if(s<-30)return(0,v.localize)(0,null,a(new Date().getTime()+s*1e3,!1));if(!n&&s<30)return(0,v.localize)(1,null);let o;return s<I?(o=s,E?o===1?d?(0,v.localize)(2,null,o):(0,v.localize)(3,null,o):d?(0,v.localize)(4,null,o):(0,v.localize)(5,null,o):o===1?d?(0,v.localize)(6,null,o):(0,v.localize)(7,null,o):d?(0,v.localize)(8,null,o):(0,v.localize)(9,null,o)):s<C?(o=Math.floor(s/I),E?o===1?d?(0,v.localize)(10,null,o):(0,v.localize)(11,null,o):d?(0,v.localize)(12,null,o):(0,v.localize)(13,null,o):o===1?d?(0,v.localize)(14,null,o):(0,v.localize)(15,null,o):d?(0,v.localize)(16,null,o):(0,v.localize)(17,null,o)):s<N?(o=Math.floor(s/C),E?o===1?d?(0,v.localize)(18,null,o):(0,v.localize)(19,null,o):d?(0,v.localize)(20,null,o):(0,v.localize)(21,null,o):o===1?d?(0,v.localize)(22,null,o):(0,v.localize)(23,null,o):d?(0,v.localize)(24,null,o):(0,v.localize)(25,null,o)):s<A?(o=Math.floor(s/N),E?o===1?(0,v.localize)(26,null,o):(0,v.localize)(27,null,o):o===1?(0,v.localize)(28,null,o):(0,v.localize)(29,null,o)):s<T?(o=Math.floor(s/A),E?o===1?d?(0,v.localize)(30,null,o):(0,v.localize)(31,null,o):d?(0,v.localize)(32,null,o):(0,v.localize)(33,null,o):o===1?d?(0,v.localize)(34,null,o):(0,v.localize)(35,null,o):d?(0,v.localize)(36,null,o):(0,v.localize)(37,null,o)):s<p?(o=Math.floor(s/T),E?o===1?d?(0,v.localize)(38,null,o):(0,v.localize)(39,null,o):d?(0,v.localize)(40,null,o):(0,v.localize)(41,null,o):o===1?d?(0,v.localize)(42,null,o):(0,v.localize)(43,null,o):d?(0,v.localize)(44,null,o):(0,v.localize)(45,null,o)):(o=Math.floor(s/p),E?o===1?d?(0,v.localize)(46,null,o):(0,v.localize)(47,null,o):d?(0,v.localize)(48,null,o):(0,v.localize)(49,null,o):o===1?d?(0,v.localize)(50,null,o):(0,v.localize)(51,null,o):d?(0,v.localize)(52,null,o):(0,v.localize)(53,null,o))}function R(u,E){const d=Math.abs(u/1e3);return d<1?E?(0,v.localize)(54,null,u):(0,v.localize)(55,null,u):d<I?E?(0,v.localize)(56,null,Math.round(u)/1e3):(0,v.localize)(57,null,Math.round(u)/1e3):d<C?E?(0,v.localize)(58,null,Math.round(u/(1e3*I))):(0,v.localize)(59,null,Math.round(u/(1e3*I))):d<N?E?(0,v.localize)(60,null,Math.round(u/(1e3*C))):(0,v.localize)(61,null,Math.round(u/(1e3*C))):(0,v.localize)(62,null,Math.round(u/(1e3*N)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ie[159],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(Ie[41],Pe([1,0,18,15,159]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=p,e.$sj=a,e.$tj=R,v=Ve(v),I=Ve(I),C=Ve(C);function N(y,u){return u&&(y.stack||y.stacktrace)?C.localize(0,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(1,null,y.message):y.message||C.localize(2,null)}function p(y=null,u=!1){if(!y)return C.localize(3,null);if(Array.isArray(y)){const E=v.$Kb(y),d=p(E[0],u);return E.length>1?C.localize(4,null,d,E.length):d}if(I.$gg(y))return y;if(y.detail){const E=y.detail;if(E.error)return N(E.error,u);if(E.exception)return N(E.exception,u)}return y.stack?N(y,u):y.message?y.message:C.localize(5,null)}function a(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function R(y,u){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=u,E}}),define(Ie[160],Pe([1,0,48,20]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=T,e.$zr=p,e.$Ar=a,e.$Br=R,e.$Cr=y,e.$Dr=u,e.$Er=E,e.$Fr=d,e.$Gr=n,e.$Hr=s,e.$Ir=$,e.$Jr=D,e.$Kr=S;const C=new v.$X(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),N=new v.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(b,k,P=!1){const f=b||"",w=k||"",F=C.value.collator.compare(f,w);return C.value.collatorIsNumeric&&F===0&&f!==w?f<w?-1:1:F}function p(b,k){const P=N.value.collator;return b=b||"",k=k||"",r(P,b,k)}function a(b,k){const P=N.value.collator;return b=b||"",k=k||"",g(b,k)||r(P,b,k)}function R(b,k){const P=N.value.collator;return b=b||"",k=k||"",l(b,k)||r(P,b,k)}function y(b,k){return b=b||"",k=k||"",b===k?0:b<k?-1:1}function u(b,k){const[P,f]=h(b),[w,F]=h(k);let O=C.value.collator.compare(f,F);if(O===0){if(C.value.collatorIsNumeric&&f!==F)return f<F?-1:1;if(O=C.value.collator.compare(P,w),C.value.collatorIsNumeric&&O===0&&P!==w)return P<w?-1:1}return O}function E(b,k){b=b||"",k=k||"";const P=i(b),f=i(k),w=N.value.collator,F=A.value.collator;return r(F,P,f)||r(w,b,k)}function d(b,k){b=b||"",k=k||"";const P=i(b),f=i(k),w=N.value.collator,F=A.value.collator;return r(F,P,f)||g(b,k)||r(w,b,k)}function n(b,k){b=b||"",k=k||"";const P=i(b),f=i(k),w=N.value.collator,F=A.value.collator;return r(F,P,f)||l(b,k)||r(w,b,k)}function s(b,k){b=b||"",k=k||"";const P=i(b).toLowerCase(),f=i(k).toLowerCase();return P!==f?P<f?-1:1:b!==k?b<k?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function h(b,k=!1){const P=b?o.exec(b):[];let f=[P&&P[1]||"",P&&P[3]||""];return k&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const k=b?o.exec(b):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function r(b,k,P){const f=b.compare(k,P);return f!==0?f:k.length!==P.length?k.length<P.length?-1:1:0}function t(b){const k=b.charAt(0);return k.toLocaleUpperCase()!==k}function c(b){const k=b.charAt(0);return k.toLocaleLowerCase()!==k}function l(b,k){return t(b)&&c(k)?-1:c(b)&&t(k)?1:0}function g(b,k){return c(b)&&t(k)?-1:t(b)&&c(k)?1:0}function m(b,k,P=!1){return P||(b=b&&b.toLowerCase(),k=k&&k.toLowerCase()),b===k?0:b<k?-1:1}function $(b,k,P=!1){const f=b.split(I.sep),w=k.split(I.sep),F=f.length-1,O=w.length-1;let L,q;for(let W=0;;W++){if(L=F===W,q=O===W,L&&q)return T(f[W],w[W],P);if(L)return-1;if(q)return 1;const M=m(f[W],w[W],P);if(M!==0)return M}}function D(b,k,P){const f=b.toLowerCase(),w=k.toLowerCase(),F=S(b,k,P);if(F)return F;const O=f.endsWith(P),L=w.endsWith(P);if(O!==L)return O?-1:1;const q=T(f,w);return q!==0?q:f.localeCompare(w)}function S(b,k,P){const f=b.toLowerCase(),w=k.toLowerCase(),F=f.startsWith(P),O=w.startsWith(P);if(F!==O)return F?-1:1;if(F&&O){if(f.length<w.length)return-1;if(f.length>w.length)return 1}return 0}}),define(Ie[53],Pe([1,0,28,20,21,13,15]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=T,e.$zg=p,e.$Ag=a,e.$Bg=R,e.$Cg=y,e.$Dg=n,e.$Eg=s,e.$Fg=o,e.$Gg=h,e.$Hg=i,e.$Ig=r,e.$Jg=t,e.$Kg=c,e.$Lg=l,e.$Mg=g,e.$Ng=m,e.$Og=S;function T(b){return b===v.CharCode.Slash||b===v.CharCode.Backslash}function p(b){return b.replace(/[\\/]/g,I.$jc.sep)}function a(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function R(b,k=I.$jc.sep){if(!b)return"";const P=b.length,f=b.charCodeAt(0);if(T(f)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let F=3;const O=F;for(;F<P&&!T(b.charCodeAt(F));F++);if(O!==F&&!T(b.charCodeAt(F+1))){for(F+=1;F<P;F++)if(T(b.charCodeAt(F)))return b.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(h(f)&&b.charCodeAt(1)===v.CharCode.Colon)return T(b.charCodeAt(2))?b.slice(0,2)+k:b.slice(0,2);let w=b.indexOf("://");if(w!==-1){for(w+=3;w<P;w++)if(T(b.charCodeAt(w)))return b.slice(0,w+1)}return""}function y(b){if(!C.$i||!b||b.length<5)return!1;let k=b.charCodeAt(0);if(k!==v.CharCode.Backslash||(k=b.charCodeAt(1),k!==v.CharCode.Backslash))return!1;let P=2;const f=P;for(;P<b.length&&(k=b.charCodeAt(P),k!==v.CharCode.Backslash);P++);return!(f===P||(k=b.charCodeAt(P+1),isNaN(k)||k===v.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,k=C.$i){const P=k?u:E;return!(!b||b.length===0||/^\s+$/.test(b)||(P.lastIndex=0,P.test(b))||k&&d.test(b)||b==="."||b===".."||k&&b[b.length-1]==="."||k&&b.length!==b.trim().length||b.length>255)}function s(b,k,P){const f=b===k;return!P||f?f:!b||!k?!1:(0,N.$Hf)(b,k)}function o(b,k,P,f=I.sep){if(b===k)return!0;if(!b||!k||k.length>b.length)return!1;if(P){if(!(0,N.$If)(b,k))return!1;if(k.length===b.length)return!0;let F=k.length;return k.charAt(k.length-1)===f&&F--,b.charAt(F)===f}return k.charAt(k.length-1)!==f&&(k+=f),b.indexOf(k)===0}function h(b){return b>=v.CharCode.A&&b<=v.CharCode.Z||b>=v.CharCode.a&&b<=v.CharCode.z}function i(b,k){return C.$i&&b.endsWith(":")&&(b+=I.sep),(0,I.$lc)(b)||(b=(0,I.$mc)(k,b)),b=(0,I.$kc)(b),r(b)}function r(b){return C.$i?(b=(0,N.$pf)(b,I.sep),b.endsWith(":")&&(b+=I.sep)):(b=(0,N.$pf)(b,I.sep),b||(b=I.sep)),b}function t(b){const k=(0,I.$kc)(b);return C.$i?b.length>3?!1:c(k)&&(b.length===2||k.charCodeAt(2)===v.CharCode.Backslash):k===I.$jc.sep}function c(b,k=C.$i){return k?h(b.charCodeAt(0))&&b.charCodeAt(1)===v.CharCode.Colon:!1}function l(b,k=C.$i){return c(b,k)?b[0]:void 0}function g(b,k,P){return k.length>b.length?-1:b===k?0:(P&&(b=b.toLowerCase(),k=k.toLowerCase()),b.indexOf(k))}function m(b){const k=b.split(":");let P,f,w;for(const F of k){const O=Number(F);(0,A.$kg)(O)?f===void 0?f=O:w===void 0&&(w=O):P=P?[P,F].join(":"):F}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(b,k,P=8){let f="";for(let F=0;F<P;F++){let O;F===0&&C.$i&&!k&&(P===3||P===4)?O=D:O=$,f+=O.charAt(Math.floor(Math.random()*O.length))}let w;return k?w=`${k}-${f}`:w=f,b?(0,I.$mc)(b,w):w}}),define(Ie[73],Pe([1,0,20]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=N,e.$$s=A,e.$_s=T,e.$at=a,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(R){const y=(0,v.$rc)(R),u=I[y.toLowerCase()];return u!==void 0?u:A(R)}function A(R){const y=(0,v.$rc)(R);return C[y.toLowerCase()]}function T(R){for(const y in C)if(C[y]===R)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function a(R,y){const u=p.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:R}}),define(Ie[49],Pe([1,0,23,2,38]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=N,e.$ci=A,e.$di=p;function N(a){return JSON.stringify(a,T)}function A(a){let R=JSON.parse(a);return R=p(R),R}function T(a,R){return R instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(a,R=0){if(!a||R>200)return a;if(typeof a=="object"){switch(a.$mid){case C.MarshalledId.Uri:return I.URI.revive(a);case C.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case C.MarshalledId.Date:return new Date(a.source)}if(a instanceof v.$Pe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=p(a[y],R+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=p(a[y],R+1))}return a}}),define(Ie[16],Pe([1,0,14,21,13,2,20]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=p,e.$Qg=a,e.$Ug=y,v=Ve(v),I=Ve(I),A=Ve(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(d,n){return N.URI.isUri(d)?(0,C.$Hf)(d.scheme,n):(0,C.$If)(d,n+":")}function a(d,...n){return n.some(s=>p(d,s))}e.$Rg="vscode-tkn",e.$Sg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,s){this.f=y(n,s)}getServerRootPath(){return this.f}get g(){return A.$jc.join(this.f,T.vscodeRemoteResource)}set(n,s,o){this.a[n]=s,this.b[n]=o}setConnectionToken(n,s){this.c[n]=s}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$3(t),n}const s=n.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const h=this.b[s],i=this.c[s];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Sg}=${encodeURIComponent(i)}`),N.URI.from({scheme:I.$o?this.d:T.vscodeRemoteResource,authority:`${o}:${h}`,path:this.g,query:r})}}e.$Tg=new R;function y(d,n){return A.$jc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class u{static{this.a=e.$Zg}asBrowserUri(n){const s=this.b(n,ae);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Tg.rewrite(n):n.scheme===T.file&&(I.$m||I.$q===`${T.vscodeFileResource}://${u.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const s=this.b(n,ae);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,s){return N.URI.isUri(n)?n:N.URI.parse(s.toUrl(n))}}e.$1g=new u;var E;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:N.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(s);if(t)return n.get(t)}d.getHeadersFromQuery=o;function h(i,r,t){if(!globalThis.crossOriginIsolated)return;const c=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,c):i[s]=c}d.addSearchParam=h})(E||(e.COI=E={}))}),define(Ie[24],Pe([1,0,28,53,16,20,21,13,2]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=a,e.$qh=y,e.$rh=E,I=Ve(I),N=Ve(N);function a(d){return(0,p.$zc)(d,!0)}class R{constructor(n){this.a=n}compare(n,s,o=!1){return n===s?0:(0,T.$Af)(this.getComparisonKey(n,o),this.getComparisonKey(s,o))}isEqual(n,s,o=!1){return n===s?!0:!n||!s?!1:this.getComparisonKey(n,o)===this.getComparisonKey(s,o)}getComparisonKey(n,s=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,s,o=!1){if(n.scheme===s.scheme){if(n.scheme===C.Schemas.file)return I.$Fg(a(n),a(s),this.a(n))&&n.query===s.query&&(o||n.fragment===s.fragment);if((0,e.$mh)(n.authority,s.authority))return I.$Fg(n.path,s.path,this.a(n),"/")&&n.query===s.query&&(o||n.fragment===s.fragment)}return!1}joinPath(n,...s){return p.URI.joinPath(n,...s)}basenameOrAuthority(n){return(0,e.$eh)(n)||n.authority}basename(n){return N.$jc.basename(n.path)}extname(n){return N.$jc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let s;return n.scheme===C.Schemas.file?s=p.URI.file(N.$pc(a(n))).path:(s=N.$jc.dirname(n.path),n.authority&&s.length&&s.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),s="/")),n.with({path:s})}normalizePath(n){if(!n.path.length)return n;let s;return n.scheme===C.Schemas.file?s=p.URI.file(N.$kc(a(n))).path:s=N.$jc.normalize(n.path),n.with({path:s})}relativePath(n,s){if(n.scheme!==s.scheme||!(0,e.$mh)(n.authority,s.authority))return;if(n.scheme===C.Schemas.file){const i=N.$oc(a(n),a(s));return A.$i?I.$zg(i):i}let o=n.path||"/";const h=s.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(o.length,h.length);i<r&&!(o.charCodeAt(i)!==h.charCodeAt(i)&&o.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);o=h.substr(0,i)+o.substr(i)}return N.$jc.relative(o,h)}resolvePath(n,s){if(n.scheme===C.Schemas.file){const o=p.URI.file(N.$nc(a(n),s));return n.with({authority:o.authority,path:o.path})}return s=I.$Ag(s),n.with({path:N.$jc.resolve(n.path,s)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,s){return n===s||n!==void 0&&s!==void 0&&(0,T.$Hf)(n,s)}hasTrailingPathSeparator(n,s=N.sep){if(n.scheme===C.Schemas.file){const o=a(n);return o.length>I.$Bg(o).length&&o[o.length-1]===s}else{const o=n.path;return o.length>1&&o.charCodeAt(o.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,s=N.sep){return(0,e.$nh)(n,s)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,s=N.sep){let o=!1;if(n.scheme===C.Schemas.file){const h=a(n);o=h!==void 0&&h.length===I.$Bg(h).length&&h[h.length-1]===s}else{s="/";const h=n.path;o=h.length===1&&h.charCodeAt(h.length-1)===v.CharCode.Slash}return!o&&!(0,e.$nh)(n,s)?n.with({path:n.path+"/"}):n}}e.$9g=R,e.$0g=new R(()=>!1),e.$$g=new R(d=>d.scheme===C.Schemas.file?!A.$k:!0),e.$_g=new R(d=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function y(d,n){const s=[];for(let o=0;o<d.length;o++){const h=n(d[o]);d.some((i,r)=>r===o?!1:(0,e.$bh)(h,n(i)))||s.push(d[o])}return s}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,c]=r.split(":");t&&c&&o.set(t,c)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&o.set(d.META_DATA_MIME,i),o}d.parseMetaData=n})(u||(e.DataUri=u={}));function E(d,n,s){if(n){let o=d.path;return o&&o[0]!==N.$jc.sep&&(o=N.$jc.sep+o),d.with({scheme:s,authority:n,path:o})}return d.with({scheme:s})}}),define(Ie[11],Pe([1,0,22,14,6,4,24,21,146,48]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=R,e.$th=y,e.$uh=u,e.$vh=E,e.$wh=d,e.$xh=n,e.$yh=s,e.$zh=o,e.$Hh=D,e.$Ih=S,e.$Jh=b,e.$Kh=k,e.$Lh=P,e.$1h=me,e.$9h=ue;function R(de){return!!de&&typeof de.then=="function"}function y(de){const J=new v.$ye,x=de(J.token),pe=new Promise(($e,Ne)=>{const ze=J.token.onCancellationRequested(()=>{ze.dispose(),Ne(new I.$8)});Promise.resolve(x).then(ke=>{ze.dispose(),J.dispose(),$e(ke)},ke=>{ze.dispose(),J.dispose(),Ne(ke)})});return new class{cancel(){J.cancel(),J.dispose()}then($e,Ne){return pe.then($e,Ne)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function u(de,J,x){return new Promise((pe,$e)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),pe(x)});de.then(pe,$e).finally(()=>Ne.dispose())})}function E(de,J){return new Promise((x,pe)=>{const $e=J.onCancellationRequested(()=>{$e.dispose(),pe(new I.$8)});de.then(x,pe).finally(()=>$e.dispose())})}async function d(de){let J=-1;const x=de.map((pe,$e)=>pe.then(Ne=>(J=$e,Ne)));try{return await Promise.race(x)}finally{de.forEach((pe,$e)=>{$e!==J&&pe.cancel()})}}function n(de,J,x){let pe;const $e=setTimeout(()=>{pe?.(void 0),x?.()},J);return Promise.race([de.finally(()=>clearTimeout($e)),new Promise(Ne=>pe=Ne)])}function s(de){return new Promise((J,x)=>{const pe=de();R(pe)?pe.then(J,x):J(pe)})}function o(){let de,J;return{promise:new Promise((pe,$e)=>{de=pe,J=$e}),resolve:de,reject:J}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(x,x).then(pe)})}return new Promise((x,pe)=>{this.b.then(x,pe)})}return this.a=J(),new Promise((x,pe)=>{this.a.then($e=>{this.a=null,x($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$Ah=h;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Bh=i;class r{constructor(){this.a=new Map}queue(J,x){const $e=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===$e&&this.a.delete(J)});return this.a.set(J,$e),$e}}e.$Ch=r;const t=(de,J)=>{let x=!0;const pe=setTimeout(()=>{x=!1,J()},de);return{isTriggered:()=>x,dispose:()=>{clearTimeout(pe),x=!1}}},c=de=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,de())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class l{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise(($e,Ne)=>{this.d=$e,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=x===p.$ie?c(pe):t(x,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new I.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=l;class g{constructor(J){this.a=new l(J),this.b=new h}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=g;class m{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=m;class $ extends m{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Gh=$;function D(de,J){return J?new Promise((x,pe)=>{const $e=setTimeout(()=>{Ne.dispose(),x()},de),Ne=J.onCancellationRequested(()=>{clearTimeout($e),Ne.dispose(),pe(new I.$8)})}):y(x=>D(de,x))}function S(de,J=0,x){const pe=setTimeout(()=>{de(),x&&$e.dispose()},J),$e=(0,N.$Vc)(()=>{clearTimeout(pe),x?.deleteAndLeak($e)});return x?.add($e),$e}function b(de){const J=[];let x=0;const pe=de.length;function $e(){return x<pe?de[x++]():null}function Ne(ze){ze!=null&&J.push(ze);const ke=$e();return ke?ke.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function k(de,J=pe=>!!pe,x=null){let pe=0;const $e=de.length,Ne=()=>{if(pe>=$e)return Promise.resolve(x);const ze=de[pe++];return Promise.resolve(ze()).then(Ae=>J(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function P(de,J=pe=>!!pe,x=null){if(de.length===0)return Promise.resolve(x);let pe=de.length;const $e=()=>{pe=-1;for(const Ne of de)Ne.cancel?.()};return new Promise((Ne,ze)=>{for(const ke of de)ke.then(Ae=>{--pe>=0&&J(Ae)?($e(),Ne(Ae)):pe===0&&Ne(x)}).catch(Ae=>{--pe>=0&&($e(),ze(Ae))})})}class f{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new C.$ne}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,pe)=>{this.g.push({factory:J,c:x,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=f;class w extends f{constructor(){super(1)}}e.$Nh=w;class F{constructor(){this.a=new se,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Oh=F;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new oe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=A.$0g){const pe=x.getComparisonKey(J);return this.a.get(pe)?.size??0}queueFor(J,x,pe=A.$0g){const $e=pe.getComparisonKey(J);let Ne=this.a.get($e);if(!Ne){Ne=new w;const ze=this.f++,ke=C.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$7c),this.d.set(ze,ke),this.a.set($e,Ne)}return Ne.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=O;class L{constructor(J,x){this.b=!1,this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){if(this.b)throw new I.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){if(this.b)throw new I.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$Qh=L;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,pe=globalThis){if(this.f)throw new I.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{J()},x);this.d=(0,N.$Vc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=q;class W{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=W;class M{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=M;class Y extends W{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Uh=Y;class Z extends N.$Xc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new N.$Yc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(de,J)=>{(0,T.$B)(()=>{if(x)return;const pe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Xh=(de,J,x)=>{const pe=de.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let $e=!1;return{dispose(){$e||($e=!0,de.cancelIdleCallback(pe))}}},e.$Wh=de=>(0,e.$Xh)(globalThis,de)}();class ge{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Xh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ge;class _ extends ge{constructor(J){super(globalThis,J)}}e.$Zh=_;async function me(de,J,x){let pe;for(let $e=0;$e<x;$e++)try{return await de()}catch(Ne){pe=Ne,await D(J)}throw pe}class se{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,pe){return this.a={taskId:J,cancel:()=>pe?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:pe,reject:$e}=o();this.b={run:J,promise:x,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=se;class ce{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$3h=ce;var we;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(we||(we={}));class oe{get isRejected(){return this.d?.outcome===we.Rejected}get isResolved(){return this.d?.outcome===we.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===we.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:we.Resolved,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:we.Rejected,value:J},x()})}cancel(){return this.error(new I.$8)}}e.$4h=oe;var Ce;(function(de){async function J(pe){let $e;const Ne=await Promise.all(pe.map(ze=>ze.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Ne}de.settled=J;function x(pe){return new Promise(async($e,Ne)=>{try{await pe($e,Ne)}catch(ze){Ne(ze)}})}de.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new I.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=Le;class X{constructor(J){this.b=J,this.a=new a.$X(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=X;var V;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(V||(V={}));class te{static fromArray(J){return new te(x=>{x.emitMany(J)})}static fromPromise(J){return new te(async x=>{x.emitMany(await J)})}static fromPromises(J){return new te(async x=>{await Promise.all(J.map(async pe=>x.emitOne(await pe)))})}static merge(J){return new te(async x=>{await Promise.all(J.map(async pe=>{for await(const $e of pe)x.emitOne($e)}))})}static{this.EMPTY=te.fromArray([])}constructor(J,x){this.a=V.Initial,this.b=[],this.d=null,this.f=x,this.g=new C.$ne,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(J(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===V.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===V.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,x){return new te(async pe=>{for await(const $e of J)pe.emitOne(x($e))})}map(J){return te.map(this,J)}static filter(J,x){return new te(async pe=>{for await(const $e of J)x($e)&&pe.emitOne($e)})}filter(J){return te.filter(this,J)}static coalesce(J){return te.filter(J,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(J){const x=[];for await(const pe of J)x.push(pe);return x}toPromise(){return te.toPromise(this)}h(J){this.a===V.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===V.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===V.Initial&&(this.a=V.DoneOK,this.g.fire())}l(J){this.a===V.Initial&&(this.a=V.DoneError,this.d=J,this.g.fire())}}e.$7h=te;class ve extends te{constructor(J,x){super(x),this.m=J}cancel(){this.m.cancel()}}e.$8h=ve;function ue(de){const J=new v.$ye,x=de(J.token);return new ve(J,async pe=>{const $e=J.token.onCancellationRequested(()=>{$e.dispose(),J.dispose(),pe.reject(new I.$8)});try{for await(const Ne of x){if(J.token.isCancellationRequested)return;pe.emitOne(Ne)}$e.dispose(),J.dispose()}catch(Ne){$e.dispose(),J.dispose(),pe.reject(Ne)}})}class be{constructor(J){this.a=new oe,this.b=new te($e=>{if(x){$e.reject(x);return}return pe&&$e.emitMany(pe),this.d=Ne=>$e.reject(Ne),this.f=Ne=>$e.emitOne(Ne),this.a.p},J);let x,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{x||(x=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$0h=be}),define(Ie[42],Pe([1,0,18,11,28,53,29,20,21,13]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=R,e.$yk=n,e.$zk=F,e.$Ak=O,e.$Bk=L,e.$Ck=q,e.$Dk=W,e.$Ek=ge;function R(){return Object.create(null)}e.$wk="**",e.$xk="/";const y="[/\\\\]",u="[^/\\\\]",E=/\//g;function d(_,me){switch(_){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${me?`|${y}${u}+`:""})*?`}}function n(_,me){if(!_)return[];const se=[];let ce=!1,we=!1,oe="";for(const Ce of _){switch(Ce){case me:if(!ce&&!we){se.push(oe),oe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":we=!0;break;case"]":we=!1;break}oe+=Ce}return oe&&se.push(oe),se}function s(_){if(!_)return"";let me="";const se=n(_,e.$xk);if(se.every(ce=>ce===e.$wk))me=".*";else{let ce=!1;se.forEach((we,oe)=>{if(we===e.$wk){if(ce)return;me+=d(2,oe===se.length-1)}else{let Ce=!1,Le="",X=!1,V="";for(const te of we){if(te!=="}"&&Ce){Le+=te;continue}if(X&&(te!=="]"||!V)){let ve;te==="-"?ve=te:(te==="^"||te==="!")&&!V?ve="^":te===e.$xk?ve="":ve=(0,a.$jf)(te),V+=ve;continue}switch(te){case"{":Ce=!0;continue;case"[":X=!0;continue;case"}":{const ue=`(?:${n(Le,",").map(be=>s(be)).join("|")})`;me+=ue,Ce=!1,Le="";break}case"]":{me+="["+V+"]",X=!1,V="";break}case"?":me+=u;continue;case"*":me+=d(1);continue;default:me+=(0,a.$jf)(te)}}oe<se.length-1&&(se[oe+1]!==e.$wk||oe+2<se.length)&&(me+=y)}ce=we===e.$wk})}return me}const o=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new A.$Gc(1e4),g=function(){return!1},m=function(){return null};function $(_,me){if(!_)return m;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ce=`${se}_${!!me.trimForExclusions}`;let we=l.get(ce);if(we)return D(we,_);let oe;return o.test(se)?we=b(se.substr(4),se):(oe=h.exec(S(se,me)))?we=k(oe[1],se):(me.trimForExclusions?r:i).test(se)?we=P(se,me):(oe=t.exec(S(se,me)))?we=f(oe[1].substr(1),se,!0):(oe=c.exec(S(se,me)))?we=f(oe[1],se,!1):we=w(se),l.set(ce,we),D(we,_)}function D(_,me){if(typeof me=="string")return _;const se=function(ce,we){return(0,N.$Fg)(ce,me.base,!p.$k)?_((0,a.$of)(ce.substr(me.base.length),T.sep),we):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function S(_,me){return me.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function b(_,me){return function(se,ce){return typeof se=="string"&&se.endsWith(_)?me:null}}function k(_,me){const se=`/${_}`,ce=`\\${_}`,we=function(Ce,Le){return typeof Ce!="string"?null:Le?Le===_?me:null:Ce===_||Ce.endsWith(se)||Ce.endsWith(ce)?me:null},oe=[_];return we.basenames=oe,we.patterns=[me],we.allBasenames=oe,we}function P(_,me){const se=Z(_.slice(1,-1).split(",").map(Le=>$(Le,me)).filter(Le=>Le!==m),_),ce=se.length;if(!ce)return m;if(ce===1)return se[0];const we=function(Le,X){for(let V=0,te=se.length;V<te;V++)if(se[V](Le,X))return _;return null},oe=se.find(Le=>!!Le.allBasenames);oe&&(we.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,X)=>X.allPaths?Le.concat(X.allPaths):Le,[]);return Ce.length&&(we.allPaths=Ce),we}function f(_,me,se){const ce=T.sep===T.$jc.sep,we=ce?_:_.replace(E,T.sep),oe=T.sep+we,Ce=T.$jc.sep+_;let Le;return se?Le=function(X,V){return typeof X=="string"&&(X===we||X.endsWith(oe)||!ce&&(X===_||X.endsWith(Ce)))?me:null}:Le=function(X,V){return typeof X=="string"&&(X===we||!ce&&X===_)?me:null},Le.allPaths=[(se?"*/":"./")+_],Le}function w(_){try{const me=new RegExp(`^${s(_)}$`);return function(se){return me.lastIndex=0,typeof se=="string"&&me.test(se)?_:null}}catch{return m}}function F(_,me,se){return!_||typeof me!="string"?!1:O(_)(me,void 0,se)}function O(_,me={}){if(!_)return g;if(typeof _=="string"||L(_)){const se=$(_,me);if(se===m)return g;const ce=function(we,oe){return!!se(we,oe)};return se.allBasenames&&(ce.allBasenames=se.allBasenames),se.allPaths&&(ce.allPaths=se.allPaths),ce}return M(_,me)}function L(_){const me=_;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function q(_){return _.allBasenames||[]}function W(_){return _.allPaths||[]}function M(_,me){const se=Z(Object.getOwnPropertyNames(_).map(Le=>Y(Le,_[Le],me)).filter(Le=>Le!==m)),ce=se.length;if(!ce)return m;if(!se.some(Le=>!!Le.requiresSiblings)){if(ce===1)return se[0];const Le=function(te,ve){let ue;for(let be=0,de=se.length;be<de;be++){const J=se[be](te,ve);if(typeof J=="string")return J;(0,I.$sh)(J)&&(ue||(ue=[]),ue.push(J))}return ue?(async()=>{for(const be of ue){const de=await be;if(typeof de=="string")return de}return null})():null},X=se.find(te=>!!te.allBasenames);X&&(Le.allBasenames=X.allBasenames);const V=se.reduce((te,ve)=>ve.allPaths?te.concat(ve.allPaths):te,[]);return V.length&&(Le.allPaths=V),Le}const we=function(Le,X,V){let te,ve;for(let ue=0,be=se.length;ue<be;ue++){const de=se[ue];de.requiresSiblings&&V&&(X||(X=(0,T.$qc)(Le)),te||(te=X.substr(0,X.length-(0,T.$rc)(Le).length)));const J=de(Le,X,te,V);if(typeof J=="string")return J;(0,I.$sh)(J)&&(ve||(ve=[]),ve.push(J))}return ve?(async()=>{for(const ue of ve){const be=await ue;if(typeof be=="string")return be}return null})():null},oe=se.find(Le=>!!Le.allBasenames);oe&&(we.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,X)=>X.allPaths?Le.concat(X.allPaths):Le,[]);return Ce.length&&(we.allPaths=Ce),we}function Y(_,me,se){if(me===!1)return m;const ce=$(_,se);if(ce===m)return m;if(typeof me=="boolean")return ce;if(me){const we=me.when;if(typeof we=="string"){const oe=(Ce,Le,X,V)=>{if(!V||!ce(Ce,Le))return null;const te=we.replace("$(basename)",()=>X),ve=V(te);return(0,I.$sh)(ve)?ve.then(ue=>ue?_:null):ve?_:null};return oe.requiresSiblings=!0,oe}}return ce}function Z(_,me){const se=_.filter(Le=>!!Le.basenames);if(se.length<2)return _;const ce=se.reduce((Le,X)=>{const V=X.basenames;return V?Le.concat(V):Le},[]);let we;if(me){we=[];for(let Le=0,X=ce.length;Le<X;Le++)we.push(me)}else we=se.reduce((Le,X)=>{const V=X.patterns;return V?Le.concat(V):Le},[]);const oe=function(Le,X){if(typeof Le!="string")return null;if(!X){let te;for(te=Le.length;te>0;te--){const ve=Le.charCodeAt(te-1);if(ve===C.CharCode.Slash||ve===C.CharCode.Backslash)break}X=Le.substr(te)}const V=ce.indexOf(X);return V!==-1?we[V]:null};oe.basenames=ce,oe.patterns=we,oe.allBasenames=ce;const Ce=_.filter(Le=>!Le.basenames);return Ce.push(oe),Ce}function ge(_,me){return(0,v.$xb)(_,me,(se,ce)=>typeof se=="string"&&typeof ce=="string"?se===ce:typeof se!="string"&&typeof ce!="string"?se.base===ce.base&&se.pattern===ce.pattern:!1)}}),define(Ie[60],Pe([1,0,14,99,24,13,2]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=a,e.$6k=R,e.$7k=y,e.$8k=u,e.$9k=E,e.$0k=d,e.$$k=n,e.$_k=s;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,v.$0)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,I.$Xk)(h):h).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(h,i){const r=new RegExp((0,N.$jf)(i),"g");return h.replace(r,(t,c)=>h.charAt(c-1)!=="\\"?`\\${t}`:t)}}e.$4k=p;function a(o){return R(o)?!o.value:Array.isArray(o)?o.every(a):!0}function R(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function y(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons&&o.supportHtml===h.supportHtml&&(o.baseUri===h.baseUri||!!o.baseUri&&!!h.baseUri&&(0,C.$ah)(A.URI.from(o.baseUri),A.URI.from(h.baseUri)))}function u(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,h){const i=o.match(/^`+/gm)?.reduce((t,c)=>t.length>c.length?t:c).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${h}`,o,`${"`".repeat(r)}`].join(`
`)}function d(o){return o.replace(/"/g,"&quot;")}function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const h=[],i=o.split("|").map(t=>t.trim());o=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),l=t?t[1]:"",g=c?c[1]:"",m=isFinite(parseInt(g)),$=isFinite(parseInt(l));m&&h.push(`width="${g}"`),$&&h.push(`height="${l}"`)}return{href:o,dimensions:h}}}),define(Ie[103],Pe([1,0,18,53,20,21,24,13]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=p,e.$Xw=R,e.$Yw=u,e.$Zw=E,e.$1w=o,e.$2w=i,e.$3w=r,e.$4w=t,e.$5w=c,e.$6w=l;function p(m,$){const{os:D,tildify:S,relative:b}=$;if(b){const f=a(m,b,D);if(typeof f=="string")return f}let k=m.fsPath;if(D===N.OperatingSystem.Windows&&!N.$i?k=k.replace(/\//g,"\\"):D!==N.OperatingSystem.Windows&&N.$i&&(k=k.replace(/\\/g,"/")),D!==N.OperatingSystem.Windows&&S?.userHome){const f=S.userHome.fsPath;let w;m.scheme!==S.userHome.scheme&&m.path[0]===C.$jc.sep&&m.path[1]!==C.$jc.sep?w=S.userHome.with({path:m.path}).fsPath:w=k,k=u(w,f,D)}return(D===N.OperatingSystem.Windows?C.$ic:C.$jc).normalize(R(k,D===N.OperatingSystem.Windows))}function a(m,$,D){const S=D===N.OperatingSystem.Windows?C.$ic:C.$jc,b=D===N.OperatingSystem.Linux?A.$0g:A.$_g,k=$.getWorkspace(),P=(0,v.$Rb)(k.folders);if(!P)return;m.scheme!==P.uri.scheme&&m.path[0]===C.$jc.sep&&m.path[1]!==C.$jc.sep&&(m=P.uri.with({path:m.path}));const f=$.getWorkspaceFolder(m);if(!f)return;let w;if(b.isEqual(f.uri,m)?w="":w=b.relativePath(f.uri,m)??"",w&&(w=S.normalize(w)),k.folders.length>1&&!$.noPrefix){const F=f.name?f.name:b.basenameOrAuthority(f.uri);w=w?`${F} \u2022 ${w}`:F}return w}function R(m,$=N.$i){return(0,I.$Kg)(m,$)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function u(m,$,D=N.OS){if(D===N.OperatingSystem.Windows||!m||!$)return m;let S=y.original===$?y.normalized:void 0;S||(S=$,N.$i&&(S=(0,I.$zg)(S)),S=`${(0,T.$pf)(S,C.$jc.sep)}${C.$jc.sep}`,y={original:$,normalized:S});let b=m;return N.$i&&(b=(0,I.$zg)(b)),(D===N.OperatingSystem.Linux?b.startsWith(S):(0,T.$If)(b,S))?`~/${b.substr(S.length)}`:m}function E(m,$){return m.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",n="\\\\",s="~";function o(m,$=C.sep){const D=new Array(m.length);let S=!1;for(let b=0;b<m.length;b++){const k=m[b];if(k===""){D[b]=`.${$}`;continue}if(!k){D[b]=k;continue}S=!0;let P="",f=k;f.indexOf(n)===0?(P=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf($)===0?(P=f.substr(0,f.indexOf($)+$.length),f=f.substr(f.indexOf($)+$.length)):f.indexOf(s)===0&&(P=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const w=f.split($);for(let F=1;S&&F<=w.length;F++)for(let O=w.length-F;S&&O>=0;O--){S=!1;let L=w.slice(O,O+F).join($);for(let q=0;!S&&q<m.length;q++)if(q!==b&&m[q]&&m[q].indexOf(L)>-1){const W=O+F===w.length,M=O>0&&m[q].indexOf($)>-1?$+L:L,Y=m[q].endsWith(M);S=!W||Y}if(!S){let q="";(w[0].endsWith(":")||P!=="")&&(O===1&&(O=0,F++,L=w[0]+$+L),O>0&&(q=w[0]+$),q=P+q),O>0&&(q=q+d+$),q=q+L,O+F<w.length&&(q=q+$+d),D[b]=q}}S&&(D[b]=k)}return D}var h;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(m,$=Object.create(null)){const D=[];let S=!1,b="";for(const k of m)if(k==="$"||S&&k==="{")b&&D.push({value:b,type:h.TEXT}),b="",S=!0;else if(k==="}"&&S){const P=$[b];if(typeof P=="string")P.length&&D.push({value:P,type:h.VARIABLE});else if(P){const f=D[D.length-1];(!f||f.type!==h.SEPARATOR)&&D.push({value:P.label,type:h.SEPARATOR})}b="",S=!1}else b+=k;return b&&!S&&D.push({value:b,type:h.TEXT}),D.filter((k,P)=>{if(k.type===h.SEPARATOR){const f=D[P-1],w=D[P+1];return[f,w].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function r(m,$){return N.$j||$?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):m.replace(/&&|&/g,D=>D==="&"?"&&":"&")}function t(m,$){return N.$j||$?m.replace(/\(&&\w\)|&&/g,""):N.$i?m.replace(/&&|&/g,D=>D==="&"?"&&":"&"):m.replace(/&&/g,"_")}function c(m){return m.replace(/&/g,"&&")}function l(m){if(m.endsWith("]")){const $=m.lastIndexOf(" [",m.length-2);if($!==-1){const D=g(m.substring(0,$)),S=m.substring($);return{name:D.name+S,parentPath:D.parentPath}}}return g(m)}function g(m){const $=m.indexOf("/")!==-1?C.$jc:C.$ic,D=$.basename(m),S=$.dirname(m);return D.length?{name:D,parentPath:S}:{name:S,parentPath:""}}}),define(Ie[161],Pe([1,0,23,38,2]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=p,e.$Pn=R,e.$Qn=y;function N(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:N(C.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:N(C.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:C.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Mn=A,e.$Nn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,E,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return E.transformOutgoing(u);for(const n in u)if(Object.hasOwnProperty.call(u,n)){const s=T(u[n],E,d+1);s!==null&&(u[n]=s)}}return null}function p(u,E){const d=T(u,E,0);return d===null?u:d}function a(u,E,d,n){if(!u||n>200)return null;if(typeof u=="object"){if(u.$mid===I.MarshalledId.Uri)return d?C.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof v.$Pe)return null;for(const s in u)if(Object.hasOwnProperty.call(u,s)){const o=a(u[s],E,d,n+1);o!==null&&(u[s]=o)}}return null}function R(u,E){const d=a(u,E,!1,0);return d===null?u:d}function y(u,E){const d=a(u,E,!0,0);return d===null?u:d}}),define(Ie[162],Pe([1,0,11,6,4,49,15]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=p;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var a;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(a||(e.StorageState=a={}));class R extends C.$Xc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new I.$qe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new v.$Eh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,n)=>this.w(n,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===a.Closed)return;let n=!1;(0,A.$pg)(d)?n=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),n=!0),n&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const n=this.f.get(E);return(0,A.$pg)(n)?d:n}getBoolean(E,d){const n=this.get(E);return(0,A.$pg)(n)?d:n==="true"}getNumber(E,d){const n=this.get(E);return(0,A.$pg)(n)?d:parseInt(n,10)}getObject(E,d){const n=this.get(E);return(0,A.$pg)(n)?d:(0,N.$ci)(n)}async set(E,d,n=!1){if(this.c===a.Closed)return;if((0,A.$pg)(d))return this.delete(E,n);const s=(0,A.$ig)(d)||Array.isArray(d)?(0,N.$bi)(d):String(d);if(this.f.get(E)!==s)return this.f.set(E,s),this.j.set(E,s),this.h.delete(E),this.b.fire({key:E,external:n}),this.D()}async delete(E,d=!1){if(!(this.c===a.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===a.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$cq=R;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,n)=>this.a.set(n,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$dq=y}),define(Ie[163],Pe([1,0,13,21,23]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$_t=R,e.$au=y,v=Ve(v),I=Ve(I),C=Ve(C);let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function R(){return a||(a=I.$D()?A():p()),a}function y(d,n,s){const o=new Uint16Array(d.buffer,n,s);return s>0&&(o[0]===65279||o[0]===65534)?u(d,n,s):A().decode(o)}function u(d,n,s){const o=[];let h=0;for(let i=0;i<s;i++){const r=C.$Re(d,n);n+=2,o[h++]=String.fromCharCode(r)}return o.join("")}class E{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const s=this.a-this.d;s<=1&&(s===0||v.$Lf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const s=n.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=n;return}for(let o=0;o<s;o++)this.b[this.d++]=n.charCodeAt(o)}}e.$bu=E}),define(Ie[164],Pe([1,0,23,163]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$du=A,v=Ve(v);function C(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,R,y,u){this.oldPosition=a,this.oldText=R,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,R,y){const u=R.length;v.$Ue(a,u,y),y+=4;for(let E=0;E<u;E++)v.$Se(a,R.charCodeAt(E),y),y+=2;return y}static d(a,R){const y=v.$Te(a,R);return R+=4,(0,I.$au)(a,R,y)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(a,R){return v.$Ue(a,this.oldPosition,R),R+=4,v.$Ue(a,this.newPosition,R),R+=4,R=N.c(a,this.oldText,R),R=N.c(a,this.newText,R),R}static read(a,R,y){const u=v.$Te(a,R);R+=4;const E=v.$Te(a,R);R+=4;const d=N.d(a,R);R+=N.a(d);const n=N.d(a,R);return R+=N.a(n),y.push(new N(u,d,E,n)),R}}e.$cu=N;function A(p,a){return p===null||p.length===0?a:new T(p,a).compress()}class T{constructor(a,R){this.a=a,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,R=0,y=this.n(a),u=this.l(R);for(;a<this.f||R<this.h;){if(y===null){this.k(u),u=this.l(++R);continue}if(u===null){this.m(y),y=this.n(++a);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++R);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++a);continue}if(u.oldPosition<y.newPosition){const[o,h]=T.r(u,y.newPosition-u.oldPosition);this.k(o),u=h;continue}if(y.newPosition<u.oldPosition){const[o,h]=T.q(y,u.oldPosition-y.newPosition);this.m(o),y=h;continue}let n,s;if(u.oldEnd===y.newEnd)n=y,s=u,y=this.n(++a),u=this.l(++R);else if(u.oldEnd<y.newEnd){const[o,h]=T.q(y,u.oldLength);n=o,s=u,y=h,u=this.l(++R)}else{const[o,h]=T.r(u,y.newLength);n=y,s=o,y=this.n(++a),u=h}this.d[this.e++]=new N(n.oldPosition,n.oldText,s.newPosition,s.newText),this.g+=n.newLength-n.oldLength,this.j+=s.newLength-s.oldLength}const E=T.s(this.d);return T.t(E)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,R){return new N(R.oldPosition-a,R.oldText,R.newPosition,R.newText)}static p(a,R){return new N(R.oldPosition,R.oldText,R.newPosition+a,R.newText)}static q(a,R){const y=a.newText.substr(0,R),u=a.newText.substr(R);return[new N(a.oldPosition,a.oldText,a.newPosition,y),new N(a.oldEnd,"",a.newPosition+R,u)]}static r(a,R){const y=a.oldText.substr(0,R),u=a.oldText.substr(R);return[new N(a.oldPosition,y,a.newPosition,a.newText),new N(a.oldPosition+R,u,a.newEnd,"")]}static s(a){if(a.length===0)return a;const R=[];let y=0,u=a[0];for(let E=1;E<a.length;E++){const d=a[E];u.oldEnd===d.oldPosition?u=new N(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(R[y++]=u,u=d)}return R[y++]=u,R}static t(a){if(a.length===0)return a;const R=[];let y=0;for(let u=0;u<a.length;u++){const E=a[u];E.oldText!==E.newText&&(R[y++]=E)}return R}}}),define(Ie[165],Pe([1,0,42,20]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=C,e.$uu=N;function C(A,T,p,a,R,y){if(Array.isArray(A)){let u=0;for(const E of A){const d=C(E,T,p,a,R,y);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return a?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:d,hasAccessToAllModels:n,notebookType:s}=A;if(!a&&!n)return 0;s&&R&&(T=R);let o=0;if(d)if(d===T.scheme)o=10;else if(d==="*")o=5;else return 0;if(u)if(u===p)o=10;else if(u==="*")o=Math.max(o,5);else return 0;if(s)if(s===y)o=10;else if(s==="*"&&y!==void 0)o=Math.max(o,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,I.$kc)(E.base)},h===T.fsPath||(0,v.$zk)(h,T.fsPath))o=10;else return 0}return o}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Ie[166],Pe([1,0,6,13,33,52,100,149,164,4]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,I=Ve(I);class R extends a.$Xc{constructor(u,E,d,n,s,o,h){super(),this.m=this.B(new v.$ne),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=n,this.h=s,this.c=new A.$kD(u,d,h)}equals(u){return!(u instanceof R)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const d=u+E,n=this.getPositionAt(u),s=this.getPositionAt(d);return new C.$Mt(n.lineNumber,n.column,s.lineNumber,s.column)}getValueInRange(u,E=N.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,E=N.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let s=0;const o=this.n(E),h=this.getEOL();if(o.length!==h.length){const i=o.length-h.length,r=u.endLineNumber-u.startLineNumber;s=i*r}return n-d+s}getCharacterCountInRange(u,E=N.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=u.startLineNumber,s=u.endLineNumber;for(let o=n;o<=s;o++){const h=this.getLineContent(o),i=o===n?u.startColumn-1:0,r=o===s?u.endColumn-1:h.length;for(let t=i;t<r;t++)I.$Lf(h.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(E).length*(s-n),d}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=I.$wf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=I.$yf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case N.EndOfLinePreference.LF:return`
`;case N.EndOfLinePreference.CRLF:return`\r
`;case N.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,d){let n=this.g,s=this.h,o=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const D=u[$];h&&D._isTracked&&(h=!1);const S=D.range;if(D.text){let w=!0;o||(w=!I.$Wf(D.text),o=w),!n&&w&&(n=I.$Vf(D.text)),!s&&w&&(s=I.$Yf(D.text))}let b="",k=0,P=0,f=0;if(D.text){let w;[k,P,f,w]=(0,T.$wu)(D.text);const F=this.getEOL(),O=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===O?b=D.text:b=D.text.replace(/\r\n|\r|\n/g,F)}i[$]={sortIndex:$,identifier:D.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:b,eolCount:k,firstLineLength:P,lastLineLength:f,forceMoveMarkers:!!D.forceMoveMarkers,isAutoWhitespaceEdit:D.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let $=0,D=i.length-1;$<D;$++){const S=i[$].range.getEndPosition(),b=i[$+1].range.getStartPosition();if(b.isBeforeOrEqual(S)){if(b.isBefore(S))throw new Error("Overlapping ranges are not allowed!");r=!0}}h&&(i=this.s(i));const t=d||E?R._getInverseEditRanges(i):[],c=[];if(E)for(let $=0;$<i.length;$++){const D=i[$],S=t[$];if(D.isAutoWhitespaceEdit&&D.range.isEmpty())for(let b=S.startLineNumber;b<=S.endLineNumber;b++){let k="";b===S.startLineNumber&&(k=this.getLineContent(D.range.startLineNumber),I.$wf(k)!==-1)||c.push({lineNumber:b,oldContent:k})}}let l=null;if(d){let $=0;l=[];for(let D=0;D<i.length;D++){const S=i[D],b=t[D],k=this.getValueInRange(S.range),P=S.rangeOffset+$;$+=S.text.length-k.length,l[D]={sortIndex:S.sortIndex,identifier:S.identifier,range:b,text:k,textChange:new p.$cu(S.rangeOffset,k,P,S.text)}}r||l.sort((D,S)=>D.sortIndex-S.sortIndex)}this.g=n,this.h=s,this.j=o;const g=this.t(i);let m=null;if(E&&c.length>0){c.sort(($,D)=>D.lineNumber-$.lineNumber),m=[];for(let $=0,D=c.length;$<D;$++){const S=c[$].lineNumber;if($>0&&c[$-1].lineNumber===S)continue;const b=c[$].oldContent,k=this.getLineContent(S);k.length===0||k===b||I.$wf(k)!==-1||m.push(S)}}return this.m.fire(),new N.$fw(l,g,m)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const d=u[0].range,n=u[u.length-1].range,s=new C.$Mt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let o=d.startLineNumber,h=d.startColumn;const i=[];for(let g=0,m=u.length;g<m;g++){const $=u[g],D=$.range;E=E||$.forceMoveMarkers,i.push(this.getValueInRange(new C.$Mt(o,h,D.startLineNumber,D.startColumn))),$.text.length>0&&i.push($.text),o=D.endLineNumber,h=D.endColumn}const r=i.join(""),[t,c,l]=(0,T.$wu)(r);return{sortIndex:0,identifier:u[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,N.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:c,lastLineLength:l,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(R.w);const E=[];for(let d=0;d<u.length;d++){const n=u[d],s=n.range.startLineNumber,o=n.range.startColumn,h=n.range.endLineNumber,i=n.range.endColumn;if(s===h&&o===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new C.$Mt(s,o,h,i);E.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,d,n){return this.c.findMatchesLineByLine(u,E,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const d=u.startLineNumber,n=u.startColumn,[s,o,h]=(0,T.$wu)(E);let i;if(E.length>0){const r=s+1;r===1?i=new C.$Mt(d,n,d,n+o):i=new C.$Mt(d,n,d+r-1,h+1)}else i=new C.$Mt(d,n,d,n);return i}static _getInverseEditRanges(u){const E=[];let d=0,n=0,s=null;for(let o=0,h=u.length;o<h;o++){const i=u[o];let r,t;s?s.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-s.range.endColumn)):(r=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let c;if(i.text.length>0){const l=i.eolCount+1;l===1?c=new C.$Mt(r,t,r,t+i.firstLineLength):c=new C.$Mt(r,t,r+l-1,i.lastLineLength+1)}else c=new C.$Mt(r,t,r,t);d=c.endLineNumber,n=c.endColumn,E.push(c),s=i}return E}static u(u,E){const d=C.$Mt.compareRangesUsingEnds(u.range,E.range);return d===0?u.sortIndex-E.sortIndex:d}static w(u,E){const d=C.$Mt.compareRangesUsingEnds(u.range,E.range);return d===0?E.sortIndex-u.sortIndex:-d}}e.$lD=R}),define(Ie[167],Pe([1,0,28,13,52,100,166]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,I=Ve(I);class T{constructor(R,y,u,E,d,n,s,o,h){this.a=R,this.b=y,this.c=u,this.d=E,this.e=d,this.f=n,this.g=s,this.h=o,this.j=h}k(R){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?R===C.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(R){const y=this.k(R),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,n=u.length;d<n;d++){const s=u[d].buffer.replace(/\r\n|\r|\n/g,y),o=(0,N.$gD)(s);u[d]=new N.$jD(s,o)}const E=new A.$lD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&I.$7f(R)&&(this.b=I.$6f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,N.$hD)(this.e,R);this.a.push(new N.$jD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Vf(R)),this.k||(this.k=I.$Yf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,N.$gD)(R.buffer);R.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$mD=p}),define(Ie[104],Pe([1,0,23,21]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdb=p,e.$Hdb=R,I=Ve(I);var C;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(C||(C={}));function N(y){for(let u=0,E=y.length;u<E;u+=4){const d=y[u+0],n=y[u+1],s=y[u+2],o=y[u+3];y[u+0]=o,y[u+1]=s,y[u+2]=n,y[u+3]=d}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return I.$D()||N(u),v.$Pe.wrap(u)}function T(y){const u=y.buffer;if(I.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(y){const u=new Uint32Array(a(y));let E=0;if(u[E++]=y.id,y.type==="full")u[E++]=C.Full,u[E++]=y.data.length,u.set(y.data,E),E+=y.data.length;else{u[E++]=C.Delta,u[E++]=y.deltas.length;for(const d of y.deltas)u[E++]=d.start,u[E++]=d.deleteCount,d.data?(u[E++]=d.data.length,u.set(d.data,E),E+=d.data.length):u[E++]=0}return A(u)}function a(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const E of y.deltas)E.data&&(u+=E.data.length)}return u}function R(y){const u=T(y);let E=0;const d=u[E++];if(u[E++]===C.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:d,type:"full",data:i}}const s=u[E++],o=[];for(let h=0;h<s;h++){const i=u[E++],r=u[E++],t=u[E++];let c;t>0&&(c=u.subarray(E,E+t),E+=t),o[h]={start:i,deleteCount:r,data:c}}return{id:d,type:"delta",deltas:o}}}),define(Ie[168],Pe([9,10]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(Ie[169],Pe([9,10]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[170],Pe([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[171],Pe([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[172],Pe([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[173],Pe([9,10]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[174],Pe([9,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(Ie[175],Pe([9,10]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(Ie[176],Pe([9,10]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(Ie[177],Pe([9,10]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(Ie[178],Pe([9,10]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[179],Pe([9,10]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ie[180],Pe([9,10]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(Ie[181],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[182],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[183],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ie[184],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ie[185],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[186],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ie[187],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[188],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[189],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[190],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[191],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ie[192],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[193],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/configuration",e)}),define(Ie[194],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(Ie[195],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(Ie[196],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ie[197],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ie[198],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[199],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[200],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[201],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[202],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ie[203],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[204],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ie[205],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[206],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[207],Pe([1,0,28,14,171]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var N;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(N||(e.TokenType=N={}));function A(...R){switch(R.length){case 1:return(0,C.localize)(0,null,R[0]);case 2:return(0,C.localize)(1,null,R[0],R[1]);case 3:return(0,C.localize)(2,null,R[0],R[1],R[2]);default:return}}const T=(0,C.localize)(3,null),p=(0,C.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case N.LParen:return"(";case N.RParen:return")";case N.Neg:return"!";case N.Eq:return y.isTripleEq?"===":"==";case N.NotEq:return y.isTripleEq?"!==":"!=";case N.Lt:return"<";case N.LtEq:return"<=";case N.Gt:return">=";case N.GtEq:return">=";case N.RegexOp:return"=~";case N.RegexStr:return y.lexeme;case N.True:return"true";case N.False:return"false";case N.In:return"in";case N.Not:return"not";case N.And:return"&&";case N.Or:return"||";case N.Str:return y.lexeme;case N.QuotedStr:return y.lexeme;case N.Error:return y.lexeme;case N.EOF:return"EOF";default:throw(0,I.$$)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",N.Not],["in",N.In],["false",N.False],["true",N.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(N.LParen);break;case v.CharCode.CloseParen:this.k(N.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:N.NotEq,offset:this.d,isTripleEq:u})}else this.k(N.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:N.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(N.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?N.LtEq:N.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?N.GtEq:N.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(N.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(N.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(N.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,E=this.c.substring(this.d,this.e),d={type:N.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),E=a.b.get(u);E?this.k(E):this.f.push({type:N.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:N.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const n=this.c.charCodeAt(y);if(u)u=!1;else if(n===v.CharCode.Slash&&!E){y++;break}else n===v.CharCode.OpenSquareBracket?E=!0:n===v.CharCode.Backslash?u=!0:n===v.CharCode.CloseSquareBracket&&(E=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:N.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=a}),define(Ie[105],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ie[74],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class v{constructor(C,N=[],A=!1){this.ctor=C,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$Di=v}),define(Ie[61],Pe([1,0,74]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=N,e.$Qs=A;const I=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function N(T,p,a){p instanceof v.$Di||(p=new v.$Di(p,[],!!a)),I.push([T,p])}function A(){return I}}),define(Ie[208],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class v{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$sr=v;class I{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const T=this.lookupOrInsertNode(N),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let T=this.a.get(A);return T||(T=new v(A,N),this.a.set(A,T)),T}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,T]of this.a)N.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const T=new Set([N]),p=this.c(A,T);if(p)return p}}c(N,A){for(const[T,p]of N.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c(p,A);if(a)return a;A.delete(T)}}}e.$tr=I}),define(Ie[3],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=C,e.$Hi=N;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Fi=C("instantiationService");function I(A,T,p){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:p}):(T[v.DI_DEPENDENCIES]=[{id:A,index:p}],T[v.DI_TARGET]=T)}function C(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function(p,a,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(T,p,R)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function N(A){return A}}),define(Ie[43],Pe([1,0,15,2,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=N,e.$cj=A,e.$dj=p,e.$ej=a,e.$fj=R,e.$gj=y,e.$hj=u,e.$ij=d,e.$jj=n,e.$kj=s,v=Ve(v),e.$aj=(0,C.$Gi)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof I.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof I.URI)}var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(o){switch(o){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function R(o,h){const i=Object.create(null);for(const r in o)y(i,r,o[r],h);return i}function y(o,h,i,r){const t=h.split("."),c=t.pop();let l=o;for(let g=0;g<t.length;g++){const m=t[g];let $=l[m];switch(typeof $){case"undefined":$=l[m]=Object.create(null);break;case"object":if($===null){r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[c]=i}catch{r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(o,h){const i=h.split(".");E(o,i)}function E(o,h){const i=h.shift();if(h.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,h),Object.keys(r).length===0&&delete o[i])}}function d(o,h,i){function r(l,g){let m=l;for(const $ of g){if(typeof m!="object"||m===null)return;m=m[$]}return m}const t=h.split("."),c=r(o,t);return typeof c>"u"?i:c}function n(o,h,i){Object.keys(h).forEach(r=>{r!=="__proto__"&&(r in o?v.$ig(o[r])&&v.$ig(h[r])?n(o[r],h[r],i):i&&(o[r]=h[r]):o[r]=h[r])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Ie[32],Pe([1,0,28,21,13,207,3,170,14]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=R,e.$Fj=g,e.$Gj=m,e.$Zj=oe;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",I.$j),a.set("isLinux",I.$k),a.set("isWindows",I.$i),a.set("isWeb",I.$o),a.set("isMacNative",I.$j&&!I.$o),a.set("isEdge",I.$H),a.set("isFirefox",I.$F),a.set("isChrome",I.$E),a.set("isSafari",I.$G);function R(X,V){if(a.get(X)!==void 0)throw(0,p.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(X,V)}const y=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),n=(0,T.localize)(1,null),s=(0,T.localize)(2,null),o=(0,T.localize)(3,null),h=(0,T.localize)(4,null),i=(0,T.localize)(5,null),r=(0,T.localize)(6,null),t=(0,T.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=E){this.k=V,this.d=new N.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ve=this.D(),ue=ve.type===N.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:ve.offset,lexeme:N.$Bj.getLexeme(ve),additionalInfo:ue}),c.c}return te}catch(te){if(te!==c.c)throw te;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(N.TokenType.Or);){const te=this.o();V.push(te)}return V.length===1?V[0]:l.or(...V)}o(){const V=[this.s()];for(;this.y(N.TokenType.And);){const te=this.s();V.push(te)}return V.length===1?V[0]:l.and(...V)}s(){if(this.y(N.TokenType.Neg)){const V=this.D();switch(V.type){case N.TokenType.True:return this.z(),D.INSTANCE;case N.TokenType.False:return this.z(),S.INSTANCE;case N.TokenType.LParen:{this.z();const te=this.l();return this.A(N.TokenType.RParen,o),te?.negate()}case N.TokenType.Str:return this.z(),F.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case N.TokenType.True:return this.z(),l.true();case N.TokenType.False:return this.z(),l.false();case N.TokenType.LParen:{this.z();const te=this.l();return this.A(N.TokenType.RParen,o),te}case N.TokenType.Str:{const te=V.lexeme;if(this.z(),this.y(N.TokenType.RegexOp)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==N.TokenType.RegexStr)throw this.B("REGEX",ue);const be=ue.lexeme,de=be.lastIndexOf("/"),J=de===be.length-1?void 0:this.w(be.substring(de+1));let x;try{x=new RegExp(be.substring(1,de),J)}catch{throw this.B("REGEX",ue)}return Y.create(te,x)}switch(ue.type){case N.TokenType.RegexStr:case N.TokenType.Error:{const be=[ue.lexeme];this.z();let de=this.D(),J=0;for(let ze=0;ze<ue.lexeme.length;ze++)ue.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ue.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--;for(;!this.E()&&de.type!==N.TokenType.And&&de.type!==N.TokenType.Or;){switch(de.type){case N.TokenType.LParen:J++;break;case N.TokenType.RParen:J--;break;case N.TokenType.RegexStr:case N.TokenType.QuotedStr:for(let ze=0;ze<de.lexeme.length;ze++)de.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ue.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--}if(J<0)break;be.push(N.$Bj.getLexeme(de)),this.z(),de=this.D()}const x=be.join(""),pe=x.lastIndexOf("/"),$e=pe===x.length-1?void 0:this.w(x.substring(pe+1));let Ne;try{Ne=new RegExp(x.substring(1,pe),$e)}catch{throw this.B("REGEX",ue)}return l.regex(te,Ne)}case N.TokenType.QuotedStr:{const be=ue.lexeme;this.z();let de=null;if(!(0,C.$ef)(be)){const J=be.indexOf("/"),x=be.lastIndexOf("/");if(J!==x&&J>=0){const pe=be.slice(J+1,x),$e=be[x+1]==="i"?"i":"";try{de=new RegExp(pe,$e)}catch{throw this.B("REGEX",ue)}}}if(de===null)throw this.B("REGEX",ue);return Y.create(te,de)}default:throw this.B("REGEX",this.D())}}if(this.y(N.TokenType.Not)){this.A(N.TokenType.In,s);const ue=this.u();return l.notIn(te,ue)}switch(this.D().type){case N.TokenType.Eq:{this.z();const ue=this.u();if(this.x().type===N.TokenType.QuotedStr)return l.equals(te,ue);switch(ue){case"true":return l.has(te);case"false":return l.not(te);default:return l.equals(te,ue)}}case N.TokenType.NotEq:{this.z();const ue=this.u();if(this.x().type===N.TokenType.QuotedStr)return l.notEquals(te,ue);switch(ue){case"true":return l.not(te);case"false":return l.has(te);default:return l.notEquals(te,ue)}}case N.TokenType.Lt:return this.z(),W.create(te,this.u());case N.TokenType.LtEq:return this.z(),M.create(te,this.u());case N.TokenType.Gt:return this.z(),L.create(te,this.u());case N.TokenType.GtEq:return this.z(),q.create(te,this.u());case N.TokenType.In:return this.z(),l.in(te,this.u());default:return l.has(te)}}case N.TokenType.EOF:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:t}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case N.TokenType.Str:case N.TokenType.QuotedStr:return this.z(),V.lexeme;case N.TokenType.True:return this.z(),"true";case N.TokenType.False:return this.z(),"false";case N.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,te){if(this.C(V))return this.z();throw this.B(te,this.D())}B(V,te,ve){const ue=(0,T.localize)(8,null,V,N.$Bj.getLexeme(te)),be=te.offset,de=N.$Bj.getLexeme(te);return this.h.push({message:ue,offset:be,lexeme:de,additionalInfo:ve}),c.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===N.TokenType.EOF}}e.$Dj=c;class l{static false(){return D.INSTANCE}static true(){return S.INSTANCE}static has(V){return b.create(V)}static equals(V,te){return k.create(V,te)}static notEquals(V,te){return w.create(V,te)}static regex(V,te){return Y.create(V,te)}static in(V,te){return P.create(V,te)}static notIn(V,te){return f.create(V,te)}static not(V){return F.create(V)}static and(...V){return _.create(V,null,!0)}static or(...V){return me.create(V,null,!0)}static greater(V,te){return L.create(V,te)}static greaterEquals(V,te){return q.create(V,te)}static smaller(V,te){return W.create(V,te)}static smallerEquals(V,te){return M.create(V,te)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ej=l;function g(X){const V=new c({regexParsingWithErrorRecovery:!1});return X.map(te=>(V.parse(te),V.lexingErrors.length>0?V.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(9,null,ve.additionalInfo):(0,T.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function m(X,V){const te=X?X.substituteConstants():void 0,ve=V?V.substituteConstants():void 0;return!te&&!ve?!0:!te||!ve?!1:te.equals(ve)}function $(X,V){return X.cmp(V)}class D{static{this.INSTANCE=new D}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return S.INSTANCE}}e.$Hj=D;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return D.INSTANCE}}e.$Ij=S;class b{static create(V,te=null){const ve=a.get(V);return typeof ve=="boolean"?ve?S.INSTANCE:D.INSTANCE:new b(V,te)}constructor(V,te){this.key=V,this.c=te,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=a.get(this.key);return typeof V=="boolean"?V?S.INSTANCE:D.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Jj=b;class k{static create(V,te,ve=null){if(typeof te=="boolean")return te?b.create(V,ve):F.create(V,ve);const ue=a.get(V);return typeof ue=="boolean"?te===(ue?"true":"false")?S.INSTANCE:D.INSTANCE:new k(V,te,ve)}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?S.INSTANCE:D.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Kj=k;class P{static create(V,te){return new P(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=u.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:we(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.f),ve=V.getValue(this.d);return Array.isArray(te)?te.includes(ve):typeof ve=="string"&&typeof te=="object"&&te!==null?y.call(te,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Lj=P;class f{static create(V,te){return new f(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=u.NotIn,this.c=P.create(V,te)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=f;class w{static create(V,te,ve=null){if(typeof te=="boolean")return te?F.create(V,ve):b.create(V,ve);const ue=a.get(V);return typeof ue=="boolean"?te===(ue?"true":"false")?D.INSTANCE:S.INSTANCE:new w(V,te,ve)}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?D.INSTANCE:S.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Nj=w;class F{static create(V,te=null){const ve=a.get(V);return typeof ve=="boolean"?ve?D.INSTANCE:S.INSTANCE:new F(V,te)}constructor(V,te){this.c=V,this.d=te,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=a.get(this.c);return typeof V=="boolean"?V?D.INSTANCE:S.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Oj=F;function O(X,V){if(typeof X=="string"){const te=parseFloat(X);isNaN(te)||(X=te)}return typeof X=="string"||typeof X=="number"?V(X):D.INSTANCE}class L{static create(V,te,ve=null){return O(te,ue=>new L(V,ue,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Pj=L;class q{static create(V,te,ve=null){return O(te,ue=>new q(V,ue,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Qj=q;class W{static create(V,te,ve=null){return O(te,ue=>new W(V,ue,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Rj=W;class M{static create(V,te,ve=null){return O(te,ue=>new M(V,ue,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:we(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Sj=M;class Y{static create(V,te){return new Y(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=u.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const te=this.f?this.f.source:"",ve=V.f?V.f.source:"";return te<ve?-1:te>ve?1:0}equals(V){if(V.type===this.type){const te=this.f?this.f.source:"",ve=V.f?V.f.source:"";return this.d===V.d&&te===ve}return!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Tj=Y;class Z{static create(V){return new Z(V)}constructor(V){this.c=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new Z(this.c.map(V))}negate(){return this.c}}e.$Uj=Z;function ge(X){let V=null;for(let te=0,ve=X.length;te<ve;te++){const ue=X[te].substituteConstants();if(X[te]!==ue&&V===null){V=[];for(let be=0;be<te;be++)V[be]=X[be]}V!==null&&(V[te]=ue)}return V===null?X:V}class _{static create(V,te,ve){return _.d(V,te,ve)}constructor(V,te){this.expr=V,this.c=te,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ue=$(this.expr[te],V.expr[te]);if(ue!==0)return ue}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=ge(this.expr);return V===this.expr?this:_.create(V,this.c,!1)}evaluate(V){for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].evaluate(V))return!1;return!0}static d(V,te,ve){const ue=[];let be=!1;for(const de of V)if(de){if(de.type===u.True){be=!0;continue}if(de.type===u.False)return D.INSTANCE;if(de.type===u.And){ue.push(...de.expr);continue}ue.push(de)}if(ue.length===0&&be)return S.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort($);for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];for(;ue.length>1;){const de=ue[ue.length-1];if(de.type!==u.Or)break;ue.pop();const J=ue.pop(),x=ue.length===0,pe=me.create(de.expr.map($e=>_.create([$e,J],null,ve)),null,x);pe&&(ue.push(pe),ue.sort($))}if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let J=de+1;J<ue.length;J++)if(ue[de].negate().equals(ue[J]))return D.INSTANCE;if(ue.length===1)return ue[0]}return new _(ue,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new _(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());this.c=me.create(V,this,!0)}return this.c}}e.$Vj=_;class me{static create(V,te,ve){return me.d(V,te,ve)}constructor(V,te){this.expr=V,this.c=te,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ue=$(this.expr[te],V.expr[te]);if(ue!==0)return ue}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=ge(this.expr);return V===this.expr?this:me.create(V,this.c,!1)}evaluate(V){for(let te=0,ve=this.expr.length;te<ve;te++)if(this.expr[te].evaluate(V))return!0;return!1}static d(V,te,ve){let ue=[],be=!1;if(V){for(let de=0,J=V.length;de<J;de++){const x=V[de];if(x){if(x.type===u.False){be=!0;continue}if(x.type===u.True)return S.INSTANCE;if(x.type===u.Or){ue=ue.concat(x.expr);continue}ue.push(x)}}if(ue.length===0&&be)return D.INSTANCE;ue.sort($)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let de=1;de<ue.length;de++)ue[de-1].equals(ue[de])&&(ue.splice(de,1),de--);if(ue.length===1)return ue[0];if(ve){for(let de=0;de<ue.length;de++)for(let J=de+1;J<ue.length;J++)if(ue[de].negate().equals(ue[J]))return S.INSTANCE;if(ue.length===1)return ue[0]}return new me(ue,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new me(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());for(;V.length>1;){const te=V.shift(),ve=V.shift(),ue=[];for(const be of Le(te))for(const de of Le(ve))ue.push(_.create([be,de],null,!1));V.unshift(me.create(ue,null,!1))}this.c=me.create(V,this,!0)}return this.c}}e.$Wj=me;class se extends b{static{this.d=[]}static all(){return se.d.values()}constructor(V,te,ve){super(V,null),this.f=te,typeof ve=="object"?se.d.push({...ve,key:V}):ve!==!0&&se.d.push({key:V,description:ve,type:te!=null?typeof te:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return k.create(this.key,V)}notEqualsTo(V){return w.create(this.key,V)}}e.$Xj=se,e.$Yj=(0,A.$Gi)("contextKeyService");function ce(X,V){return X<V?-1:X>V?1:0}function we(X,V,te,ve){return X<te?-1:X>te?1:V<ve?-1:V>ve?1:0}function oe(X,V){if(X.type===u.False||V.type===u.True)return!0;if(X.type===u.Or)return V.type===u.Or?Ce(X.expr,V.expr):!1;if(V.type===u.Or){for(const te of V.expr)if(oe(X,te))return!0;return!1}if(X.type===u.And){if(V.type===u.And)return Ce(V.expr,X.expr);for(const te of X.expr)if(oe(te,V))return!0;return!1}return X.equals(V)}function Ce(X,V){let te=0,ve=0;for(;te<X.length&&ve<V.length;){const ue=X[te].cmp(V[ve]);if(ue<0)return!1;ue===0&&te++,ve++}return te===X.length}function Le(X){return X.type===u.Or?X.expr:[X]}}),define(Ie[209],Pe([1,0,32,3]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$qt=e.AccessibilitySupport=e.$pt=void 0,e.$rt=N,e.$pt=(0,I.$Gi)("accessibilityService");var C;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$qt=new v.$Xj("accessibilityModeEnabled",!1);function N(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$st="ACCESSIBLE_VIEW_SHOWN_"}),define(Ie[106],Pe([1,0,18,26,21,144,322,150,210,168,209]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=O,e.filterValidationDecorations=Ae,v=Ve(v),I=Ve(I),C=Ve(C),a=Ve(a);var y;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(K,Se,Je,xe){this.id=K,this.name=Se,this.defaultValue=Je,this.schema=xe}applyUpdate(K,Se){return s(K,Se)}compute(K,Se,Je){return Je}}class n{constructor(K,Se){this.newValue=K,this.didChange=Se}}e.ApplyUpdateResult=n;function s(ee,K){if(typeof ee!="object"||typeof K!="object"||!ee||!K)return new n(K,ee!==K);if(Array.isArray(ee)||Array.isArray(K)){const Je=Array.isArray(ee)&&Array.isArray(K)&&v.$xb(ee,K);return new n(K,!Je)}let Se=!1;for(const Je in K)if(K.hasOwnProperty(Je)){const xe=s(ee[Je],K[Je]);xe.didChange&&(ee[Je]=xe.newValue,Se=!0)}return new n(ee,Se)}class o{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,Se){return s(K,Se)}validate(K){return this.defaultValue}}class h{constructor(K,Se,Je,xe){this.id=K,this.name=Se,this.defaultValue=Je,this.schema=xe}applyUpdate(K,Se){return s(K,Se)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,Se,Je){return Je}}function i(ee,K){return typeof ee>"u"?K:ee==="false"?!1:!!ee}class r extends h{constructor(K,Se,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(K,Se,Je,xe)}validate(K){return i(K,this.defaultValue)}}function t(ee,K,Se,Je){if(typeof ee>"u")return K;let xe=parseInt(ee,10);return isNaN(xe)?K:(xe=Math.max(Se,xe),xe=Math.min(Je,xe),xe|0)}class c extends h{static clampedInt(K,Se,Je,xe){return t(K,Se,Je,xe)}constructor(K,Se,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(K,Se,Je,$t),this.minimum=xe,this.maximum=ht}validate(K){return c.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}function l(ee,K,Se,Je){if(typeof ee>"u")return K;const xe=g.float(ee,K);return g.clamp(xe,Se,Je)}class g extends h{static clamp(K,Se,Je){return K<Se?Se:K>Je?Je:K}static float(K,Se){if(typeof K=="number")return K;if(typeof K>"u")return Se;const Je=parseFloat(K);return isNaN(Je)?Se:Je}constructor(K,Se,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(K,Se,Je,ht),this.validationFn=xe}validate(K){return this.validationFn(g.float(K,this.defaultValue))}}class m extends h{static string(K,Se){return typeof K!="string"?Se:K}constructor(K,Se,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(K,Se,Je,xe)}validate(K){return m.string(K,this.defaultValue)}}function $(ee,K,Se,Je){return typeof ee!="string"?K:Je&&ee in Je?Je[ee]:Se.indexOf(ee)===-1?K:ee}class D extends h{constructor(K,Se,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(K,Se,Je,ht),this.c=xe}validate(K){return $(K,this.defaultValue,this.c)}}class S extends d{constructor(K,Se,Je,xe,ht,$t,Ot=void 0){typeof Ot<"u"&&(Ot.type="string",Ot.enum=ht,Ot.default=xe),super(K,Se,Je,Ot),this.c=ht,this.d=$t}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function b(ee){switch(ee){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(K){switch(K){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(K,Se,Je){return Je===R.AccessibilitySupport.Unknown?K.accessibilitySupport:Je}}class P extends d{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:a.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{insertSpace:i(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function w(ee){switch(ee){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var F;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function O(ee){switch(ee){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function L(ee){switch(ee){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class q extends o{constructor(){super(je.editorClassName)}compute(K,Se,Je){const xe=["monaco-editor"];return Se.get(je.extraEditorClassName)&&xe.push(Se.get(je.extraEditorClassName)),K.extraEditorClassName&&xe.push(K.extraEditorClassName),Se.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Se.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Se.get(je.showUnused)&&xe.push("showUnused"),Se.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class W extends r{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(K,Se,Je){return Je&&K.emptySelectionClipboard}}class M extends d{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:a.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:a.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{cursorMoveOnType:i(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":$(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":$(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Se.loop,this.defaultValue.loop)}}}class Y extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"||K.length===0?Y.OFF:K==="true"?Y.ON:K:K?Y.ON:Y.OFF}}e.EditorFontLigatures=Y;class Z extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?Z.OFF:K==="true"?Z.TRANSLATE:K:K?Z.TRANSLATE:Z.OFF}compute(K,Se,Je){return K.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class ge extends o{constructor(){super(je.fontInfo)}compute(K,Se,Je){return K.fontInfo}}class _ extends h{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(K){const Se=g.float(K,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Se,6,100)}compute(K,Se,Je){return K.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(K){return K==="normal"||K==="bold"?K:String(c.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class se extends d{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Je,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Je,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Je,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Je,description:a.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{multiple:$(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??$(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??$(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??$(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??$(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??$(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends d{constructor(){const K={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:K.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:K.above,description:a.localize(46,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),delay:c.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:i(Se.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Se.above,this.defaultValue.above)}}}var we;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class oe extends o{constructor(){super(je.layoutInfo)}compute(K,Se,Je){return oe.computeLayout(Se,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio,glyphMarginDecorationLaneCount:K.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(K){const Se=K.height/K.lineHeight,Je=Math.floor(K.paddingTop/K.lineHeight);let xe=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(xe=Math.max(xe,Se-1));const ht=(Je+K.viewLineCount+xe)/(K.pixelRatio*K.height),$t=Math.floor(K.viewLineCount/ht);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(K,Se){const Je=K.outerWidth,xe=K.outerHeight,ht=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:we.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=Se.stableMinimapLayoutInput,Ot=$t&&K.outerHeight===$t.outerHeight&&K.lineHeight===$t.lineHeight&&K.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&K.pixelRatio===$t.pixelRatio&&K.scrollBeyondLastLine===$t.scrollBeyondLastLine&&K.paddingTop===$t.paddingTop&&K.paddingBottom===$t.paddingBottom&&K.minimap.enabled===$t.minimap.enabled&&K.minimap.side===$t.minimap.side&&K.minimap.size===$t.minimap.size&&K.minimap.showSlider===$t.minimap.showSlider&&K.minimap.renderCharacters===$t.minimap.renderCharacters&&K.minimap.maxColumn===$t.minimap.maxColumn&&K.minimap.scale===$t.minimap.scale&&K.verticalScrollbarWidth===$t.verticalScrollbarWidth&&K.isViewportWrapping===$t.isViewportWrapping,Ft=K.lineHeight,ei=K.typicalHalfwidthCharacterWidth,li=K.scrollBeyondLastLine,ti=K.minimap.renderCharacters;let Ye=ht>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const Gt=K.minimap.maxColumn,Kt=K.minimap.size,mt=K.minimap.side,Ct=K.verticalScrollbarWidth,ii=K.viewLineCount,Xt=K.remainingWidth,Wt=K.isViewportWrapping,vt=ti?2:3;let Nt=Math.floor(ht*xe);const hi=Nt/ht;let Vt=!1,Xe=!1,Yt=vt*Ye,ni=Ye/ht,di=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Ut,extraLinesBeyondLastLine:Ht,desiredRatio:oi,minimapLineCount:Pt}=oe.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:li,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:xe,lineHeight:Ft,pixelRatio:ht});if(ii/Pt>1)Vt=!0,Xe=!0,Ye=1,Yt=1,ni=Ye/ht;else{let bt=!1,xt=Ye+1;if(Kt==="fit"){const kt=Math.ceil((Ut+ii+Ht)*Yt);Wt&&Ot&&Xt<=Se.stableFitRemainingWidth?(bt=!0,xt=Se.stableFitMaxMinimapScale):bt=kt>Nt}if(Kt==="fill"||bt){Vt=!0;const kt=Ye;Yt=Math.min(Ft*ht,Math.max(1,Math.floor(1/oi))),Wt&&Ot&&Xt<=Se.stableFitRemainingWidth&&(xt=Se.stableFitMaxMinimapScale),Ye=Math.min(xt,Math.max(1,Math.floor(Yt/vt))),Ye>kt&&(di=Math.min(2,Ye/kt)),ni=Ye/ht/di,Nt=Math.ceil(Math.max(si,Ut+ii+Ht)*Yt),Wt?(Se.stableMinimapLayoutInput=K,Se.stableFitRemainingWidth=Xt,Se.stableFitMaxMinimapScale=Ye):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Gt*ni),Mt=Math.min(Dt,Math.max(0,Math.floor((Xt-Ct-2)*ni/(ei+ni)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(ht*Mt);const zt=Rt/ht;Rt=Math.floor(Rt*di);const ri=ti?we.Text:we.Blocks,Zt=mt==="left"?0:Je-Mt-Ct;return{renderMinimap:ri,minimapLeft:Zt,minimapWidth:Mt,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Xe,minimapScale:Ye,minimapLineHeight:Yt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:hi}}static computeLayout(K,Se){const Je=Se.outerWidth|0,xe=Se.outerHeight|0,ht=Se.lineHeight|0,$t=Se.lineNumbersDigitCount|0,Ot=Se.typicalHalfwidthCharacterWidth,Ft=Se.maxDigitWidth,ei=Se.pixelRatio,li=Se.viewLineCount,ti=K.get(je.wordWrapOverride2),Ye=ti==="inherit"?K.get(je.wordWrapOverride1):ti,Gt=Ye==="inherit"?K.get(je.wordWrap):Ye,Kt=K.get(je.wordWrapColumn),mt=Se.isDominatedByLongLines,Ct=K.get(je.glyphMargin),ii=K.get(je.lineNumbers).renderType!==ze.Off,Xt=K.get(je.lineNumbersMinChars),Wt=K.get(je.scrollBeyondLastLine),vt=K.get(je.padding),Nt=K.get(je.minimap),hi=K.get(je.scrollbar),Vt=hi.verticalScrollbarSize,Xe=hi.verticalHasArrows,Yt=hi.arrowSize,ni=hi.horizontalScrollbarSize,di=K.get(je.folding),Dt=K.get(je.showFoldingControls)!=="never";let Mt=K.get(je.lineDecorationsWidth);di&&Dt&&(Mt+=16);let Rt=0;if(ii){const qt=Math.max($t,Xt);Rt=Math.round(qt*Ft)}let zt=0;Ct&&(zt=ht*Se.glyphMarginDecorationLaneCount);let ri=0,Zt=ri+zt,si=Zt+Rt,Ut=si+Mt;const Ht=Je-zt-Rt-Mt;let oi=!1,Pt=!1,St=-1;Ye==="inherit"&&mt?(oi=!0,Pt=!0):Gt==="on"||Gt==="bounded"?Pt=!0:Gt==="wordWrapColumn"&&(St=Kt);const bt=oe.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ot,pixelRatio:ei,scrollBeyondLastLine:Wt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Nt,verticalScrollbarWidth:Vt,viewLineCount:li,remainingWidth:Ht,isViewportWrapping:Pt},Se.memory||new E);bt.renderMinimap!==we.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,Zt+=bt.minimapWidth,si+=bt.minimapWidth,Ut+=bt.minimapWidth);const xt=Ht-bt.minimapWidth,kt=Math.max(1,Math.floor((xt-Vt-2)/Ot)),fi=Xe?Yt:0;return Pt&&(St=Math.max(1,kt),Gt==="bounded"&&(St=Math.min(St,Kt))),{width:Je,height:xe,glyphMarginLeft:ri,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:Rt,decorationsLeft:si,decorationsWidth:Mt,contentLeft:Ut,contentWidth:xt,minimap:bt,viewportColumn:kt,isWordWrapMinified:oi,isViewportWrapping:Pt,wrappingColumn:St,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Vt,height:xe-2*fi,right:0}}}}e.EditorLayoutInfoComputer=oe;class Ce extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(K){return $(K,"simple",["simple","advanced"])}compute(K,Se,Je){return Se.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Le;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class X extends d{constructor(){const K={enabled:Le.On};super(je.lightbulb,"lightbulb",K,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:K.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:$(K.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class V extends d{constructor(){const K={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:K.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:K.scrollWithEditor,description:a.localize(57,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends d{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:a.localize(65,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:$(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),padding:i(Se.padding,this.defaultValue.padding)}}}class ve extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):c.clampedInt(K,this.defaultValue,0,1e3)}compute(K,Se,Je){return Je<0?c.clampedInt(-Je*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ue extends g{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>g.clamp(K,0,150),{markdownDescription:a.localize(66,null)})}compute(K,Se,Je){return K.fontInfo.lineHeight}}class be extends d{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:K.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:K.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:K.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:K.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:K.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),autohide:i(Se.autohide,this.defaultValue.autohide),size:$(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Se.side,this.defaultValue.side,["right","left"]),showSlider:$(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Se.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Se.scale,1,1,3),maxColumn:c.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Se.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Se.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(Se.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(Se.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function de(ee){return ee==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class J extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{top:c.clampedInt(Se.top,0,0,1e3),bottom:c.clampedInt(Se.bottom,0,0,1e3)}}}class x extends d{constructor(){const K={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:a.localize(85,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),cycle:i(Se.cycle,this.defaultValue.cycle)}}}class pe extends o{constructor(){super(je.pixelRatio)}compute(K,Se,Je){return K.pixelRatio}}class $e extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K:this.defaultValue}}class Ne extends d{constructor(){const K={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:K.strings,description:a.localize(89,null)},comments:{anyOf:Se,default:K.comments,description:a.localize(90,null)},other:{anyOf:Se,default:K.other,description:a.localize(91,null)}},default:K,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const ei=K?"on":"off";return{comments:ei,strings:ei,other:ei}}if(!K||typeof K!="object")return this.defaultValue;const{other:Se,comments:Je,strings:xe}=K,ht=["on","inline","off"];let $t,Ot,Ft;return typeof Se=="boolean"?$t=Se?"on":"off":$t=$(Se,this.defaultValue.other,ht),typeof Je=="boolean"?Ot=Je?"on":"off":Ot=$(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?Ft=xe?"on":"off":Ft=$(xe,this.defaultValue.strings,ht),{other:$t,comments:Ot,strings:Ft}}}var ze;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(K){let Se=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(Se=ze.Custom,Je=K):K==="interval"?Se=ze.Interval:K==="relative"?Se=ze.Relative:K==="on"?Se=ze.On:Se=ze.Off),{renderType:Se,renderFn:Je}}}function Ae(ee){const K=ee.get(je.renderValidationDecorations);return K==="editable"?ee.get(je.readOnly):K!=="on"}class Oe extends d{constructor(){const K=[],Se={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",K,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:K,description:a.localize(100,null)})}validate(K){if(Array.isArray(K)){const Se=[];for(const Je of K)if(typeof Je=="number")Se.push({column:c.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;Se.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Se.sort((Je,xe)=>Je.column-xe.column),Se}return this.defaultValue}}class j extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(K){return!K||typeof K!="object"?this.defaultValue:K}}function U(ee,K){if(typeof ee!="string")return K;switch(ee){case"hidden":return N.ScrollbarVisibility.Hidden;case"visible":return N.ScrollbarVisibility.Visible;default:return N.ScrollbarVisibility.Auto}}class G extends d{constructor(){const K={vertical:N.ScrollbarVisibility.Auto,horizontal:N.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:K.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K,Je=c.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(Se.vertical,this.defaultValue.vertical),horizontal:U(Se.horizontal,this.defaultValue.horizontal),useShadows:i(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:c.clampedInt(Se.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(Se.verticalSliderSize,xe,0,1e3),scrollByPage:i(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends d{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:a.localize(119,null)}})}applyUpdate(K,Se){let Je=!1;Se.allowedCharacters&&K&&(I.$io(K.allowedCharacters,Se.allowedCharacters)||(K={...K,allowedCharacters:Se.allowedCharacters},Je=!0)),Se.allowedLocales&&K&&(I.$io(K.allowedLocales,Se.allowedLocales)||(K={...K,allowedLocales:Se.allowedLocales},Je=!0));const xe=super.applyUpdate(K,Se);return Je?new n(xe.newValue,!0):xe}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{nonBasicASCII:Ke(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,Se){if(typeof K!="object"||!K)return Se;const Je={};for(const[xe,ht]of Object.entries(K))ht===!0&&(Je[xe]=!0);return Je}}class ne extends d{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:K.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:K.fontFamily,description:a.localize(126,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),mode:$(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const K={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",K,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:K.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:K.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:K.backgroundColoring,description:a.localize(133,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),showToolbar:$(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Se.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Re extends d{constructor(){const K={enabled:T.$jt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$jt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends d{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:K.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:K.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:K.highlightActiveIndentation,description:a.localize(149,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{bracketPairs:Ke(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ee,K,Se){const Je=Se.indexOf(ee);return Je===-1?K:Se[Je]}class _e extends d{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:K.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:K.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{insertMode:$(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Se.showIcons,this.defaultValue.showIcons),showStatusBar:i(Se.showStatusBar,this.defaultValue.showStatusBar),preview:i(Se.preview,this.defaultValue.preview),previewMode:$(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Se.showMethods,this.defaultValue.showMethods),showFunctions:i(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Se.showFields,this.defaultValue.showFields),showVariables:i(Se.showVariables,this.defaultValue.showVariables),showClasses:i(Se.showClasses,this.defaultValue.showClasses),showStructs:i(Se.showStructs,this.defaultValue.showStructs),showInterfaces:i(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Se.showModules,this.defaultValue.showModules),showProperties:i(Se.showProperties,this.defaultValue.showProperties),showEvents:i(Se.showEvents,this.defaultValue.showEvents),showOperators:i(Se.showOperators,this.defaultValue.showOperators),showUnits:i(Se.showUnits,this.defaultValue.showUnits),showValues:i(Se.showValues,this.defaultValue.showValues),showConstants:i(Se.showConstants,this.defaultValue.showConstants),showEnums:i(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Se.showKeywords,this.defaultValue.showKeywords),showWords:i(Se.showWords,this.defaultValue.showWords),showColors:i(Se.showColors,this.defaultValue.showColors),showFiles:i(Se.showFiles,this.defaultValue.showFiles),showReferences:i(Se.showReferences,this.defaultValue.showReferences),showFolders:i(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Se.showSnippets,this.defaultValue.showSnippets),showUsers:i(Se.showUsers,this.defaultValue.showUsers),showIssues:i(Se.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(K.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const K=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",K,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(K){if(typeof K=="string"&&(K=[K]),Array.isArray(K)){const Se=[];for(const Je of K)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&Se.push(Je)}catch{}return Se}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(K){switch(K){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(K,Se,Je){return Se.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?et.None:Je}}class ft extends o{constructor(){super(je.wrappingInfo)}compute(K,Se,Je){const xe=Se.get(je.layoutInfo);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class ct extends d{constructor(){const K={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),showDropSelector:$(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const K={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",K,{"editor.pasteAs.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Se=K;return{enabled:i(Se.enabled,this.defaultValue.enabled),showPasteSelector:$(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ut="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?gt:C.$k?pt:ut,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var je;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Be(new D(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Be(new k),accessibilityPageSize:Be(new c(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new m(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Be(new r(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new D(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Be(new D(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Be(new D(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Be(new D(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Be(new D(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Be(new S(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Be(new r(je.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new D(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Be(new Re),bracketPairGuides:Be(new Ue),stickyTabStops:Be(new r(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Be(new r(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Be(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Be(new c(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Be(new r(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Be(new D(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Be(new c(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Be(new r(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Be(new P),contextmenu:Be(new r(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Be(new S(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Be(new D(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Be(new S(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(261,null)})),cursorSurroundingLines:Be(new c(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Be(new D(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Be(new c(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Be(new r(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new r(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Be(new W),dropIntoEditor:Be(new ct),stickyScroll:Be(new V),experimentalWhitespaceRendering:Be(new D(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Be(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new g(je.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:a.localize(272,null)})),find:Be(new M),fixedOverflowWidgets:Be(new r(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new r(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Be(new D(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Be(new r(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Be(new r(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Be(new c(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new r(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Be(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Be(new ge),fontLigatures2:Be(new Y),fontSize:Be(new _),fontWeight:Be(new me),fontVariations:Be(new Z),formatOnPaste:Be(new r(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Be(new r(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Be(new r(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new r(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Be(new ce),inDiffEditor:Be(new r(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new g(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>g.clamp(ee,-5,20),{description:a.localize(286,null)})),lightbulb:Be(new X),lineDecorationsWidth:Be(new ve),lineHeight:Be(new ue),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new c(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Be(new r(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Be(new D(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Be(new be),mouseStyle:Be(new D(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new g(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Be(new r(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Be(new r(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Be(new S(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Be(new D(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Be(new c(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Be(new D(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Be(new r(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Be(new c(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new J),pasteAs:Be(new st),parameterHints:Be(new x),peekWidgetDefaultFocus:Be(new D(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Be(new $e),definitionLinkOpensInPeek:Be(new r(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Be(new Ne),quickSuggestionsDelay:Be(new c(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Be(new r(je.readOnly,"readOnly",!1)),readOnlyMessage:Be(new j),renameOnType:Be(new r(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Be(new r(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Be(new D(je.renderFinalNewline,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Be(new D(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Be(new D(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new D(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Be(new c(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Be(new Oe),scrollbar:Be(new G),scrollBeyondLastColumn:Be(new c(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Be(new r(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Be(new r(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Be(new r(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:C.$k})),selectionHighlight:Be(new r(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Be(new r(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new D(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Be(new r(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Be(new r(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Be(new te),snippetSuggestions:Be(new D(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Be(new tt),smoothScrolling:Be(new r(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Be(new c(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ne),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new r(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Be(new c(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new c(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Be(new D(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Be(new D(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Be(new c(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new H),unusualLineTerminators:Be(new D(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Be(new r(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new r(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Be(new D(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new m(je.wordSeparators,"wordSeparators",p.$kt,{description:a.localize(360,null)})),wordWrap:Be(new D(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new c(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Be(new D(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new D(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new q),defaultColorDecorators:Be(new r(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Be(new pe),tabFocusMode:Be(new r(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Be(new oe),wrappingInfo:Be(new ft),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Ce)}}),define(Ie[107],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,v.$Gi)("environmentService"),e.$Oi=(0,v.$Hi)(e.$Ni)}),define(Ie[30],Pe([1,0,59,20,13,15,2,174,3,21,16,48]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=u,e.$cl=s,e.$dl=h,e.$el=i,e.$fl=r,e.$gl=t,e.$hl=c,e.$il=l,e.$jl=g,e.$kl=m,e.$ll=$,e.$nl=b,e.$ol=k,e.$pl=P,e.$ql=f,e.$rl=w,e.$ul=W,e.$Gl=me,e.$Hl=se,e.$Jl=we,e.$al=(0,p.$Gi)("fileService");function u(oe){return oe.create===!0}var E;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function s(oe){const Ce=oe;return!!Ce&&typeof Ce.onDidChange=="function"}var o;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function h(oe){return!!(oe.capabilities&o.FileReadWrite)}function i(oe){return!!(oe.capabilities&o.FileFolderCopy)}function r(oe){return!!(oe.capabilities&o.FileClone)}function t(oe){return!!(oe.capabilities&o.FileOpenReadWriteClose)}function c(oe){return!!(oe.capabilities&o.FileReadStream)}function l(oe){return h(oe)?!!(oe.capabilities&o.FileAtomicRead):!1}function g(oe){return h(oe)?!!(oe.capabilities&o.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&o.FileAtomicDelete)}function $(oe){return!!(oe.capabilities&o.Readonly)}var D;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class S extends Error{static create(Ce,Le){const X=new S(Ce.toString(),Le);return P(X,Le),X}constructor(Ce,Le){super(Ce),this.code=Le}}e.$ml=S;function b(oe,Ce){return S.create(oe,Ce)}function k(oe){return oe||b((0,T.localize)(0,null),D.Unknown)}function P(oe,Ce){return oe.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return D.Unknown;if(oe instanceof S)return oe.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Ce)return D.Unknown;switch(Ce[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}function w(oe){if(oe instanceof M)return oe.fileOperationResult;switch(f(oe)){case D.FileNotFound:return ge.FILE_NOT_FOUND;case D.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case D.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case D.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case D.NoPermissions:return ge.FILE_PERMISSION_DENIED;case D.FileExists:return ge.FILE_MOVE_CONFLICT;case D.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class O{constructor(Ce,Le,X){this.resource=Ce,this.operation=Le,this.target=X}isOperation(Ce){return this.operation===Ce}}e.$sl=O;var L;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class q{static{this.a=null}constructor(Ce,Le){this.c=Le,this.b=void 0,this.d=new y.$X(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new y.$X(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new y.$X(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ce){switch(X.type){case L.ADDED:this.rawAdded.push(X.resource);break;case L.UPDATED:this.rawUpdated.push(X.resource);break;case L.DELETED:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ce,...Le){return this.h(Ce,{includeChildren:!1},...Le)}affects(Ce,...Le){return this.h(Ce,{includeChildren:!0},...Le)}h(Ce,Le,...X){if(!Ce)return!1;const V=X.length>0;return!!((!V||X.includes(L.ADDED))&&(this.d.value.get(Ce)||Le.includeChildren&&this.d.value.findSuperstr(Ce))||(!V||X.includes(L.UPDATED))&&(this.f.value.get(Ce)||Le.includeChildren&&this.f.value.findSuperstr(Ce))||(!V||X.includes(L.DELETED))&&(this.g.value.findSubstr(Ce)||Le.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$tl=q;function W(oe,Ce,Le){return!oe||!Ce||oe===Ce||Ce.length>oe.length?!1:(Ce.charAt(Ce.length-1)!==I.sep&&(Ce+=I.sep),Le?(0,C.$If)(oe,Ce):oe.indexOf(Ce)===0)}class M extends Error{constructor(Ce,Le,X){super(Ce),this.fileOperationResult=Le,this.options=X}}e.$vl=M;class Y extends M{constructor(Ce,Le,X,V){super(Ce,Le,V),this.fileOperationResult=Le,this.size=X}}e.$wl=Y;class Z extends M{constructor(Ce,Le,X){super(Ce,ge.FILE_NOT_MODIFIED_SINCE,X),this.stat=Le}}e.$xl=Z;var ge;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var _;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Fl="";function me(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,Ce){if(!Ce.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Le=>{const X=Ce.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===oe.scheme&&V.added&&(X.dispose(),Le())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Ce){return(0,N.$kg)(Ce)||(Ce=0),Ce<ce.KB?(0,T.localize)(1,null,Ce.toFixed(0)):Ce<ce.MB?(0,T.localize)(2,null,(Ce/ce.KB).toFixed(2)):Ce<ce.GB?(0,T.localize)(3,null,(Ce/ce.MB).toFixed(2)):Ce<ce.TB?(0,T.localize)(4,null,(Ce/ce.GB).toFixed(2)):(0,T.localize)(5,null,(Ce/ce.TB).toFixed(2))}}e.$Il=ce;function we(oe){const Ce=typeof oe=="string"||oe?.scheme===R.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===R.Schemas.file?1024*ce.MB:Ce?10*ce.MB:a.$o?50*ce.MB:1024*ce.MB}}),define(Ie[75],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class v{constructor(...C){this.a=new Map;for(const[N,A]of C)this.set(N,A)}set(C,N){const A=this.a.get(C);return this.a.set(C,N),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ei=v}),define(Ie[211],Pe([1,0,11,14,4,74,208,3,75,212]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const R=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class u{constructor(s=new p.$Ei,o=!1,h,i=R){this.i=s,this.j=o,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Fi,this),this._globalGraph=i?h?._globalGraph??new A.$tr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Sc)(this.h),this.h.clear();for(const s of this.g)(0,C.$Rc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,o){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),o?.add(i),i}invokeFunction(s,...o){this.m();const h=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,I.$$)("service accessor is only valid during the invocation of its target method");const c=this.s(t,h);if(!c)throw new Error(`[invokeFunction] unknown service '${t}'`);return c}},...o)}finally{i=!0,h.stop()}}createInstance(s,...o){this.m();let h,i;return s instanceof N.$Di?(h=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),h)):(h=d.traceCreation(this.l,s),i=this.o(s,o,h)),h.stop(),i}o(s,o=[],h){const i=T._util.getServiceDependencies(s).sort((c,l)=>c.index-l.index),r=[];for(const c of i){const l=this.s(c.id,h);l||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:o.length;if(o.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${o.length} static arguments`);const c=t-o.length;c>0?o=o.concat(new Array(c)):o=o.slice(0,t)}return Reflect.construct(s,o.concat(r))}q(s,o){if(this.i.get(s)instanceof N.$Di)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const h=this.r(s);return h instanceof N.$Di?this.u(s,h,o.branch(s,!0)):(o.branch(s,!1),h)}u(s,o,h){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,h)}finally{this.t.delete(s)}}v(s,o,h){const i=new A.$tr(c=>c.id.toString());let r=0;const t=[{id:s,desc:o,_trace:h}];for(;t.length;){const c=t.pop();if(i.lookupOrInsertNode(c),r++>1e3)throw new y(i);for(const l of T._util.getServiceDependencies(c.desc.ctor)){const g=this.r(l.id);if(g||this.y(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(l.id)),g instanceof N.$Di){const m={id:l.id,desc:g,_trace:c._trace.branch(l.id,!0)};i.insertEdge(c,m),t.push(m)}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:l}of c){if(this.r(l.id)instanceof N.$Di){const m=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,m)}i.removeNode(l)}}return this.r(s)}w(s,o,h=[],i,r){if(this.i.get(s)instanceof N.$Di)return this.x(s,o,h,i,r,this.g);if(this.k)return this.k.w(s,o,h,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,h=[],i,r,t){if(i){const c=new u(void 0,this.j,this,this.l);c.c=String(s);const l=new Map,g=new v.$Zh(()=>{const m=c.o(o,h,r);for(const[$,D]of l){const S=m[$];if(typeof S=="function")for(const b of D)b.disposable=S.apply(m,b.listener)}return l.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,$){if(!g.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let b=l.get($);return b||(b=new a.$8c,l.set($,b)),(P,f,w)=>{if(g.isInitialized)return g.value[$](P,f,w);{const F={listener:[P,f,w],disposable:void 0},O=b.push(F);return(0,C.$Vc)(()=>{O(),F.disposable?.dispose()})}}}if($ in m)return m[$];const D=g.value;let S=D[$];return typeof S!="function"||(S=S.bind(D),m[$]=S),S},set(m,$,D){return g.value[$]=D,!0},getPrototypeOf(m){return o.prototype}})}else{const c=this.o(o,h,r);return t.add(c),c}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$ur=u;var E;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new d(E.Invocation,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,o){return s?new d(E.Creation,o.name):d.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const h=new d(E.Branch,s.toString());return this.h.push([s,o,h]),h}stop(){const s=Date.now()-this.g;d.f+=s;let o=!1;function h(r,t){const c=[],l=new Array(r+1).join("	");for(const[g,m,$]of t.h)if(m&&$){o=!0,c.push(`${l}CREATES -> ${g}`);const D=h(r+1,$);D&&c.push(D)}else c.push(`${l}uses -> ${g}`);return c.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||o)&&d.all.add(i.join(`
`))}}e.$vr=d}),define(Ie[12],Pe([1,0,175,41,6,76,4,29,21,24,15,2,32,3]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=n,e.log=o,e.$ok=S,e.$pk=b,e.$qk=k,e.$rk=P,v=Ve(v),e.$ak=(0,E.$Gi)("logService"),e.$bk=(0,E.$Gi)("loggerService");function d(){return new Date().toISOString()}function n(f){return(0,R.$kg)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$dk=s.Info;function o(f,w,F){switch(w){case s.Trace:f.trace(F);break;case s.Debug:f.debug(F);break;case s.Info:f.info(F);break;case s.Warning:f.warn(F);break;case s.Error:f.error(F);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h(f,w=!1){let F="";for(let O=0;O<f.length;O++){let L=f[O];if(L instanceof Error&&(L=(0,I.$rj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}F+=(O>0?" ":"")+L}return F}class i extends A.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new C.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$fk=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...F){this.f(s.Trace)&&this.g(s.Trace,h([w,...F],!0))}debug(w,...F){this.f(s.Debug)&&this.g(s.Debug,h([w,...F]))}info(w,...F){this.f(s.Info)&&this.g(s.Info,h([w,...F]))}warn(w,...F){this.f(s.Warning)&&this.g(s.Warning,h([w,...F]))}error(w,...F){if(this.f(s.Error))if(w instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=w.stack,this.g(s.Error,h(O))}else this.g(s.Error,h([w,...F]))}flush(){}}e.$gk=r;class t extends i{constructor(w=e.$dk){super(),this.setLevel(w),this.g=!p.$i}trace(w,...F){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}debug(w,...F){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}info(w,...F){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}warn(w,...F){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...F):console.warn(`[main ${d()}]`,w,...F))}error(w,...F){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...F):console.error(`[main ${d()}]`,w,...F))}flush(){}}e.$hk=t;class c extends i{constructor(w=e.$dk,F=!0){super(),this.g=F,this.setLevel(w)}trace(w,...F){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...F):console.log(w,...F))}debug(w,...F){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...F):console.log(w,...F))}info(w,...F){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...F):console.log(w,...F))}warn(w,...F){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...F):console.log(w,...F))}error(w,...F){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...F):console.error(w,...F))}flush(){}}e.$ik=c;class l extends i{constructor(w,F=e.$dk){super(),this.g=w,this.setLevel(F)}trace(w,...F){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...F])}debug(w,...F){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...F])}info(w,...F){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...F])}warn(w,...F){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...F])}error(w,...F){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...F])}h(w){return typeof w=="string"?w:(0,I.$rj)(w,this.f(s.Trace))}flush(){}}e.$jk=l;class g extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const F of this.g)F.setLevel(w);super.setLevel(w)}trace(w,...F){for(const O of this.g)O.trace(w,...F)}debug(w,...F){for(const O of this.g)O.debug(w,...F)}info(w,...F){for(const O of this.g)O.info(w,...F)}warn(w,...F){for(const O of this.g)O.warn(w,...F)}error(w,...F){for(const O of this.g)O.error(w,...F)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$kk=g;class m extends A.$Xc{constructor(w,F,O){if(super(),this.h=w,this.j=F,this.b=new T.$Dc,this.c=this.B(new C.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$ne),this.onDidChangeVisibility=this.g.event,O)for(const L of O)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,R.$gg)(w)?[...this.b.values()].find(F=>F.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,F){const O=this.n(w),L=(0,R.$gg)(w)?w:F?.id??(0,N.$uj)(O.toString()).toString(16);let q=this.b.get(O)?.logger;const W=F?.logLevel==="always"?s.Trace:F?.logLevel;q||(q=this.s(O,W??this.getLogLevel(O)??this.h,{...F,id:L}));const M={logger:q,info:{resource:O,id:L,logLevel:W,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(O,M),q}n(w){return(0,R.$gg)(w)?(0,a.$hh)(this.j,`${w}.log`):w}setLogLevel(w,F){if(y.URI.isUri(w)){const O=w,L=F,q=this.b.get(O);q&&L!==q.info.logLevel&&(q.info.logLevel=L===this.h?void 0:L,q.logger?.setLevel(L),this.b.set(q.info.resource,q),this.f.fire([O,L]))}else{this.h=w;for(const[O,L]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,F){const O=this.m(w);O&&F!==!O.info.hidden&&(O.info.hidden=!F,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,F]))}getLogLevel(w){let F;return w&&(F=this.b.get(w)?.info.logLevel),F??this.h}registerLogger(w){const F=this.b.get(w.resource);F?F.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const F=this.b.get(w);F&&(F.logger&&F.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=m;class ${constructor(){this.onDidChangeLogLevel=new C.$ne().event}setLevel(w){}getLevel(){return s.Info}trace(w,...F){}debug(w,...F){}info(w,...F){}warn(w,...F){}error(w,...F){}critical(w,...F){}dispose(){}flush(){}}e.$mk=$;class D extends ${}e.$nk=D;function S(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const w=P(f.logLevel.toLowerCase());if(w!==void 0)return w}return e.$dk}function b(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function k(f){switch(f){case s.Trace:return{original:"Trace",value:v.localize(0,null)};case s.Debug:return{original:"Debug",value:v.localize(1,null)};case s.Info:return{original:"Info",value:v.localize(2,null)};case s.Warning:return{original:"Warning",value:v.localize(3,null)};case s.Error:return{original:"Error",value:v.localize(4,null)};case s.Off:return{original:"Off",value:v.localize(5,null)}}}function P(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$sk=new u.$Xj("logLevel",b(s.Info))}),define(Ie[213],Pe([1,0,4,12]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class C extends v.$Xc{constructor(A,T=[]){super(),this.a=new I.$kk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$oR=C});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[108],Pe([1,0,36,176,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=_t(v);var N;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function a(d,n){return n-d}p.compare=a;const R=Object.create(null);R[p.Error]=(0,I.localize)(0,null),R[p.Warning]=(0,I.localize)(1,null),R[p.Info]=(0,I.localize)(2,null);function y(d){return R[d]||""}p.toString=y;function u(d){switch(d){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(d){switch(d){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var T;(function(p){const a="";function R(u){return y(u,!0)}p.makeKey=R;function y(u,E){const d=[a];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(a),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(a),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(a),u.message&&E?d.push(u.message.replace("\xA6","\\\xA6")):d.push(a),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(a),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(a),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(a),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(a),d.push(a),d.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Du=(0,C.$Gi)("markerService")});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[214],Pe([1,0,6,36,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$qw=e.Severity=void 0,e.$rw=T,I=_t(I),e.Severity=I.default,e.$qw=(0,C.$Gi)("notificationService");var N;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class a{constructor(){this.progress=new R,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$sw=a;class R{infinite(){}done(){}total(u){}worked(u){}}e.$tw=R}),define(Ie[109],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,v.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(ae,e,v,I){var C=arguments.length,N=C<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,v):I,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ae,e,v,I);else for(var T=ae.length-1;T>=0;T--)(A=ae[T])&&(N=(C<3?A(N):C>3?A(e,v,N):A(e,v))||N);return C>3&&N&&Object.defineProperty(e,v,N),N},qe=this&&this.__param||function(ae,e){return function(v,I){e(v,I,ae)}};define(Ie[77],Pe([1,0,11,22,4,3]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,N.$Gi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$ww=T;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$xw=p;let a=class extends C.$Xc{constructor(u,E){super(),this.a=new v.$4h,E.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,C.$Vc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$yw=a,e.$yw=a=He([qe(1,e.$uw)],a);class R extends C.$Xc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Wc)}start(u){this.stop();const E=++this.a,d=new I.$ye;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Vc)(()=>d.cancel())),this.b.add((0,C.$Vc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$zw=R,e.$Aw=(0,N.$Gi)("editorProgressService")}),define(Ie[31],Pe([1,0,62,15]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,v=Ve(v),I=Ve(I);class C{constructor(){this.a=new Map}add(A,T){v.ok(I.$gg(A)),v.ok(I.$ig(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$ro=new C}),define(Ie[78],Pe([1,0,6,31]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,I=Ve(I),e.$so={JSONContribution:"base.contributions.json"};function C(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class N{constructor(){this.b=new v.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,a){this.a[C(p)]=a,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;I.$ro.add(e.$so.JSONContribution,A)}),define(Ie[54],Pe([1,0,18,6,15,169,43,78,31]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=n,e.$Io=s,e.$Jo=o,e.$Ko=i,e.$Lo=r,C=Ve(C),N=Ve(N);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$wo={Configuration:"base.contributions.configuration"};var R;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const y=p.$ro.as(T.$so.JSONContribution);class u{constructor(){this.h=new Set,this.i=new I.$ne,this.onDidSchemaChange=this.i.event,this.j=new I.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$Do,this.g),this.v()}registerConfiguration(c,l=!0){this.registerConfigurations([c],l)}registerConfigurations(c,l=!0){const g=new Set;this.n(c,l,g),y.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(c){const l=new Set;this.o(c,l),y.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:c,remove:l}){const g=new Set;this.o(l,g),this.n(c,!1,g),y.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(c){const l=new Set;this.k(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(c,l){const g=[];for(const{overrides:m,source:$}of c)for(const D in m)if(l.add(D),e.$Go.test(D)){const S=this.a.get(D),b=S?.valuesSources??new Map,k=S?.value||{};for(const w of Object.keys(m[D])){const F=m[D][w];if(C.$ig(F)&&(C.$ng(k[w])||C.$ig(k[w]))){if(k[w]={...k[w]??{},...F},$){let L=b.get(w);if(L||(L=new Map,b.set(w,L)),!(L instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const q in F)L.set(q,$)}}else k[w]=F,$&&b.set(w,$)}this.a.set(D,{source:$,value:k,valuesSources:b});const P=(0,A.$kj)(D),f={type:"object",default:k,description:N.localize(1,null,P),$ref:e.$Do,defaultDefaultValue:k,source:C.$gg($)?void 0:$,defaultValueSource:$};g.push(...n(D)),this.d[D]=f,this.b.properties[D]=f}else{const S=this.d[D],b=this.a.get(D);let k=b?.value??S?.defaultDefaultValue,P=m[D],f=$;if(C.$ig(P)&&(S!==void 0&&S.type==="object"||S===void 0&&(C.$ng(k)||C.$ig(k)))){if(C.$ig(k)||(k={}),P={...k,...P},f=b?.source??new Map,!(f instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const F in m[D])$?f.set(F,$):f.delete(F)}this.a.set(D,{value:P,source:f}),S&&(this.w(D,S),this.r(D,S))}this.m(g)}deregisterDefaultConfigurations(c){const l=new Set;this.l(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(c,l){for(const{overrides:g,source:m}of c)for(const $ in g){const D=C.$gg(m)?m:m?.id,S=this.a.get($);if(S){if(e.$Go.test($)){for(const k of Object.keys(g[$])){const P=g[$][k];if(C.$ig(P)){const f=S.valuesSources?.get(k);for(const w of Object.keys(P)){const F=f?.get(w);(C.$gg(F)?F:F?.id)===D&&(f?.delete(w),delete S.value[k][w])}Object.keys(S.value[k]).length===0&&(delete S.value[k],S.valuesSources?.delete(k))}else{const f=S.valuesSources?.get(k);(C.$gg(f)?f:f?.id)===D&&(S.valuesSources?.delete(k),delete S.value[k])}}const b=this.a.get($);b&&Object.keys(b.value).length===0&&(this.a.delete($),delete this.d[$],delete this.b.properties[$])}else{if(S.source instanceof Map){const k=S.source;for(const P in g[$]){const f=k.get(P);(C.$gg(f)?f:f?.id)===D&&(k.delete(P),delete S.value[P])}k.size===0&&this.a.delete($)}else{const k=C.$gg(S.source)?S.source:S.source?.id;if(D!==k)continue;this.a.delete($)}const b=this.d[$];b&&(this.w($,b),this.r($,b))}l.add($)}}this.u()}deltaConfiguration(c){let l=!1;const g=new Set;c.removedDefaults&&(this.l(c.removedDefaults,g),l=!0),c.addedDefaults&&(this.k(c.addedDefaults,g),l=!0),c.removedConfigurations&&this.o(c.removedConfigurations,g),c.addedConfigurations&&this.n(c.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...c){this.i.fire()}registerOverrideIdentifiers(c){this.m(c),this.i.fire()}m(c){for(const l of c)this.h.add(l);this.u()}n(c,l,g){c.forEach(m=>{this.p(m,l,m.extensionInfo,m.restrictedProperties,void 0,g),this.c.push(m),this.q(m)})}o(c,l){const g=m=>{if(m.properties)for(const $ in m.properties){l.add($);const D=this.d[$];D?.policy?.name&&this.e.delete(D.policy.name),delete this.d[$],this.s($,m.properties[$])}m.allOf?.forEach($=>g($))};for(const m of c){g(m);const $=this.c.indexOf(m);$!==-1&&this.c.splice($,1)}}p(c,l=!0,g,m,$=R.WINDOW,D){$=C.$pg(c.scope)?$:c.scope;const S=c.properties;if(S)for(const k in S){const P=S[k];if(l&&i(k,P)){delete S[k];continue}if(P.source=g,P.defaultDefaultValue=S[k].default,this.w(k,P),e.$Go.test(k)?P.scope=void 0:(P.scope=C.$pg(P.scope)?$:P.scope,P.restricted=C.$pg(P.restricted)?!!m?.includes(k):P.restricted),S[k].hasOwnProperty("included")&&!S[k].included){this.f[k]=S[k],delete S[k];continue}else this.d[k]=S[k],S[k].policy?.name&&this.e.set(S[k].policy.name,k);!S[k].deprecationMessage&&S[k].markdownDeprecationMessage&&(S[k].deprecationMessage=S[k].markdownDeprecationMessage),D.add(k)}const b=c.allOf;if(b)for(const k of b)this.p(k,l,g,m,$,D)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(c){const l=g=>{const m=g.properties;if(m)for(const D in m)this.r(D,m[D]);g.allOf?.forEach(l)};l(c)}r(c,l){switch(e.$xo.properties[c]=l,l.scope){case R.APPLICATION:e.$yo.properties[c]=l;break;case R.MACHINE:e.$zo.properties[c]=l;break;case R.MACHINE_OVERRIDABLE:e.$Ao.properties[c]=l;break;case R.WINDOW:e.$Bo.properties[c]=l;break;case R.RESOURCE:e.$Co.properties[c]=l;break;case R.LANGUAGE_OVERRIDABLE:e.$Co.properties[c]=l,this.g.properties[c]=l;break}}s(c,l){switch(delete e.$xo.properties[c],l.scope){case R.APPLICATION:delete e.$yo.properties[c];break;case R.MACHINE:delete e.$zo.properties[c];break;case R.MACHINE_OVERRIDABLE:delete e.$Ao.properties[c];break;case R.WINDOW:delete e.$Bo.properties[c];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[c],delete this.g.properties[c];break}}u(){for(const c of this.h.values()){const l=`[${c}]`,g={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$Do};this.w(l,g),e.$xo.properties[l]=g,e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g,e.$Co.properties[l]=g}}v(){const c={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=c,e.$yo.patternProperties[e.$Fo]=c,e.$zo.patternProperties[e.$Fo]=c,e.$Ao.patternProperties[e.$Fo]=c,e.$Bo.patternProperties[e.$Fo]=c,e.$Co.patternProperties[e.$Fo]=c,this.i.fire()}w(c,l){const g=this.a.get(c);let m=g?.value,$=g?.source;C.$ng(m)&&(m=l.defaultDefaultValue,$=void 0),C.$ng(m)&&(m=o(l.type)),l.default=m,l.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Fo=`^(${E})+$`,e.$Go=new RegExp(e.$Fo);function n(t){const c=[];if(e.$Go.test(t)){let l=d.exec(t);for(;l?.length;){const g=l[1].trim();g&&c.push(g),l=d.exec(t)}}return(0,v.$Pb)(c)}function s(t){return t.reduce((c,l)=>`${c}[${l}]`,"")}function o(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$ro.add(e.$wo.Configuration,h);function i(t,c){return t.trim()?e.$Go.test(t)?N.localize(7,null,t):h.getConfigurationProperties()[t]!==void 0?N.localize(8,null,t):c.policy?.name&&h.getPolicyConfigurations().get(c.policy?.name)!==void 0?N.localize(9,null,t,c.policy?.name,h.getPolicyConfigurations().get(c.policy?.name)):null:N.localize(6,null)}function r(){const t=[],c=h.getConfigurationProperties();for(const l of Object.keys(c))t.push([l,c[l].scope]);return t.push(["launch",R.RESOURCE]),t.push(["task",R.RESOURCE]),t}}),define(Ie[215],Pe([1,0,18,6,136,4,29,26,15,2,43,54,30,31]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=r,v=Ve(v),C=Ve(C),T=Ve(T),p=Ve(p);function d(g){return Object.isFrozen(g)?g:T.$fo(g)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,$,D,S,b){this.b=m,this.c=$,this.d=D,this.raw=S,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map($=>{if($ instanceof n)return $;const D=new s("",this.f);return D.parseRaw($),D.configurationModel});this.g=m.reduce(($,D)=>D===$?D:$.merge(D),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,R.$ij)(this.contents,m):this.contents}inspect(m,$){const D=this;return{get value(){return d(D.rawConfiguration.getValue(m))},get override(){return $?d(D.rawConfiguration.getOverrideValue(m,$)):void 0},get merged(){return d($?D.rawConfiguration.override($).getValue(m):D.rawConfiguration.getValue(m))},get overrides(){const S=[];for(const{contents:b,identifiers:k,keys:P}of D.rawConfiguration.overrides){const f=new n(b,P,[],void 0,D.f).getValue(m);f!==void 0&&S.push({identifiers:k,value:f})}return S.length?d(S):void 0}}}getOverrideValue(m,$){const D=this.j($);return D?m?(0,R.$ij)(D,m):D:void 0}getKeysForOverrideIdentifier(m){const $=[];for(const D of this.overrides)D.identifiers.includes(m)&&$.push(...D.keys);return v.$Pb($)}getAllOverrideIdentifiers(){const m=[];for(const $ of this.overrides)m.push(...$.identifiers);return v.$Pb(m)}override(m){let $=this.a.get(m);return $||($=this.h(m),this.a.set(m,$)),$}merge(...m){const $=T.$eo(this.contents),D=T.$eo(this.overrides),S=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const k of m)if(b.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i($,k.contents);for(const P of k.overrides){const[f]=D.filter(w=>v.$xb(w.identifiers,P.identifiers));f?(this.i(f.contents,P.contents),f.keys.push(...P.keys),f.keys=v.$Pb(f.keys)):D.push(T.$eo(P))}for(const P of k.keys)S.indexOf(P)===-1&&S.push(P)}return new n($,S,D,b.every(k=>k instanceof n)?void 0:b,this.f)}h(m){const $=this.j(m);if(!$||typeof $!="object"||!Object.keys($).length)return this;const D={};for(const S of v.$Pb([...Object.keys(this.contents),...Object.keys($)])){let b=this.contents[S];const k=$[S];k&&(typeof b=="object"&&typeof k=="object"?(b=T.$eo(b),this.i(b,k)):b=k),D[S]=b}return new n(D,this.keys,this.overrides,void 0,this.f)}i(m,$){for(const D of Object.keys($)){if(D in m&&p.$ig(m[D])&&p.$ig($[D])){this.i(m[D],$[D]);continue}m[D]=T.$eo($[D])}}j(m){let $=null,D=null;const S=b=>{b&&(D?this.i(D,b):D=T.$eo(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===m?$=b.contents:b.identifiers.includes(m)&&S(b.contents);return S($),D}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,$){this.k(m,$,!0)}setValue(m,$){this.k(m,$,!1)}removeValue(m){const $=this.keys.indexOf(m);$!==-1&&(this.keys.splice($,1),(0,R.$hj)(this.contents,m),y.$Go.test(m)&&this.overrides.splice(this.overrides.findIndex(D=>v.$xb(D.identifiers,(0,y.$Ho)(m))),1))}k(m,$,D){(0,R.$gj)(this.contents,m,$,S=>this.f.error(S)),D=D||this.keys.indexOf(m)===-1,D&&this.keys.push(m),y.$Go.test(m)&&this.overrides.push({identifiers:(0,y.$Ho)(m),keys:Object.keys(this.contents[m]),contents:(0,R.$fj)(this.contents[m],S=>this.f.error(S))})}}e.$Mo=n;class s{constructor(m,$){this.f=m,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,$){if(!p.$pg(m)){const D=this.h(m);this.parseRaw(D,$)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,$){this.a=m;const{contents:D,keys:S,overrides:b,restricted:k,hasExcludedProperties:P}=this.i(m,$);this.b=new n(D,S,b,P?[m]:void 0,this.g),this.c=k||[]}h(m){let $={},D=null,S=[];const b=[],k=[];function P(w){Array.isArray(S)?S.push(w):D!==null&&(S[D]=w)}const f={onObjectBegin:()=>{const w={};P(w),b.push(S),S=w,D=null},onObjectProperty:w=>{D=w},onObjectEnd:()=>{S=b.pop()},onArrayBegin:()=>{const w=[];P(w),b.push(S),S=w,D=null},onArrayEnd:()=>{S=b.pop()},onLiteralValue:P,onError:(w,F,O)=>{k.push({error:w,offset:F,length:O})}};if(m)try{C.$6n(m,f),$=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(m,$){const D=E.$ro.as(y.$wo.Configuration).getConfigurationProperties(),S=this.j(m,D,!0,$);m=S.raw;const b=(0,R.$fj)(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),k=Object.keys(m),P=this.l(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:k,overrides:P,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(m,$,D,S){let b=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:b};const k={},P=[];for(const f in m)if(y.$Go.test(f)&&D){const w=this.j(m[f],$,!1,S);k[f]=w.raw,b=b||w.hasExcludedProperties,P.push(...w.restricted)}else{const w=$[f],F=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&P.push(f),!S.exclude?.includes(f)&&(S.include?.includes(f)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&w?.restricted))?k[f]=m[f]:b=!0}return{raw:k,restricted:P,hasExcludedProperties:b}}l(m,$){const D=[];for(const S of Object.keys(m))if(y.$Go.test(S)){const b={};for(const k in m[S])b[k]=m[S][k];D.push({identifiers:(0,y.$Ho)(S),keys:Object.keys(b),contents:(0,R.$fj)(b,$)})}return D}}e.$No=s;class o extends N.$Xc{constructor(m,$,D,S,b){super(),this.c=m,this.f=$,this.g=S,this.h=b,this.b=this.B(new I.$ne),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),b),this.B(this.g.watch(D.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&D.isEqual(k.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=o;class h{constructor(m,$,D,S,b,k,P,f,w,F,O,L,q){this.a=m,this.b=$,this.c=D,this.overrideIdentifiers=S,this.d=b,this.f=k,this.g=P,this.h=f,this.i=w,this.j=F,this.k=O,this.l=L,this.m=q}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,$,D,S,b,k,P,f,w,F){this.j=m,this.l=$,this.m=D,this.n=S,this.p=b,this.q=k,this.r=P,this.s=f,this.t=w,this.u=F,this.h=null,this.i=new A.$Dc,this.v=null}getValue(m,$,D){return this.w(m,$,D).getValue(m)}updateValue(m,$,D={}){let S;D.resource?(S=this.t.get(D.resource),S||(S=n.createEmptyModel(this.u),this.t.set(D.resource,S))):S=this.s,$===void 0?S.removeValue(m):S.setValue(m,$),D.resource||(this.h=null)}inspect(m,$,D){const S=this.w(m,$,D),b=this.A($.resource,D),k=$.resource?this.t.get($.resource)||this.s:this.s,P=new Set;for(const f of S.overrides)for(const w of f.identifiers)S.getOverrideValue(m,w)!==void 0&&P.add(w);return new h(m,$,S.getValue(m),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,D?this.q:void 0,b||void 0,k)}keys(m){const $=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,$){this.r.set(m,$),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,$){const D=[];if(!$){const{added:S,updated:b,removed:k}=c(this.j,m);$=[...S,...b,...k]}for(const S of $)for(const b of(0,y.$Ho)(S)){const k=this.j.getKeysForOverrideIdentifier(b),P=m.getKeysForOverrideIdentifier(b),f=[...P.filter(w=>k.indexOf(w)===-1),...k.filter(w=>P.indexOf(w)===-1),...k.filter(w=>!T.$io(this.j.override(b).getValue(w),m.override(b).getValue(w)))];D.push([b,f])}return this.updateDefaultConfiguration(m),{keys:$,overrides:D}}compareAndUpdatePolicyConfiguration(m){const{added:$,updated:D,removed:S}=c(this.l,m),b=[...$,...D,...S];return b.length&&this.updatePolicyConfiguration(m),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:$,updated:D,removed:S,overrides:b}=c(this.applicationConfiguration,m),k=[...$,...D,...S];return k.length&&this.updateApplicationConfiguration(m),{keys:k,overrides:b}}compareAndUpdateLocalUserConfiguration(m){const{added:$,updated:D,removed:S,overrides:b}=c(this.localUserConfiguration,m),k=[...$,...D,...S];return k.length&&this.updateLocalUserConfiguration(m),{keys:k,overrides:b}}compareAndUpdateRemoteUserConfiguration(m){const{added:$,updated:D,removed:S,overrides:b}=c(this.remoteUserConfiguration,m),k=[...$,...D,...S];return k.length&&this.updateRemoteUserConfiguration(m),{keys:k,overrides:b}}compareAndUpdateWorkspaceConfiguration(m){const{added:$,updated:D,removed:S,overrides:b}=c(this.workspaceConfiguration,m),k=[...$,...D,...S];return k.length&&this.updateWorkspaceConfiguration(m),{keys:k,overrides:b}}compareAndUpdateFolderConfiguration(m,$){const D=this.folderConfigurations.get(m),{added:S,updated:b,removed:k,overrides:P}=c(D,$),f=[...S,...b,...k];return(f.length||!D)&&this.updateFolderConfiguration(m,$),{keys:f,overrides:P}}compareAndDeleteFolderConfiguration(m){const $=this.folderConfigurations.get(m);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:D,updated:S,removed:b,overrides:k}=c($,void 0);return{keys:[...D,...S,...b],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,$,D){let S=this.x($,D);return $.overrideIdentifier&&(S=S.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(S=S.merge(this.l)),S}x({resource:m},$){let D=this.y();if($&&m){const S=$.getFolder(m);S&&(D=this.z(S.uri)||D);const b=this.t.get(m);b&&(D=D.merge(b))}return D}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let $=this.i.get(m);if(!$){const D=this.y(),S=this.r.get(m);S?($=D.merge(S),this.i.set(m,$)):$=D}return $}A(m,$){if($&&m){const D=$.getFolder(m);if(D)return this.r.get(D.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,$)=>{const{contents:D,overrides:S,keys:b}=this.r.get($);return m.push([$,{contents:D,overrides:S,keys:b}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach($=>m.add($)),this.userConfiguration.keys.forEach($=>m.add($)),this.q.keys.forEach($=>m.add($)),this.r.forEach($=>$.keys.forEach(D=>m.add(D))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>m.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>m.add($)),this.q.getAllOverrideIdentifiers().forEach($=>m.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(D=>m.add(D))),[...m.values()]}D(m){const $=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(D=>$.add(D)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(D=>$.add(D)),this.q.getKeysForOverrideIdentifier(m).forEach(D=>$.add(D)),this.r.forEach(D=>D.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S))),[...$.values()]}static parse(m,$){const D=this.E(m.defaults,$),S=this.E(m.policy,$),b=this.E(m.application,$),k=this.E(m.user,$),P=this.E(m.workspace,$),f=m.folders.reduce((w,F)=>(w.set(a.URI.revive(F[0]),this.E(F[1],$)),w),new A.$Dc);return new i(D,S,b,k,n.createEmptyModel($),P,f,n.createEmptyModel($),new A.$Dc,$)}static E(m,$){return new n(m.contents,m.keys,m.overrides,void 0,$)}}e.$Po=i;function r(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const m=new Set,$=new Map;for(const S of g)S.keys.forEach(b=>m.add(b)),S.overrides.forEach(([b,k])=>{const P=(0,A.$Ac)($,b,new Set);k.forEach(f=>P.add(f))});const D=[];return $.forEach((S,b)=>D.push([b,[...S.values()]])),{keys:[...m.values()],overrides:D}}class t{constructor(m,$,D,S,b){this.change=m,this.f=$,this.g=D,this.h=S,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of m.keys)this.affectedKeys.add(k);for(const[,k]of m.overrides)for(const P of k)this.affectedKeys.add(P);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,$){const D=this.a+m,S=this.d.indexOf(D);if(S<0)return!1;const b=S+D.length;if(b>=this.d.length)return!1;const k=this.d.charCodeAt(b);if(k!==this.b&&k!==this.c)return!1;if($){const P=this.previousConfiguration?this.previousConfiguration.getValue(m,$,this.f?.workspace):void 0,f=this.g.getValue(m,$,this.h);return!T.$io(P,f)}return!0}}e.$Ro=t;function c(g,m){const{added:$,removed:D,updated:S}=l(m?.rawConfiguration,g?.rawConfiguration),b=[],k=g?.getAllOverrideIdentifiers()||[],P=m?.getAllOverrideIdentifiers()||[];if(m){const f=P.filter(w=>!k.includes(w));for(const w of f)b.push([w,m.getKeysForOverrideIdentifier(w)])}if(g){const f=k.filter(w=>!P.includes(w));for(const w of f)b.push([w,g.getKeysForOverrideIdentifier(w)])}if(m&&g){for(const f of k)if(P.includes(f)){const w=l({contents:g.getOverrideValue(void 0,f)||{},keys:g.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});b.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:D,updated:S,overrides:b}}function l(g,m){const $=g?m?g.keys.filter(b=>m.keys.indexOf(b)===-1):[...g.keys]:[],D=m?g?m.keys.filter(b=>g.keys.indexOf(b)===-1):[...m.keys]:[],S=[];if(g&&m){for(const b of m.keys)if(g.keys.indexOf(b)!==-1){const k=(0,R.$ij)(m.contents,b),P=(0,R.$ij)(g.contents,b);T.$io(k,P)||S.push(b)}}return{added:$,removed:D,updated:S}}}),define(Ie[110],Pe([1,0,14,3]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=a,e.$Rl=(0,I.$Gi)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class N{constructor(y){this.id=y,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=N;class A{constructor(y,u){this.host=y,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends v.$eb{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,u=T.Unknown,E){super(y),this._message=y,this._code=u,this._detail=E,this.isHandled=u===T.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ul=p;function a(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(Ie[63],Pe([1,0,16]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=I,e.$in=C,e.$jn=N,e.$kn=A;function I(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function C(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function N(p){const{host:a,port:R}=T(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:R}}function A(p,a){let{host:R,port:y}=T(p);return typeof y>"u"&&(y=a),{host:R,port:y}}function T(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ie[19],Pe([1,0,13,3,63]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=N,e.$un=y,e.$vn=u,e.$wn=E,e.$xn=d,e.$yn=n,e.$zn=s,v=Ve(v),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function N(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(o){o.WIN32_X64="win32-x64",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,i){if(typeof h>"u"||h===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof h=="string"||typeof i=="string"){const r=typeof h=="string"?h:h.value,t=typeof i=="string"?i:i.value;return v.$Hf(r,t)}return h._lower===i._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$rn=p;class a{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const i of h)this.add(i)}add(h){this.c.add(p.toKey(h))}delete(h){return this.c.delete(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}}e.$sn=a;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(p.toKey(h))}get(h){return this.c.get(p.toKey(h))}has(h){return this.c.has(p.toKey(h))}set(h,i){this.c.set(p.toKey(h),i)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=R;function y(o){return u(o)}function u(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}function E(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}function d(o,h){if(h){const i=`onResolveRemoteAuthority:${(0,C.$in)(h)}`;return!!o.activationEvents?.includes(i)}return!1}function n(o){return o.map(h=>{const[i,r]=h.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function s(o){return o.map(h=>h.split("@")[0])}e.$An=(0,I.$Gi)("IBuiltinExtensionsScannerService")}),define(Ie[111],Pe([1,0,21,172,19,3]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=T,e.$ep=p,e.$fp=a,e.$gp=R,e.$hp=y,e.$ip=u,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function p(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function a(t,c){switch(t){case v.Platform.Windows:return c==="x64"?C.TargetPlatform.WIN32_X64:c==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Linux:return c==="x64"?C.TargetPlatform.LINUX_X64:c==="arm64"?C.TargetPlatform.LINUX_ARM64:c==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return c==="x64"?C.TargetPlatform.ALPINE_X64:c==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Mac:return c==="x64"?C.TargetPlatform.DARWIN_X64:c==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Web:return C.TargetPlatform.WEB}}function R(t,c){return c===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function y(t,c,l){return R(c,l)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$jp=(0,N.$Gi)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class h extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$kp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$lp=r,e.$mp=(0,N.$Gi)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,N.$Gi)("IGlobalExtensionEnablementService"),e.$qp=(0,N.$Gi)("IExtensionTipsService"),e.$rp=(0,I.localize2)(0,"Extensions"),e.$sp=(0,I.localize2)(1,"Preferences")}),define(Ie[112],Pe([1,0,14,19]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const a=this.readActivationEvents(p);a.length>0&&(T[I.$rn.toKey(p.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${I.$rn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const a=this.a.get(p);if(!a)continue;const R=A.contributes[p],y=Array.isArray(R)?R:[R];try{a(y,T)}catch(u){(0,v.$3)(u)}}return T}}e.$LG=C,e.$MG=new C});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[216],Pe([1,0,24,36,173,323,19,105]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=R,e.$Yp=y,e.$Zp=u,e.$1p=E,e.$2p=d,e.$3p=n,e.$4p=s,e.$5p=o,I=_t(I),C=Ve(C),N=Ve(N);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function R(r){return r=r.trim(),r==="*"||p.test(r)}function y(r){if(!R(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(r){if(!r)return null;const t=r.majorBase,c=r.majorMustEqual,l=r.minorBase;let g=r.minorMustEqual;const m=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(g=!1),$=!1);let D=0;if(r.preRelease){const S=a.exec(r.preRelease);if(S){const[,b,k,P]=S;D=Date.UTC(Number(b),Number(k)-1,Number(P))}}return{majorBase:t,majorMustEqual:c,minorBase:l,minorMustEqual:g,patchBase:m,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:D}}function E(r,t,c){let l;typeof r=="string"?l=u(y(r)):l=r;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let m;if(typeof c=="string"?m=u(y(c)):m=c,!l||!m)return!1;const $=l.majorBase,D=l.minorBase,S=l.patchBase;let b=m.majorBase,k=m.minorBase,P=m.patchBase;const f=m.notBefore;let w=m.majorMustEqual,F=m.minorMustEqual,O=m.patchMustEqual;return m.isMinimum?$>b?!0:$<b?!1:D>k?!0:D<k||g&&g<f?!1:S>=P:($===1&&b===0&&(!w||!F||!O)&&(b=1,k=0,P=0,w=!0,F=!1,O=!1),$<b?!1:$>b?!w:D<k?!1:D>k?!F:S<P?!1:S>P?!O:!(g&&g<f))}function d(r,t,c,l,g){const m=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return m.push([I.default.Error,C.localize(0,null)]),m;if(typeof l.name!="string")return m.push([I.default.Error,C.localize(1,null,"name")]),m;if(typeof l.version!="string")return m.push([I.default.Error,C.localize(2,null,"version")]),m;if(!l.engines)return m.push([I.default.Error,C.localize(3,null,"engines")]),m;if(typeof l.engines.vscode!="string")return m.push([I.default.Error,C.localize(4,null,"engines.vscode")]),m;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return m.push([I.default.Error,C.localize(5,null,"extensionDependencies")]),m;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return m.push([I.default.Error,C.localize(6,null,"activationEvents")]),m;if(typeof l.main>"u"&&typeof l.browser>"u")return m.push([I.default.Error,C.localize(7,null,"activationEvents","main","browser")]),m}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&m.push([I.default.Warning,C.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return m.push([I.default.Error,C.localize(9,null,"main")]),m;{const S=(0,v.$hh)(c,l.main);(0,v.$bh)(S,c)||m.push([I.default.Warning,C.localize(10,null,S.path,c.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return m.push([I.default.Error,C.localize(11,null,"browser")]),m;{const S=(0,v.$hh)(c,l.browser);(0,v.$bh)(S,c)||m.push([I.default.Warning,C.localize(12,null,S.path,c.path)])}}if(!N.valid(l.version))return m.push([I.default.Error,C.localize(13,null)]),m;const $=[];if(!n(r,t,l,g,$))for(const S of $)m.push([I.default.Error,S]);if(l.enabledApiProposals?.length){const S=[];if(!o([...l.enabledApiProposals],S))for(const b of S)m.push([I.default.Error,b])}return m}function n(r,t,c,l,g){return l||typeof c.main>"u"&&typeof c.browser>"u"?!0:h(r,t,c.engines.vscode,g)}function s(r,t,c){return r==="*"||h(t,c,r)}function o(r,t){if(r.length===0)return!0;const c=Array.isArray(t)?t:void 0,l=(c?void 0:t)??T.allApiProposals,g=[],m=(0,A.$yn)(r);for(const{proposalName:$,version:D}of m){const S=l[$];S&&D&&S.version!==D&&g.push(C.localize(14,null,$))}return c?.push(...g),g.length===0}function h(r,t,c,l=[]){const g=u(y(c));if(!g)return l.push(C.localize(15,null,c)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(C.localize(16,null,c)),!1}else if(!g.majorMustEqual)return l.push(C.localize(17,null,c)),!1;return E(r,t,g)?!0:(l.push(C.localize(18,null,r,c)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,c=r.length;t<c;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ie[217],Pe([1,0,23,14,4,177,54,3,12,31]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=u,e.$9p=E,e.$0p=d,e.$$p=n,e.$_p=s,e.$aq=o,e.$6p=(0,T.$Gi)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const c in this.b)c.toLowerCase()==="authorization"||c.toLowerCase()==="proxy-authorization"?t[c]="*****":t[c]=this.b[c];this.a=t}return this.a}}class y extends C.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,N.localize)(0,null),when:p.$sk.isEqualTo((0,p.$pk)(p.LogLevel.Trace)).serialize()})}async c(t,c,l){const g=`${t} #${++this.b}: ${c.url}`;this.a.trace(`${g} - begin`,c.type,new R(c.headers??{}));try{const m=await l();return this.a.trace(`${g} - end`,c.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${g} - error`,c.type,(0,I.$ab)(m)),m}}}e.$7p=y;function u(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function E(r){return r.res.statusCode===204}async function d(r){return E(r)?null:(await(0,v.$2e)(r.stream)).toString()}async function n(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function s(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);if(E(r))return null;const c=(await(0,v.$2e)(r.stream)).toString();try{return JSON.parse(c)}catch(l){throw l.message+=`:
`+c,l}}function o(r){i(r)}let h;function i(r){const t=a.$ro.as(A.$wo.Configuration),c=h;h={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null),(0,N.localize)(10,null)],default:"override",description:(0,N.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:c?[c]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ie[218],Pe([1,0,21,79,37]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=A,e.$up=T;function N(p){if(v.$u===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,a,R,y,u,E,d,n,s,o){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=n,h.sessionID=(0,C.$3g)()+Date.now(),h.commitHash=y,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.$h)(v.$u),h["common.nodePlatform"]=I.$gc,h["common.nodeArch"]=R,h["common.product"]=o||"desktop",s&&(h["common.msftInternal"]=s);let i=0;const r=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$l&&(h["common.snap"]="true");const t=N(a);return t&&(h["common.platformDetail"]=t),h}function T(p){const a=I.env.USERDNSDOMAIN;if(!a)return!1;const R=a.toLowerCase();return p.some(y=>R===y)}}),define(Ie[113],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,v.$Gi)("telemetryService"),e.$am=(0,v.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var I;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var C;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ie[64],Pe([1,0,26,15,63,218,113]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=R,e.$Dp=y,e.$Ep=u,e.$Fp=E,e.$Gp=n,e.$Hp=o,e.$Ip=h,e.$Jp=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$vp=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=p,e.$xp=new p;class a{async publicLog(l,g,m){}async publicLogError(l,g,m){}}e.$yp=a,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function R(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}function y(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}function u(c){const l=c.getValue(A.$im),g=c.getValue(A.$jm);if(c.getValue(A.$km)===!1||g===!1)return A.TelemetryLevel.NONE;switch(l??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(c){const l={},g={},m={};s(c,m);for(let $ in m){$=$.length>150?$.substr($.length-149):$;const D=m[$];typeof D=="number"?g[$]=D:typeof D=="boolean"?g[$]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${D.length}`),l[$]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(l[$]=D)}return{properties:l,measurements:g}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(c){if(!c)return"none";const l=(0,C.$in)(c);return d.has(l)?l:"other"}function s(c,l,g=0,m){if(c)for(const $ of Object.getOwnPropertyNames(c)){const D=c[$],S=m?m+$:$;Array.isArray(D)?l[S]=(0,v.$jo)(D):D instanceof Date?l[S]=D.toISOString():(0,I.$ig)(D)?g<2?s(D,l,g+1,S+"."):l[S]=(0,v.$jo)(D):l[S]=D}}function o(c,l){const g=c.msftInternalDomains||[],m=l.getValue("telemetry.internalTesting");return(0,N.$up)(g)||m}function h(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}function i(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let g=c;const m=[];for(const b of l)for(;;){const k=b.exec(c);if(!k)break;m.push([k.index,b.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(g="";;){const b=D.exec(c);if(!b)break;const k=m.some(([P,f])=>b.index<f&&P<D.lastIndex);!$.test(b[0])&&!k&&(g+=c.substring(S,b.index)+"<REDACTED: user-file-path>",S=D.lastIndex)}return S<c.length&&(g+=c.substr(S)),g}function r(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(c))return`<REDACTED: ${g.label}>`;return c}function t(c,l){return(0,v.$go)(c,g=>{if(g instanceof T||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let m=g.replaceAll("%20"," ");m=i(m,l);for(const $ of l)m=m.replace($,"");return m=r(m),m}})}}),define(Ie[219],Pe([1,0,13,111,19,21,2,14,79,64]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=R,e.$Mp=d,e.$Np=n,e.$Op=s,e.$Pp=o,e.$Qp=h,e.$Rp=i,e.$Sp=r,e.$Up=t,e.$Vp=l;function R(g,m){return g.uuid&&m.uuid?g.uuid===m.uuid:g.id===m.id?!0:(0,v.$Cf)(g.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(m){const $=m.manifest?m.manifest.version:m.version,D=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new u(m.identifier,$,D)}static parse(m){const $=y.exec(m);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(m,$,D=C.TargetPlatform.UNDEFINED){this.identifier=m,this.version=$,this.targetPlatform=D,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof u?R(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Lp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(g){const m=E.exec(g);return m&&m[1]?[s(m[1]),m[2]]:[s(g),void 0]}function n(g,m){return`${g}.${m}`}function s(g){return g.toLowerCase()}function o(g,m){return s(n(g??C.$nn,m))}function h(g,m){const $=[],D=S=>{for(const b of $)if(b.some(k=>R(m(k),m(S))))return b;return null};for(const S of g){const b=D(S);b?b.push(S):$.push([S])}return $}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function r(g){return{id:new a.$vp(g.identifier.id),name:new a.$vp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Tp=new C.$rn("pprice.better-merge");function t(g,m){const $=[],D=m.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const S=D.shift();if(S&&$.every(b=>!R(b.identifier,{id:S}))){const b=g.filter(k=>R(k.identifier,{id:S}));b.length===1&&($.push(b[0]),D.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function c(g,m){if(!N.$k)return!1;let $;try{$=(await g.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await g.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){m.debug("Error while getting the os-release file.",(0,T.$ab)(S))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(g,m){const $=await c(g,m),D=(0,I.$fp)($?"alpine":N.$u,p.$hc);return m.debug("ComputeTargetPlatform:",D),D}}),define(Ie[220],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=v,e.$Es=I,e.$Fs=C,e.$Gs=N,e.$Hs=A,e.$Is=T;function v(p){return[...p.entries()]}function I(p){return p?[...p.entries()]:[]}function C(p){return new Map(p)}function N(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(a=>[a[0],v(a[1].map),I(a[1].descriptionMap)])}function T(p){return new Map(p.map(a=>[a[0],{map:C(a[1]),descriptionMap:N(a[2])}]))}}),define(Ie[221],Pe([1,0,3,32,31]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new I.$Xj("terminalTabFocusMode",!1,!0);var N;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(N||(e.TerminalSettingPrefix=N={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ns=(0,v.$Gi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var o;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(o||(e.ProfileSource=o={}));var h;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const l=this.b(c.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}C.$ro.add(e.$os.Backend,new r),e.$ps=(0,v.$Gi)("localPtyService"),e.$qs=(0,v.$Gi)("terminalLogService")}),define(Ie[222],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Axb=void 0;class v{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,N,A=5){const T=N(p=>{const a=typeof p=="string"?p:p.data;let R=this.a.get(C);if(R){R.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(C),A);R={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(C),T.dispose()}},this.a.set(C,R)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const N=this.a.get(C);N&&(this.a.delete(C),this.b(C,N.data.join("")))}}e.$Axb=v}),define(Ie[223],Pe([1,0,11,98,324,35,6,15,2,178,78,31]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.IconFontDefinition=e.IconContribution=e.$xx=void 0,e.$yx=s,e.$zx=o,y=Ve(y),e.$xx={IconContribution:"base.contributions.icons"};var u;(function(t){function c(l,g){let m=l.defaults;for(;N.ThemeIcon.isThemeIcon(m);){const $=n.getIcon(m.id);if(!$)return;m=$.defaults}return m}t.getDefinition=c})(u||(e.IconContribution=u={}));var E;(function(t){function c(g){return{weight:g.weight,style:g.style,src:g.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=c;function l(g){const m=$=>(0,T.$gg)($)?$:void 0;if(g&&Array.isArray(g.src)&&g.src.every($=>(0,T.$gg)($.format)&&(0,T.$gg)($.location)))return{weight:m(g.weight),style:m(g.style),src:g.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}t.fromJSONObject=l})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$ne,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,l,g,m){const $=this.b[c];if($){if(g&&!$.description){$.description=g,this.d.properties[c].markdownDescription=`${g} $(${c})`;const b=this.e.enum.indexOf(c);b!==-1&&(this.e.enumDescriptions[b]=g),this.a.fire()}return $}const D={id:c,description:g,defaults:l,deprecationMessage:m};this.b[c]=D;const S={$ref:"#/definitions/icons"};return m&&(S.deprecationMessage=m),g&&(S.markdownDescription=`${g}: $(${c})`),this.d.properties[c]=S,this.e.enum.push(c),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const l=this.e.enum.indexOf(c);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,l){const g=this.f[c];return g||(this.f[c]=l,this.a.fire(),l)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=($,D)=>$.id.localeCompare(D.id),l=$=>{for(;N.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map($=>this.b[$]);for(const $ of m.filter(D=>!!D.description).sort(c))g.push(`|<i class="${l($)}"></i>|${$.id}|${N.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const $ of m.filter(D=>!N.ThemeIcon.isThemeIcon(D.defaults)).sort(c))g.push(`|<i class="${l($)}"></i>|${$.id}|`);return g.join(`
`)}}const n=new d;y.$ro.add(e.$xx.IconContribution,n);function s(t,c,l,g){return n.registerIcon(t,c,l,g)}function o(){return n}function h(){const t=(0,C.$2j)();for(const c in t){const l="\\"+t[c].toString(16);n.registerIcon(c,{fontCharacter:l})}}h(),e.$Ax="vscode://schemas/icons";const i=y.$ro.as(R.$so.JSONContribution);i.registerSchema(e.$Ax,n.getIconSchema());const r=new v.$Sh(()=>i.notifySchemaChanged(e.$Ax),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Bx=s("widget-close",I.$6j.close,(0,a.localize)(2,null)),e.$Cx=s("goto-previous-location",I.$6j.arrowUp,(0,a.localize)(3,null)),e.$Dx=s("goto-next-location",I.$6j.arrowDown,(0,a.localize)(4,null)),e.$Ex=N.ThemeIcon.modify(I.$6j.sync,"spin"),e.$Fx=N.ThemeIcon.modify(I.$6j.loading,"spin")}),define(Ie[224],Pe([1,0,6,4,21,2,43,3,12]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=y,e.$Ew=E,e.$Fw=d,e.$Hw=n,e.$Jw=s,e.$Kw=o,e.$Bw=(0,T.$Gi)("tunnelService"),e.$Cw=(0,T.$Gi)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var u;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const c of t){const l=c.split("=")[1];if(/^https?:/.exec(l)){const g=E(N.URI.parse(l));if(g)return g}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Gw.indexOf(r)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(r){return e.$Iw.indexOf(r)>=0}function o(r,t,c,l){if(c===C.OperatingSystem.Windows)return!1;if(c===C.OperatingSystem.Macintosh&&s(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(g?.length===4&&parseInt(g[1])>=18)return!1}return r<1024}class h{constructor(t,c,l){this.remoteAddress=t,this.localAddress=c,this.b=l,this.a=new v.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=h;let i=class extends I.$Xc{constructor(t,c){super(),this.r=t,this.s=c,this.a=new v.$ne,this.onTunnelOpened=this.a.event,this.b=new v.$ne,this.onTunnelClosed=this.b.event,this.c=new v.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],c=Array.from(this.f.values());for(const l of c){const g=Array.from(l.values());for(const m of g){const $=await m.value;$&&typeof $!="string"&&t.push($)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:c}of t.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,c,l,g,m){this.z(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:l,privacy:g,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(s(t)||n(t))&&(t=e.$Gw[0]);const l=this.D(t,c);if(l)return++l.refcount,l.value}openTunnel(t,c,l,g,m,$=!1,D,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${m}.`);const b=this.g??t;if(!b)return;if(c||(c="localhost"),g||(g=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(b,c,l,g,m,$,D,S);return k?k.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(c,l),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(c,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(P);return(P.tunnelRemoteHost!==c||P.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),D&&P.privacy!==D&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.f.get(t.tunnelRemoteHost);if(c){const l=c.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,c,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const g=l.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(c),g}}async closeTunnel(t,c){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const l=this.f.get(t);if(l&&l.has(c)){const g=l.get(c);g.refcount=0,await this.y(t,c,g)}}z(t,c,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(c,{refcount:1,value:l})}async C(t,c){const l=this.f.get(t);if(l){const g=l.get(c),m=g?await g.value:void 0;(!m||typeof m=="string")&&l.delete(c),l.size===0&&this.f.delete(t)}}D(t,c){const l=[t];n(t)?(l.push(...e.$Gw),l.push(...e.$Iw)):s(t)&&l.push(...e.$Iw);const g=l.map(m=>this.f.get(m));for(const m of g){const $=m?.get(c);if($)return $}}canTunnel(t){return!!E(t)}G(t,c,l,g,m,$,D){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${g}.`);const S=l;this.n.add(S);const b=g===void 0?l:g,k={elevationRequired:m?this.isPortPrivileged(b):!1},P={remoteAddress:{host:c,port:l},localAddressPort:g,privacy:$,public:$?$!==R.Private:void 0,protocol:D},f=t.forwardPort(P,k);return f?(this.z(c,l,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),f}};e.$Mw=i,e.$Mw=i=He([qe(0,p.$ak),qe(1,A.$aj)],i)}),define(Ie[225],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,v.$Gi)("IUriIdentityService")}),define(Ie[226],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nw=void 0,e.$Nw=(0,v.$Gi)("editSessionIdentityService");var I;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(I||(e.EditSessionIdentityMatch=I={}))}),define(Ie[227],Pe([1,0,16]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=I,e.$5M=C,e.$6M=N,e.$7M=A,e.$8M=T;function I(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function C(p){if(p.folders.length)return p.folders.every(a=>I(a.uri))?p.folders[0].uri:void 0;if(p.configuration&&I(p.configuration))return p.configuration}function N(p){return C(p)?.scheme}function A(p){return C(p)?.authority}function T(p){return C(p)!==void 0}}),define(Ie[50],Pe([1,0,180,20,59,24,2,3,16]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=a,e.$Ri=R,e.$Ui=y,e.$Vi=u,e.$Wi=E,e.$Xi=n,e.$Yi=s,e.$2i=i,e.$7i=r,e.$8i=t,e.$0i=c,e.$$i=l,e.$_i=g,e.$Pi=(0,T.$Gi)("contextService");function a(m){const $=m;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(m){return typeof m?.id=="string"&&!a(m)&&!u(m)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function y(m,$){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,I.$qc)(m)}:$?e.$Si:e.$Ti;const D=m;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}function u(m){const $=m;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(m){const $=m;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const D=m;if(D?.configPath)return{id:D.id,configPath:A.URI.revive(D.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(m){const $=m;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,D,S,b,k){this.h=$,this.j=S,this.k=b,this.l=k,this.c=C.$Mi.forUris(this.l,()=>!0),this.folders=D}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=C.$Mi.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=o;class h{constructor($,D){this.raw=D,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,N.$hh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=h;function i(m){return new h({uri:m,index:0,name:(0,N.$dh)(m)},{uri:m.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,v.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function r(m,$){return N.$$g.isEqualOrParent(m,$.untitledWorkspacesHome)}function t(m){let $;return A.URI.isUri(m)?$=m:$=m.configuration,$?.scheme===p.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function c(m){return m.id===e.$9i}function l(m,$){return!r(m,$)&&!t(m)}function g(m){return(typeof m=="string"?(0,I.$rc)(m):(0,N.$fh)(m))===e.$4i}}),define(Ie[114],Pe([1,0,76,6,4,24,2,179,107,30,3,12,50,29,225,11,37,13,15]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=r,e.$Nl=t,e.$Ol=c;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Ml=(0,R.$Gi)("IUserDataProfilesService");function t(m,$){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:$}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:$}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function c(m,$,D,S,b,k){return{id:m,name:$,location:D,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:k&&b?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$hh)(D,"globalStorage"),settingsResource:k&&b?.useDefaultFlags?.settings?k.settingsResource:(0,N.$hh)(D,"settings.json"),keybindingsResource:k&&b?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$hh)(D,"keybindings.json"),tasksResource:k&&b?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$hh)(D,"tasks.json"),snippetsHome:k&&b?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$hh)(D,"snippets"),extensionsResource:k&&b?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$hh)(D,"extensions.json"),cacheHome:(0,N.$hh)(S,m),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let l=class extends C.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,D,S,b){super(),this.t=$,this.u=D,this.w=S,this.y=b,this.f=!0,this.h=this.B(new I.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Dc,workspaces:new E.$Dc,emptyWindows:new Map},this.profilesHome=(0,N.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),D=[$];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,h.$gg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}D.push(c((0,N.$eh)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},$))}}catch(k){this.y.error(k)}const S=new E.$Dc,b=new Map;if(D.length)try{const k=this.Q();if(k.workspaces)for(const[P,f]of Object.entries(k.workspaces)){const w=A.URI.parse(P),F=D.find(O=>O.id===f);F&&S.set(w,F)}if(k.emptyWindows)for(const[P,f]of Object.entries(k.emptyWindows)){const w=D.find(F=>F.id===f);w&&b.set(P,w)}}catch(k){this.y.error(k)}this.z={profiles:D,workspaces:S,emptyWindows:b}}return this.z}D(){const $=c("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const D="Temp",S=new RegExp(`${(0,o.$jf)(D)}\\s(\\d+)`);let b=0;for(const P of this.profiles){const f=S.exec(P.name),w=f?parseInt(f[1]):0;b=w>b?w:b}const k=`${D} ${b+1}`;return this.createProfile((0,v.$uj)((0,s.$3g)()).toString(16),k,{transient:!0},$)}async createNamedProfile($,D,S){return this.createProfile((0,v.$uj)((0,s.$3g)()).toString(16),$,D,S)}async createProfile($,D,S,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F($,D,S);return b&&await this.setProfileForWorkspace(b,k),k}async F($,D,S){if(!(0,h.$gg)(D)||!D)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(D);return b||(b=(async()=>{try{if(this.profiles.find(w=>w.name===D||w.id===$))throw new Error(`Profile with ${D} name already exists`);const P=c($,D,(0,N.$hh)(this.profilesHome,$),this.g,S,this.defaultProfile);await this.u.createFolder(P.location);const f=[];return this.j.fire({profile:P,join(w){f.push(w)}}),await n.Promises.settled(f),this.I([P],[],[]),P}finally{this.r.delete(D)}})(),this.r.set(D,b)),b}async updateProfile($,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(b=>b.id===$.id);if(!S)throw new Error(`Profile '${$.name}' does not exist`);return S=c(S.id,D.name??S.name,S.location,this.g,{shortName:D.shortName??S.shortName,icon:D.icon===null?void 0:D.icon??S.icon,transient:D.transient??S.isTransient,useDefaultFlags:D.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const D=this.profiles.find(b=>b.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);const S=[];this.m.fire({profile:D,join(b){S.push(b)}});try{await Promise.allSettled(S)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])D.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])D.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[D],[]);try{await this.u.del(D.cacheHome,{recursive:!0})}catch(b){(0,a.$rl)(b)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace($,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(b=>b.id===D.id);if(!S)throw new Error(`Profile '${D.name}' does not exist`);this.L($,S)}unsetWorkspace($,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,D)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(D=>D.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,D.resource))).map(D=>this.u.del(D.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(D=>!this.H(D));await Promise.allSettled($.map(D=>this.removeProfile(D)))}getProfileForWorkspace($){const D=this.G($),S=A.URI.isUri(D)?this.C.workspaces.get(D):this.C.emptyWindows.get(D);return S||((0,u.$Qi)($)?this.s.folders.get($.uri):(0,u.$Vi)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Qi)($)?$.uri:(0,u.$Vi)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(D=>this.w.extUri.isEqual(D.location,$.location))||[...this.C.workspaces.values()].some(D=>this.w.extUri.isEqual(D.location,$.location))||[...this.s.emptyWindows.values()].some(D=>this.w.extUri.isEqual(D.location,$.location))||[...this.s.workspaces.values()].some(D=>this.w.extUri.isEqual(D.location,$.location))||[...this.s.folders.values()].some(D=>this.w.extUri.isEqual(D.location,$.location)))}I($,D,S){const b=[...this.profiles,...$],k=[],P=this.s.profiles;this.s.profiles=[];for(let f of b){if(f.isDefault||D.some(F=>f.id===F.id))continue;f=S.find(F=>f.id===F.id)??f;const w=P.find(F=>f.id===F.id);if(f.isTransient)this.s.profiles.push(f);else{if(w){for(const[F,O]of this.s.emptyWindows.entries())if(f.id===O.id){this.L({id:F},f);break}for(const[F,O]of this.s.workspaces.entries())if(f.id===O.id){this.L({id:"",configPath:F},f);break}for(const[F,O]of this.s.folders.entries())if(f.id===O.id){this.L({id:"",uri:F},f);break}}k.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(k),this.z=void 0,this.J($,D,S)}J($,D,S){this.h.fire({added:$,removed:D,updated:S,all:this.profiles})}L($,D,S){if(S=D?.isTransient?!0:S,S)(0,u.$Qi)($)?(this.s.folders.delete($.uri),D&&this.s.folders.set($.uri,D)):(0,u.$Vi)($)?(this.s.workspaces.delete($.configPath),D&&this.s.workspaces.set($.configPath,D)):(this.s.emptyWindows.delete($.id),D&&this.s.emptyWindows.set($.id,D));else{this.L($,void 0,!0);const b=this.G($);A.URI.isUri(b)?(this.C.workspaces.delete(b),D&&this.C.workspaces.set(b,D)):(this.C.emptyWindows.delete(b),D&&this.C.emptyWindows.set(b,D)),this.M()}}M(){const $={};for(const[S,b]of this.C.workspaces.entries())$[S.toString()]=b.id;const D={};for(const[S,b]of this.C.emptyWindows.entries())D[S.toString()]=b.id;this.R({workspaces:$,emptyWindows:D}),this.z=void 0}N($){const D={},S=this.D();if($.workspaces)for(const[k,P]of Object.entries($.workspaces)){const f=A.URI.parse(P);D[k]=this.w.extUri.isEqual(f,S.location)?S.id:this.w.extUri.basename(f)}const b={};if($.emptyWindows)for(const[k,P]of Object.entries($.emptyWindows)){const f=A.URI.parse(P);b[k]=this.w.extUri.isEqual(f,S.location)?S.id:this.w.extUri.basename(f)}return{workspaces:D,emptyWindows:b}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Pl=l,e.$Pl=l=He([qe(0,p.$Ni),qe(1,a.$al),qe(2,d.$Kl),qe(3,y.$ak)],l);class g extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Ql=g}),define(Ie[228],Pe([1,0,11,6,4,65,15,162,3,114]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=E,e.$jq=n,e.$lq=o,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,p.$Gi)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$fq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends C.$Xc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new I.$qe),this.c=this.B(new I.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return I.Event.filter(this.b.event,c=>c.scope===i&&(r===void 0||c.key===r),t)}n(){this.j.value=(0,v.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:c}=r;if(t===e.$fq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:c})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,c,l=!1){if((0,A.$pg)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,c),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],c=this.J(i);for(const l of Object.keys(c))c[l]===r&&t.push(l);return t}z(i,r,t,c=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$fq,JSON.stringify(l),c)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$fq,JSON.stringify(l),c))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$eq,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),c=this.P(y.WORKSPACE);switch(i){case R.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return o(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,a.$Ll)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const c=new Set;for(const[l,g]of i)c.add(l),r.get(l)!==g&&this.u(t,{key:l,external:!0});for(const[l]of r.items)c.has(l)||this.u(t,{key:l,external:!0})})}}e.$iq=d;function n(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$kq=s;async function o(h,i,r,t,c,l){const g=w=>{try{return JSON.parse(w)}catch{return w}},m=new Map,$=new Map;h.forEach((w,F)=>{m.set(F,w),$.set(F,g(w))});const D=new Map,S=new Map;i.forEach((w,F)=>{D.set(F,w),S.set(F,g(w))});const b=new Map,k=new Map;r.forEach((w,F)=>{b.set(F,w),k.set(F,g(w))}),console.group(t!==c?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(m.forEach((w,F)=>{P.push({key:F,value:w})}),console.table(P),console.groupEnd(),console.log($),t!==c){console.group(`Storage: Profile (path: ${c}, profile specific)`);const w=[];D.forEach((F,O)=>{w.push({key:O,value:F})}),console.table(w),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${l})`);const f=[];b.forEach((w,F)=>{f.push({key:F,value:w})}),console.table(f),console.groupEnd(),console.log(k)}}),define(Ie[80],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;class v{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const N=this.c++;return this.b.set(N,C),this.e(),N}get(C,N){return this.b.has(C)?this.b.get(C)[N]:void 0}delete(C){this.b.delete(C),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$noc=v}),define(Ie[51],Pe([1,0,16,24,30,3]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new I.$9g(p=>{const a=this.b.get(p.scheme);return!(a===void 0||a&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,a){a===null?this.b.delete(p.scheme):this.b.set(p.scheme,a)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$soc=A,e.$toc=(0,N.$Gi)("IExtHostFileSystemInfo")}),define(Ie[27],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,v.$Gi)("IExtHostInitDataService")}),define(Ie[229],Pe([1,0,185,12,213,27]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;let A=class extends C.$oR{constructor(p,a,R){const y=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=R.remote.isRemote?(0,v.localize)(0,null):p?(0,v.localize)(1,null):(0,v.localize)(2,null);super(a.createLogger(y,{name:u}))}};e.$Bqc=A,e.$Bqc=A=He([qe(1,I.$bk),qe(2,N.$eQ)],A)}),define(Ie[230],Pe([1,0,11]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0;class I{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new v.$Sh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of a.values())R.complete()}catch(R){for(const y of a.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const a=new v.$4h;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$$oc=I;class C extends I{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$_oc=C}),define(Ie[231],Pe([1,0,6,2]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class C{constructor(A){this.c=A,this.a=new v.$ne,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$ne,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,a){const y=this.c.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(T.value,p,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(I.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(I.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$6pc=C}),define(Ie[17],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,v.$Gi)("IExtHostRpcService");class I{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$2P=I}),define(Ie[232],Pe([1,0,19,6,4]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0;class N{#e;constructor(T,p){this.disposables=new C.$Wc,this.a=v.$rn.toKey(T.identifier),this.#e=p,this.onDidChange=I.Event.map(I.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this.a),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,p){return this.#e.store(this.a,T,p)}delete(T){return this.#e.delete(this.a,T)}}e.$ipc=N}),define(Ie[66],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0,e.$Ioc=(0,v.$Gi)("IURITransformerService");class I{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Joc=I});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[115],Pe([1,0,194,15,2,4,3,31,30,16,41,156,36]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=n,e.$XF=s,e.$YF=o,e.$ZF=h,e.$1F=i,e.$2F=r,e.$3F=t,e.$4F=c,e.$5F=l,e.$8F=b,e.$9F=P,e.$0F=f,e.$$F=w,e.$_F=F,e.$aG=O,e.$bG=L,e.$cG=q,e.$dG=_,e.$fG=ce,e.$gG=oe,e.$hG=Ce,e.$iG=Le,u=_t(u),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var E;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function s(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function o(X,V,te){for(const ve of te.visibleEditorPanes)if(ve.group.id===V&&X.matches(ve.input))return ve.getViewState()}function h(X){if(b(X))return!1;const V=X;return C.URI.isUri(V?.resource)}function i(X){if(b(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function r(X){if(b(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(b(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function c(X){if(b(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===a.Schemas.untitled||V.forceUntitled===!0:!1}function l(X){if(b(X))return!1;const V=X;return C.URI.isUri(V?.base?.resource)&&C.URI.isUri(V?.input1?.resource)&&C.URI.isUri(V?.input2?.resource)&&C.URI.isUri(V?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var m;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class ${constructor(){this.a=new Map}registerSource(V,te){let ve=this.a.get(V);return ve||(ve={source:V,label:te},this.a.set(V,ve)),ve.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$6F=new $;var D;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(D||(e.EditorInputCapabilities=D={}));class S extends N.$Xc{}e.$7F=S;function b(X){return X instanceof S}function k(X){const V=X;return C.URI.isUri(V?.preferredResource)}function P(X){const V=X;return b(V?.primary)&&b(V?.secondary)}function f(X){const V=X;return b(V?.modified)&&b(V?.original)}function w(X,V,te,ve,ue){return Le(ve,[(0,y.$qj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const be={...te,limits:{size:Number.MAX_VALUE}};X.openEditor(V,be)}}),(0,y.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(X){return b(X?.editor)}function O(X){const V=X;return F(X)&&V?.group!==void 0}function L(X){const V=X;return typeof V?.groupId=="number"&&b(V.editor)}function q(X){return typeof X?.groupId=="number"}var W;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var M;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var Y;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(Y||(e.SideBySideEditor=Y={}));class Z{getOriginalUri(V,te){if(!V)return;if(l(V))return e.$eG.getOriginalUri(V.result,te);if(te?.supportSideBySide){const{primary:ue,secondary:be}=this.a(V);if(ue&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getOriginalUri(ue,{filterByScheme:te.filterByScheme})??this.getOriginalUri(be,{filterByScheme:te.filterByScheme});V=te.supportSideBySide===Y.PRIMARY?ue:be}}if(i(V)||r(V)||t(V)||l(V))return;const ve=k(V)?V.preferredResource:V.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}a(V){return P(V)||t(V)?{primary:V.primary,secondary:V.secondary}:f(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,te){if(!V)return;if(l(V))return e.$eG.getCanonicalUri(V.result,te);if(te?.supportSideBySide){const{primary:ue,secondary:be}=this.a(V);if(ue&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getCanonicalUri(ue,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:te.filterByScheme});V=te.supportSideBySide===Y.PRIMARY?ue:be}}if(i(V)||r(V)||t(V)||l(V))return;const ve=V.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}b(V,te){if(Array.isArray(te)){if(te.some(ve=>V.scheme===ve))return V}else if(te===V.scheme)return V}}var ge;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function _(X,V,te,ve){if(!X.isSticky(V))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return te===ge.MOUSE||te===ge.KEYBOARD;case"mouse":return te===ge.MOUSE;case"keyboard":return te===ge.KEYBOARD}return!1}e.$eG=new Z;var me;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class se{constructor(){this.c=new Map,this.d=new Map}start(V){const te=this.a=V.get(A.$Fi);for(const[ve,ue]of this.c)this.e(ve,ue,te);this.c.clear()}e(V,te,ve){const ue=ve.createInstance(te);this.d.set(V,ue)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,I.$rg)(this.b)}registerEditorSerializer(V,te){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,te,this.a):this.c.set(V,te),(0,N.$Vc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.$ro.add(e.$RF.EditorFactory,new se);async function ce(X,V,te){return!X||!X.length?[]:await Promise.all(X.map(async ve=>{const ue=C.URI.revive(ve.fileUri);if(!ue){te.info("Cannot resolve the path because it is not valid.",ve);return}if(!await V.canHandleResource(ue)){te.info("Cannot resolve the path because it cannot be handled",ve);return}let de=ve.exists,J=ve.type;if(typeof de!="boolean"||typeof J!="number")try{J=(await V.stat(ue)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(pe){te.error(pe),de=!1}if(!de&&ve.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ve);return}if(J===p.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ve);return}const x={...ve.options,pinned:!0};return de?{resource:ue,options:x}:{resource:ue,options:x,forceUntitled:!0}}))}var we;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(we||(e.EditorsOrder=we={}));function oe(X){const V=X;if(!V)return!1;const te=V;if(te.modified)return oe(te.modified);const ve=V;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Ce(X){return(0,R.$sj)(X)}function Le(X,V,te){const ve=(0,R.$tj)(X,V);return ve.forceMessage=te?.forceMessage,ve.forceSeverity=te?.forceSeverity,ve.allowDialog=te?.allowDialog,ve}}),define(Ie[233],Pe([1,0,6,195,3,4,29,31,26,98,223]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oG=e.ViewContentGroups=e.$mG=e.ViewContainerLocation=e.Extensions=e.$lG=e.$kG=e.$jG=void 0,e.$nG=E,e.$jG="views",e.$kG=(0,I.localize)(0,null),e.$lG=(0,R.$yx)("default-view-icon",a.$6j.window,(0,I.localize)(1,null));var y;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$mG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(c){switch(c){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new v.$ne),this.onDidRegister=this.c.event,this.f=this.B(new v.$ne),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,g,m){const $=this.get(l.id);if($)return $;const D=l;return D.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,A.$Ac)(this.g,g,[]).push(D),m?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:g}),D}deregisterViewContainer(l){for(const g of this.g.keys()){const m=this.g.get(g),$=m?.indexOf(l);if($!==-1){m?.splice($,1),m.length===0&&this.g.delete(g),this.f.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(g=>this.getViewContainerLocation(g)===l)}}T.$ro.add(y.ViewContainersRegistry,new d);var n;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(n||(e.ViewContentGroups=n={}));function s(c,l){const g=c.group??n.More,m=l.group??n.More;return g!==m?g.localeCompare(m):(c.order??5)-(l.order??5)}class o extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new v.$ne),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$ne),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$ne),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$ne),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Kc}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:m})=>this.r(g,m)),this.c.fire(l)}deregisterViews(l,g){const m=this.s(l,g);m.length&&this.f.fire({views:m,viewContainer:g})}moveViews(l,g){for(const m of this.m.keys())if(m!==g){const $=this.s(l,m);$.length&&(this.r($,g),this.g.fire({views:$,from:m,to:g}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const g of this.j){const m=(this.m.get(g)||[]).filter($=>$.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const g of this.j)if((this.m.get(g)||[]).filter($=>$.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this.n.add(l,g),this.h.fire(l),(0,N.$Vc)(()=>{this.n.delete(l,g),this.h.fire(l)})}registerViewWelcomeContent2(l,g){const m=new Map;for(const[$,D]of g)this.n.add(l,D),m.set($,(0,N.$Vc)(()=>{this.n.delete(l,D),this.h.fire(l)}));return this.h.fire(l),m}getViewWelcomeContent(l){const g=[];return this.n.forEach(l,m=>g.push(m)),g.sort(s)}r(l,g){let m=this.m.get(g);m||(m=[],this.m.set(g,m),this.j.push(g));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,I.localize)(2,null,$.id));m.push($)}}s(l,g){const m=this.m.get(g);if(!m)return[];const $=[],D=[];for(const S of m)l.includes(S)?$.push(S):D.push(S);return $.length&&(D.length?this.m.set(g,D):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),$}}T.$ro.add(y.ViewsRegistry,new o),e.$oG=(0,C.$Gi)("viewDescriptorService");var h;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,g){this.c=!1,this.d=!1,(0,p.$ho)(this,l),this.d=!!g,this.resolve=async m=>{if(g&&!this.c){const $=await g(m);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pG=r;class t extends Error{constructor(l){super((0,I.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$qG=t}),define(Ie[234],Pe([1,0,196,32]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new I.$Xj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(0,null)}),e.$vG=new I.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(1,null)}),e.$wG=new I.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(2,null)}),e.$xG=new I.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(3,null)}),e.$yG=new I.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4,null)}),e.$zG=new I.$Xj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(5,null)}),e.$AG=new I.$Xj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(6,null)}),e.$BG=new I.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(7,null)}),e.$CG=new I.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8,null)}),e.$DG=new I.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(9,null)}),e.$EG=new I.$Xj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(10,null)}),e.$FG=new I.$Xj("inChat",!1,{type:"boolean",description:(0,v.localize)(11,null)}),e.$GG=new I.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(12,null)}),e.$HG=new I.$Xj("chatCursorAtTop",!1),e.$IG=new I.$Xj("chatInputHasAgent",!1),e.$JG=new I.$Xj("chatLocation",void 0),e.$KG=new I.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(13,null)})}),define(Ie[235],Pe([1,0,325,11,22,6,40,4,49,142,13,32,19,3,12,109,217,228,234]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=g,e.$PH=m;var r;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function($){function D(S){switch(S){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=D}(r||(e.ChatAgentLocation=r={})),e.$JH=(0,E.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(D){this.f=D,this.b=new Map,this.d=new N.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$GG.bindTo(this.f)}registerAgent(D,S){if(this.getAgent(D))throw new Error(`Agent already registered: ${JSON.stringify(D)}`);const k=this,P=S.slashCommands;S={...S,get slashCommands(){return P.filter(w=>!w.when||k.f.contextMatchesRules(y.$Ej.deserialize(w.when)))}};const f={data:S};return this.b.set(D,f),(0,T.$Vc)(()=>{this.b.delete(D),this.d.fire(void 0)})}registerAgentImplementation(D,S){const b=this.b.get(D);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(D)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(D)}`);return b.data.isDefault&&this.e.set(!0),b.impl=S,this.d.fire(new c(b.data,S)),(0,T.$Vc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(D,S){D.isDynamic=!0;const b={data:D,impl:S};return this.b.set(D.id,b),this.d.fire(new c(D,S)),(0,T.$Vc)(()=>{this.b.delete(D.id),this.d.fire(void 0)})}registerAgentCompletionProvider(D,S){return this.g.set(D,S),{dispose:()=>{this.g.delete(D)}}}async getAgentCompletionItems(D,S,b){return await this.g.get(D)?.(S,b)??[]}updateAgent(D,S){const b=this.b.get(D);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(D)} registered`);b.data.metadata={...b.data.metadata,...S},this.d.fire(new c(b.data,b.impl))}getDefaultAgent(D){return(0,v.$ib)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(D))}getContributedDefaultAgent(D){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(D))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),D=>!!D.data.metadata.isSecondary)?.data}getAgent(D){if(this.h(D))return this.b.get(D)?.data}h(D){const S=this.b.get(D);return!S?.data.when||this.f.contextMatchesRules(y.$Ej.deserialize(S.data.when))}getAgentByFullyQualifiedId(D){const S=A.Iterable.find(this.b.values(),b=>g(b.data)===D)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(D=>D.data).filter(D=>this.h(D.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(D=>!!D.impl).filter(D=>this.h(D.data.id)).map(D=>new c(D.data,D.impl))}getAgentsByName(D){return this.getAgents().filter(S=>S.name===D)}agentHasDupeName(D){const S=this.getAgent(D);return S?this.getAgentsByName(S.name).filter(b=>b.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(D,S,b,k,P){const f=this.b.get(D);if(!f?.impl)throw new Error(`No activated agent with id "${D}"`);return await f.impl.invoke(S,b,k,P)}async getFollowups(D,S,b,k,P){const f=this.b.get(D);if(!f?.impl)throw new Error(`No activated agent with id "${D}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(S,b,k,P):[]}};e.$KH=t,e.$KH=t=He([qe(0,y.$Yj)],t);class c{constructor(D,S){this.b=D,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(D,S,b,k){return this.d.invoke(D,S,b,k)}async provideFollowups(D,S,b,k){return this.d.provideFollowups?this.d.provideFollowups(D,S,b,k):[]}provideWelcomeMessage(D,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(D,S)}provideSampleQuestions(D,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(D,S)}}e.$LH=c,e.$MH=(0,E.$Gi)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(D,S,b,k){if(this.g=S,this.h=b,this.i=k,this.e=(0,a.$8d)(this,Object.create(null)),this.f=!1,!D.chatParticipantRegistry)return;this.d=D.chatParticipantRegistry;const P=k.get(i.b,o.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{k.remove(i.b,o.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(D=>this.h.warn("Failed to fetch chat participant registry",D)).then(()=>(0,I.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const D=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,s.$_p)(D);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const b=S.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),o.StorageScope.APPLICATION,o.StorageTarget.MACHINE)}getAgentNameRestriction(D){const S=this.l(D.name,D).get(),b=!D.fullName||this.l(D.fullName.replace(/\s/g,""),D).get();return S&&b}l(D,S){return this.e.map(k=>k[D.toLowerCase()]).map(k=>k?k.some(P=>(0,R.$Hf)(P,P.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=l,e.$NH=l=i=He([qe(0,n.$tk),qe(1,s.$6p),qe(2,d.$ak),qe(3,o.$gq)],l);function g($){return`${$.extensionId.value}.${$.id}`}function m($){const D="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in D||(D.extensionPublisherId=D.extensionPublisher??""),"extensionDisplayName"in D||(D.extensionDisplayName=""),"extensionId"in D||(D.extensionId=new u.$rn("")),(0,p.$di)(D)}}),define(Ie[236],Pe([1,0,2,33,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.$hH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$fH=N,e.$gH=A;function N(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof v.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(I.$Mt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(N)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var p;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$hH=(0,C.$Gi)("IChatService"),e.$iH="accessibility.voice.keywordActivation"}),define(Ie[237],Pe([1,0,6,11,198]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mtb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new v.$ne,this.o=new v.$ne,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,a,R){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(y.seq);if(E){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,C.localize)(0,null,R,T)};E(d)}},R)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,I.$Hh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,a=this.f.get(p.request_seq);a&&(this.f.delete(p.request_seq),a(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,a)=>T.set(a,p)),await(0,I.$Hh)(500),T.forEach((p,a)=>{p({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Mtb=N}),define(Ie[81],Pe([1,0,2,199,32,3]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=p,e.$BK=R,I=Ve(I),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new C.$Xj("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$xJ=new C.$Xj("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$yJ=new C.$Xj("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new C.$Xj(e.$zJ,"default",{type:"string",description:I.localize(3,null)}),e.$BJ=new C.$Xj("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$CJ=new C.$Xj("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$DJ=new C.$Xj("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$EJ=new C.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$FJ=new C.$Xj("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$GJ=new C.$Xj("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$HJ=new C.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$IJ=new C.$Xj("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$JJ=new C.$Xj("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$KJ=new C.$Xj("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$LJ=new C.$Xj("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$MJ=new C.$Xj("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$NJ=new C.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$OJ=new C.$Xj("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$PJ=new C.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$QJ=new C.$Xj("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$RJ=new C.$Xj("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$SJ=new C.$Xj("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$TJ=new C.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:I.localize(22,null)}),e.$UJ=new C.$Xj("breakpointHasModes",!1,{type:"boolean",description:I.localize(23,null)}),e.$VJ=new C.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(24,null)}),e.$WJ=new C.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(25,null)}),e.$XJ=new C.$Xj("loadedScriptsItemType",void 0,{type:"string",description:I.localize(26,null)}),e.$YJ=new C.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(27,null)}),e.$ZJ=new C.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(28,null)}),e.$1J=new C.$Xj("stepBackSupported",!1,{type:"boolean",description:I.localize(29,null)}),e.$2J=new C.$Xj("restartFrameSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$3J=new C.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(31,null)}),e.$4J=new C.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(32,null)}),e.$5J=new C.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(33,null)}),e.$6J=new C.$Xj("breakpointsExist",!1,{type:"boolean",description:I.localize(34,null)}),e.$7J=new C.$Xj("debuggersAvailable",!1,{type:"boolean",description:I.localize(35,null)}),e.$8J=new C.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(36,null)}),e.$9J=new C.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(37,null)}),e.$0J=new C.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$$J=new C.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$_J=new C.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$aK=new C.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$bK=new C.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$cK=new C.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(43,null)}),e.$dK=new C.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(44,null)}),e.$eK=new C.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(45,null)}),e.$fK=new C.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(46,null)}),e.$gK=new C.$Xj("variableIsReadonly",!1,{type:"boolean",description:I.localize(47,null)}),e.$hK=new C.$Xj("variableValue",!1,{type:"string",description:I.localize(48,null)}),e.$iK=new C.$Xj("variableType",!1,{type:"string",description:I.localize(49,null)}),e.$jK=new C.$Xj("variableInterfaces",!1,{type:"array",description:I.localize(50,null)}),e.$kK=new C.$Xj("variableName",!1,{type:"string",description:I.localize(51,null)}),e.$lK=new C.$Xj("variableLanguage",!1,{type:"string",description:I.localize(52,null)}),e.$mK=new C.$Xj("variableExtensionId",!1,{type:"string",description:I.localize(53,null)}),e.$nK=new C.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(54,null)}),e.$oK=new C.$Xj("multiSessionRepl",!1,{type:"boolean",description:I.localize(55,null)}),e.$pK=new C.$Xj("multiSessionDebug",!1,{type:"boolean",description:I.localize(56,null)}),e.$qK=new C.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(57,null)}),e.$rK=new C.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(58,null)}),e.$sK=new C.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(59,null)}),e.$tK=new C.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(60,null)});const A=i=>I.localize(61,null,i);e.$uK=A,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(62,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$AK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$CK=(0,N.$Gi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var h;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(h||(e.IDebugVisualization=h={}))}),define(Ie[238],Pe([1,0,13,2,20,26,16,33,22,18]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=void 0,e.$UH=y,e.$VH=u,e.$WH=E,e.$XH=d,e.$YH=n,e.$ZH=s,e.$1H=o,e.$2H=i,e.$3H=c,e.$4H=l,e.$5H=m,e.$6H=D;const R=/{([^}]+)}/g;function y(b,k,P){return b.replace(R,function(f,w){return k&&w.length>0&&w[0]!=="_"?f:P&&P.hasOwnProperty(w)?P[w]:f})}function u(b){const k={};for(const P of Object.keys(b))P.startsWith("!")||(k[P]=b[P]);return k}function E(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||E(b.parentSession))}function d(b){let k=b.configuration.type;if(k)return k==="vslsShare"&&(k=b.configuration.adapterProxy.configuration.type),(0,v.$Hf)(k,"extensionhost")||(0,v.$Hf)(k,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function s(b,k,P){let f,w=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=F.exec(b);){const L=O.index+1,q=L+O[0].length;if(L<=k&&q>=P){f=O[0],w=L;break}}if(f){const L=/\w+/g;let q=null;for(;(q=L.exec(f))&&!(q.index+1+w+q[0].length>=P););q&&(f=f.substring(0,L.lastIndex))}return f?{start:w,end:w+f.length-1}:{start:0,end:0}}async function o(b,k,P,f){if(b.evaluatableExpressionProvider.has(k)){const w=b.evaluatableExpressionProvider.ordered(k),F=(0,a.$Kb)(await Promise.all(w.map(async O=>{try{return await O.provideEvaluatableExpression(k,P,f??p.CancellationToken.None)}catch{return}})));if(F.length>0){let O=F[0].expression;const L=F[0].range;return O||(O=k.getLineContent(P.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:O}}}else{const w=k.getLineContent(P.lineNumber),{start:F,end:O}=s(w,P.column,P.column),L=w.substring(F-1,O);return{matchingExpression:L,range:new T.$Mt(P.lineNumber,F,P.lineNumber,F+L.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(h))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return I.URI.parse(b.path);if((0,C.$lc)(b.path))return I.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const k=I.URI.revive(b.path);if(k)return k.scheme===A.Schemas.file?k.fsPath:k.toString()}return b.path}function c(b,k){const P=k?r:t,f=(0,N.$eo)(b);return g(f,(w,F)=>{w&&F&&(F.path=P(F))}),f}function l(b,k){const P=k?r:t,f=(0,N.$eo)(b);return g(f,(w,F)=>{!w&&F&&(F.path=P(F))}),f}function g(b,k){switch(b.type){case"event":{const P=b;switch(P.event){case"output":k(!1,P.body.source);break;case"loadedSource":k(!1,P.body.source);break;case"breakpoint":k(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=b;switch(P.command){case"setBreakpoints":k(!0,P.arguments.source);break;case"breakpointLocations":k(!0,P.arguments.source);break;case"source":k(!0,P.arguments.source);break;case"gotoTargets":k(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(f=>k(!1,f));break;default:break}break}case"response":{const P=b;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(f=>k(!1,f.source));break;case"loadedSources":P.body.sources.forEach(f=>k(!1,f));break;case"scopes":P.body.scopes.forEach(f=>k(!1,f.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(f=>k(!1,f.source));break;case"setBreakpoints":P.body.breakpoints.forEach(f=>k(!1,f.source));break;case"disassemble":P.body?.instructions.forEach(w=>k(!1,w.location));break;default:break}break}}}function m(b){return b.filter(k=>!k.presentation?.hidden).sort((k,P)=>k.presentation?P.presentation?k.presentation.group?P.presentation.group?k.presentation.group!==P.presentation.group?k.presentation.group.localeCompare(P.presentation.group):$(k.presentation.order,P.presentation.order):-1:P.presentation.group?1:$(k.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function $(b,k){return typeof b!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:b-k}async function D(b,k){const P=b.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(P!=="none"&&(await k.saveAll(),P==="allEditorsInActiveGroup")){const f=k.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await k.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const S=(b,k)=>!b||!k?b===k:b.name===k.name&&b.path===k.path&&b.sourceReference===k.sourceReference;e.$7H=S}),define(Ie[239],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.CellExecutionUpdateType=void 0;var I;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(I||(e.CellExecutionUpdateType=I={})),e.$KK=(0,v.$Gi)("INotebookExecutionService")}),define(Ie[240],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ProxyKernelState=e.$MK=void 0,e.$MK=100;var I;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(I||(e.ProxyKernelState=I={})),e.$NK=(0,v.$Gi)("INotebookKernelService"),e.$OK=(0,v.$Gi)("INotebookKernelHistoryService")}),define(Ie[241],Pe([1,0,4,33,52,167,102]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CZb=void 0;class T extends v.$Xc{constructor(a,R,y){super(),this._source=a,this.b=R,this.c=y,this.a=void 0}f(a){const R=a.getLineCount();return new I.$Mt(1,1,R,this.g(a,R))}g(a,R){if(R<1||R>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const a=new N.$mD;a.acceptChunk(this._source);const R=a.finish(!0),{textBuffer:y,disposable:u}=R.create(C.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const R=new N.$mD;R.acceptChunk(a);const y=R.finish(!0),{textBuffer:u,disposable:E}=y.create(C.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$CZb=T}),define(Ie[55],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(N){N.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var I;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(I||(e.TestPosition=I={}));class C{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new C([T]);const a=[A.id];for(let R=p;R&&R.id!==T;R=R.parent)a.push(R.id);return a.push(T),new C(a.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new C(A.split(v.Delimiter))}static join(A,T){return new C([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T.startsWith(A)&&T[A.length]===v.Delimiter}static compare(A,T){return A===T?I.IsSame:C.isChild(A,T)?I.IsChild:C.isChild(T,A)?I.IsParent:I.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let a=1;a<A;a++){const R=T(a-1),y=T(a);if(R.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return I.Disconnected;return A.d>this.d?I.IsChild:A.d<this.d?I.IsParent:I.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$TI=C}),define(Ie[56],Pe([1,0,2,101,33,55]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$UI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$VI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const a=W=>"runId"in W;e.$WI=a;var R;(function(W){W.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),W.deserialize=(M,Y)=>({range:C.$Mt.lift(Y.range),uri:M.asCanonicalUri(v.URI.revive(Y.uri))})})(R||(e.IRichLocation=R={}));var y;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(W){W.serialize=M=>({message:M.message,type:y.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&R.serialize(M.location)}),W.deserialize=(M,Y)=>({message:Y.message,type:y.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&R.deserialize(M,Y.location)})})(u||(e.ITestErrorMessage=u={}));const E=(W,M)=>`${M?"s":"e"}${W}`;e.$XI=E;var d;(function(W){W.serialize=M=>({message:M.message,type:y.Output,offset:M.offset,length:M.length,location:M.location&&R.serialize(M.location)}),W.deserialize=(M,Y)=>({message:Y.message,type:y.Output,offset:Y.offset,length:Y.length,location:Y.location&&R.deserialize(M,Y.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(W){W.serialize=M=>M.type===y.Error?u.serialize(M):d.serialize(M),W.deserialize=(M,Y)=>Y.type===y.Error?u.deserialize(M,Y):d.deserialize(M,Y)})(n||(e.ITestMessage=n={}));var s;(function(W){W.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),W.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(n.serialize)}),W.deserialize=(M,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(Z=>n.deserialize(M,Z))})})(s||(e.ITestTaskState=s={}));const o="\0",h=(W,M)=>W+o+M;e.$YI=h;const i=W=>{const M=W.indexOf(o);return{ctrlId:W.slice(0,M),tagId:W.slice(M+1)}};e.$ZI=i;var r;(function(W){W.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),W.deserialize=(M,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?M.asCanonicalUri(v.URI.revive(Y.uri)):void 0,range:Y.range?C.$Mt.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(r||(e.ITestItem=r={}));var t;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var c;(function(W){W.serialize=M=>({expand:M.expand,item:r.serialize(M.item)}),W.deserialize=(M,Y)=>({controllerId:N.$TI.root(Y.item.extId),expand:Y.expand,item:r.deserialize(M,Y.item)})})(c||(e.InternalTestItem=c={}));var l;(function(W){W.serialize=M=>{let Y;return M.item&&(Y={},M.item.label!==void 0&&(Y.label=M.item.label),M.item.tags!==void 0&&(Y.tags=M.item.tags),M.item.busy!==void 0&&(Y.busy=M.item.busy),M.item.uri!==void 0&&(Y.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(Y.range=M.item.range?.toJSON()),M.item.description!==void 0&&(Y.description=M.item.description),M.item.error!==void 0&&(Y.error=M.item.error),M.item.sortText!==void 0&&(Y.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:Y}},W.deserialize=M=>{let Y;return M.item&&(Y={},M.item.label!==void 0&&(Y.label=M.item.label),M.item.tags!==void 0&&(Y.tags=M.item.tags),M.item.busy!==void 0&&(Y.busy=M.item.busy),M.item.range!==void 0&&(Y.range=M.item.range?C.$Mt.lift(M.item.range):null),M.item.description!==void 0&&(Y.description=M.item.description),M.item.error!==void 0&&(Y.error=M.item.error),M.item.sortText!==void 0&&(Y.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:Y}}})(l||(e.ITestItemUpdate=l={}));const g=(W,M)=>{M.expand!==void 0&&(W.expand=M.expand),M.item!==void 0&&(W.item=W.item?Object.assign(W.item,M.item):M.item)};e.$1I=g;var m;(function(W){W.serializeWithoutMessages=M=>({...c.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(s.serializeWithoutMessages)}),W.serialize=M=>({...c.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(s.serialize)}),W.deserialize=(M,Y)=>({...c.deserialize(M,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(Z=>s.deserialize(M,Z)),retired:!0})})(m||(e.TestResultItem=m={}));var $;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(M,Y)=>{M.covered+=Y.covered,M.total+=Y.total}})($||(e.ICoverageCount=$={}));var D;(function(W){W.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testIds:M.testIds,uri:M.uri.toJSON()}),W.deserialize=(M,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:M.asCanonicalUri(v.URI.revive(Y.uri))}),W.empty=(M,Y)=>({id:M,uri:Y,statement:$.empty()})})(D||(e.IFileCoverage=D={}));function S(W){return{...W,location:W.location?.toJSON()}}function b(W){return W.location=W.location?I.$Lt.isIPosition(W.location)?I.$Lt.lift(W.location):C.$Mt.lift(W.location):void 0,W}e.$2I=3;var k;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(k||(e.DetailType=k={}));var P;(function(W){W.serialize=M=>M.type===k.Declaration?w.serialize(M):F.serialize(M),W.deserialize=M=>M.type===k.Declaration?w.deserialize(M):F.deserialize(M)})(P||(e.CoverageDetails=P={}));var f;(function(W){W.serialize=S,W.deserialize=b})(f||(e.IBranchCoverage=f={}));var w;(function(W){W.serialize=S,W.deserialize=b})(w||(e.IDeclarationCoverage=w={}));var F;(function(W){W.serialize=M=>({...S(M),branches:M.branches?.map(f.serialize)}),W.deserialize=M=>({...b(M),branches:M.branches?.map(f.deserialize)})})(F||(e.IStatementCoverage=F={}));var O;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var L;(function(W){W.deserialize=(M,Y)=>Y.op===O.Add?{op:Y.op,item:c.deserialize(M,Y.item)}:Y.op===O.Update?{op:Y.op,item:l.deserialize(Y.item)}:Y.op===O.DocumentSynced?{op:Y.op,uri:M.asCanonicalUri(v.URI.revive(Y.uri)),docv:Y.docv}:Y,W.serialize=M=>M.op===O.Add?{op:M.op,item:c.serialize(M.item)}:M.op===O.Update?{op:M.op,item:l.serialize(M.item)}:M})(L||(e.TestsDiffOp=L={}));class q{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const Y=this.w();for(const Z of M)switch(Z.op){case O.Add:this.l(c.deserialize(this.k,Z.item),Y);break;case O.Update:this.p(l.deserialize(Z.item),Y);break;case O.Remove:this.q(Z.itemId,Y);break;case O.Retire:this.v(Z.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case O.AddTag:this.c.set(Z.tag.id,Z.tag);break;case O.RemoveTag:this.c.delete(Z.id);break}Y.complete?.()}l(M,Y){const Z=N.$TI.parentId(M.item.extId)?.toString();let ge;if(!Z)ge=this.x(M),this.g.add(ge),this.f.set(M.item.extId,ge);else if(this.f.has(Z)){const _=this.f.get(Z);_.children.add(M.item.extId),ge=this.x(M,_),this.f.set(M.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return Y.add?.(ge),M.expand===t.BusyExpanding&&this.h++,ge}p(M,Y){const Z=this.f.get(M.extId);if(Z)return M.expand!==void 0&&(Z.expand===t.BusyExpanding&&this.h--,M.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(Z,M),Y.update?.(Z),Z}q(M,Y){const Z=this.f.get(M);if(!Z)return;const ge=N.$TI.parentId(Z.item.extId)?.toString();ge?this.f.get(ge).children.delete(Z.item.extId):this.g.delete(Z);const _=[[M]];for(;_.length;)for(const me of _.pop()){const se=this.f.get(me);se&&(_.push(se.children),this.f.delete(me),Y.remove?.(se,se!==Z),se.expand===t.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$3I=q}),define(Ie[242],Pe([1,0,99,202,56]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$tGb=e.$sGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var N;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(N||(e.Testing=N={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[C.TestResultState.Errored]:(0,I.localize)(0,null),[C.TestResultState.Failed]:(0,I.localize)(1,null),[C.TestResultState.Passed]:(0,I.localize)(2,null),[C.TestResultState.Queued]:(0,I.localize)(3,null),[C.TestResultState.Running]:(0,I.localize)(4,null),[C.TestResultState.Skipped]:(0,I.localize)(5,null),[C.TestResultState.Unset]:(0,I.localize)(6,null)},a=(y,u)=>(0,I.localize)(7,null,(0,v.$Zk)(y),p[u]);e.$sGb=a,e.$tGb={[C.TestRunProfileBitset.Debug]:(0,I.localize)(8,null),[C.TestRunProfileBitset.Run]:(0,I.localize)(9,null),[C.TestRunProfileBitset.Coverage]:(0,I.localize)(10,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ie[82],Pe([1,0,11,6,4,62,56,55]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const a=(h,i)=>h===i,y=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(h,i)=>!(h.length!==i.length||h.some(r=>!i.includes(r)))}),u=(h,i)=>{let r;for(const[t,c]of y)c(h[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class E extends C.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new I.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$1I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const c=this.M(t);return c.isOpen()?this.L(t,r-1):c.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case p.RemoveChild:this.O(T.$TI.joinToString(i.fullId,r.id));break;case p.Upsert:this.z(r.item,i);break;case p.Bulk:for(const t of r.ops)this.w(i,t);break;case p.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,N.$hd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$TI.fromExtHostTestItem(i,this.root.id,r?.actual),c=this.s.getApiFor(i);c.parent&&c.parent!==r?.actual&&this.s.getChildren(c.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const g=this.s.getChildren(l.actual),m=l.actual,$=u(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete $.tags),this.w(l,{op:p.SetProp,update:$})),this.I(i,l,r);for(const[S,b]of g)this.s.getChildren(i).get(b.id)||this.O(T.$TI.joinToString(t,b.id));const D=l.expandLevels;D!==void 0&&queueMicrotask(()=>{l.expand===A.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),D))}),this.y(l.actual.uri)}C(i,r,t){const c=new Set(r.map(l=>l.id));for(const l of i)c.delete(l.id)||this.D(l);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,A.$YI)(this.s.controllerId,l.id))}}}),c.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$YI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$YI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const c=this.s.getApiFor(i);c.parent=t?.actual,c.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[c,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[c,l]of this.s.getChildren(i.actual)){const g=this.expand(T.$TI.joinToString(i.fullId,l.id),r);(0,v.$sh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new v.$Fh;return l.open(),l}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Fh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let c;try{c=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,v.$sh)(c)?c.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const c=t.pop();if(c){this.s.getApiFor(c.actual).listener=void 0;for(const l of c.actual.tags)this.F(l.id);this.tree.delete(c.fullId.toString());for(const[l,g]of this.s.getChildren(c.actual))t.push(this.tree.get(T.$TI.joinToString(c.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$QP=E;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$RP=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=n;class s extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=s;const o=(h,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(c,l){for(const g of t.values())c.call(l,g,this)},[Symbol.iterator](){return t.entries()},replace(c){const l=new Map,g=new Set(t.keys()),m={op:p.Bulk,ops:[]};for(const $ of c){if(!($ instanceof r))throw new n($.id);const D=i($).controllerId;if(D!==h.controllerId)throw new s($.id,D,h.controllerId);if(l.has($.id))throw new d($.id);l.set($.id,$),g.delete($.id),m.ops.push({op:p.Upsert,item:$})}for(const $ of g.keys())m.ops.push({op:p.RemoveChild,id:$});h.listener?.(m),t=l},add(c){if(!(c instanceof r))throw new n(c.id);t.set(c.id,c),h.listener?.({op:p.Upsert,item:c})},delete(c){t.delete(c)&&h.listener?.({op:p.RemoveChild,id:c})},get(c){return t.get(c)},toJSON(){return Array.from(t.values())}}};e.$UP=o}),define(Ie[116],Pe([1,0,82]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const I=new WeakMap,C=(A,T)=>{const p={controllerId:T};return I.set(A,p),p};e.$VP=C;const N=A=>{const T=I.get(A);if(!T)throw new v.$SP(A?.id||"<unknown>");return T};e.$WP=N}),define(Ie[83],Pe([1,0,28,16,2]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gDb=e.$fDb=e.$eDb=void 0,e.$hDb=N,e.$iDb=T,e.$eDb="vscode-cdn.net",e.$fDb=`vscode-resource.${e.$eDb}`,e.$gDb=`'self' https://*.${e.$eDb}`;function N(p,a){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(a&&a.authority&&a.isRemote&&p.scheme===I.Schemas.file&&(p=C.URI.from({scheme:I.Schemas.vscodeRemote,authority:a.authority,path:p.path})),C.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$fDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,a=>{const R=a.charCodeAt(0);return R>=v.CharCode.a&&R<=v.CharCode.z||R>=v.CharCode.A&&R<=v.CharCode.Z||R>=v.CharCode.Digit0&&R<=v.CharCode.Digit9?a:"-"+R.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(a,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ie[243],Pe([1,0,6,4,83]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0;class N{constructor(T,p,a){this.d=T,this.e=p,this.f=a,this.a=0,this.b=new I.$Wc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,a,R,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,d=this.a++,n=new v.$ne,s=new v.$ne,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$hDb)(i,E.f)}get cspSource(){return C.$gDb}set options(i){this.b=i,E.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return E.d.$postMessage(d,i)}},h=new class{constructor(){this.editor=T,this.line=p,this.height=a,this.webview=o,this.onDidDispose=s.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),s.fire(),s.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,a,R||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:h,onDidReceiveMessage:n}),h}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Goc=N}),define(Ie[117],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0,e.$wM="__",e.$xM=(0,v.$Gi)("IAuthenticationService"),e.$yM=(0,v.$Gi)("IAuthenticationExtensionsService")}),define(Ie[244],Pe([1,0,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,v.$Gi)("configurationResolverService");var I;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(I||(e.VariableKind=I={}));class C extends Error{constructor(A,T){super(T),this.variable=A}}e.$PQ=C}),define(Ie[245],Pe([1,0,20,79,15,26,21,103,203,244,13]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,v=Ve(v),I=Ve(I),C=Ve(C),N=Ve(N);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,n,s){this.h=new Map,this.a=E,this.b=d,this.g=n,s&&(this.c=s.then(o=>this.i(o)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(n=>{d[n.toLowerCase()]=E[n]}),d}return E}resolveWithEnvironment(E,d,n){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(E,d){const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,d)}async j(E,d,n,s){const o=N.$eo(d);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,o,n,s)}async resolveAnyAsync(E,d,n){return this.j(E,d,n)}async resolveAnyMap(E,d,n){const s=new Map;return{newConfig:await this.j(E,d,n,s),resolvedVariables:s}}resolveWithInteractionReplace(E,d,n,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,n,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,n,s,o){if(C.$gg(n))return this.m(E,d,n,s,o);if(Array.isArray(n))return Promise.all(n.map(h=>this.l(E,d,h,s,o)));if(C.$ig(n)){const h=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(E,d,r,s,o),await this.l(E,d,n[r],s,o)]));for(const[r,t]of i)h[r]=t;return h}return n}m(E,d,n,s,o){return(0,R.$zf)(n,y.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(y.VARIABLE_LHS))return h;let r=await this.o(E,h,i,d,s);return o?.set(i,r),r!==h&&C.$gg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(E,d,r,s,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,n,s,o){let h;const i=n.split(":");i.length>1&&(n=i[0],h=i[1]);const r=l=>{const g=this.a.getFilePath();if(g)return(0,T.$Xw)(g);throw new a.$PQ(l,(0,p.localize)(0,null,d))},t=l=>{const g=r(l);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$Xw)(m)}throw new a.$PQ(l,(0,p.localize)(1,null,d,v.$qc(g)))},c=l=>{if(h){const g=this.a.getFolderUri(h);if(g)return g;throw new a.$PQ(l,(0,p.localize)(2,null,d,h))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(l,(0,p.localize)(3,null,d)):new a.$PQ(l,(0,p.localize)(4,null,d))};switch(n){case"env":if(h){if(E.env){const l=E.env[A.$i?h.toLowerCase():h];if(C.$gg(l))return l}return""}throw new a.$PQ(a.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const l=this.a.getConfigurationValue(s,h);if(C.$pg(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(6,null,d,h));if(C.$ig(l))throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(7,null,d,h));return l}throw new a.$PQ(a.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(a.VariableKind.Command,d,h,o,"command");case"input":return this.p(a.VariableKind.Input,d,h,o,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(l.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Xw)(this.n(c(a.VariableKind.WorkspaceFolder)));case"cwd":return s||h?(0,T.$Xw)(this.n(c(a.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Xw)(v.$qc(this.n(c(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new a.$PQ(a.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new a.$PQ(a.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$qc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||h?v.$oc(this.n(c(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const l=v.$pc(r(a.VariableKind.RelativeFileDirname));if(s||h){const g=v.$oc(this.n(c(a.VariableKind.RelativeFileDirname)),l);return g.length===0?".":g}return l}case"fileDirname":return v.$pc(r(a.VariableKind.FileDirname));case"fileExtname":return v.$rc(r(a.VariableKind.FileExtname));case"fileBasename":return v.$qc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=v.$qc(r(a.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-v.$rc(l).length)}case"fileDirnameBasename":return v.$qc(v.$pc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||d}case"execInstallFolder":{const l=this.a.getAppRoot();return l||d}case"pathSeparator":case"/":return v.sep;default:try{const l=h?`${n}:${h}`:n;return this.p(a.VariableKind.Unknown,d,l,o,void 0)}catch{return d}}}}p(E,d,n,s,o){if(n&&s){const h=o===void 0?s[n]:s[o+":"+n];if(typeof h=="string")return h;throw new a.$PQ(E,(0,p.localize)(14,null,d))}return d}}e.$5Q=y}),define(Ie[118],Pe([1,0,3,115]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=u,e.$mE=E,e.$jE=(0,v.$Gi)("editorGroupsService");var C;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var N;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function a(d){const n=d;return(0,I.$8F)(n?.editor)&&(0,I.$8F)(n?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(Ie[246],Pe([1,0,3,118]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=C,e.$nE=(0,v.$Gi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function C(N){const A=N;return typeof N=="number"||(0,I.$lE)(A)}}),define(Ie[247],Pe([1,0,3,107]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,v.$Hi)(I.$Ni)}),define(Ie[119],Pe([1,0,19,6,20,4,11]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=e.$Pcc=void 0,C=Ve(C);class T{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Pcc=T;class p{static isHostExtension(h,i,r){if(i.getExtensionDescription(h))return!1;const t=r.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new I.$ne,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$tn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=s(this.e,i),this.e=this.e.concat(h);const r=p.l(this.e);return this.e=s(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this.c.has(g)?this.c.get(g).push(m):this.c.set(g,[m])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,m){const $=i.getArcs(g);for(let D=0;D<$.length;D++)if(!m.has($[D]))return!1;return!0}getNodes(){return this.e}},r=new v.$tn;for(const g of h)if(r.set(g.identifier,g),g.extensionDependencies)for(const m of g.extensionDependencies)i.addArc(v.$rn.toKey(g.identifier),v.$rn.toKey(m));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const c=i.getNodes().filter(g=>!t.has(g));let l;do{l=!1;for(let g=0;g<c.length;g++){const m=c[g];i.hasOnlyGoodArcs(m,t)&&(c.splice(g,1),g--,t.add(m),l=!0)}}while(l);return c.map(g=>r.get(g))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Qcc=p;class a{constructor(h,i){this.versionId=h,this.extensions=i}}e.$Rcc=a;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new y(this,i)}deltaExtensions(h,i,r){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$Scc=R;class y extends N.$Xc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Tcc=y;class u{constructor(h){this.name=h;const i=(0,A.$zh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};h.resolve((0,N.$Vc)(t))}}var d;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(d||(d={}));function n(o,h){const i=o.isBuiltin?d.Builtin:o.isUnderDevelopment?d.Dev:d.User,r=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=C.$jc.basename(o.extensionLocation.path),c=C.$jc.basename(h.extensionLocation.path);return t<c?-1:t>c?1:0}function s(o,h){const i=new v.$sn(h);return o.filter(r=>!i.has(r.identifier))}}),define(Ie[84],Pe([1,0,23]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=A,e.$Cn=T;var I;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(I||(e.UIKind=I={}));var C;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var N;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(a){const R=v.$Pe.alloc(1);switch(a){case N.Initialized:R.writeUInt8(1,0);break;case N.Ready:R.writeUInt8(2,0);break;case N.Terminate:R.writeUInt8(3,0);break}return R}function T(a,R){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return R===N.Initialized;case 2:return R===N.Ready;case 3:return R===N.Terminate;default:return!1}}var p;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ie[67],Pe([1,0,3,6,113,12,27,84,63,64,26,2,4,188]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=s;let d=class extends u.$Xc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new I.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new I.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$Ap,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,N.$ck)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===N.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,r){const t=this.getTelemetryDetails(),c=new n(i,r,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...l,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,i,r){this.f=h,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$in)((0,a.$Gp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const c=r.filter(l=>!l.isDisposed);c.length===0?this.r.delete(t):this.r.set(t,c)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(h.value),!1;let c=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),c=!0);return c}};e.$fQ=d,e.$fQ=d=He([qe(0,A.$eQ),qe(1,N.$bk)],d);class n{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,r,t,c,l,g){this.g=r,this.h=t,this.i=c,this.j=l,this.a=new I.$ne,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,a.$Jp)(i,[]),this.c&&(i=(0,R.$ho)(i,this.c)),this.b||(i=(0,R.$ho)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const r={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,a.$Jp)(r,[]),c=new Error(t.message,{cause:t.cause});c.stack=t.stack,c.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=n;function s(o){const h=Date.now()-new Date(o).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$iQ=(0,v.$Gi)("IExtHostTelemetry")}),define(Ie[25],Pe([1,0,6,2,219,112,19,3]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=u,e.$7G=E,e.$0G=o,e.$$G=h,e.$1G=Object.freeze({identifier:new A.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,T.$Gi)("extensionService");class p{constructor(t){this.dependency=t}}e.$4G=p;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,c,l){this.c=t,this.d=c.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$MG.createActivationEventsMap(this.d)}}set(t,c,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],m=[],$=[],D=[],S=y(this.d),b=y(c),k=(O,L)=>O.extensionLocation.toString()===L.extensionLocation.toString()||O.isBuiltin===L.isBuiltin||O.isUserBuiltin===L.isUserBuiltin||O.isUnderDevelopment===L.isUnderDevelopment;for(const O of this.d){const L=b.get(O.identifier);if(!L){g.push(O.identifier),S.delete(O.identifier);continue}if(!k(O,L)){g.push(O.identifier),S.delete(O.identifier);continue}}for(const O of c){const L=S.get(O.identifier);if(!L){m.push(O);continue}if(!k(L,O)){g.push(L.identifier),S.delete(L.identifier);continue}}const P=new A.$sn(this.e),f=new A.$sn(l);for(const O of this.e)f.has(O)||$.push(O);for(const O of l)P.has(O)||D.push(O);const w=N.$MG.createActivationEventsMap(m),F={versionId:t,toRemove:g,toAdd:m,addActivationEvents:w,myToRemove:$,myToAdd:D};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:c,toAdd:l,myToRemove:g,myToAdd:m}=t,$=new A.$sn(c),D=new A.$sn(g);for(let S=0;S<this.d.length;S++)$.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)D.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of l)this.d.push(S);for(const S of m)this.e.push(S);return this.f=null,t}containsExtension(t){for(const c of this.e)if(A.$rn.equals(c,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const c of this.d){if(!this.containsExtension(c.identifier))continue;const l=N.$MG.readActivationEvents(c);for(const g of l)t.add(g)}return t}}e.$5G=R;function y(r){const t=new A.$tn;for(const c of r)t.set(c.identifier,c);return t}function u(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function E(r,t){if(!u(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,c,l,g){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=g}}e.$8G=d;class n{constructor(t,c){this.description=t,this.value=c}}e.$9G=n;var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.$Pp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function h(r,t){const c=(0,C.$Np)(r.manifest.publisher,r.manifest.name);return{id:c,identifier:new A.$rn(c),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,c){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=i}),define(Ie[248],Pe([1,0,14,119,19,25,12,11]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=e.$6oc=e.$5oc=e.$4oc=e.$3oc=void 0,v=Ve(v);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,h,i,r){this.startup=o,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r}}e.$3oc=p;class a{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,h){return o===-1||h===-1?-1:h-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$4oc=a;class R{constructor(o,h,i,r,t,c){this.activationFailed=o,this.activationFailedError=h,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=c}}e.$5oc=R;class y extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$6oc=y;class u extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$7oc=u;class E extends R{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(o,h,i,r){this.g=r,this.a=o,this.b=h,this.c=i,this.d=new C.$tn,this.f=Object.create(null)}dispose(){for(const[o,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const o=[];for(const[h,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const h=this.d.get(o);return!!(h&&h.value)}getActivatedExtension(o){const h=this.d.get(o);if(!h||!h.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return h.value}async activateByEvent(o,h){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:h,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,h){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(o){const h=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const h=this.a.getExtensionDescription(o.id);if(!h){const t=new Error(`Cannot activate unknown extension '${o.id.value}'`),c=this.k(o,null,[],new E(t));return this.c.onExtensionActivationError(o.id,t,new N.$4G(o.id.value)),c}const i=[],r=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const t of r){if(this.m(t))continue;const c=this.d.get(t);if(c){i.push(c);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:o.reason}));continue}const l=this.a.getExtensionDescription(t);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:o.reason}));continue}const g=h.displayName||h.identifier.value,m=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${t}'`),$=this.k(o,h.displayName,[],new E(m));return this.c.onExtensionActivationError(h.identifier,m,new N.$4G(t)),$}return this.k(o,h.displayName,i,null)}k(o,h,i,r){const t=new n(o.id,h,o.reason,i,r,this.c,this.g);return this.d.set(o.id,t),t}l(o){return I.$Qcc.isHostExtension(o,this.a,this.b)}m(o){const h=this.b.getExtensionDescription(o);return h?!h.main&&!h.browser:!1}};e.$8oc=d,e.$8oc=d=He([qe(3,A.$ak)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,h,i,r,t,c,l){this.c=o,this.d=h,this.f=i,this.g=r,this.h=t,this.j=c,this.k=l,this.a=new T.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const h=this.g[o];if(h.value&&!h.value.activationFailed){this.g.splice(o,1),o--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const h=new Error;if(o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this.h=new E(h),this.b&&v.$7(o))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};n=He([qe(6,A.$ak)],n)});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[120],Pe([1,0,205,14,36,111,78,31,19,109,112,105]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,v=Ve(v),C=_t(C);const u=T.$ro.as(A.$so.JSONContribution);class E{constructor(t,c,l){this.a=t,this.b=c,this.c=l}d(t,c){this.a({type:t,message:c,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$UG=E;class d{static a(t){const c=new p.$sn;for(let l=0,g=t.length;l<g;l++)c.add(t[l].description.identifier);return c}static compute(t,c){if(!t||!t.length)return new d(c,[]);if(!c||!c.length)return new d([],t);const l=this.a(t),g=this.a(c),m=c.filter(D=>!l.has(D.description.identifier)),$=t.filter(D=>!g.has(D.description.identifier));return new d(m,$)}constructor(t,c){this.added=t,this.removed=c}}e.$VG=d;class n{constructor(t,c){this.name=t,this.defaultExtensionKind=c,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,I.$3)(t)}}}e.$WG=n;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(0,null),v.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:v.localize(2,null),properties:{vscode:{type:"string",description:v.localize(3,null),default:"^1.22.0"}}},publisher:{description:v.localize(4,null),type:"string"},displayName:{description:v.localize(5,null),type:"string"},categories:{description:v.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$qn},{type:"string",const:"Languages",deprecationMessage:v.localize(7,null)}]}},galleryBanner:{type:"object",description:v.localize(8,null),properties:{color:{description:v.localize(9,null),type:"string"},theme:{description:v.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(13,null)},enabledApiProposals:{markdownDescription:v.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(15,null),type:"string",enum:["none"],enumDescriptions:[v.localize(16,null)]},activationEvents:{description:v.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(32,null)},{label:"onUri",body:"onUri",description:v.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(37,null)},{label:"onRenderer",description:v.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(44,null)},{label:"*",description:v.localize(45,null),body:"*"}]}},badges:{type:"array",description:v.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(47,null)},href:{type:"string",description:v.localize(48,null)},description:{type:"string",description:v.localize(49,null)}}}},markdown:{type:"string",description:v.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$9o}},extensionPack:{description:v.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$9o}},extensionKind:{description:v.localize(54,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(55,null)},{body:["workspace"],description:v.localize(56,null)},{body:["ui","workspace"],description:v.localize(57,null)},{body:["workspace","ui"],description:v.localize(58,null)},{body:[],description:v.localize(59,null)}]},capabilities:{description:v.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(63,null),v.localize(64,null),v.localize(65,null)]},description:{type:"string",markdownDescription:v.localize(66,null)}}},untrustedWorkspaces:{description:v.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)]},restrictedConfigurations:{description:v.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(73,null)}}}}},sponsor:{description:v.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(76,null),type:"string"},"vscode:uninstall":{description:v.localize(77,null),type:"string"}}},icon:{type:"string",description:v.localize(78,null)},l10n:{type:"string",description:v.localize(79,null)},pricing:{type:"string",markdownDescription:v.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const c=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,c),t.activationEventsGenerator&&R.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(o,e.$XG),c}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$ro.add(i.ExtensionsRegistry,new h),e.$ZG=T.$ro.as(i.ExtensionsRegistry),u.registerSchema(o,e.$XG),u.registerSchema(a.$uk,{properties:{extensionEnabledApiProposals:{description:v.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Ie[249],Pe([1,0,6,40,4,13,197,19,3,12,25,120]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var u;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$aH=(0,p.$Gi)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$bH=y.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(n,s)=>{for(const o of n)s.push(`onLanguageModelChat:${o.vendor}`)}});let d=class{constructor(s,o){this.e=s,this.f=o,this.a=new C.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(h=>{this.c.clear();for(const r of h){if(!(0,R.$6G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(2,null));continue}for(const t of I.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(3,null,t.vendor));continue}if((0,N.$ef)(t.vendor)){r.collector.error((0,A.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(5,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const o=[];for(const[h,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$rn.equals(r,s.extension)))&&o.push(h);return this.f.trace("[LM] selected language models",s,o),o}registerLanguageModelChat(s,o){if(this.f.trace("[LM] registering language model chat",s,o.metadata),!this.c.has(o.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${o.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,o),this.d.fire({added:[{identifier:s,metadata:o.metadata}]}),(0,C.$Vc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,o.metadata))})}async sendChatRequest(s,o,h,i,r){const t=this.b.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(h,o,i,r)}computeTokenLength(s,o,h){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(o,h)}};e.$cH=d,e.$cH=d=He([qe(0,R.$3G),qe(1,a.$ak)],d)}),define(Ie[250],Pe([1,0,200,15,26,120,32,6]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=void 0,v=Ve(v),I=Ve(I),C=Ve(C);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(2,null),default:""}}};var a;(function(u){function E(d,n,s){if(!d)return;const o=I.$gg(d.type)?d.type:void 0;if(!o||o.length===0){s.error(v.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const i of d.required)I.$gg(i)&&h.push(i);return{extensionId:n.value,taskType:o,required:h,properties:d.properties?C.$eo(d.properties):{},when:d.when?A.$Ej.deserialize(d.when):void 0}}u.from=E})(a||(a={}));const R=N.$ZG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const d of u)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(4,null),type:"array",items:p}});class y{constructor(){this.d=new T.$ne,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{R.setHandler((n,s)=>{this.c=void 0;try{for(const o of s.removed){const h=o.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const h=o.value;for(const i of h){const r=a.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=C.$eo(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},E.push(n)}this.c={oneOf:E}}return this.c}}e.$HI=new y}),define(Ie[251],Pe([1,0,201,15,24,26,32,250,43]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RI=e.JsonSchemaVersion=e.ExecutionEngine=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LI=e.ShellQuoting=e.$KI=e.$JI=e.$II=void 0,v=Ve(v),I=Ve(I),C=Ve(C),N=Ve(N),e.$II="settings",e.$JI=new A.$Xj("taskRunning",!1,v.localize(0,null)),e.$KI=v.localize2(2,"Tasks");var a;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$LI="$customized",function(M){function Y(Z){if(!Z)return M.Strong;switch(Z.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=Y}(a||(e.ShellQuoting=a={}));var R;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(y||(e.RevealKind=y={})),function(M){function Y(Z){switch(Z.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=Y}(y||(e.RevealKind=y={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function Y(Z){switch(Z.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=Y}(u||(e.RevealProblemKind=u={}));var E;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(E||(e.PanelKind=E={})),function(M){function Y(Z){switch(Z.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=Y}(E||(e.PanelKind=E={}));var d;(function(M){M.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(M){function Y(ge){switch(ge.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=Y;function Z(ge){switch(ge){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=Z}(n||(e.RuntimeType=n={}));var s;(function(M){function Y(Z){return I.$gg(Z)?Z:Z.value}M.value=Y})(s||(e.CommandString=s={}));var o;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function Y(ge){return ge===M.Clean._id||ge===M.Build._id||ge===M.Rebuild._id||ge===M.Test._id}M.is=Y;function Z(ge){if(ge!==void 0)return I.$gg(ge)?Y(ge)?{_id:ge,isDefault:!1}:void 0:ge}M.from=Z})(o||(e.TaskGroup=o={}));var h;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function Y(Z){switch(Z){case M.User:return p.ConfigurationTarget.USER;case M.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=Y})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var c;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class l{constructor(Y,Z,ge,_,me,se){this._label="",this._id=Y,Z&&(this._label=Z),ge&&(this.type=ge),this.runOptions=_,this.configurationProperties=me,this._source=se}getDefinition(Y){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Y={folder:this.d(),id:this._id};return JSON.stringify(Y)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Y,Z=!1){if(Y===void 0)return!1;if(I.$gg(Y))return Y===this._label||Y===this.configurationProperties.identifier||Z&&Y===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===Y._key}getQualifiedLabel(){const Y=this.getWorkspaceFolder();return Y?`${this._label} (${Y.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Y){this.c===void 0&&(this.c=[]),Y&&(this.c=this.c.concat(Y))}get taskLoadMessages(){return this.c}}e.$MI=l;class g extends l{constructor(Y,Z,ge,_,me,se,ce,we){super(Y,ge,void 0,ce,we,Z),this.command={},this._source=Z,this.hasDefinedMatchers=se,me&&(this.command=me)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Y=!1){if(Y&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case n.Shell:Z="shell";break;case n.Process:Z="process";break;case n.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(Y){return Y instanceof g}getMapKey(){const Y=this._source.config.workspaceFolder;return Y?`${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ge={type:e.$LI,folder:Y,id:Z};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(Y){return new g(Y._id,Y._source,Y._label,Y.type,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$NI=g;class m extends l{constructor(Y,Z,ge,_,me,se,ce){super(Y,ge,_,se,ce,Z),this._source=Z,this.configures=me}static is(Y){return Y instanceof m}f(Y){return Y}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$II:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ge={type:e.$LI,folder:Y,id:Z};return JSON.stringify(ge)}}e.$OI=m;class $ extends l{constructor(Y,Z,ge,_,me,se,ce,we,oe){super(Y,ge,_,we,oe,Z),this.defines=me,this.hasDefinedMatchers=ce,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Y){return Y instanceof $}getMapKey(){const Y=this._source.workspaceFolder;return Y?`${this._source.scope.toString()}|${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Y={type:"contributed",scope:this._source.scope,id:this._id};return Y.folder=this.d(),JSON.stringify(Y)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(Y){return new $(Y._id,Y._source,Y._label,Y.type,Y.defines,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$PI=$;class D extends l{constructor(Y,Z,ge,_,me,se){super(Y,ge,_,me,se,Z),this._source=Z}clone(){return new D(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Y){return Y instanceof D}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(Y){return new D(Y._id,Y._source,Y._label,Y.type,Y.runOptions,Y.configurationProperties)}}e.$QI=D;var S;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(M){M._default=M.Terminal}(S||(e.ExecutionEngine=S={}));var b;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class k{constructor(Y){this.c=new Map;for(let Z=0;Z<Y.length;Z++)this.c.set(Y[Z].uri.toString(),Z)}compare(Y,Z){const ge=Y.getWorkspaceFolder(),_=Z.getWorkspaceFolder();if(ge&&_){let me=this.c.get(ge.uri.toString());me=me===void 0?0:me+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,me===se?Y._label.localeCompare(Z._label):me-se}else return!ge&&_?-1:ge&&!_?1:0}}e.$RI=k;var P;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(P||(e.TaskEventKind=P={}));var f;(function(M){M.SingleRun="singleRun",M.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var F;(function(M){function Y(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?f.Background:f.SingleRun,group:we.configurationProperties.group,__task:we}}function Z(we,oe,Ce){return{...Y(we),kind:P.Start,terminalId:oe,resolvedVariables:Ce}}M.start=Z;function ge(we,oe,Ce){return{...Y(we),kind:P.ProcessStarted,terminalId:oe,processId:Ce}}M.processStarted=ge;function _(we,oe,Ce){return{...Y(we),kind:P.ProcessEnded,terminalId:oe,exitCode:Ce}}M.processEnded=_;function me(we,oe,Ce){return{...Y(we),kind:P.Terminated,exitReason:Ce,terminalId:oe}}M.terminated=me;function se(we,oe,Ce){return{...Y(oe),kind:we,terminalId:Ce}}M.general=se;function ce(){return{kind:P.Changed}}M.changed=ce})(F||(e.TaskEvent=F={}));var O;(function(M){function Y(ge){const _=Object.keys(ge).sort();let me="";for(const se of _){let ce=ge[se];ce instanceof Object?ce=Y(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),me+=se+","+ce+","}return me}function Z(ge){const me={_key:Y(ge),type:ge.taskType};return Object.assign(me,ge),me}M.create=Z})(O||(e.KeyedTaskIdentifier=O={}));var L;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var q;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var W;(function(M){function Y(Z,ge){const _=T.$HI.get(Z.type);if(_===void 0){const we=N.$eo(Z);return delete we._key,O.create(we)}const me=Object.create(null);me.type=_.taskType;const se=new Set;_.required.forEach(we=>se.add(we));const ce=_.properties;for(const we of Object.keys(ce)){const oe=Z[we];if(oe!=null)me[we]=oe;else if(se.has(we)){const Ce=ce[we];if(Ce.default!==void 0)me[we]=N.$eo(Ce.default);else switch(Ce.type){case"boolean":me[we]=!1;break;case"number":case"integer":me[we]=0;break;case"string":me[we]="";break;default:ge.error(v.localize(1,null,JSON.stringify(Z,void 0,0),we));return}}}return O.create(me)}M.createTaskIdentifier=Y})(W||(e.TaskDefinition=W={}))}),define(Ie[252],Pe([1,0,14]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0;class I{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$3)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Ucc=I;class C extends I{constructor(){super(),this.h=!0,this.i=new v.$8}}e.$Vcc=C}),define(Ie[39],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=C,e.$Tw=N;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$Rw=v;const I=[];function C(T){const p=new v(T);return I[p.nid]=p,p}function N(T){return I[T].sid}class A{constructor(p){this.value=p}}e.$Uw=A}),define(Ie[5],Pe([1,0,39]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(I||(e.TextEditorRevealType=I={}));var C;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var N;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$tN=y;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$uN={MainThreadAuthentication:(0,v.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Sw)("MainThreadCommands"),MainThreadComments:(0,v.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Sw)("MainThreadSCM"),MainThreadSearch:(0,v.$Sw)("MainThreadSearch"),MainThreadShare:(0,v.$Sw)("MainThreadShare"),MainThreadTask:(0,v.$Sw)("MainThreadTask"),MainThreadWindow:(0,v.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Sw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,v.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Sw)("ExtHostSCM"),ExtHostSearch:(0,v.$Sw)("ExtHostSearch"),ExtHostTask:(0,v.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Sw)("ExtHostProgress"),ExtHostComments:(0,v.$Sw)("ExtHostComments"),ExtHostSecretState:(0,v.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Sw)("ExtHostStorage"),ExtHostUrls:(0,v.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Sw)("ExtHostLocalization")}}),define(Ie[85],Pe([1,0,3,12,5,17]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=e.$qoc=e.$poc=void 0,C=Ve(C),e.$poc=(0,v.$Gi)("IExtHostApiDeprecationService");let A=class{constructor(p,a){this.c=a,this.a=new Set,this.b=p.getProxy(C.$uN.MainThreadTelemetry)}report(p,a,R){const y=this.d(p,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:p}))}d(p,a){return`${p}-${a.identifier.value}`}};e.$qoc=A,e.$qoc=A=He([qe(0,N.$1P),qe(1,I.$ak)],A),e.$roc=Object.freeze(new class{report(T,p,a){}})}),define(Ie[253],Pe([1,0,5]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class I{constructor(N){const A=N.getProxy(v.$uN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Eoc=I}),define(Ie[254],Pe([1,0,26,5,27,17]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(I.$uN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,y,E,arguments)}})}e(R,y,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(E,this.b)}),this.c&&this.f(R,u,E)}};e.$Aqc=A,e.$Aqc=A=He([qe(0,N.$1P),qe(1,C.$eQ)],A);const T=1e5;function p(a,R){const y=[];if(a.length)for(let u=0;u<a.length;u++){let E=a[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}y.push(E)}if(R){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$jo)(y);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ie[255],Pe([1,0,2,5,25]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0;class N{constructor(T){this.a=T.getProxy(I.$uN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,C.$7G)(T,"showLocal"),this.a.$showOpenDialog(p).then(a=>a?a.map(R=>v.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?v.URI.revive(p):void 0)}}e.$Gpc=N}),define(Ie[256],Pe([1,0,22,6,4,5]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class A{constructor(p){this.b=new Map,this.c=new I.$ne,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(N.$uN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,a,R){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:R}),(0,C.$Vc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,a,R){R??=v.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const u=await this.a.$computeEmbeddings(p,a,R);if(u.length!==a.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,a,R){const y=this.b.get(p);if(!y)return[];const u=await y.provider.provideEmbeddings(a,R);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Jpc=A}),define(Ie[257],Pe([1,0,4,5]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(I.$uN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$1pc=C}),define(Ie[86],Pe([1,0,21,13,2,3,12,5,27,17]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0;let R=class{constructor(u,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(T.$uN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$g}getMessage(u,E){const{message:d,args:n,comment:s}=E;if(this.c)return(0,I.$gf)(d,n??{});let o=d;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const h=this.d.get(u)?.contents[o];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,I.$gf)(h??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),s=JSON.parse(n);E=u.isBuiltin?s.contents?.bundle:s}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:d})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(E)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$jpc=R,e.$jpc=R=He([qe(0,p.$eQ),qe(1,a.$1P),qe(2,A.$ak)],R),e.$kpc=(0,N.$Gi)("IExtHostLocalizationService")}),define(Ie[258],Pe([1,0,12,5,27,17,2,49]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;let p=class extends v.$lk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,T.$di)(E))),this.r=y.getProxy(I.$uN.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,E){return new a(this.r,y,u,E)}};e.$zqc=p,e.$zqc=p=He([qe(0,N.$1P),qe(1,C.$eQ)],p);class a extends v.$gk{constructor(y,u,E,d){super(d?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const E=[[y,u]];this.m?this.u(E):this.n.push(...E)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ie[87],Pe([1,0,5,3,4,17,23]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,e.$lpc=(0,I.$Gi)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$uN.MainThreadManagedSockets)}setFactory(y,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,E=await this.c.makeConnection(),d=new C.$Wc;return this.d.set(u,new a(u,E,d)),d.add((0,C.$Vc)(()=>this.d.delete(u))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(E.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(E.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,A.$Pe.wrap(n)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$mpc=T,e.$mpc=T=He([qe(0,N.$1P)],T);class p{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class a extends C.$Xc{constructor(y,u,E){super(),this.socketId=y,this.actual=u,this.B(E)}}}),define(Ie[259],Pe([1,0,5,12,25]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;function N(T){return T&&T.title}let A=class{constructor(p,a){this.b=a,this.a=p.getProxy(v.$uN.MainThreadMessageService)}showMessage(p,a,R,y,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||N(y)?d=[y,...u]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,d=u),E.useCustom&&(0,C.$7G)(p,"resolvers");const n=[];let s=!1;for(let o=0;o<d.length;o++){const h=d[o];if(typeof h=="string")n.push({title:h,handle:o,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:r}=h;n.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(a,R,E,n).then(o=>{if(typeof o=="number")return d[o]})}};e.$4pc=A,e.$4pc=A=He([qe(1,I.$ak)],A)}),define(Ie[260],Pe([1,0,4,15,2,25,5]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$uN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,R,y){if((0,N.$7G)(a,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,a.identifier.value),(0,v.$Vc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(a,R,y,u){const E=this.b.get(a);if(!E)throw new Error(`Unknown handler with id: ${a}`);return E.saveProfile(R,y,u)}async $readProfile(a,R,y){const u=this.b.get(a);if(!u)throw new Error(`Unknown handler with id: ${a}`);return u.readProfile((0,I.$gg)(R)?R:C.URI.revive(R),y)}}e.$aqc=T}),define(Ie[88],Pe([1,0,5,6,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;class N{constructor(T){this.b=new I.$ne,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$uN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,a){return this.a.$setPassword(T,p,a)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$gpc=N,e.$hpc=(0,C.$Gi)("IExtHostSecretState")}),define(Ie[261],Pe([1,0,22,4,5]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0;class N{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$uN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new I.$Wc,u=new v.$ye;this.d.set(p,u);const E=await R.provideSpeechToTextSession(u.token,a?{language:a}:void 0);E&&(y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new I.$Wc,u=new v.$ye;this.d.set(p,u);const E=await R.provideTextToSpeechSession(u.token,a?{language:a}:void 0);E&&(this.f.set(p,E),y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const a=this.c.get(T);if(!a)return;const R=new I.$Wc,y=new v.$ye;this.d.set(p,y);const u=await a.provideKeywordRecognitionSession(y.token);u&&(R.add(u.onDidChange(E=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,a){const R=N.a++;return this.c.set(R,a),this.b.$registerProvider(R,p,{extension:T,displayName:T.value}),(0,I.$Vc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$hqc=N}),define(Ie[89],Pe([1,0,5,6,3]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;class N{constructor(T,p){this.c=p,this.b=new I.$ne,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$uN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,a){const R=await this.a.$initializeExtensionStorage(T,p);let y;return R&&(y=this.d(T,p,R)),y||a}setValue(T,p,a){return this.a.$setValue(T,p,a)}$acceptValue(T,p,a){const R=this.d(T,p,a);R&&this.b.fire({shared:T,key:p,value:R})}d(T,p,a){try{return JSON.parse(a)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${R}`)}}}e.$9oc=N,e.$0oc=(0,C.$Gi)("IExtHostStorage")}),define(Ie[262],Pe([1,0,4,16,2,5]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0;class A{static{this.a=new Set([I.Schemas.http,I.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(N.$uN.MainThreadUriOpeners)}registerExternalUriOpener(p,a,R,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const u=y.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(a,R),this.b.$registerUriOpener(a,y.schemes,p,y.label),(0,v.$Vc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const u=C.URI.revive(a);return y.canOpenExternalUri(u,R)}async $openUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(C.URI.revive(a.resolvedUri),{sourceUri:C.URI.revive(a.sourceUri)},R)}}e.$tqc=A}),define(Ie[263],Pe([1,0,5,2,4,14,19]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$sn,this.d=new Map,this.b=a.getProxy(v.$uN.MainThreadUrls)}registerUriHandler(a,R){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=T.a++;return this.c.add(y),this.d.set(u,R),this.b.$registerUriHandler(u,y,a.displayName||a.name),(0,C.$Vc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(a,R){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(I.URI.revive(R))}catch(u){(0,N.$3)(u)}return Promise.resolve(void 0)}async createAppUri(a){return I.URI.revive(await this.b.$createAppUri(a))}}e.$uqc=T}),define(Ie[264],Pe([1,0,23,5]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ztb=N,e.$Atb=T,I=Ve(I);class C{constructor(){this.buffers=[]}add(a){let R=this.buffers.indexOf(a);return R<0&&(R=this.buffers.length,this.buffers.push(a)),R}}function N(p,a){if(a.serializeBuffersForPostMessage){const R=new C,u=JSON.stringify(p,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const s=A(n);if(s)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:s,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),E=R.buffers.map(d=>{const n=new Uint8Array(d);return v.$Pe.wrap(n)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return I.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return I.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return I.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return I.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return I.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return I.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return I.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return I.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return I.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return I.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return I.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,a){const R=a.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),y=a.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:s}=n,o=R[s];if(n.view)switch(n.view.type){case I.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(o,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(o,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(o,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(o,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(o,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(o,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(o,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(o,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(o,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(o,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(o,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:R}}}),define(Ie[68],Pe([1,0,6,4,16,26,2,216,264,83,5]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Toc=void 0,e.$Uoc=u,e.$Woc=n,e.$Xoc=s,N=Ve(N),R=Ve(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,t,c,l,g,m,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new v.$ne,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$ne,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=c,this.#n=l,this.#s=g,this.#r=m,this.#l=u(m),this.#d=E(m),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,a.$hDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===C.Schemas.https||r.scheme===C.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$gDb}return a.$gDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),N.$io(this.#o,r)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,p.$ztb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,c=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,m,$,D,S)=>{const b=A.URI.from({scheme:$||"file",path:decodeURIComponent(D)}),k=(0,a.$hDb)(b,{isRemote:t,authority:c}).toString();return`${g}${k}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,m,$,D,S)=>{const b=A.URI.from({scheme:$||"file",path:decodeURIComponent(D)}),k=(0,a.$hDb)(b,{isRemote:t,authority:c}).toString();return`${g}${k}${S}`})}}e.$Toc=y;function u(i){try{const r=(0,T.$Zp)((0,T.$Yp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,T.$Zp)((0,T.$Yp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d extends I.$Xc{constructor(r,t,c,l,g){super(),this.c=t,this.f=c,this.g=l,this.h=g,this.b=new Map,this.a=r.getProxy(R.$uN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,c){const l=this.j(r);if(l){const{message:g}=(0,p.$Atb)(t,c.value);l._onMessageEmitter.fire(g)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,c){const l=new y(r,this.a,o(t),this.c,this.f,c,this.h);this.b.set(r,l);const g=l._onDidDispose(()=>{g.dispose(),this.deleteWebview(r)});return l}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Voc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||h(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function h(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ie[121],Pe([1,0,6,16,13,2,3,17,5]),function(ae,e,v,I,C,N,A,T,p){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=e.$wqc=void 0;let R=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$ne,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=u.getProxy(p.$uN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let d;if(typeof u=="string"){d=u;try{u=N.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$ef)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,E)}async asExternalUri(u,E){if((0,C.$ef)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,E);return N.URI.from(d)}};e.$wqc=R,e.$wqc=R=a=He([qe(0,T.$1P)],R),e.$xqc=(0,A.$Gi)("IExtHostWindow")}),define(Ie[265],Pe([1,0,254,27,17]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;let N=class extends v.$Aqc{constructor(T,p){super(T,p)}f(T,p,a){p.apply(console,a)}};e.$Ksc=N,e.$Ksc=N=He([qe(0,C.$1P),qe(1,I.$eQ)],N)}),define(Ie[266],Pe([1,0,11,23,22,28,14,6,4,38,161,252,39]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Wcc=h,e.$Xcc=i,A=Ve(A);function d(F,O){try{return JSON.stringify(F,O)}catch{return"null"}}const n="$$ref$$",s={[n]:-1};class o{constructor(O,L){this.jsonString=O,this.referencedBuffers=L}}function h(F,O=null,L=!1){const q=[];return{jsonString:(L?d:JSON.stringify)(F,(M,Y)=>{if(typeof Y>"u")return s;if(typeof Y=="object"){if(Y instanceof I.$Pe){const Z=q.push(Y)-1;return{[n]:Z}}if(O)return O(M,Y)}return Y}),referencedBuffers:q}}function i(F,O,L){return JSON.parse(F,(q,W)=>{if(W){const M=W[n];if(typeof M=="number")return O[M];if(L&&W.$mid===a.MarshalledId.Uri)return L.transformIncoming(W)}return W})}function r(F,O){return JSON.stringify(F,O)}function t(F){return F?(O,L)=>L&&L.$mid===a.MarshalledId.Uri?F.transformOutgoing(L):L:null}var c;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const g=()=>{},m=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class D extends p.$Xc{static{E=m}static{this.a=3*1e3}constructor(O,L=null,q=null){super(),this[E]=!0,this.b=this.B(new T.$ne),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=L,this.g=q,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,M=u.$Rw.count;W<M;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const L=this.w[O];delete this.w[O],L.resolveErr(A.$9())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+D.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+D.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,R.$Pn)(O,this.g):O}getProxy(O){const{nid:L,sid:q}=O;return this.s[L]||(this.s[L]=this.J(L,q)),this.s[L]}J(O,L){const q={get:(W,M)=>(typeof M=="string"&&!W[M]&&M.charCodeAt(0)===N.CharCode.DollarSign&&(W[M]=(...Y)=>this.U(O,M,Y)),M===$?L:W[M])};return new Proxy(Object.create(null),q)}set(O,L){return this.m[O.nid]=L,L}assertRegistered(O){for(let L=0,q=O.length;L<q;L++){const W=O[L];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(O){if(this.j)return;const L=O.byteLength,q=b.read(O,0),W=q.readUInt8(),M=q.readUInt32();switch(W){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:Y,method:Z,args:ge}=P.deserializeRequestJSONArgs(q);this.g&&(ge=(0,R.$Pn)(ge,this.g)),this.M(L,M,Y,Z,ge,W===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:Y,method:Z,args:ge}=P.deserializeRequestMixedArgs(q);this.g&&(ge=(0,R.$Pn)(ge,this.g)),this.M(L,M,Y,Z,ge,W===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,M,c.LocalSide,"ack"),this.G(M);break}case f.Cancel:{this.N(L,M);break}case f.ReplyOKEmpty:{this.O(L,M,void 0);break}case f.ReplyOKJSON:{let Y=P.deserializeReplyOKJSON(q);this.g&&(Y=(0,R.$Pn)(Y,this.g)),this.O(L,M,Y);break}case f.ReplyOKJSONWithBuffers:{const Y=P.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(L,M,Y);break}case f.ReplyOKVSBuffer:{const Y=P.deserializeReplyOKVSBuffer(q);this.O(L,M,Y);break}case f.ReplyErrError:{let Y=P.deserializeReplyErrError(q);this.g&&(Y=(0,R.$Pn)(Y,this.g)),this.P(L,M,Y);break}case f.ReplyErrEmpty:{this.P(L,M,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,L,q,W,M,Y){this.f?.logIncoming(O,L,c.OtherSide,`receiveRequest ${(0,u.$Tw)(q)}.${W}(`,M);const Z=String(L);let ge,_;if(Y){const se=new C.$ye;M.push(se.token),ge=this.Q(q,W,M),_=()=>se.cancel()}else ge=this.Q(q,W,M),_=g;this.u[Z]=_;const me=P.serializeAcknowledged(L);this.f?.logOutgoing(me.byteLength,L,c.OtherSide,"ack"),this.c.send(me),ge.then(se=>{delete this.u[Z];const ce=P.serializeReplyOK(L,se,this.h);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"reply:",se),this.c.send(ce)},se=>{delete this.u[Z];const ce=P.serializeReplyErr(L,se);this.f?.logOutgoing(ce.byteLength,L,c.OtherSide,"replyErr:",se),this.c.send(ce)})}N(O,L){this.f?.logIncoming(O,L,c.OtherSide,"receiveCancel");const q=String(L);this.u[q]?.()}O(O,L,q){this.f?.logIncoming(O,L,c.LocalSide,"receiveReply:",q);const W=String(L);if(!this.w.hasOwnProperty(W))return;const M=this.w[W];delete this.w[W],M.resolveOk(q)}P(O,L,q){this.f?.logIncoming(O,L,c.LocalSide,"receiveReplyErr:",q);const W=String(L);if(!this.w.hasOwnProperty(W))return;const M=this.w[W];delete this.w[W];let Y;q&&(q.$isError?(Y=new Error,Y.name=q.name,Y.message=q.message,Y.stack=q.stack):Y=q),M.resolveErr(Y)}Q(O,L,q){try{return Promise.resolve(this.S(O,L,q))}catch(W){return Promise.reject(W)}}S(O,L,q){const W=this.m[O];if(!W)throw new Error("Unknown actor "+(0,u.$Tw)(O));const M=W[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$Tw)(O));return M.apply(W,q)}U(O,L,q){if(this.j)return new y.$Vcc;let W=null;if(q.length>0&&C.CancellationToken.isCancellationToken(q[q.length-1])&&(W=q.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$9());const M=P.serializeRequestArguments(q,this.h),Y=++this.t,Z=String(Y),ge=new y.$Ucc,_=new p.$Wc;W&&_.add(W.onCancellationRequested(()=>{const se=P.serializeCancel(Y);this.f?.logOutgoing(se.byteLength,Y,c.LocalSide,"cancel"),this.c.send(P.serializeCancel(Y))})),this.w[Z]=new S(ge,_),this.F(Y);const me=P.serializeRequest(Y,O,L,M,!!W);return this.f?.logOutgoing(me.byteLength,Y,c.LocalSide,`request: ${(0,u.$Tw)(O)}.${L}(`,q),this.c.send(me),ge}}e.$Ycc=D;class S{constructor(O,L){this.a=O,this.b=L}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class b{static alloc(O,L,q){const W=new b(I.$Pe.alloc(q+1+4),0);return W.writeUInt8(O),W.writeUInt32(L),W}static read(O,L){return new b(O,L)}get buffer(){return this.a}constructor(O,L){this.a=O,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+O);return this.b+=O,L}static sizeMixedArray(O){let L=0;L+=1;for(let q=0,W=O.length;q<W;q++){const M=O[q];switch(L+=1,M.type){case w.String:L+=this.sizeLongString(M.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(M.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let Y=0;Y<M.buffers.length;++Y)L+=this.sizeVSBuffer(M.buffers[Y]);break;case w.Undefined:break}}return L}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let L=0,q=O.length;L<q;L++){const W=O[L];switch(W.type){case w.String:this.writeUInt8(w.String),this.writeLongString(W.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(W.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let M=0;M<W.buffers.length;++M)this.writeBuffer(W.buffers[M]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const L=new Array(O);for(let q=0;q<O;q++)switch(this.readUInt8()){case w.String:L[q]=this.readLongString();break;case w.VSBuffer:L[q]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const M=this.readUInt32(),Y=this.readLongString(),Z=[];for(let ge=0;ge<M;++ge)Z.push(this.readVSBuffer());L[q]=new u.$Uw(i(Y,Z,null));break}case w.Undefined:L[q]=void 0;break}return L}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class P{static a(O){for(let L=0,q=O.length;L<q;L++)if(O[L]instanceof I.$Pe||O[L]instanceof u.$Uw||typeof O[L]>"u")return!0;return!1}static serializeRequestArguments(O,L){if(this.a(O)){const q=[];for(let W=0,M=O.length;W<M;W++){const Y=O[W];if(Y instanceof I.$Pe)q[W]={type:w.VSBuffer,value:Y};else if(typeof Y>"u")q[W]={type:w.Undefined};else if(Y instanceof u.$Uw){const{jsonString:Z,referencedBuffers:ge}=h(Y.value,L);q[W]={type:w.SerializedObjectWithBuffers,value:I.$Pe.fromString(Z),buffers:ge}}else q[W]={type:w.String,value:I.$Pe.fromString(r(Y,L))}}return{type:k.Mixed,args:q}}return{type:k.Simple,args:r(O,L)}}static serializeRequest(O,L,q,W,M){switch(W.type){case k.Simple:return this.b(O,L,q,W.args,M);case k.Mixed:return this.c(O,L,q,W.args,M)}}static b(O,L,q,W,M){const Y=I.$Pe.fromString(q),Z=I.$Pe.fromString(W);let ge=0;ge+=b.sizeUInt8(),ge+=b.sizeShortString(Y),ge+=b.sizeLongString(Z);const _=b.alloc(M?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,O,ge);return _.writeUInt8(L),_.writeShortString(Y),_.writeLongString(Z),_.buffer}static deserializeRequestJSONArgs(O){const L=O.readUInt8(),q=O.readShortString(),W=O.readLongString();return{rpcId:L,method:q,args:JSON.parse(W)}}static c(O,L,q,W,M){const Y=I.$Pe.fromString(q);let Z=0;Z+=b.sizeUInt8(),Z+=b.sizeShortString(Y),Z+=b.sizeMixedArray(W);const ge=b.alloc(M?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,O,Z);return ge.writeUInt8(L),ge.writeShortString(Y),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(O){const L=O.readUInt8(),q=O.readShortString(),W=O.readMixedArray(),M=new Array(W.length);for(let Y=0,Z=W.length;Y<Z;Y++){const ge=W[Y];typeof ge=="string"?M[Y]=JSON.parse(ge):M[Y]=ge}return{rpcId:L,method:q,args:M}}static serializeAcknowledged(O){return b.alloc(f.Acknowledged,O,0).buffer}static serializeCancel(O){return b.alloc(f.Cancel,O,0).buffer}static serializeReplyOK(O,L,q){if(typeof L>"u")return this.d(O);if(L instanceof I.$Pe)return this.e(O,L);if(L instanceof u.$Uw){const{jsonString:W,referencedBuffers:M}=h(L.value,q,!0);return this.g(O,W,M)}else return this.f(O,d(L,q))}static d(O){return b.alloc(f.ReplyOKEmpty,O,0).buffer}static e(O,L){let q=0;q+=b.sizeVSBuffer(L);const W=b.alloc(f.ReplyOKVSBuffer,O,q);return W.writeVSBuffer(L),W.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,L){const q=I.$Pe.fromString(L);let W=0;W+=b.sizeLongString(q);const M=b.alloc(f.ReplyOKJSON,O,W);return M.writeLongString(q),M.buffer}static g(O,L,q){const W=I.$Pe.fromString(L);let M=0;M+=b.sizeUInt32,M+=b.sizeLongString(W);for(const Z of q)M+=b.sizeVSBuffer(Z);const Y=b.alloc(f.ReplyOKJSONWithBuffers,O,M);Y.writeUInt32(q.length),Y.writeLongString(W);for(const Z of q)Y.writeBuffer(Z);return Y.buffer}static deserializeReplyOKJSON(O){const L=O.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(O,L){const q=O.readUInt32(),W=O.readLongString(),M=[];for(let Y=0;Y<q;++Y)M.push(O.readVSBuffer());return new u.$Uw(i(W,M,L))}static serializeReplyErr(O,L){const q=L?d(A.$5(L),null):void 0;if(typeof q!="string")return this.h(O);const W=I.$Pe.fromString(q);let M=0;M+=b.sizeLongString(W);const Y=b.alloc(f.ReplyErrError,O,M);return Y.writeLongString(W),Y.buffer}static deserializeReplyErrError(O){const L=O.readLongString();return JSON.parse(L)}static h(O){return b.alloc(f.ReplyErrEmpty,O,0).buffer}}var f;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(w||(w={}))}),define(Ie[267],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=void 0;const v=function(N){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,R){p.postMessage(a,R)}},onmessage:{get(){return p.onmessage},set(a){p.onmessage=a}}}),p.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class I extends EventTarget{constructor(N,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${A}'))`,a=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(a),y=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:y.port2,url:R,options:T};N(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),y.port1.start()}}e.$Msc=I}),define(Ie[268],Pe([1,0,23,29,16,61,3]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$eL=void 0,e.$fL=R,e.$gL=y,e.$eL=(0,A.$Gi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),a=7;function R(E){if(E.scheme!==C.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const n=parseInt(E.fragment.substring(0,d).replace(p,""),a),s=(0,v.$9e)(E.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:E.with({scheme:s,fragment:null})}}function y(E,d){const n=d.toString(a),o=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$0e)(v.$Pe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:C.Schemas.vscodeNotebookCell,fragment:o})}class u{constructor(){this.a=new I.$Dc}getNotebook(d){if(d.scheme===C.Schemas.vscodeNotebookCell){const n=R(d);if(n){const s=this.a.get(n.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$hL=u,(0,N.$Ps)(e.$eL,u,N.InstantiationType.Delayed)}),define(Ie[90],Pe([1,0,23,42,40,73,16,20,21,32,268]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=l,e.$vL=$,e.$wL=D,e.$zL=k,e.$AL=f,I=Ve(I),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var y;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",N.$9s.latex,N.$9s.markdown,"image/png","image/jpeg",N.$9s.text],e.$oL=[N.$9s.latex,N.$9s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$9s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var u;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var s;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var h;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Z){Z.scheme=A.Schemas.vscodeNotebookCell;function ge(oe,Ce){return(0,R.$gL)(oe,Ce)}Z.generate=ge;function _(oe){return(0,R.$fL)(oe)}Z.parse=_;function me(oe,Ce){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Ce??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Z.generateCellOutputUri=me;function se(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Ce)return;const Le=Ce[1]&&Ce[1]!==""?Ce[1]:void 0,X=Ce[2];return{outputId:Le,notebook:oe.with({scheme:X||A.Schemas.file,fragment:null})}}Z.parseCellOutputUri=se;function ce(oe,Ce,Le){return Z.generate(oe,Ce).with({scheme:Le})}Z.generateCellPropertyUri=ce;function we(oe,Ce){if(oe.scheme===Ce)return Z.parse(oe.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=we})(r||(e.CellUri=r={}));const t=Z=>p.$i?Z.replace(/\//g,"\\"):Z;class c{constructor(ge=[],_=e.$nL){this.e=_,this.d=[...new Set(ge)].map(me=>({pattern:me,matches:I.$Ak(t(me))}))}sort(ge){const _=new Map(C.Iterable.map(ge,se=>[se,t(se)]));let me=[];for(const{matches:se}of this.d)for(const[ce,we]of _)if(se(we)){me.push(ce),_.delete(ce);break}return _.size&&(me=me.concat([..._.keys()].sort((se,ce)=>this.e.indexOf(se)-this.e.indexOf(ce)))),me}prioritize(ge,_){const me=this.f(ge);if(me===-1){this.d.unshift({pattern:ge,matches:I.$Ak(t(ge))});return}const se=new Set(_.map(we=>this.f(we,me)));se.delete(-1);const ce=Array.from(se).sort();this.d.splice(me+1,0,...ce.map(we=>this.d[we]));for(let we=ce.length-1;we>=0;we--)this.d.splice(ce[we],1)}toArray(){return this.d.map(ge=>ge.pattern)}f(ge,_=this.d.length){const me=t(ge);for(let se=0;se<_;se++)if(this.d[se].matches(me))return se;return-1}}e.$rL=c;function l(Z,ge,_,me=(se,ce)=>se===ce){const se=[];function ce(Ce,Le,X){if(Le===0&&X.length===0)return;const V=se[se.length-1];V&&V.start+V.deleteCount===Ce?(V.deleteCount+=Le,V.toInsert.push(...X)):se.push({start:Ce,deleteCount:Le,toInsert:X})}let we=0,oe=0;for(;;){if(we===Z.length){ce(we,0,ge.slice(oe));break}if(oe===ge.length){ce(we,Z.length-we,[]);break}const Ce=Z[we],Le=ge[oe];if(me(Ce,Le)){we+=1,oe+=1;continue}_(Le)?(ce(we,1,[]),we+=1):(ce(we,0,[Le]),oe+=1)}return se}e.$tL=new a.$Xj("notebookEditorCursorAtBoundary","none"),e.$uL=new a.$Xj("notebookEditorCursorAtLineBoundary","none");var g;(function(Z){Z.default="default",Z.option="option"})(g||(e.NotebookEditorPriority=g={}));var m;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(m||(e.NotebookFindScopeType=m={}));function $(Z){const ge=Z;return!!((typeof ge.include=="string"||I.$Bk(ge.include))&&(typeof ge.exclude=="string"||I.$Bk(ge.exclude)))}function D(Z,ge,_){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ge)>=0||Z.viewType===ge)return!0;if(Z.filenamePattern){const me=$(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,se=$(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(I.$zk(me,(0,T.$qc)(_.fsPath).toLowerCase()))return!(se&&I.$zk(se,(0,T.$qc)(_.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class b{static{this.d="notebook/"}static create(ge){return`${b.d}${ge}`}static parse(ge){if(ge.startsWith(b.d))return ge.substring(b.d.length)}}e.$yL=b;function k(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const P=new TextDecoder;function f(Z){const ge=[];let _=!1;for(const we of Z)(ge.length===0||_)&&(ge.push(we),_=!0);let me=O(ge);const se=v.$Pe.concat(ge.map(we=>v.$Pe.wrap(we))),ce=Y(se);return me=me||ce.byteLength!==se.byteLength,{data:ce,didCompression:me}}e.$BL="\x1B[A";const w=e.$BL.split("").map(Z=>Z.charCodeAt(0)),F=10;function O(Z){let ge=!1;return Z.forEach((_,me)=>{if(me===0||_.length<e.$BL.length)return;const se=Z[me-1],ce=_.subarray(0,e.$BL.length);if(ce[0]===w[0]&&ce[1]===w[1]&&ce[2]===w[2]){const we=se.lastIndexOf(F);if(we===-1)return;ge=!0,Z[me-1]=se.subarray(0,we),Z[me]=_.subarray(e.$BL.length)}}),ge}function L(Z){let ge=Z;do Z=ge,ge=Z.replace(/[^\n]\x08/gm,"");while(ge.length<Z.length);return Z}function q(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ge=Z.match(/^(.*)\r+/m)[1];let _=Z.match(/\r+(.*)$/m)[1];_=_+ge.slice(_.length,ge.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return Z}const W=8,M=13;function Y(Z){return!Z.buffer.includes(W)&&!Z.buffer.includes(M)?Z:v.$Pe.fromString(q(L(P.decode(Z.buffer))))}}),define(Ie[7],Pe([1,0,18,14,60,29,73,13,15,2,37,19,30,110,90]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d){"use strict";var n,s,o,h,i,r,t,c,l,g,m,$,D,S,b,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=xe,e.$wO=Di,e.$bP=Ai;function f(B){return Object.assign(B,{apply:function(...re){if(re.length===0)return Reflect.construct(B,[]);{const De=re.length===1?[]:re[1];return Reflect.construct(B,De,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(B,[]);{const[De,...Qe]=re;return Reflect.construct(B,Qe,De.constructor)}}})}var w;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var F;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let O=n=class{static from(...z){let re=z;return new n(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=O,e.$wN=O=n=He([f],O);let L=s=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let De=1;De<z.length;De++){const Qe=z[De];Qe.isBefore(re)&&(re=Qe)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let De=1;De<z.length;De++){const Qe=z[De];Qe.isAfter(re)&&(re=Qe)}return re}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:re,character:De}=z;return typeof re=="number"&&typeof De=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,I.$0)("line must be non-negative");if(re<0)throw(0,I.$0)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,I.$0)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&re===0?this:new s(this.line+De,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,I.$0)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),De===this.line&&re===this.character?this:new s(De,re)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=L,e.$xN=L=s=He([f],L);let q=o=class{static isRange(z){return z instanceof o?!0:z?L.isPosition(z.start)&&L.isPosition(z.end):!1}static of(z){if(z instanceof o)return z;if(this.isRange(z))return new o(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,De,Qe){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"?(it=new L(z,re),dt=new L(De,Qe)):L.isPosition(z)&&L.isPosition(re)&&(it=L.of(z),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return o.isRange(z)?this.contains(z.start)&&this.contains(z.end):L.isPosition(z)?!(L.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=L.Max(z.start,this.c),De=L.Min(z.end,this.e);if(!re.isAfter(De))return new o(re,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=L.Min(z.start,this.c),De=L.Max(z.end,this.end);return new o(re,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,I.$0)();let De;return z?L.isPosition(z)?De=z:(De=z.start||this.start,re=z.end||this.end):De=this.start,De.isEqual(this.c)&&re.isEqual(this.end)?this:new o(De,re)}toJSON(){return[this.start,this.end]}};e.$yN=q,e.$yN=q=o=He([f],q);let W=h=class extends q{static isSelection(z){return z instanceof h?!0:z?q.isRange(z)&&L.isPosition(z.anchor)&&L.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,De,Qe){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"?(it=new L(z,re),dt=new L(De,Qe)):L.isPosition(z)&&L.isPosition(re)&&(it=L.of(z),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=W,e.$zN=W=h=He([f],W);const M=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,I.$0)("connectionToken")};class Y{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,De){if(typeof z!="string"||z.length===0)throw(0,I.$0)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.$0)("port");typeof De<"u"&&M(De),this.host=z,this.port=Math.round(re),this.connectionToken=De}}e.$AN=Y;class Z{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&M(re)}}e.$BN=Z;class ge extends Error{static NotAvailable(z,re){return new ge(z,E.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new ge(z,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=E.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=re,this._detail=De,Object.setPrototypeOf(this,ge.prototype)}}e.$CN=ge;var _;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var me;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let se=i=class{static isTextEdit(z){return z instanceof i?!0:z?q.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new i(z,re)}static insert(z,re){return i.replace(new q(z,z),re)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const re=new i(new q(new L(0,0),new L(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!q.isRange(z))throw(0,I.$0)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,I.$0)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,I.$0)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=se,e.$DN=se=i=He([f],se);let ce=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?wt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new r(z,re)}static insertCells(z,re){return new r(new wt(z,z),re)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,re){const De=new r(new wt(z,z),[]);return De.newCellMetadata=re,De}static updateNotebookMetadata(z){const re=new r(new wt(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$EN=ce,e.$EN=ce=r=He([f],ce);class we{static isSnippetTextEdit(z){return z instanceof we?!0:z?q.isRange(z.range)&&Le.isSnippetString(z.snippet):!1}static replace(z,re){return new we(z,re)}static insert(z,re){return we.replace(new q(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$FN=we;var oe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,De,Qe){this.c.push({_type:oe.File,from:z,to:re,options:De,metadata:Qe})}createFile(z,re,De){this.c.push({_type:oe.File,from:void 0,to:z,options:re,metadata:De})}deleteFile(z,re,De){this.c.push({_type:oe.File,from:z,to:void 0,options:re,metadata:De})}e(z,re,De){this.c.push({_type:oe.Cell,metadata:De,uri:z,edit:{editType:d.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}f(z,re,De,Qe){const it=re.start,dt=re.end;(it!==dt||De.length>0)&&this.c.push({_type:oe.CellReplace,uri:z,index:it,count:dt-it,cells:De,metadata:Qe})}g(z,re,De,Qe){this.c.push({_type:oe.Cell,metadata:Qe,uri:z,edit:{editType:d.CellEditType.Metadata,index:re,metadata:De}})}replace(z,re,De,Qe){this.c.push({_type:oe.Text,uri:z,edit:new se(re,De),metadata:Qe})}insert(z,re,De,Qe){this.replace(z,new q(re,re),De,Qe)}delete(z,re,De){this.replace(z,re,"",De)}has(z){return this.c.some(re=>re._type===oe.Text&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const De of re){if(!De)continue;let Qe,it;Array.isArray(De)?(Qe=De[0],it=De[1]):Qe=De,ce.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(z,Qe.range.start,Qe.newCellMetadata,it):Qe.newNotebookMetadata?this.e(z,Qe.newNotebookMetadata,it):this.f(z,Qe.range,Qe.newCells,it):we.isSnippetTextEdit(Qe)?this.c.push({_type:oe.Snippet,uri:z,range:Qe.range,edit:Qe.snippet,metadata:it}):this.c.push({_type:oe.Text,uri:z,edit:Qe,metadata:it})}else{for(let De=0;De<this.c.length;De++){const Qe=this.c[De];switch(Qe._type){case oe.Text:case oe.Snippet:case oe.Cell:case oe.CellReplace:Qe.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,v.$Lb)(this.c)}}get(z){const re=[];for(const De of this.c)De._type===oe.Text&&De.uri.toString()===z.toString()&&re.push(De.edit);return re}entries(){const z=new N.$Dc;for(const re of this.c)if(re._type===oe.Text){let De=z.get(re.uri);De||(De=[re.uri,[]],z.set(re.uri,De)),De[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=Ce,e.$GN=Ce=He([f],Ce);let Le=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const De=new t;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=t.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const De=z.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const De=new t;De.e=this.e,re(De),this.e=De.e,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$HN=Le,e.$HN=Le=t=He([f],Le);var X;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var V;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(V||(e.DiagnosticSeverity=V={}));let te=c=class{static isLocation(z){return z instanceof c?!0:z?q.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(q.isRange(re))this.range=q.of(re);else if(L.isPosition(re))this.range=new q(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=te,e.$IN=te=c=He([f],te);let ve=class{static is(z){return z?typeof z.message=="string"&&z.location&&q.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$JN=ve,e.$JN=ve=He([f],ve);let ue=class{constructor(z,re,De=V.Error){if(!q.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=De}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,v.$xb)(z.tags,re.tags)&&(0,v.$xb)(z.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$KN=ue,e.$KN=ue=He([f],ue);let be=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$LN=be,e.$LN=be=He([f],be);let de=class extends be{constructor(z,re,De,Qe){super(z,re),this.canIncreaseHover=De,this.canDecreaseHover=Qe}};e.$MN=de,e.$MN=de=He([f],de);var J;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(J||(e.HoverVerbosityAction=J={}));var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let pe=class{constructor(z,re=x.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$NN=pe,e.$NN=pe=He([f],pe);let $e=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$ON=$e,e.$ON=$e=He([f],$e);var Ne;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=l=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,De,Qe,it){this.name=z,this.kind=re,this.containerName=it,typeof De=="string"&&(this.containerName=De),Qe instanceof te?this.location=Qe:De instanceof q&&(this.location=new te(Qe,De)),l.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=ke,e.$PN=ke=l=He([f],ke);let Ae=g=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(g.validate)}constructor(z,re,De,Qe,it){this.name=z,this.detail=re,this.kind=De,this.range=Qe,this.selectionRange=it,this.children=[],g.validate(this)}};e.$QN=Ae,e.$QN=Ae=g=He([f],Ae);var Oe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let j=class{constructor(z,re){this.title=z,this.kind=re}};e.$RN=j,e.$RN=j=He([f],j);let U=class{static{m=this}static{this.c="."}constructor(z){this.value=z}append(z){return new m(this.value?this.value+m.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+m.c)}};e.$SN=U,e.$SN=U=m=He([f],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let G=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=G,e.$TN=G=He([f],G);class H{constructor(z,re,De,Qe,it,dt){this.kind=z,this.name=re,this.detail=De,this.uri=Qe,this.range=it,this.selectionRange=dt}}e.$UN=H;class ne{constructor(z,re){this.fromRanges=re,this.from=z}}e.$VN=ne;class fe{constructor(z,re){this.fromRanges=re,this.to=z}}e.$WN=fe;var Re;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Ue=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$XN=Ue,e.$XN=Ue=He([f],Ue);let Ke=$=class{#e;static isMarkdownString(z){return z instanceof $?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new C.$4k(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$YN=Ke,e.$YN=Ke=$=He([f],Ke);let _e=class{constructor(z,re){this.label=z,this.documentation=re}};e.$ZN=_e,e.$ZN=_e=He([f],_e);let tt=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$1N=tt,e.$1N=tt=He([f],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=nt,e.$2N=nt=He([f],nt);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ft=class{constructor(z){this.value=z}};e.$3N=ft,e.$3N=ft=He([f],ft);let ct=class{constructor(z,re,De){this.position=z,this.label=re,this.kind=De}};e.$4N=ct,e.$4N=ct=He([f],ct);var st;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ut;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ut||(e.CompletionItemKind=ut={}));var gt;(function(B){B[B.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let pt=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&ut[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=pt,e.$5N=pt=He([f],pt);let Be=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$6N=Be,e.$6N=Be=He([f],Be);let je=class{constructor(z,re,De){this.insertText=z,this.range=re,this.command=De}};e.$7N=je,e.$7N=je=He([f],je);let ee=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$8N=ee,e.$8N=ee=He([f],ee);var K;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(K||(e.PartialAcceptTriggerKind=K={}));var Se;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Se||(e.ViewColumn=Se={}));var Je;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function xe(B,z){return`${y.$rn.toKey(B)}.${z}`}var ht;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var $t;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})($t||(e.TextDocumentSaveReason=$t={}));var Ot;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var Ft;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var ei;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var li;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(li||(e.DecorationRangeBehavior=li={})),function(B){function z(re){switch(re){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var ti;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(B){function z(re){switch(re){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(ti||(e.SyntaxTokenType=ti={}));let Ye=class{constructor(z,re){if(re&&!a.URI.isUri(re))throw(0,I.$0)("target");if(!q.isRange(z)||z.isEmpty)throw(0,I.$0)("range");this.range=z,this.target=re}};e.$0N=Ye,e.$0N=Ye=He([f],Ye);let Gt=class{constructor(z,re,De,Qe){this.red=z,this.green=re,this.blue=De,this.alpha=Qe}};e.$$N=Gt,e.$$N=Gt=He([f],Gt);let Kt=class{constructor(z,re){if(re&&!(re instanceof Gt))throw(0,I.$0)("color");if(!q.isRange(z)||z.isEmpty)throw(0,I.$0)("range");this.range=z,this.color=re}};e.$_N=Kt,e.$_N=Kt=He([f],Kt);let mt=class{constructor(z){if(!z||typeof z!="string")throw(0,I.$0)("label");this.label=z}};e.$aO=mt,e.$aO=mt=He([f],mt);var Ct;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ct||(e.ColorFormat=Ct={}));var ii;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Xt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Xt||(e.TerminalExitReason=Xt={}));var Wt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Wt||(e.TerminalShellExecutionCommandLineConfidence=Wt={}));class vt{constructor(z,re,De){if(this.startIndex=z,this.length=re,this.tooltip=De,typeof z!="number"||z<0)throw(0,I.$0)("startIndex");if(typeof re!="number"||re<1)throw(0,I.$0)("length");if(De!==void 0&&typeof De!="string")throw(0,I.$0)("tooltip")}}e.$bO=vt;class Nt{constructor(z){this.uri=z}}e.$cO=Nt;class hi{constructor(z){this.terminalCommand=z}}e.$dO=hi;var Vt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class Xe{constructor(z){if(this.options=z,typeof z!="object")throw(0,I.$0)("options")}}e.$eO=Xe;var Yt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Yt||(e.TaskRevealKind=Yt={}));var ni;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let di=class{static{D=this}static{this.Clean=new D("clean","Clean")}static{this.Build=new D("build","Build")}static{this.Rebuild=new D("rebuild","Rebuild")}static{this.Test=new D("test","Test")}static from(z){switch(z){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,I.$0)("name");this.c=z}get id(){return this.c}};e.$fO=di,e.$fO=di=D=He([f],di);function Dt(B){let z="";for(let re=0;re<B.length;re++)z+=B[re].replace(/,/g,",,")+",";return z}let Mt=class{constructor(z,re,De){if(typeof z!="string")throw(0,I.$0)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=De):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,I.$0)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return Dt(z)}};e.$gO=Mt,e.$gO=Mt=He([f],Mt);let Rt=class{constructor(z,re,De){if(this.f=[],Array.isArray(re)){if(!z)throw(0,I.$0)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$0)("command");this.e=z,this.f=re,this.g=De}else{if(typeof z!="string")throw(0,I.$0)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,I.$0)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$0)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return Dt(z)}};e.$hO=Rt,e.$hO=Rt=He([f],Rt);var zt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(zt||(e.ShellQuoting=zt={}));var ri;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Zt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$3g)()}set callback(z){this.c=z}get callback(){return this.c}}e.$iO=Zt;let si=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,De,Qe,it,dt){this.k=!1,this.l=this.definition=z;let yt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=De,this.execution=Qe,yt=it,this.k=!0):re===ri.Global||re===ri.Workspace?(this.target=re,this.o=this.name=De,this.w=this.source=Qe,this.execution=it,yt=dt):(this.target=re,this.o=this.name=De,this.w=this.source=Qe,this.execution=it,yt=dt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,R.$3g)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,I.$0)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,I.$0)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(S.g===re||S.e===re||S.f===re||S.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,I.$0)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$jO=si,e.$jO=si=S=He([f],si);var Ut;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Ut||(e.ProgressLocation=Ut={}));var Ht;(function(B){function z(re){const De=re;return(0,p.$kg)(De.value)?De.tooltip&&!(0,p.$gg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=z})(Ht||(e.ViewBadge=Ht={}));let oi=b=class{static isTreeItem(z,re){const De=z;if(De.checkboxState!==void 0){const Qe=(0,p.$kg)(De.checkboxState)?De.checkboxState:(0,p.$ig)(De.checkboxState)&&(0,p.$kg)(De.checkboxState.state)?De.checkboxState.state:void 0,it=!(0,p.$kg)(De.checkboxState)&&(0,p.$ig)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==St.Checked&&Qe!==St.Unchecked||it!==void 0&&!(0,p.$gg)(it))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof b)return!0;if(De.label!==void 0&&!(0,p.$gg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,p.$gg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,p.$gg)(De.iconPath)&&!a.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,p.$gg)(De.iconPath.id))){const Qe=De.iconPath;if(!Qe||!(0,p.$gg)(Qe.light)&&!a.URI.isUri(Qe.light)&&!(0,p.$gg)(Qe.dark)&&!a.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,p.$gg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!a.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,p.$gg)(De.tooltip)&&!(De.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Pt.None&&De.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,p.$gg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,re=Pt.None){this.collapsibleState=re,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$kO=oi,e.$kO=oi=b=He([f],oi);var Pt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var St;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$lO=bt,e.$lO=bt=He([f],bt);class xt extends bt{}e.$mO=xt;class kt extends xt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$nO=kt;class fi{constructor(z,re,De,Qe){this.name=z,this.uri=re,this._itemId=De,this.c=Qe}data(){return this.c()}}e.$oO=fi;let qt=class{#e=new Map;constructor(z){for(const[re,De]of z??[]){const Qe=this.#e.get(this.#t(re));Qe?Qe.push(De):this.#e.set(this.#t(re),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[De,Qe]of this.#e)for(const it of Qe)z.call(re,it,De,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const De of re)yield[z,De]}#t(z){return z.toLowerCase()}};e.$pO=qt,e.$pO=qt=He([f],qt);let bi=class{constructor(z,re,De){this.insertText=z,this.title=re,this.kind=De}};e.$qO=bi,e.$qO=bi=He([f],bi);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(z){this.value=z}append(...z){return new gi((this.value?[this.value,...z]:z).join(gi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+gi.c)}}e.$rO=gi,gi.Empty=new gi("");class jt{constructor(z,re,De){this.title=re,this.insertText=z,this.kind=De}}e.$sO=jt;let ai=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$tO=ai,e.$tO=ai=He([f],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(z){this.id=z}};e.$uO=Ii,e.$uO=Ii=He([f],Ii);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,I.$0)("base");if(typeof re!="string")throw(0,I.$0)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=Si,e.$vO=Si=He([f],Si);const Pi=new WeakMap;function Di(B,z){Pi.set(B,z)}let pi=class{constructor(z,re,De,Qe,it){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Qe=="string"&&(this.logMessage=Qe),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Pi.get(this)??(0,R.$3g)()),this.c}};e.$xO=pi,e.$xO=pi=He([f],pi);let Ri=class extends pi{constructor(z,re,De,Qe,it,dt){if(super(re,De,Qe,it,dt),z===null)throw(0,I.$0)("location");this.location=z}};e.$yO=Ri,e.$yO=Ri=He([f],Ri);let Bt=class extends pi{constructor(z,re,De,Qe,it,dt){super(re,De,Qe,it,dt),this.functionName=z}};e.$zO=Bt,e.$zO=Bt=He([f],Bt);let ye=class extends pi{constructor(z,re,De,Qe,it,dt,yt,Jt){if(super(Qe,it,dt,yt,Jt),!re)throw(0,I.$0)("dataId");this.label=z,this.dataId=re,this.canPersist=De}};e.$AO=ye,e.$AO=ye=He([f],ye);let Te=class{constructor(z,re,De){this.command=z,this.args=re||[],this.options=De}};e.$BO=Te,e.$BO=Te=He([f],Te);let le=class{constructor(z,re){this.port=z,this.host=re}};e.$CO=le,e.$CO=le=He([f],le);let Q=class{constructor(z){this.path=z}};e.$DO=Q,e.$DO=Q=He([f],Q);let Ee=class{constructor(z){this.implementation=z}};e.$EO=Ee,e.$EO=Ee=He([f],Ee);class We{constructor(z,re,De){this.session=z,this.threadId=re,this.frameId=De}}e.$FO=We;class Ze{constructor(z,re){this.session=z,this.threadId=re}}e.$GO=Ze;let Ge=class{constructor(z,re){this.range=z,this.expression=re}};e.$HO=Ge,e.$HO=Ge=He([f],Ge);var lt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let It=class{constructor(z,re){this.range=z,this.text=re}};e.$IO=It,e.$IO=It=He([f],It);let Qt=class{constructor(z,re,De=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=De}};e.$JO=Qt,e.$JO=Qt=He([f],Qt);let ci=class{constructor(z,re){this.range=z,this.expression=re}};e.$KO=ci,e.$KO=ci=He([f],ci);let Lt=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$LO=Lt,e.$LO=Lt=He([f],Lt);var ui;(function(B){B[B.AIGenerated=1]="AIGenerated"})(ui||(e.NewSymbolNameTag=ui={}));var Vi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Vi||(e.NewSymbolNameTriggerKind=Vi={}));class $n{constructor(z,re){this.newSymbolName=z,this.tags=re}}e.$MO=$n;var Li;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ni=k=class extends Error{static FileExists(z){return new k(z,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(z){return new k(z,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(z){return new k(z,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(z){return new k(z,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(z){return new k(z,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(z){return new k(z,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(z,re=u.FileSystemProviderErrorCode.Unknown,De){super(a.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,u.$pl)(this,re),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$NO=Ni,e.$NO=Ni=k=He([f],Ni);let qi=class{constructor(z,re,De){this.start=z,this.end=re,this.kind=De}};e.$OO=qi,e.$OO=qi=He([f],qi);var xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Fi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Fi||(e.CommentThreadState=Fi={}));var tn;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$PO=Gi;function nn(B){return typeof B>"u"||(0,p.$hg)(B)}class Ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,De=z.tokenTypes.length;re<De;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,De=z.tokenModifiers.length;re<De;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,De,Qe,it){if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,re,De,Qe,it);if(q.isRange(z)&&typeof re=="string"&&nn(De))return this.o(z,re,De);throw(0,I.$0)()}o(z,re,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Qe=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,yt=this.k.get(re);let Jt=0;if(De)for(const $i of De){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Jt|=1<<wi>>>0}this.q(Qe,it,dt,yt,Jt)}q(z,re,De,Qe,it){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Jt=this.g.length/5|0;let $i=0,wi=0;for(let Ei=0;Ei<Jt;Ei++){let Ci=this.g[5*Ei],Yi=this.g[5*Ei+1];Ci===0?(Ci=$i,Yi+=wi):Ci+=$i,this.g[5*Ei]=Ci,this.g[5*Ei+1]=Yi,$i=Ci,wi=Yi}}let dt=z,yt=re;this.f&&this.j>0&&(dt-=this.c,dt===0&&(yt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=yt,this.g[this.j++]=De,this.g[this.j++]=Qe,this.g[this.j++]=it,this.c=z,this.e=re}static r(z){const re=[],De=z.length/5|0;for(let yt=0;yt<De;yt++)re[yt]=yt;re.sort((yt,Jt)=>{const $i=z[5*yt],wi=z[5*Jt];if($i===wi){const Ei=z[5*yt+1],Ci=z[5*Jt+1];return Ei-Ci}return $i-wi});const Qe=new Uint32Array(z.length);let it=0,dt=0;for(let yt=0;yt<De;yt++){const Jt=5*re[yt],$i=z[Jt+0],wi=z[Jt+1],Ei=z[Jt+2],Ci=z[Jt+3],Yi=z[Jt+4],jn=$i-it,kr=jn===0?wi-dt:wi,Zi=5*yt;Qe[Zi+0]=jn,Qe[Zi+1]=kr,Qe[Zi+2]=Ei,Qe[Zi+3]=Ci,Qe[Zi+4]=Yi,it=$i,dt=wi}return Qe}build(z){return this.f?new zi(new Uint32Array(this.g),z):new zi(Ki.r(this.g),z)}}e.$QO=Ki;class zi{constructor(z,re){this.resultId=re,this.data=z}}e.$RO=zi;class wn{constructor(z,re,De){this.start=z,this.deleteCount=re,this.data=De}}e.$SO=wn;class Oi{constructor(z,re){this.resultId=re,this.edits=z}}e.$TO=Oi;var rn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(z){this.name=z}}e.$UO=bn;let Hi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$VO=Hi,e.$VO=Hi=He([f],Hi);var Ui;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Qi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var Fe;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Fe||(e.ExtensionKind=Fe={}));class yi{static validate(z){if(typeof z.badge=="string"){let re=(0,T.$Rf)(z.badge,0);if(re<z.badge.length&&(re+=(0,T.$Rf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,De){this.badge=z,this.tooltip=re,this.color=De}}e.$WO=yi;let ji=class{constructor(z){this.kind=z}};e.$XO=ji,e.$XO=ji=He([f],ji);var ot;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class wt{static isNotebookRange(z){return z instanceof wt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,I.$0)("start must be positive");if(re<0)throw(0,I.$0)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,De=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(De=z.end),re===this.c&&De===this.e?this:new wt(re,De)}}e.$YO=wt;class Bi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Bi.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,De,Qe,it,dt,yt){this.kind=z,this.value=re,this.languageId=De,this.mime=Qe,this.outputs=it??[],this.metadata=dt,this.executionSummary=yt,Bi.validate(this)}}e.$ZO=Bi;class vn{constructor(z){this.cells=z}}e.$1O=vn;class mi{static isNotebookCellOutputItem(z){return z instanceof mi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return mi.json(re,"application/vnd.code.notebook.error")}static stdout(z){return mi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new mi(z,re)}static#e=new TextEncoder;static text(z,re=A.$9s.text){const De=mi.#e.encode(String(z));return new mi(De,re)}static json(z,re="text/x-json"){const De=JSON.stringify(z,void 0,"	");return mi.text(De,re)}constructor(z,re){this.data=z,this.mime=re;const De=(0,A.$at)(re,!0);if(!De)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$2O=mi;class Wi{static isNotebookCellOutput(z){return z instanceof Wi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const De=new Set,Qe=new Set;for(let it=0;it<z.length;it++){const dt=z[it],yt=(0,A.$at)(dt.mime);if(!De.has(yt)||(0,d.$zL)(yt)){De.add(yt);continue}Qe.add(it),re&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Qe.size===0?z:z.filter((it,dt)=>!Qe.has(dt))}constructor(z,re,De){this.items=Wi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,R.$3g)(),this.metadata=re??De)}}e.$3O=Wi;var Mi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Mi||(e.NotebookCellKind=Mi={}));var sn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(z,re){this.text=z,this.alignment=re}}e.$4O=cn;var un;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(un||(e.NotebookControllerAffinity=un={}));var ln;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class yn{constructor(z,re=[]){this.uri=z,this.provides=(0,v.$5b)(re)}}e.$5O=yn;class En{constructor(z){this.label=z}}e.$6O=En;var hn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$7O=Ji,e.$7O=Ji=He([f],Ji);var dn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Sn{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$8O=Sn;class Dn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$9O=Dn;var ie;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ie||(e.TestResultState=ie={}));var he;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(he||(e.TestRunProfileKind=he={}));let Me=class{constructor(z=void 0,re=void 0,De=void 0,Qe=!1,it=!0){this.include=z,this.exclude=re,this.profile=De,this.continuous=Qe,this.preserveFocus=it}};e.$0O=Me,e.$0O=Me=He([f],Me);let at=P=class{static diff(z,re,De){const Qe=new P(z);return Qe.expectedOutput=re,Qe.actualOutput=De,Qe}constructor(z){this.message=z}};e.$$O=at,e.$$O=at=P=He([f],at);let Et=class{constructor(z){this.id=z}};e.$_O=Et,e.$_O=Et=He([f],Et);class Tt{constructor(z,re){this.covered=z,this.total=re,Ai(this)}}e.$aP=Tt;function Ai(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Xi{static fromDetails(z,re){const De=new Tt(0,0),Qe=new Tt(0,0),it=new Tt(0,0);for(const yt of re)if("branches"in yt){De.total+=1,De.covered+=yt.executed?1:0;for(const Jt of yt.branches)Qe.total+=1,Qe.covered+=Jt.executed?1:0}else it.total+=1,it.covered+=yt.executed?1:0;const dt=new Xi(z,De,Qe.total>0?Qe:void 0,it.total>0?it:void 0);return dt.detailedCoverage=re,dt}constructor(z,re,De,Qe,it=[]){this.uri=z,this.statementCoverage=re,this.branchCoverage=De,this.declarationCoverage=Qe,this.fromTests=it}}e.$cP=Xi;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De=[]){this.executed=z,this.location=re,this.branches=De}}e.$dP=Vn;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De){this.executed=z,this.location=re,this.label=De}}e.$eP=qn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De){this.name=z,this.executed=re,this.location=De}}e.$fP=Gn;var kn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(z,re,De,Qe,it,dt){this.kind=z,this.name=re,this.detail=De,this.uri=Qe,this.range=it,this.selectionRange=dt}}e.$gP=Kn;class Hn{constructor(z){this.uri=z}}e.$hP=Hn;class Qn{constructor(z,re){this.original=z,this.modified=re}}e.$iP=Qn;class Jn{constructor(z,re,De,Qe){this.base=z,this.input1=re,this.input2=De,this.result=Qe}}e.$jP=Jn;class Xn{constructor(z,re){this.uri=z,this.viewType=re}}e.$kP=Xn;class Yn{constructor(z){this.viewType=z}}e.$lP=Yn;class Zn{constructor(z,re){this.uri=z,this.notebookType=re}}e.$mP=Zn;class xn{constructor(z,re,De){this.original=z,this.modified=re,this.notebookType=De}}e.$nP=xn;class _n{constructor(){}}e.$oP=_n;class er{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class ir{constructor(z){this.textDiffs=z}}e.$rP=ir;var Pn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(z,re,De){this.id=z,this.label=re,this.values=De}}e.$sP=nr;var Tn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Nn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Nn||(e.ChatResultFeedbackKind=Nn={}));class rr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$tP=rr;class sr{constructor(z,re){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z,this.vulnerabilities=re}}e.$uP=sr;class or{constructor(z,re){this.participant=z,this.command=re}}e.$vP=or;class ar{constructor(z,re,De){this.title=z,this.message=re,this.data=De}}e.$wP=ar;class cr{constructor(z,re){this.value=z,this.baseUri=re}}e.$xP=cr;class ur{constructor(z,re){this.value=z,this.title=re}}e.$yP=ur;class lr{constructor(z){this.value=z}}e.$zP=lr;class hr{constructor(z,re){this.value=z,this.task=re}}e.$AP=hr;class dr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$BP=dr;class fr{constructor(z){this.value=z}}e.$CP=fr;class gr{constructor(z,re){this.value=z,this.iconPath=re}}e.$DP=gr;class mr{constructor(z,re){this.uri=z,this.edits=Array.isArray(re)?re:[re]}}e.$EP=mr;class pr{constructor(z,re,De,Qe){this.prompt=z,this.command=re,this.references=De,this.participant=Qe}}e.$FP=pr;class $r{constructor(z,re,De,Qe){this.response=z,this.result=re,this.participant=De,this.command=Qe}}e.$GP=$r;var On;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var mn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class wr{constructor(z,re,De){this.name=z,this.content=re,this.isError=De??!1}}e.$HP=wr;class pn{static User(z,re){const De=new pn(mn.User,typeof z=="string"?z:"",re);return De.content2=z,De}static Assistant(z,re){return new pn(mn.Assistant,z,re)}constructor(z,re,De){this.role=z,this.content=re,this.content2=re,this.name=De}}e.$IP=pn;class br{constructor(z,re){this.name=z,this.parameters=re}}e.$JP=br;class vr{constructor(z){this.value=z}}e.$KP=vr;class yr{constructor(z){this.content=z}}e.$LP=yr;class Er{constructor(z,re){this.content=z,this.name=re}}e.$MP=Er;class Sr{constructor(z,re){this.content=z,this.name=re}}e.$NP=Sr;class Ti extends Error{static NotFound(z){return new Ti(z,Ti.NotFound.name)}static NoPermissions(z){return new Ti(z,Ti.NoPermissions.name)}static Blocked(z){return new Ti(z,Ti.Blocked.name)}constructor(z,re,De){super(z,{cause:De}),this.name="LanguageModelError",this.code=re??""}}e.$OP=Ti;var Mn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var Ln;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Fn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var zn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Dr{constructor(z,re){this.text=z,this.range=re}}e.$PP=Dr;var Un;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Ie[269],Pe([1,0,5,7]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$uN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiRelatedInformationProvider(a,T),new I.$wN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$ooc=C}),define(Ie[91],Pe([1,0,6,5,7,19,117,3,17]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=e.$zoc=void 0,e.$zoc=(0,T.$Gi)("IExtHostAuthentication");let a=class{constructor(u){this.b=new Map,this.c=new v.$ne,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=u.getProxy(I.$uN.MainThreadAuthentication)}async getSession(u,E,d,n={}){const s=N.$rn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,d,s,h,n)})}async getSessions(u,E,d){const n=N.$rn.toKey(u.identifier),s=[...d].sort().join(" ");return await this.f.getOrCreate(`${n} ${s}`,async()=>{await this.a.$ensureProvider(E);const o=u.displayName||u.name;return this.a.$getSessions(E,d,n,o)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const d=this.b.get(u);return d?d.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:d,options:n??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(u,o));return this.a.$registerAuthenticationProvider(u,E,n?.supportsMultipleAccounts??!1),new C.$wN(()=>{s.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,d){const n=this.b.get(u);if(n)return await n.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const d=this.b.get(u);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,d){const n=this.b.get(u);if(n)return await n.provider.getSessions(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$wM)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$Aoc=a,e.$Aoc=a=He([qe(0,p.$1P)],a);class R{constructor(){this.a=new Map}getOrCreate(u,E){const d=this.a.get(u);if(d)return d;const n=E().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Ie[122],Pe([1,0,2,5,7,3,17,12,18,13,20,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,s){this.h=s,this.f=new Map,this.g=n.getProxy(I.$uN.MainThreadDecorations)}registerFileDecorationProvider(n,s){const o=u.c++;this.f.set(o,{provider:n,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const h=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$5b)(i);if(r.length<=u.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,r.length);const t=r.map(g=>({uri:g,rank:(0,a.$kf)(g.path,"/")})),c=(0,p.$Cb)(t,(g,m)=>g.rank-m.rank||(0,a.$Af)(g.uri.path,m.uri.path)),l=[];e:for(const g of c){let m;for(const $ of g){const D=(0,R.$pc)($.uri.path);if(m!==D&&(m=D,l.push($.uri)>=u.d))break e}}this.g.$onDidChange(o,l)});return new C.$wN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(n,s,o){if(!this.f.has(n))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(s.map(async t=>{try{const{uri:c,id:l}=t,g=await Promise.resolve(i.provideFileDecoration(v.URI.revive(c),o));if(!g)return;try{C.$WO.validate(g),g.badge&&typeof g.badge!="string"&&(0,y.$7G)(r,"codiconDecoration"),h[l]=[g.propagate,g.tooltip,g.badge,g.color]}catch(m){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(c){this.h.error(c)}})),h}};e.$Epc=E,e.$Epc=E=u=He([qe(0,A.$1P),qe(1,T.$ak)],E),e.$Fpc=(0,N.$Gi)("IExtHostDecorations")}),define(Ie[270],Pe([1,0,14,2,7,5,16,22,13]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class a{static{this.a=0}constructor(y,u,E){this.d=u,this.e=E,this.b=new Map,this.c=y.getProxy(N.$uN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=a.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,y);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;n&&await n;const o=this.$provideTextDocumentContent(E,s).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(s);if(!i)return;const r=(0,p.$uf)(h);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(s,h)}).catch(v.$3).finally(()=>{n===o&&(n=void 0)});n=o})}return new C.$wN(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,u){const E=this.b.get(y);return E?Promise.resolve(E.provideTextDocumentContent(I.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Hpc=a}),define(Ie[123],Pe([1,0,62,16,13,326,210,7,18]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=R;const a=new Map;function R(d,n){n?a.set(d,n):a.delete(d)}function y(d){return a.get(d)}class u extends N.$mw{constructor(n,s,o,h,i,r,t){super(s,o,h,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,p.$xb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===I.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(s){return s?n.s(s):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(s){return n.t(s)},offsetAt(s){return n.u(s)},positionAt(s){return n.v(s)},validateRange(s){return n.w(s)},validatePosition(s){return n.x(s)},getWordRangeAtPosition(s,o){return n.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const s=this.w(n);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,h=s.start.line,i=s.end.line,r=[];r.push(this.f[h].substring(s.start.character));for(let t=h+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,s.end.character)),r.join(o)}t(n){let s;if(n instanceof T.$xN?s=n.line:typeof n=="number"&&(s=n),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this.f[s],s===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),o=this.f[s.index].length;return new T.$xN(s.index,Math.min(s.remainder,o))}w(n){if(!(n instanceof T.$yN))throw new Error("Invalid argument");const s=this.x(n.start),o=this.x(n.end);return s===n.start&&o===n.end?n:new T.$yN(s.line,s.character,o.line,o.character)}x(n){if(!(n instanceof T.$xN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:s,character:o}=n,h=!1;if(s<0)s=0,o=0,h=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,h=!0;else{const i=this.f[s].length;o<0?(o=0,h=!0):o>i&&(o=i,h=!0)}return h?new T.$xN(s,o):n}y(n,s){const o=this.x(n);if(!s)s=y(this.m);else if((0,C.$tf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const h=(0,A.$ot)(o.character+1,(0,A.$mt)(s),this.f[o.line],0);if(h)return new T.$yN(o.line,h.startColumn-1,o.line,h.endColumn-1)}}e.$4P=u;class E{constructor(n,s,o){this.a=n,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$yN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$yN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=E}),define(Ie[271],Pe([1,0,5,7]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$uN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const R=await a.provideEmbeddingVector(T,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiEmbeddingVectorProvider(T,a),new I.$wN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Kpc=C}),define(Ie[69],Pe([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,I=Ve(I);let d=E=class{constructor(s,o){this.b=new Map,this.c=new R.$Ph,this.a=s.getProxy(v.$uN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let r;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await h.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===I.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=h.b.get(i.scheme);return r&&!r.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(r.impl,r.extUri,i)):await h.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,N.$Pe.wrap(r))}catch(t){return E.e(t)}},async delete(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return E.e(t)}},async rename(i,r,t){try{return await h.a.$rename(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},async copy(i,r,t){try{return await h.a.$copy(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&I.FileSystemProviderCapabilities.Readonly)}})}async d(s,o,h){const i=[];for(;!o.isEqual(h,o.dirname(h));)try{if(!((await s.stat(h)).type&I.FileType.Directory))throw C.$NO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(I.$ql(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(h)),h=o.dirname(h)}for(let r=i.length-1;r>=0;r--){h=o.joinPath(h,i[r]);try{await s.createDirectory(h)}catch(t){if(I.$ql(t)!==I.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof C.$NO)throw s;if(s instanceof I.$ml)switch(s.code){case I.FileSystemProviderErrorCode.FileExists:throw C.$NO.FileExists(s.message);case I.FileSystemProviderErrorCode.FileNotFound:throw C.$NO.FileNotFound(s.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw C.$NO.FileNotADirectory(s.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw C.$NO.FileIsADirectory(s.message);case I.FileSystemProviderErrorCode.NoPermissions:throw C.$NO.NoPermissions(s.message);case I.FileSystemProviderErrorCode.Unavailable:throw C.$NO.Unavailable(s.message);default:throw new C.$NO(s.message,s.name)}if(!(s instanceof Error))throw new C.$NO(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw C.$NO.Unavailable(s.message);switch(s.name){case I.FileSystemProviderErrorCode.FileExists:throw C.$NO.FileExists(s.message);case I.FileSystemProviderErrorCode.FileNotFound:throw C.$NO.FileNotFound(s.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw C.$NO.FileNotADirectory(s.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw C.$NO.FileIsADirectory(s.message);case I.FileSystemProviderErrorCode.NoPermissions:throw C.$NO.NoPermissions(s.message);case I.FileSystemProviderErrorCode.Unavailable:throw C.$NO.Unavailable(s.message);default:throw new C.$NO(s.message,s.name)}}addFileSystemProvider(s,o,h){return this.b.set(s,{impl:o,extUri:h?.isCaseSensitive?y.$0g:y.$_g,isReadonly:!!h?.isReadonly}),(0,a.$Vc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$0g}};e.$Poc=d,e.$Poc=d=E=He([qe(0,T.$1P),qe(1,p.$toc)],d),e.$Qoc=(0,A.$Gi)("IExtHostConsumerFileSystem")}),define(Ie[92],Pe([1,0,3,27,12,69,2]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=e.$Roc=void 0,e.$Roc=(0,v.$Gi)("IExtensionStoragePaths");let T=class{constructor(a,R,y){this.d=R,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,R=await this.g(a);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Soc=T,e.$Soc=T=He([qe(0,I.$eQ),qe(1,C.$ak),qe(2,N.$Qoc)],T)}),define(Ie[272],Pe([1,0,7,17,6]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=void 0;let N=class{constructor(T){this.a=new v.$XO(v.ColorThemeKind.Dark),this.b=new C.$ne}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$XO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pqc=N,e.$pqc=N=He([qe(0,I.$1P)],N)}),define(Ie[93],Pe([1,0,22,6,4,191,3,12,224,5,27,17,7]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Fb=e.$3Fb=e.TunnelDtoConverter=void 0,N=Ve(N),u=Ve(u);class E extends p.$Lw{}var d;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$3Fb=(0,A.$Gi)("IExtHostTunnelService");let n=class extends C.$Xc{constructor(o,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.$ne,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(a.$uN.MainThreadTunnelService)}async openTunnel(o,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,h){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:h}),this.a.$registerPortsAttributesProvider(o,i),new u.$wN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,h,i,r,t){const c=[];for(const g of o){const m=this.r.get(g);if(!m)return[];c.push(...await Promise.all(h.map(async $=>{let D;try{D=await m.provider.providePortAttributes({port:$,pid:i,commandLine:r},t)}catch{D=await m.provider.providePortAttributes($,i,r,t)}return{providedAttributes:D,port:$}})))}const l=c.filter(g=>!!g.providedAttributes);return l.length>0?l.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await o.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,h){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const t=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Vc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,h){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(h&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const h=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$4Fb=n,e.$4Fb=n=He([qe(0,y.$1P),qe(1,R.$eQ),qe(2,T.$ak)],n)}),define(Ie[8],Pe([1,0,18,23,148,273,60,29,137,49,73,26,143,24,35,15,2,106,33,152,94,52,108,77,116,115,235,249,81,90,55,56,246,7]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,D,S,b,k,P,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ce,e.$YP=oe,e.$ZP=Ce,A=Ve(A),h=Ve(h),i=Ve(i),r=Ve(r),D=Ve(D),b=Ve(b),w=Ve(w);var F;(function(ye){function Te(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:Ge}=Q,lt=new w.$xN(Ee-1,We-1),It=new w.$xN(Ze-1,Ge-1);return new w.$zN(lt,It)}ye.to=Te;function le(Q){const{anchor:Ee,active:We}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=le})(F||(e.Selection=F={}));var O;(function(ye){function Te(Q){if(!Q)return;const{start:Ee,end:We}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Te;function le(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ze,endColumn:Ge}=Q;return new w.$yN(Ee-1,We-1,Ze-1,Ge-1)}ye.to=le})(O||(e.Range=O={}));var L;(function(ye){function Te(Q){return{uri:Q.uri,range:O.from(Q.range)}}ye.from=Te;function le(Q){return new w.$IN(s.URI.revive(Q.uri),O.to(Q.range))}ye.to=le})(L||(e.Location=L={}));var q;(function(ye){function Te(le){switch(le){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}ye.to=Te})(q||(e.TokenType=q={}));var W;(function(ye){function Te(Q){return new w.$xN(Q.lineNumber-1,Q.column-1)}ye.to=Te;function le(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=le})(W||(e.Position=W={}));var M;(function(ye){function Te(Ee,We,Ze){return(0,v.$Kb)((0,v.$5b)(Ee).map(Ge=>le(Ge,We,Ze)))}ye.from=Te;function le(Ee,We,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,We),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(M||(e.DocumentSelector=M={}));var Y;(function(ye){function Te(Q){switch(Q){case w.DiagnosticTag.Unnecessary:return c.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return c.MarkerTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case c.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case c.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ye.to=le})(Y||(e.DiagnosticTag=Y={}));var Z;(function(ye){function Te(Q){let Ee;return Q.code&&((0,n.$gg)(Q.code)||(0,n.$kg)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...O.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:_.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(ge.from),tags:Array.isArray(Q.tags)?(0,v.$Kb)(Q.tags.map(Y.from)):void 0}}ye.from=Te;function le(Q){const Ee=new w.$KN(O.to(Q),Q.message,_.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,n.$gg)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(ge.to),Ee.tags=Q.tags&&(0,v.$Kb)(Q.tags.map(Y.to)),Ee}ye.to=le})(Z||(e.Diagnostic=Z={}));var ge;(function(ye){function Te(Q){return{...O.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Te;function le(Q){return new w.$JN(new w.$IN(Q.resource,O.to(Q)),Q.message)}ye.to=le})(ge||(e.DiagnosticRelatedInformation=ge={}));var _;(function(ye){function Te(Q){switch(Q){case w.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Te;function le(Q){switch(Q){case c.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var me;(function(ye){function Te(Q){return typeof Q=="number"&&Q>=w.ViewColumn.One?Q-1:Q===w.ViewColumn.Beside?f.$pE:f.$oE}ye.from=Te;function le(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(me||(e.ViewColumn=me={}));function se(ye){return typeof ye.range<"u"}function ce(ye){return ye.length===0?!0:!!se(ye[0])}var we;(function(ye){function Te(Ge){return Ge.map(ye.from)}ye.fromMany=Te;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let lt;if(le(Ge)){const{language:Lt,value:ui}=Ge;lt={value:"```"+Lt+`
`+ui+"\n```\n"}}else w.$YN.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const It=Object.create(null);lt.uris=It;const Qt=Lt=>{try{let ui=s.URI.parse(Lt,!0);ui=ui.with({query:Ee(ui.query,It)}),It[Lt]=ui}catch{}return""},ci=new p.marked.Renderer;return ci.link=Qt,ci.image=Lt=>typeof Lt=="string"?Qt(A.$_k(Lt).href):"",(0,p.marked)(lt.value,{renderer:ci}),lt}ye.from=Q;function Ee(Ge,lt){if(!Ge)return Ge;let It;try{It=(0,a.$ci)(Ge)}catch{}if(!It)return Ge;let Qt=!1;return It=(0,y.$go)(It,ci=>{if(s.URI.isUri(ci)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Lt]=ci,Qt=!0,Lt}else return}),Qt?JSON.stringify(It):Ge}function We(Ge){const lt=new w.$YN(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt.supportHtml=Ge.supportHtml,lt.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,lt}ye.to=We;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ze})(we||(e.MarkdownString=we={}));function oe(ye){return ce(ye)?ye.map(Te=>({range:O.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?we.fromMany(Te.hoverMessage):Te.hoverMessage?we.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ye.map(Te=>({range:O.from(Te)}))}function Ce(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var Le;(function(ye){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Ce(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Te})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var X;(function(ye){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Te})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(ye){function Te(le){if(typeof le>"u")return le;switch(le){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Te})(V||(e.DecorationRangeBehavior=V={}));var te;(function(ye){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?V.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?X.from(le.light):void 0,dark:le.dark?X.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Te})(te||(e.DecorationRenderOptions=te={}));var ve;(function(ye){function Te(Q){return{text:Q.newText,eol:Q.newEol&&je.from(Q.newEol),range:O.from(Q.range)}}ye.from=Te;function le(Q){const Ee=new w.$DN(O.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:je.to(Q.eol),Ee}ye.to=le})(ve||(e.TextEdit=ve={}));var ue;(function(ye){function Te(Q,Ee){const We={edits:[]};if(Q instanceof w.$GN){const Ze=new T.$Ec;for(const Ge of Q._allEntries())Ge._type===w.FileEditType.File&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===w.FileEditType.File){let lt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?lt={type:"base64",value:(0,I.$0e)(I.$Pe.wrap(Ge.options.contents))}:lt={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:lt},metadata:Ge.metadata})}else Ge._type===w.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:O.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===w.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:b.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}})}return We}ye.from=Te;function le(Q){const Ee=new w.$GN,We=new T.$Dc;for(const Ze of Q.edits)if(Ze.textEdit){const Ge=Ze,lt=s.URI.revive(Ge.resource),It=O.to(Ge.textEdit.range),Qt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Lt;ci?Lt=w.$FN.replace(It,new w.$HN(Qt)):Lt=w.$DN.replace(It,Qt);const ui=We.get(lt);ui?ui.push(Lt):We.set(lt,[Lt])}else Ee.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of We)Ee.set(Ze,Ge);return Ee}ye.to=le})(ue||(e.WorkspaceEdit=ue={}));var be;(function(ye){const Te=Object.create(null);Te[w.SymbolKind.File]=r.SymbolKind.File,Te[w.SymbolKind.Module]=r.SymbolKind.Module,Te[w.SymbolKind.Namespace]=r.SymbolKind.Namespace,Te[w.SymbolKind.Package]=r.SymbolKind.Package,Te[w.SymbolKind.Class]=r.SymbolKind.Class,Te[w.SymbolKind.Method]=r.SymbolKind.Method,Te[w.SymbolKind.Property]=r.SymbolKind.Property,Te[w.SymbolKind.Field]=r.SymbolKind.Field,Te[w.SymbolKind.Constructor]=r.SymbolKind.Constructor,Te[w.SymbolKind.Enum]=r.SymbolKind.Enum,Te[w.SymbolKind.Interface]=r.SymbolKind.Interface,Te[w.SymbolKind.Function]=r.SymbolKind.Function,Te[w.SymbolKind.Variable]=r.SymbolKind.Variable,Te[w.SymbolKind.Constant]=r.SymbolKind.Constant,Te[w.SymbolKind.String]=r.SymbolKind.String,Te[w.SymbolKind.Number]=r.SymbolKind.Number,Te[w.SymbolKind.Boolean]=r.SymbolKind.Boolean,Te[w.SymbolKind.Array]=r.SymbolKind.Array,Te[w.SymbolKind.Object]=r.SymbolKind.Object,Te[w.SymbolKind.Key]=r.SymbolKind.Key,Te[w.SymbolKind.Null]=r.SymbolKind.Null,Te[w.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Te[w.SymbolKind.Struct]=r.SymbolKind.Struct,Te[w.SymbolKind.Event]=r.SymbolKind.Event,Te[w.SymbolKind.Operator]=r.SymbolKind.Operator,Te[w.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ee){return typeof Te[Ee]=="number"?Te[Ee]:r.SymbolKind.Property}ye.from=le;function Q(Ee){for(const We in Te)if(Te[We]===Ee)return Number(We);return w.SymbolKind.Property}ye.to=Q})(be||(e.SymbolKind=be={}));var de;(function(ye){function Te(Q){switch(Q){case w.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case r.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ye.to=le})(de||(e.SymbolTag=de={}));var J;(function(ye){function Te(Q){return{name:Q.name,kind:be.from(Q.kind),tags:Q.tags&&Q.tags.map(de.from),containerName:Q.containerName,location:ze.from(Q.location)}}ye.from=Te;function le(Q){const Ee=new w.$PN(Q.name,be.to(Q.kind),Q.containerName,ze.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(de.to),Ee}ye.to=le})(J||(e.WorkspaceSymbol=J={}));var x;(function(ye){function Te(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:O.from(Q.range),selectionRange:O.from(Q.selectionRange),kind:be.from(Q.kind),tags:Q.tags?.map(de.from)??[]};return Q.children&&(Ee.children=Q.children.map(Te)),Ee}ye.from=Te;function le(Q){const Ee=new w.$QN(Q.name,Q.detail,be.to(Q.kind),O.to(Q.range),O.to(Q.selectionRange));return(0,v.$Ob)(Q.tags)&&(Ee.tags=Q.tags.map(de.to)),Q.children&&(Ee.children=Q.children.map(le)),Ee}ye.to=le})(x||(e.DocumentSymbol=x={}));var pe;(function(ye){function Te(Q){const Ee=new w.$UN(be.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),O.to(Q.range),O.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function le(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:Q.name,detail:Q.detail,kind:be.from(Q.kind),uri:Q.uri,range:O.from(Q.range),selectionRange:O.from(Q.selectionRange),tags:Q.tags?.map(de.from)}}ye.from=le})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(ye){function Te(le){return new w.$VN(pe.to(le.from),le.fromRanges.map(Q=>O.to(Q)))}ye.to=Te})($e||(e.CallHierarchyIncomingCall=$e={}));var Ne;(function(ye){function Te(le){return new w.$WN(pe.to(le.to),le.fromRanges.map(Q=>O.to(Q)))}ye.to=Te})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var ze;(function(ye){function Te(Q){return{range:Q.range&&O.from(Q.range),uri:Q.uri}}ye.from=Te;function le(Q){return new w.$IN(s.URI.revive(Q.uri),O.to(Q.range))}ye.to=le})(ze||(e.location=ze={}));var ke;(function(ye){function Te(Q){const Ee=Q,We=Q;return{originSelectionRange:Ee.originSelectionRange?O.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:O.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?O.from(Ee.targetSelectionRange):void 0}}ye.from=Te;function le(Q){return{targetUri:s.URI.revive(Q.uri),targetRange:O.to(Q.range),targetSelectionRange:Q.targetSelectionRange?O.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?O.to(Q.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Ae;(function(ye){function Te(Q){return{range:O.from(Q.range),contents:we.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}ye.from=Te;function le(Q){const Ee=Q.contents.map(we.to),We=O.to(Q.range),Ze=Q.canIncreaseVerbosity,Ge=Q.canDecreaseVerbosity;return new w.$MN(Ee,We,Ze,Ge)}ye.to=le})(Ae||(e.Hover=Ae={}));var Oe;(function(ye){function Te(Q){return{range:O.from(Q.range),expression:Q.expression}}ye.from=Te;function le(Q){return new w.$HO(O.to(Q.range),Q.expression)}ye.to=le})(Oe||(e.EvaluatableExpression=Oe={}));var j;(function(ye){function Te(Q){if(Q instanceof w.$IO)return{type:"text",range:O.from(Q.range),text:Q.text};if(Q instanceof w.$JO)return{type:"variable",range:O.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof w.$KO)return{type:"expression",range:O.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Te;function le(Q){switch(Q.type){case"text":return{range:O.to(Q.range),text:Q.text};case"variable":return{range:O.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:O.to(Q.range),expression:Q.expression}}}ye.to=le})(j||(e.InlineValue=j={}));var U;(function(ye){function Te(Q){return{frameId:Q.frameId,stoppedLocation:O.from(Q.stoppedLocation)}}ye.from=Te;function le(Q){return new w.$LO(Q.frameId,O.to(Q.stoppedLocation))}ye.to=le})(U||(e.InlineValueContext=U={}));var G;(function(ye){function Te(Q){return{range:O.from(Q.range),kind:Q.kind}}ye.from=Te;function le(Q){return new w.$NN(O.to(Q.range),Q.kind)}ye.to=le})(G||(e.DocumentHighlight=G={}));var H;(function(ye){function Te(Q){return{uri:Q.uri,highlights:Q.highlights.map(G.from)}}ye.from=Te;function le(Q){return new w.$ON(s.URI.revive(Q.uri),Q.highlights.map(G.to))}ye.to=le})(H||(e.MultiDocumentHighlight=H={}));var ne;(function(ye){function Te(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ye.to=Te})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ye){function Te(le){return{triggerKind:ne.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Te})(fe||(e.CompletionContext=fe={}));var Re;(function(ye){function Te(Q){switch(Q){case w.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case r.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ye.to=le})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(ye){const Te=new Map([[w.CompletionItemKind.Method,r.CompletionItemKind.Method],[w.CompletionItemKind.Function,r.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,r.CompletionItemKind.Field],[w.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[w.CompletionItemKind.Class,r.CompletionItemKind.Class],[w.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[w.CompletionItemKind.Module,r.CompletionItemKind.Module],[w.CompletionItemKind.Property,r.CompletionItemKind.Property],[w.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[w.CompletionItemKind.Value,r.CompletionItemKind.Value],[w.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,r.CompletionItemKind.Text],[w.CompletionItemKind.Color,r.CompletionItemKind.Color],[w.CompletionItemKind.File,r.CompletionItemKind.File],[w.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[w.CompletionItemKind.Event,r.CompletionItemKind.Event],[w.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[w.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(We){return Te.get(We)??r.CompletionItemKind.Property}ye.from=le;const Q=new Map([[r.CompletionItemKind.Method,w.CompletionItemKind.Method],[r.CompletionItemKind.Function,w.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,w.CompletionItemKind.Field],[r.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[r.CompletionItemKind.Class,w.CompletionItemKind.Class],[r.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[r.CompletionItemKind.Module,w.CompletionItemKind.Module],[r.CompletionItemKind.Property,w.CompletionItemKind.Property],[r.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[r.CompletionItemKind.Value,w.CompletionItemKind.Value],[r.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,w.CompletionItemKind.Text],[r.CompletionItemKind.Color,w.CompletionItemKind.Color],[r.CompletionItemKind.File,w.CompletionItemKind.File],[r.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[r.CompletionItemKind.Event,w.CompletionItemKind.Event],[r.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,w.CompletionItemKind.User],[r.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Ee(We){return Q.get(We)??w.CompletionItemKind.Property}ye.to=Ee})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Te(le,Q){const Ee=new w.$5N(le.label);return Ee.insertText=le.insertText,Ee.kind=Ue.to(le.kind),Ee.tags=le.tags?.map(Re.to),Ee.detail=le.detail,Ee.documentation=A.$6k(le.documentation)?we.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,h.$Mt.isIRange(le.range)?Ee.range=O.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:O.to(le.range.insert),replacing:O.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new w.$HN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof w.$yN?new w.$DN(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(We=>ve.to(We))),Ee.command=Q&&le.command?Q.fromInternal(le.command):void 0,Ee}ye.to=Te})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Te(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:we.fromStrict(Q.documentation)}}ye.from=Te;function le(Q){return{label:Q.label,documentation:A.$6k(Q.documentation)?we.to(Q.documentation):Q.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Te(Q){return{label:Q.label,documentation:we.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.from):[],activeParameter:Q.activeParameter}}ye.from=Te;function le(Q){return{label:Q.label,documentation:A.$6k(Q.documentation)?we.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.to):[],activeParameter:Q.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.from):[]}}ye.from=Te;function le(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Te(le,Q){const Ee=new w.$4N(W.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(rt.to.bind(void 0,le)),Q.kind&&ft.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(ve.to),Ee.tooltip=A.$6k(Q.tooltip)?we.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}ye.to=Te})(et||(e.InlayHint=et={}));var rt;(function(ye){function Te(le,Q){const Ee=new w.$3N(Q.label);return Ee.tooltip=A.$6k(Q.tooltip)?we.to(Q.tooltip):Q.tooltip,r.Command.is(Q.command)&&(Ee.command=le.fromInternal(Q.command)),Q.location&&(Ee.location=ze.to(Q.location)),Ee}ye.to=Te})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(ye){function Te(Q){return Q}ye.from=Te;function le(Q){return Q}ye.to=le})(ft||(e.InlayHintKind=ft={}));var ct;(function(ye){function Te(Q){return{range:O.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Te;function le(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?s.URI.parse(Q.url,!0):s.URI.revive(Q.url)}catch{}const We=new w.$0N(O.to(Q.range),Ee);return We.tooltip=Q.tooltip,We}ye.to=le})(ct||(e.DocumentLink=ct={}));var st;(function(ye){function Te(Q){const Ee=new w.$aO(Q.label);return Q.textEdit&&(Ee.textEdit=ve.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(We=>ve.to(We))),Ee}ye.to=Te;function le(Q){return{label:Q.label,textEdit:Q.textEdit?ve.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ut;(function(ye){function Te(Q){return new w.$$N(Q[0],Q[1],Q[2],Q[3])}ye.to=Te;function le(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=le})(ut||(e.Color=ut={}));var gt;(function(ye){function Te(Q){return{range:O.from(Q.range)}}ye.from=Te;function le(Q){return new w.$TN(O.to(Q.range))}ye.to=le})(gt||(e.SelectionRange=gt={}));var pt;(function(ye){function Te(le){switch(le){case m.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ye.to=Te})(pt||(e.TextDocumentSaveReason=pt={}));var Be;(function(ye){function Te(Q){switch(Q){case w.TextEditorLineNumbersStyle.Off:return o.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return o.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return o.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return o.RenderLineNumbersType.On}}ye.from=Te;function le(Q){switch(Q){case o.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case o.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case o.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case o.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ye.to=le})(Be||(e.TextEditorLineNumbersStyle=Be={}));var je;(function(ye){function Te(Q){if(Q===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(Q===w.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Te;function le(Q){if(Q===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(Q===t.EndOfLineSequence.LF)return w.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var ee;(function(ye){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case w.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case w.ProgressLocation.Window:return l.ProgressLocation.Window;case w.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Te})(ee||(e.ProgressLocation=ee={}));var K;(function(ye){function Te(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=Se.from(Q.kind)),Ee}ye.from=Te;function le(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=Se.to(Q.kind)),Ee}ye.to=le})(K||(e.FoldingRange=K={}));var Se;(function(ye){function Te(Q){if(Q)switch(Q){case w.FoldingRangeKind.Comment:return r.$Mu.Comment;case w.FoldingRangeKind.Imports:return r.$Mu.Imports;case w.FoldingRangeKind.Region:return r.$Mu.Region}}ye.from=Te;function le(Q){if(Q)switch(Q.value){case r.$Mu.Comment.value:return w.FoldingRangeKind.Comment;case r.$Mu.Imports.value:return w.FoldingRangeKind.Imports;case r.$Mu.Region.value:return w.FoldingRangeKind.Region}}ye.to=le})(Se||(e.FoldingRangeKind=Se={}));var Je;(function(ye){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?O.from(le.selection):void 0,override:typeof le.override=="boolean"?m.$SF.id:void 0}}ye.from=Te})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Te(We){return We instanceof w.$vO?We.toJSON():typeof We=="string"?We:le(We)||Q(We)?new w.$vO(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Te;function le(We){const Ze=We;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new w.$vO(s.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const Q=le;return{language:Q.language,scheme:Q.scheme,pattern:xe.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Te})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Te(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof w.$yN)))}ye.is=Te;function le(Q){return{documents:Q.documents.map(Ee=>Ee.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>O.from(Ze))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Ot;(function(ye){function Te(Q){return{start:Q.start,end:Q.end}}ye.from=Te;function le(Q){return new w.$YO(Q.start,Q.end)}ye.to=le})(Ot||(e.NotebookRange=Ot={}));var Ft;(function(ye){function Te(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Te;function le(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=le})(Ft||(e.NotebookCellExecutionSummary=Ft={}));var ei;(function(ye){function Te(le){if(le===b.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(le===b.NotebookCellExecutionState.Pending)return;if(le===b.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Te})(ei||(e.NotebookCellExecutionState=ei={}));var li;(function(ye){function Te(Q){switch(Q){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Te;function le(Q){switch(Q){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}ye.to=le})(li||(e.NotebookCellKind=li={}));var ti;(function(ye){function Te(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const We of Q.cells)w.$ZO.validate(We),Ee.cells.push(Ye.from(We));return Ee}ye.from=Te;function le(Q){const Ee=new w.$1O(Q.cells.map(Ye.to));return(0,n.$tg)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}ye.to=le})(ti||(e.NotebookData=ti={}));var Ye;(function(ye){function Te(Q){return{cellKind:li.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ft.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Kt.from):[]}}ye.from=Te;function le(Q){return new w.$ZO(li.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Kt.to):void 0,Q.metadata,Q.internalMetadata?Ft.to(Q.internalMetadata):void 0)}ye.to=le})(Ye||(e.NotebookCellData=Ye={}));var Gt;(function(ye){function Te(Q){return{mime:Q.mime,valueBytes:I.$Pe.wrap(Q.data)}}ye.from=Te;function le(Q){return new w.$2O(Q.valueBytes.buffer,Q.mime)}ye.to=le})(Gt||(e.NotebookCellOutputItem=Gt={}));var Kt;(function(ye){function Te(Q){return{outputId:Q.id,items:Q.items.map(Gt.from),metadata:Q.metadata}}ye.from=Te;function le(Q){const Ee=Q.items.map(Gt.to);return new w.$3O(Ee,Q.outputId,Q.metadata)}ye.to=le})(Kt||(e.NotebookCellOutput=Kt={}));var mt;(function(ye){function Te(Ee){return Q(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}ye.from=Te;function le(Ee){return Q(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}ye.to=le;function Q(Ee){const We=Ee;return We?!(0,n.$pg)(We.include)&&!(0,n.$pg)(We.exclude):!1}})(mt||(e.NotebookExclusiveDocumentPattern=mt={}));var Ct;(function(ye){function Te(le,Q,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===w.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:Q.toInternal(We,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Te})(Ct||(e.NotebookStatusBarItem=Ct={}));var ii;(function(ye){function Te(le,Q,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:Q.toInternal(We,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Te})(ii||(e.NotebookKernelSourceAction=ii={}));var Xt;(function(ye){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Te})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var Wt;(function(ye){function Te(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Te;function le(Q){return new w.$5O(s.URI.revive(Q.uri),Q.provides)}ye.to=le})(Wt||(e.NotebookRendererScript=Wt={}));var vt;(function(ye){function Te(Q){return{message:we.fromStrict(Q.message)||"",type:P.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:O.from(Q.location.range),uri:Q.location.uri}}}ye.from=Te;function le(Q){const Ee=new w.$$O(typeof Q.message=="string"?Q.message:we.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?ze.to(Q.location):void 0,Ee}ye.to=le})(vt||(e.TestMessage=vt={}));var Nt;(function(ye){ye.namespace=P.$YI,ye.denamespace=P.$ZI})(Nt||(e.TestTag=Nt={}));var hi;(function(ye){function Te(Q){const Ee=(0,g.$WP)(Q).controllerId;return{extId:k.$TI.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:s.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(We=>Nt.namespace(Ee,We.id)),range:h.$Mt.lift(O.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&we.fromStrict(Q.error)||null}}ye.from=Te;function le(Q){return{parent:void 0,error:void 0,id:k.$TI.fromString(Q.extId).localId,label:Q.label,uri:s.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:We}=Nt.denamespace(Ee);return new w.$_O(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=le})(hi||(e.TestItem=hi={})),function(ye){function Te(Q){return{id:Q.id}}ye.from=Te;function le(Q){return new w.$_O(Q.id)}ye.to=le}(Nt||(e.TestTag=Nt={}));var Vt;(function(ye){const Te=(Q,Ee)=>{const We=Q.value;if(!We)return;const Ze={...hi.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(lt=>lt.type===P.TestMessageType.Error).map(vt.to)})),children:[]};if(Q.children)for(const Ge of Q.children.values()){const lt=Te(Ge,Ze);lt&&Ze.children.push(lt)}return Ze};function le(Q){const Ee=new u.$SI;for(const Ge of Q.items)Ee.insert(k.$TI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ze=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ze.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:Q.completedAt,results:Ze.map(Ge=>Te(Ge)).filter(n.$og)}}ye.to=le})(Vt||(e.TestResults=Vt={}));var Xe;(function(ye){function Te(We){return{covered:We.covered,total:We.total}}function le(We){return"line"in We?W.from(We):O.from(We)}function Q(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:le(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&le(Ze.location),label:Ze.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:le(We.location)}}ye.fromDetails=Q;function Ee(We,Ze,Ge){return w.$bP(Ge.statementCoverage),w.$bP(Ge.branchCoverage),w.$bP(Ge.declarationCoverage),{id:Ze,uri:Ge.uri,statement:Te(Ge.statementCoverage),branch:Ge.branchCoverage&&Te(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Te(Ge.declarationCoverage),testIds:Ge instanceof w.$cP&&Ge.fromTests.length?Ge.fromTests.map(lt=>k.$TI.fromExtHostTestItem(lt,We).toString()):void 0}}ye.fromFile=Ee})(Xe||(e.TestCoverage=Xe={}));var Yt;(function(ye){function Te(le){switch(le){case r.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ye.to=Te})(Yt||(e.CodeActionTriggerKind=Yt={}));var ni;(function(ye){function Te(Q){const Ee=new w.$gP(be.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),O.to(Q.range),O.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function le(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:be.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:O.from(Q.range),selectionRange:O.from(Q.selectionRange),tags:Q.tags?.map(de.from)}}ye.from=le})(ni||(e.TypeHierarchyItem=ni={}));var di;(function(ye){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Te})(di||(e.ViewBadge=di={}));var Dt;(function(ye){function Te(We,Ze,Ge){const lt=Ze.fileData;return lt?new w.$nO(new w.$oO(lt.name,s.URI.revive(lt.uri),lt.id,(0,N.$gb)(()=>Ge(lt.id)))):We===R.$9s.uriList&&Ze.uriListData?new w.$mO(Ee(Ze.uriListData)):new w.$mO(Ze.asString)}ye.to=Te;async function le(We,Ze){const Ge=await Ze.asString();if(We===R.$9s.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const lt=Ze.asFile();return{asString:Ge,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ye.from=le;function Q(We){return C.$qu.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function Ee(We){return C.$qu.create(We.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(Dt||(e.DataTransferItem=Dt={}));var Mt;(function(ye){function Te(Q,Ee){const We=Q.items.map(([Ze,Ge])=>[Ze,Dt.to(Ze,Ge,Ee)]);return new w.$pO(We)}ye.toDataTransfer=Te;async function le(Q){const Ee={items:[]},We=[];for(const[Ze,Ge]of Q)We.push((async()=>{Ee.items.push([Ze,await Dt.from(Ze,Ge)])})());return await Promise.all(We),Ee}ye.from=le})(Mt||(e.DataTransfer=Mt={}));var Rt;(function(ye){function Te(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}ye.from=Te;function le(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}ye.to=le})(Rt||(e.ChatFollowup=Rt={}));var zt;(function(ye){function Te(Q){switch(Q){case D.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case D.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case D.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}ye.to=Te;function le(Q){switch(Q){case w.LanguageModelChatMessageRole.System:return D.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return D.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return D.ChatMessageRole.Assistant}return D.ChatMessageRole.User}ye.from=le})(zt||(e.LanguageModelChatMessageRole=zt={}));var ri;(function(ye){function Te(Q){let Ee="",We;Q.content.type==="text"?Ee=Q.content.value:We=new w.$HP(Q.content.name,Q.content.value,Q.content.isError);const Ze=zt.to(Q.role),Ge=new w.$IP(Ze,Ee,Q.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Te;function le(Q){const Ee=zt.from(Q.role),We=Q.name;let Ze;return Q.content2 instanceof w.$HP?Ze={type:"function_result",name:Q.content2.name,value:Q.content2.content,isError:Q.content2.isError}:Ze={type:"text",value:Q.content},{role:Ee,name:We,content:Ze}}ye.from=le})(ri||(e.LanguageModelChatMessage=ri={}));var Zt;(function(ye){function Te(Q){return{kind:"markdownContent",content:we.from(Q.value)}}ye.from=Te;function le(Q){return new w.$tP(we.to(Q.content))}ye.to=le})(Zt||(e.ChatResponseMarkdownPart=Zt={}));var si;(function(ye){function Te(Q){return{kind:"markdownVuln",content:we.from(Q.value),vulnerabilities:Q.vulnerabilities}}ye.from=Te;function le(Q){return new w.$uP(we.to(Q.content),Q.vulnerabilities)}ye.to=le})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Ut;(function(ye){function Te(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}ye.from=Te;function le(Q){return new w.$vP(Q.agentId,Q.command)}ye.to=le})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Ht;(function(ye){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}ye.from=Te})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var oi;(function(ye){function Te(Q){const{value:Ee,baseUri:We}=Q;function Ze(Ge,lt){return Ge.map(It=>{const Qt=s.URI.joinPath(lt,It.name);return{label:It.name,uri:Qt,children:It.children&&Ze(It.children,Qt)}})}return{kind:"treeData",treeData:{label:(0,E.$eh)(We),uri:We,children:Ze(Ee,We)}}}ye.from=Te;function le(Q){const Ee=(0,a.$di)(Q.treeData);function We(lt){return lt.map(It=>({name:It.label,children:It.children&&We(It.children)}))}const Ze=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new w.$xP(Ge,Ze)}ye.to=le})(oi||(e.ChatResponseFilesPart=oi={}));var Pt;(function(ye){function Te(Q){const Ee=We=>s.URI.isUri(We);return{kind:"inlineReference",name:Q.title,inlineReference:Ee(Q.value)?Q.value:L.from(Q.value)}}ye.from=Te;function le(Q){const Ee=(0,a.$di)(Q);return new w.$yP(s.URI.isUri(Ee.inlineReference)?Ee.inlineReference:L.to(Ee.inlineReference),Q.name)}ye.to=le})(Pt||(e.ChatResponseAnchorPart=Pt={}));var St;(function(ye){function Te(Q){return{kind:"progressMessage",content:we.from(Q.value)}}ye.from=Te;function le(Q){return new w.$zP(Q.content.value)}ye.to=le})(St||(e.ChatResponseProgressPart=St={}));var bt;(function(ye){function Te(Q){return{kind:"warning",content:we.from(Q.value)}}ye.from=Te;function le(Q){return new w.$BP(Q.content.value)}ye.to=le})(bt||(e.ChatResponseWarningPart=bt={}));var xt;(function(ye){function Te(le){return{kind:"progressTask",content:we.from(le.value)}}ye.from=Te})(xt||(e.ChatTask=xt={}));var kt;(function(ye){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?we.from(le):void 0}}ye.from=Te})(kt||(e.ChatTaskResult=kt={}));var fi;(function(ye){function Te(Q,Ee,We){return{kind:"command",command:Ee.toInternal(Q.value,We)??{command:Q.value.command,title:Q.value.title}}}ye.from=Te;function le(Q,Ee){return new w.$CP(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}ye.to=le})(fi||(e.ChatResponseCommandButtonPart=fi={}));var qt;(function(ye){function Te(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Ee=>ve.from(Ee))}}ye.from=Te;function le(Q){return new w.$EP(s.URI.revive(Q.uri),Q.edits.map(Ee=>ve.to(Ee)))}ye.to=le})(qt||(e.ChatResponseTextEditPart=qt={}));var bi;(function(ye){function Te(Q){const Ee=d.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:s.URI.isUri(Q.iconPath)?{light:s.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&s.URI.isUri(Q.iconPath.light)&&s.URI.isUri(Q.iconPath.dark)?{light:s.URI.revive(Q.iconPath.light),dark:s.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:s.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:L.from(Q.value.value)},iconPath:Ee}:{kind:"reference",reference:s.URI.isUri(Q.value)?Q.value:L.from(Q.value),iconPath:Ee}}ye.from=Te;function le(Q){const Ee=(0,a.$di)(Q),We=Ze=>s.URI.isUri(Ze)?Ze:L.to(Ze);return new w.$DP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=le})(bi||(e.ChatResponseReferencePart=bi={}));var vi;(function(ye){function Te(Ee,We,Ze){return Ee instanceof w.$tP?Zt.from(Ee):Ee instanceof w.$yP?Pt.from(Ee):Ee instanceof w.$DP?bi.from(Ee):Ee instanceof w.$zP?St.from(Ee):Ee instanceof w.$xP?oi.from(Ee):Ee instanceof w.$CP?fi.from(Ee,We,Ze):Ee instanceof w.$EP?qt.from(Ee):Ee instanceof w.$uP?si.from(Ee):Ee instanceof w.$vP?Ut.from(Ee):Ee instanceof w.$BP?bt.from(Ee):{kind:"markdownContent",content:we.from("")}}ye.from=Te;function le(Ee,We){switch(Ee.kind){case"reference":return bi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,We)}}ye.to=le;function Q(Ee,We){switch(Ee.kind){case"markdownContent":return Zt.to(Ee);case"inlineReference":return Pt.to(Ee);case"progressMessage":return;case"treeData":return oi.to(Ee);case"command":return fi.to(Ee,We)}}ye.toContent=Q})(vi||(e.ChatResponsePart=vi={}));var gi;(function(ye){function Te(le){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(ai.to),location:jt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData}}ye.to=Te})(gi||(e.ChatAgentRequest=gi={}));var jt;(function(ye){function Te(Q){switch(Q){case $.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ye.to=Te;function le(Q){switch(Q){case w.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=le})(jt||(e.ChatLocation=jt={}));var ai;(function(ye){function Te(le){const Q=le.value;if(!Q)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,s.$yc)(Q)?s.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,s.$yc)(Q.uri)?L.to((0,a.$di)(Q)):Q,modelDescription:le.modelDescription}}ye.to=Te})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(ye){function Te(le,Q,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:Q.toInternal(le.command,Ee)}}ye.from=Te})(Ii||(e.ChatAgentCompletionItem=Ii={}));var At;(function(ye){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Te})(At||(e.ChatAgentResult=At={}));var Si;(function(ye){function Te(le,Q,Ee){if(Q.action.kind==="vote")return;const We=At.to(le);if(Q.action.kind==="command"){const Ze=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(Q.action.followup)},result:We}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:We}:{action:Q.action,result:We}}ye.to=Te})(Si||(e.ChatAgentUserActionEvent=Si={}));var Pi;(function(ye){function Te(le,Q,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:Q.toInternal(le,Ee)}ye.from=Te})(Pi||(e.TerminalQuickFix=Pi={}));var Di;(function(ye){function Te(le){return{kind:pi.to(le.kind)}}ye.to=Te})(Di||(e.PartialAcceptInfo=Di={}));var pi;(function(ye){function Te(le){switch(le){case r.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ye.to=Te})(pi||(e.PartialAcceptTriggerKind=pi={}));var Ri;(function(ye){function Te(le,Q){return{id:Q,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Te})(Ri||(e.DebugTreeItem=Ri={}));var Bt;(function(ye){function Te(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Te})(Bt||(e.LanguageModelToolDescription=Bt={}))}),define(Ie[274],Pe([1,0,5,17,8,39]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0;let A=class{constructor(p,a){this.a=p.getProxy(v.$uN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>a.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,a,R){const y=new N.$Uw(C.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$Boc=A,e.$Boc=A=He([qe(0,I.$1P)],A)}),define(Ie[275],Pe([1,0,18,11,41,6,40,4,70,15,2,19,5,8,7,236,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0,E=Ve(E),d=Ve(d);class o{constructor(t,c,l,g,m){this.j=t,this.k=c,this.l=l,this.m=g,this.n=m,this.b=p.$he.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let c=function(g){if(t.c){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,g),m}};const t=this;this.b.reset();const l=(g,m)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),m){const $=this.l.$handleProgressChunk(this.k.requestId,g),D={report:S=>{$?.then(b=>{b&&(d.$YN.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(S),b):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(S),b))})}};Promise.all([$,m?.(D)]).then(([S,b])=>{S!==void 0&&b!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(b),S)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){c(this.markdown);const m=new d.$tP(g),$=E.ChatResponseMarkdownPart.from(m);return l($),this},markdownWithVulnerabilities(g,m){c(this.markdown),m&&(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$uP(g,m),D=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(D),this},filetree(g,m){c(this.filetree);const $=new d.$xP(g,m),D=E.ChatResponseFilesPart.from($);return l(D),this},anchor(g,m){c(this.anchor);const $=new d.$yP(g,m),D=E.ChatResponseAnchorPart.from($);return l(D),this},button(g){c(this.anchor);const m=new d.$CP(g),$=E.ChatResponseCommandButtonPart.from(m,t.m,t.n);return l($),this},progress(g,m){c(this.progress);const $=new d.$AP(g,m),D=m?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return l(D,m),this},warning(g){c(this.progress),(0,s.$7G)(t.j,"chatParticipantAdditions");const m=new d.$BP(g),$=E.ChatResponseWarningPart.from(m);return l($),this},reference(g,m){if(c(this.reference),"variableName"in g&&(0,s.$7G)(t.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const $=t.k.variables.variables.find(D=>D.name===g.variableName);if($){let D;if($.references?.length)D=$.references.map(S=>({kind:"reference",reference:{variableName:g.variableName,value:S.reference}}));else{const S=new d.$DP(g,m);D=[E.ChatResponseReferencePart.from(S)]}return D.forEach(S=>l(S)),this}}else{const $=new d.$DP(g,m),D=E.ChatResponseReferencePart.from($);l(D)}return this},textEdit(g,m){c(this.textEdit),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$EP(g,m),D=E.ChatResponseTextEditPart.from($);return l(D),this},detectedParticipant(g,m){c(this.detectedParticipant),(0,s.$7G)(t.j,"chatParticipantAdditions");const $=new d.$vP(g,m),D=E.ChatResponseDetectedParticipantPart.from($);return l(D),this},confirmation(g,m,$){c(this.confirmation),(0,s.$7G)(t.j,"chatParticipantAdditions");const D=new d.$wP(g,m,$),S=E.ChatResponseConfirmationPart.from(D);return l(S),this},push(g){if(c(this.push),(g instanceof d.$EP||g instanceof d.$uP||g instanceof d.$vP||g instanceof d.$BP||g instanceof d.$wP)&&(0,s.$7G)(t.j,"chatParticipantAdditions"),g instanceof d.$DP)this.reference(g.value,g.iconPath);else{const m=E.ChatResponsePart.from(g,t.m,t.n);l(m)}return this}}}return this.g}}class h extends T.$Xc{static{this.b=0}constructor(t,c,l){super(),this.n=c,this.s=l,this.c=new Map,this.j=this.B(new T.$7c),this.m=this.B(new T.$7c),this.g=t.getProxy(u.$uN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,c,l){const g=h.b++,m=new i(t,c,this.g,g,l);return this.c.set(g,m),this.g.$registerAgent(g,t.identifier,c,{},void 0),m.apiAgent}createDynamicChatAgent(t,c,l,g){const m=h.b++,$=new i(t,c,this.g,m,g);return this.c.set(m,$),this.g.$registerAgent(m,t.identifier,c,{isSticky:!0},l),$.apiAgent}async $invokeAgent(t,c,l,g){const m=this.c.get(t);if(!m)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(c.sessionId);$||($=new T.$Wc,this.j.set(c.sessionId,$));const D=new o(m.extension,c,this.g,this.s.converter,$);try{const S=await this.t(c.agentId,l),b=m.invoke(E.ChatAgentRequest.to(c),{history:S},D.apiObject,g);return await(0,I.$uh)(Promise.resolve(b).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(f){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${f.message}`;return this.n.error(`[${m.extension.identifier.value}] [@${m.id}] ${w}`,m.extension),{errorDetails:{message:w},timings:D.timings}}let P;return k?.errorDetails&&(P={...k.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,s.$7G)(m.extension,"chatParticipantPrivate"),{errorDetails:P,timings:D.timings,metadata:k?.metadata}}),g)}catch(S){return this.n.error(S,m.extension),S instanceof d.$OP&&S.cause&&(S=S.cause),{errorDetails:{message:(0,C.$rj)(S),responseIsIncomplete:!0}}}finally{D.close()}}async t(t,c){const l=[];for(const g of c.history){const m=E.ChatAgentResult.to(g.result),$=t===g.request.agentId?m:{...m,metadata:void 0};l.push(new d.$FP(g.request.message,g.request.command,g.request.variables.variables.map(E.ChatAgentValueReference.to),g.request.agentId));const D=(0,v.$Kb)(g.response.map(S=>E.ChatResponsePart.toContent(S,this.s.converter)));l.push(new d.$GP(D,$,g.request.agentId,g.request.command))}return l}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,c,l,g,m){const $=this.c.get(c);if(!$)return Promise.resolve([]);const D=await this.t($.id,g),S=E.ChatAgentResult.to(l);return(await $.provideFollowups(S,{history:D},m)).filter(b=>{const k=!b.participant||A.Iterable.some(this.c.values(),P=>P.id===b.participant&&y.$rn.equals(P.extension.identifier,$.extension.identifier));return k||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),k}).map(b=>E.ChatFollowup.from(b,t))}$acceptFeedback(t,c,l,g){const m=this.c.get(t);if(!m)return;const $=E.ChatAgentResult.to(c);let D;switch(l){case n.ChatAgentVoteDirection.Down:D=d.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:D=d.ChatResultFeedbackKind.Helpful;break}m.acceptFeedback(Object.freeze(g?{result:$,kind:D,reportIssue:g}:{result:$,kind:D}))}$acceptAction(t,c,l){const g=this.c.get(t);if(!g||l.action.kind==="vote")return;const m=E.ChatAgentUserActionEvent.to(c,l,this.s.converter);m&&g.acceptAction(Object.freeze(m))}async $invokeCompletionProvider(t,c,l){const g=this.c.get(t);if(!g)return[];let m=this.m.get(t);return m?m.clear():(m=new T.$Wc,this.m.set(t,m)),(await g.invokeCompletionProvider(c,l)).map(D=>E.ChatAgentCompletionItem.from(D,this.s.converter,m))}async $provideWelcomeMessage(t,c,l){const g=this.c.get(t);if(g)return await g.provideWelcomeMessage(E.ChatLocation.to(c),l)}async $provideSampleQuestions(t,c,l){const g=this.c.get(t);if(g)return(await g.provideSampleQuestions(E.ChatLocation.to(c),l)).map(m=>E.ChatFollowup.from(m,void 0))}}e.$Coc=h;class i{constructor(t,c,l,g,m){this.extension=t,this.id=c,this.w=l,this.x=g,this.y=m,this.m=new N.$ne,this.n=new N.$ne}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,c){return this.q?await this.q.provider.provideCompletionItems(t,c)??[]:[]}async provideFollowups(t,c,l){if(!this.b)return[];const g=await this.b.provideFollowups(t,c,l);return g?g.filter(m=>!(m&&"commandId"in m)).filter(m=>!(m&&"message"in m)):[]}async provideWelcomeMessage(t,c){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(t,c);return l?l.map(g=>typeof g=="string"?g:E.MarkdownString.from(g)):[]}async provideSampleQuestions(t,c){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(t,c);return l||[]}get apiAgent(){let t=!1,c=!1;const l=()=>{t||c||(c=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$tO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),c=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(m){g.c=m,l()},get requestHandler(){return g.y},set requestHandler(m){(0,a.$qg)(typeof m=="function","Invalid request handler"),g.y=m},get followupProvider(){return g.b},set followupProvider(m){g.b=m,l()},get isDefault(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.d},set isDefault(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.d=m,l()},get helpTextPrefix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.g=m,l()},get helpTextVariablesPrefix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.j=m,l()},get helpTextPostfix(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.k=m,l()},get isSecondary(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.l=m,l()},get supportIssueReporting(){return(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(m){(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.o=m,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(m){if((0,s.$7G)(g.extension,"chatParticipantAdditions"),g.q=m,m){if(!m.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,m.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,s.$7G)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(m){(0,s.$7G)(g.extension,"defaultChatParticipant"),g.s=m,l()},get welcomeMessageProvider(){return(0,s.$7G)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,s.$6G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(m){g.t=m,l()},get requester(){return g.t},set supportsSlowReferences(m){(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.u=m,l()},get supportsSlowReferences(){return(0,s.$7G)(g.extension,"chatParticipantPrivate"),g.u},dispose(){t=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(t,c,l,g){return this.y(t,c,l,g)}}}),define(Ie[276],Pe([1,0,14,4,35,5,8,7,25]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0,A=Ve(A),T=Ve(T);class a{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(N.$uN.MainThreadChatVariables)}async $resolveVariable(u,E,d,n){const s=this.b.get(u);if(s)try{if(s.resolver.resolve2){(0,p.$7G)(s.extension,"chatParticipantAdditions");const o=new R(E,this.c),h=await s.resolver.resolve2(s.data.name,{prompt:d},o.apiObject,n);if(h&&h[0])return h[0].value}else{const o=await s.resolver.resolve(s.data.name,{prompt:d},n);if(o&&o[0])return o[0].value}}catch(o){(0,v.$4)(o)}}registerVariableResolver(u,E,d,n,s,o,h,i,r){const t=a.a++,c=r?C.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:u,data:{id:E,name:d,description:n,modelDescription:s,icon:c},resolver:h}),this.c.$registerVariable(t,{id:E,name:d,description:n,modelDescription:s,isSlow:o,fullName:i,icon:c}),(0,I.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Doc=a;class R{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(n){if(u.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,n),s}};const u=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){E(this.progress);const s=new T.$zP(n),o=A.ChatResponseProgressPart.from(s);return d(o),this},reference(n){E(this.reference);const s=new T.$DP(n),o=A.ChatResponseReferencePart.from(s);return d(o),this},push(n){return E(this.push),n instanceof T.$DP?d(A.ChatResponseReferencePart.from(n)):n instanceof T.$zP&&d(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Ie[277],Pe([1,0,11,72,6,4,38,2,94,19,8,7,5,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=d,p=Ve(p),R=Ve(R),y=Ve(y);function d(n,s,o){const h=n.getProxy(u.$uN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$tn,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===A.MarshalledId.CommentController){const k=this.b.get(b.handle);return k?k.value:b}else if(b&&b.$mid===A.MarshalledId.CommentThread){const k=b,P=this.b.get(k.commentControlHandle);if(!P)return k;const f=P.getCommentThread(k.commentThreadHandle);return f?f.value:k}else if(b&&(b.$mid===A.MarshalledId.CommentThreadReply||b.$mid===A.MarshalledId.CommentThreadInstance)){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const P=k.getCommentThread(b.thread.commentThreadHandle);return P?b.$mid===A.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:b.text}:b}else if(b&&b.$mid===A.MarshalledId.CommentNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const P=k.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const f=b.commentUniqueId,w=P.getCommentByUniqueId(f);return w||b}else if(b&&b.$mid===A.MarshalledId.CommentThreadNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const P=k.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const f=b.text,w=b.commentUniqueId,F=P.getCommentByUniqueId(w);return F?(typeof F.body=="string"?F.body=f:F.body=new y.$YN(f),F):b}return b}})}createCommentController(b,k,P){const f=i.a++,w=new t(b,f,k,P);this.b.set(w.handle,w);const F=this.c.get(b.identifier)||[];return F.push(w),this.c.set(b.identifier,F),w.value}async $createCommentThreadTemplate(b,k,P,f){const w=this.b.get(b);w&&w.$createCommentThreadTemplate(k,P,f)}async $setActiveComment(b,k){const P=this.b.get(b);P&&P.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(b,k,P){const f=this.b.get(b);f&&f.$updateCommentThreadTemplate(k,P)}$deleteCommentThread(b,k){this.b.get(b)?.$deleteCommentThread(k)}async $provideCommentingRanges(b,k,P){const f=this.b.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(T.URI.revive(k));return(0,v.$yh)(async()=>{const F=await f.commentingRangeProvider.provideCommentingRanges(w.document,P);let O;return Array.isArray(F)?O={ranges:F,fileComments:!1}:F?O={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:O=F??void 0,O}).then(F=>{let O;return F&&(O={ranges:F.ranges.map(L=>R.Range.from(L)),fileComments:F.fileComments}),O})}$toggleReaction(b,k,P,f,w){const F=this.b.get(b);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,v.$yh)(()=>{const O=F.getCommentThread(k);if(O){const L=O.getCommentByUniqueId(f.uniqueIdInThread);if(F!==void 0&&L&&F.reactionHandler)return F.reactionHandler(L,g(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,E.$7G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,k,P,f,w,F,O,L,q){this.m=k,this.n=P,this.o=f,this.p=w,this.q=F,this.extensionDescription=O,this.r=L,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$ne,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Yc,this.l.value=new N.$Wc,this.n===void 0&&(this.n=`${b}.${this.handle}`),h.$createCommentThread(k,this.handle,this.n,this.o,R.Range.from(this.p),O.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{h.$deleteCommentThread(k,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(M){W.range=M},get comments(){return W.comments},set comments(M){W.comments=M},get collapsibleState(){return W.collapsibleState},set collapsibleState(M){W.collapsibleState=M},get canReply(){return W.canReply},set canReply(M){W.canReply=M},get contextValue(){return W.contextValue},set contextValue(M){W.contextValue=M},get label(){return W.label},set label(M){W.label=M},get state(){return W.state},set state(M){W.state=M},reveal:M=>W.reveal(M),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Wc);const b=P=>Object.prototype.hasOwnProperty.call(this.b,P),k={};b("range")&&(k.range=R.Range.from(this.p)),b("label")&&(k.label=this.label),b("contextValue")&&(k.contextValue=this.contextValue??null),b("comments")&&(k.comments=this.q.map(P=>c(this,P,this.k,this.extensionDescription))),b("collapsibleState")&&(k.collapseState=m(this.g)),b("canReply")&&(k.canReply=this.canReply),b("state")&&(k.state=$(this.h)),b("applicability")&&(k.applicability=D(this.h)),b("isTemplate")&&(k.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(b){for(const k of this.k){const P=k[0],f=k[1];if(b===f)return P}}async reveal(b){return(0,E.$7G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...b})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}He([(0,I.$_h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,E.$7G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$7G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$7G)(this.h,"activeComment"),this.f}constructor(b,k,P,f){this.h=b,this.i=k,this.j=P,this.k=f,this.a=new Map,h.$registerCommentController(this.handle,P,f,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(F){w.options=F},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(F){w.commentingRangeProvider=F},get reactionHandler(){return w.reactionHandler},set reactionHandler(F){w.reactionHandler=F},get activeCommentThread(){return w.activeCommentThread},createCommentThread(F,O,L){return w.createCommentThread(F,O,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(b,k,P){k===void 0&&(0,E.$7G)(this.h,"fileComments");const f=new r(this.id,this.handle,void 0,b,k,P,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const k=this.a.get(b.commentThreadHandle);k&&(this.e=b.uniqueIdInThread?k.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(b,k,P){const f=new r(this.id,this.handle,void 0,T.URI.revive(b),R.Range.to(k),[],this.h,!0,P);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(b,k){const P=this.a.get(b);P&&(P.range=R.Range.to(k))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function c(S,b,k,P){let f=k.get(b);return f||(f=++S.commentHandle,k.set(b,f)),b.state!==void 0&&(0,E.$7G)(P,"commentsDraftState"),b.reactions?.some(w=>w.reactors!==void 0)&&(0,E.$7G)(P,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:R.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(w=>l(w)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function l(S){return{label:S.label,iconPath:S.iconPath?R.$ZP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(b=>b.name):S.reactors}}function g(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?T.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(b=>({name:b}))}}function m(S){if(S!==void 0)switch(S){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(S){let b;if(typeof S=="object"?b=S.resolved:b=S,b!==void 0)switch(b){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function D(S){let b;if(typeof S=="object"&&(b=S.applicability),b!==void 0)switch(b){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ie[278],Pe([1,0,22,76,4,16,24,2,8,68,80,5,7]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=void 0,p=Ve(p),y=Ve(y),u=Ve(u);class E{constructor(l,g){this.document=l,this.b=g,this.a=1,this.c=new R.$noc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,g){await this.f(l).undo(),g||this.disposeBackup()}async redo(l,g){await this.f(l).redo(),g||this.disposeBackup()}disposeEdits(l){for(const g of l)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,A.$hh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const g=this.c.get(l,0);if(!g)throw new Error("No edit found");return g}}class d{constructor(){this.a=new Map}get(l,g){return this.a.get(this.b(l,g))}add(l,g,m){const $=this.b(l,g.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${g.uri}`);const D=new E(g,m);return this.a.set($,D),D}delete(l,g){const m=this.b(l,g.uri);this.a.delete(m)}b(l,g){return`${l}@@@${g}`}}var n;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(n||(n={}));class s{constructor(){this.a=new Map}addTextProvider(l,g,m){return this.b(l,{type:n.Text,extension:g,provider:m})}addCustomProvider(l,g,m){return this.b(l,{type:n.Custom,extension:g,provider:m})}get(l){return this.a.get(l)}b(l,g){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,g),new u.$wN(()=>this.a.delete(l))}}class o{constructor(l,g,m,$,D){this.d=g,this.f=m,this.g=$,this.h=D,this.b=new s,this.c=new d,this.a=l.getProxy(y.$uN.MainThreadCustomEditors)}registerCustomEditorProvider(l,g,m,$){const D=new C.$Wc;return i(m)?(D.add(this.b.addTextProvider(g,l,m)),this.a.$registerTextEditorProvider((0,a.$Woc)(l),g,$.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,a.$Uoc)(l))):(D.add(this.b.addCustomProvider(g,l,m)),h(m)&&D.add(m.onDidChangeCustomDocument(S=>{const b=this.i(g,S.document.uri);if(r(S)){const k=b.addEdit(S);this.a.$onDidEdit(S.document.uri,g,k,S.label)}else this.a.$onContentChange(S.document.uri,g)})),this.a.$registerCustomEditorProvider((0,a.$Woc)(l),g,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,a.$Uoc)(l))),u.$wN.from(D,new u.$wN(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(l,g,m,$,D){const S=this.b.get(g);if(!S)throw new Error(`No provider found for '${g}'`);if(S.type!==n.Custom)throw new Error(`Invalid provide type for '${g}'`);const b=T.URI.revive(l),k=await S.provider.openCustomDocument(b,{backupId:m,untitledDocumentData:$?.buffer},D);let P;return h(S.provider)&&this.f&&(P=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(g,k,P),{editable:h(S.provider)}}async $disposeCustomDocument(l,g){const m=this.b.get(g);if(!m)throw new Error(`No provider found for '${g}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${g}'`);const $=T.URI.revive(l),{document:D}=this.i(g,$);this.c.delete(g,D),D.dispose()}async $resolveCustomEditor(l,g,m,$,D,S){const b=this.b.get(m);if(!b)throw new Error(`No provider found for '${m}'`);const k=p.ViewColumn.to(D),P=this.g.createNewWebview(g,$.contentOptions,b.extension),f=this.h.createNewWebviewPanel(g,m,$.title,k,$.options,P,$.active),w=T.URI.revive(l);switch(b.type){case n.Custom:{const{document:F}=this.i(m,w);return b.provider.resolveCustomEditor(F,f,S)}case n.Text:{const F=this.d.getDocument(w);return b.provider.resolveCustomTextEditor(F,f,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,g,m){this.i(g,l).disposeEdits(m)}async $onMoveCustomEditor(l,g,m){const $=this.b.get(m);if(!$)throw new Error(`No provider found for '${m}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const D=this.h.getWebviewPanel(l);if(!D)throw new Error("No webview found");const S=T.URI.revive(g),b=this.d.getDocument(S);await $.provider.moveCustomTextEditor(b,D,v.CancellationToken.None)}async $undo(l,g,m,$){return this.i(g,l).undo(m,$)}async $redo(l,g,m,$){return this.i(g,l).redo(m,$)}async $revert(l,g,m){const $=this.i(g,l);await this.j(g).revertCustomDocument($.document,m),$.disposeBackup()}async $onSave(l,g,m){const $=this.i(g,l);await this.j(g).saveCustomDocument($.document,m),$.disposeBackup()}async $onSaveAs(l,g,m,$){const D=this.i(g,l);return this.j(g).saveCustomDocumentAs(D.document,T.URI.revive(m),$)}async $backup(l,g,m){const $=this.i(g,l),S=await this.j(g).backupCustomDocument($.document,{destination:$.getNewBackupUri()},m);return $.updateBackup(S),S.id}i(l,g){const m=this.c.get(l,T.URI.revive(g));if(!m)throw new Error("No custom document found");return m}j(l){const m=this.b.get(l)?.provider;if(!m||!h(m))throw new Error("Custom document is not editable");return m}}e.$Zoc=o;function h(c){return!!c.onDidChangeCustomDocument}function i(c){return typeof c.resolveCustomTextEditor=="function"}function r(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function t(c){const l=c.scheme===N.Schemas.file||c.scheme===N.Schemas.untitled?c.fsPath:c.toString();return(0,I.$uj)(l)+""}}),define(Ie[279],Pe([1,0,181,108,2,5,7,8,6,12,29,51]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$uoc=void 0,T=Ve(T);class E{#e;#t;#i;constructor(s,o,h,i,r,t,c,l){this.d=s,this.e=o,this.f=h,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,h),this.#i=new R.$Dc(g=>t.getComparisonKey(g)),this.#e=c,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let h=[];if(C.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),h=[s]}else if(Array.isArray(s)){h=[];let t;s=[...s].sort(E.k);for(const c of s){const[l,g]=c;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,h.push(l),this.#i.set(l,[])),g)this.#i.get(l)?.push(...g);else{const m=this.#i.get(l);m&&(m.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let r=0;for(const t of h){let c=[];const l=this.#i.get(t);if(l)if(l.length>this.g){c=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const $ of l)if($.severity===g[m]&&c.push({...T.Diagnostic.from($),modelVersionId:this.h(t)})===this.g)break e;c.push({severity:I.MarkerSeverity.Info,message:(0,v.localize)(0,null,l.length-this.g),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=l.map(g=>({...T.Diagnostic.from(g),modelVersionId:this.h(t)}));if(i.push([t,c]),r+=c.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[h,i]of this)s.call(o,h,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$uoc=E;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(s){const o=new R.$Dc;for(const h of s)o.set(h,h);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,h,i){this.j=o,this.k=h,this.l=i,this.g=new Map,this.h=new p.$re({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=s.getProxy(N.$uN.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:h,f:i,h:r,j:t,k:c,l}=this,g=new class{$changeMany(D,S){i.$changeMany(D,S),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,D,S.length===0?"CLEARING":S)}$clear(D){i.$clear(D),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,D)}dispose(){i.dispose()}};let m;if(!o)o="_generated_diagnostic_collection_name_#"+u.c++,m=o;else if(!h.has(o))m=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do m=o+u.c++;while(h.has(m))}return new class extends E{constructor(){super(o,m,u.e,u.d,D=>l.getDocument(D)?.version,c.extUri,g,r),h.set(m,this)}dispose(){super.dispose(),h.delete(m)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,h=[];for(const i of this.g.values())i.forEach((r,t)=>{let c=o.get(r.toString());typeof c>"u"&&(c=h.length,o.set(r.toString(),c),h.push([r,[]])),h[c][1]=h[c][1].concat(...t)});return h}}m(s){let o=[];for(const h of this.g.values())h.has(s)&&(o=o.concat(h.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",h=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,h),this.n=h}for(const[o,h]of s)this.n.set(C.URI.revive(o),h.map(T.Diagnostic.to))}};e.$voc=d,e.$voc=d=u=He([qe(1,a.$ak),qe(2,y.$toc)],d)}),define(Ie[280],Pe([1,0,2,14,7,8,212,39]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class p{constructor(R,y,u,E={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=u,this.g=E,this.a=new A.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,u,E)=>{const n={dispose:this.a.push([y,u,R])};return Array.isArray(E)&&E.push(n),n}}async $participateInSave(R,y){const u=v.URI.revive(R);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),n=[];try{for(const s of[...this.a]){if(E)break;const o=this.d.getDocument(u),h=await this.h(s,{document:o,reason:N.TextDocumentSaveReason.to(y)});n.push(h)}}finally{clearTimeout(d)}return n}h([R,y,u],E){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,R,y,E).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const s=this.b.get(R);this.b.set(R,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,u,E){const d=[],n=Date.now(),{document:s,reason:o}=E,{version:h}=s,i=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(d))throw(0,I.$$)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{y.apply(u,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const c=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(c),r(l)}).catch(l=>{clearTimeout(c),t(l)})}).then(r=>{const t={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(l=>l instanceof C.$DN))for(const{newText:l,newEol:g,range:m}of c)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&N.Range.from(m),text:l,eol:g&&N.EndOfLine.from(g)}});if(t.edits.length!==0)return h===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Uw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Ipc=p}),define(Ie[281],Pe([1,0,6,4,2,5,123,8,15,26,7]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,T=Ve(T);class y{constructor(E,d){this.a=new v.$ne,this.b=new v.$ne,this.c=new v.$ne,this.d=new v.$ne,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new I.$Wc,this.h=new Map,this.f=E.getProxy(N.$uN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const s of n)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const s of n)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let n=this.h.get(E.toString());return n||(n=this.f.$tryOpenDocument(E).then(s=>{this.h.delete(E.toString());const o=C.URI.revive(s);return(0,p.$rg)(this.g.getDocument(o))},s=>(this.h.delete(E.toString()),Promise.reject(s))),this.h.set(E.toString(),n)),n}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged(E,d){const n=C.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(E){const d=C.URI.revive(E),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(E,d){const n=C.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,n){const s=C.URI.revive(E),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(n),o.onEvents(d);let h;d.isUndoing?h=R.TextDocumentChangeReason.Undo:d.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,a.$fo)({document:o.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$3P)(E,d)}}e.$woc=y}),define(Ie[71],Pe([1,0,282,6,15,2,3,5,17,8,7]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0,a=Ve(a),e.$1oc=(0,A.$Gi)("IExtHostEditorTabs");class y{constructor(s,o,h){this.e=h,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$hP(N.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$iP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$jP(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$kP(N.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$lP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$mP(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$nP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$oP;case T.TabInputKind.InteractiveEditorInput:return new R.$pP(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$qP;case T.TabInputKind.MultiDiffEditorInput:return new R.$rP(this.b.input.diffEditors.map(s=>new R.$iP(N.URI.revive(s.original),N.URI.revive(s.modified))));default:return}}}class u{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const h of s.tabs)h.isActive&&(this.d=h.id),this.c.push(new y(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return a.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(h=>h.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(h=>h.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const h=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,h),s.tabDto.isActive&&(this.d=h.tabId),h}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(s.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(s.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,h),h}const o=this.c.find(h=>h.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(s){this.b=new I.$ne,this.c=new I.$ne,this.e=[],this.a=s.getProxy(T.$uN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(h=>h.apiObject))},get activeTabGroup(){const h=s.d;return(0,C.$rg)(s.e.find(r=>r.groupId===h)?.apiObject)},close:async(h,i)=>{const r=Array.isArray(h)?h:[h];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(g=>g.groupId)),h=new Set(s.map(g=>g.groupId)),i=(0,v.$L)(o,h),r=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],c=[];this.e=s.map(g=>{const m=new u(g,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):c.push(m.apiObject),m});const l=(0,C.$rg)(s.find(g=>g.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:c}))}$acceptTabGroupUpdate(s){const o=this.e.find(h=>h.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const h=o.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(s){for(const o of this.e)for(const h of o.tabs)if(h.apiObject===s)return h}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const h=[];for(const i of s){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");h.push(r.tabId)}return this.a.$closeTab(h,o)}async j(s,o){const h=[];for(const i of s){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");h.push(r.groupId)}return this.a.$closeGroup(h,o)}};e.$2oc=E,e.$2oc=E=He([qe(0,p.$1P)],E);function d(n){return n.tabs!==void 0}}),define(Ie[283],Pe([1,0,2,5,30,4,7,8,327,13,28,23,25,60]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0,C=Ve(C),T=Ve(T);class d{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const h=this.a.indexOf(o);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),h=[];let i,r,t=p.State.LastKnownState,c=p.State.LastKnownState;for(const l of o){let g=i?(0,a.$Jf)(i,l):0;for(g===0?r=p.State.Start:r=c;g<l.length;g++)g+1===l.length?(t=c,c=p.State.BeforeColon):c+=1,h.push([r,l.toUpperCase().charCodeAt(g),c]),h.push([r,l.toLowerCase().charCodeAt(g),c]),r=c;i=l,c=t}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$p4(h)}}provideDocumentLinks(o){this.c();const h=[],i=p.$q4.computeLinks({getLineContent(r){return o.lineAt(r-1).text},getLineCount(){return o.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&h.push(t)}return h}}class n{constructor(o,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(I.$uN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,h,i,r={}){if(n.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let c=C.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(c+=C.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(c+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(c+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$7G)(o,"fsChunks"),c+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,E.$6k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,c,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${h}`),console.error(m)});const g=i.onDidChangeFile(m=>{const $=[];for(const D of m){const{uri:S,type:b}=D;if(S.scheme!==h)continue;let k;switch(b){case A.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case A.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:S,type:k})}this.a.$onFileSystemChange(t,$)});return(0,N.$Vc)(()=>{g.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:h,ctime:i,mtime:r,size:t,permissions:c}=o;return{type:h,ctime:i,mtime:r,size:t,permissions:c}}$stat(o,h){return Promise.resolve(this.l(o).stat(v.URI.revive(h))).then(i=>n.k(i))}$readdir(o,h){return Promise.resolve(this.l(o).readDirectory(v.URI.revive(h)))}$readFile(o,h){return Promise.resolve(this.l(o).readFile(v.URI.revive(h))).then(i=>y.$Pe.wrap(i))}$writeFile(o,h,i,r){return Promise.resolve(this.l(o).writeFile(v.URI.revive(h),i.buffer,r))}$delete(o,h,i){return Promise.resolve(this.l(o).delete(v.URI.revive(h),i))}$rename(o,h,i,r){return Promise.resolve(this.l(o).rename(v.URI.revive(h),v.URI.revive(i),r))}$copy(o,h,i,r){const t=this.l(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(h),v.URI.revive(i),r))}$mkdir(o,h){return Promise.resolve(this.l(o).createDirectory(v.URI.revive(h)))}$watch(o,h,i,r){const t=this.l(o).watch(v.URI.revive(i),r);this.f.set(h,t)}$unwatch(o,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(o,h,i){const r=this.l(o);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(h),i))}$close(o,h){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(o,h,i,r){const t=this.l(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$Pe.alloc(r);return Promise.resolve(t.read(h,i,c.buffer,0,r)).then(l=>c.slice(0,l))}$write(o,h,i,r){const t=this.l(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,r.buffer,0,r.byteLength))}l(o){const h=this.c.get(o);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$Lpc=n}),define(Ie[284],Pe([1,0,6,42,2,5,8,7,30,48]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,A=Ve(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,s,o,h,i){this.a=Math.random(),this.b=new v.$ne,this.c=new v.$ne,this.d=new v.$ne,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,I.$Ak)(h),t=typeof h=="string",c=i?.correlate,l=o(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(c&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const m of g.created){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const m of g.changed){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const m of g.deleted){const $=C.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=T.$wN.from(this.i(d,s,h,i,i?.correlate),this.b,this.c,this.d,l)}i(d,n,s,o,h){const i=T.$wN.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const r=d.getProxy(N.$uN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(I.$wk)||s.pattern.includes(I.$xk))&&(t=!0);let c;return h&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(c=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,o?.ignoreChangeEvents&&(c&=~p.FileChangeFilter.UPDATED),o?.ignoreCreateEvents&&(c&=~p.FileChangeFilter.ADDED),o?.ignoreDeleteEvents&&(c&=~p.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,s.baseUri,{recursive:t,excludes:o?.excludes??[],filter:c},!!h),T.$wN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(C.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(C.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,n,s){this.j=d,this.k=n,this.l=s,this.a=new v.$ne,this.b=new v.$ne,this.c=new v.$ne,this.d=new v.$ne,this.g=new v.$pe,this.h=new v.$pe,this.i=new v.$pe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,s,o){return new R(this.j,d,n,this.a.event,A.GlobPattern.from(s),o)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,n){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(s=>C.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(s,o,h)=>{const i=function(t){s.call(o,t)};return i.extension=d,n.event(i,void 0,h)}}async $onWillRunFileOperation(d,n,s,o){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:n.map(h=>({oldUri:C.URI.revive(h.source),newUri:C.URI.revive(h.target)}))},s,o);case p.FileOperation.DELETE:return await this.n(this.i,{files:n.map(h=>C.URI.revive(h.target))},s,o);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:n.map(h=>C.URI.revive(h.target))},s,o)}}async n(d,n,s,o){const h=new Set,i=[];if(await d.fireAsync(n,o,async(t,c)=>{const l=Date.now(),g=await Promise.resolve(t);g instanceof T.$GN&&(i.push([c.extension,g]),h.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-l>s&&this.k.warn("SLOW file-participant",c.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:c}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(h)}}}e.$Mpc=u}),define(Ie[285],Pe([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,183,19,8,7,25,80,5]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,n=Ve(n),i=Ve(i),l=Ve(l);class g{constructor(j,U){this.d=j,this.e=U}async provideDocumentSymbols(j,U){const G=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(G,U);if(!(0,v.$Nb)(H))return H[0]instanceof r.$QN?H.map(i.DocumentSymbol.from):g.f(H)}static f(j){j=j.slice(0).sort((H,ne)=>{let fe=H.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(H.location.range.end)),fe});const U=[],G=[];for(const H of j){const ne={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ne),U.push(ne);break}const fe=G[G.length-1];if(E.$Mt.containsRange(fe.range,ne.range)&&!E.$Mt.equalsRange(fe.range,ne.range)){fe.children?.push(ne),G.push(ne);break}G.pop()}}return U}}class m{constructor(j,U,G,H,ne,fe){this.f=j,this.g=U,this.h=G,this.j=H,this.k=ne,this.l=fe,this.d=new c.$noc("CodeLens"),this.e=new Map}async provideCodeLenses(j,U){const G=this.f.getDocument(j),H=await this.h.provideCodeLenses(G,U);if(!H||U.isCancellationRequested)return;const ne=this.d.add(H),fe=new T.$Wc;this.e.set(ne,fe);const Re={cacheId:ne,lenses:[]};for(let Ue=0;Ue<H.length;Ue++)Re.lenses.push({cacheId:[ne,Ue],range:i.Range.from(H[Ue].range),command:this.g.toInternal(H[Ue].command,fe)});return Re}async resolveCodeLens(j,U){const G=j.cacheId&&this.d.get(...j.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,U),H||(H=G),U.isCancellationRequested)return;const ne=j.cacheId&&this.e.get(j.cacheId[0]);if(ne){if(!H.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return j.command=this.g.toInternal(H.command,ne),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function $(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class D{constructor(j,U){this.d=j,this.e=U}async provideDefinition(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideDefinition(H,ne,G);return $(fe)}}class S{constructor(j,U){this.d=j,this.e=U}async provideDeclaration(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideDeclaration(H,ne,G);return $(fe)}}class b{constructor(j,U){this.d=j,this.e=U}async provideImplementation(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideImplementation(H,ne,G);return $(fe)}}class k{constructor(j,U){this.d=j,this.e=U}async provideTypeDefinition(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideTypeDefinition(H,ne,G);return $(fe)}}class P{static{this.f=10}constructor(j,U){this.g=j,this.h=U,this.d=0,this.e=new Map}async provideHover(j,U,G,H){const ne=this.g.getDocument(j),fe=i.Position.to(U);let Re;if(G&&G.verbosityRequest){const tt=G.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:G.verbosityRequest.verbosityDelta,previousHover:nt};Re=await this.h.provideHover(ne,fe,H,et)}else Re=await this.h.provideHover(ne,fe,H);if(!Re||(0,v.$Nb)(Re.contents))return;Re.range||(Re.range=ne.getWordRangeAtPosition(fe)),Re.range||(Re.range=new r.$yN(fe,fe));const Ue=i.Hover.from(Re),Ke=this.d;if(this.e.size===P.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Re),this.d+=1,{...Ue,id:Ke}}releaseHover(j){this.e.delete(j)}}class f{constructor(j,U){this.d=j,this.e=U}async provideEvaluatableExpression(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideEvaluatableExpression(H,ne,G);if(fe)return i.EvaluatableExpression.from(fe)}}class w{constructor(j,U){this.d=j,this.e=U}async provideInlineValues(j,U,G,H){const ne=this.d.getDocument(j),fe=await this.e.provideInlineValues(ne,i.Range.to(U),i.InlineValueContext.to(G),H);if(Array.isArray(fe))return fe.map(Re=>i.InlineValue.from(Re))}}class F{constructor(j,U){this.d=j,this.e=U}async provideDocumentHighlights(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideDocumentHighlights(H,ne,G);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class O{constructor(j,U){this.d=j,this.e=U}async provideMultiDocumentHighlights(j,U,G,H){const ne=this.d.getDocument(j),fe=G.map(Ke=>this.d.getDocument(Ke)),Re=i.Position.to(U),Ue=await this.e.provideMultiDocumentHighlights(ne,Re,fe,H);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(j,U){this.d=j,this.e=U}async provideLinkedEditingRanges(j,U,G){const H=this.d.getDocument(j),ne=i.Position.to(U),fe=await this.e.provideLinkedEditingRanges(H,ne,G);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,v.$Kb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class q{constructor(j,U){this.d=j,this.e=U}async provideReferences(j,U,G,H){const ne=this.d.getDocument(j),fe=i.Position.to(U),Re=await this.e.provideReferences(ne,fe,G,H);if(Array.isArray(Re))return Re.map(i.location.from)}}class W{static{this.d=1e3}constructor(j,U,G,H,ne,fe,Re){this.g=j,this.h=U,this.j=G,this.k=H,this.l=ne,this.m=fe,this.n=Re,this.e=new c.$noc("CodeAction"),this.f=new Map}async provideCodeActions(j,U,G,H){const ne=this.g.getDocument(j),fe=d.$Ot.isISelection(U)?i.Selection.to(U):i.Range.to(U),Re=[];for(const et of this.j.getDiagnostics(j))if(fe.intersection(et.range)&&Re.push(et)>W.d)break;const Ue={diagnostics:Re,only:G.only?new r.$SN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Ke=await this.k.provideCodeActions(ne,fe,Ue,H);if(!(0,v.$Ob)(Ke)||H.isCancellationRequested)return;const _e=this.e.add(Ke),tt=new T.$Wc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Ke.length;et++){const rt=Ke[et];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$6G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$6G)(this.m,"codeActionRanges")?(0,v.$Kb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(j,U){const[G,H]=j,ne=this.e.get(G,H);if(!ne||W.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,U)??ne;let Re;fe.edit&&(Re=i.WorkspaceEdit.from(fe.edit,void 0));let Ue;if(fe.command){const Ke=this.f.get(G);Ke&&(Ue=this.h.toInternal(fe.command,Ke))}return{edit:Re,command:Ue}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class M{constructor(j,U,G,H,ne){this.e=j,this.f=U,this.g=G,this.h=H,this.j=ne,this.d=new c.$noc("DocumentPasteEdit")}async prepareDocumentPaste(j,U,G,H){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(j),fe=U.map(Ke=>i.Range.to(Ke)),Re=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$bb});if(await this.g.prepareDocumentPaste(ne,fe,Re,H),H.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ke])=>!(Ke instanceof r.$mO));return i.DataTransfer.from(Ue)}async providePasteEdits(j,U,G,H,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(U),Ue=G.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolvePasteFileData(this.h,j,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Re,Ue,Ke,{only:ne.only?new r.$rO(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,U){const[G,H]=j,ne=this.d.get(G,H);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class Y{constructor(j,U){this.d=j,this.e=U}async provideDocumentFormattingEdits(j,U,G){const H=this.d.getDocument(j),ne=await this.e.provideDocumentFormattingEdits(H,U,G);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class Z{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeFormattingEdits(j,U,G,H){const ne=this.d.getDocument(j),fe=i.Range.to(U),Re=await this.e.provideDocumentRangeFormattingEdits(ne,fe,G,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,U,G,H){(0,y.$qg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(j),fe=U.map(i.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ne,fe,G,H);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}}class ge{constructor(j,U){this.d=j,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,U,G,H,ne){const fe=this.d.getDocument(j),Re=i.Position.to(U),Ue=await this.e.provideOnTypeFormattingEdits(fe,Re,G,H,ne);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class _{constructor(j,U){this.e=j,this.f=U,this.d=new c.$noc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,U){const G=await this.e.provideWorkspaceSymbols(j,U);if(!(0,v.$Ob)(G))return{symbols:[]};const H=this.d.add(G),ne={cacheId:H,symbols:[]};for(let fe=0;fe<G.length;fe++){const Re=G[fe];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Re),cacheId:[H,fe]})}return ne}async resolveWorkspaceSymbol(j,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const G=this.d.get(...j.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,U);return H&&(0,p.$ho)(j,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class me{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,U,G){this.d=j,this.e=U,this.f=G}async provideRenameEdits(j,U,G,H){const ne=this.d.getDocument(j),fe=i.Position.to(U);try{const Re=await this.e.provideRenameEdits(ne,fe,G,H);return Re?i.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=me.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(j,U,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),ne=i.Position.to(U);try{const fe=await this.e.prepareRename(H,ne,G);let Re,Ue;if(r.$yN.isRange(fe)?(Re=fe,Ue=H.getText(fe)):(0,y.$ig)(fe)&&(Re=fe.range,Ue=fe.placeholder),!Re||!Ue)return;if(Re.start.line>ne.line||Re.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Re),text:Ue}}catch(fe){const Re=me.g(fe);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(fe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(j,U,G){this.e=j,this.f=U,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,U,G,H){const ne=this.e.getDocument(j),fe=i.Range.to(U);try{const Re=se.d[G],Ue=await this.f.provideNewSymbolNames(ne,fe,Re,H);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Re){this.g.error(se.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ce{constructor(j,U){this.resultId=j,this.tokens=U}}class we{constructor(j,U){this.f=j,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,U,G){const H=this.f.getDocument(j),ne=U!==0?this.d.get(U):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ne.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ne&&this.d.delete(U),fe?(fe=we.h(fe),this.o(we.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return we.j(j)?we.k(j)?j:new r.$RO(new Uint32Array(j.data),j.resultId):we.l(j)?we.m(j)?j:new r.$TO(j.edits.map(U=>new r.$SO(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const U of j.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(j,U){if(!we.j(U)||!j||!j.tokens)return U;const G=j.tokens,H=G.length,ne=U.data,fe=ne.length;let Re=0;const Ue=Math.min(H,fe);for(;Re<Ue&&G[Re]===ne[Re];)Re++;if(Re===H&&Re===fe)return new r.$TO([],U.resultId);let Ke=0;const _e=Ue-Re;for(;Ke<_e&&G[H-Ke-1]===ne[fe-Ke-1];)Ke++;return new r.$TO([{start:Re,deleteCount:H-Re-Ke,data:ne.subarray(Re,fe-Ke)}],U.resultId)}o(j,U){if(we.j(j)){const G=this.e++;return this.d.set(G,new ce(j.resultId,j.data)),(0,s.$Gdb)({id:G,type:"full",data:j.data})}if(we.l(j)){const G=this.e++;return we.j(U)?this.d.set(G,new ce(U.resultId,U.data)):this.d.set(G,new ce(j.resultId)),(0,s.$Gdb)({id:G,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class oe{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeSemanticTokens(j,U,G){const H=this.d.getDocument(j),ne=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(U),G);return ne?this.f(ne):null}f(j){return(0,s.$Gdb)({id:0,type:"full",data:j.data})}}class Ce{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,U,G,H,ne){this.f=j,this.g=U,this.h=G,this.j=H,this.k=ne,this.d=new c.$noc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,U,G,H){const ne=this.f.getDocument(j),fe=i.Position.to(U),Re=ne.getWordRangeAtPosition(fe)||new r.$yN(fe,fe),Ue=Re.with({end:fe}),Ke=new a.$he,_e=await this.h.provideCompletionItems(ne,fe,H,i.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$6N(_e):_e,nt=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Wc;this.e.set(nt,et);const rt=[],ft={x:nt,[l.ISuggestResultDtoField.completions]:rt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Re),insert:i.Range.from(Ue)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ct=0;ct<tt.items.length;ct++){const st=tt.items[ct],ut=this.l(st,[nt,ct],Ue,Re);rt.push(ut)}return ft}async resolveCompletionItem(j,U){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...j);if(!G)return;const H=this.l(G,j),ne=await this.h.resolveCompletionItem(G,U);if(!ne)return;const fe=this.l(ne,j);return(H[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||H[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||H[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,p.$io)(H[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U,G,H){const ne=this.e.get(U[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(j.command,ne),Re={x:U,[l.ISuggestDataDtoField.label]:j.label,[l.ISuggestDataDtoField.kind]:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:j.detail,[l.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),[l.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[l.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[l.ISuggestDataDtoField.preselect]:j.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[l.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Re[l.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof r.$HN&&(Re[l.ISuggestDataDtoField.insertText]=j.insertText.value,Re[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return j.textEdit?Ue=j.textEdit.range:j.range&&(Ue=j.range),r.$yN.isRange(Ue)?Re[l.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!G?.isEqual(Ue.inserting)||!H?.isEqual(Ue.replacing))&&(Re[l.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Re}}class Le{async provideInlineCompletions(j,U,G,H){}async provideInlineEdits(j,U,G,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,U,G){}handlePartialAccept(j,U,G,H){}}class X extends Le{constructor(j,U,G,H){super(),this.f=j,this.g=U,this.h=G,this.j=H,this.d=new te,this.e=(0,t.$6G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$6G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,U,G,H){const ne=this.g.getDocument(j),fe=i.Position.to(U),Re=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Wc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Wc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(j,U,G,H){if(!this.h.provideInlineEdits)return;(0,t.$7G)(this.f,"inlineCompletionsAdditions");const ne=this.g.getDocument(j),fe=i.Range.to(U),Re=await this.h.provideInlineEdits(ne,fe,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind],userPrompt:G.userPrompt},H);if(!Re||H.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],_e=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Wc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Wc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,U,G){const H=this.d.get(j)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(j,U,G,H){const ne=this.d.get(j)?.items[U];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,G),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(H)))}}class V{async provideInlineEdits(j,U,G){const H=this.f.getDocument(j),ne=await this.g.provideInlineEdit(H,{triggerKind:this.e[U.triggerKind]},G);if(!ne||G.isCancellationRequested)return;let fe;const Re=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let Ue;ne.accepted&&(fe||(fe=new T.$Wc),Ue=this.h.toInternal(ne.accepted,fe));let Ke;return ne.rejected&&(fe||(fe=new T.$Wc),Ke=this.h.toInternal(ne.rejected,fe)),{pid:Re,text:ne.text,range:i.Range.from(ne.range),accepted:Ue,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,U,G,H){this.f=U,this.g=G,this.h=H,this.d=new te,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const U=this.e++;return this.d.set(U,j),U}disposeReferenceId(j){const U=this.d.get(j);return this.d.delete(j),U}get(j){return this.d.get(j)}}class ve{constructor(j,U){this.e=j,this.f=U,this.d=new c.$noc("SignatureHelp")}async provideSignatureHelp(j,U,G,H){const ne=this.e.getDocument(j),fe=i.Position.to(U),Re=this.g(G),Ue=await this.f.provideSignatureHelp(ne,fe,H,Re);if(Ue){const Ke=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Ke}}}g(j){let U;if(j.activeSignatureHelp){const G=i.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(U=H,U.activeSignature=G.activeSignature,U.activeParameter=G.activeParameter):U=G}return{...j,activeSignatureHelp:U}}releaseSignatureHelp(j){this.d.delete(j)}}class ue{constructor(j,U,G,H,ne){this.f=j,this.g=U,this.h=G,this.j=H,this.k=ne,this.d=new c.$noc("InlayHints"),this.e=new Map}async provideInlayHints(j,U,G){const H=this.f.getDocument(j),ne=i.Range.to(U),fe=await this.h.provideInlayHints(H,ne,G);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(G.isCancellationRequested)return;const Re=this.d.add(fe);this.e.set(Re,new T.$Wc);const Ue={hints:[],cacheId:Re};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ne)&&Ue.hints.push(this.m(fe[Ke],[Re,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),Ue}async resolveInlayHint(j,U){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.h.resolveInlayHint(G,U);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U){return j.label.length===0||Array.isArray(j.label)&&j.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(U&&!U.contains(j.position))}m(j,U){const G=this.e.get(U[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:U,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const ne=[];H.label=ne;for(const fe of j.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$IN.isLocation(fe.location)&&(Re.location=i.location.from(fe.location)),fe.command&&(Re.command=this.g.toInternal(fe.command,G)),ne.push(Re)}}return H}}class be{constructor(j,U){this.e=j,this.f=U,this.d=new c.$noc("DocumentLink")}async provideLinks(j,U){const G=this.e.getDocument(j),H=await this.f.provideDocumentLinks(G,U);if(!(!Array.isArray(H)||H.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(i.DocumentLink.from)};{const ne=this.d.add(H),fe={links:[],cacheId:ne};for(let Re=0;Re<H.length;Re++){if(!be.g(H[Re]))continue;const Ue=i.DocumentLink.from(H[Re]);Ue.cacheId=[ne,Re],fe.links.push(Ue)}return fe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,U){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.f.resolveDocumentLink(G,U);if(!(!H||!be.g(H)))return i.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class de{constructor(j,U){this.d=j,this.e=U}async provideColors(j,U){const G=this.d.getDocument(j),H=await this.e.provideDocumentColors(G,U);return Array.isArray(H)?H.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(j,U,G){const H=this.d.getDocument(j),ne=i.Range.to(U.range),fe=i.Color.to(U.color),Re=await this.e.provideColorPresentations(fe,{document:H,range:ne},G);if(Array.isArray(Re))return Re.map(i.ColorPresentation.from)}}class J{constructor(j,U){this.d=j,this.e=U}async provideFoldingRanges(j,U,G){const H=this.d.getDocument(j),ne=await this.e.provideFoldingRanges(H,U,G);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class x{constructor(j,U,G){this.d=j,this.e=U,this.f=G}async provideSelectionRanges(j,U,G){const H=this.d.getDocument(j),ne=U.map(i.Position.to),fe=await this.e.provideSelectionRanges(H,ne,G);if(!(0,v.$Ob)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ne.length;Ue++){const Ke=[];Re.push(Ke);let _e=ne[Ue],tt=fe[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Re}}class pe{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,G){const H=this.f.getDocument(j),ne=i.Position.to(U),fe=await this.g.prepareCallHierarchy(H,ne,G);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideCallsTo(j,U,G){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ne)return ne.map(fe=>({from:this.h(j,fe.from),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}async provideCallsFrom(j,U,G){const H=this.j(j,U);if(!H)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ne)return ne.map(fe=>({to:this.h(j,fe.to),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}releaseSession(j){this.e.delete(j)}h(j,U){const G=this.e.get(j),H=i.CallHierarchyItem.from(U,j,G.size.toString(36));return G.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class $e{constructor(j,U){this.f=j,this.g=U,this.d=new A.$6P(""),this.e=new Map}async prepareSession(j,U,G){const H=this.f.getDocument(j),ne=i.Position.to(U),fe=await this.g.prepareTypeHierarchy(H,ne,G);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideSupertypes(j,U,G){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(H,G);if(ne)return ne.map(fe=>this.h(j,fe))}async provideSubtypes(j,U,G){const H=this.j(j,U);if(!H)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(H,G);if(ne)return ne.map(fe=>this.h(j,fe))}releaseSession(j){this.e.delete(j)}h(j,U){const G=this.e.get(j),H=i.TypeHierarchyItem.from(U,j,G.size.toString(36));return G.set(H._itemId,U),H}j(j,U){return this.e.get(j)?.get(U)}}class Ne{constructor(j,U,G,H,ne){this.e=j,this.f=U,this.g=G,this.h=H,this.j=ne,this.d=new c.$noc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,U,G,H,ne){const fe=this.f.getDocument(U),Re=i.Position.to(G),Ue=i.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Re,Ue,ne);if(!Ke)return;const _e=(0,v.$5b)(Ke),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,U){const[G,H]=j,ne=this.d.get(G,H);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class ze{constructor(j,U){this.d=j,this.e=U}async provideMappedEdits(j,U,G,H){const ne=u.URI.revive(j),fe=this.d.getDocument(ne),Re=G.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,U,Ue,H);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(j,U){this.adapter=j,this.extension=U}}class Ae{static{this.d=0}constructor(j,U,G,H,ne,fe,Re,Ue){this.g=U,this.h=G,this.j=H,this.k=ne,this.l=fe,this.m=Re,this.n=Ue,this.f=new Map,this.e=j.getProxy(l.$uN.MainThreadLanguageFeatures)}o(j,U){return i.DocumentSelector.from(j,this.g,U)}p(j){return new r.$wN(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,U,G,H,ne,fe=!1){const Re=this.f.get(j);if(!Re||!(Re.adapter instanceof U))return H;const Ue=Date.now();fe||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ke=G(Re.adapter,Re.extension);return Promise.resolve(Ke).catch(_e=>{(0,N.$7)(_e)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Re.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),C.CancellationToken.isCancellationToken(ne)?(0,I.$vh)(Ke,ne):Ke}t(j,U){const G=this.q();return this.f.set(G,new ke(j,U)),G}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,U,G,H){const ne=this.t(new g(this.h,G),j),fe=H&&H.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ne,this.o(U,j),fe),this.p(ne)}$provideDocumentSymbols(j,U,G){return this.s(j,g,H=>H.provideDocumentSymbols(u.URI.revive(U),G),void 0,G)}registerCodeLensProvider(j,U,G){const H=this.q(),ne=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ke(new m(this.h,this.j.converter,G,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(U,j),ne);let fe=this.p(H);if(ne!==void 0){const Re=G.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ne));fe=r.$wN.from(fe,Re)}return fe}$provideCodeLenses(j,U,G){return this.s(j,m,H=>H.provideCodeLenses(u.URI.revive(U),G),void 0,G)}$resolveCodeLens(j,U,G){return this.s(j,m,H=>H.resolveCodeLens(U,G),void 0,void 0)}$releaseCodeLenses(j,U){this.s(j,m,G=>Promise.resolve(G.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(j,U,G){const H=this.t(new D(this.h,G),j);return this.e.$registerDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideDefinition(j,U,G,H){return this.s(j,D,ne=>ne.provideDefinition(u.URI.revive(U),G,H),[],H)}registerDeclarationProvider(j,U,G){const H=this.t(new S(this.h,G),j);return this.e.$registerDeclarationSupport(H,this.o(U,j)),this.p(H)}$provideDeclaration(j,U,G,H){return this.s(j,S,ne=>ne.provideDeclaration(u.URI.revive(U),G,H),[],H)}registerImplementationProvider(j,U,G){const H=this.t(new b(this.h,G),j);return this.e.$registerImplementationSupport(H,this.o(U,j)),this.p(H)}$provideImplementation(j,U,G,H){return this.s(j,b,ne=>ne.provideImplementation(u.URI.revive(U),G,H),[],H)}registerTypeDefinitionProvider(j,U,G){const H=this.t(new k(this.h,G),j);return this.e.$registerTypeDefinitionSupport(H,this.o(U,j)),this.p(H)}$provideTypeDefinition(j,U,G,H){return this.s(j,k,ne=>ne.provideTypeDefinition(u.URI.revive(U),G,H),[],H)}registerHoverProvider(j,U,G,H){const ne=this.t(new P(this.h,G),j);return this.e.$registerHoverProvider(ne,this.o(U,j)),this.p(ne)}$provideHover(j,U,G,H,ne){return this.s(j,P,fe=>fe.provideHover(u.URI.revive(U),G,H,ne),void 0,ne)}$releaseHover(j,U){this.s(j,P,G=>Promise.resolve(G.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(j,U,G,H){const ne=this.t(new f(this.h,G),j);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(U,j)),this.p(ne)}$provideEvaluatableExpression(j,U,G,H){return this.s(j,f,ne=>ne.provideEvaluatableExpression(u.URI.revive(U),G,H),void 0,H)}registerInlineValuesProvider(j,U,G,H){const ne=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new w(this.h,G),j);this.e.$registerInlineValuesProvider(fe,this.o(U,j),ne);let Re=this.p(fe);if(ne!==void 0){const Ue=G.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Re=r.$wN.from(Re,Ue)}return Re}$provideInlineValues(j,U,G,H,ne){return this.s(j,w,fe=>fe.provideInlineValues(u.URI.revive(U),G,H,ne),void 0,ne)}registerDocumentHighlightProvider(j,U,G){const H=this.t(new F(this.h,G),j);return this.e.$registerDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,U,G){const H=this.t(new O(this.h,G),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(U,j)),this.p(H)}$provideDocumentHighlights(j,U,G,H){return this.s(j,F,ne=>ne.provideDocumentHighlights(u.URI.revive(U),G,H),void 0,H)}$provideMultiDocumentHighlights(j,U,G,H,ne){return this.s(j,O,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(U),G,H.map(Re=>u.URI.revive(Re)),ne),void 0,ne)}registerLinkedEditingRangeProvider(j,U,G){const H=this.t(new L(this.h,G),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(U,j)),this.p(H)}$provideLinkedEditingRanges(j,U,G,H){return this.s(j,L,async ne=>{const fe=await ne.provideLinkedEditingRanges(u.URI.revive(U),G,H);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Ae.y(fe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,U,G){const H=this.t(new q(this.h,G),j);return this.e.$registerReferenceSupport(H,this.o(U,j)),this.p(H)}$provideReferences(j,U,G,H,ne){return this.s(j,q,fe=>fe.provideReferences(u.URI.revive(U),G,H,ne),void 0,ne)}registerCodeActionProvider(j,U,G,H){const ne=new T.$Wc,fe=this.t(new W(this.h,this.j.converter,this.k,G,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(fe,this.o(U,j),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ne)}))},Ae.u(j),Ae.w(j),!!G.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(j,U,G,H,ne){return this.s(j,W,fe=>fe.provideCodeActions(u.URI.revive(U),G,H,ne),void 0,ne)}$resolveCodeAction(j,U,G){return this.s(j,W,H=>H.resolveCodeAction(U,G),{},void 0)}$releaseCodeActions(j,U){this.s(j,W,G=>Promise.resolve(G.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(j,U,G){const H=this.t(new Y(this.h,G),j);return this.e.$registerDocumentFormattingSupport(H,this.o(U,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,U,G,H){return this.s(j,Y,ne=>ne.provideDocumentFormattingEdits(u.URI.revive(U),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,U,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ne=this.t(new Z(this.h,G),j);return this.e.$registerRangeFormattingSupport(ne,this.o(U,j),j.identifier,j.displayName||j.name,H),this.p(ne)}$provideDocumentRangeFormattingEdits(j,U,G,H,ne){return this.s(j,Z,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(U),G,H,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(j,U,G,H,ne){return this.s(j,Z,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(U),G,H,ne),void 0,ne)}registerOnTypeFormattingEditProvider(j,U,G,H){const ne=this.t(new ge(this.h,G),j);return this.e.$registerOnTypeFormattingSupport(ne,this.o(U,j),H,j.identifier),this.p(ne)}$provideOnTypeFormattingEdits(j,U,G,H,ne,fe){return this.s(j,ge,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(U),G,H,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(j,U){const G=this.t(new _(U,this.l),j);return this.e.$registerNavigateTypeSupport(G,typeof U.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(j,U,G){return this.s(j,_,H=>H.provideWorkspaceSymbols(U,G),{symbols:[]},G)}$resolveWorkspaceSymbol(j,U,G){return this.s(j,_,H=>H.resolveWorkspaceSymbol(U,G),void 0,void 0)}$releaseWorkspaceSymbols(j,U){this.s(j,_,G=>G.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(j,U,G){const H=this.t(new me(this.h,G,this.l),j);return this.e.$registerRenameSupport(H,this.o(U,j),me.supportsResolving(G)),this.p(H)}$provideRenameEdits(j,U,G,H,ne){return this.s(j,me,fe=>fe.provideRenameEdits(u.URI.revive(U),G,H,ne),void 0,ne)}$resolveRenameLocation(j,U,G,H){return this.s(j,me,ne=>ne.resolveRenameLocation(u.URI.revive(U),G,H),void 0,H)}registerNewSymbolNamesProvider(j,U,G){const H=this.t(new se(this.h,G,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(U,j)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,se,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,U,G,H,ne){return this.s(j,se,fe=>fe.provideNewSymbolNames(u.URI.revive(U),G,H,ne),void 0,ne)}registerDocumentSemanticTokensProvider(j,U,G,H){const ne=this.t(new we(this.h,G),j),fe=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(U,j),H,fe);let Re=this.p(ne);if(fe){const Ue=G.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Re=r.$wN.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(j,U,G,H){return this.s(j,we,ne=>ne.provideDocumentSemanticTokens(u.URI.revive(U),G,H),null,H)}$releaseDocumentSemanticTokens(j,U){this.s(j,we,G=>G.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,U,G,H){const ne=this.t(new oe(this.h,G),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(U,j),H),this.p(ne)}$provideDocumentRangeSemanticTokens(j,U,G,H){return this.s(j,oe,ne=>ne.provideDocumentRangeSemanticTokens(u.URI.revive(U),G,H),null,H)}registerCompletionItemProvider(j,U,G,H){const ne=this.t(new Ce(this.h,this.j.converter,G,this.m,j),j);return this.e.$registerCompletionsProvider(ne,this.o(U,j),H,Ce.supportsResolving(G),j.identifier),this.p(ne)}$provideCompletionItems(j,U,G,H,ne){return this.s(j,Ce,fe=>fe.provideCompletionItems(u.URI.revive(U),G,H,ne),void 0,ne)}$resolveCompletionItem(j,U,G){return this.s(j,Ce,H=>H.resolveCompletionItem(U,G),void 0,G)}$releaseCompletionItems(j,U){this.s(j,Ce,G=>G.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(j,U,G,H){const ne=new X(j,this.h,G,this.j.converter),fe=this.t(ne,j);return this.e.$registerInlineCompletionsSupport(fe,this.o(U,j),ne.supportsHandleEvents,h.$rn.toKey(j.identifier.value),H?.yieldTo?.map(Re=>h.$rn.toKey(Re))||[]),this.p(fe)}$provideInlineCompletions(j,U,G,H,ne){return this.s(j,Le,fe=>fe.provideInlineCompletions(u.URI.revive(U),G,H,ne),void 0,ne)}$provideInlineEdits(j,U,G,H,ne){return this.s(j,Le,fe=>fe.provideInlineEdits(u.URI.revive(U),G,H,ne),void 0,ne)}$handleInlineCompletionDidShow(j,U,G,H){this.s(j,Le,async ne=>{ne.handleDidShowCompletionItem(U,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,U,G,H,ne){this.s(j,Le,async fe=>{fe.handlePartialAccept(U,G,H,ne)},void 0,void 0)}$freeInlineCompletionsList(j,U){this.s(j,Le,async G=>{G.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(j,U,G){const H=new V(j,this.h,G,this.j.converter),ne=this.t(H,j);return this.e.$registerInlineEditProvider(ne,this.o(U,j),j.identifier),this.p(ne)}$provideInlineEdit(j,U,G,H){return this.s(j,V,ne=>ne.provideInlineEdits(u.URI.revive(U),G,H),void 0,H)}$freeInlineEdit(j,U){this.s(j,V,async G=>{G.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(j,U,G,H){const ne=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,fe=this.t(new ve(this.h,G),j);return this.e.$registerSignatureHelpProvider(fe,this.o(U,j),ne),this.p(fe)}$provideSignatureHelp(j,U,G,H,ne){return this.s(j,ve,fe=>fe.provideSignatureHelp(u.URI.revive(U),G,H,ne),void 0,ne)}$releaseSignatureHelp(j,U){this.s(j,ve,G=>G.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(j,U,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ue(this.h,this.j.converter,G,this.l,j),j);this.e.$registerInlayHintsProvider(ne,this.o(U,j),typeof G.resolveInlayHint=="function",H,Ae.u(j));let fe=this.p(ne);if(H!==void 0){const Re=G.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(H));fe=r.$wN.from(fe,Re)}return fe}$provideInlayHints(j,U,G,H){return this.s(j,ue,ne=>ne.provideInlayHints(u.URI.revive(U),G,H),void 0,H)}$resolveInlayHint(j,U,G){return this.s(j,ue,H=>H.resolveInlayHint(U,G),void 0,G)}$releaseInlayHints(j,U){this.s(j,ue,G=>G.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(j,U,G){const H=this.t(new be(this.h,G),j);return this.e.$registerDocumentLinkProvider(H,this.o(U,j),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,U,G){return this.s(j,be,H=>H.provideLinks(u.URI.revive(U),G),void 0,G,U.scheme==="output")}$resolveDocumentLink(j,U,G){return this.s(j,be,H=>H.resolveLink(U,G),void 0,void 0,!0)}$releaseDocumentLinks(j,U){this.s(j,be,G=>G.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(j,U,G){const H=this.t(new de(this.h,G),j);return this.e.$registerDocumentColorProvider(H,this.o(U,j)),this.p(H)}$provideDocumentColors(j,U,G){return this.s(j,de,H=>H.provideColors(u.URI.revive(U),G),[],G)}$provideColorPresentations(j,U,G,H){return this.s(j,de,ne=>ne.provideColorPresentations(u.URI.revive(U),G,H),void 0,H)}registerFoldingRangeProvider(j,U,G){const H=this.q(),ne=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ke(new J(this.h,G),j)),this.e.$registerFoldingRangeProvider(H,this.o(U,j),j.identifier,ne);let fe=this.p(H);if(ne!==void 0){const Re=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=r.$wN.from(fe,Re)}return fe}$provideFoldingRanges(j,U,G,H){return this.s(j,J,ne=>ne.provideFoldingRanges(u.URI.revive(U),G,H),void 0,H)}registerSelectionRangeProvider(j,U,G){const H=this.t(new x(this.h,G,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(U,j)),this.p(H)}$provideSelectionRanges(j,U,G,H){return this.s(j,x,ne=>ne.provideSelectionRanges(u.URI.revive(U),G,H),[],H)}registerCallHierarchyProvider(j,U,G){const H=this.t(new pe(this.h,G),j);return this.e.$registerCallHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareCallHierarchy(j,U,G,H){return this.s(j,pe,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(U),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,U,G,H){return this.s(j,pe,ne=>ne.provideCallsTo(U,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,U,G,H){return this.s(j,pe,ne=>ne.provideCallsFrom(U,G,H),void 0,H)}$releaseCallHierarchy(j,U){this.s(j,pe,G=>Promise.resolve(G.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(j,U,G){const H=this.t(new $e(this.h,G),j);return this.e.$registerTypeHierarchyProvider(H,this.o(U,j)),this.p(H)}$prepareTypeHierarchy(j,U,G,H){return this.s(j,$e,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(U),G,H)),void 0,H)}$provideTypeHierarchySupertypes(j,U,G,H){return this.s(j,$e,ne=>ne.provideSupertypes(U,G,H),void 0,H)}$provideTypeHierarchySubtypes(j,U,G,H){return this.s(j,$e,ne=>ne.provideSubtypes(U,G,H),void 0,H)}$releaseTypeHierarchy(j,U){this.s(j,$e,G=>Promise.resolve(G.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(j,U,G,H){const ne=this.q();return this.f.set(ne,new ke(new Ne(this.e,this.h,G,ne,j),j)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(U,j),(0,t.$6G)(j,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(j,U,G,H,ne,fe){return this.s(j,Ne,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(U,u.URI.revive(G),H,ne,fe)),void 0,void 0)}$resolveDropEdit(j,U,G){return this.s(j,Ne,H=>H.resolveDropEdit(U,G),{},void 0)}$releaseDocumentOnDropEdits(j,U){this.s(j,Ne,G=>Promise.resolve(G.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(j,U,G){const H=this.t(new ze(this.h,G),j);return this.e.$registerMappedEditsProvider(H,this.o(U,j)),this.p(H)}$provideMappedEdits(j,U,G,H,ne){return this.s(j,ze,fe=>Promise.resolve(fe.provideMappedEdits(U,G,H,ne)),null,ne)}registerDocumentPasteEditProvider(j,U,G,H){const ne=this.q();return this.f.set(ne,new ke(new M(this.e,this.h,G,ne,j),j)),this.e.$registerPasteEditProvider(ne,this.o(U,j),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(j,U,G,H,ne){return this.s(j,M,fe=>fe.prepareDocumentPaste(u.URI.revive(U),G,H,ne),void 0,ne)}$providePasteEdits(j,U,G,H,ne,fe,Re){return this.s(j,M,Ue=>Ue.providePasteEdits(U,u.URI.revive(G),H,ne,fe,Re),void 0,Re)}$resolvePasteEdit(j,U,G){return this.s(j,M,H=>H.resolvePasteEdit(U,G),{},void 0)}$releasePasteEdits(j,U){this.s(j,M,G=>Promise.resolve(G.releasePasteEdits(U)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Ae.y(j.decreaseIndentPattern),increaseIndentPattern:Ae.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Ae.y(j.beforeText),afterText:j.afterText?Ae.y(j.afterText):void 0,previousLineText:j.previousLineText?Ae.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Ae.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(U=>r.SyntaxTokenType.toString(U)):void 0}}static E(j){return j.map(Ae.D)}setLanguageConfiguration(j,U,G){const{wordPattern:H}=G;if(H&&(0,R.$tf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(U,H):this.h.setWordDefinitionFor(U,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ne=this.q(),fe={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.y(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,U,fe),this.p(ne)}$setWordDefinitions(j){for(const U of j)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$xoc=Ae}),define(Ie[286],Pe([1,0,4,5,8]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,C=Ve(C);class N{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(I.$uN.MainThreadLanguageModelTools),this.b.$getTools().then(p=>{for(const a of p)this.c.set(a.name,a)})}async invokeTool(T,p,a){return await this.b.$invokeTool(T,p,a)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>C.LanguageModelToolDescription.to(T))}async $invokeTool(T,p,a){const R=this.a.get(T);if(!R)throw new Error(`Unknown tool ${T}`);return await R.tool.invoke(p,a)}registerTool(T,p,a){return this.a.set(p,{extension:T,tool:a}),this.b.$registerTool(p),(0,v.$Vc)(()=>{this.a.delete(p),this.b.$unregisterTool(p)})}}e.$2pc=N}),define(Ie[95],Pe([1,0,11,22,41,14,6,40,4,184,19,3,12,77,5,91,17,8,7,117,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0,o=Ve(o),h=Ve(h),e.$epc=(0,y.$Gi)("IExtHostLanguageModels");class c{constructor($,D){this.option=$,this.stream=new v.$0h,this.stream=D??new v.$0h}}class l{constructor(){this.a=new Map,this.b=new v.$0h,this.c=!1;const $=this;this.apiObject={get stream(){return $.b.asyncIterable},get text(){return v.$7h.map($.b.asyncIterable,D=>{if(D instanceof h.$KP)return D.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;let D=this.a.get($.index);D||(this.a.size===0?D=new c($.index,this.b):D=new c($.index),this.a.set($.index,D));let S;$.part.type==="text"?S=new h.$KP($.part.value):S=new h.$JP($.part.name,$.part.parameters),D.stream.emitOne(S)}reject($){this.c=!0;for(const D of this.d())D.reject($)}resolve(){this.c=!0;for(const $ of this.d())$.resolve()}}let g=class{static{t=this}static{this.a=1}constructor($,D,S){this.j=D,this.k=S,this.c=new A.$ne,this.d=new A.$ne,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new R.$tn,this.i=new Map,this.s=new Set,this.b=$.getProxy(d.$uN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,D,S,b){const k=t.a++;this.f.set(k,{extension:$.identifier,provider:S,languageModelId:D});let P;b.auth&&(P={providerLabel:$.displayName||$.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${R.$rn.toKey($.identifier)}/${k}/${D}`,{extension:$.identifier,id:D,vendor:b.vendor??R.$rn.toKey($.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:P,targetExtensions:b.extensions});const f=S.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:F,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(D,new R.$rn(w),F,O)});return(0,p.$Vc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),f?.dispose()})}async $startChatRequest($,D,S,b,k,P){const f=this.f.get($);if(!f)throw new Error("Provider not found");const w=new E.$ww(async O=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(O.part instanceof h.$JP?L={type:"function_use",name:O.part.name,parameters:O.part.parameters}:O.part instanceof h.$KP&&(L={type:"text",value:O.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(O)}`);return}this.b.$reportResponsePart(D,{index:O.index,part:L})});let F;if(f.provider.provideLanguageModelResponse2)F=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(o.LanguageModelChatMessage.to),k,R.$rn.toKey(S),w,P));else{const O=new E.$ww(async L=>{w.report({index:L.index,part:new h.$KP(L.part)})});F=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(o.LanguageModelChatMessage.to),k?.modelOptions??{},R.$rn.toKey(S),O,P))}F.then(()=>{this.b.$reportResponseDone(D,void 0)},O=>{this.b.$reportResponseDone(D,(0,N.$5)(O))})}$provideTokenLength($,D,S){const b=this.f.get($);return b?Promise.resolve(b.provider.provideTokenCount(D,S)):Promise.resolve(0)}$acceptChatModelMetadata($){if($.added)for(const{identifier:D,metadata:S}of $.added)this.g.set(D,{metadata:S,apiObjects:new R.$tn});if($.removed)for(const D of $.removed){this.g.delete(D);for(const[S,b]of this.i)b.languageModelId===D&&(b.res.reject(new N.$8),this.i.delete(S))}$.added?.forEach(D=>this.q(D.metadata)),this.d.fire(void 0)}async selectLanguageModels($,D){const S=await this.b.$selectChatModels({...D,extension:$.identifier}),b=[],k=this;for(const P of S){const f=this.g.get(P);if(!f)continue;this.o($.identifier,f.metadata)&&await this.q(f.metadata);let w=f.apiObjects.get($.identifier);w||(w={id:P,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(F,O){if(!k.g.has(P))throw h.$OP.NotFound(P);return k.r(P,F,O??I.CancellationToken.None)},sendRequest(F,O,L){if(!k.g.has(P))throw h.$OP.NotFound(P);return k.l($,P,F,O??{},L??I.CancellationToken.None)}},Object.freeze(w),f.apiObjects.set($.identifier,w)),b.push(w)}return b}async l($,D,S,b,k){const P=this.m($,S),f=$.identifier,w=this.g.get(D)?.metadata;if(!w||!this.g.has(D))throw h.$OP.NotFound(`Language model '${D}' is unknown.`);if(this.o(f,w)&&(!await this.n($,{identifier:w.extension,displayName:w.auth.providerLabel},b.justification,!1)||!this.h.get(f)?.has(w.extension)))throw h.$OP.NoPermissions(`Language model '${D}' cannot be used by '${f.value}'.`);try{const F=Math.random()*1e6|0,O=new l;this.i.set(F,{languageModelId:D,res:O});try{await this.b.$tryStartChatRequest(f,D,F,P,b,k)}catch(L){throw this.i.delete(F),L}return O.apiObject}catch(F){throw F.name===h.$OP.name?F:new h.$OP(`Language model '${D}' errored: ${(0,C.$rj)(F)}`,"Unknown",F)}}m($,D){const S=[];for(const b of D)b.role===h.LanguageModelChatMessageRole.System&&(0,r.$7G)($,"languageModelSystem"),b.content2 instanceof h.$HP&&(0,r.$7G)($,"lmTools"),S.push(o.LanguageModelChatMessage.from(b));return S}async $acceptResponsePart($,D){const S=this.i.get($);S&&S.res.handleFragment(D)}async $acceptResponseDone($,D){const S=this.i.get($);S&&(this.i.delete($),D?S.res.reject((0,N.$6)(D)):S.res.resolve())}async n($,D,S,b){const k=i.$wM+D.identifier.value;if(await this.k.getSession($,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:D.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=S?(0,a.localize)(0,null,D.displayName,S):void 0;return await this.k.getSession($,k,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:$.identifier,to:D.identifier,enabled:!0}]),!0}catch{return!1}}o($,D){return!!D.auth&&!R.$rn.equals(D.extension,$)}async q($){if($.auth)for(const D of this.s)try{await this.n(D,{identifier:$.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async r($,D,S){if(!this.g.get($))throw h.$OP.NotFound(`Language model '${$}' is unknown.`);const k=T.Iterable.find(this.f.values(),P=>P.languageModelId===$);return k?k.provider.provideTokenCount(D,S):this.b.$countTokens($,typeof D=="string"?D:o.LanguageModelChatMessage.from(D),S)}$updateModelAccesslist($){const D=new Array;for(const{from:S,to:b,enabled:k}of $){const P=this.h.get(S)??new R.$sn;if(P.has(b)!==k){k?P.add(b):P.delete(b),this.h.set(S,P);const w={from:S,to:b};D.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation($){this.s.add($);const D=this,S=A.Event.signal(A.Event.filter(this.c.event,k=>R.$rn.equals(k.from,$.identifier))),b=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(S,b)},canSendRequest(k){let P;e:for(const[w,F]of D.g)for(const O of F.apiObjects.values())if(O===k){P=F.metadata;break e}if(!P)return;if(!D.o($.identifier,P))return!0;const f=D.h.get($.identifier);if(f)return f.has(P.extension)}}}};e.$fpc=g,e.$fpc=g=t=He([qe(0,s.$1P),qe(1,u.$ak),qe(2,n.$zoc)],g)});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[287],Pe([1,0,5,8,7,36,11,4,25]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0,I=Ve(I),N=_t(N);class a{constructor(y,u,E,d){this.c=u,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$uN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const E=this.c.getDocumentData(y);if(!E)throw new Error(`document '${y.toString()}' NOT found`);return E.document}async tokenAtPosition(y,u){const E=y.version,d=I.Position.from(u),n=await this.a.$tokensAtPosition(y.uri,d),s={type:C.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new C.$yN(u.line,u.character,u.line,u.character)};if(!n)return s;const o={range:I.Range.to(n.range),type:I.TokenType.to(n.type)};return!o.range.contains(u)||E!==y.version?s:o}createLanguageStatusItem(y,u,E){const d=this.f++,n=this.a,s=this.g,o=`${y.identifier.value}/${u}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);s.add(o);const h={selector:E,id:u,name:y.displayName??y.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Wc,t=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Ih)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:o,name:h.name??y.displayName??y.name,source:y.displayName??y.name,selector:I.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===C.LanguageStatusSeverity.Error?N.default.Error:h.severity===C.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:h.command&&this.d.toInternal(h.command,r),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},c={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),s.delete(o)},get id(){return h.id},get name(){return h.name},set name(l){h.name=l,t()},get selector(){return h.selector},set selector(l){h.selector=l,t()},get text(){return h.text},set text(l){h.text=l,t()},set text2(l){(0,p.$7G)(y,"languageStatusText"),h.text=l,t()},get text2(){return(0,p.$7G)(y,"languageStatusText"),h.text},get detail(){return h.detail},set detail(l){h.detail=l,t()},get severity(){return h.severity},set severity(l){h.severity=l,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(l){h.accessibilityInformation=l,t()},get command(){return h.command},set command(l){h.command=l,t()},get busy(){return h.busy},set busy(l){h.busy=l,t()}};return t(),c}}e.$3pc=a}),define(Ie[288],Pe([1,0,16,2,8,7,90]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0,C=Ve(C),A=Ve(A);class T{constructor(y,u,E,d){this.start=y,this.deletedCount=u,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new N.$YO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,E){this.notebook=y,this.h=u,this.j=E,this.handle=E.handle,this.uri=I.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(C.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(E)}return this.f}setOutputs(y){this.a=y.map(C.NotebookCellOutput.to)}setOutputItems(y,u,E){const d=E.map(C.NotebookCellOutputItem.to),n=this.a.find(s=>s.id===y);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(s=>A.$zL(s.mime)))){const s=new Map,o=[];n.items.forEach(h=>{let i;s.has(h.mime)?i=s.get(h.mime):(i=[],s.set(h.mime,i),o.push(h.mime)),i.push(h.data)}),n.items.length=0,o.forEach(h=>{const i=A.$AL(s.get(h));n.items.push({mime:h,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Npc=p;class a{static{this.a=0}constructor(y,u,E,d,n){this.k=y,this.l=u,this.m=E,this.uri=d,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(E){return E=y.n(E),y.b[E].apiCell},getCells(E){return(E?y.p(E):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,E){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},n=[];for(const o of y.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,d.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,d.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),n.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),n.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<n.length;o++){const h=n[o],i=s.get(h.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});s.set(h.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,E=y.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),y.with({start:u,end:E})}p(y){y=this.o(y);const u=[];for(let E=y.start;E<y.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,E){if(this.j)return;const d=[],n=[],s=[];if(y.reverse().forEach(o=>{const i=o[2].map(c=>{const l=new p(this,this.l,c);return u||n.push(p.asModelAddData(c)),l}),r=new T(o[0],o[1],[],i),t=this.b.splice(o[0],o[1],...i);for(const c of t)s.push(c.uri),r.deletedItems.push(c.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:s}),E)for(const o of d)E.push(o.asApiEvent())}s(y,u,E,d){const n=this.b.splice(y,u);this.b.splice(E,0,...n);const s=[new T(y,u,n.map(o=>o.apiCell),[]),new T(E,0,[],n)];for(const o of s)d.push(o.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,E,d){this.b[y].setOutputItems(u,E,d)}v(y,u){const E=this.b[y];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(y,u){const E=this.b[y];E.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Opc=a}),define(Ie[289],Pe([1,0,6,2,8,7,39]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0;class T{constructor(a,R,y,u={timeout:1500,errors:3}){this.b=a,this.c=R,this.d=y,this.f=u,this.a=new v.$pe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(R,y,u)=>{const E=function(n){R.call(y,n)};return E.extension=a,this.a.event(E,void 0,u)}}async $participateInSave(a,R,y){const u=I.URI.revive(a),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:C.TextDocumentSaveReason.to(R)},y,async(s,o)=>{const h=Date.now(),i=await await Promise.resolve(s);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof N.$GN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const s of d){const{edits:o}=C.WorkspaceEdit.from(s);n.edits=n.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Uw(n))}}e.$5pc=T}),define(Ie[124],Pe([1,0,14,8,7]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,I=Ve(I),C=Ve(C);class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,a,R,y,u){this.id=T,this.f=p,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(C.$YO.isNotebookRange))throw(0,v.$0)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,a){T.f.$tryRevealRange(T.id,I.NotebookRange.from(p),a??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(I.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Ppc=N}),define(Ie[290],Pe([1,0,6,12,8]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,C=Ve(C);let N=class{constructor(T,p){this.c=T,this.d=p,this.a=new v.$ne,this.b=new v.$ne,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const a=this.d.getEditorById(T);p.visibleRanges&&a._acceptVisibleRanges(p.visibleRanges.ranges.map(C.NotebookRange.to)),p.selections&&a._acceptSelections(p.selections.selections.map(C.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(C.ViewColumn.to(T[p]))}};e.$7pc=N,e.$7pc=N=He([qe(0,I.$ak)],N)}),define(Ie[291],Pe([1,0,6,5,124]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0;class N{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(I.$uN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,a){const R=this.c.getEditorById(T);this.a.get(p)?.fire({editor:R.apiEditor,message:a})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,y,u)=>this.d(p).event(R,y,u),postMessage:(R,y)=>{C.$Ppc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const u=y&&C.$Ppc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,p,R)}}}d(T){let p=this.a.get(T);return p||(p=new v.$ne({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$0pc=N}),define(Ie[292],Pe([1,0,8,77,22,72,14]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,E){const d=this.b++,{title:n,location:s,cancellable:o}=u,h={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(s),title:n,source:h,cancellable:o},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$4),this.d(d,E,!!o)}d(y,u,E){let d;E&&(d=new C.$ye,this.c.set(y,d));const n=o=>{this.a.$progressEnd(o),this.c.delete(o),d?.dispose()};let s;try{s=u(new a(this.a,y),E&&d?d.token:C.CancellationToken.None)}catch(o){throw n(y),o}return s.then(o=>n(y),o=>n(y)),s}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$bqc=T;function p(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class a extends I.$ww{constructor(y,u){super(E=>this.throttledReport(E)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}He([(0,N.$ai)(100,(R,y)=>p(R,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ie[293],Pe([1,0,2,5,11,8]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0;class A{static{this.a=0}constructor(p,a){this.d=a,this.c=new Map,this.b=p.getProxy(I.$uN.MainThreadQuickDiff)}$provideOriginalResource(p,a,R){const y=v.URI.revive(a),u=this.c.get(p);return u?(0,C.$yh)(()=>u.provideOriginalResource(y,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,a,R,y){const u=A.a++;return this.c.set(u,a),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(p,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$cqc=A});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[294],Pe([1,0,22,6,4,5,2,7,14,18,36,35,25,8]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=d,R=_t(R);function d(n,s,o){const h=n.getProxy(N.$uN.MainThreadQuickOpen);class i{constructor(S,b){this.e=new Map,this.f=0,this.a=S,this.b=b}showQuickPick(S,b,k,P=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(b),w=++this.f,F=h.$show(w,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},P),O={},L=F.then(()=>O);return Promise.race([L,f]).then(q=>{if(q===O)return;const W=(0,u.$6G)(S,"quickPickItemTooltip");return f.then(M=>{const Y=[];for(let Z=0;Z<M.length;Z++){const ge=M[Z];if(typeof ge=="string")Y.push({label:ge,handle:Z});else if(ge.kind===T.QuickPickItemKind.Separator)Y.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const _=ge.iconPath?g(ge.iconPath):void 0;Y.push({label:ge.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?E.MarkdownString.fromStrict(ge.tooltip):void 0,handle:Z})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=Z=>{k.onDidSelectItem(M[Z])}),h.$setItems(w,Y),F.then(Z=>{if(typeof Z=="number")return M[Z];if(Array.isArray(Z))return Z.map(ge=>M[ge])})})}).then(void 0,q=>{if(!(0,p.$7)(q))return h.$setError(w,q),Promise.reject(q)})}$onItemSelected(S){this.c?.(S)}showInput(S,b=v.CancellationToken.None){return this.d=S?.validateInput,h.$input(S,typeof this.d=="function",b).then(void 0,k=>{if(!(0,p.$7)(k))return Promise.reject(k)})}async $validateInput(S){if(!this.d)return;const b=await this.d(S);if(!b||typeof b=="string")return b;let k;switch(b.severity){case T.InputBoxValidationSeverity.Info:k=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=R.default.Error;break;default:k=b.message?R.default.Error:R.default.Ignore;break}return{content:b.message,severity:k}}async showWorkspaceFolderPick(S,b=v.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!k)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(f=>f.uri.toString()===k.uri.toString())}createQuickPick(S){const b=new m(S,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(S){const b=new $(S,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(S,b){this.e.get(S)?._fireDidChangeValue(b)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,b){const k=this.e.get(S);k instanceof m&&k._fireDidChangeActive(b)}$onDidChangeSelection(S,b){const k=this.e.get(S);k instanceof m&&k._fireDidChangeSelection(b)}$onDidTriggerButton(S,b){this.e.get(S)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(S,b,k){const P=this.e.get(S);P instanceof m&&P._fireDidTriggerItemButton(b,k)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class r{static{this.a=1}constructor(S,b){this.x=S,this.y=b,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new I.$ne,this.q=new I.$ne,this.r=new I.$ne,this.s=new I.$ne,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((b,k)=>{const P=b===T.$VO.Back?-1:k;this.o.set(P,b)}),this.z({buttons:S.map((b,k)=>({...g(b.iconPath),tooltip:b.tooltip,handle:b===T.$VO.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const b=this.o.get(S);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(S){if(!this.v){for(const b of Object.keys(S)){const k=S[b];this.u[b]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function t(D){if(D instanceof T.$tO)return{id:D.id};const S=l(D),b=c(D);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof b=="string"?A.URI.file(b):b}}function c(D){return typeof D=="object"&&"light"in D?D.light:D}function l(D){return typeof D=="object"&&"dark"in D?D.dark:D}function g(D){const S=t(D);let b,k;return"id"in S?k=y.ThemeIcon.asClassName(S):b=S,{iconPath:b,iconClass:k}}class m extends r{constructor(S,b){super(S.identifier,b),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new I.$ne,this.L=[],this.M=new I.$ne,this.N=new I.$ne,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((P,f)=>{this.C.set(f,P),this.D.set(P,f)});const b=(0,u.$6G)(this.O,"quickPickItemTooltip"),k=[];for(let P=0;P<S.length;P++){const f=S[P];if(f.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const w=f.iconPath?g(f.iconPath):void 0;k.push({handle:P,label:f.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?E.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((F,O)=>({...g(F.iconPath),tooltip:F.tooltip,handle:O}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(S){const b=(0,a.$Kb)(S.map(k=>this.C.get(k)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(S){const b=(0,a.$Kb)(S.map(k=>this.C.get(k)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(S,b){const k=this.C.get(S);if(!k||!k.buttons||!k.buttons.length)return;const P=k.buttons[b];P&&this.N.fire({button:P,item:k})}}class $ extends r{constructor(S,b){super(S.identifier,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(s,o)}}),define(Ie[295],Pe([1,0,2,6,72,4,11,5,18,160,12,19,38,35,8,25,16,21]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=void 0;function i(O){return O instanceof v.URI}function r(O,L){return O.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&o.$k?O.toString()===L.toString():O.toString().toLowerCase()===L.toString().toLowerCase()}function t(O){if(O)return typeof O.iconPath=="string"?v.URI.file(O.iconPath):v.URI.isUri(O.iconPath)||E.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function c(O){if(O){if(v.URI.isUri(O))return O;if(E.ThemeIcon.isThemeIcon(O))return O;{const L=O;return{light:L.light,dark:L.dark}}}else return}function l(O){const L=c(O.icon),q=O.labels?.map(W=>({title:W.title,icon:c(W.icon)}));return{...O,icon:L,labels:q}}function g(O,L){if(!O.iconPath&&!L.iconPath)return 0;if(O.iconPath){if(!L.iconPath)return 1}else return-1;const q=typeof O.iconPath=="string"?O.iconPath:v.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,W=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,a.$Ir)(q,W)}function m(O,L){let q=0;if(O.strikeThrough!==L.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==L.faded)return O.faded?1:-1;if(O.tooltip!==L.tooltip)return(O.tooltip||"").localeCompare(L.tooltip||"");if(q=g(O,L),q!==0)return q;if(O.light&&L.light)q=g(O.light,L.light);else{if(O.light)return 1;if(L.light)return-1}if(q!==0)return q;if(O.dark&&L.dark)q=g(O.dark,L.dark);else{if(O.dark)return 1;if(L.dark)return-1}return q}function $(O,L){if(O.command!==L.command)return O.command<L.command?-1:1;if(O.title!==L.title)return O.title<L.title?-1:1;if(O.tooltip!==L.tooltip){if(O.tooltip!==void 0&&L.tooltip!==void 0)return O.tooltip<L.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(O.arguments===L.arguments)return 0;if(O.arguments)if(L.arguments){if(O.arguments.length!==L.arguments.length)return O.arguments.length-L.arguments.length}else return 1;else return-1;for(let q=0;q<O.arguments.length;q++){const W=O.arguments[q],M=L.arguments[q];if(W!==M&&!(i(W)&&i(M)&&r(W,M)))return W<M?-1:1}return 0}function D(O,L){let q=(0,a.$Ir)(O.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(q!==0)return q;if(O.command&&L.command)q=$(O.command,L.command);else{if(O.command)return 1;if(L.command)return-1}if(q!==0)return q;if(O.decorations&&L.decorations)q=m(O.decorations,L.decorations);else{if(O.decorations)return 1;if(L.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)q=(0,a.$Ir)(O.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)q=(0,a.$Ir)(O.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return q}function S(O,L){for(let q=0;q<O.length;q++)if(O[q]!==L[q])return!1;return!0}function b(O,L){return O.command===L.command&&O.title===L.title&&O.tooltip===L.tooltip&&(O.arguments&&L.arguments?S(O.arguments,L.arguments):O.arguments===L.arguments)}function k(O,L){return(0,p.$xb)(O,L,b)}class P{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,n.$7G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,n.$7G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,n.$7G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,q,W,M,Y){this.k=L,this.m=M,this.n=Y,this.d="",this.e=new I.$ne,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=W}showValidationMessage(L,q){(0,n.$7G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,q)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$eqc=P;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,q,W,M,Y,Z,ge){this.s=L,this.t=q,this.u=W,this.v=M,this.w=Y,this.multiDiffEditorEnableViewChanges=Z,this.x=ge,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new I.$ne,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new I.$ne,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,q){const W=this.h.get(L);return W?(0,A.$yh)(()=>this.t.executeCommand(W.command,...W.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(D),W=(0,p.$Gb)(this.p,L,D).map(Z=>{const ge=Z.toInsert.map(_=>{const me=this.e++;this.g.set(me,_);const se=_.resourceUri;let ce;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const x=new N.$Wc;ce=this.t.converter.toInternal(_.command,x),this.j.set(me,x)}else this.h.set(me,_.command);const we=(0,n.$6G)(this.x,"scmMultiDiffEditor"),oe=we?_.multiDiffEditorOriginalUri:void 0,Ce=we?_.multiFileDiffEditorModifiedUri:void 0,Le=t(_.decorations),X=_.decorations&&t(_.decorations.light)||Le,V=_.decorations&&t(_.decorations.dark)||Le,te=[X,V],ve=_.decorations&&_.decorations.tooltip||"",ue=_.decorations&&!!_.decorations.strikeThrough,be=_.decorations&&!!_.decorations.faded,de=_.contextValue||"";return{rawResource:[me,se,te,ve,ue,be,de,ce,oe,Ce],handle:me}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:ge}}),M=W.map(({start:Z,deleteCount:ge,toInsert:_})=>[Z,ge,_.map(me=>me.rawResource)]),Y=W.reverse();for(const{start:Z,deleteCount:ge,toInsert:_}of Y){const me=_.map(ce=>ce.handle),se=this.o.splice(Z,ge,...me);for(const ce of se)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=L,M}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let q;(0,n.$6G)(this.y,"quickDiffProvider")&&(q=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:q})}get historyProvider(){return(0,n.$7G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,n.$7G)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new N.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new N.$Wc,this.p=L;const q=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:q})}get actionButton(){return(0,n.$7G)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,n.$7G)(this.y,"scmActionButton"),this.q.value=new N.$Wc,this.s=L;const q=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(W=>W.map(M=>this.z.converter.toInternal(M,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:q??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(L??[]).map(W=>W.command).join(", ")),this.u&&L&&k(this.u,L)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new N.$Wc,this.u=L;const q=(L||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:q})}get selected(){return this.v}constructor(L,q,W,M,Y,Z,ge,_){this.y=L,this.z=M,this.A=Y,this.B=Z,this.C=ge,this.D=_,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Yc,this.n=void 0,this.o=new N.$Yc,this.p=void 0,this.q=new N.$Yc,this.t=new N.$Yc,this.u=void 0,this.v=!1,this.w=new I.$ne,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.E=new Map,this.F=new Set,this.#e=W;const me=v.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${Z}/scm${this.x}/input`,query:_?`rootUri=${encodeURIComponent(_.toString())}`:void 0});this.f=new P(L,q,this.#e,this.x,me),this.#e.$registerSourceControl(this.x,Z,ge,_,me)}createResourceGroup(L,q,W){const M=(0,n.$6G)(this.y,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,Y=new f(this.#e,this.z,this.x,L,q,M,this.y),Z=I.Event.once(Y.onDidDispose)(()=>this.E.delete(Y));return this.E.set(Y,Z),this.eventuallyAddResourceGroups(),Y}eventuallyAddResourceGroups(){const L=[],q=[];for(const[W,M]of this.E){M.dispose();const Y=W.onDidUpdateResourceStates(()=>{this.F.add(W),this.eventuallyUpdateResourceStates()});I.Event.once(W.onDidDispose)(()=>{this.F.delete(W),Y.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),L.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const Z=W._takeResourceStateSnapshot();Z.length>0&&q.push([W.handle,Z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,L,q),this.E.clear()}eventuallyUpdateResourceStates(){const L=[];this.F.forEach(q=>{const W=q._takeResourceStateSnapshot();W.length!==0&&L.push([q.handle,W])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.F.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,C.$_h)(100)],w.prototype,"eventuallyAddResourceGroups",null),He([(0,C.$_h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,q,W,M){this.m=q,this.n=W,this.o=M,this.g=new Map,this.h=new y.$tn,this.j=new I.$ne,this.e=L.getProxy(T.$uN.MainThreadSCM),this.f=L.getProxy(T.$uN.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:Y=>{if(Y&&Y.$mid===u.MarshalledId.ScmResource){const Z=this.g.get(Y.sourceControlHandle);if(!Z)return Y;const ge=Z.getResourceGroup(Y.groupHandle);return ge?ge.getResourceState(Y.handle):Y}else if(Y&&Y.$mid===u.MarshalledId.ScmResourceGroup){const Z=this.g.get(Y.sourceControlHandle);return Z?Z.getResourceGroup(Y.groupHandle):Y}else if(Y&&Y.$mid===u.MarshalledId.ScmProvider){const Z=this.g.get(Y.handle);return Z||Y}return Y}})}createSourceControl(L,q,W,M){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,q,W,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const Y=h.d++,Z=new w(L,this.n,this.e,this.m,this.o,q,W,M);this.g.set(Y,Z);const ge=this.h.get(L.identifier)||[];return ge.push(Z),this.h.set(L.identifier,ge),Z}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const q=this.h.get(L.identifier),W=q&&q[q.length-1];return W&&W.inputBox}$provideOriginalResource(L,q,W){const M=v.URI.revive(q);this.o.trace("ExtHostSCM#$provideOriginalResource",L,M.toString());const Y=this.g.get(L);return!Y||!Y.quickDiffProvider||!Y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$yh)(()=>Y.quickDiffProvider.provideOriginalResource(M,W)).then(Z=>Z||null)}$onInputBoxValueChange(L,q){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const W=this.g.get(L);return W&&W.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(L,q,W,M){this.o.trace("ExtHostSCM#$executeResourceCommand",L,q,W);const Y=this.g.get(L);if(!Y)return Promise.resolve(void 0);const Z=Y.getResourceGroup(q);return Z?Z.$executeResourceCommand(W,M):Promise.resolve(void 0)}$validateInput(L,q,W){this.o.trace("ExtHostSCM#$validateInput",L);const M=this.g.get(L);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.$yh)(()=>M.inputBox.validateInput(q,W)).then(Y=>{if(!Y)return Promise.resolve(void 0);const Z=d.MarkdownString.fromStrict(Y.message);return Z?Promise.resolve([Z,Y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,q,W,M){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,W,M)??void 0}async $provideHistoryItems(L,q,W,M){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(q,W,M))?.map(ge=>l(ge))??void 0}async $provideHistoryItems2(L,q,W){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(q,W))?.map(Z=>l(Z))??void 0}async $provideHistoryItemSummary(L,q,W,M){const Y=this.g.get(L)?.historyProvider;if(typeof Y?.provideHistoryItemSummary!="function")return;const Z=await Y.provideHistoryItemSummary(q,W,M);return Z?l(Z):void 0}async $provideHistoryItemChanges(L,q,W,M){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(q,W,M)??void 0}};e.$fqc=F,e.$fqc=F=h=He([qe(3,R.$ak)],F)}),define(Ie[296],Pe([1,0,5,8,2]),function(ae,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;class N{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(v.$uN.MainThreadShare)}async $provideShare(T,p,a){return await this.c.get(T)?.provideShare({selection:I.Range.to(p.selection),resourceUri:C.URI.revive(p.resourceUri)},a)??void 0}registerShareProvider(T,p){const a=N.a++;return this.c.set(a,p),this.b.$registerShareProvider(a,I.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$gqc=N}),define(Ie[297],Pe([1,0,7,5,187,4,8,15]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=e.$iqc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$uO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$uO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,d,n,s,o=v.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new N.$Wc,this.#e=u,this.#t=E,s&&n){this.c=(0,v.$9N)(n.identifier,s);const i=d.get(this.c);i&&(o=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=n,this.f=s,this.g=o,this.h=this.u(h)}u(u){if((0,T.$kg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Wc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,C.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,n,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$iqc=p;class a{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new v.$wN(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(u,E){this.e=new Map,this.a=u.getProxy(I.$uN.MainThreadStatusBar),this.b=E,this.c=new a(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,d,n){return new p(this.a,this.b,this.e,u,E,d,n)}setStatusBarMessage(u,E){const d=this.c.setMessage(u);let n;return typeof E=="number"?n=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new v.$wN(()=>{d.dispose(),clearTimeout(n)})}}e.$jqc=R}),define(Ie[125],Pe([1,0,33,116,55,82,56,8,2]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,v=Ve(v),T=Ve(T);const a=(i,r,t,c)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(g){if(!t(l,g)){const m=l;l=g,i.listener?.(c(g,m))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(c=>t.id===c.id)))},u=i=>r=>({op:N.TestItemEventOp.SetProp,update:i(r)}),E=(i,r)=>({range:(()=>{let t;const c=u(l=>({range:v.$Mt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:N.TestItemEventOp.DocumentSynced}),y.range(t,l)||(t=l,i.listener?.(c(l)))}}})(),label:a(i,r,y.label,u(t=>({label:t}))),description:a(i,void 0,y.description,u(t=>({description:t}))),sortText:a(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:N.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,u(t=>({busy:t}))),error:a(i,void 0,y.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,c)=>({op:N.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:c.map(T.TestTag.from)}))}),d=i=>{const r=C.$TI.fromString(i.extId),t=new s(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(c=>T.TestTag.to({id:(0,A.$ZI)(c).tagId})),t},n=i=>{let r;for(const t of i.tests){const c=d(t.item);(0,I.$WP)(c).parent=r,r=c}return r};e.$aQ=n;class s{constructor(r,t,c,l){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,I.$VP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof o?void 0:g.parent}},children:{value:(0,N.$UP)(g,I.$WP,s),enumerable:!0,writable:!1},...E(g,c)})}}e.$bQ=s;class o extends s{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$cQ=o;class h extends N.$QP{constructor(r,t,c){super({controllerId:r,getDocumentVersion:l=>l&&c.getDocument(l)?.version,getApiFor:I.$WP,getChildren:l=>l.children,root:new o(r,t),toITestItem:T.TestItem.from})}}e.$dQ=h}),define(Ie[34],Pe([1,0,15,7,8,26,5,18,12,49,33,101,2,4,3,17,125,23,39,41,70,64,67,37]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,I=Ve(I),C=Ve(C);let g=class{#e;#t;#i;constructor(k,P,f){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$uN.MainThreadCommands),this.d=P,this.#i=f,this.#t=k.getProxy(A.$uN.MainThreadTelemetry),this.converter=new m(this,w=>{const F=this.c.get(w);return F?.result===D.Void?F:void 0},P),this.f=[{processArgument(w){return(0,a.$di)(w)}},{processArgument(w){return(0,N.$go)(w,function(F){if(R.$Mt.isIRange(F))return C.Range.to(F);if(y.$Lt.isIPosition(F))return C.Position.to(F);if(R.$Mt.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof o.$Pe)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const P=this.registerCommand(!1,k.id,async(...f)=>{const w=k.args.map((O,L)=>{if(!O.validate(f[L]))throw new Error(`Invalid argument '${O.name}' when running '${k.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return O.convert(f[L])}),F=await this.executeCommand(k.internalId,...w);return k.result.convert(F,f,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new I.$wN(()=>{P.dispose(),this.c.delete(k.id)})}registerCommand(k,P,f,w,F,O){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:f,thisArg:w,metadata:F,extension:O}),k&&this.#e.$registerCommand(P),new I.$wN(()=>{this.b.delete(P)&&k&&this.#e.$unregisterCommand(P)})}executeCommand(k,...P){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,P,!0)}async g(k,P,f){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,P,!1);{let w=!1;const F=(0,N.$go)(P,function(O){if(O instanceof I.$xN)return C.Position.from(O);if(O instanceof I.$yN)return C.Range.from(O);if(O instanceof I.$IN)return C.location.from(O);if(I.$YO.isNotebookRange(O))return C.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,o.$Pe.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,o.$Pe.wrap(O);if(O instanceof o.$Pe)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(k,w?new h.$Uw(F):F,f);return(0,a.$di)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(k,P,!1);throw O}}}async h(k,P,f){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:F,thisArg:O,metadata:L}=w;if(L?.args)for(let W=0;W<L.args.length;W++)try{(0,v.$xg)(P[W],L.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${L.args[W].name}' - ${L.args[W].description}`)}const q=r.$he.create();try{return await F.apply(O,P)}catch(W){if(k===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...P);M&&(k=M.command)}if(this.d.error(W,k,w.extension?.identifier),!f)throw W;if(w.extension?.identifier){const M=this.#i.onExtensionError(w.extension.identifier,W);this.d.trace("forwarded error to extension?",M,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$rj)(W)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,q.elapsed())}}j(k,P,f){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$vp(P),duration:f})}$executeContributedCommand(k,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const f=this.b.get(k);return f?(P=P.map(w=>this.f.reduce((F,O)=>O.processArgument(F,f.extension?.identifier),w)),this.h(k,P,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(P=>(k&&(P=P.filter(f=>f[0]!=="_")),P))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[P,f]of this.b){const{metadata:w}=f;w&&(k[P]=w)}return Promise.resolve(k)}};e.$jQ=g,e.$jQ=g=He([qe(0,n.$1P),qe(1,p.$ak),qe(2,c.$iQ)],g),e.$kQ=(0,d.$Gi)("IExtHostCommands");class m{constructor(k,P,f){this.d=k,this.f=P,this.g=f,this.delegatingCommandId=`__vsc${(0,l.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,P){if(!k)return;const f={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return f;const w=this.f(k.command);if(w)f.id=w.internalId,f.arguments=w.args.map((F,O)=>F.convert(k.arguments&&k.arguments[O]));else if((0,T.$Ob)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),P.add((0,E.$Vc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),f.$ident=F,f.id=this.delegatingCommandId,f.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return f}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const P=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$lQ=m;class ${static{this.Uri=new $("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new $("position","A position in a text document",k=>I.$xN.isPosition(k),C.Position.from)}static{this.Range=new $("range","A range in a text document",k=>I.$yN.isRange(k),C.Range.from)}static{this.Selection=new $("selection","A selection in a text document",k=>I.$zN.isSelection(k),C.Selection.from)}static{this.Number=new $("number","",k=>typeof k=="number",k=>k)}static{this.String=new $("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=$.Arr($.String)}static Arr(k){return new $(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,P=>Array.isArray(P)&&P.every(f=>k.validate(f)),P=>P.map(f=>k.convert(f)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",k=>k instanceof I.$UN,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",k=>k instanceof I.$gP,C.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",k=>k instanceof s.$bQ,C.TestItem.from)}constructor(k,P,f,w){this.name=k,this.description=P,this.validate=f,this.convert=w}optional(){return new $(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,P){return new $(k??this.name,P??this.description,this.validate,this.convert)}}e.$mQ=$;class D{static{this.Void=new D("no result",k=>k)}constructor(k,P){this.description=k,this.convert=P}}e.$nQ=D;class S{constructor(k,P,f,w,F){this.id=k,this.internalId=P,this.description=f,this.args=w,this.result=F}}e.$oQ=S}),define(Ie[298],Pe([1,0,18,16,2,94,104,32,34,8,7]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0,N=Ve(N),a=Ve(a),R=Ve(R);const y=[new p.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",E(a.DocumentHighlight.to))),new p.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,s)=>{if((0,v.$Nb)(n))return;class o extends R.$PN{static to(i){const r=new o(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new R.$IN(s[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return n.map(o.to)})),new p.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$mQ.Uri,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$mQ.Uri,p.$mQ.Position,new p.$mQ("ch","Trigger character",n=>typeof n=="string",n=>n),new p.$mQ("options","Formatting options",n=>!0,n=>n)],new p.$nQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Location-instances.",E(a.location.to))),new p.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of Hover-instances.",E(a.Hover.to))),new p.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$mQ.Uri,new p.$mQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(s=>R.$xN.isPosition(s)),n=>n.map(a.Position.from))],new p.$nQ("A promise that resolves to an array of ranges.",n=>n.map(s=>{let o;for(const h of s.reverse())o=new R.$TN(a.Range.to(h),o);return o}))),new p.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$mQ.String.with("query","Search string")],new p.$nQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new p.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new p.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new p.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$mQ.CallHierarchyItem],new p.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new p.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new p.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("newName","The new symbol name")],new p.$nQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new p.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$mQ.Uri,p.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$nQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new p.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$mQ.Uri],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Hdb)(n);if(s.type==="full")return new R.$RO(s.data,void 0)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$mQ.Uri,p.$mQ.Range.optional()],new p.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$PO(n.tokenTypes,n.tokenModifiers)})),new p.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$Hdb)(n);if(s.type==="full")return new R.$RO(s.data,void 0)})),new p.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$nQ("A promise that resolves to a CompletionList-instance.",(n,s,o)=>{if(!n)return new R.$6N([]);const h=n.suggestions.map(i=>a.CompletionItem.to(i,o));return new R.$6N(h,n.incomplete)})),new p.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$mQ.Uri,p.$mQ.Position,p.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$nQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new p.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$mQ.Uri,p.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$nQ("A promise that resolves to an array of CodeLens-instances.",(n,s,o)=>E(h=>new R.$XN(a.Range.to(h.range),h.command&&o.fromInternal(h.command)))(n))),new p.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$mQ.Uri,new p.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$yN.isRange(n),n=>R.$zN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),p.$mQ.String.with("kind","Code action kind to return code actions for").optional(),p.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$nQ("A promise that resolves to an array of Command-instances.",(n,s,o)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(h.command)}else{const i=new R.$RN(h.title,h.kind?new R.$SN(h.kind):void 0);return h.edit&&(i.edit=a.WorkspaceEdit.to(h.edit)),h.command&&(i.command=o.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(n))),new p.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(s=>new R.$_N(a.Range.to(s.range),a.Color.to(s.color))):[])),new p.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$mQ("color","The color to show and insert",n=>n instanceof R.$$N,a.Color.from),new p.$mQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new p.$nQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new p.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$mQ.Uri,p.$mQ.Range],new p.$nQ("A promise that resolves to an array of Inlay objects",(n,s,o)=>n.map(a.InlayHint.to.bind(void 0,o)))),new p.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$mQ.Uri],new p.$nQ("A promise that resolves to an array of FoldingRange objects",(n,s)=>{if(n)return n.map(a.FoldingRange.to)})),new p.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",E(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.to(s))})))),new p.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$mQ.Uri,p.$mQ.Range,new p.$mQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$yN,n=>a.InlineValueContext.from(n))],new p.$nQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new p.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$mQ("uriOrString","Uri-instance or string (only http/https)",n=>C.URI.isUri(n)||typeof n=="string"&&(0,I.$Qg)(n,I.Schemas.http,I.Schemas.https),n=>n),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),p.$mQ.String.with("label","").optional()],p.$nQ.Void),new p.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$mQ.Uri.with("resource","Resource to open"),p.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],p.$nQ.Void),new p.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$mQ.String.with("title","Human readable title for the diff editor").optional(),new p.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],p.$nQ.Void),new p.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$mQ.String.with("title","Human readable title for the changes editor"),new p.$mQ("resourceList","List of resources to compare",n=>{for(const s of n){if(s.length!==3)return!1;const[o,h,i]=s;if(!C.URI.isUri(o)||!C.URI.isUri(h)&&h!==void 0&&h!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],p.$nQ.Void),new p.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$mQ.Uri,p.$mQ.Position],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$mQ.TypeHierarchyItem],new p.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$mQ.TestItem],p.$nQ.Void),new p.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$nQ.Void),new p.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$mQ.String.with("name","The context key name"),new p.$mQ("value","The context key value",()=>!0,n=>n)],p.$nQ.Void),new p.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$mQ.Uri,p.$mQ.StringArray,new p.$mQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new p.$nQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new p.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$mQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:R.$zN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],p.$nQ.Void)];class u{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Fj)}}e.$yoc=u;function E(n){return s=>{if(Array.isArray(s))return s.map(n)}}function d(n){if(!Array.isArray(n))return;const s=[];for(const o of n)N.$Iu(o)?s.push(a.DefinitionLink.to(o)):s.push(a.location.to(o));return s}}),define(Ie[299],Pe([1,0,2,34]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0;class C{constructor(A,T,p,a,R){this.a=T,this.b=p,this.c=a;const y=new I.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.$mQ("showOptions","Show Options",u=>!0,u=>u),new I.$mQ("resource","Interactive resource Uri",u=>!0,u=>u),new I.$mQ("controllerId","Notebook controller Id",u=>!0,u=>u),new I.$mQ("title","Interactive editor title",u=>!0,u=>u)],new I.$nQ("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Zpc=C}),define(Ie[300],Pe([1,0,18,11,22,6,4,29,2,19,12,5,34,8,7,83,239,25,39,240]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0,e.$9pc=$,E=Ve(E);let r=class{constructor(S,b,k,P,f){this.m=b,this.n=k,this.o=P,this.q=f,this.b=new T.$Dc,this.c=new T.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$ne,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(y.$uN.MainThreadNotebookKernels);const w=new u.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$mQ("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const L=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:L}}else if(O&&"notebookEditor"in O){const L=this.n.getIdByEditor(O.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return O})],u.$nQ.Void),F=new u.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$mQ.Uri],new u.$nQ("A promise that resolves to an array of variables",(O,L)=>O.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(F)}createNotebookController(S,b,k,P,f,w){for(const oe of this.j.values())if(oe.controller.id===b&&a.$rn.equals(S.identifier,oe.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const F=this.k++,O=this;this.q.trace(`NotebookController[${F}], CREATED by ${S.identifier.value}, ${b}`);const L=()=>console.warn(`NO execute handler from notebook controller '${Y.id}' of extension: '${S.identifier}'`);let q=!1;const W=new N.$ne,M=new N.$ne,Y={id:$(S.identifier,b),notebookType:k,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:P||S.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let Z=f??L,ge,_;this.a.$addKernel(F,Y).catch(oe=>{console.log(oe),q=!0});let me=0;const se=()=>{if(q)return;const oe=++me;Promise.resolve().then(()=>{oe===me&&this.a.$updateKernel(F,Y)})},ce=new T.$Dc,we={get id(){return b},get notebookType(){return Y.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return Y.label},set label(oe){Y.label=oe??S.displayName??S.name,se()},get detail(){return Y.detail??""},set detail(oe){Y.detail=oe,se()},get description(){return Y.description??""},set description(oe){Y.description=oe,se()},get supportedLanguages(){return Y.supportedLanguages},set supportedLanguages(oe){Y.supportedLanguages=oe,se()},get supportsExecutionOrder(){return Y.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){Y.supportsExecutionOrder=oe,se()},get rendererScripts(){return Y.preloads?Y.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(oe){Z=oe??L},get interruptHandler(){return ge},set interruptHandler(oe){ge=oe,Y.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,o.$7G)(S,"notebookVariableProvider"),_=oe,Y.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Ce=>O.a.$variablesUpdated(Ce.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(oe){if(q)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.notebook.uri))throw O.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return O._createNotebookCellExecution(oe,$(S.identifier,this.id))},createNotebookExecution(oe){if((0,o.$7G)(S,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.uri))throw O.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return O._createNotebookExecution(oe,$(S.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${F}], DISPOSED`),q=!0,this.j.delete(F),W.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(oe,Ce){Ce===d.NotebookControllerAffinity2.Hidden&&(0,o.$7G)(S,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(F,oe.uri,Ce)},onDidReceiveMessage:M.event,postMessage(oe,Ce){return(0,o.$7G)(S,"notebookMessaging"),O.a.$postMessage(F,Ce&&O.n.getIdByEditor(Ce),oe)},asWebviewUri(oe){return(0,o.$7G)(S,"notebookMessaging"),(0,n.$hDb)(oe,O.m.remote)}};return this.j.set(F,{extensionId:S.identifier,controller:we,onDidReceiveMessage:M,onDidChangeSelection:W,associatedNotebooks:ce}),we}getIdByController(S){for(const[b,k]of this.j)if(k.controller===S)return $(k.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,b){const k=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(k,b);const f={dispose:()=>{this.f.delete(k),P.a.$removeKernelDetectionTask(k)}};return this.f.set(k,f),f}registerKernelSourceActionProvider(S,b,k){const P=this.i++,f=typeof k.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,w=this;this.h.set(P,k),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,b);let F;return f!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(P),w.a.$removeKernelSourceActionProvider(P,P),F?.dispose()}}}async $provideKernelSourceActions(S,b){const k=this.h.get(S);if(k){const P=new A.$Wc;return(await k.provideNotebookKernelSourceActions(b)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.o.converter,P))}return[]}$acceptNotebookAssociation(S,b,k){const P=this.j.get(S);if(P){const f=this.n.getNotebookDocument(p.URI.revive(b));k?P.associatedNotebooks.set(f.uri,!0):P.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,f.uri.toString(),k),P.onDidChangeSelection.fire({selected:k,notebook:f.apiNotebook})}}async $executeCells(S,b,k){const P=this.j.get(S);if(!P)return;const f=this.n.getNotebookDocument(p.URI.revive(b)),w=[];for(const F of k){const O=f.getCell(F);O&&w.push(O.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,f.uri.toString(),w.length),await P.controller.executeHandler.call(P.controller,w,f.apiNotebook,P.controller)}catch(F){this.q.error(`NotebookController[${S}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(S,b,k){const P=this.j.get(S);if(!P)return;const f=this.n.getNotebookDocument(p.URI.revive(b));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,f.apiNotebook);else for(const w of k){const F=f.getCell(w);F&&this.b.get(F.uri)?.cancel()}if(P.controller.interruptHandler){const w=this.c.get(f.uri);this.c.delete(f.uri),k.length&&Array.isArray(w)&&w.length&&w.forEach(F=>F.dispose())}}async $provideVariables(S,b,k,P,f,w,F){const O=this.j.get(S);if(!O)return;const L=this.n.getNotebookDocument(p.URI.revive(k)),q=O.controller.variableProvider;if(!q)return;let W;if(P!==void 0){if(W=this.s[P],!W)return}else this.s={};const M=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,Y=q.provideVariables(L.apiNotebook,W,M,w,F);let Z=0;for await(const ge of Y){if(F.isCancellationRequested)return;const _={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[_.id]=ge.variable,this.a.$receiveVariable(b,_),Z++>=i.$MK)return}}$acceptKernelMessageFromRenderer(S,b,k){const P=this.j.get(S);if(!P)return;const f=this.n.getEditorById(b);P.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:k}))}$cellExecutionChanged(S,b,k){const f=this.n.getNotebookDocument(p.URI.revive(S)).getCell(b);if(f){const w=k?E.NotebookCellExecutionState.to(k):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:f.apiCell,state:w})}}_createNotebookCellExecution(S,b){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const f=new c(b,P,this.a);this.b.set(P.uri,f);const w=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),w.dispose(),this.b.delete(P.uri))});return f.asApiObject()}_createNotebookExecution(S,b){const k=this.n.getNotebookDocument(S.uri),P=S.getCells().find(F=>{const O=k.getCellFromApiCell(F);return O&&this.b.has(O.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const f=new g(b,k,this.a),w=f.onDidChangeState(()=>{f.state===l.Resolved&&(f.dispose(),w.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[f,w]),f.asApiObject()}};e.$8pc=r,e.$8pc=r=He([qe(4,R.$ak)],r);var t;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(t||(t={}));class c extends A.$Xc{static{this.a=0}get state(){return this.f}constructor(S,b,k){super(),this.m=b,this.n=k,this.b=c.a++,this.c=new N.$ne,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$ye),this.h=new m(10,P=>this.s(P)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const b=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new h.$Uw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let b=this.m;if(S&&(b=this.m.notebook.getCellFromApiCell(S)),!b)throw new Error("INVALID cell");return b.handle}y(S){return S.map(b=>{const k=d.$3O.ensureUniqueMimeTypes(b.items,!0);return k===b.items?E.NotebookCellOutput.from(b):E.NotebookCellOutput.from({items:k,id:b.id,metadata:b.metadata})})}async z(S,b,k){const P=this.w(b),f=this.y((0,v.$5b)(S));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:P,append:k,outputs:f})}async C(S,b,k){return S=d.$3O.ensureUniqueMimeTypes((0,v.$5b)(S),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:S.map(E.NotebookCellOutputItem.from),outputId:b.id,append:k})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(k){S.j=k,S.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(k){if(S.f===t.Resolved||S.f===t.Started)throw new Error("Cannot call start again");S.f=t.Started,S.c.fire(),S.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,P,f){if(S.f===t.Resolved)throw new Error("Cannot call resolve twice");S.f=t.Resolved,S.c.fire(),S.h.flush();const w=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;S.n.$completeExecution(S.b,new h.$Uw({runEndTime:P,lastRunSuccess:k,error:w}))},clearOutput(k){return S.t(),S.z([],k,!1)},appendOutput(k,P){return S.t(),S.z(k,P,!0)},replaceOutput(k,P){return S.t(),S.z(k,P,!1)},appendOutputItems(k,P){return S.t(),S.C(k,P,!0)},replaceOutputItems(k,P){return S.t(),S.C(k,P,!1)}})}}var l;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(l||(l={}));class g extends A.$Xc{static{this.a=0}get state(){return this.f}constructor(S,b,k){super(),this.h=b,this.j=k,this.b=g.a++,this.c=new N.$ne,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new C.$ye),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(S,b){this.f=S,this.g=b,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new I.$4h,this.b=Date.now(),(0,I.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>S.complete())}}function $(D,S){return`${D.value}/${S}`}}),define(Ie[57],Pe([1,0,6,5,3,2,17,4,7,189,14,220,22,37,221,222,35,11,8,34,38]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=e.$bpc=e.$apc=void 0,e.$apc=(0,C.$Gi)("IExtHostTerminalService");class t extends T.$Xc{constructor(f,w,F,O){super(),this.u=f,this._id=w,this.w=F,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$ne),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(q,W=!0){L.C(),L.u.$sendText(L._id,q,W)},show(q){L.C(),L.u.$show(L._id,q)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??w?.cwd??void 0,env:f.env??void 0,icon:S(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(f.location,w?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,w,F,O,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(f,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,w){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in f?{viewColumn:h.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,w){this.j=Object.freeze({code:f,reason:w})}setDimensions(f,w){return f===this.f&&w===this.h||f===0||w===0?!1:(this.f=f,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(w=>{w!==f&&(this.b=Promise.resolve(f))})}}e.$bpc=t;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$ne,this.onProcessData=this.a.event,this.b=new v.$ne,this.d=new v.$ne,this.onDidChangeProperty=this.d.event,this.f=new v.$ne,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,w){this.g.setDimensions?.({columns:f,rows:w})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,g=class extends T.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,w,F){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$ne,this.onDidCloseTerminal=this.H.event,this.I=new v.$ne,this.onDidOpenTerminal=this.I.event,this.J=new v.$ne,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$ne,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$ne,this.onDidChangeTerminalState=this.M.event,this.N=new v.$ne,this.onDidChangeShell=this.N.event,this.O=new v.$ne({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$ne({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(I.$uN.MainThreadTerminalService),this.y=new n.$Axb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:O=>{const L=q=>{const W=q;return this.getTerminalById(W.instanceId)?.value};switch(O?.$mid){case r.MarshalledId.TerminalContext:return L(O);default:{if(Array.isArray(O))for(let q=0;q<O.length&&O[q].$mid===r.MarshalledId.TerminalContext;q++)O[q]=L(O[q]);return O}}}}),this.B({dispose:()=>{for(const[O,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,w){const F=new t(this.a,(0,E.$3g)(),f,f.name),O=new c(f.pty);return F.createExtensionTerminal(f.location,w,this.R(f,w).resolvedExtHostIdentifier,S(f.iconPath),b(f.color)).then(L=>{const q=this.S(L,O);this.h[L]=q}),this.f.push(F),F.value}R(f,w){if(w=w||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const F=f.location.parentTerminal;if(F){const O=this.f.find(L=>L.value===F);O&&(w.resolvedExtHostIdentifier=O._id)}}else f.location&&typeof f.location!="object"?w.location=f.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(f,w){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const O=new c(w),L=this.S(f,O);this.h[f]=L}async $acceptActiveTerminalChanged(f){const w=this.b;if(f===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(f);F&&(this.b=F,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,w){const F=this.getTerminalById(f);F&&this.O.fire({terminal:F.value,data:w})}async $acceptTerminalDimensions(f,w,F){const O=this.getTerminalById(f);O&&O.setDimensions(w,F)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(f,w){const F=this.getTerminalById(f);F&&this.P.fire({terminal:F.value,...w})}async $acceptTerminalMaximumDimensions(f,w,F){this.g.get(f)?.resize(w,F)}async $acceptTerminalTitleChange(f,w){const F=this.getTerminalById(f);F&&(F.name=w)}async $acceptTerminalClosed(f,w,F){const O=this.X(this.f,f);if(O!==null){const L=this.f.splice(O,1)[0];L.setExitStatus(w,F),this.H.fire(L.value)}}$acceptTerminalOpened(f,w,F,O){if(w){const W=this.X(this.f,w);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const L={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:N.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},q=new t(this.a,f,L,F);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(f,w){this.getTerminalById(f)?._setProcessId(w)}async $startExtensionTerminal(f,w){const F=this.getTerminalById(f);if(!F)return{message:(0,a.localize)(0,null,f)};F.isOpen||await new Promise(L=>{const q=this.onDidOpenTerminal(async W=>{W===F.value&&(q.dispose(),L())})});const O=this.g.get(f);O?O.startSendingEvents(w):this.j[f]={initialDimensions:w}}S(f,w){const F=new T.$Wc;F.add(w.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),F.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,w.onProcessData),F.add(w.onProcessExit(L=>this.U(f,L))),this.g.set(f,w);const O=this.j[f];return O&&w instanceof c&&(w.startSendingEvents(O.initialDimensions),delete this.j[f]),F}$acceptProcessAckDataEvent(f,w){this.g.get(f)?.acknowledgeDataEvent(w)}$acceptProcessInput(f,w){this.g.get(f)?.input(w)}$acceptTerminalInteraction(f){const w=this.getTerminalById(f);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(f,w){this.getTerminalById(f)?.setSelection(w)}$acceptProcessResize(f,w,F){try{this.g.get(f)?.resize(w,F)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(f,w){this.g.get(f)?.shutdown(w)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new p.$wN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,w,F){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,F),this.a.$registerProfileProvider(w,f.identifier.value),new p.$wN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(f,w,F){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,F),this.a.$registerQuickFixProvider(f,w),new p.$wN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,w){const F=new u.$ye().token;if(F.isCancellationRequested)return;const O=this.D.get(f);if(!O)return;const L=await O.provideTerminalQuickFixes(w,F);if(L===null||Array.isArray(L)&&L.length===0)return;const q=new T.$Wc;if(this.w.value=q,!Array.isArray(L))return L?h.TerminalQuickFix.from(L,this.Q.converter,q):void 0;const W=[];for(const M of L){const Y=h.TerminalQuickFix.from(M,this.Q.converter,q);Y&&W.push(Y)}return W}async $createContributedProfileTerminal(f,w){const F=new u.$ye().token;let O=await this.C.get(f)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,w);return}this.createTerminalFromOptions(O.options,w)}}async $provideLinks(f,w){const F=this.getTerminalById(f);if(!F)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new u.$ye;this.G.set(f,L);const q=[],W={terminal:F.value,line:w},M=[];for(const ge of this.z)M.push(o.Promises.withAsyncBody(async _=>{L.token.onCancellationRequested(()=>_({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(W,L.token)||[];L.token.isCancellationRequested||_({provider:ge,links:me})}));const Y=await Promise.all(M);if(L.token.isCancellationRequested)return[];const Z=new Map;for(const ge of Y)ge&&ge.links.length>0&&q.push(...ge.links.map(_=>{const me={id:l++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return Z.set(me.id,{provider:ge.provider,link:_}),me}));return this.F.set(f,Z),q}$activateLink(f,w){const F=this.F.get(f)?.get(w);F&&F.provider.handleTerminalLink(F.link)}U(f,w){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const F=this.h[f];F&&(F.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,w)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const w=this.f.findIndex(F=>F.value===f);return w>=0?w:null}W(f,w){const F=this.X(f,w);return F!==null?f[F]:null}X(f,w){const F=f.findIndex(O=>O._id===w);return F>=0?F:null}getEnvironmentVariableCollection(f){let w=this.n.get(f.identifier.value);return w||(w=this.B(new m),this.Z(f.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(f,w){const F=(0,y.$Ds)(w.map),O=(0,y.$Es)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(f,w.persistent,F.length===0?void 0:F,O)}$initEnvironmentVariableCollections(f){f.forEach(w=>{const F=w[0],O=this.B(new m(w[1]));this.Z(F,O)})}$acceptDefaultProfile(f,w){const F=this.s;this.s=f,this.u=w,F?.path!==f.path&&this.N.fire(f.path)}Z(f,w){this.n.set(f,w),this.B(w.onDidChangeCollection(()=>{this.Y(f,w)}))}};e.$cpc=g,e.$cpc=g=He([qe(1,i.$kQ),qe(2,A.$1P)],g);class m extends T.$Xc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$ne,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const w=this.j(f);let F=this.a.get(w);return F||(F=new $(this,f),this.a.set(w,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(f,w,F,O){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:O})}append(f,w,F,O){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:O})}prepend(f,w,F,O){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:O})}g(f,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(f,w.scope),O=this.map.get(F),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==w.value||O.type!==w.type||O.options?.applyAtProcessCreation!==L.applyAtProcessCreation||O.options?.applyAtShellIntegration!==L.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const q=this.h(f,w.scope),W={variable:f,...w,options:L};this.map.set(q,W),this.f.fire()}}get(f,w){const F=this.h(f,w),O=this.map.get(F);return O?k(O):void 0}h(f,w){const F=this.j(w);return F.length?`${f}:::${F}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const w=new Map;for(const[F,O]of this.map)this.j(O.scope)===this.j(f)&&w.set(O.variable,k(O));return w}delete(f,w){const F=this.h(f,w);this.map.delete(F),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[w,F]of this.map)F.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(w);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,w){const F=this.j(w),O=this.descriptionMap.get(F);if(!O||O.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const q={description:L,scope:w};this.descriptionMap.set(F,q),this.f.fire()}}getDescription(f){const w=this.j(f);return this.descriptionMap.get(w)?.description}n(f){const w=this.j(f);this.descriptionMap.delete(w)}}class ${get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,w){this.b=f,this.d=w,this.a=new v.$ne}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,w,F){this.b.replace(f,w,F,this.d)}append(f,w,F){this.b.append(f,w,F,this.d)}prepend(f,w,F){this.b.prepend(f,w,F,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,w){this.b.getVariableMap(this.d).forEach((F,O)=>f.call(w,O,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let D=class extends g{constructor(f,w){super(!1,f,w)}createTerminal(f,w,F){throw new R.$cb}createTerminalFromOptions(f,w){throw new R.$cb}};e.$dpc=D,e.$dpc=D=He([qe(0,i.$kQ),qe(1,A.$1P)],D);function S(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function b(P){return s.ThemeColor.isThemeColor(P)?P:void 0}function k(P){const f={...P};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ie[126],Pe([1,0,7,4,3,5,17,57,6,2,11]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=e.$nqc=void 0,e.$nqc=(0,C.$Gi)("IExtHostTerminalShellIntegration");let y=class extends I.$Xc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new p.$ne,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$ne,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$ne,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(N.$uN.MainThreadTerminalShellIntegration),this.B((0,I.$Vc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const h=o.value;let i=this.b.get(s);i||(i=new u(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(s,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),o.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(s,o,h,i,r){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.startShellExecution(t,r)}$shellExecutionEnd(s,o,h,i,r){const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.endShellExecution(t,r)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,a.$yc)(o)?a.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$oqc=y,e.$oqc=y=He([qe(0,A.$1P),qe(1,T.$apc)],y);class u extends I.$Xc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new I.$Wc),this.f=this.B(new p.$ne),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$ne),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$ne),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const c={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=h.startShellExecution(c,h.c,!0).value;return h.b=!0,l}}}startShellExecution(s,o,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(s,o);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;a.URI.isUri(this.c)?o=!a.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$7h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends I.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Fh);const s=this.a;return new R.$7h(async h=>{this.b.push(h),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ie[127],Pe([1,0,62,14,97,8,7]),function(ae,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,N=Ve(N);class T{static{this.c=new C.$6P("TextEditorDecorationType")}constructor(u,E,d){const n=T.c.nextId();u.$registerTextEditorDecorationType(E.identifier,n,N.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$8P=T;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let d=null;if(u instanceof A.$xN)d=new A.$yN(u,u);else if(u instanceof A.$yN)d=u;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(u,E){this.k(),this.l(new A.$yN(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$yN)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,d){const n=this.c.validateRange(u);this.g.push({range:n,text:E,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,I.$0)("endOfLine");this.h=u}}class a{constructor(u,E,d,n){this.c=u,this.d=E,this._accept(d),this.e=n;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,E.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,E.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,E.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,E.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,E.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,E.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,E.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$9P=a;class R{constructor(u,E,d,n,s,o,h,i){this.id=u,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new a(this.j,this.id,o,d),this.e=h,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new I.$_("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$zN))throw(0,I.$0)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(c=>!(c instanceof A.$zN)))throw(0,I.$0)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new I.$_("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new I.$_("viewColumn")},edit(t,c={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(n.value,c);return t(l),r.m(l)},insertSnippet(t,c,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!c||Array.isArray(c)&&c.length===0)g=r.c.map(m=>N.Range.from(m));else if(c instanceof A.$xN){const{lineNumber:m,column:$}=N.Position.from(c);g=[{startLineNumber:m,startColumn:$,endLineNumber:m,endColumn:$}]}else if(c instanceof A.$yN)g=[N.Range.from(c)];else{g=[];for(const m of c)if(m instanceof A.$yN)g.push(N.Range.from(m));else{const{lineNumber:$,column:D}=N.Position.from(m);g.push({startLineNumber:$,startColumn:D,endLineNumber:$,endColumn:D})}}return E.$tryInsertSnippet(u,n.value.version,t.value,g,l)},setDecorations(t,c){const l=c.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(N.$XP(c))return E.$trySetDecorations(u,t.key,N.$YP(c));{const g=new Array(4*c.length);for(let m=0,$=c.length;m<$;m++){const D=c[m];g[4*m]=D.start.line+1,g[4*m+1]=D.start.character+1,g[4*m+2]=D.end.line+1,g[4*m+3]=D.end.character+1}return E.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,c){r.n(()=>E.$tryRevealRange(u,N.Range.from(t),c||A.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,N.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(s=>s.range);d.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=d.length-1;s<o;s++){const h=d[s].end;if(d[s+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=E.edits.map(s=>({range:N.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,n,{setEndOfLine:typeof E.setEndOfLine=="number"?N.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$0P=R}),define(Ie[58],Pe([1,0,62,6,4,2,3,5,123,17,127,8,12,29,16,40,48]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,v=Ve(v),y=Ve(y);class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Dc,this.d=new I.$ne,this.e=new I.$ne,this.f=new I.$ne,this.g=new I.$ne,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],c=[],l=[];if(r.removedDocuments)for(const g of r.removedDocuments){const m=N.URI.revive(g),$=this.c.get(m);$?.unref()&&(this.c.delete(m),t.push($.value))}if(r.addedDocuments)for(const g of r.addedDocuments){const m=N.URI.revive(g.uri);let $=this.c.get(m);if($&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);$||($=new o(new p.$4P(this.h.getProxy(T.$uN.MainThreadDocuments),m,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(m,$),c.push($.value)),$.ref()}if(r.removedEditors)for(const g of r.removedEditors){const m=this.b.get(g);this.b.delete(g),m&&l.push(m)}if(r.addedEditors)for(const g of r.addedEditors){const m=N.URI.revive(g.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const $=this.c.get(m).value,D=new R.$0P(g.id,this.h.getProxy(T.$uN.MainThreadTextEditors),this.i,new s.$X(()=>$.document),g.selections.map(y.Selection.to),g.options,g.visibleRanges.map(S=>y.Range.to(S)),typeof g.editorPosition=="number"?y.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,D)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,C.$Sc)(t),(0,C.$Sc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(c),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=h,e.$$P=h=He([qe(0,a.$1P),qe(1,u.$ak)],h),e.$_P=(0,A.$Gi)("IExtHostDocumentsAndEditors")}),define(Ie[96],Pe([1,0,11,23,22,6,273,76,4,38,15,37,3,12,5,34,58,17,125,8,7,242,55,82,56,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=e.$wpc=e.$vpc=e.$upc=void 0,i=Ve(i);let $=0;const D=new WeakMap;e.$upc=(0,u.$Gi)("IExtHostTesting");let S=class extends p.$Xc{constructor(_,me,se,ce){super(),this.C=me,this.D=se,this.F=ce,this.f=this.B(new N.$ne),this.g=new Map,this.w=this.B(new N.$ne),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(d.$uN.MainThreadTesting),this.m=new q(this.h),this.j=new f(this.h,me),se.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case a.MarshalledId.TestItemContext:{const oe=we,Ce=oe.tests[oe.tests.length-1].item.extId;return this.g.get(c.$TI.root(Ce))?.collection.tree.get(Ce)?.actual??(0,h.$aQ)(we)}case a.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:Ce}=we,Le=oe.item.extId;return{test:this.g.get(c.$TI.root(Le))?.collection.tree.get(Le)?.actual??(0,h.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(Ce)}}default:return we}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=Ce=>{const Le=this.g.get(c.$TI.root(Ce));if(Le)return c.$TI.isRoot(Ce)?Le.controller:Le.collection.tree.get(Ce)?.actual};return{include:we?.include.map(oe).filter(R.$og)||[],exclude:we?.exclude.map(oe).filter(R.$og)||[]}})}createTestController(_,me,se,ce){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const we=new p.$Wc,oe=we.add(new h.$dQ(me,se,this.F));oe.root.label=se;const Ce=new Map,Le=new Set,X=this.h,V={items:oe.root.children,get label(){return se},set label(ve){se=ve,oe.root.label=ve,X.$updateController(me,{label:se})},get refreshHandler(){return ce},set refreshHandler(ve){ce=ve,X.$updateController(me,{canRefresh:!!ve})},get id(){return me},createRunProfile:(ve,ue,be,de,J,x)=>{let pe=(0,T.$uj)(ve);for(;Ce.has(pe);)pe++;return new M(this.h,Ce,Le,this.w.event,me,pe,ve,ue,be,de,J,x)},createTestItem(ve,ue,be){return new h.$bQ(me,ve,ue,be)},createTestRun:(ve,ue,be=!0)=>this.j.createTestRun(_,me,oe,ve,ue,be),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ue=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ue.map(be=>c.$TI.fromExtHostTestItem(be,me).toString()))}},set resolveHandler(ve){oe.resolveHandler=ve},get resolveHandler(){return oe.resolveHandler},dispose:()=>{we.dispose()}};X.$registerTestController(me,se,!!ce),we.add((0,p.$Vc)(()=>X.$unregisterTestController(me)));const te={controller:V,collection:oe,profiles:Ce,extension:_,activeProfiles:Le};return this.g.set(me,te),we.add((0,p.$Vc)(()=>this.g.delete(me))),we.add(oe.onDidGenerateDiff(ve=>X.$publishDiff(me,ve.map(g.TestsDiffOp.serialize)))),V}createTestObserver(){return this.m.checkout()}async runTests(_,me=C.CancellationToken.None){const se=w(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:Y[se.kind],targets:[{testIds:_.include?.map(we=>c.$TI.fromExtHostTestItem(we,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map(we=>we.id)},me)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,me,se){return(await this.j.getCoverageDetails(_,me,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,me){this.g.get(_)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(_){const me=new Map;for(const[se,ce]of Object.entries(_)){const we=this.g.get(se);if(!we)continue;const oe=new Map,Ce=ce.filter(X=>!we.activeProfiles.has(X)),Le=[...we.activeProfiles].filter(X=>!ce.includes(X));for(const X of Ce)oe.set(X,!0),we.activeProfiles.add(X);for(const X of Le)oe.set(X,!1),we.activeProfiles.delete(X);oe.size&&me.set(se,oe)}this.w.fire(me)}async $refreshTests(_,me){await this.g.get(_)?.controller.refreshHandler?.(me)}$publishTestResults(_){this.results=Object.freeze(_.map(me=>{const se=i.TestResults.to(me);return D.set(se,me.id),se}).concat(this.results).sort((me,se)=>se.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,me){const se=this.g.get(c.$TI.fromString(_).controllerId)?.collection;se&&(await se.expand(_,me<0?1/0:me),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(me=>g.TestsDiffOp.deserialize({asCanonicalUri:se=>se},me)))}async $runControllerTests(_,me){return Promise.all(_.map(se=>this.G(se,!1,me)))}async $startContinuousRun(_,me){const se=new C.$ye(me),ce=await Promise.all(_.map(we=>this.G(we,!0,se.token)));return!me.isCancellationRequested&&!ce.some(we=>we.error)&&await new Promise(we=>me.onCancellationRequested(we)),se.dispose(!0),ce}async $provideTestFollowups(_,me){const se=this.results.find(oe=>D.get(oe)===_.resultId),ce=se&&Z(c.$TI.fromString(_.extId),se?.results);if(!ce)return[];let we=[];return await Promise.all([...this.y].map(async oe=>{try{const Ce=await oe.provideFollowup(se,ce,_.taskIndex,_.messageIndex,me);Ce&&(we=we.concat(Ce))}catch(Ce){this.C.error("Error thrown while providing followup for test message",Ce)}})),me.isCancellationRequested?[]:we.map(oe=>{const Ce=$++;return this.z.set(Ce,oe),{title:oe.title,id:Ce}})}$disposeTestFollowups(_){for(const me of _)this.z.delete(me)}$executeTestFollowup(_){const me=this.z.get(_);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const me of this.j.trackers){const se=me.getTaskIdForRun(_);if(se)return{taskId:se,runId:me.id}}}async G(_,me,se){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:we,profiles:oe,extension:Ce}=ce,Le=oe.get(_.profileId);if(!Le)return{};const X=_.testIds.map(ue=>we.tree.get(ue)).filter(R.$og),V=_.excludeExtIds.map(ue=>ce.collection.tree.get(ue)).filter(R.$og).filter(ue=>X.some(be=>be.fullId.compare(ue.fullId)===c.TestPosition.IsChild));if(!X.length)return{};const te=new r.$0O(X.some(ue=>ue.actual instanceof h.$cQ)?void 0:X.map(ue=>ue.actual),V.map(ue=>ue.actual),Le,me),ve=(0,g.$WI)(_)&&this.j.prepareForMainThreadTestRun(Ce,te,F.fromInternal(_,ce.collection),Le,se);try{return await Le.runHandler(te,se),{}}catch(ue){return{error:String(ue)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await N.Event.toPromise(ve.onEnd)}}};e.$vpc=S,e.$vpc=S=He([qe(0,o.$1P),qe(1,E.$ak),qe(2,n.$kQ),qe(3,s.$_P)],S);const b=1e4;var k;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(k||(k={}));class P extends p.$Xc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,me,se,ce,we,oe){super(),this.z=_,this.C=me,this.D=se,this.F=ce,this.G=we,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$ne),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$ye(oe));const Ce=this.B(new v.$Sh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>Ce.schedule()));const Le=new N.$ne;this.w=Le.event,this.B((0,p.$Vc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(_){for(const[me,{run:se}]of this.g)if(se===_)return me}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(_,me,se){const[,ce]=c.$TI.fromString(_).path,we=this.y.get(_);if(!we)return[];const{report:oe,extIds:Ce}=we,Le=this.g.get(ce);if(!Le)throw new Error("unreachable: run task was not found");let X;if(me&&oe instanceof r.$cP){const te=Ce.indexOf(me);if(te===-1)return[];X=oe.fromTests[te]}return await(X?this.F?.loadDetailedCoverageForTest?.(Le.run,oe,X,se):this.F?.loadDetailedCoverage?.(Le.run,oe,se))??[]}createRun(_){const me=this.z.id,se=this.z.controllerId,ce=(0,y.$3g)(),we=X=>(V,...te)=>{if(Ce){this.D.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}this.J(V),X(V,...te)},oe=(X,V)=>{const te=V instanceof Array?V.map(i.TestMessage.from):[i.TestMessage.from(V)];if(X.uri&&X.range){const ve={range:i.Range.from(X.range),uri:X.uri};for(const ue of te)ue.location=ue.location||ve}this.C.$appendTestMessagesInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),te)};let Ce=!1;const Le={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:X=>{if(Ce)return;const V=X instanceof r.$cP?X.fromTests:[];if(V.length){(0,m.$7G)(this.G,"attributableCoverage");for(const ue of V)this.J(ue)}const te=X.uri.toString(),ve=new c.$TI([me,ce,te]).toString();this.y.set(ve,{report:X,extIds:V.map(ue=>c.$TI.fromExtHostTestItem(ue,se).toString())}),this.C.$appendCoverage(me,ce,i.TestCoverage.fromFile(se,ve,X))},enqueued:we(X=>{this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),g.TestResultState.Queued)}),skipped:we(X=>{this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),g.TestResultState.Skipped)}),started:we(X=>{this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),g.TestResultState.Running)}),errored:we((X,V,te)=>{oe(X,V),this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),g.TestResultState.Errored,te)}),failed:we((X,V,te)=>{oe(X,V),this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,se).toString(),g.TestResultState.Failed,te)}),passed:we((X,V)=>{this.C.$updateTestStateInRun(me,ce,c.$TI.fromExtHostTestItem(X,this.z.controllerId).toString(),g.TestResultState.Passed,V)}),appendOutput:(X,V,te)=>{Ce||(te&&this.J(te),this.C.$appendOutputToRun(me,ce,I.$Pe.fromString(X),V&&i.location.from(V),te&&c.$TI.fromExtHostTestItem(te,se).toString()))},end:()=>{Ce||(Ce=!0,this.C.$finishedTestRunTask(me,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Le}),this.C.$startedTestRunTask(me,{id:ce,name:_,running:!0}),Le}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(_){if(!(_ instanceof h.$bQ))throw new l.$SP(_.id);if(this.h.has(c.$TI.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const me=[],se=this.z.colllection.root;for(;;){const ce=i.TestItem.from(_);if(me.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class f{get trackers(){return this.c.values()}constructor(_,me){this.g=_,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(_,me,se){const ce=c.$TI.root(_);return this.f.get(ce)?.getCoverageDetails(_,me,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[me,{id:se}]of this.c)se===_&&this.c.delete(me)}prepareForMainThreadTestRun(_,me,se,ce,we){return this.j(me,se,ce,_,we)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,me,se,ce,we,oe){const Ce=this.c.get(ce);if(Ce)return Ce.createRun(we);const Le=F.fromPublic(me,se,ce,oe),X=w(ce);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!ce.continuous,profile:X&&{group:Y[X.kind],id:X.profileId},exclude:ce.exclude?.map(te=>c.$TI.fromExtHostTestItem(te,se.root.id).toString())??[],id:Le.id,include:ce.include?.map(te=>c.$TI.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:oe});const V=this.j(ce,Le,ce.profile,_);return N.Event.once(V.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),V.createRun(we)}j(_,me,se,ce,we){const oe=new P(me,this.g,this.h,se,ce,we);return this.c.set(_,oe),this.f.set(oe.id,oe),oe}}e.$wpc=f;const w=ge=>{if(ge.profile){if(!(ge.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class F{static fromPublic(_,me,se,ce){return new F(_,(0,y.$3g)(),ce,me)}static fromInternal(_,me){return new F(_.controllerId,_.runId,!0,me)}constructor(_,me,se,ce){this.controllerId=_,this.id=me,this.isPersisted=se,this.colllection=ce}}e.$xpc=F;class O{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const me=c.$TI.parentId(_.item.extId);if(me&&this.h.has(me.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:me,g:se}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...me].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends g.$3I{constructor(){super(...arguments),this.y=new N.$ne,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,me){return{..._,revived:i.TestItem.toPlain(_.item),depth:me?me.depth+1:0,children:new Set}}w(){return new O(this.y)}}class q{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(me=>me.revived)},dispose:(0,A.$gb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new L({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const W=(ge,_,me,se)=>{me?Object.assign(me,se):_.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,W(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,W(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,W(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,W(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return N.Event.chain(this.#i,_=>_.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(R.$og))}constructor(_,me,se,ce,we,oe,Ce,Le,X,V=!1,te=void 0,ve=!1){this.controllerId=we,this.profileId=oe,this.f=Ce,this.kind=Le,this.runHandler=X,this._tag=te,this.g=ve,this.#e=_,this.#s=me,this.#t=se,this.#i=ce,me.set(oe,this);const ue=Y[Le];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);V&&se.add(oe),this.#n={profileId:oe,controllerId:we,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:Ce,group:ue,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$ypc=M;const Y={[r.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function Z(ge,_){for(let me=0;me<ge.path.length;me++){const se=_.find(ce=>ce.id===ge.path[me]);if(!se)return;if(me===ge.path.length-1)return se;_=se.children}}}),define(Ie[301],Pe([1,0,18,6,4,5,127,8,7]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,v=Ve(v),T=Ve(T);class a extends C.$Xc{constructor(y,u){super(),this.m=u,this.a=new I.$ne,this.b=new I.$ne,this.c=new I.$ne,this.f=new I.$ne,this.g=new I.$ne,this.h=new I.$ne,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(N.$uN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(E=>E.value)}async showTextDocument(y,u,E){let d;typeof u=="number"?d={position:T.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?d={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,d),s=n&&this.m.getEditor(n);if(s)return s.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new A.$8P(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const E=this.m.getEditor(y);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(T.Selection.to);E._acceptSelections(d)}if(u.visibleRanges){const d=v.$Kb(u.visibleRanges.map(T.Range.to));E._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:E.value,selections:n,kind:d})}if(u.visibleRanges){const d=v.$Kb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const u in y){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[u]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Foc=a}),define(Ie[302],Pe([1,0,2,3,5,4,7,8,19,38,15]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0,e.$qqc=(0,I.$Gi)("IExtHostTimeline");class y{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(C.$uN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$rn.equals(o,this.b.get(s.source)?.extension)){const h=s.uri===void 0?void 0:v.URI.revive(s.uri);return this.c.get(s.source)?.get(u(h))?.get(s.handle)}else return;return s}})}async $getTimeline(d,n,s,o){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(n),s,o)}registerTimelineProvider(d,n,s,o){const h=new N.$Wc,i=this.d(n.id,o,h).bind(this);let r;n.onDidChange&&(r=n.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(c,l,g){l?.resetCache&&(h.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(c,l,g);if(m==null)return;const $=i(c,l);return{...m,source:n.id,items:m.items.map($)}},dispose(){for(const c of t.values())c.get(n.id)?.clear();r?.dispose(),h.dispose()}},s)}d(d,n,s){return(o,h)=>{let i;if(h?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=u(o);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...c}=r,l=`${d}|${r.id??r.timestamp}`;i?.set(l,r);let g,m,$;r.iconPath&&(t instanceof A.$tO?$={id:t.id,color:t.color}:v.URI.isUri(t)?(g=t,m=t):{light:g,dark:m}=t);let D;return A.$YN.isMarkdownString(c.tooltip)?D=T.MarkdownString.from(c.tooltip):(0,R.$gg)(c.tooltip)?D=c.tooltip:A.$YN.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),D=T.MarkdownString.from(c.detail)):(0,R.$gg)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),D=c.detail),{...c,id:c.id??void 0,handle:l,source:d,command:r.command?n.toInternal(r.command,s):void 0,icon:g,iconDark:m,themeIcon:$,tooltip:D,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,N.$Vc)(()=>{for(const o of this.c.values())o.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$rqc=y;function u(E){return E?.toString()}}),define(Ie[303],Pe([1,0,190,24,2,6,4,233,11,7,15,18,8,60,22,154,25]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0,a=Ve(a);function o(r,t){if((0,R.$gg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let c;return Array.isArray(r.highlights)&&(c=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),c=c.length?c:void 0),{label:r.label,highlights:c}}}class h extends A.$Xc{constructor(t,c,l){super(),this.f=t,this.g=c,this.h=l,this.a=new Map,this.b=new n.$w_;function g(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}c.registerArgumentProcessor({processArgument:m=>g(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map($=>g($)?this.r($):$):m})}registerTreeDataProvider(t,c,l){const g=this.createTreeView(t,{treeDataProvider:c},l);return{dispose:()=>g.dispose()}}createTreeView(t,c,l){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=c.dragAndDropController?.dropMimeTypes??[],m=c.dragAndDropController?.dragMimeTypes??[],$=!!c.dragAndDropController?.handleDrag,D=!!c.dragAndDropController?.handleDrop,S=this.m(t,c,l),b={showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:g,dragMimeTypes:m,hasHandleDrag:$,hasHandleDrop:D,manuallyManageCheckboxes:!!c.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,b),P={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,s.$7G)(l,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,s.$7G)(l,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(f){(0,E.$6k)(f)&&(0,s.$7G)(l,"treeViewMarkdownMessage"),S.message=f},get title(){return S.title},set title(f){S.title=f},get description(){return S.description},set description(f){S.description=f},get badge(){return S.badge},set badge(f){f!==void 0&&a.ViewBadge.isViewBadge(f)?S.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(S.badge=void 0)},reveal:(f,w)=>S.reveal(f,w),dispose:async()=>{await k,this.a.delete(t),S.dispose()}};return this.B(P),P}$getChildren(t,c){const l=this.a.get(t);return l?l.getChildren(c):Promise.reject(new T.$qG(t))}async $handleDrop(t,c,l,g,m,$,D,S){const b=this.a.get(t);if(!b)return Promise.reject(new T.$qG(t));const k=u.DataTransfer.toDataTransfer(l,async P=>(await this.f.$resolveDropFileData(t,c,P)).buffer);return D===t&&S&&await this.j(k,b,S,m,$),b.onDrop(k,g,m)}async j(t,c,l,g,m){const $=this.b.removeDragOperationTransfer(m);if($)(await $)?.forEach((D,S)=>{D&&t.set(S,D)});else if(m&&c.handleDrag){const D=c.handleDrag(l,t,g);this.b.addDragOperationTransfer(m,D),await D}return t}async $handleDrag(t,c,l,g){const m=this.a.get(t);if(!m)return Promise.reject(new T.$qG(t));const $=await this.j(new a.$pO,m,c,g,l);if(!(!$||g.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(t){const c=this.a.get(t);if(!c)throw new T.$qG(t);return c.hasResolve}$resolve(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);return g.resolveTreeItem(c,l)}$setExpanded(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);g.setExpanded(c,l)}$setSelectionAndFocus(t,c,l){const g=this.a.get(t);if(!g)throw new T.$qG(t);g.setSelectionAndFocus(c,l)}$setVisible(t,c){const l=this.a.get(t);if(!l){if(!c)return;throw new T.$qG(t)}l.setVisible(c)}$changeCheckboxState(t,c){const l=this.a.get(t);if(!l)throw new T.$qG(t);l.setCheckboxState(c)}m(t,c,l){const g=this.B(new i(t,c,this.f,this.g.converter,this.h,l));return this.a.set(t,g),g}r(t){const c=this.a.get(t.$treeViewId);return c&&"$treeItemHandle"in t?c.getExtensionElement(t.$treeItemHandle):c&&"$focusedTreeItem"in t&&t.$focusedTreeItem?c.focusedElement:null}}e.$sqc=h;class i extends A.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$pg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,c,l,g,m,$){if(super(),this.I=t,this.J=l,this.L=g,this.M=m,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$ne),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$ne),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$ne),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$ne),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$ne),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$ne),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$ne),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ye,$.contributes&&$.contributes.views)for(const k in $.contributes.views)for(const P of $.contributes.views[k])P.id===t&&(this.P=P.name);this.f=c.treeDataProvider,this.g=c.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let D,S;const b=N.Event.debounce(this.F.event,(k,P)=>(k||(k={message:!1,elements:[]}),P.element!==!1&&(D||(D=new Promise(f=>S=f),this.G=this.G.then(()=>D)),Array.isArray(P.element)?k.elements.push(...P.element):k.elements.push(P.element)),P.message&&(k.message=!0),k),200,!0);this.B(b(({message:k,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const f=S;return D=null,this.$(P).then(()=>f())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const c=t?this.getExtensionElement(t):void 0;if(t&&!c)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(c)),l?l.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,c){c=c||{select:!0,focus:!1};const l=(0,R.$pg)(c.select)?!0:c.select,g=(0,R.$pg)(c.focus)?!1:c.focus,m=(0,R.$pg)(c.expand)?!1:c.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then($=>this.W(t,$[$.length-1]).then(D=>this.J.$reveal(this.I,{item:D.item,parentChain:$.map(S=>S.item)},{select:l,focus:g,expand:m})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:g,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,c){const l=this.getExtensionElement(t);l&&(c?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,c){const l=!(0,y.$xb)(this.s,t);this.s=t;const g=this.t!==c;this.t=c,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const c=(await Promise.all(t.map(async l=>{const g=this.getExtensionElement(l.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);c.forEach(l=>{l.treeItem.checkboxState=l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:c.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,c,l){const g=[];for(const m of t){const $=this.getExtensionElement(m);$&&g.push($)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,c,l),c}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,c,l){const g=c?this.getExtensionElement(c):void 0;if(!(!g&&c||!this.g?.handleDrop))return(0,p.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,c){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const g=this.m.get(l);if(g){const m=await this.f.resolveTreeItem(g.extensionItem,l,c)??g.extensionItem;return this.hb(m),g.item.tooltip=this.eb(m.tooltip),g.item.command=this.fb(g.disposableStore,m.command),g.item}}}S(t){return this.U(t).then(c=>c?this.S(c).then(l=>this.W(c,l[l.length-1]).then(g=>(l.push(g),l))):Promise.resolve([]))}U(t){const c=this.m.get(t);return c?Promise.resolve(c.parent?this.j.get(c.parent.item.handle):void 0):(0,p.$yh)(()=>this.f.getParent(t))}W(t,c){const l=this.m.get(t);return l?Promise.resolve(l):(0,p.$yh)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,c,!0)).then(g=>this.getChildren(c?c.item.handle:void 0).then(()=>{const m=this.getExtensionElement(g);if(m){const $=this.m.get(m);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let c;if(typeof t=="string"){const l=this.getExtensionElement(t);c=l?this.m.get(l):void 0}else c=t;return c&&c.children||void 0}return this.h}async Y(t){this.rb(t);const c=new d.$ye(this.Z.token);try{const l=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(c.token.isCancellationRequested)return;const m=(0,y.$Kb)(g||[]),$=await Promise.all((0,y.$Kb)(m).map(S=>this.f.getTreeItem(S)));if(c.token.isCancellationRequested)return;const D=$.map((S,b)=>S?this.db(m[b],S,l):null);return(0,y.$Kb)(D)}finally{c.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new d.$ye,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const c=new Set,l=t.map(m=>this.m.get(m));for(const m of l)if(m&&!c.has(m.item.handle)){let $=m;for(;$&&$.parent&&l.findIndex(D=>$&&$.parent&&D&&D.item.handle===$.parent.item.handle)===-1;){const D=this.j.get($.parent.item.handle);$=D?this.m.get(D):void 0}$&&!$.parent&&c.add(m.item.handle)}const g=[];return c.forEach(m=>{const $=this.j.get(m);if($){const D=this.m.get($);D&&(!D.parent||!c.has(D.parent.item.handle))&&g.push(m)}}),g}bb(t){const c={};return Promise.all(t.map(l=>this.cb(l).then(g=>{g&&(c[l]=g.item)}))).then(()=>Object.keys(c).length?this.J.$refresh(this.I,c):void 0)}cb(t){const c=this.getExtensionElement(t);if(c){const l=this.m.get(c);if(l)return this.rb(c),(0,p.$yh)(()=>this.f.getTreeItem(c)).then(g=>{if(g){const m=this.ib(c,g,l.parent);return this.pb(c,m,l,l.parent),l.dispose(),m}return null})}return Promise.resolve(null)}db(t,c,l){const g=this.ib(t,c,l);if(c.id&&this.j.has(g.item.handle))throw new Error((0,v.localize)(0,null,c.id));return this.ob(t,g),this.qb(g,l),g}eb(t){return a.$YN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,c){return c?{...this.L.toInternal(c,t),originalId:c.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let c,l,g;return typeof t.checkboxState=="number"?c=t.checkboxState:(c=t.checkboxState.state,l=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:c===a.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:g}}hb(t){if(!a.$kO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,c,l){this.hb(c);const g=this.B(new A.$Wc),m=this.kb(t,c,l),$=this.lb(c);return{item:{handle:m,parentHandle:l?l.item.handle:void 0,label:o(c.label,this.N),description:c.description,resourceUri:c.resourceUri,tooltip:this.eb(c.tooltip),command:this.fb(g,c.command),contextValue:c.contextValue,icon:$,iconDark:this.mb(c)||$,themeIcon:this.jb(c),collapsibleState:(0,R.$pg)(c.collapsibleState)?a.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation,checkbox:this.gb(c)},extensionItem:c,parent:l,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof a.$tO?t.iconPath:void 0}kb(t,{id:c,label:l,resourceUri:g},m,$){if(c)return`${i.b}/${c}`;const D=o(l,this.N),S=m?m.item.handle:i.a;let b=D?D.label:g?(0,I.$eh)(g):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(m)||[];let f,w=0;do{if(f=`${S}/${w}:${b}`,$||!this.j.has(f)||k===f)break;w++}while(w<=P.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$tO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,c){this.j.set(c.item.handle,t),this.m.set(t,c)}pb(t,c,l,g){this.j.delete(c.item.handle),this.m.delete(t),c.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,c);const m=this.X(g)||[],$=m.filter(D=>D.item.handle===l.item.handle)[0];$&&m.splice(m.indexOf($),1,c)}qb(t,c){c?(c.children||(c.children=[]),c.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}c.children=void 0}}else this.tb()}sb(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(c.item.handle),c.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ie[304],Pe([1,0,6,4,2,37,8,68,5,7]),function(ae,e,v,I,C,N,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0,A=Ve(A),p=Ve(p),a=Ve(a);class R extends I.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new v.$ne),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$ne),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,C.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends I.$Xc{static c(){return(0,N.$3g)()}constructor(d,n,s){super(),this.j=n,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$uN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,s,o,h={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},t=(0,T.$Uoc)(d),c=y.c();this.f.$createWebviewPanel((0,T.$Woc)(d),c,n,{title:s,panelOptions:u(h),webviewOptions:(0,T.$Xoc)(d,this.m,h),serializeBuffersForPostMessage:t},r);const l=this.j.createNewWebview(c,h,d);return this.createNewWebviewPanel(c,n,s,i,h,l,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((s,o)=>{const h=d[s],i=d[o];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const s of n){const o=this.getWebviewPanel(s);if(!o)continue;const h=d[s];o._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,s){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:s,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Uoc)(d)}),new a.$wN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,s,o){const h=this.h.get(n);if(!h)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=h,t=this.j.createNewWebview(d,s.webviewOptions,r),c=this.createNewWebviewPanel(d,n,s.title,o,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(c,s.state)}createNewWebviewPanel(d,n,s,o,h,i,r){const t=new R(d,this.f,i,{viewType:n,title:s,viewColumn:o,panelOptions:h,active:r});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$Yoc=y;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ie[305],Pe([1,0,6,4,68,8,5,7]),function(ae,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0,A=Ve(A),T=Ve(T);class p extends I.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,E,d,n,s){super(),this.#s=!1,this.#u=this.B(new v.$ne),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new v.$ne),this.onDidDispose=this.#l.event,this.#i=E,this.#a=d,this.#e=y,this.#t=u,this.#n=n,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$uN.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,E,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:y}),this.a.$registerWebviewViewProvider((0,C.$Woc)(y),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Uoc)(y)}),new T.$wN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,E,d,n){const s=this.b.get(u);if(!s)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:h}=s,i=this.d.createNewWebview(y,{},h),r=new p(y,this.a,u,E,i,!0);this.c.set(y,r),await o.resolveWebviewView(r,{state:d},n)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$vqc=a}),define(Ie[306],Pe([1,0,6,31,32,3]),function(ae,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.OutputChannelUpdateMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=void 0,e.$CM="text/x-code-output",e.$DM="output",e.$EM="Log",e.$FM="text/x-code-log-output",e.$GM="log",e.$HM="workbench.panel.output",e.$IM=new C.$Xj("inOutput",!1),e.$JM=new C.$Xj("activeLogOutput",!1),e.$KM=new C.$Xj("activeLogOutput.levelSettable",!1),e.$LM=new C.$Xj("activeLogOutput.level",""),e.$MM=new C.$Xj("activeLogOutput.levelIsDefault",!1),e.$NM=new C.$Xj("outputView.scrollLock",!1),e.$OM=(0,N.$Gi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$PM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$ne,this.onDidRegisterChannel=this.b.event,this.c=new v.$ne,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(R=>a.push(R)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}I.$ro.add(e.$PM.OutputChannels,new T),e.$QM=new C.$Xj("activeOutputChannel","")}),define(Ie[128],Pe([1,0,5,3,17,19,12,306,69,27,51,158,23,15,30,6,4]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=e.$$pc=void 0;class o extends A.$gk{get disposed(){return this.n}constructor(t,c,l,g,m){super(),this.id=t,this.name=c,this.r=l,this.s=g,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const c=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,c),this.visible&&this.r.flush()}show(t,c){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:c))}hide(){this.s.$close(this.id)}g(t,c){this.m+=u.$Pe.fromString(c).byteLength,(0,A.log)(this.r,t,c),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends o{appendLine(t){this.append(t)}}let i=class{constructor(t,c,l,g,m,$){this.i=c,this.j=l,this.k=g,this.l=m,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$uN.MainThreadOutputService),this.b=this.k.extUri.joinPath(c.logsLocation,`output_logging_${(0,y.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[c,l]of this.g)l.visible=c===this.h}createOutputChannel(t,c,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof c=="object"&&c.log,m=(0,E.$gg)(c)?c:void 0;if((0,E.$gg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const D=this.i.environment.extensionLogLevel?.find(([b])=>N.$rn.equals(l.identifier,b))?.[1];D&&($=(0,A.$rk)(D));const S=g?this.o(t,$,l):this.n(t,m,l);return S.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),g?this.r(t,$??this.m.getLevel(),S):this.q(t,S)}async n(t,c,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,m=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.a.$register(t,m,c,l.identifier.value);return new o(D,t,$,this.a,l)}async o(t,c,l){const g=await this.p(l),m=t.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(g,`${m}.log`),D=`${l.identifier.value}.${m}`,S=this.l.createLogger($,{id:D,name:t,logLevel:c,extensionId:l.identifier.value});return new h(D,t,S,this.a,l)}p(t){let c=this.d.get(t.identifier.value);if(!c){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,c=(async()=>{try{await this.j.value.createDirectory(l)}catch(g){if((0,d.$ql)(g)!==d.FileSystemProviderErrorCode.FileExists)throw g}return l})())}return c}q(t,c){let l=!1;const g=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(m){g(),c.then($=>$.append(m))},appendLine(m){g(),c.then($=>$.appendLine(m))},clear(){g(),c.then(m=>m.clear())},replace(m){g(),c.then($=>$.replace(m))},show(m,$){g(),c.then(D=>D.show(m,$))},hide(){g(),c.then(m=>m.hide())},dispose(){l=!0,c.then(m=>m.dispose())}}}r(t,c,l){const g=new s.$Wc,m=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},$=g.add(new n.$ne);function D(S){c=S,$.fire(S)}return l.then(S=>{g.add(S),S.logLevel!==c&&D(S.logLevel),g.add(S.onDidChangeLogLevel(b=>D(b)))}),{...this.q(t,l),get logLevel(){return c},onDidChangeLogLevel:$.event,trace(S,...b){m(),l.then(k=>k.trace(S,...b))},debug(S,...b){m(),l.then(k=>k.debug(S,...b))},info(S,...b){m(),l.then(k=>k.info(S,...b))},warn(S,...b){m(),l.then(k=>k.warn(S,...b))},error(S,...b){m(),l.then(k=>k.error(S,...b))},dispose(){g.dispose()}}}};e.$$pc=i,e.$$pc=i=He([qe(0,C.$1P),qe(1,a.$eQ),qe(2,p.$Qoc),qe(3,R.$toc),qe(4,A.$bk),qe(5,A.$ak)],i),e.$_pc=(0,I.$Gi)("IExtHostOutputService")}),define(Ie[129],Pe([1,0,3,11]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,v.$Gi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let N=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await C.getRoundTripTime();if(p===void 0)return;N=Math.min(N,p/2),await(0,I.$Hh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ie[307],Pe([1,0,193,54,31,50,43,4,6,129,21,26,11,114]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=void 0,e.$3K=Object.freeze({id:"application",order:100,title:(0,v.localize)(0,null),type:"object"}),e.$4K=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(1,null),type:"object"}),e.$5K=Object.freeze({id:"security",scope:I.ConfigurationScope.APPLICATION,title:(0,v.localize)(2,null),type:"object",order:7}),e.$6K=Object.freeze({id:"problems",title:(0,v.localize)(3,null),type:"object",order:101}),e.$7K=Object.freeze({id:"window",order:8,title:(0,v.localize)(4,null),type:"object"}),e.$8K={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$ne,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;C.$ro.add(e.$8K.ConfigurationMigration,n);let s=class extends T.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(c=>this.g(c,r?.uri))])}async g(r,t){const c=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===N.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[g,m]of l){const $=c[g];if(!$)continue;const D=[];if($.value!==void 0){const S=await this.h(r,g,$.value,t,void 0);for(const b of S??[])D.push([b,[]])}for(const{identifiers:S,value:b}of $.overrides??[])if(b!==void 0){const k=await this.h(r,g,b,t,S);for(const P of k??[])D.push([P,S])}D.length&&await Promise.allSettled(D.map(async([[S,b],k])=>this.a.updateValue(S,b.value,{resource:t,overrideIdentifiers:k},m)))}}async h(r,t,c,l,g){const m=D=>{const b=this.a.inspect(D,{resource:l})[t];if(b)return g?b.overrides?.find(({identifiers:k})=>(0,y.$io)(k,g))?.value:b.value},$=await r.migrateFn(c,m);return Array.isArray($)?$:[[r.key,$]]}};e.$9K=s,e.$9K=s=He([qe(0,A.$aj),qe(1,N.$Pi)],s);let o=class extends T.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;C.$ro.as(I.$wo.Configuration).registerConfiguration({...e.$5K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(5,null)},default:[],markdownDescription:(0,v.localize)(6,null),scope:I.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(7,null),scope:I.ConfigurationScope.MACHINE}}})}};e.$0K=o,e.$0K=o=He([qe(0,a.$Wm)],o),e.$$K="window.newWindowProfile";let h=class extends T.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(c=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(c=>{c.source!==A.ConfigurationTarget.DEFAULT&&c.affectsConfiguration(e.$$K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=C.$ro.as(I.$wo.Configuration),t={...e.$7K,properties:{[e.$$K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(c=>c.name),null],enumItemLabels:[...this.c.profiles.map(c=>""),(0,v.localize)(8,null)],description:(0,v.localize)(9,null),scope:I.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$$K);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$$K);if(!r)return;const t=this.b?this.c.profiles.find(c=>c.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$$K,t?.name)}};e.$_K=h,e.$_K=h=He([qe(0,E.$Ml),qe(1,A.$aj)],h)}),define(Ie[308],Pe([1,0,42,16,20,24,204,307,54,3,31]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$bL=e.$aL=void 0,e.$cL=n,e.$dL=s,v=Ve(v),e.$aL=(0,a.$Gi)("editorResolverService"),e.$bL="workbench.editorAssociations";const y=R.$ro.as(p.$wo.Configuration),u={...T.$4K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function s(o,h){if(new Set([I.Schemas.extension,I.Schemas.webviewPanel,I.Schemas.vscodeWorkspaceTrust,I.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof o=="string"&&o.indexOf(C.$jc.sep)>=0?`${h.scheme}:${h.path}`:(0,N.$eh)(h);return v.$zk(typeof o=="string"?o.toLowerCase():o,t.toLowerCase())}}),define(Ie[309],Pe([1,0,53,16,20,21,24,2,3,227,50,247,129]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,p.$Gi)("pathService");let d=E=class{constructor(s,o,h,i){this.d=s,this.e=o,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??s})()}hasValidBasename(s,o,h){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,h)}h(s,o,h){return s.scheme===I.Schemas.file||s.scheme===I.Schemas.vscodeRemote?(0,v.$Dg)(h??(0,A.$eh)(s),o===N.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return I.Schemas.vscodeRemote;const h=(0,a.$6M)(o.getWorkspace());if(h)return h;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:I.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===N.OperatingSystem.Windows?C.$ic:C.$jc)}async fileURI(s){let o="";if(await this.a===N.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:I.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$0M=d,e.$0M=d=E=He([qe(1,u.$Wm),qe(2,y.$RM),qe(3,R.$Pi)],d)}),define(Ie[130],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KL=e.$JL=void 0;class v{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new v(0,0)}with(A){return new v(0,0)}}e.$JL=v;class I{constructor(A,T,p,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,T),this.end=new v(p,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new I(0,0,0,0)}with(A){return new I(0,0,0,0)}}e.$KL=I;var C;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ie[44],Pe([1,0,18,42,26,53,13,3,20,14,130,11]),function(ae,e,v,I,C,N,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$9L=e.$2L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$YL=e.$XL=e.$WL=e.$VL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TextSearchCompleteMessageType=void 0,e.$SL=o,e.$TL=h,e.$UL=i,e.$ZL=S,e.$1L=b,e.$3L=f,e.$4L=w,e.$5L=F,e.$6L=O,e.$7L=L,e.$8L=q,e.$0L=M,e.$_L=ge,e.$aM=_,I=Ve(I),C=Ve(C),N=Ve(N),p=Ve(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$LL="workbench.view.search",e.$ML="workbench.panel.search",e.$NL="workbench.view.search",e.$OL="search-result",e.$PL="search.exclude",e.$QL=2e4;const u="\u27EA ",E=" characters skipped \u27EB",d=(u.length+E.length+5)*2;e.$RL=(0,T.$Gi)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var s;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(se){return!!se.preview}function h(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$VL=t;class c{constructor(ce,we,oe,Ce){this.ranges=we,this.webviewIndex=Ce;const Le=Array.isArray(we)?we:[we];if(oe&&oe.matchLines===1&&l(Le)){ce=(0,A.$_f)(ce,oe.matchLines);let X="",V=0,te=0;const ve=Math.floor(oe.charsPerLine/5),ue=[];for(const be of Le){const de=Math.max(be.startColumn-ve,0),J=be.startColumn+oe.charsPerLine;if(de>te+ve+d){const x=u+(de-te)+E;X+=x+ce.slice(de,J),V+=de-(te+x.length)}else X+=ce.slice(te,J);ue.push(new m(0,be.startColumn-V,be.endColumn-V)),te=J}this.preview={text:X,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const X=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,v.$4b)(we,V=>new g(V.startLineNumber-X,V.startColumn,V.endLineNumber-X,V.endColumn))}}}}e.$WL=c;function l(se){const ce=se[0].startLineNumber;for(const we of se)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class g{constructor(ce,we,oe,Ce){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=oe,this.endColumn=Ce}}e.$XL=g;class m extends g{constructor(ce,we,oe){super(ce,we,ce,oe)}}e.$YL=m;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var D;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function S(se,ce=!0){const we=se&&se.files&&se.files.exclude,oe=ce&&se&&se.search&&se.search.exclude;if(!we&&!oe)return;if(!we||!oe)return we||oe;let Ce=Object.create(null);return Ce=C.$ho(Ce,C.$eo(we)),Ce=C.$ho(Ce,C.$eo(oe),!0),Ce}function b(se,ce){return se.excludePattern&&I.$zk(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&I.$zk(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(we=>{const oe=we.folder.fsPath;if(N.$Fg(ce,oe)){const Ce=p.$oc(oe,ce);return!we.includePattern||!!I.$zk(we.includePattern,Ce)}else return!1}):!1:!0}var k;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class P extends Error{constructor(ce,we){super(ce),this.code=we}}e.$2L=P;function f(se){const ce=se.message;if((0,a.$7)(se))return new P(ce,k.canceled);try{const we=JSON.parse(ce);return new P(we.message,we.code)}catch{return new P(ce,k.other)}}function w(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function F(se){return se.type==="error"?!0:se.type==="success"}function O(se){return se.type==="success"}function L(se){return!!se.path}function q(se,ce,we=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return we?(0,A.$9f)(oe,ce):I.$zk(ce,oe)}class W{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9L=W;function M(se,ce){const we={...se||{},...ce||{}};return Object.keys(we).filter(oe=>{const Ce=we[oe];return typeof Ce=="boolean"&&Ce})}class Y{constructor(ce,we){this.c=null,this.a={...ce.excludePattern||{},...we.excludePattern||{}},this.b=I.$Ak(this.a);let oe=ce.includePattern;we.includePattern&&(oe?oe={...oe,...we.includePattern}:oe=we.includePattern),oe&&(this.c=I.$Ak(oe))}matchesExcludesSync(ce,we,oe){return!!(this.b&&this.b(ce,we,oe))}includedInQuerySync(ce,we,oe){return!(this.b&&this.b(ce,we,oe)||this.c&&!this.c(ce,we,oe))}includedInQuery(ce,we,oe){const Ce=this.b(ce,we,oe),Le=()=>this.c?!!this.c(ce,we,oe):!0;return(0,y.$sh)(Ce)?Ce.then(X=>X?!1:Le()):Le()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$$L=Y;function Z(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function ge(se){if(!se)return;let ce;return we=>(ce||(ce=(se()||Promise.resolve([])).then(oe=>oe?me(oe):{})),ce.then(oe=>!!oe[we]))}function _(se){if(!se)return;let ce;return we=>{if(!ce){const oe=se();ce=oe?me(oe):{}}return!!ce[we]}}function me(se){const ce={};for(const we of se)ce[we]=!0;return ce}}),define(Ie[45],Pe([1,0,18,11,22,6,4,59,16,139,24,13,2,192,30,3,12,214,50,51,27,17,8,7,66,44,5,49]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;function S(L,q,W){return new R.$9g(M=>f(M,W)).isEqual(L,q)}function b(L,q,W){return S(L.uri,q.uri,W)?0:(0,y.$Af)(L.uri.toString(),q.uri.toString())}function k(L,q,W){return L.index!==q.index?L.index<q.index?-1:1:S(L.uri,q.uri,W)?(0,y.$Af)(L.name,q.name):(0,y.$Af)(L.uri.toString(),q.uri.toString())}function P(L,q,W,M){const Y=L.slice(0).sort((ge,_)=>W(ge,_,M)),Z=q.slice(0).sort((ge,_)=>W(ge,_,M));return(0,v.$Hb)(Y,Z,(ge,_)=>W(ge,_,M))}function f(L,q){const W=q.getCapabilities(L.scheme);return!(W&&W&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends h.$Zi{static toExtHostWorkspace(q,W,M,Y){if(!q)return{workspace:null,added:[],removed:[]};const{id:Z,name:ge,folders:_,configuration:me,transient:se,isUntitled:ce}=q,we=[],oe=W;W?_.forEach((V,te)=>{const ve=u.URI.revive(V.uri),ue=w.o(M||W,ve,Y);ue?(ue.name=V.name,ue.index=V.index,we.push(ue)):we.push({uri:ve,name:V.name,index:te})}):we.push(..._.map(({uri:V,name:te,index:ve})=>({uri:u.URI.revive(V),name:te,index:ve}))),we.sort((V,te)=>V.index<te.index?-1:1);const Ce=new w(Z,ge,we,!!se,me?u.URI.revive(me):null,!!ce,V=>f(V,Y)),{added:Le,removed:X}=P(oe?oe.workspaceFolders:[],Ce.workspaceFolders,b,Y);return{workspace:Ce,added:Le,removed:X}}static o(q,W,M){for(let Y=0;Y<q.folders.length;Y++){const Z=q.workspaceFolders[Y];if(S(Z.uri,W,M))return Z}}constructor(q,W,M,Y,Z,ge,_){super(q,M.map(me=>new h.$1i(me)),Y,Z,_),this.t=W,this.u=ge,this.q=[],this.s=T.$Mi.forUris(_,()=>!0),M.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,W){return W&&this.s.get(q)&&(q=(0,R.$gh)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let F=class{constructor(q,W,M,Y,Z){this.c=new N.$ne,this.onDidChangeWorkspace=this.c.event,this.g=new N.$ne,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$pe,this.C=new Map,this.h=Y,this.s=M,this.t=Z,this.j=new a.$Nm,this.k=new I.$Fh,this.o=q.getProxy($.$uN.MainThreadWorkspace),this.q=q.getProxy($.$uN.MainThreadMessageService);const ge=W.workspace;this.l=ge?new w(ge.id,ge.name,[],!!ge.transient,ge.configuration?u.URI.revive(ge.configuration):null,!!ge.isUntitled,_=>f(_,M)):void 0}$initializeWorkspace(q,W){this.v=W,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,R.$eh)((0,R.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,W,M,...Y){const Z=[];if(Array.isArray(Y)&&Y.forEach(ce=>{u.URI.isUri(ce.uri)&&!Z.some(we=>S(we.uri,ce.uri,this.s))&&Z.push({uri:ce.uri,name:ce.name||(0,R.$dh)(ce.uri)})}),this.n||[W,M].some(ce=>typeof ce!="number"||ce<0)||M===0&&Z.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(W+M>ge.length)return!1;const _=ge.slice(0);_.splice(W,M,...Z.map(ce=>({uri:ce.uri,name:ce.name||(0,R.$dh)(ce.uri),index:void 0})));for(let ce=0;ce<_.length;ce++){const we=_[ce];if(_.some((oe,Ce)=>Ce!==ce&&S(we.uri,oe.uri,this.s)))return!1}_.forEach((ce,we)=>ce.index=we);const{added:me,removed:se}=P(ge,_,k,this.s);if(me.length===0&&se.length===0)return!1;if(this.o){const ce=q.displayName||q.name;this.o.$updateWorkspaceFolders(ce,W,M,Z).then(void 0,we=>{this.n=void 0;const oe={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(o.Severity.Error,(0,E.localize)(0,null,ce,we.toString()),oe,[])})}return this.y(_),!0}getWorkspaceFolder(q,W){if(this.x)return this.x.getWorkspaceFolder(q,W)}async getWorkspaceFolder2(q,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,W)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,W){let M,Y="";if(typeof q=="string"?(M=u.URI.file(q),Y=q):typeof q<"u"&&(M=q,Y=q.fsPath),!M)return Y;const Z=this.getWorkspaceFolder(M,!0);if(!Z)return Y;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ge=(0,R.$jh)(Z.uri,M);return W&&Z.name&&(ge=`${Z.name}/${ge}`),ge}y(q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:W,added:M,removed:Y}=w.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:Y}))}findFiles(q,W,M,Y,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Y.value}, entryPoint: findFiles`);let ge="",_=!0;return W===null?_=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this.z(q,void 0,{exclude:ge,maxResults:M,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(q,W={},M,Y=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,q,W,Y)}async z(q,W,M,Y=C.CancellationToken.None){if(Y&&Y.isCancellationRequested)return Promise.resolve([]);const Z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ge={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:Z,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let _;if(q){const{includePattern:me,folder:se}=O(c.GlobPattern.from(q));_=se,ge.includePattern=me}else{const{includePattern:me,folder:se}=O(c.GlobPattern.from(W));_=se,ge.filePattern=me}return this.o.$startFileSearch(_??null,ge,Y).then(me=>Array.isArray(me)?me.map(se=>u.URI.revive(se)):[])}async findTextInFiles(q,W,M,Y,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Y.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),_=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:me,folder:se}=O(c.GlobPattern.from(W.include)),ce=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,we={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:_,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:me,excludePattern:ce},oe=!1;if(this.u[ge]=Ce=>{if(oe)return;const Le=u.URI.revive(Ce.resource);Ce.results.forEach(X=>{const V=(0,D.$di)(X);(0,m.$SL)(V)?M({uri:Le,preview:{text:V.preview.text,matches:(0,v.$4b)(V.preview.matches,te=>new l.$yN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$4b)(V.ranges,te=>new l.$yN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):M({uri:Le,text:V.text,lineNumber:V.lineNumber})})},Z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(q,se??null,we,ge,Z);return delete this.u[ge],Ce||{}}catch(Ce){throw delete this.u[ge],Ce}}$handleTextSearchResult(q,W){this.u[W]?.(q)}async save(q){const W=await this.o.$save(q,{saveAs:!1});return u.URI.revive(W)}async saveAs(q){const W=await this.o.$save(q,{saveAs:!0});return u.URI.revive(W)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,W){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,W);const M=this.t.transformOutgoingScheme(q),Y=this.A++;return this.o.$registerEditSessionIdentityProvider(Y,M),(0,A.$Vc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(Y)})}async $getEditSessionIdentifier(q,W){this.h.info("Getting edit session identifier for workspaceFolder",q);const M=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const Y=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!Y),!Y)return;const Z=await Y.provideEditSessionIdentity(M,W);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(q,W,M,Y){this.h.info("Getting edit session identifier for workspaceFolder",q);const Z=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const ge=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!ge),!ge)return;const _=await ge.provideEditSessionIdentityMatch?.(W,M,Y);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(q){return(W,M,Y)=>{const Z=function(_){W.call(M,_)};return Z.extension=q,this.B.event(Z,void 0,Y)}}async $onWillCreateEditSessionIdentity(q,W,M){const Y=await this.resolveWorkspaceFolder(u.URI.revive(q));if(Y===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Y},W,async(Z,ge)=>{const _=Date.now();await Promise.resolve(Z),Date.now()-_>M&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(q,W){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,W);const M=this.t.transformOutgoingScheme(q),Y=this.A++;return this.o.$registerCanonicalUriProvider(Y,M),(0,A.$Vc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(Y)})}async provideCanonicalUri(q,W,M){const Y=this.C.get(q.scheme);if(!Y)return;const Z=await Y.provideCanonicalUri?.(u.URI.revive(q),W,M);if(Z)return Z}async $provideCanonicalUri(q,W,M){return this.provideCanonicalUri(u.URI.revive(q),{targetScheme:W},M)}};e.$Koc=F,e.$Koc=F=He([qe(0,t.$1P),qe(1,r.$eQ),qe(2,i.$toc),qe(3,s.$ak),qe(4,g.$Ioc)],F),e.$Loc=(0,n.$Gi)("IExtHostWorkspace");function O(L){let q,W;return L&&(typeof L=="string"?q=L:(q=L.pattern,W=u.URI.revive(L.baseUri))),{includePattern:q,folder:W}}}),define(Ie[46],Pe([1,0,26,6,45,5,7,43,215,54,15,11,3,17,12,2]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=e.$Moc=void 0;function s(g,m){if(m){const $=m.split(".");let D=g;for(let S=0;D&&S<$.length;S++)D=D[$[S]];return D}}function o(g){return g instanceof n.URI}function h(g){return g&&g.uri instanceof n.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function r(g){return g&&g.uri instanceof n.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(o(g))return{resource:g};if(h(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(r(g))return{resource:g.uri};if(g===null)return{resource:null}}let c=class{constructor(m,$,D){this.a=m.getProxy(N.$uN.MainThreadConfiguration),this.c=$,this.b=D,this.d=new y.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new l(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,$){this.getConfigProvider().then(D=>D.$acceptConfigurationChanged(m,$))}};e.$Moc=c,e.$Moc=c=He([qe(0,E.$1P),qe(1,C.$Loc),qe(2,d.$ak)],c);class l{constructor(m,$,D,S){this.a=new I.$ne,this.b=m,this.f=S,this.c=$,this.e=p.$Po.parse(D,S),this.d=this.k(D.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,$){const D={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Po.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j($,D))}getConfiguration(m,$,D){const S=t($)||{},b=this.g(m?s(this.e.getValue(void 0,S,this.c.workspace),m):this.e.getValue(void 0,S,this.c.workspace));m&&this.h(m,S,D?.identifier);function k(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(f){return typeof s(b,f)<"u"},get:(f,w)=>{this.h(m?`${m}.${f}`:f,S,D?.identifier);let F=s(b,f);if(typeof F>"u")F=w;else{let O;const L=(q,W)=>{if((0,R.$ig)(q)){let M;const Y=()=>{O=O||(0,v.$eo)(b),M=M||s(O,W)};return new Proxy(q,{get:(Z,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return Y(),()=>M;if(O)return M=M||s(O,W),M[ge];const _=Z[ge];return typeof ge=="string"?L(_,`${W}.${ge}`):_},set:(Z,ge,_)=>(Y(),M&&(M[ge]=_),!0),deleteProperty:(Z,ge)=>(Y(),M&&delete M[ge],!0),defineProperty:(Z,ge,_)=>(Y(),M&&Object.defineProperty(M,ge,_),!0)})}return Array.isArray(q)?(0,v.$eo)(q):q};F=L(F,f)}return F},update:(f,w,F,O)=>{f=m?`${m}.${f}`:f;const L=k(F);return w!==void 0?this.b.$updateConfigurationOption(L,f,w,S,O):this.b.$removeConfigurationOption(L,f,S,O)},inspect:f=>{f=m?`${m}.${f}`:f;const w=this.e.inspect(f,S,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$eo)(w.policy?.value??w.default?.value),globalValue:(0,v.$eo)(w.user?.value??w.application?.value),workspaceValue:(0,v.$eo)(w.workspace?.value),workspaceFolderValue:(0,v.$eo)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$eo)(w.default?.override),globalLanguageValue:(0,v.$eo)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$eo)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$eo)(w.workspaceFolder?.override),languageIds:(0,v.$eo)(w.overrideIdentifiers)}}};return typeof b=="object"&&(0,v.$ho)(P,b,!1),Object.freeze(P)}g(m){const $=D=>(0,R.$ig)(D)?new Proxy(D,{get:(S,b)=>$(S[b]),set:(S,b,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(S,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(S,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):D;return $(m)}h(m,$,D){const S=a.$Go.test(m)?a.ConfigurationScope.RESOURCE:this.d.get(m),b=D?`[${D.value}] `:"";if(a.ConfigurationScope.RESOURCE===S){typeof $?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===S){$?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,$){const D=new p.$Ro(m,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,b)=>D.affectsConfiguration(S,t(b))})}k(m){return m.reduce(($,D)=>($.set(D[0],D[1]),$),new Map)}}e.$Noc=l,e.$Ooc=(0,u.$Gi)("IExtHostConfiguration")}),define(Ie[131],Pe([1,0,2,11,6,5,7,45,58,46,22,57,17,27,3,16,21,12,85,251,14]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=e.$kqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=Ve(A),s=Ve(s);var t;(function(O){function L(W){if(W!=null)return W}O.from=L;function q(W){if(W!=null)return W}O.to=q})(t||(t={}));var c;(function(O){function L(W){if(W!=null)return W}O.from=L;function q(W){if(W!=null)return W}O.to=q})(c||(c={}));var l;(function(O){function L(W){if(W!=null)return W}O.from=L;function q(W){if(W!=null)return W}O.to=q})(l||(l={}));var g;(function(O){function L(M){if(M){const Y=M;return Y&&!!Y.process}else return!1}O.is=L;function q(M){if(M==null)return;const Y={process:M.process,args:M.args};return M.options&&(Y.options=l.from(M.options)),Y}O.from=q;function W(M){if(M!=null)return new A.$gO(M.process,M.args,M.options)}O.to=W})(g||(g={}));var m;(function(O){function L(W){if(W!=null)return W}O.from=L;function q(W){if(W!=null)return W}O.to=q})(m||(m={}));var $;(function(O){function L(M){if(M){const Y=M;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}O.is=L;function q(M){if(M==null)return;const Y={};return M.commandLine!==void 0?Y.commandLine=M.commandLine:(Y.command=M.command,Y.args=M.args),M.options&&(Y.options=m.from(M.options)),Y}O.from=q;function W(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.$hO(M.commandLine,M.options):new A.$hO(M.command,M.args?M.args:[],M.options)}O.to=W})($||($={}));var D;(function(O){function L(M){if(M){const Y=M;return Y&&Y.customExecution==="customExecution"}else return!1}O.is=L;function q(M){return{customExecution:"customExecution"}}O.from=q;function W(M,Y){return Y.get(M)}O.to=W})(D||(e.CustomExecutionDTO=D={}));var S;(function(O){function L(q,W){let M;return q.scope!==void 0&&typeof q.scope!="number"?M=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?M=W.workspaceFile:M=i.$II),{id:q._id,workspaceFolder:M}}O.from=L})(S||(e.TaskHandleDTO=S={}));var b;(function(O){function L(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}O.from=L})(b||(b={}));var k;(function(O){function L(M,Y){if(M==null)return[];const Z=[];for(const ge of M){const _=q(ge,Y);_&&Z.push(_)}return Z}O.fromMany=L;function q(M,Y){if(M==null)return;let Z;M.execution instanceof A.$gO?Z=g.from(M.execution):M.execution instanceof A.$hO?Z=$.from(M.execution):M.execution&&M.execution instanceof A.$iO&&(Z=D.from(M.execution));const ge=t.from(M.definition);let _;return M.scope?typeof M.scope=="number"?_=M.scope:_=M.scope.uri:_=A.TaskScope.Workspace,!ge||!_?void 0:{_id:M._id,definition:ge,name:M.name,source:{extensionId:Y.identifier.value,label:M.source,scope:_},execution:Z,isBackground:M.isBackground,group:b.from(M.group),presentationOptions:c.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=q;async function W(M,Y,Z){if(M==null)return;let ge;g.is(M.execution)?ge=g.to(M.execution):$.is(M.execution)?ge=$.to(M.execution):D.is(M.execution)&&(ge=D.to(M._id,Z));const _=t.to(M.definition);let me;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?me=M.source.scope:me=await Y.resolveWorkspaceFolder(v.URI.revive(M.source.scope)):me=A.TaskScope.Workspace),!_||!me)return;const se=new A.$jO(_,me,M.name,M.source.label,ge,M.problemMatchers);return M.isBackground!==void 0&&(se.isBackground=M.isBackground),M.group!==void 0&&(se.group=A.$fO.from(M.group._id),se.group&&M.group.isDefault&&(se.group=new A.$fO(se.group.id,se.group.label),M.group.isDefault===!0&&(se.group.isDefault=M.group.isDefault))),M.presentationOptions&&(se.presentationOptions=c.to(M.presentationOptions)),M._id&&(se._id=M._id),M.detail&&(se.detail=M.detail),se}O.to=W})(k||(e.TaskDTO=k={}));var P;(function(O){function L(W){return W}O.from=L;function q(W){if(W)return Object.assign(Object.create(null),W)}O.to=q})(P||(P={}));class f{#e;constructor(L,q,W){this._id=q,this.a=W,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,q,W,M,Y,Z,ge,_){this.q=new C.$ne,this.r=new C.$ne,this.s=new C.$ne,this.u=new C.$ne,this.a=L.getProxy(N.$uN.MainThreadTask),this.b=W,this.c=M,this.d=Y,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,q,W){if(!W)return new A.$wN(()=>{});const M=this.x();return this.j.set(M,{type:q,provider:W,extension:L}),this.a.$registerTaskProvider(M,q),new A.$wN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(L,q){this.a.$registerTaskSystem(L,q)}fetchTasks(L){return this.a.$fetchTasks(P.from(L)).then(async q=>{const W=[];for(const M of q){const Y=await k.to(M,this.b,this.m);Y&&W.push(Y)}return W})}get taskExecutions(){const L=[];return this.k.forEach(q=>L.push(q)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,q,W){const M=this.m.get(L.id);M&&(this.o.set(L.id,M),this.e.attachPtyToTerminal(q,await M.callback(W))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const q=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const q=await this.z(L.id);this.s.fire({execution:q,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const q=await this.z(L.id);this.u.fire({execution:q,exitCode:L.exitCode})}$provideTasks(L,q){const W=this.j.get(L);if(!W)return Promise.reject(new Error("no handler found"));const M=[],Y=(0,I.$yh)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(Z=>this.v(q,M,W,Z));return new Promise(Z=>{Y.then(ge=>{Promise.all(M).then(()=>{Z(ge)})})})}async $resolveTask(L,q){const W=this.j.get(L);if(!W)return Promise.reject(new Error("no handler found"));if(q.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${W.type}].`);const M=await k.to(q,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const Y=await W.provider.resolveTask(M,R.CancellationToken.None);if(!Y)return;this.A(Y,W);const Z=k.from(Y,W.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(Z.execution)&&await this.y(Z,Y,!0),await this.w(Z)}x(){return this.h++}async y(L,q,W){const M=await this.a.$createTaskId(L);!W&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,q.execution)),this.m.set(M,q.execution)}async z(L,q){if(typeof L=="string"){const Y=this.l.get(L);if(!Y)throw new r.$eb("Unexpected: The specified task is missing an execution");return Y}const W=this.l.get(L.id);if(W)return W;let M;return q?M=Promise.resolve(new f(this,L.id,q)):M=k.to(L.task,this.b,this.m).then(Y=>{if(!Y)throw new r.$eb("Unexpected: Task does not exist.");return new f(this,L.id,Y)}),this.l.set(L.id,M),M.then(Y=>(this.k.set(L.id,Y),Y))}A(L,q){L._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const W=this.n.values();let M=W.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=W.next()}};e.$kqc=w,e.$kqc=w=He([qe(0,u.$1P),qe(1,E.$eQ),qe(2,T.$Loc),qe(3,p.$_P),qe(4,a.$Ooc),qe(5,y.$apc),qe(6,o.$ak),qe(7,h.$poc)],w);let F=class extends w{constructor(L,q,W,M,Y,Z,ge,_){super(L,q,W,M,Y,Z,ge,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:s.$h(s.Platform.Web)})}async executeTask(L,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const W=k.from(q,L);if(W===void 0)throw new Error("Task is not valid");if(D.is(W.execution))await this.y(W,q,!1);else throw new r.$cb;const M=await this.z(await this.a.$getTaskExecution(W),q);return this.a.$executeTask(W).catch(Y=>{throw new Error(Y)}),M}v(L,q,W,M){const Y=[];if(M)for(const Z of M){if(this.A(Z,W),!Z.definition||!L[Z.definition.type]){const _=Z.source?Z.source:"No task source";this.f.warn(`The task [${_}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=k.from(Z,W.extension);ge&&D.is(ge.execution)?(Y.push(ge),q.push(this.y(ge,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:W.extension}}async w(L){if(D.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,q,W){}};e.$lqc=F,e.$lqc=F=He([qe(0,u.$1P),qe(1,E.$eQ),qe(2,T.$Loc),qe(3,p.$_P),qe(4,a.$Ooc),qe(5,y.$apc),qe(6,o.$ak),qe(7,h.$poc)],F),e.$mqc=(0,d.$Gi)("IExtHostTask")}),define(Ie[310],Pe([1,0,44,33]),function(ae,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=void 0,e.$gM=C,e.$iM=N;function C(A){return"cellResults"in A}e.$hM="rawCell#";function N(A,T){let p=-1;const a=[];let R=[];return A.forEach(u=>{u.range.startLineNumber!==p&&R.length>0&&(a.push([...R]),R=[]),R.push(u),p=u.range.endLineNumber}),R.length>0&&a.push([...R]),a.map(u=>{const E=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let s=d;s<=n;s++)E.push(T.getLineContent(s));return new v.$WL(E.join(`
`)+`
`,u.map(s=>new I.$Mt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ie[311],Pe([1,0,186,23,6,4,29,38,13,15,2,30,80,5,34,8,7,39,288,124,26,16,44,241,310,308]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,y=Ve(y),n=Ve(n),s=Ve(s);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,b,k,P,f,w,F){this.q=k,this.r=P,this.s=f,this.t=w,this.u=F,this.f=new Map,this.g=new A.$Dc,this.h=new Map,this.j=new C.$ne,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$ne,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$ne,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$ne,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$noc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(E.$uN.MainThreadNotebook),this.c=S.getProxy(E.$uN.MainThreadNotebookDocuments),this.d=S.getProxy(E.$uN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===T.MarshalledId.NotebookCellActionContext){const L=O.notebookEditor?.notebookUri,q=O.cell.handle,M=this.g.get(L)?.getCell(q);if(M)return M.apiCell}if(O&&O.$mid===T.MarshalledId.NotebookActionContext){const L=O.uri,q=this.g.get(L);if(q)return q.apiNotebook}return O}}),$.C(b)}getEditorById(S){const b=this.h.get(S);if(!b)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(S){for(const[b,k]of this.h)if(k.apiEditor===S)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,b){const k=this.g.get(S);if(!k&&!b)throw new Error(`NO notebook document for '${S}'`);return k}static w(S,b){if(!b)return;const k=b.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(b.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:b.displayName,filenamePattern:k,priority:b.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(S,b,k){const P=$.a++,f=typeof k.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(P,k),this.b.$registerNotebookCellStatusBarItemProvider(P,f,b);let w;return f!==void 0&&(w=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(f))),new s.$wN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,f),w?.dispose()})}async createNotebookDocument(S){const b=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&n.NotebookData.from(S.content)});return R.URI.revive(b)}async openNotebookDocument(S){const b=this.g.get(S);if(b)return b.apiNotebook;const k=await this.c.$tryOpenNotebook(S),P=this.g.get(R.URI.revive(k));return(0,a.$rg)(P?.apiNotebook)}async showNotebookDocument(S,b){R.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let k;typeof b=="object"?k={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:k={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,k),f=P&&this.h.get(P)?.apiEditor;if(f)return f;throw P?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,b,k,P){const f=this.f.get(S),w=R.URI.revive(b),F=this.g.get(w);if(!F||!f)return;const O=F.getCellFromIndex(k);if(!O)return;const L=await f.provideCellStatusBarItems(O.apiCell,P);if(!L)return;const q=new N.$Wc,W=this.p.add([q]),Y=(Array.isArray(L)?L:[L]).map(Z=>n.NotebookStatusBarItem.from(Z,this.i,q));return{cacheId:W,items:Y}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,b,k,P,f){if((0,p.$ef)(b))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:b,serializer:k,options:P}),this.b.$registerNotebookSerializer(w,{id:S.identifier,location:S.extensionLocation},b,n.NotebookDocumentContentOptions.from(P),$.w(S,f)),(0,N.$Vc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(S,b,k){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const f=await P.serializer.deserializeNotebook(b.buffer,k);return new o.$Uw(n.NotebookData.from(f))}async $notebookToData(S,b,k){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const f=await P.serializer.serializeNotebook(n.NotebookData.to(b.value),k);return I.$Pe.wrap(f)}async $saveNotebook(S,b,k,P,f){const w=R.URI.revive(b),F=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${k}, ${w.toString()})`),!F)throw new Error("NO serializer found");const O=this.g.get(w);if(!O)throw new Error("Document NOT found");if(O.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$vl((0,v.localize)(0,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,r.$mo)(O.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of O.apiNotebook.getCells()){const ge=new s.$ZO(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);ge.metadata=(0,r.$mo)(Z.metadata,_=>!(F.options?.transientCellMetadata??{})[_]),L.cells.push(ge)}if(await this.z(w,P),f.isCancellationRequested)throw new Error("canceled");const q=await F.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${w.toString()}`),await this.s.value.writeFile(w,q),this.D(`Finished write versionId: ${k} ${w.toString()}`);const W=this.s.getFileSystemProviderExtUri(w.scheme),M=await this.s.value.stat(w),Y={name:W.basename(w),isFile:(M.type&y.FileType.File)!==0,isDirectory:(M.type&y.FileType.Directory)!==0,isSymbolicLink:(M.type&y.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((M.permissions??0)&y.FilePermission.Locked),etag:y.$Gl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${w.toString()})`),Y}async $searchInNotebooks(S,b,k,P,f){const w=this.y.get(S)?.serializer;if(!w)return{limitHit:!1,results:[]};const F=new A.$Ec;await(async(M,Y,Z)=>{await Promise.all(M.map(async ge=>await Promise.all(ge.filenamePatterns.map(_=>{const me={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:c.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(me,Y,se=>{se.forEach(ce=>{F.has(ce)||P.some(oe=>ge.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Ce=>(0,m.$dL)(Ce,ce)))||F.add(ce)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(k,f,b);const L=new A.$Dc;let q=!1;const W=Array.from(F).map(async M=>{const Y=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((me,se)=>me+se.cellResults.length,0)>b.maxResults){q=!0;return}const Z=[],ge=this.g.get(M);if(ge)ge.apiNotebook.getCells().forEach(se=>Z.push({input:se.document.getText(),outputs:se.outputs.flatMap(ce=>ce.items.map(we=>we.data.toString()))}));else{const me=await this.s.value.readFile(M),se=I.$Pe.fromString(me.toString()),ce=await w.deserializeNotebook(se.buffer,f);if(f.isCancellationRequested)return;n.NotebookData.from(ce).cells.forEach(oe=>Z.push({input:oe.source,outputs:oe.outputs.flatMap(Ce=>Ce.items.map(Le=>Le.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Z.forEach((me,se)=>{const ce=b.contentPattern.pattern,we=new l.$CZb(me.input,void 0,me.outputs),oe=we.findInInputs(ce),Ce=we.findInOutputs(ce),Le=Ce.flatMap(X=>(0,g.$iM)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(oe.length>0||Ce.length>0){const X={index:se,contentResults:(0,g.$iM)(oe,we.inputTextBuffer),webviewResults:Le};Y.push(X)}});const _={resource:M,cellResults:Y};L.set(M,_);return}catch{return}});return await Promise.all(W),{limitHit:q,results:[...L.values()]}}async z(S,b){const k=await this.s.value.stat(S);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==y.$Fl&&typeof k.mtime=="number"&&typeof k.size=="number"&&b.mtime<k.mtime&&b.etag!==y.$Gl({mtime:b.mtime,size:k.size}))throw new y.$vl((0,v.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(S){return S.scheme===t.Schemas.file?S.fsPath:S.toString()}B(S,b,k){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const P=new i.$Ppc(b,this.d,S,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this.h.set(b,P)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const k of S.value.removedDocuments){const P=R.URI.revive(k),f=this.g.get(P);f&&(f.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(f.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===P.toString()&&this.h.delete(w.id)}if(S.value.addedDocuments){const k=[];for(const P of S.value.addedDocuments){const f=R.URI.revive(P.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const w=new h.$Opc(this.c,this.q,this.r,f,P);k.push(...P.cells.map(F=>h.$Npc.asModelAddData(F))),this.g.get(f)?.dispose(),this.g.set(f,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(S.value.addedEditors)for(const k of S.value.addedEditors){if(this.h.has(k.id))return;const P=R.URI.revive(k.documentUri),f=this.g.get(P);f&&this.B(f,k.id,k)}const b=[];if(S.value.removedEditors)for(const k of S.value.removedEditors){const P=this.h.get(k);P&&(this.h.delete(k),this.k?.id===P.id&&(this.k=void 0),b.push(P))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const k=new Set;this.l.forEach(P=>k.add(P.id));for(const P of this.h.values()){const f=k.has(P.id);P._acceptVisibility(f)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const b=d.$mQ.String.with("notebookType","A notebook type"),k=new d.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$mQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>I.$Pe.wrap(f))],new d.$nQ("Notebook Data",f=>n.NotebookData.to(f.value))),P=new d.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$mQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$Uw(n.NotebookData.from(f)))],new d.$nQ("Bytes",f=>f.buffer));S.registerApiCommand(k),S.registerApiCommand(P)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$Ypc=$}),define(Ie[312],Pe([1,0,20,22,41,42,24,70,44]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,v=Ve(v),N=Ve(N),A=Ve(A);class a{constructor(u,E,d){this.k=u,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$Ak(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$Ak(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((d,n)=>{const s=o=>{this.f++,u(o)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const h=o.toString(),i=v.$qc(h);this.j&&this.j(h,i)||this.v(s,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,s))).then(o=>{d({limitHit:this.e,stats:o[0]||void 0})},o=>{n(new Error((0,C.$rj)(o)))})})}async p(u,E){const d=new I.$ye,n=this.q(u),s=this.r(),o=new p.$$L(this.k,u),h=!o.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$he.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),c=T.$he.create();return this.g&&!this.e||(r&&r.forEach(l=>{const g=v.$jc.relative(u.folder.path,l.path);if(h){const m=v.$qc(l.path);this.v(E,{base:u.folder,relativePath:g,basename:m});return}this.s(s,u.folder,g,E)}),this.g&&!this.e)?null:(this.u(s,o,E),{providerTime:t,postProcessTime:c.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const E=(0,p.$0L)(this.k.includePattern,u.includePattern),d=(0,p.$0L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,d,n){if(d===this.a){const o=v.$qc(this.a);this.v(n,{base:E,relativePath:this.a,basename:o})}function s(o){const h=v.$qc(o),i=v.$pc(o);let r=u[i];r||(r=u[i]=[],s(i)),r.push({base:E,relativePath:o,basename:h})}s(d)}u({rootEntries:u,pathToEntries:E},d,n){const s=this,o=this.a;function h(i){const r=(0,p.$aM)(()=>i.map(t=>t.basename));for(let t=0,c=i.length;t<c;t++){const l=i[t],{relativePath:g,basename:m}=l;if(d.matchesExcludesSync(g,m,o!==m?r:void 0))continue;const $=E[g];if($)h($);else{if(g===o)continue;s.v(n,l)}if(s.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,d,n){const s=this.c(u.cacheKey),o=new a(u,E,s&&s.token);let h=0;const i=r=>{h+=r.length,d(r.map(t=>this.d(t)))};return this.e(o,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:r.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new I.$ye),this.b.get(u)}d(u){return u.relativePath?{resource:A.$hh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,d,n){const s=n.onCancellationRequested(()=>{u.cancel()}),o=i=>{i&&(h.push(i),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return u.search(o).then(i=>(h.length&&d(h),s.dispose(),i),i=>(h.length&&d(h),s.dispose(),Promise.reject(i)))}}e.$Qpc=R}),define(Ie[313],Pe([1,0,18,282,42,103,29,16,20,24,13,15,2,102,206,43,12,50,118,309,44]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0,e.$_M=b,v=Ve(v),I=Ve(I),C=Ve(C),p=Ve(p),R=Ve(R),d=Ve(d);let t=class{constructor(P,f,w,F,O){this.a=P,this.b=f,this.c=w,this.d=F,this.e=O}text(P,f,w={}){P=this.f(P,w);const F=this.a.getValue(),O=f&&f.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(f?.map(o.$2i),w),type:r.QueryType.Text,contentPattern:P,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:F.search.usePCRE2||O||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(P,f){const w=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const F={...P,wordSeparators:w.editor.wordSeparators};return this.j(P,f)&&(F.isCaseSensitive=!0),this.k(P)&&(F.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),F}file(P,f={}){return{...this.h(P,f),type:r.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(P,f){return P?(P=Array.isArray(P)?P.map($):$(P),f?this.parseSearchPaths(P):{pattern:l(...Array.isArray(P)?P:[P])}):{}}h(P=[],f={}){const w=this.g(f.includePattern,f.expandPatterns),F=this.g(f.excludePattern,f.expandPatterns),O=P.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(M=>this.q(M,f,F)):P.map(M=>this.r(M,f,F,O))).filter(M=>!!M),q={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const M=v.$Kb(this.c.groups.flatMap(ge=>ge.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const Y=M.filter(ge=>(0,r.$1L)(q,ge.fsPath)),Z=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...q,...Z}}const W=f.extraFileResources&&f.extraFileResources.filter(M=>(0,r.$1L)(q,M.fsPath));return q.extraFileResources=W&&W.length?W:void 0,q}i(P){const f=[],w=new A.$Dc,F={};let O=!1;return P.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,a.$lh)(L)){const W=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$pc(L.fsPath)});let M=w.get(W);M||(O=!0,M={folder:W,includePattern:{}},f.push(M),w.set(W,M));const Y=p.$oc(W.fsPath,L.fsPath);(0,y.$rg)(M.includePattern)[Y.replace(/\\/g,"/")]=!0}else L.fsPath&&(O=!0,F[L.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(P,f){if(f.isSmartCase){if(P.isRegExp){if(R.$0f(P.pattern,!0))return!0}else if(R.$0f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,E.$bD)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const f=Z=>p.$lc(Z)||/^\.\.?([\/\\]|$)/.test(Z),F=(Array.isArray(P)?P:g(P)).map(Z=>{const ge=this.e.resolvedUserHome;return ge?(0,N.$Zw)(Z,ge.scheme===T.Schemas.file?ge.fsPath:ge.path):Z}),O=I.$K(F,Z=>f(Z)?"searchPaths":"exprSegments"),L=(O.exprSegments||[]).map(Z=>R.$pf(Z,"/")).map(Z=>R.$pf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),m(Z))),q={},W=this.m(O.searchPaths||[]);W&&W.length&&(q.searchPaths=W);const M=L.flat(),Y=l(...M);return Y&&(q.pattern=Y),q}l(P,f){return f.disregardExcludeSettings?void 0:(0,r.$ZL)(P,!f.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const f=P.flatMap(F=>{let{pathPortion:O,globPortion:L}=c(F);return L&&(L=D(L)),this.n(O).flatMap(W=>this.o(W,L))}),w=new Map;return f.forEach(F=>{const O=F.searchPath.toString(),L=w.get(O);L?F.pattern&&(L.pattern=L.pattern||{},L.pattern[F.pattern]=!0):w.set(O,{searchPath:F.searchPath,pattern:F.pattern?l(F.pattern):void 0})}),Array.from(w.values())}n(P){if(p.$lc(P)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:P})}]:[{searchPath:u.URI.file(p.$kc(P))}]}if(this.b.getWorkbenchState()===o.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(P=$(P),P.startsWith("../")||P===".."){const F=p.$jc.resolve(f.path,P);return[{searchPath:f.with({path:F})}]}const w=D(P);return[{searchPath:f,pattern:w}]}else{if(P==="./"||P===".\\")return[];{const f=P.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(O=>{const L=f.match(new RegExp(`^${R.$jf(O.name)}(?:/(.*)|$)`));return L?{match:L,folder:O}:null}).filter(y.$og);if(F.length)return F.map(O=>{const L=O.match[1];return{searchPath:O.folder.uri,pattern:L&&D(L)}});{const O=P.match(/\.[\/\\](.+)[\/\\]?/),L=O?O[1]:P,q=d.localize(0,null,L);throw new Error(q)}}}}o(P,f){const w=P.pattern&&f?`${P.pattern}/${f}`:P.pattern||f,F=[{searchPath:P.searchPath,pattern:w}];return w&&!w.endsWith("**")&&F.push({searchPath:P.searchPath,pattern:w+"/**"}),F}q(P,f,w){const F=this.r((0,o.$2i)(P.searchPath),f,w,!1);return F?{...F,includePattern:P.pattern}:null}r(P,f,w,F){let O;const L=u.URI.isUri(P)?P:P.uri;if(w.searchPaths){const Z=w.searchPaths.filter(ge=>(0,a.$ah)(ge.searchPath,L))[0];if(Z&&!Z.pattern)return null;Z&&(O=Z.pattern)}const q=this.a.getValue({resource:L}),M={...this.l(q,f)||{},...O||{}},Y=u.URI.isUri(P)?(0,a.$eh)(P):P.name;return{folder:L,folderName:F?Y:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!q.search.followSymlinks}}};e.$$M=t,e.$$M=t=He([qe(0,n.$aj),qe(1,o.$Pi),qe(2,h.$jE),qe(3,s.$ak),qe(4,i.$9M)],t);function c(k){const P=k.match(/[\*\{\}\(\)\[\]\?]/);if(P){const f=P.index,w=k.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let F=k.substr(0,w.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((w.index||0)+1)}}}return{pathPortion:k}}function l(...k){return k.length?k.reduce((P,f)=>(P[f]=!0,P),Object.create(null)):void 0}function g(k){return C.$yk(k,",").map(P=>P.trim()).filter(P=>!!P.length)}function m(k){return[`**/${k}/**`,`**/${k}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function $(k){return k.replace(/\\/g,"/")}function D(k){return $(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(k){return k.replace(/([?*[\]])/g,"[$1]")}function b(k,P){k=v.$Pb(k,F=>F.toString());const f=[],w=P.getWorkspace();return k&&k.forEach(F=>{let O;if(P.getWorkbenchState()===o.WorkbenchState.FOLDER)O=(0,a.$jh)(w.folders[0].uri,F),O&&O!=="."&&(O="./"+O);else{const L=P.getWorkspaceFolder(F);if(L){const q=L.name;if(w.folders.filter(M=>M.name===q).length===1){const M=(0,a.$jh)(L.uri,F);M===""?O=`./${L.name}`:O=`./${L.name}/${M}`}else O=F.fsPath}}O&&f.push(S(O))}),f}}),define(Ie[314],Pe([1,0,24,2,22,14,3,313,44,50,11]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gyb=u,e.$hyb=n,v=Ve(v),N=Ve(N);const y=7e3;function u(s,o){const h=o.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],r=[];for(const $ of h)if(/^workspaceContains:/.test($)){const D=$.substr(18);D.indexOf("*")>=0||D.indexOf("?")>=0||s.forceUsingSearch?r.push(D):i.push(D)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:c}=(0,R.$zh)(),l=$=>c({activationEvent:$}),g=Promise.all(i.map($=>E(s,$,l))).then(()=>{}),m=d(s,o.identifier,r,l);return Promise.all([g,m]).then(()=>{c(void 0)}),t}async function E(s,o,h){for(const i of s.folders)if(await s.exists(v.$hh(I.URI.revive(i),o))){h(`workspaceContains:${o}`);return}}async function d(s,o,h,i){if(h.length===0)return Promise.resolve(void 0);const r=new C.$ye,t=s.checkExists(s.folders,h,r.token),c=setTimeout(async()=>{r.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},y);let l=!1;try{l=await t}catch(g){N.$7(g)||N.$3(g)}r.dispose(),clearTimeout(c),l&&i(`workspaceContains:${h.join(",")}`)}function n(s,o,h,i){const r=s.get(A.$Fi),t=s.get(p.$RL),l=r.createInstance(T.$$M).file(o.map(g=>(0,a.$2i)(I.URI.revive(g))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(l,i).then(g=>!!g.limitHit,g=>N.$7(g)?!1:Promise.reject(g))}}),define(Ie[47],Pe([1,0,182,20,65,24,11,4,59,2,12,5,46,248,89,45,25,119,14,19,23,230,7,110,3,27,92,17,75,93,57,95,6,314,88,232,16,86,70,21,87]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,D,S,b,k,P,f,w,F,O,L,q,W,M,Y){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=e.$ppc=e.$opc=e.$npc=void 0,v=Ve(v),I=Ve(I),C=Ve(C),h=Ve(h),e.$npc=(0,g.$Gi)("IHostUtils");let ge=Z=class extends T.$Xc{constructor(X,V,te,ve,ue,be,de,J,x,pe,$e,Ne,ze){super(),this.Y=Ne,this.Z=ze,this.a=this.B(new f.$ne),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=te,this.f=de,this.j=ve,this.m=ue,this.s=be,this.t=x,this.u=pe,this.w=$e,this.y=this.g.getProxy(y.$uN.MainThreadWorkspace),this.z=this.g.getProxy(y.$uN.MainThreadTelemetry),this.C=this.g.getProxy(y.$uN.MainThreadExtensionService),this.D=new A.$Fh,this.F=new A.$Fh,this.G=new A.$Fh,this.H=new A.$Fh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$Qcc(this.I,this.f.extensions.allExtensions);const ke=new i.$sn(this.f.extensions.myExtensions);this.J=new o.$Qcc(this.I,we(this.L,ke)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$9oc(this.g,this.s),this.N=new F.$gpc(this.g),this.O=J,this.h=X.createChild(new S.$Ei([d.$0oc,this.M],[F.$hpc,this.N])),this.P=this.B(new E.$8oc(this.J,this.L,{onExtensionActivationError:(Ae,Oe,j)=>{this.C.$onExtensionActivationError(Ae,h.$5(Oe),j)},actualActivateExtension:async(Ae,Oe)=>{if(o.$Qcc.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Oe),new E.$7oc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){h.$3(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.eb(ue))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const te=this.$();Promise.race([(0,A.$Hh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new i.$rn(V.identifier.value),extensionLocation:a.URI.revive(V.extensionLocation)}}ab(X,V){return this.P.activateByEvent(X,V)}bb(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.bb(X,V).then(()=>{const te=this.P.getActivatedExtension(X);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===L.Schemas.file&&this.c.fsRealpath){const V=X.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const te=await this.R.get(V);return a.URI.file(te)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new oe(X))),this.Q}async db(X){const V=p.$Mi.forUris(te=>N.$$g.ignorePathCasing(te));return await Promise.all(X.map(async te=>{if(this.wb(te)){const ve=await this.cb(te.extensionLocation);V.set(ve,te)}})),V}eb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const te=this.P.getActivatedExtension(X);if(!te)return V;try{typeof te.module.deactivate=="function"&&(V=Promise.resolve(te.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(ve)}try{(0,T.$Sc)(te.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(ve)}return V}async fb(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,V).then(te=>{const ve=te.activationTimes;return this.C.$onDidActivateExtension(X.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,V),this.gb(X,V,"success",ve),te},te=>{throw this.gb(X,V,"failure"),te})}gb(X,V,te,ve){const ue=me(X,V);this.z.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:te})}hb(X,V){const te=me(X,V);this.z.$publicLog2("activatePlugin",te);const ve=this.wb(X);if(!ve)return Promise.resolve(new E.$6oc(E.$3oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const ue=new E.$4oc(V.startup);return Promise.all([this.xb(X,(0,N.$hh)(X.extensionLocation,ve),ue),this.ib(X)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.jb(this.s,X.identifier,be[0],be[1],ue))).then(be=>(C.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),be))}ib(X){const V=this.Z.createLanguageModelAccessInformation(X),te=this.B(new t.$_oc(X,this.M)),ve=this.B(new t.$$oc(X.identifier.value,!1,this.M)),ue=this.B(new O.$ipc(X,this.N)),be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,de=this.f.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([te.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const J=this;let x,pe;const $e=(0,s.$6G)(X,"ipc")?this.f.messagePorts?.get(i.$rn.toKey(X.identifier)):void 0;return Object.freeze({globalState:te,workspaceState:ve,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return V},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ne){return I.$mc(X.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return J.O.globalValue(X).fsPath},get logPath(){return I.$mc(J.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return a.URI.joinPath(J.f.logsLocation,X.identifier.value)},get storageUri(){return J.O.workspaceValue(X)},get globalStorageUri(){return J.O.globalValue(X)},get extensionMode(){return be},get extension(){return x===void 0&&(x=new ce(J,X.identifier,X,de,!1)),x},get extensionRuntime(){return(0,s.$7G)(X,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!pe){if(!$e)return;const Ne=f.Event.buffer(f.Event.fromDOMEventEmitter($e,"message",ze=>ze.data));$e.start(),pe={onDidReceiveMessage:Ne,postMessage:$e.postMessage.bind($e)}}return pe}})})}static jb(X,V,te,ve,ue){return te=te||{activate:void 0,deactivate:void 0},this.kb(X,V,te,ve,ue).then(be=>new E.$5oc(!1,null,ue.build(),te,be,ve.subscriptions))}static kb(X,V,te,ve,ue){if(typeof te.activate=="function")try{ue.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const be=typeof global=="object"?global:self,de=te.activate.apply(be,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(J=>(ue.activateResolveStop(),J))}catch(be){return Promise.reject(be)}else return Promise.resolve(te)}lb(X,V){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,te=>{this.s.error(te)})}mb(X,V=0){const ve=Date.now();(0,M.$B)(()=>{for(let ue=V;ue<X.length;ue+=1){const be=X[ue];for(const de of be.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ve>50){this.mb(X,ue);break}else this.lb(be,de)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(V)this.mb(te);else for(const ve of te)if(ve.activationEvents)for(const ue of ve.activationEvents)ue==="onStartupFinished"&&this.lb(ve,ue)})}ob(){const X=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const V=this.j.workspace?this.j.workspace.folders:[],te=this.pb(V),ve=this.rb(),ue=Promise.all([ve,X,te]).then(()=>{});return Promise.race([ue,(0,A.$Hh)(1e4)]).then(()=>{this.nb()}),ue}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(X,V))).then(()=>{})}async qb(X,V){if(this.isActivated(V.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:X.map(be=>be.uri),forceUsingSearch:te||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,de,J)=>this.y.$checkExists(be,de,J)},ue=await(0,w.$gyb)(ve,V);if(ue)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:ue.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(v.localize(0,null));const te=await this.xb(null,V,new E.$4oc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(1,null,V.toString()));return new Promise((ve,ue)=>{const be=(x,pe)=>{x?(M.$t&&this.s.error("Test runner called back with error",x),ue(x)):(M.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof pe=="number"&&pe>0?1:0))},de=(0,N.$8g)(V),J=te.run(de,be);J&&J.then&&J.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ve(0)}).catch(x=>{M.$t&&this.s.error("Test runner finished with error",x),ue(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.S[X]=V,(0,T.$Vc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.ub(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const V=X.indexOf("+");if(V===-1)throw new c.$CN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=X.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(X,V){const te=W.$he.create(!1),ve=()=>`[resolveAuthority(${(0,l.$Vl)(X)},${V})][${te.elapsed()}ms] `,ue=U=>this.s.info(`${ve()}${U}`),be=U=>this.s.warn(`${ve()}${U}`),de=(U,G=void 0)=>this.s.error(`${ve()}${U}`,G),J=U=>{if(U instanceof c.$CN)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},x=async U=>{ue(`activating resolver for ${U}...`);const{resolver:G,authorityPrefix:H}=await this.ub(U);if(!G)throw de(`no resolver for ${H}`),new c.$CN(`No remote extension installed to resolve ${H}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:U}},pe=X.split(/@|%40/g).reverse();ue(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(x)).catch(async U=>{if(!(U instanceof c.$CN)||U._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return be(`resolving nested authorities failed: ${U.message}`),[await x(X)]})}catch(U){return J(U)}const Ne=new A.$Rh;Ne.cancelAndSet(()=>ue("waiting..."),1e3);let ze,ke;for(const[U,{authorityPrefix:G,resolver:H,remoteAuthority:ne}]of $e.entries())try{if(U===$e.length-1)ue("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${G}`),ze=await H.resolve(ne,{resolveAttempt:V,execServer:ke}),C.mark(`code/extHost/didResolveAuthorityOK/${G}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,c.$BN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ue(`invoking resolveExecServer() for ${ne}`),C.mark(`code/extHost/willResolveExecServer/${G}`),ke=await H.resolveExecServer?.(ne,{resolveAttempt:V,execServer:ke}),!ke)throw new c.$CN(`Exec server was not available for ${ne}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(fe){return C.mark(`code/extHost/didResolveAuthorityError/${G}`),de("returned an error",fe),Ne.dispose(),J(fe)}Ne.dispose();const Ae={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${c.$BN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let j;if(c.$BN.isManagedResolvedAuthority(ze)){const U=V;this.Y.setFactory(U,ze.makeConnection),j={authority:X,connectTo:new l.$Sl(U),connectionToken:ze.connectionToken}}else j={authority:X,connectTo:new l.$Tl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:j,options:Oe,tunnelInformation:Ae}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Vl)(X)})`);const{resolver:te}=await this.ub(X);if(!te)return null;const ve=a.URI.revive(V);if(typeof te.getCanonicalURI>"u")return ve;const ue=await(0,A.$yh)(()=>te.getCanonicalURI(ve));return ue||ve}async $startExtensionHost(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:V,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(V.getAllExtensionDescriptions()),this.J.set(te),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(X,V){return V===s.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(X,!1)):this.G.wait().then(te=>this.ab(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:V,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(V.getAllExtensionDescriptions()),this.J.set(te),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=r.$Pe.alloc(X),te=Math.random()%256;for(let ve=0;ve<X;ve++)V.writeUInt8(te,ve);return V}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$opc=ge,e.$opc=ge=Z=He([qe(0,g.$Fi),qe(1,e.$npc),qe(2,D.$1P),qe(3,n.$Loc),qe(4,u.$Ooc),qe(5,R.$ak),qe(6,m.$eQ),qe(7,$.$Roc),qe(8,b.$3Fb),qe(9,k.$apc),qe(10,q.$kpc),qe(11,Y.$lpc),qe(12,P.$epc)],ge);function _(Le,X,V,te){Le.addActivationEvents(te.addActivationEvents);const ve=new o.$Qcc(Le,X.getAllExtensionDescriptions());ve.deltaExtensions(te.toAdd,te.toRemove);const ue=new i.$sn(V.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of te.myToRemove)ue.delete(de);for(const de of te.myToAdd)ue.add(de);const be=we(ve,ue);return{globalRegistry:ve,myExtensions:be}}function me(Le,X){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$ppc=(0,g.$Gi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(X,V,te,ve,ue){this.#e=X,this.#t=V,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=I.$kc((0,N.$8g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ve,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$qpc=ce;function we(Le,X){return Le.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class oe{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$rpc=oe;class Ce{constructor(X){this.a=new i.$tn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Ie[315],Pe([1,0,65,2,5,46,25,19,17,27,3,47,12,13]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,v=Ve(v);let n=class{constructor(r,t,c,l,g,m,$){this.c=r,this.d=t,this.e=c,this.f=l,this.g=g,this.h=m,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new o(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$Cqc=n,e.$Cqc=n=He([qe(2,R.$Fi),qe(3,N.$Ooc),qe(4,y.$ppc),qe(5,a.$eQ),qe(6,u.$ak)],n);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,E.$jf)(this.c(r.environment.appRoot.fsPath)),c="[a-z0-9_.-]",l=`@${c}+\\/${c}+|${c}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,c,l,g]=t,m=d.a.get(l);if(m!==void 0)return console.warn(`${l} as been renamed to ${m}, please update your imports`),c+m+g}c(r){return r.replace(/\\/g,"/")}};s=d=He([qe(0,a.$eQ)],s);class o{constructor(r,t,c,l,g){this.c=r,this.d=t,this.e=c,this.f=l,this.g=g,this.nodeModuleName="vscode",this.a=new T.$tn}load(r,t){const c=this.d.findSubstr(t);if(c){let l=this.a.get(c.identifier);return l||(l=this.c(c,this.e,this.f),this.a.set(c.identifier,l)),l}if(!this.b){let l="";this.d.forEach((g,m)=>l+=`	${m} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(A.$1G,this.e,this.f)}return this.b}}let h=class{constructor(r,t,c){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=c.getProxy(C.$uN.MainThreadTelemetry);const l=c.getProxy(C.$uN.MainThreadWindow);this.c=(g,m)=>{const $=I.URI.parse(g);return m?this.g(g,m):$.scheme==="http"||$.scheme==="https"?l.$openUri($,g,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,g,{}):this.g(g,m)}}load(r,t,c){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=c(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([qe(2,p.$1P)],h)}),define(Ie[132],Pe([1,0,48,4,20,79,3,58,71,47,7,45,245,46]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=void 0,C=Ve(C),N=Ve(N),e.$spc=(0,A.$Gi)("IExtHostVariableResolverProvider");class d extends u.$5Q{constructor(o,h,i,r,t,c,l){function g(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const $=r.tabGroups.all.find(D=>D.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$iP||$.input instanceof R.$nP)return $.input.modified;if($.input instanceof R.$hP||$.input instanceof R.$mP||$.input instanceof R.$kP)return $.input.uri}}}super({getFolderUri:m=>{const $=c.folders.filter(D=>D.name===m);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>c.folders.length,getConfigurationValue:(m,$)=>t.getConfiguration(void 0,m).get($),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=g();if(m)return C.$kc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const m=g();if(m){const $=h.getWorkspaceFolder(m);if($)return C.$kc($.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>o.getExtension(m)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(N.env))}}let n=class extends I.$Xc{constructor(o,h,i,r,t){super(),this.b=o,this.c=h,this.g=i,this.h=r,this.j=t,this.a=new v.$X(async()=>{const c=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,c,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$tpc=n,e.$tpc=n=He([qe(0,a.$ppc),qe(1,y.$Loc),qe(2,T.$_P),qe(3,E.$Ooc),qe(4,p.$1oc)],n)}),define(Ie[133],Pe([1,0,11,6,2,4,19,3,5,71,47,17,7,45,237,81,238,46,132,35,34,8,18,96]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=e.$Bpc=e.$Apc=e.$zpc=void 0,t=Ve(t),e.$zpc=(0,T.$Gi)("IExtHostDebugService");let g=class extends N.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,f,w,F,O,L,q,W){super(),this.Y=f,this.Z=w,this.$=F,this.ab=O,this.bb=L,this.cb=q,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new I.$ne),this.z=this.B(new I.$ne),this.C=this.B(new I.$ne),this.F=this.B(new I.$ne),this.u=P.getProxy(p.$uN.MainThreadDebugService),this.I=this.B(new I.$ne),this.L=this.B(new I.$ne),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(Y=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(P,f){const w=this.gb(f);if(!w)return;const F=await this.Q.get(P)?.getTreeItem?.(w);return F?this.eb(P,F):void 0}registerDebugVisualizationTree(P,f,w){const F=A.$rn.toKey(P.identifier),O=this.ub(F,f);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(O,w),this.u.$registerDebugVisualizerTree(O,!!w.editItem),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(P,f){const w=this.S.get(f)?.item;return w?(await this.Q.get(P)?.getChildren?.(w))?.map(O=>this.eb(P,O))||[]:[]}async $editVisualizerTreeItem(P,f){const w=this.S.get(P);if(!w)return;const F=await this.Q.get(w.provider)?.editItem?.(w.item,f);return this.eb(w.provider,F||w.item)}$disposeVisualizedTree(P){const f=this.S.get(P);if(!f)return;const w=[f.children];for(const F of w)if(F)for(const O of F)w.push(this.S.get(O)?.children),this.S.delete(O)}eb(P,f){let w=this.R.get(f);return w||(w=this.O++,this.R.set(f,w),this.S.set(w,{provider:P,item:f})),t.DebugTreeItem.from(f,w)}asDebugSourceUri(P,f){const w=P;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let F=`debug:${encodeURIComponent(w.path||"")}`,O="?";return f&&(F+=`${O}session=${encodeURIComponent(f.id)}`,O="&"),F+=`${O}ref=${w.sourceReference}`,C.URI.parse(F)}else{if(w.path)return C.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const f=[];for(const w of P.getAllExtensionDescriptions())if(w.contributes){const F=w.contributes.debuggers;if(F&&F.length>0)for(const O of F)(0,s.$YH)(O)&&f.push(O.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(f=>P.push(f)),P}async $resolveDebugVisualizer(P,f){const w=this.W.get(P);if(!w)throw new Error(`No debug visualizer found with id '${P}'`);let{v:F,provider:O,extensionId:L}=w;if(F.visualization||(F=await O.resolveDebugVisualization?.(F,f)||F,w.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.vb(L,F.visualization)}async $executeDebugVisualizerCommand(P){const f=this.W.get(P);if(!f)throw new Error(`No debug visualizer found with id '${P}'`);const w=f.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(P){const f=this.w.get(P.sessionId);return f&&{session:f.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,f,w,F){const O=this.gb(w),L=this.ub(P,f),q=this.P.get(L);if(!O||!q)return[];const W=await q.provideDebugVisualization(O,F);return W?W.map(M=>{const Y=++this.X;this.W.set(Y,{v:M,provider:q,extensionId:P});const Z=M.iconPath?this.wb(M.iconPath):void 0;return{id:Y,name:M.name,iconClass:Z?.iconClass,iconPath:Z?.iconPath,visualization:this.vb(P,M.visualization)}}):[]}$disposeDebugVisualizers(P){for(const f of P)this.W.delete(f)}registerDebugVisualizationProvider(P,f,w){if(!P.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const F=A.$rn.toKey(P.identifier),O=this.ub(F,f);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(O,w),this.u.$registerDebugVisualizer(F,f),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizer(F,f),this.P.delete(f)})}addBreakpoints(P){const f=P.filter(O=>{const L=O.id;return this.H.has(L)?!1:(this.H.set(L,O),!0)});this.rb(f,[],[]);const w=[],F=new Map;for(const O of f)if(O instanceof u.$yO){let L=F.get(O.location.uri.toString());L||(L={type:"sourceMulti",uri:O.location.uri,lines:[]},F.set(O.location.uri.toString(),L),w.push(L)),L.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof u.$zO&&w.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(P){const f=P.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const w=f.filter(L=>L instanceof u.$yO).map(L=>L.id),F=f.filter(L=>L instanceof u.$zO).map(L=>L.id),O=f.filter(L=>L instanceof u.$AO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,F,O)}startDebugging(P,f,w){const F=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(P?P.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,f,w){if(!f)return new u.$wN(()=>{});const F=this.f++;return this.g.push({type:P,handle:F,provider:f}),this.u.$registerDebugConfigurationProvider(P,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$wN(()=>{this.g=this.g.filter(O=>O.provider!==f),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(P,f,w){if(!w)return new u.$wN(()=>{});if(!this.nb(P,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:f,handle:F,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(f,F),new u.$wN(()=>{this.j=this.j.filter(O=>O.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(P,f){if(!f)return new u.$wN(()=>{});const w=this.m++;return this.n.push({type:P,handle:w,factory:f}),new u.$wN(()=>{this.n=this.n.filter(F=>F.factory!==f)})}async $runInTerminal(P,f){return Promise.resolve(void 0)}async $substituteVariables(P,f){let w;const F=await this.tb(P);return F&&(w={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,f)}hb(P,f){if(P.type==="implementation")return new S(P.implementation)}ib(){}async $startDASession(P,f){const w=this,F=await this.sb(f);return this.pb(this.kb(F.type),F).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const L=this.jb(O),q=this.hb(L,F);if(!q)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const W=q;return this.M.set(P,W),this.ob(F).then(M=>(M&&this.N.set(P,M),W.onMessage(async Y=>{if(Y.type==="request"&&Y.command==="handshake"){const Z=Y,ge={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(Z.arguments.value);ge.body={signature:_},W.sendResponse(ge)}else throw new Error("no signer")}catch(_){ge.success=!1,ge.message=_.message,W.sendResponse(ge)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(Y),Y=(0,s.$4H)(Y,!0),w.u.$acceptDAMessage(P,Y)}),W.onError(Y=>{M&&M.onError&&M.onError(Y),this.u.$acceptDAError(P,Y.name,Y.message,Y.stack)}),W.onExit(Y=>{M&&M.onExit&&M.onExit(Y??void 0,void 0),this.u.$acceptDAExit(P,Y??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),W.startSession()))})}$sendDAMessage(P,f){f=(0,s.$3H)(f,!1);const w=this.N.get(P);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f),this.M.get(P)?.sendMessage(f)}$stopDASession(P){const f=this.N.get(P);this.N.delete(P),f&&f.onWillStopSession&&f.onWillStopSession();const w=this.M.get(P);return this.M.delete(P),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const f=[],w=[],F=[];if(P.added)for(const O of P.added){const L=O.id;if(L&&!this.H.has(L)){let q;if(O.type==="function")q=new u.$zO(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")q=new u.$AO(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const W=C.URI.revive(O.uri);q=new u.$yO(new u.$IN(W,new u.$xN(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,u.$wO)(q,L),this.H.set(L,q),f.push(q)}}if(P.removed)for(const O of P.removed){const L=this.H.get(O);L&&(this.H.delete(O),w.push(L))}if(P.changed){for(const O of P.changed)if(O.id){const L=this.H.get(O.id);if(L){if(L instanceof u.$zO&&O.type==="function"){const q=L;q.enabled=O.enabled,q.condition=O.condition,q.hitCondition=O.hitCondition,q.logMessage=O.logMessage,q.functionName=O.functionName}else if(L instanceof u.$yO&&O.type==="source"){const q=L;q.enabled=O.enabled,q.condition=O.condition,q.hitCondition=O.hitCondition,q.logMessage=O.logMessage,q.location=new u.$IN(C.URI.revive(O.uri),new u.$xN(O.line,O.character))}F.push(L)}}}this.rb(f,w,F)}async $acceptStackFrameFocus(P){let f;if(P){const w=await this.sb(P.sessionId);P.kind==="thread"?f=new u.$GO(w.api,P.threadId):f=new u.$FO(w.api,P.threadId,P.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(P,f,w){return(0,v.$yh)(async()=>{const F=this.mb(P);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.tb(f);return F.provideDebugConfigurations(O,w)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(P,f,w,F){return(0,v.$yh)(async()=>{const O=this.mb(P);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return O.resolveDebugConfiguration(L,w,F)})}$resolveDebugConfigurationWithSubstitutedVariables(P,f,w,F){return(0,v.$yh)(async()=>{const O=this.mb(P);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return O.resolveDebugConfigurationWithSubstitutedVariables(L,w,F)})}async $provideDebugAdapter(P,f){const w=this.lb(P);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(f);return this.pb(w,F).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(O)})}async $acceptDebugSessionStarted(P){const f=await this.sb(P);this.y.fire(f.api)}async $acceptDebugSessionTerminated(P){const f=await this.sb(P);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,f){(await this.sb(P))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(P,f){const F={session:(await this.sb(P)).api,event:f.event,body:f.body};this.F.fire(F)}jb(P){if(P instanceof u.$BO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof u.$CO)return{type:"server",port:P.port,host:P.host};if(P instanceof u.$DO)return{type:"pipeServer",path:P.path};if(P instanceof u.$EO)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const f=this.j.filter(w=>w.type===P);if(f.length>0)return f[0].factory}lb(P){const f=this.j.filter(w=>w.handle===P);if(f.length>0)return f[0].factory}mb(P){const f=this.g.filter(w=>w.handle===P);if(f.length>0)return f[0].provider}nb(P,f){if(P.contributes){const w=P.contributes.debuggers;if(w&&w.length>0){for(const F of w)if(F.label&&F.type&&F.type===f)return!0}}return!1}ob(P){const w=P.configuration.type,F=this.n.filter(O=>O.type===w||O.type==="*").map(O=>(0,v.$yh)(()=>O.factory.createDebugAdapterTracker(P.api)).then(L=>L,L=>null));return Promise.race([Promise.all(F).then(O=>{const L=(0,c.$Kb)(O);if(L.length>0)return new D(L)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async pb(P,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$CO(w));if(P){const O=await this.Z.getExtensionRegistry();return(0,v.$yh)(()=>P.createDebugAdapterDescriptor(f.api,this.qb(f,O))).then(L=>{if(L)return L})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,F))}qb(P,f){}rb(P,f,w){(P.length>0||f.length>0||w.length>0)&&this.I.fire(Object.freeze({added:P,removed:f,changed:w}))}async sb(P){if(P)if(typeof P=="string"){const f=this.w.get(P);if(f)return f}else{let f=this.w.get(P.id);if(!f){const w=await this.tb(P.folderUri),F=P.parent?this.w.get(P.parent):void 0;f=new m(this.u,P.id,P.type,P.name,w,P.configuration,F?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(P){if(P){const f=C.URI.revive(P);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(P,f){return`${P}\0${f}`}vb(P,f){if(f){if("title"in f&&"command"in f)return{type:n.DebugVisualizationType.Command};if("treeId"in f)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const f=this.xb(P);let w,F;return"id"in f?F=i.ThemeIcon.asClassName(f):w=f,{iconPath:w,iconClass:F}}xb(P){if(P instanceof u.$tO)return{id:P.id};const f=typeof P=="object"&&"dark"in P?P.dark:P,w=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof f=="string"?C.URI.file(f):f,light:typeof w=="string"?C.URI.file(w):w}}};e.$Apc=g,e.$Apc=g=He([qe(0,y.$1P),qe(1,E.$Loc),qe(2,R.$ppc),qe(3,o.$Ooc),qe(4,a.$1oc),qe(5,h.$spc),qe(6,r.$kQ),qe(7,l.$upc)],g);class m{constructor(P,f,w,F,O,L,q){this.f=P,this.g=f,this.h=w,this.j=F,this.k=O,this.l=L,this.m=q}get api(){const P=this;return this.d??=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(f){P.j=f,P.f.$setDebugSessionName(P.g,f)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(f,w){return P.f.$customDebugAdapterRequest(P.g,f,w)},getDebugProtocolBreakpoint(f){return P.f.$getDebugProtocolBreakpoint(P.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$Bpc=m;class ${constructor(P){this.value=Object.freeze({append(f){P.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$Cpc=$;class D{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(f=>f.onError?f.onError(P):void 0)}onExit(P,f){this.d.forEach(w=>w.onExit?w.onExit(P,f):void 0)}}class S extends d.$Mtb{constructor(P){super(),this.h=P,P.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends g{constructor(P,f,w,F,O,L,q,W){super(P,f,w,F,O,L,q,W)}};e.$Dpc=b,e.$Dpc=b=He([qe(0,y.$1P),qe(1,E.$Loc),qe(2,R.$ppc),qe(3,o.$Ooc),qe(4,a.$1oc),qe(5,h.$spc),qe(6,r.$kQ),qe(7,l.$upc)],b)}),define(Ie[316],Pe([1,0,14,65,2,5,266,12,61,75,27,211,17,66,47,67]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=e.$Dqc=void 0,v=Ve(v),I=Ve(I);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$ak),c=i.get(u.$1P).getProxy(N.$uN.MainThreadErrors);v.setUnexpectedErrorHandler(l=>{r.error(l);const g=v.$5(l);c.$onUnexpectedError(g)})}static async installFullHandler(i){const r=i.get(T.$ak),t=i.get(u.$1P),c=i.get(d.$ppc),l=i.get(n.$iQ),g=t.getProxy(N.$uN.MainThreadExtensionService),m=t.getProxy(N.$uN.MainThreadErrors),$=await c.getExtensionPathIndex(),D=new WeakMap;function S(P,f){if(D.has(P))return D.get(P).stack;let w="",F,O;for(const q of f)w+=`
	at ${q.toString()}`,O=q.getFileName(),!F&&O&&(F=$.findSubstr(C.URI.file(O)));const L=`${P.name||"Error"}: ${P.message||""}${w}`;return D.set(P,{extensionIdentifier:F?.identifier,stack:L}),L}const b=Symbol("prepareStackTrace wrapped");let k=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(P){if(P===S||!P||P[b]){k=P||S;return}k=function(f,w){return S(f,w),P.call(Error,f,w)},Object.assign(k,{[b]:!0})}}),v.setUnexpectedErrorHandler(P=>{r.error(P);const f=v.$5(P),w=D.get(P);if(!w?.extensionIdentifier){m.$onUnexpectedError(f);return}g.$onExtensionRuntimeError(w.extensionIdentifier,f);const F=l.onExtensionError(w.extensionIdentifier,P);r.trace("forwarded error to extension?",F,w)})}}e.$Dqc=s;class o{constructor(i,r,t,c,l){this.a=t,this.b=new A.$Ycc(i,null,c),r=o.e(r,this.b);const g=new a.$Ei(...(0,p.$Qs)());g.set(R.$eQ,{_serviceBrand:void 0,...r,messagePorts:l}),g.set(u.$1P,new u.$2P(this.b)),g.set(E.$Ioc,new E.$Joc(c)),g.set(d.$npc,t);const m=new y.$ur(g,!0);m.invokeFunction(s.installEarlyHandler),this.d=m.invokeFunction($=>$.get(T.$ak)),I.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=m.invokeFunction($=>$.get(d.$ppc)),this.c.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(N.$uN.MainThreadExtensionService);return C.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(c=>{c.extensionLocation=C.URI.revive(r.transformIncomingURIs(c.extensionLocation))}),i.environment.appRoot=C.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(c=>C.URI.revive(r.transformIncomingURIs(c)))),i.environment.extensionTestsLocationURI=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Eqc=o}),define(Ie[317],Pe([1,0,18,11,22,41,16,20,24,2,44]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Spc=e.$Rpc=void 0,e.$Tpc=n,T=Ve(T),p=Ve(p);class y{constructor(h,i,r){this.d=h,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const r=this.g.folderQueries||[],t=new C.$ye(i);return new Promise((c,l)=>{this.a=new E(h);let g=!1;const m=($,D)=>{if(!g&&!this.b){const S=this.h($);n($)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,g=!0,t.cancel(),$=this.j($,this.g.maxResults-this.c));const b=this.h($);this.c+=b,(b>0||!n($))&&this.a.add($,D)}};Promise.all(r.map(($,D)=>this.k($,S=>m(S,D),t.token))).then($=>{t.dispose(),this.a.flush();const D=$.some(S=>!!S&&!!S.limitHit);c({limitHit:this.b||D,messages:$.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},$=>{t.dispose();const D=(0,N.$rj)($);l(new Error(D))})})}h(h){return n(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const r=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,r){const t=new R.$$L(this.g,h),c=[],l={report:$=>{if(!this.l($))return;const D=h.folder.scheme===A.Schemas.file?(0,R.$_L)(()=>this.e.readdir(p.$gh($.uri))):void 0,S=p.$jh(h.folder,$.uri);if(S){const b=t.includedInQuery(S,T.$qc(S),D);(0,I.$sh)(b)?c.push(b.then(k=>{k&&i($)})):b&&i($)}}},g=this.n(h);let m;return this.d.query.type===R.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,g,l,r):m=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),g,l,r),c.length&&await Promise.all(c),m}l(h){if(n(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,R.$0L)(this.g.includePattern,h.includePattern),r=(0,R.$0L)(this.g.excludePattern,h.excludePattern),t={folder:a.URI.from(h.folder),excludes:r,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$QL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Rpc=y;function u(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!p.$ah(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Spc=E;function d(o){return n(o)?{preview:{matches:(0,v.$4b)(o.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:o.preview.text},ranges:(0,v.$4b)(o.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function n(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Upc=s}),define(Ie[134],Pe([1,0,4,5,3,312,17,66,12,2,317]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=e.$Vpc=void 0,e.$Xpc=u,e.$Vpc=(0,C.$Gi)("IExtHostSearch");let y=class{constructor(n,s,o){this.n=n,this.o=s,this.q=o,this.c=this.n.getProxy(I.$uN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Qpc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,s){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(n)),(0,v.$Vc)(()=>{this.g.delete(n),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(n,s){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(n)),(0,v.$Vc)(()=>{this.i.delete(n),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(n,s){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(n)),(0,v.$Vc)(()=>{this.k.delete(n),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(n,s,o,h){const i=u(o),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,s,t.map(c=>c.resource))},h);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,s,o){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,s,o,h){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=u(o);return this.t(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$provideAITextSearchResults(n,s,o,h){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=u(o);return this.v(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$enableExtensionHostSearch(){}t(n,s){return new R.$Rpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(n,s){return new R.$Rpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Wpc=y,e.$Wpc=y=He([qe(0,A.$1P),qe(1,T.$Ioc),qe(2,p.$ak)],y);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>a.URI.revive(n))}}function E(d){return{...d,folder:a.URI.revive(d.folder)}}});var _t=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Ie[318],Pe([1,0,22,14,6,4,16,36,2,106,165,151,52,19,30,12,63,64,226,5,269,298,85,91,274,275,276,253,243,34,277,46,278,133,122,279,255,270,280,281,58,71,256,271,47,283,69,284,51,27,299,257,285,286,95,287,86,87,259,311,289,231,290,300,291,128,260,292,293,294,17,295,134,88,296,261,297,89,92,131,67,57,126,96,301,272,302,303,93,8,7,262,66,263,68,304,305,121,45,81,84,25,130]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,D,S,b,k,P,f,w,F,O,L,q,W,M,Y,Z,ge,_,me,se,ce,we,oe,Ce,Le,X,V,te,ve,ue,be,de,J,x,pe,$e,Ne,ze,ke,Ae,Oe,j,U,G,H,ne,fe,Re,Ue,Ke,_e,tt,nt,et,rt,ft,ct,st,ut,gt,pt,Be,je,ee,K,Se,Je,xe,ht,$t,Ot,Ft,ei,li,ti,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=Kt,I=Ve(I),T=_t(T),y=Ve(y),d=Ve(d),ee=Ve(ee),K=Ve(K);function Kt(mt){const Ct=mt.get(Ce.$eQ),ii=mt.get(oe.$toc),Xt=mt.get(ce.$Qoc),Wt=mt.get(me.$ppc),vt=mt.get(ei.$Loc),Nt=mt.get(rt.$iQ),hi=mt.get(P.$Ooc),Vt=mt.get(Je.$Ioc),Xe=mt.get(H.$1P),Yt=mt.get(tt.$0oc),ni=mt.get(nt.$Roc),di=mt.get(n.$bk),Dt=mt.get(n.$ak),Mt=mt.get(je.$3Fb),Rt=mt.get(c.$poc),zt=mt.get(Ft.$xqc),ri=mt.get(Re.$hpc),Zt=mt.get(Z.$1oc),si=mt.get(de.$lpc),Ut=mt.get(l.$zoc),Ht=mt.get(ve.$epc);Xe.set(i.$vN.ExtHostFileSystemInfo,ii),Xe.set(i.$vN.ExtHostLogLevelServiceShape,di),Xe.set(i.$vN.ExtHostWorkspace,vt),Xe.set(i.$vN.ExtHostConfiguration,hi),Xe.set(i.$vN.ExtHostExtensionService,Wt),Xe.set(i.$vN.ExtHostStorage,Yt),Xe.set(i.$vN.ExtHostTunnelService,Mt),Xe.set(i.$vN.ExtHostWindow,zt),Xe.set(i.$vN.ExtHostSecretState,ri),Xe.set(i.$vN.ExtHostTelemetry,Nt),Xe.set(i.$vN.ExtHostEditorTabs,Zt),Xe.set(i.$vN.ExtHostManagedSockets,si),Xe.set(i.$vN.ExtHostAuthentication,Ut),Xe.set(i.$vN.ExtHostChatProvider,Ht);const oi=Xe.set(i.$vN.ExtHostDecorations,mt.get(F.$Fpc)),Pt=Xe.set(i.$vN.ExtHostDocumentsAndEditors,mt.get(Y.$_P)),St=Xe.set(i.$vN.ExtHostCommands,mt.get(b.$kQ)),bt=Xe.set(i.$vN.ExtHostTerminalService,mt.get(ft.$apc)),xt=Xe.set(i.$vN.ExtHostTerminalShellIntegration,mt.get(ct.$nqc)),kt=Xe.set(i.$vN.ExtHostDebugService,mt.get(w.$zpc)),fi=Xe.set(i.$vN.ExtHostSearch,mt.get(fe.$Vpc)),qt=Xe.set(i.$vN.ExtHostTask,mt.get(et.$mqc)),bi=Xe.set(i.$vN.ExtHostOutputService,mt.get(Ae.$_pc)),vi=Xe.set(i.$vN.ExtHostLocalization,mt.get(be.$kpc)),gi=Xe.set(i.$vN.ExtHostUrls,new xe.$uqc(Xe)),jt=Xe.set(i.$vN.ExtHostDocuments,new M.$woc(Xe,Pt)),ai=Xe.set(i.$vN.ExtHostDocumentContentProviders,new q.$Hpc(Xe,Pt,Dt)),Ii=Xe.set(i.$vN.ExtHostDocumentSaveParticipant,new W.$Ipc(Dt,jt,Xe.getProxy(i.$uN.MainThreadBulkEdits))),At=Xe.set(i.$vN.ExtHostNotebook,new x.$Ypc(Xe,St,Pt,jt,Xt,fi,Dt)),Si=Xe.set(i.$vN.ExtHostNotebookDocuments,new $e.$6pc(At)),Pi=Xe.set(i.$vN.ExtHostNotebookEditors,new Ne.$7pc(Dt,At)),Di=Xe.set(i.$vN.ExtHostNotebookKernels,new ze.$8pc(Xe,Ct,At,St,Dt)),pi=Xe.set(i.$vN.ExtHostNotebookRenderers,new ke.$0pc(Xe,At)),Ri=Xe.set(i.$vN.ExtHostNotebookDocumentSaveParticipant,new pe.$5pc(Dt,At,Xe.getProxy(i.$uN.MainThreadBulkEdits))),Bt=Xe.set(i.$vN.ExtHostEditors,new ut.$Foc(Xe,Pt)),ye=Xe.set(i.$vN.ExtHostTreeViews,new Be.$sqc(Xe.getProxy(i.$uN.MainThreadTreeViews),St,Dt)),Te=Xe.set(i.$vN.ExtHostEditorInsets,new S.$Goc(Xe.getProxy(i.$uN.MainThreadEditorInsets),Bt,Ct.remote)),le=Xe.set(i.$vN.ExtHostDiagnostics,new O.$voc(Xe,Dt,ii,Pt)),Q=Xe.set(i.$vN.ExtHostLanguages,new ue.$3pc(Xe,jt,St.converter,Vt)),Ee=Xe.set(i.$vN.ExtHostLanguageFeatures,new V.$xoc(Xe,Vt,jt,St,le,Dt,Rt,Nt)),We=Xe.set(i.$vN.ExtHostFileSystem,new se.$Lpc(Xe,Ee)),Ze=Xe.set(i.$vN.ExtHostFileSystemEventService,new we.$Mpc(Xe,Dt,Pt)),Ge=Xe.set(i.$vN.ExtHostQuickOpen,(0,G.$dqc)(Xe,vt,St)),lt=Xe.set(i.$vN.ExtHostSCM,new ne.$fqc(Xe,St,jt,Dt)),It=Xe.set(i.$vN.ExtHostQuickDiff,new U.$cqc(Xe,Vt)),Qt=Xe.set(i.$vN.ExtHostShare,new Ue.$gqc(Xe,Vt)),ci=Xe.set(i.$vN.ExtHostComments,(0,k.$Hoc)(Xe,St,jt)),Lt=Xe.set(i.$vN.ExtHostProgress,new j.$bqc(Xe.getProxy(i.$uN.MainThreadProgress))),ui=Xe.set(i.$vN.ExtHostLabelService,new X.$1pc(Xe)),Vi=Xe.set(i.$vN.ExtHostTheming,new gt.$pqc(Xe)),$n=Xe.set(i.$vN.ExtHostTimeline,new pt.$rqc(Xe,St)),Li=Xe.set(i.$vN.ExtHostWebviews,new ht.$Voc(Xe,Ct.remote,vt,Dt,Rt)),Ni=Xe.set(i.$vN.ExtHostWebviewPanels,new $t.$Yoc(Xe,Li,vt)),qi=Xe.set(i.$vN.ExtHostCustomEditors,new f.$Zoc(Xe,jt,ni,Li,Ni)),xi=Xe.set(i.$vN.ExtHostWebviewViews,new Ot.$vqc(Xe,Li)),ki=Xe.set(i.$vN.ExtHostTesting,mt.get(st.$upc)),_i=Xe.set(i.$vN.ExtHostUriOpeners,new Se.$tqc(Xe)),en=Xe.set(i.$vN.ExtHostProfileContentHandlers,new Oe.$aqc(Xe));Xe.set(i.$vN.ExtHostInteractive,new Le.$Zpc(Xe,At,Pt,St,Dt));const Fi=Xe.set(i.$vN.ExtHostChatAgents2,new m.$Coc(Xe,Dt,St)),tn=Xe.set(i.$vN.ExtHostChatVariables,new $.$Doc(Xe)),Gi=Xe.set(i.$vN.ExtHostLanguageModelTools,new te.$2pc(Xe)),nn=Xe.set(i.$vN.ExtHostAiRelatedInformation,new r.$ooc(Xe)),Ki=Xe.set(i.$vN.ExtHostAiEmbeddingVector,new _.$Kpc(Xe)),zi=Xe.set(i.$vN.ExtHostStatusBar,new _e.$jqc(Xe,St.converter)),wn=Xe.set(i.$vN.ExtHostSpeech,new Ke.$hqc(Xe)),Oi=Xe.set(i.$vN.ExtHostEmbeddings,new ge.$Jpc(Xe)),rn=Object.values(i.$vN);Xe.assertRegistered(rn);const bn=new g.$Boc(Xe,Pt),Hi=new D.$Eoc(Xe),Ui=new J.$4pc(Xe,Dt),Qi=new L.$Gpc(Xe);return t.$yoc.register(St),function(Fe,yi,ji){function ot(ie){return(he,Me,at)=>{const Et=ie(Tt=>{try{he.call(Me,Tt)}catch(Ai){I.$4(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Nt.onExtensionError(Fe.identifier,Ai)}});return at?.push(Et),Et}}const wt=function(){let ie=!Fe.isUnderDevelopment;function he(){ie||(Dt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")he();else{const Et=at;typeof Et.scheme>"u"&&he(),typeof Et.exclusive=="boolean"&&(0,Ye.$7G)(Fe,"documentFiltersExclusive")}return at}}(),Bi={getSession(ie,he,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ye.$7G)(Fe,"authLearnMore"),Me?.account&&(0,Ye.$7G)(Fe,"authGetSessions"),Ut.getSession(Fe,ie,he,Me)},getSessions(ie,he){return(0,Ye.$7G)(Fe,"authGetSessions"),Ut.getSessions(Fe,ie,he)},getAccounts(ie){return(0,Ye.$7G)(Fe,"authGetSessions"),Ut.getAccounts(ie)},async hasSession(ie,he){return(0,Ye.$7G)(Fe,"authSession"),!!await Ut.getSession(Fe,ie,he,{silent:!0})},get onDidChangeSessions(){return ot(Ut.onDidChangeSessions)},registerAuthenticationProvider(ie,he,Me,at){return Ut.registerAuthenticationProvider(ie,he,Me,at)}},vn={registerCommand(ie,he,Me){return St.registerCommand(!0,ie,he,Me,void 0,Fe)},registerTextEditorCommand(ie,he,Me){return St.registerCommand(!0,ie,(...at)=>{const Et=Bt.getActiveTextEditor();if(!Et){Dt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Et.edit(Tt=>{he.apply(Me,[Et,Tt,...at])}).then(Tt=>{Tt||Dt.warn("Edits from command "+ie+" were not applied.")},Tt=>{Dt.warn("An error occurred while running command "+ie,Tt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ie,he,Me)=>((0,Ye.$7G)(Fe,"diffCommand"),St.registerCommand(!0,ie,async(...at)=>{const Et=Pt.activeEditor(!0);if(!Et){Dt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Tt=await Bt.getDiffInformation(Et.id);he.apply(Me,[Tt,...at])},void 0,void 0,Fe)),executeCommand(ie,...he){return St.executeCommand(ie,...he)},getCommands(ie=!1){return St.getCommands(ie)}},mi={get machineId(){return Ct.telemetryInfo.machineId},get sessionId(){return Ct.telemetryInfo.sessionId},get language(){return Ct.environment.appLanguage},get appName(){return Ct.environment.appName},get appRoot(){return Ct.environment.appRoot?.fsPath??""},get appHost(){return Ct.environment.appHost},get uriScheme(){return Ct.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$7G)(Fe,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$7G)(Fe,"telemetry"),ot(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$hQ)(Ct.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,he){return rt.$gQ.validateSender(ie),Nt.instantiateLogger(Fe,ie,he)},openExternal(ie,he){return zt.openUri(ie,{allowTunneling:!!Ct.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Ct.environment.appUriScheme)return gi.createAppUri(ie);try{return await zt.asExternalUri(ie,{allowTunneling:!!Ct.remote.authority})}catch(he){if((0,A.$Pg)(ie,A.Schemas.http)||(0,A.$Pg)(ie,A.Schemas.https))return ie;throw he}},get remoteName(){return(0,s.$in)(Ct.remote.authority)},get remoteAuthority(){return(0,Ye.$7G)(Fe,"resolvers"),Ct.remote.authority},get uiKind(){return Ct.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return ot(Dt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$7G)(Fe,"resolvers"),Ct.quality},get appCommit(){return(0,Ye.$7G)(Fe,"resolvers"),Ct.commit}};Ct.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(ie,he,Me){return ki.createTestController(Fe,ie,he,Me)},createTestObserver(){return(0,Ye.$7G)(Fe,"testObserver"),ki.createTestObserver()},runTests(ie){return(0,Ye.$7G)(Fe,"testObserver"),ki.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ye.$7G)(Fe,"testObserver"),ki.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ye.$7G)(Fe,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,Ye.$7G)(Fe,"testObserver"),ki.results}},Mi=Ct.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,sn={getExtension(ie,he){(0,Ye.$6G)(Fe,"extensionsAny")||(he=!1);const Me=yi.mine.getExtensionDescription(ie);if(Me)return new me.$qpc(Wt,Fe.identifier,Me,Mi,!1);if(he){const at=yi.all.getExtensionDescription(ie);if(at)return new me.$qpc(Wt,Fe.identifier,at,Mi,!0)}},get all(){const ie=[];for(const he of yi.mine.getAllExtensionDescriptions())ie.push(new me.$qpc(Wt,Fe.identifier,he,Mi,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.$7G)(Fe,"extensionsAny");const ie=new E.$sn(yi.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),he=[];for(const Me of yi.all.getAllExtensionDescriptions()){const at=!ie.has(Me.identifier);he.push(new me.$qpc(Wt,Fe.identifier,Me,Mi,at))}return he},get onDidChange(){return(0,Ye.$6G)(Fe,"extensionsAny")?ot(C.Event.any(yi.mine.onDidChange,yi.all.onDidChange)):ot(yi.mine.onDidChange)}},on={createDiagnosticCollection(ie){return le.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:ie=>le.getDiagnostics(ie),getLanguages(){return Q.getLanguages()},setTextDocumentLanguage(ie,he){return Q.changeLanguage(ie.uri,he)},match(ie,he){const Me=ee.LanguageSelector.from(ie);let at;return(0,R.$uu)(Me)&&(at=At.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Tt=>Tt.document===he))?.apiNotebook),(0,R.$tu)(Me,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,he,Me){return Ee.registerCodeActionProvider(Fe,wt(ie),he,Me)},registerDocumentPasteEditProvider(ie,he,Me){return(0,Ye.$7G)(Fe,"documentPaste"),Ee.registerDocumentPasteEditProvider(Fe,wt(ie),he,Me)},registerCodeLensProvider(ie,he){return Ee.registerCodeLensProvider(Fe,wt(ie),he)},registerDefinitionProvider(ie,he){return Ee.registerDefinitionProvider(Fe,wt(ie),he)},registerDeclarationProvider(ie,he){return Ee.registerDeclarationProvider(Fe,wt(ie),he)},registerImplementationProvider(ie,he){return Ee.registerImplementationProvider(Fe,wt(ie),he)},registerTypeDefinitionProvider(ie,he){return Ee.registerTypeDefinitionProvider(Fe,wt(ie),he)},registerHoverProvider(ie,he){return Ee.registerHoverProvider(Fe,wt(ie),he,Fe.identifier)},registerEvaluatableExpressionProvider(ie,he){return Ee.registerEvaluatableExpressionProvider(Fe,wt(ie),he,Fe.identifier)},registerInlineValuesProvider(ie,he){return Ee.registerInlineValuesProvider(Fe,wt(ie),he,Fe.identifier)},registerDocumentHighlightProvider(ie,he){return Ee.registerDocumentHighlightProvider(Fe,wt(ie),he)},registerMultiDocumentHighlightProvider(ie,he){return Ee.registerMultiDocumentHighlightProvider(Fe,wt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return Ee.registerLinkedEditingRangeProvider(Fe,wt(ie),he)},registerReferenceProvider(ie,he){return Ee.registerReferenceProvider(Fe,wt(ie),he)},registerRenameProvider(ie,he){return Ee.registerRenameProvider(Fe,wt(ie),he)},registerNewSymbolNamesProvider(ie,he){return(0,Ye.$7G)(Fe,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Fe,wt(ie),he)},registerDocumentSymbolProvider(ie,he,Me){return Ee.registerDocumentSymbolProvider(Fe,wt(ie),he,Me)},registerWorkspaceSymbolProvider(ie){return Ee.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,he){return Ee.registerDocumentFormattingEditProvider(Fe,wt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return Ee.registerDocumentRangeFormattingEditProvider(Fe,wt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Me,...at){return Ee.registerOnTypeFormattingEditProvider(Fe,wt(ie),he,[Me].concat(at))},registerDocumentSemanticTokensProvider(ie,he,Me){return Ee.registerDocumentSemanticTokensProvider(Fe,wt(ie),he,Me)},registerDocumentRangeSemanticTokensProvider(ie,he,Me){return Ee.registerDocumentRangeSemanticTokensProvider(Fe,wt(ie),he,Me)},registerSignatureHelpProvider(ie,he,Me,...at){return typeof Me=="object"?Ee.registerSignatureHelpProvider(Fe,wt(ie),he,Me):Ee.registerSignatureHelpProvider(Fe,wt(ie),he,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ie,he,...Me){return Ee.registerCompletionItemProvider(Fe,wt(ie),he,Me)},registerInlineCompletionItemProvider(ie,he,Me){return he.handleDidShowCompletionItem&&(0,Ye.$7G)(Fe,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$7G)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ye.$7G)(Fe,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Fe,wt(ie),he,Me)},registerInlineEditProvider(ie,he){return(0,Ye.$7G)(Fe,"inlineEdit"),Ee.registerInlineEditProvider(Fe,wt(ie),he)},registerDocumentLinkProvider(ie,he){return Ee.registerDocumentLinkProvider(Fe,wt(ie),he)},registerColorProvider(ie,he){return Ee.registerColorProvider(Fe,wt(ie),he)},registerFoldingRangeProvider(ie,he){return Ee.registerFoldingRangeProvider(Fe,wt(ie),he)},registerSelectionRangeProvider(ie,he){return Ee.registerSelectionRangeProvider(Fe,ie,he)},registerCallHierarchyProvider(ie,he){return Ee.registerCallHierarchyProvider(Fe,ie,he)},registerTypeHierarchyProvider(ie,he){return Ee.registerTypeHierarchyProvider(Fe,ie,he)},setLanguageConfiguration:(ie,he)=>Ee.setLanguageConfiguration(Fe,ie,he),getTokenInformationAtPosition(ie,he){return(0,Ye.$7G)(Fe,"tokenInformation"),Q.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return Ee.registerInlayHintsProvider(Fe,ie,he)},createLanguageStatusItem(ie,he){return Q.createLanguageStatusItem(Fe,ie,he)},registerDocumentDropEditProvider(ie,he,Me){return Ee.registerDocumentOnDropEditProvider(Fe,ie,he,(0,Ye.$6G)(Fe,"documentPaste")?Me:void 0)}},an={get activeTextEditor(){return Bt.getActiveTextEditor()},get visibleTextEditors(){return Bt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,he,Me){p.URI.isUri(ie)&&ie.scheme===A.Schemas.vscodeRemote&&!ie.authority&&Rt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ie)?Promise.resolve(cn.openTextDocument(ie)):Promise.resolve(ie));return Bt.showTextDocument(at,he,Me)},createTextEditorDecorationType(ie){return Bt.createTextEditorDecorationType(Fe,ie)},onDidChangeActiveTextEditor(ie,he,Me){return ot(Bt.onDidChangeActiveTextEditor)(ie,he,Me)},onDidChangeVisibleTextEditors(ie,he,Me){return ot(Bt.onDidChangeVisibleTextEditors)(ie,he,Me)},onDidChangeTextEditorSelection(ie,he,Me){return ot(Bt.onDidChangeTextEditorSelection)(ie,he,Me)},onDidChangeTextEditorOptions(ie,he,Me){return ot(Bt.onDidChangeTextEditorOptions)(ie,he,Me)},onDidChangeTextEditorVisibleRanges(ie,he,Me){return ot(Bt.onDidChangeTextEditorVisibleRanges)(ie,he,Me)},onDidChangeTextEditorViewColumn(ie,he,Me){return ot(Bt.onDidChangeTextEditorViewColumn)(ie,he,Me)},onDidCloseTerminal(ie,he,Me){return ot(bt.onDidCloseTerminal)(ie,he,Me)},onDidOpenTerminal(ie,he,Me){return ot(bt.onDidOpenTerminal)(ie,he,Me)},onDidChangeActiveTerminal(ie,he,Me){return ot(bt.onDidChangeActiveTerminal)(ie,he,Me)},onDidChangeTerminalDimensions(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ie,he,Me)},onDidChangeTerminalState(ie,he,Me){return ot(bt.onDidChangeTerminalState)(ie,he,Me)},onDidWriteTerminalData(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ie,he,Me)},onDidExecuteTerminalCommand(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ie,he,Me)},onDidChangeTerminalShellIntegration(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalShellIntegration"),ot(xt.onDidChangeTerminalShellIntegration)(ie,he,Me)},onDidStartTerminalShellExecution(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalShellIntegration"),ot(xt.onDidStartTerminalShellExecution)(ie,he,Me)},onDidEndTerminalShellExecution(ie,he,Me){return(0,Ye.$7G)(Fe,"terminalShellIntegration"),ot(xt.onDidEndTerminalShellExecution)(ie,he,Me)},get state(){return zt.getState()},onDidChangeWindowState(ie,he,Me){return ot(zt.onDidChangeWindowState)(ie,he,Me)},showInformationMessage(ie,...he){return Ui.showMessage(Fe,T.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return Ui.showMessage(Fe,T.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return Ui.showMessage(Fe,T.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Me){return Ge.showQuickPick(Fe,ie,he,Me)},showWorkspaceFolderPick(ie){return Ge.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Ge.showInput(ie,he)},showOpenDialog(ie){return Qi.showOpenDialog(Fe,ie)},showSaveDialog(ie){return Qi.showSaveDialog(ie)},createStatusBarItem(ie,he,Me){let at,Et,Tt;return typeof ie=="string"?(at=ie,Et=he,Tt=Me):(Et=ie,Tt=he),zi.createStatusBarEntry(Fe,at,Et,Tt)},setStatusBarMessage(ie,he){return zi.setStatusBarMessage(ie,he)},withScmProgress(ie){return Rt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Lt.withProgress(Fe,{location:K.ProgressLocation.SourceControl},(he,Me)=>ie({report(at){}}))},withProgress(ie,he){return Lt.withProgress(Fe,ie,he)},createOutputChannel(ie,he){return bi.createOutputChannel(ie,he,Fe)},createWebviewPanel(ie,he,Me,at){return Ni.createWebviewPanel(Fe,ie,he,Me,at)},createWebviewTextEditorInset(ie,he,Me,at){return(0,Ye.$7G)(Fe,"editorInsets"),Te.createWebviewEditorInset(ie,he,Me,at,Fe)},createTerminal(ie,he,Me){return typeof ie=="object"?"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie):bt.createTerminal(ie,he,Me)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return bt.registerProfileProvider(Fe,ie,he)},registerTerminalQuickFixProvider(ie,he){return(0,Ye.$7G)(Fe,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ie,Fe.identifier.value,he)},registerTreeDataProvider(ie,he){return ye.registerTreeDataProvider(ie,he,Fe)},createTreeView(ie,he){return ye.createTreeView(ie,he,Fe)},registerWebviewPanelSerializer:(ie,he)=>Ni.registerWebviewPanelSerializer(Fe,ie,he),registerCustomEditorProvider:(ie,he,Me={})=>qi.registerCustomEditorProvider(Fe,ie,he,Me),registerFileDecorationProvider(ie){return oi.registerFileDecorationProvider(ie,Fe)},registerUriHandler(ie){return gi.registerUriHandler(Fe,ie)},createQuickPick(){return Ge.createQuickPick(Fe)},createInputBox(){return Ge.createInputBox(Fe)},get activeColorTheme(){return Vi.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Me){return ot(Vi.onDidChangeActiveColorTheme)(ie,he,Me)},registerWebviewViewProvider(ie,he,Me){return xi.registerWebviewViewProvider(Fe,ie,he,Me?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Me){return ot(At.onDidChangeActiveNotebookEditor)(ie,he,Me)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,he,Me){return ot(Pi.onDidChangeNotebookEditorSelection)(ie,he,Me)},onDidChangeNotebookEditorVisibleRanges(ie,he,Me){return ot(Pi.onDidChangeNotebookEditorVisibleRanges)(ie,he,Me)},showNotebookDocument(ie,he){return At.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Me){return(0,Ye.$7G)(Fe,"externalUriOpener"),_i.registerExternalUriOpener(Fe.identifier,ie,he,Me)},registerProfileContentHandler(ie,he){return(0,Ye.$7G)(Fe,"profileContentHandlers"),en.registerProfileContentHandler(Fe,ie,he)},registerQuickDiffProvider(ie,he,Me,at){return(0,Ye.$7G)(Fe,"quickDiffProvider"),It.registerQuickDiffProvider(wt(ie),he,Me,at)},get tabGroups(){return Zt.tabGroups},registerShareProvider(ie,he){return(0,Ye.$7G)(Fe,"shareProvider"),Qt.registerShareProvider(wt(ie),he)}},cn={get rootPath(){return Rt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(ie){throw new I.$_("rootPath")},getWorkspaceFolder(ie){return vt.getWorkspaceFolder(ie)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(ie){throw new I.$_("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(ie){throw new I.$_("workspaceFile")},updateWorkspaceFolders:(ie,he,...Me)=>vt.updateWorkspaceFolders(Fe,ie,he||0,...Me),onDidChangeWorkspaceFolders:function(ie,he,Me){return ot(vt.onDidChangeWorkspace)(ie,he,Me)},asRelativePath:(ie,he)=>vt.getRelativePath(ie,he),findFiles:(ie,he,Me,at)=>vt.findFiles(ie,he,Me,Fe.identifier,at),findFiles2:(ie,he,Me)=>((0,Ye.$7G)(Fe,"findFiles2"),vt.findFiles2(ie,he,Fe.identifier,Me)),findTextInFiles:(ie,he,Me,at)=>{(0,Ye.$7G)(Fe,"findTextInFiles");let Et,Tt;return typeof he=="object"?(Et=he,Tt=Me):(Et={},Tt=he,at=Me),vt.findTextInFiles(ie,Et||{},Tt,Fe.identifier,at)},save:ie=>vt.save(ie),saveAs:ie=>vt.saveAs(ie),saveAll:ie=>vt.saveAll(ie),applyEdit(ie,he){return bn.applyWorkspaceEdit(ie,Fe,he)},createFileSystemWatcher:(ie,he,Me,at)=>{let Et;return typeof he=="boolean"?Et={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,Ye.$7G)(Fe,"createFileSystemWatcher"),Et={...he,correlate:!0}),Ze.createFileSystemWatcher(vt,Fe,ie,Et)},get textDocuments(){return jt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new I.$_("textDocuments")},openTextDocument(ie){let he;const Me=ie;if(typeof ie=="string")he=Promise.resolve(p.URI.file(ie));else if(p.URI.isUri(ie))he=Promise.resolve(ie);else if(!Me||typeof Me=="object")he=jt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&Rt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),jt.ensureDocumentData(at).then(Et=>Et.document)))},onDidOpenTextDocument:(ie,he,Me)=>ot(jt.onDidAddDocument)(ie,he,Me),onDidCloseTextDocument:(ie,he,Me)=>ot(jt.onDidRemoveDocument)(ie,he,Me),onDidChangeTextDocument:(ie,he,Me)=>ot(jt.onDidChangeDocument)(ie,he,Me),onDidSaveTextDocument:(ie,he,Me)=>ot(jt.onDidSaveDocument)(ie,he,Me),onWillSaveTextDocument:(ie,he,Me)=>ot(Ii.getOnWillSaveTextDocumentEvent(Fe))(ie,he,Me),get notebookDocuments(){return At.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Me;if(p.URI.isUri(ie))Me=ie,await At.openNotebookDocument(ie);else if(typeof ie=="string")Me=p.URI.revive(await At.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return At.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ie,he,Me){return ot(Si.onDidSaveNotebookDocument)(ie,he,Me)},onDidChangeNotebookDocument(ie,he,Me){return ot(Si.onDidChangeNotebookDocument)(ie,he,Me)},onWillSaveNotebookDocument(ie,he,Me){return ot(Ri.getOnWillSaveNotebookDocumentEvent(Fe))(ie,he,Me)},get onDidOpenNotebookDocument(){return ot(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(At.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,he,Me,at){return At.registerNotebookSerializer(Fe,ie,he,Me,(0,Ye.$6G)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,he,Me)=>ot(ji.onDidChangeConfiguration)(ie,he,Me),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,ji.getConfiguration(ie,he,Fe)},registerTextDocumentContentProvider(ie,he){return ai.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Rt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Fe,ie,he)),registerFileSystemProvider(ie,he,Me){return(0,N.$Uc)(We.registerFileSystemProvider(Fe,ie,he,Me),Xt.addFileSystemProvider(ie,he,Me))},get fs(){return Xt.value},registerFileSearchProvider:(ie,he)=>((0,Ye.$7G)(Fe,"fileSearchProvider"),fi.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,Ye.$7G)(Fe,"textSearchProvider"),fi.registerTextSearchProvider(ie,he)),registerAITextSearchProvider:(ie,he)=>((0,Ye.$7G)(Fe,"aiTextSearchProvider"),(0,Ye.$7G)(Fe,"textSearchProvider"),fi.registerAITextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,Ye.$7G)(Fe,"resolvers"),Wt.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,Ye.$7G)(Fe,"resolvers"),ui.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.$7G)(Fe,"resolvers"),Wt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,he,Me)=>ot(Ze.onDidCreateFile)(ie,he,Me),onDidDeleteFiles:(ie,he,Me)=>ot(Ze.onDidDeleteFile)(ie,he,Me),onDidRenameFiles:(ie,he,Me)=>ot(Ze.onDidRenameFile)(ie,he,Me),onWillCreateFiles:(ie,he,Me)=>ot(Ze.getOnWillCreateFileEvent(Fe))(ie,he,Me),onWillDeleteFiles:(ie,he,Me)=>ot(Ze.getOnWillDeleteFileEvent(Fe))(ie,he,Me),onWillRenameFiles:(ie,he,Me)=>ot(Ze.getOnWillRenameFileEvent(Fe))(ie,he,Me),openTunnel:ie=>((0,Ye.$7G)(Fe,"tunnels"),Mt.openTunnel(Fe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ye.$7G)(Fe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ie,he,Me)=>((0,Ye.$7G)(Fe,"tunnels"),ot(Mt.onDidChangeTunnels)(ie,he,Me)),registerPortAttributesProvider:(ie,he)=>((0,Ye.$7G)(Fe,"portsAttributes"),Mt.registerPortsAttributesProvider(ie,he)),registerTunnelProvider:(ie,he)=>((0,Ye.$7G)(Fe,"tunnelFactory"),Mt.registerTunnelProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,Ye.$7G)(Fe,"timeline"),$n.registerTimelineProvider(ie,he,Fe.identifier,St.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:ie=>((0,Ye.$7G)(Fe,"workspaceTrust"),vt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Me)=>ot(vt.onDidGrantWorkspaceTrust)(ie,he,Me),registerEditSessionIdentityProvider:(ie,he)=>((0,Ye.$7G)(Fe,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(ie,he)),onWillCreateEditSessionIdentity:(ie,he,Me)=>((0,Ye.$7G)(Fe,"editSessionIdentityProvider"),ot(vt.getOnWillCreateEditSessionIdentityEvent(Fe))(ie,he,Me)),registerCanonicalUriProvider:(ie,he)=>((0,Ye.$7G)(Fe,"canonicalUriProvider"),vt.registerCanonicalUriProvider(ie,he)),getCanonicalUri:(ie,he,Me)=>((0,Ye.$7G)(Fe,"canonicalUriProvider"),vt.provideCanonicalUri(ie,he,Me))},un={get inputBox(){return Rt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),lt.getLastInputBox(Fe)},createSourceControl(ie,he,Me){return lt.createSourceControl(Fe,ie,he,Me)}},ln={createCommentController(ie,he){return ci.createCommentController(Fe,ie,he)}},yn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(ie,he){return(0,Ye.$7G)(Fe,"debugVisualization"),kt.registerDebugVisualizationProvider(Fe,ie,he)},registerDebugVisualizationTreeProvider(ie,he){return(0,Ye.$7G)(Fe,"debugVisualization"),kt.registerDebugVisualizationTree(Fe,ie,he)},onDidStartDebugSession(ie,he,Me){return ot(kt.onDidStartDebugSession)(ie,he,Me)},onDidTerminateDebugSession(ie,he,Me){return ot(kt.onDidTerminateDebugSession)(ie,he,Me)},onDidChangeActiveDebugSession(ie,he,Me){return ot(kt.onDidChangeActiveDebugSession)(ie,he,Me)},onDidReceiveDebugSessionCustomEvent(ie,he,Me){return ot(kt.onDidReceiveDebugSessionCustomEvent)(ie,he,Me)},onDidChangeBreakpoints(ie,he,Me){return ot(kt.onDidChangeBreakpoints)(ie,he,Me)},onDidChangeActiveStackItem(ie,he,Me){return ot(kt.onDidChangeActiveStackItem)(ie,he,Me)},registerDebugConfigurationProvider(ie,he,Me){return kt.registerDebugConfigurationProvider(ie,he,Me||li.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return kt.registerDebugAdapterDescriptorFactory(Fe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return kt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Me){return!Me||typeof Me=="object"&&"configuration"in Me?kt.startDebugging(ie,he,{parentSession:Me}):kt.startDebugging(ie,he,Me||{})},stopDebugging(ie){return kt.stopDebugging(ie)},addBreakpoints(ie){return kt.addBreakpoints(ie)},removeBreakpoints(ie){return kt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return kt.asDebugSourceUri(ie,he)}},En={registerTaskProvider:(ie,he)=>qt.registerTaskProvider(Fe,ie,he),fetchTasks:ie=>qt.fetchTasks(ie),executeTask:ie=>qt.executeTask(Fe,ie),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ie,he,Me)=>ot(qt.onDidStartTask)(ie,he,Me),onDidEndTask:(ie,he,Me)=>ot(qt.onDidEndTask)(ie,he,Me),onDidStartTaskProcess:(ie,he,Me)=>ot(qt.onDidStartTaskProcess)(ie,he,Me),onDidEndTaskProcess:(ie,he,Me)=>ot(qt.onDidEndTaskProcess)(ie,he,Me)},hn={createNotebookController(ie,he,Me,at,Et){return Di.createNotebookController(Fe,ie,he,Me,at,(0,Ye.$6G)(Fe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>At.registerNotebookCellStatusBarItemProvider(Fe,ie,he),createRendererMessaging(ie){return pi.createRendererMessaging(Fe,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.$7G)(Fe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(Fe,ie)},registerKernelSourceActionProvider(ie,he){return(0,Ye.$7G)(Fe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(Fe,ie,he)},onDidChangeNotebookCellExecutionState(ie,he,Me){return(0,Ye.$7G)(Fe,"notebookCellExecutionState"),ot(Di.onDidChangeNotebookCellExecutionState)(ie,he,Me)}},Ji={t(...ie){if(typeof ie[0]=="string"){const he=ie.shift(),Me=!ie||typeof ie[0]!="object"?ie:ie[0];return vi.getMessage(Fe.identifier.value,{message:he,args:Me})}return vi.getMessage(Fe.identifier.value,ie[0])},get bundle(){return vi.getBundle(Fe.identifier.value)},get uri(){return vi.getBundleUri(Fe.identifier.value)}},dn={_version:1,transferActiveChat(ie){return(0,Ye.$7G)(Fe,"interactive"),Fi.transferActiveChat(ie)}},fn={getRelatedInformation(ie,he){return(0,Ye.$7G)(Fe,"aiRelatedInformation"),nn.getRelatedInformation(Fe,ie,he)},registerRelatedInformationProvider(ie,he){return(0,Ye.$7G)(Fe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Fe,ie,he)},registerEmbeddingVectorProvider(ie,he){return(0,Ye.$7G)(Fe,"aiRelatedInformation"),Ki.registerEmbeddingVectorProvider(Fe,ie,he)}},gn={_version:1,registerChatResponseProvider(ie,he,Me){return(0,Ye.$7G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,he,Me)},registerChatVariableResolver(ie,he,Me,at,Et,Tt,Ai,Xi){return(0,Ye.$7G)(Fe,"chatVariableResolver"),tn.registerVariableResolver(Fe,ie,he,Me,at,Et,Tt,Ai,Xi?.id)},registerMappedEditsProvider(ie,he){return(0,Ye.$7G)(Fe,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Fe,ie,he)},createChatParticipant(ie,he){return Fi.createChatAgent(Fe,ie,he)},createDynamicChatParticipant(ie,he,Me){return(0,Ye.$7G)(Fe,"chatParticipantPrivate"),Fi.createDynamicChatAgent(Fe,ie,he,Me)}},Sn={selectChatModels:ie=>Ht.selectLanguageModels(Fe,ie??{}),onDidChangeChatModels:(ie,he,Me)=>Ht.onDidChangeProviders(ie,he,Me),registerChatModelProvider:(ie,he,Me)=>((0,Ye.$7G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,he,Me)),get embeddingModels(){return(0,Ye.$7G)(Fe,"embeddings"),Oi.embeddingsModels},onDidChangeEmbeddingModels:(ie,he,Me)=>((0,Ye.$7G)(Fe,"embeddings"),Oi.onDidChange(ie,he,Me)),registerEmbeddingsProvider(ie,he){return(0,Ye.$7G)(Fe,"embeddings"),Oi.registerEmbeddingsProvider(Fe,ie,he)},async computeEmbeddings(ie,he,Me){return(0,Ye.$7G)(Fe,"embeddings"),Oi.computeEmbeddings(ie,he,Me)},registerTool(ie,he){return(0,Ye.$7G)(Fe,"lmTools"),Gi.registerTool(Fe,ie,he)},invokeTool(ie,he,Me){return(0,Ye.$7G)(Fe,"lmTools"),Gi.invokeTool(ie,he,Me)},get tools(){return(0,Ye.$7G)(Fe,"lmTools"),Gi.tools}},Dn={registerSpeechProvider(ie,he){return(0,Ye.$7G)(Fe,"speech"),wn.registerProvider(Fe.identifier,ie,he)}};return{version:Ct.version,ai:fn,authentication:Bi,commands:vn,comments:ln,chat:gn,debug:yn,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Sn,notebooks:hn,scm:un,speech:Dn,tasks:En,tests:Wi,window:an,workspace:cn,Breakpoint:K.$xO,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatResultFeedbackKind:K.ChatResultFeedbackKind,ChatVariableLevel:K.ChatVariableLevel,ChatCompletionItem:K.$sP,CallHierarchyIncomingCall:K.$VN,CallHierarchyItem:K.$UN,CallHierarchyOutgoingCall:K.$WN,CancellationError:I.$8,CancellationTokenSource:v.$ye,CandidatePortSource:i.CandidatePortSource,CodeAction:K.$RN,CodeActionKind:K.$SN,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$XN,Color:K.$$N,ColorInformation:K.$_N,ColorPresentation:K.$aO,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CommentThreadApplicability:K.CommentThreadApplicability,CompletionItem:K.$5N,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$6N,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$iO,DebugAdapterExecutable:K.$BO,DebugAdapterInlineImplementation:K.$EO,DebugAdapterNamedPipeServer:K.$DO,DebugAdapterServer:K.$CO,DebugConfigurationProviderTriggerKind:li.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DebugVisualization:K.$UO,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$KN,DiagnosticRelatedInformation:K.$JN,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$wN,DocumentHighlight:K.$NN,DocumentHighlightKind:K.DocumentHighlightKind,MultiDocumentHighlight:K.$ON,DocumentLink:K.$0N,DocumentSymbol:K.$QN,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$HO,InlineValueText:K.$IO,InlineValueVariableLookup:K.$JO,InlineValueEvaluatableExpression:K.$KO,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:C.$ne,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$WO,FileDecoration2:K.$WO,FileSystemError:K.$NO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:K.$OO,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$zO,InlineCompletionItem:K.$7N,InlineCompletionList:K.$8N,Hover:K.$LN,VerboseHover:K.$MN,HoverVerbosityAction:K.HoverVerbosityAction,IndentAction:y.IndentAction,Location:K.$IN,MarkdownString:K.$YN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:K.$ZN,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$xN,ProcessExecution:K.$gO,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$VO,Range:K.$yN,RelativePattern:K.$vO,Selection:K.$zN,SelectionRange:K.$TN,SemanticTokens:K.$RO,SemanticTokensBuilder:K.$QO,SemanticTokensEdit:K.$SO,SemanticTokensEdits:K.$TO,SemanticTokensLegend:K.$PO,ShellExecution:K.$hO,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$2N,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$1N,SnippetString:K.$HN,SourceBreakpoint:K.$yO,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$PN,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$jO,TaskGroup:K.$fO,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$bO,TerminalQuickFixTerminalCommand:K.$dO,TerminalQuickFixOpener:K.$cO,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$eO,TerminalExitReason:K.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:K.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$DN,SnippetTextEdit:K.$FN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$uO,ThemeIcon:K.$tO,TreeItem:K.$kO,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$gP,UIKind:ti.UIKind,Uri:p.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$GN,DocumentPasteTriggerKind:K.DocumentPasteTriggerKind,DocumentDropEdit:K.$qO,DocumentDropOrPasteEditKind:K.$rO,DocumentPasteEdit:K.$sO,InlayHint:K.$4N,InlayHintLabelPart:K.$3N,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$CN,ResolvedAuthority:K.$AN,ManagedResolvedAuthority:K.$BN,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$7O,NotebookRange:K.$YO,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$ZO,NotebookData:K.$1O,NotebookRendererScript:K.$5O,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$3O,NotebookCellOutputItem:K.$2O,NotebookCellStatusBarItem:K.$4O,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$EN,NotebookKernelSourceAction:K.$6O,NotebookVariablesRequestKind:K.NotebookVariablesRequestKind,PortAttributes:K.$9O,LinkedEditingRanges:K.$8O,TestResultState:K.TestResultState,TestRunRequest:K.$0O,TestMessage:K.$$O,TestTag:K.$_O,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:K.$pO,DataTransferItem:K.$lO,TestCoverageCount:K.$aP,FileCoverage:K.$cP,FileCoverage2:K.$cP,StatementCoverage:K.$dP,BranchCoverage:K.$eP,DeclarationCoverage:K.$fP,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$hP,TabInputTextDiff:K.$iP,TabInputTextMerge:K.$jP,TabInputCustom:K.$kP,TabInputNotebook:K.$mP,TabInputNotebookDiff:K.$nP,TabInputWebview:K.$lP,TabInputTerminal:K.$oP,TabInputInteractiveWindow:K.$pP,TabInputChat:K.$qP,TabInputTextMultiDiff:K.$rP,TelemetryTrustedValue:o.$vp,LogLevel:n.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,ChatCopyKind:K.ChatCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,DebugStackFrame:K.$FO,DebugThread:K.$GO,RelatedInformationType:K.RelatedInformationType,SpeechToTextStatus:K.SpeechToTextStatus,TextToSpeechStatus:K.TextToSpeechStatus,PartialAcceptTriggerKind:K.PartialAcceptTriggerKind,KeywordRecognitionStatus:K.KeywordRecognitionStatus,ChatResponseMarkdownPart:K.$tP,ChatResponseFileTreePart:K.$xP,ChatResponseAnchorPart:K.$yP,ChatResponseProgressPart:K.$zP,ChatResponseProgressPart2:K.$AP,ChatResponseReferencePart:K.$DP,ChatResponseWarningPart:K.$BP,ChatResponseTextEditPart:K.$EP,ChatResponseMarkdownWithVulnerabilitiesPart:K.$uP,ChatResponseCommandButtonPart:K.$CP,ChatResponseDetectedParticipantPart:K.$vP,ChatResponseConfirmationPart:K.$wP,ChatRequestTurn:K.$FP,ChatResponseTurn:K.$GP,ChatLocation:K.ChatLocation,LanguageModelChatMessageRole:K.LanguageModelChatMessageRole,LanguageModelChatMessage:K.$IP,LanguageModelChatMessageFunctionResultPart:K.$HP,LanguageModelChatResponseTextPart:K.$KP,LanguageModelChatResponseFunctionUsePart:K.$JP,LanguageModelChatMessage2:K.$IP,LanguageModelChatSystemMessage:K.$LP,LanguageModelChatUserMessage:K.$MP,LanguageModelChatAssistantMessage:K.$NP,LanguageModelError:K.$OP,NewSymbolName:K.$MO,NewSymbolNameTag:K.NewSymbolNameTag,NewSymbolNameTriggerKind:K.NewSymbolNameTriggerKind,InlineEdit:K.$PP,InlineEditTriggerKind:K.InlineEditTriggerKind}}}}),define(Ie[319],Pe([1,0,61,128,45,122,46,34,58,57,131,133,134,89,93,85,121,69,51,88,67,71,258,12,132,86,87,91,95,126,96]),function(ae,e,v,I,C,N,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,g,m,$,D,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Ps)(m.$kpc,m.$jpc,v.InstantiationType.Delayed),(0,v.$Ps)(l.$bk,c.$zqc,v.InstantiationType.Delayed),(0,v.$Ps)(n.$poc,n.$qoc,v.InstantiationType.Delayed),(0,v.$Ps)(T.$kQ,T.$jQ,v.InstantiationType.Eager),(0,v.$Ps)(D.$zoc,D.$Aoc,v.InstantiationType.Eager),(0,v.$Ps)(S.$epc,S.$fpc,v.InstantiationType.Eager),(0,v.$Ps)(A.$Ooc,A.$Moc,v.InstantiationType.Eager),(0,v.$Ps)(o.$Qoc,o.$Poc,v.InstantiationType.Eager),(0,v.$Ps)(k.$upc,k.$vpc,v.InstantiationType.Eager),(0,v.$Ps)(y.$zpc,y.$Dpc,v.InstantiationType.Eager),(0,v.$Ps)(N.$Fpc,N.$Epc,v.InstantiationType.Eager),(0,v.$Ps)(p.$_P,p.$$P,v.InstantiationType.Eager),(0,v.$Ps)($.$lpc,$.$mpc,v.InstantiationType.Eager),(0,v.$Ps)(h.$toc,h.$soc,v.InstantiationType.Eager),(0,v.$Ps)(I.$_pc,I.$$pc,v.InstantiationType.Delayed),(0,v.$Ps)(u.$Vpc,u.$Wpc,v.InstantiationType.Eager),(0,v.$Ps)(E.$0oc,E.$9oc,v.InstantiationType.Eager),(0,v.$Ps)(R.$mqc,R.$lqc,v.InstantiationType.Eager),(0,v.$Ps)(a.$apc,a.$dpc,v.InstantiationType.Eager),(0,v.$Ps)(b.$nqc,b.$oqc,v.InstantiationType.Eager),(0,v.$Ps)(d.$3Fb,d.$4Fb,v.InstantiationType.Eager),(0,v.$Ps)(s.$xqc,s.$wqc,v.InstantiationType.Eager),(0,v.$Ps)(C.$Loc,C.$Koc,v.InstantiationType.Eager),(0,v.$Ps)(i.$hpc,i.$gpc,v.InstantiationType.Eager),(0,v.$Ps)(r.$iQ,r.$fQ,v.InstantiationType.Eager),(0,v.$Ps)(t.$1oc,t.$2oc,v.InstantiationType.Eager),(0,v.$Ps)(g.$spc,g.$tpc,v.InstantiationType.Eager)}),define(Ie[320],Pe([1,0,318,47,2,315,7,11,265]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsc=void 0;class a extends N.$Cqc{j(){}getModule(E,d){for(const n of this.b){const s=n(E);if(s){E=s;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends I.$opc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Ksc);const E=this.h.invokeFunction(v.$yqc);this.r=this.h.createInstance(a,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,n){d=d.with({path:y(d.path,".js")});const s=E?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=C.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let c;try{c=new Function("module","exports","require",t)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const l={},g={exports:l},m=$=>{const D=this.r.getModule($,d);if(D===void 0)throw new Error(`Cannot load module '${$}'`);return D};try{return n.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),c(g,l,m),g.exports!==l?g.exports:l}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Hh)(10)}}e.$Lsc=R;function y(u,E){return u.endsWith(E)?u:u+E}}),define(Ie[321],Pe([1,0,74,61,12,47,229,92,320]),function(ae,e,v,I,C,N,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Ps)(C.$ak,new v.$Di(A.$Bqc,[!0],!0)),(0,I.$Ps)(N.$ppc,p.$Lsc,I.InstantiationType.Eager),(0,I.$Ps)(T.$Roc,T.$Soc,I.InstantiationType.Eager)}),define(Ie[329],Pe([1,0,23,6,84,316,267,20,65,16,2,319,321]),function(ae,e,v,I,C,N,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=Ve(T),p=Ve(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(c){return/^(file|vscode-remote):/i.test(c)}const d=fetch.bind(self);function n(c){self.fetch=async function(l,g){return l instanceof Request||E(String(l))&&(l=(await c(R.URI.parse(String(l)))).toString(!0)),d(l,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,g,m,$,D){(async()=>(E(g.toString())&&(g=(await c(R.URI.parse(g.toString()))).toString(!0)),super.open(l,g,m??!0,$,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const c=self.Worker;Worker=function(l,g){if(/^file:/i.test(l.toString()))l=a.$1g.uriToBrowserUri(R.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(k){function P(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const f=fetch.bind(self);self.fetch=function(F,O){return F instanceof Request?f(F,O):f(P(F),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,O,L,q,W){return super.open(F,P(O),L??!0,q,W)}};const w=importScripts.bind(self);self.importScripts=(...F)=>{w(...F.map(P))},w(k)}.toString()}('${l}'))`;g=g||{},g.name=`${name} -> ${g.name||T.$qc(l.toString())}`;const D=new Blob([$],{type:"application/javascript"}),S=URL.createObjectURL(D);return new c(S,g)}}else self.Worker=class extends A.$Msc{constructor(c,l){super(u,c,{name:T.$qc(c.toString()),...l})}};const s=new class{constructor(){this.pid=void 0}exit(c){y()}};class o{constructor(){const l=new MessageChannel,g=new I.$ne;let m=!1;u(l.port2,[l.port2]),l.port1.onmessage=$=>{const{data:D}=$;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const S=v.$Pe.wrap(new Uint8Array(D,0,D.byteLength));if((0,C.$Cn)(S,C.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}g.fire(S)},this.protocol={onMessage:g.event,send:$=>{if(!m){const D=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);l.port1.postMessage(D,[D])}}}}}function h(c){return new Promise(l=>{const g=c.onMessage(m=>{g.dispose();const $=JSON.parse(m.toString());c.send((0,C.$Bn)(C.MessageType.Initialized)),l({protocol:c,initData:$})});c.send((0,C.$Bn)(C.MessageType.Ready))})}let i=c=>y();function r(c){return!!c&&typeof c=="object"&&c.type==="vscode.init"&&c.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const c=new o;return{onmessage(l){r(l)&&h(c.protocol).then(g=>{p.mark("code/extHost/didWaitForInitData");const m=new N.$Eqc(g.protocol,g.initData,s,null,l.data);n($=>m.asBrowserUri($)),i=$=>m.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/b36286db80c68b7fdc6bfee2f55e0208c8833dfc/core/vs/workbench/api/worker/extensionHostWorker.js.map
